/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 5;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 307
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode)
          || GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x4, 0, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3
          || XINT (x3, 1) != 307
          || GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode)
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      operands[3] = x9;
      x10 = XVECEXP (x3, 0, 2);
      operands[2] = x10;
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 1;

    case SUBREG:
    case TRUNCATE:
      operands[3] = x3;
      if (!subreg_lowpart_operator (operands[3], E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 307
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode)
          || GET_MODE (x2) != E_VNx8HImode)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[4] = x6;
      x7 = XVECEXP (x4, 0, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  return pattern49 (x1); /* [-1, 1] */
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 2;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 3;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 4;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 5;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern69 (x3); /* [-1, 2] */
}

int
pattern73 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern79 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aligned_register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern84 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || pattern83 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern86 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 15
      || pattern85 (x1, 
E_DImode, 
15) != 0)
    return -1;
  return 0;
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern77 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern77 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern77 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern77 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern77 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern77 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_QImode:
      if (pattern90 (x3, 
E_VNx16QImode, 
E_VNx16BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_HImode:
      if (pattern90 (x3, 
E_VNx8HImode, 
E_VNx8BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_SImode:
      if (pattern90 (x3, 
E_VNx4SImode, 
E_VNx4BImode, 
E_SImode) != 0)
        return -1;
      return 8;

    case E_DImode:
      if (pattern90 (x3, 
E_VNx2DImode, 
E_VNx2BImode, 
E_DImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          return pattern77 (x3, 
E_V8QImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern77 (x3, 
E_V16QImode) != 0)
            return -1;
          return 1;

        case E_V4HImode:
          if (pattern77 (x3, 
E_V4HImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern77 (x3, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V2SImode:
          if (pattern77 (x3, 
E_V2SImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern77 (x3, 
E_V4SImode) != 0)
            return -1;
          return 5;

        case E_V2DImode:
          if (pattern77 (x3, 
E_V2DImode) != 0)
            return -1;
          return 6;

        case E_QImode:
          if (pattern77 (x3, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_HImode:
          if (pattern77 (x3, 
E_HImode) != 0)
            return -1;
          return 8;

        case E_SImode:
          if (pattern77 (x3, 
E_SImode) != 0)
            return -1;
          return 9;

        case E_DImode:
          if (pattern77 (x3, 
E_DImode) != 0)
            return -1;
          return 10;

        default:
          return -1;
        }

    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern100 (x3, 
E_V8QImode) != 0)
            return -1;
          return 11;

        case E_V16QImode:
          if (pattern100 (x3, 
E_V16QImode) != 0)
            return -1;
          return 12;

        case E_V4HImode:
          if (pattern101 (x3, 
E_V4HImode) != 0)
            return -1;
          return 13;

        case E_V8HImode:
          if (pattern101 (x3, 
E_V8HImode) != 0)
            return -1;
          return 14;

        case E_V2SImode:
          if (pattern102 (x3, 
E_V2SImode) != 0)
            return -1;
          return 15;

        case E_V4SImode:
          if (pattern102 (x3, 
E_V4SImode) != 0)
            return -1;
          return 16;

        case E_V2DImode:
          if (pattern103 (x3, 
E_V2DImode) != 0)
            return -1;
          return 17;

        case E_QImode:
          if (pattern100 (x3, 
E_QImode) != 0)
            return -1;
          return 18;

        case E_HImode:
          if (pattern101 (x3, 
E_HImode) != 0)
            return -1;
          return 19;

        case E_SImode:
          if (pattern102 (x3, 
E_SImode) != 0)
            return -1;
          return 20;

        case E_DImode:
          if (pattern103 (x3, 
E_DImode) != 0)
            return -1;
          return 21;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8SImode:
          if (!register_operand (operands[1], E_VNx8SImode))
            return -1;
          return 0;

        case E_VNx8DImode:
          if (!register_operand (operands[1], E_VNx8DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_offset_di (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 168)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 0);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x8 = XVECEXP (x2, 0, 2);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BFmode:
      return pattern168 (x2, 
E_VNx8BFmode); /* [-1, 0] */

    case E_VNx8HFmode:
      if (pattern168 (x2, 
E_VNx8HFmode) != 0)
        return -1;
      return 1;

    case E_VNx4SFmode:
      if (pattern168 (x2, 
E_VNx4SFmode) != 0)
        return -1;
      return 2;

    case E_VNx2DFmode:
      if (pattern168 (x2, 
E_VNx2DFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  return pattern178 (
i1); /* [-1, 2] */
}

int
pattern185 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern184 (x3, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern184 (x3, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern184 (x3, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2BImode:
      if (pattern184 (x3, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern116 (x3, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern116 (x3, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern116 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          return pattern193 (x3, 
E_VNx16QImode, 
E_VNx4SImode); /* [-1, 0] */

        case E_VNx2DImode:
          if (pattern193 (x3, 
E_VNx8HImode, 
E_VNx2DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 168)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      operands[3] = x7;
      x8 = XVECEXP (x6, 0, 1);
      operands[4] = x8;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern202 (x3, 
E_VNx16QImode, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern202 (x3, 
E_VNx8HImode, 
E_VNx2DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern217 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  return 0;
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern236 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x4 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  if (!aarch64_reg_or_zero (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x2, 0, 4);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 8LL:
      return 0;

    case 16LL:
      return 1;

    case 32LL:
      return 2;

    case 64LL:
      return 3;

    default:
      return -1;
    }
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[2], E_VNx32QImode)
          || !aligned_register_operand (operands[3], E_VNx32QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[2], E_VNx64QImode)
          || !aligned_register_operand (operands[3], E_VNx64QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[2], E_VNx16HImode)
          || !aligned_register_operand (operands[3], E_VNx16HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[2], E_VNx32HImode)
          || !aligned_register_operand (operands[3], E_VNx32HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return pattern246 (x1); /* [-1, 23] */

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      res = pattern250 (x1);
      if (res >= 0)
        return res + 24; /* [24, 47] */
      return -1;

    default:
      return -1;
    }
}

int
pattern256 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aligned_register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !const_0_to_7_operand (operands[1], E_SImode)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern265 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i3
      || pattern264 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  switch (GET_MODE (x5))
    {
    case E_VNx4SFmode:
      return pattern269 (x2, 
E_VNx4SFmode, 
E_VNx4BImode); /* [-1, 0] */

    case E_VNx2DFmode:
      if (pattern269 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 1;

    case E_VNx8HFmode:
      if (pattern269 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 2;

    case E_VNx8BFmode:
      if (pattern269 (x2, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 3;

    case E_VNx4SImode:
      if (GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx8BFmode:
          if (!register_operand (operands[3], E_VNx8BFmode)
              || !register_operand (operands[4], E_VNx8BFmode))
            return -1;
          return 4;

        case E_VNx8HFmode:
          if (!register_operand (operands[3], E_VNx8HFmode)
              || !register_operand (operands[4], E_VNx8HFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern284 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 3);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  x9 = XVECEXP (x2, 0, 5);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[4] = x9;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (!register_operand (operands[0], E_VNx16QImode)
              || GET_MODE (x2) != E_VNx16QImode
              || !register_operand (operands[1], E_VNx16QImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx16QImode:
              if (!register_operand (operands[2], E_VNx16BImode))
                return -1;
              return 0;

            case E_VNx1TImode:
              if (!register_operand (operands[2], E_VNx2BImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_VNx8HImode:
          res = pattern279 (x2, 
E_VNx8HImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case E_VNx4SImode:
          res = pattern280 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case E_VNx2DImode:
          res = pattern281 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case E_VNx8BFmode:
          res = pattern279 (x2, 
E_VNx8BFmode);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case E_VNx8HFmode:
          res = pattern279 (x2, 
E_VNx8HFmode);
          if (res >= 0)
            return res + 10; /* [10, 11] */
          return -1;

        case E_VNx4SFmode:
          res = pattern280 (x2, 
E_VNx4SFmode);
          if (res >= 0)
            return res + 12; /* [12, 13] */
          return -1;

        case E_VNx2DFmode:
          res = pattern281 (x2, 
E_VNx2DFmode);
          if (res >= 0)
            return res + 14; /* [14, 15] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x11 = XEXP (x9, 1);
      operands[5] = x11;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern282 (x2, 
E_VNx16BImode, 
E_VNx16QImode) != 0)
            return -1;
          return 16;

        case E_VNx8HImode:
          if (pattern282 (x2, 
E_VNx8BImode, 
E_VNx8HImode) != 0)
            return -1;
          return 17;

        case E_VNx4SImode:
          if (pattern282 (x2, 
E_VNx4BImode, 
E_VNx4SImode) != 0)
            return -1;
          return 18;

        case E_VNx2DImode:
          if (pattern282 (x2, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
            return -1;
          return 19;

        case E_VNx8BFmode:
          if (pattern283 (x2, 
E_VNx8BImode, 
E_VNx8BFmode, 
E_VNx8HImode) != 0)
            return -1;
          return 20;

        case E_VNx8HFmode:
          if (pattern283 (x2, 
E_VNx8BImode, 
E_VNx8HFmode, 
E_VNx8HImode) != 0)
            return -1;
          return 21;

        case E_VNx4SFmode:
          if (pattern283 (x2, 
E_VNx4BImode, 
E_VNx4SFmode, 
E_VNx4SImode) != 0)
            return -1;
          return 22;

        case E_VNx2DFmode:
          if (pattern283 (x2, 
E_VNx2BImode, 
E_VNx2DFmode, 
E_VNx2DImode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern319 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return pattern322 (x1); /* [-1, 4] */
}

int
pattern324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8QImode
      || !register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!aarch64_simd_or_scalar_imm_zero (operands[2], E_V8QImode))
    return -1;
  return 0;
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern321 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern321 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern321 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx4SImode))
    return -1;
  switch (XINT (x1, 1))
    {
    case 169:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[3] = x2;
      x4 = XVECEXP (x1, 0, 2);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern344 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x1) != E_QImode
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode))
                return -1;
              return 0;

            case E_HImode:
              if (pattern339 (x1, 
E_SImode, 
E_HImode) != 0)
                return -1;
              return 1;

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x1) != E_SImode
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        case CONST_VECTOR:
          res = pattern340 (x1);
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != i1)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      switch (GET_CODE (operands[2]))
        {
        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (!register_operand (operands[0], E_V8QImode)
                  || GET_MODE (x1) != E_V8QImode
                  || GET_MODE (x2) != E_V8SImode
                  || pattern341 (x4, 
E_V8HImode, 
E_V8SImode) != 0)
                return -1;
              return 6;

            case E_V4HImode:
              if (!register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x1) != E_V4HImode
                  || GET_MODE (x2) != E_V4DImode
                  || pattern342 (x4, 
E_V4SImode, 
E_V4DImode) != 0)
                return -1;
              return 7;

            case E_V2SImode:
              if (!register_operand (operands[0], E_V2SImode)
                  || GET_MODE (x1) != E_V2SImode
                  || GET_MODE (x2) != E_V2TImode
                  || pattern343 (x4, 
E_V2DImode, 
E_V2TImode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x1) != E_QImode
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x4) != E_SImode
                  || GET_MODE (x5) != E_SImode
                  || !register_operand (operands[1], E_HImode)
                  || !aarch64_int_rnd_operand (operands[3], E_SImode)
                  || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode))
                return -1;
              return 9;

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x1) != E_HImode
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x4) != E_DImode
                  || GET_MODE (x5) != E_DImode
                  || !register_operand (operands[1], E_SImode)
                  || !aarch64_int_rnd_operand (operands[3], E_DImode)
                  || !aarch64_simd_shift_imm_offset_si (operands[2], E_SImode))
                return -1;
              return 10;

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x1) != E_SImode
                  || GET_MODE (x2) != E_TImode
                  || GET_MODE (x4) != E_TImode
                  || GET_MODE (x5) != E_TImode
                  || !register_operand (operands[1], E_DImode)
                  || !aarch64_int_rnd_operand (operands[3], E_TImode)
                  || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern386 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern391 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_shift_imm_si (operands[1], E_QImode)
          || !aarch64_reg_or_zero (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_shift_imm_di (operands[1], E_QImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern396 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern401 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern406 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern409 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern415 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern421 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern420 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern420 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern420 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern427 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern434 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern433 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern433 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern433 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern440 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V8QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_int_rnd_operand (operands[4], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[3], i1)
      || !register_operand (operands[1], E_V8QImode))
    return -1;
  return 0;
}

int
pattern445 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern448 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern453 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern455 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  return pattern454 (x4, 
67, 
E_DImode, 
USE); /* [-1, 0] */
}

int
pattern459 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_even_or_odd_half (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern464 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || pattern213 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_select_half (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !vect_par_cnst_select_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern473 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  x3 = XVECEXP (x1, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern471 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern471 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern471 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern471 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern471 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern471 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern471 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern471 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern471 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern471 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    case E_VNx8HFmode:
      if (pattern471 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (pattern471 (x1, 
E_VNx4HFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 11;

    case E_VNx2HFmode:
      if (pattern471 (x1, 
E_VNx2HFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 12;

    case E_VNx8BFmode:
      if (pattern471 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 13;

    case E_VNx4BFmode:
      if (pattern471 (x1, 
E_VNx4BFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 14;

    case E_VNx2BFmode:
      if (pattern471 (x1, 
E_VNx2BFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 15;

    case E_VNx4SFmode:
      if (pattern471 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 16;

    case E_VNx2SFmode:
      if (pattern471 (x1, 
E_VNx2SFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 17;

    case E_VNx2DFmode:
      if (pattern471 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 18;

    case E_VNx32QImode:
      if (pattern472 (x1, 
E_VNx32QImode, 
E_VNx16BImode) != 0)
        return -1;
      return 19;

    case E_VNx16HImode:
      if (pattern472 (x1, 
E_VNx16HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 20;

    case E_VNx8SImode:
      if (pattern472 (x1, 
E_VNx8SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 21;

    case E_VNx4DImode:
      if (pattern472 (x1, 
E_VNx4DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 22;

    case E_VNx16BFmode:
      if (pattern472 (x1, 
E_VNx16BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 23;

    case E_VNx16HFmode:
      if (pattern472 (x1, 
E_VNx16HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 24;

    case E_VNx8SFmode:
      if (pattern472 (x1, 
E_VNx8SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 25;

    case E_VNx4DFmode:
      if (pattern472 (x1, 
E_VNx4DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 26;

    case E_VNx48QImode:
      if (pattern472 (x1, 
E_VNx48QImode, 
E_VNx16BImode) != 0)
        return -1;
      return 27;

    case E_VNx24HImode:
      if (pattern472 (x1, 
E_VNx24HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 28;

    case E_VNx12SImode:
      if (pattern472 (x1, 
E_VNx12SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 29;

    case E_VNx6DImode:
      if (pattern472 (x1, 
E_VNx6DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 30;

    case E_VNx24BFmode:
      if (pattern472 (x1, 
E_VNx24BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 31;

    case E_VNx24HFmode:
      if (pattern472 (x1, 
E_VNx24HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 32;

    case E_VNx12SFmode:
      if (pattern472 (x1, 
E_VNx12SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 33;

    case E_VNx6DFmode:
      if (pattern472 (x1, 
E_VNx6DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 34;

    case E_VNx64QImode:
      if (pattern472 (x1, 
E_VNx64QImode, 
E_VNx16BImode) != 0)
        return -1;
      return 35;

    case E_VNx32HImode:
      if (pattern472 (x1, 
E_VNx32HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 36;

    case E_VNx16SImode:
      if (pattern472 (x1, 
E_VNx16SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 37;

    case E_VNx8DImode:
      if (pattern472 (x1, 
E_VNx8DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 38;

    case E_VNx32BFmode:
      if (pattern472 (x1, 
E_VNx32BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 39;

    case E_VNx32HFmode:
      if (pattern472 (x1, 
E_VNx32HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 40;

    case E_VNx16SFmode:
      if (pattern472 (x1, 
E_VNx16SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 41;

    case E_VNx8DFmode:
      if (pattern472 (x1, 
E_VNx8DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 42;

    default:
      return -1;
    }
}

int
pattern529 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern534 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern541 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  return pattern540 (x1); /* [-1, 2] */
}

int
pattern546 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_si (operands[2], i1))
    return -1;
  return 0;
}

int
pattern552 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern550 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern550 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern550 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern550 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V8BFmode:
      if (pattern550 (x1, 
E_V4BFmode, 
E_V8BFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern550 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern565 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern564 (x5, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern564 (x5, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern576 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (XINT (x3, 1) != 27
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 66
          || GET_MODE (x5) != E_CCmode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != UNSPEC_VOLATILE
          || XVECLEN (x8, 0) != 5
          || XINT (x8, 1) != 27)
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      x10 = XVECEXP (x8, 0, 0);
      operands[2] = x10;
      x11 = XVECEXP (x8, 0, 1);
      operands[3] = x11;
      x12 = XVECEXP (x8, 0, 2);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x13 = XVECEXP (x8, 0, 3);
      operands[5] = x13;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      x14 = XVECEXP (x8, 0, 4);
      operands[6] = x14;
      if (!const_int_operand (operands[6], E_SImode))
        return -1;
      x15 = XVECEXP (x1, 0, 3);
      x16 = XEXP (x15, 0);
      operands[7] = x16;
      return pattern570 (x1); /* [-1, 4] */

    case 2:
      if (XINT (x3, 1) != 31)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 66
          || GET_MODE (x9) != E_CCmode)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x17 = XVECEXP (x3, 0, 1);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x18 = XEXP (x7, 0);
      operands[3] = x18;
      x15 = XVECEXP (x1, 0, 3);
      x16 = XEXP (x15, 0);
      operands[4] = x16;
      x4 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          res = pattern572 (x3);
          if (res >= 0)
            return res + 5; /* [5, 8] */
          return -1;

        case MINUS:
          res = pattern572 (x3);
          if (res >= 0)
            return res + 9; /* [9, 12] */
          return -1;

        case IOR:
          res = pattern574 (x3);
          if (res >= 0)
            return res + 13; /* [13, 16] */
          return -1;

        case XOR:
          res = pattern574 (x3);
          if (res >= 0)
            return res + 17; /* [17, 20] */
          return -1;

        case AND:
          res = pattern574 (x3);
          if (res >= 0)
            return res + 21; /* [21, 24] */
          return -1;

        case NOT:
          x19 = XEXP (x4, 0);
          if (GET_CODE (x19) != AND)
            return -1;
          x20 = XEXP (x19, 1);
          operands[1] = x20;
          x21 = XEXP (x19, 0);
          if (!rtx_equal_p (x21, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern575 (x3, 
E_QImode) != 0)
                return -1;
              return 25;

            case E_HImode:
              if (pattern575 (x3, 
E_HImode) != 0)
                return -1;
              return 26;

            case E_SImode:
              if (pattern575 (x3, 
E_SImode) != 0)
                return -1;
              return 27;

            case E_DImode:
              if (pattern575 (x3, 
E_DImode) != 0)
                return -1;
              return 28;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern617 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_DImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V4DImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 4;

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern632 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern631 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern631 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern631 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern631 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern637 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern645 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern644 (x1, 
E_VNx16QImode, 
E_VNx8HImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern644 (x1, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern644 (x1, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern652 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_vsm_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern657 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x1, 0);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 1);
      operands[2] = x8;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[4] = x10;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x6) != E_V4SImode
              || GET_MODE (x7) != E_V4HImode
              || !register_operand (operands[1], E_V8HImode)
              || !vect_par_cnst_hi_half (operands[2], E_V8HImode)
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 0;

            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x6) != E_V2DImode
              || GET_MODE (x7) != E_V2SImode
              || !register_operand (operands[1], E_V4SImode)
              || !vect_par_cnst_hi_half (operands[2], E_V4SImode)
              || GET_MODE (x2) != E_V2DImode
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 2;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x4;
      x6 = XEXP (x1, 0);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern656 (x1, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern656 (x1, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern688 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      operands[5] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x9 = XEXP (x5, 1);
      operands[3] = x9;
      x10 = XEXP (x4, 1);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern686 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern686 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern686 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      x9 = XEXP (x5, 1);
      operands[4] = x9;
      x10 = XEXP (x4, 1);
      operands[5] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern687 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern687 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern687 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern707 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern712 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern715 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern718 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !aarch64_simd_shift_imm_qi (operands[1], E_VOIDmode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !aarch64_simd_shift_imm_hi (operands[1], E_VOIDmode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_simd_shift_imm_si (operands[1], E_VOIDmode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_simd_shift_imm_di (operands[1], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern725 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[2], i2)
      || !aarch64_sve_ld1rq_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern730 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern735 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!aarch64_shift_imm_si (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern740 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern743 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern752 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern755 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern761 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_even_or_odd_half (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern769 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern763 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern763 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern763 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern763 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V8BFmode:
      if (pattern763 (x1, 
E_V4BFmode, 
E_V8BFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern763 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern780 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x5, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  x11 = XEXP (x1, 1);
  operands[4] = x11;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern779 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern779 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern779 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern794 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_arith_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern798 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern806 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!aarch64_shift_imm_si (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern816 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_cnt_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern821 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern828 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  return pattern827 (x2, 
i1); /* [-1, 0] */
}

int
pattern834 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[3] = x3;
      x4 = XEXP (x1, 0);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern833 (x1, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern833 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x4 = XEXP (x1, 0);
      operands[5] = x4;
      x6 = XEXP (x3, 0);
      operands[3] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[4] = x7;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !register_operand (operands[2], E_V4HImode)
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 2;

            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 4;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern870 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern876 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern882 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[2], i3)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern887 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern886 (x1, 
E_V4HImode, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern886 (x1, 
E_V8HImode, 
E_V16HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern886 (x1, 
E_V2SImode, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern886 (x1, 
E_V4SImode, 
E_V8SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern886 (x1, 
E_V2DImode, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_DImode:
      if (pattern886 (x1, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern896 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  return pattern895 (x4); /* [-1, 1] */
}

int
pattern902 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!register_operand (operands[1], E_TImode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    case E_TDmode:
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern907 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_orr_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern912 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  operands[5] = x2;
  if (!aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_V2SFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2SFmode)
    return -1;
  return 0;
}

int
pattern920 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CC_NZmode
      || GET_MODE (x3) != E_CC_NZmode)
    return -1;
  return 0;
}

int
pattern925 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != NEG)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CC_NZmode
      || GET_MODE (x3) != E_CC_NZmode)
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  x14 = XEXP (x7, 1);
  if (!rtx_equal_p (x14, operands[2]))
    return -1;
  switch (GET_MODE (x9))
    {
    case E_SImode:
      if (GET_MODE (x10) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode
          || GET_MODE (x7) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x10) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode
          || GET_MODE (x7) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern941 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[3], E_SImode)
          || !aarch64_simd_shift_imm_si (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[3], E_DImode)
          || !aarch64_simd_shift_imm_di (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern955 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_minus_one (operands[4], i1))
    return -1;
  return 0;
}

int
pattern962 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1000 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1006 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1014 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1021 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1025 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_raddsubhn_imm_vec (operands[3], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1035 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1043 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern1042 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern1042 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern1042 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern1042 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1054 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[3] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[2] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1063 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_uxt_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1070 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1074 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SFmode
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1084 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_minus_one (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1091 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i2)
      || !aarch64_simd_umax_half_mode (operands[3], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[4] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1045 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1045 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1045 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1045 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return 4;

        case E_VNx4SFmode:
          return 5;

        case E_VNx2DFmode:
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0LL:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1109 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1109 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1109 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1LL:
      x4 = XVECEXP (x1, 0, 2);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1110 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SFmode:
          if (pattern1110 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DFmode:
          if (pattern1110 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1129 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx16QImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  if (!register_operand (operands[4], E_VNx4SImode))
    return -1;
  return 0;
}

int
pattern1143 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SFmode
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1152 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_hi_half (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1166 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !aarch64_reg_or_zero (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !aarch64_reg_or_zero (operands[3], i1)
      || pattern991 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern1172 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1176 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1183 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i4))
    return -1;
  x5 = XEXP (x3, 1);
  return pattern1182 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1191 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern1195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1194 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1194 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1194 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1194 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XVECEXP (x4, 0, 0);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[5] = x6;
  if (!aarch64_sve_ptrue_flag (operands[5], E_SImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[6] = x7;
  switch (GET_MODE (x4))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[6], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[6], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[6], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[6], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1218 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != AND)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != i1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[2]))
        return -1;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[3]))
        return -1;
      x8 = XEXP (x3, 1);
      if (!rtx_equal_p (x8, operands[4]))
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 1);
      x11 = XVECEXP (x10, 0, 3);
      switch (GET_MODE (x11))
        {
        case E_VNx16BImode:
          return pattern1217 (x1, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8BImode:
          if (pattern1217 (x1, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (pattern1217 (x1, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2BImode:
          if (pattern1217 (x1, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!scratch_operand (operands[0], E_VNx16BImode))
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 1);
      x11 = XVECEXP (x10, 0, 3);
      switch (GET_MODE (x11))
        {
        case E_VNx16BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16BImode)
              || !register_operand (operands[3], E_VNx16BImode))
            return -1;
          return 4;

        case E_VNx8BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx8BImode
              || !register_operand (operands[2], E_VNx8BImode)
              || !register_operand (operands[3], E_VNx8BImode))
            return -1;
          return 5;

        case E_VNx4BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx4BImode
              || !register_operand (operands[2], E_VNx4BImode)
              || !register_operand (operands[3], E_VNx4BImode))
            return -1;
          return 6;

        case E_VNx2BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx2BImode
              || !register_operand (operands[2], E_VNx2BImode)
              || !register_operand (operands[3], E_VNx2BImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  switch (GET_MODE (x8))
    {
    case E_SImode:
      return pattern1252 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1252 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1260 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !aarch64_sve_float_arith_immediate (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1267 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1274 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1282 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1)
      || !const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1288 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_si (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1295 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !aarch64_logical_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1300 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1305 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (GET_MODE (x2) != E_VNx8BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (GET_MODE (x2) != E_VNx4BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (GET_MODE (x2) != E_VNx2BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[1], E_V4SImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1354 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1362 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 2);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x7, 0, 2);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern1370 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_simd_register (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[4], i2)
      || !aarch64_simd_register (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !aarch64_simd_register (operands[2], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !aarch64_simd_register (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[6] = x3;
  if (!subreg_lowpart_operator (operands[6], E_SImode))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[4] = x9;
  if (!aarch64_simd_shift_imm_si (operands[4], E_SImode))
    return -1;
  x10 = XEXP (x4, 2);
  operands[5] = x10;
  if (!aarch64_simd_shift_imm_si (operands[5], E_SImode)
      || !
#line 6603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_M1U << INTVAL (operands[4])
   && INTVAL (operands[4])
   && UINTVAL (operands[4]) + UINTVAL (operands[5]) <= 32))
    return -1;
  return 864; /* *aarch64_bfxilsi_extrdi */
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x16QImode)
          || GET_MODE (x3) != E_V3x16QImode
          || !register_operand (operands[1], E_V3x16QImode)
          || !
#line 7717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4497; /* aarch64_simd_st3v16qi */

    case E_V3x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8HImode)
          || GET_MODE (x3) != E_V3x8HImode
          || !register_operand (operands[1], E_V3x8HImode)
          || !
#line 7717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4498; /* aarch64_simd_st3v8hi */

    case E_V3x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4SImode)
          || GET_MODE (x3) != E_V3x4SImode
          || !register_operand (operands[1], E_V3x4SImode)
          || !
#line 7717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4499; /* aarch64_simd_st3v4si */

    case E_V3x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2DImode)
          || GET_MODE (x3) != E_V3x2DImode
          || !register_operand (operands[1], E_V3x2DImode)
          || !
#line 7717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4500; /* aarch64_simd_st3v2di */

    case E_V3x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8HFmode)
          || GET_MODE (x3) != E_V3x8HFmode
          || !register_operand (operands[1], E_V3x8HFmode)
          || !
#line 7717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4501; /* aarch64_simd_st3v8hf */

    case E_V3x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4SFmode)
          || GET_MODE (x3) != E_V3x4SFmode
          || !register_operand (operands[1], E_V3x4SFmode)
          || !
#line 7717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4502; /* aarch64_simd_st3v4sf */

    case E_V3x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2DFmode)
          || GET_MODE (x3) != E_V3x2DFmode
          || !register_operand (operands[1], E_V3x2DFmode)
          || !
#line 7717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4503; /* aarch64_simd_st3v2df */

    case E_V3x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8BFmode)
          || GET_MODE (x3) != E_V3x8BFmode
          || !register_operand (operands[1], E_V3x8BFmode)
          || !
#line 7717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4504; /* aarch64_simd_st3v8bf */

    case E_V3x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8QImode)
          || GET_MODE (x3) != E_V3x8QImode
          || !register_operand (operands[1], E_V3x8QImode)
          || !
#line 8707 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5108; /* aarch64_st3v8qi_dreg */

    case E_V3x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4HImode)
          || GET_MODE (x3) != E_V3x4HImode
          || !register_operand (operands[1], E_V3x4HImode)
          || !
#line 8707 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5109; /* aarch64_st3v4hi_dreg */

    case E_V3x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2SImode)
          || GET_MODE (x3) != E_V3x2SImode
          || !register_operand (operands[1], E_V3x2SImode)
          || !
#line 8707 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5110; /* aarch64_st3v2si_dreg */

    case E_V3x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4HFmode)
          || GET_MODE (x3) != E_V3x4HFmode
          || !register_operand (operands[1], E_V3x4HFmode)
          || !
#line 8707 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5111; /* aarch64_st3v4hf_dreg */

    case E_V3x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2SFmode)
          || GET_MODE (x3) != E_V3x2SFmode
          || !register_operand (operands[1], E_V3x2SFmode)
          || !
#line 8707 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5112; /* aarch64_st3v2sf_dreg */

    case E_V3x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4BFmode)
          || GET_MODE (x3) != E_V3x4BFmode
          || !register_operand (operands[1], E_V3x4BFmode)
          || !
#line 8707 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5113; /* aarch64_st3v4bf_dreg */

    case E_V3x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x1DImode)
          || GET_MODE (x3) != E_V3x1DImode
          || !register_operand (operands[1], E_V3x1DImode)
          || !
#line 8717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5114; /* aarch64_st3di_dreg */

    case E_V3x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x1DFmode)
          || GET_MODE (x3) != E_V3x1DFmode
          || !register_operand (operands[1], E_V3x1DFmode)
          || !
#line 8717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5115; /* aarch64_st3df_dreg */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4x8QImode:
      if (!register_operand (operands[0], E_V4x8QImode)
          || GET_MODE (x3) != E_V4x8QImode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4529; /* aarch64_simd_ld4rv8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[0], E_V4x4HImode)
          || GET_MODE (x3) != E_V4x4HImode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4530; /* aarch64_simd_ld4rv4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[0], E_V4x2SImode)
          || GET_MODE (x3) != E_V4x2SImode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4531; /* aarch64_simd_ld4rv2si */

    case E_V4x1DImode:
      if (!register_operand (operands[0], E_V4x1DImode)
          || GET_MODE (x3) != E_V4x1DImode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4532; /* aarch64_simd_ld4rdi */

    case E_V4x4HFmode:
      if (!register_operand (operands[0], E_V4x4HFmode)
          || GET_MODE (x3) != E_V4x4HFmode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4533; /* aarch64_simd_ld4rv4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[0], E_V4x2SFmode)
          || GET_MODE (x3) != E_V4x2SFmode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4534; /* aarch64_simd_ld4rv2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[0], E_V4x1DFmode)
          || GET_MODE (x3) != E_V4x1DFmode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4535; /* aarch64_simd_ld4rdf */

    case E_V4x4BFmode:
      if (!register_operand (operands[0], E_V4x4BFmode)
          || GET_MODE (x3) != E_V4x4BFmode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4536; /* aarch64_simd_ld4rv4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[0], E_V4x16QImode)
          || GET_MODE (x3) != E_V4x16QImode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4537; /* aarch64_simd_ld4rv16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[0], E_V4x8HImode)
          || GET_MODE (x3) != E_V4x8HImode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4538; /* aarch64_simd_ld4rv8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[0], E_V4x4SImode)
          || GET_MODE (x3) != E_V4x4SImode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4539; /* aarch64_simd_ld4rv4si */

    case E_V4x2DImode:
      if (!register_operand (operands[0], E_V4x2DImode)
          || GET_MODE (x3) != E_V4x2DImode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4540; /* aarch64_simd_ld4rv2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[0], E_V4x8HFmode)
          || GET_MODE (x3) != E_V4x8HFmode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4541; /* aarch64_simd_ld4rv8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[0], E_V4x4SFmode)
          || GET_MODE (x3) != E_V4x4SFmode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4542; /* aarch64_simd_ld4rv4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[0], E_V4x2DFmode)
          || GET_MODE (x3) != E_V4x2DFmode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4543; /* aarch64_simd_ld4rv2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[0], E_V4x8BFmode)
          || GET_MODE (x3) != E_V4x8BFmode
          || !
#line 7772 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4544; /* aarch64_simd_ld4rv8bf */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[0], E_V3x8QImode)
          || GET_MODE (x3) != E_V3x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8QImode)
          || !
#line 8403 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4811; /* aarch64_ld3v8qi_dreg */

    case E_V3x4HImode:
      if (!register_operand (operands[0], E_V3x4HImode)
          || GET_MODE (x3) != E_V3x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HImode)
          || !
#line 8403 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4812; /* aarch64_ld3v4hi_dreg */

    case E_V3x2SImode:
      if (!register_operand (operands[0], E_V3x2SImode)
          || GET_MODE (x3) != E_V3x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SImode)
          || !
#line 8403 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4813; /* aarch64_ld3v2si_dreg */

    case E_V3x4HFmode:
      if (!register_operand (operands[0], E_V3x4HFmode)
          || GET_MODE (x3) != E_V3x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HFmode)
          || !
#line 8403 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4814; /* aarch64_ld3v4hf_dreg */

    case E_V3x2SFmode:
      if (!register_operand (operands[0], E_V3x2SFmode)
          || GET_MODE (x3) != E_V3x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SFmode)
          || !
#line 8403 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4815; /* aarch64_ld3v2sf_dreg */

    case E_V3x4BFmode:
      if (!register_operand (operands[0], E_V3x4BFmode)
          || GET_MODE (x3) != E_V3x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4BFmode)
          || !
#line 8403 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4816; /* aarch64_ld3v4bf_dreg */

    case E_V3x1DImode:
      if (!register_operand (operands[0], E_V3x1DImode)
          || GET_MODE (x3) != E_V3x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DImode)
          || !
#line 8413 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4817; /* aarch64_ld3di_dreg */

    case E_V3x1DFmode:
      if (!register_operand (operands[0], E_V3x1DFmode)
          || GET_MODE (x3) != E_V3x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DFmode)
          || !
#line 8413 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4818; /* aarch64_ld3df_dreg */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 803 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1625; /* aarch64_absv8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 803 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1628; /* aarch64_absv16qi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 803 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1629; /* aarch64_absv4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 803 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1632; /* aarch64_absv8hi */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 803 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1633; /* aarch64_absv2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 803 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1636; /* aarch64_absv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 803 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1637; /* aarch64_absv2di */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 803 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1638; /* aarch64_absdi */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 8985 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5181; /* aarch64_crypto_sha1hsi */

    case VEC_SELECT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      switch (XWINT (x6, 0))
        {
        case 0LL:
          if (!
#line 8995 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2 && !BYTES_BIG_ENDIAN))
            return -1;
          return 5182; /* aarch64_crypto_sha1hv4si */

        case 3LL:
          if (!
#line 9005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2 && BYTES_BIG_ENDIAN))
            return -1;
          return 5183; /* aarch64_be_crypto_sha1hv4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern72 (x1))
    {
    case 0:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12907; /* aarch64_sve_uzpvnx64qi */

    case 1:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12909; /* aarch64_sve_uzpvnx32hi */

    case 2:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12911; /* aarch64_sve_uzpvnx16si */

    case 3:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12913; /* aarch64_sve_uzpvnx8di */

    case 4:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12915; /* aarch64_sve_uzpvnx32bf */

    case 5:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12917; /* aarch64_sve_uzpvnx32hf */

    case 6:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12919; /* aarch64_sve_uzpvnx16sf */

    case 7:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12921; /* aarch64_sve_uzpvnx8df */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern54 (x1))
    {
    case 0:
      if (!(
#line 6843 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 901; /* rinthf2 */

    case 1:
      if (!
#line 6843 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 908; /* rintsf2 */

    case 2:
      if (!
#line 6843 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 915; /* rintdf2 */

    case 3:
      if (!(
#line 3005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2502; /* rintv4hf2 */

    case 4:
      if (!(
#line 3005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2513; /* rintv8hf2 */

    case 5:
      if (!
#line 3005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2530; /* rintv2sf2 */

    case 6:
      if (!
#line 3005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2541; /* rintv4sf2 */

    case 7:
      if (!
#line 3005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2548; /* rintv2df2 */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern602 (x2))
    {
    case 0:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
        return -1;
      return 5781; /* aarch64_load_extendvnx8hivnx8qi */

    case 1:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
        return -1;
      return 5783; /* aarch64_load_extendvnx8hivnx4qi */

    case 2:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
        return -1;
      return 5785; /* aarch64_load_extendvnx8hivnx2qi */

    case 3:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
        return -1;
      return 5787; /* aarch64_load_extendvnx8hivnx4hi */

    case 4:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
        return -1;
      return 5789; /* aarch64_load_extendvnx8hivnx2hi */

    case 5:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
        return -1;
      return 5791; /* aarch64_load_extendvnx8hivnx2si */

    case 6:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
        return -1;
      return 5793; /* aarch64_load_extendvnx4hivnx8qi */

    case 7:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
        return -1;
      return 5795; /* aarch64_load_extendvnx4hivnx4qi */

    case 8:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
        return -1;
      return 5797; /* aarch64_load_extendvnx4hivnx2qi */

    case 9:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
        return -1;
      return 5799; /* aarch64_load_extendvnx4hivnx4hi */

    case 10:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
        return -1;
      return 5801; /* aarch64_load_extendvnx4hivnx2hi */

    case 11:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
        return -1;
      return 5803; /* aarch64_load_extendvnx4hivnx2si */

    case 12:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
        return -1;
      return 5805; /* aarch64_load_extendvnx2hivnx8qi */

    case 13:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
        return -1;
      return 5807; /* aarch64_load_extendvnx2hivnx4qi */

    case 14:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
        return -1;
      return 5809; /* aarch64_load_extendvnx2hivnx2qi */

    case 15:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
        return -1;
      return 5811; /* aarch64_load_extendvnx2hivnx4hi */

    case 16:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
        return -1;
      return 5813; /* aarch64_load_extendvnx2hivnx2hi */

    case 17:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
        return -1;
      return 5815; /* aarch64_load_extendvnx2hivnx2si */

    case 18:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
        return -1;
      return 5817; /* aarch64_load_extendvnx4sivnx8qi */

    case 19:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
        return -1;
      return 5819; /* aarch64_load_extendvnx4sivnx4qi */

    case 20:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
        return -1;
      return 5821; /* aarch64_load_extendvnx4sivnx2qi */

    case 21:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
        return -1;
      return 5823; /* aarch64_load_extendvnx4sivnx4hi */

    case 22:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
        return -1;
      return 5825; /* aarch64_load_extendvnx4sivnx2hi */

    case 23:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
        return -1;
      return 5827; /* aarch64_load_extendvnx4sivnx2si */

    case 24:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
        return -1;
      return 5829; /* aarch64_load_extendvnx2sivnx8qi */

    case 25:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
        return -1;
      return 5831; /* aarch64_load_extendvnx2sivnx4qi */

    case 26:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
        return -1;
      return 5833; /* aarch64_load_extendvnx2sivnx2qi */

    case 27:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
        return -1;
      return 5835; /* aarch64_load_extendvnx2sivnx4hi */

    case 28:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
        return -1;
      return 5837; /* aarch64_load_extendvnx2sivnx2hi */

    case 29:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
        return -1;
      return 5839; /* aarch64_load_extendvnx2sivnx2si */

    case 30:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
        return -1;
      return 5841; /* aarch64_load_extendvnx2divnx8qi */

    case 31:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
        return -1;
      return 5843; /* aarch64_load_extendvnx2divnx4qi */

    case 32:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
        return -1;
      return 5845; /* aarch64_load_extendvnx2divnx2qi */

    case 33:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
        return -1;
      return 5847; /* aarch64_load_extendvnx2divnx4hi */

    case 34:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
        return -1;
      return 5849; /* aarch64_load_extendvnx2divnx2hi */

    case 35:
      if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
        return -1;
      return 5851; /* aarch64_load_extendvnx2divnx2si */

    case 36:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0))
        return -1;
      return 5941; /* aarch64_ldff1_extendvnx8hivnx8qi */

    case 37:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0))
        return -1;
      return 5945; /* aarch64_ldff1_extendvnx8hivnx4qi */

    case 38:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0))
        return -1;
      return 5949; /* aarch64_ldff1_extendvnx8hivnx2qi */

    case 39:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0))
        return -1;
      return 5953; /* aarch64_ldff1_extendvnx8hivnx4hi */

    case 40:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0))
        return -1;
      return 5957; /* aarch64_ldff1_extendvnx8hivnx2hi */

    case 41:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0))
        return -1;
      return 5961; /* aarch64_ldff1_extendvnx8hivnx2si */

    case 42:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0))
        return -1;
      return 5965; /* aarch64_ldff1_extendvnx4hivnx8qi */

    case 43:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 5969; /* aarch64_ldff1_extendvnx4hivnx4qi */

    case 44:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0))
        return -1;
      return 5973; /* aarch64_ldff1_extendvnx4hivnx2qi */

    case 45:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 5977; /* aarch64_ldff1_extendvnx4hivnx4hi */

    case 46:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0))
        return -1;
      return 5981; /* aarch64_ldff1_extendvnx4hivnx2hi */

    case 47:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0))
        return -1;
      return 5985; /* aarch64_ldff1_extendvnx4hivnx2si */

    case 48:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0))
        return -1;
      return 5989; /* aarch64_ldff1_extendvnx2hivnx8qi */

    case 49:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0))
        return -1;
      return 5993; /* aarch64_ldff1_extendvnx2hivnx4qi */

    case 50:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 5997; /* aarch64_ldff1_extendvnx2hivnx2qi */

    case 51:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0))
        return -1;
      return 6001; /* aarch64_ldff1_extendvnx2hivnx4hi */

    case 52:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6005; /* aarch64_ldff1_extendvnx2hivnx2hi */

    case 53:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6009; /* aarch64_ldff1_extendvnx2hivnx2si */

    case 54:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 6013; /* aarch64_ldff1_extendvnx4sivnx8qi */

    case 55:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6017; /* aarch64_ldff1_extendvnx4sivnx4qi */

    case 56:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 6021; /* aarch64_ldff1_extendvnx4sivnx2qi */

    case 57:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6025; /* aarch64_ldff1_extendvnx4sivnx4hi */

    case 58:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 6029; /* aarch64_ldff1_extendvnx4sivnx2hi */

    case 59:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 6033; /* aarch64_ldff1_extendvnx4sivnx2si */

    case 60:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0))
        return -1;
      return 6037; /* aarch64_ldff1_extendvnx2sivnx8qi */

    case 61:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0))
        return -1;
      return 6041; /* aarch64_ldff1_extendvnx2sivnx4qi */

    case 62:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6045; /* aarch64_ldff1_extendvnx2sivnx2qi */

    case 63:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0))
        return -1;
      return 6049; /* aarch64_ldff1_extendvnx2sivnx4hi */

    case 64:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6053; /* aarch64_ldff1_extendvnx2sivnx2hi */

    case 65:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6057; /* aarch64_ldff1_extendvnx2sivnx2si */

    case 66:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 6061; /* aarch64_ldff1_extendvnx2divnx8qi */

    case 67:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 6065; /* aarch64_ldff1_extendvnx2divnx4qi */

    case 68:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6069; /* aarch64_ldff1_extendvnx2divnx2qi */

    case 69:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 6073; /* aarch64_ldff1_extendvnx2divnx4hi */

    case 70:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6077; /* aarch64_ldff1_extendvnx2divnx2hi */

    case 71:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6081; /* aarch64_ldff1_extendvnx2divnx2si */

    case 72:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0))
        return -1;
      return 5942; /* aarch64_ldnf1_extendvnx8hivnx8qi */

    case 73:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0))
        return -1;
      return 5946; /* aarch64_ldnf1_extendvnx8hivnx4qi */

    case 74:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0))
        return -1;
      return 5950; /* aarch64_ldnf1_extendvnx8hivnx2qi */

    case 75:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0))
        return -1;
      return 5954; /* aarch64_ldnf1_extendvnx8hivnx4hi */

    case 76:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0))
        return -1;
      return 5958; /* aarch64_ldnf1_extendvnx8hivnx2hi */

    case 77:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0))
        return -1;
      return 5962; /* aarch64_ldnf1_extendvnx8hivnx2si */

    case 78:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0))
        return -1;
      return 5966; /* aarch64_ldnf1_extendvnx4hivnx8qi */

    case 79:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 5970; /* aarch64_ldnf1_extendvnx4hivnx4qi */

    case 80:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0))
        return -1;
      return 5974; /* aarch64_ldnf1_extendvnx4hivnx2qi */

    case 81:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 5978; /* aarch64_ldnf1_extendvnx4hivnx4hi */

    case 82:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0))
        return -1;
      return 5982; /* aarch64_ldnf1_extendvnx4hivnx2hi */

    case 83:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0))
        return -1;
      return 5986; /* aarch64_ldnf1_extendvnx4hivnx2si */

    case 84:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0))
        return -1;
      return 5990; /* aarch64_ldnf1_extendvnx2hivnx8qi */

    case 85:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0))
        return -1;
      return 5994; /* aarch64_ldnf1_extendvnx2hivnx4qi */

    case 86:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 5998; /* aarch64_ldnf1_extendvnx2hivnx2qi */

    case 87:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0))
        return -1;
      return 6002; /* aarch64_ldnf1_extendvnx2hivnx4hi */

    case 88:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6006; /* aarch64_ldnf1_extendvnx2hivnx2hi */

    case 89:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6010; /* aarch64_ldnf1_extendvnx2hivnx2si */

    case 90:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 6014; /* aarch64_ldnf1_extendvnx4sivnx8qi */

    case 91:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6018; /* aarch64_ldnf1_extendvnx4sivnx4qi */

    case 92:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 6022; /* aarch64_ldnf1_extendvnx4sivnx2qi */

    case 93:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6026; /* aarch64_ldnf1_extendvnx4sivnx4hi */

    case 94:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 6030; /* aarch64_ldnf1_extendvnx4sivnx2hi */

    case 95:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 6034; /* aarch64_ldnf1_extendvnx4sivnx2si */

    case 96:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0))
        return -1;
      return 6038; /* aarch64_ldnf1_extendvnx2sivnx8qi */

    case 97:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0))
        return -1;
      return 6042; /* aarch64_ldnf1_extendvnx2sivnx4qi */

    case 98:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6046; /* aarch64_ldnf1_extendvnx2sivnx2qi */

    case 99:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0))
        return -1;
      return 6050; /* aarch64_ldnf1_extendvnx2sivnx4hi */

    case 100:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6054; /* aarch64_ldnf1_extendvnx2sivnx2hi */

    case 101:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6058; /* aarch64_ldnf1_extendvnx2sivnx2si */

    case 102:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 6062; /* aarch64_ldnf1_extendvnx2divnx8qi */

    case 103:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 6066; /* aarch64_ldnf1_extendvnx2divnx4qi */

    case 104:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6070; /* aarch64_ldnf1_extendvnx2divnx2qi */

    case 105:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 6074; /* aarch64_ldnf1_extendvnx2divnx4hi */

    case 106:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6078; /* aarch64_ldnf1_extendvnx2divnx2hi */

    case 107:
      if (!
#line 1435 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6082; /* aarch64_ldnf1_extendvnx2divnx2si */

    case 108:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
        return -1;
      return 5853; /* *aarch64_load_extend_movvnx8hivnx8qi */

    case 109:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
        return -1;
      return 5855; /* *aarch64_load_extend_movvnx8hivnx4qi */

    case 110:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
        return -1;
      return 5857; /* *aarch64_load_extend_movvnx8hivnx2qi */

    case 111:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
        return -1;
      return 5859; /* *aarch64_load_extend_movvnx8hivnx4hi */

    case 112:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
        return -1;
      return 5861; /* *aarch64_load_extend_movvnx8hivnx2hi */

    case 113:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
        return -1;
      return 5863; /* *aarch64_load_extend_movvnx8hivnx2si */

    case 114:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
        return -1;
      return 5865; /* *aarch64_load_extend_movvnx4hivnx8qi */

    case 115:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
        return -1;
      return 5867; /* *aarch64_load_extend_movvnx4hivnx4qi */

    case 116:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
        return -1;
      return 5869; /* *aarch64_load_extend_movvnx4hivnx2qi */

    case 117:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
        return -1;
      return 5871; /* *aarch64_load_extend_movvnx4hivnx4hi */

    case 118:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
        return -1;
      return 5873; /* *aarch64_load_extend_movvnx4hivnx2hi */

    case 119:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
        return -1;
      return 5875; /* *aarch64_load_extend_movvnx4hivnx2si */

    case 120:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
        return -1;
      return 5877; /* *aarch64_load_extend_movvnx2hivnx8qi */

    case 121:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
        return -1;
      return 5879; /* *aarch64_load_extend_movvnx2hivnx4qi */

    case 122:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
        return -1;
      return 5881; /* *aarch64_load_extend_movvnx2hivnx2qi */

    case 123:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
        return -1;
      return 5883; /* *aarch64_load_extend_movvnx2hivnx4hi */

    case 124:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
        return -1;
      return 5885; /* *aarch64_load_extend_movvnx2hivnx2hi */

    case 125:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
        return -1;
      return 5887; /* *aarch64_load_extend_movvnx2hivnx2si */

    case 126:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
        return -1;
      return 5889; /* *aarch64_load_extend_movvnx4sivnx8qi */

    case 127:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
        return -1;
      return 5891; /* *aarch64_load_extend_movvnx4sivnx4qi */

    case 128:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
        return -1;
      return 5893; /* *aarch64_load_extend_movvnx4sivnx2qi */

    case 129:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
        return -1;
      return 5895; /* *aarch64_load_extend_movvnx4sivnx4hi */

    case 130:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
        return -1;
      return 5897; /* *aarch64_load_extend_movvnx4sivnx2hi */

    case 131:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
        return -1;
      return 5899; /* *aarch64_load_extend_movvnx4sivnx2si */

    case 132:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
        return -1;
      return 5901; /* *aarch64_load_extend_movvnx2sivnx8qi */

    case 133:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
        return -1;
      return 5903; /* *aarch64_load_extend_movvnx2sivnx4qi */

    case 134:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
        return -1;
      return 5905; /* *aarch64_load_extend_movvnx2sivnx2qi */

    case 135:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
        return -1;
      return 5907; /* *aarch64_load_extend_movvnx2sivnx4hi */

    case 136:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
        return -1;
      return 5909; /* *aarch64_load_extend_movvnx2sivnx2hi */

    case 137:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
        return -1;
      return 5911; /* *aarch64_load_extend_movvnx2sivnx2si */

    case 138:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
        return -1;
      return 5913; /* *aarch64_load_extend_movvnx2divnx8qi */

    case 139:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
        return -1;
      return 5915; /* *aarch64_load_extend_movvnx2divnx4qi */

    case 140:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
        return -1;
      return 5917; /* *aarch64_load_extend_movvnx2divnx2qi */

    case 141:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
        return -1;
      return 5919; /* *aarch64_load_extend_movvnx2divnx4hi */

    case 142:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
        return -1;
      return 5921; /* *aarch64_load_extend_movvnx2divnx2hi */

    case 143:
      if (!
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
        return -1;
      return 5923; /* *aarch64_load_extend_movvnx2divnx2si */

    case 144:
      if (!
#line 1663 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 6139; /* aarch64_gather_load_extendvnx4hivnx4qi */

    case 145:
      if (!
#line 1663 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 6143; /* aarch64_gather_load_extendvnx4hivnx4hi */

    case 146:
      if (!
#line 1663 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6141; /* aarch64_gather_load_extendvnx4sivnx4qi */

    case 147:
      if (!
#line 1663 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6145; /* aarch64_gather_load_extendvnx4sivnx4hi */

    case 148:
      if (!
#line 1703 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6147; /* aarch64_gather_load_extendvnx2hivnx2qi */

    case 149:
      if (!
#line 1703 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6153; /* aarch64_gather_load_extendvnx2hivnx2hi */

    case 150:
      if (!
#line 1703 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6159; /* aarch64_gather_load_extendvnx2hivnx2si */

    case 151:
      if (!
#line 1703 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6149; /* aarch64_gather_load_extendvnx2sivnx2qi */

    case 152:
      if (!
#line 1703 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6155; /* aarch64_gather_load_extendvnx2sivnx2hi */

    case 153:
      if (!
#line 1703 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6161; /* aarch64_gather_load_extendvnx2sivnx2si */

    case 154:
      if (!
#line 1703 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6151; /* aarch64_gather_load_extendvnx2divnx2qi */

    case 155:
      if (!
#line 1703 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6157; /* aarch64_gather_load_extendvnx2divnx2hi */

    case 156:
      if (!
#line 1703 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6163; /* aarch64_gather_load_extendvnx2divnx2si */

    case 157:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6165; /* *aarch64_gather_load_extendvnx2hivnx2qi_sxtw_unpacked */

    case 158:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6177; /* *aarch64_gather_load_extendvnx2hivnx2hi_sxtw_unpacked */

    case 159:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6189; /* *aarch64_gather_load_extendvnx2hivnx2si_sxtw_unpacked */

    case 160:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6169; /* *aarch64_gather_load_extendvnx2sivnx2qi_sxtw_unpacked */

    case 161:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6181; /* *aarch64_gather_load_extendvnx2sivnx2hi_sxtw_unpacked */

    case 162:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6193; /* *aarch64_gather_load_extendvnx2sivnx2si_sxtw_unpacked */

    case 163:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6173; /* *aarch64_gather_load_extendvnx2divnx2qi_sxtw_unpacked */

    case 164:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6185; /* *aarch64_gather_load_extendvnx2divnx2hi_sxtw_unpacked */

    case 165:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6197; /* *aarch64_gather_load_extendvnx2divnx2si_sxtw_unpacked */

    case 166:
      if (!
#line 1780 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6201; /* *aarch64_gather_load_extendvnx2hivnx2qi_sxtw */

    case 167:
      if (!
#line 1780 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6207; /* *aarch64_gather_load_extendvnx2hivnx2hi_sxtw */

    case 168:
      if (!
#line 1780 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6213; /* *aarch64_gather_load_extendvnx2hivnx2si_sxtw */

    case 169:
      if (!
#line 1780 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6203; /* *aarch64_gather_load_extendvnx2sivnx2qi_sxtw */

    case 170:
      if (!
#line 1780 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6209; /* *aarch64_gather_load_extendvnx2sivnx2hi_sxtw */

    case 171:
      if (!
#line 1780 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6215; /* *aarch64_gather_load_extendvnx2sivnx2si_sxtw */

    case 172:
      if (!
#line 1780 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6205; /* *aarch64_gather_load_extendvnx2divnx2qi_sxtw */

    case 173:
      if (!
#line 1780 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6211; /* *aarch64_gather_load_extendvnx2divnx2hi_sxtw */

    case 174:
      if (!
#line 1780 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6217; /* *aarch64_gather_load_extendvnx2divnx2si_sxtw */

    case 175:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6167; /* *aarch64_gather_load_extendvnx2hivnx2qi_uxtw_unpacked */

    case 176:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6179; /* *aarch64_gather_load_extendvnx2hivnx2hi_uxtw_unpacked */

    case 177:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6191; /* *aarch64_gather_load_extendvnx2hivnx2si_uxtw_unpacked */

    case 178:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6171; /* *aarch64_gather_load_extendvnx2sivnx2qi_uxtw_unpacked */

    case 179:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6183; /* *aarch64_gather_load_extendvnx2sivnx2hi_uxtw_unpacked */

    case 180:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6195; /* *aarch64_gather_load_extendvnx2sivnx2si_uxtw_unpacked */

    case 181:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6175; /* *aarch64_gather_load_extendvnx2divnx2qi_uxtw_unpacked */

    case 182:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6187; /* *aarch64_gather_load_extendvnx2divnx2hi_uxtw_unpacked */

    case 183:
      if (!
#line 1742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6199; /* *aarch64_gather_load_extendvnx2divnx2si_uxtw_unpacked */

    case 184:
      if (!
#line 1815 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6219; /* *aarch64_gather_load_extendvnx2hivnx2qi_uxtw */

    case 185:
      if (!
#line 1815 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6225; /* *aarch64_gather_load_extendvnx2hivnx2hi_uxtw */

    case 186:
      if (!
#line 1815 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6231; /* *aarch64_gather_load_extendvnx2hivnx2si_uxtw */

    case 187:
      if (!
#line 1815 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6221; /* *aarch64_gather_load_extendvnx2sivnx2qi_uxtw */

    case 188:
      if (!
#line 1815 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6227; /* *aarch64_gather_load_extendvnx2sivnx2hi_uxtw */

    case 189:
      if (!
#line 1815 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6233; /* *aarch64_gather_load_extendvnx2sivnx2si_uxtw */

    case 190:
      if (!
#line 1815 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6223; /* *aarch64_gather_load_extendvnx2divnx2qi_uxtw */

    case 191:
      if (!
#line 1815 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6229; /* *aarch64_gather_load_extendvnx2divnx2hi_uxtw */

    case 192:
      if (!
#line 1815 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6235; /* *aarch64_gather_load_extendvnx2divnx2si_uxtw */

    case 193:
      if (!
#line 1976 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6245; /* aarch64_ldff1_gather_extendvnx4sivnx4qi */

    case 194:
      if (!
#line 1976 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6247; /* aarch64_ldff1_gather_extendvnx4sivnx4hi */

    case 195:
      if (!
#line 2014 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6249; /* aarch64_ldff1_gather_extendvnx2divnx2qi */

    case 196:
      if (!
#line 2014 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6251; /* aarch64_ldff1_gather_extendvnx2divnx2hi */

    case 197:
      if (!
#line 2014 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6253; /* aarch64_ldff1_gather_extendvnx2divnx2si */

    case 198:
      if (!
#line 2052 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6255; /* *aarch64_ldff1_gather_extendvnx2divnx2qi_sxtw */

    case 199:
      if (!
#line 2052 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6257; /* *aarch64_ldff1_gather_extendvnx2divnx2hi_sxtw */

    case 200:
      if (!
#line 2052 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6259; /* *aarch64_ldff1_gather_extendvnx2divnx2si_sxtw */

    case 201:
      if (!
#line 2084 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6261; /* *aarch64_ldff1_gather_extendvnx2divnx2qi_uxtw */

    case 202:
      if (!
#line 2084 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6263; /* *aarch64_ldff1_gather_extendvnx2divnx2hi_uxtw */

    case 203:
      if (!
#line 2084 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6265; /* *aarch64_ldff1_gather_extendvnx2divnx2si_uxtw */

    case 204:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 11259; /* aarch64_gather_ldnt_extendvnx4sivnx8qi */

    case 205:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 11261; /* aarch64_gather_ldnt_extendvnx4sivnx4qi */

    case 206:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 11263; /* aarch64_gather_ldnt_extendvnx4sivnx2qi */

    case 207:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 11265; /* aarch64_gather_ldnt_extendvnx4sivnx4hi */

    case 208:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 11267; /* aarch64_gather_ldnt_extendvnx4sivnx2hi */

    case 209:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 11269; /* aarch64_gather_ldnt_extendvnx4sivnx2si */

    case 210:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 11271; /* aarch64_gather_ldnt_extendvnx2divnx8qi */

    case 211:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 11273; /* aarch64_gather_ldnt_extendvnx2divnx4qi */

    case 212:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 11275; /* aarch64_gather_ldnt_extendvnx2divnx2qi */

    case 213:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 11277; /* aarch64_gather_ldnt_extendvnx2divnx4hi */

    case 214:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 11279; /* aarch64_gather_ldnt_extendvnx2divnx2hi */

    case 215:
      if (!
#line 398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 11281; /* aarch64_gather_ldnt_extendvnx2divnx2si */

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12890; /* aarch64_sve_zipqvnx32qi */

    case 1:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12892; /* aarch64_sve_zipqvnx16hi */

    case 2:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12894; /* aarch64_sve_zipqvnx8si */

    case 3:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12896; /* aarch64_sve_zipqvnx4di */

    case 4:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12898; /* aarch64_sve_zipqvnx16bf */

    case 5:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12900; /* aarch64_sve_zipqvnx16hf */

    case 6:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12902; /* aarch64_sve_zipqvnx8sf */

    case 7:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12904; /* aarch64_sve_zipqvnx4df */

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      if (pattern730 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 9113 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10473; /* aarch64_sve_compactvnx4si */

    case E_VNx2DImode:
      if (pattern730 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 9113 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10474; /* aarch64_sve_compactvnx2di */

    case E_VNx4SFmode:
      if (pattern730 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 9113 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10475; /* aarch64_sve_compactvnx4sf */

    case E_VNx2DFmode:
      if (pattern730 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 9113 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10476; /* aarch64_sve_compactvnx2df */

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      return 1042; /* ucvtfsi3 */

    case 1:
      return 1044; /* ucvtfdi3 */

    case 2:
      if (!
#line 7226 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1050; /* ucvtfsihf3 */

    case 3:
      if (!
#line 7226 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1052; /* ucvtfdihf3 */

    case 4:
      if (!
#line 7246 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1056; /* ucvtfhi3 */

    case 5:
      if (!(
#line 3136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 291 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2643; /* ucvtfv4hi3 */

    case 6:
      if (!(
#line 3136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 292 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2645; /* ucvtfv8hi3 */

    case 7:
      if (!
#line 3136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2647; /* ucvtfv2si3 */

    case 8:
      if (!
#line 3136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2649; /* ucvtfv4si3 */

    case 9:
      if (!
#line 3136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2651; /* ucvtfv2di3 */

    default:
      return -1;
    }
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || pattern85 (x1, 
E_V8DImode, 
94) != 0
      || !aarch64_sync_memory_operand (operands[0], E_V8DImode)
      || !
#line 560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME2))
    return -1;
  return 13032; /* aarch64_restore_zt0 */
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern128 (x1))
    {
    case 0:
      if (!
#line 2270 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12133; /* aarch64_sve_sqdmullbvnx8hi */

    case 1:
      if (!
#line 2270 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12154; /* aarch64_sve_sqdmullbvnx4si */

    case 2:
      if (!
#line 2270 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12175; /* aarch64_sve_sqdmullbvnx2di */

    case 3:
      if (!
#line 2283 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12191; /* aarch64_sve_sqdmullb_lane_vnx4si */

    case 4:
      if (!
#line 2283 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12197; /* aarch64_sve_sqdmullb_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern140 (x1))
    {
    case 0:
      if (!
#line 3723 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12778; /* aarch64_pred_reduc_uminqv_vnx16qi */

    case 1:
      if (!
#line 3723 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12786; /* aarch64_pred_reduc_uminqv_vnx8hi */

    case 2:
      if (!
#line 3723 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12794; /* aarch64_pred_reduc_uminqv_vnx4si */

    case 3:
      if (!
#line 3723 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12802; /* aarch64_pred_reduc_uminqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern134 (x1))
    {
    case 0:
      if (!
#line 2984 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12551; /* aarch64_sve_sqcadd90vnx16qi */

    case 1:
      if (!
#line 2984 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12555; /* aarch64_sve_sqcadd90vnx8hi */

    case 2:
      if (!
#line 2984 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12559; /* aarch64_sve_sqcadd90vnx4si */

    case 3:
      if (!
#line 2984 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12563; /* aarch64_sve_sqcadd90vnx2di */

    default:
      return -1;
    }
}

 int
recog_194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 4
      || XINT (x4, 1) != 393)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  operands[5] = x5;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x6 = XVECEXP (x4, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[3] = x7;
  x8 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (pattern1297 (x2))
    {
    case 0:
      if (!
#line 6329 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8994; /* *aarch64_cond_abdvnx8hf_2_strict */

    case 1:
      if (!
#line 6329 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8995; /* *aarch64_cond_abdvnx4sf_2_strict */

    case 2:
      if (!
#line 6329 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8996; /* *aarch64_cond_abdvnx2df_2_strict */

    default:
      return -1;
    }
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern872 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7238; /* *cond_sqrtvnx8hf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7304; /* *cond_sqrtvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7249; /* *cond_sqrtvnx4sf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7315; /* *cond_sqrtvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7260; /* *cond_sqrtvnx2df_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7326; /* *cond_sqrtvnx2df_any_relaxed */

    case 3:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7271; /* *cond_sqrtvnx8hf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7337; /* *cond_sqrtvnx8hf_any_strict */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7282; /* *cond_sqrtvnx4sf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7348; /* *cond_sqrtvnx4sf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7293; /* *cond_sqrtvnx2df_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7359; /* *cond_sqrtvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern872 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7234; /* *cond_frintnvnx8hf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7300; /* *cond_frintnvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7245; /* *cond_frintnvnx4sf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7311; /* *cond_frintnvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7256; /* *cond_frintnvnx2df_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7322; /* *cond_frintnvnx2df_any_relaxed */

    case 3:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7267; /* *cond_frintnvnx8hf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7333; /* *cond_frintnvnx8hf_any_strict */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7278; /* *cond_frintnvnx4sf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7344; /* *cond_frintnvnx4sf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7289; /* *cond_frintnvnx2df_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7355; /* *cond_frintnvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_236 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11707; /* *cond_srshlvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11749; /* *cond_srshlvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11789; /* *cond_srshlvnx2di_any */
}

 int
recog_246 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11681; /* *cond_sqrshlvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11727; /* *cond_sqrshlvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11767; /* *cond_sqrshlvnx8hi_any */
}

 int
recog_256 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0LL:
      switch (pattern1103 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8529; /* *cond_addvnx8bf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8675; /* *cond_addvnx8bf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8779; /* *cond_addvnx8bf_any_relaxed */

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8542; /* *cond_addvnx8hf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8688; /* *cond_addvnx8hf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8792; /* *cond_addvnx8hf_any_relaxed */

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8555; /* *cond_addvnx4sf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8701; /* *cond_addvnx4sf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8805; /* *cond_addvnx4sf_any_relaxed */

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8568; /* *cond_addvnx2df_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8714; /* *cond_addvnx2df_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8818; /* *cond_addvnx2df_any_relaxed */

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8928; /* *cond_addvnx8hf_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5829 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8934; /* *cond_addvnx8hf_any_const_relaxed */

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8929; /* *cond_addvnx4sf_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5829 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8935; /* *cond_addvnx4sf_any_const_relaxed */

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8930; /* *cond_addvnx2df_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5829 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8936; /* *cond_addvnx2df_any_const_relaxed */

        default:
          return -1;
        }

    case 1LL:
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (pattern1103 (x2))
        {
        case 0:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5497 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8581; /* *cond_addvnx8bf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8727; /* *cond_addvnx8bf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8831; /* *cond_addvnx8bf_any_strict */

        case 1:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5497 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8594; /* *cond_addvnx8hf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8740; /* *cond_addvnx8hf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8844; /* *cond_addvnx8hf_any_strict */

        case 2:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5497 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8607; /* *cond_addvnx4sf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8753; /* *cond_addvnx4sf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8857; /* *cond_addvnx4sf_any_strict */

        case 3:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5497 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8620; /* *cond_addvnx2df_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8766; /* *cond_addvnx2df_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8870; /* *cond_addvnx2df_any_strict */

        case 4:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5806 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8931; /* *cond_addvnx8hf_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5868 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8937; /* *cond_addvnx8hf_any_const_strict */

        case 5:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5806 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8932; /* *cond_addvnx4sf_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5868 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8938; /* *cond_addvnx4sf_any_const_strict */

        case 6:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5806 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8933; /* *cond_addvnx2df_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5868 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8939; /* *cond_addvnx2df_any_const_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XINT (x3, 1))
    {
    case 299:
      return recog_196 (x1, insn, pnum_clobbers);

    case 351:
      return recog_197 (x1, insn, pnum_clobbers);

    case 380:
      switch (pattern872 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7229; /* *cond_negvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7295; /* *cond_negvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7240; /* *cond_negvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7306; /* *cond_negvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7251; /* *cond_negvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7317; /* *cond_negvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7262; /* *cond_negvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7328; /* *cond_negvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7273; /* *cond_negvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7339; /* *cond_negvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7284; /* *cond_negvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7350; /* *cond_negvnx2df_any_strict */

        default:
          return -1;
        }

    case 383:
      switch (pattern872 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7230; /* *cond_frecpxvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7296; /* *cond_frecpxvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7241; /* *cond_frecpxvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7307; /* *cond_frecpxvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7252; /* *cond_frecpxvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7318; /* *cond_frecpxvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7263; /* *cond_frecpxvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7329; /* *cond_frecpxvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7274; /* *cond_frecpxvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7340; /* *cond_frecpxvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7285; /* *cond_frecpxvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7351; /* *cond_frecpxvnx2df_any_strict */

        default:
          return -1;
        }

    case 384:
      switch (pattern872 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7231; /* *cond_roundvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7297; /* *cond_roundvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7242; /* *cond_roundvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7308; /* *cond_roundvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7253; /* *cond_roundvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7319; /* *cond_roundvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7264; /* *cond_roundvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7330; /* *cond_roundvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7275; /* *cond_roundvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7341; /* *cond_roundvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7286; /* *cond_roundvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7352; /* *cond_roundvnx2df_any_strict */

        default:
          return -1;
        }

    case 385:
      switch (pattern872 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7232; /* *cond_nearbyintvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7298; /* *cond_nearbyintvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7243; /* *cond_nearbyintvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7309; /* *cond_nearbyintvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7254; /* *cond_nearbyintvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7320; /* *cond_nearbyintvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7265; /* *cond_nearbyintvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7331; /* *cond_nearbyintvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7276; /* *cond_nearbyintvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7342; /* *cond_nearbyintvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7287; /* *cond_nearbyintvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7353; /* *cond_nearbyintvnx2df_any_strict */

        default:
          return -1;
        }

    case 386:
      switch (pattern872 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7233; /* *cond_floorvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7299; /* *cond_floorvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7244; /* *cond_floorvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7310; /* *cond_floorvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7255; /* *cond_floorvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7321; /* *cond_floorvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7266; /* *cond_floorvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7332; /* *cond_floorvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7277; /* *cond_floorvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7343; /* *cond_floorvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7288; /* *cond_floorvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3781 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7354; /* *cond_floorvnx2df_any_strict */

        default:
          return -1;
        }

    case 387:
      return recog_207 (x1, insn, pnum_clobbers);

    case 388:
      return recog_206 (x1, insn, pnum_clobbers);

    case 389:
      return recog_205 (x1, insn, pnum_clobbers);

    case 390:
      return recog_204 (x1, insn, pnum_clobbers);

    case 392:
      return recog_203 (x1, insn, pnum_clobbers);

    case 369:
      return recog_202 (x1, insn, pnum_clobbers);

    case 370:
      return recog_201 (x1, insn, pnum_clobbers);

    case 394:
      return recog_200 (x1, insn, pnum_clobbers);

    case 397:
      return recog_199 (x1, insn, pnum_clobbers);

    case 368:
      return recog_198 (x1, insn, pnum_clobbers);

    case 78:
      switch (pattern855 (x2))
        {
        case 0:
          if (!
#line 2894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12531; /* *cond_sadalpvnx8hi_2 */

        case 1:
          if (!
#line 2894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12533; /* *cond_sadalpvnx4si_2 */

        case 2:
          if (!
#line 2894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12535; /* *cond_sadalpvnx2di_2 */

        case 3:
          if (!
#line 2917 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12537; /* *cond_sadalpvnx8hi_z */

        case 4:
          if (!
#line 2917 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12539; /* *cond_sadalpvnx4si_z */

        case 5:
          if (!
#line 2917 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12541; /* *cond_sadalpvnx2di_z */

        default:
          return -1;
        }

    case 103:
      switch (pattern855 (x2))
        {
        case 0:
          if (!
#line 2894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12532; /* *cond_uadalpvnx8hi_2 */

        case 1:
          if (!
#line 2894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12534; /* *cond_uadalpvnx4si_2 */

        case 2:
          if (!
#line 2894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12536; /* *cond_uadalpvnx2di_2 */

        case 3:
          if (!
#line 2917 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12538; /* *cond_uadalpvnx8hi_z */

        case 4:
          if (!
#line 2917 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12540; /* *cond_uadalpvnx4si_z */

        case 5:
          if (!
#line 2917 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12542; /* *cond_uadalpvnx2di_z */

        default:
          return -1;
        }

    case 438:
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      operands[2] = x7;
      x5 = XVECEXP (x2, 0, 2);
      operands[3] = x5;
      switch (XWINT (x6, 0))
        {
        case 0LL:
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx4SFmode:
              if (pattern1161 (x2, 
E_VNx4SFmode, 
E_VNx8HFmode, 
E_VNx4BImode) != 0
                  || !
#line 3178 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12631; /* *cond_fcvtltvnx4sf_relaxed */

            case E_VNx2DFmode:
              if (pattern1161 (x2, 
E_VNx2DFmode, 
E_VNx4SFmode, 
E_VNx2BImode) != 0
                  || !
#line 3178 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12632; /* *cond_fcvtltvnx2df_relaxed */

            default:
              return -1;
            }

        case 1LL:
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx4SFmode:
              if (pattern1161 (x2, 
E_VNx4SFmode, 
E_VNx8HFmode, 
E_VNx4BImode) != 0
                  || !
#line 3197 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12633; /* *cond_fcvtltvnx4sf_strict */

            case E_VNx2DFmode:
              if (pattern1161 (x2, 
E_VNx2DFmode, 
E_VNx4SFmode, 
E_VNx2BImode) != 0
                  || !
#line 3197 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12634; /* *cond_fcvtltvnx2df_strict */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 440:
      if (GET_MODE (x3) != E_VNx4SFmode)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x2) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx2DFmode))
        return -1;
      x5 = XVECEXP (x2, 0, 2);
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode))
        return -1;
      switch (XWINT (x6, 0))
        {
        case 0LL:
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          if (!
#line 3279 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 12646; /* *cond_fcvtxvnx4sf_any_relaxed */

        case 1LL:
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[1])
              || !
#line 3302 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 12647; /* *cond_fcvtxvnx4sf_any_strict */

        default:
          return -1;
        }

    case 442:
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      operands[2] = x7;
      x5 = XVECEXP (x2, 0, 2);
      operands[3] = x5;
      switch (XWINT (x6, 0))
        {
        case 0LL:
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              if (pattern1162 (x2, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !
#line 3563 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12674; /* *cond_flogbvnx8hf */

            case E_VNx4SImode:
              if (pattern1162 (x2, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !
#line 3563 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12675; /* *cond_flogbvnx4sf */

            case E_VNx2DImode:
              if (pattern1162 (x2, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !
#line 3563 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12676; /* *cond_flogbvnx2df */

            default:
              return -1;
            }

        case 1LL:
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              if (pattern1162 (x2, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !
#line 3586 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12677; /* *cond_flogbvnx8hf_strict */

            case E_VNx4SImode:
              if (pattern1162 (x2, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !
#line 3586 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12678; /* *cond_flogbvnx4sf_strict */

            case E_VNx2DImode:
              if (pattern1162 (x2, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !
#line 3586 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12679; /* *cond_flogbvnx2df_strict */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_282 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern734 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7488; /* *cond_usaddvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7658; /* *cond_usaddvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7828; /* *cond_usaddvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7505; /* *cond_usaddvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7675; /* *cond_usaddvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7845; /* *cond_usaddvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7522; /* *cond_usaddvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7692; /* *cond_usaddvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7862; /* *cond_usaddvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7539; /* *cond_usaddvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7709; /* *cond_usaddvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7879; /* *cond_usaddvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7556; /* *cond_usaddvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7726; /* *cond_usaddvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7896; /* *cond_usaddvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7573; /* *cond_usaddvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7743; /* *cond_usaddvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7913; /* *cond_usaddvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7590; /* *cond_usaddvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7760; /* *cond_usaddvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7930; /* *cond_usaddvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7607; /* *cond_usaddvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7777; /* *cond_usaddvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7947; /* *cond_usaddvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7624; /* *cond_usaddvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7794; /* *cond_usaddvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7964; /* *cond_usaddvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7641; /* *cond_usaddvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7811; /* *cond_usaddvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7981; /* *cond_usaddvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern610 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6737; /* *cond_rbitvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6827; /* *cond_rbitvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6746; /* *cond_rbitvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6836; /* *cond_rbitvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6755; /* *cond_rbitvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6845; /* *cond_rbitvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6764; /* *cond_rbitvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6854; /* *cond_rbitvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6773; /* *cond_rbitvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6863; /* *cond_rbitvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6782; /* *cond_rbitvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6872; /* *cond_rbitvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6791; /* *cond_rbitvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6881; /* *cond_rbitvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6800; /* *cond_rbitvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6890; /* *cond_rbitvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6809; /* *cond_rbitvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6899; /* *cond_rbitvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6818; /* *cond_rbitvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6908; /* *cond_rbitvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_298 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case LT:
      switch (pattern879 (x3))
        {
        case 0:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9481; /* aarch64_pred_cmpltvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9491; /* aarch64_pred_cmpltvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9521; /* aarch64_pred_cmpltvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9501; /* aarch64_pred_cmpltvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9531; /* aarch64_pred_cmpltvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9551; /* aarch64_pred_cmpltvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9511; /* aarch64_pred_cmpltvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9541; /* aarch64_pred_cmpltvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9561; /* aarch64_pred_cmpltvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9571; /* aarch64_pred_cmpltvnx2di */

        default:
          return -1;
        }

    case LE:
      switch (pattern879 (x3))
        {
        case 0:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9482; /* aarch64_pred_cmplevnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9492; /* aarch64_pred_cmplevnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9522; /* aarch64_pred_cmplevnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9502; /* aarch64_pred_cmplevnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9532; /* aarch64_pred_cmplevnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9552; /* aarch64_pred_cmplevnx4si */

        case 6:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9512; /* aarch64_pred_cmplevnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9542; /* aarch64_pred_cmplevnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9562; /* aarch64_pred_cmplevnx2si */

        case 9:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9572; /* aarch64_pred_cmplevnx2di */

        default:
          return -1;
        }

    case EQ:
      switch (pattern879 (x3))
        {
        case 0:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9483; /* aarch64_pred_cmpeqvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9493; /* aarch64_pred_cmpeqvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9523; /* aarch64_pred_cmpeqvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9503; /* aarch64_pred_cmpeqvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9533; /* aarch64_pred_cmpeqvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9553; /* aarch64_pred_cmpeqvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9513; /* aarch64_pred_cmpeqvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9543; /* aarch64_pred_cmpeqvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9563; /* aarch64_pred_cmpeqvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9573; /* aarch64_pred_cmpeqvnx2di */

        default:
          return -1;
        }

    case NE:
      switch (pattern879 (x3))
        {
        case 0:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9484; /* aarch64_pred_cmpnevnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9494; /* aarch64_pred_cmpnevnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9524; /* aarch64_pred_cmpnevnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9504; /* aarch64_pred_cmpnevnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9534; /* aarch64_pred_cmpnevnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9554; /* aarch64_pred_cmpnevnx4si */

        case 6:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9514; /* aarch64_pred_cmpnevnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9544; /* aarch64_pred_cmpnevnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9564; /* aarch64_pred_cmpnevnx2si */

        case 9:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9574; /* aarch64_pred_cmpnevnx2di */

        default:
          return -1;
        }

    case GE:
      switch (pattern879 (x3))
        {
        case 0:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9485; /* aarch64_pred_cmpgevnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9495; /* aarch64_pred_cmpgevnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9525; /* aarch64_pred_cmpgevnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9505; /* aarch64_pred_cmpgevnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9535; /* aarch64_pred_cmpgevnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9555; /* aarch64_pred_cmpgevnx4si */

        case 6:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9515; /* aarch64_pred_cmpgevnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9545; /* aarch64_pred_cmpgevnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9565; /* aarch64_pred_cmpgevnx2si */

        case 9:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9575; /* aarch64_pred_cmpgevnx2di */

        default:
          return -1;
        }

    case GT:
      switch (pattern879 (x3))
        {
        case 0:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9486; /* aarch64_pred_cmpgtvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9496; /* aarch64_pred_cmpgtvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9526; /* aarch64_pred_cmpgtvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9506; /* aarch64_pred_cmpgtvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9536; /* aarch64_pred_cmpgtvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9556; /* aarch64_pred_cmpgtvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9516; /* aarch64_pred_cmpgtvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9546; /* aarch64_pred_cmpgtvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9566; /* aarch64_pred_cmpgtvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9576; /* aarch64_pred_cmpgtvnx2di */

        default:
          return -1;
        }

    case LTU:
      switch (pattern880 (x3))
        {
        case 0:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9487; /* aarch64_pred_cmplovnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9497; /* aarch64_pred_cmplovnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9527; /* aarch64_pred_cmplovnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9507; /* aarch64_pred_cmplovnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9537; /* aarch64_pred_cmplovnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9557; /* aarch64_pred_cmplovnx4si */

        case 6:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9517; /* aarch64_pred_cmplovnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9547; /* aarch64_pred_cmplovnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9567; /* aarch64_pred_cmplovnx2si */

        case 9:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9577; /* aarch64_pred_cmplovnx2di */

        default:
          return -1;
        }

    case LEU:
      switch (pattern880 (x3))
        {
        case 0:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9488; /* aarch64_pred_cmplsvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9498; /* aarch64_pred_cmplsvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9528; /* aarch64_pred_cmplsvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9508; /* aarch64_pred_cmplsvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9538; /* aarch64_pred_cmplsvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9558; /* aarch64_pred_cmplsvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9518; /* aarch64_pred_cmplsvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9548; /* aarch64_pred_cmplsvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9568; /* aarch64_pred_cmplsvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9578; /* aarch64_pred_cmplsvnx2di */

        default:
          return -1;
        }

    case GEU:
      switch (pattern880 (x3))
        {
        case 0:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9489; /* aarch64_pred_cmphsvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9499; /* aarch64_pred_cmphsvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9529; /* aarch64_pred_cmphsvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9509; /* aarch64_pred_cmphsvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9539; /* aarch64_pred_cmphsvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9559; /* aarch64_pred_cmphsvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9519; /* aarch64_pred_cmphsvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9549; /* aarch64_pred_cmphsvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9569; /* aarch64_pred_cmphsvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9579; /* aarch64_pred_cmphsvnx2di */

        default:
          return -1;
        }

    case GTU:
      switch (pattern880 (x3))
        {
        case 0:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9490; /* aarch64_pred_cmphivnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9500; /* aarch64_pred_cmphivnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9530; /* aarch64_pred_cmphivnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9510; /* aarch64_pred_cmphivnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9540; /* aarch64_pred_cmphivnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9560; /* aarch64_pred_cmphivnx4si */

        case 6:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9520; /* aarch64_pred_cmphivnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9550; /* aarch64_pred_cmphivnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9570; /* aarch64_pred_cmphivnx2si */

        case 9:
          if (!
#line 8184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 9580; /* aarch64_pred_cmphivnx2di */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 2)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      operands[3] = x7;
      x8 = XVECEXP (x6, 0, 1);
      operands[4] = x8;
      switch (XINT (x6, 1))
        {
        case 341:
          switch (pattern1130 (x3))
            {
            case 0:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9881; /* aarch64_pred_cmpeqvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9891; /* aarch64_pred_cmpeqvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9901; /* aarch64_pred_cmpeqvnx4si_wide */

            default:
              return -1;
            }

        case 342:
          switch (pattern1130 (x3))
            {
            case 0:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9882; /* aarch64_pred_cmpgevnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9892; /* aarch64_pred_cmpgevnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9902; /* aarch64_pred_cmpgevnx4si_wide */

            default:
              return -1;
            }

        case 343:
          switch (pattern1130 (x3))
            {
            case 0:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9883; /* aarch64_pred_cmpgtvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9893; /* aarch64_pred_cmpgtvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9903; /* aarch64_pred_cmpgtvnx4si_wide */

            default:
              return -1;
            }

        case 344:
          switch (pattern1130 (x3))
            {
            case 0:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9884; /* aarch64_pred_cmphivnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9894; /* aarch64_pred_cmphivnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9904; /* aarch64_pred_cmphivnx4si_wide */

            default:
              return -1;
            }

        case 345:
          switch (pattern1130 (x3))
            {
            case 0:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9885; /* aarch64_pred_cmphsvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9895; /* aarch64_pred_cmphsvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9905; /* aarch64_pred_cmphsvnx4si_wide */

            default:
              return -1;
            }

        case 346:
          switch (pattern1130 (x3))
            {
            case 0:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9886; /* aarch64_pred_cmplevnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9896; /* aarch64_pred_cmplevnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9906; /* aarch64_pred_cmplevnx4si_wide */

            default:
              return -1;
            }

        case 347:
          switch (pattern1130 (x3))
            {
            case 0:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9887; /* aarch64_pred_cmplovnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9897; /* aarch64_pred_cmplovnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9907; /* aarch64_pred_cmplovnx4si_wide */

            default:
              return -1;
            }

        case 348:
          switch (pattern1130 (x3))
            {
            case 0:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9888; /* aarch64_pred_cmplsvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9898; /* aarch64_pred_cmplsvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9908; /* aarch64_pred_cmplsvnx4si_wide */

            default:
              return -1;
            }

        case 349:
          switch (pattern1130 (x3))
            {
            case 0:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9889; /* aarch64_pred_cmpltvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9899; /* aarch64_pred_cmpltvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9909; /* aarch64_pred_cmpltvnx4si_wide */

            default:
              return -1;
            }

        case 350:
          switch (pattern1130 (x3))
            {
            case 0:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9890; /* aarch64_pred_cmpnevnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9900; /* aarch64_pred_cmpnevnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9910; /* aarch64_pred_cmpnevnx4si_wide */

            default:
              return -1;
            }

        case 473:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (pattern1169 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 4020 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              *pnum_clobbers = 1;
              return 12953; /* aarch64_pred_matchvnx16qi */

            case E_VNx8BImode:
              if (pattern1169 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 4020 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              *pnum_clobbers = 1;
              return 12955; /* aarch64_pred_matchvnx8hi */

            default:
              return -1;
            }

        case 474:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (pattern1169 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 4020 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              *pnum_clobbers = 1;
              return 12954; /* aarch64_pred_nmatchvnx16qi */

            case E_VNx8BImode:
              if (pattern1169 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 4020 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              *pnum_clobbers = 1;
              return 12956; /* aarch64_pred_nmatchvnx8hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_400 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern227 (x1))
    {
    case 0:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13202; /* aarch64_sme_read_vervnx32qivnx32qi */

    case 1:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13204; /* aarch64_sme_read_vervnx16hivnx16hi */

    case 2:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13206; /* aarch64_sme_read_vervnx8sivnx8si */

    case 3:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13208; /* aarch64_sme_read_vervnx4divnx4di */

    case 4:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13210; /* aarch64_sme_read_vervnx16bfvnx16bf */

    case 5:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13212; /* aarch64_sme_read_vervnx16hfvnx16hf */

    case 6:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13214; /* aarch64_sme_read_vervnx8sfvnx8sf */

    case 7:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13216; /* aarch64_sme_read_vervnx4dfvnx4df */

    case 8:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13218; /* aarch64_sme_read_vervnx64qivnx64qi */

    case 9:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13220; /* aarch64_sme_read_vervnx32hivnx32hi */

    case 10:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13222; /* aarch64_sme_read_vervnx16sivnx16si */

    case 11:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13224; /* aarch64_sme_read_vervnx8divnx8di */

    case 12:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13226; /* aarch64_sme_read_vervnx32bfvnx32bf */

    case 13:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13228; /* aarch64_sme_read_vervnx32hfvnx32hf */

    case 14:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13230; /* aarch64_sme_read_vervnx16sfvnx16sf */

    case 15:
      if (!
#line 827 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13232; /* aarch64_sme_read_vervnx8dfvnx8df */

    case 16:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 8))
        return -1;
      return 13234; /* *aarch64_sme_read_vervnx32qivnx32qi_plus */

    case 17:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13236; /* *aarch64_sme_read_vervnx16hivnx16hi_plus */

    case 18:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13238; /* *aarch64_sme_read_vervnx8sivnx8si_plus */

    case 19:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13240; /* *aarch64_sme_read_vervnx4divnx4di_plus */

    case 20:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13242; /* *aarch64_sme_read_vervnx16bfvnx16bf_plus */

    case 21:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13244; /* *aarch64_sme_read_vervnx16hfvnx16hf_plus */

    case 22:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13246; /* *aarch64_sme_read_vervnx8sfvnx8sf_plus */

    case 23:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13248; /* *aarch64_sme_read_vervnx4dfvnx4df_plus */

    case 24:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 8))
        return -1;
      return 13250; /* *aarch64_sme_read_vervnx64qivnx64qi_plus */

    case 25:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13252; /* *aarch64_sme_read_vervnx32hivnx32hi_plus */

    case 26:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13254; /* *aarch64_sme_read_vervnx16sivnx16si_plus */

    case 27:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13256; /* *aarch64_sme_read_vervnx8divnx8di_plus */

    case 28:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13258; /* *aarch64_sme_read_vervnx32bfvnx32bf_plus */

    case 29:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13260; /* *aarch64_sme_read_vervnx32hfvnx32hf_plus */

    case 30:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13262; /* *aarch64_sme_read_vervnx16sfvnx16sf_plus */

    case 31:
      if (!
#line 844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13264; /* *aarch64_sme_read_vervnx8dfvnx8df_plus */

    default:
      return -1;
    }
}

 int
recog_414 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!aarch64_reg_or_zero (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x2, 0, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      if (pattern1066 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 376 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
        return -1;
      return 11255; /* aarch64_gather_ldntvnx4si */

    case E_VNx2DImode:
      if (pattern1066 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 376 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
        return -1;
      return 11256; /* aarch64_gather_ldntvnx2di */

    case E_VNx4SFmode:
      if (pattern1067 (x2, 
E_VNx4SImode, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
          || !
#line 376 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
        return -1;
      return 11257; /* aarch64_gather_ldntvnx4sf */

    case E_VNx2DFmode:
      if (pattern1067 (x2, 
E_VNx2DImode, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
          || !
#line 376 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
        return -1;
      return 11258; /* aarch64_gather_ldntvnx2df */

    default:
      return -1;
    }
}

 int
recog_419 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 90
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 92
      || GET_MODE (x5) != E_DImode
      || pattern732 (x1, 
92) != 0)
    return -1;
  *pnum_clobbers = 8;
  return 13003; /* aarch64_restore_za */
}

 int
recog_420 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (pattern193 (x2, 
E_V8QImode, 
E_V4HFmode) != 0
          || !
#line 203 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT2))
        return -1;
      return 5335; /* aarch64_fdotv4hf */

    case E_V8HFmode:
      if (pattern193 (x2, 
E_V16QImode, 
E_V8HFmode) != 0
          || !
#line 204 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT2))
        return -1;
      return 5336; /* aarch64_fdotv8hf */

    case E_V2SFmode:
      if (pattern193 (x2, 
E_V8QImode, 
E_V2SFmode) != 0
          || !
#line 205 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT4))
        return -1;
      return 5337; /* aarch64_fdotv2sf */

    case E_V4SFmode:
      if (pattern193 (x2, 
E_V16QImode, 
E_V4SFmode) != 0
          || !
#line 206 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT4))
        return -1;
      return 5338; /* aarch64_fdotv4sf */

    default:
      return -1;
    }
}

 int
recog_427 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern261 (x1))
    {
    case 0:
      if (!
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13986; /* aarch64_sme_fmlsvnx8sfvnx8sf */

    case 1:
      if (!
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13988; /* aarch64_sme_fmlsvnx16sfvnx16sf */

    case 2:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13990; /* aarch64_sme_fmlsvnx4dfvnx4df */

    case 3:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13992; /* aarch64_sme_fmlsvnx8dfvnx8df */

    case 4:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13994; /* aarch64_sme_fmlsvnx16hfvnx16hf */

    case 5:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13996; /* aarch64_sme_fmlsvnx32hfvnx32hf */

    case 6:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13998; /* aarch64_sme_fmlsvnx16bfvnx16bf */

    case 7:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14000; /* aarch64_sme_fmlsvnx32bfvnx32bf */

    case 8:
      if (!
#line 1966 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14082; /* aarch64_sme_fmlsvnx4sivnx8bf */

    case 9:
      if (!
#line 1966 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14084; /* aarch64_sme_fmlsvnx4sivnx8hf */

    case 10:
      if (!
#line 1996 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14090; /* aarch64_sme_fmlsvnx4sivnx16bf */

    case 11:
      if (!
#line 1996 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14092; /* aarch64_sme_fmlsvnx4sivnx32bf */

    case 12:
      if (!
#line 1996 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14094; /* aarch64_sme_fmlsvnx4sivnx16hf */

    case 13:
      if (!
#line 1996 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14096; /* aarch64_sme_fmlsvnx4sivnx32hf */

    case 14:
      if (!
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14018; /* aarch64_sme_single_fmlsvnx8sfvnx8sf */

    case 15:
      if (!
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14020; /* aarch64_sme_single_fmlsvnx16sfvnx16sf */

    case 16:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14022; /* aarch64_sme_single_fmlsvnx4dfvnx4df */

    case 17:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14024; /* aarch64_sme_single_fmlsvnx8dfvnx8df */

    case 18:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14026; /* aarch64_sme_single_fmlsvnx16hfvnx16hf */

    case 19:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14028; /* aarch64_sme_single_fmlsvnx32hfvnx32hf */

    case 20:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14030; /* aarch64_sme_single_fmlsvnx16bfvnx16bf */

    case 21:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14032; /* aarch64_sme_single_fmlsvnx32bfvnx32bf */

    case 22:
      if (!
#line 2027 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14106; /* aarch64_sme_single_fmlsvnx4sivnx16bf */

    case 23:
      if (!
#line 2027 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14108; /* aarch64_sme_single_fmlsvnx4sivnx32bf */

    case 24:
      if (!
#line 2027 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14110; /* aarch64_sme_single_fmlsvnx4sivnx16hf */

    case 25:
      if (!
#line 2027 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14112; /* aarch64_sme_single_fmlsvnx4sivnx32hf */

    case 26:
      if (!
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14050; /* aarch64_sme_lane_fmlsvnx8sfvnx8sf */

    case 27:
      if (!
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14052; /* aarch64_sme_lane_fmlsvnx16sfvnx16sf */

    case 28:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14054; /* aarch64_sme_lane_fmlsvnx4dfvnx4df */

    case 29:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14056; /* aarch64_sme_lane_fmlsvnx8dfvnx8df */

    case 30:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14058; /* aarch64_sme_lane_fmlsvnx16hfvnx16hf */

    case 31:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14060; /* aarch64_sme_lane_fmlsvnx32hfvnx32hf */

    case 32:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14062; /* aarch64_sme_lane_fmlsvnx16bfvnx16bf */

    case 33:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14064; /* aarch64_sme_lane_fmlsvnx32bfvnx32bf */

    case 34:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14122; /* aarch64_sme_lane_fmlsvnx4sivnx8bf */

    case 35:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14124; /* aarch64_sme_lane_fmlsvnx4sivnx16bf */

    case 36:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14126; /* aarch64_sme_lane_fmlsvnx4sivnx32bf */

    case 37:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14128; /* aarch64_sme_lane_fmlsvnx4sivnx8hf */

    case 38:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14130; /* aarch64_sme_lane_fmlsvnx4sivnx16hf */

    case 39:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14132; /* aarch64_sme_lane_fmlsvnx4sivnx32hf */

    case 40:
      if (!
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14002; /* *aarch64_sme_fmlsvnx8sfvnx8sf_plus */

    case 41:
      if (!
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14004; /* *aarch64_sme_fmlsvnx16sfvnx16sf_plus */

    case 42:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14006; /* *aarch64_sme_fmlsvnx4dfvnx4df_plus */

    case 43:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14008; /* *aarch64_sme_fmlsvnx8dfvnx8df_plus */

    case 44:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14010; /* *aarch64_sme_fmlsvnx16hfvnx16hf_plus */

    case 45:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14012; /* *aarch64_sme_fmlsvnx32hfvnx32hf_plus */

    case 46:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14014; /* *aarch64_sme_fmlsvnx16bfvnx16bf_plus */

    case 47:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14016; /* *aarch64_sme_fmlsvnx32bfvnx32bf_plus */

    case 48:
      if (const_0_to_14_step_2_operand (operands[1], E_SImode))
        {
          switch (pattern1329 ())
            {
            case 0:
              if (
#line 1980 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 14086; /* *aarch64_sme_fmlsvnx4sivnx8bf_plus */
              break;

            case 1:
              if (
#line 1980 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 14088; /* *aarch64_sme_fmlsvnx4sivnx8hf_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1328 ())
        {
        case 0:
          if (!
#line 2010 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14098; /* *aarch64_sme_fmlsvnx4sivnx16bf_plus */

        case 1:
          if (!
#line 2010 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14100; /* *aarch64_sme_fmlsvnx4sivnx32bf_plus */

        case 2:
          if (!
#line 2010 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14102; /* *aarch64_sme_fmlsvnx4sivnx16hf_plus */

        case 3:
          if (!
#line 2010 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14104; /* *aarch64_sme_fmlsvnx4sivnx32hf_plus */

        default:
          return -1;
        }

    case 49:
      if (!
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14034; /* *aarch64_sme_single_fmlsvnx8sfvnx8sf_plus */

    case 50:
      if (!
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14036; /* *aarch64_sme_single_fmlsvnx16sfvnx16sf_plus */

    case 51:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14038; /* *aarch64_sme_single_fmlsvnx4dfvnx4df_plus */

    case 52:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14040; /* *aarch64_sme_single_fmlsvnx8dfvnx8df_plus */

    case 53:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14042; /* *aarch64_sme_single_fmlsvnx16hfvnx16hf_plus */

    case 54:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14044; /* *aarch64_sme_single_fmlsvnx32hfvnx32hf_plus */

    case 55:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14046; /* *aarch64_sme_single_fmlsvnx16bfvnx16bf_plus */

    case 56:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14048; /* *aarch64_sme_single_fmlsvnx32bfvnx32bf_plus */

    case 57:
      if (!
#line 2042 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14114; /* *aarch64_sme_single_fmlsvnx4sivnx16bf_plus */

    case 58:
      if (!
#line 2042 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14116; /* *aarch64_sme_single_fmlsvnx4sivnx32bf_plus */

    case 59:
      if (!
#line 2042 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14118; /* *aarch64_sme_single_fmlsvnx4sivnx16hf_plus */

    case 60:
      if (!
#line 2042 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14120; /* *aarch64_sme_single_fmlsvnx4sivnx32hf_plus */

    case 61:
      if (!
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14066; /* *aarch64_sme_lane_fmlsvnx8sfvnx8sf */

    case 62:
      if (!
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14068; /* *aarch64_sme_lane_fmlsvnx16sfvnx16sf */

    case 63:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14070; /* *aarch64_sme_lane_fmlsvnx4dfvnx4df */

    case 64:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14072; /* *aarch64_sme_lane_fmlsvnx8dfvnx8df */

    case 65:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14074; /* *aarch64_sme_lane_fmlsvnx16hfvnx16hf */

    case 66:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14076; /* *aarch64_sme_lane_fmlsvnx32hfvnx32hf */

    case 67:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14078; /* *aarch64_sme_lane_fmlsvnx16bfvnx16bf */

    case 68:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14080; /* *aarch64_sme_lane_fmlsvnx32bfvnx32bf */

    case 69:
      if (const_0_to_14_step_2_operand (operands[1], E_SImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          switch (pattern1358 (x3))
            {
            case 0:
              if (
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 14134; /* *aarch64_sme_lane_fmlsvnx4sivnx8bf */
              break;

            case 1:
              if (
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 14140; /* *aarch64_sme_lane_fmlsvnx4sivnx8hf */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1357 (x3))
        {
        case 0:
          if (!
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14136; /* *aarch64_sme_lane_fmlsvnx4sivnx16bf */

        case 1:
          if (!
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14138; /* *aarch64_sme_lane_fmlsvnx4sivnx32bf */

        case 2:
          if (!
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14142; /* *aarch64_sme_lane_fmlsvnx4sivnx16hf */

        case 3:
          if (!
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14144; /* *aarch64_sme_lane_fmlsvnx4sivnx32hf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_442 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern252 (x1))
    {
    case 0:
      if (!
#line 1385 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13616; /* aarch64_sme_lane_suvdotvnx4sivnx32qi */

    case 1:
      if (!
#line 1385 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13624; /* aarch64_sme_lane_suvdotvnx4sivnx64qi */

    case 2:
      if (!
#line 1385 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13632; /* aarch64_sme_lane_suvdotvnx4sivnx16hi */

    case 3:
      if (!
#line 1385 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13640; /* aarch64_sme_lane_suvdotvnx4sivnx32hi */

    case 4:
      if (!(
#line 1385 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13648; /* aarch64_sme_lane_suvdotvnx2divnx32qi */

    case 5:
      if (!(
#line 1385 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13656; /* aarch64_sme_lane_suvdotvnx2divnx64qi */

    case 6:
      if (!(
#line 1385 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13664; /* aarch64_sme_lane_suvdotvnx2divnx16hi */

    case 7:
      if (!(
#line 1385 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13672; /* aarch64_sme_lane_suvdotvnx2divnx32hi */

    case 8:
      if (!
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13680; /* *aarch64_sme_lane_suvdotvnx4sivnx32qi_plus */

    case 9:
      if (!
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13688; /* *aarch64_sme_lane_suvdotvnx4sivnx64qi_plus */

    case 10:
      if (!
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13696; /* *aarch64_sme_lane_suvdotvnx4sivnx16hi_plus */

    case 11:
      if (!
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13704; /* *aarch64_sme_lane_suvdotvnx4sivnx32hi_plus */

    case 12:
      if (!(
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13712; /* *aarch64_sme_lane_suvdotvnx2divnx32qi_plus */

    case 13:
      if (!(
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13720; /* *aarch64_sme_lane_suvdotvnx2divnx64qi_plus */

    case 14:
      if (!(
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13728; /* *aarch64_sme_lane_suvdotvnx2divnx16hi_plus */

    case 15:
      if (!(
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13736; /* *aarch64_sme_lane_suvdotvnx2divnx32hi_plus */

    default:
      return -1;
    }
}

 int
recog_451 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  operands[1] = x3;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      switch (pattern954 (x4, 
E_SImode))
        {
        case 0:
          if (!
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 32))
            return -1;
          return 829; /* *aarch64_bfisihi_16 */

        case 1:
          if (!
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 32))
            return -1;
          return 833; /* *aarch64_bfisisi_16 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern954 (x4, 
E_DImode))
        {
        case 0:
          if (!
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
            return -1;
          return 831; /* *aarch64_bfidihi_16 */

        case 1:
          if (!
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
            return -1;
          return 836; /* *aarch64_bfidisi_16 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_452 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!cc_register (operands[2], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[3] = x8;
  if (!aarch64_reg_zero_or_m1_or_1 (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x3, 2);
  operands[4] = x9;
  if (!aarch64_reg_zero_or_m1_or_1 (operands[4], E_SImode)
      || !
#line 4574 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
    return -1;
  return 459; /* *cmovsi_insn_uxtw */
}

 int
recog_454 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      switch (XINT (x4, 1))
        {
        case 39:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != LO_SUM
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!aarch64_valid_symref (operands[2], E_DImode)
              || !
#line 7678 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_ILP32))
            return -1;
          return 1129; /* ldr_got_small_28k_sidi */

        case 41:
          if (GET_MODE (x4) != E_SImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!aarch64_valid_symref (operands[1], E_DImode)
              || !
#line 7697 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_ILP32))
            return -1;
          return 1132; /* ldr_got_tiny_sidi */

        case 40:
          if (pattern495 (x3) != 0)
            return -1;
          return 1138; /* tlsie_small_sidi */

        case 205:
          x5 = XVECEXP (x4, 0, 0);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  switch (pattern809 (x3, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 3402 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2732; /* aarch64_zero_extendsi_reduc_plus_v8qi */

                    case 1:
                      if (!
#line 3402 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2734; /* aarch64_zero_extendsi_reduc_plus_v16qi */

                    case 2:
                      if (!
#line 3402 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2736; /* aarch64_zero_extendsi_reduc_plus_v4hi */

                    case 3:
                      if (!
#line 3402 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2738; /* aarch64_zero_extendsi_reduc_plus_v8hi */

                    default:
                      return -1;
                    }

                case E_DImode:
                  switch (pattern809 (x3, 
E_DImode))
                    {
                    case 0:
                      if (!
#line 3402 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2733; /* aarch64_zero_extenddi_reduc_plus_v8qi */

                    case 1:
                      if (!
#line 3402 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2735; /* aarch64_zero_extenddi_reduc_plus_v16qi */

                    case 2:
                      if (!
#line 3402 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2737; /* aarch64_zero_extenddi_reduc_plus_v4hi */

                    case 3:
                      if (!
#line 3402 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2739; /* aarch64_zero_extenddi_reduc_plus_v8hi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern618 (x3))
                {
                case 0:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2770; /* *aarch64_saddlvv8qi_zesi */

                case 1:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2774; /* *aarch64_saddlvv16qi_zesi */

                case 2:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2778; /* *aarch64_saddlvv4hi_zesi */

                case 3:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2782; /* *aarch64_saddlvv8hi_zesi */

                case 4:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2786; /* *aarch64_saddlvv4si_zesi */

                case 5:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2790; /* *aarch64_saddlvv2si_zesi */

                case 6:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2772; /* *aarch64_saddlvv8qi_zedi */

                case 7:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2776; /* *aarch64_saddlvv16qi_zedi */

                case 8:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2780; /* *aarch64_saddlvv4hi_zedi */

                case 9:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2784; /* *aarch64_saddlvv8hi_zedi */

                case 10:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2788; /* *aarch64_saddlvv4si_zedi */

                case 11:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2792; /* *aarch64_saddlvv2si_zedi */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern618 (x3))
                {
                case 0:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2771; /* *aarch64_uaddlvv8qi_zesi */

                case 1:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2775; /* *aarch64_uaddlvv16qi_zesi */

                case 2:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2779; /* *aarch64_uaddlvv4hi_zesi */

                case 3:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2783; /* *aarch64_uaddlvv8hi_zesi */

                case 4:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2787; /* *aarch64_uaddlvv4si_zesi */

                case 5:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2791; /* *aarch64_uaddlvv2si_zesi */

                case 6:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2773; /* *aarch64_uaddlvv8qi_zedi */

                case 7:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2777; /* *aarch64_uaddlvv16qi_zedi */

                case 8:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2781; /* *aarch64_uaddlvv4hi_zedi */

                case 9:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2785; /* *aarch64_uaddlvv8hi_zedi */

                case 10:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2789; /* *aarch64_uaddlvv4si_zedi */

                case 11:
                  if (!
#line 3508 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2793; /* *aarch64_uaddlvv2si_zedi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x4, 1) != 42
          || pattern495 (x3) != 0)
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1141; /* tlsie_tiny_sidi */

    case 3:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      x10 = XVECEXP (x4, 0, 2);
      operands[3] = x10;
      switch (XINT (x4, 1))
        {
        case 169:
          if (!const_int_operand (operands[1], E_DImode)
              || !const_int_operand (operands[2], E_DImode)
              || !const_int_operand (operands[3], E_DImode)
              || !
#line 10356 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11029; /* aarch64_sve_cnt_pat */

        case 307:
          if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16BImode:
              if (!register_operand (operands[1], E_VNx16BImode)
                  || !register_operand (operands[3], E_VNx16BImode)
                  || !
#line 10678 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11060; /* aarch64_pred_cntpvnx16bi */

            case E_VNx8BImode:
              if (!register_operand (operands[1], E_VNx8BImode)
                  || !register_operand (operands[3], E_VNx8BImode)
                  || !
#line 10678 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11061; /* aarch64_pred_cntpvnx8bi */

            case E_VNx4BImode:
              if (!register_operand (operands[1], E_VNx4BImode)
                  || !register_operand (operands[3], E_VNx4BImode)
                  || !
#line 10678 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11062; /* aarch64_pred_cntpvnx4bi */

            case E_VNx2BImode:
              if (!register_operand (operands[1], E_VNx2BImode)
                  || !register_operand (operands[3], E_VNx2BImode)
                  || !
#line 10678 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11063; /* aarch64_pred_cntpvnx2bi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_458 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!aarch64_pluslong_operand (operands[2], E_SImode))
        return -1;
      return 122; /* *addsi3_aarch64_uxtw */

    case ASHIFT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern808 (x3))
            {
            case 0:
              return 212; /* *add_lsl_si_uxtw */

            case 1:
              if (!
#line 6232 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < 32 &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == 32)))
                return -1;
              return 789; /* *extrsi5_insn_uxtw */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern885 (x3))
            {
            case 0:
              return 247; /* *add_extendqi_shft_si_uxtw */

            case 1:
              return 249; /* *add_extendhi_shft_si_uxtw */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern885 (x3))
            {
            case 0:
              return 248; /* *add_zero_extendqi_shft_si_uxtw */

            case 1:
              return 250; /* *add_zero_extendhi_shft_si_uxtw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern735 (x3) != 0)
        return -1;
      return 213; /* *add_asr_si_uxtw */

    case LSHIFTRT:
      switch (pattern736 (x3))
        {
        case 0:
          return 214; /* *add_lsr_si_uxtw */

        case 1:
          if (!
#line 6246 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < 32 &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == 32)))
            return -1;
          return 792; /* *extrsi5_insn_uxtw_alt */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern738 (x3))
        {
        case 0:
          return 227; /* *add_extendqi_si_uxtw */

        case 1:
          return 229; /* *add_extendqi_si_uxtw */

        case 2:
          return 231; /* *add_extendhi_si_uxtw */

        case 3:
          return 233; /* *add_extendhi_si_uxtw */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern738 (x3))
        {
        case 0:
          return 228; /* *add_zero_extendqi_si_uxtw */

        case 1:
          return 230; /* *add_zero_extendqi_si_uxtw */

        case 2:
          return 232; /* *add_zero_extendhi_si_uxtw */

        case 3:
          return 234; /* *add_zero_extendhi_si_uxtw */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!aarch64_carry_operation (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 253; /* *addsi3_carryin_uxtw */

    case AND:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != ASHIFT
          || GET_MODE (x7) != E_SImode)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x7, 1);
      operands[2] = x10;
      if (!aarch64_imm3 (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[4] = x6;
      if (!register_operand (operands[4], E_SImode)
          || !
#line 3269 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]), INTVAL (operands[3])) != 0))
        return -1;
      return 264; /* *add_uxtsi_shift2_uxtw */

    case MULT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 382; /* *maddsi_uxtw */

    default:
      return -1;
    }
}

 int
recog_462 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_459 (x1, insn, pnum_clobbers);

    case 3:
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 407:
          switch (pattern633 (x2))
            {
            case 0:
              if (!(
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1454; /* aarch64_fcmla_lane0v4hf */

            case 1:
              if (!
#line 486 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1490; /* aarch64_fcmla_laneq0v4hf */

            case 2:
              if (!(
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1466; /* aarch64_fcmla_lane0v8hf */

            case 3:
              if (!
#line 501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1502; /* aarch64_fcmlaq_lane0v8hf */

            case 4:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1470; /* aarch64_fcmla_lane0v2sf */

            case 5:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1482; /* aarch64_fcmla_lane0v4sf */

            case 6:
              if (!
#line 501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1506; /* aarch64_fcmlaq_lane0v4sf */

            case 7:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1486; /* aarch64_fcmla_lane0v2df */

            default:
              return -1;
            }

        case 408:
          switch (pattern633 (x2))
            {
            case 0:
              if (!(
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1457; /* aarch64_fcmla_lane90v4hf */

            case 1:
              if (!
#line 486 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1493; /* aarch64_fcmla_laneq90v4hf */

            case 2:
              if (!(
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1467; /* aarch64_fcmla_lane90v8hf */

            case 3:
              if (!
#line 501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1503; /* aarch64_fcmlaq_lane90v8hf */

            case 4:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1473; /* aarch64_fcmla_lane90v2sf */

            case 5:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1483; /* aarch64_fcmla_lane90v4sf */

            case 6:
              if (!
#line 501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1507; /* aarch64_fcmlaq_lane90v4sf */

            case 7:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1487; /* aarch64_fcmla_lane90v2df */

            default:
              return -1;
            }

        case 409:
          switch (pattern633 (x2))
            {
            case 0:
              if (!(
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1460; /* aarch64_fcmla_lane180v4hf */

            case 1:
              if (!
#line 486 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1496; /* aarch64_fcmla_laneq180v4hf */

            case 2:
              if (!(
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1468; /* aarch64_fcmla_lane180v8hf */

            case 3:
              if (!
#line 501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1504; /* aarch64_fcmlaq_lane180v8hf */

            case 4:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1476; /* aarch64_fcmla_lane180v2sf */

            case 5:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1484; /* aarch64_fcmla_lane180v4sf */

            case 6:
              if (!
#line 501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1508; /* aarch64_fcmlaq_lane180v4sf */

            case 7:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1488; /* aarch64_fcmla_lane180v2df */

            default:
              return -1;
            }

        case 410:
          switch (pattern633 (x2))
            {
            case 0:
              if (!(
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1463; /* aarch64_fcmla_lane270v4hf */

            case 1:
              if (!
#line 486 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1499; /* aarch64_fcmla_laneq270v4hf */

            case 2:
              if (!(
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1469; /* aarch64_fcmla_lane270v8hf */

            case 3:
              if (!
#line 501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1505; /* aarch64_fcmlaq_lane270v8hf */

            case 4:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1479; /* aarch64_fcmla_lane270v2sf */

            case 5:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1485; /* aarch64_fcmla_lane270v4sf */

            case 6:
              if (!
#line 501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1509; /* aarch64_fcmlaq_lane270v4sf */

            case 7:
              if (!
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
                return -1;
              return 1489; /* aarch64_fcmla_lane270v2df */

            default:
              return -1;
            }

        case 279:
          switch (pattern635 (x2))
            {
            case 0:
              if (!
#line 606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1522; /* aarch64_sdot_lanev8qi */

            case 1:
              if (!
#line 622 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1530; /* aarch64_sdot_laneqv8qi */

            case 2:
              if (!
#line 606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1528; /* aarch64_sdot_lanev16qi */

            case 3:
              if (!
#line 622 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1536; /* aarch64_sdot_laneqv16qi */

            default:
              return -1;
            }

        case 280:
          switch (pattern635 (x2))
            {
            case 0:
              if (!
#line 606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1525; /* aarch64_udot_lanev8qi */

            case 1:
              if (!
#line 622 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1533; /* aarch64_udot_laneqv8qi */

            case 2:
              if (!
#line 606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1529; /* aarch64_udot_lanev16qi */

            case 3:
              if (!
#line 622 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
                return -1;
              return 1537; /* aarch64_udot_laneqv16qi */

            default:
              return -1;
            }

        case 573:
          switch (pattern635 (x2))
            {
            case 0:
              if (!
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1538; /* aarch64_usdot_lanev8qi */

            case 1:
              if (!
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1546; /* aarch64_usdot_laneqv8qi */

            case 2:
              if (!
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1544; /* aarch64_usdot_lanev16qi */

            case 3:
              if (!
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1552; /* aarch64_usdot_laneqv16qi */

            default:
              return -1;
            }

        case 578:
          switch (pattern635 (x2))
            {
            case 0:
              if (!
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1541; /* aarch64_sudot_lanev8qi */

            case 1:
              if (!
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1549; /* aarch64_sudot_laneqv8qi */

            case 2:
              if (!
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1545; /* aarch64_sudot_lanev16qi */

            case 3:
              if (!
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1553; /* aarch64_sudot_laneqv16qi */

            default:
              return -1;
            }

        case 579:
          x5 = XVECEXP (x3, 0, 0);
          operands[2] = x5;
          x6 = XVECEXP (x3, 0, 1);
          operands[3] = x6;
          x7 = XVECEXP (x3, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              switch (pattern1007 (x2, 
E_V2SFmode, 
E_V4BFmode))
                {
                case 0:
                  if (!
#line 9910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5259; /* aarch64_bfdot_lanev2sf */

                case 1:
                  if (!
#line 9910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5261; /* aarch64_bfdot_laneqv2sf */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1007 (x2, 
E_V4SFmode, 
E_V8BFmode))
                {
                case 0:
                  if (!
#line 9910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5260; /* aarch64_bfdot_lanev4sf */

                case 1:
                  if (!
#line 9910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5262; /* aarch64_bfdot_laneqv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 169:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x5 = XVECEXP (x3, 0, 0);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x3, 0, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x7 = XVECEXP (x3, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_DImode)
              || !register_operand (operands[1], E_SImode)
              || !
#line 10398 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11033; /* *aarch64_sve_incsi_pat */

        case 307:
          switch (pattern636 (x2))
            {
            case 0:
              if (!
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11076; /* *aarch64_incsivnx16bi_cntp */

            case 1:
              if (!
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11077; /* *aarch64_incsivnx8bi_cntp */

            case 2:
              if (!
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11078; /* *aarch64_incsivnx4bi_cntp */

            case 3:
              if (!
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11079; /* *aarch64_incsivnx2bi_cntp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_467 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern642 (x2, 
E_SImode) != 0)
            return -1;
          return 383; /* *msubsi */

        case E_DImode:
          if (pattern642 (x2, 
E_DImode) != 0)
            return -1;
          return 384; /* *msubdi */

        case E_V8QImode:
          if (pattern643 (x2, 
E_V8QImode) != 0
              || !
#line 1695 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2036; /* aarch64_mlsv8qi */

        case E_V16QImode:
          if (pattern643 (x2, 
E_V16QImode) != 0
              || !
#line 1695 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2039; /* aarch64_mlsv16qi */

        case E_V4HImode:
          if (pattern643 (x2, 
E_V4HImode) != 0
              || !
#line 1695 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2040; /* aarch64_mlsv4hi */

        case E_V8HImode:
          if (pattern643 (x2, 
E_V8HImode) != 0
              || !
#line 1695 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2043; /* aarch64_mlsv8hi */

        case E_V2SImode:
          if (pattern643 (x2, 
E_V2SImode) != 0
              || !
#line 1695 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2044; /* aarch64_mlsv2si */

        case E_V4SImode:
          if (pattern643 (x2, 
E_V4SImode) != 0
              || !
#line 1695 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2047; /* aarch64_mlsv4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern748 (x2))
                {
                case 0:
                  return 393; /* msubsidi4 */

                case 1:
                  if (!
#line 2201 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2276; /* aarch64_smlslv8qi */

                case 2:
                  if (!
#line 2201 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2278; /* aarch64_smlslv4hi */

                case 3:
                  if (!
#line 2201 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2280; /* aarch64_smlslv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern750 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2216 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2282; /* aarch64_smlsl_nv4hi */

                case 1:
                  if (!
#line 2216 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2284; /* aarch64_smlsl_nv2si */

                case 2:
                  if (!
#line 2522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2344; /* aarch64_vec_smlsl_lane_v4hi */

                case 3:
                  if (!
#line 2522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2346; /* aarch64_vec_smlsl_laneq_v4hi */

                case 4:
                  if (!
#line 2522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2348; /* aarch64_vec_smlsl_lane_v2si */

                case 5:
                  if (!
#line 2522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2350; /* aarch64_vec_smlsl_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern957 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2250; /* *aarch64_smlsl_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2113 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2256; /* aarch64_smlsl_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2252; /* *aarch64_smlsl_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2113 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2258; /* aarch64_smlsl_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2254; /* *aarch64_smlsl_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2113 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2260; /* aarch64_smlsl_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern959 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2144 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2262; /* aarch64_smlsl_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2144 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2264; /* aarch64_smlsl_hi_nv4si_insn */

                case 2:
                  if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2352; /* aarch64_smlsl_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2356; /* aarch64_smlsl_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2354; /* aarch64_smlsl_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2358; /* aarch64_smlsl_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern748 (x2))
                {
                case 0:
                  return 394; /* umsubsidi4 */

                case 1:
                  if (!
#line 2201 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2277; /* aarch64_umlslv8qi */

                case 2:
                  if (!
#line 2201 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2279; /* aarch64_umlslv4hi */

                case 3:
                  if (!
#line 2201 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2281; /* aarch64_umlslv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern750 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2216 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2283; /* aarch64_umlsl_nv4hi */

                case 1:
                  if (!
#line 2216 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2285; /* aarch64_umlsl_nv2si */

                case 2:
                  if (!
#line 2522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2345; /* aarch64_vec_umlsl_lane_v4hi */

                case 3:
                  if (!
#line 2522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2347; /* aarch64_vec_umlsl_laneq_v4hi */

                case 4:
                  if (!
#line 2522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2349; /* aarch64_vec_umlsl_lane_v2si */

                case 5:
                  if (!
#line 2522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2351; /* aarch64_vec_umlsl_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern957 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2251; /* *aarch64_umlsl_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2113 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2257; /* aarch64_umlsl_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2253; /* *aarch64_umlsl_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2113 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2259; /* aarch64_umlsl_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2255; /* *aarch64_umlsl_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2113 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2261; /* aarch64_umlsl_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern959 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2144 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2263; /* aarch64_umlsl_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2144 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2265; /* aarch64_umlsl_hi_nv4si_insn */

                case 2:
                  if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2353; /* aarch64_umlsl_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2357; /* aarch64_umlsl_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2355; /* aarch64_umlsl_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2359; /* aarch64_umlsl_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          x9 = XEXP (x5, 1);
          if (GET_CODE (x9) != PARALLEL
              || XVECLEN (x9, 0) != 1)
            return -1;
          x7 = XEXP (x2, 0);
          operands[4] = x7;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          x10 = XVECEXP (x9, 0, 0);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern1176 (x2, 
E_V4HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2048; /* *aarch64_mls_eltv4hi */

                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2056; /* *aarch64_mls_elt_to_128v4hi */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern1176 (x2, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2051; /* *aarch64_mls_eltv8hi */

                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2059; /* *aarch64_mls_elt_to_64v8hi */

                default:
                  return -1;
                }

            case E_V2SImode:
              if (pattern1176 (x2, 
E_V2SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2052; /* *aarch64_mls_eltv2si */

                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2060; /* *aarch64_mls_elt_to_128v2si */

                default:
                  return -1;
                }

            case E_V4SImode:
              if (pattern1176 (x2, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2055; /* *aarch64_mls_eltv4si */

                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2063; /* *aarch64_mls_elt_to_64v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x5;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern960 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 1744 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2064; /* aarch64_mls_nv4hi */

            case E_V8HImode:
              if (pattern960 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 1744 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2067; /* aarch64_mls_nv8hi */

            case E_V2SImode:
              if (pattern960 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 1744 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2068; /* aarch64_mls_nv2si */

            case E_V4SImode:
              if (pattern960 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 1744 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2071; /* aarch64_mls_nv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 168)
        return -1;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      x11 = XVECEXP (x4, 0, 0);
      operands[3] = x11;
      x12 = XVECEXP (x4, 0, 1);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern1139 (x2, 
E_VNx8HImode) != 0
              || !
#line 1510 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11916; /* aarch64_sve_sub_mul_lane_vnx8hi */

        case E_VNx4SImode:
          if (pattern1139 (x2, 
E_VNx4SImode) != 0
              || !
#line 1510 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11917; /* aarch64_sve_sub_mul_lane_vnx4si */

        case E_VNx2DImode:
          if (pattern1139 (x2, 
E_VNx2DImode) != 0
              || !
#line 1510 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11918; /* aarch64_sve_sub_mul_lane_vnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_483 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (XVECLEN (x4, 0) == 1)
    {
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern823 (x2, 
E_V8QImode, 
E_QImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1259; /* aarch64_dup_lanev8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 137 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1273; /* aarch64_dup_lane_to_128v8qi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V16QImode:
          if (pattern823 (x2, 
E_V16QImode, 
E_QImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1260; /* aarch64_dup_lanev16qi */
                  break;

                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 137 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1274; /* aarch64_dup_lane_to_64v16qi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4HImode:
          if (pattern823 (x2, 
E_V4HImode, 
E_HImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1261; /* aarch64_dup_lanev4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 137 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1275; /* aarch64_dup_lane_to_128v4hi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V8HImode:
          if (pattern823 (x2, 
E_V8HImode, 
E_HImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1262; /* aarch64_dup_lanev8hi */
                  break;

                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 137 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1276; /* aarch64_dup_lane_to_64v8hi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2SImode:
          if (pattern823 (x2, 
E_V2SImode, 
E_SImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1263; /* aarch64_dup_lanev2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 137 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1277; /* aarch64_dup_lane_to_128v2si */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SImode:
          if (pattern823 (x2, 
E_V4SImode, 
E_SImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1264; /* aarch64_dup_lanev4si */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 137 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1278; /* aarch64_dup_lane_to_64v4si */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2DImode:
          if (pattern824 (x2, 
E_V2DImode, 
E_DImode) == 0
              && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1265; /* aarch64_dup_lanev2di */
          break;

        case E_V4HFmode:
          if (pattern823 (x2, 
E_V4HFmode, 
E_HFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1266; /* aarch64_dup_lanev4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 137 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1279; /* aarch64_dup_lane_to_128v4hf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V8HFmode:
          if (pattern823 (x2, 
E_V8HFmode, 
E_HFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1267; /* aarch64_dup_lanev8hf */
                  break;

                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 137 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1280; /* aarch64_dup_lane_to_64v8hf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4BFmode:
          if (pattern824 (x2, 
E_V4BFmode, 
E_BFmode) == 0
              && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1268; /* aarch64_dup_lanev4bf */
          break;

        case E_V8BFmode:
          if (pattern824 (x2, 
E_V8BFmode, 
E_BFmode) == 0
              && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1269; /* aarch64_dup_lanev8bf */
          break;

        case E_V2SFmode:
          if (pattern823 (x2, 
E_V2SFmode, 
E_SFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1270; /* aarch64_dup_lanev2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 137 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1281; /* aarch64_dup_lane_to_128v2sf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SFmode:
          if (pattern823 (x2, 
E_V4SFmode, 
E_SFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1271; /* aarch64_dup_lanev4sf */
                  break;

                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 137 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1282; /* aarch64_dup_lane_to_64v4sf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2DFmode:
          if (pattern824 (x2, 
E_V2DFmode, 
E_DFmode) == 0
              && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1272; /* aarch64_dup_lanev2df */
          break;

        case E_VNx16QImode:
          if (pattern825 (x2, 
E_VNx16QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 8 / 8, 0, 63)))
            return 10477; /* aarch64_sve_dup_lanevnx16qi */
          break;

        case E_VNx8QImode:
          if (pattern825 (x2, 
E_VNx8QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10478; /* aarch64_sve_dup_lanevnx8qi */
          break;

        case E_VNx4QImode:
          if (pattern825 (x2, 
E_VNx4QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10479; /* aarch64_sve_dup_lanevnx4qi */
          break;

        case E_VNx2QImode:
          if (pattern825 (x2, 
E_VNx2QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10480; /* aarch64_sve_dup_lanevnx2qi */
          break;

        case E_VNx8HImode:
          if (pattern825 (x2, 
E_VNx8HImode, 
E_HImode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10481; /* aarch64_sve_dup_lanevnx8hi */
          break;

        case E_VNx4HImode:
          if (pattern825 (x2, 
E_VNx4HImode, 
E_HImode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10482; /* aarch64_sve_dup_lanevnx4hi */
          break;

        case E_VNx2HImode:
          if (pattern825 (x2, 
E_VNx2HImode, 
E_HImode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10483; /* aarch64_sve_dup_lanevnx2hi */
          break;

        case E_VNx4SImode:
          if (pattern825 (x2, 
E_VNx4SImode, 
E_SImode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10484; /* aarch64_sve_dup_lanevnx4si */
          break;

        case E_VNx2SImode:
          if (pattern825 (x2, 
E_VNx2SImode, 
E_SImode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10485; /* aarch64_sve_dup_lanevnx2si */
          break;

        case E_VNx2DImode:
          if (pattern825 (x2, 
E_VNx2DImode, 
E_DImode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10486; /* aarch64_sve_dup_lanevnx2di */
          break;

        case E_VNx8HFmode:
          if (pattern825 (x2, 
E_VNx8HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10487; /* aarch64_sve_dup_lanevnx8hf */
          break;

        case E_VNx4HFmode:
          if (pattern825 (x2, 
E_VNx4HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10488; /* aarch64_sve_dup_lanevnx4hf */
          break;

        case E_VNx2HFmode:
          if (pattern825 (x2, 
E_VNx2HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10489; /* aarch64_sve_dup_lanevnx2hf */
          break;

        case E_VNx8BFmode:
          if (pattern825 (x2, 
E_VNx8BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10490; /* aarch64_sve_dup_lanevnx8bf */
          break;

        case E_VNx4BFmode:
          if (pattern825 (x2, 
E_VNx4BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10491; /* aarch64_sve_dup_lanevnx4bf */
          break;

        case E_VNx2BFmode:
          if (pattern825 (x2, 
E_VNx2BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10492; /* aarch64_sve_dup_lanevnx2bf */
          break;

        case E_VNx4SFmode:
          if (pattern825 (x2, 
E_VNx4SFmode, 
E_SFmode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10493; /* aarch64_sve_dup_lanevnx4sf */
          break;

        case E_VNx2SFmode:
          if (pattern825 (x2, 
E_VNx2SFmode, 
E_SFmode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10494; /* aarch64_sve_dup_lanevnx2sf */
          break;

        case E_VNx2DFmode:
          if (pattern825 (x2, 
E_VNx2DFmode, 
E_DFmode) == 0
              && 
#line 9124 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10495; /* aarch64_sve_dup_lanevnx2df */
          break;

        default:
          break;
        }
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x2) != E_VNx16QImode
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V16QImode) - 1)))
            return -1;
          return 6428; /* aarch64_vec_duplicate_vqvnx16qi_be */

        case E_VNx16QImode:
          if (!register_operand (operands[1], E_VNx16QImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (QImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (QImode), 0, 63)))
            return -1;
          return 10496; /* aarch64_sve_dupq_lanevnx16qi */

        default:
          return -1;
        }

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x2) != E_VNx8HImode
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HImode) - 1)))
            return -1;
          return 6429; /* aarch64_vec_duplicate_vqvnx8hi_be */

        case E_VNx8HImode:
          if (!register_operand (operands[1], E_VNx8HImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (HImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (HImode), 0, 63)))
            return -1;
          return 10497; /* aarch64_sve_dupq_lanevnx8hi */

        default:
          return -1;
        }

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SImode) - 1)))
            return -1;
          return 6430; /* aarch64_vec_duplicate_vqvnx4si_be */

        case E_VNx4SImode:
          if (!register_operand (operands[1], E_VNx4SImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (SImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (SImode), 0, 63)))
            return -1;
          return 10498; /* aarch64_sve_dupq_lanevnx4si */

        default:
          return -1;
        }

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x2) != E_VNx2DImode
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DImode) - 1)))
            return -1;
          return 6431; /* aarch64_vec_duplicate_vqvnx2di_be */

        case E_VNx2DImode:
          if (!register_operand (operands[1], E_VNx2DImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (DImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (DImode), 0, 63)))
            return -1;
          return 10499; /* aarch64_sve_dupq_lanevnx2di */

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x2) != E_VNx8BFmode
          || GET_MODE (x3) != E_V8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8BFmode:
          if (!register_operand (operands[1], E_V8BFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8BFmode) - 1)))
            return -1;
          return 6432; /* aarch64_vec_duplicate_vqvnx8bf_be */

        case E_VNx8BFmode:
          if (!register_operand (operands[1], E_VNx8BFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (BFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (BFmode), 0, 63)))
            return -1;
          return 10500; /* aarch64_sve_dupq_lanevnx8bf */

        default:
          return -1;
        }

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x2) != E_VNx8HFmode
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HFmode) - 1)))
            return -1;
          return 6433; /* aarch64_vec_duplicate_vqvnx8hf_be */

        case E_VNx8HFmode:
          if (!register_operand (operands[1], E_VNx8HFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (HFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (HFmode), 0, 63)))
            return -1;
          return 10501; /* aarch64_sve_dupq_lanevnx8hf */

        default:
          return -1;
        }

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x2) != E_VNx4SFmode
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SFmode) - 1)))
            return -1;
          return 6434; /* aarch64_vec_duplicate_vqvnx4sf_be */

        case E_VNx4SFmode:
          if (!register_operand (operands[1], E_VNx4SFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (SFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (SFmode), 0, 63)))
            return -1;
          return 10502; /* aarch64_sve_dupq_lanevnx4sf */

        default:
          return -1;
        }

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x2) != E_VNx2DFmode
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DFmode) - 1)))
            return -1;
          return 6435; /* aarch64_vec_duplicate_vqvnx2df_be */

        case E_VNx2DFmode:
          if (!register_operand (operands[1], E_VNx2DFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (DFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (DFmode), 0, 63)))
            return -1;
          return 10503; /* aarch64_sve_dupq_lanevnx2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_493 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (XINT (x3, 1))
    {
    case 405:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 439 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 1401; /* aarch64_fcadd90v4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 439 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
            return -1;
          return 1409; /* aarch64_fcadd90v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 406:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 439 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 1404; /* aarch64_fcadd270v4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 439 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
            return -1;
          return 1412; /* aarch64_fcadd270v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 186:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1957; /* aarch64_simd_reg_shlv8qi_unsigned_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1961; /* aarch64_simd_reg_shlv4hi_unsigned_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1965; /* aarch64_simd_reg_shlv2si_unsigned_vec_concatz_le */

        default:
          return -1;
        }

    case 185:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1970; /* aarch64_simd_reg_shlv8qi_signed_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1974; /* aarch64_simd_reg_shlv4hi_signed_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1978; /* aarch64_simd_reg_shlv2si_signed_vec_concatz_le */

        default:
          return -1;
        }

    case 274:
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern972 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1983; /* vec_shr_v8qi_vec_concatz_le */

        case E_V8HImode:
          if (pattern972 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1986; /* vec_shr_v4hi_vec_concatz_le */

        case E_V8HFmode:
          if (pattern972 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1989; /* vec_shr_v4hf_vec_concatz_le */

        case E_V4SImode:
          if (pattern972 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1992; /* vec_shr_v2si_vec_concatz_le */

        case E_V4SFmode:
          if (pattern972 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1995; /* vec_shr_v2sf_vec_concatz_le */

        case E_V8BFmode:
          if (pattern972 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
              || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1998; /* vec_shr_v4bf_vec_concatz_le */

        default:
          return -1;
        }

    case 208:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2121; /* aarch64_umaxpv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2137; /* aarch64_umaxpv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2153; /* aarch64_umaxpv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 209:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2124; /* aarch64_uminpv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2140; /* aarch64_uminpv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2156; /* aarch64_uminpv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 206:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2127; /* aarch64_smaxpv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2143; /* aarch64_smaxpv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2159; /* aarch64_smaxpv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 207:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2130; /* aarch64_sminpv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2146; /* aarch64_sminpv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2162; /* aarch64_sminpv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 198:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 1811 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2169; /* aarch64_smax_nanpv4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1811 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2185; /* aarch64_smax_nanpv2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 201:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 1811 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2172; /* aarch64_smin_nanpv4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1811 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2188; /* aarch64_smin_nanpv2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 197:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 1811 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2175; /* aarch64_smaxpv4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1811 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2191; /* aarch64_smaxpv2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 200:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 1811 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2178; /* aarch64_sminpv4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1811 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2194; /* aarch64_sminpv2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 196:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2681; /* fmax_nanv4hf3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2697; /* fmax_nanv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case 199:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2684; /* fmin_nanv4hf3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2700; /* fmin_nanv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case 277:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2687; /* fmaxv4hf3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2703; /* fmaxv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case 278:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2690; /* fminv4hf3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2706; /* fminv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case 202:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3373 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2717; /* aarch64_faddpv4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3373 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2721; /* aarch64_faddpv2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 221:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3311; /* aarch64_suqaddv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3319; /* aarch64_suqaddv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3327; /* aarch64_suqaddv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3343; /* aarch64_suqadddi_vec_concatz_le */

        default:
          return -1;
        }

    case 220:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3314; /* aarch64_usqaddv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3322; /* aarch64_usqaddv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3330; /* aarch64_usqaddv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3346; /* aarch64_usqadddi_vec_concatz_le */

        default:
          return -1;
        }

    case 216:
      switch (pattern674 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5555 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3441; /* aarch64_sqdmulhv4hi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5555 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3449; /* aarch64_sqdmulhv2si_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5567 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3461; /* aarch64_sqdmulh_nv4hi_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5567 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3469; /* aarch64_sqdmulh_nv2si_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5582 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3477; /* aarch64_sqdmulh_lanev4hi_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3493; /* aarch64_sqdmulh_laneqv4hi_vec_concatz_le */

        case 6:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5582 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3485; /* aarch64_sqdmulh_lanev2si_vec_concatz_le */

        case 7:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3501; /* aarch64_sqdmulh_laneqv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 217:
      switch (pattern674 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5555 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3444; /* aarch64_sqrdmulhv4hi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5555 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3452; /* aarch64_sqrdmulhv2si_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5567 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3464; /* aarch64_sqrdmulh_nv4hi_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5567 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3472; /* aarch64_sqrdmulh_nv2si_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5582 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3480; /* aarch64_sqrdmulh_lanev4hi_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3496; /* aarch64_sqrdmulh_laneqv4hi_vec_concatz_le */

        case 6:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5582 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3488; /* aarch64_sqrdmulh_lanev2si_vec_concatz_le */

        case 7:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3504; /* aarch64_sqrdmulh_laneqv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 229:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3643; /* aarch64_sshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3659; /* aarch64_sshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3675; /* aarch64_sshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3695; /* aarch64_sshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 230:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3646; /* aarch64_ushlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3662; /* aarch64_ushlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3678; /* aarch64_ushlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3698; /* aarch64_ushldi_vec_concatz_le */

        default:
          return -1;
        }

    case 231:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3649; /* aarch64_srshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3665; /* aarch64_srshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3681; /* aarch64_srshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3701; /* aarch64_srshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 232:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3652; /* aarch64_urshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3668; /* aarch64_urshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3684; /* aarch64_urshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3704; /* aarch64_urshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 227:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3707; /* aarch64_sqshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3723; /* aarch64_sqshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3739; /* aarch64_sqshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3771; /* aarch64_sqshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 228:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3710; /* aarch64_uqshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3726; /* aarch64_uqshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3742; /* aarch64_uqshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3774; /* aarch64_uqshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 233:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3713; /* aarch64_sqrshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3729; /* aarch64_sqrshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3745; /* aarch64_sqrshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3777; /* aarch64_sqrshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 234:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3716; /* aarch64_uqrshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3732; /* aarch64_uqrshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3748; /* aarch64_uqrshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3780; /* aarch64_uqrshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 247:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4845; /* aarch64_zip1v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4869; /* aarch64_zip1v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4893; /* aarch64_zip1v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4923; /* aarch64_zip1v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4947; /* aarch64_zip1v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4971; /* aarch64_zip1v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 248:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4848; /* aarch64_zip2v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4872; /* aarch64_zip2v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4896; /* aarch64_zip2v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4926; /* aarch64_zip2v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4950; /* aarch64_zip2v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4974; /* aarch64_zip2v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 251:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4851; /* aarch64_trn1v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4875; /* aarch64_trn1v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4899; /* aarch64_trn1v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4929; /* aarch64_trn1v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4953; /* aarch64_trn1v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4977; /* aarch64_trn1v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 252:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4854; /* aarch64_trn2v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4878; /* aarch64_trn2v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4902; /* aarch64_trn2v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4932; /* aarch64_trn2v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4956; /* aarch64_trn2v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4980; /* aarch64_trn2v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 249:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4857; /* aarch64_uzp1v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4881; /* aarch64_uzp1v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4905; /* aarch64_uzp1v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4935; /* aarch64_uzp1v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4959; /* aarch64_uzp1v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4983; /* aarch64_uzp1v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 250:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4860; /* aarch64_uzp2v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4884; /* aarch64_uzp2v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4908; /* aarch64_uzp2v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4938; /* aarch64_uzp2v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4962; /* aarch64_uzp2v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4986; /* aarch64_uzp2v2sf_vec_concatz_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_513 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 2);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern528 (x3, 
E_HFmode) != 0
                  || !(
#line 6897 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
                return -1;
              return 985; /* *aarch64_fmahf4 */

            case E_SFmode:
              if (pattern528 (x3, 
E_SFmode) != 0
                  || !
#line 6897 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 986; /* *aarch64_fmasf4 */

            case E_DFmode:
              if (pattern528 (x3, 
E_DFmode) != 0
                  || !
#line 6897 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 987; /* *aarch64_fmadf4 */

            case E_V4HFmode:
              if (pattern529 (x3, 
E_V4HFmode) != 0
                  || !(
#line 2855 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2415; /* fmav4hf4 */

            case E_V8HFmode:
              if (pattern529 (x3, 
E_V8HFmode) != 0
                  || !(
#line 2855 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2418; /* fmav8hf4 */

            case E_V2SFmode:
              if (pattern529 (x3, 
E_V2SFmode) != 0
                  || !
#line 2855 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2419; /* fmav2sf4 */

            case E_V4SFmode:
              if (pattern529 (x3, 
E_V4SFmode) != 0
                  || !
#line 2855 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2422; /* fmav4sf4 */

            case E_V2DFmode:
              if (pattern529 (x3, 
E_V2DFmode) != 0
                  || !
#line 2855 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2423; /* fmav2df4 */

            default:
              return -1;
            }

        case NEG:
          operands[2] = x4;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern820 (x3, 
E_SFmode) != 0
                  || !
#line 6936 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 991; /* *aarch64_fmssf4 */

            case E_DFmode:
              if (pattern820 (x3, 
E_DFmode) != 0
                  || !
#line 6936 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 992; /* *aarch64_fmsdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          x5 = XEXP (x3, 2);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_HFmode:
                  if (pattern663 (x3, 
E_HFmode) != 0
                      || !(
#line 6917 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
                    return -1;
                  return 988; /* *aarch64_fnmahf4 */

                case E_SFmode:
                  if (pattern663 (x3, 
E_SFmode) != 0
                      || !
#line 6917 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                    return -1;
                  return 989; /* *aarch64_fnmasf4 */

                case E_DFmode:
                  if (pattern663 (x3, 
E_DFmode) != 0
                      || !
#line 6917 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                    return -1;
                  return 990; /* *aarch64_fnmadf4 */

                case E_V4HFmode:
                  if (pattern664 (x3, 
E_V4HFmode) != 0
                      || !(
#line 2928 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                    return -1;
                  return 2451; /* fnmav4hf4 */

                case E_V8HFmode:
                  if (pattern664 (x3, 
E_V8HFmode) != 0
                      || !(
#line 2928 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                    return -1;
                  return 2454; /* fnmav8hf4 */

                case E_V2SFmode:
                  if (pattern664 (x3, 
E_V2SFmode) != 0
                      || !
#line 2928 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2455; /* fnmav2sf4 */

                case E_V4SFmode:
                  if (pattern664 (x3, 
E_V4SFmode) != 0
                      || !
#line 2928 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2458; /* fnmav4sf4 */

                case E_V2DFmode:
                  if (pattern664 (x3, 
E_V2DFmode) != 0
                      || !
#line 2928 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2459; /* fnmav2df4 */

                default:
                  return -1;
                }

            case NEG:
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              operands[3] = x6;
              x7 = XEXP (x5, 0);
              operands[1] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern905 (x3, 
E_SFmode) != 0
                      || !
#line 6954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                    return -1;
                  return 993; /* *aarch64_fnmssf4 */

                case E_DFmode:
                  if (pattern905 (x3, 
E_DFmode) != 0
                      || !
#line 6954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                    return -1;
                  return 994; /* *aarch64_fnmsdf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x6, 0);
          switch (GET_CODE (x9))
            {
            case VEC_SELECT:
              x10 = XEXP (x9, 1);
              if (GET_CODE (x10) != PARALLEL
                  || XVECLEN (x10, 0) != 1)
                return -1;
              x8 = XEXP (x4, 0);
              operands[3] = x8;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              x12 = XVECEXP (x10, 0, 0);
              operands[2] = x12;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x5 = XEXP (x3, 2);
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V2SFmode:
                  if (pattern1143 (x3, 
E_V2SFmode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V2SFmode:
                      if (!register_operand (operands[1], E_V2SFmode)
                          || !
#line 2943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2460; /* *aarch64_fnma4_eltv2sf */

                    case E_V4SFmode:
                      if (!register_operand (operands[1], E_V4SFmode)
                          || !
#line 2961 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2465; /* *aarch64_fnma4_elt_to_128v2sf */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  if (pattern1143 (x3, 
E_V4SFmode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4SFmode:
                      if (!register_operand (operands[1], E_V4SFmode)
                          || !
#line 2943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2463; /* *aarch64_fnma4_eltv4sf */

                    case E_V2SFmode:
                      if (!register_operand (operands[1], E_V2SFmode)
                          || !
#line 2961 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2468; /* *aarch64_fnma4_elt_to_64v4sf */

                    default:
                      return -1;
                    }

                case E_V2DFmode:
                  if (!register_operand (operands[0], E_V2DFmode)
                      || GET_MODE (x3) != E_V2DFmode
                      || GET_MODE (x4) != E_V2DFmode
                      || !register_operand (operands[3], E_V2DFmode)
                      || GET_MODE (x6) != E_V2DFmode
                      || GET_MODE (x9) != E_DFmode
                      || !register_operand (operands[1], E_V2DFmode)
                      || !register_operand (operands[4], E_V2DFmode)
                      || !
#line 2943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2464; /* *aarch64_fnma4_eltv2df */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x9;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              x5 = XEXP (x3, 2);
              operands[3] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V4HImode:
                  if (pattern906 (x3, 
E_V4HImode, 
E_HImode) != 0
                      || !
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2469; /* *aarch64_fnma4_elt_from_dupv4hi */

                case E_V8HImode:
                  if (pattern906 (x3, 
E_V8HImode, 
E_HImode) != 0
                      || !
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2472; /* *aarch64_fnma4_elt_from_dupv8hi */

                case E_V2SImode:
                  if (pattern906 (x3, 
E_V2SImode, 
E_SImode) != 0
                      || !
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2473; /* *aarch64_fnma4_elt_from_dupv2si */

                case E_V4SImode:
                  if (pattern906 (x3, 
E_V4SImode, 
E_SImode) != 0
                      || !
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2476; /* *aarch64_fnma4_elt_from_dupv4si */

                case E_V4HFmode:
                  if (pattern906 (x3, 
E_V4HFmode, 
E_HFmode) != 0
                      || !(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                    return -1;
                  return 2477; /* *aarch64_fnma4_elt_from_dupv4hf */

                case E_V8HFmode:
                  if (pattern906 (x3, 
E_V8HFmode, 
E_HFmode) != 0
                      || !(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 441 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                    return -1;
                  return 2480; /* *aarch64_fnma4_elt_from_dupv8hf */

                case E_V2SFmode:
                  if (pattern906 (x3, 
E_V2SFmode, 
E_SFmode) != 0
                      || !
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2481; /* *aarch64_fnma4_elt_from_dupv2sf */

                case E_V4SFmode:
                  if (pattern906 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                      || !
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2484; /* *aarch64_fnma4_elt_from_dupv4sf */

                case E_V2DFmode:
                  if (pattern906 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                      || !
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2485; /* *aarch64_fnma4_elt_from_dupv2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case VEC_SELECT:
          x13 = XEXP (x8, 1);
          if (GET_CODE (x13) != PARALLEL
              || XVECLEN (x13, 0) != 1)
            return -1;
          x14 = XEXP (x8, 0);
          operands[1] = x14;
          x15 = XVECEXP (x13, 0, 0);
          operands[2] = x15;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          x5 = XEXP (x3, 2);
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              if (pattern1074 (x3, 
E_V2SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (!register_operand (operands[1], E_V2SFmode)
                      || !
#line 2869 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2424; /* *aarch64_fma4_eltv2sf */

                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2429; /* *aarch64_fma4_elt_to_128v2sf */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (pattern1074 (x3, 
E_V4SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !
#line 2869 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2427; /* *aarch64_fma4_eltv4sf */

                case E_V2SFmode:
                  if (!register_operand (operands[1], E_V2SFmode)
                      || !
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2432; /* *aarch64_fma4_elt_to_64v4sf */

                default:
                  return -1;
                }

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || GET_MODE (x4) != E_V2DFmode
                  || GET_MODE (x8) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !register_operand (operands[3], E_V2DFmode)
                  || !register_operand (operands[4], E_V2DFmode)
                  || !
#line 2869 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2428; /* *aarch64_fma4_eltv2df */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x8;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          x5 = XEXP (x3, 2);
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern821 (x3, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2433; /* *aarch64_fma4_elt_from_dupv4hi */

            case E_V8HImode:
              if (pattern821 (x3, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2436; /* *aarch64_fma4_elt_from_dupv8hi */

            case E_V2SImode:
              if (pattern821 (x3, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2437; /* *aarch64_fma4_elt_from_dupv2si */

            case E_V4SImode:
              if (pattern821 (x3, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2440; /* *aarch64_fma4_elt_from_dupv4si */

            case E_V4HFmode:
              if (pattern821 (x3, 
E_V4HFmode, 
E_HFmode) != 0
                  || !(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2441; /* *aarch64_fma4_elt_from_dupv4hf */

            case E_V8HFmode:
              if (pattern821 (x3, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 441 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2444; /* *aarch64_fma4_elt_from_dupv8hf */

            case E_V2SFmode:
              if (pattern821 (x3, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2445; /* *aarch64_fma4_elt_from_dupv2sf */

            case E_V4SFmode:
              if (pattern821 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2448; /* *aarch64_fma4_elt_from_dupv4sf */

            case E_V2DFmode:
              if (pattern821 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2449; /* *aarch64_fma4_elt_from_dupv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      if (pattern300 (x3) != 0)
        return -1;
      x5 = XEXP (x3, 2);
      operands[4] = x5;
      if (!register_operand (operands[4], E_DFmode))
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          if (!register_operand (operands[3], E_DFmode)
              || !
#line 2914 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2450; /* *aarch64_fma4_elt_to_64v2df */

        case NEG:
          if (GET_MODE (x6) != E_DFmode)
            return -1;
          x9 = XEXP (x6, 0);
          operands[3] = x9;
          if (!register_operand (operands[3], E_DFmode)
              || !
#line 2991 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2486; /* *aarch64_fnma4_elt_to_64v2df */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      return recog_481 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_519 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      switch (pattern447 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3248; /* sssubv8qi3 */

        case 1:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3256; /* sssubv16qi3 */

        case 2:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3264; /* sssubv4hi3 */

        case 3:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3272; /* sssubv8hi3 */

        case 4:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3280; /* sssubv2si3 */

        case 5:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3288; /* sssubv4si3 */

        case 6:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3292; /* sssubv2di3 */

        case 7:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3296; /* sssubhi3 */

        case 8:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3300; /* sssubqi3 */

        case 9:
          *pnum_clobbers = 2;
          return 3303; /* aarch64_sssubsi3 */

        case 10:
          *pnum_clobbers = 2;
          return 3305; /* aarch64_sssubdi3 */

        case 11:
          if (!
#line 4457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8099; /* sssubvnx16qi3 */

        case 12:
          if (!
#line 4457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8101; /* sssubvnx8hi3 */

        case 13:
          if (!
#line 4457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8103; /* sssubvnx4si3 */

        case 14:
          if (!
#line 4457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8105; /* sssubvnx2di3 */

        default:
          return -1;
        }

    case SS_ASHIFT:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MULT)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != SIGN_EXTEND)
        return -1;
      x8 = XEXP (x5, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[2] = x9;
          x10 = XEXP (x6, 1);
          switch (GET_CODE (x10))
            {
            case SIGN_EXTEND:
              x11 = XEXP (x10, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  operands[3] = x11;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1151 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                          || !
#line 5753 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3580; /* aarch64_sqdmlslv4hi */

                    case E_V2DImode:
                      if (pattern1151 (x3, 
E_V2SImode, 
E_V2DImode) != 0
                          || !
#line 5753 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3581; /* aarch64_sqdmlslv2si */

                    case E_SImode:
                      if (pattern1151 (x3, 
E_HImode, 
E_SImode) != 0
                          || !
#line 5753 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3582; /* aarch64_sqdmlslhi */

                    case E_DImode:
                      if (pattern1151 (x3, 
E_SImode, 
E_DImode) != 0
                          || !
#line 5753 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3583; /* aarch64_sqdmlslsi */

                    default:
                      return -1;
                    }

                case VEC_SELECT:
                  x12 = XEXP (x11, 1);
                  if (GET_CODE (x12) != PARALLEL
                      || XVECLEN (x12, 0) != 1)
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[3] = x13;
                  x14 = XVECEXP (x12, 0, 0);
                  operands[4] = x14;
                  if (!immediate_operand (operands[4], E_SImode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern1268 (x3, 
E_HImode, 
E_SImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[3]))
                        {
                        case E_V4HImode:
                          if (!register_operand (operands[3], E_V4HImode)
                              || !
#line 5895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3594; /* aarch64_sqdmlsl_lanehi */

                        case E_V8HImode:
                          if (!register_operand (operands[3], E_V8HImode)
                              || !
#line 5942 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3598; /* aarch64_sqdmlsl_laneqhi */

                        default:
                          return -1;
                        }

                    case E_DImode:
                      if (pattern1268 (x3, 
E_SImode, 
E_DImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[3]))
                        {
                        case E_V2SImode:
                          if (!register_operand (operands[3], E_V2SImode)
                              || !
#line 5895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3595; /* aarch64_sqdmlsl_lanesi */

                        case E_V4SImode:
                          if (!register_operand (operands[3], E_V4SImode)
                              || !
#line 5942 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3599; /* aarch64_sqdmlsl_laneqsi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x11 = XEXP (x10, 0);
              switch (pattern977 (x11))
                {
                case 0:
                  x13 = XEXP (x11, 0);
                  x15 = XEXP (x13, 0);
                  operands[3] = x15;
                  x16 = XEXP (x13, 1);
                  x17 = XVECEXP (x16, 0, 0);
                  operands[4] = x17;
                  if (!immediate_operand (operands[4], E_SImode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1290 (x3, 
E_V4HImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (pattern1354 (x10))
                        {
                        case 0:
                          if (!
#line 5799 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3586; /* aarch64_sqdmlsl_lanev4hi */

                        case 1:
                          if (!
#line 5824 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3588; /* aarch64_sqdmlsl_laneqv4hi */

                        default:
                          return -1;
                        }

                    case E_V2DImode:
                      if (pattern1290 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
                        return -1;
                      switch (pattern1355 (x10))
                        {
                        case 0:
                          if (!
#line 5799 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3587; /* aarch64_sqdmlsl_lanev2si */

                        case 1:
                          if (!
#line 5824 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3589; /* aarch64_sqdmlsl_laneqv2si */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1184 (x3, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V4HImode) != 0
                          || !
#line 5965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3600; /* aarch64_sqdmlsl_nv4hi */

                    case E_V2DImode:
                      if (pattern1184 (x3, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0
                          || !
#line 5965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3601; /* aarch64_sqdmlsl_nv2si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x18 = XEXP (x9, 0);
          operands[2] = x18;
          x10 = XEXP (x6, 1);
          switch (GET_CODE (x10))
            {
            case SIGN_EXTEND:
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != VEC_SELECT)
                return -1;
              x19 = XEXP (x9, 1);
              operands[4] = x19;
              x13 = XEXP (x11, 0);
              operands[3] = x13;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[4]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern1214 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 6025 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3606; /* aarch64_sqdmlsl2v8hi_internal */

                case E_V2DImode:
                  if (pattern1214 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0
                      || !
#line 6025 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3607; /* aarch64_sqdmlsl2v4si_internal */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x11 = XEXP (x10, 0);
              switch (pattern977 (x11))
                {
                case 0:
                  x19 = XEXP (x9, 1);
                  operands[5] = x19;
                  x13 = XEXP (x11, 0);
                  x15 = XEXP (x13, 0);
                  operands[3] = x15;
                  x16 = XEXP (x13, 1);
                  x17 = XVECEXP (x16, 0, 0);
                  operands[4] = x17;
                  if (!immediate_operand (operands[4], E_SImode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1299 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (pattern1354 (x10))
                        {
                        case 0:
                          if (!
#line 6065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3608; /* aarch64_sqdmlsl2_lanev8hi_internal */

                        case 1:
                          if (!
#line 6117 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3612; /* aarch64_sqdmlsl2_laneqv8hi_internal */

                        default:
                          return -1;
                        }

                    case E_V2DImode:
                      if (pattern1299 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
                        return -1;
                      switch (pattern1355 (x10))
                        {
                        case 0:
                          if (!
#line 6065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3609; /* aarch64_sqdmlsl2_lanev4si_internal */

                        case 1:
                          if (!
#line 6117 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3613; /* aarch64_sqdmlsl2_laneqv4si_internal */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1:
                  x19 = XEXP (x9, 1);
                  operands[4] = x19;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1215 (x3, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0
                          || !
#line 6200 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3616; /* aarch64_sqdmlsl2_nv8hi_internal */

                    case E_V2DImode:
                      if (pattern1215 (x3, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0
                          || !
#line 6200 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3617; /* aarch64_sqdmlsl2_nv4si_internal */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern451 (x3))
        {
        case 0:
          if (!
#line 10531 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11046; /* aarch64_sve_sqdecdi_pat */

        case 1:
          if (!
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11098; /* *aarch64_sve_sqdecdivnx16bi_cntp */

        case 2:
          if (!
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11101; /* *aarch64_sve_sqdecdivnx8bi_cntp */

        case 3:
          if (!
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11104; /* *aarch64_sve_sqdecdivnx4bi_cntp */

        case 4:
          if (!
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11107; /* *aarch64_sve_sqdecdivnx2bi_cntp */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern452 (x3))
        {
        case 0:
          if (!
#line 10596 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11052; /* aarch64_sve_sqdecvnx2di_pat */

        case 1:
          if (!
#line 11056 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11122; /* *aarch64_sve_sqdecvnx2di_cntp */

        case 2:
          if (!
#line 10617 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11055; /* aarch64_sve_sqdecvnx4si_pat */

        case 3:
          if (!
#line 11095 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11125; /* *aarch64_sve_sqdecvnx4si_cntp */

        case 4:
          if (!
#line 10652 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11058; /* *aarch64_sve_sqdecvnx8hi_pat */

        case 5:
          if (!
#line 11136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11128; /* *aarch64_sve_sqdecvnx8hi_cntp */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 2)
        return -1;
      x20 = XVECEXP (x5, 0, 0);
      operands[2] = x20;
      switch (XINT (x5, 1))
        {
        case 509:
          switch (pattern647 (x3))
            {
            case 0:
              if (!
#line 2448 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12278; /* aarch64_sve_qsub_sqdmullbvnx8hi */

            case 1:
              if (!
#line 2448 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12281; /* aarch64_sve_qsub_sqdmullbvnx4si */

            case 2:
              if (!
#line 2448 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12284; /* aarch64_sve_qsub_sqdmullbvnx2di */

            case 3:
              if (!
#line 2467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12287; /* aarch64_sve_qsub_sqdmullb_lane_vnx4si */

            case 4:
              if (!
#line 2467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12289; /* aarch64_sve_qsub_sqdmullb_lane_vnx2di */

            default:
              return -1;
            }

        case 510:
          switch (pattern645 (x3))
            {
            case 0:
              if (!
#line 2448 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12279; /* aarch64_sve_qsub_sqdmullbtvnx8hi */

            case 1:
              if (!
#line 2448 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12282; /* aarch64_sve_qsub_sqdmullbtvnx4si */

            case 2:
              if (!
#line 2448 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12285; /* aarch64_sve_qsub_sqdmullbtvnx2di */

            default:
              return -1;
            }

        case 511:
          switch (pattern647 (x3))
            {
            case 0:
              if (!
#line 2448 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12280; /* aarch64_sve_qsub_sqdmulltvnx8hi */

            case 1:
              if (!
#line 2448 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12283; /* aarch64_sve_qsub_sqdmulltvnx4si */

            case 2:
              if (!
#line 2448 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12286; /* aarch64_sve_qsub_sqdmulltvnx2di */

            case 3:
              if (!
#line 2467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12288; /* aarch64_sve_qsub_sqdmullt_lane_vnx4si */

            case 4:
              if (!
#line 2467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12290; /* aarch64_sve_qsub_sqdmullt_lane_vnx2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_534 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case TRUNCATE:
      operands[1] = x4;
      switch (pattern395 (x3))
        {
        case 0:
          return 352; /* negsi2 */

        case 1:
          return 353; /* negdi2 */

        case 2:
          if ((
#line 7329 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return 1073; /* neghf2 */
          break;

        case 3:
          if (
#line 7329 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1074; /* negsf2 */
          break;

        case 4:
          if (
#line 7329 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1075; /* negdf2 */
          break;

        case 5:
          if (
#line 782 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1599; /* negv8qi2 */
          break;

        case 6:
          if (
#line 782 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1602; /* negv16qi2 */
          break;

        case 7:
          if (
#line 782 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1603; /* negv4hi2 */
          break;

        case 8:
          if (
#line 782 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1606; /* negv8hi2 */
          break;

        case 9:
          if (
#line 782 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1607; /* negv2si2 */
          break;

        case 10:
          if (
#line 782 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1610; /* negv4si2 */
          break;

        case 11:
          if (
#line 782 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1611; /* negv2di2 */
          break;

        case 12:
          if ((
#line 2682 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2396; /* negv4hf2 */
          break;

        case 13:
          if ((
#line 2682 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2399; /* negv8hf2 */
          break;

        case 14:
          if (
#line 2682 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2400; /* negv2sf2 */
          break;

        case 15:
          if (
#line 2682 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2403; /* negv4sf2 */
          break;

        case 16:
          if (
#line 2682 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2404; /* negv2df2 */
          break;

        default:
          break;
        }
      if (!subreg_lowpart_operator (x4, E_SImode))
        return -1;
      operands[4] = x4;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTRACT
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!aarch64_simd_shift_imm_offset_si (operands[3], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[2] = x8;
      if (!aarch64_simd_shift_imm_offset_si (operands[2], E_VOIDmode)
          || !
#line 4112 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) + INTVAL (operands[3]) == 32))
        return -1;
      return 376; /* *neg_asr_si2_extr */

    case ASHIFT:
      switch (pattern298 (x3))
        {
        case 0:
          return 367; /* *neg_lsl_si2 */

        case 1:
          return 370; /* *neg_lsl_di2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern298 (x3))
        {
        case 0:
          return 368; /* *neg_asr_si2 */

        case 1:
          return 371; /* *neg_asr_di2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern298 (x3))
        {
        case 0:
          return 369; /* *neg_lsr_si2 */

        case 1:
          return 372; /* *neg_lsr_di2 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_469 (x1, insn, pnum_clobbers);

    case FMA:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x9 = XEXP (x4, 1);
      operands[3] = x9;
      x10 = XEXP (x4, 2);
      operands[1] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern751 (x3, 
E_SFmode) != 0
              || !
#line 6965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(!HONOR_SIGNED_ZEROS (SFmode) && TARGET_FLOAT))
            return -1;
          return 995; /* *aarch64_fnmaddsf4 */

        case E_DFmode:
          if (pattern751 (x3, 
E_DFmode) != 0
              || !
#line 6965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(!HONOR_SIGNED_ZEROS (DFmode) && TARGET_FLOAT))
            return -1;
          return 996; /* *aarch64_fnmadddf4 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern369 (x3, 
E_SFmode) != 0
              || !
#line 7300 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1068; /* *fnmulsf3 */

        case E_DFmode:
          if (pattern369 (x3, 
E_DFmode) != 0
              || !
#line 7300 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1069; /* *fnmuldf3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_540 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 884; /* bswapsi2 */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 885; /* bswapdi2 */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 886; /* bswaphi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 372 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1391; /* bswapv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 372 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1392; /* bswapv8hi2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 372 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1393; /* bswapv2si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 372 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1394; /* bswapv4si2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 372 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1395; /* bswapv2di2 */

    default:
      return -1;
    }
}

 int
recog_547 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10200; /* while_wrsivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10210; /* while_wrdivnx2bi_ptest */
}

 int
recog_548 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10180; /* while_wrsivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10190; /* while_wrdivnx4bi_ptest */
}

 int
recog_552 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10100; /* *while_wrsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10110; /* *while_wrdivnx4bi_cc */
}

 int
recog_556 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10179; /* while_rwsivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10189; /* while_rwdivnx4bi_ptest */
}

 int
recog_564 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10178; /* while_ugesivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10188; /* while_ugedivnx4bi_ptest */
}

 int
recog_573 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10157; /* while_ugtsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10167; /* while_ugtdivnx8bi_ptest */
}

 int
recog_583 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10116; /* *while_gtsivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10126; /* *while_gtdivnx2bi_cc */
}

 int
recog_593 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10075; /* *while_gesivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10085; /* *while_gedivnx8bi_cc */
}

 int
recog_603 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern689 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9978; /* while_ugesivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9988; /* while_ugedivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9998; /* while_ugesivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10008; /* while_ugedivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10018; /* while_ugesivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10028; /* while_ugedivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10038; /* while_ugesivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10048; /* while_ugedivnx2bi */

    default:
      return -1;
    }
}

 int
recog_608 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (pattern1271 (x6, 
E_SImode) != 0
          || !
#line 3562 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == -UINTVAL (operands[3])))
        return -1;
      return 283; /* subsi3_compare1_imm */

    case E_DImode:
      if (pattern1271 (x6, 
E_DImode) != 0
          || !
#line 3562 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == -UINTVAL (operands[3])))
        return -1;
      return 284; /* subdi3_compare1_imm */

    default:
      return -1;
    }
}

 int
recog_610 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (GET_MODE (x5) != E_TImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LTU
          || GET_MODE (x6) != E_TImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 66
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != SIGN_EXTEND
          || GET_MODE (x9) != E_TImode)
        return -1;
      x10 = XEXP (x3, 1);
      if (GET_CODE (x10) != SIGN_EXTEND
          || GET_MODE (x10) != E_TImode)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != NEG
          || GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != PLUS
          || GET_MODE (x12) != E_DImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != LTU
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 66
          || GET_MODE (x14) != E_CCmode)
        return -1;
      x15 = XEXP (x13, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x16 = XVECEXP (x1, 0, 1);
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != NEG
          || GET_MODE (x17) != E_DImode)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != E_DImode)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != LTU
          || GET_MODE (x19) != E_DImode)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 66
          || GET_MODE (x20) != E_CCmode)
        return -1;
      x21 = XEXP (x19, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XEXP (x2, 0);
      if (GET_MODE (x22) != E_CC_Vmode
          || GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x4) != E_TImode)
        return -1;
      x23 = XEXP (x9, 0);
      operands[1] = x23;
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x24 = XEXP (x12, 1);
      if (!rtx_equal_p (x24, operands[1]))
        return -1;
      x25 = XEXP (x18, 1);
      if (!rtx_equal_p (x25, operands[1]))
        return -1;
      return 279; /* negvdi_carryinV */

    case REG:
    case SUBREG:
      operands[1] = x5;
      x10 = XEXP (x3, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XEXP (x2, 0);
      if (GET_MODE (x22) != E_CC_NZmode
          || GET_MODE (x3) != E_CC_NZmode)
        return -1;
      x16 = XVECEXP (x1, 0, 1);
      x17 = XEXP (x16, 1);
      switch (GET_CODE (x17))
        {
        case NEG:
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x17) != E_SImode)
                return -1;
              return 358; /* negsi2_compare0 */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x17) != E_DImode)
                return -1;
              return 359; /* negdi2_compare0 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern1191 (x1, 
NEG) != 0
              || !register_operand (operands[0], E_DImode))
            return -1;
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[1]))
            return -1;
          return 360; /* *negsi2_compare0_uxtw */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern925 (x1, 
ASHIFT))
        {
        case 0:
          return 361; /* *neg_lslsi3_compare0 */

        case 1:
          return 364; /* *neg_lsldi3_compare0 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern925 (x1, 
ASHIFTRT))
        {
        case 0:
          return 362; /* *neg_asrsi3_compare0 */

        case 1:
          return 365; /* *neg_asrdi3_compare0 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern925 (x1, 
LSHIFTRT))
        {
        case 0:
          return 363; /* *neg_lsrsi3_compare0 */

        case 1:
          return 366; /* *neg_lsrdi3_compare0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_614 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case PLUS:
      return recog_609 (x1, insn, pnum_clobbers);

    case MINUS:
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_CC_NZmode
              || GET_MODE (x6) != E_CC_NZmode)
            return -1;
          x10 = XEXP (x7, 1);
          switch (GET_CODE (x10))
            {
            case ASHIFT:
              x11 = XEXP (x4, 1);
              if (GET_CODE (x11) != MINUS)
                return -1;
              x12 = XEXP (x11, 1);
              if (GET_CODE (x12) != ASHIFT)
                return -1;
              x13 = XEXP (x10, 1);
              operands[3] = x13;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x12, 1);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              x16 = XEXP (x10, 0);
              switch (GET_CODE (x16))
                {
                case REG:
                case SUBREG:
                  operands[2] = x16;
                  x17 = XEXP (x12, 0);
                  if (!rtx_equal_p (x17, operands[2]))
                    return -1;
                  switch (pattern1187 (x1))
                    {
                    case 0:
                      return 146; /* *subs_shift_imm_si */

                    case 1:
                      return 149; /* *subs_shift_imm_di */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  switch (pattern1316 (x1, 
SIGN_EXTEND))
                    {
                    case 0:
                      return 188; /* *subs_extendqi_shift_si */

                    case 1:
                      return 192; /* *subs_extendhi_shift_si */

                    case 2:
                      return 196; /* *subs_extendsi_shift_si */

                    case 3:
                      return 190; /* *subs_extendqi_shift_di */

                    case 4:
                      return 194; /* *subs_extendhi_shift_di */

                    case 5:
                      return 198; /* *subs_extendsi_shift_di */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern1316 (x1, 
ZERO_EXTEND))
                    {
                    case 0:
                      return 189; /* *subs_zero_extendqi_shift_si */

                    case 1:
                      return 193; /* *subs_zero_extendhi_shift_si */

                    case 2:
                      return 197; /* *subs_zero_extendsi_shift_si */

                    case 3:
                      return 191; /* *subs_zero_extendqi_shift_di */

                    case 4:
                      return 195; /* *subs_zero_extendhi_shift_di */

                    case 5:
                      return 199; /* *subs_zero_extendsi_shift_di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern1188 (x1, 
ASHIFTRT))
                {
                case 0:
                  return 147; /* *subs_shift_imm_si */

                case 1:
                  return 150; /* *subs_shift_imm_di */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern1188 (x1, 
LSHIFTRT))
                {
                case 0:
                  return 148; /* *subs_shift_imm_si */

                case 1:
                  return 151; /* *subs_shift_imm_di */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern1190 (x1, 
SIGN_EXTEND))
                {
                case 0:
                  return 164; /* *subs_extendqi_si */

                case 1:
                  return 168; /* *subs_extendhi_si */

                case 2:
                  return 172; /* *subs_extendsi_si */

                case 3:
                  return 166; /* *subs_extendqi_di */

                case 4:
                  return 170; /* *subs_extendhi_di */

                case 5:
                  return 174; /* *subs_extendsi_di */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern1190 (x1, 
ZERO_EXTEND))
                {
                case 0:
                  return 165; /* *subs_zero_extendqi_si */

                case 1:
                  return 169; /* *subs_zero_extendhi_si */

                case 2:
                  return 173; /* *subs_zero_extendsi_si */

                case 3:
                  return 167; /* *subs_zero_extendqi_di */

                case 4:
                  return 171; /* *subs_zero_extendhi_di */

                case 5:
                  return 175; /* *subs_zero_extendsi_di */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[2] = x10;
              x11 = XEXP (x4, 1);
              switch (GET_CODE (x11))
                {
                case MINUS:
                  x14 = XEXP (x11, 0);
                  if (!rtx_equal_p (x14, operands[1]))
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (!rtx_equal_p (x12, operands[2]))
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_SImode:
                      if (pattern1303 (x11, 
E_SImode) != 0)
                        return -1;
                      return 280; /* *subsi3_compare0 */

                    case E_DImode:
                      if (pattern1303 (x11, 
E_DImode) != 0)
                        return -1;
                      return 281; /* *subdi3_compare0 */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  if (pattern1224 (x1, 
MINUS) != 0
                      || !register_operand (operands[1], E_SImode)
                      || !register_operand (operands[2], E_SImode)
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x14 = XEXP (x11, 0);
                  x18 = XEXP (x14, 0);
                  if (!rtx_equal_p (x18, operands[1]))
                    return -1;
                  x19 = XEXP (x14, 1);
                  if (!rtx_equal_p (x19, operands[2]))
                    return -1;
                  return 282; /* *subsi3_compare0_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != SIGN_EXTEND)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != MINUS)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x3) != E_CC_Vmode
              || GET_MODE (x6) != E_CC_Vmode)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x10 = XEXP (x7, 1);
          switch (GET_CODE (x10))
            {
            case GEU:
            case LTU:
              operands[2] = x10;
              x23 = XEXP (x20, 1);
              operands[3] = x23;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1342 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 343; /* *subsi3_carryinV_z2 */

                case E_TImode:
                  if (pattern1342 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 344; /* *subdi3_carryinV_z2 */

                default:
                  return -1;
                }

            case PLUS:
              x16 = XEXP (x10, 0);
              if (GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x23 = XEXP (x20, 1);
              if (GET_CODE (x23) != PLUS)
                return -1;
              x14 = XEXP (x11, 0);
              if (GET_CODE (x14) != MINUS)
                return -1;
              x24 = XEXP (x16, 0);
              operands[2] = x24;
              x13 = XEXP (x10, 1);
              operands[3] = x13;
              x25 = XEXP (x23, 0);
              operands[4] = x25;
              x26 = XEXP (x23, 1);
              if (!rtx_equal_p (x26, operands[2]))
                return -1;
              x18 = XEXP (x14, 0);
              if (!rtx_equal_p (x18, operands[1]))
                return -1;
              x19 = XEXP (x14, 1);
              if (!rtx_equal_p (x19, operands[2]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[4]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1368 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 345; /* *subsi3_carryinV */

                case E_TImode:
                  if (pattern1368 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 346; /* *subdi3_carryinV */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x6) != E_CC_Vmode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case MINUS:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != MINUS)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != SIGN_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x27 = XEXP (x8, 1);
          operands[2] = x27;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x12 = XEXP (x11, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              x28 = XEXP (x9, 1);
              if (GET_CODE (x28) != SIGN_EXTEND)
                return -1;
              x29 = XEXP (x28, 0);
              if (!rtx_equal_p (x29, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1346 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 268; /* subvsi_insn */

                case E_TImode:
                  if (pattern1346 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 269; /* subvdi_insn */

                default:
                  return -1;
                }

            case CONST_INT:
              x28 = XEXP (x9, 1);
              if (!rtx_equal_p (x28, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern1343 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 270; /* subvsi_imm */

                case E_TImode:
                  if (pattern1343 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 271; /* subvdi_imm */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != NEG)
            return -1;
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != SIGN_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != NEG)
            return -1;
          x21 = XEXP (x8, 0);
          operands[1] = x21;
          x22 = XEXP (x20, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1294 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 272; /* negvsi_insn */

            case E_TImode:
              if (pattern1294 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 273; /* negvdi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_610 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      if (GET_MODE (x3) != E_CCmode
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          res = recog_607 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          res = recog_608 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != MINUS)
        return -1;
      operands[1] = x7;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (aarch64_reg_or_zero (operands[2], E_SImode)
          && pattern1192 (x11, 
E_SImode) == 0)
        return 285; /* subsi3_compare1 */
      if (!aarch64_reg_or_zero (operands[2], E_DImode)
          || pattern1192 (x11, 
E_DImode) != 0)
        return -1;
      return 286; /* subdi3_compare1 */

    case ZERO_EXTEND:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      x9 = XEXP (x6, 1);
      switch (GET_CODE (x9))
        {
        case GEU:
        case LTU:
          operands[2] = x9;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x12 = XEXP (x11, 1);
          operands[3] = x12;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1272 (x11, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 339; /* *usubsi3_carryinC_z2 */

            case E_TImode:
              if (pattern1272 (x11, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 340; /* *usubdi3_carryinC_z2 */

            default:
              return -1;
            }

        case PLUS:
          x20 = XEXP (x9, 0);
          if (GET_CODE (x20) != ZERO_EXTEND)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != MINUS)
            return -1;
          x14 = XEXP (x11, 0);
          if (GET_CODE (x14) != MINUS
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x22 = XEXP (x20, 0);
          operands[2] = x22;
          x28 = XEXP (x9, 1);
          operands[3] = x28;
          x12 = XEXP (x11, 1);
          operands[4] = x12;
          x18 = XEXP (x14, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          x19 = XEXP (x14, 1);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DImode:
              if (pattern1324 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 341; /* *usubsi3_carryinC */

            case E_TImode:
              if (pattern1324 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 342; /* *usubdi3_carryinC */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x9, 0) != 0LL)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != ZERO_EXTEND
              || GET_MODE (x3) != E_CC_Zmode
              || GET_MODE (x6) != E_CC_Zmode)
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_SImode:
              switch (pattern1256 (x11, 
E_SImode))
                {
                case 0:
                  return 700; /* *andssi_compare0 */

                case 1:
                  return 702; /* *andssi_compare0 */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1256 (x11, 
E_DImode))
                {
                case 0:
                  return 701; /* *andsdi_compare0 */

                case 1:
                  return 703; /* *andsdi_compare0 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x9 = XEXP (x6, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_CC_NZVmode
          || GET_MODE (x6) != E_CC_NZVmode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          x11 = XEXP (x4, 1);
          switch (GET_CODE (x11))
            {
            case AND:
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (GET_MODE (x7))
                {
                case E_SImode:
                  if (pattern1295 (x11, 
E_SImode) != 0)
                    return -1;
                  return 513; /* *andsi3_compare0 */

                case E_DImode:
                  if (pattern1295 (x11, 
E_DImode) != 0)
                    return -1;
                  return 514; /* *anddi3_compare0 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1224 (x1, 
AND) != 0
                  || !register_operand (operands[1], E_SImode)
                  || !aarch64_logical_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_DImode))
                return -1;
              x14 = XEXP (x11, 0);
              x18 = XEXP (x14, 0);
              if (!rtx_equal_p (x18, operands[1]))
                return -1;
              x19 = XEXP (x14, 1);
              if (!rtx_equal_p (x19, operands[2]))
                return -1;
              return 515; /* *andsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern1101 (x1, 
ASHIFT))
            {
            case 0:
              return 516; /* *and_ashlsi3_compare0 */

            case 1:
              return 521; /* *and_ashldi3_compare0 */

            case 2:
              return 526; /* *and_ashlsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern1101 (x1, 
ASHIFTRT))
            {
            case 0:
              return 517; /* *and_ashrsi3_compare0 */

            case 1:
              return 522; /* *and_ashrdi3_compare0 */

            case 2:
              return 527; /* *and_ashrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern1101 (x1, 
LSHIFTRT))
            {
            case 0:
              return 518; /* *and_lshrsi3_compare0 */

            case 1:
              return 523; /* *and_lshrdi3_compare0 */

            case 2:
              return 528; /* *and_lshrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern1101 (x1, 
ROTATERT))
            {
            case 0:
              return 519; /* *and_rotrsi3_compare0 */

            case 1:
              return 524; /* *and_rotrdi3_compare0 */

            case 2:
              return 529; /* *and_rotrsi3_compare0_uxtw */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern1101 (x1, 
ROTATE))
            {
            case 0:
              return 520; /* *and_rotlsi3_compare0 */

            case 1:
              return 525; /* *and_rotldi3_compare0 */

            case 2:
              return 530; /* *and_rotlsi3_compare0_uxtw */

            default:
              return -1;
            }

        case NOT:
          x21 = XEXP (x8, 0);
          switch (GET_CODE (x21))
            {
            case REG:
            case SUBREG:
              operands[1] = x21;
              x10 = XEXP (x7, 1);
              operands[2] = x10;
              x11 = XEXP (x4, 1);
              switch (GET_CODE (x11))
                {
                case AND:
                  x14 = XEXP (x11, 0);
                  if (GET_CODE (x14) != NOT)
                    return -1;
                  x18 = XEXP (x14, 0);
                  if (!rtx_equal_p (x18, operands[1]))
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (!rtx_equal_p (x12, operands[2]))
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_SImode:
                      if (pattern1317 (x1, 
E_SImode) != 0)
                        return -1;
                      return 598; /* *and_one_cmplsi3_compare0 */

                    case E_DImode:
                      if (pattern1317 (x1, 
E_DImode) != 0)
                        return -1;
                      return 599; /* *and_one_cmpldi3_compare0 */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x14 = XEXP (x11, 0);
                  if (GET_CODE (x14) != AND
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x18 = XEXP (x14, 0);
                  if (GET_CODE (x18) != NOT
                      || GET_MODE (x18) != E_SImode
                      || GET_MODE (x7) != E_SImode
                      || GET_MODE (x8) != E_SImode
                      || !register_operand (operands[1], E_SImode)
                      || !register_operand (operands[2], E_SImode)
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x30 = XEXP (x18, 0);
                  if (!rtx_equal_p (x30, operands[1]))
                    return -1;
                  x19 = XEXP (x14, 1);
                  if (!rtx_equal_p (x19, operands[2]))
                    return -1;
                  return 600; /* *and_one_cmplsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern1156 (x1, 
ASHIFT))
                {
                case 0:
                  return 663; /* *and_one_cmpl_ashlsi3_compare0 */

                case 1:
                  return 668; /* *and_one_cmpl_ashldi3_compare0 */

                case 2:
                  return 673; /* *and_one_cmpl_ashlsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern1156 (x1, 
ASHIFTRT))
                {
                case 0:
                  return 664; /* *and_one_cmpl_ashrsi3_compare0 */

                case 1:
                  return 669; /* *and_one_cmpl_ashrdi3_compare0 */

                case 2:
                  return 674; /* *and_one_cmpl_ashrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern1156 (x1, 
LSHIFTRT))
                {
                case 0:
                  return 665; /* *and_one_cmpl_lshrsi3_compare0 */

                case 1:
                  return 670; /* *and_one_cmpl_lshrdi3_compare0 */

                case 2:
                  return 675; /* *and_one_cmpl_lshrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ROTATERT:
              switch (pattern1156 (x1, 
ROTATERT))
                {
                case 0:
                  return 666; /* *and_one_cmpl_rotrsi3_compare0 */

                case 1:
                  return 671; /* *and_one_cmpl_rotrdi3_compare0 */

                case 2:
                  return 676; /* *and_one_cmpl_rotrsi3_compare0_uxtw */

                default:
                  return -1;
                }

            case ROTATE:
              switch (pattern1156 (x1, 
ROTATE))
                {
                case 0:
                  return 667; /* *and_one_cmpl_rotlsi3_compare0 */

                case 1:
                  return 672; /* *and_one_cmpl_rotldi3_compare0 */

                case 2:
                  return 677; /* *and_one_cmpl_rotlsi3_compare0_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_623 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          switch (XINT (x1, 1))
            {
            case 165:
              if (GET_MODE (x1) != E_DImode
                  || !aarch64_sysreg_string (operands[0], E_VOIDmode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              return 3; /* aarch64_write_sysregdi */

            case 166:
              if (GET_MODE (x1) != E_TImode
                  || !aarch64_sysreg_string (operands[0], E_VOIDmode)
                  || !register_operand (operands[1], E_TImode)
                  || !
#line 673 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_D128))
                return -1;
              return 4; /* aarch64_write_sysregti */

            case 181:
              if (!const_int_operand (operands[0], E_VOIDmode)
                  || !const_int_operand (operands[1], E_VOIDmode))
                return -1;
              return 1236; /* patchable_area */

            default:
              return -1;
            }

        case 1:
          switch (XINT (x1, 1))
            {
            case 5:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1165; /* blockage */

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  return 1175; /* aarch64_set_fpsrsi */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  return 1177; /* aarch64_set_fpsrdi */

                default:
                  return -1;
                }

            case 2:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  return 1176; /* aarch64_set_fpcrsi */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  return 1178; /* aarch64_set_fpcrdi */

                default:
                  return -1;
                }

            case 8:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1185; /* bti_noarg */

            case 9:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1186; /* bti_c */

            case 10:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1187; /* bti_j */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1188; /* bti_jc */

            case 7:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1189; /* speculation_barrier */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1242; /* aarch64_gcspopm_xzr */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              return 1243; /* aarch64_gcsss1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PARALLEL:
      return recog_624 (x1, insn, pnum_clobbers);

    case UNSPEC:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          if (XINT (x1, 1) != 71)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 29; /* nop */

        case 2:
          if (XINT (x1, 1) != 167)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          if (!aarch64_prefetch_operand (operands[1], E_DImode))
            return -1;
          return 31; /* aarch64_pldx */

        default:
          return -1;
        }

    case PREFETCH:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (aarch64_prefetch_operand (operands[0], E_DImode))
        {
          x5 = XEXP (x1, 1);
          operands[1] = x5;
          if (const_int_operand (operands[1], E_QImode))
            {
              x6 = XEXP (x1, 2);
              operands[2] = x6;
              if (const_int_operand (operands[2], E_QImode))
                return 30; /* prefetch */
            }
        }
      if (GET_CODE (x4) != UNSPEC
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x1, 1);
      if (!const_int_operand (x5, E_DImode))
        return -1;
      x6 = XEXP (x1, 2);
      if (!const_int_operand (x6, E_DImode))
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          if (XINT (x4, 1) != 170)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[0] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[1] = x8;
          x9 = XVECEXP (x4, 0, 2);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          operands[3] = x5;
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (!register_operand (operands[0], E_VNx16BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx16QImode)
                  || !
#line 2122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6267; /* aarch64_sve_prefetchvnx16qi */

            case E_VNx8BImode:
              if (!register_operand (operands[0], E_VNx8BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx8HImode)
                  || !
#line 2122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6268; /* aarch64_sve_prefetchvnx8hi */

            case E_VNx4BImode:
              if (!register_operand (operands[0], E_VNx4BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx4SImode)
                  || !
#line 2122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6269; /* aarch64_sve_prefetchvnx4si */

            case E_VNx2BImode:
              if (!register_operand (operands[0], E_VNx2BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx2DImode)
                  || !
#line 2122 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6270; /* aarch64_sve_prefetchvnx2di */

            default:
              return -1;
            }

        case 7:
          if (XINT (x4, 1) != 171)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[0] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[1] = x8;
          x10 = XVECEXP (x4, 0, 3);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x11 = XVECEXP (x4, 0, 4);
          operands[4] = x11;
          x12 = XVECEXP (x4, 0, 5);
          operands[5] = x12;
          x13 = XVECEXP (x4, 0, 6);
          operands[6] = x13;
          if (!const_int_operand (operands[6], E_DImode))
            return -1;
          operands[7] = x5;
          operands[8] = x6;
          x9 = XVECEXP (x4, 0, 2);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4BImode:
                  if (!register_operand (operands[0], E_VNx4BImode)
                      || !register_operand (operands[2], E_VNx4SImode))
                    return -1;
                  if (aarch64_sve_gather_offset_b (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_b (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                      && 
#line 2162 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6271; /* aarch64_sve_gather_prefetchvnx16qivnx4si */
                  if (aarch64_sve_gather_offset_h (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_h (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                      && 
#line 2162 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6272; /* aarch64_sve_gather_prefetchvnx8hivnx4si */
                  if (aarch64_sve_gather_offset_w (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_w (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                      && 
#line 2162 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6273; /* aarch64_sve_gather_prefetchvnx4sivnx4si */
                  if (!aarch64_sve_gather_offset_d (operands[1], E_DImode)
                      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
                      || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                      || !
#line 2162 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6274; /* aarch64_sve_gather_prefetchvnx2divnx4si */

                case E_VNx2BImode:
                  if (!register_operand (operands[0], E_VNx2BImode)
                      || !register_operand (operands[2], E_VNx2DImode))
                    return -1;
                  if (aarch64_sve_gather_offset_b (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_b (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                      && 
#line 2191 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6275; /* aarch64_sve_gather_prefetchvnx16qivnx2di */
                  if (aarch64_sve_gather_offset_h (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_h (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                      && 
#line 2191 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6276; /* aarch64_sve_gather_prefetchvnx8hivnx2di */
                  if (aarch64_sve_gather_offset_w (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_w (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                      && 
#line 2191 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6277; /* aarch64_sve_gather_prefetchvnx4sivnx2di */
                  if (!aarch64_sve_gather_offset_d (operands[1], E_DImode)
                      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
                      || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                      || !
#line 2191 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6278; /* aarch64_sve_gather_prefetchvnx2divnx2di */

                default:
                  return -1;
                }

            case UNSPEC:
              if (pattern582 (x9) != 0
                  || !register_operand (operands[0], E_VNx2BImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x14 = XVECEXP (x9, 0, 0);
              operands[9] = x14;
              x15 = XVECEXP (x9, 0, 1);
              x16 = XEXP (x15, 0);
              x17 = XEXP (x16, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              if (aarch64_gather_scale_operand_b (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                  && 
#line 2222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6279; /* *aarch64_sve_gather_prefetchvnx16qivnx2di_sxtw */
              if (aarch64_gather_scale_operand_h (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                  && 
#line 2222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6280; /* *aarch64_sve_gather_prefetchvnx8hivnx2di_sxtw */
              if (aarch64_gather_scale_operand_w (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                  && 
#line 2222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6281; /* *aarch64_sve_gather_prefetchvnx4sivnx2di_sxtw */
              if (!aarch64_gather_scale_operand_d (operands[4], E_DImode)
                  || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                  || !
#line 2222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6282; /* *aarch64_sve_gather_prefetchvnx2divnx2di_sxtw */

            case AND:
              if (GET_MODE (x9) != E_VNx2DImode
                  || !register_operand (operands[0], E_VNx2BImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x18 = XEXP (x9, 0);
              operands[2] = x18;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              x19 = XEXP (x9, 1);
              operands[9] = x19;
              if (!aarch64_sve_uxtw_immediate (operands[9], E_VNx2DImode))
                return -1;
              if (aarch64_gather_scale_operand_b (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                  && 
#line 2252 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6283; /* *aarch64_sve_gather_prefetchvnx16qivnx2di_uxtw */
              if (aarch64_gather_scale_operand_h (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                  && 
#line 2252 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6284; /* *aarch64_sve_gather_prefetchvnx8hivnx2di_uxtw */
              if (aarch64_gather_scale_operand_w (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                  && 
#line 2252 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6285; /* *aarch64_sve_gather_prefetchvnx4sivnx2di_uxtw */
              if (!aarch64_gather_scale_operand_d (operands[4], E_DImode)
                  || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                  || !
#line 2252 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6286; /* *aarch64_sve_gather_prefetchvnx2divnx2di_uxtw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRAP_IF:
      x4 = XEXP (x1, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return 32; /* trap */

    case RETURN:
      return 33; /* *do_return */

    case SIMPLE_RETURN:
      return 34; /* simple_return */

    default:
      return -1;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern870 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1133 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1166 (insn, operands);

    case E_VNx4SFmode:
      if (pattern870 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1144 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1177 (insn, operands);

    case E_VNx2DFmode:
      if (pattern870 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1155 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3758 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1188 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2944 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2952 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2960 (insn, operands);
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2941 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2949 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2957 (insn, operands);
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2813 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2860 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2900 (insn, operands);
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2847 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2888 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2928 (insn, operands);
}

 rtx_insn *
split_33 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2834 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2877 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2917 (insn, operands);
}

 rtx_insn *
split_38 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2821 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2866 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2906 (insn, operands);
}

 rtx_insn *
split_43 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2807 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2855 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2895 (insn, operands);
}

 rtx_insn *
split_49 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2829 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2873 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2913 (insn, operands);
}

 rtx_insn *
split_55 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2804 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2852 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2892 (insn, operands);
}

 rtx_insn *
split_61 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1050 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1681 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1754 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1806 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1694 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1767 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1819 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1707 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1780 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1832 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1720 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1793 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1845 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1727 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1904 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1734 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1911 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1741 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1918 (insn, operands);

    case 7:
      if (!((
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1858 (insn, operands);

    case 8:
      if (!(
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1871 (insn, operands);

    case 9:
      if (!(
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1884 (insn, operands);

    case 10:
      if (!(
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1897 (insn, operands);

    case 11:
      if (!(
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1925 (insn, operands);

    case 12:
      if (!(
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1932 (insn, operands);

    case 13:
      if (!(
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1939 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_65 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1050 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1674 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1747 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1799 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1687 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1760 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1812 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1700 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1773 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1825 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1713 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1786 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1838 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1722 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1899 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1729 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1906 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1736 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1913 (insn, operands);

    case 7:
      if (!((
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1851 (insn, operands);

    case 8:
      if (!(
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1864 (insn, operands);

    case 9:
      if (!(
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1877 (insn, operands);

    case 10:
      if (!(
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1890 (insn, operands);

    case 11:
      if (!(
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1920 (insn, operands);

    case 12:
      if (!(
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1927 (insn, operands);

    case 13:
      if (!(
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1934 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_72 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[4] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern710 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1252 (insn, operands);

        case E_VNx8QImode:
          if (pattern710 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1269 (insn, operands);

        case E_VNx4QImode:
          if (pattern710 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1286 (insn, operands);

        case E_VNx2QImode:
          if (pattern710 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1303 (insn, operands);

        case E_VNx8HImode:
          if (pattern710 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1320 (insn, operands);

        case E_VNx4HImode:
          if (pattern710 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1337 (insn, operands);

        case E_VNx2HImode:
          if (pattern710 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1354 (insn, operands);

        case E_VNx4SImode:
          if (pattern710 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1371 (insn, operands);

        case E_VNx2SImode:
          if (pattern710 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1388 (insn, operands);

        case E_VNx2DImode:
          if (pattern710 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1405 (insn, operands);

        default:
          return NULL;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1052 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1539 (insn, operands);

        case E_VNx8QImode:
          if (pattern1052 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1542 (insn, operands);

        case E_VNx4QImode:
          if (pattern1052 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1545 (insn, operands);

        case E_VNx2QImode:
          if (pattern1052 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1548 (insn, operands);

        case E_VNx8HImode:
          if (pattern1052 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1551 (insn, operands);

        case E_VNx4HImode:
          if (pattern1052 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1554 (insn, operands);

        case E_VNx2HImode:
          if (pattern1052 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1557 (insn, operands);

        case E_VNx4SImode:
          if (pattern1052 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1560 (insn, operands);

        case E_VNx2SImode:
          if (pattern1052 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1563 (insn, operands);

        case E_VNx2DImode:
          if (pattern1052 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1566 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_75 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 123
      || GET_MODE (x2) != E_BLKmode)
    return NULL;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 125
      || GET_MODE (x3) != E_VNx2DImode)
    return NULL;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return NULL;
  x6 = XVECEXP (x2, 0, 0);
  operands[5] = x6;
  if (!register_operand (operands[5], E_VNx2BImode))
    return NULL;
  x7 = XVECEXP (x2, 0, 1);
  operands[0] = x7;
  if (!register_operand (operands[0], E_DImode))
    return NULL;
  x8 = XVECEXP (x3, 0, 0);
  operands[6] = x8;
  x9 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x9) != E_VNx2DImode)
    return NULL;
  x10 = XVECEXP (x2, 0, 3);
  operands[2] = x10;
  if (!const_int_operand (operands[2], E_DImode))
    return NULL;
  x11 = XVECEXP (x2, 0, 4);
  operands[3] = x11;
  switch (pattern1313 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1006 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1320 ())
            {
            case 0:
              if ((
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1008 (insn, operands);
              break;

            case 1:
              if ((
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1010 (insn, operands);
              break;

            case 2:
              if ((
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1012 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1014 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1016 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1018 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1020 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1022 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1320 ())
            {
            case 0:
              if ((
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1023 (insn, operands);
              break;

            case 1:
              if ((
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1024 (insn, operands);
              break;

            case 2:
              if ((
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1025 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1026 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1027 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1028 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1029 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x12 = XVECEXP (x2, 0, 5);
      if (GET_MODE (x12) == E_VNx2QImode
          && aarch64_gather_scale_operand_b (operands[3], E_DImode))
        {
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          if (register_operand (operands[4], E_VNx2DImode)
              && (
#line 2616 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2621 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
            return gen_split_1030 (insn, operands);
        }
      if (GET_MODE (x12) == E_VNx2HImode
          && aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          if (register_operand (operands[4], E_VNx2DImode)
              && (
#line 2616 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2621 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
            return gen_split_1031 (insn, operands);
        }
      if (GET_MODE (x12) != E_VNx2SImode
          || !aarch64_gather_scale_operand_w (operands[3], E_DImode))
        return NULL;
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_VNx2DImode)
          || !(
#line 2616 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2621 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
        return NULL;
      return gen_split_1032 (insn, operands);

    case 3:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1007 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1320 ())
            {
            case 0:
              if ((
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1009 (insn, operands);
              break;

            case 1:
              if ((
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1011 (insn, operands);
              break;

            case 2:
              if ((
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1013 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1015 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1017 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1019 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1021 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_79 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern2 (x3))
        {
        case 0:
          if (aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              && 
#line 2549 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(epilogue_completed))
            return gen_split_15 (insn, operands);
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_SImode)
              || !(
#line 2581 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx) && 
#line 2591 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( epilogue_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && aarch64_split_add_offset_immediate (operands[2], SImode))))
            return NULL;
          return gen_split_17 (insn, operands);

        case 1:
          if (aarch64_pluslong_strict_immedate (operands[2], E_DImode)
              && 
#line 2549 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(epilogue_completed))
            return gen_split_16 (insn, operands);
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_DImode)
              || !(
#line 2581 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx) && 
#line 2591 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( epilogue_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && aarch64_split_add_offset_immediate (operands[2], DImode))))
            return NULL;
          return gen_split_18 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case LSHIFTRT:
          switch (pattern457 (x3))
            {
            case 0:
              if (!
#line 5163 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   SImode)))
                return NULL;
              return gen_split_42 (insn, operands);

            case 1:
              if (!
#line 5163 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   DImode)))
                return NULL;
              return gen_split_46 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern458 (x3))
            {
            case 0:
              if (!
#line 5185 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[3]))
   && (PLUS != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_50 (insn, operands);

            case 1:
              if (!
#line 5185 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[3]))
   && (PLUS != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_54 (insn, operands);

            case 2:
              if (!
#line 5214 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[4]))
   && (PLUS != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_58 (insn, operands);

            case 3:
              if (!
#line 5214 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[4]))
   && (PLUS != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_62 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != PLUS)
        return NULL;
      switch (pattern389 (x3))
        {
        case 0:
          if (!(
#line 5014 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5016 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_192 (insn, operands);

        case 1:
          if (!(
#line 5014 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5016 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_193 (insn, operands);

        case 2:
          if (!(
#line 5014 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5016 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_194 (insn, operands);

        default:
          return NULL;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != VEC_SELECT)
        return NULL;
      switch (pattern460 (x3))
        {
        case 0:
          if (!(
#line 7501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7503 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_237 (insn, operands);

        case 1:
          if (!(
#line 7501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7503 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_238 (insn, operands);

        case 2:
          if (!(
#line 7501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7503 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_239 (insn, operands);

        case 3:
          if (!(
#line 7501 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7503 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_240 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          if (XINT (x4, 1) != 125)
            return NULL;
          x7 = XVECEXP (x4, 0, 1);
          switch (GET_CODE (x7))
            {
            case ASHIFT:
              x8 = XEXP (x7, 1);
              operands[3] = x8;
              switch (pattern812 (x3))
                {
                case 0:
                  if (!(
#line 4208 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1416 (insn, operands);

                case 1:
                  if (!(
#line 4208 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1417 (insn, operands);

                case 2:
                  if (!(
#line 4208 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1418 (insn, operands);

                case 3:
                  if (!(
#line 4208 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1419 (insn, operands);

                case 4:
                  if (!(
#line 4208 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1420 (insn, operands);

                case 5:
                  if (!(
#line 4208 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1421 (insn, operands);

                case 6:
                  if (!(
#line 4208 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1422 (insn, operands);

                case 7:
                  if (!(
#line 4232 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4234 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
                    return NULL;
                  return gen_split_1423 (insn, operands);

                case 8:
                  if (!(
#line 4253 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4255 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
                    return NULL;
                  return gen_split_1424 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFTRT:
              switch (pattern785 (x3))
                {
                case 0:
                  if (!(
#line 1960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3011 (insn, operands);

                case 1:
                  if (!(
#line 1960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3013 (insn, operands);

                case 2:
                  if (!(
#line 1960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3015 (insn, operands);

                case 3:
                  if (!(
#line 1960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3017 (insn, operands);

                default:
                  return NULL;
                }

            case LSHIFTRT:
              switch (pattern785 (x3))
                {
                case 0:
                  if (!(
#line 1960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3012 (insn, operands);

                case 1:
                  if (!(
#line 1960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3014 (insn, operands);

                case 2:
                  if (!(
#line 1960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3016 (insn, operands);

                case 3:
                  if (!(
#line 1960 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1965 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3018 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 3:
          if (XINT (x4, 1) != 307)
            return NULL;
          switch (pattern636 (x3))
            {
            case 0:
              if (!(
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2709 (insn, operands);

            case 1:
              if (!(
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2710 (insn, operands);

            case 2:
              if (!(
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2711 (insn, operands);

            case 3:
              if (!(
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2712 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (pattern38 (x4, 
E_DImode) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x6 = XEXP (x4, 0);
      x9 = XVECEXP (x6, 0, 0);
      operands[3] = x9;
      x10 = XVECEXP (x6, 0, 2);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      switch (pattern19 ())
        {
        case 0:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2697 (insn, operands);

        case 1:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2700 (insn, operands);

        case 2:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2703 (insn, operands);

        case 3:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2706 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (pattern20 (x3))
        {
        case 0:
          if (!(
#line 10823 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10828 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2721 (insn, operands);

        case 1:
          if (!(
#line 10862 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2724 (insn, operands);

        case 2:
          if (!(
#line 10903 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10908 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2727 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_91 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2417 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2427 (insn, operands);
}

 rtx_insn *
split_95 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2496 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2506 (insn, operands);
}

 rtx_insn *
split_99 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2416 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2426 (insn, operands);
}

 rtx_insn *
split_105 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2455 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2465 (insn, operands);
}

 rtx_insn *
split_111 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2494 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2504 (insn, operands);
}

 rtx_insn *
split_118 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2513 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2523 (insn, operands);
}

 rtx_insn *
split_125 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2532 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2542 (insn, operands);
}

 rtx_insn *
split_133 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern1337 (x1, 
GTU))
    {
    case 0:
      if (!(
#line 8219 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2117 (insn, operands);

    case 1:
      if (!(
#line 8219 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2127 (insn, operands);

    case 2:
      if (!(
#line 8219 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2157 (insn, operands);

    case 3:
      if (!(
#line 8219 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2137 (insn, operands);

    case 4:
      if (!(
#line 8219 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2167 (insn, operands);

    case 5:
      if (!(
#line 8219 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2187 (insn, operands);

    case 6:
      if (!(
#line 8219 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2147 (insn, operands);

    case 7:
      if (!(
#line 8219 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2177 (insn, operands);

    case 8:
      if (!(
#line 8219 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2197 (insn, operands);

    case 9:
      if (!(
#line 8219 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2207 (insn, operands);

    case 10:
      if (!(
#line 8253 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2217 (insn, operands);

    case 11:
      if (!(
#line 8253 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2227 (insn, operands);

    case 12:
      if (!(
#line 8253 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2257 (insn, operands);

    case 13:
      if (!(
#line 8253 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2237 (insn, operands);

    case 14:
      if (!(
#line 8253 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2267 (insn, operands);

    case 15:
      if (!(
#line 8253 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2287 (insn, operands);

    case 16:
      if (!(
#line 8253 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2247 (insn, operands);

    case 17:
      if (!(
#line 8253 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2277 (insn, operands);

    case 18:
      if (!(
#line 8253 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2297 (insn, operands);

    case 19:
      if (!(
#line 8253 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2307 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_DFmode)
      && memory_operand (operands[1], E_DFmode))
    {
      switch (GET_MODE (operands[2]))
        {
        case E_DFmode:
          if (register_operand (operands[2], E_DFmode)
              && memory_operand (operands[3], E_DFmode)
              && 
#line 50 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_17 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_V8QImode:
          if (register_operand (operands[2], E_V8QImode)
              && memory_operand (operands[3], E_V8QImode)
              && 
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_25 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_V4HImode:
          if (register_operand (operands[2], E_V4HImode)
              && memory_operand (operands[3], E_V4HImode)
              && 
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_31 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_V4HFmode:
          if (register_operand (operands[2], E_V4HFmode)
              && memory_operand (operands[3], E_V4HFmode)
              && 
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_37 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_V2SImode:
          if (register_operand (operands[2], E_V2SImode)
              && memory_operand (operands[3], E_V2SImode)
              && 
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_43 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_V2SFmode:
          if (register_operand (operands[2], E_V2SFmode)
              && memory_operand (operands[3], E_V2SFmode)
              && 
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_49 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_DFmode))
    {
      if (aarch64_reg_or_fp_zero (operands[1], E_DFmode)
          && memory_operand (operands[2], E_DFmode)
          && aarch64_reg_or_fp_zero (operands[3], E_DFmode)
          && 
#line 62 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_19 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (register_operand (operands[1], E_DFmode))
        {
          switch (GET_MODE (operands[2]))
            {
            case E_V8QImode:
              if (memory_operand (operands[2], E_V8QImode)
                  && register_operand (operands[3], E_V8QImode)
                  && 
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_61 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_V4HImode:
              if (memory_operand (operands[2], E_V4HImode)
                  && register_operand (operands[3], E_V4HImode)
                  && 
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_67 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_V4HFmode:
              if (memory_operand (operands[2], E_V4HFmode)
                  && register_operand (operands[3], E_V4HFmode)
                  && 
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_73 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_V2SImode:
              if (memory_operand (operands[2], E_V2SImode)
                  && register_operand (operands[3], E_V2SImode)
                  && 
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_79 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_V2SFmode:
              if (memory_operand (operands[2], E_V2SFmode)
                  && register_operand (operands[3], E_V2SFmode)
                  && 
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_85 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (aarch64_reg_zero_or_fp_zero (operands[1], E_DFmode)
          && memory_operand (operands[2], E_DImode)
          && aarch64_reg_zero_or_fp_zero (operands[3], E_DImode)
          && 
#line 161 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_222 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (register_operand (operands[0], E_DFmode)
      && memory_operand (operands[1], E_DFmode)
      && register_operand (operands[2], E_DFmode)
      && memory_operand (operands[3], E_DFmode)
      && 
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
    {
      *pmatch_len_ = 1;
      res = gen_peephole2_55 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (memory_operand (operands[0], E_DFmode)
      && register_operand (operands[1], E_DFmode)
      && memory_operand (operands[2], E_DFmode)
      && register_operand (operands[3], E_DFmode)
      && 
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
    {
      *pmatch_len_ = 1;
      res = gen_peephole2_91 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 3
      || peep2_current_count < 4)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  if (register_operand (operands[4], E_DFmode))
    {
      x4 = XEXP (x2, 1);
      if (pattern1165 (x4, 
E_DFmode) == 0
          && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, DFmode)))
        {
          *pmatch_len_ = 3;
          res = gen_peephole2_229 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (!memory_operand (operands[4], E_DFmode))
    return NULL;
  x4 = XEXP (x2, 1);
  if (pattern1167 (x4, 
E_DFmode) != 0
      || !
#line 284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, false, DFmode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_235 (insn, operands);
}

 rtx_insn *
peephole2_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V8BFmode))
    {
      switch (pattern938 (
E_V8BFmode))
        {
        case 0:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_148 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_149 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_150 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_151 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_152 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_153 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_154 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_155 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V8BFmode)
      || !register_operand (operands[1], E_V8BFmode))
    return NULL;
  switch (pattern993 ())
    {
    case 0:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_212 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_213 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_214 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_215 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_216 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_217 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_218 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_219 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V8HImode))
    {
      switch (pattern938 (
E_V8HImode))
        {
        case 0:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_100 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_101 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_102 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_103 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_104 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_105 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_106 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_107 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V8HImode)
      || !register_operand (operands[1], E_V8HImode))
    return NULL;
  switch (pattern993 ())
    {
    case 0:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_164 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_165 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_166 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_167 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_168 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_169 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_170 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_171 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && memory_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_SImode)
          && memory_operand (operands[3], E_SImode)
          && 
#line 26 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_12 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (memory_operand (operands[0], E_SImode))
        {
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && memory_operand (operands[2], E_SImode)
              && aarch64_reg_or_zero (operands[3], E_SImode)
              && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_14 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (aarch64_reg_zero_or_fp_zero (operands[1], E_SImode)
              && memory_operand (operands[2], E_SFmode)
              && aarch64_reg_zero_or_fp_zero (operands[3], E_SFmode)
              && 
#line 161 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_225 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3
          || peep2_current_count < 4)
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x7) != SET)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (register_operand (operands[4], E_SImode))
        {
          x9 = XEXP (x7, 1);
          if (pattern1165 (x9, 
E_SImode) == 0
              && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SImode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_226 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[4], E_SImode))
        return NULL;
      x9 = XEXP (x7, 1);
      if (pattern1166 (x9, 
E_SImode) != 0
          || !
#line 264 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, false, SImode)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_232 (insn, operands);

    case E_DImode:
      if (register_operand (operands[0], E_DImode)
          && memory_operand (operands[1], E_DImode)
          && register_operand (operands[2], E_DImode)
          && memory_operand (operands[3], E_DImode)
          && 
#line 26 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_13 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (memory_operand (operands[0], E_DImode))
        {
          if (aarch64_reg_or_zero (operands[1], E_DImode)
              && memory_operand (operands[2], E_DImode)
              && aarch64_reg_or_zero (operands[3], E_DImode)
              && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_15 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (aarch64_reg_zero_or_fp_zero (operands[1], E_DImode)
              && memory_operand (operands[2], E_DFmode)
              && aarch64_reg_zero_or_fp_zero (operands[3], E_DFmode)
              && 
#line 161 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_223 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3
          || peep2_current_count < 4)
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x7) != SET)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (register_operand (operands[4], E_DImode))
        {
          x9 = XEXP (x7, 1);
          if (pattern1165 (x9, 
E_DImode) == 0
              && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, DImode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_227 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[4], E_DImode))
        return NULL;
      x9 = XEXP (x7, 1);
      if (pattern1166 (x9, 
E_DImode) != 0
          || !
#line 264 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, false, DImode)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_233 (insn, operands);

    case E_SFmode:
      if (register_operand (operands[0], E_SFmode)
          && memory_operand (operands[1], E_SFmode)
          && register_operand (operands[2], E_SFmode)
          && memory_operand (operands[3], E_SFmode)
          && 
#line 50 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_16 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (memory_operand (operands[0], E_SFmode))
        {
          if (aarch64_reg_or_fp_zero (operands[1], E_SFmode)
              && memory_operand (operands[2], E_SFmode)
              && aarch64_reg_or_fp_zero (operands[3], E_SFmode)
              && 
#line 62 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_18 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (aarch64_reg_zero_or_fp_zero (operands[1], E_SFmode)
              && memory_operand (operands[2], E_SImode)
              && aarch64_reg_zero_or_fp_zero (operands[3], E_SImode)
              && 
#line 161 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_224 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3
          || peep2_current_count < 4)
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x7) != SET)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (register_operand (operands[4], E_SFmode))
        {
          x9 = XEXP (x7, 1);
          if (pattern1165 (x9, 
E_SFmode) == 0
              && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SFmode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_228 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[4], E_SFmode))
        return NULL;
      x9 = XEXP (x7, 1);
      if (pattern1167 (x9, 
E_SFmode) != 0
          || !
#line 284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, false, SFmode)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_234 (insn, operands);

    case E_DFmode:
      return peephole2_1 (x1, insn, pmatch_len_);

    case E_V8QImode:
      if (register_operand (operands[0], E_V8QImode))
        {
          switch (pattern935 (
E_V8QImode))
            {
            case 0:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_20 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_26 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_32 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_38 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_44 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_50 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_V8QImode)
          || !register_operand (operands[1], E_V8QImode))
        return NULL;
      switch (pattern990 ())
        {
        case 0:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_56 (insn, operands);

        case 1:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_62 (insn, operands);

        case 2:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_68 (insn, operands);

        case 3:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_74 (insn, operands);

        case 4:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_80 (insn, operands);

        case 5:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_86 (insn, operands);

        default:
          return NULL;
        }

    case E_V4HImode:
      if (register_operand (operands[0], E_V4HImode))
        {
          switch (pattern935 (
E_V4HImode))
            {
            case 0:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_21 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_27 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_33 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_39 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_45 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_51 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_V4HImode)
          || !register_operand (operands[1], E_V4HImode))
        return NULL;
      switch (pattern990 ())
        {
        case 0:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_57 (insn, operands);

        case 1:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_63 (insn, operands);

        case 2:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_69 (insn, operands);

        case 3:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_75 (insn, operands);

        case 4:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_81 (insn, operands);

        case 5:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_87 (insn, operands);

        default:
          return NULL;
        }

    case E_V4HFmode:
      if (register_operand (operands[0], E_V4HFmode))
        {
          switch (pattern935 (
E_V4HFmode))
            {
            case 0:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_22 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_28 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_34 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_40 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_46 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 74 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_52 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_V4HFmode)
          || !register_operand (operands[1], E_V4HFmode))
        return NULL;
      switch (pattern990 ())
        {
        case 0:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_58 (insn, operands);

        case 1:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_64 (insn, operands);

        case 2:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_70 (insn, operands);

        case 3:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_76 (insn, operands);

        case 4:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_82 (insn, operands);

        case 5:
          if (!
#line 86 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_88 (insn, operands);

        default:
          return NULL;
        }

    case E_V2SImode:
      return peephole2_11 (x1, insn, pmatch_len_);

    case E_V2SFmode:
      return peephole2_10 (x1, insn, pmatch_len_);

    case E_V16QImode:
      return peephole2_9 (x1, insn, pmatch_len_);

    case E_V8HImode:
      return peephole2_8 (x1, insn, pmatch_len_);

    case E_V4SImode:
      return peephole2_7 (x1, insn, pmatch_len_);

    case E_V2DImode:
      return peephole2_3 (x1, insn, pmatch_len_);

    case E_V8HFmode:
      return peephole2_6 (x1, insn, pmatch_len_);

    case E_V4SFmode:
      return peephole2_4 (x1, insn, pmatch_len_);

    case E_V2DFmode:
      return peephole2_2 (x1, insn, pmatch_len_);

    case E_V8BFmode:
      return peephole2_5 (x1, insn, pmatch_len_);

    default:
      return NULL;
    }
}
