/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 4;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 5;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 9;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 10;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 11;

    case E_VNx8SFmode:
      if (!aligned_register_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x3) != E_VNx8SFmode
          || !aligned_register_operand (operands[1], E_VNx8SImode))
        return -1;
      return 12;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x3) != E_VNx16SFmode
          || !aligned_register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 4;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx64QImode:
      if (!aligned_register_operand (operands[0], E_VNx64QImode)
          || GET_MODE (x3) != E_VNx64QImode
          || !aligned_register_operand (operands[1], E_VNx64QImode))
        return -1;
      return 0;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[0], E_VNx32HImode)
          || GET_MODE (x3) != E_VNx32HImode
          || !aligned_register_operand (operands[1], E_VNx32HImode))
        return -1;
      return 1;

    case E_VNx16SImode:
      if (!aligned_register_operand (operands[0], E_VNx16SImode)
          || GET_MODE (x3) != E_VNx16SImode
          || !aligned_register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 2;

    case E_VNx8DImode:
      if (!aligned_register_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x3) != E_VNx8DImode
          || !aligned_register_operand (operands[1], E_VNx8DImode))
        return -1;
      return 3;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[0], E_VNx32BFmode)
          || GET_MODE (x3) != E_VNx32BFmode
          || !aligned_register_operand (operands[1], E_VNx32BFmode))
        return -1;
      return 4;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[0], E_VNx32HFmode)
          || GET_MODE (x3) != E_VNx32HFmode
          || !aligned_register_operand (operands[1], E_VNx32HFmode))
        return -1;
      return 5;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x3) != E_VNx16SFmode
          || !aligned_register_operand (operands[1], E_VNx16SFmode))
        return -1;
      return 6;

    case E_VNx8DFmode:
      if (!aligned_register_operand (operands[0], E_VNx8DFmode)
          || GET_MODE (x3) != E_VNx8DFmode
          || !aligned_register_operand (operands[1], E_VNx8DFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4HImode:
      if (!register_operand (operands[2], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern77 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern77 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern77 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern77 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern77 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern77 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern77 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_DImode:
      if (pattern77 (x3, 
E_DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode))
        return -1;
      return 1;

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern77 (x3, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern77 (x3, 
E_VNx8QImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern77 (x3, 
E_VNx4QImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern77 (x3, 
E_VNx2QImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern77 (x3, 
E_VNx8HImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern77 (x3, 
E_VNx4HImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern77 (x3, 
E_VNx2HImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern77 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern77 (x3, 
E_VNx2SImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern77 (x3, 
E_VNx2DImode) != 0)
        return -1;
      return 9;

    case E_VNx8HFmode:
      if (pattern77 (x3, 
E_VNx8HFmode) != 0)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (pattern77 (x3, 
E_VNx4HFmode) != 0)
        return -1;
      return 11;

    case E_VNx2HFmode:
      if (pattern77 (x3, 
E_VNx2HFmode) != 0)
        return -1;
      return 12;

    case E_VNx8BFmode:
      if (pattern77 (x3, 
E_VNx8BFmode) != 0)
        return -1;
      return 13;

    case E_VNx4BFmode:
      if (pattern77 (x3, 
E_VNx4BFmode) != 0)
        return -1;
      return 14;

    case E_VNx2BFmode:
      if (pattern77 (x3, 
E_VNx2BFmode) != 0)
        return -1;
      return 15;

    case E_VNx4SFmode:
      if (pattern77 (x3, 
E_VNx4SFmode) != 0)
        return -1;
      return 16;

    case E_VNx2SFmode:
      if (pattern77 (x3, 
E_VNx2SFmode) != 0)
        return -1;
      return 17;

    case E_VNx2DFmode:
      if (pattern77 (x3, 
E_VNx2DFmode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern147 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[3] = x3;
  if (!register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_di (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern164 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx4SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx4SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_VNx4SFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx8BFmode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_VNx8BFmode))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx8BImode:
      if (!register_operand (operands[1], E_VNx8BImode)
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 0;

    case E_VNx4BImode:
      if (!register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4SImode))
        return -1;
      return 1;

    case E_VNx2BImode:
      if (!register_operand (operands[1], E_VNx2BImode)
          || !register_operand (operands[2], E_VNx2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 8LL:
      return 0;

    case 16LL:
      return 1;

    case 32LL:
      return 2;

    case 64LL:
      return 3;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern202 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern208 (x3, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern208 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern208 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern211 (x3); /* [-1, 3] */

    case UNSPEC:
      if (XVECLEN (x6, 0) != 3
          || XINT (x6, 1) != 351)
        return -1;
      x7 = XVECEXP (x6, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 3
          || XINT (x8, 1) != 351)
        return -1;
      x9 = XVECEXP (x8, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      res = pattern215 (x3);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern231 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i2))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], i2))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[1], E_VNx32QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[1], E_VNx64QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx64QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[1], E_VNx16HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx16HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[1], E_VNx32HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 168)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 93)
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (!const_int_operand (x7, E_SImode))
    return -1;
  x8 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[1] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[2] = x10;
      operands[3] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          return pattern245 (x2, 
E_VNx4SImode); /* [-1, 3] */

        case E_VNx2DImode:
          res = pattern245 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 4; /* [4, 7] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x8, 1);
      operands[1] = x12;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[2] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[3] = x10;
      operands[4] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          res = pattern249 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case E_VNx2DImode:
          res = pattern249 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  switch (GET_MODE (x5))
    {
    case E_VNx4SImode:
      if (GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx16QImode:
          if (!register_operand (operands[3], E_VNx16QImode)
              || !register_operand (operands[4], E_VNx16QImode))
            return -1;
          return 0;

        case E_VNx8HImode:
          if (!register_operand (operands[3], E_VNx8HImode)
              || !register_operand (operands[4], E_VNx8HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx2DImode:
      if (pattern265 (x2, 
E_VNx8HImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern281 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], E_VNx2BImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_VNx2DImode:
      return 0;

    case E_VNx1TImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern285 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[2] = x8;
      x9 = XVECEXP (x2, 0, 5);
      operands[3] = x9;
      switch (GET_MODE (x5))
        {
        case E_VNx16QImode:
          if (GET_MODE (x2) != E_VNx16QImode
              || GET_MODE (x3) != E_VNx16QImode
              || !register_operand (operands[2], E_VNx16BImode)
              || !register_operand (operands[3], E_VNx16QImode))
            return -1;
          return 0;

        case E_VNx8HImode:
          if (GET_MODE (x2) != E_VNx8HImode
              || !register_operand (operands[2], E_VNx8BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx8HImode:
              if (!register_operand (operands[3], E_VNx8HImode))
                return -1;
              return 1;

            case E_VNx8BFmode:
              if (!register_operand (operands[3], E_VNx8BFmode))
                return -1;
              return 2;

            case E_VNx8HFmode:
              if (!register_operand (operands[3], E_VNx8HFmode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_VNx4SImode:
          if (GET_MODE (x2) != E_VNx4SImode
              || !register_operand (operands[2], E_VNx4BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx4SImode:
              if (!register_operand (operands[3], E_VNx4SImode))
                return -1;
              return 4;

            case E_VNx4SFmode:
              if (!register_operand (operands[3], E_VNx4SFmode))
                return -1;
              return 5;

            default:
              return -1;
            }

        case E_VNx2DImode:
          if (GET_MODE (x2) != E_VNx2DImode
              || !register_operand (operands[2], E_VNx2BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[3], E_VNx2DImode))
                return -1;
              return 6;

            case E_VNx2DFmode:
              if (!register_operand (operands[3], E_VNx2DFmode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_VNx1TImode:
          if (GET_MODE (x2) != E_VNx1TImode
              || GET_MODE (x3) != E_VNx1TImode
              || !register_operand (operands[2], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx16QImode:
              if (!register_operand (operands[3], E_VNx16QImode))
                return -1;
              return 8;

            case E_VNx8HImode:
              if (!register_operand (operands[3], E_VNx8HImode))
                return -1;
              return 9;

            case E_VNx4SImode:
              if (!register_operand (operands[3], E_VNx4SImode))
                return -1;
              return 10;

            case E_VNx2DImode:
              if (!register_operand (operands[3], E_VNx2DImode))
                return -1;
              return 11;

            case E_VNx8BFmode:
              if (!register_operand (operands[3], E_VNx8BFmode))
                return -1;
              return 12;

            case E_VNx8HFmode:
              if (!register_operand (operands[3], E_VNx8HFmode))
                return -1;
              return 13;

            case E_VNx4SFmode:
              if (!register_operand (operands[3], E_VNx4SFmode))
                return -1;
              return 14;

            case E_VNx2DFmode:
              if (!register_operand (operands[3], E_VNx2DFmode))
                return -1;
              return 15;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x7, 1);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[3] = x8;
      x9 = XVECEXP (x2, 0, 5);
      operands[4] = x9;
      switch (GET_MODE (x5))
        {
        case E_VNx16QImode:
          if (GET_MODE (x2) != E_VNx16QImode
              || GET_MODE (x3) != E_VNx16QImode
              || !register_operand (operands[3], E_VNx16BImode)
              || !register_operand (operands[4], E_VNx16QImode))
            return -1;
          return 16;

        case E_VNx8HImode:
          if (GET_MODE (x2) != E_VNx8HImode
              || !register_operand (operands[3], E_VNx8BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx8HImode:
              if (!register_operand (operands[4], E_VNx8HImode))
                return -1;
              return 17;

            case E_VNx8BFmode:
              if (!register_operand (operands[4], E_VNx8BFmode))
                return -1;
              return 18;

            case E_VNx8HFmode:
              if (!register_operand (operands[4], E_VNx8HFmode))
                return -1;
              return 19;

            default:
              return -1;
            }

        case E_VNx4SImode:
          if (GET_MODE (x2) != E_VNx4SImode
              || !register_operand (operands[3], E_VNx4BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx4SImode:
              if (!register_operand (operands[4], E_VNx4SImode))
                return -1;
              return 20;

            case E_VNx4SFmode:
              if (!register_operand (operands[4], E_VNx4SFmode))
                return -1;
              return 21;

            default:
              return -1;
            }

        case E_VNx2DImode:
          if (GET_MODE (x2) != E_VNx2DImode
              || !register_operand (operands[3], E_VNx2BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[4], E_VNx2DImode))
                return -1;
              return 22;

            case E_VNx2DFmode:
              if (!register_operand (operands[4], E_VNx2DFmode))
                return -1;
              return 23;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern342 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_hi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return pattern352 (x1); /* [-1, 3] */
}

int
pattern358 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 31)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  x12 = XVECEXP (x3, 0, 2);
  operands[3] = x12;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[4] = x13;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return pattern352 (x1); /* [-1, 3] */
}

int
pattern372 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern377 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!aarch64_any_register_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x1) != E_VNx16QImode)
        return -1;
      return 0;

    case E_VNx8QImode:
      if (!register_operand (operands[0], E_VNx8QImode)
          || GET_MODE (x1) != E_VNx8QImode)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (!register_operand (operands[0], E_VNx4QImode)
          || GET_MODE (x1) != E_VNx4QImode)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x1) != E_VNx2QImode)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (!register_operand (operands[0], E_VNx4HImode)
          || GET_MODE (x1) != E_VNx4HImode)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (!register_operand (operands[0], E_VNx2HImode)
          || GET_MODE (x1) != E_VNx2HImode)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (!register_operand (operands[0], E_VNx2SImode)
          || GET_MODE (x1) != E_VNx2SImode)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode)
        return -1;
      return 9;

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (!register_operand (operands[0], E_VNx4HFmode)
          || GET_MODE (x1) != E_VNx4HFmode)
        return -1;
      return 11;

    case E_VNx2HFmode:
      if (!register_operand (operands[0], E_VNx2HFmode)
          || GET_MODE (x1) != E_VNx2HFmode)
        return -1;
      return 12;

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x1) != E_VNx8BFmode)
        return -1;
      return 13;

    case E_VNx4BFmode:
      if (!register_operand (operands[0], E_VNx4BFmode)
          || GET_MODE (x1) != E_VNx4BFmode)
        return -1;
      return 14;

    case E_VNx2BFmode:
      if (!register_operand (operands[0], E_VNx2BFmode)
          || GET_MODE (x1) != E_VNx2BFmode)
        return -1;
      return 15;

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x1) != E_VNx4SFmode)
        return -1;
      return 16;

    case E_VNx2SFmode:
      if (!register_operand (operands[0], E_VNx2SFmode)
          || GET_MODE (x1) != E_VNx2SFmode)
        return -1;
      return 17;

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x1) != E_VNx2DFmode)
        return -1;
      return 18;

    case E_VNx32QImode:
      if (!register_operand (operands[0], E_VNx32QImode)
          || GET_MODE (x1) != E_VNx32QImode)
        return -1;
      return 19;

    case E_VNx16HImode:
      if (!register_operand (operands[0], E_VNx16HImode)
          || GET_MODE (x1) != E_VNx16HImode)
        return -1;
      return 20;

    case E_VNx8SImode:
      if (!register_operand (operands[0], E_VNx8SImode)
          || GET_MODE (x1) != E_VNx8SImode)
        return -1;
      return 21;

    case E_VNx4DImode:
      if (!register_operand (operands[0], E_VNx4DImode)
          || GET_MODE (x1) != E_VNx4DImode)
        return -1;
      return 22;

    case E_VNx16BFmode:
      if (!register_operand (operands[0], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode)
        return -1;
      return 23;

    case E_VNx16HFmode:
      if (!register_operand (operands[0], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode)
        return -1;
      return 24;

    case E_VNx8SFmode:
      if (!register_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x1) != E_VNx8SFmode)
        return -1;
      return 25;

    case E_VNx4DFmode:
      if (!register_operand (operands[0], E_VNx4DFmode)
          || GET_MODE (x1) != E_VNx4DFmode)
        return -1;
      return 26;

    case E_VNx48QImode:
      if (!register_operand (operands[0], E_VNx48QImode)
          || GET_MODE (x1) != E_VNx48QImode)
        return -1;
      return 27;

    case E_VNx24HImode:
      if (!register_operand (operands[0], E_VNx24HImode)
          || GET_MODE (x1) != E_VNx24HImode)
        return -1;
      return 28;

    case E_VNx12SImode:
      if (!register_operand (operands[0], E_VNx12SImode)
          || GET_MODE (x1) != E_VNx12SImode)
        return -1;
      return 29;

    case E_VNx6DImode:
      if (!register_operand (operands[0], E_VNx6DImode)
          || GET_MODE (x1) != E_VNx6DImode)
        return -1;
      return 30;

    case E_VNx24BFmode:
      if (!register_operand (operands[0], E_VNx24BFmode)
          || GET_MODE (x1) != E_VNx24BFmode)
        return -1;
      return 31;

    case E_VNx24HFmode:
      if (!register_operand (operands[0], E_VNx24HFmode)
          || GET_MODE (x1) != E_VNx24HFmode)
        return -1;
      return 32;

    case E_VNx12SFmode:
      if (!register_operand (operands[0], E_VNx12SFmode)
          || GET_MODE (x1) != E_VNx12SFmode)
        return -1;
      return 33;

    case E_VNx6DFmode:
      if (!register_operand (operands[0], E_VNx6DFmode)
          || GET_MODE (x1) != E_VNx6DFmode)
        return -1;
      return 34;

    case E_VNx64QImode:
      if (!register_operand (operands[0], E_VNx64QImode)
          || GET_MODE (x1) != E_VNx64QImode)
        return -1;
      return 35;

    case E_VNx32HImode:
      if (!register_operand (operands[0], E_VNx32HImode)
          || GET_MODE (x1) != E_VNx32HImode)
        return -1;
      return 36;

    case E_VNx16SImode:
      if (!register_operand (operands[0], E_VNx16SImode)
          || GET_MODE (x1) != E_VNx16SImode)
        return -1;
      return 37;

    case E_VNx8DImode:
      if (!register_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x1) != E_VNx8DImode)
        return -1;
      return 38;

    case E_VNx32BFmode:
      if (!register_operand (operands[0], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode)
        return -1;
      return 39;

    case E_VNx32HFmode:
      if (!register_operand (operands[0], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode)
        return -1;
      return 40;

    case E_VNx16SFmode:
      if (!register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x1) != E_VNx16SFmode)
        return -1;
      return 41;

    case E_VNx8DFmode:
      if (!register_operand (operands[0], E_VNx8DFmode)
          || GET_MODE (x1) != E_VNx8DFmode)
        return -1;
      return 42;

    default:
      return -1;
    }
}

int
pattern429 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern325 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern325 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern325 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern325 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern325 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern436 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || GET_MODE (x3) != E_V8QImode
          || GET_MODE (x4) != E_V8HImode
          || !register_operand (operands[2], E_V8HImode)
          || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x3) != E_V4HImode
          || GET_MODE (x4) != E_V4SImode
          || !register_operand (operands[2], E_V4SImode)
          || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x3) != E_V2SImode
          || GET_MODE (x4) != E_V2DImode
          || !register_operand (operands[2], E_V2DImode)
          || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 3
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode))
    return -1;
  return pattern450 (x3); /* [-1, 4] */
}

int
pattern456 (rtx x1, unsigned int i1, rtx_code i2, unsigned int i3, machine_mode i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i5
      || GET_MODE (x3) != i4)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i3
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern373 (x6, 
i1, 
i2, 
E_DImode); /* [-1, 0] */
}

int
pattern461 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_lshift_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern466 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 351)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 351)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 1);
  operands[4] = x7;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  return pattern215 (x1); /* [-1, 2] */
}

int
pattern474 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern478 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern482 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern481 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern481 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern481 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern481 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern481 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern481 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern481 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern481 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern481 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern481 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    case E_V2DImode:
      if (pattern481 (x1, 
E_V2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern494 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern493 (x1, 
E_SImode); /* [-1, 3] */

    case E_DImode:
      res = pattern493 (x1, 
E_DImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern503 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern509 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[3] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          return pattern503 (x1, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx4SImode:
          if (pattern503 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx2DImode:
          if (pattern503 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 168)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern508 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
            return -1;
          return 3;

        case E_VNx2DImode:
          if (pattern508 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern524 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (!register_operand (operands[2], E_DImode))
                return -1;
              return 1;

            case E_SImode:
              if (!register_operand (operands[2], E_SImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      res = pattern16 (x1);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern542 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern547 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V2SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  return pattern546 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern555 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern559 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (!register_operand (x4, i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (!register_operand (x7, i1))
    return -1;
  return 0;
}

int
pattern571 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern577 (rtx x1, unsigned int i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1)
    return -1;
  return 0;
}

int
pattern584 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_reg_or_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern586 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != AND)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != NOT)
    return -1;
  return 0;
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[3], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx4QImode))
        return -1;
      return 1;

    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx2QImode))
        return -1;
      return 2;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx4HImode))
        return -1;
      return 3;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx2HImode))
        return -1;
      return 4;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern606 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != XOR)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  operands[4] = x6;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 1);
  operands[2] = x8;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern605 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern605 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern605 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern605 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return pattern331 (x3); /* [-1, 4] */
}

int
pattern620 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern625 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i3)
      || !vect_par_cnst_hi_half (operands[4], i3))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern635 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern634 (x1, 
E_V2SImode, 
E_V8QImode); /* [-1, 1] */

    case E_V4SImode:
      res = pattern634 (x1, 
E_V4SImode, 
E_V16QImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern640 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern644 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern649 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_borrow_operation (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern655 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[3] = x7;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_MODE (x8) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V4HImode:
              if (!register_operand (operands[2], E_V4HImode))
                return -1;
              return 0;

            case E_V8HImode:
              if (!register_operand (operands[2], E_V8HImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_MODE (x8) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || GET_MODE (x2) != E_V2DImode
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V2SImode:
              if (!register_operand (operands[2], E_V2SImode))
                return -1;
              return 2;

            case E_V4SImode:
              if (!register_operand (operands[2], E_V4SImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern654 (x1, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern654 (x1, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern685 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      operands[4] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern683 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern683 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern683 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x4, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern684 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern684 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern684 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern698 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern696 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern696 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern696 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern696 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    case E_VNx8BFmode:
      if (pattern697 (x1, 
E_VNx8HImode, 
E_VNx8BFmode) != 0)
        return -1;
      return 4;

    case E_VNx8HFmode:
      if (pattern697 (x1, 
E_VNx8HImode, 
E_VNx8HFmode) != 0)
        return -1;
      return 5;

    case E_VNx4SFmode:
      if (pattern697 (x1, 
E_VNx4SImode, 
E_VNx4SFmode) != 0)
        return -1;
      return 6;

    case E_VNx2DFmode:
      if (pattern697 (x1, 
E_VNx2DImode, 
E_VNx2DFmode) != 0)
        return -1;
      return 7;

    case E_VNx32QImode:
      if (!aligned_register_operand (operands[0], E_VNx32QImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32QImode
          || pattern695 (x1, 
E_VNx32QImode) != 0)
        return -1;
      return 8;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[0], E_VNx16HImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16HImode
          || pattern695 (x1, 
E_VNx16HImode) != 0)
        return -1;
      return 9;

    case E_VNx8SImode:
      if (!aligned_register_operand (operands[0], E_VNx8SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8SImode
          || pattern695 (x1, 
E_VNx8SImode) != 0)
        return -1;
      return 10;

    case E_VNx4DImode:
      if (!aligned_register_operand (operands[0], E_VNx4DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx4DImode
          || pattern695 (x1, 
E_VNx4DImode) != 0)
        return -1;
      return 11;

    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[0], E_VNx16BFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16BFmode
          || pattern695 (x1, 
E_VNx16BFmode) != 0)
        return -1;
      return 12;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[0], E_VNx16HFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16HFmode
          || pattern695 (x1, 
E_VNx16HFmode) != 0)
        return -1;
      return 13;

    case E_VNx8SFmode:
      if (!aligned_register_operand (operands[0], E_VNx8SFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8SFmode
          || pattern695 (x1, 
E_VNx8SFmode) != 0)
        return -1;
      return 14;

    case E_VNx4DFmode:
      if (!aligned_register_operand (operands[0], E_VNx4DFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx4DFmode
          || pattern695 (x1, 
E_VNx4DFmode) != 0)
        return -1;
      return 15;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[0], E_VNx64QImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx64QImode
          || pattern695 (x1, 
E_VNx64QImode) != 0)
        return -1;
      return 16;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[0], E_VNx32HImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32HImode
          || pattern695 (x1, 
E_VNx32HImode) != 0)
        return -1;
      return 17;

    case E_VNx16SImode:
      if (!aligned_register_operand (operands[0], E_VNx16SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16SImode
          || pattern695 (x1, 
E_VNx16SImode) != 0)
        return -1;
      return 18;

    case E_VNx8DImode:
      if (!aligned_register_operand (operands[0], E_VNx8DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8DImode
          || pattern695 (x1, 
E_VNx8DImode) != 0)
        return -1;
      return 19;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[0], E_VNx32BFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32BFmode
          || pattern695 (x1, 
E_VNx32BFmode) != 0)
        return -1;
      return 20;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[0], E_VNx32HFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32HFmode
          || pattern695 (x1, 
E_VNx32HFmode) != 0)
        return -1;
      return 21;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16SFmode
          || pattern695 (x1, 
E_VNx16SFmode) != 0)
        return -1;
      return 22;

    case E_VNx8DFmode:
      if (!aligned_register_operand (operands[0], E_VNx8DFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8DFmode
          || pattern695 (x1, 
E_VNx8DFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern754 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_imm24 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern760 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sminmax_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern763 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern767 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern776 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[4], i1))
    return -1;
  return 0;
}

int
pattern782 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CC_Zmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_CC_Zmode
      || !register_operand (operands[0], E_DImode))
    return -1;
  return 0;
}

int
pattern790 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_logical_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern797 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V2x16QImode:
      if (!register_operand (operands[2], E_V2x16QImode))
        return -1;
      return 1;

    case E_V3x16QImode:
      if (!register_operand (operands[2], E_V3x16QImode))
        return -1;
      return 2;

    case E_V4x16QImode:
      if (!register_operand (operands[2], E_V4x16QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern813 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || !aarch64_shift_imm_si (operands[1], E_QImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || !aarch64_shift_imm_di (operands[1], E_QImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern825 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern832 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XEXP (x4, 1);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern831 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern831 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern831 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern844 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_imm_zero (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern850 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern849 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 2] */

    case E_VNx4SImode:
      res = pattern849 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DImode:
      res = pattern849 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern860 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x2, operands[2]))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      operands[4] = x2;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 4;

        case E_VNx8HImode:
          if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 5;

        case E_VNx4SImode:
          if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 6;

        case E_VNx2DImode:
          if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern884 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern889 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  return pattern888 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern895 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_plus_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_plus_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern901 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern906 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern913 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_imm_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern923 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x3, 1);
  if (!rtx_equal_p (x7, operands[3]))
    return -1;
  return pattern922 (x1); /* [-1, 1] */
}

int
pattern930 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  return pattern615 (x4); /* [-1, 3] */
}

int
pattern934 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_general_reg (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!aarch64_plus_immediate (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern938 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode)
          || !memory_operand (operands[3], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode)
          || !memory_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode)
          || !memory_operand (operands[3], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode)
          || !memory_operand (operands[3], E_V2DImode))
        return -1;
      return 3;

    case E_V8HFmode:
      if (!register_operand (operands[2], E_V8HFmode)
          || !memory_operand (operands[3], E_V8HFmode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!register_operand (operands[2], E_V4SFmode)
          || !memory_operand (operands[3], E_V4SFmode))
        return -1;
      return 5;

    case E_V2DFmode:
      if (!register_operand (operands[2], E_V2DFmode)
          || !memory_operand (operands[3], E_V2DFmode))
        return -1;
      return 6;

    case E_V8BFmode:
      if (!register_operand (operands[2], E_V8BFmode)
          || !memory_operand (operands[3], E_V8BFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern956 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern963 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1002 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x1) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8HImode:
          if (!register_operand (operands[1], E_VNx8HImode))
            return -1;
          return 1;

        case E_VNx16HImode:
          if (!register_operand (operands[1], E_VNx16HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8HFmode:
          if (!register_operand (operands[1], E_VNx8HFmode))
            return -1;
          return 3;

        case E_VNx16HFmode:
          if (!register_operand (operands[1], E_VNx16HFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x1) != E_VNx8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8BFmode:
          if (!register_operand (operands[1], E_VNx8BFmode))
            return -1;
          return 5;

        case E_VNx16BFmode:
          if (!register_operand (operands[1], E_VNx16BFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1026 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern1025 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern1025 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern1025 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1034 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1041 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i2
      || GET_MODE (x11) != i1)
    return -1;
  return 0;
}

int
pattern1055 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !aarch64_logical_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1062 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0LL:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1044 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1044 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1044 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1LL:
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1044 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SFmode:
          if (pattern1044 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DFmode:
          if (pattern1044 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1080 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SImode
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SImode)
      || GET_MODE (x2) != E_V2SImode
      || !register_operand (operands[2], E_V8QImode)
      || !immediate_operand (operands[4], E_SImode)
      || !register_operand (operands[1], E_V2SImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1093 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[1], i4))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1102 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_arith_with_sub_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1044 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1044 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1044 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1044 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1105 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4SFmode:
          if (pattern1105 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2DFmode:
          if (pattern1105 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1117 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1127 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0LL:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1109 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1109 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1109 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1LL:
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1109 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SFmode:
          if (pattern1109 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DFmode:
          if (pattern1109 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1145 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1157 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1162 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16BImode)
          || !register_operand (operands[3], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx8BImode
          || !register_operand (operands[2], E_VNx8BImode)
          || !register_operand (operands[3], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx4BImode
          || !register_operand (operands[2], E_VNx4BImode)
          || !register_operand (operands[3], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx2BImode
          || !register_operand (operands[2], E_VNx2BImode)
          || !register_operand (operands[3], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1196 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1196 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1196 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1196 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1207 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i1)
      || !const_scalar_int_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !aarch64_plus_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1212 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_hi_half (operands[4], i2))
    return -1;
  x6 = XEXP (x3, 1);
  return pattern1182 (x6, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1220 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1226 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern1232 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i3)
      || !aarch64_sve_gather_offset_h (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || !aarch64_gather_scale_operand_h (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1238 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1245 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1249 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (GET_MODE (x4) != E_VNx16BImode)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[3] = x7;
  if (!register_operand (operands[3], E_VNx16BImode))
    return -1;
  return pattern1247 (x1, 
i1); /* [-1, 1] */
}

int
pattern1258 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_arith_with_sub_immediate (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1264 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  if (!aarch64_sve_gp_strictness (operands[6], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern464 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern464 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern464 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1276 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1284 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], E_VNx2BImode)
      || !aarch64_sve_gather_offset_d (operands[1], E_DImode)
      || !register_operand (operands[2], E_VNx2DImode)
      || !aarch64_gather_scale_operand_d (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern1291 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1296 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !aarch64_logical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x3 = XEXP (x1, 1);
      return pattern1193 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (pattern1193 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (pattern1193 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      x3 = XEXP (x1, 1);
      if (pattern1193 (x3, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1316 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!aarch64_imm3 (operands[3], E_VOIDmode))
    return -1;
  x12 = XEXP (x5, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  switch (GET_MODE (x8))
    {
    case E_SImode:
      return pattern1315 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern1315 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1326 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16HImode:
      if (!aligned_register_operand (operands[2], E_VNx16HImode)
          || !aligned_register_operand (operands[3], E_VNx16HImode))
        return -1;
      return 0;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[2], E_VNx32HImode)
          || !aligned_register_operand (operands[3], E_VNx32HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1333 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 2);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case SET:
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 3
          || XINT (x9, 1) != 126)
        return -1;
      x10 = XVECEXP (x9, 0, 2);
      if (GET_CODE (x10) != i1)
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      x12 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x12, operands[6]))
        return -1;
      x13 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x13, operands[7]))
        return -1;
      x14 = XEXP (x10, 0);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XEXP (x10, 1);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (GET_MODE (x5) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
              || !register_operand (operands[0], E_VNx16BImode)
              || GET_MODE (x9) != E_VNx16BImode
              || GET_MODE (x10) != E_VNx16BImode)
            return -1;
          return 0;

        case E_VNx8BImode:
          if (GET_MODE (x5) != E_VNx8BImode
              || !register_operand (operands[0], E_VNx8BImode)
              || GET_MODE (x9) != E_VNx8BImode
              || GET_MODE (x10) != E_VNx8BImode)
            return -1;
          res = pattern1330 ();
          if (res >= 0)
            return res + 1; /* [1, 2] */
          return -1;

        case E_VNx4BImode:
          if (GET_MODE (x5) != E_VNx4BImode
              || !register_operand (operands[0], E_VNx4BImode)
              || GET_MODE (x9) != E_VNx4BImode
              || GET_MODE (x10) != E_VNx4BImode)
            return -1;
          res = pattern1331 ();
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        case E_VNx2BImode:
          if (GET_MODE (x5) != E_VNx2BImode
              || !register_operand (operands[0], E_VNx2BImode)
              || GET_MODE (x9) != E_VNx2BImode
              || GET_MODE (x10) != E_VNx2BImode)
            return -1;
          res = pattern1332 ();
          if (res >= 0)
            return res + 6; /* [6, 9] */
          return -1;

        default:
          return -1;
        }

    case CLOBBER:
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (GET_MODE (x5) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 10;

        case E_VNx8BImode:
          if (GET_MODE (x5) != E_VNx8BImode
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          res = pattern1330 ();
          if (res >= 0)
            return res + 11; /* [11, 12] */
          return -1;

        case E_VNx4BImode:
          if (GET_MODE (x5) != E_VNx4BImode
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          res = pattern1331 ();
          if (res >= 0)
            return res + 13; /* [13, 15] */
          return -1;

        case E_VNx2BImode:
          if (GET_MODE (x5) != E_VNx2BImode
              || !scratch_operand (operands[0], E_VNx2BImode))
            return -1;
          res = pattern1332 ();
          if (res >= 0)
            return res + 16; /* [16, 19] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      x9 = XEXP (x4, 1);
      operands[4] = x9;
      x10 = XEXP (x3, 1);
      operands[5] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1115 (x2, 
E_SImode) != 0
              || !aarch64_simd_shift_imm_si (operands[4], E_SImode)
              || !const_int_operand (operands[5], E_SImode)
              || !
#line 6491 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (SImode, UINTVAL (operands[2]),
				      UINTVAL (operands[4]),
				      UINTVAL(operands[5]))))
            return -1;
          return 850; /* *aarch64_bfisi5_shift */

        case E_DImode:
          if (pattern1115 (x2, 
E_DImode) != 0
              || !aarch64_simd_shift_imm_di (operands[4], E_DImode)
              || !const_int_operand (operands[5], E_DImode)
              || !
#line 6491 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (DImode, UINTVAL (operands[2]),
				      UINTVAL (operands[4]),
				      UINTVAL(operands[5]))))
            return -1;
          return 851; /* *aarch64_bfidi5_shift */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern792 (x2, 
E_SImode) != 0)
            return -1;
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (GET_MODE (x3) == E_SImode)
            {
              operands[3] = x4;
              if (register_operand (operands[3], E_SImode))
                {
                  x10 = XEXP (x3, 1);
                  operands[4] = x10;
                  if (const_int_operand (operands[4], E_SImode)
                      && 
#line 6560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (SImode, UINTVAL (operands[2]), 0,
				      UINTVAL (operands[4]))))
                    return 858; /* *aarch64_bfisi4_noshift */
                }
            }
          operands[4] = x7;
          operands[3] = x6;
          if (GET_MODE (x3) == E_SImode)
            {
              operands[1] = x4;
              if (register_operand (operands[1], E_SImode))
                {
                  x10 = XEXP (x3, 1);
                  operands[2] = x10;
                  if (const_int_operand (operands[2], E_SImode)
                      && 
#line 6572 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (SImode, UINTVAL (operands[2]), 0,
				      UINTVAL (operands[4]))))
                    return 860; /* *aarch64_bfisi4_noshift_alt */
                }
            }
          operands[3] = x7;
          operands[1] = x6;
          if (GET_MODE (x3) != E_SImode)
            return -1;
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[4] = x10;
          if (!const_int_operand (operands[4], E_SImode)
              || !
#line 6720 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
((INTVAL (operands[3]) == ~INTVAL (operands[4]))
  && (aarch64_high_bits_all_ones_p (INTVAL (operands[3]))
    || aarch64_high_bits_all_ones_p (INTVAL (operands[4])))))
            return -1;
          return 887; /* *aarch64_bfxilsi */

        case E_DImode:
          if (pattern792 (x2, 
E_DImode) != 0)
            return -1;
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (GET_MODE (x3) == E_DImode)
            {
              operands[3] = x4;
              if (register_operand (operands[3], E_DImode))
                {
                  x10 = XEXP (x3, 1);
                  operands[4] = x10;
                  if (const_int_operand (operands[4], E_DImode)
                      && 
#line 6560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (DImode, UINTVAL (operands[2]), 0,
				      UINTVAL (operands[4]))))
                    return 859; /* *aarch64_bfidi4_noshift */
                }
            }
          operands[4] = x7;
          operands[3] = x6;
          if (GET_MODE (x3) == E_DImode)
            {
              operands[1] = x4;
              if (register_operand (operands[1], E_DImode))
                {
                  x10 = XEXP (x3, 1);
                  operands[2] = x10;
                  if (const_int_operand (operands[2], E_DImode)
                      && 
#line 6572 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (DImode, UINTVAL (operands[2]), 0,
				      UINTVAL (operands[4]))))
                    return 861; /* *aarch64_bfidi4_noshift_alt */
                }
            }
          operands[3] = x7;
          operands[1] = x6;
          if (GET_MODE (x3) != E_DImode)
            return -1;
          operands[2] = x4;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[4] = x10;
          if (!const_int_operand (operands[4], E_DImode)
              || !
#line 6720 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
((INTVAL (operands[3]) == ~INTVAL (operands[4]))
  && (aarch64_high_bits_all_ones_p (INTVAL (operands[3]))
    || aarch64_high_bits_all_ones_p (INTVAL (operands[4])))))
            return -1;
          return 888; /* *aarch64_bfxildi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !
#line 3382 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2725; /* reduc_plus_scal_v8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !
#line 3382 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2726; /* reduc_plus_scal_v16qi */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !
#line 3382 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2727; /* reduc_plus_scal_v4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !
#line 3382 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2728; /* reduc_plus_scal_v8hi */

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 3382 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2729; /* reduc_plus_scal_v4si */

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode)
                  || !
#line 3391 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2731; /* reduc_plus_scal_v2si */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 3382 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2730; /* reduc_plus_scal_v2di */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern467 (x3))
        {
        case 0:
          if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2742; /* aarch64_saddlvv8qi */

        case 1:
          if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2744; /* aarch64_saddlvv16qi */

        case 2:
          if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2746; /* aarch64_saddlvv4hi */

        case 3:
          if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2748; /* aarch64_saddlvv8hi */

        case 4:
          if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2750; /* aarch64_saddlvv4si */

        case 5:
          if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2752; /* aarch64_saddlvv2si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern467 (x3))
            {
            case 0:
              if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2743; /* aarch64_uaddlvv8qi */

            case 1:
              if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2745; /* aarch64_uaddlvv16qi */

            case 2:
              if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2747; /* aarch64_uaddlvv4hi */

            case 3:
              if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2749; /* aarch64_uaddlvv8hi */

            case 4:
              if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2751; /* aarch64_uaddlvv4si */

            case 5:
              if (!
#line 3438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2753; /* aarch64_uaddlvv2si */

            default:
              return -1;
            }

        case PLUS:
          switch (pattern591 (x3))
            {
            case 0:
              if (!
#line 3485 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
                return -1;
              return 2766; /* *aarch64_uaddlvv8qi_reduction_2 */

            case 1:
              if (!
#line 3485 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
                return -1;
              return 2767; /* *aarch64_uaddlvv16qi_reduction_2 */

            case 2:
              if (!
#line 3485 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
                return -1;
              return 2768; /* *aarch64_uaddlvv4hi_reduction_2 */

            case 3:
              if (!
#line 3485 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
                return -1;
              return 2769; /* *aarch64_uaddlvv8hi_reduction_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern470 (x3))
        {
        case 0:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2754; /* *aarch64_saddlvv8qi_reduction */

        case 1:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2756; /* *aarch64_saddlvv16qi_reduction */

        case 2:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2758; /* *aarch64_saddlvv4hi_reduction */

        case 3:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2760; /* *aarch64_saddlvv8hi_reduction */

        case 4:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2762; /* *aarch64_saddlvv4si_reduction */

        case 5:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2764; /* *aarch64_saddlvv2si_reduction */

        case 6:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2755; /* *aarch64_uaddlvv8qi_reduction */

        case 7:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2757; /* *aarch64_uaddlvv16qi_reduction */

        case 8:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2759; /* *aarch64_uaddlvv4hi_reduction */

        case 9:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2761; /* *aarch64_uaddlvv8hi_reduction */

        case 10:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2763; /* *aarch64_uaddlvv4si_reduction */

        case 11:
          if (!
#line 3458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2765; /* *aarch64_uaddlvv2si_reduction */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern61 (x1))
    {
    case 0:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5025; /* aarch64_rev32v8qi */

    case 1:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5032; /* aarch64_rev32v16qi */

    case 2:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5037; /* aarch64_rev32v4hi */

    case 3:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5044; /* aarch64_rev32v8hi */

    case 4:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5049; /* aarch64_rev32v2si */

    case 5:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5056; /* aarch64_rev32v4si */

    case 6:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5059; /* aarch64_rev32v2di */

    case 7:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5064; /* aarch64_rev32v4hf */

    case 8:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5071; /* aarch64_rev32v8hf */

    case 9:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5076; /* aarch64_rev32v4bf */

    case 10:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5083; /* aarch64_rev32v8bf */

    case 11:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5088; /* aarch64_rev32v2sf */

    case 12:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5095; /* aarch64_rev32v4sf */

    case 13:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5098; /* aarch64_rev32v2df */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern55 (x1))
    {
    case 0:
      if (!(
#line 6843 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 902; /* roundhf2 */

    case 1:
      if (!
#line 6843 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 909; /* roundsf2 */

    case 2:
      if (!
#line 6843 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 916; /* rounddf2 */

    case 3:
      if (!(
#line 3005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2505; /* roundv4hf2 */

    case 4:
      if (!(
#line 3005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2514; /* roundv8hf2 */

    case 5:
      if (!
#line 3005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2533; /* roundv2sf2 */

    case 6:
      if (!
#line 3005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2542; /* roundv4sf2 */

    case 7:
      if (!
#line 3005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2549; /* roundv2df2 */

    case 8:
      if (!
#line 700 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11448; /* roundvnx8sf2 */

    case 9:
      if (!
#line 700 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11452; /* roundvnx16sf2 */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern72 (x1))
    {
    case 0:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12906; /* aarch64_sve_zipvnx64qi */

    case 1:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12908; /* aarch64_sve_zipvnx32hi */

    case 2:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12910; /* aarch64_sve_zipvnx16si */

    case 3:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12912; /* aarch64_sve_zipvnx8di */

    case 4:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12914; /* aarch64_sve_zipvnx32bf */

    case 5:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12916; /* aarch64_sve_zipvnx32hf */

    case 6:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12918; /* aarch64_sve_zipvnx16sf */

    case 7:
      if (!
#line 3894 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12920; /* aarch64_sve_zipvnx8df */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (pattern722 ())
    {
    case 0:
      if (!
#line 181 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11154; /* aarch64_pmov_from_vnx16qi */

    case 1:
      if (!
#line 181 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11155; /* aarch64_pmov_from_vnx8hi */

    case 2:
      if (!
#line 181 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11156; /* aarch64_pmov_from_vnx4si */

    case 3:
      if (!
#line 181 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11157; /* aarch64_pmov_from_vnx2di */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  switch (XINT (x3, 1))
    {
    case 321:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8114; /* aarch64_pred_smulhvnx16qi */

        case E_VNx8QImode:
          if (pattern873 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8116; /* aarch64_pred_smulhvnx8qi */

        case E_VNx4QImode:
          if (pattern873 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8118; /* aarch64_pred_smulhvnx4qi */

        case E_VNx2QImode:
          if (pattern873 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8120; /* aarch64_pred_smulhvnx2qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8122; /* aarch64_pred_smulhvnx8hi */

        case E_VNx4HImode:
          if (pattern873 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8124; /* aarch64_pred_smulhvnx4hi */

        case E_VNx2HImode:
          if (pattern873 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8126; /* aarch64_pred_smulhvnx2hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8128; /* aarch64_pred_smulhvnx4si */

        case E_VNx2SImode:
          if (pattern873 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8130; /* aarch64_pred_smulhvnx2si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8132; /* aarch64_pred_smulhvnx2di */

        default:
          return -1;
        }

    case 322:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8115; /* aarch64_pred_umulhvnx16qi */

        case E_VNx8QImode:
          if (pattern873 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8117; /* aarch64_pred_umulhvnx8qi */

        case E_VNx4QImode:
          if (pattern873 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8119; /* aarch64_pred_umulhvnx4qi */

        case E_VNx2QImode:
          if (pattern873 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8121; /* aarch64_pred_umulhvnx2qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8123; /* aarch64_pred_umulhvnx8hi */

        case E_VNx4HImode:
          if (pattern873 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8125; /* aarch64_pred_umulhvnx4hi */

        case E_VNx2HImode:
          if (pattern873 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8127; /* aarch64_pred_umulhvnx2hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8129; /* aarch64_pred_umulhvnx4si */

        case E_VNx2SImode:
          if (pattern873 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8131; /* aarch64_pred_umulhvnx2si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8133; /* aarch64_pred_umulhvnx2di */

        default:
          return -1;
        }

    case 415:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern996 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8377; /* *sdiv_pow2vnx16qi3 */

        case E_VNx8QImode:
          if (pattern996 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8378; /* *sdiv_pow2vnx8qi3 */

        case E_VNx4QImode:
          if (pattern996 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8379; /* *sdiv_pow2vnx4qi3 */

        case E_VNx2QImode:
          if (pattern996 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8380; /* *sdiv_pow2vnx2qi3 */

        case E_VNx8HImode:
          if (pattern996 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8381; /* *sdiv_pow2vnx8hi3 */

        case E_VNx4HImode:
          if (pattern996 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8382; /* *sdiv_pow2vnx4hi3 */

        case E_VNx2HImode:
          if (pattern996 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8383; /* *sdiv_pow2vnx2hi3 */

        case E_VNx4SImode:
          if (pattern996 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8384; /* *sdiv_pow2vnx4si3 */

        case E_VNx2SImode:
          if (pattern996 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8385; /* *sdiv_pow2vnx2si3 */

        case E_VNx2DImode:
          if (pattern996 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8386; /* *sdiv_pow2vnx2di3 */

        case E_V8QImode:
          if (pattern996 (x2, 
E_V8QImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8387; /* *sdiv_pow2v8qi3 */

        case E_V16QImode:
          if (pattern996 (x2, 
E_V16QImode, 
E_VNx16BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8388; /* *sdiv_pow2v16qi3 */

        case E_V4HImode:
          if (pattern996 (x2, 
E_V4HImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8389; /* *sdiv_pow2v4hi3 */

        case E_V8HImode:
          if (pattern996 (x2, 
E_V8HImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8390; /* *sdiv_pow2v8hi3 */

        case E_V2SImode:
          if (pattern996 (x2, 
E_V2SImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8391; /* *sdiv_pow2v2si3 */

        case E_V4SImode:
          if (pattern996 (x2, 
E_V4SImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8392; /* *sdiv_pow2v4si3 */

        case E_V2DImode:
          if (pattern996 (x2, 
E_V2DImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8393; /* *sdiv_pow2v2di3 */

        case E_V1DImode:
          if (pattern996 (x2, 
E_V1DImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8394; /* *sdiv_pow2v1di3 */

        default:
          return -1;
        }

    case 210:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11627; /* aarch64_pred_shaddvnx16qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11637; /* aarch64_pred_shaddvnx8hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11647; /* aarch64_pred_shaddvnx4si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11657; /* aarch64_pred_shaddvnx2di */

        default:
          return -1;
        }

    case 214:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11628; /* aarch64_pred_shsubvnx16qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11638; /* aarch64_pred_shsubvnx8hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11648; /* aarch64_pred_shsubvnx4si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11658; /* aarch64_pred_shsubvnx2di */

        default:
          return -1;
        }

    case 233:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11629; /* aarch64_pred_sqrshlvnx16qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11639; /* aarch64_pred_sqrshlvnx8hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11649; /* aarch64_pred_sqrshlvnx4si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11659; /* aarch64_pred_sqrshlvnx2di */

        default:
          return -1;
        }

    case 212:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11630; /* aarch64_pred_srhaddvnx16qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11640; /* aarch64_pred_srhaddvnx8hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11650; /* aarch64_pred_srhaddvnx4si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11660; /* aarch64_pred_srhaddvnx2di */

        default:
          return -1;
        }

    case 231:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11631; /* aarch64_pred_srshlvnx16qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11641; /* aarch64_pred_srshlvnx8hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11651; /* aarch64_pred_srshlvnx4si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11661; /* aarch64_pred_srshlvnx2di */

        default:
          return -1;
        }

    case 211:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11632; /* aarch64_pred_uhaddvnx16qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11642; /* aarch64_pred_uhaddvnx8hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11652; /* aarch64_pred_uhaddvnx4si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11662; /* aarch64_pred_uhaddvnx2di */

        default:
          return -1;
        }

    case 215:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11633; /* aarch64_pred_uhsubvnx16qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11643; /* aarch64_pred_uhsubvnx8hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11653; /* aarch64_pred_uhsubvnx4si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11663; /* aarch64_pred_uhsubvnx2di */

        default:
          return -1;
        }

    case 234:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11634; /* aarch64_pred_uqrshlvnx16qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11644; /* aarch64_pred_uqrshlvnx8hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11654; /* aarch64_pred_uqrshlvnx4si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11664; /* aarch64_pred_uqrshlvnx2di */

        default:
          return -1;
        }

    case 213:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11635; /* aarch64_pred_urhaddvnx16qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11645; /* aarch64_pred_urhaddvnx8hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11655; /* aarch64_pred_urhaddvnx4si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11665; /* aarch64_pred_urhaddvnx2di */

        default:
          return -1;
        }

    case 232:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern873 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11636; /* aarch64_pred_urshlvnx16qi */

        case E_VNx8HImode:
          if (pattern873 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11646; /* aarch64_pred_urshlvnx8hi */

        case E_VNx4SImode:
          if (pattern873 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11656; /* aarch64_pred_urshlvnx4si */

        case E_VNx2DImode:
          if (pattern873 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 998 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11666; /* aarch64_pred_urshlvnx2di */

        default:
          return -1;
        }

    case 227:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern997 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11817; /* aarch64_pred_sqshlvnx16qi */

        case E_VNx8HImode:
          if (pattern997 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11819; /* aarch64_pred_sqshlvnx8hi */

        case E_VNx4SImode:
          if (pattern997 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11821; /* aarch64_pred_sqshlvnx4si */

        case E_VNx2DImode:
          if (pattern997 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11823; /* aarch64_pred_sqshlvnx2di */

        default:
          return -1;
        }

    case 228:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern997 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11818; /* aarch64_pred_uqshlvnx16qi */

        case E_VNx8HImode:
          if (pattern997 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11820; /* aarch64_pred_uqshlvnx8hi */

        case E_VNx4SImode:
          if (pattern997 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11822; /* aarch64_pred_uqshlvnx4si */

        case E_VNx2DImode:
          if (pattern997 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11824; /* aarch64_pred_uqshlvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern106 (x1))
    {
    case 0:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4847; /* aarch64_zip2v8qi */

    case 1:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4863; /* aarch64_zip2v16qi */

    case 2:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4871; /* aarch64_zip2v4hi */

    case 3:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4887; /* aarch64_zip2v8hi */

    case 4:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4895; /* aarch64_zip2v2si */

    case 5:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4911; /* aarch64_zip2v4si */

    case 6:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4917; /* aarch64_zip2v2di */

    case 7:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4925; /* aarch64_zip2v4hf */

    case 8:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4941; /* aarch64_zip2v8hf */

    case 9:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4949; /* aarch64_zip2v4bf */

    case 10:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4965; /* aarch64_zip2v8bf */

    case 11:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4973; /* aarch64_zip2v2sf */

    case 12:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4989; /* aarch64_zip2v4sf */

    case 13:
      if (!
#line 8634 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4995; /* aarch64_zip2v2df */

    case 14:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10532; /* aarch64_sve_zip2vnx16qi */

    case 15:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10542; /* aarch64_sve_zip2vnx8qi */

    case 16:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10552; /* aarch64_sve_zip2vnx4qi */

    case 17:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10562; /* aarch64_sve_zip2vnx2qi */

    case 18:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10572; /* aarch64_sve_zip2vnx8hi */

    case 19:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10582; /* aarch64_sve_zip2vnx4hi */

    case 20:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10592; /* aarch64_sve_zip2vnx2hi */

    case 21:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10602; /* aarch64_sve_zip2vnx4si */

    case 22:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10612; /* aarch64_sve_zip2vnx2si */

    case 23:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10622; /* aarch64_sve_zip2vnx2di */

    case 24:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10632; /* aarch64_sve_zip2vnx8hf */

    case 25:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10642; /* aarch64_sve_zip2vnx4hf */

    case 26:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10652; /* aarch64_sve_zip2vnx2hf */

    case 27:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10662; /* aarch64_sve_zip2vnx8bf */

    case 28:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10672; /* aarch64_sve_zip2vnx4bf */

    case 29:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10682; /* aarch64_sve_zip2vnx2bf */

    case 30:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10692; /* aarch64_sve_zip2vnx4sf */

    case 31:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10702; /* aarch64_sve_zip2vnx2sf */

    case 32:
      if (!
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10712; /* aarch64_sve_zip2vnx2df */

    case 33:
      if (!
#line 9284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10793; /* aarch64_sve_zip2vnx16bi */

    case 34:
      if (!
#line 9284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10799; /* aarch64_sve_zip2vnx8bi */

    case 35:
      if (!
#line 9284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10805; /* aarch64_sve_zip2vnx4bi */

    case 36:
      if (!
#line 9284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10811; /* aarch64_sve_zip2vnx2bi */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1982; /* vec_shr_v8qi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1985; /* vec_shr_v4hi */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1988; /* vec_shr_v4hf */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1991; /* vec_shr_v2si */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1994; /* vec_shr_v2sf */

    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !register_operand (operands[1], E_V4BFmode)
          || !
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1997; /* vec_shr_v4bf */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (!(
#line 7431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 1099; /* fmin_nanhf3 */

    case 1:
      if (!
#line 7431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1103; /* fmin_nansf3 */

    case 2:
      if (!
#line 7431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1107; /* fmin_nandf3 */

    case 3:
      if (!(
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2683; /* fmin_nanv4hf3 */

    case 4:
      if (!(
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2693; /* fmin_nanv8hf3 */

    case 5:
      if (!
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2699; /* fmin_nanv2sf3 */

    case 6:
      if (!
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2709; /* fmin_nanv4sf3 */

    case 7:
      if (!
#line 3361 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2713; /* fmin_nanv2df3 */

    case 8:
      if (!(
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12295; /* *aarch64_sve_fminvnx16bf */

    case 9:
      if (!(
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12299; /* *aarch64_sve_fminvnx32bf */

    case 10:
      if (!
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12303; /* *aarch64_sve_fminvnx16hf */

    case 11:
      if (!
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12307; /* *aarch64_sve_fminvnx8sf */

    case 12:
      if (!
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12311; /* *aarch64_sve_fminvnx4df */

    case 13:
      if (!
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12315; /* *aarch64_sve_fminvnx32hf */

    case 14:
      if (!
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12319; /* *aarch64_sve_fminvnx16sf */

    case 15:
      if (!
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12323; /* *aarch64_sve_fminvnx8df */

    case 16:
      if (!(
#line 2526 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12327; /* aarch64_sve_single_fminvnx16bf */

    case 17:
      if (!(
#line 2526 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12331; /* aarch64_sve_single_fminvnx32bf */

    case 18:
      if (!
#line 2526 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12335; /* aarch64_sve_single_fminvnx16hf */

    case 19:
      if (!
#line 2526 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12339; /* aarch64_sve_single_fminvnx8sf */

    case 20:
      if (!
#line 2526 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12343; /* aarch64_sve_single_fminvnx4df */

    case 21:
      if (!
#line 2526 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12347; /* aarch64_sve_single_fminvnx32hf */

    case 22:
      if (!
#line 2526 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12351; /* aarch64_sve_single_fminvnx16sf */

    case 23:
      if (!
#line 2526 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12355; /* aarch64_sve_single_fminvnx8df */

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern121 (x1))
    {
    case 0:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10537; /* aarch64_sve_uzpq1vnx16qi */

    case 1:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10547; /* aarch64_sve_uzpq1vnx8qi */

    case 2:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10557; /* aarch64_sve_uzpq1vnx4qi */

    case 3:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10567; /* aarch64_sve_uzpq1vnx2qi */

    case 4:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10577; /* aarch64_sve_uzpq1vnx8hi */

    case 5:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10587; /* aarch64_sve_uzpq1vnx4hi */

    case 6:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10597; /* aarch64_sve_uzpq1vnx2hi */

    case 7:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10607; /* aarch64_sve_uzpq1vnx4si */

    case 8:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10617; /* aarch64_sve_uzpq1vnx2si */

    case 9:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10627; /* aarch64_sve_uzpq1vnx2di */

    case 10:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10637; /* aarch64_sve_uzpq1vnx8hf */

    case 11:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10647; /* aarch64_sve_uzpq1vnx4hf */

    case 12:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10657; /* aarch64_sve_uzpq1vnx2hf */

    case 13:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10667; /* aarch64_sve_uzpq1vnx8bf */

    case 14:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10677; /* aarch64_sve_uzpq1vnx4bf */

    case 15:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10687; /* aarch64_sve_uzpq1vnx2bf */

    case 16:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10697; /* aarch64_sve_uzpq1vnx4sf */

    case 17:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10707; /* aarch64_sve_uzpq1vnx2sf */

    case 18:
      if (!(
#line 9215 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3183 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10717; /* aarch64_sve_uzpq1vnx2df */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern124 (x3, 
E_VNx16QImode, 
E_VNx8HImode) != 0
          || !
#line 9321 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10820; /* vec_pack_trunc_vnx8hi */

    case E_VNx8HImode:
      if (pattern124 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0
          || !
#line 9321 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10821; /* vec_pack_trunc_vnx4si */

    case E_VNx4SImode:
      if (pattern124 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0
          || !
#line 9321 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10822; /* vec_pack_trunc_vnx2di */

    case E_VNx16BImode:
      if (pattern124 (x3, 
E_VNx16BImode, 
E_VNx8BImode) != 0
          || !
#line 10003 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10981; /* vec_pack_trunc_vnx8bi */

    case E_VNx8BImode:
      if (pattern124 (x3, 
E_VNx8BImode, 
E_VNx4BImode) != 0
          || !
#line 10003 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10982; /* vec_pack_trunc_vnx4bi */

    case E_VNx4BImode:
      if (pattern124 (x3, 
E_VNx4BImode, 
E_VNx2BImode) != 0
          || !
#line 10003 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10983; /* vec_pack_trunc_vnx2bi */

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern88 (x1))
    {
    case 0:
      if (!(
#line 742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1588; /* aarch64_rsqrtsv4hf */

    case 1:
      if (!(
#line 742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1589; /* aarch64_rsqrtsv8hf */

    case 2:
      if (!
#line 742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1590; /* aarch64_rsqrtsv2sf */

    case 3:
      if (!
#line 742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1591; /* aarch64_rsqrtsv4sf */

    case 4:
      if (!
#line 742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1592; /* aarch64_rsqrtsv2df */

    case 5:
      if (!(
#line 742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1593; /* aarch64_rsqrtshf */

    case 6:
      if (!
#line 742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1594; /* aarch64_rsqrtssf */

    case 7:
      if (!
#line 742 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1595; /* aarch64_rsqrtsdf */

    case 8:
      if (!
#line 5408 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8512; /* aarch64_sve_frsqrtsvnx8hf */

    case 9:
      if (!
#line 5408 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8514; /* aarch64_sve_frsqrtsvnx4sf */

    case 10:
      if (!
#line 5408 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8516; /* aarch64_sve_frsqrtsvnx2df */

    default:
      return -1;
    }
}

 int
recog_129 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12891; /* aarch64_sve_uzpqvnx32qi */

    case 1:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12893; /* aarch64_sve_uzpqvnx16hi */

    case 2:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12895; /* aarch64_sve_uzpqvnx8si */

    case 3:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12897; /* aarch64_sve_uzpqvnx4di */

    case 4:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12899; /* aarch64_sve_uzpqvnx16bf */

    case 5:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12901; /* aarch64_sve_uzpqvnx16hf */

    case 6:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12903; /* aarch64_sve_uzpqvnx8sf */

    case 7:
      if (!
#line 3885 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12905; /* aarch64_sve_uzpqvnx4df */

    default:
      return -1;
    }
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern122 (x1))
    {
    case 0:
      if (!
#line 9227 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10721; /* aarch64_sve_zip1qvnx16qi */

    case 1:
      if (!
#line 9227 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10727; /* aarch64_sve_zip1qvnx8hi */

    case 2:
      if (!
#line 9227 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10733; /* aarch64_sve_zip1qvnx4si */

    case 3:
      if (!
#line 9227 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10739; /* aarch64_sve_zip1qvnx2di */

    case 4:
      if (!
#line 9227 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10745; /* aarch64_sve_zip1qvnx8bf */

    case 5:
      if (!
#line 9227 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10751; /* aarch64_sve_zip1qvnx8hf */

    case 6:
      if (!
#line 9227 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10757; /* aarch64_sve_zip1qvnx4sf */

    case 7:
      if (!
#line 9227 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10763; /* aarch64_sve_zip1qvnx2df */

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      return 1041; /* scvtfsi3 */

    case 1:
      return 1043; /* scvtfdi3 */

    case 2:
      if (!
#line 7226 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1049; /* scvtfsihf3 */

    case 3:
      if (!
#line 7226 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1051; /* scvtfdihf3 */

    case 4:
      if (!
#line 7246 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1055; /* scvtfhi3 */

    case 5:
      if (!(
#line 3136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 291 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2642; /* scvtfv4hi3 */

    case 6:
      if (!(
#line 3136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 292 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2644; /* scvtfv8hi3 */

    case 7:
      if (!
#line 3136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2646; /* scvtfv2si3 */

    case 8:
      if (!
#line 3136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2648; /* scvtfv4si3 */

    case 9:
      if (!
#line 3136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2650; /* scvtfv2di3 */

    default:
      return -1;
    }
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern128 (x1))
    {
    case 0:
      if (!
#line 2270 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12144; /* aarch64_sve_umulltvnx8hi */

    case 1:
      if (!
#line 2270 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12165; /* aarch64_sve_umulltvnx4si */

    case 2:
      if (!
#line 2270 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12186; /* aarch64_sve_umulltvnx2di */

    case 3:
      if (!
#line 2283 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12194; /* aarch64_sve_umullt_lane_vnx4si */

    case 4:
      if (!
#line 2283 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12200; /* aarch64_sve_umullt_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern134 (x1))
    {
    case 0:
      if (!
#line 3922 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12940; /* aarch64_sve_bgrpvnx16qi */

    case 1:
      if (!
#line 3922 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12943; /* aarch64_sve_bgrpvnx8hi */

    case 2:
      if (!
#line 3922 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12946; /* aarch64_sve_bgrpvnx4si */

    case 3:
      if (!
#line 3922 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12949; /* aarch64_sve_bgrpvnx2di */

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern140 (x1))
    {
    case 0:
      if (!
#line 3723 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12773; /* aarch64_pred_reduc_eorqv_vnx16qi */

    case 1:
      if (!
#line 3723 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12781; /* aarch64_pred_reduc_eorqv_vnx8hi */

    case 2:
      if (!
#line 3723 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12789; /* aarch64_pred_reduc_eorqv_vnx4si */

    case 3:
      if (!
#line 3723 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12797; /* aarch64_pred_reduc_eorqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern119 (x1))
    {
    case 0:
      if (!
#line 8961 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 8))
        return -1;
      return 10404; /* aarch64_pred_reduc_uadd_vnx16qi */

    case 1:
      if (!
#line 8961 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
        return -1;
      return 10406; /* aarch64_pred_reduc_uadd_vnx8hi */

    case 2:
      if (!
#line 8961 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
        return -1;
      return 10408; /* aarch64_pred_reduc_uadd_vnx4si */

    case 3:
      if (!
#line 8961 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
        return -1;
      return 10410; /* aarch64_pred_reduc_uadd_vnx2di */

    default:
      return -1;
    }
}

 int
recog_200 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (XWINT (x4, 0))
    {
    case 0LL:
      switch (pattern1124 (x2))
        {
        case 0:
          if (
#line 9646 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10924; /* *cond_float_nonextendvnx8hivnx8hf_relaxed */
          break;

        case 1:
          if (
#line 9646 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10930; /* *cond_float_nonextendvnx4sivnx8hf_relaxed */
          break;

        case 2:
          if (
#line 9646 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10936; /* *cond_float_nonextendvnx2divnx8hf_relaxed */
          break;

        case 3:
          if (
#line 9646 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10926; /* *cond_float_nonextendvnx8hivnx4sf_relaxed */
          break;

        case 4:
          if (
#line 9646 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10932; /* *cond_float_nonextendvnx4sivnx4sf_relaxed */
          break;

        case 5:
          if (
#line 9646 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10938; /* *cond_float_nonextendvnx2divnx4sf_relaxed */
          break;

        case 6:
          if (
#line 9646 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10928; /* *cond_float_nonextendvnx8hivnx2df_relaxed */
          break;

        case 7:
          if (
#line 9646 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10934; /* *cond_float_nonextendvnx4sivnx2df_relaxed */
          break;

        case 8:
          if (
#line 9646 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10940; /* *cond_float_nonextendvnx2divnx2df_relaxed */
          break;

        default:
          break;
        }
      break;

    case 1LL:
      switch (pattern1125 (x2))
        {
        case 0:
          if (
#line 9669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10942; /* *cond_float_nonextendvnx8hivnx8hf_strict */
          break;

        case 1:
          if (
#line 9669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10948; /* *cond_float_nonextendvnx4sivnx8hf_strict */
          break;

        case 2:
          if (
#line 9669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10954; /* *cond_float_nonextendvnx2divnx8hf_strict */
          break;

        case 3:
          if (
#line 9669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10944; /* *cond_float_nonextendvnx8hivnx4sf_strict */
          break;

        case 4:
          if (
#line 9669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10950; /* *cond_float_nonextendvnx4sivnx4sf_strict */
          break;

        case 5:
          if (
#line 9669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10956; /* *cond_float_nonextendvnx2divnx4sf_strict */
          break;

        case 6:
          if (
#line 9669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10946; /* *cond_float_nonextendvnx8hivnx2df_strict */
          break;

        case 7:
          if (
#line 9669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10952; /* *cond_float_nonextendvnx4sivnx2df_strict */
          break;

        case 8:
          if (
#line 9669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10958; /* *cond_float_nonextendvnx2divnx2df_strict */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
      || pattern1123 (x2, 
E_VNx4SImode, 
E_VNx2DFmode) != 0
      || !
#line 9703 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
    return -1;
  return 10960; /* *cond_float_extendvnx4sivnx2df */
}

 int
recog_208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1242 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11832; /* *cond_uqshlvnx2di_2 */
    }
  if (register_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11840; /* *cond_uqshlvnx2di_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11848; /* *cond_uqshlvnx2di_any */
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11713; /* *cond_urshlvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11754; /* *cond_urshlvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11794; /* *cond_urshlvnx2di_any */
}

 int
recog_222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11688; /* *cond_urhaddvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11733; /* *cond_urhaddvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11773; /* *cond_urhaddvnx8hi_any */
}

 int
recog_231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11674; /* *cond_uhsubvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11721; /* *cond_uhsubvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11761; /* *cond_uhsubvnx16qi_any */
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11694; /* *cond_srhaddvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11738; /* *cond_srhaddvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11778; /* *cond_srhaddvnx4si_any */
}

 int
recog_251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11668; /* *cond_shsubvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11716; /* *cond_shsubvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11756; /* *cond_shsubvnx16qi_any */
}

 int
recog_261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1061 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8534; /* *cond_fmaxvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8680; /* *cond_fmaxvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8784; /* *cond_fmaxvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8547; /* *cond_fmaxvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8693; /* *cond_fmaxvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8797; /* *cond_fmaxvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8560; /* *cond_fmaxvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8706; /* *cond_fmaxvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8810; /* *cond_fmaxvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8573; /* *cond_fmaxvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8719; /* *cond_fmaxvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8823; /* *cond_fmaxvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8634; /* *cond_fmaxvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8884; /* *cond_fmaxvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8641; /* *cond_fmaxvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8891; /* *cond_fmaxvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8648; /* *cond_fmaxvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8898; /* *cond_fmaxvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8586; /* *cond_fmaxvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8732; /* *cond_fmaxvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8836; /* *cond_fmaxvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8599; /* *cond_fmaxvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8745; /* *cond_fmaxvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8849; /* *cond_fmaxvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8612; /* *cond_fmaxvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8758; /* *cond_fmaxvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8862; /* *cond_fmaxvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8625; /* *cond_fmaxvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8771; /* *cond_fmaxvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8875; /* *cond_fmaxvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8655; /* *cond_fmaxvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8905; /* *cond_fmaxvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8662; /* *cond_fmaxvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8912; /* *cond_fmaxvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8669; /* *cond_fmaxvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8919; /* *cond_fmaxvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_270 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      x2 = XEXP (x1, 1);
      if (pattern1128 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9199; /* *cond_fnmavnx16qi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9209; /* *cond_fnmavnx16qi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx16QImode)
          || !
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9219; /* *cond_fnmavnx16qi_any */

    case E_VNx8QImode:
      x2 = XEXP (x1, 1);
      if (pattern1128 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9200; /* *cond_fnmavnx8qi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9210; /* *cond_fnmavnx8qi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8QImode)
          || !
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9220; /* *cond_fnmavnx8qi_any */

    case E_VNx4QImode:
      x2 = XEXP (x1, 1);
      if (pattern1128 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9201; /* *cond_fnmavnx4qi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9211; /* *cond_fnmavnx4qi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4QImode)
          || !
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9221; /* *cond_fnmavnx4qi_any */

    case E_VNx2QImode:
      x2 = XEXP (x1, 1);
      if (pattern1128 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9202; /* *cond_fnmavnx2qi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9212; /* *cond_fnmavnx2qi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2QImode)
          || !
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9222; /* *cond_fnmavnx2qi_any */

    case E_VNx8HImode:
      x2 = XEXP (x1, 1);
      if (pattern1128 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9203; /* *cond_fnmavnx8hi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9213; /* *cond_fnmavnx8hi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HImode)
          || !
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9223; /* *cond_fnmavnx8hi_any */

    case E_VNx4HImode:
      x2 = XEXP (x1, 1);
      if (pattern1128 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9204; /* *cond_fnmavnx4hi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9214; /* *cond_fnmavnx4hi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4HImode)
          || !
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9224; /* *cond_fnmavnx4hi_any */

    case E_VNx2HImode:
      x2 = XEXP (x1, 1);
      if (pattern1128 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9205; /* *cond_fnmavnx2hi_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9215; /* *cond_fnmavnx2hi_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2HImode)
          || !
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9225; /* *cond_fnmavnx2hi_any */

    case E_VNx4SImode:
      x2 = XEXP (x1, 1);
      if (pattern1128 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9206; /* *cond_fnmavnx4si_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9216; /* *cond_fnmavnx4si_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SImode)
          || !
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9226; /* *cond_fnmavnx4si_any */

    case E_VNx2SImode:
      x2 = XEXP (x1, 1);
      if (pattern1128 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9207; /* *cond_fnmavnx2si_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9217; /* *cond_fnmavnx2si_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2SImode)
          || !
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9227; /* *cond_fnmavnx2si_any */

    case E_VNx2DImode:
      x2 = XEXP (x1, 1);
      if (pattern1128 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 7222 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9208; /* *cond_fnmavnx2di_2 */
      if (rtx_equal_p (x3, operands[4])
          && 
#line 7241 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9218; /* *cond_fnmavnx2di_4 */
      operands[5] = x3;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DImode)
          || !
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9228; /* *cond_fnmavnx2di_any */

    default:
      return -1;
    }
}

 int
recog_276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern612 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7482; /* *cond_ashrvnx16qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7652; /* *cond_ashrvnx16qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7822; /* *cond_ashrvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7499; /* *cond_ashrvnx8qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7669; /* *cond_ashrvnx8qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7839; /* *cond_ashrvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7516; /* *cond_ashrvnx4qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7686; /* *cond_ashrvnx4qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7856; /* *cond_ashrvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7533; /* *cond_ashrvnx2qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7703; /* *cond_ashrvnx2qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7873; /* *cond_ashrvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7550; /* *cond_ashrvnx8hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7720; /* *cond_ashrvnx8hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7890; /* *cond_ashrvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7567; /* *cond_ashrvnx4hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7737; /* *cond_ashrvnx4hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7907; /* *cond_ashrvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7584; /* *cond_ashrvnx2hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7754; /* *cond_ashrvnx2hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7924; /* *cond_ashrvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7601; /* *cond_ashrvnx4si_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7771; /* *cond_ashrvnx4si_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7941; /* *cond_ashrvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7618; /* *cond_ashrvnx2si_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7788; /* *cond_ashrvnx2si_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7958; /* *cond_ashrvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7635; /* *cond_ashrvnx2di_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7805; /* *cond_ashrvnx2di_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7975; /* *cond_ashrvnx2di_any */

    case 10:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8291; /* *cond_ashrvnx16qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8321; /* *cond_ashrvnx16qi_any_const */

    case 11:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8294; /* *cond_ashrvnx8qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8324; /* *cond_ashrvnx8qi_any_const */

    case 12:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8297; /* *cond_ashrvnx4qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8327; /* *cond_ashrvnx4qi_any_const */

    case 13:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8300; /* *cond_ashrvnx2qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8330; /* *cond_ashrvnx2qi_any_const */

    case 14:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8303; /* *cond_ashrvnx8hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8333; /* *cond_ashrvnx8hi_any_const */

    case 15:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8306; /* *cond_ashrvnx4hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8336; /* *cond_ashrvnx4hi_any_const */

    case 16:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8309; /* *cond_ashrvnx2hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8339; /* *cond_ashrvnx2hi_any_const */

    case 17:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8312; /* *cond_ashrvnx4si_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8342; /* *cond_ashrvnx4si_any_const */

    case 18:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8315; /* *cond_ashrvnx2si_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8345; /* *cond_ashrvnx2si_any_const */

    case 19:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8318; /* *cond_ashrvnx2di_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8348; /* *cond_ashrvnx2di_any_const */

    default:
      return -1;
    }
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern612 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7483; /* *cond_lshrvnx16qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7653; /* *cond_lshrvnx16qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7823; /* *cond_lshrvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7500; /* *cond_lshrvnx8qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7670; /* *cond_lshrvnx8qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7840; /* *cond_lshrvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7517; /* *cond_lshrvnx4qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7687; /* *cond_lshrvnx4qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7857; /* *cond_lshrvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7534; /* *cond_lshrvnx2qi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7704; /* *cond_lshrvnx2qi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7874; /* *cond_lshrvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7551; /* *cond_lshrvnx8hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7721; /* *cond_lshrvnx8hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7891; /* *cond_lshrvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7568; /* *cond_lshrvnx4hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7738; /* *cond_lshrvnx4hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7908; /* *cond_lshrvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7585; /* *cond_lshrvnx2hi_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7755; /* *cond_lshrvnx2hi_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7925; /* *cond_lshrvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7602; /* *cond_lshrvnx4si_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7772; /* *cond_lshrvnx4si_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7942; /* *cond_lshrvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7619; /* *cond_lshrvnx2si_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7789; /* *cond_lshrvnx2si_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7959; /* *cond_lshrvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7636; /* *cond_lshrvnx2di_2 */
      if (rtx_equal_p (x3, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7806; /* *cond_lshrvnx2di_3 */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7976; /* *cond_lshrvnx2di_any */

    case 10:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8292; /* *cond_lshrvnx16qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8322; /* *cond_lshrvnx16qi_any_const */

    case 11:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8295; /* *cond_lshrvnx8qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8325; /* *cond_lshrvnx8qi_any_const */

    case 12:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8298; /* *cond_lshrvnx4qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8328; /* *cond_lshrvnx4qi_any_const */

    case 13:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8301; /* *cond_lshrvnx2qi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8331; /* *cond_lshrvnx2qi_any_const */

    case 14:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8304; /* *cond_lshrvnx8hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8334; /* *cond_lshrvnx8hi_any_const */

    case 15:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8307; /* *cond_lshrvnx4hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8337; /* *cond_lshrvnx4hi_any_const */

    case 16:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8310; /* *cond_lshrvnx2hi_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8340; /* *cond_lshrvnx2hi_any_const */

    case 17:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8313; /* *cond_lshrvnx4si_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8343; /* *cond_lshrvnx4si_any_const */

    case 18:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8316; /* *cond_lshrvnx2si_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8346; /* *cond_lshrvnx2si_any_const */

    case 19:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 4937 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8319; /* *cond_lshrvnx2di_2_const */
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8349; /* *cond_lshrvnx2di_any_const */

    default:
      return -1;
    }
}

 int
recog_286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern734 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7480; /* *cond_uminvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7650; /* *cond_uminvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7820; /* *cond_uminvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7497; /* *cond_uminvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7667; /* *cond_uminvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7837; /* *cond_uminvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7514; /* *cond_uminvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7684; /* *cond_uminvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7854; /* *cond_uminvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7531; /* *cond_uminvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7701; /* *cond_uminvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7871; /* *cond_uminvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7548; /* *cond_uminvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7718; /* *cond_uminvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7888; /* *cond_uminvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7565; /* *cond_uminvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7735; /* *cond_uminvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7905; /* *cond_uminvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7582; /* *cond_uminvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7752; /* *cond_uminvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7922; /* *cond_uminvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7599; /* *cond_uminvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7769; /* *cond_uminvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7939; /* *cond_uminvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7616; /* *cond_uminvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7786; /* *cond_uminvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7956; /* *cond_uminvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7633; /* *cond_uminvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7803; /* *cond_uminvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7973; /* *cond_uminvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_296 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern610 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6734; /* *cond_clrsbvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6824; /* *cond_clrsbvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6743; /* *cond_clrsbvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6833; /* *cond_clrsbvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6752; /* *cond_clrsbvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6842; /* *cond_clrsbvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6761; /* *cond_clrsbvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6851; /* *cond_clrsbvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6770; /* *cond_clrsbvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6860; /* *cond_clrsbvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6779; /* *cond_clrsbvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6869; /* *cond_clrsbvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6788; /* *cond_clrsbvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6878; /* *cond_clrsbvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6797; /* *cond_clrsbvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6887; /* *cond_clrsbvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6806; /* *cond_clrsbvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6896; /* *cond_clrsbvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6815; /* *cond_clrsbvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !
#line 3250 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6905; /* *cond_clrsbvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_306 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!aarch64_maskload_else_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      if (pattern868 (x3, 
E_VNx32QImode, 
E_VNx16BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5757; /* vec_mask_load_lanesvnx32qivnx16qi */

    case E_VNx16HImode:
      if (pattern868 (x3, 
E_VNx16HImode, 
E_VNx8BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5758; /* vec_mask_load_lanesvnx16hivnx8hi */

    case E_VNx8SImode:
      if (pattern868 (x3, 
E_VNx8SImode, 
E_VNx4BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5759; /* vec_mask_load_lanesvnx8sivnx4si */

    case E_VNx4DImode:
      if (pattern868 (x3, 
E_VNx4DImode, 
E_VNx2BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5760; /* vec_mask_load_lanesvnx4divnx2di */

    case E_VNx16BFmode:
      if (pattern868 (x3, 
E_VNx16BFmode, 
E_VNx8BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5761; /* vec_mask_load_lanesvnx16bfvnx8bf */

    case E_VNx16HFmode:
      if (pattern868 (x3, 
E_VNx16HFmode, 
E_VNx8BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5762; /* vec_mask_load_lanesvnx16hfvnx8hf */

    case E_VNx8SFmode:
      if (pattern868 (x3, 
E_VNx8SFmode, 
E_VNx4BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5763; /* vec_mask_load_lanesvnx8sfvnx4sf */

    case E_VNx4DFmode:
      if (pattern868 (x3, 
E_VNx4DFmode, 
E_VNx2BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5764; /* vec_mask_load_lanesvnx4dfvnx2df */

    case E_VNx48QImode:
      if (pattern868 (x3, 
E_VNx48QImode, 
E_VNx16BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5765; /* vec_mask_load_lanesvnx48qivnx16qi */

    case E_VNx24HImode:
      if (pattern868 (x3, 
E_VNx24HImode, 
E_VNx8BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5766; /* vec_mask_load_lanesvnx24hivnx8hi */

    case E_VNx12SImode:
      if (pattern868 (x3, 
E_VNx12SImode, 
E_VNx4BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5767; /* vec_mask_load_lanesvnx12sivnx4si */

    case E_VNx6DImode:
      if (pattern868 (x3, 
E_VNx6DImode, 
E_VNx2BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5768; /* vec_mask_load_lanesvnx6divnx2di */

    case E_VNx24BFmode:
      if (pattern868 (x3, 
E_VNx24BFmode, 
E_VNx8BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5769; /* vec_mask_load_lanesvnx24bfvnx8bf */

    case E_VNx24HFmode:
      if (pattern868 (x3, 
E_VNx24HFmode, 
E_VNx8BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5770; /* vec_mask_load_lanesvnx24hfvnx8hf */

    case E_VNx12SFmode:
      if (pattern868 (x3, 
E_VNx12SFmode, 
E_VNx4BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5771; /* vec_mask_load_lanesvnx12sfvnx4sf */

    case E_VNx6DFmode:
      if (pattern868 (x3, 
E_VNx6DFmode, 
E_VNx2BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5772; /* vec_mask_load_lanesvnx6dfvnx2df */

    case E_VNx64QImode:
      if (pattern868 (x3, 
E_VNx64QImode, 
E_VNx16BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5773; /* vec_mask_load_lanesvnx64qivnx16qi */

    case E_VNx32HImode:
      if (pattern868 (x3, 
E_VNx32HImode, 
E_VNx8BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5774; /* vec_mask_load_lanesvnx32hivnx8hi */

    case E_VNx16SImode:
      if (pattern868 (x3, 
E_VNx16SImode, 
E_VNx4BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5775; /* vec_mask_load_lanesvnx16sivnx4si */

    case E_VNx8DImode:
      if (pattern868 (x3, 
E_VNx8DImode, 
E_VNx2BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5776; /* vec_mask_load_lanesvnx8divnx2di */

    case E_VNx32BFmode:
      if (pattern868 (x3, 
E_VNx32BFmode, 
E_VNx8BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5777; /* vec_mask_load_lanesvnx32bfvnx8bf */

    case E_VNx32HFmode:
      if (pattern868 (x3, 
E_VNx32HFmode, 
E_VNx8BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5778; /* vec_mask_load_lanesvnx32hfvnx8hf */

    case E_VNx16SFmode:
      if (pattern868 (x3, 
E_VNx16SFmode, 
E_VNx4BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5779; /* vec_mask_load_lanesvnx16sfvnx4sf */

    case E_VNx8DFmode:
      if (pattern868 (x3, 
E_VNx8DFmode, 
E_VNx2BImode) != 0
          || !
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5780; /* vec_mask_load_lanesvnx8dfvnx2df */

    default:
      return -1;
    }
}

 int
recog_314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 5643 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3516; /* aarch64_sqrdmlahv4hi */

    case 1:
      if (!
#line 5643 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3522; /* aarch64_sqrdmlahv8hi */

    case 2:
      if (!
#line 5643 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3524; /* aarch64_sqrdmlahv2si */

    case 3:
      if (!
#line 5643 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3530; /* aarch64_sqrdmlahv4si */

    case 4:
      if (!
#line 5643 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3532; /* aarch64_sqrdmlahhi */

    case 5:
      if (!
#line 5643 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3534; /* aarch64_sqrdmlahsi */

    case 6:
      if (!
#line 1451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11881; /* aarch64_sve_sqrdmlahvnx16qi */

    case 7:
      if (!
#line 1451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11889; /* aarch64_sve_sqrdmlahvnx8hi */

    case 8:
      if (!
#line 1451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11897; /* aarch64_sve_sqrdmlahvnx4si */

    case 9:
      if (!
#line 1451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11905; /* aarch64_sve_sqrdmlahvnx2di */

    case 10:
      if (!
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3536; /* aarch64_sqrdmlah_lanev4hi */

    case 11:
      if (!
#line 5697 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3556; /* aarch64_sqrdmlah_laneqv4hi */

    case 12:
      if (!
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3542; /* aarch64_sqrdmlah_lanev8hi */

    case 13:
      if (!
#line 5697 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3562; /* aarch64_sqrdmlah_laneqv8hi */

    case 14:
      if (!
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3544; /* aarch64_sqrdmlah_lanev2si */

    case 15:
      if (!
#line 5697 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3564; /* aarch64_sqrdmlah_laneqv2si */

    case 16:
      if (!
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3550; /* aarch64_sqrdmlah_lanev4si */

    case 17:
      if (!
#line 5697 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3570; /* aarch64_sqrdmlah_laneqv4si */

    case 18:
      if (!
#line 5677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3552; /* aarch64_sqrdmlah_lanehi */

    case 19:
      if (!
#line 5715 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3572; /* aarch64_sqrdmlah_laneqhi */

    case 20:
      if (!
#line 5677 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3554; /* aarch64_sqrdmlah_lanesi */

    case 21:
      if (!
#line 5715 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3574; /* aarch64_sqrdmlah_laneqsi */

    case 22:
      if (!
#line 1468 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11907; /* aarch64_sve_sqrdmlah_lane_vnx8hi */

    case 23:
      if (!
#line 1468 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11909; /* aarch64_sve_sqrdmlah_lane_vnx4si */

    case 24:
      if (!
#line 1468 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11911; /* aarch64_sve_sqrdmlah_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_323 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9972; /* while_ultsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9982; /* while_ultdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9992; /* while_ultsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10002; /* while_ultdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10012; /* while_ultsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10022; /* while_ultdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10032; /* while_ultsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10042; /* while_ultdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_332 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern187 (x1))
    {
    case 0:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11191; /* aarch64_ldnt1vnx32qi */

    case 1:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11193; /* aarch64_ldnt1vnx16hi */

    case 2:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11195; /* aarch64_ldnt1vnx8si */

    case 3:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11197; /* aarch64_ldnt1vnx4di */

    case 4:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11199; /* aarch64_ldnt1vnx16bf */

    case 5:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11201; /* aarch64_ldnt1vnx16hf */

    case 6:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11203; /* aarch64_ldnt1vnx8sf */

    case 7:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11205; /* aarch64_ldnt1vnx4df */

    case 8:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11207; /* aarch64_ldnt1vnx64qi */

    case 9:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11209; /* aarch64_ldnt1vnx32hi */

    case 10:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11211; /* aarch64_ldnt1vnx16si */

    case 11:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11213; /* aarch64_ldnt1vnx8di */

    case 12:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11215; /* aarch64_ldnt1vnx32bf */

    case 13:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11217; /* aarch64_ldnt1vnx32hf */

    case 14:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11219; /* aarch64_ldnt1vnx16sf */

    case 15:
      if (!
#line 275 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11221; /* aarch64_ldnt1vnx8df */

    default:
      return -1;
    }
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_VNx16BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx16BImode)
          || !
#line 9298 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10816; /* aarch64_sve_trn1_convvnx16bi */

    case E_VNx8BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx8BImode)
          || !
#line 9298 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10817; /* aarch64_sve_trn1_convvnx8bi */

    case E_VNx4BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx4BImode)
          || !
#line 9298 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10818; /* aarch64_sve_trn1_convvnx4bi */

    case E_VNx2BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx2BImode)
          || !
#line 9298 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10819; /* aarch64_sve_trn1_convvnx2bi */

    default:
      return -1;
    }
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern116 (x3, 
E_VNx16BImode, 
E_VNx16QImode) != 0
          || !
#line 165 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11150; /* aarch64_pmov_lane_to_vnx16qi */

    case E_VNx8HImode:
      if (pattern116 (x3, 
E_VNx8BImode, 
E_VNx8HImode) != 0
          || !
#line 165 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11151; /* aarch64_pmov_lane_to_vnx8hi */

    case E_VNx4SImode:
      if (pattern116 (x3, 
E_VNx4BImode, 
E_VNx4SImode) != 0
          || !
#line 165 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11152; /* aarch64_pmov_lane_to_vnx4si */

    case E_VNx2DImode:
      if (pattern116 (x3, 
E_VNx2BImode, 
E_VNx2DImode) != 0
          || !
#line 165 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11153; /* aarch64_pmov_lane_to_vnx2di */

    default:
      return -1;
    }
}

 int
recog_354 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16QImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!aligned_register_operand (operands[2], E_VNx8SFmode)
      || !
#line 3408 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
    return -1;
  return 12658; /* aarch64_sve_cvtntvnx16qi */
}

 int
recog_358 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      if (!
#line 3016 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12570; /* aarch64_sve_sqrdcmlah90vnx16qi */

    case 1:
      if (!
#line 3016 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12578; /* aarch64_sve_sqrdcmlah90vnx8hi */

    case 2:
      if (!
#line 3016 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12586; /* aarch64_sve_sqrdcmlah90vnx4si */

    case 3:
      if (!
#line 3016 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12594; /* aarch64_sve_sqrdcmlah90vnx2di */

    case 4:
      if (!
#line 3033 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12602; /* aarch64_sqrdcmlah90_lane_vnx8hi */

    case 5:
      if (!
#line 3033 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12610; /* aarch64_sqrdcmlah90_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_366 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx4SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx4SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_VNx2BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[2] = x6;
  if (!register_operand (operands[2], E_VNx2DFmode)
      || !
#line 3246 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return -1;
  return 12645; /* aarch64_pred_fcvtxvnx4sf */
}

 int
recog_374 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!
#line 2821 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12499; /* aarch64_pred_umaxpvnx16qi */

    case 1:
      if (!
#line 2821 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12504; /* aarch64_pred_umaxpvnx8hi */

    case 2:
      if (!
#line 2821 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12509; /* aarch64_pred_umaxpvnx4si */

    case 3:
      if (!
#line 2821 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12514; /* aarch64_pred_umaxpvnx2di */

    default:
      return -1;
    }
}

 int
recog_382 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      if (!
#line 1451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11876; /* aarch64_sve_adcltvnx16qi */

    case 1:
      if (!
#line 1451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11884; /* aarch64_sve_adcltvnx8hi */

    case 2:
      if (!
#line 1451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11892; /* aarch64_sve_adcltvnx4si */

    case 3:
      if (!
#line 1451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11900; /* aarch64_sve_adcltvnx2di */

    default:
      return -1;
    }
}

 int
recog_390 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern169 (x1))
    {
    case 0:
      if (!(
#line 7684 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9352; /* aarch64_fnma_lane_vnx8bf */

    case 1:
      if (!
#line 7684 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9354; /* aarch64_fnma_lane_vnx8hf */

    case 2:
      if (!
#line 7684 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9356; /* aarch64_fnma_lane_vnx4sf */

    case 3:
      if (!
#line 7684 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9358; /* aarch64_fnma_lane_vnx2df */

    default:
      return -1;
    }
}

 int
recog_397 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CC_NZCmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  if (pnum_clobbers != NULL)
    {
      res = recog_395 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!aarch64_sve_ptrue_flag (x3, E_SImode))
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_CC_NZCmode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  if (!register_operand (x5, E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x6))
    {
    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x5;
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 86
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          operands[2] = x3;
          if (GET_MODE (x6) != E_VNx16BImode)
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return -1;
          x9 = XEXP (x6, 1);
          if (!rtx_equal_p (x9, operands[1])
              || !
#line 1182 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          *pnum_clobbers = 1;
          return 5733; /* *aarch64_rdffr_z_ptest */

        case AND:
          switch (pattern1174 (x2))
            {
            case 0:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9089; /* *andvnx16bi3_ptest */

            case 1:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9092; /* *andvnx8bi3_ptest */

            case 2:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9095; /* *andvnx4bi3_ptest */

            case 3:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9098; /* *andvnx2bi3_ptest */

            case 4:
              if (!
#line 6911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9117; /* *bicvnx16bi3_ptest */

            case 5:
              if (!
#line 6911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9119; /* *bicvnx8bi3_ptest */

            case 6:
              if (!
#line 6911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9121; /* *bicvnx4bi3_ptest */

            case 7:
              if (!
#line 6911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9123; /* *bicvnx2bi3_ptest */

            case 8:
              if (!
#line 6987 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9141; /* *norvnx16bi3_ptest */

            case 9:
              if (!
#line 6987 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9143; /* *norvnx8bi3_ptest */

            case 10:
              if (!
#line 6987 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9145; /* *norvnx4bi3_ptest */

            case 11:
              if (!
#line 6987 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9147; /* *norvnx2bi3_ptest */

            default:
              return -1;
            }

        case IOR:
          switch (pattern1174 (x2))
            {
            case 0:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9090; /* *iorvnx16bi3_ptest */

            case 1:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9093; /* *iorvnx8bi3_ptest */

            case 2:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9096; /* *iorvnx4bi3_ptest */

            case 3:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9099; /* *iorvnx2bi3_ptest */

            case 4:
              if (!
#line 6911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9118; /* *ornvnx16bi3_ptest */

            case 5:
              if (!
#line 6911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9120; /* *ornvnx8bi3_ptest */

            case 6:
              if (!
#line 6911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9122; /* *ornvnx4bi3_ptest */

            case 7:
              if (!
#line 6911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9124; /* *ornvnx2bi3_ptest */

            case 8:
              if (!
#line 6987 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9142; /* *nandvnx16bi3_ptest */

            case 9:
              if (!
#line 6987 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9144; /* *nandvnx8bi3_ptest */

            case 10:
              if (!
#line 6987 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9146; /* *nandvnx4bi3_ptest */

            case 11:
              if (!
#line 6987 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9148; /* *nandvnx2bi3_ptest */

            default:
              return -1;
            }

        case XOR:
          x8 = XVECEXP (x2, 0, 1);
          operands[4] = x8;
          operands[5] = x3;
          x10 = XEXP (x7, 0);
          operands[2] = x10;
          x11 = XEXP (x7, 1);
          operands[3] = x11;
          x9 = XEXP (x6, 1);
          if (!rtx_equal_p (x9, operands[4]))
            return -1;
          switch (pattern1171 (x6))
            {
            case 0:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9091; /* *xorvnx16bi3_ptest */

            case 1:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9094; /* *xorvnx8bi3_ptest */

            case 2:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9097; /* *xorvnx4bi3_ptest */

            case 3:
              if (!
#line 6837 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9100; /* *xorvnx2bi3_ptest */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_396 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
      operands[3] = x6;
      operands[0] = x5;
      x8 = XVECEXP (x2, 0, 1);
      operands[1] = x8;
      operands[2] = x3;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[3], E_VNx16BImode)
              || !
#line 8879 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10323; /* aarch64_ptestvnx16bi */

        case E_VNx8BImode:
          if (!register_operand (operands[3], E_VNx8BImode)
              || !
#line 8879 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10324; /* aarch64_ptestvnx8bi */

        case E_VNx4BImode:
          if (!register_operand (operands[3], E_VNx4BImode)
              || !
#line 8879 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10325; /* aarch64_ptestvnx4bi */

        case E_VNx2BImode:
          if (!register_operand (operands[3], E_VNx2BImode)
              || !
#line 8879 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10326; /* aarch64_ptestvnx2bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_413 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern948 (x3, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 5198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8481; /* aarch64_pred_fscalevnx8hf */

    case E_VNx4SFmode:
      if (pattern948 (x3, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 5198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8482; /* aarch64_pred_fscalevnx4sf */

    case E_VNx2DFmode:
      if (pattern948 (x3, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 5198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8483; /* aarch64_pred_fscalevnx2df */

    case E_HFmode:
      if (pattern948 (x3, 
E_HImode, 
E_HFmode, 
E_VNx8BImode) != 0
          || !
#line 5198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8484; /* aarch64_pred_fscalehf */

    case E_SFmode:
      if (pattern948 (x3, 
E_SImode, 
E_SFmode, 
E_VNx4BImode) != 0
          || !
#line 5198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8485; /* aarch64_pred_fscalesf */

    case E_DFmode:
      if (pattern948 (x3, 
E_DImode, 
E_DFmode, 
E_VNx2BImode) != 0
          || !
#line 5198 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8486; /* aarch64_pred_fscaledf */

    default:
      return -1;
    }
}

 int
recog_418 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern220 (x1))
    {
    case 0:
      if (!
#line 8512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10212; /* aarch64_pred_fcmgevnx8hf */

    case 1:
      if (!
#line 8512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10218; /* aarch64_pred_fcmgevnx4sf */

    case 2:
      if (!
#line 8512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10224; /* aarch64_pred_fcmgevnx2df */

    case 3:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 2);
      x4 = XVECEXP (x3, 0, 1);
      if (XWINT (x4, 0) == 0LL)
        {
          switch (pattern1263 (x2))
            {
            case 0:
              if (
#line 8785 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10295; /* *aarch64_pred_facgevnx8hf_relaxed */
              break;

            case 1:
              if (
#line 8785 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10299; /* *aarch64_pred_facgevnx4sf_relaxed */
              break;

            case 2:
              if (
#line 8785 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10303; /* *aarch64_pred_facgevnx2df_relaxed */
              break;

            default:
              break;
            }
        }
      operands[5] = x4;
      switch (pattern1264 (x2))
        {
        case 0:
          if (!
#line 8811 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10307; /* *aarch64_pred_facgevnx8hf_strict */

        case 1:
          if (!
#line 8811 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10311; /* *aarch64_pred_facgevnx4sf_strict */

        case 2:
          if (!
#line 8811 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10315; /* *aarch64_pred_facgevnx2df_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_428 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern261 (x1))
    {
    case 0:
      if (!
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13985; /* aarch64_sme_fmlavnx8sfvnx8sf */

    case 1:
      if (!
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13987; /* aarch64_sme_fmlavnx16sfvnx16sf */

    case 2:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13989; /* aarch64_sme_fmlavnx4dfvnx4df */

    case 3:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13991; /* aarch64_sme_fmlavnx8dfvnx8df */

    case 4:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13993; /* aarch64_sme_fmlavnx16hfvnx16hf */

    case 5:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13995; /* aarch64_sme_fmlavnx32hfvnx32hf */

    case 6:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13997; /* aarch64_sme_fmlavnx16bfvnx16bf */

    case 7:
      if (!(
#line 1867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13999; /* aarch64_sme_fmlavnx32bfvnx32bf */

    case 8:
      if (!
#line 1966 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14081; /* aarch64_sme_fmlavnx4sivnx8bf */

    case 9:
      if (!
#line 1966 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14083; /* aarch64_sme_fmlavnx4sivnx8hf */

    case 10:
      if (!
#line 1996 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14089; /* aarch64_sme_fmlavnx4sivnx16bf */

    case 11:
      if (!
#line 1996 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14091; /* aarch64_sme_fmlavnx4sivnx32bf */

    case 12:
      if (!
#line 1996 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14093; /* aarch64_sme_fmlavnx4sivnx16hf */

    case 13:
      if (!
#line 1996 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14095; /* aarch64_sme_fmlavnx4sivnx32hf */

    case 14:
      if (!
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14017; /* aarch64_sme_single_fmlavnx8sfvnx8sf */

    case 15:
      if (!
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14019; /* aarch64_sme_single_fmlavnx16sfvnx16sf */

    case 16:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14021; /* aarch64_sme_single_fmlavnx4dfvnx4df */

    case 17:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14023; /* aarch64_sme_single_fmlavnx8dfvnx8df */

    case 18:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14025; /* aarch64_sme_single_fmlavnx16hfvnx16hf */

    case 19:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14027; /* aarch64_sme_single_fmlavnx32hfvnx32hf */

    case 20:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14029; /* aarch64_sme_single_fmlavnx16bfvnx16bf */

    case 21:
      if (!(
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14031; /* aarch64_sme_single_fmlavnx32bfvnx32bf */

    case 22:
      if (!
#line 2027 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14105; /* aarch64_sme_single_fmlavnx4sivnx16bf */

    case 23:
      if (!
#line 2027 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14107; /* aarch64_sme_single_fmlavnx4sivnx32bf */

    case 24:
      if (!
#line 2027 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14109; /* aarch64_sme_single_fmlavnx4sivnx16hf */

    case 25:
      if (!
#line 2027 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14111; /* aarch64_sme_single_fmlavnx4sivnx32hf */

    case 26:
      if (!
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14049; /* aarch64_sme_lane_fmlavnx8sfvnx8sf */

    case 27:
      if (!
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14051; /* aarch64_sme_lane_fmlavnx16sfvnx16sf */

    case 28:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14053; /* aarch64_sme_lane_fmlavnx4dfvnx4df */

    case 29:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14055; /* aarch64_sme_lane_fmlavnx8dfvnx8df */

    case 30:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14057; /* aarch64_sme_lane_fmlavnx16hfvnx16hf */

    case 31:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14059; /* aarch64_sme_lane_fmlavnx32hfvnx32hf */

    case 32:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14061; /* aarch64_sme_lane_fmlavnx16bfvnx16bf */

    case 33:
      if (!(
#line 1926 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14063; /* aarch64_sme_lane_fmlavnx32bfvnx32bf */

    case 34:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14121; /* aarch64_sme_lane_fmlavnx4sivnx8bf */

    case 35:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14123; /* aarch64_sme_lane_fmlavnx4sivnx16bf */

    case 36:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14125; /* aarch64_sme_lane_fmlavnx4sivnx32bf */

    case 37:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14127; /* aarch64_sme_lane_fmlavnx4sivnx8hf */

    case 38:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14129; /* aarch64_sme_lane_fmlavnx4sivnx16hf */

    case 39:
      if (!
#line 2061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14131; /* aarch64_sme_lane_fmlavnx4sivnx32hf */

    case 40:
      if (!
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14001; /* *aarch64_sme_fmlavnx8sfvnx8sf_plus */

    case 41:
      if (!
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14003; /* *aarch64_sme_fmlavnx16sfvnx16sf_plus */

    case 42:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14005; /* *aarch64_sme_fmlavnx4dfvnx4df_plus */

    case 43:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14007; /* *aarch64_sme_fmlavnx8dfvnx8df_plus */

    case 44:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14009; /* *aarch64_sme_fmlavnx16hfvnx16hf_plus */

    case 45:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14011; /* *aarch64_sme_fmlavnx32hfvnx32hf_plus */

    case 46:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14013; /* *aarch64_sme_fmlavnx16bfvnx16bf_plus */

    case 47:
      if (!(
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14015; /* *aarch64_sme_fmlavnx32bfvnx32bf_plus */

    case 48:
      if (const_0_to_14_step_2_operand (operands[1], E_SImode))
        {
          switch (pattern1329 ())
            {
            case 0:
              if (
#line 1980 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 14085; /* *aarch64_sme_fmlavnx4sivnx8bf_plus */
              break;

            case 1:
              if (
#line 1980 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 14087; /* *aarch64_sme_fmlavnx4sivnx8hf_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1328 ())
        {
        case 0:
          if (!
#line 2010 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14097; /* *aarch64_sme_fmlavnx4sivnx16bf_plus */

        case 1:
          if (!
#line 2010 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14099; /* *aarch64_sme_fmlavnx4sivnx32bf_plus */

        case 2:
          if (!
#line 2010 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14101; /* *aarch64_sme_fmlavnx4sivnx16hf_plus */

        case 3:
          if (!
#line 2010 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14103; /* *aarch64_sme_fmlavnx4sivnx32hf_plus */

        default:
          return -1;
        }

    case 49:
      if (!
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14033; /* *aarch64_sme_single_fmlavnx8sfvnx8sf_plus */

    case 50:
      if (!
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14035; /* *aarch64_sme_single_fmlavnx16sfvnx16sf_plus */

    case 51:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14037; /* *aarch64_sme_single_fmlavnx4dfvnx4df_plus */

    case 52:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14039; /* *aarch64_sme_single_fmlavnx8dfvnx8df_plus */

    case 53:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14041; /* *aarch64_sme_single_fmlavnx16hfvnx16hf_plus */

    case 54:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14043; /* *aarch64_sme_single_fmlavnx32hfvnx32hf_plus */

    case 55:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14045; /* *aarch64_sme_single_fmlavnx16bfvnx16bf_plus */

    case 56:
      if (!(
#line 1910 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14047; /* *aarch64_sme_single_fmlavnx32bfvnx32bf_plus */

    case 57:
      if (!
#line 2042 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14113; /* *aarch64_sme_single_fmlavnx4sivnx16bf_plus */

    case 58:
      if (!
#line 2042 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14115; /* *aarch64_sme_single_fmlavnx4sivnx32bf_plus */

    case 59:
      if (!
#line 2042 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14117; /* *aarch64_sme_single_fmlavnx4sivnx16hf_plus */

    case 60:
      if (!
#line 2042 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14119; /* *aarch64_sme_single_fmlavnx4sivnx32hf_plus */

    case 61:
      if (!
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14065; /* *aarch64_sme_lane_fmlavnx8sfvnx8sf */

    case 62:
      if (!
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 14067; /* *aarch64_sme_lane_fmlavnx16sfvnx16sf */

    case 63:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14069; /* *aarch64_sme_lane_fmlavnx4dfvnx4df */

    case 64:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 14071; /* *aarch64_sme_lane_fmlavnx8dfvnx8df */

    case 65:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14073; /* *aarch64_sme_lane_fmlavnx16hfvnx16hf */

    case 66:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 14075; /* *aarch64_sme_lane_fmlavnx32hfvnx32hf */

    case 67:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14077; /* *aarch64_sme_lane_fmlavnx16bfvnx16bf */

    case 68:
      if (!(
#line 1943 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 14079; /* *aarch64_sme_lane_fmlavnx32bfvnx32bf */

    case 69:
      if (const_0_to_14_step_2_operand (operands[1], E_SImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          switch (pattern1358 (x3))
            {
            case 0:
              if (
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 14133; /* *aarch64_sme_lane_fmlavnx4sivnx8bf */
              break;

            case 1:
              if (
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 14139; /* *aarch64_sme_lane_fmlavnx4sivnx8hf */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1357 (x3))
        {
        case 0:
          if (!
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14135; /* *aarch64_sme_lane_fmlavnx4sivnx16bf */

        case 1:
          if (!
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14137; /* *aarch64_sme_lane_fmlavnx4sivnx32bf */

        case 2:
          if (!
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14141; /* *aarch64_sme_lane_fmlavnx4sivnx16hf */

        case 3:
          if (!
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14143; /* *aarch64_sme_lane_fmlavnx4sivnx32hf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_443 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  if (pattern223 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 4);
  operands[3] = x6;
  x7 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      x8 = XVECEXP (x2, 0, 5);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[4] = x8;
          switch (GET_MODE (operands[5]))
            {
            case E_VNx4BImode:
              if (!register_operand (operands[5], E_VNx4BImode)
                  || !register_operand (operands[1], E_VNx4SImode))
                return -1;
              if (aarch64_sve_gather_offset_b (operands[0], E_DImode)
                  && aarch64_gather_scale_operand_b (operands[3], E_DImode)
                  && register_operand (operands[4], E_VNx4QImode)
                  && 
#line 2437 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6344; /* mask_scatter_storevnx4qivnx4si */
              if (aarch64_sve_gather_offset_h (operands[0], E_DImode)
                  && aarch64_gather_scale_operand_h (operands[3], E_DImode))
                {
                  switch (GET_MODE (operands[4]))
                    {
                    case E_VNx4HImode:
                      if (register_operand (operands[4], E_VNx4HImode)
                          && 
#line 2437 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                        return 6345; /* mask_scatter_storevnx4hivnx4si */
                      break;

                    case E_VNx4HFmode:
                      if (register_operand (operands[4], E_VNx4HFmode)
                          && 
#line 2437 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                        return 6346; /* mask_scatter_storevnx4hfvnx4si */
                      break;

                    case E_VNx4BFmode:
                      if (register_operand (operands[4], E_VNx4BFmode)
                          && 
#line 2437 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                        return 6347; /* mask_scatter_storevnx4bfvnx4si */
                      break;

                    default:
                      break;
                    }
                }
              if (!aarch64_sve_gather_offset_w (operands[0], E_DImode)
                  || !aarch64_gather_scale_operand_w (operands[3], E_DImode))
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_VNx4SImode:
                  if (!register_operand (operands[4], E_VNx4SImode)
                      || !
#line 2437 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6348; /* mask_scatter_storevnx4sivnx4si */

                case E_VNx4SFmode:
                  if (!register_operand (operands[4], E_VNx4SFmode)
                      || !
#line 2437 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6349; /* mask_scatter_storevnx4sfvnx4si */

                default:
                  return -1;
                }

            case E_VNx2BImode:
              if (!register_operand (operands[5], E_VNx2BImode)
                  || !register_operand (operands[1], E_VNx2DImode))
                return -1;
              if (aarch64_sve_gather_offset_b (operands[0], E_DImode)
                  && aarch64_gather_scale_operand_b (operands[3], E_DImode)
                  && register_operand (operands[4], E_VNx2QImode)
                  && 
#line 2460 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6350; /* mask_scatter_storevnx2qivnx2di */
              if (aarch64_sve_gather_offset_h (operands[0], E_DImode)
                  && aarch64_gather_scale_operand_h (operands[3], E_DImode))
                {
                  switch (pattern1320 ())
                    {
                    case 0:
                      if (
#line 2460 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                        return 6351; /* mask_scatter_storevnx2hivnx2di */
                      break;

                    case 1:
                      if (
#line 2460 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                        return 6352; /* mask_scatter_storevnx2hfvnx2di */
                      break;

                    case 2:
                      if (
#line 2460 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                        return 6353; /* mask_scatter_storevnx2bfvnx2di */
                      break;

                    default:
                      break;
                    }
                }
              if (aarch64_sve_gather_offset_w (operands[0], E_DImode)
                  && aarch64_gather_scale_operand_w (operands[3], E_DImode))
                {
                  switch (GET_MODE (operands[4]))
                    {
                    case E_VNx2SImode:
                      if (register_operand (operands[4], E_VNx2SImode)
                          && 
#line 2460 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                        return 6354; /* mask_scatter_storevnx2sivnx2di */
                      break;

                    case E_VNx2SFmode:
                      if (register_operand (operands[4], E_VNx2SFmode)
                          && 
#line 2460 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                        return 6355; /* mask_scatter_storevnx2sfvnx2di */
                      break;

                    default:
                      break;
                    }
                }
              if (!aarch64_sve_gather_offset_d (operands[0], E_DImode)
                  || !aarch64_gather_scale_operand_d (operands[3], E_DImode))
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_VNx2DImode:
                  if (!register_operand (operands[4], E_VNx2DImode)
                      || !
#line 2460 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6356; /* mask_scatter_storevnx2divnx2di */

                case E_VNx2DFmode:
                  if (!register_operand (operands[4], E_VNx2DFmode)
                      || !
#line 2460 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6357; /* mask_scatter_storevnx2dfvnx2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case TRUNCATE:
          x9 = XEXP (x8, 0);
          operands[4] = x9;
          switch (GET_MODE (operands[5]))
            {
            case E_VNx4BImode:
              if (!register_operand (operands[5], E_VNx4BImode)
                  || !register_operand (operands[1], E_VNx4SImode)
                  || !register_operand (operands[4], E_VNx4SImode))
                return -1;
              if (aarch64_sve_gather_offset_b (operands[0], E_DImode)
                  && aarch64_gather_scale_operand_b (operands[3], E_DImode)
                  && GET_MODE (x8) == E_VNx4QImode
                  && 
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6390; /* aarch64_scatter_store_truncvnx4qivnx4si */
              if (!aarch64_sve_gather_offset_h (operands[0], E_DImode)
                  || !aarch64_gather_scale_operand_h (operands[3], E_DImode)
                  || GET_MODE (x8) != E_VNx4HImode
                  || !
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6391; /* aarch64_scatter_store_truncvnx4hivnx4si */

            case E_VNx2BImode:
              if (!register_operand (operands[5], E_VNx2BImode)
                  || !register_operand (operands[1], E_VNx2DImode)
                  || !register_operand (operands[4], E_VNx2DImode))
                return -1;
              if (aarch64_sve_gather_offset_b (operands[0], E_DImode)
                  && aarch64_gather_scale_operand_b (operands[3], E_DImode)
                  && GET_MODE (x8) == E_VNx2QImode
                  && 
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6392; /* aarch64_scatter_store_truncvnx2qivnx2di */
              if (aarch64_sve_gather_offset_h (operands[0], E_DImode)
                  && aarch64_gather_scale_operand_h (operands[3], E_DImode)
                  && GET_MODE (x8) == E_VNx2HImode
                  && 
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6393; /* aarch64_scatter_store_truncvnx2hivnx2di */
              if (!aarch64_sve_gather_offset_w (operands[0], E_DImode)
                  || !aarch64_gather_scale_operand_w (operands[3], E_DImode)
                  || GET_MODE (x8) != E_VNx2SImode
                  || !
#line 2590 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6394; /* aarch64_scatter_store_truncvnx2sivnx2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern1132 (x7) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x10 = XVECEXP (x7, 0, 0);
      operands[6] = x10;
      x11 = XVECEXP (x7, 0, 1);
      if (GET_MODE (x11) != E_VNx2DImode)
        return -1;
      switch (pattern1313 (x2))
        {
        case 0:
          if (register_operand (operands[4], E_VNx2QImode)
              && aarch64_gather_scale_operand_b (operands[3], E_DImode)
              && 
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return 6358; /* *mask_scatter_storevnx2qivnx2di_sxtw_unpacked */
          if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
            {
              switch (pattern1320 ())
                {
                case 0:
                  if (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6360; /* *mask_scatter_storevnx2hivnx2di_sxtw_unpacked */
                  break;

                case 1:
                  if (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6362; /* *mask_scatter_storevnx2hfvnx2di_sxtw_unpacked */
                  break;

                case 2:
                  if (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6364; /* *mask_scatter_storevnx2bfvnx2di_sxtw_unpacked */
                  break;

                default:
                  break;
                }
            }
          if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_VNx2SImode:
                  if (register_operand (operands[4], E_VNx2SImode)
                      && 
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6366; /* *mask_scatter_storevnx2sivnx2di_sxtw_unpacked */
                  break;

                case E_VNx2SFmode:
                  if (register_operand (operands[4], E_VNx2SFmode)
                      && 
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6368; /* *mask_scatter_storevnx2sfvnx2di_sxtw_unpacked */
                  break;

                default:
                  break;
                }
            }
          if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[4], E_VNx2DImode)
                  || !
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6370; /* *mask_scatter_storevnx2divnx2di_sxtw_unpacked */

            case E_VNx2DFmode:
              if (!register_operand (operands[4], E_VNx2DFmode)
                  || !
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6372; /* *mask_scatter_storevnx2dfvnx2di_sxtw_unpacked */

            default:
              return -1;
            }

        case 1:
          if (register_operand (operands[4], E_VNx2QImode)
              && aarch64_gather_scale_operand_b (operands[3], E_DImode)
              && 
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return 6374; /* *mask_scatter_storevnx2qivnx2di_sxtw */
          if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
            {
              switch (pattern1320 ())
                {
                case 0:
                  if (
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6375; /* *mask_scatter_storevnx2hivnx2di_sxtw */
                  break;

                case 1:
                  if (
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6376; /* *mask_scatter_storevnx2hfvnx2di_sxtw */
                  break;

                case 2:
                  if (
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6377; /* *mask_scatter_storevnx2bfvnx2di_sxtw */
                  break;

                default:
                  break;
                }
            }
          if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_VNx2SImode:
                  if (register_operand (operands[4], E_VNx2SImode)
                      && 
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6378; /* *mask_scatter_storevnx2sivnx2di_sxtw */
                  break;

                case E_VNx2SFmode:
                  if (register_operand (operands[4], E_VNx2SFmode)
                      && 
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6379; /* *mask_scatter_storevnx2sfvnx2di_sxtw */
                  break;

                default:
                  break;
                }
            }
          if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[4], E_VNx2DImode)
                  || !
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6380; /* *mask_scatter_storevnx2divnx2di_sxtw */

            case E_VNx2DFmode:
              if (!register_operand (operands[4], E_VNx2DFmode)
                  || !
#line 2512 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6381; /* *mask_scatter_storevnx2dfvnx2di_sxtw */

            default:
              return -1;
            }

        case 2:
          x8 = XVECEXP (x2, 0, 5);
          if (GET_MODE (x8) == E_VNx2QImode
              && aarch64_gather_scale_operand_b (operands[3], E_DImode))
            {
              x9 = XEXP (x8, 0);
              operands[4] = x9;
              if (register_operand (operands[4], E_VNx2DImode)
                  && 
#line 2616 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6395; /* *aarch64_scatter_store_truncvnx2qivnx2di_sxtw */
            }
          if (GET_MODE (x8) == E_VNx2HImode
              && aarch64_gather_scale_operand_h (operands[3], E_DImode))
            {
              x9 = XEXP (x8, 0);
              operands[4] = x9;
              if (register_operand (operands[4], E_VNx2DImode)
                  && 
#line 2616 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6396; /* *aarch64_scatter_store_truncvnx2hivnx2di_sxtw */
            }
          if (GET_MODE (x8) != E_VNx2SImode
              || !aarch64_gather_scale_operand_w (operands[3], E_DImode))
            return -1;
          x9 = XEXP (x8, 0);
          operands[4] = x9;
          if (!register_operand (operands[4], E_VNx2DImode)
              || !
#line 2616 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 6397; /* *aarch64_scatter_store_truncvnx2sivnx2di_sxtw */

        case 3:
          if (register_operand (operands[4], E_VNx2QImode)
              && aarch64_gather_scale_operand_b (operands[3], E_DImode)
              && 
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return 6359; /* *mask_scatter_storevnx2qivnx2di_uxtw_unpacked */
          if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
            {
              switch (pattern1320 ())
                {
                case 0:
                  if (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6361; /* *mask_scatter_storevnx2hivnx2di_uxtw_unpacked */
                  break;

                case 1:
                  if (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6363; /* *mask_scatter_storevnx2hfvnx2di_uxtw_unpacked */
                  break;

                case 2:
                  if (
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6365; /* *mask_scatter_storevnx2bfvnx2di_uxtw_unpacked */
                  break;

                default:
                  break;
                }
            }
          if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_VNx2SImode:
                  if (register_operand (operands[4], E_VNx2SImode)
                      && 
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6367; /* *mask_scatter_storevnx2sivnx2di_uxtw_unpacked */
                  break;

                case E_VNx2SFmode:
                  if (register_operand (operands[4], E_VNx2SFmode)
                      && 
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6369; /* *mask_scatter_storevnx2sfvnx2di_uxtw_unpacked */
                  break;

                default:
                  break;
                }
            }
          if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[4], E_VNx2DImode)
                  || !
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6371; /* *mask_scatter_storevnx2divnx2di_uxtw_unpacked */

            case E_VNx2DFmode:
              if (!register_operand (operands[4], E_VNx2DFmode)
                  || !
#line 2484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6373; /* *mask_scatter_storevnx2dfvnx2di_uxtw_unpacked */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x7) != E_VNx2DImode
          || !register_operand (operands[5], E_VNx2BImode)
          || !aarch64_reg_or_zero (operands[0], E_DImode))
        return -1;
      x12 = XEXP (x7, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_VNx2DImode))
        return -1;
      x13 = XEXP (x7, 1);
      operands[6] = x13;
      if (!aarch64_sve_uxtw_immediate (operands[6], E_VNx2DImode))
        return -1;
      x8 = XVECEXP (x2, 0, 5);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[4] = x8;
          if (register_operand (operands[4], E_VNx2QImode)
              && aarch64_gather_scale_operand_b (operands[3], E_DImode)
              && 
#line 2537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return 6382; /* *mask_scatter_storevnx2qivnx2di_uxtw */
          if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
            {
              switch (pattern1320 ())
                {
                case 0:
                  if (
#line 2537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6383; /* *mask_scatter_storevnx2hivnx2di_uxtw */
                  break;

                case 1:
                  if (
#line 2537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6384; /* *mask_scatter_storevnx2hfvnx2di_uxtw */
                  break;

                case 2:
                  if (
#line 2537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6385; /* *mask_scatter_storevnx2bfvnx2di_uxtw */
                  break;

                default:
                  break;
                }
            }
          if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_VNx2SImode:
                  if (register_operand (operands[4], E_VNx2SImode)
                      && 
#line 2537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6386; /* *mask_scatter_storevnx2sivnx2di_uxtw */
                  break;

                case E_VNx2SFmode:
                  if (register_operand (operands[4], E_VNx2SFmode)
                      && 
#line 2537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6387; /* *mask_scatter_storevnx2sfvnx2di_uxtw */
                  break;

                default:
                  break;
                }
            }
          if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[4], E_VNx2DImode)
                  || !
#line 2537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6388; /* *mask_scatter_storevnx2divnx2di_uxtw */

            case E_VNx2DFmode:
              if (!register_operand (operands[4], E_VNx2DFmode)
                  || !
#line 2537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6389; /* *mask_scatter_storevnx2dfvnx2di_uxtw */

            default:
              return -1;
            }

        case TRUNCATE:
          if (GET_MODE (x8) == E_VNx2QImode
              && aarch64_gather_scale_operand_b (operands[3], E_DImode))
            {
              x9 = XEXP (x8, 0);
              operands[4] = x9;
              if (register_operand (operands[4], E_VNx2DImode)
                  && 
#line 2641 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6398; /* *aarch64_scatter_store_truncvnx2qivnx2di_uxtw */
            }
          if (GET_MODE (x8) == E_VNx2HImode
              && aarch64_gather_scale_operand_h (operands[3], E_DImode))
            {
              x9 = XEXP (x8, 0);
              operands[4] = x9;
              if (register_operand (operands[4], E_VNx2DImode)
                  && 
#line 2641 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6399; /* *aarch64_scatter_store_truncvnx2hivnx2di_uxtw */
            }
          if (GET_MODE (x8) != E_VNx2SImode
              || !aarch64_gather_scale_operand_w (operands[3], E_DImode))
            return -1;
          x9 = XEXP (x8, 0);
          operands[4] = x9;
          if (!register_operand (operands[4], E_VNx2DImode)
              || !
#line 2641 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 6400; /* *aarch64_scatter_store_truncvnx2sivnx2di_uxtw */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_460 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern409 (x2, 
E_SImode) != 0)
            return -1;
          return 380; /* maddsi */

        case E_DImode:
          if (pattern409 (x2, 
E_DImode) != 0)
            return -1;
          return 381; /* madddi */

        case E_V8QImode:
          if (pattern408 (x2, 
E_V8QImode) != 0
              || !
#line 1636 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2000; /* aarch64_mlav8qi */

        case E_V16QImode:
          if (pattern408 (x2, 
E_V16QImode) != 0
              || !
#line 1636 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2003; /* aarch64_mlav16qi */

        case E_V4HImode:
          if (pattern408 (x2, 
E_V4HImode) != 0
              || !
#line 1636 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2004; /* aarch64_mlav4hi */

        case E_V8HImode:
          if (pattern408 (x2, 
E_V8HImode) != 0
              || !
#line 1636 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2007; /* aarch64_mlav8hi */

        case E_V2SImode:
          if (pattern408 (x2, 
E_V2SImode) != 0
              || !
#line 1636 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2008; /* aarch64_mlav2si */

        case E_V4SImode:
          if (pattern408 (x2, 
E_V4SImode) != 0
              || !
#line 1636 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2011; /* aarch64_mlav4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern628 (x2))
                {
                case 0:
                  return 391; /* maddsidi4 */

                case 1:
                  if (!
#line 2172 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2266; /* aarch64_smlalv8qi */

                case 2:
                  if (!
#line 2172 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2268; /* aarch64_smlalv4hi */

                case 3:
                  if (!
#line 2172 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2270; /* aarch64_smlalv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern630 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2187 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2272; /* aarch64_smlal_nv4hi */

                case 1:
                  if (!
#line 2187 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2274; /* aarch64_smlal_nv2si */

                case 2:
                  if (!
#line 2428 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2328; /* aarch64_vec_smlal_lane_v4hi */

                case 3:
                  if (!
#line 2428 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2330; /* aarch64_vec_smlal_laneq_v4hi */

                case 4:
                  if (!
#line 2428 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2332; /* aarch64_vec_smlal_lane_v2si */

                case 5:
                  if (!
#line 2428 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2334; /* aarch64_vec_smlal_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XEXP (x5, 1);
          operands[3] = x8;
          x9 = XEXP (x2, 1);
          operands[1] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern890 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2020 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2234; /* *aarch64_smlal_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2036 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2240; /* aarch64_smlal_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2020 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2236; /* *aarch64_smlal_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2036 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2242; /* aarch64_smlal_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2020 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2238; /* *aarch64_smlal_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2036 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2244; /* aarch64_smlal_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern892 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2067 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2246; /* aarch64_smlal_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2067 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2248; /* aarch64_smlal_hi_nv4si_insn */

                case 2:
                  if (!
#line 2450 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2336; /* aarch64_smlal_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2487 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2340; /* aarch64_smlal_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2450 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2338; /* aarch64_smlal_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2487 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2342; /* aarch64_smlal_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern628 (x2))
                {
                case 0:
                  return 392; /* umaddsidi4 */

                case 1:
                  if (!
#line 2172 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2267; /* aarch64_umlalv8qi */

                case 2:
                  if (!
#line 2172 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2269; /* aarch64_umlalv4hi */

                case 3:
                  if (!
#line 2172 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2271; /* aarch64_umlalv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern630 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2187 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2273; /* aarch64_umlal_nv4hi */

                case 1:
                  if (!
#line 2187 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2275; /* aarch64_umlal_nv2si */

                case 2:
                  if (!
#line 2428 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2329; /* aarch64_vec_umlal_lane_v4hi */

                case 3:
                  if (!
#line 2428 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2331; /* aarch64_vec_umlal_laneq_v4hi */

                case 4:
                  if (!
#line 2428 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2333; /* aarch64_vec_umlal_lane_v2si */

                case 5:
                  if (!
#line 2428 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2335; /* aarch64_vec_umlal_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XEXP (x5, 1);
          operands[3] = x8;
          x9 = XEXP (x2, 1);
          operands[1] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern890 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2020 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2235; /* *aarch64_umlal_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2036 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2241; /* aarch64_umlal_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2020 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2237; /* *aarch64_umlal_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2036 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2243; /* aarch64_umlal_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2020 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2239; /* *aarch64_umlal_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2036 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2245; /* aarch64_umlal_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern892 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2067 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2247; /* aarch64_umlal_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2067 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2249; /* aarch64_umlal_hi_nv4si_insn */

                case 2:
                  if (!
#line 2450 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2337; /* aarch64_umlal_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2487 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2341; /* aarch64_umlal_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2450 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2339; /* aarch64_umlal_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2487 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2343; /* aarch64_umlal_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != PARALLEL
              || XVECLEN (x8, 0) != 1)
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x10 = XVECEXP (x8, 0, 0);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          x9 = XEXP (x2, 1);
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern1134 (x2, 
E_V4HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1651 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2012; /* *aarch64_mla_eltv4hi */

                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2020; /* *aarch64_mla_elt_to_128v4hi */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern1134 (x2, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1651 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2015; /* *aarch64_mla_eltv8hi */

                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2023; /* *aarch64_mla_elt_to_64v8hi */

                default:
                  return -1;
                }

            case E_V2SImode:
              if (pattern1134 (x2, 
E_V2SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1651 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2016; /* *aarch64_mla_eltv2si */

                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2024; /* *aarch64_mla_elt_to_128v2si */

                default:
                  return -1;
                }

            case E_V4SImode:
              if (pattern1134 (x2, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1651 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2019; /* *aarch64_mla_eltv4si */

                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2027; /* *aarch64_mla_elt_to_64v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x5;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          x9 = XEXP (x2, 1);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern893 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 1685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2028; /* aarch64_mla_nv4hi */

            case E_V8HImode:
              if (pattern893 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 1685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2031; /* aarch64_mla_nv8hi */

            case E_V2SImode:
              if (pattern893 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 1685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2032; /* aarch64_mla_nv2si */

            case E_V4SImode:
              if (pattern893 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 1685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2035; /* aarch64_mla_nv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 168)
        return -1;
      x11 = XVECEXP (x4, 0, 0);
      operands[3] = x11;
      x12 = XVECEXP (x4, 0, 1);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x9 = XEXP (x2, 1);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern1069 (x2, 
E_VNx8HImode) != 0
              || !
#line 1493 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11913; /* aarch64_sve_add_mul_lane_vnx8hi */

        case E_VNx4SImode:
          if (pattern1069 (x2, 
E_VNx4SImode) != 0
              || !
#line 1493 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11914; /* aarch64_sve_add_mul_lane_vnx4si */

        case E_VNx2DImode:
          if (pattern1069 (x2, 
E_VNx2DImode) != 0
              || !
#line 1493 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11915; /* aarch64_sve_add_mul_lane_vnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_474 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
    case TRUNCATE:
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case TRUNCATE:
          if (subreg_lowpart_operator (x3, E_VOIDmode))
            {
              operands[4] = x3;
              switch (pattern524 (x2))
                {
                case 0:
                  if (
#line 5858 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0))
                    return 718; /* *aarch64_ashl_reg_si3_mask1 */
                  break;

                case 1:
                  if (
#line 5858 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0))
                    return 723; /* *aarch64_ashl_reg_di3_mask1 */
                  break;

                case 2:
                  if (
#line 5922 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                    return 740; /* *aarch64_ashl_reg_di3_mask2 */
                  break;

                case 3:
                  if (
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)))
                    return 728; /* *aarch64_ashl_reg_si3_neg_mask2 */
                  break;

                case 4:
                  if (
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                    return 733; /* *aarch64_ashl_reg_di3_neg_mask2 */
                  break;

                default:
                  break;
                }
            }
          operands[2] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern31 (x2, 
E_V8QImode) == 0
                  && 
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1943; /* aarch64_simd_reg_sshlv8qi */
              break;

            case E_V16QImode:
              if (pattern31 (x2, 
E_V16QImode) == 0
                  && 
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1946; /* aarch64_simd_reg_sshlv16qi */
              break;

            case E_V4HImode:
              if (pattern31 (x2, 
E_V4HImode) == 0
                  && 
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1947; /* aarch64_simd_reg_sshlv4hi */
              break;

            case E_V8HImode:
              if (pattern31 (x2, 
E_V8HImode) == 0
                  && 
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1950; /* aarch64_simd_reg_sshlv8hi */
              break;

            case E_V2SImode:
              if (pattern31 (x2, 
E_V2SImode) == 0
                  && 
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1951; /* aarch64_simd_reg_sshlv2si */
              break;

            case E_V4SImode:
              if (pattern31 (x2, 
E_V4SImode) == 0
                  && 
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1954; /* aarch64_simd_reg_sshlv4si */
              break;

            case E_V2DImode:
              if (pattern31 (x2, 
E_V2DImode) == 0
                  && 
#line 1404 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1955; /* aarch64_simd_reg_sshlv2di */
              break;

            default:
              break;
            }
          break;

        case CONST_INT:
          switch (pattern526 (x2))
            {
            case 0:
              if (
#line 6186 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
                return 771; /* *ashlqi3_insn */
              break;

            case 1:
              if (
#line 6186 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
                return 774; /* *ashlhi3_insn */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      switch (pattern416 (x2))
        {
        case 0:
          return 751; /* *aarch64_ashl_sisd_or_int_si3 */

        case 1:
          return 752; /* *aarch64_ashl_sisd_or_int_di3 */

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      if (subreg_lowpart_operator (x5, E_VOIDmode))
        {
          switch (pattern846 (x2))
            {
            case 0:
              if (
#line 5895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[4]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)
   && INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)))
                return 738; /* *aarch64_ashl_reg_si3_minus_mask */
              break;

            case 1:
              if (
#line 5895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[4]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)
   && INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)))
                return 739; /* *aarch64_ashl_reg_di3_minus_mask */
              break;

            default:
              break;
            }
        }
      operands[3] = x5;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      switch (pattern2 (x2))
        {
        case 0:
          if (!
#line 5940 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)))
            return -1;
          return 745; /* *aarch64_ashl_reg_minussi3 */

        case 1:
          if (!
#line 5940 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)))
            return -1;
          return 748; /* *aarch64_ashl_reg_minusdi3 */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern461 (x2, 
E_V8QImode) != 0
              || !
#line 1393 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1930; /* aarch64_simd_imm_shlv8qi */

        case E_V16QImode:
          if (pattern461 (x2, 
E_V16QImode) != 0
              || !
#line 1393 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1933; /* aarch64_simd_imm_shlv16qi */

        case E_V4HImode:
          if (pattern461 (x2, 
E_V4HImode) != 0
              || !
#line 1393 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1934; /* aarch64_simd_imm_shlv4hi */

        case E_V8HImode:
          if (pattern461 (x2, 
E_V8HImode) != 0
              || !
#line 1393 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1937; /* aarch64_simd_imm_shlv8hi */

        case E_V2SImode:
          if (pattern461 (x2, 
E_V2SImode) != 0
              || !
#line 1393 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1938; /* aarch64_simd_imm_shlv2si */

        case E_V4SImode:
          if (pattern461 (x2, 
E_V4SImode) != 0
              || !
#line 1393 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1941; /* aarch64_simd_imm_shlv4si */

        case E_V2DImode:
          if (pattern461 (x2, 
E_V2DImode) != 0
              || !
#line 1393 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1942; /* aarch64_simd_imm_shlv2di */

        case E_VNx16QImode:
          if (pattern461 (x2, 
E_VNx16QImode) != 0
              || !
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8260; /* *post_ra_v_ashlvnx16qi3 */

        case E_VNx8QImode:
          if (pattern461 (x2, 
E_VNx8QImode) != 0
              || !
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8261; /* *post_ra_v_ashlvnx8qi3 */

        case E_VNx4QImode:
          if (pattern461 (x2, 
E_VNx4QImode) != 0
              || !
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8262; /* *post_ra_v_ashlvnx4qi3 */

        case E_VNx2QImode:
          if (pattern461 (x2, 
E_VNx2QImode) != 0
              || !
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8263; /* *post_ra_v_ashlvnx2qi3 */

        case E_VNx8HImode:
          if (pattern461 (x2, 
E_VNx8HImode) != 0
              || !
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8264; /* *post_ra_v_ashlvnx8hi3 */

        case E_VNx4HImode:
          if (pattern461 (x2, 
E_VNx4HImode) != 0
              || !
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8265; /* *post_ra_v_ashlvnx4hi3 */

        case E_VNx2HImode:
          if (pattern461 (x2, 
E_VNx2HImode) != 0
              || !
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8266; /* *post_ra_v_ashlvnx2hi3 */

        case E_VNx4SImode:
          if (pattern461 (x2, 
E_VNx4SImode) != 0
              || !
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8267; /* *post_ra_v_ashlvnx4si3 */

        case E_VNx2SImode:
          if (pattern461 (x2, 
E_VNx2SImode) != 0
              || !
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8268; /* *post_ra_v_ashlvnx2si3 */

        case E_VNx2DImode:
          if (pattern461 (x2, 
E_VNx2DImode) != 0
              || !
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8269; /* *post_ra_v_ashlvnx2di3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_480 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case MULT:
          if (GET_MODE (x5) != E_TImode)
            return -1;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 64]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_TImode)
            return -1;
          x7 = XEXP (x5, 0);
          if (GET_MODE (x7) != E_TImode)
            return -1;
          x8 = XEXP (x5, 1);
          if (GET_MODE (x8) != E_TImode)
            return -1;
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              if (GET_CODE (x8) != SIGN_EXTEND)
                return -1;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_DImode))
                return -1;
              return 397; /* smuldi3_highpart */

            case ZERO_EXTEND:
              if (GET_CODE (x8) != ZERO_EXTEND)
                return -1;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_DImode))
                return -1;
              return 398; /* umuldi3_highpart */

            default:
              return -1;
            }

        case PLUS:
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != ZERO_EXTEND)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          switch (pattern756 (x3))
            {
            case 0:
              if (!register_operand (operands[0], E_V8QImode)
                  || GET_MODE (x3) != E_V8QImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V8HImode:
                  if (pattern341 (x5, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 6600 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3797; /* aarch64_urshr_nv8qi_insn */

                case E_V8SImode:
                  if (pattern341 (x5, 
E_V8HImode, 
E_V8SImode) != 0
                      || !
#line 6720 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3959; /* *aarch64_rshrn_nv8hi_insn */

                default:
                  return -1;
                }

            case 1:
              if (pattern1015 (x3, 
E_V16QImode, 
E_V16HImode) != 0
                  || !
#line 6600 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                return -1;
              return 3801; /* aarch64_urshr_nv16qi_insn */

            case 2:
              if (!register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x3) != E_V4HImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V4SImode:
                  if (pattern342 (x5, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 6600 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3805; /* aarch64_urshr_nv4hi_insn */

                case E_V4DImode:
                  if (pattern342 (x5, 
E_V4SImode, 
E_V4DImode) != 0
                      || !
#line 6720 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3968; /* *aarch64_rshrn_nv4si_insn */

                default:
                  return -1;
                }

            case 3:
              if (pattern1016 (x3, 
E_V8HImode, 
E_V8SImode) != 0
                  || !
#line 6600 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                return -1;
              return 3809; /* aarch64_urshr_nv8hi_insn */

            case 4:
              if (!register_operand (operands[0], E_V2SImode)
                  || GET_MODE (x3) != E_V2SImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V2DImode:
                  if (pattern343 (x5, 
E_V2SImode, 
E_V2DImode) != 0
                      || !
#line 6600 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3813; /* aarch64_urshr_nv2si_insn */

                case E_V2TImode:
                  if (pattern343 (x5, 
E_V2DImode, 
E_V2TImode) != 0
                      || !
#line 6720 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3977; /* *aarch64_rshrn_nv2di_insn */

                default:
                  return -1;
                }

            case 5:
              if (pattern1017 (x3, 
E_V4SImode, 
E_V4DImode) != 0
                  || !
#line 6600 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                return -1;
              return 3817; /* aarch64_urshr_nv4si_insn */

            case 6:
              if (pattern1018 (x3) != 0
                  || !
#line 6600 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                return -1;
              return 3819; /* aarch64_urshr_nv2di_insn */

            case 7:
              if (!
#line 6600 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                return -1;
              return 3823; /* aarch64_urshr_ndi_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern345 (x3))
            {
            case 0:
              if (!
#line 6693 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 3914; /* *aarch64_shrn_nv8hi_insn */

            case 1:
              if (!
#line 6693 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 3932; /* *aarch64_shrn_nv4si_insn */

            case 2:
              if (!
#line 6693 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 3950; /* *aarch64_shrn_nv2di_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_CONCAT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern757 (x3, 
E_V4HImode, 
E_V8HImode, 
E_V8QImode) != 0
              || !
#line 1883 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2213; /* *aarch64_trunc_concatv8hi */

        case E_V4HImode:
          if (pattern757 (x3, 
E_V2SImode, 
E_V4SImode, 
E_V4HImode) != 0
              || !
#line 1883 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2214; /* *aarch64_trunc_concatv4si */

        case E_V2SImode:
          if (pattern757 (x3, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0
              || !
#line 1883 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2215; /* *aarch64_trunc_concatv2di */

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_479 (x1, insn, pnum_clobbers);

    case SMIN:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SMAX)
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          x8 = XEXP (x5, 1);
          if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x6 = XEXP (x4, 1);
              if (GET_CODE (x6) == CONST_INT)
                {
                  switch (XWINT (x6, 0))
                    {
                    case 255LL:
                      if (pattern965 (x3, 
E_HImode, 
E_QImode) == 0
                          && 
#line 5454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return 3384; /* aarch64_sqmovunhi */
                      break;

                    case 65535LL:
                      if (pattern965 (x3, 
E_SImode, 
E_HImode) == 0
                          && 
#line 5454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return 3385; /* aarch64_sqmovunsi */
                      break;

                    case 4294967295LL:
                      if (pattern965 (x3, 
E_DImode, 
E_SImode) == 0
                          && 
#line 5454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return 3386; /* aarch64_sqmovundi */
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[2] = x8;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern966 (x3, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 5466 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3387; /* *aarch64_sqmovunv8hi_insn */

            case E_V4HImode:
              if (pattern966 (x3, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 5466 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3390; /* *aarch64_sqmovunv4si_insn */

            case E_V2SImode:
              if (pattern966 (x3, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 5466 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3393; /* *aarch64_sqmovunv2di_insn */

            default:
              return -1;
            }

        case ASHIFTRT:
          x11 = XEXP (x7, 1);
          operands[2] = x11;
          x9 = XEXP (x7, 0);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[1] = x9;
              x8 = XEXP (x5, 1);
              operands[3] = x8;
              x6 = XEXP (x4, 1);
              operands[4] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (pattern1073 (x3, 
E_V8HImode, 
E_V8QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V8HImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V8HImode)
                      || !
#line 6800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3986; /* *aarch64_sqshrun_nv8hi_insn */

                case E_V4HImode:
                  if (pattern1073 (x3, 
E_V4SImode, 
E_V4HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V4SImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V4SImode)
                      || !
#line 6800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3989; /* *aarch64_sqshrun_nv4si_insn */

                case E_V2SImode:
                  if (pattern1073 (x3, 
E_V2DImode, 
E_V2SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V2DImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V2DImode)
                      || !
#line 6800 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3992; /* *aarch64_sqshrun_nv2di_insn */

                default:
                  return -1;
                }

            case PLUS:
              x12 = XEXP (x9, 0);
              if (GET_CODE (x12) != SIGN_EXTEND)
                return -1;
              x13 = XEXP (x12, 0);
              operands[1] = x13;
              x14 = XEXP (x9, 1);
              operands[3] = x14;
              x8 = XEXP (x5, 1);
              operands[4] = x8;
              x6 = XEXP (x4, 1);
              operands[5] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (pattern1177 (x3, 
E_V8SImode, 
E_V8HImode, 
E_V8QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V8SImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V8SImode)
                      || !
#line 6867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3998; /* *aarch64_sqrshrun_nv8hi_insn */

                case E_V4HImode:
                  if (pattern1177 (x3, 
E_V4DImode, 
E_V4SImode, 
E_V4HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V4DImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V4DImode)
                      || !
#line 6867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4001; /* *aarch64_sqrshrun_nv4si_insn */

                case E_V2SImode:
                  if (pattern1177 (x3, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V2TImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V2TImode)
                      || !
#line 6867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4004; /* *aarch64_sqrshrun_nv2di_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 9874 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5248; /* truncv8hiv8qi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 9874 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5251; /* truncv4siv4hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 9874 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5254; /* truncv2div2si2 */

        case E_VNx8QImode:
          switch (pattern579 (x3, 
E_VNx8QImode))
            {
            case 0:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
                return -1;
              return 7120; /* truncvnx8hivnx8qi2 */

            case 1:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
                return -1;
              return 7126; /* truncvnx4hivnx8qi2 */

            case 2:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
                return -1;
              return 7132; /* truncvnx2hivnx8qi2 */

            case 3:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
                return -1;
              return 7138; /* truncvnx4sivnx8qi2 */

            case 4:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
                return -1;
              return 7144; /* truncvnx2sivnx8qi2 */

            case 5:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
                return -1;
              return 7150; /* truncvnx2divnx8qi2 */

            default:
              return -1;
            }

        case E_VNx4QImode:
          switch (pattern579 (x3, 
E_VNx4QImode))
            {
            case 0:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
                return -1;
              return 7121; /* truncvnx8hivnx4qi2 */

            case 1:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
                return -1;
              return 7127; /* truncvnx4hivnx4qi2 */

            case 2:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
                return -1;
              return 7133; /* truncvnx2hivnx4qi2 */

            case 3:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
                return -1;
              return 7139; /* truncvnx4sivnx4qi2 */

            case 4:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
                return -1;
              return 7145; /* truncvnx2sivnx4qi2 */

            case 5:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
                return -1;
              return 7151; /* truncvnx2divnx4qi2 */

            default:
              return -1;
            }

        case E_VNx2QImode:
          switch (pattern579 (x3, 
E_VNx2QImode))
            {
            case 0:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
                return -1;
              return 7122; /* truncvnx8hivnx2qi2 */

            case 1:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
                return -1;
              return 7128; /* truncvnx4hivnx2qi2 */

            case 2:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
                return -1;
              return 7134; /* truncvnx2hivnx2qi2 */

            case 3:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
                return -1;
              return 7140; /* truncvnx4sivnx2qi2 */

            case 4:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
                return -1;
              return 7146; /* truncvnx2sivnx2qi2 */

            case 5:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
                return -1;
              return 7152; /* truncvnx2divnx2qi2 */

            default:
              return -1;
            }

        case E_VNx4HImode:
          switch (pattern579 (x3, 
E_VNx4HImode))
            {
            case 0:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
                return -1;
              return 7123; /* truncvnx8hivnx4hi2 */

            case 1:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
                return -1;
              return 7129; /* truncvnx4hivnx4hi2 */

            case 2:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
                return -1;
              return 7135; /* truncvnx2hivnx4hi2 */

            case 3:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
                return -1;
              return 7141; /* truncvnx4sivnx4hi2 */

            case 4:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
                return -1;
              return 7147; /* truncvnx2sivnx4hi2 */

            case 5:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
                return -1;
              return 7153; /* truncvnx2divnx4hi2 */

            default:
              return -1;
            }

        case E_VNx2HImode:
          switch (pattern579 (x3, 
E_VNx2HImode))
            {
            case 0:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
                return -1;
              return 7124; /* truncvnx8hivnx2hi2 */

            case 1:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
                return -1;
              return 7130; /* truncvnx4hivnx2hi2 */

            case 2:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
                return -1;
              return 7136; /* truncvnx2hivnx2hi2 */

            case 3:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
                return -1;
              return 7142; /* truncvnx4sivnx2hi2 */

            case 4:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
                return -1;
              return 7148; /* truncvnx2sivnx2hi2 */

            case 5:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
                return -1;
              return 7154; /* truncvnx2divnx2hi2 */

            default:
              return -1;
            }

        case E_VNx2SImode:
          switch (pattern579 (x3, 
E_VNx2SImode))
            {
            case 0:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
                return -1;
              return 7125; /* truncvnx8hivnx2si2 */

            case 1:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
                return -1;
              return 7131; /* truncvnx4hivnx2si2 */

            case 2:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
                return -1;
              return 7137; /* truncvnx2hivnx2si2 */

            case 3:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
                return -1;
              return 7143; /* truncvnx4sivnx2si2 */

            case 4:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
                return -1;
              return 7149; /* truncvnx2sivnx2si2 */

            case 5:
              if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
                return -1;
              return 7155; /* truncvnx2divnx2si2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_491 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x6 = XEXP (x2, 0);
          operands[3] = x6;
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern424 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1368; /* subv8qi3_vec_concatz_be */

            case E_V8HImode:
              if (pattern424 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1372; /* subv4hi3_vec_concatz_be */

            case E_V4SImode:
              if (pattern424 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1376; /* subv2si3_vec_concatz_be */

            case E_V8HFmode:
              if (pattern424 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2644 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2371; /* subv4hf3_vec_concatz_be */

            case E_V4SFmode:
              if (pattern424 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2644 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2375; /* subv2sf3_vec_concatz_be */

            default:
              return -1;
            }

        case MULT:
          x7 = XEXP (x5, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              x6 = XEXP (x2, 0);
              operands[4] = x6;
              operands[1] = x4;
              x8 = XEXP (x5, 1);
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1085 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                      || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1695 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2038; /* aarch64_mlsv8qi_vec_concatz_be */

                case E_V8HImode:
                  if (pattern1085 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                      || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1695 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2042; /* aarch64_mlsv4hi_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1085 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                      || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1695 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2046; /* aarch64_mlsv2si_vec_concatz_be */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x9 = XEXP (x7, 0);
              switch (GET_CODE (x9))
                {
                case VEC_SELECT:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != PARALLEL
                      || XVECLEN (x10, 0) != 1)
                    return -1;
                  x6 = XEXP (x2, 0);
                  operands[5] = x6;
                  operands[4] = x4;
                  x11 = XEXP (x9, 0);
                  operands[1] = x11;
                  x12 = XVECEXP (x10, 0, 0);
                  operands[2] = x12;
                  if (!immediate_operand (operands[2], E_SImode))
                    return -1;
                  x8 = XEXP (x5, 1);
                  operands[3] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1266 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V4HImode:
                          if (!register_operand (operands[1], E_V4HImode)
                              || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2050; /* *aarch64_mls_eltv4hi_vec_concatz_be */

                        case E_V8HImode:
                          if (!register_operand (operands[1], E_V8HImode)
                              || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2058; /* *aarch64_mls_elt_to_128v4hi_vec_concatz_be */

                        default:
                          return -1;
                        }

                    case E_V4SImode:
                      if (pattern1266 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V2SImode:
                          if (!register_operand (operands[1], E_V2SImode)
                              || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1710 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2054; /* *aarch64_mls_eltv2si_vec_concatz_be */

                        case E_V4SImode:
                          if (!register_operand (operands[1], E_V4SImode)
                              || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1728 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2062; /* *aarch64_mls_elt_to_128v2si_vec_concatz_be */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[3] = x9;
                  x6 = XEXP (x2, 0);
                  operands[4] = x6;
                  operands[1] = x4;
                  x8 = XEXP (x5, 1);
                  operands[2] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1145 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                          || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1744 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2066; /* aarch64_mls_nv4hi_vec_concatz_be */

                    case E_V4SImode:
                      if (pattern1145 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                          || !(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1744 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2070; /* aarch64_mls_nv2si_vec_concatz_be */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern531 (x2, 
SMIN))
        {
        case 0:
          if (!(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1643; /* aarch64_sabdv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1651; /* aarch64_sabdv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1659; /* aarch64_sabdv2si_vec_concatz_be */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern531 (x2, 
UMIN))
        {
        case 0:
          if (!(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1646; /* aarch64_uabdv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1654; /* aarch64_uabdv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1662; /* aarch64_uabdv2si_vec_concatz_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_497 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern323 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1354; /* addv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1358; /* addv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1362; /* addv2si3_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2635 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2361; /* addv4hf3_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2635 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2365; /* addv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XEXP (x2, 1);
          operands[4] = x5;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern772 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1419; /* aarch64_fcmla0v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1435; /* aarch64_fcmla0v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 408:
              switch (pattern772 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1422; /* aarch64_fcmla90v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1438; /* aarch64_fcmla90v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 409:
              switch (pattern772 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1425; /* aarch64_fcmla180v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1441; /* aarch64_fcmla180v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 410:
              switch (pattern772 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1428; /* aarch64_fcmla270v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1444; /* aarch64_fcmla270v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 279:
              if (pattern773 (x2) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1511; /* sdot_prodv2siv8qi_vec_concatz_le */

            case 280:
              if (pattern773 (x2) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1514; /* udot_prodv2siv8qi_vec_concatz_le */

            case 573:
              if (pattern773 (x2) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 591 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                return -1;
              return 1519; /* usdot_prodv2siv8qi_vec_concatz_le */

            default:
              return -1;
            }

        case 3:
          x6 = XVECEXP (x4, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x4, 0, 1);
          operands[3] = x7;
          x8 = XVECEXP (x4, 0, 2);
          operands[4] = x8;
          x9 = XEXP (x3, 1);
          operands[1] = x9;
          x5 = XEXP (x2, 1);
          operands[5] = x5;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern1028 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1455; /* aarch64_fcmla_lane0v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1491; /* aarch64_fcmla_laneq0v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1471; /* aarch64_fcmla_lane0v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 408:
              switch (pattern1028 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1458; /* aarch64_fcmla_lane90v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1494; /* aarch64_fcmla_laneq90v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1474; /* aarch64_fcmla_lane90v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 409:
              switch (pattern1028 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1461; /* aarch64_fcmla_lane180v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1497; /* aarch64_fcmla_laneq180v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1477; /* aarch64_fcmla_lane180v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 410:
              switch (pattern1028 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1464; /* aarch64_fcmla_lane270v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1500; /* aarch64_fcmla_laneq270v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1480; /* aarch64_fcmla_lane270v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 279:
              switch (pattern1029 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1523; /* aarch64_sdot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 622 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1531; /* aarch64_sdot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            case 280:
              switch (pattern1029 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1526; /* aarch64_udot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 622 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1534; /* aarch64_udot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            case 573:
              switch (pattern1029 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1539; /* aarch64_usdot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1547; /* aarch64_usdot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            case 578:
              switch (pattern1029 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1542; /* aarch64_sudot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1550; /* aarch64_sudot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) != VEC_SELECT)
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT)
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      x13 = XEXP (x11, 1);
      operands[4] = x13;
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      x5 = XEXP (x2, 1);
      operands[5] = x5;
      x14 = XEXP (x10, 0);
      switch (GET_CODE (x14))
        {
        case SIGN_EXTEND:
          switch (pattern1031 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1702; /* *aarch64_sadalpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1710; /* *aarch64_sadalpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1720; /* *aarch64_sadalpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1031 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1705; /* *aarch64_uadalpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1713; /* *aarch64_uadalpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1723; /* *aarch64_uadalpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      x5 = XEXP (x2, 1);
      operands[4] = x5;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SMAX:
          switch (pattern775 (x2, 
SMIN))
            {
            case 0:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1726; /* aarch64_sabav8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1734; /* aarch64_sabav4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1742; /* aarch64_sabav2si_vec_concatz_le */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern775 (x2, 
UMIN))
            {
            case 0:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1729; /* aarch64_uabav8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1737; /* aarch64_uabav4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1745; /* aarch64_uabav2si_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[2] = x10;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x9 = XEXP (x3, 1);
          operands[1] = x9;
          x5 = XEXP (x2, 1);
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern970 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1636 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2001; /* aarch64_mlav8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern970 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1636 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2005; /* aarch64_mlav4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern970 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1636 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2009; /* aarch64_mlav2si_vec_concatz_le */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x14 = XEXP (x10, 0);
          switch (GET_CODE (x14))
            {
            case VEC_SELECT:
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != PARALLEL
                  || XVECLEN (x15, 0) != 1)
                return -1;
              x16 = XEXP (x14, 0);
              operands[1] = x16;
              x17 = XVECEXP (x15, 0, 0);
              operands[2] = x17;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x4, 1);
              operands[3] = x11;
              x9 = XEXP (x3, 1);
              operands[4] = x9;
              x5 = XEXP (x2, 1);
              operands[5] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1210 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4HImode:
                      if (!register_operand (operands[1], E_V4HImode)
                          || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1651 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2013; /* *aarch64_mla_eltv4hi_vec_concatz_le */

                    case E_V8HImode:
                      if (!register_operand (operands[1], E_V8HImode)
                          || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2021; /* *aarch64_mla_elt_to_128v4hi_vec_concatz_le */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  if (pattern1210 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V2SImode:
                      if (!register_operand (operands[1], E_V2SImode)
                          || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1651 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2017; /* *aarch64_mla_eltv2si_vec_concatz_le */

                    case E_V4SImode:
                      if (!register_operand (operands[1], E_V4SImode)
                          || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1669 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2025; /* *aarch64_mla_elt_to_128v2si_vec_concatz_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x14;
              x11 = XEXP (x4, 1);
              operands[2] = x11;
              x9 = XEXP (x3, 1);
              operands[1] = x9;
              x5 = XEXP (x2, 1);
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1032 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                      || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2029; /* aarch64_mla_nv4hi_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1032 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                      || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2033; /* aarch64_mla_nv2si_vec_concatz_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != VEC_SELECT)
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          switch (pattern668 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2795; /* *aarch64_saddlpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2803; /* *aarch64_saddlpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2813; /* *aarch64_saddlpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern668 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2798; /* *aarch64_uaddlpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2806; /* *aarch64_uaddlpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2816; /* *aarch64_uaddlpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x10;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != PLUS)
            return -1;
          x18 = XEXP (x5, 0);
          if (GET_CODE (x18) != VEC_SELECT)
            return -1;
          x19 = XEXP (x5, 1);
          if (GET_CODE (x19) != VEC_SELECT)
            return -1;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x20 = XEXP (x9, 1);
          operands[4] = x20;
          x21 = XEXP (x18, 0);
          operands[2] = x21;
          x22 = XEXP (x9, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x23 = XEXP (x18, 1);
          if (!rtx_equal_p (x23, operands[3]))
            return -1;
          x24 = XEXP (x19, 0);
          if (!rtx_equal_p (x24, operands[2]))
            return -1;
          x25 = XEXP (x19, 1);
          if (!rtx_equal_p (x25, operands[4]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1285 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !
#line 7462 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4367; /* aarch64_addpv16qi_insn */

            case E_V8HImode:
              if (pattern1285 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !
#line 7462 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4368; /* aarch64_addpv8hi_insn */

            case E_V4SImode:
              if (pattern1285 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !
#line 7462 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4369; /* aarch64_addpv4si_insn */

            case E_V2DImode:
              if (pattern1285 (x2, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 7462 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4370; /* aarch64_addpv2di_insn */

            default:
              return -1;
            }

        case VEC_CONCAT:
          x22 = XEXP (x9, 0);
          if (GET_CODE (x22) != VEC_CONCAT)
            return -1;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x20 = XEXP (x9, 1);
          operands[4] = x20;
          x5 = XEXP (x2, 1);
          operands[5] = x5;
          x26 = XEXP (x22, 0);
          if (!rtx_equal_p (x26, operands[1]))
            return -1;
          x27 = XEXP (x22, 1);
          if (!rtx_equal_p (x27, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1211 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4372; /* aarch64_addpv8qi_vec_concatz_le_insn */

            case E_V8HImode:
              if (pattern1211 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4375; /* aarch64_addpv4hi_vec_concatz_le_insn */

            case E_V4SImode:
              if (pattern1211 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7484 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4378; /* aarch64_addpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x9 = XEXP (x3, 1);
          operands[4] = x9;
          x5 = XEXP (x2, 1);
          operands[5] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1033 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7331 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4212; /* aarch64_cmtstv8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern1033 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7331 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4216; /* aarch64_cmtstv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern1033 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7331 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4220; /* aarch64_cmtstv2si_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x10;
          x11 = XEXP (x4, 1);
          operands[2] = x11;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          x5 = XEXP (x2, 1);
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern971 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7348 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4225; /* *aarch64_cmtst_same_v8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern971 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7348 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4229; /* *aarch64_cmtst_same_v4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern971 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7348 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4233; /* *aarch64_cmtst_same_v2si_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_511 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      return recog_448 (x1, insn, pnum_clobbers);

    case 2:
      return recog_444 (x1, insn, pnum_clobbers);

    case 3:
      return recog_447 (x1, insn, pnum_clobbers);

    case 4:
      return recog_446 (x1, insn, pnum_clobbers);

    case 5:
      return recog_445 (x1, insn, pnum_clobbers);

    case 7:
      switch (XINT (x2, 1))
        {
        case 120:
          x3 = XVECEXP (x2, 0, 6);
          if (GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != SCRATCH)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XVECEXP (x2, 0, 0);
          operands[5] = x6;
          x7 = XVECEXP (x2, 0, 1);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 3);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x9 = XVECEXP (x2, 0, 4);
          operands[4] = x9;
          x10 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x10))
            {
            case REG:
            case SUBREG:
              operands[2] = x10;
              x11 = XVECEXP (x2, 0, 5);
              operands[6] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4QImode:
                  if (pattern1231 (x2, 
E_VNx4QImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6093; /* mask_gather_loadvnx4qivnx4si */

                case E_VNx4HImode:
                  if (pattern1232 (x2, 
E_VNx4HImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6094; /* mask_gather_loadvnx4hivnx4si */

                case E_VNx4HFmode:
                  if (pattern1232 (x2, 
E_VNx4HFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6095; /* mask_gather_loadvnx4hfvnx4si */

                case E_VNx4BFmode:
                  if (pattern1232 (x2, 
E_VNx4BFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6096; /* mask_gather_loadvnx4bfvnx4si */

                case E_VNx4SImode:
                  if (!register_operand (operands[0], E_VNx4SImode)
                      || GET_MODE (x2) != E_VNx4SImode
                      || !register_operand (operands[5], E_VNx4BImode)
                      || !aarch64_sve_gather_offset_w (operands[1], E_DImode)
                      || !register_operand (operands[2], E_VNx4SImode)
                      || !aarch64_gather_scale_operand_w (operands[4], E_DImode)
                      || !aarch64_maskload_else_operand (operands[6], E_VNx4SImode)
                      || !
#line 1507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6097; /* mask_gather_loadvnx4sivnx4si */

                case E_VNx4SFmode:
                  if (pattern1233 (x2, 
E_VNx4SFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1507 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6098; /* mask_gather_loadvnx4sfvnx4si */

                case E_VNx2QImode:
                  if (pattern1231 (x2, 
E_VNx2QImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6099; /* mask_gather_loadvnx2qivnx2di */

                case E_VNx2HImode:
                  if (pattern1232 (x2, 
E_VNx2HImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6100; /* mask_gather_loadvnx2hivnx2di */

                case E_VNx2HFmode:
                  if (pattern1232 (x2, 
E_VNx2HFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6101; /* mask_gather_loadvnx2hfvnx2di */

                case E_VNx2BFmode:
                  if (pattern1232 (x2, 
E_VNx2BFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6102; /* mask_gather_loadvnx2bfvnx2di */

                case E_VNx2SImode:
                  if (pattern1233 (x2, 
E_VNx2SImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6103; /* mask_gather_loadvnx2sivnx2di */

                case E_VNx2SFmode:
                  if (pattern1233 (x2, 
E_VNx2SFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6104; /* mask_gather_loadvnx2sfvnx2di */

                case E_VNx2DImode:
                  if (pattern1234 (x2, 
E_VNx2DImode) != 0
                      || !
#line 1537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6105; /* mask_gather_loadvnx2divnx2di */

                case E_VNx2DFmode:
                  if (pattern1234 (x2, 
E_VNx2DFmode) != 0
                      || !
#line 1537 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6106; /* mask_gather_loadvnx2dfvnx2di */

                default:
                  return -1;
                }

            case UNSPEC:
              if (pattern1132 (x10) != 0
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x12 = XVECEXP (x10, 0, 0);
              operands[6] = x12;
              x13 = XVECEXP (x10, 0, 1);
              if (GET_MODE (x13) != E_VNx2DImode)
                return -1;
              switch (pattern1312 (x2))
                {
                case 0:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6107; /* *mask_gather_loadvnx2qivnx2di_sxtw_unpacked */

                case 1:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6109; /* *mask_gather_loadvnx2hivnx2di_sxtw_unpacked */

                case 2:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6111; /* *mask_gather_loadvnx2hfvnx2di_sxtw_unpacked */

                case 3:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6113; /* *mask_gather_loadvnx2bfvnx2di_sxtw_unpacked */

                case 4:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6115; /* *mask_gather_loadvnx2sivnx2di_sxtw_unpacked */

                case 5:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6117; /* *mask_gather_loadvnx2sfvnx2di_sxtw_unpacked */

                case 6:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6119; /* *mask_gather_loadvnx2divnx2di_sxtw_unpacked */

                case 7:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6121; /* *mask_gather_loadvnx2dfvnx2di_sxtw_unpacked */

                case 8:
                  if (!
#line 1597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6123; /* *mask_gather_loadvnx2qivnx2di_sxtw */

                case 9:
                  if (!
#line 1597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6124; /* *mask_gather_loadvnx2hivnx2di_sxtw */

                case 10:
                  if (!
#line 1597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6125; /* *mask_gather_loadvnx2hfvnx2di_sxtw */

                case 11:
                  if (!
#line 1597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6126; /* *mask_gather_loadvnx2bfvnx2di_sxtw */

                case 12:
                  if (!
#line 1597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6127; /* *mask_gather_loadvnx2sivnx2di_sxtw */

                case 13:
                  if (!
#line 1597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6128; /* *mask_gather_loadvnx2sfvnx2di_sxtw */

                case 14:
                  if (!
#line 1597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6129; /* *mask_gather_loadvnx2divnx2di_sxtw */

                case 15:
                  if (!
#line 1597 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6130; /* *mask_gather_loadvnx2dfvnx2di_sxtw */

                case 16:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6108; /* *mask_gather_loadvnx2qivnx2di_uxtw_unpacked */

                case 17:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6110; /* *mask_gather_loadvnx2hivnx2di_uxtw_unpacked */

                case 18:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6112; /* *mask_gather_loadvnx2hfvnx2di_uxtw_unpacked */

                case 19:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6114; /* *mask_gather_loadvnx2bfvnx2di_uxtw_unpacked */

                case 20:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6116; /* *mask_gather_loadvnx2sivnx2di_uxtw_unpacked */

                case 21:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6118; /* *mask_gather_loadvnx2sfvnx2di_uxtw_unpacked */

                case 22:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6120; /* *mask_gather_loadvnx2divnx2di_uxtw_unpacked */

                case 23:
                  if (!
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6122; /* *mask_gather_loadvnx2dfvnx2di_uxtw_unpacked */

                default:
                  return -1;
                }

            case AND:
              if (pattern1133 (x10) != 0)
                return -1;
              x11 = XVECEXP (x2, 0, 5);
              operands[7] = x11;
              switch (pattern1310 (x2))
                {
                case 0:
                  if (!
#line 1625 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6131; /* *mask_gather_loadvnx2qivnx2di_uxtw */

                case 1:
                  if (!
#line 1625 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6132; /* *mask_gather_loadvnx2hivnx2di_uxtw */

                case 2:
                  if (!
#line 1625 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6133; /* *mask_gather_loadvnx2hfvnx2di_uxtw */

                case 3:
                  if (!
#line 1625 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6134; /* *mask_gather_loadvnx2bfvnx2di_uxtw */

                case 4:
                  if (!
#line 1625 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6135; /* *mask_gather_loadvnx2sivnx2di_uxtw */

                case 5:
                  if (!
#line 1625 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6136; /* *mask_gather_loadvnx2sfvnx2di_uxtw */

                case 6:
                  if (!
#line 1625 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6137; /* *mask_gather_loadvnx2divnx2di_uxtw */

                case 7:
                  if (!
#line 1625 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6138; /* *mask_gather_loadvnx2dfvnx2di_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 121:
          if (pattern263 (x2) != 0)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XVECEXP (x2, 0, 0);
          operands[5] = x6;
          x7 = XVECEXP (x2, 0, 1);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 3);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x9 = XVECEXP (x2, 0, 4);
          operands[4] = x9;
          x10 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x10))
            {
            case REG:
            case SUBREG:
              operands[2] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4SImode:
                  if (pattern1283 (x2, 
E_VNx4SImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1851 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6237; /* aarch64_ldff1_gathervnx4si */

                case E_VNx4SFmode:
                  if (pattern1283 (x2, 
E_VNx4SFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1851 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6238; /* aarch64_ldff1_gathervnx4sf */

                case E_VNx2DImode:
                  if (pattern1284 (x2, 
E_VNx2DImode) != 0
                      || !
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6239; /* aarch64_ldff1_gathervnx2di */

                case E_VNx2DFmode:
                  if (pattern1284 (x2, 
E_VNx2DFmode) != 0
                      || !
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6240; /* aarch64_ldff1_gathervnx2df */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x10, 0) != 2
                  || XINT (x10, 1) != 125
                  || GET_MODE (x10) != E_VNx2DImode)
                return -1;
              x13 = XVECEXP (x10, 0, 1);
              if (GET_CODE (x13) != SIGN_EXTEND
                  || GET_MODE (x13) != E_VNx2DImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != TRUNCATE
                  || GET_MODE (x14) != E_VNx2SImode
                  || !register_operand (operands[5], E_VNx2BImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x12 = XVECEXP (x10, 0, 0);
              operands[6] = x12;
              switch (pattern1359 (x2))
                {
                case 0:
                  if (!
#line 1911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6241; /* *aarch64_ldff1_gathervnx2di_sxtw */

                case 1:
                  if (!
#line 1911 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6242; /* *aarch64_ldff1_gathervnx2df_sxtw */

                default:
                  return -1;
                }

            case AND:
              if (pattern1133 (x10) != 0)
                return -1;
              switch (pattern1345 (x2))
                {
                case 0:
                  if (!
#line 1938 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6243; /* *aarch64_ldff1_gathervnx2di_uxtw */

                case 1:
                  if (!
#line 1938 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6244; /* *aarch64_ldff1_gathervnx2df_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 659:
          switch (pattern266 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13931; /* aarch64_sme_smopavnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13947; /* aarch64_sme_smopavnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13939; /* aarch64_sme_smopavnx2divnx8hi */

            default:
              return -1;
            }

        case 660:
          switch (pattern266 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13932; /* aarch64_sme_smopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13948; /* aarch64_sme_smopsvnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13940; /* aarch64_sme_smopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 667:
          switch (pattern267 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13933; /* aarch64_sme_sumopavnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13941; /* aarch64_sme_sumopavnx2divnx8hi */

            default:
              return -1;
            }

        case 668:
          switch (pattern267 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13934; /* aarch64_sme_sumopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13942; /* aarch64_sme_sumopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 673:
          switch (pattern266 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13935; /* aarch64_sme_umopavnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13949; /* aarch64_sme_umopavnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13943; /* aarch64_sme_umopavnx2divnx8hi */

            default:
              return -1;
            }

        case 674:
          switch (pattern266 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13936; /* aarch64_sme_umopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13950; /* aarch64_sme_umopsvnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13944; /* aarch64_sme_umopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 677:
          switch (pattern267 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13937; /* aarch64_sme_usmopavnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13945; /* aarch64_sme_usmopavnx2divnx8hi */

            default:
              return -1;
            }

        case 678:
          switch (pattern267 (x1))
            {
            case 0:
              if (!
#line 1702 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13938; /* aarch64_sme_usmopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13946; /* aarch64_sme_usmopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 637:
          if (pattern268 (x1) != 0
              || !
#line 1747 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13951; /* aarch64_sme_bmopavnx4sivnx4si */

        case 638:
          if (pattern268 (x1) != 0
              || !
#line 1747 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13952; /* aarch64_sme_bmopsvnx4sivnx4si */

        case 644:
          switch (pattern270 (x1))
            {
            case 0:
              if (!
#line 2106 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14145; /* aarch64_sme_fmopavnx4sfvnx4sf */

            case 1:
              if (!(
#line 2106 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 734 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
                return -1;
              return 14147; /* aarch64_sme_fmopavnx2dfvnx2df */

            case 2:
              if (!(
#line 2106 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
                return -1;
              return 14149; /* aarch64_sme_fmopavnx8hfvnx8hf */

            case 3:
              if (!(
#line 2106 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 736 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
                return -1;
              return 14151; /* aarch64_sme_fmopavnx8bfvnx8bf */

            case 4:
              if (!
#line 2121 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14153; /* aarch64_sme_fmopavnx4sivnx8bf */

            case 5:
              if (!
#line 2121 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14155; /* aarch64_sme_fmopavnx4sivnx8hf */

            default:
              return -1;
            }

        case 645:
          switch (pattern270 (x1))
            {
            case 0:
              if (!
#line 2106 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14146; /* aarch64_sme_fmopsvnx4sfvnx4sf */

            case 1:
              if (!(
#line 2106 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 734 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
                return -1;
              return 14148; /* aarch64_sme_fmopsvnx2dfvnx2df */

            case 2:
              if (!(
#line 2106 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
                return -1;
              return 14150; /* aarch64_sme_fmopsvnx8hfvnx8hf */

            case 3:
              if (!(
#line 2106 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 736 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
                return -1;
              return 14152; /* aarch64_sme_fmopsvnx8bfvnx8bf */

            case 4:
              if (!
#line 2121 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14154; /* aarch64_sme_fmopsvnx4sivnx8bf */

            case 5:
              if (!
#line 2121 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14156; /* aarch64_sme_fmopsvnx4sivnx8hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 6:
      return recog_449 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_523 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 576; /* one_cmplsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 577; /* one_cmpldi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1802; /* one_cmplv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1805; /* one_cmplv16qi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1806; /* one_cmplv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1809; /* one_cmplv8hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1810; /* one_cmplv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1813; /* one_cmplv4si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1814; /* one_cmplv2di2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern298 (x3))
        {
        case 0:
          return 579; /* *one_cmpl_ashlsi2 */

        case 1:
          return 584; /* *one_cmpl_ashldi2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern298 (x3))
        {
        case 0:
          return 580; /* *one_cmpl_ashrsi2 */

        case 1:
          return 585; /* *one_cmpl_ashrdi2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern298 (x3))
        {
        case 0:
          return 581; /* *one_cmpl_lshrsi2 */

        case 1:
          return 586; /* *one_cmpl_lshrdi2 */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern298 (x3))
        {
        case 0:
          return 582; /* *one_cmpl_rotrsi2 */

        case 1:
          return 587; /* *one_cmpl_rotrdi2 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern298 (x3))
        {
        case 0:
          return 583; /* *one_cmpl_rotlsi2 */

        case 1:
          return 588; /* *one_cmpl_rotldi2 */

        default:
          return -1;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern370 (x3))
            {
            case 0:
              return 596; /* *xor_one_cmplsi3 */

            case 1:
              return 597; /* *xor_one_cmpldi3 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern415 (x3))
            {
            case 0:
              return 648; /* *eor_one_cmpl_ashlsi3_alt */

            case 1:
              return 653; /* *eor_one_cmpl_ashldi3_alt */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern415 (x3))
            {
            case 0:
              return 649; /* *eor_one_cmpl_ashrsi3_alt */

            case 1:
              return 654; /* *eor_one_cmpl_ashrdi3_alt */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern415 (x3))
            {
            case 0:
              return 650; /* *eor_one_cmpl_lshrsi3_alt */

            case 1:
              return 655; /* *eor_one_cmpl_lshrdi3_alt */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern415 (x3))
            {
            case 0:
              return 651; /* *eor_one_cmpl_rotrsi3_alt */

            case 1:
              return 656; /* *eor_one_cmpl_rotrdi3_alt */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern415 (x3))
            {
            case 0:
              return 652; /* *eor_one_cmpl_rotlsi3_alt */

            case 1:
              return 657; /* *eor_one_cmpl_rotldi3_alt */

            default:
              return -1;
            }

        case AND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != XOR)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern901 (x3, 
E_V8QImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11962; /* *aarch64_sve2_nbsl_unpredv8qi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11963; /* *aarch64_sve2_nbsl_unpredv8qi */

            case E_V16QImode:
              if (pattern901 (x3, 
E_V16QImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11964; /* *aarch64_sve2_nbsl_unpredv16qi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11965; /* *aarch64_sve2_nbsl_unpredv16qi */

            case E_V4HImode:
              if (pattern901 (x3, 
E_V4HImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11966; /* *aarch64_sve2_nbsl_unpredv4hi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11967; /* *aarch64_sve2_nbsl_unpredv4hi */

            case E_V8HImode:
              if (pattern901 (x3, 
E_V8HImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11968; /* *aarch64_sve2_nbsl_unpredv8hi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11969; /* *aarch64_sve2_nbsl_unpredv8hi */

            case E_V2SImode:
              if (pattern901 (x3, 
E_V2SImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11970; /* *aarch64_sve2_nbsl_unpredv2si */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11971; /* *aarch64_sve2_nbsl_unpredv2si */

            case E_V4SImode:
              if (pattern901 (x3, 
E_V4SImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11972; /* *aarch64_sve2_nbsl_unpredv4si */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11973; /* *aarch64_sve2_nbsl_unpredv4si */

            case E_V2DImode:
              if (pattern901 (x3, 
E_V2DImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11974; /* *aarch64_sve2_nbsl_unpredv2di */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11975; /* *aarch64_sve2_nbsl_unpredv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_527 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern314 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern760 (x3, 
E_SImode) == 0
                  && 
#line 7384 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1082; /* *aarch64_smaxsi3_cssc */
              break;

            case E_DImode:
              if (pattern760 (x3, 
E_DImode) == 0
                  && 
#line 7384 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1086; /* *aarch64_smaxdi3_cssc */
              break;

            case E_SFmode:
              if (pattern31 (x3, 
E_SFmode) == 0
                  && 
#line 7409 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1094; /* smaxsf3 */
              break;

            case E_DFmode:
              if (pattern31 (x3, 
E_DFmode) == 0
                  && 
#line 7409 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1095; /* smaxdf3 */
              break;

            case E_V8QImode:
              if (pattern31 (x3, 
E_V8QImode) == 0
                  && 
#line 1754 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2072; /* smaxv8qi3 */
              break;

            case E_V16QImode:
              if (pattern31 (x3, 
E_V16QImode) == 0
                  && 
#line 1754 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2084; /* smaxv16qi3 */
              break;

            case E_V4HImode:
              if (pattern31 (x3, 
E_V4HImode) == 0
                  && 
#line 1754 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2088; /* smaxv4hi3 */
              break;

            case E_V8HImode:
              if (pattern31 (x3, 
E_V8HImode) == 0
                  && 
#line 1754 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2100; /* smaxv8hi3 */
              break;

            case E_V2SImode:
              if (pattern31 (x3, 
E_V2SImode) == 0
                  && 
#line 1754 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2104; /* smaxv2si3 */
              break;

            case E_V4SImode:
              if (pattern31 (x3, 
E_V4SImode) == 0
                  && 
#line 1754 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2116; /* smaxv4si3 */
              break;

            case E_V4HFmode:
              if (pattern31 (x3, 
E_V4HFmode) == 0
                  && (
#line 3348 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2670; /* smaxv4hf3 */
              break;

            case E_V8HFmode:
              if (pattern31 (x3, 
E_V8HFmode) == 0
                  && (
#line 3348 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2672; /* smaxv8hf3 */
              break;

            case E_V2SFmode:
              if (pattern31 (x3, 
E_V2SFmode) == 0
                  && 
#line 3348 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2674; /* smaxv2sf3 */
              break;

            case E_V4SFmode:
              if (pattern31 (x3, 
E_V4SFmode) == 0
                  && 
#line 3348 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2676; /* smaxv4sf3 */
              break;

            case E_V2DFmode:
              if (pattern31 (x3, 
E_V2DFmode) == 0
                  && 
#line 3348 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2678; /* smaxv2df3 */
              break;

            case E_VNx32QImode:
              if (pattern32 (x3, 
E_VNx32QImode) == 0
                  && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11456; /* *smaxvnx32qi3 */
              break;

            case E_VNx16HImode:
              if (pattern32 (x3, 
E_VNx16HImode) == 0
                  && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11460; /* *smaxvnx16hi3 */
              break;

            case E_VNx8SImode:
              if (pattern32 (x3, 
E_VNx8SImode) == 0
                  && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11464; /* *smaxvnx8si3 */
              break;

            case E_VNx4DImode:
              if (pattern32 (x3, 
E_VNx4DImode) == 0
                  && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11468; /* *smaxvnx4di3 */
              break;

            case E_VNx64QImode:
              if (pattern32 (x3, 
E_VNx64QImode) == 0
                  && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11472; /* *smaxvnx64qi3 */
              break;

            case E_VNx32HImode:
              if (pattern32 (x3, 
E_VNx32HImode) == 0
                  && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11476; /* *smaxvnx32hi3 */
              break;

            case E_VNx16SImode:
              if (pattern32 (x3, 
E_VNx16SImode) == 0
                  && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11480; /* *smaxvnx16si3 */
              break;

            case E_VNx8DImode:
              if (pattern32 (x3, 
E_VNx8DImode) == 0
                  && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11484; /* *smaxvnx8di3 */
              break;

            default:
              break;
            }
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern2 (x3))
            {
            case 0:
              return 1090; /* *aarch64_smaxsi3_zero */

            case 1:
              return 1092; /* *aarch64_smaxdi3_zero */

            default:
              return -1;
            }

        case 1:
          if (!
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7420; /* *post_ra_smaxvnx16qi3 */

        case 2:
          if (!
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7425; /* *post_ra_smaxvnx8qi3 */

        case 3:
          if (!
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7430; /* *post_ra_smaxvnx4qi3 */

        case 4:
          if (!
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7435; /* *post_ra_smaxvnx2qi3 */

        case 5:
          if (!
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7440; /* *post_ra_smaxvnx8hi3 */

        case 6:
          if (!
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7445; /* *post_ra_smaxvnx4hi3 */

        case 7:
          if (!
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7450; /* *post_ra_smaxvnx2hi3 */

        case 8:
          if (!
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7455; /* *post_ra_smaxvnx4si3 */

        case 9:
          if (!
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7460; /* *post_ra_smaxvnx2si3 */

        case 10:
          if (!
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7465; /* *post_ra_smaxvnx2di3 */

        case 11:
          if (!
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7470; /* *post_ra_smaxv2di3 */

        case 12:
          if (!
#line 745 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11489; /* aarch64_sve_single_smaxvnx32qi */

        case 13:
          if (!
#line 745 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11494; /* aarch64_sve_single_smaxvnx16hi */

        case 14:
          if (!
#line 745 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11499; /* aarch64_sve_single_smaxvnx8si */

        case 15:
          if (!
#line 745 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11504; /* aarch64_sve_single_smaxvnx4di */

        case 16:
          if (!
#line 745 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11509; /* aarch64_sve_single_smaxvnx64qi */

        case 17:
          if (!
#line 745 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11514; /* aarch64_sve_single_smaxvnx32hi */

        case 18:
          if (!
#line 745 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11519; /* aarch64_sve_single_smaxvnx16si */

        case 19:
          if (!
#line 745 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11524; /* aarch64_sve_single_smaxvnx8di */

        default:
          return -1;
        }

    case ABS:
      switch (pattern315 (x3))
        {
        case 0:
          if (!(
#line 10043 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5291; /* *aarch64_faminmax_fused */

        case 1:
          if (!(
#line 10043 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5293; /* *aarch64_faminmax_fused */

        case 2:
          if (!
#line 10043 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5295; /* *aarch64_faminmax_fused */

        case 3:
          if (!
#line 10043 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5297; /* *aarch64_faminmax_fused */

        case 4:
          if (!
#line 10043 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5299; /* *aarch64_faminmax_fused */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_541 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      switch (pattern449 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3251; /* ussubv8qi3 */

        case 1:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3257; /* ussubv16qi3 */

        case 2:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3267; /* ussubv4hi3 */

        case 3:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3273; /* ussubv8hi3 */

        case 4:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3283; /* ussubv2si3 */

        case 5:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3289; /* ussubv4si3 */

        case 6:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3293; /* ussubv2di3 */

        case 7:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3297; /* ussubhi3 */

        case 8:
          if (!
#line 5170 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3301; /* ussubqi3 */

        case 9:
          *pnum_clobbers = 1;
          return 3307; /* ussubsi3 */

        case 10:
          *pnum_clobbers = 1;
          return 3309; /* ussubdi3 */

        case 11:
          if (!
#line 4473 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8107; /* ussubvnx16qi3 */

        case 12:
          if (!
#line 4473 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8109; /* ussubvnx8hi3 */

        case 13:
          if (!
#line 4473 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8111; /* ussubvnx4si3 */

        case 14:
          if (!
#line 4473 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8113; /* ussubvnx2di3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern451 (x3))
        {
        case 0:
          if (!
#line 10531 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11047; /* aarch64_sve_uqdecdi_pat */

        case 1:
          if (!
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11099; /* *aarch64_sve_uqdecdivnx16bi_cntp */

        case 2:
          if (!
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11102; /* *aarch64_sve_uqdecdivnx8bi_cntp */

        case 3:
          if (!
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11105; /* *aarch64_sve_uqdecdivnx4bi_cntp */

        case 4:
          if (!
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11108; /* *aarch64_sve_uqdecdivnx2bi_cntp */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern452 (x3))
        {
        case 0:
          if (!
#line 10596 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11053; /* aarch64_sve_uqdecvnx2di_pat */

        case 1:
          if (!
#line 11056 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11123; /* *aarch64_sve_uqdecvnx2di_cntp */

        case 2:
          if (!
#line 10617 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11056; /* aarch64_sve_uqdecvnx4si_pat */

        case 3:
          if (!
#line 11095 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11126; /* *aarch64_sve_uqdecvnx4si_cntp */

        case 4:
          if (!
#line 10652 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11059; /* *aarch64_sve_uqdecvnx8hi_pat */

        case 5:
          if (!
#line 11136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11129; /* *aarch64_sve_uqdecvnx8hi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_559 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10119; /* *while_rwsivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10129; /* *while_rwdivnx2bi_cc */
}

 int
recog_567 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10118; /* *while_ugesivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10128; /* *while_ugedivnx2bi_cc */
}

 int
recog_576 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10097; /* *while_ugtsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10107; /* *while_ugtdivnx4bi_cc */
}

 int
recog_586 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10056; /* *while_gtsivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10066; /* *while_gtdivnx16bi_cc */
}

 int
recog_596 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  switch (GET_CODE (x4))
    {
    case CONST:
      switch (pattern1094 (x1))
        {
        case 0:
          if (!
#line 983 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5718; /* *aarch64_sve_ptruevnx16bi_cc */

        case 1:
          if (!
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5722; /* *aarch64_sve_ptruevnx16bi_ptest */

        default:
          return -1;
        }

    case SUBREG:
      switch (pattern1096 (x1))
        {
        case 0:
          if (!
#line 1009 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5719; /* *aarch64_sve_ptruevnx8bi_cc */

        case 1:
          if (!
#line 1009 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5720; /* *aarch64_sve_ptruevnx4bi_cc */

        case 2:
          if (!
#line 1009 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5721; /* *aarch64_sve_ptruevnx2bi_cc */

        case 3:
          if (!
#line 1061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5723; /* *aarch64_sve_ptruevnx8bi_ptest */

        case 4:
          if (!
#line 1061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5724; /* *aarch64_sve_ptruevnx4bi_ptest */

        case 5:
          if (!
#line 1061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 5725; /* *aarch64_sve_ptruevnx2bi_ptest */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x4) != 86
          || GET_MODE (x4) != E_VNx16BImode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_VNx16BImode))
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case CLOBBER:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          if (!scratch_operand (operands[0], E_VNx16BImode)
              || !
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 5734; /* *aarch64_rdffr_ptest */

        case SET:
          x9 = XEXP (x7, 1);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 86
              || GET_MODE (x9) != E_VNx16BImode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_VNx16BImode)
              || !
#line 1242 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 5736; /* *aarch64_rdffr_cc */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_595 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_606 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XINT (x4, 1))
    {
    case 126:
      return recog_600 (x1, insn, pnum_clobbers);

    case 140:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9971; /* while_lesivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9981; /* while_ledivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9991; /* while_lesivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10001; /* while_ledivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10011; /* while_lesivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10021; /* while_ledivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10031; /* while_lesivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10041; /* while_ledivnx2bi */

        default:
          return -1;
        }

    case 141:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9972; /* while_ultsivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9982; /* while_ultdivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9992; /* while_ultsivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10002; /* while_ultdivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10012; /* while_ultsivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10022; /* while_ultdivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10032; /* while_ultsivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10042; /* while_ultdivnx2bi */

        default:
          return -1;
        }

    case 142:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9973; /* while_ulesivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9983; /* while_uledivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9993; /* while_ulesivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10003; /* while_uledivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10013; /* while_ulesivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10023; /* while_uledivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10033; /* while_ulesivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10043; /* while_uledivnx2bi */

        default:
          return -1;
        }

    case 143:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9974; /* while_ltsivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9984; /* while_ltdivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9994; /* while_ltsivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10004; /* while_ltdivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10014; /* while_ltsivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10024; /* while_ltdivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10034; /* while_ltsivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10044; /* while_ltdivnx2bi */

        default:
          return -1;
        }

    case 136:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9975; /* while_gesivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 9985; /* while_gedivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9995; /* while_gesivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10005; /* while_gedivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 10015; /* while_gesivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10025; /* while_gedivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 10035; /* while_gesivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10045; /* while_gedivnx2bi */

        default:
          return -1;
        }

    case 137:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9976; /* while_gtsivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 9986; /* while_gtdivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9996; /* while_gtsivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10006; /* while_gtdivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 10016; /* while_gtsivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10026; /* while_gtdivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 10036; /* while_gtsivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10046; /* while_gtdivnx2bi */

        default:
          return -1;
        }

    case 138:
      return recog_604 (x1, insn, pnum_clobbers);

    case 139:
      return recog_603 (x1, insn, pnum_clobbers);

    case 144:
      return recog_602 (x1, insn, pnum_clobbers);

    case 145:
      return recog_601 (x1, insn, pnum_clobbers);

    case 305:
      switch (pattern691 (x1))
        {
        case 0:
          if (!
#line 10271 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 8))
            return -1;
          return 11005; /* aarch64_sve_pfirstvnx16bi */

        case 1:
          if (!
#line 10271 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
            return -1;
          return 11007; /* aarch64_sve_pfirstvnx8bi */

        case 2:
          if (!
#line 10271 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
            return -1;
          return 11009; /* aarch64_sve_pfirstvnx4bi */

        case 3:
          if (!
#line 10271 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
            return -1;
          return 11011; /* aarch64_sve_pfirstvnx2bi */

        default:
          return -1;
        }

    case 306:
      switch (pattern691 (x1))
        {
        case 0:
          if (!
#line 10271 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 8))
            return -1;
          return 11006; /* aarch64_sve_pnextvnx16bi */

        case 1:
          if (!
#line 10271 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return -1;
          return 11008; /* aarch64_sve_pnextvnx8bi */

        case 2:
          if (!
#line 10271 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return -1;
          return 11010; /* aarch64_sve_pnextvnx4bi */

        case 3:
          if (!
#line 10271 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return -1;
          return 11012; /* aarch64_sve_pnextvnx2bi */

        default:
          return -1;
        }

    case 471:
      switch (pattern693 (x1, 
471))
        {
        case 0:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11222; /* aarch64_ld1vnx32qi_strided2 */

        case 1:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11224; /* aarch64_ld1vnx16hi_strided2 */

        case 2:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11226; /* aarch64_ld1vnx8si_strided2 */

        case 3:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11228; /* aarch64_ld1vnx4di_strided2 */

        case 4:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11230; /* aarch64_ld1vnx16bf_strided2 */

        case 5:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11232; /* aarch64_ld1vnx16hf_strided2 */

        case 6:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11234; /* aarch64_ld1vnx8sf_strided2 */

        case 7:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11236; /* aarch64_ld1vnx4df_strided2 */

        default:
          return -1;
        }

    case 472:
      switch (pattern693 (x1, 
472))
        {
        case 0:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11223; /* aarch64_ldnt1vnx32qi_strided2 */

        case 1:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11225; /* aarch64_ldnt1vnx16hi_strided2 */

        case 2:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11227; /* aarch64_ldnt1vnx8si_strided2 */

        case 3:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11229; /* aarch64_ldnt1vnx4di_strided2 */

        case 4:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11231; /* aarch64_ldnt1vnx16bf_strided2 */

        case 5:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11233; /* aarch64_ldnt1vnx16hf_strided2 */

        case 6:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11235; /* aarch64_ldnt1vnx8sf_strided2 */

        case 7:
          if (!
#line 293 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11237; /* aarch64_ldnt1vnx4df_strided2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_622 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      if (pattern37 (x1) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      switch (pattern1160 (x3))
        {
        case 0:
          return 63; /* *call_insn */

        case 1:
          if (!
#line 1412 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 65; /* *sibcall_insn */

        default:
          return -1;
        }

    case SET:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CALL:
          if (pattern357 (x1) != 0)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          res = recog_617 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          x6 = XEXP (x4, 0);
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != UNSPEC
              || pattern985 (x2) != 0)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (pattern373 (x3, 
30, 
CLOBBER, 
E_DImode) != 0)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[0] = x8;
          if (!aarch64_valid_symref (operands[0], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XVECEXP (x9, 0, 0);
          operands[1] = x10;
          if (!const_int_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (GET_MODE (x7) != E_SImode
                  || !(
#line 7868 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && TARGET_SVE) && 
#line 168 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode)))
                return -1;
              return 1152; /* tlsdesc_small_sve_si */

            case E_DImode:
              if (GET_MODE (x7) != E_DImode
                  || !(
#line 7868 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && TARGET_SVE) && 
#line 168 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode)))
                return -1;
              return 1153; /* tlsdesc_small_sve_di */

            default:
              return -1;
            }

        case PLUS:
          if (!pmode_plus_operator (x4, E_VOIDmode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != SET)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!pmode_register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!pmode_register_operand (operands[1], E_VOIDmode))
            return -1;
          x11 = XEXP (x4, 1);
          operands[4] = x11;
          if (!const_int_operand (operands[4], E_VOIDmode))
            return -1;
          x12 = XEXP (x9, 1);
          if (memory_operand (x12, E_VOIDmode))
            {
              res = recog_618 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x13 = XEXP (x9, 0);
          if (GET_CODE (x13) != MEM)
            return -1;
          operands[6] = x13;
          if (aarch64_mem_pair_operator (operands[6], E_TImode))
            {
              res = recog_619 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x14 = XEXP (x3, 0);
          if (GET_CODE (x14) != MEM)
            return -1;
          x15 = XEXP (x14, 0);
          if (!pmode_plus_operator (x15, E_VOIDmode))
            return -1;
          operands[2] = x12;
          x16 = XEXP (x3, 1);
          operands[3] = x16;
          x17 = XEXP (x15, 0);
          if (!rtx_equal_p (x17, operands[0]))
            return -1;
          x18 = XEXP (x13, 0);
          switch (GET_CODE (x18))
            {
            case PLUS:
              operands[8] = x18;
              if (!pmode_plus_operator (operands[8], E_VOIDmode))
                return -1;
              operands[6] = x4;
              operands[7] = x13;
              operands[9] = x14;
              if (aarch64_mem_pair_operator (operands[9], E_SImode)
                  && pattern1356 (x1, 
E_SImode) == 0
                  && 
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], SImode)
   && known_eq (INTVAL (operands[5]),
		INTVAL (operands[4]) + GET_MODE_SIZE (SImode))
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                return 100; /* *storewb_pre_pair_4 */
              if (aarch64_mem_pair_operator (operands[9], E_DImode)
                  && pattern1356 (x1, 
E_DImode) == 0
                  && 
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], DImode)
   && known_eq (INTVAL (operands[5]),
		INTVAL (operands[4]) + GET_MODE_SIZE (DImode))
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                return 101; /* *storewb_pre_pair_8 */
              if (!aarch64_mem_pair_operator (operands[9], E_TImode)
                  || !aarch64_mem_pair_operator (operands[7], E_TImode)
                  || !aarch64_ldp_reg_operand (operands[2], E_TImode))
                return -1;
              operands[10] = x15;
              x19 = XEXP (x15, 1);
              operands[5] = x19;
              if (!const_int_operand (operands[5], E_VOIDmode)
                  || !aarch64_ldp_reg_operand (operands[3], E_TImode))
                return -1;
              x20 = XEXP (x18, 0);
              if (!rtx_equal_p (x20, operands[0]))
                return -1;
              x21 = XEXP (x18, 1);
              if (!rtx_equal_p (x21, operands[4])
                  || !
#line 2265 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && aarch64_mem_pair_offset (operands[4], TImode)
   && known_eq (INTVAL (operands[5]), INTVAL (operands[4]) + 16)
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                return -1;
              return 102; /* *storewb_pre_pair_16 */

            case REG:
            case SUBREG:
              if (!rtx_equal_p (x18, operands[1]))
                return -1;
              x19 = XEXP (x15, 1);
              if (GET_CODE (x19) != CONST_INT)
                return -1;
              operands[5] = x4;
              operands[6] = x13;
              if (!aarch64_stp_reg_operand (operands[2], E_VOIDmode))
                return -1;
              operands[7] = x14;
              operands[8] = x15;
              if (!aarch64_stp_reg_operand (operands[3], E_VOIDmode))
                return -1;
              switch (XWINT (x19, 0))
                {
                case 4LL:
                  if (!aarch64_mem_pair_operator (operands[6], E_SImode)
                      || !aarch64_mem_pair_operator (operands[7], E_SImode)
                      || !
#line 2289 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], SImode)
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                    return -1;
                  return 103; /* *storewb_post_pair_4 */

                case 8LL:
                  if (!aarch64_mem_pair_operator (operands[6], E_DImode)
                      || !aarch64_mem_pair_operator (operands[7], E_DImode)
                      || !
#line 2289 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], DImode)
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                    return -1;
                  return 104; /* *storewb_post_pair_8 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x4, 0) != 2
              || XINT (x4, 1) != 109
              || GET_MODE (x4) != E_CCmode)
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 66
              || GET_MODE (x5) != E_CCmode)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return -1;
          x22 = XVECEXP (x4, 0, 0);
          operands[0] = x22;
          x23 = XVECEXP (x4, 0, 1);
          operands[1] = x23;
          x13 = XEXP (x9, 0);
          operands[2] = x13;
          x14 = XEXP (x3, 0);
          operands[3] = x14;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1257 (
E_SImode) != 0
                  || !
#line 168 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
                return -1;
              return 1173; /* stack_protect_test_si */

            case E_DImode:
              if (pattern1257 (
E_DImode) != 0
                  || !
#line 168 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
                return -1;
              return 1174; /* stack_protect_test_di */

            default:
              return -1;
            }

        case SS_PLUS:
          switch (pattern359 (x1))
            {
            case 0:
              return 3302; /* aarch64_ssaddsi3 */

            case 1:
              return 3304; /* aarch64_ssadddi3 */

            default:
              return -1;
            }

        case SS_MINUS:
          switch (pattern359 (x1))
            {
            case 0:
              return 3303; /* aarch64_sssubsi3 */

            case 1:
              return 3305; /* aarch64_sssubdi3 */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (pnum_clobbers == NULL
              || pattern364 (x4, 
E_CCmode, 
27) != 0
              || pattern715 (x1, 
SET, 
E_CCmode) != 0)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != SET)
            return -1;
          x16 = XEXP (x3, 1);
          if (GET_CODE (x16) != UNSPEC_VOLATILE
              || XVECLEN (x16, 0) != 5
              || XINT (x16, 1) != 27)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x13 = XEXP (x9, 0);
          operands[0] = x13;
          x24 = XVECEXP (x16, 0, 0);
          operands[2] = x24;
          x25 = XVECEXP (x16, 0, 1);
          operands[3] = x25;
          x26 = XVECEXP (x16, 0, 2);
          operands[4] = x26;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          x27 = XVECEXP (x16, 0, 3);
          operands[5] = x27;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x28 = XVECEXP (x16, 0, 4);
          operands[6] = x28;
          if (!const_int_operand (operands[6], E_SImode))
            return -1;
          switch (pattern570 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 5365; /* aarch64_compare_and_swapqi */

            case 1:
              *pnum_clobbers = 1;
              return 5366; /* aarch64_compare_and_swaphi */

            case 2:
              *pnum_clobbers = 1;
              return 5367; /* aarch64_compare_and_swapsi */

            case 3:
              *pnum_clobbers = 1;
              return 5368; /* aarch64_compare_and_swapdi */

            case 4:
              *pnum_clobbers = 1;
              return 5369; /* aarch64_compare_and_swapti */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x4, 0) != 1LL
              || pattern456 (x1, 
91, 
USE, 
90, 
E_DImode, 
89) != 0)
            return -1;
          return 12995; /* aarch64_smstart_za */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !aarch64_mov_operand (operands[1], E_SImode)
          || !
#line 1602 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(CONST_INT_P (operands[1]) && !aarch64_move_imm (INTVAL (operands[1]), SImode)
    && REG_P (operands[0]) && GP_REGNUM_P (REGNO (operands[0]))))
        return NULL;
      return gen_split_9 (insn, operands);

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !aarch64_mov_operand (operands[1], E_DImode)
          || !
#line 1642 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(CONST_INT_P (operands[1])
   && REG_P (operands[0])
   && ((!aarch64_move_imm (INTVAL (operands[1]), DImode)
	&& GP_REGNUM_P (REGNO (operands[0])))
       || (aarch64_simd_special_constant_p (operands[1], DImode)
	   && FP_REGNUM_P (REGNO (operands[0]))))))
        return NULL;
      return gen_split_10 (insn, operands);

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !aarch64_reg_or_imm (operands[1], E_TImode)
          || !
#line 1738 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(reload_completed && aarch64_split_128bit_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_11 (insn, operands);

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || !nonmemory_operand (operands[1], E_TDmode)
          || !
#line 1878 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(reload_completed && aarch64_split_128bit_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_12 (insn, operands);

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !nonmemory_operand (operands[1], E_TFmode)
          || !
#line 1878 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(reload_completed && aarch64_split_128bit_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_13 (insn, operands);

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !
#line 167 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(CONST_INT_P (operands[1])
   && aarch64_simd_special_constant_p (operands[1], V8QImode)
   && FP_REGNUM_P (REGNO (operands[0]))))
        return NULL;
      return gen_split_127 (insn, operands);

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !
#line 167 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(CONST_INT_P (operands[1])
   && aarch64_simd_special_constant_p (operands[1], V4HImode)
   && FP_REGNUM_P (REGNO (operands[0]))))
        return NULL;
      return gen_split_128 (insn, operands);

    case E_V4HFmode:
      if (!nonimmediate_operand (operands[0], E_V4HFmode)
          || !general_operand (operands[1], E_V4HFmode)
          || !
#line 167 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(CONST_INT_P (operands[1])
   && aarch64_simd_special_constant_p (operands[1], V4HFmode)
   && FP_REGNUM_P (REGNO (operands[0]))))
        return NULL;
      return gen_split_129 (insn, operands);

    case E_V4BFmode:
      if (!nonimmediate_operand (operands[0], E_V4BFmode)
          || !general_operand (operands[1], E_V4BFmode)
          || !
#line 167 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(CONST_INT_P (operands[1])
   && aarch64_simd_special_constant_p (operands[1], V4BFmode)
   && FP_REGNUM_P (REGNO (operands[0]))))
        return NULL;
      return gen_split_130 (insn, operands);

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 167 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(CONST_INT_P (operands[1])
   && aarch64_simd_special_constant_p (operands[1], V2SImode)
   && FP_REGNUM_P (REGNO (operands[0]))))
        return NULL;
      return gen_split_131 (insn, operands);

    case E_V2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !general_operand (operands[1], E_V2SFmode)
          || !
#line 167 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(CONST_INT_P (operands[1])
   && aarch64_simd_special_constant_p (operands[1], V2SFmode)
   && FP_REGNUM_P (REGNO (operands[0]))))
        return NULL;
      return gen_split_132 (insn, operands);

    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !general_operand (operands[1], E_V16QImode)
          || !(
#line 180 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V16QImode)
       || aarch64_simd_reg_or_zero (operands[1], V16QImode))) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( reload_completed
   && ((REG_P (operands[0])
	&& REG_P (operands[1])
	&& !(FP_REGNUM_P (REGNO (operands[0]))
	     && FP_REGNUM_P (REGNO (operands[1]))))
       || (aarch64_simd_special_constant_p (operands[1], V16QImode)
	   && FP_REGNUM_P (REGNO (operands[0])))))))
        return NULL;
      return gen_split_133 (insn, operands);

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !general_operand (operands[1], E_V8HImode)
          || !(
#line 180 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V8HImode)
       || aarch64_simd_reg_or_zero (operands[1], V8HImode))) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( reload_completed
   && ((REG_P (operands[0])
	&& REG_P (operands[1])
	&& !(FP_REGNUM_P (REGNO (operands[0]))
	     && FP_REGNUM_P (REGNO (operands[1]))))
       || (aarch64_simd_special_constant_p (operands[1], V8HImode)
	   && FP_REGNUM_P (REGNO (operands[0])))))))
        return NULL;
      return gen_split_134 (insn, operands);

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !general_operand (operands[1], E_V4SImode)
          || !(
#line 180 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4SImode)
       || aarch64_simd_reg_or_zero (operands[1], V4SImode))) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( reload_completed
   && ((REG_P (operands[0])
	&& REG_P (operands[1])
	&& !(FP_REGNUM_P (REGNO (operands[0]))
	     && FP_REGNUM_P (REGNO (operands[1]))))
       || (aarch64_simd_special_constant_p (operands[1], V4SImode)
	   && FP_REGNUM_P (REGNO (operands[0])))))))
        return NULL;
      return gen_split_135 (insn, operands);

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode)
          || !(
#line 180 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2DImode)
       || aarch64_simd_reg_or_zero (operands[1], V2DImode))) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( reload_completed
   && ((REG_P (operands[0])
	&& REG_P (operands[1])
	&& !(FP_REGNUM_P (REGNO (operands[0]))
	     && FP_REGNUM_P (REGNO (operands[1]))))
       || (aarch64_simd_special_constant_p (operands[1], V2DImode)
	   && FP_REGNUM_P (REGNO (operands[0])))))))
        return NULL;
      return gen_split_136 (insn, operands);

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !general_operand (operands[1], E_V8HFmode)
          || !(
#line 180 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V8HFmode)
       || aarch64_simd_reg_or_zero (operands[1], V8HFmode))) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( reload_completed
   && ((REG_P (operands[0])
	&& REG_P (operands[1])
	&& !(FP_REGNUM_P (REGNO (operands[0]))
	     && FP_REGNUM_P (REGNO (operands[1]))))
       || (aarch64_simd_special_constant_p (operands[1], V8HFmode)
	   && FP_REGNUM_P (REGNO (operands[0])))))))
        return NULL;
      return gen_split_137 (insn, operands);

    case E_V8BFmode:
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !general_operand (operands[1], E_V8BFmode)
          || !(
#line 180 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V8BFmode)
       || aarch64_simd_reg_or_zero (operands[1], V8BFmode))) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( reload_completed
   && ((REG_P (operands[0])
	&& REG_P (operands[1])
	&& !(FP_REGNUM_P (REGNO (operands[0]))
	     && FP_REGNUM_P (REGNO (operands[1]))))
       || (aarch64_simd_special_constant_p (operands[1], V8BFmode)
	   && FP_REGNUM_P (REGNO (operands[0])))))))
        return NULL;
      return gen_split_138 (insn, operands);

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !general_operand (operands[1], E_V4SFmode)
          || !(
#line 180 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4SFmode)
       || aarch64_simd_reg_or_zero (operands[1], V4SFmode))) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( reload_completed
   && ((REG_P (operands[0])
	&& REG_P (operands[1])
	&& !(FP_REGNUM_P (REGNO (operands[0]))
	     && FP_REGNUM_P (REGNO (operands[1]))))
       || (aarch64_simd_special_constant_p (operands[1], V4SFmode)
	   && FP_REGNUM_P (REGNO (operands[0])))))))
        return NULL;
      return gen_split_139 (insn, operands);

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !general_operand (operands[1], E_V2DFmode)
          || !(
#line 180 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2DFmode)
       || aarch64_simd_reg_or_zero (operands[1], V2DFmode))) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( reload_completed
   && ((REG_P (operands[0])
	&& REG_P (operands[1])
	&& !(FP_REGNUM_P (REGNO (operands[0]))
	     && FP_REGNUM_P (REGNO (operands[1]))))
       || (aarch64_simd_special_constant_p (operands[1], V2DFmode)
	   && FP_REGNUM_P (REGNO (operands[0])))))))
        return NULL;
      return gen_split_140 (insn, operands);

    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode)
          || !register_operand (operands[1], E_V2x8QImode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_289 (insn, operands);

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode)
          || !register_operand (operands[1], E_V2x4HImode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_290 (insn, operands);

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode)
          || !register_operand (operands[1], E_V2x2SImode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_291 (insn, operands);

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode)
          || !register_operand (operands[1], E_V2x1DImode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_292 (insn, operands);

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode)
          || !register_operand (operands[1], E_V2x4HFmode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_293 (insn, operands);

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode)
          || !register_operand (operands[1], E_V2x2SFmode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_294 (insn, operands);

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode)
          || !register_operand (operands[1], E_V2x1DFmode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_295 (insn, operands);

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode)
          || !register_operand (operands[1], E_V2x4BFmode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_296 (insn, operands);

    case E_V2x16QImode:
      if (!register_operand (operands[0], E_V2x16QImode)
          || !register_operand (operands[1], E_V2x16QImode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_297 (insn, operands);

    case E_V2x8HImode:
      if (!register_operand (operands[0], E_V2x8HImode)
          || !register_operand (operands[1], E_V2x8HImode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_298 (insn, operands);

    case E_V2x4SImode:
      if (!register_operand (operands[0], E_V2x4SImode)
          || !register_operand (operands[1], E_V2x4SImode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_299 (insn, operands);

    case E_V2x2DImode:
      if (!register_operand (operands[0], E_V2x2DImode)
          || !register_operand (operands[1], E_V2x2DImode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_300 (insn, operands);

    case E_V2x8HFmode:
      if (!register_operand (operands[0], E_V2x8HFmode)
          || !register_operand (operands[1], E_V2x8HFmode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_301 (insn, operands);

    case E_V2x4SFmode:
      if (!register_operand (operands[0], E_V2x4SFmode)
          || !register_operand (operands[1], E_V2x4SFmode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_302 (insn, operands);

    case E_V2x2DFmode:
      if (!register_operand (operands[0], E_V2x2DFmode)
          || !register_operand (operands[1], E_V2x2DFmode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_303 (insn, operands);

    case E_V2x8BFmode:
      if (!register_operand (operands[0], E_V2x8BFmode)
          || !register_operand (operands[1], E_V2x8BFmode)
          || !
#line 8210 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_304 (insn, operands);

    case E_OImode:
      if (!register_operand (operands[0], E_OImode)
          || !register_operand (operands[1], E_OImode)
          || !
#line 8220 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_305 (insn, operands);

    case E_V3x8QImode:
      if (!nonimmediate_operand (operands[0], E_V3x8QImode)
          || !general_operand (operands[1], E_V3x8QImode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_306 (insn, operands);

    case E_V3x4HImode:
      if (!nonimmediate_operand (operands[0], E_V3x4HImode)
          || !general_operand (operands[1], E_V3x4HImode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_307 (insn, operands);

    case E_V3x2SImode:
      if (!nonimmediate_operand (operands[0], E_V3x2SImode)
          || !general_operand (operands[1], E_V3x2SImode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_308 (insn, operands);

    case E_V3x1DImode:
      if (!nonimmediate_operand (operands[0], E_V3x1DImode)
          || !general_operand (operands[1], E_V3x1DImode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_309 (insn, operands);

    case E_V3x4HFmode:
      if (!nonimmediate_operand (operands[0], E_V3x4HFmode)
          || !general_operand (operands[1], E_V3x4HFmode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_310 (insn, operands);

    case E_V3x2SFmode:
      if (!nonimmediate_operand (operands[0], E_V3x2SFmode)
          || !general_operand (operands[1], E_V3x2SFmode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_311 (insn, operands);

    case E_V3x1DFmode:
      if (!nonimmediate_operand (operands[0], E_V3x1DFmode)
          || !general_operand (operands[1], E_V3x1DFmode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_312 (insn, operands);

    case E_V3x4BFmode:
      if (!nonimmediate_operand (operands[0], E_V3x4BFmode)
          || !general_operand (operands[1], E_V3x4BFmode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_313 (insn, operands);

    case E_V3x16QImode:
      if (!nonimmediate_operand (operands[0], E_V3x16QImode)
          || !general_operand (operands[1], E_V3x16QImode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_314 (insn, operands);

    case E_V3x8HImode:
      if (!nonimmediate_operand (operands[0], E_V3x8HImode)
          || !general_operand (operands[1], E_V3x8HImode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_315 (insn, operands);

    case E_V3x4SImode:
      if (!nonimmediate_operand (operands[0], E_V3x4SImode)
          || !general_operand (operands[1], E_V3x4SImode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_316 (insn, operands);

    case E_V3x2DImode:
      if (!nonimmediate_operand (operands[0], E_V3x2DImode)
          || !general_operand (operands[1], E_V3x2DImode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_317 (insn, operands);

    case E_V3x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V3x8HFmode)
          || !general_operand (operands[1], E_V3x8HFmode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_318 (insn, operands);

    case E_V3x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V3x4SFmode)
          || !general_operand (operands[1], E_V3x4SFmode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_319 (insn, operands);

    case E_V3x2DFmode:
      if (!nonimmediate_operand (operands[0], E_V3x2DFmode)
          || !general_operand (operands[1], E_V3x2DFmode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_320 (insn, operands);

    case E_V3x8BFmode:
      if (!nonimmediate_operand (operands[0], E_V3x8BFmode)
          || !general_operand (operands[1], E_V3x8BFmode)
          || !
#line 8230 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_321 (insn, operands);

    case E_CImode:
      if (!nonimmediate_operand (operands[0], E_CImode)
          || !general_operand (operands[1], E_CImode)
          || !
#line 8261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_322 (insn, operands);

    case E_V4x8QImode:
      if (!nonimmediate_operand (operands[0], E_V4x8QImode)
          || !general_operand (operands[1], E_V4x8QImode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_323 (insn, operands);

    case E_V4x4HImode:
      if (!nonimmediate_operand (operands[0], E_V4x4HImode)
          || !general_operand (operands[1], E_V4x4HImode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_324 (insn, operands);

    case E_V4x2SImode:
      if (!nonimmediate_operand (operands[0], E_V4x2SImode)
          || !general_operand (operands[1], E_V4x2SImode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_325 (insn, operands);

    case E_V4x1DImode:
      if (!nonimmediate_operand (operands[0], E_V4x1DImode)
          || !general_operand (operands[1], E_V4x1DImode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_326 (insn, operands);

    case E_V4x4HFmode:
      if (!nonimmediate_operand (operands[0], E_V4x4HFmode)
          || !general_operand (operands[1], E_V4x4HFmode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_327 (insn, operands);

    case E_V4x2SFmode:
      if (!nonimmediate_operand (operands[0], E_V4x2SFmode)
          || !general_operand (operands[1], E_V4x2SFmode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_328 (insn, operands);

    case E_V4x1DFmode:
      if (!nonimmediate_operand (operands[0], E_V4x1DFmode)
          || !general_operand (operands[1], E_V4x1DFmode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_329 (insn, operands);

    case E_V4x4BFmode:
      if (!nonimmediate_operand (operands[0], E_V4x4BFmode)
          || !general_operand (operands[1], E_V4x4BFmode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_330 (insn, operands);

    case E_V4x16QImode:
      if (!nonimmediate_operand (operands[0], E_V4x16QImode)
          || !general_operand (operands[1], E_V4x16QImode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_331 (insn, operands);

    case E_V4x8HImode:
      if (!nonimmediate_operand (operands[0], E_V4x8HImode)
          || !general_operand (operands[1], E_V4x8HImode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_332 (insn, operands);

    case E_V4x4SImode:
      if (!nonimmediate_operand (operands[0], E_V4x4SImode)
          || !general_operand (operands[1], E_V4x4SImode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_333 (insn, operands);

    case E_V4x2DImode:
      if (!nonimmediate_operand (operands[0], E_V4x2DImode)
          || !general_operand (operands[1], E_V4x2DImode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_334 (insn, operands);

    case E_V4x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V4x8HFmode)
          || !general_operand (operands[1], E_V4x8HFmode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_335 (insn, operands);

    case E_V4x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4x4SFmode)
          || !general_operand (operands[1], E_V4x4SFmode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_336 (insn, operands);

    case E_V4x2DFmode:
      if (!nonimmediate_operand (operands[0], E_V4x2DFmode)
          || !general_operand (operands[1], E_V4x2DFmode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_337 (insn, operands);

    case E_V4x8BFmode:
      if (!nonimmediate_operand (operands[0], E_V4x8BFmode)
          || !general_operand (operands[1], E_V4x8BFmode)
          || !
#line 8284 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_338 (insn, operands);

    case E_XImode:
      if (!nonimmediate_operand (operands[0], E_XImode)
          || !general_operand (operands[1], E_XImode)
          || !
#line 8309 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && reload_completed))
        return NULL;
      return gen_split_339 (insn, operands);

    case E_V8DImode:
      if (!nonimmediate_operand (operands[0], E_V8DImode)
          || !general_operand (operands[1], E_V8DImode)
          || !
#line 8328 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(reload_completed))
        return NULL;
      return gen_split_340 (insn, operands);

    case E_VNx32QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx32QImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx32QImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_510 (insn, operands);

    case E_VNx16HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16HImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx16HImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_511 (insn, operands);

    case E_VNx8SImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8SImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx8SImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_512 (insn, operands);

    case E_VNx4DImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4DImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx4DImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_513 (insn, operands);

    case E_VNx16BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16BFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx16BFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_514 (insn, operands);

    case E_VNx16HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16HFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx16HFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_515 (insn, operands);

    case E_VNx8SFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8SFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx8SFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_516 (insn, operands);

    case E_VNx4DFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4DFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx4DFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_517 (insn, operands);

    case E_VNx48QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx48QImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx48QImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_518 (insn, operands);

    case E_VNx24HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx24HImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx24HImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_519 (insn, operands);

    case E_VNx12SImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx12SImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx12SImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_520 (insn, operands);

    case E_VNx6DImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx6DImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx6DImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_521 (insn, operands);

    case E_VNx24BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx24BFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx24BFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_522 (insn, operands);

    case E_VNx24HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx24HFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx24HFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_523 (insn, operands);

    case E_VNx12SFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx12SFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx12SFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_524 (insn, operands);

    case E_VNx6DFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx6DFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx6DFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_525 (insn, operands);

    case E_VNx64QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx64QImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx64QImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_526 (insn, operands);

    case E_VNx32HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx32HImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx32HImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_527 (insn, operands);

    case E_VNx16SImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16SImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx16SImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_528 (insn, operands);

    case E_VNx8DImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8DImode)
          || !aarch64_sve_general_operand (operands[1], E_VNx8DImode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_529 (insn, operands);

    case E_VNx32BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx32BFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx32BFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_530 (insn, operands);

    case E_VNx32HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx32HFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx32HFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_531 (insn, operands);

    case E_VNx16SFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16SFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx16SFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_532 (insn, operands);

    case E_VNx8DFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8DFmode)
          || !aarch64_sve_general_operand (operands[1], E_VNx8DFmode)
          || !
#line 876 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return NULL;
      return gen_split_533 (insn, operands);

    case E_VNx32BImode:
      if (!nonimmediate_operand (operands[0], E_VNx32BImode)
          || !aarch64_mov_operand (operands[1], E_VNx32BImode)
          || !(
#line 1079 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1085 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return NULL;
      return gen_split_566 (insn, operands);

    case E_VNx64BImode:
      if (!nonimmediate_operand (operands[0], E_VNx64BImode)
          || !aarch64_mov_operand (operands[1], E_VNx64BImode)
          || !(
#line 1079 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1085 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return NULL;
      return gen_split_567 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_63 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1050 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1676 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1749 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1801 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1689 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1762 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1814 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1702 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1775 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1827 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1715 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1788 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5603 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1840 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1724 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1901 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1731 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1908 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1738 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5685 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1915 (insn, operands);

    case 7:
      if (!((
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1853 (insn, operands);

    case 8:
      if (!(
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1866 (insn, operands);

    case 9:
      if (!(
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1879 (insn, operands);

    case 10:
      if (!(
#line 5647 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1892 (insn, operands);

    case 11:
      if (!(
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1922 (insn, operands);

    case 12:
      if (!(
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1929 (insn, operands);

    case 13:
      if (!(
#line 5721 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1936 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_70 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern709 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      operands[4] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern710 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1246 (insn, operands);

        case E_VNx8QImode:
          if (pattern710 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1263 (insn, operands);

        case E_VNx4QImode:
          if (pattern710 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1280 (insn, operands);

        case E_VNx2QImode:
          if (pattern710 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1297 (insn, operands);

        case E_VNx8HImode:
          if (pattern710 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1314 (insn, operands);

        case E_VNx4HImode:
          if (pattern710 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1331 (insn, operands);

        case E_VNx2HImode:
          if (pattern710 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1348 (insn, operands);

        case E_VNx4SImode:
          if (pattern710 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1365 (insn, operands);

        case E_VNx2SImode:
          if (pattern710 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1382 (insn, operands);

        case E_VNx2DImode:
          if (pattern710 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1399 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      operands[5] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1164 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7273 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2002 (insn, operands);

        case E_VNx8QImode:
          if (pattern1164 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7273 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2003 (insn, operands);

        case E_VNx4QImode:
          if (pattern1164 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7273 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2004 (insn, operands);

        case E_VNx2QImode:
          if (pattern1164 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7273 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2005 (insn, operands);

        case E_VNx8HImode:
          if (pattern1164 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7273 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2006 (insn, operands);

        case E_VNx4HImode:
          if (pattern1164 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7273 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2007 (insn, operands);

        case E_VNx2HImode:
          if (pattern1164 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7273 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2008 (insn, operands);

        case E_VNx4SImode:
          if (pattern1164 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7273 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2009 (insn, operands);

        case E_VNx2SImode:
          if (pattern1164 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7273 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2010 (insn, operands);

        case E_VNx2DImode:
          if (pattern1164 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 7261 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7273 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2011 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1425 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1445 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1465 (insn, operands);

    case 3:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1427 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1447 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1467 (insn, operands);

    case 4:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1429 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1449 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1469 (insn, operands);

    case 5:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1431 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1451 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1471 (insn, operands);

    case 6:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1433 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1453 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1473 (insn, operands);

    case 7:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1435 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1455 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1475 (insn, operands);

    case 8:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1437 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1457 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1477 (insn, operands);

    case 9:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1439 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1459 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1479 (insn, operands);

    case 10:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1441 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1461 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1481 (insn, operands);

    case 11:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1443 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1463 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1483 (insn, operands);

    case 12:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1426 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1446 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1466 (insn, operands);

    case 13:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1428 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1448 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1468 (insn, operands);

    case 14:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1430 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1450 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1470 (insn, operands);

    case 15:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1432 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1452 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1472 (insn, operands);

    case 16:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1434 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1454 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1474 (insn, operands);

    case 17:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1436 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1456 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1476 (insn, operands);

    case 18:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1438 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1458 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1478 (insn, operands);

    case 19:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1440 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1460 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1480 (insn, operands);

    case 20:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1442 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1462 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1482 (insn, operands);

    case 21:
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x4, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1444 (insn, operands);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
        return gen_split_1464 (insn, operands);
      operands[5] = x6;
      operands[6] = x8;
      operands[4] = x3;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4424 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1484 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_81 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!aarch64_pluslong_strict_immedate (operands[2], E_SImode)
          || !
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(epilogue_completed))
        return NULL;
      return gen_split_19 (insn, operands);

    case XOR:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != NEG
          || GET_MODE (x5) != E_SImode)
        return NULL;
      x7 = XEXP (x5, 0);
      if (!aarch64_comparison_operator (x7, E_SImode))
        return NULL;
      operands[1] = x7;
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!cc_register (operands[2], E_VOIDmode))
        return NULL;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      if (!general_operand (operands[3], E_SImode))
        return NULL;
      return gen_split_28 (insn, operands);

    case REG:
    case SUBREG:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTRACT:
          x10 = XEXP (x4, 1);
          if (GET_CODE (x10) != CONST_INT)
            return NULL;
          x11 = XEXP (x4, 0);
          operands[0] = x11;
          x12 = XEXP (x4, 2);
          operands[1] = x12;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return NULL;
          operands[2] = x3;
          switch (XWINT (x10, 0))
            {
            case 8LL:
              switch (GET_MODE (x4))
                {
                case E_SImode:
                  switch (pattern953 (x2, 
E_SImode))
                    {
                    case 0:
                      if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(8 <= 8
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 32) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                        return NULL;
                      return gen_split_108 (insn, operands);

                    case 1:
                      if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(8 <= 16
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 32) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                        return NULL;
                      return gen_split_110 (insn, operands);

                    case 2:
                      if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(8 <= 32
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 32) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                        return NULL;
                      return gen_split_114 (insn, operands);

                    default:
                      return NULL;
                    }

                case E_DImode:
                  switch (pattern953 (x2, 
E_DImode))
                    {
                    case 0:
                      if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(8 <= 8
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                        return NULL;
                      return gen_split_109 (insn, operands);

                    case 1:
                      if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(8 <= 16
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                        return NULL;
                      return gen_split_112 (insn, operands);

                    case 2:
                      if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(8 <= 32
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                        return NULL;
                      return gen_split_117 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case 16LL:
              switch (GET_MODE (x4))
                {
                case E_SImode:
                  switch (pattern954 (x2, 
E_SImode))
                    {
                    case 0:
                      if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 32) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                        return NULL;
                      return gen_split_111 (insn, operands);

                    case 1:
                      if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 32) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                        return NULL;
                      return gen_split_115 (insn, operands);

                    default:
                      return NULL;
                    }

                case E_DImode:
                  switch (pattern954 (x2, 
E_DImode))
                    {
                    case 0:
                      if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                        return NULL;
                      return gen_split_113 (insn, operands);

                    case 1:
                      if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                        return NULL;
                      return gen_split_118 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case 32LL:
              switch (pattern884 (x1))
                {
                case 0:
                  if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(32 <= 32
   && multiple_p (UINTVAL (operands[1]), 32)
   && UINTVAL (operands[1]) + 32 <= 32) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                    return NULL;
                  return gen_split_116 (insn, operands);

                case 1:
                  if (!(
#line 6427 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(32 <= 32
   && multiple_p (UINTVAL (operands[1]), 32)
   && UINTVAL (operands[1]) + 32 <= 64) && 
#line 6431 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
                    return NULL;
                  return gen_split_119 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          operands[0] = x4;
          switch (pattern371 (x2))
            {
            case 0:
              if (!(
#line 9844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 9846 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( ZERO_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_343 (insn, operands);

            case 1:
              if (!(
#line 9844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 9846 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( ZERO_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_345 (insn, operands);

            case 2:
              if (!(
#line 9844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 9846 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( ZERO_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_347 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case VEC_SELECT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern366 (x2))
        {
        case 0:
          if (!(
#line 1968 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 1970 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( ZERO_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
            return NULL;
          return gen_split_155 (insn, operands);

        case 1:
          if (!(
#line 1968 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 1970 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( ZERO_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
            return NULL;
          return gen_split_157 (insn, operands);

        case 2:
          if (!(
#line 1968 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 1970 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( ZERO_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
            return NULL;
          return gen_split_159 (insn, operands);

        default:
          return NULL;
        }

    case US_PLUS:
      if (pattern38 (x3, 
E_SImode) != 0)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern929 (x2))
        {
        case 0:
          if (!(
#line 10771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2714 (insn, operands);

        case 1:
          if (!(
#line 10771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2716 (insn, operands);

        case 2:
          if (!(
#line 10771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2718 (insn, operands);

        case 3:
          if (!(
#line 10771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2720 (insn, operands);

        default:
          return NULL;
        }

    case US_MINUS:
      if (pattern39 (x3) != 0)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern930 (x2))
        {
        case 0:
          if (!(
#line 11004 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2747 (insn, operands);

        case 1:
          if (!(
#line 11004 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2749 (insn, operands);

        case 2:
          if (!(
#line 11004 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2751 (insn, operands);

        case 3:
          if (!(
#line 11004 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2753 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_102 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2515 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2525 (insn, operands);
}

 rtx_insn *
split_108 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2554 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2564 (insn, operands);
}

 rtx_insn *
split_115 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2414 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2424 (insn, operands);
}

 rtx_insn *
split_122 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2433 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2443 (insn, operands);
}

 rtx_insn *
split_130 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2432 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2442 (insn, operands);
}

 rtx_insn *
split_138 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IF_THEN_ELSE:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != LABEL_REF)
        return NULL;
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != PC)
        return NULL;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return NULL;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case EQ:
          switch (pattern703 (x2))
            {
            case 0:
              if (!((
#line 908 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)) && 
#line 912 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_1 (insn, operands);

            case 1:
              if (!((
#line 908 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 164 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)) && 
#line 912 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_5 (insn, operands);

            case 2:
              if (!((
#line 908 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)) && 
#line 912 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_3 (insn, operands);

            case 3:
              if (!((
#line 908 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 164 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)) && 
#line 912 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_7 (insn, operands);

            default:
              return NULL;
            }

        case NE:
          switch (pattern703 (x2))
            {
            case 0:
              if (!((
#line 908 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)) && 
#line 912 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_2 (insn, operands);

            case 1:
              if (!((
#line 908 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 164 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)) && 
#line 912 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_6 (insn, operands);

            case 2:
              if (!((
#line 908 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)) && 
#line 912 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_4 (insn, operands);

            case 3:
              if (!((
#line 908 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 164 "../../gcc-15.1.1-20250425/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)) && 
#line 912 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_8 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case TRUNCATE:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x2;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          operands[0] = x2;
          if (aarch64_reg_or_zero (operands[0], E_DImode)
              && GET_CODE (x5) == REG
              && REGNO (x5) == 84
              && GET_MODE (x5) == E_DImode
              && 
#line 1900 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_FP8 && !TARGET_CHEAP_FPMR_WRITE && can_create_pseudo_p ()))
            return gen_split_14 (insn, operands);
          break;

        case TRUNCATE:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (!subreg_lowpart_operator (x2, E_DImode))
        return NULL;
      switch (pattern29 (x1))
        {
        case 0:
          if (!(
#line 6461 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(8 <= 8
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64) && 
#line 6465 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_120 (insn, operands);

        case 1:
          if (!(
#line 6461 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(8 <= 16
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64) && 
#line 6465 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_121 (insn, operands);

        case 2:
          if (!(
#line 6461 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(8 <= 32
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64) && 
#line 6465 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_123 (insn, operands);

        case 3:
          if (!(
#line 6461 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64) && 
#line 6465 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_122 (insn, operands);

        case 4:
          if (!(
#line 6461 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64) && 
#line 6465 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_124 (insn, operands);

        case 5:
          if (!(
#line 6461 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(32 <= 32
   && multiple_p (UINTVAL (operands[1]), 32)
   && UINTVAL (operands[1]) + 32 <= 64) && 
#line 6465 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_125 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      return split_79 (x1, insn);

    case ZERO_EXTEND:
      return split_81 (x1, insn);

    case IOR:
      return split_82 (x1, insn);

    case XOR:
      return split_83 (x1, insn);

    case AND:
      return split_80 (x1, insn);

    case NOT:
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != XOR)
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern370 (x2))
        {
        case 0:
          if (!
#line 5336 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(reload_completed && FP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_69 (insn, operands);

        case 1:
          if (!
#line 5336 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(reload_completed && FP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_70 (insn, operands);

        default:
          return NULL;
        }

    case CTZ:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 5642 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(reload_completed && !TARGET_CSSC))
            return NULL;
          return gen_split_71 (insn, operands);

        case 1:
          if (!
#line 5642 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(reload_completed && !TARGET_CSSC))
            return NULL;
          return gen_split_72 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
        case TRUNCATE:
          switch (pattern17 (x2))
            {
            case 0:
              if (!(
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)) && 
#line 5872 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_85 (insn, operands);

            case 1:
              if (!(
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)) && 
#line 5872 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_90 (insn, operands);

            default:
              return NULL;
            }

        case MINUS:
          if (GET_MODE (x3) != E_QImode)
            return NULL;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return NULL;
          x8 = XEXP (x3, 1);
          if (subreg_lowpart_operator (x8, E_VOIDmode))
            {
              switch (pattern846 (x2))
                {
                case 0:
                  if ((
#line 5895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[4]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)
   && INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)) && 
#line 5898 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                    return gen_split_95 (insn, operands);
                  break;

                case 1:
                  if ((
#line 5895 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[4]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)
   && INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)) && 
#line 5898 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                    return gen_split_96 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          operands[3] = x8;
          if (!register_operand (operands[3], E_QImode))
            return NULL;
          switch (pattern2 (x2))
            {
            case 0:
              if (!(
#line 5940 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)) && 
#line 5942 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_97 (insn, operands);

            case 1:
              if (!(
#line 5940 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)) && 
#line 5942 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_100 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern18 (x1))
        {
        case 0:
          if (!(
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)) && 
#line 5872 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_86 (insn, operands);

        case 1:
          if (!(
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)) && 
#line 5872 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_91 (insn, operands);

        case 2:
          if (!(
#line 5940 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)) && 
#line 5942 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_98 (insn, operands);

        case 3:
          if (!(
#line 5940 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)) && 
#line 5942 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_101 (insn, operands);

        case 4:
          if (!
#line 6045 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_SIMD && reload_completed))
            return NULL;
          return gen_split_105 (insn, operands);

        case 5:
          if (!
#line 6060 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_SIMD && reload_completed))
            return NULL;
          return gen_split_106 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern18 (x1))
        {
        case 0:
          if (!(
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)) && 
#line 5872 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_87 (insn, operands);

        case 1:
          if (!(
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)) && 
#line 5872 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_92 (insn, operands);

        case 2:
          if (!(
#line 5940 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)) && 
#line 5942 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_99 (insn, operands);

        case 3:
          if (!(
#line 5940 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)) && 
#line 5942 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_102 (insn, operands);

        case 4:
          if (!
#line 5999 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_SIMD && reload_completed))
            return NULL;
          return gen_split_103 (insn, operands);

        case 5:
          if (!
#line 6014 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(TARGET_SIMD && reload_completed))
            return NULL;
          return gen_split_104 (insn, operands);

        default:
          return NULL;
        }

    case ROTATERT:
      x3 = XEXP (x2, 1);
      if (!subreg_lowpart_operator (x3, E_VOIDmode))
        return NULL;
      operands[4] = x3;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != NEG
          || GET_MODE (x6) != E_SImode)
        return NULL;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != AND
          || GET_MODE (x9) != E_SImode)
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      switch (pattern15 (x2))
        {
        case 0:
          if (!(
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)) && 
#line 5872 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_88 (insn, operands);

        case 1:
          if (!(
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)) && 
#line 5872 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_93 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
        case TRUNCATE:
          switch (pattern17 (x2))
            {
            case 0:
              if (!(
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)) && 
#line 5872 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_89 (insn, operands);

            case 1:
              if (!(
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)) && 
#line 5872 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_94 (insn, operands);

            default:
              return NULL;
            }

        case CONST_VECTOR:
        case CONST:
          switch (pattern462 (x2))
            {
            case 0:
              if (!(
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_147 (insn, operands);

            case 1:
              if (!(
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_148 (insn, operands);

            case 2:
              if (!(
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_149 (insn, operands);

            case 3:
              if (!(
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_150 (insn, operands);

            case 4:
              if (!(
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_151 (insn, operands);

            case 5:
              if (!(
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_152 (insn, operands);

            case 6:
              if (!(
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_153 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!aarch64_simd_shift_imm_offset_di (operands[2], E_VOIDmode))
        return NULL;
      x4 = XEXP (x2, 2);
      operands[3] = x4;
      if (!aarch64_simd_shift_imm_di (operands[3], E_VOIDmode)
          || !
#line 6348 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]), 1,
	     GET_MODE_BITSIZE (DImode) - 1)
   && (INTVAL (operands[2]) + INTVAL (operands[3]))
       == GET_MODE_BITSIZE (SImode)))
        return NULL;
      return gen_split_107 (insn, operands);

    case VEC_SELECT:
      return split_78 (x1, insn);

    case SIGN_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case VEC_SELECT:
          switch (pattern366 (x2))
            {
            case 0:
              if (!(
#line 1968 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 1970 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_154 (insn, operands);

            case 1:
              if (!(
#line 1968 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 1970 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_156 (insn, operands);

            case 2:
              if (!(
#line 1968 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 1970 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_158 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          switch (pattern371 (x2))
            {
            case 0:
              if (!(
#line 9844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 9846 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_342 (insn, operands);

            case 1:
              if (!(
#line 9844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 9846 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_344 (insn, operands);

            case 2:
              if (!(
#line 9844 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 9846 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_346 (insn, operands);

            default:
              return NULL;
            }

        case SS_PLUS:
          if (pattern38 (x7, 
E_SImode) != 0)
            return NULL;
          switch (pattern929 (x2))
            {
            case 0:
              if (!(
#line 10771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2713 (insn, operands);

            case 1:
              if (!(
#line 10771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2715 (insn, operands);

            case 2:
              if (!(
#line 10771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2717 (insn, operands);

            case 3:
              if (!(
#line 10771 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2719 (insn, operands);

            default:
              return NULL;
            }

        case SS_MINUS:
          if (pattern39 (x7) != 0)
            return NULL;
          switch (pattern930 (x2))
            {
            case 0:
              if (!(
#line 11004 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2746 (insn, operands);

            case 1:
              if (!(
#line 11004 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2748 (insn, operands);

            case 2:
              if (!(
#line 11004 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2750 (insn, operands);

            case 3:
              if (!(
#line 11004 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2752 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC:
      return split_77 (x1, insn);

    case SS_PLUS:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2698 (insn, operands);

        case 1:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2701 (insn, operands);

        case 2:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2704 (insn, operands);

        case 3:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2707 (insn, operands);

        case 4:
          if (!(
#line 10823 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10828 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2722 (insn, operands);

        case 5:
          if (!(
#line 10862 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2725 (insn, operands);

        case 6:
          if (!(
#line 10903 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10908 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2728 (insn, operands);

        default:
          return NULL;
        }

    case US_PLUS:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2699 (insn, operands);

        case 1:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2702 (insn, operands);

        case 2:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2705 (insn, operands);

        case 3:
          if (!(
#line 10716 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2708 (insn, operands);

        case 4:
          if (!(
#line 10823 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10828 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2723 (insn, operands);

        case 5:
          if (!(
#line 10862 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10867 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2726 (insn, operands);

        case 6:
          if (!(
#line 10903 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10908 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2729 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTEND:
          switch (pattern23 (x2))
            {
            case 0:
              if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2730 (insn, operands);

            case 1:
              if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2733 (insn, operands);

            case 2:
              if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2736 (insn, operands);

            case 3:
              if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2739 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 3
              || XINT (x3, 1) != 307
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x10 = XVECEXP (x3, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return NULL;
          switch (pattern1054 (x3))
            {
            case 0:
              if (!(
#line 10968 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10970 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2742 (insn, operands);

            case 1:
              if (!(
#line 10968 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10970 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2743 (insn, operands);

            case 2:
              if (!(
#line 10968 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10970 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2744 (insn, operands);

            case 3:
              if (!(
#line 10968 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10970 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2745 (insn, operands);

            default:
              return NULL;
            }

        case VEC_DUPLICATE:
          switch (pattern24 (x2))
            {
            case 0:
              if (!(
#line 11056 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2754 (insn, operands);

            case 1:
              if (!(
#line 11095 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11100 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2757 (insn, operands);

            case 2:
              if (!(
#line 11136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11141 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2760 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SS_MINUS:
      switch (pattern25 (x1))
        {
        case 0:
          if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2731 (insn, operands);

        case 1:
          if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2734 (insn, operands);

        case 2:
          if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2737 (insn, operands);

        case 3:
          if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2740 (insn, operands);

        case 4:
          if (!(
#line 11056 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2755 (insn, operands);

        case 5:
          if (!(
#line 11095 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11100 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2758 (insn, operands);

        case 6:
          if (!(
#line 11136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11141 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2761 (insn, operands);

        default:
          return NULL;
        }

    case US_MINUS:
      switch (pattern25 (x1))
        {
        case 0:
          if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2732 (insn, operands);

        case 1:
          if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2735 (insn, operands);

        case 2:
          if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2738 (insn, operands);

        case 3:
          if (!(
#line 10949 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2741 (insn, operands);

        case 4:
          if (!(
#line 11056 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11061 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2756 (insn, operands);

        case 5:
          if (!(
#line 11095 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11100 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2759 (insn, operands);

        case 6:
          if (!(
#line 11136 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11141 "../../gcc-15.1.1-20250425/gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2762 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
