/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != UNSPEC_VOLATILE
      || XVECLEN (x4, 0) != 2
      || XINT (x4, 1) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern10 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern10 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern10 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V8BFmode:
      if (pattern10 (x1, 
E_V4BFmode, 
E_V8BFmode) != 0)
        return -1;
      return 3;

    case E_V4SImode:
      if (pattern10 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern10 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern10 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 100
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x9 = XEXP (x3, 0);
  operands[1] = x9;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x10 = XEXP (x3, 1);
  operands[2] = x10;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x11 = XEXP (x4, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[4] = x12;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern44 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i2))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!s_register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    case E_V2DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[2], E_V16QImode)
          || !s_register_operand (operands[3], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !s_register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !s_register_operand (operands[3], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !mve_imm_7 (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !mve_imm_15 (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !mve_imm_31 (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern146 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern41 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 3;

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    case E_V2DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4x16QImode:
      return 0;

    case E_V4x8HImode:
      return 1;

    case E_V4x4SImode:
      return 2;

    case E_V4x8HFmode:
      return 3;

    case E_V4x4SFmode:
      return 4;

    default:
      return -1;
    }
}

int
pattern177 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return pattern115 (x3); /* [-1, 2] */
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern40 (x3, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern40 (x3, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern38 (x3, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern38 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 2);
  operands[3] = x8;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern205 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !mve_imm_16 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern206 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern223 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern216 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern216 (x3, 
E_V4BImode, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern239 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XVECEXP (x3, 0, 5);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x10 = XVECEXP (x3, 0, 6);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x11 = XVECEXP (x3, 0, 7);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x12 = XEXP (x1, 1);
  x13 = XEXP (x12, 1);
  if (XVECLEN (x13, 0) != 8)
    return -1;
  x14 = XVECEXP (x13, 0, 0);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x15 = XVECEXP (x13, 0, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x16 = XVECEXP (x13, 0, 2);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x17 = XVECEXP (x13, 0, 3);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x18 = XVECEXP (x13, 0, 4);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x19 = XVECEXP (x13, 0, 5);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x20 = XVECEXP (x13, 0, 6);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x21 = XVECEXP (x13, 0, 7);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
      || pattern237 (x1, 
E_V8QImode, 
E_V16QImode) != 0)
    return -1;
  return 0;
}

int
pattern259 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!cc_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!mem_noofs_operand (operands[2], E_QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QImode
          || !s_register_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!mem_noofs_operand (operands[2], E_HImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HImode
          || !s_register_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  return 0;
}

int
pattern272 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !reg_or_zero_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern281 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 19)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  return pattern21 (x1); /* [-1, 3] */
}

int
pattern293 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern292 (x1); /* [-1, 3] */
}

int
pattern296 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_V4HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XEXP (x5, 2);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != ZERO_EXTRACT
      || GET_MODE (x8) != E_V4HImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x10 = XEXP (x8, 2);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != ZERO_EXTRACT
      || GET_MODE (x11) != E_V4HImode)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x11, 2);
  if (GET_CODE (x13) != CONST_INT
      || !register_operand (operands[0], E_V2SImode)
      || !register_operand (operands[1], E_V2SImode))
    return -1;
  x14 = XEXP (x2, 0);
  operands[2] = x14;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x15 = XEXP (x8, 0);
  operands[3] = x15;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x16 = XEXP (x5, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  x17 = XEXP (x11, 0);
  if (!rtx_equal_p (x17, operands[3]))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 0LL:
      if (XWINT (x7, 0) != 32LL)
        return -1;
      switch (XWINT (x10, 0))
        {
        case 0LL:
          if (XWINT (x13, 0) != 32LL)
            return -1;
          return 0;

        case 16LL:
          if (XWINT (x13, 0) != 48LL)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 16LL:
      if (XWINT (x7, 0) != 48LL)
        return -1;
      switch (XWINT (x10, 0))
        {
        case 0LL:
          if (XWINT (x13, 0) != 32LL)
            return -1;
          return 2;

        case 16LL:
          if (XWINT (x13, 0) != 48LL)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern334 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  return 0;
}

int
pattern339 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[4] = x9;
  if (!mve_imm_32 (operands[4], E_SImode))
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  operands[5] = x10;
  x11 = XEXP (x2, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  x14 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x14, operands[4]))
    return -1;
  x15 = XVECEXP (x3, 0, 3);
  if (!rtx_equal_p (x15, operands[5]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern338 (x6, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern338 (x6, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern338 (x6, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 2);
  operands[2] = x5;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !mve_memory_operand (operands[1], i2)
      || !vpr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern376 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[1], E_SImode)
      || !reg_or_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern381 (rtx x1, machine_mode i1, rtx_code i2, rtx_code i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i4)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern386 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!shift_nomul_operator (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[5] = x2;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!shift_amount_operand (operands[4], E_SImode))
    return -1;
  x9 = XEXP (x5, 1);
  operands[1] = x9;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern416 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern425 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || pattern307 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern430 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mve_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i3)
      || !vpr_register_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern438 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MULT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SIGN_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern446 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern454 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SIGN_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_MODE (x5) != E_CC_Vmode
      || GET_MODE (x2) != E_CC_Vmode)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern463 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern462 (x1, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (GET_MODE (x1) != E_V8HFmode)
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern462 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (GET_MODE (x1) != E_V4SFmode)
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern478 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern318 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern484 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern493 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != COND_EXEC)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != NE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x5, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != COND_EXEC)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != EQ)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 100
      || GET_MODE (x10) != E_CCmode)
    return -1;
  x11 = XEXP (x9, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x8, 1);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XEXP (x12, 0);
  if (!rtx_equal_p (x14, operands[0]))
    return -1;
  return 0;
}

int
pattern515 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !s_register_operand (operands[3], i2)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !arm_low_register_operand (operands[0], E_DImode)
      || !arm_low_register_operand (operands[1], E_DImode)
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern531 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XVECEXP (x9, 0, 2);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return pattern530 (x1); /* [-1, 3] */
}

int
pattern542 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern548 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != i1
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case CLOBBER:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern557 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern563 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern573 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern579 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PLUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case MINUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 1;

    case IOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 2;

    case XOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 3;

    case AND:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 4;

    case NOT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != AND
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern608 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[2], i1)
      || !vpr_register_operand (operands[4], i2)
      || !s_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x5, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x9, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern624 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern635 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8LL)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12LL)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern646 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

int
pattern650 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x9 = XEXP (x1, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XEXP (x9, 1);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  x16 = XEXP (x4, 1);
  x17 = XVECEXP (x16, 0, 0);
  switch (XWINT (x17, 0))
    {
    case 0LL:
      x18 = XEXP (x11, 1);
      x19 = XVECEXP (x18, 0, 0);
      if (XWINT (x19, 0) != 2LL)
        return -1;
      x20 = XEXP (x7, 1);
      x21 = XVECEXP (x20, 0, 0);
      switch (XWINT (x21, 0))
        {
        case 0LL:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 2LL)
            return -1;
          return 0;

        case 1LL:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 3LL)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 1LL:
      x18 = XEXP (x11, 1);
      x19 = XVECEXP (x18, 0, 0);
      if (XWINT (x19, 0) != 3LL)
        return -1;
      x20 = XEXP (x7, 1);
      x21 = XVECEXP (x20, 0, 0);
      switch (XWINT (x21, 0))
        {
        case 0LL:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 2LL)
            return -1;
          return 2;

        case 1LL:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 3LL)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (pattern289 (x2, 
E_CC_NZmode) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != XOR
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != E_CC_NZmode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  operands[0] = x9;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x4, 1);
  if (!rtx_equal_p (x11, operands[2])
      || !
#line 3871 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
    return -1;
  return 114; /* *xorsi3_compare0 */
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case NE:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 2);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          operands[3] = x7;
          if (const_int_operand (operands[3], E_SImode)
              && pattern527 (x1) == 0
              && 
#line 3116 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)))
            return 94; /* *ne_zeroextractsi */
          if (XWINT (x7, 0) != 0LL
              || pattern527 (x1) != 0
              || !
#line 3154 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 95; /* *ne_zeroextractsi_shifted */

        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x2, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 1769 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 986; /* *cstoresi_ne0_thumb1_insn */

        default:
          return -1;
        }

    case EQ:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[2] = x8;
      if (!s_register_operand (operands[2], E_SImode)
          || !
#line 1756 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 985; /* *cstoresi_eq0_thumb1_insn */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[6] = x5;
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  if (!arm_add_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x3, 2);
  operands[1] = x9;
  if (!arm_rhs_operand (operands[1], E_SImode)
      || !
#line 10874 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
    return -1;
  return 352; /* *ifcompare_plus_move */
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[2] = x6;
      if (ldrd_strd_offset_operand (operands[2], E_SImode))
        {
          res = recog_21 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x6, 0) != -4LL)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode
          || !s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x8, 0);
      if (!rtx_equal_p (x11, operands[1])
          || !
#line 12751 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[0], operands[2],
                                  operands[1], -4, false, true))))
        return -1;
      return 425; /* *thumb2_ldrd_base_neg */

    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != PLUS
          || GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
          || !s_register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x11, 0);
      if (!rtx_equal_p (x13, operands[1])
          || !
#line 12738 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[0], operands[2],
                                  operands[1], 0, false, true))))
        return -1;
      return 424; /* *thumb2_ldrd_base */

    case UNSPEC:
      if (XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 2
          || GET_MODE (x5) != E_SImode)
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || !register_operand (operands[0], E_SImode))
        return -1;
      x15 = XVECEXP (x5, 0, 0);
      operands[2] = x15;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XVECEXP (x5, 0, 2);
      operands[3] = x16;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!scratch_operand (operands[1], E_SImode)
          || !
#line 274 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      return 1015; /* tls_load_dot_plus_four */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  x9 = XVECEXP (x6, 0, 0);
  operands[2] = x9;
  switch (XINT (x3, 1))
    {
    case 22:
      if (XINT (x6, 1) != 22)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!mem_noofs_operand (operands[1], E_QImode)
              || GET_MODE (x6) != E_QImode
              || !s_register_operand (operands[2], E_QImode)
              || !
#line 557 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3173; /* arm_store_exclusiveqi */

        case E_HImode:
          if (!mem_noofs_operand (operands[1], E_HImode)
              || GET_MODE (x6) != E_HImode
              || !s_register_operand (operands[2], E_HImode)
              || !
#line 557 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3174; /* arm_store_exclusivehi */

        case E_SImode:
          if (!mem_noofs_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !s_register_operand (operands[2], E_SImode)
              || !
#line 557 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3175; /* arm_store_exclusivesi */

        case E_DImode:
          if (!mem_noofs_operand (operands[1], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !s_register_operand (operands[2], E_DImode)
              || !
#line 557 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3176; /* arm_store_exclusivedi */

        default:
          return -1;
        }

    case 24:
      if (XINT (x6, 1) != 24)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!mem_noofs_operand (operands[1], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !s_register_operand (operands[2], E_DImode)
              || !
#line 580 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQEXD && ARM_DOUBLEWORD_ALIGN))
            return -1;
          return 3177; /* arm_store_release_exclusivedi */

        case E_QImode:
          if (!mem_noofs_operand (operands[1], E_QImode)
              || GET_MODE (x6) != E_QImode
              || !s_register_operand (operands[2], E_QImode)
              || !
#line 595 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
            return -1;
          return 3178; /* arm_store_release_exclusiveqi */

        case E_HImode:
          if (!mem_noofs_operand (operands[1], E_HImode)
              || GET_MODE (x6) != E_HImode
              || !s_register_operand (operands[2], E_HImode)
              || !
#line 595 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
            return -1;
          return 3179; /* arm_store_release_exclusivehi */

        case E_SImode:
          if (!mem_noofs_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !s_register_operand (operands[2], E_SImode)
              || !
#line 595 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
            return -1;
          return 3180; /* arm_store_release_exclusivesi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_33 (x1, insn, pnum_clobbers);

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XEXP (x2, 0);
      switch (pattern6 (x4))
        {
        case 0:
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (s_register_operand (operands[0], E_SImode))
            {
              if (
#line 8714 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 290; /* *call_reg_armv5 */
                }
              if (
#line 8724 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 291; /* *call_reg_arm */
                }
            }
          if (
#line 8853 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !SIBLING_CALL_P (insn)
   && (GET_CODE (operands[0]) == SYMBOL_REF)
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[0]))))
            {
              *pnum_clobbers = 1;
              return 294; /* *call_symbol */
            }
          if (register_operand (operands[0], E_SImode))
            {
              if (
#line 1870 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 991; /* *call_reg_thumb1_v5 */
                }
              if (
#line 1893 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && !arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 993; /* *call_reg_thumb1 */
                }
            }
          if (
#line 1960 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[0]))))
            {
              *pnum_clobbers = 1;
              return 997; /* *call_insn */
            }
          if (!s_register_operand (operands[0], E_SImode)
              || !
#line 534 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          *pnum_clobbers = 1;
          return 1025; /* *call_reg_thumb2 */

        case 1:
          x7 = XVECEXP (x4, 0, 0);
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) == REG
              && REGNO (x8) == 4
              && GET_MODE (x8) == E_SImode)
            {
              x5 = XEXP (x2, 1);
              operands[0] = x5;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (
#line 1882 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && use_cmse && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 992; /* *nonsecure_call_reg_thumb1_v5 */
                }
            }
          operands[0] = x8;
          if (s_register_operand (operands[0], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              x6 = XEXP (x3, 0);
              operands[2] = x6;
              if (
#line 545 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && TARGET_HAVE_FPCXT_CMSE))
                {
                  *pnum_clobbers = 1;
                  return 1026; /* *nonsecure_call_reg_thumb2_fpcxt */
                }
            }
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 4
              || GET_MODE (x8) != E_SImode)
            return -1;
          x5 = XEXP (x2, 1);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!
#line 557 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && !TARGET_HAVE_FPCXT_CMSE))
            return -1;
          *pnum_clobbers = 1;
          return 1027; /* *nonsecure_call_reg_thumb2 */

        default:
          return -1;
        }

    case RETURN:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x9 = XEXP (x3, 1);
      if (pattern16 (x9, 
POST_INC, 
MEM, 
E_SImode) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 15
          || GET_MODE (x6) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!s_register_operand (operands[0], E_SImode)
          || !
#line 12016 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
        return -1;
      return 389; /* *ldr_with_return */

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x2, 0))
        {
        case 1:
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return -1;
          switch (XINT (x2, 1))
            {
            case 16:
              x12 = XVECEXP (x2, 0, 0);
              operands[0] = x12;
              if (!s_register_operand (operands[0], E_SImode))
                return -1;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (!scratch_operand (operands[1], E_SImode))
                return -1;
              if (
#line 12275 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 404; /* arm_eh_return */
              if (
#line 2096 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return 1005; /* thumb_eh_return */
              if (!
#line 1239 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return -1;
              return 1051; /* thumb2_eh_return */

            case 54:
              if (GET_MODE (x2) != E_SImode)
                return -1;
              x12 = XVECEXP (x2, 0, 0);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x6 = XEXP (x3, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 100
                  || GET_MODE (x6) != E_CCmode
                  || !
#line 1699 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse))
                return -1;
              return 1070; /* *clear_apsr */

            default:
              return -1;
            }

        case 6:
          if (pattern17 (x1, 
E_SImode) != 0)
            return -1;
          x13 = XVECEXP (x2, 0, 4);
          operands[4] = x13;
          if (!immediate_operand (operands[4], E_SImode))
            return -1;
          x14 = XVECEXP (x2, 0, 5);
          operands[5] = x14;
          if (!immediate_operand (operands[5], E_SImode))
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x3, 0);
          if (!rtx_equal_p (x6, operands[2]))
            return -1;
          switch (XINT (x2, 1))
            {
            case 43:
              if (!
#line 13007 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCR)))
                return -1;
              return 505; /* arm_mcr */

            case 44:
              if (!
#line 13007 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCR2)))
                return -1;
              return 506; /* arm_mcr2 */

            default:
              return -1;
            }

        case 4:
          if (pattern17 (x1, 
E_DImode) != 0)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x3, 0);
          if (!rtx_equal_p (x6, operands[2]))
            return -1;
          switch (XINT (x2, 1))
            {
            case 47:
              if (!
#line 13044 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCRR)))
                return -1;
              return 509; /* arm_mcrr */

            case 48:
              if (!
#line 13044 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCRR2)))
                return -1;
              return 510; /* arm_mcrr2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  switch (pattern299 (x1))
    {
    case 0:
      if (pattern389 (x1) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      operands[3] = x7;
      x8 = XEXP (x2, 1);
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[4] = x9;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x10 = XEXP (x3, 1);
          x11 = XEXP (x10, 0);
          x12 = XEXP (x11, 1);
          if (XWINT (x12, 0) != 4LL)
            return -1;
          x13 = XEXP (x4, 1);
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_SImode)
            return -1;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          x17 = XEXP (x14, 0);
          if (!rtx_equal_p (x17, operands[4]))
            return -1;
          if (arm_hard_general_register_operand (operands[1], E_SImode)
              && arm_hard_general_register_operand (operands[2], E_SImode)
              && arm_hard_general_register_operand (operands[3], E_SImode)
              && 
#line 477 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
            return 456; /* *ldm3_ */
          if (!low_register_operand (operands[1], E_SImode)
              || !low_register_operand (operands[2], E_SImode)
              || !low_register_operand (operands[3], E_SImode)
              || !
#line 492 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 3))
            return -1;
          return 457; /* *thumb_ldm3_ia */

        case PLUS:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x18 = XEXP (x9, 1);
          if (GET_CODE (x18) != CONST_INT
              || !arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x19 = XEXP (x9, 0);
          operands[4] = x19;
          if (!s_register_operand (operands[4], E_SImode)
              || !arm_hard_general_register_operand (operands[2], E_SImode)
              || !arm_hard_general_register_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x3, 1);
          x11 = XEXP (x10, 0);
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          switch (XWINT (x18, 0))
            {
            case 4LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != 8LL)
                return -1;
              x13 = XEXP (x4, 1);
              x14 = XEXP (x13, 0);
              if (pattern626 (x14, 
12) != 0
                  || !
#line 582 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 463; /* *ldm3_ib */

            case -8LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -4LL)
                return -1;
              x13 = XEXP (x4, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[4])
                  || !
#line 643 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 467; /* *ldm3_da */

            case -12LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -8LL)
                return -1;
              x13 = XEXP (x4, 1);
              x14 = XEXP (x13, 0);
              if (pattern626 (x14, 
-4) != 0
                  || !
#line 704 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 471; /* *ldm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern452 (x1) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x4, 1);
      operands[3] = x13;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      x20 = XEXP (x5, 0);
      switch (GET_CODE (x20))
        {
        case REG:
        case SUBREG:
          operands[4] = x20;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          x21 = XEXP (x6, 0);
          x22 = XEXP (x21, 1);
          if (XWINT (x22, 0) != 4LL)
            return -1;
          x7 = XEXP (x4, 0);
          x23 = XEXP (x7, 0);
          if (GET_CODE (x23) != PLUS
              || GET_MODE (x23) != E_SImode)
            return -1;
          x24 = XEXP (x23, 1);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x25 = XEXP (x21, 0);
          if (!rtx_equal_p (x25, operands[4]))
            return -1;
          x26 = XEXP (x23, 0);
          if (!rtx_equal_p (x26, operands[4])
              || !
#line 537 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
            return -1;
          return 460; /* *stm3_ */

        case PLUS:
          if (GET_MODE (x20) != E_SImode)
            return -1;
          x27 = XEXP (x20, 1);
          if (GET_CODE (x27) != CONST_INT)
            return -1;
          x28 = XEXP (x20, 0);
          operands[4] = x28;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          x21 = XEXP (x6, 0);
          x25 = XEXP (x21, 0);
          if (!rtx_equal_p (x25, operands[4]))
            return -1;
          switch (XWINT (x27, 0))
            {
            case 4LL:
              x22 = XEXP (x21, 1);
              if (XWINT (x22, 0) != 8LL)
                return -1;
              x7 = XEXP (x4, 0);
              x23 = XEXP (x7, 0);
              if (pattern629 (x23, 
12) != 0
                  || !
#line 613 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 465; /* *stm3_ib */

            case -8LL:
              x22 = XEXP (x21, 1);
              if (XWINT (x22, 0) != -4LL)
                return -1;
              x7 = XEXP (x4, 0);
              x23 = XEXP (x7, 0);
              if (!rtx_equal_p (x23, operands[4])
                  || !
#line 673 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 469; /* *stm3_da */

            case -12LL:
              x22 = XEXP (x21, 1);
              if (XWINT (x22, 0) != -8LL)
                return -1;
              x7 = XEXP (x4, 0);
              x23 = XEXP (x7, 0);
              if (pattern629 (x23, 
-4) != 0
                  || !
#line 735 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 473; /* *stm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      x9 = XEXP (x8, 0);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      x29 = XEXP (x8, 1);
      switch (XWINT (x29, 0))
        {
        case 8LL:
          switch (pattern496 (x3))
            {
            case 0:
              x13 = XEXP (x4, 1);
              if (GET_CODE (x13) != MEM
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != PLUS
                  || GET_MODE (x14) != E_SImode)
                return -1;
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != CONST_INT
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              x17 = XEXP (x14, 0);
              if (!rtx_equal_p (x17, operands[3]))
                return -1;
              x10 = XEXP (x3, 1);
              x11 = XEXP (x10, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x11, operands[3])
                      || XWINT (x15, 0) != 4LL)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return 477; /* *ldm2_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !
#line 894 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 478; /* *thumb_ldm2_ia_update */

                case PLUS:
                  if (GET_MODE (x11) != E_SImode)
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x15, 0) != 8LL
                      || !arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode))
                    return -1;
                  x16 = XEXP (x11, 0);
                  if (!rtx_equal_p (x16, operands[3])
                      || !
#line 957 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 483; /* *ldm2_ib_update */

                default:
                  return -1;
                }

            case 1:
              x7 = XEXP (x4, 0);
              if (pattern453 (x7) != 0)
                return -1;
              x23 = XEXP (x7, 0);
              x24 = XEXP (x23, 1);
              if (GET_CODE (x24) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x4, 1);
              operands[2] = x13;
              x26 = XEXP (x23, 0);
              if (!rtx_equal_p (x26, operands[3]))
                return -1;
              x6 = XEXP (x3, 0);
              x21 = XEXP (x6, 0);
              switch (GET_CODE (x21))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x21, operands[3])
                      || XWINT (x24, 0) != 4LL)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && 
#line 917 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return 480; /* *stm2_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !
#line 930 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 481; /* *thumb_stm2_ia_update */

                case PLUS:
                  if (GET_MODE (x21) != E_SImode)
                    return -1;
                  x22 = XEXP (x21, 1);
                  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x24, 0) != 8LL
                      || !arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode))
                    return -1;
                  x25 = XEXP (x21, 0);
                  if (!rtx_equal_p (x25, operands[3])
                      || !
#line 981 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 485; /* *stm2_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -8LL:
          x10 = XEXP (x3, 1);
          switch (GET_CODE (x10))
            {
            case MEM:
              if (pattern389 (x1) != 0
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x10, 0);
              x16 = XEXP (x11, 0);
              if (!rtx_equal_p (x16, operands[3]))
                return -1;
              x12 = XEXP (x11, 1);
              switch (XWINT (x12, 0))
                {
                case -4LL:
                  x13 = XEXP (x4, 1);
                  x14 = XEXP (x13, 0);
                  if (!rtx_equal_p (x14, operands[3])
                      || !
#line 1007 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 487; /* *ldm2_da_update */

                case -8LL:
                  x13 = XEXP (x4, 1);
                  x14 = XEXP (x13, 0);
                  if (GET_CODE (x14) != PLUS
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x15 = XEXP (x14, 1);
                  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x17 = XEXP (x14, 0);
                  if (!rtx_equal_p (x17, operands[3])
                      || !
#line 1059 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 491; /* *ldm2_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x10;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern452 (x1) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x4, 1);
              operands[2] = x13;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x6 = XEXP (x3, 0);
              x21 = XEXP (x6, 0);
              x25 = XEXP (x21, 0);
              if (!rtx_equal_p (x25, operands[3]))
                return -1;
              x22 = XEXP (x21, 1);
              switch (XWINT (x22, 0))
                {
                case -4LL:
                  x7 = XEXP (x4, 0);
                  x23 = XEXP (x7, 0);
                  if (!rtx_equal_p (x23, operands[3])
                      || !
#line 1031 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 489; /* *stm2_da_update */

                case -8LL:
                  x7 = XEXP (x4, 0);
                  x23 = XEXP (x7, 0);
                  if (GET_CODE (x23) != PLUS
                      || GET_MODE (x23) != E_SImode)
                    return -1;
                  x24 = XEXP (x23, 1);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x26 = XEXP (x23, 0);
                  if (!rtx_equal_p (x26, operands[3])
                      || !
#line 1083 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 493; /* *stm2_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern391 (x3, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 3155 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4825; /* mve_vstrq_p_v16qi */

    case E_V8HImode:
      if (pattern391 (x3, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3155 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4826; /* mve_vstrq_p_v8hi */

    case E_V4SImode:
      if (pattern391 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3155 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4827; /* mve_vstrq_p_v4si */

    case E_V8HFmode:
      if (pattern391 (x3, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 3155 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4828; /* mve_vstrq_p_v8hf */

    case E_V4SFmode:
      if (pattern391 (x3, 
E_V4BImode, 
E_V4SFmode) != 0
          || !
#line 3155 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4829; /* mve_vstrq_p_v4sf */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != TRUNCATE)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern430 (x2, 
E_V8QImode, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3203 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4833; /* mve_vstrq_p_truncate_v8qi */

    case E_V4QImode:
      if (pattern430 (x2, 
E_V4QImode, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3203 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4834; /* mve_vstrq_p_truncate_v4qi */

    case E_V4HImode:
      if (pattern430 (x2, 
E_V4HImode, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3203 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4835; /* mve_vstrq_p_truncate_v4hi */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern90 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  switch (pattern509 (x3))
    {
    case 0:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !
#line 3374 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
        return -1;
      return 4870; /* mve_vstrq_truncate_scatter_offset_v8qi */

    case 1:
      if (!s_register_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4QImode:
          if (!
#line 3374 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4871; /* mve_vstrq_truncate_scatter_offset_v4qi */

        case E_V4HImode:
          if (!
#line 3374 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4872; /* mve_vstrq_truncate_scatter_offset_v4hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (pattern94 (x2, 
0, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 0
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[1] = x5;
  if (!
#line 12341 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_GNU2_TLS))
    return -1;
  *pnum_clobbers = 3;
  return 409; /* tlscall */
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern36 (x1))
    {
    case 0:
      if (!
#line 2192 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1596; /* neon_vqrdmlahv4hi */

    case 1:
      if (!
#line 2192 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1598; /* neon_vqrdmlahv2si */

    case 2:
      if (!
#line 2192 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1600; /* neon_vqrdmlahv8hi */

    case 3:
      if (!
#line 2192 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1602; /* neon_vqrdmlahv4si */

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      if (!general_operand (operands[1], E_V16QImode)
          || !register_operand (operands[0], E_V16QImode)
          || !
#line 75 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098))
        return -1;
      return 3047; /* aes_op_protect */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      switch (XINT (x4, 1))
        {
        case 352:
          if (!s_register_operand (operands[0], E_V16QImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!neon_permissive_struct_operand (operands[1], E_V16QImode)
              || !
#line 100 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098))
            return -1;
          return 3048; /* *aes_op_protect_misalign_load */

        case 198:
          if (!s_register_operand (operands[0], E_V16QImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!neon_struct_operand (operands[1], E_V16QImode)
              || !
#line 112 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_NEON))
            return -1;
          return 3049; /* aes_op_protect_neon_vld1v16qi */

        case 132:
          x5 = XVECEXP (x4, 0, 0);
          switch (pattern431 (x5, 
130))
            {
            case 0:
              if (!
#line 126 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098))
                return -1;
              return 3050; /* *crypto_aesmc_protected */

            case 1:
              if (!
#line 163 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098
   && arm_fusion_enabled_p (tune_params::FUSE_AES_AESMC)))
                return -1;
              return 3053; /* *aarch32_crypto_aese_fused_protected */

            default:
              return -1;
            }

        case 131:
          x5 = XVECEXP (x4, 0, 0);
          switch (pattern431 (x5, 
129))
            {
            case 0:
              if (!
#line 126 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098))
                return -1;
              return 3051; /* *crypto_aesimc_protected */

            case 1:
              if (!
#line 200 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098
   && arm_fusion_enabled_p (tune_params::FUSE_AES_AESMC)))
                return -1;
              return 3055; /* *aarch32_crypto_aesd_fused_protected */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      switch (pattern301 (x3))
        {
        case 0:
          if (!
#line 3275 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4846; /* mve_vldrq_extend_v8qis */

        case 1:
          if (!
#line 3275 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4848; /* mve_vldrq_extend_v4qis */

        case 2:
          if (!
#line 3275 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4850; /* mve_vldrq_extend_v4his */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern301 (x3))
        {
        case 0:
          if (!
#line 3275 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4847; /* mve_vldrq_extend_v8qiu */

        case 1:
          if (!
#line 3275 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4849; /* mve_vldrq_extend_v4qiu */

        case 2:
          if (!
#line 3275 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4851; /* mve_vldrq_extend_v4hiu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_129 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern103 (x1))
    {
    case 0:
      if (!
#line 2756 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1869; /* neon_vpaddlsv8qi */

    case 1:
      if (!
#line 2756 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1871; /* neon_vpaddlsv16qi */

    case 2:
      if (!
#line 2756 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1873; /* neon_vpaddlsv4hi */

    case 3:
      if (!
#line 2756 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1875; /* neon_vpaddlsv8hi */

    case 4:
      if (!
#line 2756 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1877; /* neon_vpaddlsv2si */

    case 5:
      if (!
#line 2756 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1879; /* neon_vpaddlsv4si */

    default:
      return -1;
    }
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern159 (x1))
    {
    case 0:
      if (!neon_struct_operand (operands[0], E_TImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_TImode
          || !s_register_operand (operands[1], E_TImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5544 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2804; /* neon_vst2v8qi */

        case E_V4HImode:
          if (!
#line 5544 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2805; /* neon_vst2v4hi */

        case E_V4HFmode:
          if (!
#line 5544 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2806; /* neon_vst2v4hf */

        case E_V4BFmode:
          if (!(
#line 5544 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2807; /* neon_vst2v4bf */

        case E_V2SImode:
          if (!
#line 5544 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2808; /* neon_vst2v2si */

        case E_V2SFmode:
          if (!
#line 5544 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2809; /* neon_vst2v2sf */

        case E_DImode:
          if (!
#line 5544 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2810; /* neon_vst2di */

        default:
          return -1;
        }

    case 1:
      if (!neon_struct_operand (operands[0], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_OImode
          || !s_register_operand (operands[1], E_OImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V16QImode:
          if (!
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2811; /* neon_vst2v16qi */

        case E_V8HImode:
          if (!
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2812; /* neon_vst2v8hi */

        case E_V8HFmode:
          if (!
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2813; /* neon_vst2v8hf */

        case E_V8BFmode:
          if (!(
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2814; /* neon_vst2v8bf */

        case E_V4SImode:
          if (!
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2815; /* neon_vst2v4si */

        case E_V4SFmode:
          if (!
#line 5562 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2816; /* neon_vst2v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 3539 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4906; /* mve_vldrq_gather_base_v4si */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 3539 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4907; /* mve_vldrq_gather_base_v4sf */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V2DImode)
          || !
#line 3539 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4908; /* mve_vldrq_gather_base_v2di */

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern370 (x3, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 3252 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4841; /* mve_vldrq_z_v16qi */

    case E_V8HImode:
      if (pattern370 (x3, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3252 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4842; /* mve_vldrq_z_v8hi */

    case E_V4SImode:
      if (pattern370 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3252 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4843; /* mve_vldrq_z_v4si */

    case E_V8HFmode:
      if (pattern370 (x3, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 3252 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4844; /* mve_vldrq_z_v8hf */

    case E_V4SFmode:
      if (pattern370 (x3, 
E_V4BImode, 
E_V4SFmode) != 0
          || !
#line 3252 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4845; /* mve_vldrq_z_v4sf */

    default:
      return -1;
    }
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4601 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2419; /* neon_vqshlu_nv8qi */

    case 1:
      if (!
#line 4601 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2420; /* neon_vqshlu_nv16qi */

    case 2:
      if (!
#line 4601 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2421; /* neon_vqshlu_nv4hi */

    case 3:
      if (!
#line 4601 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2422; /* neon_vqshlu_nv8hi */

    case 4:
      if (!
#line 4601 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2423; /* neon_vqshlu_nv2si */

    case 5:
      if (!
#line 4601 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2424; /* neon_vqshlu_nv4si */

    case 6:
      if (!
#line 4601 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2425; /* neon_vqshlu_ndi */

    case 7:
      if (!
#line 4601 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2426; /* neon_vqshlu_nv2di */

    default:
      return -1;
    }
}

 int
recog_170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2309; /* neon_vqrshlsv8qi */

    case 1:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2313; /* neon_vqrshlsv16qi */

    case 2:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2317; /* neon_vqrshlsv4hi */

    case 3:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2321; /* neon_vqrshlsv8hi */

    case 4:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2325; /* neon_vqrshlsv2si */

    case 5:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2329; /* neon_vqrshlsv4si */

    case 6:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2333; /* neon_vqrshlsdi */

    case 7:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2337; /* neon_vqrshlsv2di */

    default:
      return -1;
    }
}

 int
recog_181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 2293 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1634; /* neon_vqsubuv8qi */

    case 1:
      if (!
#line 2293 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1636; /* neon_vqsubuv16qi */

    case 2:
      if (!
#line 2293 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1638; /* neon_vqsubuv4hi */

    case 3:
      if (!
#line 2293 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1640; /* neon_vqsubuv8hi */

    case 4:
      if (!
#line 2293 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1642; /* neon_vqsubuv2si */

    case 5:
      if (!
#line 2293 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1644; /* neon_vqsubuv4si */

    case 6:
      if (!
#line 2293 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1646; /* neon_vqsubudi */

    case 7:
      if (!
#line 2293 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1648; /* neon_vqsubuv2di */

    default:
      return -1;
    }
}

 int
recog_192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern158 (x1))
    {
    case 0:
      if (!
#line 5327 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2744; /* neon_vst1x4qav16qi */

    case 1:
      if (!
#line 5327 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2745; /* neon_vst1x4qav8hi */

    case 2:
      if (!
#line 5327 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2746; /* neon_vst1x4qav8hf */

    case 3:
      if (!(
#line 5327 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2747; /* neon_vst1x4qav8bf */

    case 4:
      if (!
#line 5327 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2748; /* neon_vst1x4qav4si */

    case 5:
      if (!
#line 5327 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2749; /* neon_vst1x4qav4sf */

    case 6:
      if (!
#line 5327 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2750; /* neon_vst1x4qav2di */

    default:
      return -1;
    }
}

 int
recog_202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern161 (x1, 
E_OImode, 
E_XImode))
    {
    case 0:
      if (!
#line 6004 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2903; /* neon_vld4qav16qi */

    case 1:
      if (!
#line 6004 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2904; /* neon_vld4qav8hi */

    case 2:
      if (!
#line 6004 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2905; /* neon_vld4qav8hf */

    case 3:
      if (!(
#line 6004 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2906; /* neon_vld4qav8bf */

    case 4:
      if (!
#line 6004 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2907; /* neon_vld4qav4si */

    case 5:
      if (!
#line 6004 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2908; /* neon_vld4qav4sf */

    default:
      return -1;
    }
}

 int
recog_212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2593 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1788; /* neon_vabduv8qi */

    case 1:
      if (!
#line 2593 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1790; /* neon_vabduv16qi */

    case 2:
      if (!
#line 2593 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1792; /* neon_vabduv4hi */

    case 3:
      if (!
#line 2593 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1794; /* neon_vabduv8hi */

    case 4:
      if (!
#line 2593 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1796; /* neon_vabduv2si */

    case 5:
      if (!
#line 2593 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1798; /* neon_vabduv4si */

    default:
      return -1;
    }
}

 int
recog_222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern126 (x1))
    {
    case 0:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V8QI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 518; /* mve_vshlq_sv8qi */

    case 1:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V16QI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 520; /* mve_vshlq_sv16qi */

    case 2:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V4HI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 522; /* mve_vshlq_sv4hi */

    case 3:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V8HI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 524; /* mve_vshlq_sv8hi */

    case 4:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V2SI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 526; /* mve_vshlq_sv2si */

    case 5:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V4SI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 528; /* mve_vshlq_sv4si */

    default:
      return -1;
    }
}

 int
recog_236 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern140 (x1))
    {
    case 0:
      if (!
#line 2180 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1589; /* neon_vqrdmulhv4hi */

    case 1:
      if (!
#line 2180 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1591; /* neon_vqrdmulhv2si */

    case 2:
      if (!
#line 2180 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1593; /* neon_vqrdmulhv8hi */

    case 3:
      if (!
#line 2180 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1595; /* neon_vqrdmulhv4si */

    default:
      return -1;
    }
}

 int
recog_245 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern200 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!s_register_operand (operands[0], E_TImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_TImode
          || !s_register_operand (operands[2], E_TImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!neon_struct_operand (operands[1], E_HImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8QImode
              || !
#line 5448 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2785; /* neon_vld2_lanev8qi */

        case E_SImode:
          if (!neon_struct_operand (operands[1], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4HImode
              || !
#line 5448 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2786; /* neon_vld2_lanev4hi */

        case E_SFmode:
          if (!neon_struct_operand (operands[1], E_SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4HFmode
              || !
#line 5448 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2787; /* neon_vld2_lanev4hf */

        case E_BFmode:
          if (!neon_struct_operand (operands[1], E_BFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4BFmode
              || !
#line 5448 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2788; /* neon_vld2_lanev4bf */

        case E_V2SImode:
          if (!neon_struct_operand (operands[1], E_V2SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V2SImode
              || !
#line 5448 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2789; /* neon_vld2_lanev2si */

        case E_V2SFmode:
          if (!neon_struct_operand (operands[1], E_V2SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V2SFmode
              || !
#line 5448 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2790; /* neon_vld2_lanev2sf */

        default:
          return -1;
        }

    case E_OImode:
      if (!s_register_operand (operands[0], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_OImode
          || !s_register_operand (operands[2], E_OImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!neon_struct_operand (operands[1], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8HImode
              || !
#line 5472 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2791; /* neon_vld2_lanev8hi */

        case E_SFmode:
          if (!neon_struct_operand (operands[1], E_SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8HFmode
              || !
#line 5472 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2792; /* neon_vld2_lanev8hf */

        case E_V2SImode:
          if (!neon_struct_operand (operands[1], E_V2SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4SImode
              || !
#line 5472 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2793; /* neon_vld2_lanev4si */

        case E_V2SFmode:
          if (!neon_struct_operand (operands[1], E_V2SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4SFmode
              || !
#line 5472 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2794; /* neon_vld2_lanev4sf */

        case E_BFmode:
          if (!neon_struct_operand (operands[1], E_BFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8BFmode
              || !(
#line 5472 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2795; /* neon_vld2_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (!s_register_operand (x4, E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (!arm_add_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      x8 = XEXP (x7, 0);
      if (!s_register_operand (x8, E_SImode))
        return -1;
      operands[2] = x8;
      res = recog_270 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (!shiftable_operator (x7, E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      if (!arm_rhs_operand (x9, E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          operands[7] = x10;
          if (!shiftable_operator (operands[7], E_SImode))
            return -1;
          operands[9] = x3;
          operands[5] = x4;
          operands[6] = x6;
          operands[8] = x7;
          operands[1] = x8;
          operands[2] = x9;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[4] = x12;
          if (!arm_rhs_operand (operands[4], E_SImode)
              || !
#line 10962 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 356; /* *ifcompare_arith_arith */

        case NOT:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          operands[6] = x3;
          operands[4] = x4;
          operands[5] = x6;
          operands[7] = x7;
          operands[2] = x8;
          operands[3] = x9;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 11361 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 374; /* *ifcompare_arith_not */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x7;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case PLUS:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          operands[6] = x3;
          operands[4] = x4;
          operands[5] = x6;
          if (!arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!arm_add_operand (operands[3], E_SImode)
              || !
#line 10917 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 354; /* *ifcompare_move_plus */

        case NOT:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          operands[5] = x3;
          operands[3] = x4;
          operands[4] = x6;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 11128 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 362; /* *ifcompare_move_not */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[7] = x10;
          if (!shift_operator (operands[7], E_SImode))
            return -1;
          operands[6] = x3;
          operands[4] = x4;
          operands[5] = x6;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!arm_rhs_operand (operands[3], E_SImode)
              || !
#line 11241 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 368; /* *ifcompare_move_shift */

        case NEG:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          operands[5] = x3;
          operands[3] = x4;
          operands[4] = x6;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 11429 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 378; /* *ifcompare_move_neg */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (!s_register_operand (x8, E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x10;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          operands[5] = x3;
          operands[3] = x4;
          operands[4] = x6;
          operands[2] = x8;
          if (!
#line 11163 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 364; /* *ifcompare_not_move */

        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          operands[7] = x10;
          if (!shiftable_operator (operands[7], E_SImode))
            return -1;
          operands[6] = x3;
          operands[4] = x4;
          operands[5] = x6;
          operands[1] = x8;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!arm_rhs_operand (operands[3], E_SImode)
              || !
#line 11327 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 372; /* *ifcompare_not_arith */

        default:
          return -1;
        }

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      if (!shift_operator (x7, E_SImode))
        return -1;
      x8 = XEXP (x7, 0);
      if (!s_register_operand (x8, E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      if (!arm_rhs_operand (x9, E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x10;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          operands[6] = x3;
          operands[4] = x4;
          operands[5] = x6;
          operands[7] = x7;
          operands[2] = x8;
          operands[3] = x9;
          if (!
#line 11198 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 366; /* *ifcompare_shift_move */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[9] = x10;
          if (!shift_operator (operands[9], E_SImode))
            return -1;
          operands[7] = x3;
          operands[5] = x4;
          operands[6] = x6;
          operands[8] = x7;
          operands[1] = x8;
          operands[2] = x9;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[4] = x12;
          if (!arm_rhs_operand (operands[4], E_SImode)
              || !
#line 11286 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 370; /* *ifcompare_shift_shift */

        default:
          return -1;
        }

    case NEG:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      operands[5] = x3;
      operands[3] = x4;
      operands[4] = x6;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      operands[1] = x10;
      if (!arm_not_operand (operands[1], E_SImode)
          || !
#line 11393 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 376; /* *ifcompare_neg_move */

    default:
      return -1;
    }
}

 int
recog_282 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern371 (x2) != 0
              || !
#line 944 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 7; /* *arm_addsi3 */

        case E_V2SImode:
          if (GET_MODE (x2) != E_V2SImode)
            return -1;
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 341 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 552; /* *addv2si3_iwmmxt */
          if (!s_register_operand (operands[0], E_V2SImode)
              || !s_register_operand (operands[1], E_V2SImode)
              || !s_register_operand (operands[2], E_V2SImode)
              || !
#line 519 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SI_ARITH))
            return -1;
          return 1163; /* *addv2si3_neon */

        case E_V4HImode:
          if (GET_MODE (x2) != E_V4HImode)
            return -1;
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 341 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 553; /* *addv4hi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V4HImode)
              || !s_register_operand (operands[1], E_V4HImode)
              || !s_register_operand (operands[2], E_V4HImode)
              || !
#line 519 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HI_ARITH))
            return -1;
          return 1161; /* *addv4hi3_neon */

        case E_V8QImode:
          if (GET_MODE (x2) != E_V8QImode)
            return -1;
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 341 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 554; /* *addv8qi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V8QImode)
              || !s_register_operand (operands[1], E_V8QImode)
              || !s_register_operand (operands[2], E_V8QImode)
              || !
#line 519 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8QI_ARITH))
            return -1;
          return 1159; /* *addv8qi3_neon */

        case E_HFmode:
          if (pattern1 (x2, 
E_HFmode) != 0
              || !
#line 996 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 795; /* addhf3 */

        case E_SFmode:
          if (pattern1 (x2, 
E_SFmode) != 0
              || !
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 796; /* *addsf3_vfp */

        case E_DFmode:
          if (pattern1 (x2, 
E_DFmode) != 0
              || !
#line 1016 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 797; /* *adddf3_vfp */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern347 (x2, 
E_DImode) != 0
              || !
#line 52 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          *pnum_clobbers = 1;
          return 941; /* *thumb1_adddi3 */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0)
            return -1;
          if (
#line 519 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V16QI_ARITH))
            return 1160; /* *addv16qi3_neon */
          if (!
#line 991 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3670; /* mve_vaddqv16qi */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0)
            return -1;
          if (
#line 519 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HI_ARITH))
            return 1162; /* *addv8hi3_neon */
          if (!
#line 991 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3673; /* mve_vaddqv8hi */

        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0)
            return -1;
          if (
#line 519 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SI_ARITH))
            return 1164; /* *addv4si3_neon */
          if (!
#line 991 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3676; /* mve_vaddqv4si */

        case E_V4HFmode:
          if (pattern1 (x2, 
E_V4HFmode) != 0
              || !
#line 519 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HF_ARITH))
            return -1;
          return 1165; /* *addv4hf3_neon */

        case E_V8HFmode:
          if (pattern1 (x2, 
E_V8HFmode) != 0)
            return -1;
          if (
#line 519 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HF_ARITH))
            return 1166; /* *addv8hf3_neon */
          if (!
#line 1399 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3828; /* mve_vaddq_fv8hf */

        case E_V2SFmode:
          if (pattern1 (x2, 
E_V2SFmode) != 0
              || !
#line 519 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 1167; /* *addv2sf3_neon */

        case E_V4SFmode:
          if (pattern1 (x2, 
E_V4SFmode) != 0)
            return -1;
          if (
#line 519 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return 1168; /* *addv4sf3_neon */
          if (!
#line 1399 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3831; /* mve_vaddq_fv4sf */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 519 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2DI_ARITH))
            return -1;
          return 1169; /* *addv2di3_neon */

        case E_QQmode:
          if (pattern1 (x2, 
E_QQmode) != 0
              || !
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3181; /* addqq3 */

        case E_HQmode:
          if (pattern1 (x2, 
E_HQmode) != 0
              || !
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3182; /* addhq3 */

        case E_SQmode:
          if (pattern1 (x2, 
E_SQmode) != 0
              || !
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3183; /* addsq3 */

        case E_UQQmode:
          if (pattern1 (x2, 
E_UQQmode) != 0
              || !
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3184; /* adduqq3 */

        case E_UHQmode:
          if (pattern1 (x2, 
E_UHQmode) != 0
              || !
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3185; /* adduhq3 */

        case E_USQmode:
          if (pattern1 (x2, 
E_USQmode) != 0
              || !
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3186; /* addusq3 */

        case E_HAmode:
          if (pattern1 (x2, 
E_HAmode) != 0
              || !
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3187; /* addha3 */

        case E_SAmode:
          if (pattern1 (x2, 
E_SAmode) != 0
              || !
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3188; /* addsa3 */

        case E_UHAmode:
          if (pattern1 (x2, 
E_UHAmode) != 0
              || !
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3189; /* adduha3 */

        case E_USAmode:
          if (pattern1 (x2, 
E_USAmode) != 0
              || !
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3190; /* addusa3 */

        case E_V4QQmode:
          if (pattern1 (x2, 
E_V4QQmode) != 0
              || !
#line 46 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ))
            return -1;
          return 3191; /* *arm_addv4qq3 */

        case E_V2HQmode:
          if (pattern1 (x2, 
E_V2HQmode) != 0
              || !
#line 46 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ))
            return -1;
          return 3192; /* *arm_addv2hq3 */

        case E_V2HAmode:
          if (pattern1 (x2, 
E_V2HAmode) != 0
              || !
#line 46 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ))
            return -1;
          return 3193; /* *arm_addv2ha3 */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!register_operand (operands[3], E_SImode)
              || !
#line 1486 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 665; /* iwmmxt_tmia */

        case TRUNCATE:
          if (GET_MODE (x7) != E_HImode)
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != TRUNCATE
              || GET_MODE (x8) != E_HImode)
            return -1;
          x9 = XEXP (x7, 0);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[2] = x9;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              switch (pattern610 (x10))
                {
                case 0:
                  if (!
#line 1517 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 667; /* iwmmxt_tmiabb */

                case 1:
                  if (!
#line 1551 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 669; /* iwmmxt_tmiabt */

                default:
                  return -1;
                }

            case ASHIFTRT:
              if (GET_MODE (x9) != E_SImode)
                return -1;
              x11 = XEXP (x9, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x12 = XEXP (x9, 0);
              operands[2] = x12;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              switch (pattern610 (x10))
                {
                case 0:
                  if (!
#line 1534 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 668; /* iwmmxt_tmiatb */

                case 1:
                  if (!
#line 1570 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 670; /* iwmmxt_tmiatt */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern467 (x7) != 0)
            return -1;
          x8 = XEXP (x6, 0);
          if (pattern581 (x8) != 0)
            return -1;
          switch (pattern620 (x4))
            {
            case 0:
              if (!
#line 742 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 732; /* iwmmxt_wmiawbb */

            case 1:
              if (!
#line 755 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 733; /* iwmmxt_wmiawbt */

            case 2:
              if (!
#line 768 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 734; /* iwmmxt_wmiawtb */

            case 3:
              if (!
#line 781 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 735; /* iwmmxt_wmiawtt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != SIGN_EXTEND
          || GET_MODE (x7) != E_DImode)
        return -1;
      x13 = XEXP (x5, 1);
      if (GET_CODE (x13) != SIGN_EXTEND
          || GET_MODE (x13) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != MULT
          || pattern437 (x6) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_MODE (x9) != E_HImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_MODE (x14) != E_HImode)
        return -1;
      x8 = XEXP (x6, 0);
      x10 = XEXP (x8, 0);
      if (GET_MODE (x10) != E_HImode)
        return -1;
      x15 = XEXP (x6, 1);
      x16 = XEXP (x15, 0);
      if (GET_MODE (x16) != E_HImode)
        return -1;
      switch (GET_CODE (x9))
        {
        case TRUNCATE:
          if (GET_CODE (x14) != TRUNCATE
              || GET_CODE (x10) != TRUNCATE)
            return -1;
          x17 = XEXP (x10, 0);
          if (GET_CODE (x17) != ASHIFTRT
              || GET_MODE (x17) != E_SImode)
            return -1;
          x18 = XEXP (x17, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || GET_CODE (x16) != TRUNCATE)
            return -1;
          x19 = XEXP (x16, 0);
          if (GET_CODE (x19) != ASHIFTRT
              || GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XEXP (x19, 1);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x12 = XEXP (x9, 0);
          operands[2] = x12;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x21 = XEXP (x14, 0);
          operands[3] = x21;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x22 = XEXP (x17, 0);
          if (!rtx_equal_p (x22, operands[2]))
            return -1;
          x23 = XEXP (x19, 0);
          if (!rtx_equal_p (x23, operands[3])
              || !
#line 1504 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 666; /* iwmmxt_tmiaph */

        case VEC_SELECT:
          x11 = XEXP (x9, 1);
          if (GET_CODE (x11) != PARALLEL
              || XVECLEN (x11, 0) != 1)
            return -1;
          x24 = XVECEXP (x11, 0, 0);
          if (GET_CODE (x24) != CONST_INT
              || GET_CODE (x14) != VEC_SELECT)
            return -1;
          x25 = XEXP (x14, 1);
          if (GET_CODE (x25) != PARALLEL
              || XVECLEN (x25, 0) != 1)
            return -1;
          x26 = XVECEXP (x25, 0, 0);
          if (GET_CODE (x26) != CONST_INT
              || GET_CODE (x10) != VEC_SELECT)
            return -1;
          x27 = XEXP (x10, 1);
          if (GET_CODE (x27) != PARALLEL
              || XVECLEN (x27, 0) != 1)
            return -1;
          x28 = XVECEXP (x27, 0, 0);
          if (GET_CODE (x28) != CONST_INT
              || GET_CODE (x16) != VEC_SELECT)
            return -1;
          x29 = XEXP (x16, 1);
          if (GET_CODE (x29) != PARALLEL
              || XVECLEN (x29, 0) != 1)
            return -1;
          x30 = XVECEXP (x29, 0, 0);
          if (GET_CODE (x30) != CONST_INT)
            return -1;
          switch (pattern650 (x4))
            {
            case 0:
              if (!
#line 561 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 724; /* iwmmxt_wmiabb */

            case 1:
              if (!
#line 585 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 725; /* iwmmxt_wmiabt */

            case 2:
              if (!
#line 609 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 726; /* iwmmxt_wmiatb */

            case 3:
              if (!
#line 633 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 727; /* iwmmxt_wmiatt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_281 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern371 (x2) != 0
              || !
#line 3843 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 113; /* *arm_xorsi3 */

        case E_DImode:
          if (pattern347 (x2, 
E_DImode) != 0
              || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 534; /* iwmmxt_xordi3 */

        case E_V2SImode:
          if (GET_MODE (x2) != E_V2SImode)
            return -1;
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 328 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 549; /* *xorv2si3_iwmmxt */
          if (!s_register_operand (operands[0], E_V2SImode)
              || !s_register_operand (operands[1], E_V2SImode)
              || !s_register_operand (operands[2], E_V2SImode)
              || !
#line 784 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1291; /* xorv2si3_neon */

        case E_V4HImode:
          if (GET_MODE (x2) != E_V4HImode)
            return -1;
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 328 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 550; /* *xorv4hi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V4HImode)
              || !s_register_operand (operands[1], E_V4HImode)
              || !s_register_operand (operands[2], E_V4HImode)
              || !
#line 784 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1289; /* xorv4hi3_neon */

        case E_V8QImode:
          if (GET_MODE (x2) != E_V8QImode)
            return -1;
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 328 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 551; /* *xorv8qi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V8QImode)
              || !s_register_operand (operands[1], E_V8QImode)
              || !s_register_operand (operands[2], E_V8QImode)
              || !
#line 784 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1287; /* xorv8qi3_neon */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0)
            return -1;
          if (
#line 784 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1288; /* xorv16qi3_neon */
          if (!
#line 854 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3574; /* mve_veorq_uv16qi */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0)
            return -1;
          if (
#line 784 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1290; /* xorv8hi3_neon */
          if (!
#line 854 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3575; /* mve_veorq_uv8hi */

        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0)
            return -1;
          if (
#line 784 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1292; /* xorv4si3_neon */
          if (!
#line 854 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3576; /* mve_veorq_uv4si */

        case E_V4HFmode:
          if (pattern1 (x2, 
E_V4HFmode) != 0
              || !
#line 784 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1293; /* xorv4hf3_neon */

        case E_V8HFmode:
          if (pattern1 (x2, 
E_V8HFmode) != 0)
            return -1;
          if (
#line 784 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1294; /* xorv8hf3_neon */
          if (!
#line 1289 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3780; /* mve_veorq_fv8hf */

        case E_V2SFmode:
          if (pattern1 (x2, 
E_V2SFmode) != 0
              || !
#line 784 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1295; /* xorv2sf3_neon */

        case E_V4SFmode:
          if (pattern1 (x2, 
E_V4SFmode) != 0)
            return -1;
          if (
#line 784 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1296; /* xorv4sf3_neon */
          if (!
#line 1289 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3781; /* mve_veorq_fv4sf */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 784 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1297; /* xorv2di3_neon */

        default:
          return -1;
        }

    case MULT:
      if (pattern275 (x2) != 0
          || !
#line 9686 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 322; /* *eor_multsi */

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x3;
      if (pattern304 (x2) != 0
          || !
#line 9700 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT))
        return -1;
      return 327; /* *eor_shiftsi */

    default:
      return -1;
    }
}

 int
recog_296 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case GEU:
    case LTU:
      operands[1] = x3;
      if (arm_borrow_operation (operands[1], E_SImode)
          && s_register_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode
          && 
#line 8108 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return 280; /* *negscc_borrow */
      if (GET_CODE (x3) == GEU)
        {
          switch (pattern282 (x2))
            {
            case 0:
              if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1738; /* neon_vcgeuv8qi */
              break;

            case 1:
              if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1740; /* neon_vcgeuv16qi */
              break;

            case 2:
              if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1742; /* neon_vcgeuv4hi */
              break;

            case 3:
              if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1744; /* neon_vcgeuv8hi */
              break;

            case 4:
              if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1746; /* neon_vcgeuv2si */
              break;

            case 5:
              if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1748; /* neon_vcgeuv4si */
              break;

            default:
              break;
            }
        }
      break;

    case EQ:
      switch (pattern278 (x2))
        {
        case 0:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V8QImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1667; /* neon_vceqv8qi_insn */
          break;

        case 1:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V16QImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1672; /* neon_vceqv16qi_insn */
          break;

        case 2:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4HImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1677; /* neon_vceqv4hi_insn */
          break;

        case 3:
          if (
#line 2432 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST
  && !(GET_MODE_CLASS (V4HFmode) == MODE_VECTOR_FLOAT
  && !flag_unsafe_math_optimizations)))
            return 1722; /* neon_vceqv4hf_fp16insn */
          break;

        case 4:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V8HImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1682; /* neon_vceqv8hi_insn */
          break;

        case 5:
          if (
#line 2432 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST
  && !(GET_MODE_CLASS (V8HFmode) == MODE_VECTOR_FLOAT
  && !flag_unsafe_math_optimizations)))
            return 1717; /* neon_vceqv8hf_fp16insn */
          break;

        case 6:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V2SImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1687; /* neon_vceqv2si_insn */
          break;

        case 7:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V2SFmode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1697; /* neon_vceqv2sf_insn */
          break;

        case 8:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4SImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1692; /* neon_vceqv4si_insn */
          break;

        case 9:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4SFmode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1702; /* neon_vceqv4sf_insn */
          break;

        default:
          break;
        }
      break;

    case GT:
      switch (pattern280 (x2))
        {
        case 0:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V8QImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1668; /* neon_vcgtv8qi_insn */
          break;

        case 1:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V16QImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1673; /* neon_vcgtv16qi_insn */
          break;

        case 2:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4HImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1678; /* neon_vcgtv4hi_insn */
          break;

        case 3:
          if (
#line 2432 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST
  && !(GET_MODE_CLASS (V4HFmode) == MODE_VECTOR_FLOAT
  && !flag_unsafe_math_optimizations)))
            return 1723; /* neon_vcgtv4hf_fp16insn */
          break;

        case 4:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V8HImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1683; /* neon_vcgtv8hi_insn */
          break;

        case 5:
          if (
#line 2432 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST
  && !(GET_MODE_CLASS (V8HFmode) == MODE_VECTOR_FLOAT
  && !flag_unsafe_math_optimizations)))
            return 1718; /* neon_vcgtv8hf_fp16insn */
          break;

        case 6:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V2SImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1688; /* neon_vcgtv2si_insn */
          break;

        case 7:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V2SFmode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1698; /* neon_vcgtv2sf_insn */
          break;

        case 8:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4SImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1693; /* neon_vcgtv4si_insn */
          break;

        case 9:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4SFmode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1703; /* neon_vcgtv4sf_insn */
          break;

        case 10:
          if (
#line 2506 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && flag_unsafe_math_optimizations))
            return 1749; /* neon_vcagtv2sf_insn */
          break;

        case 11:
          if (
#line 2506 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && flag_unsafe_math_optimizations))
            return 1753; /* neon_vcagtv4sf_insn */
          break;

        case 12:
          if (
#line 2546 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST && flag_unsafe_math_optimizations))
            return 1765; /* neon_vcagtv8hf_fp16insn */
          break;

        case 13:
          if (
#line 2546 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST && flag_unsafe_math_optimizations))
            return 1769; /* neon_vcagtv4hf_fp16insn */
          break;

        default:
          break;
        }
      break;

    case GE:
      switch (pattern280 (x2))
        {
        case 0:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V8QImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1669; /* neon_vcgev8qi_insn */
          break;

        case 1:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V16QImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1674; /* neon_vcgev16qi_insn */
          break;

        case 2:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4HImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1679; /* neon_vcgev4hi_insn */
          break;

        case 3:
          if (
#line 2432 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST
  && !(GET_MODE_CLASS (V4HFmode) == MODE_VECTOR_FLOAT
  && !flag_unsafe_math_optimizations)))
            return 1724; /* neon_vcgev4hf_fp16insn */
          break;

        case 4:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V8HImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1684; /* neon_vcgev8hi_insn */
          break;

        case 5:
          if (
#line 2432 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST
  && !(GET_MODE_CLASS (V8HFmode) == MODE_VECTOR_FLOAT
  && !flag_unsafe_math_optimizations)))
            return 1719; /* neon_vcgev8hf_fp16insn */
          break;

        case 6:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V2SImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1689; /* neon_vcgev2si_insn */
          break;

        case 7:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V2SFmode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1699; /* neon_vcgev2sf_insn */
          break;

        case 8:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4SImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1694; /* neon_vcgev4si_insn */
          break;

        case 9:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4SFmode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1704; /* neon_vcgev4sf_insn */
          break;

        case 10:
          if (
#line 2506 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && flag_unsafe_math_optimizations))
            return 1750; /* neon_vcagev2sf_insn */
          break;

        case 11:
          if (
#line 2506 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && flag_unsafe_math_optimizations))
            return 1754; /* neon_vcagev4sf_insn */
          break;

        case 12:
          if (
#line 2546 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST && flag_unsafe_math_optimizations))
            return 1766; /* neon_vcagev8hf_fp16insn */
          break;

        case 13:
          if (
#line 2546 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST && flag_unsafe_math_optimizations))
            return 1770; /* neon_vcagev4hf_fp16insn */
          break;

        default:
          break;
        }
      break;

    case LE:
      switch (pattern280 (x2))
        {
        case 0:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V8QImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1670; /* neon_vclev8qi_insn */
          break;

        case 1:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V16QImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1675; /* neon_vclev16qi_insn */
          break;

        case 2:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4HImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1680; /* neon_vclev4hi_insn */
          break;

        case 3:
          if (
#line 2432 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST
  && !(GET_MODE_CLASS (V4HFmode) == MODE_VECTOR_FLOAT
  && !flag_unsafe_math_optimizations)))
            return 1725; /* neon_vclev4hf_fp16insn */
          break;

        case 4:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V8HImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1685; /* neon_vclev8hi_insn */
          break;

        case 5:
          if (
#line 2432 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST
  && !(GET_MODE_CLASS (V8HFmode) == MODE_VECTOR_FLOAT
  && !flag_unsafe_math_optimizations)))
            return 1720; /* neon_vclev8hf_fp16insn */
          break;

        case 6:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V2SImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1690; /* neon_vclev2si_insn */
          break;

        case 7:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V2SFmode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1700; /* neon_vclev2sf_insn */
          break;

        case 8:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4SImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1695; /* neon_vclev4si_insn */
          break;

        case 9:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4SFmode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1705; /* neon_vclev4sf_insn */
          break;

        case 10:
          if (
#line 2506 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && flag_unsafe_math_optimizations))
            return 1752; /* neon_vcalev2sf_insn */
          break;

        case 11:
          if (
#line 2506 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && flag_unsafe_math_optimizations))
            return 1756; /* neon_vcalev4sf_insn */
          break;

        case 12:
          if (
#line 2546 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST && flag_unsafe_math_optimizations))
            return 1768; /* neon_vcalev8hf_fp16insn */
          break;

        case 13:
          if (
#line 2546 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST && flag_unsafe_math_optimizations))
            return 1772; /* neon_vcalev4hf_fp16insn */
          break;

        default:
          break;
        }
      break;

    case LT:
      switch (pattern280 (x2))
        {
        case 0:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V8QImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1671; /* neon_vcltv8qi_insn */
          break;

        case 1:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V16QImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1676; /* neon_vcltv16qi_insn */
          break;

        case 2:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4HImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1681; /* neon_vcltv4hi_insn */
          break;

        case 3:
          if (
#line 2432 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST
  && !(GET_MODE_CLASS (V4HFmode) == MODE_VECTOR_FLOAT
  && !flag_unsafe_math_optimizations)))
            return 1726; /* neon_vcltv4hf_fp16insn */
          break;

        case 4:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V8HImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1686; /* neon_vcltv8hi_insn */
          break;

        case 5:
          if (
#line 2432 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST
  && !(GET_MODE_CLASS (V8HFmode) == MODE_VECTOR_FLOAT
  && !flag_unsafe_math_optimizations)))
            return 1721; /* neon_vcltv8hf_fp16insn */
          break;

        case 6:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V2SImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1691; /* neon_vcltv2si_insn */
          break;

        case 7:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V2SFmode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1701; /* neon_vcltv2sf_insn */
          break;

        case 8:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4SImode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1696; /* neon_vcltv4si_insn */
          break;

        case 9:
          if (
#line 2366 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !(GET_MODE_CLASS (V4SFmode) == MODE_VECTOR_FLOAT
                    && !flag_unsafe_math_optimizations)))
            return 1706; /* neon_vcltv4sf_insn */
          break;

        case 10:
          if (
#line 2506 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && flag_unsafe_math_optimizations))
            return 1751; /* neon_vcaltv2sf_insn */
          break;

        case 11:
          if (
#line 2506 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && flag_unsafe_math_optimizations))
            return 1755; /* neon_vcaltv4sf_insn */
          break;

        case 12:
          if (
#line 2546 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST && flag_unsafe_math_optimizations))
            return 1767; /* neon_vcaltv8hf_fp16insn */
          break;

        case 13:
          if (
#line 2546 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST && flag_unsafe_math_optimizations))
            return 1771; /* neon_vcaltv4hf_fp16insn */
          break;

        default:
          break;
        }
      break;

    case GTU:
      switch (pattern282 (x2))
        {
        case 0:
          if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1737; /* neon_vcgtuv8qi */
          break;

        case 1:
          if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1739; /* neon_vcgtuv16qi */
          break;

        case 2:
          if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1741; /* neon_vcgtuv4hi */
          break;

        case 3:
          if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1743; /* neon_vcgtuv8hi */
          break;

        case 4:
          if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1745; /* neon_vcgtuv2si */
          break;

        case 5:
          if (
#line 2476 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1747; /* neon_vcgtuv4si */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  if (arm_comparison_operator_mode (operands[1], E_SImode))
    {
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && s_register_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode)
        {
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (cc_register (operands[2], E_VOIDmode)
              && 
#line 8119 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_borrow_operation (operands[1], SImode)))
            return 281; /* *mov_negscc */
        }
    }
  if (pnum_clobbers != NULL)
    {
      operands[3] = x3;
      if (arm_comparison_operator (operands[3], E_VOIDmode)
          && s_register_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode)
        {
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (s_register_operand (operands[1], E_SImode))
            {
              x4 = XEXP (x3, 1);
              operands[2] = x4;
              if (arm_rhs_operand (operands[2], E_SImode)
                  && 
#line 10692 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                {
                  *pnum_clobbers = 1;
                  return 349; /* *negscc */
                }
            }
        }
    }
  if (GET_MODE (x2) != E_SImode)
    return -1;
  if (GET_CODE (x3) == LTU
      && GET_MODE (x3) == E_SImode
      && s_register_operand (operands[0], E_SImode))
    {
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (s_register_operand (operands[1], E_SImode))
        {
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          if (thumb1_cmp_operand (operands[2], E_SImode)
              && 
#line 1779 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 987; /* cstoresi_nltu_thumb1 */
        }
    }
  x4 = XEXP (x3, 1);
  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      operands[1] = x3;
      if (arm_comparison_operator_mode (operands[1], E_SImode))
        {
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (cc_register (operands[2], E_VOIDmode))
            {
              if (s_register_operand (operands[0], E_SImode)
                  && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && !arm_restrict_it
   && !arm_borrow_operation (operands[1], SImode)))
                return 1019; /* *thumb2_mov_negscc */
              if (low_register_operand (operands[0], E_SImode)
                  && 
#line 365 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && arm_restrict_it
   && !arm_borrow_operation (operands[1], SImode)))
                return 1020; /* *thumb2_mov_negscc_strict_it */
            }
        }
    }
  if (pnum_clobbers == NULL
      || !s_register_operand (operands[0], E_SImode))
    return -1;
  operands[3] = x3;
  if (!arm_comparison_operator (operands[3], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  operands[2] = x4;
  if (!arm_rhs_operand (operands[2], E_SImode)
      || !
#line 899 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
    return -1;
  *pnum_clobbers = 1;
  return 1039; /* *thumb2_negscc */
}

 int
recog_307 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case MULT:
      res = recog_56 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATE:
      if (GET_MODE (x3) == E_SImode)
        {
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) == BSWAP
              && GET_MODE (x4) == E_SImode)
            {
              x5 = XEXP (x3, 1);
              if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 16]
                  && register_operand (operands[0], E_SImode))
                {
                  x6 = XEXP (x4, 0);
                  operands[1] = x6;
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 12631 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch6))
                    return 416; /* arm_rev16si2 */
                }
            }
        }
      break;

    case ROTATERT:
      res = recog_57 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ASHIFTRT:
      switch (pattern28 (x3))
        {
        case 0:
          if (register_operand (operands[1], E_V4HImode)
              && register_operand (operands[0], E_V4HImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (imm_or_reg_operand (operands[2], E_SImode)
                  && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 642; /* ashrv4hi3_iwmmxt */
              if (imm_or_reg_operand (operands[2], E_DImode)
                  && 
#line 1382 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 654; /* ashrv4hi3_di */
            }
          if (s_register_operand (operands[1], E_V4HImode)
              && s_register_operand (operands[0], E_V4HImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (imm_for_neon_rshift_operand (operands[2], E_V4HImode)
                  && 
#line 907 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1373; /* vashrv4hi3_imm */
            }
          break;

        case 1:
          if (register_operand (operands[1], E_V2SImode)
              && register_operand (operands[0], E_V2SImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (imm_or_reg_operand (operands[2], E_SImode)
                  && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 643; /* ashrv2si3_iwmmxt */
              if (imm_or_reg_operand (operands[2], E_DImode)
                  && 
#line 1382 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 655; /* ashrv2si3_di */
            }
          if (s_register_operand (operands[1], E_V2SImode)
              && s_register_operand (operands[0], E_V2SImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (imm_for_neon_rshift_operand (operands[2], E_V2SImode)
                  && 
#line 907 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1375; /* vashrv2si3_imm */
            }
          break;

        case 2:
          if (register_operand (operands[0], E_DImode))
            {
              x4 = XEXP (x3, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_DImode))
                {
                  x5 = XEXP (x3, 1);
                  operands[2] = x5;
                  if (imm_or_reg_operand (operands[2], E_SImode)
                      && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return 644; /* ashrdi3_iwmmxt */
                  if (imm_or_reg_operand (operands[2], E_DImode)
                      && 
#line 1382 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return 656; /* ashrdi3_di */
                }
            }
          if (arm_general_register_operand (operands[0], E_DImode))
            {
              x5 = XEXP (x3, 1);
              operands[1] = x5;
              if (arm_reg_or_long_shift_imm (operands[1], E_SImode))
                {
                  x4 = XEXP (x3, 0);
                  if (rtx_equal_p (x4, operands[0])
                      && 
#line 1741 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE))
                    return 1072; /* thumb2_asrl */
                }
            }
          break;

        case 3:
          if (
#line 907 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1371; /* vashrv8qi3_imm */
          break;

        case 4:
          if (
#line 907 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1372; /* vashrv16qi3_imm */
          if (
#line 573 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3388; /* mve_vshrq_n_sv16qi_imm */
          break;

        case 5:
          if (
#line 907 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1374; /* vashrv8hi3_imm */
          if (
#line 573 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3389; /* mve_vshrq_n_sv8hi_imm */
          break;

        case 6:
          if (
#line 907 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1376; /* vashrv4si3_imm */
          if (
#line 573 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3390; /* mve_vshrq_n_sv4si_imm */
          break;

        default:
          break;
        }
      break;

    case LSHIFTRT:
      switch (pattern28 (x3))
        {
        case 0:
          if (register_operand (operands[1], E_V4HImode)
              && register_operand (operands[0], E_V4HImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (imm_or_reg_operand (operands[2], E_SImode)
                  && 
#line 1319 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 645; /* lshrv4hi3_iwmmxt */
              if (register_operand (operands[2], E_DImode)
                  && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 657; /* lshrv4hi3_di */
            }
          if (s_register_operand (operands[1], E_V4HImode)
              && s_register_operand (operands[0], E_V4HImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (imm_for_neon_rshift_operand (operands[2], E_V4HImode)
                  && 
#line 920 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1379; /* vlshrv4hi3_imm */
            }
          break;

        case 1:
          if (register_operand (operands[1], E_V2SImode)
              && register_operand (operands[0], E_V2SImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (imm_or_reg_operand (operands[2], E_SImode)
                  && 
#line 1319 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 646; /* lshrv2si3_iwmmxt */
              if (register_operand (operands[2], E_DImode)
                  && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 658; /* lshrv2si3_di */
            }
          if (s_register_operand (operands[1], E_V2SImode)
              && s_register_operand (operands[0], E_V2SImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (imm_for_neon_rshift_operand (operands[2], E_V2SImode)
                  && 
#line 920 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1381; /* vlshrv2si3_imm */
            }
          break;

        case 2:
          if (register_operand (operands[0], E_DImode))
            {
              x4 = XEXP (x3, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_DImode))
                {
                  x5 = XEXP (x3, 1);
                  operands[2] = x5;
                  if (imm_or_reg_operand (operands[2], E_SImode)
                      && 
#line 1319 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return 647; /* lshrdi3_iwmmxt */
                  if (register_operand (operands[2], E_DImode)
                      && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return 659; /* lshrdi3_di */
                }
            }
          if (arm_general_register_operand (operands[0], E_DImode))
            {
              x5 = XEXP (x3, 1);
              operands[1] = x5;
              if (long_shift_imm (operands[1], E_SImode))
                {
                  x4 = XEXP (x3, 0);
                  if (rtx_equal_p (x4, operands[0])
                      && 
#line 1757 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE))
                    return 1074; /* thumb2_lsrl */
                }
            }
          break;

        case 3:
          if (
#line 920 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1377; /* vlshrv8qi3_imm */
          break;

        case 4:
          if (
#line 920 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1378; /* vlshrv16qi3_imm */
          if (
#line 589 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3391; /* mve_vshrq_n_uv16qi_imm */
          break;

        case 5:
          if (
#line 920 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1380; /* vlshrv8hi3_imm */
          if (
#line 589 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3392; /* mve_vshrq_n_uv8hi_imm */
          break;

        case 6:
          if (
#line 920 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1382; /* vlshrv4si3_imm */
          if (
#line 589 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3393; /* mve_vshrq_n_uv4si_imm */
          break;

        default:
          break;
        }
      break;

    case ASHIFT:
      res = recog_58 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (s_register_operand (operands[1], E_SImode)
      && s_register_operand (operands[0], E_SImode))
    {
      operands[3] = x3;
      if (shift_operator (operands[3], E_SImode))
        {
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (reg_or_int_operand (operands[2], E_SImode)
              && 
#line 4753 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 151; /* *arm_shiftsi3 */
        }
    }
  if (register_operand (operands[1], E_SImode)
      && register_operand (operands[0], E_SImode))
    {
      res = recog_59 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL
      || !low_register_operand (operands[1], E_SImode)
      || !low_register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (low_reg_or_int_operand (operands[2], E_SImode))
    {
      operands[3] = x3;
      if (shift_operator (operands[3], E_SImode)
          && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && ((GET_CODE(operands[3]) != ROTATE && GET_CODE(operands[3]) != ROTATERT)
       || REG_P (operands[2]))))
        {
          *pnum_clobbers = 1;
          return 1053; /* *thumb2_shiftsi3_short */
        }
    }
  if (!low_register_operand (operands[2], E_SImode)
      || GET_CODE (x3) != MULT
      || GET_MODE (x3) != E_SImode
      || !
#line 1429 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size && reload_completed))
    return -1;
  *pnum_clobbers = 1;
  return 1061; /* *thumb2_mulsi_short */
}

 int
recog_312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      switch (pattern243 (x3))
        {
        case 0:
          if (!mem_and_no_t1_wback_op (operands[1], E_HImode)
              || !
#line 5046 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(unaligned_access))
            return -1;
          return 160; /* unaligned_loadhiu */

        case 1:
          if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
            return -1;
          return 4886; /* mve_vldrq_gather_offset_extend_v8qiu */

        case 2:
          if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4888; /* mve_vldrq_gather_offset_extend_v4qiu */

        case 3:
          if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4890; /* mve_vldrq_gather_offset_extend_v4hiu */

        case 4:
          if (!
#line 3600 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4918; /* mve_vldrq_gather_shifted_offset_extend_v4siu */

        case 5:
          if (!
#line 3501 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
            return -1;
          return 4898; /* mve_vldrq_gather_offset_z_extend_v8qiu */

        case 6:
          if (!
#line 3501 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4900; /* mve_vldrq_gather_offset_z_extend_v4qiu */

        case 7:
          if (!
#line 3501 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4902; /* mve_vldrq_gather_offset_z_extend_v4hiu */

        case 8:
          if (!
#line 3642 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4925; /* mve_vldrq_gather_shifted_offset_z_extend_v4siu */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          if (s_register_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (nonimmediate_operand (operands[1], E_HImode))
                    {
                      if (
#line 5688 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6))
                        return 176; /* *arm_zero_extendhisi2 */
                      if (
#line 5699 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                        return 177; /* *arm_zero_extendhisi2_v6 */
                    }
                  break;

                case E_QImode:
                  if (nonimmediate_operand (operands[1], E_QImode))
                    {
                      if (
#line 5757 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6))
                        return 179; /* *arm_zero_extendqisi2 */
                      if (
#line 5769 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                        return 180; /* *arm_zero_extendqisi2_v6 */
                    }
                  break;

                default:
                  break;
                }
            }
          if (register_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (nonimmediate_operand (operands[1], E_HImode)
                      && 
#line 372 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    return 960; /* *thumb1_zero_extendhisi2 */
                  break;

                case E_QImode:
                  if (nonimmediate_operand (operands[1], E_QImode))
                    {
                      if (
#line 415 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && !arm_arch6))
                        return 961; /* *thumb1_zero_extendqisi2 */
                      if (
#line 427 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && arm_arch6))
                        return 962; /* *thumb1_zero_extendqisi2_v6 */
                    }
                  break;

                default:
                  break;
                }
            }
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 1107 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6))
                return -1;
              return 1045; /* *thumb2_zero_extendhisi2_v6 */

            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 1120 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6))
                return -1;
              return 1046; /* thumb2_zero_extendqisi2_v6 */

            default:
              return -1;
            }

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 6458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2995; /* neon_unpacku_v8qi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 6458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2997; /* neon_unpacku_v4hi */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 6458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2999; /* neon_unpacku_v2si */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (XVECLEN (x5, 0) == 1)
        {
          res = recog_295 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern373 (x3, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          if (vect_par_constant_low (operands[2], E_V16QImode)
              && 
#line 6295 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return 2965; /* neon_vec_unpacku_lo_v16qi */
          if (!vect_par_constant_high (operands[2], E_V16QImode)
              || !
#line 6305 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 2971; /* neon_vec_unpacku_hi_v16qi */

        case E_V4SImode:
          if (pattern373 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          if (vect_par_constant_low (operands[2], E_V8HImode)
              && 
#line 6295 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return 2967; /* neon_vec_unpacku_lo_v8hi */
          if (!vect_par_constant_high (operands[2], E_V8HImode)
              || !
#line 6305 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 2973; /* neon_vec_unpacku_hi_v8hi */

        case E_V2DImode:
          if (pattern373 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          if (vect_par_constant_low (operands[2], E_V4SImode)
              && 
#line 6295 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return 2969; /* neon_vec_unpacku_lo_v4si */
          if (!vect_par_constant_high (operands[2], E_V4SImode)
              || !
#line 6305 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 2975; /* neon_vec_unpacku_hi_v4si */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern246 (x3))
        {
        case 0:
          if (!
#line 6420 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2989; /* neon_vec_ushiftl_v8qi */

        case 1:
          if (!
#line 6420 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2991; /* neon_vec_ushiftl_v4hi */

        case 2:
          if (!
#line 6420 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2993; /* neon_vec_ushiftl_v2si */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x4, 0) != 1
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      switch (XINT (x4, 1))
        {
        case 20:
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!mem_noofs_operand (operands[1], E_QImode)
                  || !
#line 500 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH))
                return -1;
              return 3165; /* arm_load_exclusiveqi */

            case E_HImode:
              if (!mem_noofs_operand (operands[1], E_HImode)
                  || !
#line 500 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH))
                return -1;
              return 3166; /* arm_load_exclusivehi */

            default:
              return -1;
            }

        case 23:
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!mem_noofs_operand (operands[1], E_QImode)
                  || !
#line 510 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3167; /* arm_load_acquire_exclusiveqi */

            case E_HImode:
              if (!mem_noofs_operand (operands[1], E_HImode)
                  || !
#line 510 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3168; /* arm_load_acquire_exclusivehi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_323 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FIX:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (x4))
            {
            case E_SFmode:
              if (!s_register_operand (operands[1], E_SFmode)
                  || !
#line 1512 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 843; /* *truncsisf2_vfp */

            case E_DFmode:
              if (!s_register_operand (operands[1], E_DFmode)
                  || !
#line 1521 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 844; /* *truncsidf2_vfp */

            default:
              return -1;
            }

        case MULT:
          if (GET_MODE (x5) != E_SFmode
              || GET_MODE (x4) != E_SFmode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!s_register_operand (operands[1], E_SFmode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!const_double_vcvt_power_of_two (operands[2], E_VOIDmode)
              || !
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math))
            return -1;
          return 873; /* *combine_vcvtf2i */

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern252 (x3))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 903; /* lceilsfsi2 */

        case 1:
          if (!(
#line 2053 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 909; /* lceildfsi2 */

        case 2:
          if (!
#line 2053 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 904; /* lfloorsfsi2 */

        case 3:
          if (!(
#line 2053 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 910; /* lfloordfsi2 */

        case 4:
          if (!
#line 2053 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 905; /* lroundsfsi2 */

        case 5:
          if (!(
#line 2053 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 911; /* lrounddfsi2 */

        case 6:
          if (!
#line 717 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1231; /* neon_vcvtpv2sfv2si */

        case 7:
          if (!
#line 717 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1237; /* neon_vcvtpv4sfv4si */

        case 8:
          if (!
#line 717 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1232; /* neon_vcvtmv2sfv2si */

        case 9:
          if (!
#line 717 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1238; /* neon_vcvtmv4sfv4si */

        case 10:
          if (!
#line 717 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1233; /* neon_vcvtav2sfv2si */

        case 11:
          if (!
#line 717 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1239; /* neon_vcvtav4sfv4si */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern253 (x3))
        {
        case 0:
          if (!
#line 3701 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2104; /* fix_truncv2sfv2si2 */

        case 1:
          if (!
#line 3701 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2105; /* fix_truncv4sfv4si2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x5) != E_SImode)
            return -1;
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2261 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6416; /* *p *mul */

        case E_V4HImode:
          if (pattern488 (x5, 
E_V4HImode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 481 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6708; /* *p *mulv4hi3_iwmmxt */

        case E_V2SImode:
          if (pattern488 (x5, 
E_V2SImode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 361 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6847; /* *p iwmmxt_wmulwl */

        case E_SFmode:
          if (pattern489 (x5, 
E_SFmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1113 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6921; /* *p *mulsf3_vfp */

        case E_DFmode:
          if (pattern489 (x5, 
E_DFmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6922; /* *p *muldf3_vfp */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      switch (pattern490 (x5, 
E_HImode))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2528 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
            return -1;
          return 6425; /* *p mulhisi3 */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2554 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
            return -1;
          return 6427; /* *p *mulhisi3bt */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      switch (pattern490 (x5, 
E_SImode))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2541 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
            return -1;
          return 6426; /* *p *mulhisi3tb */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2568 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
            return -1;
          return 6428; /* *p *mulhisi3tt */

        default:
          return -1;
        }

    case NEG:
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern541 (x5, 
E_SFmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1153 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && !flag_rounding_math)))
            return -1;
          return 6923; /* *p *mulsf3negsf_vfp */

        case E_DFmode:
          if (pattern541 (x5, 
E_DFmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1173 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE
  && !flag_rounding_math)))
            return -1;
          return 6925; /* *p *muldf3negdf_vfp */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern473 (x5))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1865 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math)))
            return -1;
          return 6967; /* *p *combine_vcvt_f32_u32 */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1878 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math
  && !TARGET_VFP_SINGLE)))
            return -1;
          return 6969; /* *p *combine_vcvt_f64_u32 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern473 (x5))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1865 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math)))
            return -1;
          return 6968; /* *p *combine_vcvt_f32_s32 */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1878 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math
  && !TARGET_VFP_SINGLE)))
            return -1;
          return 6970; /* *p *combine_vcvt_f64_s32 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return recog_332 (x1, insn, pnum_clobbers);

    case PLUS:
      if (GET_MODE (x5) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x1, 0);
          operands[4] = x7;
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          x9 = XEXP (x5, 1);
          operands[2] = x9;
          if (!arm_not_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          if (!arm_carry_operation (operands[3], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1338 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6403; /* *p addsi3_carryin */

        case GEU:
        case LTU:
          operands[3] = x6;
          if (!arm_carry_operation (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x1, 0);
          operands[4] = x7;
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          x9 = XEXP (x5, 1);
          operands[1] = x9;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          if (!arm_not_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1369 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6405; /* *p *addsi3_carryin_alt2 */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (!shift_operator (x6, E_SImode))
            return -1;
          x7 = XEXP (x1, 0);
          operands[6] = x7;
          x8 = XEXP (x7, 0);
          operands[7] = x8;
          x11 = XEXP (x6, 0);
          if (!s_register_operand (x11, E_SImode))
            return -1;
          x12 = XEXP (x6, 1);
          if (!shift_amount_operand (x12, E_SImode))
            return -1;
          x9 = XEXP (x5, 1);
          switch (GET_CODE (x9))
            {
            case GEU:
            case LTU:
              operands[5] = x9;
              if (!arm_carry_operation (operands[5], E_SImode))
                return -1;
              operands[2] = x6;
              operands[3] = x11;
              operands[4] = x12;
              x10 = XEXP (x4, 1);
              operands[1] = x10;
              if (!s_register_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1390 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6406; /* *p *addsi3_carryin_shift */

            case NOT:
              if (GET_MODE (x9) != E_SImode)
                return -1;
              operands[3] = x6;
              operands[1] = x11;
              operands[2] = x12;
              x13 = XEXP (x9, 0);
              operands[4] = x13;
              if (!s_register_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[5] = x10;
              if (!arm_carry_operation (operands[5], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1749 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM)))
                return -1;
              return 6410; /* *p add_not_shift_cin */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[4] = x7;
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          x11 = XEXP (x6, 0);
          operands[1] = x11;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          if (!arm_carry_operation (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          if (!arm_rhs_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1729 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM || (TARGET_THUMB2 && !CONST_INT_P (operands[2])))))
            return -1;
          return 6409; /* *p *add_not_cin */

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[2] = x5;
      if (!arm_carry_operation (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XEXP (x4, 1);
      operands[1] = x10;
      if (!arm_not_operand (operands[1], E_SImode)
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1356 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6404; /* *p add0si3_carryin */

    case MULT:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          x7 = XEXP (x1, 0);
          operands[4] = x7;
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x9 = XEXP (x5, 1);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!s_register_operand (operands[0], E_SImode)
                      || GET_MODE (x4) != E_SImode
                      || GET_MODE (x5) != E_SImode)
                    return -1;
                  operands[3] = x6;
                  if (!s_register_operand (operands[3], E_SImode))
                    return -1;
                  operands[2] = x9;
                  if (!s_register_operand (operands[2], E_SImode)
                      || !s_register_operand (operands[1], E_SImode)
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2279 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                    return -1;
                  return 6417; /* *p *mla */

                case E_SFmode:
                  if (pattern538 (x4, 
E_SFmode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
                    return -1;
                  return 6927; /* *p *mulsf3addsf_vfp */

                case E_DFmode:
                  if (pattern538 (x4, 
E_DFmode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
                    return -1;
                  return 6928; /* *p *muldf3adddf_vfp */

                default:
                  return -1;
                }

            case CONST_INT:
              operands[3] = x9;
              if (!power_of_two_operand (operands[3], E_SImode)
                  || !s_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || GET_MODE (x5) != E_SImode)
                return -1;
              operands[2] = x6;
              if (!s_register_operand (operands[2], E_SImode)
                  || !s_register_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9686 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6583; /* *p *add_multsi */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x9 = XEXP (x5, 1);
          if (GET_CODE (x9) != SIGN_EXTEND)
            return -1;
          x7 = XEXP (x1, 0);
          operands[4] = x7;
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          x11 = XEXP (x6, 0);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[1] = x11;
              if (!s_register_operand (operands[1], E_HImode))
                return -1;
              x13 = XEXP (x9, 0);
              operands[2] = x13;
              if (!s_register_operand (operands[2], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern592 (x4, 
E_SImode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2603 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ)))
                    return -1;
                  return 6429; /* *p *arm_maddhisi4 */

                case E_DImode:
                  if (pattern592 (x4, 
E_DImode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2747 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
                    return -1;
                  return 6435; /* *p maddhidi4 */

                default:
                  return -1;
                }

            case ASHIFTRT:
              if (GET_MODE (x11) != E_SImode)
                return -1;
              x14 = XEXP (x11, 1);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                  || !s_register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode
                  || GET_MODE (x5) != E_DImode
                  || GET_MODE (x6) != E_DImode)
                return -1;
              x15 = XEXP (x11, 0);
              operands[1] = x15;
              if (!s_register_operand (operands[1], E_SImode)
                  || GET_MODE (x9) != E_DImode
                  || !s_register_operand (operands[3], E_DImode))
                return -1;
              x13 = XEXP (x9, 0);
              switch (GET_CODE (x13))
                {
                case REG:
                case SUBREG:
                  operands[2] = x13;
                  if (!s_register_operand (operands[2], E_HImode)
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2763 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
                    return -1;
                  return 6436; /* *p *maddhidi4tb */

                case ASHIFTRT:
                  if (GET_MODE (x13) != E_SImode)
                    return -1;
                  x16 = XEXP (x13, 1);
                  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    return -1;
                  x17 = XEXP (x13, 0);
                  operands[2] = x17;
                  if (!s_register_operand (operands[2], E_SImode)
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
                    return -1;
                  return 6437; /* *p *maddhidi4tt */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFTRT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x12 = XEXP (x6, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x7 = XEXP (x1, 0);
          operands[4] = x7;
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x5) != E_SImode)
            return -1;
          x11 = XEXP (x6, 0);
          operands[1] = x11;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x5, 1);
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_CODE (x9))
            {
            case SIGN_EXTEND:
              x13 = XEXP (x9, 0);
              operands[2] = x13;
              if (!s_register_operand (operands[2], E_HImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2650 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ)))
                return -1;
              return 6431; /* *p maddhisi4tb */

            case ASHIFTRT:
              x18 = XEXP (x9, 1);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x13 = XEXP (x9, 0);
              operands[2] = x13;
              if (!s_register_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2699 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ)))
                return -1;
              return 6433; /* *p maddhisi4tt */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern406 (x5, 
3, 
1) != 0)
            return -1;
          x9 = XEXP (x5, 1);
          x18 = XEXP (x9, 1);
          x19 = XVECEXP (x18, 0, 0);
          if (GET_CODE (x19) != CONST_INT)
            return -1;
          x20 = XVECEXP (x18, 0, 1);
          if (GET_CODE (x20) != CONST_INT)
            return -1;
          x10 = XEXP (x4, 1);
          if (pattern599 (x10, 
2, 
0) != 0)
            return -1;
          x21 = XEXP (x10, 1);
          if (GET_CODE (x21) != VEC_SELECT
              || GET_MODE (x21) != E_V2SImode)
            return -1;
          x22 = XEXP (x21, 1);
          if (GET_CODE (x22) != PARALLEL
              || XVECLEN (x22, 0) != 2)
            return -1;
          x23 = XVECEXP (x22, 0, 0);
          if (GET_CODE (x23) != CONST_INT)
            return -1;
          x24 = XVECEXP (x22, 0, 1);
          if (GET_CODE (x24) != CONST_INT)
            return -1;
          switch (pattern636 (x1))
            {
            case 0:
              switch (pattern651 (x4, 
SIGN_EXTEND))
                {
                case 0:
                  if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1454 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6801; /* *p iwmmxt_wmadds */

                case 1:
                  if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6837; /* *p iwmmxt_wmaddsx */

                default:
                  return -1;
                }

            case 1:
              switch (pattern651 (x4, 
ZERO_EXTEND))
                {
                case 0:
                  if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6802; /* *p iwmmxt_wmaddu */

                case 1:
                  if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6838; /* *p iwmmxt_wmaddux */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!s_register_operand (operands[1], E_HImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5711 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6489; /* *p *arm_zero_extendhisi2addsi */

        case E_QImode:
          if (!s_register_operand (operands[1], E_QImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5781 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6492; /* *p *arm_zero_extendqisi2addsi */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_QImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode)
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6046 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6499; /* *p *arm_extendqisi2addsi */

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x5;
      if (pattern407 (x1) != 0
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9700 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT)))
        return -1;
      return 6588; /* *p *add_shiftsi */

    default:
      return -1;
    }
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 25
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x8 = XVECEXP (x5, 0, 0);
      operands[1] = x8;
      if (!memory_operand (operands[1], E_HImode)
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5036 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(unaligned_access && TARGET_32BIT)))
        return -1;
      return 6475; /* *p unaligned_loadhis */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode)
            return -1;
          if (nonimmediate_operand (operands[1], E_HImode))
            {
              if ((
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5927 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6)))
                return 6494; /* *p *arm_extendhisi2 */
              if ((
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5940 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6)))
                return 6495; /* *p *arm_extendhisi2_v6 */
            }
          if (arm_reg_or_extendqisi_mem_op (operands[1], E_QImode))
            {
              if ((
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6021 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6)))
                return 6497; /* *p *arm_extendqisi */
              if ((
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6034 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
                return 6498; /* *p *arm_extendqisi_v6 */
            }
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1094 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6)))
            return -1;
          return 6983; /* *p *thumb2_extendqisi_v6 */

        case E_HImode:
          if (!s_register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || !arm_extendqisi_mem_op (operands[1], E_QImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5984 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4)))
            return -1;
          return 6496; /* *p *arm_extendqihi_insn */

        default:
          return -1;
        }

    case BSWAP:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_HImode)
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12555 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch6)))
        return -1;
      return 6604; /* *p *arm_revsh */

    case VEC_SELECT:
      x10 = XEXP (x5, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (pattern543 (x5))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 736 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6727; /* *p iwmmxt_textrmsb */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6729; /* *p iwmmxt_textrmsh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_359 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (pattern563 (x6, 
MULT, 
E_DImode, 
LSHIFTRT, 
TRUNCATE) != 0)
    return -1;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x7, 0);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XEXP (x12, 1);
  if (GET_MODE (x14) != E_DImode)
    return -1;
  switch (GET_CODE (x13))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x14) != SIGN_EXTEND)
        return -1;
      x15 = XEXP (x13, 0);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x14, 0);
      if (!rtx_equal_p (x16, operands[3])
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2444 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6419; /* *p smull */

    case ZERO_EXTEND:
      if (GET_CODE (x14) != ZERO_EXTEND)
        return -1;
      x15 = XEXP (x13, 0);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x14, 0);
      if (!rtx_equal_p (x16, operands[3])
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2444 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6420; /* *p umull */

    default:
      return -1;
    }
}

 int
recog_368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  x6 = XVECEXP (x2, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  if (!memory_operand (operands[3], E_SImode)
      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 164 "../../gcc-15.1.1-20250425/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, true))))
    return -1;
  return 6620; /* *p *arm_ldrd */
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  switch (pattern443 (x2))
    {
    case 0:
      if (pattern525 (x2) != 0)
        return -1;
      x6 = XEXP (x1, 0);
      operands[5] = x6;
      x7 = XEXP (x6, 0);
      operands[6] = x7;
      if (pattern606 (operands[0]) != 0)
        return -1;
      x8 = XEXP (x3, 1);
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[4] = x9;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          x11 = XEXP (x10, 0);
          x12 = XEXP (x11, 1);
          if (XWINT (x12, 0) != 4LL)
            return -1;
          x13 = XEXP (x5, 1);
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_SImode)
            return -1;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          x17 = XEXP (x14, 0);
          if (!rtx_equal_p (x17, operands[4])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 477 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
            return -1;
          return 6638; /* *p *ldm3_ */

        case PLUS:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x18 = XEXP (x9, 1);
          if (GET_CODE (x18) != CONST_INT)
            return -1;
          x19 = XEXP (x9, 0);
          operands[4] = x19;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          x11 = XEXP (x10, 0);
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          switch (XWINT (x18, 0))
            {
            case 4LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != 8LL)
                return -1;
              x13 = XEXP (x5, 1);
              x14 = XEXP (x13, 0);
              if (pattern638 (x14, 
12) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 582 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6642; /* *p *ldm3_ib */

            case -8LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -4LL)
                return -1;
              x13 = XEXP (x5, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[4])
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 643 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6646; /* *p *ldm3_da */

            case -12LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -8LL)
                return -1;
              x13 = XEXP (x5, 1);
              x14 = XEXP (x13, 0);
              if (pattern638 (x14, 
-4) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 704 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6650; /* *p *ldm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern564 (x2) != 0)
        return -1;
      x6 = XEXP (x1, 0);
      operands[5] = x6;
      x7 = XEXP (x6, 0);
      operands[6] = x7;
      if (!store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[3] = x13;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x20 = XEXP (x3, 0);
      x21 = XEXP (x20, 0);
      switch (GET_CODE (x21))
        {
        case REG:
        case SUBREG:
          operands[4] = x21;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x22 = XEXP (x4, 0);
          x23 = XEXP (x22, 0);
          x24 = XEXP (x23, 1);
          if (XWINT (x24, 0) != 4LL)
            return -1;
          x25 = XEXP (x5, 0);
          x26 = XEXP (x25, 0);
          if (GET_CODE (x26) != PLUS
              || GET_MODE (x26) != E_SImode)
            return -1;
          x27 = XEXP (x26, 1);
          if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x28 = XEXP (x23, 0);
          if (!rtx_equal_p (x28, operands[4]))
            return -1;
          x29 = XEXP (x26, 0);
          if (!rtx_equal_p (x29, operands[4])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 537 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
            return -1;
          return 6640; /* *p *stm3_ */

        case PLUS:
          if (GET_MODE (x21) != E_SImode)
            return -1;
          x30 = XEXP (x21, 1);
          if (GET_CODE (x30) != CONST_INT)
            return -1;
          x31 = XEXP (x21, 0);
          operands[4] = x31;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x22 = XEXP (x4, 0);
          x23 = XEXP (x22, 0);
          x28 = XEXP (x23, 0);
          if (!rtx_equal_p (x28, operands[4]))
            return -1;
          switch (XWINT (x30, 0))
            {
            case 4LL:
              x24 = XEXP (x23, 1);
              if (XWINT (x24, 0) != 8LL)
                return -1;
              x25 = XEXP (x5, 0);
              x26 = XEXP (x25, 0);
              if (pattern640 (x26, 
12) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6644; /* *p *stm3_ib */

            case -8LL:
              x24 = XEXP (x23, 1);
              if (XWINT (x24, 0) != -4LL)
                return -1;
              x25 = XEXP (x5, 0);
              x26 = XEXP (x25, 0);
              if (!rtx_equal_p (x26, operands[4])
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 673 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6648; /* *p *stm3_da */

            case -12LL:
              x24 = XEXP (x23, 1);
              if (XWINT (x24, 0) != -8LL)
                return -1;
              x25 = XEXP (x5, 0);
              x26 = XEXP (x25, 0);
              if (pattern640 (x26, 
-4) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6652; /* *p *stm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      x20 = XEXP (x3, 0);
      operands[3] = x20;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      x9 = XEXP (x8, 0);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      x32 = XEXP (x8, 1);
      switch (XWINT (x32, 0))
        {
        case 8LL:
          switch (pattern597 (x4))
            {
            case 0:
              x13 = XEXP (x5, 1);
              if (GET_CODE (x13) != MEM
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != PLUS
                  || GET_MODE (x14) != E_SImode)
                return -1;
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != CONST_INT
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x22 = XEXP (x4, 0);
              operands[1] = x22;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x25 = XEXP (x5, 0);
              operands[2] = x25;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x17 = XEXP (x14, 0);
              if (!rtx_equal_p (x17, operands[3]))
                return -1;
              x10 = XEXP (x4, 1);
              x11 = XEXP (x10, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x11, operands[3])
                      || XWINT (x15, 0) != 4LL
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6655; /* *p *ldm2_ia_update */

                case PLUS:
                  if (GET_MODE (x11) != E_SImode)
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x15, 0) != 8LL)
                    return -1;
                  x16 = XEXP (x11, 0);
                  if (!rtx_equal_p (x16, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6659; /* *p *ldm2_ib_update */

                default:
                  return -1;
                }

            case 1:
              x25 = XEXP (x5, 0);
              if (GET_CODE (x25) != MEM
                  || GET_MODE (x25) != E_SImode)
                return -1;
              x26 = XEXP (x25, 0);
              if (GET_CODE (x26) != PLUS
                  || GET_MODE (x26) != E_SImode)
                return -1;
              x27 = XEXP (x26, 1);
              if (GET_CODE (x27) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x5, 1);
              operands[2] = x13;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x29 = XEXP (x26, 0);
              if (!rtx_equal_p (x29, operands[3]))
                return -1;
              x22 = XEXP (x4, 0);
              x23 = XEXP (x22, 0);
              switch (GET_CODE (x23))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x23, operands[3])
                      || XWINT (x27, 0) != 4LL
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 917 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6657; /* *p *stm2_ia_update */

                case PLUS:
                  if (GET_MODE (x23) != E_SImode)
                    return -1;
                  x24 = XEXP (x23, 1);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x27, 0) != 8LL)
                    return -1;
                  x28 = XEXP (x23, 0);
                  if (!rtx_equal_p (x28, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6661; /* *p *stm2_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -8LL:
          x10 = XEXP (x4, 1);
          switch (GET_CODE (x10))
            {
            case MEM:
              if (pattern525 (x2) != 0
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x22 = XEXP (x4, 0);
              operands[1] = x22;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x25 = XEXP (x5, 0);
              operands[2] = x25;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x10, 0);
              x16 = XEXP (x11, 0);
              if (!rtx_equal_p (x16, operands[3]))
                return -1;
              x12 = XEXP (x11, 1);
              switch (XWINT (x12, 0))
                {
                case -4LL:
                  x13 = XEXP (x5, 1);
                  x14 = XEXP (x13, 0);
                  if (!rtx_equal_p (x14, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1007 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6663; /* *p *ldm2_da_update */

                case -8LL:
                  x13 = XEXP (x5, 1);
                  x14 = XEXP (x13, 0);
                  if (GET_CODE (x14) != PLUS
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x15 = XEXP (x14, 1);
                  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x17 = XEXP (x14, 0);
                  if (!rtx_equal_p (x17, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1059 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6667; /* *p *ldm2_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x10;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern564 (x2) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x5, 1);
              operands[2] = x13;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x22 = XEXP (x4, 0);
              x23 = XEXP (x22, 0);
              x28 = XEXP (x23, 0);
              if (!rtx_equal_p (x28, operands[3]))
                return -1;
              x24 = XEXP (x23, 1);
              switch (XWINT (x24, 0))
                {
                case -4LL:
                  x25 = XEXP (x5, 0);
                  x26 = XEXP (x25, 0);
                  if (!rtx_equal_p (x26, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1031 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6665; /* *p *stm2_da_update */

                case -8LL:
                  x25 = XEXP (x5, 0);
                  x26 = XEXP (x25, 0);
                  if (GET_CODE (x26) != PLUS
                      || GET_MODE (x26) != E_SImode)
                    return -1;
                  x27 = XEXP (x26, 1);
                  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x29 = XEXP (x26, 0);
                  if (!rtx_equal_p (x29, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1083 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6669; /* *p *stm2_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (s_register_operand (operands[1], E_SImode)
          && s_register_operand (operands[0], E_SImode))
        {
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (reg_or_int_operand (operands[2], E_SImode)
              && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_op (INTVAL (operands[2]), PLUS)
   && (reload_completed || !arm_eliminable_register (operands[1]))))
            return gen_split_1 (insn, operands);
        }
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!nonmemory_operand (operands[2], E_SImode)
          || !(
#line 66 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1) && 
#line 87 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
( reload_completed && CONST_INT_P (operands[2])
   && ((operands[1] != stack_pointer_rtx
        && (INTVAL (operands[2]) > 255 || INTVAL (operands[2]) < -255))
       || (operands[1] == stack_pointer_rtx
 	   && INTVAL (operands[2]) > 1020)))))
        return NULL;
      return gen_split_113 (insn, operands);

    case MINUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_int_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!reg_or_int_operand (operands[2], E_SImode)
          || !(
#line 2020 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 2031 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( (CONST_INT_P (operands[1])
       && !const_ok_for_arm (INTVAL (operands[1]))))))
        return NULL;
      return gen_split_3 (insn, operands);

    case AND:
    case IOR:
    case XOR:
      operands[6] = x2;
      if (logical_binary_operator (operands[6], E_DImode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (s_register_operand (operands[0], E_DImode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (s_register_operand (operands[1], E_DImode))
                {
                  x5 = XEXP (x2, 1);
                  operands[2] = x5;
                  if (s_register_operand (operands[2], E_DImode)
                      && 
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed
   && ! IS_IWMMXT_REGNUM (REGNO (operands[0]))))
                    return gen_split_4 (insn, operands);
                }
            }
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return NULL;
      switch (GET_CODE (x2))
        {
        case AND:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
	|| const_ok_for_arm (~INTVAL (operands[2]))
	|| (arm_arch_thumb2
	    && satisfies_constraint_Dj (operands[2])
	    && (rtx_equal_p (operands[0], operands[1])
		|| !reload_completed)))))
                return NULL;
              return gen_split_6 (insn, operands);

            case IOR:
              if (GET_MODE (x4) != E_SImode)
                return NULL;
              x5 = XEXP (x2, 1);
              if (GET_CODE (x5) != NOT
                  || GET_MODE (x5) != E_SImode)
                return NULL;
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x7 = XEXP (x4, 1);
              operands[2] = x7;
              if (!arm_rhs_operand (operands[2], E_SImode))
                return NULL;
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              if (!arm_rhs_operand (operands[3], E_SImode)
                  || !(
#line 3910 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 3912 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
                return NULL;
              return gen_split_17 (insn, operands);

            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              operands[1] = x4;
              if (!arm_comparison_operator (operands[1], E_SImode))
                return NULL;
              x7 = XEXP (x4, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              if (!cc_register (operands[2], E_VOIDmode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (!s_register_operand (operands[3], E_SImode))
                return NULL;
              if ((
#line 9815 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 9817 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_78 (insn, operands);
              if (!(
#line 618 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 620 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_146 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !
#line 3744 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
        || (TARGET_THUMB2 && const_ok_for_arm (~INTVAL (operands[2]))))))
                return NULL;
              return gen_split_14 (insn, operands);

            case AND:
              if (pattern361 (x2) != 0
                  || !
#line 5817 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (UINTVAL (operands[3])
       == (GET_MODE_MASK (GET_MODE (operands[5]))
           & (GET_MODE_MASK (GET_MODE (operands[5]))
	      << (INTVAL (operands[2])))))))
                return NULL;
              return gen_split_35 (insn, operands);

            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              if (!arm_comparison_operator (x4, E_SImode))
                return NULL;
              x7 = XEXP (x4, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x6 = XEXP (x4, 0);
              if (!cc_register (x6, E_VOIDmode))
                return NULL;
              operands[2] = x6;
              operands[1] = x4;
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (s_register_operand (operands[3], E_SImode))
                {
                  if ((
#line 9844 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 9848 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed
   && REGNO (operands [0]) != REGNO (operands[3]))))
                    return gen_split_79 (insn, operands);
                  if ((
#line 646 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it) && 
#line 651 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed
    && REGNO (operands [0]) != REGNO (operands[3]))))
                    return gen_split_147 (insn, operands);
                }
              operands[3] = x6;
              operands[2] = x4;
              operands[1] = x5;
              if (!s_register_operand (operands[1], E_SImode)
                  || !(
#line 677 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it) && 
#line 679 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_148 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !
#line 3849 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_arm (INTVAL (operands[2]))))
                return NULL;
              return gen_split_15 (insn, operands);

            case AND:
              if (pattern361 (x2) != 0
                  || !
#line 5817 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (UINTVAL (operands[3])
       == (GET_MODE_MASK (GET_MODE (operands[5]))
           & (GET_MODE_MASK (GET_MODE (operands[5]))
	      << (INTVAL (operands[2])))))))
                return NULL;
              return gen_split_36 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          if (!s_register_operand (operands[1], E_DImode)
              || !s_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !
#line 2922 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_5 (insn, operands);

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x2) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!cc_register (operands[2], E_VOIDmode))
            return NULL;
          if (s_register_operand (operands[0], E_SImode))
            {
              if (arm_comparison_operator (operands[1], E_SImode)
                  && 
#line 8140 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return gen_split_73 (insn, operands);
              if (arm_comparison_operator_mode (operands[1], E_SImode)
                  && (
#line 396 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it) && 
#line 398 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( true)))
                return gen_split_143 (insn, operands);
            }
          if (!low_register_operand (operands[0], E_SImode)
              || !arm_comparison_operator_mode (operands[1], E_SImode)
              || !(
#line 416 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it) && 
#line 418 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
            return NULL;
          return gen_split_144 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!s_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[1], E_VOIDmode)
              || !
#line 5622 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_29 (insn, operands);

        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return NULL;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!s_register_operand (operands[1], E_HImode)
                  || !
#line 5678 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(!TARGET_THUMB2 && !arm_arch6))
                return NULL;
              return gen_split_31 (insn, operands);

            case E_QImode:
              if (!s_register_operand (operands[1], E_QImode)
                  || !
#line 5742 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(!arm_arch6))
                return NULL;
              return gen_split_32 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!s_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[1], E_VOIDmode)
              || !
#line 5640 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_30 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return NULL;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !
#line 5917 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(!arm_arch6))
                return NULL;
              return gen_split_38 (insn, operands);

            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && 
#line 6011 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(!arm_arch6))
                return gen_split_39 (insn, operands);
              if (!memory_operand (operands[1], E_QImode)
                  || !
#line 512 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed))
                return NULL;
              return gen_split_118 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_2 (x1, insn);

    case UNSPEC:
      if (XVECLEN (x2, 0) != 2)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x9 = XVECEXP (x2, 0, 0);
      operands[1] = x9;
      x10 = XVECEXP (x2, 0, 1);
      operands[2] = x10;
      switch (XINT (x2, 1))
        {
        case 27:
          if (GET_MODE (x2) != E_SImode
              || !s_register_operand (operands[0], E_SImode)
              || !(
#line 6690 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(flag_pic) && 
#line 6692 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
            return NULL;
          return gen_split_67 (insn, operands);

        case 343:
          if (GET_MODE (x2) != E_V16QImode
              || !s_register_operand (operands[0], E_V16QImode))
            return NULL;
          switch (pattern415 ())
            {
            case 0:
              if (!(
#line 4748 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 4750 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
( reload_completed)))
                return NULL;
              return gen_split_173 (insn, operands);

            case 1:
              if (!(
#line 4779 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 4781 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
( reload_completed)))
                return NULL;
              return gen_split_174 (insn, operands);

            default:
              return NULL;
            }

        case 171:
          if (GET_MODE (x2) != E_OImode
              || !s_register_operand (operands[0], E_OImode)
              || !s_register_operand (operands[1], E_V16QImode)
              || !s_register_operand (operands[2], E_V16QImode)
              || !(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 4816 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_175 (insn, operands);

        default:
          return NULL;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      if (arm_comparison_operator_mode (operands[1], E_SImode))
        {
          x5 = XEXP (x2, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x2, 0);
                  operands[2] = x4;
                  if (cc_register (operands[2], E_VOIDmode)
                      && 
#line 8094 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                    return gen_split_71 (insn, operands);
                }
            }
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      if (GET_MODE (x2) == E_SImode)
        {
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (s_register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              switch (GET_CODE (x2))
                {
                case LTU:
                  if (thumb1_cmp_operand (operands[2], E_SImode)
                      && 
#line 1791 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    return gen_split_130 (insn, operands);
                  break;

                case LEU:
                  if (s_register_operand (operands[2], E_SImode)
                      && 
#line 1819 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
  && !reg_overlap_mentioned_p (operands[0], operands[1])
  && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    return gen_split_131 (insn, operands);
                  break;

                case GEU:
                  if (thumb1_cmp_operand (operands[2], E_SImode)
                      && 
#line 1832 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
  && !reg_overlap_mentioned_p (operands[0], operands[1])
  && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    return gen_split_132 (insn, operands);
                  break;

                default:
                  break;
                }
            }
        }
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      operands[1] = x2;
      if (!arm_comparison_operator_mode (operands[1], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!cc_register (operands[2], E_VOIDmode)
          || !
#line 328 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return NULL;
      return gen_split_140 (insn, operands);

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!arm_comparison_operator_mode (operands[1], E_SImode))
            return NULL;
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x2) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!cc_register (operands[2], E_VOIDmode))
            return NULL;
          if (s_register_operand (operands[0], E_SImode))
            {
              if ((
#line 8119 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_borrow_operation (operands[1], SImode)) && 
#line 8121 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( true)))
                return gen_split_72 (insn, operands);
              if ((
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && !arm_restrict_it
   && !arm_borrow_operation (operands[1], SImode)) && 
#line 348 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( true)))
                return gen_split_141 (insn, operands);
            }
          if (!low_register_operand (operands[0], E_SImode)
              || !(
#line 365 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && arm_restrict_it
   && !arm_borrow_operation (operands[1], SImode)) && 
#line 369 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
            return NULL;
          return gen_split_142 (insn, operands);

        case REG:
        case SUBREG:
          if (!s_register_operand (operands[1], E_DFmode)
              || !s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !
#line 906 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE && reload_completed
   && arm_general_register_operand (operands[0], DFmode)))
            return NULL;
          return gen_split_106 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (!arm_comparison_operator (x4, E_VOIDmode))
        return NULL;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x6 = XEXP (x4, 0);
      if (!cc_register (x6, E_VOIDmode))
        return NULL;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x5;
          x11 = XEXP (x2, 2);
          switch (GET_CODE (x11))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[2] = x11;
              if (!arm_not_operand (operands[2], E_SImode))
                return NULL;
              operands[3] = x4;
              operands[4] = x6;
              if (!arm_not_operand (operands[1], E_SImode))
                return NULL;
              if ((
#line 8506 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 8520 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_74 (insn, operands);
              if (!(
#line 442 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 462 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_145 (insn, operands);

            case NEG:
              if (GET_MODE (x11) != E_SImode)
                return NULL;
              operands[4] = x4;
              operands[3] = x6;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x12 = XEXP (x11, 0);
              operands[2] = x12;
              if (!s_register_operand (operands[2], E_SImode)
                  || !(
#line 11443 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 11445 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
                return NULL;
              return gen_split_97 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          operands[4] = x4;
          operands[3] = x6;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode))
            return NULL;
          x11 = XEXP (x2, 2);
          operands[1] = x11;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 11407 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && !TARGET_COND_ARITH) && 
#line 11409 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
            return NULL;
          return gen_split_96 (insn, operands);

        default:
          return NULL;
        }

    case CTZ:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !(
#line 12213 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2) && 
#line 12215 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
        return NULL;
      return gen_split_104 (insn, operands);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 100)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      switch (GET_MODE (x3))
        {
        case E_CCFPmode:
          switch (pattern362 (x2, 
E_CCFPmode))
            {
            case 0:
              if (!
#line 1751 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return NULL;
              return gen_split_107 (insn, operands);

            case 1:
              if (!
#line 1781 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return NULL;
              return gen_split_109 (insn, operands);

            default:
              return NULL;
            }

        case E_CCFPEmode:
          switch (pattern362 (x2, 
E_CCFPEmode))
            {
            case 0:
              if (!
#line 1766 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return NULL;
              return gen_split_108 (insn, operands);

            case 1:
              if (!
#line 1796 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return NULL;
              return gen_split_110 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return NULL;
      x11 = XEXP (x2, 2);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 220 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return NULL;
      return gen_split_115 (insn, operands);

    case VEC_CONCAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern11 (x2))
        {
        case 0:
          if (!(
#line 3649 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_166 (insn, operands);

        case 1:
          if (!(
#line 3649 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_167 (insn, operands);

        case 2:
          if (!(
#line 3649 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_168 (insn, operands);

        case 3:
          if (!(
#line 3649 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_169 (insn, operands);

        case 4:
          if (!(
#line 3649 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_170 (insn, operands);

        case 5:
          if (!(
#line 3649 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_171 (insn, operands);

        case 6:
          if (!(
#line 3649 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_172 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      if (GET_MODE (x2) != E_V2DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V2DImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!neon_struct_operand (operands[1], E_DImode)
          || !(
#line 5204 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 5206 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
( reload_completed)))
        return NULL;
      return gen_split_176 (insn, operands);

    default:
      return NULL;
    }
}
