/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || !const_double_operand (operands[1], E_DFmode)
          || !s_register_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !s_register_operand (operands[2], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PLUS
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XEXP (x5, 0);
  if (GET_CODE (x9) != MEM
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS
      || GET_MODE (x14) != E_SImode)
    return -1;
  x15 = XEXP (x14, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x16 = XEXP (x12, 0);
  if (GET_CODE (x16) != MEM
      || GET_MODE (x16) != E_SImode)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != PLUS
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XEXP (x17, 1);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x19 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x19) != SET)
    return -1;
  x20 = XEXP (x19, 1);
  if (GET_CODE (x20) != PLUS
      || GET_MODE (x20) != E_SImode)
    return -1;
  x21 = XEXP (x20, 1);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x22) != SET)
    return -1;
  x23 = XEXP (x22, 1);
  if (GET_CODE (x23) != PLUS
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XEXP (x23, 1);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  return 0;
}

int
pattern53 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern51 (x3, 
E_V8BImode, 
i1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern51 (x3, 
E_V4BImode, 
i2, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern51 (x3, 
E_V16BImode, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern51 (x3, 
E_V8BImode, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern51 (x3, 
E_V4BImode, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern54 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern55 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !mve_imm_32 (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!vpr_register_operand (operands[3], E_V4BImode))
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!s_register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern106 (x3); /* [-1, 2] */
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != XOR
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern118 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern117 (x3, 
i1, 
i2); /* [-1, 1] */
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 3;

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 6;

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern40 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern40 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern40 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return 0;

        case E_DImode:
          return 1;

        case E_V16QImode:
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
      if (!const_int_mve_cde1_operand (operands[3], E_SImode)
          || !register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[2], E_V16QImode)
          || !vpr_register_operand (operands[4], E_V16BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern211 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i3)
      || !s_register_operand (operands[3], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern216 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !s_register_operand (operands[3], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern216 (x3, 
E_V16BImode, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern216 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern234 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern148 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern148 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern148 (x3, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern248 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 2
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (XINT (x2, 1))
    {
    case 33:
      return pattern250 (x1); /* [-1, 1] */

    case 34:
      res = pattern250 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case 37:
      res = pattern250 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case 356:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    case 357:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 8;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case 359:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern267 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern277 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern277 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || GET_MODE (x2) != E_V4HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!s_register_operand (operands[1], E_V4HImode)
              || !reg_or_zero_operand (operands[2], E_V4HImode))
            return -1;
          return 2;

        case E_V4HFmode:
          if (!s_register_operand (operands[1], E_V4HFmode)
              || !reg_or_zero_operand (operands[2], E_V4HFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!s_register_operand (operands[1], E_V8HImode)
              || !reg_or_zero_operand (operands[2], E_V8HImode))
            return -1;
          return 4;

        case E_V8HFmode:
          if (!s_register_operand (operands[1], E_V8HFmode)
              || !reg_or_zero_operand (operands[2], E_V8HFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!s_register_operand (operands[1], E_V2SImode)
              || !reg_or_zero_operand (operands[2], E_V2SImode))
            return -1;
          return 6;

        case E_V2SFmode:
          if (!s_register_operand (operands[1], E_V2SFmode)
              || !reg_or_zero_operand (operands[2], E_V2SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!s_register_operand (operands[1], E_V4SImode)
              || !reg_or_zero_operand (operands[2], E_V4SImode))
            return -1;
          return 8;

        case E_V4SFmode:
          if (!s_register_operand (operands[1], E_V4SFmode)
              || !reg_or_zero_operand (operands[2], E_V4SFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern316 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern327 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern332 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !vpr_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern337 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 101
      || GET_MODE (x6) != E_SImode
      || pattern335 (x1) != 0)
    return -1;
  return 0;
}

int
pattern345 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 32LL:
      return 0;

    case 16LL:
      if (pattern344 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern354 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern359 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!s_register_operand (x3, i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (!s_register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern368 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern374 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[2] = x6;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      return 0;

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[4] = x6;
      if (!shift_operator (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x1, 0);
      operands[5] = x7;
      x8 = XEXP (x7, 0);
      operands[6] = x8;
      return 1;

    default:
      return -1;
    }
}

int
pattern389 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern396 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !neon_inv_logic_op2 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern402 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern409 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern419 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode
      || !arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern431 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != i1
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != XOR
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern447 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MINUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern456 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !neon_struct_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_MODE (x2))
    {
    case E_V8QImode:
      return 0;

    case E_V16QImode:
      return 1;

    case E_V4HImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V4HFmode:
      return 6;

    case E_V8HFmode:
      return 7;

    case E_V4BFmode:
      return 8;

    case E_V8BFmode:
      return 9;

    case E_V2SFmode:
      return 10;

    case E_V4SFmode:
      return 11;

    case E_DImode:
      return 12;

    case E_V2DImode:
      return 13;

    default:
      return -1;
    }
}

int
pattern471 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern481 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const_int_vcde2_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !s_register_operand (operands[2], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!s_register_operand (operands[3], E_V4HFmode))
            return -1;
          return 0;

        case E_V8HFmode:
          if (!s_register_operand (operands[3], E_V8HFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !s_register_operand (operands[2], E_V8HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HFmode:
          if (!s_register_operand (operands[3], E_V8HFmode))
            return -1;
          return 2;

        case E_V4HFmode:
          if (!s_register_operand (operands[3], E_V4HFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !s_register_operand (operands[2], E_V2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SFmode:
          if (!s_register_operand (operands[3], E_V2SFmode))
            return -1;
          return 4;

        case E_V4SFmode:
          if (!s_register_operand (operands[3], E_V4SFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !s_register_operand (operands[2], E_V4SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SFmode:
          if (!s_register_operand (operands[3], E_V4SFmode))
            return -1;
          return 6;

        case E_V2SFmode:
          if (!s_register_operand (operands[3], E_V2SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern539 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern545 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern544 (x1) != 0)
    return -1;
  return 0;
}

int
pattern555 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern566 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!commutative_binary_operator (x3, E_SImode))
    return -1;
  operands[5] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[4] = x6;
  return 0;
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XVECEXP (x8, 0, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!guard_addr_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x5, 1);
  x12 = XEXP (x11, 0);
  operands[2] = x12;
  x13 = XVECEXP (x1, 0, 1);
  x14 = XEXP (x13, 0);
  operands[3] = x14;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x15 = XVECEXP (x1, 0, 2);
  x16 = XEXP (x15, 0);
  operands[4] = x16;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern611 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_int_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern619 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern632 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern631 (x5, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern642 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!load_multiple_operation (operands[0], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!arm_hard_general_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!arm_hard_general_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!arm_hard_general_register_operand (operands[3], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!arm_hard_general_register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern653 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  x13 = XEXP (x9, 0);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 0);
  if (!rtx_equal_p (x18, operands[2]))
    return -1;
  x19 = XVECEXP (x1, 0, 4);
  x20 = XEXP (x19, 1);
  x21 = XEXP (x20, 0);
  if (!rtx_equal_p (x21, operands[3]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != SIGN_EXTEND
          || pattern448 (x1) != 0)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern615 (x1) != 0
          || !
#line 1669 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 27; /* subvsi3 */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (pattern448 (x1) != 0
              || !arm_immediate_operand (operands[1], E_VOIDmode)
              || pattern615 (x1) != 0
              || !
#line 1686 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 28; /* subvsi3_imm1 */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!arm_rhs_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern447 (x1, 
E_SImode, 
E_CC_NZmode) != 0
              || !arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x14 = XEXP (x12, 1);
          if (!rtx_equal_p (x14, operands[2])
              || !
#line 2067 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 46; /* subsi3_compare0 */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[2] = x7;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_CC_NZmode
              || GET_MODE (x4) != E_CC_NZmode
              || GET_MODE (x5) != E_SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x7, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x16 = XEXP (x7, 1);
          operands[4] = x16;
          if (!shift_amount_operand (operands[4], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          switch (pattern548 (x10, 
MINUS))
            {
            case 0:
              x12 = XEXP (x10, 1);
              x14 = XEXP (x12, 1);
              switch (GET_CODE (x14))
                {
                case MULT:
                case ASHIFT:
                case ROTATE:
                case ASHIFTRT:
                case LSHIFTRT:
                case ROTATERT:
                  if (!rtx_equal_p (x14, operands[2]))
                    return -1;
                  x11 = XEXP (x10, 0);
                  operands[0] = x11;
                  if (!s_register_operand (operands[0], E_SImode))
                    return -1;
                  x13 = XEXP (x12, 0);
                  if (!rtx_equal_p (x13, operands[1])
                      || !
#line 9786 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 332; /* *sub_shiftsi_compare0 */

                default:
                  return -1;
                }

            case 1:
              if (!
#line 9802 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 333; /* *sub_shiftsi_compare0_scratch */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != SIGN_EXTEND
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (pattern477 (x9, 
MINUS) != 0)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (pattern418 (x10, 
MINUS) != 0
          || GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x4) != E_CC_Vmode
          || GET_MODE (x5) != E_DImode)
        return -1;
      x17 = XEXP (x8, 0);
      operands[1] = x17;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!arm_borrow_operation (operands[4], E_DImode))
        return -1;
      x18 = XEXP (x9, 0);
      x19 = XEXP (x18, 1);
      operands[3] = x19;
      if (!arm_borrow_operation (operands[3], E_SImode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x20 = XEXP (x18, 0);
      x21 = XEXP (x20, 0);
      if (!rtx_equal_p (x21, operands[1]))
        return -1;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      x22 = XEXP (x13, 0);
      if (!rtx_equal_p (x22, operands[1]))
        return -1;
      x14 = XEXP (x12, 1);
      if (!rtx_equal_p (x14, operands[3]))
        return -1;
      x23 = XEXP (x6, 1);
      switch (GET_CODE (x23))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x23) != E_DImode)
            return -1;
          x24 = XEXP (x23, 0);
          operands[2] = x24;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x25 = XEXP (x20, 1);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x26 = XEXP (x13, 1);
          if (!rtx_equal_p (x26, operands[2])
              || !
#line 2185 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 54; /* subvsi3_borrow */

        case CONST_INT:
          operands[2] = x23;
          if (!arm_adcimm_operand (operands[2], E_VOIDmode))
            return -1;
          x25 = XEXP (x20, 1);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x26 = XEXP (x13, 1);
          if (!rtx_equal_p (x26, operands[2])
              || !
#line 2206 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && INTVAL (operands[2]) == ARM_SIGN_EXTEND (INTVAL (operands[2]))))
            return -1;
          return 55; /* subvsi3_borrow_imm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case MEM:
      res = recog_25 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) == USE)
        {
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) == LABEL_REF)
            {
              x6 = XEXP (x2, 1);
              operands[0] = x6;
              if (register_operand (operands[0], E_SImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (
#line 2086 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    return 1004; /* *thumb1_tablejump */
                }
            }
        }
      break;

    case REG:
    case SUBREG:
      res = recog_26 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != SUBREG
      || maybe_ne (SUBREG_BYTE (x6), 0)
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x8 = XEXP (x6, 0);
  if (GET_CODE (x8) != UNSPEC
      || pattern287 (x1, 
UNSPEC, 
E_CCmode, 
100) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x4, 0) != 1
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x9 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 15
      || GET_MODE (x9) != E_SImode)
    return -1;
  switch (XVECLEN (x8, 0))
    {
    case 1:
      x10 = XVECEXP (x8, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x8, 1))
        {
        case 116:
          if (XINT (x4, 1) != 116)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 868 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 741; /* iwmmxt_tandcv2si3 */

            case E_V4HImode:
              if (!
#line 868 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 742; /* iwmmxt_tandcv4hi3 */

            case E_V8QImode:
              if (!
#line 868 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 743; /* iwmmxt_tandcv8qi3 */

            default:
              return -1;
            }

        case 117:
          if (XINT (x4, 1) != 117)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 878 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 744; /* iwmmxt_torcv2si3 */

            case E_V4HImode:
              if (!
#line 878 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 745; /* iwmmxt_torcv4hi3 */

            case E_V8QImode:
              if (!
#line 878 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 746; /* iwmmxt_torcv8qi3 */

            default:
              return -1;
            }

        case 118:
          if (XINT (x4, 1) != 118)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 888 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 747; /* iwmmxt_torvscv2si3 */

            case E_V4HImode:
              if (!
#line 888 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 748; /* iwmmxt_torvscv4hi3 */

            case E_V8QImode:
              if (!
#line 888 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 749; /* iwmmxt_torvscv8qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x8, 1) != 119)
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XINT (x4, 1) != 119)
        return -1;
      x11 = XVECEXP (x8, 0, 1);
      operands[0] = x11;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      switch (GET_MODE (x8))
        {
        case E_V2SImode:
          if (!
#line 899 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 750; /* iwmmxt_textrcv2si3 */

        case E_V4HImode:
          if (!
#line 899 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 751; /* iwmmxt_textrcv4hi3 */

        case E_V8QImode:
          if (!
#line 899 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 752; /* iwmmxt_textrcv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      return recog_29 (x1, insn, pnum_clobbers);

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      return recog_31 (x1, insn, pnum_clobbers);

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (s_register_operand (operands[0], E_SImode))
        {
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!low_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern296 (x5) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!low_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (low_reg_or_int_operand (operands[2], E_SImode))
        {
          operands[3] = x3;
          if (shift_operator (operands[3], E_SImode)
              && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && ((GET_CODE(operands[3]) != ROTATE && GET_CODE(operands[3]) != ROTATERT)
       || REG_P (operands[2]))))
            return 1053; /* *thumb2_shiftsi3_short */
        }
      if (!low_register_operand (operands[2], E_SImode)
          || GET_CODE (x3) != MULT
          || GET_MODE (x3) != E_SImode
          || !
#line 1429 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size && reload_completed))
        return -1;
      return 1061; /* *thumb2_mulsi_short */

    case TRUNCATE:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != MULT
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x6, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (GET_MODE (x10) != E_DImode)
        return -1;
      x11 = XEXP (x8, 1);
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x5, 0);
      operands[3] = x12;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x11) != SIGN_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 71; /* *smull_high */

        case ZERO_EXTEND:
          if (GET_CODE (x11) != ZERO_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 72; /* *umull_high */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_28 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x7 = XEXP (x3, 1);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_16 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!arm_comparison_operator (operands[1], E_SImode)
          || pattern255 (x1) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      operands[3] = x7;
      if (!arm_add_operand (operands[3], E_SImode)
          || !
#line 9952 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 336; /* *compare_scc */

    case IF_THEN_ELSE:
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          switch (GET_CODE (x6))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              res = recog_20 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[5] = x6;
          if (!comparison_operator (operands[5], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != PLUS
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER
              || pattern450 (x1) != 0
              || pattern575 (x3) != 0
              || !
#line 10767 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 350; /* movcond_addsi */

        default:
          return -1;
        }

    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      return recog_32 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      if (pattern13 (x1) != 0
          || !
#line 4360 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
        return -1;
      return 128; /* arm_qadd_setq_insn */

    case SS_MINUS:
      if (pattern13 (x1) != 0
          || !
#line 4360 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
        return -1;
      return 130; /* arm_qsub_setq_insn */

    case ABS:
      if (pattern14 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x5, 0);
      if (GET_CODE (x12) == REG
          && REGNO (x12) == 100
          && GET_MODE (x12) == E_CCmode)
        {
          if (
#line 5255 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 171; /* *arm_abssi2 */
          if (
#line 117 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return 1011; /* *thumb2_abssi2 */
        }
      operands[2] = x12;
      if (!scratch_operand (operands[2], E_SImode)
          || !
#line 334 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 957; /* *thumb1_abssi2 */

    case NEG:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case ABS:
          if (GET_MODE (x6) != E_SImode
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) == REG
              && REGNO (x12) == 100
              && GET_MODE (x12) == E_CCmode)
            {
              if (
#line 5319 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 172; /* *arm_neg_abssi2 */
              if (
#line 170 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return 1012; /* *thumb2_neg_abssi2 */
            }
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 349 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 958; /* *thumb1_neg_abssi2 */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[3] = x6;
          if (!arm_comparison_operator (operands[3], E_VOIDmode)
              || pattern385 (x1) != 0)
            return -1;
          if (
#line 10692 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 349; /* *negscc */
          if (!
#line 899 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
            return -1;
          return 1039; /* *thumb2_negscc */

        case REG:
        case SUBREG:
          operands[1] = x6;
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 100
              || GET_MODE (x12) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 315 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return -1;
              return 955; /* *thumb1_negdi2 */

            case E_SImode:
              if (!low_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !low_register_operand (operands[1], E_SImode)
                  || !
#line 1523 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
                return -1;
              return 1067; /* *thumb2_negsi2_short */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      switch (pattern18 (x2))
        {
        case 0:
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          x12 = XEXP (x5, 0);
          operands[3] = x12;
          if (s_register_operand (operands[1], E_SImode))
            {
              if (
#line 8826 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 292; /* *call_value_reg_armv5 */
                }
              if (
#line 8837 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 293; /* *call_value_reg_arm */
                }
            }
          if (
#line 8877 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !SIBLING_CALL_P (insn)
   && (GET_CODE (operands[1]) == SYMBOL_REF)
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[1]))))
            {
              *pnum_clobbers = 1;
              return 295; /* *call_value_symbol */
            }
          if (register_operand (operands[1], E_SImode))
            {
              if (
#line 1914 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && arm_arch5t))
                {
                  *pnum_clobbers = 1;
                  return 994; /* *call_value_reg_thumb1_v5 */
                }
              if (
#line 1940 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && !arm_arch5t))
                {
                  *pnum_clobbers = 1;
                  return 996; /* *call_value_reg_thumb1 */
                }
            }
          if (
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[1]))))
            {
              *pnum_clobbers = 1;
              return 998; /* *call_value_insn */
            }
          if (!register_operand (operands[1], E_SImode)
              || !
#line 569 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          *pnum_clobbers = 1;
          return 1028; /* *call_value_reg_thumb2 */

        case 1:
          x6 = XEXP (x3, 0);
          x15 = XVECEXP (x6, 0, 0);
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) == REG
              && REGNO (x16) == 4
              && GET_MODE (x16) == E_SImode)
            {
              x7 = XEXP (x3, 1);
              operands[1] = x7;
              x12 = XEXP (x5, 0);
              operands[2] = x12;
              if (
#line 1928 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && use_cmse))
                {
                  *pnum_clobbers = 1;
                  return 995; /* *nonsecure_call_value_reg_thumb1_v5 */
                }
            }
          operands[1] = x16;
          if (register_operand (operands[1], E_SImode))
            {
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              if (
#line 582 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && TARGET_HAVE_FPCXT_CMSE))
                {
                  *pnum_clobbers = 1;
                  return 1029; /* *nonsecure_call_value_reg_thumb2_fpcxt */
                }
            }
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 4
              || GET_MODE (x16) != E_SImode)
            return -1;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          x12 = XEXP (x5, 0);
          operands[2] = x12;
          if (!
#line 595 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && !TARGET_HAVE_FPCXT_CMSE))
            return -1;
          *pnum_clobbers = 1;
          return 1030; /* *nonsecure_call_value_reg_thumb2 */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern296 (x5) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x17 = XEXP (x3, 2);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 11839 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      return 382; /* *sign_extract_onebit */

    case NOT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTRACT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern256 (x5) != 0
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x18 = XEXP (x6, 2);
          operands[2] = x18;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 11857 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 383; /* *not_signextract_onebit */

        case REG:
          operands[1] = x6;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern256 (x5) != 0
              || !low_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 1512 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1066; /* *thumb2_one_cmplsi2_short */

        case AND:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern295 (x5, pnum_clobbers) != 0)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          operands[2] = x9;
          x19 = XEXP (x5, 1);
          x20 = XVECEXP (x19, 0, 2);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern530 (x1))
            {
            case 0:
              if (!
#line 483 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3161; /* atomic_nand_fetchqi */

            case 1:
              if (!
#line 483 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3162; /* atomic_nand_fetchhi */

            case 2:
              if (!
#line 483 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3163; /* atomic_nand_fetchsi */

            case 3:
              if (!
#line 483 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3164; /* atomic_nand_fetchdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (GET_CODE (x3))
        {
        case MEM:
          res = recog_23 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          res = recog_27 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (memory_operand (operands[2], E_SImode))
        {
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) == SET)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x12 = XEXP (x5, 0);
                  operands[1] = x12;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      x19 = XEXP (x5, 1);
                      operands[3] = x19;
                      if (memory_operand (operands[3], E_SImode)
                          && 
#line 164 "../../gcc-15.1.1-20250425/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, true)))
                        return 435; /* *arm_ldrd */
                    }
                }
            }
        }
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!memory_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[3] = x12;
      if (!memory_operand (operands[3], E_SImode))
        return -1;
      x19 = XEXP (x5, 1);
      operands[1] = x19;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 184 "../../gcc-15.1.1-20250425/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, false)))
        return -1;
      return 436; /* *arm_strd */

    case CONST_DOUBLE:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 2142 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !arm_const_double_rtx (operands[1])
   && !(TARGET_VFP_DOUBLE && vfp3_const_double_rtx (operands[1]))))
            return -1;
          return 927; /* no_literal_pool_df_immediate */

        case 1:
          if (!
#line 2169 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !vfp3_const_double_rtx (operands[1])))
            return -1;
          return 928; /* no_literal_pool_sf_immediate */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[2] = x12;
      if (!scratch_operand (operands[2], E_SImode)
          || !
#line 446 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 963; /* thumb1_extendhisi2 */

    case CONST_INT:
      operands[1] = x3;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern256 (x5) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!low_register_operand (operands[0], E_QImode)
              || !const_int_operand (operands[1], E_QImode)
              || !
#line 1289 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1054; /* *thumb2_movqi_shortim */

        case E_HImode:
          if (!low_register_operand (operands[0], E_HImode)
              || !const_int_operand (operands[1], E_HImode)
              || !
#line 1289 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1055; /* *thumb2_movhi_shortim */

        case E_SImode:
          if (!low_register_operand (operands[0], E_SImode)
              || !const_int_operand (operands[1], E_SImode)
              || !
#line 1289 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1056; /* *thumb2_movsi_shortim */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_30 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern92 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !s_register_operand (operands[2], E_V8HImode)
          || !
#line 3581 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4912; /* mve_vldrq_gather_shifted_offset_v8hi */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !s_register_operand (operands[2], E_V4SImode)
          || !
#line 3581 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4913; /* mve_vldrq_gather_shifted_offset_v4si */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !s_register_operand (operands[2], E_V8HImode)
          || !
#line 3581 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4914; /* mve_vldrq_gather_shifted_offset_v8hf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !s_register_operand (operands[2], E_V4SImode)
          || !
#line 3581 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4915; /* mve_vldrq_gather_shifted_offset_v4sf */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !s_register_operand (operands[2], E_V2DImode)
          || !
#line 3581 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4916; /* mve_vldrq_gather_shifted_offset_v2di */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern89 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !
#line 3331 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4858; /* mve_vstrq_scatter_offset_v16qi */

    case E_V8HImode:
      switch (pattern507 ())
        {
        case 0:
          if (!
#line 3331 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
            return -1;
          return 4859; /* mve_vstrq_scatter_offset_v8hi */

        case 1:
          if (!
#line 3331 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
            return -1;
          return 4861; /* mve_vstrq_scatter_offset_v8hf */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern508 ())
        {
        case 0:
          if (!
#line 3331 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
            return -1;
          return 4860; /* mve_vstrq_scatter_offset_v4si */

        case 1:
          if (!
#line 3331 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
            return -1;
          return 4862; /* mve_vstrq_scatter_offset_v4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!s_register_operand (operands[1], E_V2DImode)
          || !s_register_operand (operands[2], E_V2DImode)
          || !
#line 3331 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4863; /* mve_vstrq_scatter_offset_v2di */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2436; /* neon_vrsrau_nv8qi */

    case 1:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2440; /* neon_vrsrau_nv16qi */

    case 2:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2444; /* neon_vrsrau_nv4hi */

    case 3:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2448; /* neon_vrsrau_nv8hi */

    case 4:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2452; /* neon_vrsrau_nv2si */

    case 5:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2456; /* neon_vrsrau_nv4si */

    case 6:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2460; /* neon_vrsrau_ndi */

    case 7:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2464; /* neon_vrsrau_nv2di */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 105
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode)
      || !
#line 6194 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
    return -1;
  return 254; /* arm_sel */
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern46 (x1, 
E_CImode, 
E_EImode))
    {
    case 0:
      if (!
#line 5696 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2841; /* neon_vld3qbv16qi */

    case 1:
      if (!
#line 5696 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2842; /* neon_vld3qbv8hi */

    case 2:
      if (!
#line 5696 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2843; /* neon_vld3qbv8hf */

    case 3:
      if (!(
#line 5696 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2844; /* neon_vld3qbv8bf */

    case 4:
      if (!
#line 5696 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2845; /* neon_vld3qbv4si */

    case 5:
      if (!
#line 5696 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2846; /* neon_vld3qbv4sf */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 4435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2244; /* neon_vrev64v8qi */

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 4435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2245; /* neon_vrev64v16qi */

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode)
          || !
#line 4435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2246; /* neon_vrev64v4hi */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 4435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2247; /* neon_vrev64v8hi */

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode)
          || !
#line 4435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2248; /* neon_vrev64v2si */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 4435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2249; /* neon_vrev64v4si */

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode)
          || !
#line 4435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2250; /* neon_vrev64v4hf */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode)
          || !
#line 4435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2251; /* neon_vrev64v8hf */

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode)
          || !
#line 4435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2252; /* neon_vrev64v2sf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 4435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2253; /* neon_vrev64v4sf */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V2DImode)
          || !
#line 4435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2254; /* neon_vrev64v2di */

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 4453 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2259; /* neon_vrev16v8qi */

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 4453 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2260; /* neon_vrev16v16qi */

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern104 (x1))
    {
    case 0:
      if (!
#line 3141 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2006; /* neon_vqnegv8qi */

    case 1:
      if (!
#line 3141 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2007; /* neon_vqnegv16qi */

    case 2:
      if (!
#line 3141 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2008; /* neon_vqnegv4hi */

    case 3:
      if (!
#line 3141 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2009; /* neon_vqnegv8hi */

    case 4:
      if (!
#line 3141 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2010; /* neon_vqnegv2si */

    case 5:
      if (!
#line 3141 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2011; /* neon_vqnegv4si */

    default:
      return -1;
    }
}

 int
recog_136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern155 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      switch (pattern456 (x2, 
E_TImode))
        {
        case 0:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2536; /* neon_vld1_x2v8qi */

        case 1:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2538; /* neon_vld1_x2v16qi */

        case 2:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2540; /* neon_vld1_x2v4hi */

        case 3:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2542; /* neon_vld1_x2v8hi */

        case 4:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2544; /* neon_vld1_x2v2si */

        case 5:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2546; /* neon_vld1_x2v4si */

        case 6:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2548; /* neon_vld1_x2v4hf */

        case 7:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2550; /* neon_vld1_x2v8hf */

        case 8:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2552; /* neon_vld1_x2v4bf */

        case 9:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2554; /* neon_vld1_x2v8bf */

        case 10:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2556; /* neon_vld1_x2v2sf */

        case 11:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2558; /* neon_vld1_x2v4sf */

        case 12:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2560; /* neon_vld1_x2di */

        case 13:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2562; /* neon_vld1_x2v2di */

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      switch (pattern456 (x2, 
E_OImode))
        {
        case 0:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2537; /* neon_vld1q_x2v8qi */

        case 1:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2539; /* neon_vld1q_x2v16qi */

        case 2:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2541; /* neon_vld1q_x2v4hi */

        case 3:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2543; /* neon_vld1q_x2v8hi */

        case 4:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2545; /* neon_vld1q_x2v2si */

        case 5:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2547; /* neon_vld1q_x2v4si */

        case 6:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2549; /* neon_vld1q_x2v4hf */

        case 7:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2551; /* neon_vld1q_x2v8hf */

        case 8:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2553; /* neon_vld1q_x2v4bf */

        case 9:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2555; /* neon_vld1q_x2v8bf */

        case 10:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2557; /* neon_vld1q_x2v2sf */

        case 11:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2559; /* neon_vld1q_x2v4sf */

        case 12:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2561; /* neon_vld1q_x2di */

        case 13:
          if (!
#line 5003 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2563; /* neon_vld1q_x2v2di */

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 1);
      switch (pattern456 (x2, 
E_EImode))
        {
        case 0:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2564; /* neon_vld1_x3v8qi */

        case 1:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2565; /* neon_vld1_x3v16qi */

        case 2:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2566; /* neon_vld1_x3v4hi */

        case 3:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2567; /* neon_vld1_x3v8hi */

        case 4:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2568; /* neon_vld1_x3v2si */

        case 5:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2569; /* neon_vld1_x3v4si */

        case 6:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2570; /* neon_vld1_x3v4hf */

        case 7:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2571; /* neon_vld1_x3v8hf */

        case 8:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2572; /* neon_vld1_x3v4bf */

        case 9:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2573; /* neon_vld1_x3v8bf */

        case 10:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2574; /* neon_vld1_x3v2sf */

        case 11:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2575; /* neon_vld1_x3v4sf */

        case 12:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2576; /* neon_vld1_x3di */

        case 13:
          if (!
#line 5013 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2577; /* neon_vld1_x3v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4588 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2403; /* neon_vqshl_s_nv8qi */

    case 1:
      if (!
#line 4588 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2405; /* neon_vqshl_s_nv16qi */

    case 2:
      if (!
#line 4588 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2407; /* neon_vqshl_s_nv4hi */

    case 3:
      if (!
#line 4588 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2409; /* neon_vqshl_s_nv8hi */

    case 4:
      if (!
#line 4588 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2411; /* neon_vqshl_s_nv2si */

    case 5:
      if (!
#line 4588 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2413; /* neon_vqshl_s_nv4si */

    case 6:
      if (!
#line 4588 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2415; /* neon_vqshl_s_ndi */

    case 7:
      if (!
#line 4588 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2417; /* neon_vqshl_s_nv2di */

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2278; /* neon_vrshluv8qi */

    case 1:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2282; /* neon_vrshluv16qi */

    case 2:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2286; /* neon_vrshluv4hi */

    case 3:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2290; /* neon_vrshluv8hi */

    case 4:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2294; /* neon_vrshluv2si */

    case 5:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2298; /* neon_vrshluv4si */

    case 6:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2302; /* neon_vrshludi */

    case 7:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2306; /* neon_vrshluv2di */

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0
          || !
#line 1621 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1530; /* neon_vmulpv8qi */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0
          || !
#line 1621 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1531; /* neon_vmulpv16qi */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 1621 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1532; /* neon_vmulfv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 1621 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1533; /* neon_vmulfv4sf */

    default:
      return -1;
    }
}

 int
recog_191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern158 (x1))
    {
    case 0:
      if (!
#line 5344 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2751; /* neon_vst1x4qbv16qi */

    case 1:
      if (!
#line 5344 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2752; /* neon_vst1x4qbv8hi */

    case 2:
      if (!
#line 5344 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2753; /* neon_vst1x4qbv8hf */

    case 3:
      if (!(
#line 5344 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2754; /* neon_vst1x4qbv8bf */

    case 4:
      if (!
#line 5344 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2755; /* neon_vst1x4qbv4si */

    case 5:
      if (!
#line 5344 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2756; /* neon_vst1x4qbv4sf */

    case 6:
      if (!
#line 5344 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2757; /* neon_vst1x4qbv2di */

    default:
      return -1;
    }
}

 int
recog_201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern164 (x1, 
E_XImode, 
E_OImode))
    {
    case 0:
      if (!
#line 6195 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2941; /* neon_vst4qav16qi */

    case 1:
      if (!
#line 6195 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2942; /* neon_vst4qav8hi */

    case 2:
      if (!
#line 6195 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2943; /* neon_vst4qav8hf */

    case 3:
      if (!(
#line 6195 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2944; /* neon_vst4qav8bf */

    case 4:
      if (!
#line 6195 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2945; /* neon_vst4qav4si */

    case 5:
      if (!
#line 6195 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2946; /* neon_vst4qav4sf */

    default:
      return -1;
    }
}

 int
recog_211 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1828; /* neon_vmaxuv8qi */

    case 1:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1832; /* neon_vmaxuv16qi */

    case 2:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1836; /* neon_vmaxuv4hi */

    case 3:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1840; /* neon_vmaxuv8hi */

    case 4:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1844; /* neon_vmaxuv2si */

    case 5:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1848; /* neon_vmaxuv4si */

    default:
      return -1;
    }
}

 int
recog_221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern126 (x1))
    {
    case 0:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V8QI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 519; /* mve_vshlq_uv8qi */

    case 1:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V16QI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 521; /* mve_vshlq_uv16qi */

    case 2:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V4HI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 523; /* mve_vshlq_uv4hi */

    case 3:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V8HI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 525; /* mve_vshlq_uv8hi */

    case 4:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V2SI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 527; /* mve_vshlq_uv2si */

    case 5:
      if (!
#line 376 "../../gcc-15.1.1-20250425/gcc/config/arm/vec-common.md"
(ARM_HAVE_V4SI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 529; /* mve_vshlq_uv4si */

    default:
      return -1;
    }
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1707; /* neon_vceqv2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1712; /* neon_vceqv4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1727; /* neon_vceqv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1732; /* neon_vceqv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_246 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], E_BLKmode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 2);
  operands[3] = x8;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_EImode:
      if (!s_register_operand (operands[0], E_EImode)
          || GET_MODE (x2) != E_EImode
          || !s_register_operand (operands[2], E_EImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2847; /* neon_vld3_lanev8qi */

        case E_V4HImode:
          if (!
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2848; /* neon_vld3_lanev4hi */

        case E_V4HFmode:
          if (!
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2849; /* neon_vld3_lanev4hf */

        case E_V4BFmode:
          if (!
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2850; /* neon_vld3_lanev4bf */

        case E_V2SImode:
          if (!
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2851; /* neon_vld3_lanev2si */

        case E_V2SFmode:
          if (!
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2852; /* neon_vld3_lanev2sf */

        default:
          return -1;
        }

    case E_CImode:
      if (!s_register_operand (operands[0], E_CImode)
          || GET_MODE (x2) != E_CImode
          || !s_register_operand (operands[2], E_CImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!
#line 5745 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2853; /* neon_vld3_lanev8hi */

        case E_V8HFmode:
          if (!
#line 5745 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2854; /* neon_vld3_lanev8hf */

        case E_V4SImode:
          if (!
#line 5745 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2855; /* neon_vld3_lanev4si */

        case E_V4SFmode:
          if (!
#line 5745 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2856; /* neon_vld3_lanev4sf */

        case E_V8BFmode:
          if (!(
#line 5745 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2857; /* neon_vld3_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 103:
      return recog_259 (x1, insn, pnum_clobbers);

    case 102:
      return recog_257 (x1, insn, pnum_clobbers);

    case 105:
      return recog_254 (x1, insn, pnum_clobbers);

    case 104:
      return recog_253 (x1, insn, pnum_clobbers);

    case 361:
      return recog_261 (x1, insn, pnum_clobbers);

    case 362:
      return recog_260 (x1, insn, pnum_clobbers);

    case 224:
      return recog_256 (x1, insn, pnum_clobbers);

    case 227:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4052 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2212; /* neon_vmlals_lanev4hi */

        case 1:
          if (!
#line 4052 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2214; /* neon_vmlals_lanev2si */

        default:
          return -1;
        }

    case 228:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4052 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2213; /* neon_vmlalu_lanev4hi */

        case 1:
          if (!
#line 4052 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2215; /* neon_vmlalu_lanev2si */

        default:
          return -1;
        }

    case 265:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4067 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2216; /* neon_vqdmlal_lanev4hi */

        case 1:
          if (!
#line 4067 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2217; /* neon_vqdmlal_lanev2si */

        default:
          return -1;
        }

    case 230:
      return recog_255 (x1, insn, pnum_clobbers);

    case 233:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4118 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2224; /* neon_vmlsls_lanev4hi */

        case 1:
          if (!
#line 4118 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2226; /* neon_vmlsls_lanev2si */

        default:
          return -1;
        }

    case 234:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4118 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2225; /* neon_vmlslu_lanev4hi */

        case 1:
          if (!
#line 4118 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2227; /* neon_vmlslu_lanev2si */

        default:
          return -1;
        }

    case 267:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4133 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2228; /* neon_vqdmlsl_lanev4hi */

        case 1:
          if (!
#line 4133 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2229; /* neon_vqdmlsl_lanev2si */

        default:
          return -1;
        }

    case 206:
      return recog_245 (x1, insn, pnum_clobbers);

    case 211:
      return recog_246 (x1, insn, pnum_clobbers);

    case 216:
      return recog_244 (x1, insn, pnum_clobbers);

    case 809:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 2462 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4349; /* mve_vcvtq_m_n_from_f_sv8hi */

        case 1:
          if (!
#line 2462 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4351; /* mve_vcvtq_m_n_from_f_sv4si */

        default:
          return -1;
        }

    case 818:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 2462 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4350; /* mve_vcvtq_m_n_from_f_uv8hi */

        case 1:
          if (!
#line 2462 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4352; /* mve_vcvtq_m_n_from_f_uv4si */

        default:
          return -1;
        }

    case 820:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2514 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4359; /* mve_vabavq_p_sv16qi */

        case 1:
          if (!
#line 2514 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4361; /* mve_vabavq_p_sv8hi */

        case 2:
          if (!
#line 2514 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4363; /* mve_vabavq_p_sv4si */

        default:
          return -1;
        }

    case 821:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2514 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4360; /* mve_vabavq_p_uv16qi */

        case 1:
          if (!
#line 2514 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4362; /* mve_vabavq_p_uv8hi */

        case 2:
          if (!
#line 2514 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4364; /* mve_vabavq_p_uv4si */

        default:
          return -1;
        }

    case 819:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2532 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4365; /* mve_vqshluq_m_n_sv16qi */

        case 1:
          if (!
#line 2532 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4366; /* mve_vqshluq_m_n_sv8hi */

        case 2:
          if (!
#line 2532 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4367; /* mve_vqshluq_m_n_sv4si */

        default:
          return -1;
        }

    case 824:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4368; /* mve_vsriq_m_n_sv16qi */

        case 1:
          if (!
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4370; /* mve_vsriq_m_n_sv8hi */

        case 2:
          if (!
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4372; /* mve_vsriq_m_n_sv4si */

        default:
          return -1;
        }

    case 825:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4369; /* mve_vsriq_m_n_uv16qi */

        case 1:
          if (!
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4371; /* mve_vsriq_m_n_uv8hi */

        case 2:
          if (!
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4373; /* mve_vsriq_m_n_uv4si */

        default:
          return -1;
        }

    case 828:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 2568 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4374; /* mve_vcvtq_m_n_to_f_uv8hf */

        case 1:
          if (!
#line 2568 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4376; /* mve_vcvtq_m_n_to_f_uv4sf */

        default:
          return -1;
        }

    case 829:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 2568 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4375; /* mve_vcvtq_m_n_to_f_sv8hf */

        case 1:
          if (!
#line 2568 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4377; /* mve_vcvtq_m_n_to_f_sv4sf */

        default:
          return -1;
        }

    case 552:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4378; /* mve_vabdq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4416; /* mve_vabdq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4454; /* mve_vabdq_m_sv4si */

        default:
          return -1;
        }

    case 553:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4379; /* mve_vabdq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4417; /* mve_vabdq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4455; /* mve_vabdq_m_uv4si */

        default:
          return -1;
        }

    case 842:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4380; /* mve_vhaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4418; /* mve_vhaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4456; /* mve_vhaddq_m_sv4si */

        default:
          return -1;
        }

    case 838:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4381; /* mve_vhaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4419; /* mve_vhaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4457; /* mve_vhaddq_m_uv4si */

        default:
          return -1;
        }

    case 924:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4382; /* mve_vhsubq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4420; /* mve_vhsubq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4458; /* mve_vhsubq_m_sv4si */

        default:
          return -1;
        }

    case 925:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4383; /* mve_vhsubq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4421; /* mve_vhsubq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4459; /* mve_vhsubq_m_uv4si */

        default:
          return -1;
        }

    case 876:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4384; /* mve_vmaxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4422; /* mve_vmaxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4460; /* mve_vmaxq_m_sv4si */

        default:
          return -1;
        }

    case 856:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4385; /* mve_vmaxq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4423; /* mve_vmaxq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4461; /* mve_vmaxq_m_uv4si */

        default:
          return -1;
        }

    case 884:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4386; /* mve_vminq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4424; /* mve_vminq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4462; /* mve_vminq_m_sv4si */

        default:
          return -1;
        }

    case 885:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4387; /* mve_vminq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4425; /* mve_vminq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4463; /* mve_vminq_m_uv4si */

        default:
          return -1;
        }

    case 891:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4388; /* mve_vmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4426; /* mve_vmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4464; /* mve_vmulhq_m_sv4si */

        default:
          return -1;
        }

    case 892:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4389; /* mve_vmulhq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4427; /* mve_vmulhq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4465; /* mve_vmulhq_m_uv4si */

        default:
          return -1;
        }

    case 831:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4390; /* mve_vqaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4428; /* mve_vqaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4466; /* mve_vqaddq_m_sv4si */

        default:
          return -1;
        }

    case 830:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4391; /* mve_vqaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4429; /* mve_vqaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4467; /* mve_vqaddq_m_uv4si */

        default:
          return -1;
        }

    case 942:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4392; /* mve_vqdmladhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4430; /* mve_vqdmladhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4468; /* mve_vqdmladhq_m_sv4si */

        default:
          return -1;
        }

    case 933:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4393; /* mve_vqdmladhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4431; /* mve_vqdmladhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4469; /* mve_vqdmladhxq_m_sv4si */

        default:
          return -1;
        }

    case 938:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4394; /* mve_vqdmlsdhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4432; /* mve_vqdmlsdhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4470; /* mve_vqdmlsdhq_m_sv4si */

        default:
          return -1;
        }

    case 939:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4395; /* mve_vqdmlsdhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4433; /* mve_vqdmlsdhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4471; /* mve_vqdmlsdhxq_m_sv4si */

        default:
          return -1;
        }

    case 931:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4396; /* mve_vqdmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4434; /* mve_vqdmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4472; /* mve_vqdmulhq_m_sv4si */

        default:
          return -1;
        }

    case 941:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4397; /* mve_vqrdmladhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4435; /* mve_vqrdmladhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4473; /* mve_vqrdmladhq_m_sv4si */

        default:
          return -1;
        }

    case 930:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4398; /* mve_vqrdmladhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4436; /* mve_vqrdmladhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4474; /* mve_vqrdmladhxq_m_sv4si */

        default:
          return -1;
        }

    case 928:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4399; /* mve_vqrdmlsdhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4437; /* mve_vqrdmlsdhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4475; /* mve_vqrdmlsdhq_m_sv4si */

        default:
          return -1;
        }

    case 929:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4400; /* mve_vqrdmlsdhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4438; /* mve_vqrdmlsdhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4476; /* mve_vqrdmlsdhxq_m_sv4si */

        default:
          return -1;
        }

    case 934:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4401; /* mve_vqrdmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4439; /* mve_vqrdmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4477; /* mve_vqrdmulhq_m_sv4si */

        default:
          return -1;
        }

    case 860:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4402; /* mve_vqrshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4440; /* mve_vqrshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4478; /* mve_vqrshlq_m_sv4si */

        default:
          return -1;
        }

    case 881:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4403; /* mve_vqrshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4441; /* mve_vqrshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4479; /* mve_vqrshlq_m_uv4si */

        default:
          return -1;
        }

    case 912:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4404; /* mve_vqshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4442; /* mve_vqshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4480; /* mve_vqshlq_m_sv4si */

        default:
          return -1;
        }

    case 911:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4405; /* mve_vqshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4443; /* mve_vqshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4481; /* mve_vqshlq_m_uv4si */

        default:
          return -1;
        }

    case 846:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4406; /* mve_vqsubq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4444; /* mve_vqsubq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4482; /* mve_vqsubq_m_sv4si */

        default:
          return -1;
        }

    case 845:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4407; /* mve_vqsubq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4445; /* mve_vqsubq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4483; /* mve_vqsubq_m_uv4si */

        default:
          return -1;
        }

    case 864:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4408; /* mve_vrhaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4446; /* mve_vrhaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4484; /* mve_vrhaddq_m_sv4si */

        default:
          return -1;
        }

    case 862:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4409; /* mve_vrhaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4447; /* mve_vrhaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4485; /* mve_vrhaddq_m_uv4si */

        default:
          return -1;
        }

    case 883:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4410; /* mve_vrmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4448; /* mve_vrmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4486; /* mve_vrmulhq_m_sv4si */

        default:
          return -1;
        }

    case 882:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4411; /* mve_vrmulhq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4449; /* mve_vrmulhq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4487; /* mve_vrmulhq_m_uv4si */

        default:
          return -1;
        }

    case 869:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4412; /* mve_vrshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4450; /* mve_vrshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4488; /* mve_vrshlq_m_sv4si */

        default:
          return -1;
        }

    case 870:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4413; /* mve_vrshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4451; /* mve_vrshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4489; /* mve_vrshlq_m_uv4si */

        default:
          return -1;
        }

    case 822:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4414; /* mve_vshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4452; /* mve_vshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4490; /* mve_vshlq_m_sv4si */

        default:
          return -1;
        }

    case 823:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4415; /* mve_vshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4453; /* mve_vshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4491; /* mve_vshlq_m_uv4si */

        default:
          return -1;
        }

    case 873:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4492; /* mve_vaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4498; /* mve_vaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4504; /* mve_vaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 874:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4493; /* mve_vaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4499; /* mve_vaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4505; /* mve_vaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 852:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4494; /* mve_vmulq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4500; /* mve_vmulq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4506; /* mve_vmulq_m_n_sv4si */

        default:
          return -1;
        }

    case 841:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4495; /* mve_vmulq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4501; /* mve_vmulq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4507; /* mve_vmulq_m_n_uv4si */

        default:
          return -1;
        }

    case 833:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4496; /* mve_vsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4502; /* mve_vsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4508; /* mve_vsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 834:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4497; /* mve_vsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4503; /* mve_vsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4509; /* mve_vsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 918:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4510; /* mve_vaddq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4516; /* mve_vaddq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4522; /* mve_vaddq_m_sv4si */

        default:
          return -1;
        }

    case 897:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4511; /* mve_vaddq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4517; /* mve_vaddq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4523; /* mve_vaddq_m_uv4si */

        default:
          return -1;
        }

    case 865:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4512; /* mve_vmulq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4518; /* mve_vmulq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4524; /* mve_vmulq_m_sv4si */

        default:
          return -1;
        }

    case 866:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4513; /* mve_vmulq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4519; /* mve_vmulq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4525; /* mve_vmulq_m_uv4si */

        default:
          return -1;
        }

    case 827:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4514; /* mve_vsubq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4520; /* mve_vsubq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4526; /* mve_vsubq_m_sv4si */

        default:
          return -1;
        }

    case 826:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4515; /* mve_vsubq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4521; /* mve_vsubq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4527; /* mve_vsubq_m_uv4si */

        default:
          return -1;
        }

    case 888:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4528; /* mve_vandq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4538; /* mve_vandq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4548; /* mve_vandq_m_sv4si */

        default:
          return -1;
        }

    case 887:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4529; /* mve_vandq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4539; /* mve_vandq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4549; /* mve_vandq_m_uv4si */

        default:
          return -1;
        }

    case 840:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4530; /* mve_vbicq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4540; /* mve_vbicq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4550; /* mve_vbicq_m_sv4si */

        default:
          return -1;
        }

    case 839:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4531; /* mve_vbicq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4541; /* mve_vbicq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4551; /* mve_vbicq_m_uv4si */

        default:
          return -1;
        }

    case 922:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4532; /* mve_veorq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4542; /* mve_veorq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4552; /* mve_veorq_m_sv4si */

        default:
          return -1;
        }

    case 923:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4533; /* mve_veorq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4543; /* mve_veorq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4553; /* mve_veorq_m_uv4si */

        default:
          return -1;
        }

    case 915:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4534; /* mve_vornq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4544; /* mve_vornq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4554; /* mve_vornq_m_sv4si */

        default:
          return -1;
        }

    case 914:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4535; /* mve_vornq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4545; /* mve_vornq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4555; /* mve_vornq_m_uv4si */

        default:
          return -1;
        }

    case 878:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4536; /* mve_vorrq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4546; /* mve_vorrq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4556; /* mve_vorrq_m_sv4si */

        default:
          return -1;
        }

    case 879:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4537; /* mve_vorrq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4547; /* mve_vorrq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4557; /* mve_vorrq_m_uv4si */

        default:
          return -1;
        }

    case 902:
      switch (pattern215 (x1))
        {
        case 0:
          if (!
#line 2689 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4558; /* mve_vbrsrq_m_n_uv16qi */

        case 1:
          if (!
#line 2689 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4560; /* mve_vbrsrq_m_n_uv8hi */

        case 2:
          if (!
#line 2689 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4562; /* mve_vbrsrq_m_n_uv4si */

        default:
          return -1;
        }

    case 835:
      switch (pattern215 (x1))
        {
        case 0:
          if (!
#line 2689 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4559; /* mve_vbrsrq_m_n_sv16qi */

        case 1:
          if (!
#line 2689 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4561; /* mve_vbrsrq_m_n_sv8hi */

        case 2:
          if (!
#line 2689 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4563; /* mve_vbrsrq_m_n_sv4si */

        default:
          return -1;
        }

    case 927:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4564; /* mve_vhcaddq_rot90_m_sv16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4568; /* mve_vhcaddq_rot90_m_sv8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4572; /* mve_vhcaddq_rot90_m_sv4si */

        default:
          return -1;
        }

    case 937:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4565; /* mve_vhcaddq_rot270_m_sv16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4569; /* mve_vhcaddq_rot270_m_sv8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4573; /* mve_vhcaddq_rot270_m_sv4si */

        default:
          return -1;
        }

    case 913:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4566; /* mve_vcaddq_rot90_m_v16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4570; /* mve_vcaddq_rot90_m_v8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4574; /* mve_vcaddq_rot90_m_v4si */

        default:
          return -1;
        }

    case 859:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4567; /* mve_vcaddq_rot270_m_v16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4571; /* mve_vcaddq_rot270_m_v8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4575; /* mve_vcaddq_rot270_m_v4si */

        default:
          return -1;
        }

    case 919:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4576; /* mve_vhaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4594; /* mve_vhaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4612; /* mve_vhaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 926:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4577; /* mve_vhaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4595; /* mve_vhaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4613; /* mve_vhaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 889:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4578; /* mve_vhsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4596; /* mve_vhsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4614; /* mve_vhsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 890:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4579; /* mve_vhsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4597; /* mve_vhsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4615; /* mve_vhsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 844:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4580; /* mve_vmlaq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4598; /* mve_vmlaq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4616; /* mve_vmlaq_m_n_sv4si */

        default:
          return -1;
        }

    case 847:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4581; /* mve_vmlaq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4599; /* mve_vmlaq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4617; /* mve_vmlaq_m_n_uv4si */

        default:
          return -1;
        }

    case 855:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4582; /* mve_vmlasq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4600; /* mve_vmlasq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4618; /* mve_vmlasq_m_n_sv4si */

        default:
          return -1;
        }

    case 854:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4583; /* mve_vmlasq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4601; /* mve_vmlasq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4619; /* mve_vmlasq_m_n_uv4si */

        default:
          return -1;
        }

    case 906:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4584; /* mve_vqdmlahq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4602; /* mve_vqdmlahq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4620; /* mve_vqdmlahq_m_n_sv4si */

        default:
          return -1;
        }

    case 867:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4585; /* mve_vqdmlashq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4603; /* mve_vqdmlashq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4621; /* mve_vqdmlashq_m_n_sv4si */

        default:
          return -1;
        }

    case 877:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4586; /* mve_vqrdmlahq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4604; /* mve_vqrdmlahq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4622; /* mve_vqrdmlahq_m_n_sv4si */

        default:
          return -1;
        }

    case 868:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4587; /* mve_vqrdmlashq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4605; /* mve_vqrdmlashq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4623; /* mve_vqrdmlashq_m_n_sv4si */

        default:
          return -1;
        }

    case 899:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4588; /* mve_vqaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4606; /* mve_vqaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4624; /* mve_vqaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 921:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4589; /* mve_vqaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4607; /* mve_vqaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4625; /* mve_vqaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 849:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4590; /* mve_vqsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4608; /* mve_vqsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4626; /* mve_vqsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 848:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4591; /* mve_vqsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4609; /* mve_vqsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4627; /* mve_vqsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 936:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4592; /* mve_vqdmulhq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4610; /* mve_vqdmulhq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4628; /* mve_vqdmulhq_m_n_sv4si */

        default:
          return -1;
        }

    case 966:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4593; /* mve_vqrdmulhq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4611; /* mve_vqrdmulhq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4629; /* mve_vqrdmulhq_m_n_sv4si */

        default:
          return -1;
        }

    case 909:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4630; /* mve_vmladavaq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4635; /* mve_vmladavaq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4640; /* mve_vmladavaq_p_sv4si */

        default:
          return -1;
        }

    case 908:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4631; /* mve_vmladavaq_p_uv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4636; /* mve_vmladavaq_p_uv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4641; /* mve_vmladavaq_p_uv4si */

        default:
          return -1;
        }

    case 935:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4632; /* mve_vmlsdavaxq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4637; /* mve_vmlsdavaxq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4642; /* mve_vmlsdavaxq_p_sv4si */

        default:
          return -1;
        }

    case 940:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4633; /* mve_vmlsdavaq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4638; /* mve_vmlsdavaq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4643; /* mve_vmlsdavaq_p_sv4si */

        default:
          return -1;
        }

    case 932:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4634; /* mve_vmladavaxq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4639; /* mve_vmladavaxq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4644; /* mve_vmladavaxq_p_sv4si */

        default:
          return -1;
        }

    case 893:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4645; /* mve_vmullbq_int_m_uv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4649; /* mve_vmullbq_int_m_uv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4653; /* mve_vmullbq_int_m_uv4si */

        default:
          return -1;
        }

    case 894:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4646; /* mve_vmullbq_int_m_sv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4650; /* mve_vmullbq_int_m_sv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4654; /* mve_vmullbq_int_m_sv4si */

        default:
          return -1;
        }

    case 851:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4647; /* mve_vmulltq_int_m_uv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4651; /* mve_vmulltq_int_m_uv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4655; /* mve_vmulltq_int_m_uv4si */

        default:
          return -1;
        }

    case 850:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4648; /* mve_vmulltq_int_m_sv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4652; /* mve_vmulltq_int_m_sv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4656; /* mve_vmulltq_int_m_sv4si */

        default:
          return -1;
        }

    case 916:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4657; /* mve_vqshlq_m_n_sv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4661; /* mve_vqshlq_m_n_sv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4665; /* mve_vqshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 917:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4658; /* mve_vqshlq_m_n_uv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4662; /* mve_vqshlq_m_n_uv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4666; /* mve_vqshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 904:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4659; /* mve_vshlq_m_n_sv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4663; /* mve_vshlq_m_n_sv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4667; /* mve_vshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 907:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4660; /* mve_vshlq_m_n_uv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4664; /* mve_vshlq_m_n_uv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4668; /* mve_vshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 832:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4669; /* mve_vrshrq_m_n_sv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4673; /* mve_vrshrq_m_n_sv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4677; /* mve_vrshrq_m_n_sv4si */

        default:
          return -1;
        }

    case 871:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4670; /* mve_vrshrq_m_n_uv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4674; /* mve_vrshrq_m_n_uv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4678; /* mve_vrshrq_m_n_uv4si */

        default:
          return -1;
        }

    case 896:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4671; /* mve_vshrq_m_n_sv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4675; /* mve_vshrq_m_n_sv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4679; /* mve_vshrq_m_n_sv4si */

        default:
          return -1;
        }

    case 863:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4672; /* mve_vshrq_m_n_uv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4676; /* mve_vshrq_m_n_uv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4680; /* mve_vshrq_m_n_uv4si */

        default:
          return -1;
        }

    case 898:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4681; /* mve_vsliq_m_n_uv16qi */

        case 1:
          if (!
#line 2836 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4683; /* mve_vsliq_m_n_uv8hi */

        case 2:
          if (!
#line 2836 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4685; /* mve_vsliq_m_n_uv4si */

        default:
          return -1;
        }

    case 910:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4682; /* mve_vsliq_m_n_sv16qi */

        case 1:
          if (!
#line 2836 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4684; /* mve_vsliq_m_n_sv8hi */

        case 2:
          if (!
#line 2836 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4686; /* mve_vsliq_m_n_sv4si */

        default:
          return -1;
        }

    case 944:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4687; /* mve_vmlaldavaq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4692; /* mve_vmlaldavaq_p_sv4si */

        default:
          return -1;
        }

    case 943:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4688; /* mve_vmlaldavaq_p_uv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4693; /* mve_vmlaldavaq_p_uv4si */

        default:
          return -1;
        }

    case 962:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4689; /* mve_vmlaldavaxq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4694; /* mve_vmlaldavaxq_p_sv4si */

        default:
          return -1;
        }

    case 968:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4690; /* mve_vmlsldavaq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4695; /* mve_vmlsldavaq_p_sv4si */

        default:
          return -1;
        }

    case 969:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4691; /* mve_vmlsldavaxq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4696; /* mve_vmlsldavaxq_p_sv4si */

        default:
          return -1;
        }

    case 946:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4697; /* mve_vqrshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4717; /* mve_vqrshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 945:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4698; /* mve_vqrshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4718; /* mve_vqrshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 947:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4699; /* mve_vqrshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4719; /* mve_vqrshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 963:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4700; /* mve_vqrshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4720; /* mve_vqrshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 976:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4701; /* mve_vqrshrunbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4721; /* mve_vqrshrunbq_m_n_sv4si */

        default:
          return -1;
        }

    case 983:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4702; /* mve_vqrshruntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4722; /* mve_vqrshruntq_m_n_sv4si */

        default:
          return -1;
        }

    case 949:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4703; /* mve_vqshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4723; /* mve_vqshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 948:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4704; /* mve_vqshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4724; /* mve_vqshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 950:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4705; /* mve_vqshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4725; /* mve_vqshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 964:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4706; /* mve_vqshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4726; /* mve_vqshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 977:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4707; /* mve_vqshrunbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4727; /* mve_vqshrunbq_m_n_sv4si */

        default:
          return -1;
        }

    case 978:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4708; /* mve_vqshruntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4728; /* mve_vqshruntq_m_n_sv4si */

        default:
          return -1;
        }

    case 952:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4709; /* mve_vrshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4729; /* mve_vrshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 951:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4710; /* mve_vrshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4730; /* mve_vrshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 965:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4711; /* mve_vrshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4731; /* mve_vrshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 953:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4712; /* mve_vrshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4732; /* mve_vrshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 958:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4713; /* mve_vshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4733; /* mve_vshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 959:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4714; /* mve_vshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4734; /* mve_vshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 960:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4715; /* mve_vshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4735; /* mve_vshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 961:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4716; /* mve_vshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4736; /* mve_vshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 967:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4737; /* mve_vrmlaldavhaq_p_sv4si */

    case 979:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4738; /* mve_vrmlaldavhaq_p_uv4si */

    case 980:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4739; /* mve_vrmlaldavhaxq_p_sv4si */

    case 981:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4740; /* mve_vrmlsldavhaq_p_sv4si */

    case 982:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4741; /* mve_vrmlsldavhaxq_p_sv4si */

    case 954:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4742; /* mve_vshllbq_m_n_uv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4746; /* mve_vshllbq_m_n_uv8hi */

        default:
          return -1;
        }

    case 955:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4743; /* mve_vshllbq_m_n_sv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4747; /* mve_vshllbq_m_n_sv8hi */

        default:
          return -1;
        }

    case 956:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4744; /* mve_vshlltq_m_n_uv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4748; /* mve_vshlltq_m_n_uv8hi */

        default:
          return -1;
        }

    case 957:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4745; /* mve_vshlltq_m_n_sv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4749; /* mve_vshlltq_m_n_sv8hi */

        default:
          return -1;
        }

    case 970:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 2945 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4750; /* mve_vmullbq_poly_m_pv16qi */

        case 1:
          if (!
#line 2945 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4752; /* mve_vmullbq_poly_m_pv8hi */

        default:
          return -1;
        }

    case 971:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 2945 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4751; /* mve_vmulltq_poly_m_pv16qi */

        case 1:
          if (!
#line 2945 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4753; /* mve_vmulltq_poly_m_pv8hi */

        default:
          return -1;
        }

    case 972:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 2964 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4754; /* mve_vqdmullbq_m_n_sv8hi */

        case 1:
          if (!
#line 2964 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4756; /* mve_vqdmullbq_m_n_sv4si */

        default:
          return -1;
        }

    case 974:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 2964 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4755; /* mve_vqdmulltq_m_n_sv8hi */

        case 1:
          if (!
#line 2964 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4757; /* mve_vqdmulltq_m_n_sv4si */

        default:
          return -1;
        }

    case 973:
      switch (pattern228 (x1))
        {
        case 0:
          if (!
#line 2983 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4758; /* mve_vqdmullbq_m_sv8hi */

        case 1:
          if (!
#line 2983 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4760; /* mve_vqdmullbq_m_sv4si */

        default:
          return -1;
        }

    case 975:
      switch (pattern228 (x1))
        {
        case 0:
          if (!
#line 2983 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4759; /* mve_vqdmulltq_m_sv8hi */

        case 1:
          if (!
#line 2983 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4761; /* mve_vqdmulltq_m_sv4si */

        default:
          return -1;
        }

    case 901:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4762; /* mve_vabdq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4770; /* mve_vabdq_m_fv4sf */

        default:
          return -1;
        }

    case 920:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4763; /* mve_vaddq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4771; /* mve_vaddq_m_fv4sf */

        default:
          return -1;
        }

    case 992:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4764; /* mve_vfmaq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4772; /* mve_vfmaq_m_fv4sf */

        default:
          return -1;
        }

    case 995:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4765; /* mve_vfmsq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4773; /* mve_vfmsq_m_fv4sf */

        default:
          return -1;
        }

    case 996:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4766; /* mve_vmaxnmq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4774; /* mve_vmaxnmq_m_fv4sf */

        default:
          return -1;
        }

    case 997:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4767; /* mve_vminnmq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4775; /* mve_vminnmq_m_fv4sf */

        default:
          return -1;
        }

    case 861:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4768; /* mve_vmulq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4776; /* mve_vmulq_m_fv4sf */

        default:
          return -1;
        }

    case 998:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4769; /* mve_vsubq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4777; /* mve_vsubq_m_fv4sf */

        default:
          return -1;
        }

    case 872:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4778; /* mve_vaddq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4783; /* mve_vaddq_m_n_fv4sf */

        default:
          return -1;
        }

    case 993:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4779; /* mve_vfmaq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4784; /* mve_vfmaq_m_n_fv4sf */

        default:
          return -1;
        }

    case 994:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4780; /* mve_vfmasq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4785; /* mve_vfmasq_m_n_fv4sf */

        default:
          return -1;
        }

    case 853:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4781; /* mve_vmulq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4786; /* mve_vmulq_m_n_fv4sf */

        default:
          return -1;
        }

    case 836:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4782; /* mve_vsubq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4787; /* mve_vsubq_m_n_fv4sf */

        default:
          return -1;
        }

    case 886:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4788; /* mve_vandq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4793; /* mve_vandq_m_fv4sf */

        default:
          return -1;
        }

    case 837:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4789; /* mve_vbicq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4794; /* mve_vbicq_m_fv4sf */

        default:
          return -1;
        }

    case 903:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4790; /* mve_veorq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4795; /* mve_veorq_m_fv4sf */

        default:
          return -1;
        }

    case 843:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4791; /* mve_vornq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4796; /* mve_vornq_m_fv4sf */

        default:
          return -1;
        }

    case 880:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4792; /* mve_vorrq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4797; /* mve_vorrq_m_fv4sf */

        default:
          return -1;
        }

    case 900:
      return recog_258 (x1, insn, pnum_clobbers);

    case 895:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4800; /* mve_vcaddq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4806; /* mve_vcaddq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 858:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4801; /* mve_vcaddq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4807; /* mve_vcaddq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 988:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4802; /* mve_vcmulq_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4808; /* mve_vcmulq_m_fv4sf */

        default:
          return -1;
        }

    case 991:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4803; /* mve_vcmulq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4809; /* mve_vcmulq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 989:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4804; /* mve_vcmulq_rot180_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4810; /* mve_vcmulq_rot180_m_fv4sf */

        default:
          return -1;
        }

    case 990:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4805; /* mve_vcmulq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4811; /* mve_vcmulq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 984:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4812; /* mve_vcmlaq_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4816; /* mve_vcmlaq_m_fv4sf */

        default:
          return -1;
        }

    case 987:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4813; /* mve_vcmlaq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4817; /* mve_vcmlaq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 985:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4814; /* mve_vcmlaq_rot180_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4818; /* mve_vcmlaq_rot180_m_fv4sf */

        default:
          return -1;
        }

    case 986:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4815; /* mve_vcmlaq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4819; /* mve_vcmlaq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 1002:
      return recog_247 (x1, insn, pnum_clobbers);

    case 1004:
      return recog_252 (x1, insn, pnum_clobbers);

    case 1010:
      return recog_248 (x1, insn, pnum_clobbers);

    case 1000:
      return recog_251 (x1, insn, pnum_clobbers);

    case 1016:
      return recog_250 (x1, insn, pnum_clobbers);

    case 1026:
      return recog_249 (x1, insn, pnum_clobbers);

    case 1028:
      if (pattern93 (x1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 3);
      operands[3] = x3;
      if (!vpr_register_operand (operands[3], E_V8BImode)
          || !
#line 3717 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4937; /* mve_vstrq_truncate_scatter_shifted_offset_p_v4si */

    default:
      return -1;
    }
}

 int
recog_344 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case MULT:
      res = recog_335 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATERT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1277 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6777; /* *p rorv4hi3 */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1361 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6789; /* *p rorv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1277 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6778; /* *p rorv2si3 */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1361 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6790; /* *p rorv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1277 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6779; /* *p rordi3 */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1361 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6791; /* *p rordi3_di */
          break;

        default:
          break;
        }
      break;

    case ASHIFTRT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6780; /* *p ashrv4hi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1382 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6792; /* *p ashrv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6781; /* *p ashrv2si3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1382 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6793; /* *p ashrv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6782; /* *p ashrdi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1382 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6794; /* *p ashrdi3_di */
          break;

        default:
          break;
        }
      if (GET_MODE (x4) == E_DImode)
        {
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (arm_general_register_operand (operands[0], E_DImode))
            {
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              if (arm_reg_or_long_shift_imm (operands[1], E_SImode))
                {
                  x8 = XEXP (x4, 0);
                  if (rtx_equal_p (x8, operands[0])
                      && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1741 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE)))
                    return 7000; /* *p thumb2_asrl */
                }
            }
        }
      break;

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1319 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6783; /* *p lshrv4hi3_iwmmxt */
          if (register_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6795; /* *p lshrv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1319 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6784; /* *p lshrv2si3_iwmmxt */
          if (register_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6796; /* *p lshrv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1319 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6785; /* *p lshrdi3_iwmmxt */
          if (register_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6797; /* *p lshrdi3_di */
          break;

        default:
          break;
        }
      if (GET_MODE (x4) == E_DImode)
        {
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (arm_general_register_operand (operands[0], E_DImode))
            {
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              if (long_shift_imm (operands[1], E_SImode))
                {
                  x8 = XEXP (x4, 0);
                  if (rtx_equal_p (x8, operands[0])
                      && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1757 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE)))
                    return 7002; /* *p thumb2_lsrl */
                }
            }
        }
      break;

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1340 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6786; /* *p ashlv4hi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1424 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6798; /* *p ashlv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1340 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6787; /* *p ashlv2si3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1424 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6799; /* *p ashlv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1340 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6788; /* *p ashldi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1424 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6800; /* *p ashldi3_di */
          break;

        default:
          break;
        }
      if (GET_MODE (x4) == E_DImode)
        {
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (arm_general_register_operand (operands[0], E_DImode))
            {
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              if (arm_reg_or_long_shift_imm (operands[1], E_SImode))
                {
                  x8 = XEXP (x4, 0);
                  if (rtx_equal_p (x8, operands[0])
                      && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1749 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE)))
                    return 7001; /* *p thumb2_lsll */
                }
            }
        }
      break;

    default:
      break;
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  operands[3] = x4;
  if (!shift_operator (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!reg_or_int_operand (operands[2], E_SImode)
      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4753 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
    return -1;
  return 6472; /* *p *arm_shiftsi3 */
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          if (XWINT (x6, 0) != 0LL)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4127 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6459; /* *p *smin_0 */

        case REG:
        case SUBREG:
          switch (pattern441 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6747; /* *p *sminv2si3_iwmmxt */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6748; /* *p *sminv4hi3_iwmmxt */

            case 2:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6749; /* *p *sminv8qi3_iwmmxt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern379 (x1))
        {
        case 0:
          if ((
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4477 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return 6466; /* *p satsi_smin */
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4477 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return -1;
          return 6467; /* *p satsi_smin_setq */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4503 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return -1;
          return 6470; /* *p *satsi_smin_shift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_370 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case PLUS:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x3, 0);
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[1])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11940 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
            return -1;
          return 6595; /* *p *load_multiple_with_writeback */

        case MEM:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x12 = XEXP (x7, 0);
          if (GET_CODE (x12) != PLUS
              || GET_MODE (x12) != E_SImode)
            return -1;
          x14 = XEXP (x12, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x12, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x3, 0);
          operands[2] = x11;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[3])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 993 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6662; /* *p *ldm2_da */

        case REG:
          operands[1] = x7;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x4, 0);
          if (GET_CODE (x9) != MEM
              || GET_MODE (x9) != E_SImode)
            return -1;
          x16 = XEXP (x9, 0);
          if (GET_CODE (x16) != PLUS
              || GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x16, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_SImode
              || !store_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x18 = XEXP (x16, 0);
          operands[3] = x18;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x19 = XEXP (x11, 0);
          if (!rtx_equal_p (x19, operands[3])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1018 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6664; /* *p *stm2_da */

        default:
          return -1;
        }

    case RETURN:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      if (!pop_multiple_return (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (GET_CODE (x8))
        {
        case PLUS:
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x20 = XEXP (x8, 1);
          operands[2] = x20;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[1])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11971 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
            return -1;
          return 6596; /* *p *pop_multiple_with_writeback_and_return */

        case MEM:
          x11 = XEXP (x3, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11994 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
            return -1;
          return 6597; /* *p *pop_multiple_with_return */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      if (XWINT (x2, 0) == 0LL)
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == ZERO_EXTRACT
              && pattern247 (x3) == 0)
            return gen_split_13 (insn, operands);
        }
      operands[1] = x2;
      if (const_int_operand (operands[1], E_SImode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (arm_general_register_operand (operands[0], E_SImode)
              && 
#line 6577 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
((TARGET_32BIT || TARGET_HAVE_MOVT)
  && (!(const_ok_for_arm (INTVAL (operands[1]))
        || const_ok_for_arm (~INTVAL (operands[1]))))))
            return gen_split_63 (insn, operands);
        }
      break;

    case CONST:
      if (GET_MODE (x2) == E_SImode)
        {
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) == PLUS
              && GET_MODE (x4) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (arm_general_register_operand (operands[0], E_SImode))
                {
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (general_operand (operands[1], E_SImode))
                    {
                      x6 = XEXP (x4, 1);
                      operands[2] = x6;
                      if (const_int_operand (operands[2], E_SImode)
                          && 
#line 6606 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_THUMB
   && TARGET_HAVE_MOVT
   && arm_disable_literal_pool
   && reload_completed
   && GET_CODE (operands[1]) == SYMBOL_REF))
                        return gen_split_64 (insn, operands);
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!arm_general_register_operand (operands[0], E_DImode))
        return NULL;
      if (immediate_operand (operands[1], E_DImode)
          && 
#line 6378 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_40 (insn, operands);
      if (const_double_operand (operands[1], E_DImode)
          && 
#line 6408 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_47 (insn, operands);
      if (!immediate_operand (operands[1], E_DImode)
          || !
#line 752 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_119 (insn, operands);

    case E_DFmode:
      if (arm_general_register_operand (operands[0], E_DFmode))
        {
          if (immediate_operand (operands[1], E_DFmode)
              && 
#line 6378 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
            return gen_split_41 (insn, operands);
          if (const_double_operand (operands[1], E_DFmode)
              && 
#line 6408 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
            return gen_split_48 (insn, operands);
        }
      if (s_register_operand (operands[0], E_DFmode)
          && const_double_operand (operands[1], E_DFmode)
          && 
#line 7658 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_disable_literal_pool && TARGET_SOFT_FLOAT))
        return gen_split_70 (insn, operands);
      if (!arm_general_register_operand (operands[0], E_DFmode)
          || !immediate_operand (operands[1], E_DFmode)
          || !
#line 752 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_120 (insn, operands);

    case E_V8QImode:
      if (!arm_general_register_operand (operands[0], E_V8QImode))
        return NULL;
      if (immediate_operand (operands[1], E_V8QImode)
          && 
#line 6378 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_42 (insn, operands);
      if (const_double_operand (operands[1], E_V8QImode)
          && 
#line 6408 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_49 (insn, operands);
      if (!immediate_operand (operands[1], E_V8QImode)
          || !
#line 752 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_121 (insn, operands);

    case E_V4HImode:
      if (!arm_general_register_operand (operands[0], E_V4HImode))
        return NULL;
      if (immediate_operand (operands[1], E_V4HImode)
          && 
#line 6378 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_43 (insn, operands);
      if (const_double_operand (operands[1], E_V4HImode)
          && 
#line 6408 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_50 (insn, operands);
      if (!immediate_operand (operands[1], E_V4HImode)
          || !
#line 752 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_122 (insn, operands);

    case E_V4HFmode:
      if (!arm_general_register_operand (operands[0], E_V4HFmode))
        return NULL;
      if (immediate_operand (operands[1], E_V4HFmode)
          && 
#line 6378 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_44 (insn, operands);
      if (const_double_operand (operands[1], E_V4HFmode)
          && 
#line 6408 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_51 (insn, operands);
      if (!immediate_operand (operands[1], E_V4HFmode)
          || !
#line 752 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_123 (insn, operands);

    case E_V2SImode:
      if (!arm_general_register_operand (operands[0], E_V2SImode))
        return NULL;
      if (immediate_operand (operands[1], E_V2SImode)
          && 
#line 6378 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_45 (insn, operands);
      if (const_double_operand (operands[1], E_V2SImode)
          && 
#line 6408 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_52 (insn, operands);
      if (!immediate_operand (operands[1], E_V2SImode)
          || !
#line 752 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_124 (insn, operands);

    case E_V2SFmode:
      if (!arm_general_register_operand (operands[0], E_V2SFmode))
        return NULL;
      if (immediate_operand (operands[1], E_V2SFmode)
          && 
#line 6378 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_46 (insn, operands);
      if (const_double_operand (operands[1], E_V2SFmode)
          && 
#line 6408 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_53 (insn, operands);
      if (!immediate_operand (operands[1], E_V2SFmode)
          || !
#line 752 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_125 (insn, operands);

    case E_SFmode:
      if (arm_general_register_operand (operands[0], E_SFmode)
          && immediate_operand (operands[1], E_SFmode)
          && 
#line 7487 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_EITHER
   && reload_completed
   && CONST_DOUBLE_P (operands[1])))
        return gen_split_68 (insn, operands);
      if (!s_register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 7531 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_disable_literal_pool && TARGET_SOFT_FLOAT))
        return NULL;
      return gen_split_69 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      res = split_4 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case AND:
    case IOR:
    case XOR:
      res = split_6 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (!shiftable_operator_strict_it (x3, E_SImode))
    return NULL;
  operands[5] = x3;
  x4 = XEXP (x3, 0);
  if (!arm_comparison_operator (x4, E_SImode))
    return NULL;
  operands[4] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return NULL;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  if (!arm_rhs_operand (operands[3], E_SImode))
    return NULL;
  x9 = XEXP (x3, 1);
  operands[1] = x9;
  if (!s_register_operand (operands[1], E_SImode)
      || !(
#line 798 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it) && 
#line 800 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
    return NULL;
  return gen_split_149 (insn, operands);
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return NULL;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 2);
  if (GET_CODE (x6) != CONST_INT)
    return NULL;
  operands[3] = x6;
  if (const_int_operand (operands[3], E_SImode))
    {
      x7 = XEXP (x3, 2);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (s_register_operand (operands[1], E_SImode))
            {
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (const_int_operand (operands[2], E_SImode))
                {
                  x10 = XEXP (x3, 1);
                  operands[4] = x10;
                  if (arm_not_operand (operands[4], E_SImode)
                      && 
#line 3189 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)
   && !reg_overlap_mentioned_p (operands[0], operands[4])))
                    return gen_split_9 (insn, operands);
                }
            }
        }
    }
  if (XWINT (x6, 0) != 0LL)
    return NULL;
  x7 = XEXP (x3, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x9 = XEXP (x5, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_SImode))
    return NULL;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!arm_not_operand (operands[3], E_SImode)
      || !
#line 3223 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && !reg_overlap_mentioned_p (operands[0], operands[3])))
    return NULL;
  return gen_split_10 (insn, operands);
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_11 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_10 (x1, insn);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != UNSPEC
              || XVECLEN (x3, 0) != 1
              || pattern285 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER
              || pattern451 (x1) != 0
              || !
#line 9306 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(reload_completed))
            return NULL;
          return gen_split_75 (insn, operands);

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case IF_THEN_ELSE:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != EQ)
                return NULL;
              x8 = XEXP (x7, 1);
              if (pattern297 (x8) != 0)
                return NULL;
              x9 = XEXP (x3, 1);
              if (GET_CODE (x9) != LABEL_REF)
                return NULL;
              x10 = XEXP (x3, 2);
              if (GET_CODE (x10) != PC)
                return NULL;
              x11 = XEXP (x2, 0);
              if (GET_CODE (x11) != PC)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER
                  || pattern577 (x1) != 0
                  || !
#line 9395 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(reload_completed))
                return NULL;
              return gen_split_76 (insn, operands);

            case UNSPEC_VOLATILE:
              switch (pattern265 (x1))
                {
                case 0:
                  if (!((
#line 250 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_177 (insn, operands);

                case 1:
                  if (!((
#line 250 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_179 (insn, operands);

                case 2:
                  if (!((
#line 250 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_178 (insn, operands);

                case 3:
                  if (!((
#line 250 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_180 (insn, operands);

                case 4:
                  if (!((
#line 281 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_181 (insn, operands);

                case 5:
                  if (!((
#line 281 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_183 (insn, operands);

                case 6:
                  if (!((
#line 281 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_182 (insn, operands);

                case 7:
                  if (!((
#line 281 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_184 (insn, operands);

                case 8:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_189 (insn, operands);

                case 9:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_194 (insn, operands);

                case 10:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_199 (insn, operands);

                case 11:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_204 (insn, operands);

                case 12:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_190 (insn, operands);

                case 13:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_195 (insn, operands);

                case 14:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_200 (insn, operands);

                case 15:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_205 (insn, operands);

                case 16:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_191 (insn, operands);

                case 17:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_196 (insn, operands);

                case 18:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_201 (insn, operands);

                case 19:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_206 (insn, operands);

                case 20:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_192 (insn, operands);

                case 21:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_197 (insn, operands);

                case 22:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_202 (insn, operands);

                case 23:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_207 (insn, operands);

                case 24:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_193 (insn, operands);

                case 25:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_198 (insn, operands);

                case 26:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_203 (insn, operands);

                case 27:
                  if (!(
#line 342 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_208 (insn, operands);

                case 28:
                  if (!(
#line 366 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_209 (insn, operands);

                case 29:
                  if (!(
#line 366 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_210 (insn, operands);

                case 30:
                  if (!(
#line 366 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_211 (insn, operands);

                case 31:
                  if (!(
#line 366 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_212 (insn, operands);

                default:
                  return NULL;
                }

            case MEM:
              operands[1] = x3;
              if (pattern319 (x1, 
18, 
2) != 0)
                return NULL;
              x11 = XEXP (x2, 0);
              operands[0] = x11;
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              x13 = XVECEXP (x12, 0, 0);
              operands[2] = x13;
              x14 = XVECEXP (x12, 0, 1);
              operands[3] = x14;
              if (!const_int_operand (operands[3], E_SImode))
                return NULL;
              x15 = XEXP (x6, 0);
              operands[4] = x15;
              if (!scratch_operand (operands[4], E_SImode))
                return NULL;
              x16 = XEXP (x4, 0);
              if (!rtx_equal_p (x16, operands[1]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern576 (x12, 
E_QImode) != 0
                      || !(
#line 301 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_185 (insn, operands);

                case E_HImode:
                  if (pattern576 (x12, 
E_HImode) != 0
                      || !(
#line 301 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_186 (insn, operands);

                case E_SImode:
                  if (pattern576 (x12, 
E_SImode) != 0
                      || !(
#line 301 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_187 (insn, operands);

                case E_DImode:
                  if (pattern576 (x12, 
E_DImode) != 0
                      || !(
#line 301 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_188 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_237 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_242 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_247 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_252 (insn, operands);

                default:
                  return NULL;
                }

            case MINUS:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_238 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_243 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_248 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_253 (insn, operands);

                default:
                  return NULL;
                }

            case IOR:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_239 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_244 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_249 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_254 (insn, operands);

                default:
                  return NULL;
                }

            case XOR:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_240 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_245 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_250 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_255 (insn, operands);

                default:
                  return NULL;
                }

            case AND:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_241 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_246 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_251 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_256 (insn, operands);

                default:
                  return NULL;
                }

            case NOT:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != AND
                  || pattern319 (x1, 
19, 
3) != 0)
                return NULL;
              switch (pattern531 (x1))
                {
                case 0:
                  if (!(
#line 483 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_257 (insn, operands);

                case 1:
                  if (!(
#line 483 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_258 (insn, operands);

                case 2:
                  if (!(
#line 483 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_259 (insn, operands);

                case 3:
                  if (!(
#line 483 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_260 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET
              || pattern12 (x1) != 0)
            return NULL;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          switch (pattern565 (x1))
            {
            case 0:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_213 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_218 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_223 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_228 (insn, operands);

                default:
                  return NULL;
                }

            case 1:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_214 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_219 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_224 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_229 (insn, operands);

                default:
                  return NULL;
                }

            case 2:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_215 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_220 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_225 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_230 (insn, operands);

                default:
                  return NULL;
                }

            case 3:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_216 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_221 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_226 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_231 (insn, operands);

                default:
                  return NULL;
                }

            case 4:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_217 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_222 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_227 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_232 (insn, operands);

                default:
                  return NULL;
                }

            case 5:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              x13 = XVECEXP (x12, 0, 0);
              x17 = XEXP (x13, 0);
              if (GET_CODE (x17) != AND)
                return NULL;
              x18 = XEXP (x17, 1);
              operands[2] = x18;
              x19 = XEXP (x17, 0);
              if (!rtx_equal_p (x19, operands[1]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern622 (x12, 
E_QImode) != 0
                      || !(
#line 432 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_233 (insn, operands);

                case E_HImode:
                  if (pattern622 (x12, 
E_HImode) != 0
                      || !(
#line 432 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_234 (insn, operands);

                case E_SImode:
                  if (pattern622 (x12, 
E_SImode) != 0
                      || !(
#line 432 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_235 (insn, operands);

                case E_DImode:
                  if (pattern623 (x12) != 0
                      || !(
#line 432 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_236 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case COND_EXEC:
      x20 = XEXP (x1, 0);
      if (!arm_comparison_operator (x20, E_VOIDmode))
        return NULL;
      x21 = XEXP (x20, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x22 = XEXP (x20, 0);
      if (!cc_register (x22, E_VOIDmode))
        return NULL;
      x23 = XEXP (x1, 1);
      switch (GET_CODE (x23))
        {
        case SET:
          x24 = XEXP (x23, 1);
          switch (GET_CODE (x24))
            {
            case PLUS:
              if (pattern320 (x1) != 0
                  || !
#line 962 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_op (INTVAL (operands[2]), PLUS)
   && (reload_completed || !arm_eliminable_register (operands[1]))))
                return NULL;
              return gen_split_261 (insn, operands);

            case MINUS:
              if (GET_MODE (x24) != E_SImode)
                return NULL;
              operands[3] = x20;
              operands[4] = x22;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x26 = XEXP (x24, 0);
              operands[1] = x26;
              if (!reg_or_int_operand (operands[1], E_SImode))
                return NULL;
              x27 = XEXP (x24, 1);
              operands[2] = x27;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !(
#line 2020 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 2031 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( (CONST_INT_P (operands[1])
       && !const_ok_for_arm (INTVAL (operands[1]))))))
                return NULL;
              return gen_split_262 (insn, operands);

            case AND:
              if (GET_MODE (x24) != E_SImode)
                return NULL;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x26 = XEXP (x24, 0);
              switch (GET_CODE (x26))
                {
                case REG:
                case SUBREG:
                  operands[1] = x26;
                  if (!s_register_operand (operands[1], E_SImode))
                    return NULL;
                  operands[3] = x20;
                  operands[4] = x22;
                  x27 = XEXP (x24, 1);
                  operands[2] = x27;
                  if (!reg_or_int_operand (operands[2], E_SImode)
                      || !
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
	|| const_ok_for_arm (~INTVAL (operands[2]))
	|| (arm_arch_thumb2
	    && satisfies_constraint_Dj (operands[2])
	    && (rtx_equal_p (operands[0], operands[1])
		|| !reload_completed)))))
                    return NULL;
                  return gen_split_263 (insn, operands);

                case IOR:
                  if (GET_MODE (x26) != E_SImode)
                    return NULL;
                  x27 = XEXP (x24, 1);
                  if (GET_CODE (x27) != NOT
                      || GET_MODE (x27) != E_SImode)
                    return NULL;
                  operands[4] = x20;
                  operands[5] = x22;
                  x28 = XEXP (x26, 0);
                  operands[1] = x28;
                  if (!s_register_operand (operands[1], E_SImode))
                    return NULL;
                  x29 = XEXP (x26, 1);
                  operands[2] = x29;
                  if (!arm_rhs_operand (operands[2], E_SImode))
                    return NULL;
                  x30 = XEXP (x27, 0);
                  operands[3] = x30;
                  if (!arm_rhs_operand (operands[3], E_SImode)
                      || !(
#line 3910 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 3912 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
                    return NULL;
                  return gen_split_267 (insn, operands);

                default:
                  return NULL;
                }

            case CONST_INT:
              if (XWINT (x24, 0) != 0LL)
                return NULL;
              x25 = XEXP (x23, 0);
              if (GET_CODE (x25) != ZERO_EXTRACT
                  || GET_MODE (x25) != E_SImode)
                return NULL;
              operands[3] = x20;
              operands[4] = x22;
              x31 = XEXP (x25, 0);
              operands[0] = x31;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x32 = XEXP (x25, 1);
              operands[1] = x32;
              if (!const_int_M_operand (operands[1], E_SImode))
                return NULL;
              x33 = XEXP (x25, 2);
              operands[2] = x33;
              if (!const_int_M_operand (operands[2], E_SImode))
                return NULL;
              return gen_split_264 (insn, operands);

            case IOR:
              if (pattern320 (x1) != 0
                  || !
#line 3744 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
        || (TARGET_THUMB2 && const_ok_for_arm (~INTVAL (operands[2]))))))
                return NULL;
              return gen_split_265 (insn, operands);

            case XOR:
              if (pattern320 (x1) != 0
                  || !
#line 3849 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_arm (INTVAL (operands[2]))))
                return NULL;
              return gen_split_266 (insn, operands);

            case NEG:
              if (GET_MODE (x24) != E_DFmode)
                return NULL;
              operands[2] = x20;
              operands[3] = x22;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_DFmode))
                return NULL;
              x26 = XEXP (x24, 0);
              operands[1] = x26;
              if (!s_register_operand (operands[1], E_DFmode)
                  || !
#line 906 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE && reload_completed
   && arm_general_register_operand (operands[0], DFmode)))
                return NULL;
              return gen_split_270 (insn, operands);

            default:
              return NULL;
            }

        case PARALLEL:
          if (XVECLEN (x23, 0) != 2)
            return NULL;
          x34 = XVECEXP (x23, 0, 0);
          if (GET_CODE (x34) != SET
              || pattern363 (x1) != 0)
            return NULL;
          x35 = XEXP (x34, 0);
          operands[0] = x35;
          if (!s_register_operand (operands[0], E_SImode))
            return NULL;
          x36 = XEXP (x34, 1);
          if (GET_MODE (x36) != E_SImode)
            return NULL;
          switch (GET_CODE (x36))
            {
            case ABS:
              x37 = XEXP (x36, 0);
              operands[1] = x37;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              if ((
#line 5255 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5257 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_268 (insn, operands);
              if (!(
#line 117 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_271 (insn, operands);

            case NEG:
              x37 = XEXP (x36, 0);
              if (GET_CODE (x37) != ABS
                  || GET_MODE (x37) != E_SImode)
                return NULL;
              x38 = XEXP (x37, 0);
              operands[1] = x38;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              if ((
#line 5319 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5321 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_269 (insn, operands);
              if (!(
#line 170 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 175 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_272 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
