/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (GET_MODE (x3) != E_V8QImode)
        return -1;
      return 0;

    case E_V4HImode:
      if (GET_MODE (x3) != E_V4HImode)
        return -1;
      return 1;

    case E_V2SImode:
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 2;

    case E_V2SFmode:
      if (pattern1 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 3;

    case E_V4UQQmode:
      if (pattern1 (x3, 
E_V4UQQmode) != 0)
        return -1;
      return 4;

    case E_V2UHQmode:
      if (pattern1 (x3, 
E_V2UHQmode) != 0)
        return -1;
      return 5;

    case E_UQQmode:
      if (pattern1 (x3, 
E_UQQmode) != 0)
        return -1;
      return 6;

    case E_UHQmode:
      if (pattern1 (x3, 
E_UHQmode) != 0)
        return -1;
      return 7;

    case E_V2UHAmode:
      if (pattern1 (x3, 
E_V2UHAmode) != 0)
        return -1;
      return 8;

    case E_UHAmode:
      if (pattern1 (x3, 
E_UHAmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 19)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return pattern21 (x1); /* [-1, 3] */
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern34 (x3, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern34 (x3, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern34 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern52 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern51 (x3, 
i1, 
i2, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern51 (x3, 
i3, 
i4, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BImode:
      return pattern49 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8BImode:
      if (pattern49 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4BImode:
      if (pattern49 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern72 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern72 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern72 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !vpr_register_operand (operands[3], E_V8BImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != i1
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != XOR
          || GET_MODE (x5) != E_V16QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern38 (x3, 
i1, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern38 (x3, 
i2, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern148 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (GET_MODE (x3) != E_V8HFmode)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern148 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 5;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !mve_imm_16 (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern166 (x3, 
E_V8HFmode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern167 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arm_low_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!arm_low_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[2], E_V16QImode)
          || !s_register_operand (operands[3], E_V16QImode)
          || !vpr_register_operand (operands[4], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !s_register_operand (operands[3], E_V8HImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !s_register_operand (operands[3], E_V4SImode)
          || !vpr_register_operand (operands[4], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[2]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !s_register_operand (operands[3], E_V8HImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !s_register_operand (operands[3], E_V4SImode)
          || !vpr_register_operand (operands[4], E_V4BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern237 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern245 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !const_neon_scalar_shift_amount_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!const_int_M_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  if (!const_int_M_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern261 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!arm_add_operand (operands[3], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_CC_Zmode:
          return pattern259 (x1, 
E_CC_Zmode); /* [-1, 1] */

        case E_SImode:
          res = pattern259 (x1, 
E_SImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case MEM:
      operands[2] = x3;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_CC_Zmode:
          res = pattern260 (x1, 
E_CC_Zmode);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case E_SImode:
          res = pattern260 (x1, 
E_SImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern275 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!power_of_two_operand (operands[3], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return pattern278 (x1); /* [-1, 9] */

    case ABS:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ABS)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern279 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern279 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case E_V8HImode:
          if (pattern279 (x1, 
E_V8HFmode, 
E_V8HImode) != 0)
            return -1;
          return 12;

        case E_V4HImode:
          if (pattern279 (x1, 
E_V4HFmode, 
E_V4HImode) != 0)
            return -1;
          return 13;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern294 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[3] = x4;
      if (!arm_comparison_operator (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (!arm_comparison_operator (x5, E_SImode))
        return -1;
      operands[6] = x5;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 100
          || GET_MODE (x7) != E_CCmode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || pattern290 (x3) != 0)
        return -1;
      return 0;

    case MEM:
      res = pattern293 (x1, pnum_clobbers);
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern313 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern311 (x6, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern311 (x6, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern311 (x6, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V4UQQmode:
      if (pattern310 (x6, 
E_V4UQQmode) != 0)
        return -1;
      return 3;

    case E_V2UHQmode:
      if (pattern310 (x6, 
E_V2UHQmode) != 0)
        return -1;
      return 4;

    case E_UQQmode:
      if (pattern310 (x6, 
E_UQQmode) != 0)
        return -1;
      return 5;

    case E_UHQmode:
      if (pattern310 (x6, 
E_UHQmode) != 0)
        return -1;
      return 6;

    case E_V2UHAmode:
      if (pattern310 (x6, 
E_V2UHAmode) != 0)
        return -1;
      return 7;

    case E_UHAmode:
      if (pattern310 (x6, 
E_UHAmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern330 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  operands[3] = x7;
  if (!mve_imm_selective_upto_8 (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x2, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[4] = x9;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return pattern329 (x5); /* [-1, 2] */
}

int
pattern344 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern352 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern352 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern352 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern361 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (!subreg_lowpart_operator (x5, E_VOIDmode))
    return -1;
  operands[5] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x2, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[4] = x9;
  if (!s_register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x1, 0);
      operands[4] = x8;
      x9 = XEXP (x8, 0);
      operands[5] = x9;
      return 0;

    case MULT:
    case ASHIFT:
    case ASHIFTRT:
      if (!sat_shift_operator (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x1, 0);
      operands[6] = x8;
      x9 = XEXP (x8, 0);
      operands[7] = x9;
      x10 = XEXP (x5, 0);
      operands[4] = x10;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[5] = x11;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern397 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern404 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern411 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 2);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern418 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern426 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !s_register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !s_register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern437 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SIGN_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern445 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!guard_addr_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern464 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode
      || !register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode
      || !register_operand (operands[1], E_V4SFmode)
      || !register_operand (operands[2], E_V8BFmode)
      || !register_operand (operands[3], E_V8BFmode))
    return -1;
  return 0;
}

int
pattern472 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern483 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const_int_vcde3_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern491 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern498 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern507 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[1], E_V8HImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!s_register_operand (operands[2], E_V8HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern517 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || !s_register_operand (operands[1], E_SImode)
      || !s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern524 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern533 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[1], E_V8HImode)
      || !vpr_register_operand (operands[3], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!s_register_operand (operands[2], E_V8HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern540 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  return pattern539 (x7, 
i1); /* [-1, 0] */
}

int
pattern552 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[3], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern561 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern570 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern582 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern591 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !s_register_operand (operands[2], i3))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern599 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MULT
      || GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern609 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  return pattern608 (x5, 
i1, 
i2); /* [-1, 0] */
}

int
pattern618 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern625 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[3] = x1;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case ASHIFTRT:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern634 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!load_multiple_operation (operands[0], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!arm_hard_general_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!arm_hard_general_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!arm_hard_general_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern643 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x2, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x9, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x3, 1);
  x17 = XVECEXP (x16, 0, 0);
  switch (XWINT (x17, 0))
    {
    case 1LL:
      x18 = XVECEXP (x16, 0, 1);
      if (XWINT (x18, 0) != 3LL)
        return -1;
      x19 = XEXP (x8, 1);
      x20 = XVECEXP (x19, 0, 0);
      if (XWINT (x20, 0) != 0LL)
        return -1;
      x21 = XVECEXP (x19, 0, 1);
      if (XWINT (x21, 0) != 2LL)
        return -1;
      return 0;

    case 0LL:
      x18 = XVECEXP (x16, 0, 1);
      if (XWINT (x18, 0) != 2LL)
        return -1;
      x19 = XEXP (x8, 1);
      x20 = XVECEXP (x19, 0, 0);
      if (XWINT (x20, 0) != 1LL)
        return -1;
      x21 = XVECEXP (x19, 0, 1);
      if (XWINT (x21, 0) != 3LL)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case PLUS:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (pattern418 (x7, 
PLUS) != 0
          || GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      if (!arm_carry_operation (operands[3], E_DImode))
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      switch (GET_CODE (x9))
        {
        case SIGN_EXTEND:
          x11 = XEXP (x4, 1);
          if (pattern477 (x11, 
PLUS) != 0
              || GET_MODE (x3) != E_CC_Vmode
              || GET_MODE (x4) != E_CC_Vmode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x11, 0);
          x14 = XEXP (x13, 0);
          x15 = XEXP (x14, 0);
          operands[4] = x15;
          if (!arm_carry_operation (operands[4], E_SImode))
            return -1;
          x16 = XEXP (x14, 1);
          if (!rtx_equal_p (x16, operands[1]))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[4]))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x5, 1);
          switch (GET_CODE (x21))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x21) != E_DImode)
                return -1;
              x22 = XEXP (x21, 0);
              operands[2] = x22;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x23 = XEXP (x13, 1);
              if (!rtx_equal_p (x23, operands[2]))
                return -1;
              x24 = XEXP (x17, 1);
              if (!rtx_equal_p (x24, operands[2])
                  || !
#line 643 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 1; /* *addsi3_cin_vout_reg_insn */

            case CONST_INT:
              operands[2] = x21;
              if (!arm_adcimm_operand (operands[2], E_VOIDmode))
                return -1;
              x23 = XEXP (x13, 1);
              if (!rtx_equal_p (x23, operands[2]))
                return -1;
              x24 = XEXP (x17, 1);
              if (!rtx_equal_p (x24, operands[2])
                  || !
#line 689 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 2; /* *addsi3_cin_vout_imm_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != CONST_INT
              || XWINT (x11, 0) != 4294967296LL
              || GET_MODE (x3) != E_CC_ADCmode
              || GET_MODE (x4) != E_CC_ADCmode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          operands[4] = x19;
          if (!arm_carry_operation (operands[4], E_SImode))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x5, 1);
          switch (GET_CODE (x21))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x21) != E_DImode)
                return -1;
              x22 = XEXP (x21, 0);
              operands[2] = x22;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x24 = XEXP (x17, 1);
              if (!rtx_equal_p (x24, operands[2])
                  || !
#line 821 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 4; /* *addsi3_cin_cout_reg_insn */

            case CONST_INT:
              operands[5] = x21;
              if (!const_int_operand (operands[5], E_DImode))
                return -1;
              x24 = XEXP (x17, 1);
              operands[2] = x24;
              if (!arm_adcimm_operand (operands[2], E_SImode)
                  || !
#line 865 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (UINTVAL (operands[2]) & 0xffffffff) == UINTVAL (operands[5])))
                return -1;
              return 5; /* *addsi3_cin_cout_imm_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[2] = x6;
      if (!arm_carry_operation (operands[2], E_DImode)
          || pattern445 (x1, 
E_DImode) != 0)
        return -1;
      x21 = XEXP (x5, 1);
      if (GET_MODE (x21) != E_DImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      switch (GET_CODE (x21))
        {
        case SIGN_EXTEND:
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != SIGN_EXTEND
              || GET_MODE (x11) != E_DImode)
            return -1;
          x13 = XEXP (x11, 0);
          if (GET_CODE (x13) != PLUS
              || GET_MODE (x13) != E_SImode
              || GET_MODE (x3) != E_CC_Vmode
              || GET_MODE (x4) != E_CC_Vmode)
            return -1;
          x22 = XEXP (x21, 0);
          operands[1] = x22;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          if (!arm_carry_operation (operands[3], E_SImode))
            return -1;
          x23 = XEXP (x13, 1);
          if (!rtx_equal_p (x23, operands[1]))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          x24 = XEXP (x17, 1);
          if (!rtx_equal_p (x24, operands[1])
              || !
#line 725 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 3; /* *addsi3_cin_vout_0_insn */

        case ZERO_EXTEND:
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != CONST_INT
              || XWINT (x11, 0) != 4294967296LL
              || GET_MODE (x3) != E_CC_ADCmode
              || GET_MODE (x4) != E_CC_ADCmode)
            return -1;
          x22 = XEXP (x21, 0);
          operands[1] = x22;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          operands[3] = x18;
          if (!arm_carry_operation (operands[3], E_SImode))
            return -1;
          x24 = XEXP (x17, 1);
          if (!rtx_equal_p (x24, operands[1])
              || !
#line 900 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 6; /* *addsi3_cin_cout_0_insn */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x6) != E_DImode
          || GET_MODE (x5) != E_DImode)
        return -1;
      x21 = XEXP (x5, 1);
      switch (GET_CODE (x21))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x21) != E_DImode
              || pattern476 (x1) != 0)
            return -1;
          x22 = XEXP (x21, 0);
          operands[2] = x22;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x7, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode)
              || pattern614 (x1) != 0
              || !
#line 992 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 8; /* addsi3_compareV_reg */

        case CONST_INT:
          if (pattern476 (x1) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x7, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x11 = XEXP (x4, 1);
          x13 = XEXP (x11, 0);
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          if (XWINT (x21, 0) == 2147483648LL)
            {
              x23 = XEXP (x13, 1);
              if (GET_CODE (x23) == CONST_INT
                  && XWINT (x23, 0) == -2147483648LL)
                {
                  x24 = XEXP (x17, 1);
                  if (GET_CODE (x24) == CONST_INT
                      && XWINT (x24, 0) == -2147483648LL
                      && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return 10; /* subvsi3_intmin */
                }
            }
          operands[2] = x21;
          if (!arm_addimm_operand (operands[2], E_VOIDmode))
            return -1;
          x23 = XEXP (x13, 1);
          if (!rtx_equal_p (x23, operands[2]))
            return -1;
          x24 = XEXP (x17, 1);
          if (!rtx_equal_p (x24, operands[2])
              || !
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && INTVAL (operands[2]) == ARM_SIGN_EXTEND (INTVAL (operands[2]))))
            return -1;
          return 11; /* addsi3_compareV_imm */

        case GEU:
        case LTU:
          operands[3] = x21;
          if (!arm_borrow_operation (operands[3], E_DImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER
              || GET_MODE (x3) != E_CC_SWPmode
              || GET_MODE (x4) != E_CC_SWPmode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x4, 1);
          operands[1] = x11;
          if (!arm_immediate_operand (operands[1], E_VOIDmode))
            return -1;
          x10 = XEXP (x7, 0);
          operands[0] = x10;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 2128 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 50; /* rscsi3_CC_NVout_scratch */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern445 (x1, 
E_SImode) != 0)
        return -1;
      x21 = XEXP (x5, 1);
      operands[2] = x21;
      if (!arm_add_operand (operands[2], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x17 = XEXP (x7, 1);
      x18 = XEXP (x17, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x24 = XEXP (x17, 1);
      if (!rtx_equal_p (x24, operands[2]))
        return -1;
      x11 = XEXP (x4, 1);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
          if (XWINT (x11, 0) == 0LL
              && GET_MODE (x3) == E_CC_NZmode
              && GET_MODE (x4) == E_CC_NZmode)
            {
              if (
#line 1127 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 13; /* addsi3_compare0 */
              if (
#line 1371 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return 1059; /* thumb2_addsi3_compare0 */
            }
          break;

        case REG:
        case SUBREG:
          if (rtx_equal_p (x11, operands[1])
              && GET_MODE (x3) == E_CC_Cmode
              && GET_MODE (x4) == E_CC_Cmode
              && 
#line 1245 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 17; /* addsi3_compare_op1 */
          break;

        default:
          break;
        }
      if (GET_MODE (x3) != E_CC_Cmode
          || GET_MODE (x4) != E_CC_Cmode
          || !rtx_equal_p (x11, operands[2])
          || !
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 18; /* *addsi3_compare_op2 */

    case ZERO_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || pattern446 (x2, 
E_DImode, 
E_CC_SWPmode) != 0)
        return -1;
      x21 = XEXP (x5, 1);
      operands[3] = x21;
      if (!arm_borrow_operation (operands[3], E_DImode))
        return -1;
      x11 = XEXP (x4, 1);
      operands[1] = x11;
      if (!arm_immediate_operand (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!scratch_operand (operands[0], E_SImode)
          || !
#line 2128 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      return 51; /* rscsi3_CC_Bout_scratch */

    case MULT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x4, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern446 (x2, 
E_SImode, 
E_CC_NZmode) != 0)
        return -1;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x21 = XEXP (x5, 1);
      operands[3] = x21;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      switch (pattern588 (x7, 
MULT, 
PLUS))
        {
        case 0:
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x24 = XEXP (x17, 1);
          if (!rtx_equal_p (x24, operands[3]))
            return -1;
          if (
#line 2363 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
            return 63; /* *mulsi3addsi_compare0 */
          if (!
#line 2380 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6 && optimize_size))
            return -1;
          return 64; /* *mulsi3addsi_compare0_v6 */

        case 1:
          if (
#line 2395 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6))
            return 65; /* *mulsi3addsi_compare0_scratch */
          if (!
#line 2410 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6 && optimize_size))
            return -1;
          return 66; /* *mulsi3addsi_compare0_scratch_v6 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
      operands[3] = x4;
      if (equality_operator (operands[3], E_VOIDmode))
        {
          res = recog_35 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x4) != NE)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 14
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (XWINT (x6, 0) != 1LL)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 1);
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 14
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XEXP (x9, 1);
      if (XWINT (x11, 0) != -1LL
          || pattern478 (x1, 
E_CCmode, 
100, 
14) != 0)
        return -1;
      x12 = XEXP (x7, 0);
      operands[0] = x12;
      if (!
#line 1771 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_32BIT && TARGET_HAVE_LOB))
        return -1;
      return 1075; /* *doloop_end_internal */

    case GTU:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      if (pattern298 (x5) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 1);
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 14
          || GET_MODE (x10) != E_SImode
          || pattern603 (x1) != 0)
        return -1;
      switch (pattern628 (x1))
        {
        case 0:
          if (!
#line 4677 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5067; /* predicated_doloop_end_internal16 */

        case 1:
          if (!
#line 4677 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5068; /* predicated_doloop_end_internal8 */

        case 2:
          if (!
#line 4677 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5069; /* predicated_doloop_end_internal4 */

        case 3:
          if (!
#line 4677 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5070; /* predicated_doloop_end_internal2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || pattern25 (x1) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CLOBBER
      || pattern624 (x1) != 0)
    return -1;
  x6 = XEXP (x4, 0);
  operands[4] = x6;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[5] = x7;
  if (!scratch_operand (operands[5], E_SImode)
      || pattern637 (x1) != 0
      || !
#line 1063 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
    return -1;
  return 973; /* cpymem8b */
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != MEM)
            return -1;
          if (GET_MODE (x5) == E_SImode
              && load_multiple_operation (operands[0], E_VOIDmode))
            {
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (s_register_operand (operands[1], E_SImode))
                {
                  x7 = XEXP (x4, 1);
                  operands[2] = x7;
                  if (const_int_I_operand (operands[2], E_SImode))
                    {
                      x8 = XEXP (x2, 0);
                      operands[3] = x8;
                      if (s_register_operand (operands[3], E_SImode))
                        {
                          x9 = XEXP (x4, 0);
                          if (rtx_equal_p (x9, operands[1]))
                            {
                              x10 = XEXP (x5, 0);
                              if (rtx_equal_p (x10, operands[1])
                                  && 
#line 11940 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
                                return 386; /* *load_multiple_with_writeback */
                            }
                        }
                    }
                }
            }
          if (GET_MODE (x5) != E_DFmode
              || !pop_multiple_fp (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x2, 0);
          operands[3] = x8;
          if (!vfp_hard_register_operand (operands[3], E_DFmode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[1])
              || !
#line 12029 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && TARGET_VFP_BASE))
            return -1;
          return 390; /* *vfp_pop_multiple_with_writeback */

        case MEM:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x9 = XEXP (x4, 0);
          if (GET_CODE (x9) != PLUS
              || GET_MODE (x9) != E_SImode)
            return -1;
          x11 = XEXP (x9, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x9, 0);
          operands[3] = x12;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x2, 0);
          operands[2] = x8;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[3])
              || !
#line 993 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 486; /* *ldm2_da */

        case REG:
          operands[1] = x4;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_SImode)
            return -1;
          x13 = XEXP (x6, 0);
          if (GET_CODE (x13) != PLUS
              || GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XEXP (x13, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode
              || !store_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x15 = XEXP (x13, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x16 = XEXP (x8, 0);
          if (!rtx_equal_p (x16, operands[3])
              || !
#line 1018 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 488; /* *stm2_da */

        default:
          return -1;
        }

    case RETURN:
      if (!pop_multiple_return (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_CODE (x5))
        {
        case PLUS:
          x8 = XEXP (x2, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x5, 1);
          operands[2] = x17;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[1])
              || !
#line 11971 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
            return -1;
          return 387; /* *pop_multiple_with_writeback_and_return */

        case MEM:
          x8 = XEXP (x2, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 11994 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
            return -1;
          return 388; /* *pop_multiple_with_return */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case MEM:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != MEM
          || pattern367 (x5) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[3] = x8;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          x10 = XEXP (x9, 1);
          if (XWINT (x10, 0) != 4LL)
            return -1;
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          if (arm_hard_general_register_operand (operands[1], E_SImode)
              && arm_hard_general_register_operand (operands[2], E_SImode)
              && 
#line 855 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
            return 475; /* *ldm2_ */
          if (!low_register_operand (operands[1], E_SImode)
              || !low_register_operand (operands[2], E_SImode)
              || !
#line 867 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 476; /* *thumb_ldm2_ia */

        case PLUS:
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x12 = XEXP (x8, 1);
          if (GET_CODE (x12) != CONST_INT
              || !arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          operands[3] = x13;
          if (!s_register_operand (operands[3], E_SImode)
              || !arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          switch (XWINT (x12, 0))
            {
            case 4LL:
              x10 = XEXP (x9, 1);
              if (XWINT (x10, 0) != 8LL
                  || !
#line 942 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 482; /* *ldm2_ib */

            case -8LL:
              x10 = XEXP (x9, 1);
              if (XWINT (x10, 0) != -4LL
                  || !
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 490; /* *ldm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      operands[1] = x4;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (pattern423 (x7) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x14 = XEXP (x6, 0);
      switch (GET_CODE (x14))
        {
        case REG:
        case SUBREG:
          operands[3] = x14;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x7, 0);
          x16 = XEXP (x15, 1);
          if (XWINT (x16, 0) != 4LL)
            return -1;
          x17 = XEXP (x15, 0);
          if (!rtx_equal_p (x17, operands[3])
              || !
#line 904 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 479; /* *stm2_ */

        case PLUS:
          if (GET_MODE (x14) != E_SImode)
            return -1;
          x18 = XEXP (x14, 1);
          if (GET_CODE (x18) != CONST_INT)
            return -1;
          x19 = XEXP (x14, 0);
          operands[3] = x19;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x7, 0);
          x17 = XEXP (x15, 0);
          if (!rtx_equal_p (x17, operands[3]))
            return -1;
          switch (XWINT (x18, 0))
            {
            case 4LL:
              x16 = XEXP (x15, 1);
              if (XWINT (x16, 0) != 8LL
                  || !
#line 968 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 484; /* *stm2_ib */

            case -8LL:
              x16 = XEXP (x15, 1);
              if (XWINT (x16, 0) != -4LL
                  || !
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 492; /* *stm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (!shift_operator (x4, E_SImode))
    return -1;
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CC_NZmode
      || GET_MODE (x2) != E_CC_NZmode)
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[4] = x9;
  if (!shift_amount_operand (operands[4], E_SImode)
      || !
#line 9802 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
    return -1;
  *pnum_clobbers = 1;
  return 333; /* *sub_shiftsi_compare0_scratch */
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1277 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 639; /* rorv4hi3 */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1361 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 651; /* rorv4hi3_di */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1277 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 640; /* rorv2si3 */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1361 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 652; /* rorv2si3_di */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1277 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 641; /* rordi3 */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1361 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 653; /* rordi3_di */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2230; /* neon_vextv8qi */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2231; /* neon_vextv16qi */

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2232; /* neon_vextv4hi */

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2233; /* neon_vextv8hi */

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2234; /* neon_vextv2si */

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2235; /* neon_vextv4si */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2236; /* neon_vextv4hf */

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2237; /* neon_vextv8hf */

    case E_V4BFmode:
      if (pattern41 (x3, 
E_V4BFmode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2238; /* neon_vextv4bf */

    case E_V8BFmode:
      if (pattern41 (x3, 
E_V8BFmode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2239; /* neon_vextv8bf */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2240; /* neon_vextv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2241; /* neon_vextv4sf */

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2242; /* neon_vextdi */

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2243; /* neon_vextv2di */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern45 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern500 (x2, 
E_OImode, 
E_SImode) != 0
          || !
#line 6239 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2953; /* neon_vst4_lanev8qi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      switch (pattern505 (x2, 
E_V4HImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 6239 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2954; /* neon_vst4_lanev4hi */

        case 1:
          if (!
#line 6266 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2959; /* neon_vst4_lanev8hi */

        default:
          return -1;
        }

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern505 (x2, 
E_V4HFmode, 
E_V8HFmode))
        {
        case 0:
          if (!
#line 6239 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2955; /* neon_vst4_lanev4hf */

        case 1:
          if (!
#line 6266 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2960; /* neon_vst4_lanev8hf */

        default:
          return -1;
        }

    case E_V4BFmode:
      x2 = XEXP (x1, 1);
      switch (pattern505 (x2, 
E_V4BFmode, 
E_V8BFmode))
        {
        case 0:
          if (!
#line 6239 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2956; /* neon_vst4_lanev4bf */

        case 1:
          if (!(
#line 6266 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2963; /* neon_vst4_lanev8bf */

        default:
          return -1;
        }

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      switch (pattern506 (x2, 
E_V2SImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 6239 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2957; /* neon_vst4_lanev2si */

        case 1:
          if (!
#line 6266 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2961; /* neon_vst4_lanev4si */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern506 (x2, 
E_V2SFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 6239 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2958; /* neon_vst4_lanev2sf */

        case 1:
          if (!
#line 6266 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2962; /* neon_vst4_lanev4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern428 (x3, 
E_SImode) != 0
          || !
#line 2214 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 933; /* arm_vcx2si */

    case E_DImode:
      if (pattern428 (x3, 
E_DImode) != 0
          || !
#line 2214 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 934; /* arm_vcx2di */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[2], E_V16QImode)
          || !const_int_mve_cde2_operand (operands[3], E_SImode)
          || !
#line 4460 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5047; /* arm_vcx2qv16qi */

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2433; /* neon_vsras_nv8qi */

    case 1:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2437; /* neon_vsras_nv16qi */

    case 2:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2441; /* neon_vsras_nv4hi */

    case 3:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2445; /* neon_vsras_nv8hi */

    case 4:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2449; /* neon_vsras_nv2si */

    case 5:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2453; /* neon_vsras_nv4si */

    case 6:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2457; /* neon_vsras_ndi */

    case 7:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2461; /* neon_vsras_nv2di */

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_ccde2_operand (operands[3], E_SImode))
    return -1;
  switch (pattern393 (x3))
    {
    case 0:
      if (!
#line 4550 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 143; /* arm_cx2si */

    case 1:
      if (!
#line 4550 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 144; /* arm_cx2di */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!neon_permissive_struct_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !s_register_operand (operands[1], E_V8QImode)
              || !
#line 287 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1107; /* *movmisalignv8qi_neon_store */

        case E_V4HImode:
          if (!neon_permissive_struct_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !s_register_operand (operands[1], E_V4HImode)
              || !
#line 287 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1108; /* *movmisalignv4hi_neon_store */

        case E_V4HFmode:
          if (!neon_permissive_struct_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !s_register_operand (operands[1], E_V4HFmode)
              || !
#line 287 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1109; /* *movmisalignv4hf_neon_store */

        case E_V4BFmode:
          if (!neon_permissive_struct_operand (operands[0], E_V4BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !s_register_operand (operands[1], E_V4BFmode)
              || !
#line 287 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1110; /* *movmisalignv4bf_neon_store */

        case E_V2SImode:
          if (!neon_permissive_struct_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !s_register_operand (operands[1], E_V2SImode)
              || !
#line 287 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1111; /* *movmisalignv2si_neon_store */

        case E_V2SFmode:
          if (!neon_permissive_struct_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !s_register_operand (operands[1], E_V2SFmode)
              || !
#line 287 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1112; /* *movmisalignv2sf_neon_store */

        case E_DImode:
          if (!neon_permissive_struct_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !s_register_operand (operands[1], E_DImode)
              || !
#line 287 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1113; /* *movmisaligndi_neon_store */

        case E_V16QImode:
          if (GET_MODE (x3) != E_V16QImode
              || !s_register_operand (operands[1], E_V16QImode))
            return -1;
          if (neon_permissive_struct_operand (operands[0], E_V16QImode)
              && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1121; /* *movmisalignv16qi_neon_store */
          if (!mve_memory_operand (operands[0], E_V16QImode)
              || !
#line 4555 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5057; /* movmisalignv16qi_mve_store */

        case E_V8HImode:
          if (GET_MODE (x3) != E_V8HImode
              || !s_register_operand (operands[1], E_V8HImode))
            return -1;
          if (neon_permissive_struct_operand (operands[0], E_V8HImode)
              && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1122; /* *movmisalignv8hi_neon_store */
          if (!mve_memory_operand (operands[0], E_V8HImode)
              || !
#line 4555 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5058; /* movmisalignv8hi_mve_store */

        case E_V8HFmode:
          if (GET_MODE (x3) != E_V8HFmode
              || !s_register_operand (operands[1], E_V8HFmode))
            return -1;
          if (neon_permissive_struct_operand (operands[0], E_V8HFmode)
              && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1123; /* *movmisalignv8hf_neon_store */
          if (!mve_memory_operand (operands[0], E_V8HFmode)
              || !
#line 4555 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5060; /* movmisalignv8hf_mve_store */

        case E_V8BFmode:
          if (!neon_permissive_struct_operand (operands[0], E_V8BFmode)
              || GET_MODE (x3) != E_V8BFmode
              || !s_register_operand (operands[1], E_V8BFmode)
              || !
#line 304 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1124; /* *movmisalignv8bf_neon_store */

        case E_V4SImode:
          if (GET_MODE (x3) != E_V4SImode
              || !s_register_operand (operands[1], E_V4SImode))
            return -1;
          if (neon_permissive_struct_operand (operands[0], E_V4SImode)
              && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1125; /* *movmisalignv4si_neon_store */
          if (!mve_memory_operand (operands[0], E_V4SImode)
              || !
#line 4555 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5059; /* movmisalignv4si_mve_store */

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode
              || !s_register_operand (operands[1], E_V4SFmode))
            return -1;
          if (neon_permissive_struct_operand (operands[0], E_V4SFmode)
              && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1126; /* *movmisalignv4sf_neon_store */
          if (!mve_memory_operand (operands[0], E_V4SFmode)
              || !
#line 4555 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5061; /* movmisalignv4sf_mve_store */

        case E_V2DImode:
          if (!neon_permissive_struct_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !s_register_operand (operands[1], E_V2DImode)
              || !
#line 304 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1127; /* *movmisalignv2di_neon_store */

        default:
          return -1;
        }

    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !neon_permissive_struct_operand (operands[1], E_V8QImode)
              || !
#line 296 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1114; /* *movmisalignv8qi_neon_load */

        case E_V4HImode:
          if (!s_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !neon_permissive_struct_operand (operands[1], E_V4HImode)
              || !
#line 296 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1115; /* *movmisalignv4hi_neon_load */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !neon_permissive_struct_operand (operands[1], E_V4HFmode)
              || !
#line 296 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1116; /* *movmisalignv4hf_neon_load */

        case E_V4BFmode:
          if (!s_register_operand (operands[0], E_V4BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !neon_permissive_struct_operand (operands[1], E_V4BFmode)
              || !
#line 296 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1117; /* *movmisalignv4bf_neon_load */

        case E_V2SImode:
          if (!s_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !neon_permissive_struct_operand (operands[1], E_V2SImode)
              || !
#line 296 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1118; /* *movmisalignv2si_neon_load */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !neon_permissive_struct_operand (operands[1], E_V2SFmode)
              || !
#line 296 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1119; /* *movmisalignv2sf_neon_load */

        case E_DImode:
          if (!s_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !neon_permissive_struct_operand (operands[1], E_DImode)
              || !
#line 296 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1120; /* *movmisaligndi_neon_load */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode)
            return -1;
          if (neon_permissive_struct_operand (operands[1], E_V16QImode)
              && 
#line 313 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1128; /* *movmisalignv16qi_neon_load */
          if (!mve_memory_operand (operands[1], E_V16QImode)
              || !
#line 4568 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5062; /* movmisalignv16qi_mve_load */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode)
            return -1;
          if (neon_permissive_struct_operand (operands[1], E_V8HImode)
              && 
#line 313 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1129; /* *movmisalignv8hi_neon_load */
          if (!mve_memory_operand (operands[1], E_V8HImode)
              || !
#line 4568 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5063; /* movmisalignv8hi_mve_load */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode)
            return -1;
          if (neon_permissive_struct_operand (operands[1], E_V8HFmode)
              && 
#line 313 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1130; /* *movmisalignv8hf_neon_load */
          if (!mve_memory_operand (operands[1], E_V8HFmode)
              || !
#line 4568 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5065; /* movmisalignv8hf_mve_load */

        case E_V8BFmode:
          if (!s_register_operand (operands[0], E_V8BFmode)
              || GET_MODE (x3) != E_V8BFmode
              || !neon_permissive_struct_operand (operands[1], E_V8BFmode)
              || !
#line 313 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1131; /* *movmisalignv8bf_neon_load */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode)
            return -1;
          if (neon_permissive_struct_operand (operands[1], E_V4SImode)
              && 
#line 313 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1132; /* *movmisalignv4si_neon_load */
          if (!mve_memory_operand (operands[1], E_V4SImode)
              || !
#line 4568 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5064; /* movmisalignv4si_mve_load */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (neon_permissive_struct_operand (operands[1], E_V4SFmode)
              && 
#line 313 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1133; /* *movmisalignv4sf_neon_load */
          if (!mve_memory_operand (operands[1], E_V4SFmode)
              || !
#line 4568 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5066; /* movmisalignv4sf_mve_load */

        case E_V2DImode:
          if (!s_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !neon_permissive_struct_operand (operands[1], E_V2DImode)
              || !
#line 313 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1134; /* *movmisalignv2di_neon_load */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2308; /* neon_vqshluv8qi */

    case 1:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2312; /* neon_vqshluv16qi */

    case 2:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2316; /* neon_vqshluv4hi */

    case 3:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2320; /* neon_vqshluv8hi */

    case 4:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2324; /* neon_vqshluv2si */

    case 5:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2328; /* neon_vqshluv4si */

    case 6:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2332; /* neon_vqshludi */

    case 7:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2336; /* neon_vqshluv2di */

    default:
      return -1;
    }
}

 int
recog_180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0
          || !
#line 2603 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1799; /* neon_vabdv8hf */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 2603 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1800; /* neon_vabdv4hf */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 2613 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1801; /* neon_vabdfv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 2613 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1802; /* neon_vabdfv4sf */

    default:
      return -1;
    }
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern160 (x1, 
E_EImode))
    {
    case 0:
      if (!
#line 5633 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2828; /* neon_vld3v8qi */

    case 1:
      if (!
#line 5633 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2829; /* neon_vld3v4hi */

    case 2:
      if (!
#line 5633 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2830; /* neon_vld3v4hf */

    case 3:
      if (!(
#line 5633 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2831; /* neon_vld3v4bf */

    case 4:
      if (!
#line 5633 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2832; /* neon_vld3v2si */

    case 5:
      if (!
#line 5633 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2833; /* neon_vld3v2sf */

    case 6:
      if (!
#line 5633 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2834; /* neon_vld3di */

    default:
      return -1;
    }
}

 int
recog_200 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern164 (x1, 
E_XImode, 
E_OImode))
    {
    case 0:
      if (!
#line 6215 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2947; /* neon_vst4qbv16qi */

    case 1:
      if (!
#line 6215 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2948; /* neon_vst4qbv8hi */

    case 2:
      if (!
#line 6215 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2949; /* neon_vst4qbv8hf */

    case 3:
      if (!(
#line 6215 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2950; /* neon_vst4qbv8bf */

    case 4:
      if (!
#line 6215 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2951; /* neon_vst4qbv4si */

    case 5:
      if (!
#line 6215 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2952; /* neon_vst4qbv4sf */

    default:
      return -1;
    }
}

 int
recog_210 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern146 (x1))
    {
    case 0:
      if (!
#line 2713 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1859; /* neon_vpmaxfv4hf */

    case 1:
      if (!
#line 2776 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1893; /* neon_vpmaxsv8qi */

    case 2:
      if (!
#line 2776 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1897; /* neon_vpmaxsv4hi */

    case 3:
      if (!
#line 2776 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1901; /* neon_vpmaxsv2si */

    case 4:
      if (!
#line 2786 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1905; /* neon_vpmaxfv2sf */

    case 5:
      if (!
#line 2786 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1907; /* neon_vpmaxfv4sf */

    default:
      return -1;
    }
}

 int
recog_220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 0
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!
#line 2008 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
    return -1;
  *pnum_clobbers = 2;
  return 999; /* thumb1_casesi_dispatch */
}

 int
recog_227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern144 (x1))
    {
    case 0:
      if (!
#line 2516 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1760; /* neon_vcaltv2sf_insn_unspec */

    case 1:
      if (!
#line 2516 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1764; /* neon_vcaltv4sf_insn_unspec */

    case 2:
      if (!
#line 2557 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1776; /* neon_vcaltv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2557 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1780; /* neon_vcaltv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern140 (x1))
    {
    case 0:
      if (!
#line 2180 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1588; /* neon_vqdmulhv4hi */

    case 1:
      if (!
#line 2180 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1590; /* neon_vqdmulhv2si */

    case 2:
      if (!
#line 2180 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1592; /* neon_vqdmulhv8hi */

    case 3:
      if (!
#line 2180 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1594; /* neon_vqdmulhv4si */

    default:
      return -1;
    }
}

 int
recog_247 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern231 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !vpr_register_operand (operands[3], E_V16BImode)
          || !
#line 3354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4864; /* mve_vstrq_scatter_offset_p_v16qi */

    case E_V8HImode:
      switch (pattern533 ())
        {
        case 0:
          if (!
#line 3354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
            return -1;
          return 4865; /* mve_vstrq_scatter_offset_p_v8hi */

        case 1:
          if (!
#line 3354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
            return -1;
          return 4867; /* mve_vstrq_scatter_offset_p_v8hf */

        default:
          return -1;
        }

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode))
        return -1;
      switch (pattern552 ())
        {
        case 0:
          if (!
#line 3354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
            return -1;
          return 4866; /* mve_vstrq_scatter_offset_p_v4si */

        case 1:
          if (!
#line 3354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
            return -1;
          return 4868; /* mve_vstrq_scatter_offset_p_v4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!s_register_operand (operands[1], E_V2DImode)
          || !s_register_operand (operands[2], E_V2DImode)
          || !vpr_register_operand (operands[3], E_V2QImode)
          || !
#line 3354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4869; /* mve_vstrq_scatter_offset_p_v2di */

    default:
      return -1;
    }
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!
#line 3984 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2199; /* neon_vqrdmlsh_lanev8hi */

    case 1:
      if (!
#line 3984 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2201; /* neon_vqrdmlsh_lanev4si */

    case 2:
      if (!
#line 4000 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2203; /* neon_vqrdmlsh_lanev4hi */

    case 3:
      if (!
#line 4000 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2205; /* neon_vqrdmlsh_lanev2si */

    default:
      return -1;
    }
}

 int
recog_267 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 2);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[3] = x5;
      if (const_int_operand (operands[3], E_SImode)
          && pattern461 (x1) == 0)
        {
          x6 = XEXP (x2, 1);
          operands[4] = x6;
          if (arm_not_operand (operands[4], E_SImode)
              && 
#line 3182 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)
   && !reg_overlap_mentioned_p (operands[0], operands[4])))
            {
              *pnum_clobbers = 1;
              return 96; /* *ite_ne_zeroextractsi */
            }
        }
      if (XWINT (x5, 0) != 0LL
          || pattern461 (x1) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      if (!arm_not_operand (operands[3], E_SImode)
          || !
#line 3221 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && !reg_overlap_mentioned_p (operands[0], operands[3])))
        return -1;
      *pnum_clobbers = 1;
      return 97; /* *ite_ne_zeroextractsi_shifted */

    case EQ:
      x7 = XEXP (x3, 1);
      if (pattern317 (x7, 
41) != 0)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != PC)
        return -1;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != PC)
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (!guard_addr_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x6, 0);
      operands[2] = x12;
      *pnum_clobbers = 3;
      return 310; /* *stack_protect_combined_test_insn */

    default:
      return -1;
    }
}

 int
recog_274 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers != NULL)
        {
          res = recog_271 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (cc_register (x4, E_VOIDmode))
        {
          res = recog_272 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_273 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[6] = x4;
      if (!cc_register (operands[6], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      operands[4] = x3;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          operands[5] = x7;
          if (!shiftable_operator (operands[5], E_SImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[3] = x9;
          if (!arm_rhs_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x2, 2);
          operands[1] = x10;
          if (!arm_rhs_operand (operands[1], E_SImode)
              || !
#line 11036 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 359; /* *if_arith_move */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x7;
          if (!arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x2, 2);
          if (!shiftable_operator (x10, E_SImode))
            return -1;
          operands[5] = x10;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!arm_rhs_operand (operands[3], E_SImode)
              || !
#line 11103 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 361; /* *if_move_arith */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x10 = XEXP (x2, 2);
      if (GET_CODE (x10) != PC)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      operands[3] = x3;
      x13 = XEXP (x4, 0);
      operands[1] = x13;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x14 = XEXP (x4, 1);
      operands[2] = x14;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (!
#line 1661 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (GET_CODE (operands[3]) == EQ
       || GET_CODE (operands[3]) == NE
       || GET_CODE (operands[3]) == GE
       || GET_CODE (operands[3]) == LT)))
        return -1;
      *pnum_clobbers = 1;
      return 983; /* *addsi3_cbranch_scratch */

    default:
      return -1;
    }
}

 int
recog_280 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
          if (XWINT (x4, 0) == 0LL
              && s_register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && s_register_operand (operands[1], E_SImode)
              && 
#line 4127 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 120; /* *smin_0 */
          break;

        case REG:
        case SUBREG:
          switch (pattern348 (x2))
            {
            case 0:
              if (register_operand (operands[0], E_V2SImode)
                  && register_operand (operands[1], E_V2SImode)
                  && register_operand (operands[2], E_V2SImode)
                  && 
#line 923 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 609; /* *sminv2si3_iwmmxt */
              if (s_register_operand (operands[0], E_V2SImode)
                  && s_register_operand (operands[1], E_V2SImode)
                  && s_register_operand (operands[2], E_V2SImode)
                  && 
#line 879 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1359; /* *sminv2si3_neon */
              break;

            case 1:
              if (register_operand (operands[0], E_V4HImode)
                  && register_operand (operands[1], E_V4HImode)
                  && register_operand (operands[2], E_V4HImode)
                  && 
#line 923 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 610; /* *sminv4hi3_iwmmxt */
              if (s_register_operand (operands[0], E_V4HImode)
                  && s_register_operand (operands[1], E_V4HImode)
                  && s_register_operand (operands[2], E_V4HImode)
                  && 
#line 879 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1357; /* *sminv4hi3_neon */
              break;

            case 2:
              if (register_operand (operands[0], E_V8QImode)
                  && register_operand (operands[1], E_V8QImode)
                  && register_operand (operands[2], E_V8QImode)
                  && 
#line 923 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 611; /* *sminv8qi3_iwmmxt */
              if (s_register_operand (operands[0], E_V8QImode)
                  && s_register_operand (operands[1], E_V8QImode)
                  && s_register_operand (operands[2], E_V8QImode)
                  && 
#line 879 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1355; /* *sminv8qi3_neon */
              break;

            case 3:
              if (
#line 2080 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
                return 917; /* sminsf3 */
              break;

            case 4:
              if ((
#line 2080 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return 918; /* smindf3 */
              break;

            case 5:
              if (
#line 879 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1356; /* *sminv16qi3_neon */
              if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3615; /* mve_vminq_sv16qi */
              break;

            case 6:
              if (
#line 879 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1358; /* *sminv8hi3_neon */
              if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3619; /* mve_vminq_sv8hi */
              break;

            case 7:
              if (
#line 879 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1360; /* *sminv4si3_neon */
              if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3623; /* mve_vminq_sv4si */
              break;

            case 8:
              if (
#line 879 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1361; /* *sminv2sf3_neon */
              break;

            case 9:
              if (
#line 879 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1362; /* *sminv4sf3_neon */
              if (
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return 3797; /* mve_vminnmq_fv4sf */
              break;

            case 10:
              if (
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return 3795; /* mve_vminnmq_fv8hf */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || pattern349 (x2) != 0
          || !
#line 4138 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 121; /* *arm_smin_insn */

    case SMAX:
      switch (pattern270 (x2))
        {
        case 0:
          if (!
#line 4477 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL)))
            return -1;
          return 133; /* satsi_smin */

        case 1:
          if (!
#line 4503 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL)))
            return -1;
          return 137; /* *satsi_smin_shift */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern271 (x2))
        {
        case 0:
          if (!
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1417; /* quad_halves_sminv4si */

        case 1:
          if (!
#line 1142 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 1422; /* quad_halves_sminv4sf */

        case 2:
          if (!
#line 1157 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1425; /* quad_halves_sminv8hi */

        case 3:
          if (!
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1430; /* quad_halves_sminv16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[2] = x4;
      if (arm_borrow_operation (operands[2], E_SImode)
          && s_register_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode
          && s_register_operand (operands[1], E_SImode)
          && 
#line 1817 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return 40; /* *subsi3_carryin_const0 */
      if (pnum_clobbers == NULL)
        return -1;
      operands[4] = x4;
      if (!arm_comparison_operator (operands[4], E_SImode)
          || pattern432 (x2) != 0)
        return -1;
      if (
#line 10136 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
        {
          *pnum_clobbers = 1;
          return 339; /* *cond_sub */
        }
      if (!
#line 868 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1038; /* *thumb2_cond_sub */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !reg_or_int_operand (operands[1], E_SImode)
              || !reg_or_int_operand (operands[2], E_SImode)
              || !
#line 2020 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 45; /* *arm_subsi3_insn */

        case E_V2SImode:
          if (GET_MODE (x2) != E_V2SImode)
            return -1;
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 411 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 561; /* *subv2si3_iwmmxt */
          if (!s_register_operand (operands[0], E_V2SImode)
              || !s_register_operand (operands[1], E_V2SImode)
              || !s_register_operand (operands[2], E_V2SImode)
              || !
#line 531 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SI_ARITH))
            return -1;
          return 1174; /* *subv2si3_neon */

        case E_V4HImode:
          if (GET_MODE (x2) != E_V4HImode)
            return -1;
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 411 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 562; /* *subv4hi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V4HImode)
              || !s_register_operand (operands[1], E_V4HImode)
              || !s_register_operand (operands[2], E_V4HImode)
              || !
#line 531 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HI_ARITH))
            return -1;
          return 1172; /* *subv4hi3_neon */

        case E_V8QImode:
          if (GET_MODE (x2) != E_V8QImode)
            return -1;
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 411 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 563; /* *subv8qi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V8QImode)
              || !s_register_operand (operands[1], E_V8QImode)
              || !s_register_operand (operands[2], E_V8QImode)
              || !
#line 531 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8QI_ARITH))
            return -1;
          return 1170; /* *subv8qi3_neon */

        case E_HFmode:
          if (pattern1 (x2, 
E_HFmode) != 0
              || !
#line 1028 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 798; /* subhf3 */

        case E_SFmode:
          if (pattern1 (x2, 
E_SFmode) != 0
              || !
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 799; /* *subsf3_vfp */

        case E_DFmode:
          if (pattern1 (x2, 
E_DFmode) != 0
              || !
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 800; /* *subdf3_vfp */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern347 (x2, 
E_DImode) != 0
              || !
#line 132 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          *pnum_clobbers = 1;
          return 943; /* *thumb_subdi3 */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0)
            return -1;
          if (
#line 531 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V16QI_ARITH))
            return 1171; /* *subv16qi3_neon */
          if (!
#line 991 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3671; /* mve_vsubqv16qi */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0)
            return -1;
          if (
#line 531 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HI_ARITH))
            return 1173; /* *subv8hi3_neon */
          if (!
#line 991 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3674; /* mve_vsubqv8hi */

        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0)
            return -1;
          if (
#line 531 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SI_ARITH))
            return 1175; /* *subv4si3_neon */
          if (!
#line 991 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3677; /* mve_vsubqv4si */

        case E_V4HFmode:
          if (pattern1 (x2, 
E_V4HFmode) != 0
              || !
#line 531 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HF_ARITH))
            return -1;
          return 1176; /* *subv4hf3_neon */

        case E_V8HFmode:
          if (pattern1 (x2, 
E_V8HFmode) != 0)
            return -1;
          if (
#line 531 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HF_ARITH))
            return 1177; /* *subv8hf3_neon */
          if (!
#line 1399 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3829; /* mve_vsubq_fv8hf */

        case E_V2SFmode:
          if (pattern1 (x2, 
E_V2SFmode) != 0
              || !
#line 531 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 1178; /* *subv2sf3_neon */

        case E_V4SFmode:
          if (pattern1 (x2, 
E_V4SFmode) != 0)
            return -1;
          if (
#line 531 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return 1179; /* *subv4sf3_neon */
          if (!
#line 1399 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3832; /* mve_vsubq_fv4sf */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 531 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2DI_ARITH))
            return -1;
          return 1180; /* *subv2di3_neon */

        case E_QQmode:
          if (pattern1 (x2, 
E_QQmode) != 0
              || !
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3208; /* subqq3 */

        case E_HQmode:
          if (pattern1 (x2, 
E_HQmode) != 0
              || !
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3209; /* subhq3 */

        case E_SQmode:
          if (pattern1 (x2, 
E_SQmode) != 0
              || !
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3210; /* subsq3 */

        case E_UQQmode:
          if (pattern1 (x2, 
E_UQQmode) != 0
              || !
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3211; /* subuqq3 */

        case E_UHQmode:
          if (pattern1 (x2, 
E_UHQmode) != 0
              || !
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3212; /* subuhq3 */

        case E_USQmode:
          if (pattern1 (x2, 
E_USQmode) != 0
              || !
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3213; /* subusq3 */

        case E_HAmode:
          if (pattern1 (x2, 
E_HAmode) != 0
              || !
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3214; /* subha3 */

        case E_SAmode:
          if (pattern1 (x2, 
E_SAmode) != 0
              || !
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3215; /* subsa3 */

        case E_UHAmode:
          if (pattern1 (x2, 
E_UHAmode) != 0
              || !
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3216; /* subuha3 */

        case E_USAmode:
          if (pattern1 (x2, 
E_USAmode) != 0
              || !
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3217; /* subusa3 */

        case E_V4QQmode:
          if (pattern1 (x2, 
E_V4QQmode) != 0
              || !
#line 105 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ))
            return -1;
          return 3218; /* *arm_subv4qq3 */

        case E_V2HQmode:
          if (pattern1 (x2, 
E_V2HQmode) != 0
              || !
#line 105 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ))
            return -1;
          return 3219; /* *arm_subv2hq3 */

        case E_V2HAmode:
          if (pattern1 (x2, 
E_V2HAmode) != 0
              || !
#line 105 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ))
            return -1;
          return 3220; /* *arm_subv2ha3 */

        default:
          return -1;
        }

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      if (GET_CODE (x4) == MULT)
        {
          res = recog_285 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[2] = x4;
      if (!shift_operator (operands[2], E_SImode)
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[4] = x6;
      if (!shift_amount_operand (operands[4], E_SImode)
          || !
#line 9767 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 331; /* *sub_shiftsi */

    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      if (pnum_clobbers == NULL)
        return -1;
      operands[4] = x4;
      if (!minmax_operator (operands[4], E_SImode)
          || pattern432 (x2) != 0
          || !
#line 4301 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1])
   && !(arm_restrict_it && CONST_INT_P (operands[3]))))
        return -1;
      *pnum_clobbers = 1;
      return 126; /* *minmax_arithsi_non_canon */

    case PLUS:
      if (pattern357 (x4, 
SIGN_EXTEND, 
E_DImode, 
MULT) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      x7 = XEXP (x5, 0);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != VEC_SELECT
          || GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x10 = XVECEXP (x9, 0, 0);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XEXP (x5, 1);
      if (pattern536 (x11, 
E_HImode, 
E_DImode, 
SIGN_EXTEND) != 0)
        return -1;
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (GET_CODE (x13) != PARALLEL
          || XVECLEN (x13, 0) != 1)
        return -1;
      x14 = XVECEXP (x13, 0, 0);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != MULT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x15 = XEXP (x6, 0);
      if (GET_CODE (x15) != SIGN_EXTEND
          || pattern540 (x6, 
E_HImode) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      switch (pattern650 (x4))
        {
        case 0:
          if (!
#line 657 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 728; /* iwmmxt_wmiabbn */

        case 1:
          if (!
#line 681 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 729; /* iwmmxt_wmiabtn */

        case 2:
          if (!
#line 705 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 730; /* iwmmxt_wmiatbn */

        case 3:
          if (!
#line 729 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 731; /* iwmmxt_wmiattn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_289 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != AND
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (!s_register_operand (x5, E_SImode)
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x3, 1);
          if (!const_int_operand (x6, E_VOIDmode))
            return -1;
          x7 = XEXP (x4, 1);
          if (!const_int_operand (x7, E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 0);
          switch (GET_CODE (x8))
            {
            case ASHIFT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[1] = x5;
              operands[2] = x6;
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x10 = XEXP (x8, 1);
              operands[4] = x10;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              operands[5] = x7;
              if (!
#line 3539 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[4]) < 32
   && UINTVAL (operands[2]) == ~UINTVAL (operands[5])
   && (exact_log2 (UINTVAL (operands[5])
		   + (HOST_WIDE_INT_1U << UINTVAL (operands[4])))
       >= 0)))
                return -1;
              return 100; /* *bfi */

            case REG:
            case SUBREG:
              operands[3] = x8;
              if (s_register_operand (operands[3], E_SImode))
                {
                  operands[1] = x5;
                  operands[2] = x6;
                  operands[4] = x7;
                  if (
#line 3577 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[2]) == ~UINTVAL (operands[4])
   && exact_log2 (UINTVAL (operands[4]) + 1) >= 0))
                    return 102; /* *bfi_alt2 */
                }
              operands[1] = x8;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              operands[3] = x5;
              operands[4] = x6;
              operands[2] = x7;
              if (!
#line 3592 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[2]) == ~UINTVAL (operands[4])
   && exact_log2 (UINTVAL (operands[4]) + 1) >= 0))
                return -1;
              return 103; /* *bfi_alt3 */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x11 = XEXP (x5, 1);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          operands[4] = x11;
          if (const_int_operand (operands[4], E_VOIDmode)
              && s_register_operand (operands[0], E_SImode))
            {
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              if (s_register_operand (operands[3], E_SImode))
                {
                  x6 = XEXP (x3, 1);
                  operands[5] = x6;
                  if (const_int_operand (operands[5], E_VOIDmode))
                    {
                      x8 = XEXP (x4, 0);
                      operands[1] = x8;
                      if (s_register_operand (operands[1], E_SImode))
                        {
                          x7 = XEXP (x4, 1);
                          operands[2] = x7;
                          if (const_int_operand (operands[2], E_VOIDmode)
                              && 
#line 3559 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[4]) < 32
   && UINTVAL (operands[2]) == ~UINTVAL (operands[5])
   && (exact_log2 (UINTVAL (operands[5])
		   + (HOST_WIDE_INT_1U << UINTVAL (operands[4])))
       >= 0)))
                            return 101; /* *bfi_alt1 */
                        }
                    }
                }
            }
          if (XWINT (x11, 0) != 8LL
              || pattern487 (x2, 
LSHIFTRT) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x4, 0);
          x9 = XEXP (x8, 0);
          if (!rtx_equal_p (x9, operands[1])
              || !
#line 12592 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch6
   && aarch_rev16_shleft_mask_imm_p (operands[3], SImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], SImode)))
            return -1;
          return 414; /* arm_rev16si2_alt1 */

        case LSHIFTRT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x11 = XEXP (x5, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || pattern487 (x2, 
ASHIFT) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x4, 0);
          x9 = XEXP (x8, 0);
          if (!rtx_equal_p (x9, operands[1])
              || !
#line 12613 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch6
   && aarch_rev16_shleft_mask_imm_p (operands[3], SImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], SImode)))
            return -1;
          return 415; /* *arm_rev16si2_alt2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern371 (x2) != 0
              || !
#line 3737 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 110; /* *iorsi3_insn */

        case E_DImode:
          if (pattern347 (x2, 
E_DImode) != 0
              || !
#line 61 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 533; /* iwmmxt_iordi3 */

        case E_V2SImode:
          if (GET_MODE (x2) != E_V2SImode)
            return -1;
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 546; /* *iorv2si3_iwmmxt */
          if (!s_register_operand (operands[0], E_V2SImode)
              || !s_register_operand (operands[1], E_V2SImode)
              || !neon_logic_op2 (operands[2], E_V2SImode)
              || !
#line 727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1247; /* iorv2si3_neon */

        case E_V4HImode:
          if (GET_MODE (x2) != E_V4HImode)
            return -1;
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 547; /* *iorv4hi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V4HImode)
              || !s_register_operand (operands[1], E_V4HImode)
              || !neon_logic_op2 (operands[2], E_V4HImode)
              || !
#line 727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1245; /* iorv4hi3_neon */

        case E_V8QImode:
          if (GET_MODE (x2) != E_V8QImode)
            return -1;
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 548; /* *iorv8qi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V8QImode)
              || !s_register_operand (operands[1], E_V8QImode)
              || !neon_logic_op2 (operands[2], E_V8QImode)
              || !
#line 727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1243; /* iorv8qi3_neon */

        case E_V16QImode:
          if (pattern372 (x2, 
E_V16QImode) != 0)
            return -1;
          if (
#line 727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1244; /* iorv16qi3_neon */
          if (!
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3682; /* mve_vorrq_sv16qi */

        case E_V8HImode:
          if (pattern372 (x2, 
E_V8HImode) != 0)
            return -1;
          if (
#line 727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1246; /* iorv8hi3_neon */
          if (!
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3683; /* mve_vorrq_sv8hi */

        case E_V4SImode:
          if (pattern372 (x2, 
E_V4SImode) != 0)
            return -1;
          if (
#line 727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1248; /* iorv4si3_neon */
          if (!
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3684; /* mve_vorrq_sv4si */

        case E_V4HFmode:
          if (pattern372 (x2, 
E_V4HFmode) != 0
              || !
#line 727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1249; /* iorv4hf3_neon */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x2) != E_V8HFmode
              || !s_register_operand (operands[1], E_V8HFmode))
            return -1;
          if (neon_logic_op2 (operands[2], E_V8HFmode)
              && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1250; /* iorv8hf3_neon */
          if (!s_register_operand (operands[2], E_V8HFmode)
              || !
#line 1429 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3836; /* mve_vorrq_fv8hf */

        case E_V2SFmode:
          if (pattern372 (x2, 
E_V2SFmode) != 0
              || !
#line 727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1251; /* iorv2sf3_neon */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !s_register_operand (operands[1], E_V4SFmode))
            return -1;
          if (neon_logic_op2 (operands[2], E_V4SFmode)
              && 
#line 727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1252; /* iorv4sf3_neon */
          if (!s_register_operand (operands[2], E_V4SFmode)
              || !
#line 1429 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3837; /* mve_vorrq_fv4sf */

        case E_V2DImode:
          if (pattern372 (x2, 
E_V2DImode) != 0
              || !
#line 727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1253; /* iorv2di3_neon */

        default:
          return -1;
        }

    case MULT:
      if (pattern275 (x2) != 0
          || !
#line 9686 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 321; /* *orr_multsi */

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x3;
      if (pattern304 (x2) == 0
          && 
#line 9700 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT))
        return 326; /* *orr_shiftsi */
      if (GET_CODE (x3) != ASHIFT
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != MINUS
          || GET_MODE (x6) != E_SImode)
        return -1;
      x13 = XEXP (x6, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      x14 = XEXP (x6, 1);
      if (GET_CODE (x14) != MULT
          || GET_MODE (x14) != E_SImode)
        return -1;
      x15 = XEXP (x14, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != LSHIFTRT
          || GET_MODE (x4) != E_DImode)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != ASHIFT
          || GET_MODE (x8) != E_DImode)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != MULT
          || GET_MODE (x10) != E_SImode)
        return -1;
      x16 = XEXP (x10, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != MULT
          || GET_MODE (x7) != E_SImode)
        return -1;
      x17 = XEXP (x7, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      x18 = XEXP (x14, 0);
      operands[3] = x18;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x19 = XEXP (x10, 0);
      if (!rtx_equal_p (x19, operands[3]))
        return -1;
      x20 = XEXP (x7, 0);
      if (!rtx_equal_p (x20, operands[3])
          || !
#line 858 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 740; /* iwmmxt_wmerge */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      if (pattern305 (x2) == 0
          && 
#line 9844 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
        return 335; /* *ior_scc */
      if (pnum_clobbers == NULL
          || pattern306 (x2) != 0
          || !
#line 10494 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_OR_Y)
       != CCmode)))
        return -1;
      *pnum_clobbers = 1;
      return 344; /* *ior_scc_scc */

    case NOT:
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern397 (x2, 
E_SImode) != 0
                  || !
#line 1534 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return -1;
              return 1068; /* *orsi_notsi_si */

            case E_V8QImode:
              if (pattern397 (x2, 
E_V8QImode) != 0
                  || !
#line 766 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1265; /* ornv8qi3_neon */

            case E_V16QImode:
              if (pattern397 (x2, 
E_V16QImode) != 0)
                return -1;
              if (
#line 766 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1266; /* ornv16qi3_neon */
              if (!
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3679; /* mve_vornq_sv16qi */

            case E_V4HImode:
              if (pattern397 (x2, 
E_V4HImode) != 0
                  || !
#line 766 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1267; /* ornv4hi3_neon */

            case E_V8HImode:
              if (pattern397 (x2, 
E_V8HImode) != 0)
                return -1;
              if (
#line 766 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1268; /* ornv8hi3_neon */
              if (!
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3680; /* mve_vornq_sv8hi */

            case E_V2SImode:
              if (pattern397 (x2, 
E_V2SImode) != 0
                  || !
#line 766 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1269; /* ornv2si3_neon */

            case E_V4SImode:
              if (pattern397 (x2, 
E_V4SImode) != 0)
                return -1;
              if (
#line 766 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1270; /* ornv4si3_neon */
              if (!
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3681; /* mve_vornq_sv4si */

            case E_V4HFmode:
              if (pattern397 (x2, 
E_V4HFmode) != 0
                  || !
#line 766 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1271; /* ornv4hf3_neon */

            case E_V8HFmode:
              if (pattern397 (x2, 
E_V8HFmode) != 0)
                return -1;
              if (
#line 766 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1272; /* ornv8hf3_neon */
              if (!
#line 1414 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3834; /* mve_vornq_fv8hf */

            case E_V2SFmode:
              if (pattern397 (x2, 
E_V2SFmode) != 0
                  || !
#line 766 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1273; /* ornv2sf3_neon */

            case E_V4SFmode:
              if (pattern397 (x2, 
E_V4SFmode) != 0)
                return -1;
              if (
#line 766 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1274; /* ornv4sf3_neon */
              if (!
#line 1414 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3835; /* mve_vornq_fv4sf */

            case E_V2DImode:
              if (pattern397 (x2, 
E_V2DImode) != 0
                  || !
#line 766 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1275; /* ornv2di3_neon */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[4] = x5;
          if (!shift_operator (operands[4], E_SImode)
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          x12 = XEXP (x5, 0);
          operands[2] = x12;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x5, 1);
          operands[3] = x11;
          if (!const_int_operand (operands[3], E_SImode)
              || !s_register_operand (operands[1], E_SImode)
              || !
#line 1546 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          return 1069; /* *orsi_not_shiftsi_si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (GET_MODE (x3) != E_V8QImode
              || !s_register_operand (operands[1], E_QImode))
            return -1;
          if (register_operand (operands[0], E_V8QImode)
              && 
#line 33 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 530; /* tbcstv8qi */
          if (!s_register_operand (operands[0], E_V8QImode)
              || !
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2054; /* neon_vdup_nv8qi */

        case E_V4HImode:
          if (GET_MODE (x3) != E_V4HImode
              || !s_register_operand (operands[1], E_HImode))
            return -1;
          if (register_operand (operands[0], E_V4HImode)
              && 
#line 42 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 531; /* tbcstv4hi */
          if (!s_register_operand (operands[0], E_V4HImode)
              || !
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2055; /* neon_vdup_nv4hi */

        case E_V2SImode:
          if (GET_MODE (x3) != E_V2SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          if (register_operand (operands[0], E_V2SImode)
              && 
#line 51 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 532; /* tbcstv2si */
          if (!s_register_operand (operands[0], E_V2SImode)
              || !
#line 3494 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2062; /* neon_vdup_nv2si */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !s_register_operand (operands[1], E_QImode))
            return -1;
          if (
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 2056; /* neon_vdup_nv16qi */
          if (!
#line 104 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3247; /* mve_vdupq_nv16qi */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !s_register_operand (operands[1], E_HImode))
            return -1;
          if (
#line 3454 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 2057; /* neon_vdup_nv8hi */
          if (!
#line 104 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3248; /* mve_vdupq_nv8hi */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !s_register_operand (operands[1], E_HFmode)
              || !
#line 3462 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2058; /* neon_vdup_nv4hf */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !s_register_operand (operands[1], E_HFmode))
            return -1;
          if (
#line 3470 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 2059; /* neon_vdup_nv8hf */
          if (!
#line 104 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3250; /* mve_vdupq_nv8hf */

        case E_V4BFmode:
          if (!s_register_operand (operands[0], E_V4BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !s_register_operand (operands[1], E_BFmode)
              || !
#line 3478 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2060; /* neon_vdup_nv4bf */

        case E_V8BFmode:
          if (!s_register_operand (operands[0], E_V8BFmode)
              || GET_MODE (x3) != E_V8BFmode
              || !s_register_operand (operands[1], E_BFmode)
              || !
#line 3486 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2061; /* neon_vdup_nv8bf */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !s_register_operand (operands[1], E_SFmode)
              || !
#line 3494 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2063; /* neon_vdup_nv2sf */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          if (
#line 3494 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 2064; /* neon_vdup_nv4si */
          if (!
#line 104 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3249; /* mve_vdupq_nv4si */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !s_register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 3494 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 2065; /* neon_vdup_nv4sf */
          if (!
#line 104 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3251; /* mve_vdupq_nv4sf */

        case E_V2DImode:
          if (!s_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !s_register_operand (operands[1], E_DImode)
              || !
#line 3514 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2066; /* neon_vdup_nv2di */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern435 (x3, 
E_V8QImode, 
E_QImode) != 0
              || !
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2067; /* neon_vdup_lanev8qi_internal */

        case E_V16QImode:
          if (pattern436 (x3, 
E_V16QImode, 
E_V8QImode, 
E_QImode) != 0
              || !
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2068; /* neon_vdup_lanev16qi_internal */

        case E_V4HImode:
          if (pattern435 (x3, 
E_V4HImode, 
E_HImode) != 0
              || !
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2069; /* neon_vdup_lanev4hi_internal */

        case E_V8HImode:
          if (pattern436 (x3, 
E_V8HImode, 
E_V4HImode, 
E_HImode) != 0
              || !
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2070; /* neon_vdup_lanev8hi_internal */

        case E_V2SImode:
          if (pattern435 (x3, 
E_V2SImode, 
E_SImode) != 0
              || !
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2071; /* neon_vdup_lanev2si_internal */

        case E_V4SImode:
          if (pattern436 (x3, 
E_V4SImode, 
E_V2SImode, 
E_SImode) != 0
              || !
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2072; /* neon_vdup_lanev4si_internal */

        case E_V2SFmode:
          if (pattern435 (x3, 
E_V2SFmode, 
E_SFmode) != 0
              || !
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2073; /* neon_vdup_lanev2sf_internal */

        case E_V4SFmode:
          if (pattern436 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_SFmode) != 0
              || !
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2074; /* neon_vdup_lanev4sf_internal */

        case E_V8HFmode:
          if (pattern436 (x3, 
E_V8HFmode, 
E_V4HFmode, 
E_HFmode) != 0
              || !
#line 3550 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && (TARGET_FP16 || TARGET_BF16_SIMD)))
            return -1;
          return 2075; /* neon_vdup_lanev8hf_internal */

        case E_V4HFmode:
          if (pattern435 (x3, 
E_V4HFmode, 
E_HFmode) != 0
              || !
#line 3550 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && (TARGET_FP16 || TARGET_BF16_SIMD)))
            return -1;
          return 2076; /* neon_vdup_lanev4hf_internal */

        case E_V4BFmode:
          if (pattern436 (x3, 
E_V4BFmode, 
E_V4BFmode, 
E_BFmode) != 0
              || !
#line 3550 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && (TARGET_FP16 || TARGET_BF16_SIMD)))
            return -1;
          return 2077; /* neon_vdup_lanev4bf_internal */

        case E_V8BFmode:
          if (pattern436 (x3, 
E_V8BFmode, 
E_V4BFmode, 
E_BFmode) != 0
              || !
#line 3550 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && (TARGET_FP16 || TARGET_BF16_SIMD)))
            return -1;
          return 2078; /* neon_vdup_lanev8bf_internal */

        default:
          return -1;
        }

    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !neon_struct_operand (operands[1], E_QImode)
              || !
#line 5177 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2634; /* neon_vld1_dupv8qi */

        case E_V4HImode:
          if (!s_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !neon_struct_operand (operands[1], E_HImode)
              || !
#line 5177 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2635; /* neon_vld1_dupv4hi */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !neon_struct_operand (operands[1], E_HFmode)
              || !
#line 5177 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2636; /* neon_vld1_dupv4hf */

        case E_V4BFmode:
          if (!s_register_operand (operands[0], E_V4BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !neon_struct_operand (operands[1], E_BFmode)
              || !
#line 5177 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2637; /* neon_vld1_dupv4bf */

        case E_V2SImode:
          if (!s_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !neon_struct_operand (operands[1], E_SImode)
              || !
#line 5177 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2638; /* neon_vld1_dupv2si */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !neon_struct_operand (operands[1], E_SFmode)
              || !
#line 5177 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2639; /* neon_vld1_dupv2sf */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !neon_struct_operand (operands[1], E_QImode)
              || !
#line 5194 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2640; /* neon_vld1_dupv16qi */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !neon_struct_operand (operands[1], E_HImode)
              || !
#line 5194 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2641; /* neon_vld1_dupv8hi */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !neon_struct_operand (operands[1], E_HFmode)
              || !
#line 5194 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2642; /* neon_vld1_dupv8hf */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !neon_struct_operand (operands[1], E_SImode)
              || !
#line 5194 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2643; /* neon_vld1_dupv4si */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !neon_struct_operand (operands[1], E_SFmode)
              || !
#line 5194 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2644; /* neon_vld1_dupv4sf */

        case E_V2DImode:
          if (!s_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !neon_struct_operand (operands[1], E_DImode)
              || !
#line 5204 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2645; /* neon_vld1_dupv2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers == NULL
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          if (
#line 5255 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            {
              *pnum_clobbers = 1;
              return 171; /* *arm_abssi2 */
            }
          if (
#line 334 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            {
              *pnum_clobbers = 1;
              return 957; /* *thumb1_abssi2 */
            }
          if (!
#line 117 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          *pnum_clobbers = 1;
          return 1011; /* *thumb2_abssi2 */

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !s_register_operand (operands[1], E_SFmode)
              || !
#line 872 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 782; /* *abssf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !
#line 881 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 783; /* *absdf2_vfp */

        case E_HFmode:
          if (!s_register_operand (operands[0], E_HFmode)
              || GET_MODE (x3) != E_HFmode
              || !s_register_operand (operands[1], E_HFmode)
              || !
#line 949 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 786; /* abshf2 */

        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !s_register_operand (operands[1], E_V8QImode)
              || !
#line 800 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1309; /* neon_absv8qi2 */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !s_register_operand (operands[1], E_V16QImode))
            return -1;
          if (
#line 800 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1310; /* neon_absv16qi2 */
          if (!
#line 280 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3292; /* mve_vabsq_sv16qi */

        case E_V4HImode:
          if (!s_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !s_register_operand (operands[1], E_V4HImode)
              || !
#line 800 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1311; /* neon_absv4hi2 */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !s_register_operand (operands[1], E_V8HImode))
            return -1;
          if (
#line 800 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1312; /* neon_absv8hi2 */
          if (!
#line 280 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3294; /* mve_vabsq_sv8hi */

        case E_V2SImode:
          if (!s_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !s_register_operand (operands[1], E_V2SImode)
              || !
#line 800 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1313; /* neon_absv2si2 */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !s_register_operand (operands[1], E_V4SImode))
            return -1;
          if (
#line 800 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1314; /* neon_absv4si2 */
          if (!
#line 280 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3296; /* mve_vabsq_sv4si */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !s_register_operand (operands[1], E_V2SFmode)
              || !
#line 800 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1315; /* neon_absv2sf2 */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !s_register_operand (operands[1], E_V4SFmode))
            return -1;
          if (
#line 800 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1316; /* neon_absv4sf2 */
          if (!
#line 189 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3273; /* mve_vabsq_fv4sf */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !s_register_operand (operands[1], E_V8HFmode))
            return -1;
          if (
#line 822 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return 1325; /* neon_absv8hf2 */
          if (!
#line 189 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3271; /* mve_vabsq_fv8hf */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !s_register_operand (operands[1], E_V4HFmode)
              || !
#line 822 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1327; /* neon_absv4hf2 */

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HFmode:
          if (pattern281 (x3, 
E_V4HFmode) != 0
              || !(
#line 6602 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HF_ARITH) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
            return -1;
          return 3012; /* neon_vabdv4hf_2 */

        case E_V8HFmode:
          if (pattern281 (x3, 
E_V8HFmode) != 0
              || !(
#line 6602 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HF_ARITH) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
            return -1;
          return 3013; /* neon_vabdv8hf_2 */

        case E_V2SFmode:
          if (pattern281 (x3, 
E_V2SFmode) != 0
              || !
#line 6602 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 3014; /* neon_vabdv2sf_2 */

        case E_V4SFmode:
          if (pattern281 (x3, 
E_V4SFmode) != 0
              || !
#line 6602 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 3015; /* neon_vabdv4sf_2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 336)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HFmode:
          if (pattern400 (x3, 
E_V4HFmode) != 0
              || !(
#line 6612 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HF_ARITH) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
            return -1;
          return 3016; /* neon_vabdv4hf_3 */

        case E_V8HFmode:
          if (pattern400 (x3, 
E_V8HFmode) != 0
              || !(
#line 6612 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HF_ARITH) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
            return -1;
          return 3017; /* neon_vabdv8hf_3 */

        case E_V2SFmode:
          if (pattern400 (x3, 
E_V2SFmode) != 0
              || !
#line 6612 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 3018; /* neon_vabdv2sf_3 */

        case E_V4SFmode:
          if (pattern400 (x3, 
E_V4SFmode) != 0
              || !
#line 6612 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 3019; /* neon_vabdv4sf_3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_315 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      switch (pattern243 (x3))
        {
        case 0:
          if (!memory_operand (operands[1], E_HImode)
              || !
#line 5036 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(unaligned_access && TARGET_32BIT))
            return -1;
          return 159; /* unaligned_loadhis */

        case 1:
          if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
            return -1;
          return 4885; /* mve_vldrq_gather_offset_extend_v8qis */

        case 2:
          if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4887; /* mve_vldrq_gather_offset_extend_v4qis */

        case 3:
          if (!
#line 3457 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4889; /* mve_vldrq_gather_offset_extend_v4his */

        case 4:
          if (!
#line 3600 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4917; /* mve_vldrq_gather_shifted_offset_extend_v4sis */

        case 5:
          if (!
#line 3501 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
            return -1;
          return 4897; /* mve_vldrq_gather_offset_z_extend_v8qis */

        case 6:
          if (!
#line 3501 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4899; /* mve_vldrq_gather_offset_z_extend_v4qis */

        case 7:
          if (!
#line 3501 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4901; /* mve_vldrq_gather_offset_z_extend_v4his */

        case 8:
          if (!
#line 3642 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4924; /* mve_vldrq_gather_shifted_offset_z_extend_v4sis */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          if (s_register_operand (operands[0], E_SImode))
            {
              if (nonimmediate_operand (operands[1], E_HImode))
                {
                  if (
#line 5927 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6))
                    return 183; /* *arm_extendhisi2 */
                  if (
#line 5940 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6))
                    return 184; /* *arm_extendhisi2_v6 */
                }
              if (arm_reg_or_extendqisi_mem_op (operands[1], E_QImode))
                {
                  if (
#line 6021 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6))
                    return 187; /* *arm_extendqisi */
                  if (
#line 6034 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                    return 188; /* *arm_extendqisi_v6 */
                }
            }
          if (register_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_HImode)
                      && 
#line 446 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    {
                      *pnum_clobbers = 1;
                      return 963; /* thumb1_extendhisi2 */
                    }
                  break;

                case E_QImode:
                  if (nonimmediate_operand (operands[1], E_QImode)
                      && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    return 964; /* thumb1_extendqisi2 */
                  break;

                default:
                  break;
                }
            }
          if (!s_register_operand (operands[0], E_SImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 1094 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6))
            return -1;
          return 1044; /* *thumb2_extendqisi_v6 */

        case E_HImode:
          if (!s_register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !arm_extendqisi_mem_op (operands[1], E_QImode)
              || !
#line 5984 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4))
            return -1;
          return 186; /* *arm_extendqihi_insn */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 6458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2994; /* neon_unpacks_v8qi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 6458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2996; /* neon_unpacks_v4hi */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 6458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2998; /* neon_unpacks_v2si */

        default:
          return -1;
        }

    case BSWAP:
      if (pattern244 (x3, 
E_HImode) != 0
          || !
#line 12555 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch6))
        return -1;
      return 412; /* *arm_revsh */

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (XVECLEN (x5, 0) == 1)
        {
          res = recog_294 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern373 (x3, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          if (vect_par_constant_low (operands[2], E_V16QImode)
              && 
#line 6295 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return 2964; /* neon_vec_unpacks_lo_v16qi */
          if (!vect_par_constant_high (operands[2], E_V16QImode)
              || !
#line 6305 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 2970; /* neon_vec_unpacks_hi_v16qi */

        case E_V4SImode:
          if (pattern373 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          if (vect_par_constant_low (operands[2], E_V8HImode)
              && 
#line 6295 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return 2966; /* neon_vec_unpacks_lo_v8hi */
          if (!vect_par_constant_high (operands[2], E_V8HImode)
              || !
#line 6305 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 2972; /* neon_vec_unpacks_hi_v8hi */

        case E_V2DImode:
          if (pattern373 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          if (vect_par_constant_low (operands[2], E_V4SImode)
              && 
#line 6295 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return 2968; /* neon_vec_unpacks_lo_v4si */
          if (!vect_par_constant_high (operands[2], E_V4SImode)
              || !
#line 6305 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 2974; /* neon_vec_unpacks_hi_v4si */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern246 (x3))
        {
        case 0:
          if (!
#line 6420 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2988; /* neon_vec_sshiftl_v8qi */

        case 1:
          if (!
#line 6420 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2990; /* neon_vec_sshiftl_v4hi */

        case 2:
          if (!
#line 6420 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2992; /* neon_vec_sshiftl_v2si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1))
    {
    case 0:
      if (register_operand (operands[0], E_V8QImode)
          && register_operand (operands[1], E_V8QImode)
          && register_operand (operands[2], E_V8QImode)
          && 
#line 381 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 558; /* usaddv8qi3 */
      if (!s_register_operand (operands[0], E_V8QImode)
          || !s_register_operand (operands[1], E_V8QImode)
          || !s_register_operand (operands[2], E_V8QImode)
          || !
#line 1438 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1458; /* *us_addv8qi_neon */

    case 1:
      if (register_operand (operands[0], E_V4HImode)
          && register_operand (operands[1], E_V4HImode)
          && register_operand (operands[2], E_V4HImode)
          && 
#line 391 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 559; /* usaddv4hi3 */
      if (!s_register_operand (operands[0], E_V4HImode)
          || !s_register_operand (operands[1], E_V4HImode)
          || !s_register_operand (operands[2], E_V4HImode)
          || !
#line 1438 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1459; /* *us_addv4hi_neon */

    case 2:
      if (register_operand (operands[0], E_V2SImode)
          && register_operand (operands[1], E_V2SImode)
          && register_operand (operands[2], E_V2SImode)
          && 
#line 401 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 560; /* usaddv2si3 */
      if (!s_register_operand (operands[0], E_V2SImode)
          || !s_register_operand (operands[1], E_V2SImode)
          || !s_register_operand (operands[2], E_V2SImode)
          || !
#line 1438 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1460; /* *us_addv2si_neon */

    case 3:
      if (!
#line 1438 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1461; /* *us_addv2sf_neon */

    case 4:
      if (!
#line 55 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3194; /* usaddv4uqq3 */

    case 5:
      if (!
#line 55 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3195; /* usaddv2uhq3 */

    case 6:
      if (!
#line 55 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3196; /* usadduqq3 */

    case 7:
      if (!
#line 55 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3197; /* usadduhq3 */

    case 8:
      if (!
#line 55 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3198; /* usaddv2uha3 */

    case 9:
      if (!
#line 55 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3199; /* usadduha3 */

    default:
      return -1;
    }
}

 int
recog_328 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  if (XWINT (x5, 0) == 0LL)
    {
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x8 = XEXP (x3, 1);
      operands[1] = x8;
      if (const_int_M_operand (operands[1], E_SImode))
        {
          x9 = XEXP (x3, 2);
          operands[2] = x9;
          if (const_int_M_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3500 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch_thumb2)))
            return 6444; /* *p insv_zero */
        }
    }
  x8 = XEXP (x3, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x9 = XEXP (x3, 2);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x6 = XEXP (x1, 0);
  operands[2] = x6;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  operands[1] = x5;
  if (!const_int_operand (operands[1], E_SImode)
      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12371 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_HAVE_MOVT)))
    return -1;
  return 6602; /* *p *arm_movtas_ze */
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 101)
    return -1;
  x6 = XEXP (x1, 0);
  operands[2] = x6;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (x5))
    {
    case E_CCFPmode:
      switch (pattern554 (x3, 
E_CCFPmode))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1815 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6963; /* *p *cmpsf_vfp */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1839 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6965; /* *p *cmpdf_vfp */

        default:
          return -1;
        }

    case E_CCFPEmode:
      switch (pattern554 (x3, 
E_CCFPEmode))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1827 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6964; /* *p *cmpsf_trap_vfp */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1851 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6966; /* *p *cmpdf_trap_vfp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_337 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[6] = x2;
  x3 = XEXP (x2, 0);
  operands[7] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x6, 1);
  operands[5] = x9;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x10 = XEXP (x5, 1);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  if (!const_int_operand (operands[2], E_VOIDmode)
      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3559 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[4]) < 32
   && UINTVAL (operands[2]) == ~UINTVAL (operands[5])
   && (exact_log2 (UINTVAL (operands[5])
		   + (HOST_WIDE_INT_1U << UINTVAL (operands[4])))
       >= 0))))
    return -1;
  return 6447; /* *p *bfi_alt1 */
}

 int
recog_339 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case LSHIFTRT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case MULT:
          x10 = XEXP (x9, 0);
          switch (GET_CODE (x10))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x10) != E_V4SImode)
                return -1;
              x11 = XEXP (x9, 1);
              if (GET_CODE (x11) != SIGN_EXTEND
                  || GET_MODE (x11) != E_V4SImode
                  || XWINT (x8, 0) != 16LL
                  || !register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x6) != E_V4HImode
                  || GET_MODE (x7) != E_V4SImode
                  || GET_MODE (x9) != E_V4SImode)
                return -1;
              x12 = XEXP (x10, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_V4HImode))
                return -1;
              x13 = XEXP (x11, 0);
              operands[2] = x13;
              if (!register_operand (operands[2], E_V4HImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 494 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6709; /* *p smulv4hi3_highpart */

            case ZERO_EXTEND:
              x11 = XEXP (x9, 1);
              if (GET_CODE (x11) != ZERO_EXTEND)
                return -1;
              x12 = XEXP (x10, 0);
              operands[1] = x12;
              x13 = XEXP (x11, 0);
              operands[2] = x13;
              switch (XWINT (x8, 0))
                {
                case 16LL:
                  if (pattern570 (x6, 
E_V4HImode, 
E_V4SImode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 507 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6710; /* *p umulv4hi3_highpart */

                case 32LL:
                  if (pattern570 (x6, 
E_V2SImode, 
E_V2DImode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 279 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6842; /* *p iwmmxt_wmulwum */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          x10 = XEXP (x9, 0);
          switch (GET_CODE (x10))
            {
            case PLUS:
              x12 = XEXP (x10, 0);
              if (GET_CODE (x12) != ZERO_EXTEND)
                return -1;
              x14 = XEXP (x10, 1);
              if (GET_CODE (x14) != ZERO_EXTEND)
                return -1;
              x11 = XEXP (x9, 1);
              if (GET_CODE (x11) != CONST_VECTOR
                  || XWINT (x8, 0) != 1LL)
                return -1;
              x15 = XEXP (x12, 0);
              operands[1] = x15;
              x16 = XEXP (x14, 0);
              operands[2] = x16;
              switch (XVECLEN (x11, 0))
                {
                case 8:
                  if (pattern601 (x11, 
1) != 0
                      || pattern594 (x6, 
E_V8QImode, 
E_V8HImode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 617 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6719; /* *p iwmmxt_uavgrndv8qi3 */

                case 4:
                  if (GET_MODE (x11) != E_V4SImode)
                    return -1;
                  x17 = XVECEXP (x11, 0, 0);
                  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x18 = XVECEXP (x11, 0, 1);
                  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x19 = XVECEXP (x11, 0, 2);
                  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x20 = XVECEXP (x11, 0, 3);
                  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                      || pattern594 (x6, 
E_V4HImode, 
E_V4SImode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6720; /* *p iwmmxt_uavgrndv4hi3 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x11 = XEXP (x9, 1);
              if (GET_CODE (x11) != ZERO_EXTEND
                  || XWINT (x8, 0) != 1LL)
                return -1;
              x12 = XEXP (x10, 0);
              operands[1] = x12;
              x13 = XEXP (x11, 0);
              operands[2] = x13;
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (pattern570 (x6, 
E_V8QImode, 
E_V8HImode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 648 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6721; /* *p iwmmxt_uavgv8qi3 */

                case E_V4HImode:
                  if (pattern570 (x6, 
E_V4HImode, 
E_V4SImode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 661 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6722; /* *p iwmmxt_uavgv4hi3 */

                default:
                  return -1;
                }

            case MULT:
              x12 = XEXP (x10, 0);
              if (GET_CODE (x12) != ZERO_EXTEND)
                return -1;
              x14 = XEXP (x10, 1);
              if (GET_CODE (x14) != ZERO_EXTEND)
                return -1;
              x11 = XEXP (x9, 1);
              if (GET_CODE (x11) != CONST_VECTOR)
                return -1;
              x15 = XEXP (x12, 0);
              operands[1] = x15;
              x16 = XEXP (x14, 0);
              operands[2] = x16;
              switch (XVECLEN (x11, 0))
                {
                case 4:
                  if (pattern593 (x11) != 0)
                    return -1;
                  x20 = XVECEXP (x11, 0, 3);
                  if (GET_CODE (x20) != CONST_INT
                      || XWINT (x20, 0) != 32768LL
                      || XWINT (x8, 0) != 16LL
                      || pattern594 (x6, 
E_V4HImode, 
E_V4SImode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 316 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6844; /* *p iwmmxt_wmulumr */

                case 2:
                  if (pattern595 (x6) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 350 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6846; /* *p iwmmxt_wmulwumr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != MINUS)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != ZERO_EXTEND)
        return -1;
      x11 = XEXP (x9, 1);
      if (GET_CODE (x11) != ZERO_EXTEND)
        return -1;
      x12 = XEXP (x10, 0);
      operands[1] = x12;
      x13 = XEXP (x11, 0);
      operands[2] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern570 (x6, 
E_V8QImode, 
E_V8HImode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 37 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6828; /* *p iwmmxt_wabsdiffb */

        case E_V4HImode:
          if (pattern570 (x6, 
E_V4HImode, 
E_V4SImode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 50 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6829; /* *p iwmmxt_wabsdiffh */

        case E_V2SImode:
          if (pattern570 (x6, 
E_V2SImode, 
E_V2DImode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 63 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6830; /* *p iwmmxt_wabsdiffw */

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x7) != E_V8HImode)
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != VEC_MERGE
          || GET_MODE (x9) != E_V8HImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != LSHIFTRT
          || GET_MODE (x10) != E_V8HImode)
        return -1;
      x12 = XEXP (x10, 0);
      if (GET_CODE (x12) != PLUS
          || GET_MODE (x12) != E_V8HImode)
        return -1;
      x15 = XEXP (x12, 0);
      if (GET_CODE (x15) != PLUS
          || GET_MODE (x15) != E_V8HImode)
        return -1;
      x21 = XEXP (x15, 0);
      if (GET_CODE (x21) != PLUS
          || GET_MODE (x21) != E_V8HImode)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != PLUS
          || GET_MODE (x22) != E_V8HImode)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != ZERO_EXTEND
          || GET_MODE (x23) != E_V8HImode)
        return -1;
      x24 = XEXP (x22, 1);
      if (GET_CODE (x24) != ZERO_EXTEND
          || GET_MODE (x24) != E_V8HImode)
        return -1;
      x25 = XEXP (x21, 1);
      if (GET_CODE (x25) != VEC_SELECT
          || GET_MODE (x25) != E_V8HImode)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != ZERO_EXTEND
          || GET_MODE (x26) != E_V8HImode)
        return -1;
      x27 = XEXP (x25, 1);
      if (GET_CODE (x27) != PARALLEL
          || XVECLEN (x27, 0) != 8)
        return -1;
      x28 = XVECEXP (x27, 0, 0);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x29 = XVECEXP (x27, 0, 1);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x30 = XVECEXP (x27, 0, 2);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x31 = XVECEXP (x27, 0, 3);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x32 = XVECEXP (x27, 0, 4);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x33 = XVECEXP (x27, 0, 5);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x34 = XVECEXP (x27, 0, 6);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x35 = XVECEXP (x27, 0, 7);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x36 = XEXP (x15, 1);
      if (GET_CODE (x36) != VEC_SELECT
          || GET_MODE (x36) != E_V8HImode)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != ZERO_EXTEND
          || GET_MODE (x37) != E_V8HImode)
        return -1;
      x38 = XEXP (x36, 1);
      if (GET_CODE (x38) != PARALLEL
          || XVECLEN (x38, 0) != 8)
        return -1;
      x39 = XVECEXP (x38, 0, 0);
      if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x40 = XVECEXP (x38, 0, 1);
      if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x41 = XVECEXP (x38, 0, 2);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x42 = XVECEXP (x38, 0, 3);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x43 = XVECEXP (x38, 0, 4);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x44 = XVECEXP (x38, 0, 5);
      if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x45 = XVECEXP (x38, 0, 6);
      if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x46 = XVECEXP (x38, 0, 7);
      if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x47 = XEXP (x12, 1);
      if (GET_CODE (x47) != CONST_VECTOR
          || XVECLEN (x47, 0) != 8
          || GET_MODE (x47) != E_V8HImode)
        return -1;
      x48 = XVECEXP (x47, 0, 0);
      if (GET_CODE (x48) != CONST_INT)
        return -1;
      x49 = XVECEXP (x47, 0, 1);
      if (GET_CODE (x49) != CONST_INT)
        return -1;
      x50 = XVECEXP (x47, 0, 2);
      if (GET_CODE (x50) != CONST_INT)
        return -1;
      x51 = XVECEXP (x47, 0, 3);
      if (GET_CODE (x51) != CONST_INT)
        return -1;
      x52 = XVECEXP (x47, 0, 4);
      if (GET_CODE (x52) != CONST_INT)
        return -1;
      x53 = XVECEXP (x47, 0, 5);
      if (GET_CODE (x53) != CONST_INT)
        return -1;
      x54 = XVECEXP (x47, 0, 6);
      if (GET_CODE (x54) != CONST_INT)
        return -1;
      x55 = XVECEXP (x47, 0, 7);
      if (GET_CODE (x55) != CONST_INT)
        return -1;
      x14 = XEXP (x10, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XEXP (x9, 1);
      if (GET_CODE (x11) != CONST_VECTOR
          || XVECLEN (x11, 0) != 8
          || pattern601 (x11, 
0) != 0)
        return -1;
      x56 = XEXP (x9, 2);
      if (GET_CODE (x56) != CONST_INT
          || XWINT (x56, 0) != 254LL)
        return -1;
      x8 = XEXP (x7, 1);
      if (pattern604 (x8, 
2, 
8) != 0)
        return -1;
      x57 = XVECEXP (x8, 0, 2);
      if (x57 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x58 = XVECEXP (x8, 0, 3);
      if (x58 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x59 = XVECEXP (x8, 0, 4);
      if (x59 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x60 = XVECEXP (x8, 0, 5);
      if (x60 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x61 = XVECEXP (x8, 0, 6);
      if (x61 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x62 = XVECEXP (x8, 0, 7);
      if (x62 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V8QImode)
          || GET_MODE (x6) != E_V8QImode)
        return -1;
      x63 = XEXP (x23, 0);
      operands[1] = x63;
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      x64 = XEXP (x24, 0);
      operands[2] = x64;
      if (!register_operand (operands[2], E_V8QImode))
        return -1;
      x65 = XEXP (x26, 0);
      if (!rtx_equal_p (x65, operands[1]))
        return -1;
      x66 = XEXP (x37, 0);
      if (!rtx_equal_p (x66, operands[2]))
        return -1;
      switch (XWINT (x48, 0))
        {
        case 1LL:
          if (XWINT (x49, 0) != 1LL
              || XWINT (x50, 0) != 1LL
              || XWINT (x51, 0) != 1LL
              || XWINT (x52, 0) != 1LL
              || XWINT (x53, 0) != 1LL
              || XWINT (x54, 0) != 1LL
              || XWINT (x55, 0) != 1LL
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 143 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6835; /* *p iwmmxt_avg4 */

        case 2LL:
          if (XWINT (x49, 0) != 2LL
              || XWINT (x50, 0) != 2LL
              || XWINT (x51, 0) != 2LL
              || XWINT (x52, 0) != 2LL
              || XWINT (x53, 0) != 2LL
              || XWINT (x54, 0) != 2LL
              || XWINT (x55, 0) != 2LL
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 175 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6836; /* *p iwmmxt_avg4r */

        default:
          return -1;
        }

    case ASHIFTRT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case MULT:
          if (GET_MODE (x9) != E_V2DImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != SIGN_EXTEND
              || GET_MODE (x10) != E_V2DImode)
            return -1;
          x11 = XEXP (x9, 1);
          if (GET_CODE (x11) != SIGN_EXTEND
              || GET_MODE (x11) != E_V2DImode
              || XWINT (x8, 0) != 32LL
              || !register_operand (operands[0], E_V2SImode)
              || GET_MODE (x6) != E_V2SImode
              || GET_MODE (x7) != E_V2DImode)
            return -1;
          x12 = XEXP (x10, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          x13 = XEXP (x11, 0);
          operands[2] = x13;
          if (!register_operand (operands[2], E_V2SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6841; /* *p iwmmxt_wmulwsm */

        case PLUS:
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MULT)
            return -1;
          x12 = XEXP (x10, 0);
          if (GET_CODE (x12) != SIGN_EXTEND)
            return -1;
          x14 = XEXP (x10, 1);
          if (GET_CODE (x14) != SIGN_EXTEND)
            return -1;
          x11 = XEXP (x9, 1);
          if (GET_CODE (x11) != CONST_VECTOR)
            return -1;
          x15 = XEXP (x12, 0);
          operands[1] = x15;
          x16 = XEXP (x14, 0);
          operands[2] = x16;
          switch (XVECLEN (x11, 0))
            {
            case 3:
              if (pattern593 (x11) != 0
                  || XWINT (x8, 0) != 16LL
                  || pattern594 (x6, 
E_V4HImode, 
E_V4SImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6843; /* *p iwmmxt_wmulsmr */

            case 2:
              if (pattern595 (x6) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6845; /* *p iwmmxt_wmulwsmr */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_347 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 52:
          if (GET_MODE (x3) != E_CCmode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 104
              || GET_MODE (x4) != E_CCmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XVECEXP (x3, 0, 0);
          operands[0] = x7;
          if (!s_register_operand (operands[0], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4429 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM_QBIT)))
            return -1;
          return 6465; /* *p arm_set_apsr */

        case 53:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x8 = XEXP (x4, 0);
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          switch (GET_CODE (x8))
            {
            case POST_DEC:
              x9 = XEXP (x8, 0);
              operands[0] = x9;
              if (!s_register_operand (operands[0], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse)))
                return -1;
              return 6959; /* *p push_fpsysreg_insn */

            case POST_INC:
              x9 = XEXP (x8, 0);
              operands[0] = x9;
              if (!s_register_operand (operands[0], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1666 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse)))
                return -1;
              return 6960; /* *p pop_fpsysreg_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x10 = XVECEXP (x3, 0, 1);
      operands[2] = x10;
      switch (XINT (x3, 1))
        {
        case 13:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern542 (x3, 
E_V8QImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 802 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6732; /* *p eqv8qi3 */

            case E_V4HImode:
              if (pattern542 (x3, 
E_V4HImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 813 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6733; /* *p eqv4hi3 */

            case E_V2SImode:
              if (pattern542 (x3, 
E_V2SImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 825 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6734; /* *p eqv2si3 */

            default:
              return -1;
            }

        case 14:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern542 (x3, 
E_V8QImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 836 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6735; /* *p gtuv8qi3 */

            case E_V4HImode:
              if (pattern542 (x3, 
E_V4HImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 847 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6736; /* *p gtuv4hi3 */

            case E_V2SImode:
              if (pattern542 (x3, 
E_V2SImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 858 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6737; /* *p gtuv2si3 */

            default:
              return -1;
            }

        case 15:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern542 (x3, 
E_V8QImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 869 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6738; /* *p gtv8qi3 */

            case E_V4HImode:
              if (pattern542 (x3, 
E_V4HImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6739; /* *p gtv4hi3 */

            case E_V2SImode:
              if (pattern542 (x3, 
E_V2SImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 891 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6740; /* *p gtv2si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_355 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x6, 0))
            {
            case 0LL:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4067 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6457; /* *p *smax_0 */

            case -1LL:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4077 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6458; /* *p *smax_m1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern441 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 903 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6741; /* *p *smaxv2si3_iwmmxt */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 903 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6742; /* *p *smaxv4hi3_iwmmxt */

            case 2:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 903 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6743; /* *p *smaxv8qi3_iwmmxt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMIN:
      switch (pattern379 (x1))
        {
        case 0:
          if ((
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4477 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[2], operands[1], NULL, NULL))))
            return 6468; /* *p satsi_smax */
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4477 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[2], operands[1], NULL, NULL))))
            return -1;
          return 6469; /* *p satsi_smax_setq */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4503 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[2], operands[1], NULL, NULL))))
            return -1;
          return 6471; /* *p *satsi_smax_shift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MULT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x4, 1);
  if (!s_register_operand (x7, E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[4] = x8;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      if (pattern563 (x9, 
LSHIFTRT, 
E_SImode, 
TRUNCATE, 
PLUS) != 0)
        return -1;
      x10 = XEXP (x9, 0);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != PLUS
          || GET_MODE (x12) != E_DImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != MULT
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XEXP (x12, 1);
      if (GET_CODE (x14) != ZERO_EXTEND
          || GET_MODE (x14) != E_DImode)
        return -1;
      x15 = XEXP (x11, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x16 = XEXP (x1, 0);
      operands[6] = x16;
      x17 = XEXP (x16, 0);
      operands[7] = x17;
      x18 = XEXP (x5, 1);
      operands[5] = x18;
      if (!s_register_operand (operands[5], E_SImode))
        return -1;
      operands[1] = x7;
      x19 = XEXP (x6, 0);
      operands[2] = x19;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x20 = XEXP (x13, 0);
      if (GET_MODE (x20) != E_DImode)
        return -1;
      x21 = XEXP (x13, 1);
      if (GET_MODE (x21) != E_DImode)
        return -1;
      x22 = XEXP (x9, 1);
      operands[3] = x22;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x23 = XEXP (x14, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      switch (GET_CODE (x20))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x21) != SIGN_EXTEND)
            return -1;
          x24 = XEXP (x20, 0);
          if (!rtx_equal_p (x24, operands[4]))
            return -1;
          x25 = XEXP (x21, 0);
          if (!rtx_equal_p (x25, operands[5])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2485 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6421; /* *p smlal */

        case ZERO_EXTEND:
          if (GET_CODE (x21) != ZERO_EXTEND)
            return -1;
          x24 = XEXP (x20, 0);
          if (!rtx_equal_p (x24, operands[4]))
            return -1;
          x25 = XEXP (x21, 0);
          if (!rtx_equal_p (x25, operands[5])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2485 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6422; /* *p umlal */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x18 = XEXP (x5, 1);
      if (GET_CODE (x18) != SIGN_EXTEND
          || GET_MODE (x18) != E_SImode
          || pattern596 (x1, 
E_HImode) != 0)
        return -1;
      x26 = XEXP (x18, 0);
      operands[2] = x26;
      if (!s_register_operand (operands[2], E_HImode))
        return -1;
      operands[3] = x7;
      if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2618 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
        return -1;
      return 6430; /* *p arm_smlabb_setq */

    case ASHIFTRT:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x27 = XEXP (x8, 1);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || pattern596 (x1, 
E_SImode) != 0)
        return -1;
      x18 = XEXP (x5, 1);
      if (GET_MODE (x18) != E_SImode)
        return -1;
      operands[3] = x7;
      switch (GET_CODE (x18))
        {
        case SIGN_EXTEND:
          x26 = XEXP (x18, 0);
          operands[2] = x26;
          if (!s_register_operand (operands[2], E_HImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2666 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
            return -1;
          return 6432; /* *p arm_smlatb_setq */

        case ASHIFTRT:
          x28 = XEXP (x18, 1);
          if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x26 = XEXP (x18, 0);
          operands[2] = x26;
          if (!s_register_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2716 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
            return -1;
          return 6434; /* *p arm_smlatt_setq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_377 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 1:
      switch (XINT (x1, 1))
        {
        case 0:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 305; /* blockage */

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 391; /* align_4 */

        case 12:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 392; /* align_8 */

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 393; /* consttable_end */

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          return 394; /* consttable_1 */

        case 6:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          return 395; /* consttable_2 */

        case 7:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          return 396; /* consttable_4 */

        case 8:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          return 397; /* consttable_8 */

        case 9:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          return 398; /* consttable_16 */

        case 16:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          if (
#line 12275 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            {
              *pnum_clobbers = 1;
              return 404; /* arm_eh_return */
            }
          if (
#line 2096 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            {
              *pnum_clobbers = 1;
              return 1005; /* thumb_eh_return */
            }
          if (!
#line 1239 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          *pnum_clobbers = 1;
          return 1051; /* thumb2_eh_return */

        case 51:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 13090 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch7 || arm_arch8))
            return -1;
          return 513; /* *speculation_barrier_insn */

        case 60:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 13121 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch8m_main))
            return -1;
          return 517; /* bti_nop */

        case 56:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != MEM
              || GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          if (!s_register_operand (operands[0], E_SImode)
              || !
#line 1725 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(use_cmse && reload_completed))
            return -1;
          return 859; /* lazy_store_multiple_insn */

        case 57:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != MEM
              || GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          if (!s_register_operand (operands[0], E_SImode)
              || !
#line 1735 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(use_cmse && reload_completed))
            return -1;
          return 860; /* lazy_load_multiple_insn */

        case 30:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 2116 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_BASE))
            return -1;
          return 925; /* set_fpscr */

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 2028 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 1001; /* prologue_thumb1_interwork */

        case 1:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != RETURN
              || !
#line 2036 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 1002; /* *epilogue_insns */

        case 54:
          if (pnum_clobbers == NULL
              || GET_MODE (x1) != E_SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 1699 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse))
            return -1;
          *pnum_clobbers = 1;
          return 1070; /* *clear_apsr */

        default:
          return -1;
        }

    case 6:
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      operands[1] = x4;
      if (!immediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      operands[3] = x6;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 4);
      operands[4] = x7;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 5);
      operands[5] = x8;
      if (!immediate_operand (operands[5], E_SImode))
        return -1;
      switch (XINT (x1, 1))
        {
        case 33:
          if (!
#line 12948 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_CDP)))
            return -1;
          return 495; /* arm_cdp */

        case 34:
          if (!
#line 12948 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_CDP2)))
            return -1;
          return 496; /* arm_cdp2 */

        default:
          return -1;
        }

    case 3:
      switch (XINT (x1, 1))
        {
        case 35:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12965 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_LDC)))
            return -1;
          return 497; /* *ldc */

        case 36:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12965 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_LDC2)))
            return -1;
          return 498; /* *ldc */

        case 37:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12965 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_LDCL)))
            return -1;
          return 499; /* *ldc */

        case 38:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12965 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_LDC2L)))
            return -1;
          return 500; /* *ldc */

        case 39:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12978 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_STC)))
            return -1;
          return 501; /* *stc */

        case 40:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12978 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_STC2)))
            return -1;
          return 502; /* *stc */

        case 41:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12978 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_STCL)))
            return -1;
          return 503; /* *stc */

        case 42:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12978 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_STC2L)))
            return -1;
          return 504; /* *stc */

        case 59:
          if (GET_MODE (x1) != E_SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != REG
              || REGNO (x2) != 12
              || GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 13
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 14
              || GET_MODE (x5) != E_SImode
              || !
#line 13115 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch8m_main))
            return -1;
          return 516; /* aut_nop */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == E_SImode)
    {
      res = split_5 (x1, insn);
      if (res != NULL_RTX)
        return res;
    }
  operands[1] = x3;
  if (!logical_binary_operator (operands[1], E_SImode))
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[8] = x5;
  if (!s_register_operand (operands[8], E_SImode))
    return NULL;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case ZERO_EXTRACT:
      if (pattern547 (x3, 
LSHIFTRT) != 0
          || !
#line 3949 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && GET_CODE (operands[1]) == GET_CODE (operands[9])
   && INTVAL (operands[3]) == 32 - INTVAL (operands[6])))
        return NULL;
      return gen_split_18 (insn, operands);

    case AND:
    case IOR:
    case XOR:
      operands[9] = x6;
      if (!logical_binary_operator (operands[9], E_SImode))
        return NULL;
      x7 = XEXP (x6, 0);
      if (GET_MODE (x7) != E_SImode)
        return NULL;
      x8 = XEXP (x6, 1);
      operands[7] = x8;
      if (!s_register_operand (operands[7], E_SImode))
        return NULL;
      x9 = XEXP (x3, 1);
      if (GET_MODE (x9) != E_SImode)
        return NULL;
      switch (GET_CODE (x7))
        {
        case LSHIFTRT:
          if (pattern607 (x3, 
ZERO_EXTRACT) != 0
              || !
#line 3975 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && GET_CODE (operands[1]) == GET_CODE (operands[9])
   && INTVAL (operands[3]) == 32 - INTVAL (operands[6])))
            return NULL;
          return gen_split_19 (insn, operands);

        case ASHIFTRT:
          if (pattern607 (x3, 
SIGN_EXTRACT) != 0
              || !
#line 4027 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && GET_CODE (operands[1]) == GET_CODE (operands[9])
   && INTVAL (operands[3]) == 32 - INTVAL (operands[6])))
            return NULL;
          return gen_split_21 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      if (pattern547 (x3, 
ASHIFTRT) != 0
          || !
#line 4001 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && GET_CODE (operands[1]) == GET_CODE (operands[9])
   && INTVAL (operands[3]) == 32 - INTVAL (operands[6])))
        return NULL;
      return gen_split_20 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!s_register_operand (operands[0], E_SImode))
            return NULL;
          switch (GET_CODE (x3))
            {
            case MINUS:
              res = split_3 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case PLUS:
            case AND:
            case IOR:
            case XOR:
              res = split_7 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x3;
          if (!shiftable_operator (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          if (!s_register_operand (x6, E_SImode))
            return NULL;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTRACT:
              if (pattern475 (x1) != 0
                  || !
#line 3248 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return NULL;
              return gen_split_11 (insn, operands);

            case SIGN_EXTRACT:
              if (pattern475 (x1) != 0
                  || !
#line 3270 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return NULL;
              return gen_split_12 (insn, operands);

            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[2] = x7;
              if (!shiftable_operator (operands[2], E_SImode))
                return NULL;
              x8 = XEXP (x7, 0);
              if (!shift_operator (x8, E_SImode))
                return NULL;
              operands[3] = x8;
              x9 = XEXP (x8, 0);
              operands[4] = x9;
              if (!s_register_operand (operands[4], E_SImode))
                return NULL;
              x10 = XEXP (x8, 1);
              operands[5] = x10;
              if (!reg_or_int_operand (operands[5], E_SImode))
                return NULL;
              x11 = XEXP (x7, 1);
              operands[6] = x11;
              if (!s_register_operand (operands[6], E_SImode))
                return NULL;
              x12 = XEXP (x3, 1);
              operands[7] = x12;
              if (!arm_rhs_operand (operands[7], E_SImode))
                return NULL;
              operands[8] = x6;
              if (!
#line 9717 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return NULL;
              return gen_split_77 (insn, operands);

            default:
              return NULL;
            }

        case IF_THEN_ELSE:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case LTGT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNEQ:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              x11 = XEXP (x7, 1);
              if (x11 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  && pattern255 (x1) == 0)
                {
                  x8 = XEXP (x7, 0);
                  if (GET_MODE (x8) == E_SImode)
                    {
                      if (GET_CODE (x8) == ZERO_EXTRACT)
                        {
                          res = split_8 (x1, insn);
                          if (res != NULL_RTX)
                            return res;
                        }
                      if (GET_CODE (x8) == PLUS)
                        {
                          operands[5] = x7;
                          if (comparison_operator (operands[5], E_VOIDmode)
                              && pattern575 (x3) == 0
                              && (
#line 10767 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 10769 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
                            return gen_split_95 (insn, operands);
                        }
                    }
                }
              if (!arm_comparison_operator (x7, E_VOIDmode))
                return NULL;
              operands[1] = x7;
              if (pattern255 (x1) != 0)
                return NULL;
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              operands[3] = x11;
              x13 = XEXP (x3, 2);
              operands[4] = x13;
              x12 = XEXP (x3, 1);
              if (rtx_equal_p (x12, operands[0])
                  && 
#line 11710 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed))
                return gen_split_100 (insn, operands);
              operands[4] = x12;
              if (rtx_equal_p (x13, operands[0])
                  && 
#line 11738 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed))
                return gen_split_101 (insn, operands);
              operands[5] = x13;
              if (
#line 11759 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed))
                return gen_split_102 (insn, operands);
              if (!arm_rhs_operand (operands[4], E_SImode)
                  || GET_CODE (x13) != NOT
                  || GET_MODE (x13) != E_SImode
                  || !s_register_operand (operands[2], E_SImode)
                  || !arm_add_operand (operands[3], E_SImode))
                return NULL;
              x14 = XEXP (x13, 0);
              operands[5] = x14;
              if (!s_register_operand (operands[5], E_SImode)
                  || !
#line 11791 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed))
                return NULL;
              return gen_split_103 (insn, operands);

            default:
              return NULL;
            }

        case SMAX:
          if (pattern254 (x1) != 0)
            return NULL;
          if (
#line 4092 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return gen_split_22 (insn, operands);
          if (!
#line 37 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return NULL;
          return gen_split_134 (insn, operands);

        case SMIN:
          if (pattern254 (x1) != 0)
            return NULL;
          if (
#line 4142 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return gen_split_23 (insn, operands);
          if (!
#line 58 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return NULL;
          return gen_split_135 (insn, operands);

        case UMAX:
          if (pattern254 (x1) != 0)
            return NULL;
          if (
#line 4175 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return gen_split_24 (insn, operands);
          if (!
#line 79 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return NULL;
          return gen_split_136 (insn, operands);

        case UMIN:
          if (pattern254 (x1) != 0)
            return NULL;
          if (
#line 4208 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return gen_split_25 (insn, operands);
          if (!
#line 100 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return NULL;
          return gen_split_137 (insn, operands);

        case ABS:
          if (pattern14 (x1) != 0)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) == REG
              && REGNO (x6) == 100
              && GET_MODE (x6) == E_CCmode)
            {
              if ((
#line 5255 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5257 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_27 (insn, operands);
              if ((
#line 117 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 122 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
                return gen_split_138 (insn, operands);
            }
          operands[2] = x6;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 336 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed))
            return NULL;
          return gen_split_116 (insn, operands);

        case NEG:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!s_register_operand (operands[0], E_SImode))
            return NULL;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case ABS:
              if (GET_MODE (x7) != E_SImode)
                return NULL;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x6 = XEXP (x4, 0);
              if (GET_CODE (x6) == REG
                  && REGNO (x6) == 100
                  && GET_MODE (x6) == E_CCmode)
                {
                  if ((
#line 5319 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5321 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
                    return gen_split_28 (insn, operands);
                  if ((
#line 170 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 175 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
                    return gen_split_139 (insn, operands);
                }
              operands[2] = x6;
              if (!scratch_operand (operands[2], E_SImode)
                  || !
#line 351 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed))
                return NULL;
              return gen_split_117 (insn, operands);

            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              operands[3] = x7;
              if (!arm_comparison_operator (operands[3], E_VOIDmode))
                return NULL;
              x6 = XEXP (x4, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 100
                  || GET_MODE (x6) != E_CCmode)
                return NULL;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x11 = XEXP (x7, 1);
              operands[2] = x11;
              if (!arm_rhs_operand (operands[2], E_SImode))
                return NULL;
              if ((
#line 10692 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 10694 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_94 (insn, operands);
              if (!(
#line 899 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH) && 
#line 901 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_150 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != SUBREG)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x7) != E_QImode)
            return NULL;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_SImode))
            return NULL;
          switch (SUBREG_BYTE (x7))
            {
            case 0:
              if (!
#line 5791 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && (!MEM_P (operands[1])) && ! BYTES_BIG_ENDIAN))
                return NULL;
              return gen_split_33 (insn, operands);

            case 3:
              if (!
#line 5801 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && (!MEM_P (operands[1])) && BYTES_BIG_ENDIAN))
                return NULL;
              return gen_split_34 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_HImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 5870 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(!arm_arch6))
            return NULL;
          return gen_split_37 (insn, operands);

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (pattern255 (x1) != 0)
            return NULL;
          if (GET_MODE (x3) == E_SImode)
            {
              res = split_9 (x1, insn);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x3;
          if (!arm_comparison_operator (operands[1], E_SImode))
            return NULL;
          x7 = XEXP (x3, 0);
          operands[2] = x7;
          if (!s_register_operand (operands[2], E_SImode))
            return NULL;
          x12 = XEXP (x3, 1);
          operands[3] = x12;
          if (!arm_add_operand (operands[3], E_SImode)
              || !(
#line 9952 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 9954 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
            return NULL;
          return gen_split_86 (insn, operands);

        case COMPARE:
          x7 = XEXP (x3, 0);
          if (GET_MODE (x7) != E_SImode)
            return NULL;
          switch (GET_CODE (x7))
            {
            case IOR:
              x12 = XEXP (x3, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x8 = XEXP (x7, 0);
              switch (GET_CODE (x8))
                {
                case NE:
                case EQ:
                case GE:
                case GT:
                case LE:
                case LT:
                case GEU:
                case GTU:
                case LEU:
                case LTU:
                case UNORDERED:
                case ORDERED:
                case UNGE:
                case UNGT:
                case UNLE:
                case UNLT:
                  if (!arm_comparison_operator (x8, E_SImode))
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (!s_register_operand (x9, E_SImode))
                    return NULL;
                  x10 = XEXP (x8, 1);
                  if (!arm_add_operand (x10, E_SImode))
                    return NULL;
                  x11 = XEXP (x7, 1);
                  switch (GET_CODE (x11))
                    {
                    case NE:
                    case EQ:
                    case GE:
                    case GT:
                    case LE:
                    case LT:
                    case GEU:
                    case GTU:
                    case LEU:
                    case LTU:
                    case UNORDERED:
                    case ORDERED:
                    case UNGE:
                    case UNGT:
                    case UNLE:
                    case UNLT:
                      operands[6] = x11;
                      if (!arm_comparison_operator (operands[6], E_SImode))
                        return NULL;
                      x4 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x4) != SET)
                        return NULL;
                      x15 = XEXP (x4, 1);
                      if (GET_CODE (x15) != IOR
                          || GET_MODE (x15) != E_SImode)
                        return NULL;
                      x16 = XEXP (x15, 0);
                      switch (GET_CODE (x16))
                        {
                        case NE:
                        case EQ:
                        case GE:
                        case GT:
                        case LE:
                        case LT:
                        case GEU:
                        case GTU:
                        case LEU:
                        case LTU:
                        case UNORDERED:
                        case ORDERED:
                        case UNGE:
                        case UNGT:
                        case UNLE:
                        case UNLT:
                          x17 = XEXP (x15, 1);
                          switch (GET_CODE (x17))
                            {
                            case NE:
                            case EQ:
                            case GE:
                            case GT:
                            case LE:
                            case LT:
                            case GEU:
                            case GTU:
                            case LEU:
                            case LTU:
                            case UNORDERED:
                            case ORDERED:
                            case UNGE:
                            case UNGT:
                            case UNLE:
                            case UNLT:
                              if (!rtx_equal_p (x17, operands[6]))
                                return NULL;
                              x5 = XEXP (x2, 0);
                              operands[0] = x5;
                              if (!dominant_cc_register (operands[0], E_VOIDmode))
                                return NULL;
                              operands[3] = x8;
                              operands[1] = x9;
                              operands[2] = x10;
                              x18 = XEXP (x11, 0);
                              operands[4] = x18;
                              if (!s_register_operand (operands[4], E_SImode))
                                return NULL;
                              x19 = XEXP (x11, 1);
                              operands[5] = x19;
                              if (!arm_add_operand (operands[5], E_SImode))
                                return NULL;
                              x6 = XEXP (x4, 0);
                              operands[7] = x6;
                              if (!s_register_operand (operands[7], E_SImode)
                                  || !rtx_equal_p (x16, operands[3])
                                  || !
#line 10532 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
                                return NULL;
                              return gen_split_88 (insn, operands);

                            default:
                              return NULL;
                            }

                        default:
                          return NULL;
                        }

                    case AND:
                      if (GET_MODE (x11) != E_SImode)
                        return NULL;
                      x19 = XEXP (x11, 1);
                      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                        return NULL;
                      x5 = XEXP (x2, 0);
                      if (GET_CODE (x5) != REG
                          || REGNO (x5) != 100
                          || GET_MODE (x5) != E_CC_NZmode)
                        return NULL;
                      x4 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x4) != CLOBBER
                          || GET_MODE (x3) != E_CC_NZmode)
                        return NULL;
                      operands[1] = x8;
                      operands[2] = x9;
                      operands[3] = x10;
                      x18 = XEXP (x11, 0);
                      operands[0] = x18;
                      if (!s_register_operand (operands[0], E_SImode))
                        return NULL;
                      x6 = XEXP (x4, 0);
                      operands[4] = x6;
                      if (!s_register_operand (operands[4], E_SImode)
                          || !
#line 10676 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                        return NULL;
                      return gen_split_93 (insn, operands);

                    default:
                      return NULL;
                    }

                case AND:
                  if (GET_MODE (x8) != E_SImode)
                    return NULL;
                  x10 = XEXP (x8, 1);
                  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return NULL;
                  x11 = XEXP (x7, 1);
                  if (!arm_comparison_operator (x11, E_SImode))
                    return NULL;
                  operands[1] = x11;
                  if (pattern444 (x1, 
E_CC_NZmode) != 0
                      || !s_register_operand (operands[0], E_SImode))
                    return NULL;
                  x18 = XEXP (x11, 0);
                  operands[2] = x18;
                  if (!s_register_operand (operands[2], E_SImode))
                    return NULL;
                  x19 = XEXP (x11, 1);
                  operands[3] = x19;
                  if (!arm_add_operand (operands[3], E_SImode))
                    return NULL;
                  x4 = XVECEXP (x1, 0, 1);
                  x6 = XEXP (x4, 0);
                  operands[4] = x6;
                  if (!s_register_operand (operands[4], E_SImode)
                      || !
#line 10657 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                    return NULL;
                  return gen_split_92 (insn, operands);

                default:
                  return NULL;
                }

            case AND:
              x8 = XEXP (x7, 0);
              if (!arm_comparison_operator (x8, E_SImode))
                return NULL;
              operands[3] = x8;
              x11 = XEXP (x7, 1);
              if (!arm_comparison_operator (x11, E_SImode))
                return NULL;
              operands[6] = x11;
              x12 = XEXP (x3, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || pattern383 (x1, 
AND) != 0
                  || !
#line 10596 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
                return NULL;
              return gen_split_90 (insn, operands);

            case ASHIFT:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x8), 0)
                  || GET_MODE (x8) != E_SImode)
                return NULL;
              x11 = XEXP (x7, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 24]
                  || pattern444 (x1, 
E_CC_Zmode) != 0
                  || !memory_operand (operands[0], E_QImode))
                return NULL;
              x12 = XEXP (x3, 1);
              operands[1] = x12;
              if (!const_int_operand (operands[1], E_VOIDmode))
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              if (!scratch_operand (operands[2], E_SImode)
                  || !
#line 11609 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM
   && ((UINTVAL (operands[1]))
       == ((UINTVAL (operands[1])) >> 24) << 24)))
                return NULL;
              return gen_split_99 (insn, operands);

            default:
              return NULL;
            }

        case CONST_DOUBLE:
          switch (pattern15 (x1))
            {
            case 0:
              if (!(
#line 2142 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !arm_const_double_rtx (operands[1])
   && !(TARGET_VFP_DOUBLE && vfp3_const_double_rtx (operands[1]))) && 
#line 2147 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
( 1)))
                return NULL;
              return gen_split_111 (insn, operands);

            case 1:
              if (!(
#line 2169 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !vfp3_const_double_rtx (operands[1])) && 
#line 2173 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
( 1)))
                return NULL;
              return gen_split_112 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTRACT:
          if (pattern14 (x1) != 0)
            return NULL;
          x12 = XEXP (x3, 1);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x13 = XEXP (x3, 2);
          operands[3] = x13;
          if (!const_int_operand (operands[3], E_SImode))
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x4, 0);
          operands[4] = x6;
          if (!s_register_operand (operands[4], E_SImode)
              || !
#line 204 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return NULL;
          return gen_split_114 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 16)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return NULL;
      x20 = XVECEXP (x2, 0, 0);
      operands[0] = x20;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!scratch_operand (operands[1], E_SImode))
        return NULL;
      if ((
#line 12275 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 12277 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
( reload_completed)))
        return gen_split_105 (insn, operands);
      if ((
#line 2096 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1) && 
#line 2098 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
( reload_completed)))
        return gen_split_133 (insn, operands);
      if (!(
#line 1239 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 1241 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
( reload_completed)))
        return NULL;
      return gen_split_151 (insn, operands);

    default:
      return NULL;
    }
}
