/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case PLUS:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!arm_borrow_operation (operands[3], E_DImode))
        return -1;
      return 0;

    case GEU:
    case LTU:
      operands[2] = x6;
      if (!arm_borrow_operation (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!immediate_operand (operands[0], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern32 (x3, 
E_V4HImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern32 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern32 (x3, 
E_V4SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode
      || !s_register_operand (operands[1], E_V16QImode)
      || !s_register_operand (operands[2], i1)
      || !mve_imm_8 (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern59 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern59 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern59 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern59 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern59 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern59 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern59 (x3, 
E_V2QImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern51 (x3, 
E_V8BImode, 
E_V8HFmode, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern51 (x3, 
E_V4BImode, 
E_V4SFmode, 
E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != TRUNCATE)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[1] = x7;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  return 0;
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern117 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !s_register_operand (operands[1], i1))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !s_register_operand (operands[1], i2))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern125 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern125 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern125 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern125 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern125 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern125 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V8QImode:
      return 0;

    case E_V4HImode:
      return 1;

    case E_V4HFmode:
      return 2;

    case E_V4BFmode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V2SFmode:
      return 5;

    case E_DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 2;

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern186 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern34 (x3, 
E_V4HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern34 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern209 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern209 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern209 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern205 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern201 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern206 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern231 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 3);
  operands[3] = x8;
  return 0;
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      if (XINT (x2, 1) != 25
          || GET_MODE (x2) != E_HImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      return 0;

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SCRATCH)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      switch (XINT (x2, 1))
        {
        case 1011:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (!s_register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x1) != E_V8HImode
                  || GET_MODE (x2) != E_V8QImode
                  || !s_register_operand (operands[2], E_V8HImode))
                return -1;
              return 1;

            case E_V4SImode:
              if (!s_register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x1) != E_V4SImode
                  || !s_register_operand (operands[2], E_V4SImode))
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V4QImode:
                  return 2;

                case E_V4HImode:
                  return 3;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1017:
          if (GET_MODE (x2) != E_V4HImode
              || !s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !s_register_operand (operands[2], E_V4SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != SCRATCH)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      x4 = XVECEXP (x2, 0, 2);
      operands[3] = x4;
      switch (XINT (x2, 1))
        {
        case 1012:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (!s_register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x1) != E_V8HImode
                  || GET_MODE (x2) != E_V8QImode
                  || !s_register_operand (operands[2], E_V8HImode)
                  || !vpr_register_operand (operands[3], E_V8BImode))
                return -1;
              return 5;

            case E_V4SImode:
              if (!s_register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x1) != E_V4SImode
                  || !s_register_operand (operands[2], E_V4SImode)
                  || !vpr_register_operand (operands[3], E_V4BImode))
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V4QImode:
                  return 6;

                case E_V4HImode:
                  return 7;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1018:
          if (GET_MODE (x2) != E_V4HImode
              || !s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !s_register_operand (operands[2], E_V4SImode)
              || !vpr_register_operand (operands[3], E_V4BImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern282 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern281 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern281 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern281 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern281 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern281 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern281 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern290 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arm_add_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  if (!s_register_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[5] = x7;
  if (!arm_add_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode
          || !mve_memory_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4QImode:
          if (!mve_memory_operand (operands[1], E_V4QImode))
            return -1;
          return 1;

        case E_V4HImode:
          if (!mve_memory_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern310 (x6, 
E_SImode); /* [-1, 0] */

    case E_V8QImode:
      if (pattern311 (x6, 
E_V8QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern311 (x6, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern311 (x6, 
E_V2SImode) != 0)
        return -1;
      return 3;

    case E_V4QQmode:
      if (pattern310 (x6, 
E_V4QQmode) != 0)
        return -1;
      return 4;

    case E_V2HQmode:
      if (pattern310 (x6, 
E_V2HQmode) != 0)
        return -1;
      return 5;

    case E_QQmode:
      if (pattern310 (x6, 
E_QQmode) != 0)
        return -1;
      return 6;

    case E_HQmode:
      if (pattern310 (x6, 
E_HQmode) != 0)
        return -1;
      return 7;

    case E_V2HAmode:
      if (pattern310 (x6, 
E_V2HAmode) != 0)
        return -1;
      return 8;

    case E_HAmode:
      if (pattern310 (x6, 
E_HAmode) != 0)
        return -1;
      return 9;

    case E_SQmode:
      if (pattern310 (x6, 
E_SQmode) != 0)
        return -1;
      return 10;

    case E_SAmode:
      if (pattern310 (x6, 
E_SAmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 101
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_V4SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[3] = x9;
  if (!s_register_operand (operands[3], E_V4SImode))
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  operands[4] = x10;
  if (!vpr_register_operand (operands[4], E_V4BImode))
    return -1;
  return 0;
}

int
pattern346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode
          || !mve_memory_operand (operands[1], E_V8QImode)
          || !vpr_register_operand (operands[2], E_V8BImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4SImode
          || !vpr_register_operand (operands[2], E_V4BImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4QImode:
          if (!mve_memory_operand (operands[1], E_V4QImode))
            return -1;
          return 1;

        case E_V4HImode:
          if (!mve_memory_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern362 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || !vfp_compare_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || !vfp_compare_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern372 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !neon_logic_op2 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern378 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  return pattern377 (x3); /* [-1, 4] */
}

int
pattern383 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (!rtx_equal_p (x4, operands[3]))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!rtx_equal_p (x5, operands[6]))
            return -1;
          x6 = XVECEXP (x1, 0, 0);
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          if (!dominant_cc_register (operands[0], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 1);
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          if (!arm_add_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x9, 1);
          x14 = XEXP (x13, 0);
          operands[4] = x14;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x15 = XEXP (x13, 1);
          operands[5] = x15;
          if (!arm_add_operand (operands[5], E_SImode))
            return -1;
          x16 = XEXP (x2, 0);
          operands[7] = x16;
          if (!s_register_operand (operands[7], E_SImode))
            return -1;
          return 0;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XVECEXP (x2, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  return 0;
}

int
pattern422 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern421 (x1) != 0)
    return -1;
  return 0;
}

int
pattern429 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !neon_struct_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern436 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !s_register_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern443 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != MEM)
        return -1;
      return 0;

    case REG:
      operands[1] = x3;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      return 1;

    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern457 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!neon_struct_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_MODE (x2))
    {
    case E_V8QImode:
      return 0;

    case E_V16QImode:
      return 1;

    case E_V4HImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V4HFmode:
      return 6;

    case E_V8HFmode:
      return 7;

    case E_V4BFmode:
      return 8;

    case E_V8BFmode:
      return 9;

    case E_V2SFmode:
      return 10;

    case E_V4SFmode:
      return 11;

    case E_DImode:
      return 12;

    case E_V2DImode:
      return 13;

    default:
      return -1;
    }
}

int
pattern473 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!const_double_vcvt_power_of_two_reciprocal (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || GET_MODE (x2) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || GET_MODE (x2) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern487 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
      || !register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern497 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT
      || XWINT (x2, 0) != 32768LL)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT
      || XWINT (x3, 0) != 32768LL)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != 32768LL)
    return -1;
  return 0;
}

int
pattern504 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_OImode:
      if (!s_register_operand (operands[1], E_OImode)
          || GET_MODE (x1) != i1)
        return -1;
      return 0;

    case E_XImode:
      if (!s_register_operand (operands[1], E_XImode)
          || GET_MODE (x1) != i2)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern514 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!mem_noofs_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !reg_or_int_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern523 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !arm_general_register_operand (operands[0], E_SImode)
      || !arm_general_register_operand (operands[1], i1)
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern532 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V8HImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern547 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (!logical_binary_operator (x3, E_SImode))
    return -1;
  operands[9] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[5] = x8;
  if (!s_register_operand (operands[5], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_SImode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[7] = x10;
  if (!s_register_operand (operands[7], E_SImode))
    return -1;
  return 0;
}

int
pattern569 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern576 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern584 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern590 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern602 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern610 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[3] = x1;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case ASHIFTRT:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern622 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !reg_or_int_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern629 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  return 0;
}

int
pattern637 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  x13 = XEXP (x12, 1);
  x14 = XEXP (x13, 0);
  if (!rtx_equal_p (x14, operands[3]))
    return -1;
  return 0;
}

int
pattern644 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x2, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x9, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  return 0;
}

int
pattern654 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CC_RSBmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_CC_RSBmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case SET:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != MINUS
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!arm_immediate_operand (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x6, 1);
      if (!rtx_equal_p (x10, operands[2])
          || !
#line 2101 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && ~UINTVAL (operands[1]) == UINTVAL (operands[3])))
        return -1;
      return 48; /* rsb_imm_compare */

    case CLOBBER:
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!arm_not_immediate_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!scratch_operand (operands[0], E_SImode)
          || !
#line 2113 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 49; /* rsb_imm_compare_scratch */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern256 (x5) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case SMIN:
        case SMAX:
        case UMIN:
        case UMAX:
          operands[4] = x6;
          if (!minmax_operator (operands[4], E_SImode)
              || pattern550 (x3) != 0
              || !
#line 4301 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1])
   && !(arm_restrict_it && CONST_INT_P (operands[3]))))
            return -1;
          return 126; /* *minmax_arithsi_non_canon */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[4] = x6;
          if (!arm_comparison_operator (operands[4], E_SImode)
              || pattern550 (x3) != 0)
            return -1;
          if (
#line 10136 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 339; /* *cond_sub */
          if (!
#line 868 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          return 1038; /* *thumb2_cond_sub */

        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 132 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 943; /* *thumb_subdi3 */

        default:
          return -1;
        }

    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern292 (x1))
        {
        case 0:
          if (!
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3142; /* atomic_sub_fetchqi */

        case 1:
          if (!
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3147; /* atomic_sub_fetchhi */

        case 2:
          if (!
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3152; /* atomic_sub_fetchsi */

        case 3:
          if (!
#line 457 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3157; /* atomic_sub_fetchdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!arm_comparison_operator (x4, E_VOIDmode))
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (!s_register_operand (x5, E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x7;
          if (pattern449 (x1) != 0)
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[2] = x8;
              if (!arm_rhs_operand (operands[2], E_SImode))
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              if (
#line 10807 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 351; /* movcond */
              if (!
#line 1012 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
                return -1;
              return 1043; /* *thumb2_movcond */

            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (arm_add_operand (operands[3], E_SImode)
                  && GET_CODE (x8) == PLUS
                  && GET_MODE (x8) == E_SImode
                  && 
#line 10917 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 354; /* *ifcompare_move_plus */
              if (!arm_rhs_operand (operands[3], E_SImode))
                return -1;
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode)
                  || !
#line 11061 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 360; /* *ifcompare_move_arith */

            case NOT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 11128 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 362; /* *ifcompare_move_not */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[7] = x8;
              if (!shift_operator (operands[7], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (!arm_rhs_operand (operands[3], E_SImode)
                  || !
#line 11241 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 368; /* *ifcompare_move_shift */

            case NEG:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 11429 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 378; /* *ifcompare_move_neg */

            default:
              return -1;
            }

        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          if (pattern449 (x1) != 0)
            return -1;
          x9 = XEXP (x4, 1);
          operands[5] = x9;
          res = recog_19 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!shiftable_operator (x7, E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x13 = XEXP (x7, 1);
          if (!arm_rhs_operand (x13, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode))
                return -1;
              operands[9] = x4;
              operands[5] = x5;
              operands[6] = x9;
              operands[8] = x7;
              operands[1] = x12;
              operands[2] = x13;
              x10 = XEXP (x8, 0);
              operands[3] = x10;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[4] = x11;
              if (!arm_rhs_operand (operands[4], E_SImode)
                  || !
#line 10962 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 356; /* *ifcompare_arith_arith */

            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              operands[6] = x4;
              operands[2] = x5;
              operands[3] = x9;
              operands[7] = x7;
              operands[4] = x12;
              operands[5] = x13;
              if (!
#line 10996 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 358; /* *ifcompare_arith_move */

            case NOT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              operands[5] = x9;
              operands[7] = x7;
              operands[2] = x12;
              operands[3] = x13;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (!s_register_operand (operands[1], E_SImode)
                  || !
#line 11361 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 374; /* *ifcompare_arith_not */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x7) != E_SImode
              || pattern449 (x1) != 0)
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              operands[2] = x12;
              if (!
#line 11163 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 364; /* *ifcompare_not_move */

            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              operands[1] = x12;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (!arm_rhs_operand (operands[3], E_SImode)
                  || !
#line 11327 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 372; /* *ifcompare_not_arith */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (!shift_operator (x7, E_SImode)
              || pattern449 (x1) != 0)
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x13 = XEXP (x7, 1);
          if (!arm_rhs_operand (x13, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              operands[7] = x7;
              operands[2] = x12;
              operands[3] = x13;
              if (!
#line 11198 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 366; /* *ifcompare_shift_move */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[9] = x8;
              if (!shift_operator (operands[9], E_SImode))
                return -1;
              operands[7] = x4;
              operands[5] = x5;
              x9 = XEXP (x4, 1);
              operands[6] = x9;
              operands[8] = x7;
              operands[1] = x12;
              operands[2] = x13;
              x10 = XEXP (x8, 0);
              operands[3] = x10;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[4] = x11;
              if (!arm_rhs_operand (operands[4], E_SImode)
                  || !
#line 11286 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 370; /* *ifcompare_shift_shift */

            default:
              return -1;
            }

        case NEG:
          if (GET_MODE (x7) != E_SImode
              || pattern450 (x1) != 0)
            return -1;
          operands[5] = x4;
          operands[3] = x5;
          x9 = XEXP (x4, 1);
          operands[4] = x9;
          if (!arm_add_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          operands[2] = x12;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          operands[1] = x8;
          if (!arm_not_operand (operands[1], E_SImode)
              || !
#line 11393 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 376; /* *ifcompare_neg_move */

        case LABEL_REF:
          x8 = XEXP (x3, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x14 = XEXP (x2, 0);
          if (GET_CODE (x14) != PC)
            return -1;
          operands[4] = x4;
          operands[1] = x5;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (!thumb1_cmpneg_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          operands[3] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 976; /* cbranchsi4_scratch */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x14 = XEXP (x2, 0);
      if (GET_CODE (x14) != PC)
        return -1;
      x16 = XEXP (x5, 0);
      if (!s_register_operand (x16, E_SImode))
        return -1;
      x17 = XEXP (x5, 1);
      if (!reg_or_int_operand (x17, E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case SET:
          if (pnum_clobbers == NULL)
            return -1;
          x18 = XEXP (x6, 1);
          if (GET_CODE (x18) != PLUS
              || GET_MODE (x18) != E_SImode)
            return -1;
          operands[4] = x4;
          operands[2] = x16;
          operands[3] = x17;
          x12 = XEXP (x7, 0);
          operands[5] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!thumb_cbrch_target_operand (operands[0], E_SImode))
            return -1;
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[3])
              || !
#line 1582 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (GET_CODE (operands[4]) == EQ
       || GET_CODE (operands[4]) == NE
       || GET_CODE (operands[4]) == GE
       || GET_CODE (operands[4]) == LT)))
            return -1;
          *pnum_clobbers = 1;
          return 982; /* *addsi3_cbranch */

        case CLOBBER:
          operands[3] = x4;
          operands[1] = x16;
          operands[2] = x17;
          x12 = XEXP (x7, 0);
          operands[4] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 1661 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (GET_CODE (operands[3]) == EQ
       || GET_CODE (operands[3]) == NE
       || GET_CODE (operands[3]) == GE
       || GET_CODE (operands[3]) == LT)))
            return -1;
          return 983; /* *addsi3_cbranch_scratch */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != SET)
    return -1;
  switch (pattern299 (x1))
    {
    case 0:
      if (pattern422 (x1) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      x9 = XEXP (x5, 0);
      operands[4] = x9;
      x10 = XEXP (x2, 1);
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[5] = x11;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x12 = XEXP (x3, 1);
          x13 = XEXP (x12, 0);
          x14 = XEXP (x13, 1);
          if (XWINT (x14, 0) != 4LL)
            return -1;
          x15 = XEXP (x4, 1);
          x16 = XEXP (x15, 0);
          x17 = XEXP (x16, 1);
          if (XWINT (x17, 0) != 8LL)
            return -1;
          x18 = XEXP (x5, 1);
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != PLUS
              || GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XEXP (x19, 1);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x23 = XEXP (x19, 0);
          if (!rtx_equal_p (x23, operands[5]))
            return -1;
          if (arm_hard_general_register_operand (operands[1], E_SImode)
              && arm_hard_general_register_operand (operands[2], E_SImode)
              && arm_hard_general_register_operand (operands[3], E_SImode)
              && arm_hard_general_register_operand (operands[4], E_SImode)
              && 
#line 37 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
            return 437; /* *ldm4_ */
          if (!low_register_operand (operands[1], E_SImode)
              || !low_register_operand (operands[2], E_SImode)
              || !low_register_operand (operands[3], E_SImode)
              || !low_register_operand (operands[4], E_SImode)
              || !
#line 55 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
            return -1;
          return 438; /* *thumb_ldm4_ia */

        case PLUS:
          if (GET_MODE (x11) != E_SImode)
            return -1;
          x24 = XEXP (x11, 1);
          if (GET_CODE (x24) != CONST_INT
              || !arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x25 = XEXP (x11, 0);
          operands[5] = x25;
          if (!s_register_operand (operands[5], E_SImode)
              || !arm_hard_general_register_operand (operands[2], E_SImode)
              || !arm_hard_general_register_operand (operands[3], E_SImode)
              || !arm_hard_general_register_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x3, 1);
          x13 = XEXP (x12, 0);
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x15 = XEXP (x4, 1);
          x16 = XEXP (x15, 0);
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          switch (XWINT (x24, 0))
            {
            case 4LL:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != 8LL)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != 12LL)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (pattern645 (x19, 
16) != 0
                  || !
#line 160 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 444; /* *ldm4_ib */

            case -12LL:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -8LL)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -4LL)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (!rtx_equal_p (x19, operands[5])
                  || !
#line 231 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 448; /* *ldm4_da */

            case -16LL:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -12LL)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -8LL)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (pattern645 (x19, 
-4) != 0
                  || !
#line 302 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 452; /* *ldm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern480 (x1) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x15 = XEXP (x4, 1);
      operands[3] = x15;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x18 = XEXP (x5, 1);
      operands[4] = x18;
      if (!arm_hard_general_register_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      x26 = XEXP (x6, 0);
      switch (GET_CODE (x26))
        {
        case REG:
        case SUBREG:
          operands[5] = x26;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x7 = XEXP (x3, 0);
          x27 = XEXP (x7, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != 4LL)
            return -1;
          x8 = XEXP (x4, 0);
          x29 = XEXP (x8, 0);
          x30 = XEXP (x29, 1);
          if (XWINT (x30, 0) != 8LL)
            return -1;
          x9 = XEXP (x5, 0);
          x31 = XEXP (x9, 0);
          if (GET_CODE (x31) != PLUS
              || GET_MODE (x31) != E_SImode)
            return -1;
          x32 = XEXP (x31, 1);
          if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x33 = XEXP (x27, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x34 = XEXP (x29, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          x35 = XEXP (x31, 0);
          if (!rtx_equal_p (x35, operands[5])
              || !
#line 108 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
            return -1;
          return 441; /* *stm4_ */

        case PLUS:
          if (GET_MODE (x26) != E_SImode)
            return -1;
          x36 = XEXP (x26, 1);
          if (GET_CODE (x36) != CONST_INT)
            return -1;
          x37 = XEXP (x26, 0);
          operands[5] = x37;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x7 = XEXP (x3, 0);
          x27 = XEXP (x7, 0);
          x33 = XEXP (x27, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x8 = XEXP (x4, 0);
          x29 = XEXP (x8, 0);
          x34 = XEXP (x29, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          switch (XWINT (x36, 0))
            {
            case 4LL:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != 8LL)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != 12LL)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (pattern646 (x31, 
16) != 0
                  || !
#line 196 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 446; /* *stm4_ib */

            case -12LL:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != -8LL)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -4LL)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (!rtx_equal_p (x31, operands[5])
                  || !
#line 266 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 450; /* *stm4_da */

            case -16LL:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != -12LL)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -8LL)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (pattern646 (x31, 
-4) != 0
                  || !
#line 338 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 454; /* *stm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x6 = XEXP (x2, 0);
      operands[4] = x6;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x10 = XEXP (x2, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[4]))
        return -1;
      x38 = XEXP (x10, 1);
      switch (XWINT (x38, 0))
        {
        case 12LL:
          switch (pattern496 (x3))
            {
            case 0:
              if (pattern421 (x1) != 0)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (GET_CODE (x19) != PLUS
                  || GET_MODE (x19) != E_SImode)
                return -1;
              x20 = XEXP (x19, 1);
              if (GET_CODE (x20) != CONST_INT
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x7 = XEXP (x3, 0);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              x15 = XEXP (x4, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x23 = XEXP (x19, 0);
              if (!rtx_equal_p (x23, operands[4]))
                return -1;
              switch (pattern633 (x1))
                {
                case 0:
                  x12 = XEXP (x3, 1);
                  x13 = XEXP (x12, 0);
                  if (!rtx_equal_p (x13, operands[4]))
                    return -1;
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != 4LL
                      || XWINT (x20, 0) != 8LL)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && arm_hard_general_register_operand (operands[3], E_SImode)
                      && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return 458; /* *ldm3_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !low_register_operand (operands[3], E_SImode)
                      || !
#line 525 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 459; /* *thumb_ldm3_ia_update */

                case 1:
                  if (!arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode)
                      || !arm_hard_general_register_operand (operands[3], E_SImode))
                    return -1;
                  x12 = XEXP (x3, 1);
                  x13 = XEXP (x12, 0);
                  x21 = XEXP (x13, 0);
                  if (!rtx_equal_p (x21, operands[4])
                      || !
#line 600 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 464; /* *ldm3_ib_update */

                default:
                  return -1;
                }

            case 1:
              if (pattern479 (x1) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (GET_CODE (x31) != PLUS
                  || GET_MODE (x31) != E_SImode)
                return -1;
              x32 = XEXP (x31, 1);
              if (GET_CODE (x32) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x4, 1);
              operands[2] = x15;
              x18 = XEXP (x5, 1);
              operands[3] = x18;
              x8 = XEXP (x4, 0);
              x29 = XEXP (x8, 0);
              x34 = XEXP (x29, 0);
              if (!rtx_equal_p (x34, operands[4]))
                return -1;
              x35 = XEXP (x31, 0);
              if (!rtx_equal_p (x35, operands[4]))
                return -1;
              switch (pattern635 (x1))
                {
                case 0:
                  x7 = XEXP (x3, 0);
                  x27 = XEXP (x7, 0);
                  if (!rtx_equal_p (x27, operands[4]))
                    return -1;
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != 4LL
                      || XWINT (x32, 0) != 8LL)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && arm_hard_general_register_operand (operands[3], E_SImode)
                      && 
#line 552 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return 461; /* *stm3_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !low_register_operand (operands[3], E_SImode)
                      || !
#line 567 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 462; /* *thumb_stm3_ia_update */

                case 1:
                  if (!arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode)
                      || !arm_hard_general_register_operand (operands[3], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 0);
                  x27 = XEXP (x7, 0);
                  x33 = XEXP (x27, 0);
                  if (!rtx_equal_p (x33, operands[4])
                      || !
#line 628 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 466; /* *stm3_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -12LL:
          x12 = XEXP (x3, 1);
          switch (GET_CODE (x12))
            {
            case MEM:
              if (pattern422 (x1) != 0
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x7 = XEXP (x3, 0);
              operands[1] = x7;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x13 = XEXP (x12, 0);
              x21 = XEXP (x13, 0);
              if (!rtx_equal_p (x21, operands[4]))
                return -1;
              x15 = XEXP (x4, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x14 = XEXP (x13, 1);
              switch (XWINT (x14, 0))
                {
                case -8LL:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -4LL)
                    return -1;
                  x18 = XEXP (x5, 1);
                  x19 = XEXP (x18, 0);
                  if (!rtx_equal_p (x19, operands[4])
                      || !
#line 660 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 468; /* *ldm3_da_update */

                case -12LL:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -8LL)
                    return -1;
                  x18 = XEXP (x5, 1);
                  x19 = XEXP (x18, 0);
                  if (GET_CODE (x19) != PLUS
                      || GET_MODE (x19) != E_SImode)
                    return -1;
                  x20 = XEXP (x19, 1);
                  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x23 = XEXP (x19, 0);
                  if (!rtx_equal_p (x23, operands[4])
                      || !
#line 722 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 472; /* *ldm3_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x12;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern480 (x1) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x4, 1);
              operands[2] = x15;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x18 = XEXP (x5, 1);
              operands[3] = x18;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x7 = XEXP (x3, 0);
              x27 = XEXP (x7, 0);
              x33 = XEXP (x27, 0);
              if (!rtx_equal_p (x33, operands[4]))
                return -1;
              x8 = XEXP (x4, 0);
              x29 = XEXP (x8, 0);
              x34 = XEXP (x29, 0);
              if (!rtx_equal_p (x34, operands[4]))
                return -1;
              x28 = XEXP (x27, 1);
              switch (XWINT (x28, 0))
                {
                case -8LL:
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != -4LL)
                    return -1;
                  x9 = XEXP (x5, 0);
                  x31 = XEXP (x9, 0);
                  if (!rtx_equal_p (x31, operands[4])
                      || !
#line 688 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 470; /* *stm3_da_update */

                case -12LL:
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != -8LL)
                    return -1;
                  x9 = XEXP (x5, 0);
                  x31 = XEXP (x9, 0);
                  if (GET_CODE (x31) != PLUS
                      || GET_MODE (x31) != E_SImode)
                    return -1;
                  x32 = XEXP (x31, 1);
                  if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x35 = XEXP (x31, 0);
                  if (!rtx_equal_p (x35, operands[4])
                      || !
#line 750 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 474; /* *stm3_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2435; /* neon_vrsras_nv8qi */

    case 1:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2439; /* neon_vrsras_nv16qi */

    case 2:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2443; /* neon_vrsras_nv4hi */

    case 3:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2447; /* neon_vrsras_nv8hi */

    case 4:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2451; /* neon_vrsras_nv2si */

    case 5:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2455; /* neon_vrsras_nv4si */

    case 6:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2459; /* neon_vrsras_ndi */

    case 7:
      if (!
#line 4630 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2463; /* neon_vrsras_nv2di */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern46 (x1, 
E_XImode, 
E_OImode))
    {
    case 0:
      if (!
#line 6025 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2909; /* neon_vld4qbv16qi */

    case 1:
      if (!
#line 6025 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2910; /* neon_vld4qbv8hi */

    case 2:
      if (!
#line 6025 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2911; /* neon_vld4qbv8hf */

    case 3:
      if (!(
#line 6025 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2912; /* neon_vld4qbv8bf */

    case 4:
      if (!
#line 6025 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2913; /* neon_vld4qbv4si */

    case 5:
      if (!
#line 6025 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2914; /* neon_vld4qbv4sf */

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern42 (x1))
    {
    case 0:
      if (!
#line 3954 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2191; /* neon_vqrdmulh_lanev8hi */

    case 1:
      if (!
#line 3954 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2193; /* neon_vqrdmulh_lanev4si */

    case 2:
      if (!
#line 3968 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2195; /* neon_vqrdmulh_lanev4hi */

    case 3:
      if (!
#line 3968 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2197; /* neon_vqrdmulh_lanev2si */

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !mve_memory_operand (operands[1], E_V16QImode)
          || !
#line 3229 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4836; /* mve_vldrq_v16qi */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !mve_memory_operand (operands[1], E_V8HImode)
          || !
#line 3229 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4837; /* mve_vldrq_v8hi */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !mve_memory_operand (operands[1], E_V4SImode)
          || !
#line 3229 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4838; /* mve_vldrq_v4si */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !mve_memory_operand (operands[1], E_V8HFmode)
          || !
#line 3229 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4839; /* mve_vldrq_v8hf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !mve_memory_operand (operands[1], E_V4SFmode)
          || !
#line 3229 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4840; /* mve_vldrq_v4sf */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!memory_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !s_register_operand (operands[1], E_DImode)
          || !
#line 5061 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && TARGET_LDRD))
        return -1;
      return 161; /* unaligned_storedi */

    case E_SImode:
      if (!mem_and_no_t1_wback_op (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_SImode)
          || !
#line 5072 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(unaligned_access))
        return -1;
      return 162; /* unaligned_storesi */

    case E_HImode:
      if (!mem_and_no_t1_wback_op (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !s_register_operand (operands[1], E_HImode)
          || !
#line 5087 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(unaligned_access))
        return -1;
      return 163; /* unaligned_storehi */

    case E_V8QImode:
      if (!memory_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 30 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1077; /* unaligned_storev8qi */

    default:
      return -1;
    }
}

 int
recog_122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern105 (x1))
    {
    case 0:
      if (!
#line 3718 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2108; /* neon_vcvtsv2sf */

    case 1:
      if (!
#line 3718 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2110; /* neon_vcvtsv4sf */

    case 2:
      if (!
#line 3727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2112; /* neon_vcvtsv2si */

    case 3:
      if (!
#line 3727 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2114; /* neon_vcvtsv4si */

    case 4:
      if (!
#line 3756 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2118; /* neon_vcvtsv4hi */

    case 5:
      if (!
#line 3756 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2120; /* neon_vcvtsv8hi */

    case 6:
      if (!
#line 3767 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2122; /* neon_vcvtsv8hf */

    case 7:
      if (!
#line 3767 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2124; /* neon_vcvtsv4hf */

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (pattern392 (x2, 
E_V4HImode) != 0
          || !
#line 111 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 695; /* addcv4hi3 */

    case E_V2SImode:
      if (pattern392 (x2, 
E_V2SImode) != 0
          || !
#line 111 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 696; /* addcv2si3 */

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern159 (x1))
    {
    case 0:
      if (!s_register_operand (operands[0], E_TImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_TImode
          || !neon_struct_operand (operands[1], E_TImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5417 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2772; /* neon_vld2v8qi */

        case E_V4HImode:
          if (!
#line 5417 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2773; /* neon_vld2v4hi */

        case E_V4HFmode:
          if (!
#line 5417 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2774; /* neon_vld2v4hf */

        case E_V4BFmode:
          if (!(
#line 5417 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2775; /* neon_vld2v4bf */

        case E_V2SImode:
          if (!
#line 5417 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2776; /* neon_vld2v2si */

        case E_V2SFmode:
          if (!
#line 5417 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2777; /* neon_vld2v2sf */

        case E_DImode:
          if (!
#line 5417 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2778; /* neon_vld2di */

        default:
          return -1;
        }

    case 1:
      if (!s_register_operand (operands[0], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_OImode
          || !neon_struct_operand (operands[1], E_OImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V16QImode:
          if (!
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2779; /* neon_vld2v16qi */

        case E_V8HImode:
          if (!
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2780; /* neon_vld2v8hi */

        case E_V8HFmode:
          if (!
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2781; /* neon_vld2v8hf */

        case E_V8BFmode:
          if (!(
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2782; /* neon_vld2v8bf */

        case E_V4SImode:
          if (!
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2783; /* neon_vld2v4si */

        case E_V4SFmode:
          if (!
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2784; /* neon_vld2v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !const_int_vcde1_operand (operands[2], E_SImode)
          || !
#line 2192 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 929; /* arm_vcx1si */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !const_int_vcde1_operand (operands[2], E_SImode)
          || !
#line 2192 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 930; /* arm_vcx1di */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !const_int_mve_cde1_operand (operands[2], E_SImode)
          || !
#line 4436 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5045; /* arm_vcx1qv16qi */

    default:
      return -1;
    }
}

 int
recog_152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V16QImode, 
E_V2x16QImode) != 0
          || !
#line 4072 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x16QImode))))
        return -1;
      return 4992; /* mve_vst2qv16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HImode, 
E_V2x8HImode) != 0
          || !
#line 4072 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HImode))))
        return -1;
      return 4993; /* mve_vst2qv8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SImode, 
E_V2x4SImode) != 0
          || !
#line 4072 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SImode))))
        return -1;
      return 4994; /* mve_vst2qv4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HFmode, 
E_V2x8HFmode) != 0
          || !
#line 4072 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HFmode))))
        return -1;
      return 4995; /* mve_vst2qv8hf */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SFmode, 
E_V2x4SFmode) != 0
          || !
#line 4072 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SFmode))))
        return -1;
      return 4996; /* mve_vst2qv4sf */

    default:
      return -1;
    }
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      switch (pattern346 (x3))
        {
        case 0:
          if (!
#line 3298 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4852; /* mve_vldrq_z_extend_v8qis */

        case 1:
          if (!
#line 3298 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4854; /* mve_vldrq_z_extend_v4qis */

        case 2:
          if (!
#line 3298 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4856; /* mve_vldrq_z_extend_v4his */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern346 (x3))
        {
        case 0:
          if (!
#line 3298 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4853; /* mve_vldrq_z_extend_v8qiu */

        case 1:
          if (!
#line 3298 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4855; /* mve_vldrq_z_extend_v4qiu */

        case 2:
          if (!
#line 3298 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4857; /* mve_vldrq_z_extend_v4hiu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2310; /* neon_vqrshluv8qi */

    case 1:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2314; /* neon_vqrshluv16qi */

    case 2:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2318; /* neon_vqrshluv4hi */

    case 3:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2322; /* neon_vqrshluv8hi */

    case 4:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2326; /* neon_vqrshluv2si */

    case 5:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2330; /* neon_vqrshluv4si */

    case 6:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2334; /* neon_vqrshludi */

    case 7:
      if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2338; /* neon_vqrshluv2di */

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 2796 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1909; /* neon_vrecpsv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 2796 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1910; /* neon_vrecpsv4sf */

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0
          || !
#line 2807 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1911; /* neon_vrecpsv8hf */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 2807 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1912; /* neon_vrecpsv4hf */

    default:
      return -1;
    }
}

 int
recog_188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern160 (x1, 
E_OImode))
    {
    case 0:
      if (!
#line 5971 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2896; /* neon_vld4v8qi */

    case 1:
      if (!
#line 5971 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2897; /* neon_vld4v4hi */

    case 2:
      if (!
#line 5971 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2898; /* neon_vld4v4hf */

    case 3:
      if (!(
#line 5971 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2899; /* neon_vld4v4bf */

    case 4:
      if (!
#line 5971 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2900; /* neon_vld4v2si */

    case 5:
      if (!
#line 5971 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2901; /* neon_vld4v2sf */

    case 6:
      if (!
#line 5971 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2902; /* neon_vld4di */

    default:
      return -1;
    }
}

 int
recog_198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern130 (x1))
    {
    case 0:
      if (!
#line 2095 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 920; /* neon_vminnmhf */

    case 1:
      if (!
#line 2106 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
        return -1;
      return 922; /* fminsf3 */

    case 2:
      if (!(
#line 2106 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
        return -1;
      return 924; /* fmindf3 */

    case 3:
      if (!
#line 2725 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1862; /* neon_vminnmv8hf */

    case 4:
      if (!
#line 2725 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1864; /* neon_vminnmv4hf */

    case 5:
      if (!
#line 2736 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
        return -1;
      return 1866; /* neon_vminnmv2sf */

    case 6:
      if (!
#line 2736 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
        return -1;
      return 1868; /* neon_vminnmv4sf */

    default:
      return -1;
    }
}

 int
recog_209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1830; /* neon_vminuv8qi */

    case 1:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1834; /* neon_vminuv16qi */

    case 2:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1838; /* neon_vminuv4hi */

    case 3:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1842; /* neon_vminuv8hi */

    case 4:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1846; /* neon_vminuv2si */

    case 5:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1850; /* neon_vminuv4si */

    default:
      return -1;
    }
}

 int
recog_219 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1484; /* neon_vrhaddsv8qi */

    case 1:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1488; /* neon_vrhaddsv16qi */

    case 2:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1492; /* neon_vrhaddsv4hi */

    case 3:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1496; /* neon_vrhaddsv8hi */

    case 4:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1500; /* neon_vrhaddsv2si */

    case 5:
      if (!
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1504; /* neon_vrhaddsv4si */

    default:
      return -1;
    }
}

 int
recog_231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1711; /* neon_vclev2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1716; /* neon_vclev4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1731; /* neon_vclev8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1736; /* neon_vclev4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!usat16_imm (operands[2], E_SImode)
      || !
#line 6166 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
    return -1;
  return 252; /* arm_usat16_insn */
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern232 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3622 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4919; /* mve_vldrq_gather_shifted_offset_z_v8hi */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3622 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4920; /* mve_vldrq_gather_shifted_offset_z_v4si */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V8BImode, 
E_V8HImode, 
E_V8HFmode) != 0
          || !
#line 3622 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4921; /* mve_vldrq_gather_shifted_offset_z_v8hf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V4BImode, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 3622 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4922; /* mve_vldrq_gather_shifted_offset_z_v4sf */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V2QImode, 
E_V2DImode) != 0
          || !
#line 3622 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4923; /* mve_vldrq_gather_shifted_offset_z_v2di */

    default:
      return -1;
    }
}

 int
recog_257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_ccde3_operand (operands[4], E_SImode))
    return -1;
  switch (pattern393 (x3))
    {
    case 0:
      if (!
#line 4574 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 147; /* arm_cx3si */

    case 1:
      if (!
#line 4574 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 148; /* arm_cx3di */

    default:
      return -1;
    }
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 30:
      if (pattern94 (x2, 
104, 
E_CCmode) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode)
          || !
#line 4419 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM_QBIT))
        return -1;
      return 131; /* arm_get_apsr */

    case 25:
      return recog_123 (x1, insn, pnum_clobbers);

    case 26:
      return recog_113 (x1, insn, pnum_clobbers);

    case 45:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 6056 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 190; /* arm_sxtb16 */

    case 46:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 6056 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 191; /* arm_uxtb16 */

    case 1:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (
#line 6711 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && flag_pic))
        return 259; /* pic_load_addr_32bit */
      if (!
#line 6727 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_THUMB1 && flag_pic))
        return -1;
      return 260; /* pic_load_addr_thumb1 */

    case 38:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_SImode)
          || !
#line 9262 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 306; /* probe_stack */

    case 40:
      return recog_133 (x1, insn, pnum_clobbers);

    case 22:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 12201 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2))
        return -1;
      return 400; /* arm_rbit */

    case 17:
      return recog_116 (x1, insn, pnum_clobbers);

    case 15:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode)
          || !
#line 560 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 577; /* iwmmxt_clrdi */

    case 8:
      switch (pattern95 (x1, 
E_SImode))
        {
        case 0:
          if (!
#line 1579 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 671; /* iwmmxt_tmovmskb */

        case 1:
          if (!
#line 1588 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 672; /* iwmmxt_tmovmskh */

        case 2:
          if (!
#line 1597 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 673; /* iwmmxt_tmovmskw */

        default:
          return -1;
        }

    case 7:
      switch (pattern95 (x1, 
E_DImode))
        {
        case 0:
          if (!
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 674; /* iwmmxt_waccb */

        case 1:
          if (!
#line 1615 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 675; /* iwmmxt_wacch */

        case 2:
          if (!
#line 1624 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 676; /* iwmmxt_waccw */

        default:
          return -1;
        }

    case 16:
      return recog_111 (x1, insn, pnum_clobbers);

    case 109:
      return recog_115 (x1, insn, pnum_clobbers);

    case 108:
      return recog_132 (x1, insn, pnum_clobbers);

    case 363:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 788; /* neon_vrndhf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1329; /* neon_vrndv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1335; /* neon_vrndv4hf */

        default:
          return -1;
        }

    case 364:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 789; /* neon_vrndahf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1330; /* neon_vrndav8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1336; /* neon_vrndav4hf */

        default:
          return -1;
        }

    case 366:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 790; /* neon_vrndmhf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1331; /* neon_vrndmv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1337; /* neon_vrndmv4hf */

        default:
          return -1;
        }

    case 367:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 791; /* neon_vrndnhf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1332; /* neon_vrndnv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1338; /* neon_vrndnv4hf */

        default:
          return -1;
        }

    case 368:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 792; /* neon_vrndphf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1333; /* neon_vrndpv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1339; /* neon_vrndpv4hf */

        default:
          return -1;
        }

    case 369:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 793; /* neon_vrndxhf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1334; /* neon_vrndxv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1340; /* neon_vrndxv4hf */

        default:
          return -1;
        }

    case 365:
      if (GET_MODE (x2) != E_HFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_HFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_HFmode)
          || !
#line 982 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 794; /* neon_vrndihf */

    case 181:
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 1907 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 874; /* neon_vcvthshf */

        case 1:
          if (!
#line 1918 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 876; /* neon_vcvthssi */

        default:
          return -1;
        }

    case 182:
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 1907 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 875; /* neon_vcvthuhf */

        case 1:
          if (!
#line 1918 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 877; /* neon_vcvthusi */

        default:
          return -1;
        }

    case 183:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 882; /* neon_vcvtahssi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2142; /* neon_vcvtasv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2150; /* neon_vcvtasv4hf */

        default:
          return -1;
        }

    case 184:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 883; /* neon_vcvtahusi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2143; /* neon_vcvtauv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2151; /* neon_vcvtauv4hf */

        default:
          return -1;
        }

    case 185:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 884; /* neon_vcvtmhssi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2144; /* neon_vcvtmsv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2152; /* neon_vcvtmsv4hf */

        default:
          return -1;
        }

    case 186:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 885; /* neon_vcvtmhusi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2145; /* neon_vcvtmuv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2153; /* neon_vcvtmuv4hf */

        default:
          return -1;
        }

    case 187:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 886; /* neon_vcvtnhssi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2146; /* neon_vcvtnsv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2154; /* neon_vcvtnsv4hf */

        default:
          return -1;
        }

    case 188:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 887; /* neon_vcvtnhusi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2147; /* neon_vcvtnuv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2155; /* neon_vcvtnuv4hf */

        default:
          return -1;
        }

    case 189:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 888; /* neon_vcvtphssi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2148; /* neon_vcvtpsv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2156; /* neon_vcvtpsv4hf */

        default:
          return -1;
        }

    case 190:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 889; /* neon_vcvtphusi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2149; /* neon_vcvtpuv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2157; /* neon_vcvtpuv4hf */

        default:
          return -1;
        }

    case 32:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 891; /* btruncsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 897; /* btruncdf2 */

        default:
          return -1;
        }

    case 33:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 892; /* ceilsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 898; /* ceildf2 */

        default:
          return -1;
        }

    case 34:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 893; /* floorsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 899; /* floordf2 */

        default:
          return -1;
        }

    case 35:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 894; /* nearbyintsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 900; /* nearbyintdf2 */

        default:
          return -1;
        }

    case 36:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 895; /* rintsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 901; /* rintdf2 */

        default:
          return -1;
        }

    case 37:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 896; /* roundsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 902; /* rounddf2 */

        default:
          return -1;
        }

    case 106:
      if (pattern100 (x1, 
E_SImode, 
14) != 0
          || !
#line 1832 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_32BIT && TARGET_HAVE_LOB))
        return -1;
      return 1076; /* dls_insn */

    case 352:
      return recog_103 (x1, insn, pnum_clobbers);

    case 356:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1219; /* neon_vrintpv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1225; /* neon_vrintpv4sf */

        default:
          return -1;
        }

    case 355:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1220; /* neon_vrintzv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1226; /* neon_vrintzv4sf */

        default:
          return -1;
        }

    case 357:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1221; /* neon_vrintmv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1227; /* neon_vrintmv4sf */

        default:
          return -1;
        }

    case 358:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1222; /* neon_vrintxv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1228; /* neon_vrintxv4sf */

        default:
          return -1;
        }

    case 359:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1223; /* neon_vrintav2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1229; /* neon_vrintav4sf */

        default:
          return -1;
        }

    case 360:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1224; /* neon_vrintnv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1230; /* neon_vrintnv4sf */

        default:
          return -1;
        }

    case 298:
      return recog_131 (x1, insn, pnum_clobbers);

    case 145:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 968 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1397; /* neon_load_count */

    case 250:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V2DImode)
          || !
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
        return -1;
      return 1434; /* arm_reduc_plus_internal_v2di */

    case 251:
      return recog_129 (x1, insn, pnum_clobbers);

    case 252:
      return recog_130 (x1, insn, pnum_clobbers);

    case 261:
      return recog_128 (x1, insn, pnum_clobbers);

    case 277:
      return recog_127 (x1, insn, pnum_clobbers);

    case 170:
      return recog_126 (x1, insn, pnum_clobbers);

    case 293:
      return recog_125 (x1, insn, pnum_clobbers);

    case 173:
      return recog_122 (x1, insn, pnum_clobbers);

    case 174:
      return recog_121 (x1, insn, pnum_clobbers);

    case 172:
      return recog_120 (x1, insn, pnum_clobbers);

    case 240:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3841 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2158; /* neon_vmovnv8hi */

        case 1:
          if (!
#line 3841 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2159; /* neon_vmovnv4si */

        case 2:
          if (!
#line 3841 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2160; /* neon_vmovnv2di */

        default:
          return -1;
        }

    case 274:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3850 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2161; /* neon_vqmovnsv8hi */

        case 1:
          if (!
#line 3850 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2163; /* neon_vqmovnsv4si */

        case 2:
          if (!
#line 3850 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2165; /* neon_vqmovnsv2di */

        default:
          return -1;
        }

    case 275:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3850 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2162; /* neon_vqmovnuv8hi */

        case 1:
          if (!
#line 3850 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2164; /* neon_vqmovnuv4si */

        case 2:
          if (!
#line 3850 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2166; /* neon_vqmovnuv2di */

        default:
          return -1;
        }

    case 276:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3859 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2167; /* neon_vqmovunv8hi */

        case 1:
          if (!
#line 3859 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2168; /* neon_vqmovunv4si */

        case 2:
          if (!
#line 3859 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2169; /* neon_vqmovunv2di */

        default:
          return -1;
        }

    case 238:
      switch (pattern109 (x1))
        {
        case 0:
          if (!
#line 3868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2170; /* neon_vmovlsv8qi */

        case 1:
          if (!
#line 3868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2172; /* neon_vmovlsv4hi */

        case 2:
          if (!
#line 3868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2174; /* neon_vmovlsv2si */

        default:
          return -1;
        }

    case 239:
      switch (pattern109 (x1))
        {
        case 0:
          if (!
#line 3868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2171; /* neon_vmovluv8qi */

        case 1:
          if (!
#line 3868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2173; /* neon_vmovluv4hi */

        case 2:
          if (!
#line 3868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2175; /* neon_vmovluv2si */

        default:
          return -1;
        }

    case 297:
      return recog_106 (x1, insn, pnum_clobbers);

    case 296:
      return recog_112 (x1, insn, pnum_clobbers);

    case 295:
      return recog_119 (x1, insn, pnum_clobbers);

    case 198:
      return recog_105 (x1, insn, pnum_clobbers);

    case 319:
      return recog_104 (x1, insn, pnum_clobbers);

    case 392:
      return recog_107 (x1, insn, pnum_clobbers);

    case 393:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8BFmode)
          || !
#line 6717 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 3035; /* neon_vbfcvt_highv8bf */

    case 132:
      switch (pattern110 (x1, 
130))
        {
        case 0:
          if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 3043; /* crypto_aesmc */

        case 1:
          if (!
#line 144 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO
   && arm_fusion_enabled_p (tune_params::FUSE_AES_AESMC)))
            return -1;
          return 3052; /* *aarch32_crypto_aese_fused */

        default:
          return -1;
        }

    case 131:
      switch (pattern110 (x1, 
129))
        {
        case 0:
          if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 3044; /* crypto_aesimc */

        case 1:
          if (!
#line 183 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO
   && arm_fusion_enabled_p (tune_params::FUSE_AES_AESMC)))
            return -1;
          return 3054; /* *aarch32_crypto_aesd_fused */

        default:
          return -1;
        }

    case 129:
      if (pattern111 (x1) != 0
          || !
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3045; /* *crypto_aesd_insn */

    case 130:
      if (pattern111 (x1) != 0
          || !
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3046; /* *crypto_aese_insn */

    case 133:
      return recog_110 (x1, insn, pnum_clobbers);

    case 137:
      return recog_118 (x1, insn, pnum_clobbers);

    case 24:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0])
          || !
#line 49 "../../gcc-15.1.1-20250425/gcc/config/arm/sync.md"
(TARGET_HAVE_MEMORY_BARRIER))
        return -1;
      return 3067; /* *memory_barrier */

    case 399:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3257; /* mve_vrndq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3263; /* mve_vrndq_fv4sf */

        default:
          return -1;
        }

    case 403:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3258; /* mve_vrndaq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3264; /* mve_vrndaq_fv4sf */

        default:
          return -1;
        }

    case 402:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3259; /* mve_vrndmq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3265; /* mve_vrndmq_fv4sf */

        default:
          return -1;
        }

    case 401:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3260; /* mve_vrndnq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3266; /* mve_vrndnq_fv4sf */

        default:
          return -1;
        }

    case 400:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3261; /* mve_vrndpq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3267; /* mve_vrndpq_fv4sf */

        default:
          return -1;
        }

    case 398:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3262; /* mve_vrndxq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3268; /* mve_vrndxq_fv4sf */

        default:
          return -1;
        }

    case 404:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 174 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3269; /* mve_vrev64q_fv8hf */

        case 1:
          if (!
#line 174 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3270; /* mve_vrev64q_fv4sf */

        default:
          return -1;
        }

    case 406:
      if (GET_MODE (x2) != E_V8HFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V8HFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V8HFmode)
          || !
#line 204 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3275; /* mve_vrev32q_fv8hf */

    case 408:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V8HFmode)
          || !
#line 220 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3276; /* mve_vcvtbq_f32_f16v4sf */

    case 407:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V8HFmode)
          || !
#line 220 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3277; /* mve_vcvttq_f32_f16v4sf */

    case 409:
      switch (pattern114 (x1))
        {
        case 0:
          if (!
#line 235 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3278; /* mve_vcvtq_to_f_sv8hf */

        case 1:
          if (!
#line 235 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3280; /* mve_vcvtq_to_f_sv4sf */

        default:
          return -1;
        }

    case 411:
      switch (pattern114 (x1))
        {
        case 0:
          if (!
#line 235 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3279; /* mve_vcvtq_to_f_uv8hf */

        case 1:
          if (!
#line 235 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3281; /* mve_vcvtq_to_f_uv4sf */

        default:
          return -1;
        }

    case 419:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 250 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3282; /* mve_vrev64q_sv16qi */

        case 1:
          if (!
#line 250 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3284; /* mve_vrev64q_sv8hi */

        case 2:
          if (!
#line 250 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3286; /* mve_vrev64q_sv4si */

        default:
          return -1;
        }

    case 420:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 250 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3283; /* mve_vrev64q_uv16qi */

        case 1:
          if (!
#line 250 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3285; /* mve_vrev64q_uv8hi */

        case 2:
          if (!
#line 250 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3287; /* mve_vrev64q_uv4si */

        default:
          return -1;
        }

    case 433:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 265 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3288; /* mve_vcvtq_from_f_sv8hi */

        case 1:
          if (!
#line 265 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3290; /* mve_vcvtq_from_f_sv4si */

        default:
          return -1;
        }

    case 434:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 265 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3289; /* mve_vcvtq_from_f_uv8hi */

        case 1:
          if (!
#line 265 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3291; /* mve_vcvtq_from_f_uv4si */

        default:
          return -1;
        }

    case 424:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3304; /* mve_vclsq_sv16qi */

        case 1:
          if (!
#line 339 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3307; /* mve_vclsq_sv8hi */

        case 2:
          if (!
#line 339 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3310; /* mve_vclsq_sv4si */

        default:
          return -1;
        }

    case 421:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3305; /* mve_vqabsq_sv16qi */

        case 1:
          if (!
#line 339 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3308; /* mve_vqabsq_sv8hi */

        case 2:
          if (!
#line 339 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3311; /* mve_vqabsq_sv4si */

        default:
          return -1;
        }

    case 410:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3306; /* mve_vqnegq_sv16qi */

        case 1:
          if (!
#line 339 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3309; /* mve_vqnegq_sv8hi */

        case 2:
          if (!
#line 339 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3312; /* mve_vqnegq_sv4si */

        default:
          return -1;
        }

    case 426:
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3313; /* mve_vaddvq_uv16qi */

        case 1:
          if (!
#line 354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3315; /* mve_vaddvq_uv8hi */

        case 2:
          if (!
#line 354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3317; /* mve_vaddvq_uv4si */

        default:
          return -1;
        }

    case 425:
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3314; /* mve_vaddvq_sv16qi */

        case 1:
          if (!
#line 354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3316; /* mve_vaddvq_sv8hi */

        case 2:
          if (!
#line 354 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3318; /* mve_vaddvq_sv4si */

        default:
          return -1;
        }

    case 427:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 370 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3319; /* mve_vrev32q_uv16qi */

        case 1:
          if (!
#line 370 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3321; /* mve_vrev32q_uv8hi */

        default:
          return -1;
        }

    case 428:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 370 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3320; /* mve_vrev32q_sv16qi */

        case 1:
          if (!
#line 370 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3322; /* mve_vrev32q_sv8hi */

        default:
          return -1;
        }

    case 431:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3323; /* mve_vmovlbq_sv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3327; /* mve_vmovlbq_sv8hi */

        default:
          return -1;
        }

    case 432:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3324; /* mve_vmovlbq_uv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3328; /* mve_vmovlbq_uv8hi */

        default:
          return -1;
        }

    case 429:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3325; /* mve_vmovltq_uv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3329; /* mve_vmovltq_uv8hi */

        default:
          return -1;
        }

    case 430:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3326; /* mve_vmovltq_sv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3330; /* mve_vmovltq_sv8hi */

        default:
          return -1;
        }

    case 417:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3331; /* mve_vcvtaq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3339; /* mve_vcvtaq_sv4si */

        default:
          return -1;
        }

    case 418:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3332; /* mve_vcvtaq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3340; /* mve_vcvtaq_uv4si */

        default:
          return -1;
        }

    case 439:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3333; /* mve_vcvtmq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3341; /* mve_vcvtmq_sv4si */

        default:
          return -1;
        }

    case 440:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3334; /* mve_vcvtmq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3342; /* mve_vcvtmq_uv4si */

        default:
          return -1;
        }

    case 437:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3335; /* mve_vcvtnq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3343; /* mve_vcvtnq_sv4si */

        default:
          return -1;
        }

    case 438:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3336; /* mve_vcvtnq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3344; /* mve_vcvtnq_uv4si */

        default:
          return -1;
        }

    case 435:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3337; /* mve_vcvtpq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3345; /* mve_vcvtpq_sv4si */

        default:
          return -1;
        }

    case 436:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3338; /* mve_vcvtpq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3346; /* mve_vcvtpq_uv4si */

        default:
          return -1;
        }

    case 416:
      switch (pattern121 (x1))
        {
        case 0:
          if (!
#line 419 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3347; /* mve_vmvnq_n_uv8hi */

        case 1:
          if (!
#line 419 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3349; /* mve_vmvnq_n_uv4si */

        default:
          return -1;
        }

    case 415:
      switch (pattern121 (x1))
        {
        case 0:
          if (!
#line 419 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3348; /* mve_vmvnq_n_sv8hi */

        case 1:
          if (!
#line 419 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3350; /* mve_vmvnq_n_sv4si */

        default:
          return -1;
        }

    case 413:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V16QImode)
          || !
#line 434 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3351; /* mve_vrev16q_uv16qi */

    case 412:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V16QImode)
          || !
#line 434 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3352; /* mve_vrev16q_sv16qi */

    case 441:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V4SImode)
          || !
#line 449 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3353; /* mve_vaddlvq_uv4si */

    case 414:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V4SImode)
          || !
#line 449 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3354; /* mve_vaddlvq_sv4si */

    case 442:
      return recog_114 (x1, insn, pnum_clobbers);

    case 448:
      if (GET_MODE (x2) != E_V16BImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vpr_register_operand (operands[0], E_V16BImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vpr_register_operand (operands[1], E_V16BImode)
          || !
#line 480 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3359; /* mve_vpnotv16bi */

    case 1019:
      return recog_109 (x1, insn, pnum_clobbers);

    case 1021:
      return recog_124 (x1, insn, pnum_clobbers);

    case 1005:
      return recog_108 (x1, insn, pnum_clobbers);

    case 1007:
      return recog_117 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_DUPLICATE:
      x5 = XEXP (x3, 2);
      if (!immediate_operand (x5, E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case TRUNCATE:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          operands[1] = x8;
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern470 (x3, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 676 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 585; /* iwmmxt_tinsrb */

            case E_V4HImode:
              if (pattern470 (x3, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 693 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 586; /* iwmmxt_tinsrh */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (GET_MODE (x3) != E_V2SImode
                  || GET_MODE (x4) != E_V2SImode
                  || !nonimmediate_operand (x6, E_SImode))
                return -1;
              operands[2] = x6;
              if (register_operand (operands[0], E_V2SImode))
                {
                  x8 = XEXP (x3, 1);
                  operands[1] = x8;
                  if (register_operand (operands[1], E_V2SImode))
                    {
                      operands[3] = x5;
                      if (
#line 710 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                        return 587; /* iwmmxt_tinsrw */
                    }
                }
              operands[1] = x6;
              if (!s_register_operand (operands[0], E_V2SImode))
                return -1;
              x8 = XEXP (x3, 1);
              operands[3] = x8;
              if (!s_register_operand (operands[3], E_V2SImode))
                return -1;
              operands[2] = x5;
              if (!
#line 324 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1139; /* vec_setv2si_internal */

            case E_V8QImode:
              if (pattern360 (x3, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 324 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1135; /* vec_setv8qi_internal */

            case E_V4HImode:
              if (pattern360 (x3, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 324 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1136; /* vec_setv4hi_internal */

            case E_V4HFmode:
              if (pattern360 (x3, 
E_V4HFmode, 
E_HFmode) != 0
                  || !
#line 324 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1137; /* vec_setv4hf_internal */

            case E_V4BFmode:
              if (pattern360 (x3, 
E_V4BFmode, 
E_BFmode) != 0
                  || !
#line 324 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1138; /* vec_setv4bf_internal */

            case E_V2SFmode:
              if (pattern360 (x3, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 324 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1140; /* vec_setv2sf_internal */

            case E_V16QImode:
              if (pattern360 (x3, 
E_V16QImode, 
E_QImode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1141; /* vec_setv16qi_internal */
              if (!
#line 4234 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
                return -1;
              return 5019; /* mve_vec_setv16qi_internal */

            case E_V8HImode:
              if (pattern360 (x3, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1142; /* vec_setv8hi_internal */
              if (!
#line 4234 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
                return -1;
              return 5020; /* mve_vec_setv8hi_internal */

            case E_V8HFmode:
              if (pattern360 (x3, 
E_V8HFmode, 
E_HFmode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1143; /* vec_setv8hf_internal */
              if (!
#line 4234 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
                return -1;
              return 5021; /* mve_vec_setv8hf_internal */

            case E_V4SImode:
              if (pattern360 (x3, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1144; /* vec_setv4si_internal */
              if (!
#line 4234 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 5022; /* mve_vec_setv4si_internal */

            case E_V4SFmode:
              if (pattern360 (x3, 
E_V4SFmode, 
E_SFmode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1145; /* vec_setv4sf_internal */
              if (!
#line 4234 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 5023; /* mve_vec_setv4sf_internal */

            case E_V2DImode:
              if (pattern360 (x3, 
E_V2DImode, 
E_DImode) != 0)
                return -1;
              if (
#line 374 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1146; /* vec_setv2di_internal */
              if (!
#line 4253 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5024; /* mve_vec_setv2di_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PARALLEL)
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != PARALLEL)
        return -1;
      x5 = XEXP (x3, 2);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x11 = XEXP (x8, 0);
      operands[2] = x11;
      switch (XVECLEN (x9, 0))
        {
        case 8:
          if (pattern471 (x9) != 0)
            return -1;
          x12 = XVECEXP (x9, 0, 4);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          x13 = XVECEXP (x9, 0, 5);
          if (GET_CODE (x13) != CONST_INT)
            return -1;
          x14 = XVECEXP (x9, 0, 6);
          if (GET_CODE (x14) != CONST_INT)
            return -1;
          x15 = XVECEXP (x9, 0, 7);
          if (GET_CODE (x15) != CONST_INT
              || pattern553 (x10, 
8) != 0)
            return -1;
          x16 = XVECEXP (x10, 0, 4);
          if (GET_CODE (x16) != CONST_INT)
            return -1;
          x17 = XVECEXP (x10, 0, 5);
          if (GET_CODE (x17) != CONST_INT)
            return -1;
          x18 = XVECEXP (x10, 0, 6);
          if (GET_CODE (x18) != CONST_INT)
            return -1;
          x19 = XVECEXP (x10, 0, 7);
          if (GET_CODE (x19) != CONST_INT
              || XWINT (x5, 0) != 85LL
              || pattern582 (x3, 
E_V8QImode) != 0)
            return -1;
          x20 = XVECEXP (x9, 0, 0);
          switch (XWINT (x20, 0))
            {
            case 4LL:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 0LL)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 5LL)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 1LL
                  || XWINT (x12, 0) != 6LL
                  || XWINT (x13, 0) != 2LL
                  || XWINT (x14, 0) != 7LL
                  || XWINT (x15, 0) != 3LL)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 0LL)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 4LL)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 1LL)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 5LL
                  || XWINT (x16, 0) != 2LL
                  || XWINT (x17, 0) != 6LL
                  || XWINT (x18, 0) != 3LL
                  || XWINT (x19, 0) != 7LL
                  || !
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 621; /* iwmmxt_wunpckihb */

            case 0LL:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 4LL)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 1LL)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 5LL
                  || XWINT (x12, 0) != 2LL
                  || XWINT (x13, 0) != 6LL
                  || XWINT (x14, 0) != 3LL
                  || XWINT (x15, 0) != 7LL)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 4LL)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 0LL)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 5LL)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 1LL
                  || XWINT (x16, 0) != 6LL
                  || XWINT (x17, 0) != 2LL
                  || XWINT (x18, 0) != 7LL
                  || XWINT (x19, 0) != 3LL
                  || !
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 624; /* iwmmxt_wunpckilb */

            default:
              return -1;
            }

        case 4:
          if (pattern471 (x9) != 0
              || pattern553 (x10, 
4) != 0
              || XWINT (x5, 0) != 5LL
              || pattern582 (x3, 
E_V4HImode) != 0)
            return -1;
          x20 = XVECEXP (x9, 0, 0);
          switch (XWINT (x20, 0))
            {
            case 2LL:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 0LL)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 3LL)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 1LL)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 0LL)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 2LL)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 1LL)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 3LL
                  || !
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 622; /* iwmmxt_wunpckihh */

            case 0LL:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 2LL)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 1LL)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 3LL)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 2LL)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 0LL)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 3LL)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 1LL
                  || !
#line 1113 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 625; /* iwmmxt_wunpckilh */

            default:
              return -1;
            }

        case 2:
          x20 = XVECEXP (x9, 0, 0);
          if (GET_CODE (x20) != CONST_INT)
            return -1;
          x21 = XVECEXP (x9, 0, 1);
          if (GET_CODE (x21) != CONST_INT
              || XVECLEN (x10, 0) != 2)
            return -1;
          x24 = XVECEXP (x10, 0, 0);
          if (GET_CODE (x24) != CONST_INT)
            return -1;
          x25 = XVECEXP (x10, 0, 1);
          if (GET_CODE (x25) != CONST_INT
              || XWINT (x5, 0) != 1LL
              || pattern582 (x3, 
E_V2SImode) != 0)
            return -1;
          switch (XWINT (x20, 0))
            {
            case 1LL:
              if (XWINT (x21, 0) != 0LL
                  || XWINT (x24, 0) != 0LL
                  || XWINT (x25, 0) != 1LL
                  || !
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 623; /* iwmmxt_wunpckihw */

            case 0LL:
              if (XWINT (x21, 0) != 1LL
                  || XWINT (x24, 0) != 1LL
                  || XWINT (x25, 0) != 0LL
                  || !
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 626; /* iwmmxt_wunpckilw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_MINUS:
      if (pattern249 (x3, 
SS_PLUS) != 0
          || !
#line 81 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 693; /* iwmmxt_waddsubhx */

    case SS_PLUS:
      if (pattern249 (x3, 
SS_MINUS) != 0
          || !
#line 99 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 694; /* iwmmxt_wsubaddhx */

    default:
      return -1;
    }
}

 int
recog_311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case SMAX:
      res = recog_279 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SMIN:
      res = recog_280 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UMAX:
      switch (pattern240 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 4170 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            {
              *pnum_clobbers = 1;
              return 122; /* *arm_umaxsi3 */
            }
          break;

        case 1:
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 913 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 606; /* *umaxv2si3_iwmmxt */
          if (s_register_operand (operands[0], E_V2SImode)
              && s_register_operand (operands[1], E_V2SImode)
              && s_register_operand (operands[2], E_V2SImode)
              && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1353; /* *umaxv2si3_neon */
          break;

        case 2:
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 913 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 607; /* *umaxv4hi3_iwmmxt */
          if (s_register_operand (operands[0], E_V4HImode)
              && s_register_operand (operands[1], E_V4HImode)
              && s_register_operand (operands[2], E_V4HImode)
              && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1351; /* *umaxv4hi3_neon */
          break;

        case 3:
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 913 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 608; /* *umaxv8qi3_iwmmxt */
          if (s_register_operand (operands[0], E_V8QImode)
              && s_register_operand (operands[1], E_V8QImode)
              && s_register_operand (operands[2], E_V8QImode)
              && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1349; /* *umaxv8qi3_neon */
          break;

        case 4:
          if (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1350; /* *umaxv16qi3_neon */
          if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3614; /* mve_vmaxq_uv16qi */
          break;

        case 5:
          if (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1352; /* *umaxv8hi3_neon */
          if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3618; /* mve_vmaxq_uv8hi */
          break;

        case 6:
          if (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1354; /* *umaxv4si3_neon */
          if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3622; /* mve_vmaxq_uv4si */
          break;

        case 7:
          if (
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1420; /* quad_halves_umaxv4si */
          break;

        case 8:
          if (
#line 1157 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1428; /* quad_halves_umaxv8hi */
          break;

        case 9:
          if (
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1433; /* quad_halves_umaxv16qi */
          break;

        default:
          break;
        }
      break;

    case UMIN:
      switch (pattern240 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 4203 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            {
              *pnum_clobbers = 1;
              return 123; /* *arm_uminsi3 */
            }
          break;

        case 1:
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 933 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 612; /* *uminv2si3_iwmmxt */
          if (s_register_operand (operands[0], E_V2SImode)
              && s_register_operand (operands[1], E_V2SImode)
              && s_register_operand (operands[2], E_V2SImode)
              && 
#line 861 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1347; /* *uminv2si3_neon */
          break;

        case 2:
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 933 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 613; /* *uminv4hi3_iwmmxt */
          if (s_register_operand (operands[0], E_V4HImode)
              && s_register_operand (operands[1], E_V4HImode)
              && s_register_operand (operands[2], E_V4HImode)
              && 
#line 861 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1345; /* *uminv4hi3_neon */
          break;

        case 3:
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 933 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 614; /* *uminv8qi3_iwmmxt */
          if (s_register_operand (operands[0], E_V8QImode)
              && s_register_operand (operands[1], E_V8QImode)
              && s_register_operand (operands[2], E_V8QImode)
              && 
#line 861 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1343; /* *uminv8qi3_neon */
          break;

        case 4:
          if (
#line 861 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1344; /* *uminv16qi3_neon */
          if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3616; /* mve_vminq_uv16qi */
          break;

        case 5:
          if (
#line 861 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1346; /* *uminv8hi3_neon */
          if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3620; /* mve_vminq_uv8hi */
          break;

        case 6:
          if (
#line 861 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1348; /* *uminv4si3_neon */
          if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3624; /* mve_vminq_uv4si */
          break;

        case 7:
          if (
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1419; /* quad_halves_uminv4si */
          break;

        case 8:
          if (
#line 1157 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1427; /* quad_halves_uminv8hi */
          break;

        case 9:
          if (
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1432; /* quad_halves_uminv16qi */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (s_register_operand (operands[2], E_SImode)
      && memory_operand (operands[0], E_SImode))
    {
      operands[3] = x3;
      if (minmax_operator (operands[3], E_SImode)
          && 
#line 4227 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && optimize_function_for_size_p (cfun) && !arm_restrict_it))
        {
          *pnum_clobbers = 1;
          return 124; /* *store_minmaxsi */
        }
    }
  if (!arm_rhs_operand (operands[2], E_SImode)
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_CODE (x3))
    {
    case SMAX:
      if (!
#line 34 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1007; /* *thumb2_smaxsi3 */

    case SMIN:
      if (!
#line 55 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1008; /* *thumb2_sminsi3 */

    case UMAX:
      if (!
#line 76 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1009; /* *thumb32_umaxsi3 */

    case UMIN:
      if (!
#line 97 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1010; /* *thumb2_uminsi3 */

    default:
      return -1;
    }
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!
#line 4360 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
        return -1;
      return 127; /* arm_qadd_insn */

    case 1:
      if (register_operand (operands[0], E_V8QImode)
          && register_operand (operands[1], E_V8QImode)
          && register_operand (operands[2], E_V8QImode)
          && 
#line 351 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 555; /* ssaddv8qi3 */
      if (!s_register_operand (operands[0], E_V8QImode)
          || !s_register_operand (operands[1], E_V8QImode)
          || !s_register_operand (operands[2], E_V8QImode)
          || !
#line 1429 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1454; /* *ss_addv8qi_neon */

    case 2:
      if (register_operand (operands[0], E_V4HImode)
          && register_operand (operands[1], E_V4HImode)
          && register_operand (operands[2], E_V4HImode)
          && 
#line 361 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 556; /* ssaddv4hi3 */
      if (!s_register_operand (operands[0], E_V4HImode)
          || !s_register_operand (operands[1], E_V4HImode)
          || !s_register_operand (operands[2], E_V4HImode)
          || !
#line 1429 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1455; /* *ss_addv4hi_neon */

    case 3:
      if (register_operand (operands[0], E_V2SImode)
          && register_operand (operands[1], E_V2SImode)
          && register_operand (operands[2], E_V2SImode)
          && 
#line 371 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 557; /* ssaddv2si3 */
      if (!s_register_operand (operands[0], E_V2SImode)
          || !s_register_operand (operands[1], E_V2SImode)
          || !s_register_operand (operands[2], E_V2SImode)
          || !
#line 1429 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1456; /* *ss_addv2si_neon */

    case 4:
      if (!
#line 1429 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1457; /* *ss_addv2sf_neon */

    case 5:
      if (!
#line 75 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3200; /* *arm_ssaddv4qq3 */

    case 6:
      if (!
#line 75 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3201; /* *arm_ssaddv2hq3 */

    case 7:
      if (!
#line 75 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3202; /* *arm_ssaddqq3 */

    case 8:
      if (!
#line 75 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3203; /* *arm_ssaddhq3 */

    case 9:
      if (!
#line 75 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3204; /* *arm_ssaddv2ha3 */

    case 10:
      if (!
#line 75 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3205; /* *arm_ssaddha3 */

    case 11:
      if (!
#line 75 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 3206; /* *arm_ssaddsq3 */

    case 12:
      if (!
#line 75 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 3207; /* *arm_ssaddsa3 */

    default:
      return -1;
    }
}

 int
recog_320 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1))
    {
    case 0:
      if (register_operand (operands[0], E_V8QImode)
          && register_operand (operands[1], E_V8QImode)
          && register_operand (operands[2], E_V8QImode)
          && 
#line 451 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 567; /* ussubv8qi3 */
      if (!s_register_operand (operands[0], E_V8QImode)
          || !s_register_operand (operands[1], E_V8QImode)
          || !s_register_operand (operands[2], E_V8QImode)
          || !
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1466; /* *us_subv8qi_neon */

    case 1:
      if (register_operand (operands[0], E_V4HImode)
          && register_operand (operands[1], E_V4HImode)
          && register_operand (operands[2], E_V4HImode)
          && 
#line 461 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 568; /* ussubv4hi3 */
      if (!s_register_operand (operands[0], E_V4HImode)
          || !s_register_operand (operands[1], E_V4HImode)
          || !s_register_operand (operands[2], E_V4HImode)
          || !
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1467; /* *us_subv4hi_neon */

    case 2:
      if (register_operand (operands[0], E_V2SImode)
          && register_operand (operands[1], E_V2SImode)
          && register_operand (operands[2], E_V2SImode)
          && 
#line 471 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 569; /* ussubv2si3 */
      if (!s_register_operand (operands[0], E_V2SImode)
          || !s_register_operand (operands[1], E_V2SImode)
          || !s_register_operand (operands[2], E_V2SImode)
          || !
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1468; /* *us_subv2si_neon */

    case 3:
      if (!
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1469; /* *us_subv2sf_neon */

    case 4:
      if (!
#line 115 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3221; /* ussubv4uqq3 */

    case 5:
      if (!
#line 115 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3222; /* ussubv2uhq3 */

    case 6:
      if (!
#line 115 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3223; /* ussubuqq3 */

    case 7:
      if (!
#line 115 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3224; /* ussubuhq3 */

    case 8:
      if (!
#line 115 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3225; /* ussubv2uha3 */

    case 9:
      if (!
#line 115 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3226; /* ussubuha3 */

    default:
      return -1;
    }
}

 int
recog_327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  x6 = XEXP (x3, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[1] = x7;
  if (!const_int_M_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 2);
  operands[2] = x8;
  if (!const_int_M_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x2, 1);
  operands[3] = x9;
  if (!s_register_operand (operands[3], E_SImode)
      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3524 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch_thumb2)))
    return -1;
  return 6445; /* *p insv_t2 */
}

 int
recog_330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  switch (XVECLEN (x6, 0))
    {
    case 8:
      if (pattern472 (x6, 
E_V8QImode) != 0)
        return -1;
      x7 = XVECEXP (x6, 0, 4);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x6, 0, 5);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x6, 0, 6);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x6, 0, 7);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !s_register_operand (operands[0], E_V8QImode)
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 574 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6716; /* *p iwmmxt_clrv8qi */

    case 4:
      if (pattern472 (x6, 
E_V4HImode) != 0
          || !s_register_operand (operands[0], E_V4HImode)
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6717; /* *p iwmmxt_clrv4hi */

    case 2:
      if (GET_MODE (x6) != E_V2SImode)
        return -1;
      x11 = XVECEXP (x6, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x12 = XVECEXP (x6, 0, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V2SImode)
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 593 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6718; /* *p iwmmxt_clrv2si */

    default:
      return -1;
    }
}

 int
recog_334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x5) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode)
            return -1;
          operands[3] = x7;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2292 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2)))
            return -1;
          return 6418; /* *p *mls */

        case E_SFmode:
          if (pattern555 (x5, 
E_SFmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1279 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6931; /* *p *mulsf3negsfaddsf_vfp */

        case E_DFmode:
          if (pattern555 (x5, 
E_DFmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1290 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6932; /* *p *fmuldf3negdfadddf_vfp */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern540 (x6, 
E_SImode) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      switch (pattern627 (x6))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6874; /* *p iwmmxt_wmiawbbn */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 807 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6875; /* *p iwmmxt_wmiawbtn */

        case 2:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 820 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6876; /* *p iwmmxt_wmiawtbn */

        case 3:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 833 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6877; /* *p iwmmxt_wmiawttn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case MINUS:
      if (GET_MODE (x5) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x8 = XEXP (x1, 0);
              operands[4] = x8;
              x9 = XEXP (x8, 0);
              operands[5] = x9;
              if (!reg_or_int_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[3] = x10;
              if (!arm_borrow_operation (operands[3], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1697 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6407; /* *p subsi3_carryin */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[2] = x7;
              if (!shift_operator (operands[2], E_SImode))
                return -1;
              x8 = XEXP (x1, 0);
              operands[6] = x8;
              x9 = XEXP (x8, 0);
              operands[7] = x9;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x7, 0);
              operands[3] = x11;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[4] = x12;
              if (!shift_amount_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[5] = x10;
              if (!arm_borrow_operation (operands[5], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1831 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6411; /* *p *subsi3_carryin_shift */

            case GEU:
            case LTU:
              operands[5] = x7;
              if (!arm_borrow_operation (operands[5], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              if (!shift_operator (x10, E_SImode))
                return -1;
              operands[2] = x10;
              x8 = XEXP (x1, 0);
              operands[6] = x8;
              x9 = XEXP (x8, 0);
              operands[7] = x9;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x13 = XEXP (x10, 0);
              operands[3] = x13;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x14 = XEXP (x10, 1);
              operands[4] = x14;
              if (!shift_amount_operand (operands[4], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1848 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6412; /* *p *subsi3_carryin_shift_alt */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[2] = x6;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x1, 0);
          operands[6] = x8;
          x9 = XEXP (x8, 0);
          operands[7] = x9;
          x15 = XEXP (x6, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x16 = XEXP (x6, 1);
          operands[4] = x16;
          if (!shift_amount_operand (operands[4], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[5] = x10;
              if (!arm_borrow_operation (operands[5], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1866 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM)))
                return -1;
              return 6413; /* *p *rsbsi3_carryin_shift */

            case GEU:
            case LTU:
              operands[5] = x7;
              if (!arm_borrow_operation (operands[5], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[1] = x10;
              if (!s_register_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM)))
                return -1;
              return 6414; /* *p *rsbsi3_carryin_shift_alt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[1] = x5;
      if (!arm_carry_operation (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x1, 0);
      operands[3] = x8;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode)
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1714 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM)))
        return -1;
      return 6408; /* *p rsbsi_carryin_reg */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x5;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x10;
          x8 = XEXP (x1, 0);
          operands[3] = x8;
          x9 = XEXP (x8, 0);
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!s_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !reg_or_int_operand (operands[1], E_SImode)
                  || !reg_or_int_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2020 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6415; /* *p *arm_subsi3_insn */

            case E_V2SImode:
              if (pattern311 (x4, 
E_V2SImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 411 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6699; /* *p *subv2si3_iwmmxt */

            case E_V4HImode:
              if (pattern311 (x4, 
E_V4HImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 411 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6700; /* *p *subv4hi3_iwmmxt */

            case E_V8QImode:
              if (pattern311 (x4, 
E_V8QImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 411 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6701; /* *p *subv8qi3_iwmmxt */

            case E_SFmode:
              if (pattern310 (x4, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
                return -1;
              return 6917; /* *p *subsf3_vfp */

            case E_DFmode:
              if (pattern310 (x4, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
                return -1;
              return 6918; /* *p *subdf3_vfp */

            case E_QQmode:
              if (pattern310 (x4, 
E_QQmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7030; /* *p subqq3 */

            case E_HQmode:
              if (pattern310 (x4, 
E_HQmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7031; /* *p subhq3 */

            case E_SQmode:
              if (pattern310 (x4, 
E_SQmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7032; /* *p subsq3 */

            case E_UQQmode:
              if (pattern310 (x4, 
E_UQQmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7033; /* *p subuqq3 */

            case E_UHQmode:
              if (pattern310 (x4, 
E_UHQmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7034; /* *p subuhq3 */

            case E_USQmode:
              if (pattern310 (x4, 
E_USQmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7035; /* *p subusq3 */

            case E_HAmode:
              if (pattern310 (x4, 
E_HAmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7036; /* *p subha3 */

            case E_SAmode:
              if (pattern310 (x4, 
E_SAmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7037; /* *p subsa3 */

            case E_UHAmode:
              if (pattern310 (x4, 
E_UHAmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7038; /* *p subuha3 */

            case E_USAmode:
              if (pattern310 (x4, 
E_USAmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7039; /* *p subusa3 */

            case E_V4QQmode:
              if (pattern310 (x4, 
E_V4QQmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
                return -1;
              return 7040; /* *p *arm_subv4qq3 */

            case E_V2HQmode:
              if (pattern310 (x4, 
E_V2HQmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
                return -1;
              return 7041; /* *p *arm_subv2hq3 */

            case E_V2HAmode:
              if (pattern310 (x4, 
E_V2HAmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
                return -1;
              return 7042; /* *p *arm_subv2ha3 */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (GET_CODE (x10) == MULT)
            {
              res = recog_334 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[2] = x10;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x1, 0);
          operands[5] = x8;
          x9 = XEXP (x8, 0);
          operands[6] = x9;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x10, 0);
          operands[3] = x13;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x14 = XEXP (x10, 1);
          operands[4] = x14;
          if (!shift_amount_operand (operands[4], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9767 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6593; /* *p *sub_shiftsi */

        case PLUS:
          if (pattern438 (x10) != 0)
            return -1;
          x13 = XEXP (x10, 0);
          x17 = XEXP (x13, 0);
          x18 = XEXP (x17, 0);
          if (GET_CODE (x18) != VEC_SELECT
              || GET_MODE (x18) != E_HImode)
            return -1;
          x19 = XEXP (x18, 1);
          if (GET_CODE (x19) != PARALLEL
              || XVECLEN (x19, 0) != 1)
            return -1;
          x20 = XVECEXP (x19, 0, 0);
          if (GET_CODE (x20) != CONST_INT)
            return -1;
          x21 = XEXP (x13, 1);
          if (pattern600 (x21, 
E_HImode, 
E_DImode, 
SIGN_EXTEND) != 0)
            return -1;
          x22 = XEXP (x21, 0);
          x23 = XEXP (x22, 1);
          if (GET_CODE (x23) != PARALLEL
              || XVECLEN (x23, 0) != 1)
            return -1;
          x24 = XVECEXP (x23, 0, 0);
          if (GET_CODE (x24) != CONST_INT)
            return -1;
          x14 = XEXP (x10, 1);
          if (pattern583 (x14) != 0)
            return -1;
          x25 = XEXP (x14, 0);
          x26 = XEXP (x25, 0);
          if (GET_CODE (x26) != VEC_SELECT
              || GET_MODE (x26) != E_HImode)
            return -1;
          x27 = XEXP (x26, 1);
          if (GET_CODE (x27) != PARALLEL
              || XVECLEN (x27, 0) != 1)
            return -1;
          x28 = XVECEXP (x27, 0, 0);
          if (GET_CODE (x28) != CONST_INT)
            return -1;
          x29 = XEXP (x14, 1);
          if (GET_CODE (x29) != SIGN_EXTEND
              || GET_MODE (x29) != E_DImode)
            return -1;
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != VEC_SELECT
              || GET_MODE (x30) != E_HImode)
            return -1;
          x31 = XEXP (x30, 1);
          if (GET_CODE (x31) != PARALLEL
              || XVECLEN (x31, 0) != 1)
            return -1;
          x32 = XVECEXP (x31, 0, 0);
          if (GET_CODE (x32) != CONST_INT)
            return -1;
          x8 = XEXP (x1, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 0);
          operands[5] = x9;
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          switch (pattern656 (x10))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 657 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6866; /* *p iwmmxt_wmiabbn */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 681 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6867; /* *p iwmmxt_wmiabtn */

            case 2:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 705 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6868; /* *p iwmmxt_wmiatbn */

            case 3:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6869; /* *p iwmmxt_wmiattn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x8 = XEXP (x1, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 0);
          operands[5] = x9;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          switch (GET_CODE (operands[3]))
            {
            case CONST_INT:
              if (!power_of_two_operand (operands[3], E_SImode)
                  || !s_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || GET_MODE (x5) != E_SImode
                  || !s_register_operand (operands[2], E_SImode)
                  || !s_register_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9686 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6584; /* *p *rsb_multsi */

            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern569 (x4, 
E_SFmode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1245 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
                    return -1;
                  return 6929; /* *p *mulsf3subsf_vfp */

                case E_DFmode:
                  if (pattern569 (x4, 
E_DFmode) != 0
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
                    return -1;
                  return 6930; /* *p *muldf3subdf_vfp */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern406 (x5, 
2, 
0) != 0)
            return -1;
          x7 = XEXP (x5, 1);
          x12 = XEXP (x7, 1);
          x33 = XVECEXP (x12, 0, 0);
          if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x34 = XVECEXP (x12, 0, 1);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x10 = XEXP (x4, 1);
          if (pattern599 (x10, 
3, 
1) != 0)
            return -1;
          x14 = XEXP (x10, 1);
          if (GET_CODE (x14) != VEC_SELECT
              || GET_MODE (x14) != E_V2SImode)
            return -1;
          x29 = XEXP (x14, 1);
          if (GET_CODE (x29) != PARALLEL
              || XVECLEN (x29, 0) != 2)
            return -1;
          x35 = XVECEXP (x29, 0, 0);
          if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x36 = XVECEXP (x29, 0, 1);
          if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          switch (pattern636 (x1))
            {
            case 0:
              if (pattern652 (x4, 
SIGN_EXTEND) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6839; /* *p iwmmxt_wmaddsn */

            case 1:
              if (pattern652 (x4, 
ZERO_EXTEND) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6840; /* *p iwmmxt_wmaddun */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x1, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 0);
          operands[5] = x9;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern556 (x4, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1316 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
                return -1;
              return 6933; /* *p *mulsf3negsfsubsf_vfp */

            case E_DFmode:
              if (pattern556 (x4, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
                return -1;
              return 6934; /* *p *muldf3negdfsubdf_vfp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x5;
      if (pattern407 (x1) != 0
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9700 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT)))
        return -1;
      return 6589; /* *p *rsb_shiftsi */

    default:
      return -1;
    }
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_V2SImode)
          || XVECLEN (x4, 0) != 1)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x9 = XVECEXP (x4, 0, 0);
      operands[2] = x9;
      if (!immediate_operand (operands[2], E_SImode)
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6730; /* *p iwmmxt_textrmw */

    case ZERO_EXTEND:
      switch (pattern413 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1141 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6765; /* *p iwmmxt_wunpckehub */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6771; /* *p iwmmxt_wunpckelub */

        case 2:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6766; /* *p iwmmxt_wunpckehuh */

        case 3:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6772; /* *p iwmmxt_wunpckeluh */

        case 4:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1163 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6767; /* *p iwmmxt_wunpckehuw */

        case 5:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1231 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6773; /* *p iwmmxt_wunpckeluw */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern413 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1175 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6768; /* *p iwmmxt_wunpckehsb */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1243 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6774; /* *p iwmmxt_wunpckelsb */

        case 2:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1186 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6769; /* *p iwmmxt_wunpckehsh */

        case 3:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6775; /* *p iwmmxt_wunpckelsh */

        case 4:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6770; /* *p iwmmxt_wunpckehsw */

        case 5:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6776; /* *p iwmmxt_wunpckelsw */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[5] = x6;
  x7 = XEXP (x6, 0);
  operands[6] = x7;
  x8 = XVECEXP (x2, 0, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x12 = XEXP (x8, 1);
  operands[2] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  x15 = XEXP (x5, 0);
  if (!rtx_equal_p (x15, operands[0])
      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12765 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && ((INTVAL (operands[1]) + 4) == INTVAL (operands[3]))
     && (operands_ok_ldrd_strd (operands[2], operands[4],
                                  operands[0], INTVAL (operands[1]),
                                  false, false)))))
    return -1;
  return 6617; /* *p *thumb2_strd */
}

 int
recog_371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x6) != SET)
    return -1;
  switch (pattern443 (x2))
    {
    case 0:
      if (pattern545 (x2) != 0)
        return -1;
      x7 = XEXP (x1, 0);
      operands[6] = x7;
      x8 = XEXP (x7, 0);
      operands[7] = x8;
      if (pattern606 (operands[0]) != 0)
        return -1;
      x9 = XEXP (x6, 0);
      operands[4] = x9;
      if (!arm_hard_general_register_operand (operands[4], E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[5] = x11;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x12 = XEXP (x4, 1);
          x13 = XEXP (x12, 0);
          x14 = XEXP (x13, 1);
          if (XWINT (x14, 0) != 4LL)
            return -1;
          x15 = XEXP (x5, 1);
          x16 = XEXP (x15, 0);
          x17 = XEXP (x16, 1);
          if (XWINT (x17, 0) != 8LL)
            return -1;
          x18 = XEXP (x6, 1);
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != PLUS
              || GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XEXP (x19, 1);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x23 = XEXP (x19, 0);
          if (!rtx_equal_p (x23, operands[5])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 37 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
            return -1;
          return 6622; /* *p *ldm4_ */

        case PLUS:
          if (GET_MODE (x11) != E_SImode)
            return -1;
          x24 = XEXP (x11, 1);
          if (GET_CODE (x24) != CONST_INT)
            return -1;
          x25 = XEXP (x11, 0);
          operands[5] = x25;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x12 = XEXP (x4, 1);
          x13 = XEXP (x12, 0);
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x15 = XEXP (x5, 1);
          x16 = XEXP (x15, 0);
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          switch (XWINT (x24, 0))
            {
            case 4LL:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != 8LL)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != 12LL)
                return -1;
              x18 = XEXP (x6, 1);
              x19 = XEXP (x18, 0);
              if (pattern654 (x19, 
16) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6626; /* *p *ldm4_ib */

            case -12LL:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -8LL)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -4LL)
                return -1;
              x18 = XEXP (x6, 1);
              x19 = XEXP (x18, 0);
              if (!rtx_equal_p (x19, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6630; /* *p *ldm4_da */

            case -16LL:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -12LL)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -8LL)
                return -1;
              x18 = XEXP (x6, 1);
              x19 = XEXP (x18, 0);
              if (pattern654 (x19, 
-4) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 302 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6634; /* *p *ldm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern572 (x2) != 0)
        return -1;
      x7 = XEXP (x1, 0);
      operands[6] = x7;
      x8 = XEXP (x7, 0);
      operands[7] = x8;
      if (!store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x4, 1);
      operands[2] = x12;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x15 = XEXP (x5, 1);
      operands[3] = x15;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x18 = XEXP (x6, 1);
      operands[4] = x18;
      if (!arm_hard_general_register_operand (operands[4], E_SImode))
        return -1;
      x26 = XEXP (x3, 0);
      x27 = XEXP (x26, 0);
      switch (GET_CODE (x27))
        {
        case REG:
        case SUBREG:
          operands[5] = x27;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x28 = XEXP (x4, 0);
          x29 = XEXP (x28, 0);
          x30 = XEXP (x29, 1);
          if (XWINT (x30, 0) != 4LL)
            return -1;
          x31 = XEXP (x5, 0);
          x32 = XEXP (x31, 0);
          x33 = XEXP (x32, 1);
          if (XWINT (x33, 0) != 8LL)
            return -1;
          x9 = XEXP (x6, 0);
          x34 = XEXP (x9, 0);
          if (GET_CODE (x34) != PLUS
              || GET_MODE (x34) != E_SImode)
            return -1;
          x35 = XEXP (x34, 1);
          if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x36 = XEXP (x29, 0);
          if (!rtx_equal_p (x36, operands[5]))
            return -1;
          x37 = XEXP (x32, 0);
          if (!rtx_equal_p (x37, operands[5]))
            return -1;
          x38 = XEXP (x34, 0);
          if (!rtx_equal_p (x38, operands[5])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 108 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
            return -1;
          return 6624; /* *p *stm4_ */

        case PLUS:
          if (GET_MODE (x27) != E_SImode)
            return -1;
          x39 = XEXP (x27, 1);
          if (GET_CODE (x39) != CONST_INT)
            return -1;
          x40 = XEXP (x27, 0);
          operands[5] = x40;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x28 = XEXP (x4, 0);
          x29 = XEXP (x28, 0);
          x36 = XEXP (x29, 0);
          if (!rtx_equal_p (x36, operands[5]))
            return -1;
          x31 = XEXP (x5, 0);
          x32 = XEXP (x31, 0);
          x37 = XEXP (x32, 0);
          if (!rtx_equal_p (x37, operands[5]))
            return -1;
          switch (XWINT (x39, 0))
            {
            case 4LL:
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != 8LL)
                return -1;
              x33 = XEXP (x32, 1);
              if (XWINT (x33, 0) != 12LL)
                return -1;
              x9 = XEXP (x6, 0);
              x34 = XEXP (x9, 0);
              if (pattern655 (x34, 
16) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6628; /* *p *stm4_ib */

            case -12LL:
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -8LL)
                return -1;
              x33 = XEXP (x32, 1);
              if (XWINT (x33, 0) != -4LL)
                return -1;
              x9 = XEXP (x6, 0);
              x34 = XEXP (x9, 0);
              if (!rtx_equal_p (x34, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6632; /* *p *stm4_da */

            case -16LL:
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -12LL)
                return -1;
              x33 = XEXP (x32, 1);
              if (XWINT (x33, 0) != -8LL)
                return -1;
              x9 = XEXP (x6, 0);
              x34 = XEXP (x9, 0);
              if (pattern655 (x34, 
-4) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6636; /* *p *stm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x7 = XEXP (x1, 0);
      operands[5] = x7;
      x8 = XEXP (x7, 0);
      operands[6] = x8;
      x26 = XEXP (x3, 0);
      operands[4] = x26;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[4]))
        return -1;
      x41 = XEXP (x10, 1);
      switch (XWINT (x41, 0))
        {
        case 12LL:
          switch (pattern597 (x4))
            {
            case 0:
              if (pattern544 (x2) != 0)
                return -1;
              x18 = XEXP (x6, 1);
              x19 = XEXP (x18, 0);
              if (GET_CODE (x19) != PLUS
                  || GET_MODE (x19) != E_SImode)
                return -1;
              x20 = XEXP (x19, 1);
              if (GET_CODE (x20) != CONST_INT
                  || pattern634 (operands[0]) != 0)
                return -1;
              x15 = XEXP (x5, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x23 = XEXP (x19, 0);
              if (!rtx_equal_p (x23, operands[4]))
                return -1;
              switch (pattern647 (x2))
                {
                case 0:
                  x12 = XEXP (x4, 1);
                  x13 = XEXP (x12, 0);
                  if (!rtx_equal_p (x13, operands[4]))
                    return -1;
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != 4LL
                      || XWINT (x20, 0) != 8LL
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6639; /* *p *ldm3_ia_update */

                case 1:
                  x12 = XEXP (x4, 1);
                  x13 = XEXP (x12, 0);
                  x21 = XEXP (x13, 0);
                  if (!rtx_equal_p (x21, operands[4])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6643; /* *p *ldm3_ib_update */

                default:
                  return -1;
                }

            case 1:
              if (pattern571 (x2) != 0)
                return -1;
              x9 = XEXP (x6, 0);
              x34 = XEXP (x9, 0);
              if (GET_CODE (x34) != PLUS
                  || GET_MODE (x34) != E_SImode)
                return -1;
              x35 = XEXP (x34, 1);
              if (GET_CODE (x35) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x5, 1);
              operands[2] = x15;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x18 = XEXP (x6, 1);
              operands[3] = x18;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x31 = XEXP (x5, 0);
              x32 = XEXP (x31, 0);
              x37 = XEXP (x32, 0);
              if (!rtx_equal_p (x37, operands[4]))
                return -1;
              x38 = XEXP (x34, 0);
              if (!rtx_equal_p (x38, operands[4]))
                return -1;
              switch (pattern649 (x2))
                {
                case 0:
                  x28 = XEXP (x4, 0);
                  x29 = XEXP (x28, 0);
                  if (!rtx_equal_p (x29, operands[4]))
                    return -1;
                  x33 = XEXP (x32, 1);
                  if (XWINT (x33, 0) != 4LL
                      || XWINT (x35, 0) != 8LL
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 552 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6641; /* *p *stm3_ia_update */

                case 1:
                  x28 = XEXP (x4, 0);
                  x29 = XEXP (x28, 0);
                  x36 = XEXP (x29, 0);
                  if (!rtx_equal_p (x36, operands[4])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 628 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6645; /* *p *stm3_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -12LL:
          x12 = XEXP (x4, 1);
          switch (GET_CODE (x12))
            {
            case MEM:
              if (pattern545 (x2) != 0
                  || pattern634 (operands[0]) != 0)
                return -1;
              x13 = XEXP (x12, 0);
              x21 = XEXP (x13, 0);
              if (!rtx_equal_p (x21, operands[4]))
                return -1;
              x15 = XEXP (x5, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x14 = XEXP (x13, 1);
              switch (XWINT (x14, 0))
                {
                case -8LL:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -4LL)
                    return -1;
                  x18 = XEXP (x6, 1);
                  x19 = XEXP (x18, 0);
                  if (!rtx_equal_p (x19, operands[4])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 660 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6647; /* *p *ldm3_da_update */

                case -12LL:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -8LL)
                    return -1;
                  x18 = XEXP (x6, 1);
                  x19 = XEXP (x18, 0);
                  if (GET_CODE (x19) != PLUS
                      || GET_MODE (x19) != E_SImode)
                    return -1;
                  x20 = XEXP (x19, 1);
                  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x23 = XEXP (x19, 0);
                  if (!rtx_equal_p (x23, operands[4])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 722 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6651; /* *p *ldm3_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x12;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern572 (x2) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x5, 1);
              operands[2] = x15;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x18 = XEXP (x6, 1);
              operands[3] = x18;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x28 = XEXP (x4, 0);
              x29 = XEXP (x28, 0);
              x36 = XEXP (x29, 0);
              if (!rtx_equal_p (x36, operands[4]))
                return -1;
              x31 = XEXP (x5, 0);
              x32 = XEXP (x31, 0);
              x37 = XEXP (x32, 0);
              if (!rtx_equal_p (x37, operands[4]))
                return -1;
              x30 = XEXP (x29, 1);
              switch (XWINT (x30, 0))
                {
                case -8LL:
                  x33 = XEXP (x32, 1);
                  if (XWINT (x33, 0) != -4LL)
                    return -1;
                  x9 = XEXP (x6, 0);
                  x34 = XEXP (x9, 0);
                  if (!rtx_equal_p (x34, operands[4])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 688 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6649; /* *p *stm3_da_update */

                case -12LL:
                  x33 = XEXP (x32, 1);
                  if (XWINT (x33, 0) != -8LL)
                    return -1;
                  x9 = XEXP (x6, 0);
                  x34 = XEXP (x9, 0);
                  if (GET_CODE (x34) != PLUS
                      || GET_MODE (x34) != E_SImode)
                    return -1;
                  x35 = XEXP (x34, 1);
                  if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x38 = XEXP (x34, 0);
                  if (!rtx_equal_p (x38, operands[4])
                      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 750 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6653; /* *p *stm3_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3)
    return NULL;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return NULL;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern26 (x1, 
E_CCmode) != 0)
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (pattern493 (x5) != 0)
    return NULL;
  if (
#line 9990 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch5t && TARGET_32BIT && peep2_regno_dead_p (3, CC_REGNUM)))
    {
      *pmatch_len_ = 2;
      res = gen_peephole2_8 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (!
#line 10007 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && peep2_regno_dead_p (3, CC_REGNUM)))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_9 (insn, operands);
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (arm_general_register_operand (operands[1], E_SImode))
    {
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == COMPARE
          && GET_MODE (x4) == E_CCmode)
        {
          x5 = XEXP (x4, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x6 = XEXP (x2, 0);
              if (GET_CODE (x6) == REG
                  && REGNO (x6) == 100
                  && GET_MODE (x6) == E_CCmode)
                {
                  x7 = XEXP (x4, 0);
                  if (rtx_equal_p (x7, operands[1])
                      && 
#line 11577 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_12 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
    }
  operands[2] = x3;
  if (!memory_operand (operands[2], E_SImode))
    return NULL;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!arm_general_register_operand (operands[1], E_SImode))
    return NULL;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!memory_operand (operands[3], E_SImode)
      || !
#line 36 "../../gcc-15.1.1-20250425/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_13 (insn, operands);
}

 rtx_insn *
peephole2_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  if (!memory_operand (operands[4], E_SImode))
    return NULL;
  x3 = XEXP (x1, 1);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 0);
  operands[6] = x8;
  if (!memory_operand (operands[6], E_SImode))
    return NULL;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x10 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x10) != SET)
    return NULL;
  x11 = XEXP (x10, 0);
  operands[7] = x11;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!s_register_operand (operands[3], E_SImode))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_23 (insn, operands);
}

 rtx_insn *
peephole2_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 8)
    return NULL;
  x2 = XEXP (x1, 1);
  operands[8] = x2;
  x3 = PATTERN (peep2_next_insn (2));
  x4 = XEXP (x3, 0);
  if (!s_register_operand (x4, E_SImode))
    return NULL;
  x5 = XEXP (x3, 1);
  if (!const_int_operand (x5, E_SImode))
    return NULL;
  x6 = PATTERN (peep2_next_insn (4));
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = PATTERN (peep2_next_insn (5));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 0);
  if (!memory_operand (x8, E_SImode))
    return NULL;
  x9 = PATTERN (peep2_next_insn (6));
  if (GET_CODE (x9) != SET)
    return NULL;
  x10 = PATTERN (peep2_next_insn (7));
  if (GET_CODE (x10) != SET)
    return NULL;
  x11 = XEXP (x10, 0);
  operands[7] = x11;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  x12 = PATTERN (peep2_next_insn (1));
  x13 = XEXP (x12, 1);
  switch (GET_CODE (x13))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x13, operands[0]))
        return NULL;
      x14 = XEXP (x12, 0);
      operands[4] = x14;
      if (!memory_operand (operands[4], E_SImode))
        return NULL;
      operands[1] = x4;
      operands[9] = x5;
      x15 = PATTERN (peep2_next_insn (3));
      x16 = XEXP (x15, 0);
      operands[5] = x16;
      if (!memory_operand (operands[5], E_SImode))
        return NULL;
      x17 = XEXP (x15, 1);
      if (!rtx_equal_p (x17, operands[1]))
        return NULL;
      x18 = XEXP (x6, 0);
      operands[2] = x18;
      if (!s_register_operand (operands[2], E_SImode))
        return NULL;
      x19 = XEXP (x6, 1);
      operands[10] = x19;
      if (!const_int_operand (operands[10], E_SImode))
        return NULL;
      operands[6] = x8;
      x20 = XEXP (x7, 1);
      if (!rtx_equal_p (x20, operands[2]))
        return NULL;
      x21 = XEXP (x9, 0);
      operands[3] = x21;
      if (!s_register_operand (operands[3], E_SImode))
        return NULL;
      x22 = XEXP (x9, 1);
      operands[11] = x22;
      if (!const_int_operand (operands[11], E_SImode))
        return NULL;
      x23 = XEXP (x10, 1);
      if (!rtx_equal_p (x23, operands[3]))
        return NULL;
      *pmatch_len_ = 7;
      return gen_peephole2_21 (insn, operands);

    case CONST_INT:
      operands[9] = x13;
      if (!const_int_operand (operands[9], E_SImode))
        return NULL;
      x14 = XEXP (x12, 0);
      operands[1] = x14;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      operands[2] = x4;
      operands[10] = x5;
      x15 = PATTERN (peep2_next_insn (3));
      x16 = XEXP (x15, 0);
      operands[3] = x16;
      if (!s_register_operand (operands[3], E_SImode))
        return NULL;
      x17 = XEXP (x15, 1);
      operands[11] = x17;
      if (!const_int_operand (operands[11], E_SImode))
        return NULL;
      x18 = XEXP (x6, 0);
      operands[4] = x18;
      if (!memory_operand (operands[4], E_SImode))
        return NULL;
      x19 = XEXP (x6, 1);
      if (!rtx_equal_p (x19, operands[0]))
        return NULL;
      operands[5] = x8;
      x20 = XEXP (x7, 1);
      if (!rtx_equal_p (x20, operands[1]))
        return NULL;
      x21 = XEXP (x9, 0);
      operands[6] = x21;
      if (!memory_operand (operands[6], E_SImode))
        return NULL;
      x22 = XEXP (x9, 1);
      if (!rtx_equal_p (x22, operands[2]))
        return NULL;
      x23 = XEXP (x10, 1);
      if (!rtx_equal_p (x23, operands[3]))
        return NULL;
      *pmatch_len_ = 7;
      return gen_peephole2_22 (insn, operands);

    default:
      return NULL;
    }
}
