/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CC_NZmode
      || GET_MODE (x2) != E_CC_NZmode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !mem_noofs_operand (operands[1], i1)
      || !reg_or_int_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern27 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!imm_for_neon_rshift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern32 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern32 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern32 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern32 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern32 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2SFmode:
      if (pattern32 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern32 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern68 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern68 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern68 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern32 (x3, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern32 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern59 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern59 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != TRUNCATE
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  return 0;
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !s_register_operand (operands[1], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern127 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern40 (x3, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern40 (x3, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern40 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern38 (x3, 
E_V2SFmode, 
E_V2SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern38 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern38 (x3, 
E_V8HFmode, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern38 (x3, 
E_V4HFmode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_OImode:
      return 1;

    case E_EImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern163 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V8QImode:
      return 0;

    case E_V4HImode:
      return 1;

    case E_V4HFmode:
      return 2;

    case E_V4BFmode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V2SFmode:
      return 5;

    case E_DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern173 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern41 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern181 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern41 (x3, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return pattern117 (x3, 
E_V16QImode, 
E_V8HImode); /* [-1, 1] */
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern68 (x3, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern68 (x3, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern32 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern208 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern201 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern206 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern217 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern216 (x3, 
E_V16BImode, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern216 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern216 (x3, 
E_V4BImode, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern209 (x3, 
E_V8BImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern209 (x3, 
E_V4BImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern240 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers == NULL
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || !arm_rhs_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_V2SImode:
          if (GET_MODE (x1) != E_V2SImode)
            return -1;
          return 1;

        case E_V4HImode:
          if (GET_MODE (x1) != E_V4HImode)
            return -1;
          return 2;

        case E_V8QImode:
          if (GET_MODE (x1) != E_V8QImode)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern1 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V8HImode:
          if (pattern1 (x1, 
E_V8HImode) != 0)
            return -1;
          return 5;

        case E_V4SImode:
          if (pattern1 (x1, 
E_V4SImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    case VEC_SELECT:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_CODE (x3) != VEC_SELECT)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 0);
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x8 = XVECEXP (x4, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XVECLEN (x5, 0) != 2)
            return -1;
          x10 = XVECEXP (x5, 0, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x11 = XVECEXP (x5, 0, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || pattern237 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 7;

        case 4:
          if (pattern238 (x1) != 0)
            return -1;
          return 8;

        case 8:
          if (pattern239 (x1) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern265 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (XVECLEN (x6, 0))
    {
    case 1:
      if (XINT (x6, 1) != 17)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != UNSPEC_VOLATILE
          || XVECLEN (x10, 0) != 5
          || XINT (x10, 1) != 17)
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      x12 = XVECEXP (x10, 0, 0);
      operands[3] = x12;
      x13 = XVECEXP (x10, 0, 1);
      operands[4] = x13;
      x14 = XVECEXP (x10, 0, 2);
      operands[5] = x14;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      x15 = XVECEXP (x10, 0, 3);
      operands[6] = x15;
      if (!const_int_operand (operands[6], E_SImode))
        return -1;
      x16 = XVECEXP (x10, 0, 4);
      operands[7] = x16;
      if (!const_int_operand (operands[7], E_SImode))
        return -1;
      operands[8] = x5;
      return pattern261 (x1); /* [-1, 7] */

    case 2:
      if (XINT (x6, 1) != 19)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 100
          || GET_MODE (x11) != E_CCmode)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x17 = XVECEXP (x6, 0, 1);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x18 = XEXP (x9, 0);
      operands[3] = x18;
      operands[4] = x5;
      x7 = XVECEXP (x6, 0, 0);
      switch (GET_CODE (x7))
        {
        case PLUS:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case MINUS:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        case IOR:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 16; /* [16, 19] */
          return -1;

        case XOR:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 20; /* [20, 23] */
          return -1;

        case AND:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 24; /* [24, 27] */
          return -1;

        case NOT:
          x19 = XEXP (x7, 0);
          if (GET_CODE (x19) != AND)
            return -1;
          x20 = XEXP (x19, 1);
          operands[1] = x20;
          x21 = XEXP (x19, 0);
          if (!rtx_equal_p (x21, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern264 (x6, 
E_QImode) != 0)
                return -1;
              return 28;

            case E_HImode:
              if (pattern264 (x6, 
E_HImode) != 0)
                return -1;
              return 29;

            case E_SImode:
              if (pattern264 (x6, 
E_SImode) != 0)
                return -1;
              return 30;

            case E_DImode:
              if (!mem_noofs_operand (operands[0], E_DImode)
                  || GET_MODE (x6) != E_DImode
                  || GET_MODE (x7) != E_DImode
                  || GET_MODE (x19) != E_DImode
                  || !s_register_operand (operands[1], E_DImode)
                  || !scratch_operand (operands[3], E_DImode))
                return -1;
              return 31;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern311 (x6, 
E_V2SImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern311 (x6, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V8QImode:
      if (pattern311 (x6, 
E_V8QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2
      || !s_register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern331 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern323 (x1, 
E_V4SImode, 
E_SImode, 
101) != 0)
    return -1;
  return 0;
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  if (!arm_comparison_operator (operands[4], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  if (!arm_comparison_operator (x5, E_SImode))
    return -1;
  operands[5] = x5;
  return pattern340 (x1); /* [-1, 0] */
}

int
pattern347 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern350 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern350 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern350 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern350 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern350 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern350 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern365 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[4] = x9;
  if (!mve_imm_32 (operands[4], E_SImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[1] = x10;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x11 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  x13 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x13, operands[4]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x6) != E_V16QImode
          || !s_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x6) != E_V8HImode
          || !s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x6) != E_V4SImode
          || !s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern390 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern399 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern398 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern398 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern398 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (!mem_noofs_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !s_register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern412 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  switch (XWINT (x8, 0))
    {
    case 8LL:
      x9 = XEXP (x6, 2);
      switch (XWINT (x9, 0))
        {
        case 8LL:
          return 0;

        case 16LL:
          return 1;

        default:
          return -1;
        }

    case 16LL:
      x9 = XEXP (x6, 2);
      if (XWINT (x9, 0) != 8LL)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern424 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !s_register_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern432 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!arm_rhs_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern440 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  if (!register_operand (operands[0], E_DImode)
      || !register_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x7 = XVECEXP (x3, 0, 2);
  operands[3] = x7;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  return 0;
}

int
pattern450 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

int
pattern460 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !mve_struct_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern477 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern482 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode
      || !register_operand (operands[2], E_V16QImode)
      || !register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern489 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern495 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (XWINT (x5, 0) != 0LL)
    return -1;
  x6 = XEXP (x3, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER
      || pattern450 (x1) != 0)
    return -1;
  return 0;
}

int
pattern501 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!s_register_operand (operands[1], E_TImode)
          || GET_MODE (x1) != i1)
        return -1;
      return 0;

    case E_OImode:
      if (!s_register_operand (operands[1], E_OImode)
          || GET_MODE (x1) != i2)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern511 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern520 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !arm_low_register_operand (operands[0], E_DImode)
      || !arm_low_register_operand (operands[1], E_DImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern527 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern537 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !s_register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern515 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern546 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern553 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern562 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern572 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern571 (x1) != 0)
    return -1;
  return 0;
}

int
pattern580 (rtx x1, machine_mode i1, rtx_code i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern587 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !s_register_operand (operands[2], i3))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern596 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 28
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 104
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 104
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x1, 0);
  operands[4] = x7;
  x8 = XEXP (x7, 0);
  operands[5] = x8;
  x9 = XVECEXP (x2, 0, 0);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_DImode)
      || !mem_noofs_operand (operands[1], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_DImode
      || !s_register_operand (operands[2], E_DImode)
      || !scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern621 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8LL)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12LL)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern645 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

int
pattern649 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8LL)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12LL)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode)
      || pattern417 (x1, 
E_CCmode, 
MINUS) != 0)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[2])
      || !
#line 1654 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
    return -1;
  return 26; /* subsi3_compare1 */
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern288 (x2) != 0)
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!arm_rhs_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (pattern548 (x8, 
IOR))
        {
        case 0:
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x10 = XEXP (x8, 1);
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XEXP (x10, 1);
          if (!rtx_equal_p (x12, operands[2])
              || !
#line 3782 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 111; /* *iorsi3_compare0 */

        case 1:
          if (!
#line 3797 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 112; /* *iorsi3_compare0_scratch */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pattern384 (x1, 
IOR) != 0
          || !
#line 10530 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 345; /* *ior_scc_scc_cmp */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_SImode)
          && pattern495 (x1) == 0)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (s_register_operand (operands[1], E_SImode))
            {
              x8 = XEXP (x5, 1);
              operands[2] = x8;
              if (const_int_operand (operands[2], E_SImode))
                {
                  x9 = XEXP (x3, 1);
                  operands[4] = x9;
                  if (arm_not_operand (operands[4], E_SImode)
                      && 
#line 3182 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)
   && !reg_overlap_mentioned_p (operands[0], operands[4])))
                    return 96; /* *ite_ne_zeroextractsi */
                }
            }
        }
      if (XWINT (x6, 0) != 0LL
          || pattern495 (x1) != 0)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!arm_not_operand (operands[3], E_SImode)
          || !
#line 3221 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && !reg_overlap_mentioned_p (operands[0], operands[3])))
        return -1;
      return 97; /* *ite_ne_zeroextractsi_shifted */

    case REG:
    case SUBREG:
      operands[0] = x5;
      if (s_register_operand (operands[0], E_SImode)
          && pattern387 (x1) == 0)
        {
          x9 = XEXP (x3, 1);
          x10 = XEXP (x9, 0);
          operands[1] = x10;
          if (
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return 1065; /* *thumb2_cbnz */
        }
      if (pnum_clobbers == NULL
          || GET_CODE (x5) != REG
          || REGNO (x5) != 14
          || GET_MODE (x5) != E_SImode)
        return -1;
      x11 = XEXP (x4, 1);
      if (XWINT (x11, 0) != 1LL)
        return -1;
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != LABEL_REF)
        return -1;
      x12 = XEXP (x3, 2);
      if (GET_CODE (x12) != PC)
        return -1;
      x13 = XEXP (x2, 0);
      if (GET_CODE (x13) != PC)
        return -1;
      x14 = XVECEXP (x1, 0, 1);
      if (pattern528 (x14) != 0)
        return -1;
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x17 = XEXP (x14, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 14
          || GET_MODE (x17) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!
#line 1771 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_32BIT && TARGET_HAVE_LOB))
        return -1;
      *pnum_clobbers = 1;
      return 1075; /* *doloop_end_internal */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x5, 1);
  operands[2] = x9;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x2, 1);
  operands[4] = x11;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[0])
      || !
#line 12765 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && ((INTVAL (operands[1]) + 4) == INTVAL (operands[3]))
     && (operands_ok_ldrd_strd (operands[2], operands[4],
                                  operands[0], INTVAL (operands[1]),
                                  false, false))))
    return -1;
  return 426; /* *thumb2_strd */
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC)
        return -1;
      switch (XINT (x3, 1))
        {
        case 79:
          if (pattern364 (x1) != 0
              || !
#line 2792 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
            return -1;
          return 87; /* arm_smlawb_setq_insn */

        case 80:
          if (pattern364 (x1) != 0
              || !
#line 2792 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
            return -1;
          return 89; /* arm_smlawt_setq_insn */

        case 94:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 239; /* arm_smlad_setq_insn */

        case 95:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 241; /* arm_smladx_setq_insn */

        case 96:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 243; /* arm_smlsd_setq_insn */

        case 97:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 245; /* arm_smlsdx_setq_insn */

        case 622:
          switch (pattern365 (x1, 
622))
            {
            case 0:
              if (!
#line 1679 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3954; /* mve_vshlcq_sv16qi */

            case 1:
              if (!
#line 1679 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3956; /* mve_vshlcq_sv8hi */

            case 2:
              if (!
#line 1679 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3958; /* mve_vshlcq_sv4si */

            default:
              return -1;
            }

        case 623:
          switch (pattern365 (x1, 
623))
            {
            case 0:
              if (!
#line 1679 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3955; /* mve_vshlcq_uv16qi */

            case 1:
              if (!
#line 1679 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3957; /* mve_vshlcq_uv8hi */

            case 2:
              if (!
#line 1679 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3959; /* mve_vshlcq_uv4si */

            default:
              return -1;
            }

        case 1035:
          switch (pattern366 (x1, 
1035))
            {
            case 0:
              if (!
#line 3769 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4950; /* mve_viwdupq_wb_uv16qi_insn */

            case 1:
              if (!
#line 3769 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4952; /* mve_viwdupq_wb_uv8hi_insn */

            case 2:
              if (!
#line 3769 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4954; /* mve_viwdupq_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1031:
          switch (pattern366 (x1, 
1031))
            {
            case 0:
              if (!
#line 3769 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4951; /* mve_vdwdupq_wb_uv16qi_insn */

            case 1:
              if (!
#line 3769 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4953; /* mve_vdwdupq_wb_uv8hi_insn */

            case 2:
              if (!
#line 3769 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4955; /* mve_vdwdupq_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1037:
          if (pattern334 (x2) != 0
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1037)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!mve_vldrd_immediate (operands[2], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          switch (pattern586 (x4))
            {
            case 0:
              switch (pattern616 (x5))
                {
                case 0:
                  if (!
#line 3891 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                    return -1;
                  return 4962; /* mve_vstrq_scatter_base_wb_v4si */

                case 1:
                  if (!
#line 3891 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                    return -1;
                  return 4963; /* mve_vstrq_scatter_base_wb_v4sf */

                default:
                  return -1;
                }

            case 1:
              if (!s_register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x5) != E_V2DImode
                  || !
#line 3891 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4964; /* mve_vstrq_scatter_base_wb_v2di */

            default:
              return -1;
            }

        case 1039:
          x8 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_BLKmode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != SCRATCH
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1039)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x6 = XVECEXP (x3, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[3] = x7;
          if (!mve_vldrd_immediate (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          x12 = XVECEXP (x5, 0, 0);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          x13 = XVECEXP (x5, 0, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern602 (x1, 
E_V4SImode) != 0
                  || !
#line 3937 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 4968; /* mve_vldrq_gather_base_wb_v4si */

            case E_V4SFmode:
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !s_register_operand (operands[2], E_V4SImode)
                  || !s_register_operand (operands[1], E_V4SImode)
                  || GET_MODE (x5) != E_V4SImode
                  || !
#line 3937 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 4969; /* mve_vldrq_gather_base_wb_v4sf */

            case E_V2DImode:
              if (pattern602 (x1, 
E_V2DImode) != 0
                  || !
#line 3937 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4970; /* mve_vldrq_gather_base_wb_v2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_15 (x1, insn, pnum_clobbers);

    case 1:
      if (XINT (x3, 1) != 40
          || GET_MODE (x3) != E_SImode)
        return -1;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x6) == MEM
          && GET_MODE (x6) == E_SImode)
        {
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) == CLOBBER)
            {
              x14 = XEXP (x6, 0);
              operands[1] = x14;
              if (register_operand (operands[1], E_SImode))
                {
                  x11 = XEXP (x4, 0);
                  if (rtx_equal_p (x11, operands[1]))
                    return 309; /* *stack_protect_set_insn */
                }
            }
        }
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x6;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 312; /* stack_protect_set_tls */

    case 4:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      switch (XINT (x3, 1))
        {
        case 1034:
          switch (pattern333 (x1, 
PLUS))
            {
            case 0:
              if (!
#line 3750 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4944; /* mve_vidupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3750 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4946; /* mve_vidupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3750 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4948; /* mve_vidupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1030:
          switch (pattern333 (x1, 
MINUS))
            {
            case 0:
              if (!
#line 3750 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4945; /* mve_vddupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3750 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4947; /* mve_vddupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3750 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4949; /* mve_vddupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1038:
          if (pattern334 (x2) != 0)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1038)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!mve_vldrd_immediate (operands[2], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          x15 = XVECEXP (x3, 0, 3);
          operands[4] = x15;
          switch (pattern586 (x4))
            {
            case 0:
              if (!vpr_register_operand (operands[4], E_V4BImode))
                return -1;
              switch (pattern616 (x5))
                {
                case 0:
                  if (!
#line 3915 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                    return -1;
                  return 4965; /* mve_vstrq_scatter_base_wb_p_v4si */

                case 1:
                  if (!
#line 3915 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                    return -1;
                  return 4966; /* mve_vstrq_scatter_base_wb_p_v4sf */

                default:
                  return -1;
                }

            case 1:
              if (!vpr_register_operand (operands[4], E_V2QImode)
                  || !s_register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x5) != E_V2DImode
                  || !
#line 3915 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4967; /* mve_vstrq_scatter_base_wb_p_v2di */

            default:
              return -1;
            }

        case 1040:
          x15 = XVECEXP (x3, 0, 3);
          if (GET_CODE (x15) != MEM
              || GET_MODE (x15) != E_BLKmode)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != SCRATCH)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1040)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x6 = XVECEXP (x3, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[3] = x7;
          if (!mve_vldrd_immediate (operands[3], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[4] = x8;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          x12 = XVECEXP (x5, 0, 0);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          x13 = XVECEXP (x5, 0, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern609 (x1, 
E_V4SImode, 
E_V4BImode) != 0
                  || !
#line 3960 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 4971; /* mve_vldrq_gather_base_wb_z_v4si */

            case E_V4SFmode:
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || pattern608 (x5, 
E_V4SImode, 
E_V4BImode) != 0
                  || !
#line 3960 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 4972; /* mve_vldrq_gather_base_wb_z_v4sf */

            case E_V2DImode:
              if (pattern609 (x1, 
E_V2DImode, 
E_V2QImode) != 0
                  || !
#line 3960 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4973; /* mve_vldrq_gather_base_wb_z_v2di */

            default:
              return -1;
            }

        case 1054:
          if (pattern336 (x1, 
1054) != 0
              || !
#line 4015 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4980; /* mve_vadciq_m_uv4si */

        case 1056:
          if (pattern336 (x1, 
1056) != 0
              || !
#line 4015 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4981; /* mve_vadciq_m_sv4si */

        case 1047:
          if (pattern336 (x1, 
1047) != 0
              || !
#line 4015 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4982; /* mve_vsbciq_m_uv4si */

        case 1048:
          if (pattern336 (x1, 
1048) != 0
              || !
#line 4015 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4983; /* mve_vsbciq_m_sv4si */

        case 1042:
          if (pattern337 (x1, 
1042) != 0
              || !
#line 4056 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4988; /* mve_vadcq_m_uv4si */

        case 1044:
          if (pattern337 (x1, 
1044) != 0
              || !
#line 4056 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4989; /* mve_vadcq_m_sv4si */

        case 1051:
          if (pattern337 (x1, 
1051) != 0
              || !
#line 4056 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4990; /* mve_vsbcq_m_uv4si */

        case 1052:
          if (pattern337 (x1, 
1052) != 0
              || !
#line 4056 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4991; /* mve_vsbcq_m_sv4si */

        case 1061:
          switch (pattern339 (x1, 
1061))
            {
            case 0:
              if (!
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5039; /* mve_vshlcq_m_sv16qi */

            case 1:
              if (!
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5041; /* mve_vshlcq_m_sv8hi */

            case 2:
              if (!
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5043; /* mve_vshlcq_m_sv4si */

            default:
              return -1;
            }

        case 1060:
          switch (pattern339 (x1, 
1060))
            {
            case 0:
              if (!
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5040; /* mve_vshlcq_m_uv16qi */

            case 1:
              if (!
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5042; /* mve_vshlcq_m_uv8hi */

            case 2:
              if (!
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5044; /* mve_vshlcq_m_uv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      x8 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x8) != SUBREG
          || maybe_ne (SUBREG_BYTE (x8), 4)
          || GET_MODE (x8) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 5
          || GET_MODE (x5) != E_SImode)
        return -1;
      x17 = XVECEXP (x5, 0, 2);
      if (GET_CODE (x17) != SUBREG
          || maybe_ne (SUBREG_BYTE (x17), 4)
          || GET_MODE (x17) != E_SImode)
        return -1;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[3] = x7;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      if (!s_register_operand (operands[4], E_DImode))
        return -1;
      x15 = XVECEXP (x3, 0, 3);
      operands[5] = x15;
      if (!mve_imm_selective_upto_8 (operands[5], E_SImode))
        return -1;
      x18 = XVECEXP (x3, 0, 4);
      operands[6] = x18;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x12 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x13, operands[3]))
        return -1;
      x19 = XEXP (x17, 0);
      if (!rtx_equal_p (x19, operands[4]))
        return -1;
      x20 = XVECEXP (x5, 0, 3);
      if (!rtx_equal_p (x20, operands[5]))
        return -1;
      x21 = XVECEXP (x5, 0, 4);
      if (!rtx_equal_p (x21, operands[6]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 1036:
          switch (pattern632 (x1, 
1036))
            {
            case 0:
              if (!
#line 3793 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4956; /* mve_viwdupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3793 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4958; /* mve_viwdupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3793 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4960; /* mve_viwdupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1032:
          switch (pattern632 (x1, 
1032))
            {
            case 0:
              if (!
#line 3793 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4957; /* mve_vdwdupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3793 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4959; /* mve_vdwdupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3793 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4961; /* mve_vdwdupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[0] = x5;
      if (!s_register_operand (operands[0], E_SImode)
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!arm_not_operand (operands[1], E_SImode)
          || !
#line 3076 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      *pnum_clobbers = 1;
      return 92; /* *andsi3_compare0_scratch */

    case NOT:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_SImode
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      if (!s_register_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[0] = x7;
          if (!shift_operator (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[2] = x9;
          if (!shift_amount_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x6;
          if (!
#line 3637 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 106; /* andsi_not_shiftsi_si_scc_no_reuse */

        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          operands[1] = x6;
          if (!
#line 3691 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 109; /* *andsi_notsi_si_compare0_scratch */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pattern341 (x1) != 0
          || !
#line 10330 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 342; /* *cmp_and */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1340 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 648; /* ashlv4hi3_iwmmxt */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1424 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 660; /* ashlv4hi3_di */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1340 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 649; /* ashlv2si3_iwmmxt */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1424 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 661; /* ashlv2si3_di */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      if (register_operand (operands[0], E_DImode))
        {
          x3 = XEXP (x2, 0);
          operands[1] = x3;
          if (register_operand (operands[1], E_DImode))
            {
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (imm_or_reg_operand (operands[2], E_SImode)
                  && 
#line 1340 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 650; /* ashldi3_iwmmxt */
              if (imm_or_reg_operand (operands[2], E_DImode)
                  && 
#line 1424 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 662; /* ashldi3_di */
            }
        }
      if (!arm_general_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!arm_reg_or_long_shift_imm (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[0])
          || !
#line 1749 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE))
        return -1;
      return 1073; /* thumb2_lsll */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], E_BLKmode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_EImode:
      if (!s_register_operand (operands[1], E_EImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5910 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2885; /* neon_vst3_lanev8qi */

        case E_V4HImode:
          if (!
#line 5910 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2886; /* neon_vst3_lanev4hi */

        case E_V4HFmode:
          if (!
#line 5910 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2887; /* neon_vst3_lanev4hf */

        case E_V4BFmode:
          if (!
#line 5910 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2888; /* neon_vst3_lanev4bf */

        case E_V2SImode:
          if (!
#line 5910 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2889; /* neon_vst3_lanev2si */

        case E_V2SFmode:
          if (!
#line 5910 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2890; /* neon_vst3_lanev2sf */

        default:
          return -1;
        }

    case E_CImode:
      if (!s_register_operand (operands[1], E_CImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2891; /* neon_vst3_lanev8hi */

        case E_V8HFmode:
          if (!
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2892; /* neon_vst3_lanev8hf */

        case E_V4SImode:
          if (!
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2893; /* neon_vst3_lanev4si */

        case E_V4SFmode:
          if (!
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2894; /* neon_vst3_lanev4sf */

        case E_V8BFmode:
          if (!(
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2895; /* neon_vst3_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern72 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3558 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4909; /* mve_vldrq_gather_base_z_v4si */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode)
          || !
#line 3558 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4910; /* mve_vldrq_gather_base_z_v4sf */

    case E_V2DImode:
      if (pattern72 (x3, 
E_V2QImode, 
E_V2DImode) != 0
          || !
#line 3558 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4911; /* mve_vldrq_gather_base_z_v2di */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4658 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2473; /* neon_vsli_nv8qi */

    case 1:
      if (!
#line 4658 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2474; /* neon_vsli_nv16qi */

    case 2:
      if (!
#line 4658 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2475; /* neon_vsli_nv4hi */

    case 3:
      if (!
#line 4658 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2476; /* neon_vsli_nv8hi */

    case 4:
      if (!
#line 4658 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2477; /* neon_vsli_nv2si */

    case 5:
      if (!
#line 4658 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2478; /* neon_vsli_nv4si */

    case 6:
      if (!
#line 4658 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2479; /* neon_vsli_ndi */

    case 7:
      if (!
#line 4658 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2480; /* neon_vsli_nv2di */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern44 (x1, 
E_CImode, 
E_EImode))
    {
    case 0:
      if (!
#line 5054 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2585; /* neon_vld1x3qbv16qi */

    case 1:
      if (!
#line 5054 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2586; /* neon_vld1x3qbv8hi */

    case 2:
      if (!
#line 5054 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2587; /* neon_vld1x3qbv8hf */

    case 3:
      if (!(
#line 5054 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2588; /* neon_vld1x3qbv8bf */

    case 4:
      if (!
#line 5054 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2589; /* neon_vld1x3qbv4si */

    case 5:
      if (!
#line 5054 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2590; /* neon_vld1x3qbv4sf */

    case 6:
      if (!
#line 5054 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2591; /* neon_vld1x3qbv2di */

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern36 (x1))
    {
    case 0:
      if (!
#line 2192 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1597; /* neon_vqrdmlshv4hi */

    case 1:
      if (!
#line 2192 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1599; /* neon_vqrdmlshv2si */

    case 2:
      if (!
#line 2192 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1601; /* neon_vqrdmlshv8hi */

    case 3:
      if (!
#line 2192 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1603; /* neon_vqrdmlshv4si */

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!mve_memory_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 3130 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4820; /* mve_vstrq_v16qi */

    case E_V8HImode:
      if (!mve_memory_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 3130 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4821; /* mve_vstrq_v8hi */

    case E_V4SImode:
      if (!mve_memory_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 3130 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4822; /* mve_vstrq_v4si */

    case E_V8HFmode:
      if (!mve_memory_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode)
          || !
#line 3130 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4823; /* mve_vstrq_v8hf */

    case E_V4SFmode:
      if (!mve_memory_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 3130 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4824; /* mve_vstrq_v4sf */

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BImode:
      if (!vpr_register_operand (operands[0], E_V16BImode)
          || GET_MODE (x3) != E_V16BImode
          || !
#line 465 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3355; /* mve_vctp8qv16bi */

    case E_V8BImode:
      if (!vpr_register_operand (operands[0], E_V8BImode)
          || GET_MODE (x3) != E_V8BImode
          || !
#line 465 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3356; /* mve_vctp16qv8bi */

    case E_V4BImode:
      if (!vpr_register_operand (operands[0], E_V4BImode)
          || GET_MODE (x3) != E_V4BImode
          || !
#line 465 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3357; /* mve_vctp32qv4bi */

    case E_V2QImode:
      if (!vpr_register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !
#line 465 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3358; /* mve_vctp64qv2qi */

    default:
      return -1;
    }
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4HFmode)
          || !
#line 3736 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FP16))
        return -1;
      return 2116; /* neon_vcvtv4sfv4hf */

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 3745 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FP16))
        return -1;
      return 2117; /* neon_vcvtv4hfv4sf */

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern104 (x1))
    {
    case 0:
      if (!
#line 2846 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1917; /* neon_vqabsv8qi */

    case 1:
      if (!
#line 2846 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1918; /* neon_vqabsv16qi */

    case 2:
      if (!
#line 2846 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1919; /* neon_vqabsv4hi */

    case 3:
      if (!
#line 2846 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1920; /* neon_vqabsv8hi */

    case 4:
      if (!
#line 2846 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1921; /* neon_vqabsv2si */

    case 5:
      if (!
#line 2846 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1922; /* neon_vqabsv4si */

    default:
      return -1;
    }
}

 int
recog_137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!s_register_operand (operands[0], E_TImode)
          || GET_MODE (x2) != E_TImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!neon_struct_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_V8QImode
              || !
#line 5498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2796; /* neon_vld2_dupv8qi */

        case E_SImode:
          if (!neon_struct_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_V4HImode
              || !
#line 5498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2797; /* neon_vld2_dupv4hi */

        case E_SFmode:
          if (!neon_struct_operand (operands[1], E_SFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !
#line 5498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2798; /* neon_vld2_dupv4hf */

        case E_BFmode:
          if (!neon_struct_operand (operands[1], E_BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !(
#line 5498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2799; /* neon_vld2_dupv4bf */

        case E_V2SImode:
          if (!neon_struct_operand (operands[1], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !
#line 5498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2800; /* neon_vld2_dupv2si */

        case E_V2SFmode:
          if (!neon_struct_operand (operands[1], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !
#line 5498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2801; /* neon_vld2_dupv2sf */

        case E_V2DImode:
          if (!neon_struct_operand (operands[1], E_V2DImode)
              || GET_MODE (x3) != E_DImode
              || !
#line 5498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2802; /* neon_vld2_dupdi */

        default:
          return -1;
        }

    case E_OImode:
      if (pattern458 (x2, 
E_OImode) != 0
          || !
#line 5516 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 2803; /* neon_vld2_dupv8bf */

    case E_CImode:
      if (pattern458 (x2, 
E_CImode) != 0
          || !
#line 5799 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 2865; /* neon_vld3_dupv8bf */

    case E_XImode:
      if (pattern458 (x2, 
E_XImode) != 0
          || !
#line 6134 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 2933; /* neon_vld4_dupv8bf */

    default:
      return -1;
    }
}

 int
recog_146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern157 (x1))
    {
    case 0:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2702; /* neon_vst1x3qav8qi */

    case 1:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2703; /* neon_vst1x3qav16qi */

    case 2:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2704; /* neon_vst1x3qav4hi */

    case 3:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2705; /* neon_vst1x3qav8hi */

    case 4:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2706; /* neon_vst1x3qav2si */

    case 5:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2707; /* neon_vst1x3qav4si */

    case 6:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2708; /* neon_vst1x3qav4hf */

    case 7:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2709; /* neon_vst1x3qav8hf */

    case 8:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2710; /* neon_vst1x3qav4bf */

    case 9:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2711; /* neon_vst1x3qav8bf */

    case 10:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2712; /* neon_vst1x3qav2sf */

    case 11:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2713; /* neon_vst1x3qav4sf */

    case 12:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2714; /* neon_vst1x3qadi */

    case 13:
      if (!
#line 5270 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2715; /* neon_vst1x3qav2di */

    default:
      return -1;
    }
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern145 (x1))
    {
    case 0:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1829; /* neon_vminsv8qi */

    case 1:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1833; /* neon_vminsv16qi */

    case 2:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1837; /* neon_vminsv4hi */

    case 3:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1841; /* neon_vminsv8hi */

    case 4:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1845; /* neon_vminsv2si */

    case 5:
      if (!
#line 2681 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1849; /* neon_vminsv4si */

    case 6:
      if (!
#line 2691 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1852; /* neon_vminfv2sf */

    case 7:
      if (!
#line 2691 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1854; /* neon_vminfv4sf */

    case 8:
      if (!
#line 2702 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1856; /* neon_vminfv8hf */

    case 9:
      if (!
#line 2702 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1858; /* neon_vminfv4hf */

    default:
      return -1;
    }
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4575 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2395; /* neon_vshl_nv8qi */

    case 1:
      if (!
#line 4575 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2396; /* neon_vshl_nv16qi */

    case 2:
      if (!
#line 4575 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2397; /* neon_vshl_nv4hi */

    case 3:
      if (!
#line 4575 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2398; /* neon_vshl_nv8hi */

    case 4:
      if (!
#line 4575 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2399; /* neon_vshl_nv2si */

    case 5:
      if (!
#line 4575 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2400; /* neon_vshl_nv4si */

    case 6:
      if (!
#line 4575 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2401; /* neon_vshl_ndi */

    case 7:
      if (!
#line 4575 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2402; /* neon_vshl_nv2di */

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2277; /* neon_vrshlsv8qi */

    case 1:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2281; /* neon_vrshlsv16qi */

    case 2:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2285; /* neon_vrshlsv4hi */

    case 3:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2289; /* neon_vrshlsv8hi */

    case 4:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2293; /* neon_vrshlsv2si */

    case 5:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2297; /* neon_vrshlsv4si */

    case 6:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2301; /* neon_vrshlsdi */

    case 7:
      if (!
#line 4498 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2305; /* neon_vrshlsv2di */

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 1600 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1509; /* neon_vqadduv8qi */

    case 1:
      if (!
#line 1600 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1511; /* neon_vqadduv16qi */

    case 2:
      if (!
#line 1600 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1513; /* neon_vqadduv4hi */

    case 3:
      if (!
#line 1600 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1515; /* neon_vqadduv8hi */

    case 4:
      if (!
#line 1600 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1517; /* neon_vqadduv2si */

    case 5:
      if (!
#line 1600 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1519; /* neon_vqadduv4si */

    case 6:
      if (!
#line 1600 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1521; /* neon_vqaddudi */

    case 7:
      if (!
#line 1600 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1523; /* neon_vqadduv2di */

    default:
      return -1;
    }
}

 int
recog_194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1, 
E_EImode, 
E_CImode))
    {
    case 0:
      if (!
#line 5036 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2578; /* neon_vld1x3qav16qi */

    case 1:
      if (!
#line 5036 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2579; /* neon_vld1x3qav8hi */

    case 2:
      if (!
#line 5036 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2580; /* neon_vld1x3qav8hf */

    case 3:
      if (!(
#line 5036 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2581; /* neon_vld1x3qav8bf */

    case 4:
      if (!
#line 5036 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2582; /* neon_vld1x3qav4si */

    case 5:
      if (!
#line 5036 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2583; /* neon_vld1x3qav4sf */

    case 6:
      if (!
#line 5036 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2584; /* neon_vld1x3qav2di */

    default:
      return -1;
    }
}

 int
recog_204 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern164 (x1, 
E_CImode, 
E_EImode))
    {
    case 0:
      if (!
#line 5868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2873; /* neon_vst3qav16qi */

    case 1:
      if (!
#line 5868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2874; /* neon_vst3qav8hi */

    case 2:
      if (!
#line 5868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2875; /* neon_vst3qav8hf */

    case 3:
      if (!(
#line 5868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2876; /* neon_vst3qav8bf */

    case 4:
      if (!
#line 5868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2877; /* neon_vst3qav4si */

    case 5:
      if (!
#line 5868 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2878; /* neon_vst3qav4sf */

    default:
      return -1;
    }
}

 int
recog_214 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2303 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1650; /* neon_vhsubuv8qi */

    case 1:
      if (!
#line 2303 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1652; /* neon_vhsubuv16qi */

    case 2:
      if (!
#line 2303 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1654; /* neon_vhsubuv4hi */

    case 3:
      if (!
#line 2303 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1656; /* neon_vhsubuv8hi */

    case 4:
      if (!
#line 2303 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1658; /* neon_vhsubuv2si */

    case 5:
      if (!
#line 2303 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1660; /* neon_vhsubuv4si */

    default:
      return -1;
    }
}

 int
recog_224 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern169 (x1))
    {
    case 0:
      if (!
#line 542 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3369; /* mve_vcreateq_sv16qi */

    case 1:
      if (!
#line 542 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3371; /* mve_vcreateq_sv8hi */

    case 2:
      if (!
#line 542 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3373; /* mve_vcreateq_sv4si */

    case 3:
      if (!
#line 542 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3375; /* mve_vcreateq_sv2di */

    default:
      return -1;
    }
}

 int
recog_233 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1708; /* neon_vcgtv2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1713; /* neon_vcgtv4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1728; /* neon_vcgtv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1733; /* neon_vcgtv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_243 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_ccde1_operand (operands[2], E_SImode))
    return -1;
  switch (pattern393 (x3))
    {
    case 0:
      if (!
#line 4528 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 139; /* arm_cx1si */

    case 1:
      if (!
#line 4528 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 140; /* arm_cx1di */

    default:
      return -1;
    }
}

 int
recog_253 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern196 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern483 (x2, 
E_SImode) != 0
          || !
#line 2238 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 937; /* arm_vcx3si */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern483 (x2, 
E_DImode) != 0
          || !
#line 2238 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 938; /* arm_vcx3di */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern482 (x2) != 0
          || !const_int_mve_cde3_operand (operands[4], E_SImode)
          || !
#line 4486 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5049; /* arm_vcx3qv16qi */

    case 3:
      if (!
#line 4513 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5051; /* arm_vcx1q_p_v16qi */

    default:
      return -1;
    }
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern198 (x1))
    {
    case 0:
      if (!
#line 4082 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2218; /* neon_vmls_lanev4hi */

    case 1:
      if (!
#line 4082 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2219; /* neon_vmls_lanev2si */

    case 2:
      if (!
#line 4082 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2220; /* neon_vmls_lanev2sf */

    case 3:
      if (!
#line 4100 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2221; /* neon_vmls_lanev8hi */

    case 4:
      if (!
#line 4100 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2222; /* neon_vmls_lanev4si */

    case 5:
      if (!
#line 4100 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2223; /* neon_vmls_lanev4sf */

    default:
      return -1;
    }
}

 int
recog_261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!
#line 3984 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2198; /* neon_vqrdmlah_lanev8hi */

    case 1:
      if (!
#line 3984 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2200; /* neon_vqrdmlah_lanev4si */

    case 2:
      if (!
#line 4000 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2202; /* neon_vqrdmlah_lanev4hi */

    case 3:
      if (!
#line 4000 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2204; /* neon_vqrdmlah_lanev2si */

    default:
      return -1;
    }
}

 int
recog_269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL)
    {
      res = recog_267 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!equality_operator (x3, E_VOIDmode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) == LABEL_REF)
    {
      res = recog_268 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  x5 = XEXP (x3, 0);
  if (!arm_comparison_operator (x5, E_VOIDmode))
    return -1;
  operands[4] = x5;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x3, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x1, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[5] = x9;
  if (!cc_register (operands[5], E_VOIDmode))
    return -1;
  operands[1] = x4;
  if (!arm_rhs_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  if (
#line 10074 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
    return 337; /* *cond_move */
  if (!
#line 706 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
    return -1;
  return 1035; /* *thumb2_cond_move */
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (!s_register_operand (x4, E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  operands[6] = x3;
  x6 = XEXP (x3, 1);
  if (!arm_add_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      operands[7] = x7;
      if (!shiftable_operator (operands[7], E_SImode))
        return -1;
      operands[2] = x4;
      operands[3] = x6;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[5] = x9;
      if (!arm_rhs_operand (operands[5], E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      operands[1] = x10;
      if (!arm_rhs_operand (operands[1], E_SImode)
          || !
#line 10996 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 358; /* *ifcompare_arith_move */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!arm_rhs_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      if (!shiftable_operator (x10, E_SImode))
        return -1;
      operands[7] = x10;
      operands[4] = x4;
      operands[5] = x6;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!arm_rhs_operand (operands[3], E_SImode)
          || !
#line 11061 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 360; /* *ifcompare_move_arith */

    default:
      return -1;
    }
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  if (!cc_register (operands[4], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!arm_not_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x2, 2);
  operands[2] = x8;
  if (!arm_not_operand (operands[2], E_SImode)
      || !
#line 442 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
    return -1;
  return 1023; /* *thumb2_movsicc_insn */
}

 int
recog_279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
          if (s_register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && s_register_operand (operands[1], E_SImode))
            {
              switch (XWINT (x4, 0))
                {
                case 0LL:
                  if (
#line 4067 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return 117; /* *smax_0 */
                  break;

                case -1LL:
                  if (
#line 4077 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return 118; /* *smax_m1 */
                  break;

                default:
                  break;
                }
            }
          break;

        case REG:
        case SUBREG:
          switch (pattern348 (x2))
            {
            case 0:
              if (register_operand (operands[0], E_V2SImode)
                  && register_operand (operands[1], E_V2SImode)
                  && register_operand (operands[2], E_V2SImode)
                  && 
#line 903 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 603; /* *smaxv2si3_iwmmxt */
              if (s_register_operand (operands[0], E_V2SImode)
                  && s_register_operand (operands[1], E_V2SImode)
                  && s_register_operand (operands[2], E_V2SImode)
                  && 
#line 891 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1367; /* *smaxv2si3_neon */
              break;

            case 1:
              if (register_operand (operands[0], E_V4HImode)
                  && register_operand (operands[1], E_V4HImode)
                  && register_operand (operands[2], E_V4HImode)
                  && 
#line 903 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 604; /* *smaxv4hi3_iwmmxt */
              if (s_register_operand (operands[0], E_V4HImode)
                  && s_register_operand (operands[1], E_V4HImode)
                  && s_register_operand (operands[2], E_V4HImode)
                  && 
#line 891 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1365; /* *smaxv4hi3_neon */
              break;

            case 2:
              if (register_operand (operands[0], E_V8QImode)
                  && register_operand (operands[1], E_V8QImode)
                  && register_operand (operands[2], E_V8QImode)
                  && 
#line 903 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 605; /* *smaxv8qi3_iwmmxt */
              if (s_register_operand (operands[0], E_V8QImode)
                  && s_register_operand (operands[1], E_V8QImode)
                  && s_register_operand (operands[2], E_V8QImode)
                  && 
#line 891 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1363; /* *smaxv8qi3_neon */
              break;

            case 3:
              if (
#line 2070 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
                return 915; /* smaxsf3 */
              break;

            case 4:
              if ((
#line 2070 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return 916; /* smaxdf3 */
              break;

            case 5:
              if (
#line 891 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1364; /* *smaxv16qi3_neon */
              if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3613; /* mve_vmaxq_sv16qi */
              break;

            case 6:
              if (
#line 891 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1366; /* *smaxv8hi3_neon */
              if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3617; /* mve_vmaxq_sv8hi */
              break;

            case 7:
              if (
#line 891 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1368; /* *smaxv4si3_neon */
              if (
#line 916 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3621; /* mve_vmaxq_sv4si */
              break;

            case 8:
              if (
#line 891 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1369; /* *smaxv2sf3_neon */
              break;

            case 9:
              if (
#line 891 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1370; /* *smaxv4sf3_neon */
              if (
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return 3796; /* mve_vmaxnmq_fv4sf */
              break;

            case 10:
              if (
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return 3794; /* mve_vmaxnmq_fv8hf */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || pattern349 (x2) != 0
          || !
#line 4088 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 119; /* *arm_smax_insn */

    case SMIN:
      switch (pattern270 (x2))
        {
        case 0:
          if (!
#line 4477 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[2], operands[1], NULL, NULL)))
            return -1;
          return 135; /* satsi_smax */

        case 1:
          if (!
#line 4503 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[2], operands[1], NULL, NULL)))
            return -1;
          return 138; /* *satsi_smax_shift */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern271 (x2))
        {
        case 0:
          if (!
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1418; /* quad_halves_smaxv4si */

        case 1:
          if (!
#line 1142 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 1423; /* quad_halves_smaxv4sf */

        case 2:
          if (!
#line 1157 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1426; /* quad_halves_smaxv8hi */

        case 3:
          if (!
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1431; /* quad_halves_smaxv16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          operands[3] = x4;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2292 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2))
            return -1;
          return 58; /* *mls */

        case E_HFmode:
          if (pattern433 (x2, 
E_HFmode) != 0
              || !
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 819; /* *mulhf3neghfaddhf_vfp */

        case E_SFmode:
          if (pattern433 (x2, 
E_SFmode) != 0
              || !
#line 1279 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 820; /* *mulsf3negsfaddsf_vfp */

        case E_DFmode:
          if (pattern433 (x2, 
E_DFmode) != 0
              || !
#line 1290 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 821; /* *fmuldf3negdfadddf_vfp */

        case E_V8QImode:
          if (pattern433 (x2, 
E_V8QImode) != 0
              || !
#line 611 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8QI_ARITH))
            return -1;
          return 1199; /* mulv8qi3negv8qiaddv8qi_neon */

        case E_V16QImode:
          if (pattern433 (x2, 
E_V16QImode) != 0
              || !
#line 611 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V16QI_ARITH))
            return -1;
          return 1200; /* mulv16qi3negv16qiaddv16qi_neon */

        case E_V4HImode:
          if (pattern433 (x2, 
E_V4HImode) != 0
              || !
#line 611 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HI_ARITH))
            return -1;
          return 1201; /* mulv4hi3negv4hiaddv4hi_neon */

        case E_V8HImode:
          if (pattern433 (x2, 
E_V8HImode) != 0
              || !
#line 611 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HI_ARITH))
            return -1;
          return 1202; /* mulv8hi3negv8hiaddv8hi_neon */

        case E_V2SImode:
          if (pattern433 (x2, 
E_V2SImode) != 0
              || !
#line 611 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SI_ARITH))
            return -1;
          return 1203; /* mulv2si3negv2siaddv2si_neon */

        case E_V4SImode:
          if (pattern433 (x2, 
E_V4SImode) != 0
              || !
#line 611 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SI_ARITH))
            return -1;
          return 1204; /* mulv4si3negv4siaddv4si_neon */

        case E_V2SFmode:
          if (pattern433 (x2, 
E_V2SFmode) != 0
              || !
#line 611 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 1205; /* mulv2sf3negv2sfaddv2sf_neon */

        case E_V4SFmode:
          if (pattern433 (x2, 
E_V4SFmode) != 0
              || !
#line 611 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 1206; /* mulv4sf3negv4sfaddv4sf_neon */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || pattern467 (x6) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (pattern581 (x7) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (pattern620 (x3))
        {
        case 0:
          if (!
#line 794 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 736; /* iwmmxt_wmiawbbn */

        case 1:
          if (!
#line 807 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 737; /* iwmmxt_wmiawbtn */

        case 2:
          if (!
#line 820 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 738; /* iwmmxt_wmiawtbn */

        case 3:
          if (!
#line 833 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 739; /* iwmmxt_wmiawttn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_287 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case MINUS:
      if (GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[2] = x5;
              if (!s_register_operand (operands[2], E_SImode)
                  || !reg_or_int_operand (operands[1], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              operands[3] = x6;
              if (!arm_borrow_operation (operands[3], E_SImode)
                  || !
#line 1697 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 29; /* subsi3_carryin */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[2] = x5;
              if (!shift_operator (operands[2], E_SImode)
                  || !s_register_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x5, 0);
              operands[3] = x7;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x8 = XEXP (x5, 1);
              operands[4] = x8;
              if (!shift_amount_operand (operands[4], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              operands[5] = x6;
              if (!arm_borrow_operation (operands[5], E_SImode)
                  || !
#line 1831 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 41; /* *subsi3_carryin_shift */

            case GEU:
            case LTU:
              operands[5] = x5;
              if (!arm_borrow_operation (operands[5], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              if (!shift_operator (x6, E_SImode))
                return -1;
              operands[2] = x6;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x6, 0);
              operands[3] = x9;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x10 = XEXP (x6, 1);
              operands[4] = x10;
              if (!shift_amount_operand (operands[4], E_SImode)
                  || !
#line 1848 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 42; /* *subsi3_carryin_shift_alt */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[2] = x4;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x4, 0);
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x4, 1);
          operands[4] = x12;
          if (!shift_amount_operand (operands[4], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[1] = x5;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              operands[5] = x6;
              if (!arm_borrow_operation (operands[5], E_SImode)
                  || !
#line 1866 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 43; /* *rsbsi3_carryin_shift */

            case GEU:
            case LTU:
              operands[5] = x5;
              if (!arm_borrow_operation (operands[5], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              if (!s_register_operand (operands[1], E_SImode)
                  || !
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 44; /* *rsbsi3_carryin_shift_alt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[1] = x3;
      if (!arm_carry_operation (operands[1], E_SImode)
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!s_register_operand (operands[2], E_SImode)
          || !
#line 1714 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      return 30; /* rsbsi_carryin_reg */

    case PLUS:
      if (GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!arm_neg_immediate_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      if (!arm_borrow_operation (operands[3], E_SImode)
          || !
#line 1807 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 39; /* *subsi3_carryin_const */

    case CONST_INT:
    case REG:
    case SUBREG:
      return recog_286 (x1, insn, pnum_clobbers);

    case NEG:
      if (pattern244 (x2, 
E_SImode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!arm_borrow_operation (operands[2], E_SImode)
          || !
#line 5211 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 170; /* negsi2_carryin */

    case MULT:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[2] = x4;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          switch (GET_CODE (operands[3]))
            {
            case CONST_INT:
              if (!power_of_two_operand (operands[3], E_SImode)
                  || pattern397 (x2, 
E_SImode) != 0
                  || !
#line 9686 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 320; /* *rsb_multsi */

            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_HFmode:
                  if (pattern468 (x2, 
E_HFmode) != 0
                      || !
#line 1234 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                    return -1;
                  return 816; /* *mulhf3subhf_vfp */

                case E_SFmode:
                  if (pattern468 (x2, 
E_SFmode) != 0
                      || !
#line 1245 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                    return -1;
                  return 817; /* *mulsf3subsf_vfp */

                case E_DFmode:
                  if (pattern468 (x2, 
E_DFmode) != 0
                      || !
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                    return -1;
                  return 818; /* *muldf3subdf_vfp */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern303 (x3, 
2, 
0) != 0)
            return -1;
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 1);
          x13 = XVECEXP (x8, 0, 0);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x14 = XVECEXP (x8, 0, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x6 = XEXP (x2, 1);
          if (pattern580 (x6, 
E_V2SImode, 
VEC_SELECT, 
MULT) != 0)
            return -1;
          x9 = XEXP (x6, 0);
          x15 = XEXP (x9, 1);
          if (pattern604 (x15, 
3, 
2) != 0)
            return -1;
          x10 = XEXP (x6, 1);
          if (GET_CODE (x10) != VEC_SELECT
              || GET_MODE (x10) != E_V2SImode)
            return -1;
          x16 = XEXP (x10, 1);
          if (GET_CODE (x16) != PARALLEL
              || XVECLEN (x16, 0) != 2)
            return -1;
          x17 = XVECEXP (x16, 0, 0);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x18 = XVECEXP (x16, 0, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          switch (pattern630 (x2))
            {
            case 0:
              if (pattern644 (x2, 
SIGN_EXTEND) != 0
                  || !
#line 232 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 701; /* iwmmxt_wmaddsn */

            case 1:
              if (pattern644 (x2, 
ZERO_EXTEND) != 0
                  || !
#line 251 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 702; /* iwmmxt_wmaddun */

            default:
              return -1;
            }

        case NEG:
          x11 = XEXP (x4, 0);
          operands[2] = x11;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern434 (x2, 
E_HFmode) != 0
                  || !
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 822; /* *mulhf3neghfsubhf_vfp */

            case E_SFmode:
              if (pattern434 (x2, 
E_SFmode) != 0
                  || !
#line 1316 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 823; /* *mulsf3negsfsubsf_vfp */

            case E_DFmode:
              if (pattern434 (x2, 
E_DFmode) != 0
                  || !
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 824; /* *muldf3negdfsubdf_vfp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x3;
      if (pattern304 (x2) != 0
          || !
#line 9700 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT))
        return -1;
      return 325; /* *rsb_shiftsi */

    default:
      return -1;
    }
}

 int
recog_291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (!shiftable_operator (x2, E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      operands[5] = x3;
      if (!minmax_operator (operands[5], E_SImode))
        return -1;
      operands[4] = x2;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!arm_rhs_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 4256 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1]) && !arm_restrict_it))
        return -1;
      *pnum_clobbers = 1;
      return 125; /* *minmax_arithsi */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[4] = x3;
      if (!arm_comparison_operator (operands[4], E_SImode))
        return -1;
      operands[5] = x2;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!arm_rhs_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 10110 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 338; /* *cond_arith */

    case SUBREG:
    case MEM:
      operands[2] = x3;
      if (!memory_operand (operands[2], E_SImode))
        return -1;
      operands[1] = x2;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      if (!memory_operand (operands[3], E_SImode)
          || !
#line 11472 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && adjacent_mem_locations (operands[2], operands[3])))
        return -1;
      *pnum_clobbers = 1;
      return 380; /* *arith_adjacentmem */

    default:
      return -1;
    }
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (!s_register_operand (x3, E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[4] = x4;
      if (!arm_comparison_operator (operands[4], E_SImode))
        return -1;
      operands[5] = x2;
      if (!shiftable_operator (operands[5], E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!arm_rhs_operand (operands[3], E_SImode))
        return -1;
      operands[1] = x3;
      if (!
#line 756 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it))
        return -1;
      *pnum_clobbers = 1;
      return 1036; /* *thumb2_cond_arith */

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      operands[3] = x2;
      if (!thumb_16bit_operator (operands[3], E_SImode))
        return -1;
      operands[2] = x3;
      if (!
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && GET_CODE(operands[3]) != PLUS
   && GET_CODE(operands[3]) != MINUS))
        return -1;
      *pnum_clobbers = 1;
      return 1052; /* *thumb2_alusi3_short */

    default:
      return -1;
    }
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  if (register_operand (operands[0], E_SImode))
    {
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (register_operand (operands[1], E_V8QImode)
              && 
#line 736 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 589; /* iwmmxt_textrmsb */
          break;

        case E_HImode:
          if (register_operand (operands[1], E_V4HImode)
              && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 591; /* iwmmxt_textrmsh */
          break;

        default:
          break;
        }
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  switch (pattern469 (x3))
    {
    case 0:
      if (!
#line 3222 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2036; /* neon_vget_lanev8qi_sext_internal */

    case 1:
      if (
#line 3260 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2044; /* neon_vget_lanev16qi_sext_internal */
      if (!
#line 4194 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))))
        return -1;
      return 5013; /* *mve_vec_extract_sext_internalv16qi */

    case 2:
      if (!
#line 3222 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2037; /* neon_vget_lanev4hi_sext_internal */

    case 3:
      if (
#line 3260 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2045; /* neon_vget_lanev8hi_sext_internal */
      if (!
#line 4194 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
        return -1;
      return 5014; /* *mve_vec_extract_sext_internalv8hi */

    case 4:
      if (!
#line 3222 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2038; /* neon_vget_lanev2si_sext_internal */

    case 5:
      if (
#line 3260 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2047; /* neon_vget_lanev4si_sext_internal */
      if (!
#line 4194 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
        return -1;
      return 5015; /* *mve_vec_extract_sext_internalv4si */

    case 6:
      if (!
#line 3222 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2039; /* neon_vget_lanev2sf_sext_internal */

    case 7:
      if (!
#line 3260 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2048; /* neon_vget_lanev4sf_sext_internal */

    case 8:
      if (!
#line 3260 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2046; /* neon_vget_lanev8hf_sext_internal */

    default:
      return -1;
    }
}

 int
recog_297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 8:
      if (pattern283 (x2, 
E_V8QImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 4);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XVECEXP (x2, 0, 5);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 6);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x2, 0, 7);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !s_register_operand (operands[0], E_V8QImode)
          || !
#line 574 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 578; /* iwmmxt_clrv8qi */

    case 4:
      if (pattern283 (x2, 
E_V4HImode) != 0
          || !s_register_operand (operands[0], E_V4HImode)
          || !
#line 584 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 579; /* iwmmxt_clrv4hi */

    case 2:
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x2, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V2SImode)
          || !
#line 593 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 580; /* iwmmxt_clrv2si */

    default:
      return -1;
    }
}

 int
recog_300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern345 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (pattern455 (x3, pnum_clobbers) != 0
                      || !
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 71; /* *smull_high */

                case 1:
                  if (!
#line 494 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 571; /* smulv4hi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern345 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern455 (x3, pnum_clobbers) != 0
                          || !
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                        return -1;
                      *pnum_clobbers = 1;
                      return 72; /* *umull_high */

                    case E_V2SImode:
                      if (pattern344 (x3, 
E_V2SImode, 
E_V2DImode) != 0
                          || !
#line 279 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                        return -1;
                      return 704; /* iwmmxt_wmulwum */

                    default:
                      return -1;
                    }

                case 1:
                  if (!
#line 507 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 572; /* umulv4hi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case PLUS:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != ZERO_EXTEND)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x10 = XEXP (x6, 1);
              if (GET_CODE (x10) != CONST_VECTOR
                  || XWINT (x5, 0) != 1LL)
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              x12 = XEXP (x9, 0);
              operands[2] = x12;
              switch (XVECLEN (x10, 0))
                {
                case 8:
                  if (pattern532 (x10, 
1) != 0
                      || pattern498 (x3, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 617 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 581; /* iwmmxt_uavgrndv8qi3 */

                case 4:
                  if (GET_MODE (x10) != E_V4SImode)
                    return -1;
                  x13 = XVECEXP (x10, 0, 0);
                  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x14 = XVECEXP (x10, 0, 1);
                  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x15 = XVECEXP (x10, 0, 2);
                  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x16 = XVECEXP (x10, 0, 3);
                  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                      || pattern498 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 635 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 582; /* iwmmxt_uavgrndv4hi3 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x10 = XEXP (x6, 1);
              if (GET_CODE (x10) != ZERO_EXTEND
                  || XWINT (x5, 0) != 1LL)
                return -1;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              x17 = XEXP (x10, 0);
              operands[2] = x17;
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (pattern344 (x3, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 648 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 583; /* iwmmxt_uavgv8qi3 */

                case E_V4HImode:
                  if (pattern344 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 661 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 584; /* iwmmxt_uavgv4hi3 */

                default:
                  return -1;
                }

            case MULT:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != ZERO_EXTEND)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x10 = XEXP (x6, 1);
              if (GET_CODE (x10) != CONST_VECTOR)
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              x12 = XEXP (x9, 0);
              operands[2] = x12;
              switch (XVECLEN (x10, 0))
                {
                case 4:
                  if (pattern497 (x10) != 0)
                    return -1;
                  x16 = XVECEXP (x10, 0, 3);
                  if (GET_CODE (x16) != CONST_INT
                      || XWINT (x16, 0) != 32768LL
                      || XWINT (x5, 0) != 16LL
                      || pattern498 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 316 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 706; /* iwmmxt_wmulumr */

                case 2:
                  if (pattern499 (x3) != 0
                      || !
#line 350 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 708; /* iwmmxt_wmulwumr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != MINUS)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != ZERO_EXTEND)
        return -1;
      x10 = XEXP (x6, 1);
      if (GET_CODE (x10) != ZERO_EXTEND)
        return -1;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      x17 = XEXP (x10, 0);
      operands[2] = x17;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern344 (x3, 
E_V8QImode, 
E_V8HImode) != 0
              || !
#line 37 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 690; /* iwmmxt_wabsdiffb */

        case E_V4HImode:
          if (pattern344 (x3, 
E_V4HImode, 
E_V4SImode) != 0
              || !
#line 50 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 691; /* iwmmxt_wabsdiffh */

        case E_V2SImode:
          if (pattern344 (x3, 
E_V2SImode, 
E_V2DImode) != 0
              || !
#line 63 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 692; /* iwmmxt_wabsdiffw */

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V8HImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != VEC_MERGE
          || GET_MODE (x6) != E_V8HImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != LSHIFTRT
          || GET_MODE (x7) != E_V8HImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != PLUS
          || GET_MODE (x8) != E_V8HImode)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != PLUS
          || GET_MODE (x11) != E_V8HImode)
        return -1;
      x18 = XEXP (x11, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != E_V8HImode)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != PLUS
          || GET_MODE (x19) != E_V8HImode)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != ZERO_EXTEND
          || GET_MODE (x20) != E_V8HImode)
        return -1;
      x21 = XEXP (x19, 1);
      if (GET_CODE (x21) != ZERO_EXTEND
          || GET_MODE (x21) != E_V8HImode)
        return -1;
      x22 = XEXP (x18, 1);
      if (GET_CODE (x22) != VEC_SELECT
          || GET_MODE (x22) != E_V8HImode)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != ZERO_EXTEND
          || GET_MODE (x23) != E_V8HImode)
        return -1;
      x24 = XEXP (x22, 1);
      if (GET_CODE (x24) != PARALLEL
          || XVECLEN (x24, 0) != 8)
        return -1;
      x25 = XVECEXP (x24, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x26 = XVECEXP (x24, 0, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x27 = XVECEXP (x24, 0, 2);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x28 = XVECEXP (x24, 0, 3);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x29 = XVECEXP (x24, 0, 4);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x30 = XVECEXP (x24, 0, 5);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x31 = XVECEXP (x24, 0, 6);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x32 = XVECEXP (x24, 0, 7);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x33 = XEXP (x11, 1);
      if (GET_CODE (x33) != VEC_SELECT
          || GET_MODE (x33) != E_V8HImode)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != ZERO_EXTEND
          || GET_MODE (x34) != E_V8HImode)
        return -1;
      x35 = XEXP (x33, 1);
      if (GET_CODE (x35) != PARALLEL
          || XVECLEN (x35, 0) != 8)
        return -1;
      x36 = XVECEXP (x35, 0, 0);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x37 = XVECEXP (x35, 0, 1);
      if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x38 = XVECEXP (x35, 0, 2);
      if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x39 = XVECEXP (x35, 0, 3);
      if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x40 = XVECEXP (x35, 0, 4);
      if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x41 = XVECEXP (x35, 0, 5);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x42 = XVECEXP (x35, 0, 6);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x43 = XVECEXP (x35, 0, 7);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x44 = XEXP (x8, 1);
      if (GET_CODE (x44) != CONST_VECTOR
          || XVECLEN (x44, 0) != 8
          || GET_MODE (x44) != E_V8HImode)
        return -1;
      x45 = XVECEXP (x44, 0, 0);
      if (GET_CODE (x45) != CONST_INT)
        return -1;
      x46 = XVECEXP (x44, 0, 1);
      if (GET_CODE (x46) != CONST_INT)
        return -1;
      x47 = XVECEXP (x44, 0, 2);
      if (GET_CODE (x47) != CONST_INT)
        return -1;
      x48 = XVECEXP (x44, 0, 3);
      if (GET_CODE (x48) != CONST_INT)
        return -1;
      x49 = XVECEXP (x44, 0, 4);
      if (GET_CODE (x49) != CONST_INT)
        return -1;
      x50 = XVECEXP (x44, 0, 5);
      if (GET_CODE (x50) != CONST_INT)
        return -1;
      x51 = XVECEXP (x44, 0, 6);
      if (GET_CODE (x51) != CONST_INT)
        return -1;
      x52 = XVECEXP (x44, 0, 7);
      if (GET_CODE (x52) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x10 = XEXP (x6, 1);
      if (GET_CODE (x10) != CONST_VECTOR
          || XVECLEN (x10, 0) != 8
          || pattern532 (x10, 
0) != 0)
        return -1;
      x53 = XEXP (x6, 2);
      if (GET_CODE (x53) != CONST_INT
          || XWINT (x53, 0) != 254LL)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 8)
        return -1;
      x54 = XVECEXP (x5, 0, 0);
      if (x54 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x55 = XVECEXP (x5, 0, 1);
      if (x55 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x56 = XVECEXP (x5, 0, 2);
      if (x56 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x57 = XVECEXP (x5, 0, 3);
      if (x57 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x58 = XVECEXP (x5, 0, 4);
      if (x58 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x59 = XVECEXP (x5, 0, 5);
      if (x59 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x60 = XVECEXP (x5, 0, 6);
      if (x60 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x61 = XVECEXP (x5, 0, 7);
      if (x61 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode)
        return -1;
      x62 = XEXP (x20, 0);
      operands[1] = x62;
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      x63 = XEXP (x21, 0);
      operands[2] = x63;
      if (!register_operand (operands[2], E_V8QImode))
        return -1;
      x64 = XEXP (x23, 0);
      if (!rtx_equal_p (x64, operands[1]))
        return -1;
      x65 = XEXP (x34, 0);
      if (!rtx_equal_p (x65, operands[2]))
        return -1;
      switch (XWINT (x45, 0))
        {
        case 1LL:
          if (XWINT (x46, 0) != 1LL
              || XWINT (x47, 0) != 1LL
              || XWINT (x48, 0) != 1LL
              || XWINT (x49, 0) != 1LL
              || XWINT (x50, 0) != 1LL
              || XWINT (x51, 0) != 1LL
              || XWINT (x52, 0) != 1LL
              || !
#line 143 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 697; /* iwmmxt_avg4 */

        case 2LL:
          if (XWINT (x46, 0) != 2LL
              || XWINT (x47, 0) != 2LL
              || XWINT (x48, 0) != 2LL
              || XWINT (x49, 0) != 2LL
              || XWINT (x50, 0) != 2LL
              || XWINT (x51, 0) != 2LL
              || XWINT (x52, 0) != 2LL
              || !
#line 175 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 698; /* iwmmxt_avg4r */

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          if (GET_MODE (x6) != E_V2DImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != SIGN_EXTEND
              || GET_MODE (x7) != E_V2DImode)
            return -1;
          x10 = XEXP (x6, 1);
          if (GET_CODE (x10) != SIGN_EXTEND
              || GET_MODE (x10) != E_V2DImode
              || XWINT (x5, 0) != 32LL
              || !register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || GET_MODE (x4) != E_V2DImode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          x17 = XEXP (x10, 0);
          operands[2] = x17;
          if (!register_operand (operands[2], E_V2SImode)
              || !
#line 265 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 703; /* iwmmxt_wmulwsm */

        case PLUS:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MULT)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != SIGN_EXTEND)
            return -1;
          x9 = XEXP (x7, 1);
          if (GET_CODE (x9) != SIGN_EXTEND)
            return -1;
          x10 = XEXP (x6, 1);
          if (GET_CODE (x10) != CONST_VECTOR)
            return -1;
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          x12 = XEXP (x9, 0);
          operands[2] = x12;
          switch (XVECLEN (x10, 0))
            {
            case 3:
              if (pattern497 (x10) != 0
                  || XWINT (x5, 0) != 16LL
                  || pattern498 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                  || !
#line 297 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 705; /* iwmmxt_wmulsmr */

            case 2:
              if (pattern499 (x3) != 0
                  || !
#line 333 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 707; /* iwmmxt_wmulwsmr */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 6579 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3009; /* neon_vec_pack_trunc_v8hi */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 6579 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3010; /* neon_vec_pack_trunc_v4si */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 6579 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3011; /* neon_vec_pack_trunc_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_306 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NEG:
      if (GET_MODE (x3) != E_SImode
          || pattern26 (x1, 
E_CC_Zmode) != 0)
        return -1;
      x4 = XEXP (x2, 1);
      if (!s_register_operand (x4, E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[0] = x5;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          operands[1] = x4;
          if (!
#line 1157 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 15; /* *compare_negsi_si */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[1] = x5;
          if (!shift_operator (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          if (!shift_amount_operand (operands[3], E_SImode))
            return -1;
          operands[0] = x4;
          if (!
#line 7925 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 275; /* *arm_cmpsi_negshiftsi_si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern7 (x1, pnum_clobbers, 
E_CC_NVmode))
        {
        case 0:
          x4 = XEXP (x2, 1);
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x8) != E_DImode)
                return -1;
              x9 = XEXP (x8, 0);
              operands[2] = x9;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 1763 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 1;
              return 33; /* cmpsi3_carryin_CC_NVout */

            case CONST_INT:
              operands[2] = x8;
              if (!arm_adcimm_operand (operands[2], E_DImode)
                  || !
#line 1780 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 1;
              return 35; /* cmpsi3_imm_carryin_CC_NVout */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1795 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 37; /* cmpsi3_0_carryin_CC_NVout */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern7 (x1, pnum_clobbers, 
E_CC_Bmode))
        {
        case 0:
          x4 = XEXP (x2, 1);
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x8) != E_DImode)
                return -1;
              x9 = XEXP (x8, 0);
              operands[2] = x9;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 1763 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 1;
              return 34; /* cmpsi3_carryin_CC_Bout */

            case CONST_INT:
              operands[2] = x8;
              if (!arm_adcimm_operand (operands[2], E_DImode)
                  || !
#line 1780 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 1;
              return 36; /* cmpsi3_imm_carryin_CC_Bout */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1795 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 38; /* cmpsi3_0_carryin_CC_Bout */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 100)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          if (s_register_operand (operands[2], E_SImode)
              && GET_MODE (x10) == E_CC_RSBmode
              && GET_MODE (x2) == E_CC_RSBmode)
            {
              operands[1] = x4;
              if (arm_not_immediate_operand (operands[1], E_VOIDmode)
                  && 
#line 2113 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                {
                  *pnum_clobbers = 1;
                  return 49; /* rsb_imm_compare_scratch */
                }
            }
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode)
              || XWINT (x4, 0) != 0LL
              || GET_MODE (x10) != E_CC_NZmode
              || GET_MODE (x2) != E_CC_NZmode
              || !
#line 5428 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 175; /* *notsi_compare0_scratch */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[3] = x5;
          if (!shift_operator (operands[3], E_SImode)
              || XWINT (x4, 0) != 0LL
              || GET_MODE (x10) != E_CC_NZmode
              || GET_MODE (x2) != E_CC_NZmode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!shift_amount_operand (operands[2], E_SImode)
              || !
#line 4828 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 156; /* *not_shiftsi_compare0_scratch */

        default:
          return -1;
        }

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      if (pnum_clobbers != NULL)
        {
          res = recog_48 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (shift_operator (operands[3], E_SImode))
        {
          res = recog_49 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != MULT
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x3, 1);
      operands[2] = x11;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 1455 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size))
        return -1;
      *pnum_clobbers = 1;
      return 1063; /* *thumb2_mulsi_short_compare0_scratch */

    case ZERO_EXTRACT:
      if (pattern8 (x1) != 0)
        return -1;
      x11 = XEXP (x3, 1);
      operands[1] = x11;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x12 = XEXP (x3, 2);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 3092 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
  && (INTVAL (operands[2]) >= 0 && INTVAL (operands[2]) < 32
      && INTVAL (operands[1]) > 0 
      && INTVAL (operands[1]) + (INTVAL (operands[2]) & 1) <= 8
      && INTVAL (operands[1]) + INTVAL (operands[2]) <= 32)))
        return -1;
      return 93; /* *zeroextractsi_compare0_scratch */

    case REG:
    case SUBREG:
      operands[0] = x3;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          switch (GET_CODE (x4))
            {
            case CONST_INT:
              res = recog_50 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case CONST_DOUBLE:
            case REG:
            case SUBREG:
              res = recog_51 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x4;
          if (!arm_add_operand (operands[1], E_SImode)
              || REGNO (x10) != 100
              || GET_MODE (x10) != E_CCmode
              || GET_MODE (x2) != E_CCmode
              || !s_register_operand (operands[0], E_SImode)
              || !
#line 7877 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 272; /* *arm_cmpsi_insn */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[3] = x4;
          if (!shift_operator (operands[3], E_SImode)
              || REGNO (x10) != 100
              || GET_MODE (x10) != E_CCmode
              || GET_MODE (x2) != E_CCmode
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x13 = XEXP (x4, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!shift_amount_operand (operands[2], E_SImode)
              || !
#line 7898 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 273; /* *cmpsi_shiftsi */

        default:
          return -1;
        }

    case UNSPEC:
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (XINT (x3, 1) != 5)
            return -1;
          x14 = XVECEXP (x3, 0, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x1, 0);
          operands[0] = x10;
          if (!cc_register (operands[0], E_CC_NZmode)
              || GET_MODE (x2) != E_CC_NZmode
              || !
#line 9119 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 304; /* *check_arch2 */

        case 2:
          if (pnum_clobbers == NULL
              || XINT (x3, 1) != 41
              || GET_MODE (x3) != E_SImode
              || pattern26 (x1, 
E_CC_Zmode) != 0)
            return -1;
          x14 = XVECEXP (x3, 0, 0);
          operands[0] = x14;
          if (!memory_operand (operands[0], E_SImode))
            return -1;
          x15 = XVECEXP (x3, 0, 1);
          operands[1] = x15;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 2;
          return 313; /* stack_protect_test_tls */

        default:
          return -1;
        }

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      switch (GET_CODE (x3))
        {
        case PLUS:
          res = recog_52 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          res = recog_53 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case IOR:
          res = recog_54 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case XOR:
          if (pattern8 (x1) == 0)
            {
              x11 = XEXP (x3, 1);
              operands[1] = x11;
              if (arm_rhs_operand (operands[1], E_SImode)
                  && 
#line 3882 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return 115; /* *xorsi3_compare0_scratch */
            }
          break;

        case MINUS:
          res = recog_55 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!shiftable_operator (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!shift_operator (x5, E_SImode))
        return -1;
      operands[3] = x5;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      if (!shift_amount_operand (operands[5], E_SImode))
        return -1;
      x11 = XEXP (x3, 1);
      operands[2] = x11;
      if (!s_register_operand (operands[2], E_SImode)
          || !
#line 9754 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      *pnum_clobbers = 1;
      return 330; /* *arith_shiftsi_compare0_scratch */

    case IF_THEN_ELSE:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (!arm_comparison_operator (x5, E_VOIDmode))
        return -1;
      operands[4] = x5;
      x11 = XEXP (x3, 1);
      if (!arm_comparison_operator (x11, E_SImode))
        return -1;
      operands[5] = x11;
      x12 = XEXP (x3, 2);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern340 (x1) != 0)
        return -1;
      switch (XWINT (x12, 0))
        {
        case 0LL:
          if (!
#line 10164 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 340; /* *cmp_ite0 */

        case 1LL:
          if (!
#line 10247 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 341; /* *cmp_ite1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (XVECLEN (x3, 0) != 1)
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[2] = x6;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          if (register_operand (operands[0], E_SImode)
              && register_operand (operands[1], E_V2SImode)
              && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 592; /* iwmmxt_textrmw */
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2SImode:
              if (!s_register_operand (operands[1], E_V2SImode)
                  || !
#line 394 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1151; /* vec_extractv2sisi */

            case E_V4SImode:
              if (!s_register_operand (operands[1], E_V4SImode))
                return -1;
              if (
#line 468 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1156; /* neon_vec_extractv4sisi */
              if (!
#line 4157 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 5009; /* mve_vec_extractv4sisi */

            default:
              return -1;
            }

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!s_register_operand (operands[1], E_V8QImode)
                  || !
#line 394 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1147; /* vec_extractv8qiqi */

            case E_V16QImode:
              if (!s_register_operand (operands[1], E_V16QImode))
                return -1;
              if (
#line 468 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1153; /* neon_vec_extractv16qiqi */
              if (!
#line 4157 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
                return -1;
              return 5007; /* mve_vec_extractv16qiqi */

            default:
              return -1;
            }

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HImode:
              if (!s_register_operand (operands[1], E_V4HImode)
                  || !
#line 394 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1148; /* vec_extractv4hihi */

            case E_V8HImode:
              if (!s_register_operand (operands[1], E_V8HImode))
                return -1;
              if (
#line 468 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1154; /* neon_vec_extractv8hihi */
              if (!
#line 4157 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
                return -1;
              return 5008; /* mve_vec_extractv8hihi */

            default:
              return -1;
            }

        case E_HFmode:
          if (!nonimmediate_operand (operands[0], E_HFmode)
              || GET_MODE (x2) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HFmode:
              if (!s_register_operand (operands[1], E_V4HFmode)
                  || !
#line 394 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1149; /* vec_extractv4hfhf */

            case E_V8HFmode:
              if (!s_register_operand (operands[1], E_V8HFmode))
                return -1;
              if (
#line 468 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1155; /* neon_vec_extractv8hfhf */
              if (!
#line 4157 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
                return -1;
              return 5010; /* mve_vec_extractv8hfhf */

            default:
              return -1;
            }

        case E_BFmode:
          if (!nonimmediate_operand (operands[0], E_BFmode)
              || GET_MODE (x2) != E_BFmode
              || !s_register_operand (operands[1], E_V4BFmode)
              || !
#line 394 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1150; /* vec_extractv4bfbf */

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2SFmode:
              if (!s_register_operand (operands[1], E_V2SFmode)
                  || !
#line 394 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1152; /* vec_extractv2sfsf */

            case E_V4SFmode:
              if (!s_register_operand (operands[1], E_V4SFmode))
                return -1;
              if (
#line 468 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1157; /* neon_vec_extractv4sfsf */
              if (!
#line 4157 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 5011; /* mve_vec_extractv4sfsf */

            default:
              return -1;
            }

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !s_register_operand (operands[1], E_V2DImode))
            return -1;
          if (
#line 496 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1158; /* neon_vec_extractv2didi */
          if (!
#line 4175 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5012; /* mve_vec_extractv2didi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern284 (x2))
        {
        case 0:
          if (!
#line 1141 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 627; /* iwmmxt_wunpckehub */

        case 1:
          if (!
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 633; /* iwmmxt_wunpckelub */

        case 2:
          if (!
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 628; /* iwmmxt_wunpckehuh */

        case 3:
          if (!
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 634; /* iwmmxt_wunpckeluh */

        case 4:
          if (!
#line 1163 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 629; /* iwmmxt_wunpckehuw */

        case 5:
          if (!
#line 1231 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 635; /* iwmmxt_wunpckeluw */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern284 (x2))
        {
        case 0:
          if (!
#line 1175 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 630; /* iwmmxt_wunpckehsb */

        case 1:
          if (!
#line 1243 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 636; /* iwmmxt_wunpckelsb */

        case 2:
          if (!
#line 1186 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 631; /* iwmmxt_wunpckehsh */

        case 3:
          if (!
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 637; /* iwmmxt_wunpckelsh */

        case 4:
          if (!
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 632; /* iwmmxt_wunpckehsw */

        case 5:
          if (!
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 638; /* iwmmxt_wunpckelsw */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_SImode)
          || !
#line 12193 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch5t))
        return -1;
      return 399; /* clzsi2 */

    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 3158 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2018; /* neon_vclzv8qi */

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      if (
#line 3158 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2019; /* neon_vclzv16qi */
      if (!
#line 315 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3301; /* mve_vclzq_sv16qi */

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode)
          || !
#line 3158 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2020; /* neon_vclzv4hi */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      if (
#line 3158 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2021; /* neon_vclzv8hi */
      if (!
#line 315 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3302; /* mve_vclzq_sv8hi */

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode)
          || !
#line 3158 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2022; /* neon_vclzv2si */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      if (
#line 3158 "../../gcc-15.1.1-20250425/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2023; /* neon_vclzv4si */
      if (!
#line 315 "../../gcc-15.1.1-20250425/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3303; /* mve_vclzq_sv4si */

    default:
      return -1;
    }
}

 int
recog_329 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x6 = XEXP (x1, 0);
  operands[3] = x6;
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x4, 0, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XVECEXP (x4, 0, 2);
  operands[2] = x10;
  if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6771 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM)))
    return -1;
  return 6568; /* *p tls_load_dot_plus_eight */
}

 int
recog_332 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x5;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern376 (x3) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 944 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6398; /* *p *arm_addsi3 */

        case E_V2SImode:
          if (pattern311 (x3, 
E_V2SImode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 341 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6690; /* *p *addv2si3_iwmmxt */

        case E_V4HImode:
          if (pattern311 (x3, 
E_V4HImode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 341 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6691; /* *p *addv4hi3_iwmmxt */

        case E_V8QImode:
          if (pattern311 (x3, 
E_V8QImode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 341 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6692; /* *p *addv8qi3_iwmmxt */

        case E_SFmode:
          if (pattern310 (x3, 
E_SFmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6915; /* *p *addsf3_vfp */

        case E_DFmode:
          if (pattern310 (x3, 
E_DFmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1016 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6916; /* *p *adddf3_vfp */

        case E_QQmode:
          if (pattern310 (x3, 
E_QQmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
            return -1;
          return 7003; /* *p addqq3 */

        case E_HQmode:
          if (pattern310 (x3, 
E_HQmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
            return -1;
          return 7004; /* *p addhq3 */

        case E_SQmode:
          if (pattern310 (x3, 
E_SQmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
            return -1;
          return 7005; /* *p addsq3 */

        case E_UQQmode:
          if (pattern310 (x3, 
E_UQQmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
            return -1;
          return 7006; /* *p adduqq3 */

        case E_UHQmode:
          if (pattern310 (x3, 
E_UHQmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
            return -1;
          return 7007; /* *p adduhq3 */

        case E_USQmode:
          if (pattern310 (x3, 
E_USQmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
            return -1;
          return 7008; /* *p addusq3 */

        case E_HAmode:
          if (pattern310 (x3, 
E_HAmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
            return -1;
          return 7009; /* *p addha3 */

        case E_SAmode:
          if (pattern310 (x3, 
E_SAmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
            return -1;
          return 7010; /* *p addsa3 */

        case E_UHAmode:
          if (pattern310 (x3, 
E_UHAmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
            return -1;
          return 7011; /* *p adduha3 */

        case E_USAmode:
          if (pattern310 (x3, 
E_USAmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 25 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
            return -1;
          return 7012; /* *p addusa3 */

        case E_V4QQmode:
          if (pattern310 (x3, 
E_V4QQmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 46 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
            return -1;
          return 7013; /* *p *arm_addv4qq3 */

        case E_V2HQmode:
          if (pattern310 (x3, 
E_V2HQmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 46 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
            return -1;
          return 7014; /* *p *arm_addv2hq3 */

        case E_V2HAmode:
          if (pattern310 (x3, 
E_V2HAmode) != 0
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 46 "../../gcc-15.1.1-20250425/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
            return -1;
          return 7015; /* *p *arm_addv2ha3 */

        default:
          return -1;
        }

    case MULT:
      if (pattern437 (x5) != 0)
        return -1;
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x5, 0);
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 1);
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          if (!register_operand (operands[3], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1486 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6803; /* *p iwmmxt_tmia */

        case TRUNCATE:
          if (GET_MODE (x9) != E_HImode)
            return -1;
          x10 = XEXP (x5, 1);
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != TRUNCATE
              || GET_MODE (x11) != E_HImode)
            return -1;
          x12 = XEXP (x9, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              operands[2] = x12;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              x13 = XEXP (x11, 0);
              switch (pattern625 (x13))
                {
                case 0:
                  if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1517 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6805; /* *p iwmmxt_tmiabb */

                case 1:
                  if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1551 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6807; /* *p iwmmxt_tmiabt */

                default:
                  return -1;
                }

            case ASHIFTRT:
              if (GET_MODE (x12) != E_SImode)
                return -1;
              x14 = XEXP (x12, 1);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x15 = XEXP (x12, 0);
              operands[2] = x15;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              x13 = XEXP (x11, 0);
              switch (pattern625 (x13))
                {
                case 0:
                  if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1534 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6806; /* *p iwmmxt_tmiatb */

                case 1:
                  if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1570 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6808; /* *p iwmmxt_tmiatt */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x16 = XEXP (x9, 1);
          if (GET_CODE (x16) != PARALLEL
              || XVECLEN (x16, 0) != 1)
            return -1;
          x17 = XVECEXP (x16, 0, 0);
          if (GET_CODE (x17) != CONST_INT)
            return -1;
          x10 = XEXP (x5, 1);
          x11 = XEXP (x10, 0);
          if (pattern539 (x11, 
E_SImode) != 0)
            return -1;
          switch (pattern627 (x5))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 742 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6870; /* *p iwmmxt_wmiawbb */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 755 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6871; /* *p iwmmxt_wmiawbt */

            case 2:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 768 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6872; /* *p iwmmxt_wmiawtb */

            case 3:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6873; /* *p iwmmxt_wmiawtt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pattern438 (x5) != 0)
        return -1;
      x8 = XEXP (x5, 0);
      x18 = XEXP (x8, 1);
      if (GET_CODE (x18) != SIGN_EXTEND
          || GET_MODE (x18) != E_DImode)
        return -1;
      x10 = XEXP (x5, 1);
      if (pattern583 (x10) != 0)
        return -1;
      x19 = XEXP (x10, 1);
      if (GET_CODE (x19) != SIGN_EXTEND
          || GET_MODE (x19) != E_DImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x8, 0);
      x12 = XEXP (x9, 0);
      if (GET_MODE (x12) != E_HImode)
        return -1;
      x20 = XEXP (x18, 0);
      if (GET_MODE (x20) != E_HImode)
        return -1;
      x11 = XEXP (x10, 0);
      x13 = XEXP (x11, 0);
      if (GET_MODE (x13) != E_HImode)
        return -1;
      x21 = XEXP (x19, 0);
      if (GET_MODE (x21) != E_HImode)
        return -1;
      switch (GET_CODE (x12))
        {
        case TRUNCATE:
          if (GET_CODE (x20) != TRUNCATE
              || GET_CODE (x13) != TRUNCATE)
            return -1;
          x22 = XEXP (x13, 0);
          if (GET_CODE (x22) != ASHIFTRT
              || GET_MODE (x22) != E_SImode)
            return -1;
          x23 = XEXP (x22, 1);
          if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || GET_CODE (x21) != TRUNCATE)
            return -1;
          x24 = XEXP (x21, 0);
          if (GET_CODE (x24) != ASHIFTRT
              || GET_MODE (x24) != E_SImode)
            return -1;
          x25 = XEXP (x24, 1);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x15 = XEXP (x12, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x26 = XEXP (x20, 0);
          operands[3] = x26;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x27 = XEXP (x22, 0);
          if (!rtx_equal_p (x27, operands[2]))
            return -1;
          x28 = XEXP (x24, 0);
          if (!rtx_equal_p (x28, operands[3])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1504 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6804; /* *p iwmmxt_tmiaph */

        case VEC_SELECT:
          x14 = XEXP (x12, 1);
          if (GET_CODE (x14) != PARALLEL
              || XVECLEN (x14, 0) != 1)
            return -1;
          x29 = XVECEXP (x14, 0, 0);
          if (GET_CODE (x29) != CONST_INT
              || GET_CODE (x20) != VEC_SELECT)
            return -1;
          x30 = XEXP (x20, 1);
          if (GET_CODE (x30) != PARALLEL
              || XVECLEN (x30, 0) != 1)
            return -1;
          x31 = XVECEXP (x30, 0, 0);
          if (GET_CODE (x31) != CONST_INT
              || GET_CODE (x13) != VEC_SELECT)
            return -1;
          x32 = XEXP (x13, 1);
          if (GET_CODE (x32) != PARALLEL
              || XVECLEN (x32, 0) != 1)
            return -1;
          x33 = XVECEXP (x32, 0, 0);
          if (GET_CODE (x33) != CONST_INT
              || GET_CODE (x21) != VEC_SELECT)
            return -1;
          x34 = XEXP (x21, 1);
          if (GET_CODE (x34) != PARALLEL
              || XVECLEN (x34, 0) != 1)
            return -1;
          x35 = XVECEXP (x34, 0, 0);
          if (GET_CODE (x35) != CONST_INT)
            return -1;
          switch (pattern656 (x5))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 561 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6862; /* *p iwmmxt_wmiabb */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6863; /* *p iwmmxt_wmiabt */

            case 2:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 609 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6864; /* *p iwmmxt_wmiatb */

            case 3:
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 633 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6865; /* *p iwmmxt_wmiatt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_343 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != AND
          || GET_MODE (x6) != E_SImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          if (!s_register_operand (x7, E_SImode)
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x5, 1);
          if (!const_int_operand (x8, E_VOIDmode))
            return -1;
          x9 = XEXP (x6, 1);
          if (!const_int_operand (x9, E_VOIDmode))
            return -1;
          x10 = XEXP (x6, 0);
          switch (GET_CODE (x10))
            {
            case ASHIFT:
              if (GET_MODE (x10) != E_SImode)
                return -1;
              x11 = XEXP (x1, 0);
              operands[6] = x11;
              x12 = XEXP (x11, 0);
              operands[7] = x12;
              operands[1] = x7;
              operands[2] = x8;
              x13 = XEXP (x10, 0);
              operands[3] = x13;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x14 = XEXP (x10, 1);
              operands[4] = x14;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              operands[5] = x9;
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3539 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[4]) < 32
   && UINTVAL (operands[2]) == ~UINTVAL (operands[5])
   && (exact_log2 (UINTVAL (operands[5])
		   + (HOST_WIDE_INT_1U << UINTVAL (operands[4])))
       >= 0))))
                return -1;
              return 6446; /* *p *bfi */

            case REG:
            case SUBREG:
              if (!s_register_operand (x10, E_SImode))
                return -1;
              x11 = XEXP (x1, 0);
              operands[5] = x11;
              x12 = XEXP (x11, 0);
              operands[6] = x12;
              operands[1] = x7;
              operands[2] = x8;
              operands[3] = x10;
              operands[4] = x9;
              if ((
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3577 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[2]) == ~UINTVAL (operands[4])
   && exact_log2 (UINTVAL (operands[4]) + 1) >= 0)))
                return 6448; /* *p *bfi_alt2 */
              operands[3] = x7;
              operands[4] = x8;
              operands[1] = x10;
              operands[2] = x9;
              if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3592 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[2]) == ~UINTVAL (operands[4])
   && exact_log2 (UINTVAL (operands[4]) + 1) >= 0)))
                return -1;
              return 6449; /* *p *bfi_alt3 */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x15 = XEXP (x7, 1);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          operands[4] = x15;
          if (const_int_operand (operands[4], E_VOIDmode))
            {
              res = recog_337 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XWINT (x15, 0) != 8LL
              || pattern558 (x1, 
LSHIFTRT) != 0)
            return -1;
          x8 = XEXP (x5, 1);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x6, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x6, 0);
          x13 = XEXP (x10, 0);
          if (!rtx_equal_p (x13, operands[1])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12592 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch6
   && aarch_rev16_shleft_mask_imm_p (operands[3], SImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], SImode))))
            return -1;
          return 6606; /* *p arm_rev16si2_alt1 */

        case LSHIFTRT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x15 = XEXP (x7, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || pattern558 (x1, 
ASHIFT) != 0)
            return -1;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x6, 0);
          x13 = XEXP (x10, 0);
          if (!rtx_equal_p (x13, operands[1])
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12613 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch6
   && aarch_rev16_shleft_mask_imm_p (operands[3], SImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], SImode))))
            return -1;
          return 6607; /* *p *arm_rev16si2_alt2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern378 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3737 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6454; /* *p *iorsi3_insn */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 61 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6674; /* *p iwmmxt_iordi3 */

        case 2:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6684; /* *p *iorv2si3_iwmmxt */

        case 3:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6685; /* *p *iorv4hi3_iwmmxt */

        case 4:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6686; /* *p *iorv8qi3_iwmmxt */

        default:
          return -1;
        }

    case MULT:
      if (pattern375 (x1) != 0
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9686 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6585; /* *p *orr_multsi */

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x5;
      if (pattern407 (x1) == 0
          && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9700 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT)))
        return 6590; /* *p *orr_shiftsi */
      if (GET_CODE (x5) != ASHIFT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_CODE (x8) != MINUS
          || GET_MODE (x8) != E_SImode)
        return -1;
      x16 = XEXP (x8, 0);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      x17 = XEXP (x8, 1);
      if (GET_CODE (x17) != MULT
          || GET_MODE (x17) != E_SImode)
        return -1;
      x18 = XEXP (x17, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != ASHIFT
          || GET_MODE (x10) != E_DImode)
        return -1;
      x14 = XEXP (x10, 1);
      if (GET_CODE (x14) != MULT
          || GET_MODE (x14) != E_SImode)
        return -1;
      x19 = XEXP (x14, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != MULT
          || GET_MODE (x9) != E_SImode)
        return -1;
      x20 = XEXP (x9, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x11 = XEXP (x1, 0);
      operands[4] = x11;
      x12 = XEXP (x11, 0);
      operands[5] = x12;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      x21 = XEXP (x17, 0);
      operands[3] = x21;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x13 = XEXP (x10, 0);
      operands[1] = x13;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x22 = XEXP (x14, 0);
      if (!rtx_equal_p (x22, operands[3]))
        return -1;
      x23 = XEXP (x9, 0);
      if (!rtx_equal_p (x23, operands[3])
          || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 858 "../../gcc-15.1.1-20250425/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6878; /* *p iwmmxt_wmerge */

    case NOT:
      switch (pattern374 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1534 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2)))
            return -1;
          return 6996; /* *p *orsi_notsi_si */

        case 1:
          x7 = XEXP (x5, 0);
          x24 = XEXP (x7, 0);
          operands[2] = x24;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x15 = XEXP (x7, 1);
          operands[3] = x15;
          if (!const_int_operand (operands[3], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1546 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2)))
            return -1;
          return 6997; /* *p *orsi_not_shiftsi_si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_351 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      x9 = XEXP (x6, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern559 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1365 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6935; /* *p fmasf4 */

            case E_DFmode:
              if (pattern559 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1365 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6936; /* *p fmadf4 */

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern560 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1423 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6939; /* *p *fnmsubsf4 */

            case E_DFmode:
              if (pattern560 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1423 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6940; /* *p *fnmsubdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      x9 = XEXP (x6, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern561 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1401 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6937; /* *p *fmsubsf4 */

            case E_DFmode:
              if (pattern561 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1401 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6938; /* *p *fmsubdf4 */

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern562 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1446 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6941; /* *p *fnmaddsf4 */

            case E_DFmode:
              if (pattern562 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1446 "../../gcc-15.1.1-20250425/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6942; /* *p *fnmadddf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == PLUS
      && GET_MODE (x4) == E_SImode)
    {
      res = recog_361 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x1, 0);
  operands[5] = x6;
  x7 = XEXP (x6, 0);
  operands[6] = x7;
  operands[1] = x4;
  if (shiftable_operator (operands[1], E_SImode))
    {
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (memory_operand (operands[2], E_SImode))
        {
          x9 = XEXP (x4, 1);
          operands[3] = x9;
          if (memory_operand (operands[3], E_SImode))
            {
              x10 = XEXP (x5, 0);
              operands[4] = x10;
              if (scratch_operand (operands[4], E_SImode)
                  && (
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11472 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM && adjacent_mem_locations (operands[2], operands[3]))))
                return 6594; /* *p *arith_adjacentmem */
            }
        }
    }
  x10 = XEXP (x5, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 100
      || GET_MODE (x10) != E_CCmode)
    return -1;
  operands[4] = x6;
  operands[5] = x7;
  operands[3] = x4;
  if (!thumb_16bit_operator (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode)
      || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && GET_CODE(operands[3]) != PLUS
   && GET_CODE(operands[3]) != MINUS)))
    return -1;
  return 6986; /* *p *thumb2_alusi3_short */
}

 int
recog_372 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x1, 0);
  operands[6] = x10;
  x11 = XEXP (x10, 0);
  operands[7] = x11;
  x12 = XEXP (x3, 0);
  operands[5] = x12;
  if (!s_register_operand (operands[5], E_SImode))
    return -1;
  x13 = XEXP (x4, 0);
  if (!rtx_equal_p (x13, operands[5]))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 16LL:
      switch (pattern597 (x6))
        {
        case 0:
          if (pattern619 (x2) != 0)
            return -1;
          x14 = XEXP (x9, 1);
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != PLUS
              || GET_MODE (x15) != E_SImode)
            return -1;
          x16 = XEXP (x15, 1);
          if (GET_CODE (x16) != CONST_INT
              || pattern642 (operands[0]) != 0)
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[5]))
            return -1;
          x20 = XEXP (x8, 1);
          x21 = XEXP (x20, 0);
          x22 = XEXP (x21, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x23 = XEXP (x15, 0);
          if (!rtx_equal_p (x23, operands[5]))
            return -1;
          switch (pattern647 (x2))
            {
            case 0:
              x24 = XEXP (x6, 1);
              x25 = XEXP (x24, 0);
              if (!rtx_equal_p (x25, operands[5]))
                return -1;
              x26 = XEXP (x18, 1);
              if (XWINT (x26, 0) != 4LL)
                return -1;
              x27 = XEXP (x21, 1);
              if (XWINT (x27, 0) != 8LL
                  || XWINT (x16, 0) != 12LL
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 74 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6623; /* *p *ldm4_ia_update */

            case 1:
              if (XWINT (x16, 0) != 16LL)
                return -1;
              x24 = XEXP (x6, 1);
              x25 = XEXP (x24, 0);
              x28 = XEXP (x25, 0);
              if (!rtx_equal_p (x28, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6627; /* *p *ldm4_ib_update */

            default:
              return -1;
            }

        case 1:
          if (pattern621 (x2) != 0)
            return -1;
          x29 = XEXP (x9, 0);
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != PLUS
              || GET_MODE (x30) != E_SImode)
            return -1;
          x31 = XEXP (x30, 1);
          if (GET_CODE (x31) != CONST_INT
              || pattern648 (operands[0]) != 0)
            return -1;
          x32 = XEXP (x7, 0);
          x33 = XEXP (x32, 0);
          x34 = XEXP (x33, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          x35 = XEXP (x8, 0);
          x36 = XEXP (x35, 0);
          x37 = XEXP (x36, 0);
          if (!rtx_equal_p (x37, operands[5]))
            return -1;
          x38 = XEXP (x30, 0);
          if (!rtx_equal_p (x38, operands[5]))
            return -1;
          switch (pattern649 (x2))
            {
            case 0:
              x39 = XEXP (x6, 0);
              x40 = XEXP (x39, 0);
              if (!rtx_equal_p (x40, operands[5]))
                return -1;
              x41 = XEXP (x33, 1);
              if (XWINT (x41, 0) != 4LL)
                return -1;
              x42 = XEXP (x36, 1);
              if (XWINT (x42, 0) != 8LL
                  || XWINT (x31, 0) != 12LL
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 125 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6625; /* *p *stm4_ia_update */

            case 1:
              if (XWINT (x31, 0) != 16LL)
                return -1;
              x39 = XEXP (x6, 0);
              x40 = XEXP (x39, 0);
              x43 = XEXP (x40, 0);
              if (!rtx_equal_p (x43, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6629; /* *p *stm4_ib_update */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case -16LL:
      x24 = XEXP (x6, 1);
      switch (GET_CODE (x24))
        {
        case MEM:
          if (pattern546 (x24) != 0
              || pattern619 (x2) != 0
              || pattern642 (operands[0]) != 0)
            return -1;
          x25 = XEXP (x24, 0);
          x28 = XEXP (x25, 0);
          if (!rtx_equal_p (x28, operands[5]))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[5]))
            return -1;
          x20 = XEXP (x8, 1);
          x21 = XEXP (x20, 0);
          x22 = XEXP (x21, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x44 = XEXP (x25, 1);
          switch (XWINT (x44, 0))
            {
            case -12LL:
              x26 = XEXP (x18, 1);
              if (XWINT (x26, 0) != -8LL)
                return -1;
              x27 = XEXP (x21, 1);
              if (XWINT (x27, 0) != -4LL)
                return -1;
              x14 = XEXP (x9, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6631; /* *p *ldm4_da_update */

            case -16LL:
              x26 = XEXP (x18, 1);
              if (XWINT (x26, 0) != -12LL)
                return -1;
              x27 = XEXP (x21, 1);
              if (XWINT (x27, 0) != -8LL)
                return -1;
              x14 = XEXP (x9, 1);
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != PLUS
                  || GET_MODE (x15) != E_SImode)
                return -1;
              x16 = XEXP (x15, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x23 = XEXP (x15, 0);
              if (!rtx_equal_p (x23, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6635; /* *p *ldm4_db_update */

            default:
              return -1;
            }

        case REG:
          operands[1] = x24;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x39 = XEXP (x6, 0);
          if (pattern573 (x39) != 0
              || pattern621 (x2) != 0
              || pattern648 (operands[0]) != 0)
            return -1;
          x40 = XEXP (x39, 0);
          x43 = XEXP (x40, 0);
          if (!rtx_equal_p (x43, operands[5]))
            return -1;
          x32 = XEXP (x7, 0);
          x33 = XEXP (x32, 0);
          x34 = XEXP (x33, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          x35 = XEXP (x8, 0);
          x36 = XEXP (x35, 0);
          x37 = XEXP (x36, 0);
          if (!rtx_equal_p (x37, operands[5]))
            return -1;
          x45 = XEXP (x40, 1);
          switch (XWINT (x45, 0))
            {
            case -12LL:
              x41 = XEXP (x33, 1);
              if (XWINT (x41, 0) != -8LL)
                return -1;
              x42 = XEXP (x36, 1);
              if (XWINT (x42, 0) != -4LL)
                return -1;
              x29 = XEXP (x9, 0);
              x30 = XEXP (x29, 0);
              if (!rtx_equal_p (x30, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6633; /* *p *stm4_da_update */

            case -16LL:
              x41 = XEXP (x33, 1);
              if (XWINT (x41, 0) != -12LL)
                return -1;
              x42 = XEXP (x36, 1);
              if (XWINT (x42, 0) != -8LL)
                return -1;
              x29 = XEXP (x9, 0);
              x30 = XEXP (x29, 0);
              if (GET_CODE (x30) != PLUS
                  || GET_MODE (x30) != E_SImode)
                return -1;
              x31 = XEXP (x30, 1);
              if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x38 = XEXP (x30, 0);
              if (!rtx_equal_p (x38, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 355 "../../gcc-15.1.1-20250425/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6637; /* *p *stm4_db_update */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XEXP (x3, 1);
  if (!minmax_operator (x4, E_SImode))
    return NULL;
  operands[4] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return NULL;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  if (!arm_rhs_operand (operands[3], E_SImode)
      || !
#line 4304 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1]) && reload_completed))
    return NULL;
  return gen_split_26 (insn, operands);
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFT
      || GET_MODE (x4) != E_SImode)
    return NULL;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return NULL;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_SImode))
    return NULL;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!s_register_operand (operands[3], E_SImode)
      || !
#line 1895 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
    return NULL;
  return gen_split_2 (insn, operands);
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != NOT
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != NOT
              || GET_MODE (x6) != E_SImode)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!arm_rhs_operand (operands[2], E_SImode))
            return NULL;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          if (!arm_rhs_operand (operands[3], E_SImode))
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x10, 0);
          operands[4] = x11;
          if (!s_register_operand (operands[4], E_SImode)
              || !
#line 3898 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_16 (insn, operands);

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[3] = x4;
          if (pattern526 (x1) != 0
              || !
#line 10498 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
            return NULL;
          return gen_split_87 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[3] = x4;
          if (pattern526 (x1) == 0)
            {
              if (
#line 10560 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_AND_Y)
       != CCmode)))
                return gen_split_89 (insn, operands);
              if (
#line 10628 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
                return gen_split_91 (insn, operands);
            }
          if (GET_CODE (x4) != GE
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x9 = XEXP (x3, 1);
          if (GET_CODE (x9) != NEG
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x12 = XEXP (x9, 0);
          if (!arm_comparison_operator (x12, E_SImode))
            return NULL;
          operands[2] = x12;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x13 = XEXP (x12, 0);
          operands[3] = x13;
          if (!s_register_operand (operands[3], E_SImode))
            return NULL;
          x14 = XEXP (x12, 1);
          operands[4] = x14;
          if (!arm_rhs_operand (operands[4], E_SImode))
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x10, 0);
          operands[5] = x11;
          if (!s_register_operand (operands[5], E_SImode)
              || !
#line 11591 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return NULL;
          return gen_split_98 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case NE:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x5 = XEXP (x4, 2);
          if (GET_CODE (x5) != CONST_INT)
            return NULL;
          operands[3] = x5;
          if (const_int_operand (operands[3], E_SImode))
            {
              x6 = XEXP (x3, 1);
              if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x7 = XEXP (x4, 0);
                  operands[1] = x7;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      x8 = XEXP (x4, 1);
                      operands[2] = x8;
                      if (const_int_operand (operands[2], E_SImode)
                          && 
#line 3122 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)))
                        return gen_split_7 (insn, operands);
                    }
                }
            }
          if (XWINT (x5, 0) != 0LL)
            return NULL;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 3156 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_ARM))
            return NULL;
          return gen_split_8 (insn, operands);

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 9921 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
            return gen_split_84 (insn, operands);
          if (!arm_add_operand (operands[2], E_SImode)
              || !
#line 9937 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
            return NULL;
          return gen_split_85 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 9880 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
        return NULL;
      return gen_split_80 (insn, operands);

    case GE:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 9888 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
        return NULL;
      return gen_split_81 (insn, operands);

    case EQ:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      if (
#line 9897 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(arm_arch5t && TARGET_32BIT))
        return gen_split_82 (insn, operands);
      if (!
#line 9907 "../../gcc-15.1.1-20250425/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
        return NULL;
      return gen_split_83 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != SET)
    return NULL;
  x6 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x8 = XEXP (x4, 1);
  operands[5] = x8;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x9 = XEXP (x5, 0);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x10 = XEXP (x5, 1);
  operands[6] = x10;
  if (!memory_operand (operands[6], E_SImode))
    return NULL;
  x11 = XEXP (x6, 0);
  operands[3] = x11;
  if (!s_register_operand (operands[3], E_SImode))
    return NULL;
  x12 = XEXP (x6, 1);
  operands[7] = x12;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_20 (insn, operands);
}

 rtx_insn *
peephole2_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (!memory_operand (x2, E_SImode))
    return NULL;
  operands[2] = x2;
  if (arm_general_register_operand (operands[0], E_SImode))
    {
      res = peephole2_7 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 4)
    return NULL;
  operands[4] = x2;
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x5 = XEXP (x3, 1);
  operands[5] = x5;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x8 = XEXP (x6, 1);
  operands[6] = x8;
  if (!memory_operand (operands[6], E_SImode))
    return NULL;
  x9 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x9) != SET)
    return NULL;
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!s_register_operand (operands[3], E_SImode))
    return NULL;
  x11 = XEXP (x9, 1);
  operands[7] = x11;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_19 (insn, operands);
}

 rtx_insn *
peephole2_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  switch (pattern494 (x3))
    {
    case 0:
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (2));
      x5 = XEXP (x4, 1);
      operands[5] = x5;
      if (!const_int_operand (operands[5], E_SImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (3));
      x7 = XEXP (x6, 1);
      if (!rtx_equal_p (x7, operands[1])
          || !
#line 67 "../../gcc-15.1.1-20250425/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_15 (insn, operands);

    case 1:
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (2));
      x9 = XEXP (x4, 0);
      operands[2] = x9;
      if (!memory_operand (operands[2], E_SImode))
        return NULL;
      x5 = XEXP (x4, 1);
      if (!rtx_equal_p (x5, operands[0]))
        return NULL;
      x6 = PATTERN (peep2_next_insn (3));
      x7 = XEXP (x6, 1);
      if (!rtx_equal_p (x7, operands[1])
          || !
#line 86 "../../gcc-15.1.1-20250425/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_16 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4)
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x4) != SET)
    return NULL;
  if (arm_general_register_operand (operands[0], E_SImode))
    {
      res = peephole2_11 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  if (peep2_current_count >= 5)
    {
      res = peephole2_13 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x5 = XEXP (x1, 1);
  operands[4] = x5;
  switch (pattern494 (x2))
    {
    case 0:
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x3, 1);
      operands[5] = x6;
      if (!const_int_operand (operands[5], E_SImode))
        return NULL;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[1]))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_30 (insn, operands);

    case 1:
      x8 = XEXP (x2, 0);
      operands[1] = x8;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      x9 = XEXP (x3, 0);
      operands[2] = x9;
      if (!memory_operand (operands[2], E_SImode))
        return NULL;
      x6 = XEXP (x3, 1);
      if (!rtx_equal_p (x6, operands[0]))
        return NULL;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[1]))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_31 (insn, operands);

    default:
      return NULL;
    }
}
