/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return 0;

    case VEC_SELECT:
      res = pattern7 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern2 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern2 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_QImode))
            return -1;
          return 2;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || pattern37 (x1, 
E_DImode, 
-1, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern43 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      return pattern6 (x3, 
E_V4SImode); /* [-1, 1] */

    case 1:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          res = pattern67 (x1, 
E_DFmode);
          if (res >= 0)
            return res + 2; /* [2, 4] */
          return -1;

        case E_SFmode:
          res = pattern67 (x1, 
E_SFmode);
          if (res >= 0)
            return res + 5; /* [5, 7] */
          return -1;

        case E_IFmode:
          if (!gpc_reg_operand (operands[0], E_IFmode)
              || GET_MODE (x1) != E_IFmode
              || GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[1], E_V4SImode)
              || !const_0_to_3_operand (operands[2], E_QImode))
            return -1;
          return 8;

        case E_KFmode:
          res = pattern67 (x1, 
E_KFmode);
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        case E_TFmode:
          res = pattern67 (x1, 
E_TFmode);
          if (res >= 0)
            return res + 12; /* [12, 14] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern86 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern91 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_V4SImode))
    return -1;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_IFmode:
      if (!gpc_reg_operand (operands[0], E_IFmode)
          || GET_MODE (x3) != E_IFmode)
        return -1;
      return 1;

    case E_KFmode:
      if (!gpc_reg_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode)
        return -1;
      return 2;

    case E_TFmode:
      if (!gpc_reg_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern41 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern141 (x3, 
E_V4SFmode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 2;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern166 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_V16QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  if (!vsx_register_operand (operands[0], E_V16QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          return pattern179 (x1); /* [-1, 1] */

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT)
            return -1;
          res = pattern183 (x1);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x8) != E_DImode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (!reg_or_mem_operand (operands[1], E_SImode)
          || !u6bit_cint_operand (operands[2], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!scratch_operand (operands[0], E_DImode))
            return -1;
          return 4;

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT
              || GET_MODE (x10) != E_DImode)
            return -1;
          x13 = XEXP (x10, 0);
          if (GET_CODE (x13) != SIGN_EXTEND
              || GET_MODE (x13) != E_DImode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x10, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vsx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern222 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 106
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i2
      || GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern239 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case NOT:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case NOT:
          return pattern246 (x6); /* [-1, 23] */

        case REG:
        case SUBREG:
          res = pattern242 (x6);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern237 (x6);
      if (res >= 0)
        return res + 48; /* [48, 71] */
      return -1;

    default:
      return -1;
    }
}

int
pattern259 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !reg_or_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern265 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern272 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern272 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern294 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern293 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern293 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern303 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern301 (x5); /* [-1, 1] */
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern309 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern309 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vlogical_operand (operands[1], i1)
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern324 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern330 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern339 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!vsx_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!vsx_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern350 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern354 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern354 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern361 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!int_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern370 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_or_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern378 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern385 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          return pattern402 (x1); /* [-1, 11] */

        case REG:
        case SUBREG:
          res = pattern399 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern396 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern416 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern418 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern425 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern423 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern423 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern424 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern424 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern424 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern424 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern424 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern424 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern424 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern424 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern424 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern424 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern445 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern445 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern446 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern446 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern446 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern446 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern446 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern446 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern446 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern446 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern446 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern446 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern470 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], E_V4SFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (!const_0_to_3_operand (x4, E_QImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (!scratch_operand (x6, E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      if (!gpc_reg_operand (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 0;

    case CONST_DOUBLE:
      operands[2] = x7;
      if (!zero_fp_constant (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 1;

    case VEC_SELECT:
      if (GET_MODE (x7) != E_SFmode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!gpc_reg_operand (operands[2], E_V4SFmode))
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_0_to_3_operand (operands[3], E_QImode))
        return -1;
      operands[4] = x4;
      operands[5] = x6;
      return 2;

    default:
      return -1;
    }
}

int
pattern492 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern501 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 3)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2)
    return -1;
  return 0;
}

int
pattern507 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern516 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern520 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern520 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern521 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern521 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern521 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern521 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern521 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern521 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern521 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern521 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern521 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern521 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern542 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern553 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern561 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern568 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[4] = x3;
      if (!altivec_register_operand (operands[4], E_V4SImode))
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XVECEXP (x1, 0, 0);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_SImode:
          return pattern566 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern566 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case MEM:
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!altivec_register_operand (operands[2], E_V4SImode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      x12 = XEXP (x10, 1);
      operands[4] = x12;
      x8 = XVECEXP (x1, 0, 0);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_SImode:
          if (pattern567 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern567 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern602 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x9, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x5, 0);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x14 = XEXP (x6, 0);
  operands[2] = x14;
  if (!gpc_reg_operand (operands[2], E_HImode))
    return -1;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x11, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case EQ:
      res = recog_7 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LT:
      if (pattern48 (x1, 
E_CCmode, 
GT) == 0
          && 
#line 15710 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1208; /* setb_signed */
      break;

    case LTU:
      if (pattern48 (x1, 
E_CCUNSmode, 
GTU) == 0
          && 
#line 15723 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1209; /* setb_unsigned */
      break;

    default:
      break;
    }
  operands[1] = x3;
  if (!scc_comparison_operator (operands[1], E_VOIDmode))
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern456 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5570 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 353; /* isel_cc_si */

        case 1:
          if (!
#line 5570 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 355; /* isel_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern456 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5570 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 354; /* isel_cc_di */

        case 1:
          if (!(
#line 5570 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 356; /* isel_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case XOR:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x5, 1);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          switch (pattern429 (x3))
            {
            case 0:
              if (!
#line 403 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2535; /* *fuse_eqv_and */

            case 1:
              if (!(
#line 403 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2536; /* *fuse_eqv_and */

            case 2:
              if (!
#line 1915 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2719; /* *fuse_veqv_vand */

            case 3:
              if (!
#line 1915 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2720; /* *fuse_veqv_vand */

            case 4:
              if (!
#line 1915 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2721; /* *fuse_veqv_vand */

            case 5:
              if (!
#line 1915 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2722; /* *fuse_veqv_vand */

            case 6:
              if (!
#line 1915 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2723; /* *fuse_veqv_vand */

            case 7:
              if (!
#line 1915 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2724; /* *fuse_veqv_vand */

            case 8:
              if (!
#line 1915 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2725; /* *fuse_veqv_vand */

            case 9:
              if (!
#line 1915 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2726; /* *fuse_veqv_vand */

            case 10:
              if (!(
#line 1915 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2727; /* *fuse_veqv_vand */

            case 11:
              if (!(
#line 1915 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2728; /* *fuse_veqv_vand */

            default:
              return -1;
            }

        case NOT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern272 (x3, 
E_SImode) != 0
                  || !
#line 583 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2555; /* *fuse_eqv_andc */

            case E_DImode:
              if (pattern272 (x3, 
E_DImode) != 0
                  || !(
#line 583 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2556; /* *fuse_eqv_andc */

            case E_V4SImode:
              if (pattern273 (x3, 
E_V4SImode) != 0
                  || !
#line 2059 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2799; /* *fuse_veqv_vandc */

            case E_V8HImode:
              if (pattern273 (x3, 
E_V8HImode) != 0
                  || !
#line 2059 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2800; /* *fuse_veqv_vandc */

            case E_V16QImode:
              if (pattern273 (x3, 
E_V16QImode) != 0
                  || !
#line 2059 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2801; /* *fuse_veqv_vandc */

            case E_V4SFmode:
              if (pattern273 (x3, 
E_V4SFmode) != 0
                  || !
#line 2059 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2802; /* *fuse_veqv_vandc */

            case E_V2DFmode:
              if (pattern273 (x3, 
E_V2DFmode) != 0
                  || !
#line 2059 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2803; /* *fuse_veqv_vandc */

            case E_V2DImode:
              if (pattern273 (x3, 
E_V2DImode) != 0
                  || !
#line 2059 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2804; /* *fuse_veqv_vandc */

            case E_V1TImode:
              if (pattern273 (x3, 
E_V1TImode) != 0
                  || !
#line 2059 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2805; /* *fuse_veqv_vandc */

            case E_TImode:
              if (pattern273 (x3, 
E_TImode) != 0
                  || !
#line 2059 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2806; /* *fuse_veqv_vandc */

            case E_KFmode:
              if (pattern273 (x3, 
E_KFmode) != 0
                  || !(
#line 2059 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2807; /* *fuse_veqv_vandc */

            case E_TFmode:
              if (pattern273 (x3, 
E_TFmode) != 0
                  || !(
#line 2059 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2808; /* *fuse_veqv_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern281 (x3))
        {
        case 0:
          if (!
#line 1015 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2603; /* *fuse_and_nor */

        case 1:
          if (!(
#line 1015 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2604; /* *fuse_and_nor */

        case 2:
          if (!
#line 2455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3019; /* *fuse_vand_vnor */

        case 3:
          if (!
#line 2455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3020; /* *fuse_vand_vnor */

        case 4:
          if (!
#line 2455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3021; /* *fuse_vand_vnor */

        case 5:
          if (!
#line 2455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3022; /* *fuse_vand_vnor */

        case 6:
          if (!
#line 2455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3023; /* *fuse_vand_vnor */

        case 7:
          if (!
#line 2455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3024; /* *fuse_vand_vnor */

        case 8:
          if (!
#line 2455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3025; /* *fuse_vand_vnor */

        case 9:
          if (!
#line 2455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3026; /* *fuse_vand_vnor */

        case 10:
          if (!(
#line 2455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3027; /* *fuse_vand_vnor */

        case 11:
          if (!(
#line 2455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3028; /* *fuse_vand_vnor */

        case 12:
          if (!
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2605; /* *fuse_andc_nor */

        case 13:
          if (!(
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2606; /* *fuse_andc_nor */

        case 14:
          if (!
#line 2473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3029; /* *fuse_vandc_vnor */

        case 15:
          if (!
#line 2473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3030; /* *fuse_vandc_vnor */

        case 16:
          if (!
#line 2473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3031; /* *fuse_vandc_vnor */

        case 17:
          if (!
#line 2473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3032; /* *fuse_vandc_vnor */

        case 18:
          if (!
#line 2473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3033; /* *fuse_vandc_vnor */

        case 19:
          if (!
#line 2473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3034; /* *fuse_vandc_vnor */

        case 20:
          if (!
#line 2473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3035; /* *fuse_vandc_vnor */

        case 21:
          if (!
#line 2473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3036; /* *fuse_vandc_vnor */

        case 22:
          if (!(
#line 2473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3037; /* *fuse_vandc_vnor */

        case 23:
          if (!(
#line 2473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3038; /* *fuse_vandc_vnor */

        case 24:
          if (!
#line 1087 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2611; /* *fuse_nor_nor */

        case 25:
          if (!(
#line 1087 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2612; /* *fuse_nor_nor */

        case 26:
          if (!
#line 2527 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3059; /* *fuse_vnor_vnor */

        case 27:
          if (!
#line 2527 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3060; /* *fuse_vnor_vnor */

        case 28:
          if (!
#line 2527 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3061; /* *fuse_vnor_vnor */

        case 29:
          if (!
#line 2527 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3062; /* *fuse_vnor_vnor */

        case 30:
          if (!
#line 2527 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3063; /* *fuse_vnor_vnor */

        case 31:
          if (!
#line 2527 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3064; /* *fuse_vnor_vnor */

        case 32:
          if (!
#line 2527 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3065; /* *fuse_vnor_vnor */

        case 33:
          if (!
#line 2527 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3066; /* *fuse_vnor_vnor */

        case 34:
          if (!(
#line 2527 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3067; /* *fuse_vnor_vnor */

        case 35:
          if (!(
#line 2527 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3068; /* *fuse_vnor_vnor */

        default:
          return -1;
        }

    case NOT:
      switch (pattern284 (x3))
        {
        case 0:
          if (!
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2607; /* *fuse_eqv_nor */

        case 1:
          if (!(
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2608; /* *fuse_eqv_nor */

        case 2:
          if (!
#line 2491 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3039; /* *fuse_veqv_vnor */

        case 3:
          if (!
#line 2491 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3040; /* *fuse_veqv_vnor */

        case 4:
          if (!
#line 2491 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3041; /* *fuse_veqv_vnor */

        case 5:
          if (!
#line 2491 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3042; /* *fuse_veqv_vnor */

        case 6:
          if (!
#line 2491 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3043; /* *fuse_veqv_vnor */

        case 7:
          if (!
#line 2491 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3044; /* *fuse_veqv_vnor */

        case 8:
          if (!
#line 2491 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3045; /* *fuse_veqv_vnor */

        case 9:
          if (!
#line 2491 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3046; /* *fuse_veqv_vnor */

        case 10:
          if (!(
#line 2491 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3047; /* *fuse_veqv_vnor */

        case 11:
          if (!(
#line 2491 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3048; /* *fuse_veqv_vnor */

        default:
          return -1;
        }

    case IOR:
      switch (pattern285 (x3))
        {
        case 0:
          if (!
#line 1069 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2609; /* *fuse_nand_nor */

        case 1:
          if (!(
#line 1069 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2610; /* *fuse_nand_nor */

        case 2:
          if (!
#line 2509 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3049; /* *fuse_vnand_vnor */

        case 3:
          if (!
#line 2509 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3050; /* *fuse_vnand_vnor */

        case 4:
          if (!
#line 2509 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3051; /* *fuse_vnand_vnor */

        case 5:
          if (!
#line 2509 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3052; /* *fuse_vnand_vnor */

        case 6:
          if (!
#line 2509 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3053; /* *fuse_vnand_vnor */

        case 7:
          if (!
#line 2509 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3054; /* *fuse_vnand_vnor */

        case 8:
          if (!
#line 2509 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3055; /* *fuse_vnand_vnor */

        case 9:
          if (!
#line 2509 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3056; /* *fuse_vnand_vnor */

        case 10:
          if (!(
#line 2509 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3057; /* *fuse_vnand_vnor */

        case 11:
          if (!(
#line 2509 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3058; /* *fuse_vnand_vnor */

        case 12:
          if (!
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2615; /* *fuse_orc_nor */

        case 13:
          if (!(
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2616; /* *fuse_orc_nor */

        case 14:
          if (!
#line 2563 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3079; /* *fuse_vorc_vnor */

        case 15:
          if (!
#line 2563 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3080; /* *fuse_vorc_vnor */

        case 16:
          if (!
#line 2563 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3081; /* *fuse_vorc_vnor */

        case 17:
          if (!
#line 2563 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3082; /* *fuse_vorc_vnor */

        case 18:
          if (!
#line 2563 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3083; /* *fuse_vorc_vnor */

        case 19:
          if (!
#line 2563 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3084; /* *fuse_vorc_vnor */

        case 20:
          if (!
#line 2563 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3085; /* *fuse_vorc_vnor */

        case 21:
          if (!
#line 2563 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3086; /* *fuse_vorc_vnor */

        case 22:
          if (!(
#line 2563 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3087; /* *fuse_vorc_vnor */

        case 23:
          if (!(
#line 2563 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3088; /* *fuse_vorc_vnor */

        case 24:
          if (!
#line 1105 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2613; /* *fuse_or_nor */

        case 25:
          if (!(
#line 1105 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2614; /* *fuse_or_nor */

        case 26:
          if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3069; /* *fuse_vor_vnor */

        case 27:
          if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3070; /* *fuse_vor_vnor */

        case 28:
          if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3071; /* *fuse_vor_vnor */

        case 29:
          if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3072; /* *fuse_vor_vnor */

        case 30:
          if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3073; /* *fuse_vor_vnor */

        case 31:
          if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3074; /* *fuse_vor_vnor */

        case 32:
          if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3075; /* *fuse_vor_vnor */

        case 33:
          if (!
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3076; /* *fuse_vor_vnor */

        case 34:
          if (!(
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3077; /* *fuse_vor_vnor */

        case 35:
          if (!(
#line 2545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3078; /* *fuse_vor_vnor */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 1159 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2619; /* *fuse_add_nor */

        case 1:
          if (!(
#line 1159 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2620; /* *fuse_add_nor */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2621; /* *fuse_subf_nor */

        case 1:
          if (!(
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2622; /* *fuse_subf_nor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5239 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1670; /* xsiexpqpf_kf */

        case E_V1TImode:
          if (!altivec_register_operand (operands[1], E_V1TImode)
              || !altivec_register_operand (operands[2], E_V2DImode)
              || !(
#line 5251 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1672; /* xsiexpqp_kf_v2di */

        case E_TImode:
          if (!altivec_register_operand (operands[1], E_TImode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5251 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1673; /* xsiexpqp_kf_di */

        default:
          return -1;
        }

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5239 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1671; /* xsiexpqpf_tf */

        case E_V1TImode:
          if (!altivec_register_operand (operands[1], E_V1TImode)
              || !altivec_register_operand (operands[2], E_V2DImode)
              || !(
#line 5251 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1674; /* xsiexpqp_tf_v2di */

        case E_TImode:
          if (!altivec_register_operand (operands[1], E_TImode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5251 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1675; /* xsiexpqp_tf_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (pattern146 (x3, 
E_DFmode, 
E_TFmode) != 0)
        return -1;
      if ((
#line 14940 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_HARD_FLOAT) && 
#line 543 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return 1085; /* packtf_hard */
      if (!(
#line 14964 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_SOFT_FLOAT) && 
#line 543 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return -1;
      return 1088; /* packtf_soft */

    case E_IFmode:
      if (pattern146 (x3, 
E_DFmode, 
E_IFmode) != 0
          || !(
#line 14940 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode) && TARGET_HARD_FLOAT) && 
#line 544 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
        return -1;
      return 1086; /* packif_hard */

    case E_TDmode:
      if (pattern146 (x3, 
E_DImode, 
E_TDmode) != 0
          || !(
#line 14940 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TDmode) && TARGET_HARD_FLOAT) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 1087; /* packtd_hard */

    case E_V1TImode:
      if (pattern146 (x3, 
E_DImode, 
E_V1TImode) != 0
          || !
#line 15007 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_VSX))
        return -1;
      return 1091; /* packv1ti */

    case E_KFmode:
      if (pattern146 (x3, 
E_DImode, 
E_KFmode) != 0
          || !
#line 15007 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_VSX))
        return -1;
      return 1092; /* packkf */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (pattern132 (x3, 
E_V4SFmode) != 0
          || !
#line 5484 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1691; /* xviexpsp */

    case E_V2DFmode:
      if (pattern132 (x3, 
E_V2DFmode) != 0
          || !
#line 5484 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1692; /* xviexpdp */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode)
          || !
#line 2547 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_CMPB && TARGET_POPCNTB))
        return -1;
      return 141; /* paritysi2_cmpb */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode)
          || !(
#line 2547 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_CMPB && TARGET_POPCNTB) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 142; /* paritydi2_cmpb */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 4410 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2316; /* rs6000_vprtybv8hi2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 4410 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2317; /* rs6000_vprtybv4si2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 4410 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2318; /* rs6000_vprtybv2di2 */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 4410 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2319; /* rs6000_vprtybv1ti2 */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode)
          || !
#line 4410 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2320; /* rs6000_vprtybti2 */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1))
    {
    case 0:
      if (!
#line 6840 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 483; /* floorsf2 */

    case 1:
      if (!
#line 6840 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 484; /* floordf2 */

    case 2:
      if (!(
#line 15447 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1175; /* floorkf2 */

    case 3:
      if (!(
#line 15447 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1176; /* floortf2 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2339 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1415; /* vsx_floorv4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2107; /* *altivec_vrfim */

    case 5:
      if (!
#line 2339 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1416; /* vsx_floorv2df2 */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!base_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !fusion_addis_mem_combo_load (operands[1], E_QImode)
          || !
#line 14733 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 1068; /* *fusion_gpr_load_qi */

    case E_HImode:
      if (!base_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !fusion_addis_mem_combo_load (operands[1], E_HImode)
          || !
#line 14733 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 1069; /* *fusion_gpr_load_hi */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6776 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
        return -1;
      return 473; /* lrintsfdi2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6776 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
        return -1;
      return 474; /* lrintdfdi2 */

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!const_0_to_12_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1565; /* vreplace_un_si */

    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1566; /* vreplace_un_sf */

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1567; /* vreplace_un_di */

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !
#line 4423 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1568; /* vreplace_un_df */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 32:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (pattern292 (x2))
        {
        case 0:
          if (!
#line 2523 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB))
            return -1;
          return 137; /* popcntbsi2 */

        case 1:
          if (!(
#line 2523 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 138; /* popcntbdi2 */

        default:
          return -1;
        }

    case 50:
      return recog_61 (x1, insn, pnum_clobbers);

    case 33:
      return recog_77 (x1, insn, pnum_clobbers);

    case 46:
      return recog_76 (x1, insn, pnum_clobbers);

    case 85:
      return recog_74 (x1, insn, pnum_clobbers);

    case 54:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5861 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX))
        return -1;
      return 401; /* lfiwax */

    case 55:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5963 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX))
        return -1;
      return 410; /* lfiwzx */

    case 5:
      switch (pattern155 (x1, 
FIX))
        {
        case 0:
          if (!
#line 6669 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 464; /* fctiwz_sf */

        case 1:
          if (!
#line 6669 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 465; /* fctiwz_df */

        default:
          return -1;
        }

    case 56:
      switch (pattern155 (x1, 
UNSIGNED_FIX))
        {
        case 0:
          if (!
#line 6680 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 466; /* fctiwuz_sf */

        case 1:
          if (!
#line 6680 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 467; /* fctiwuz_df */

        default:
          return -1;
        }

    case 53:
      return recog_94 (x1, insn, pnum_clobbers);

    case 52:
      return recog_93 (x1, insn, pnum_clobbers);

    case 9:
      return recog_62 (x1, insn, pnum_clobbers);

    case 8:
      return recog_72 (x1, insn, pnum_clobbers);

    case 6:
      return recog_71 (x1, insn, pnum_clobbers);

    case 7:
      return recog_68 (x1, insn, pnum_clobbers);

    case 10:
      return recog_84 (x1, insn, pnum_clobbers);

    case 31:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !
#line 6880 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_PPC_GFXOPT))
        return -1;
      return 489; /* stfiwx */

    case 87:
      return recog_75 (x1, insn, pnum_clobbers);

    case 86:
      return recog_69 (x1, insn, pnum_clobbers);

    case 97:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 8733 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 597; /* xxspltidp_sf_internal */

        case 1:
          if (!
#line 8733 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 598; /* xxspltidp_df_internal */

        default:
          return -1;
        }

    case 98:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 8742 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 599; /* xxspltiw_sf_internal */

        case 1:
          if (!
#line 8742 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 600; /* xxspltiw_df_internal */

        default:
          return -1;
        }

    case 60:
      return recog_88 (x1, insn, pnum_clobbers);

    case 62:
      return recog_73 (x1, insn, pnum_clobbers);

    case 64:
      return recog_63 (x1, insn, pnum_clobbers);

    case 15:
      return recog_87 (x1, insn, pnum_clobbers);

    case 2:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 96
          || GET_MODE (x3) != E_SImode
          || !
#line 11135 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4 && flag_pic == 1 && TARGET_32BIT))
        return -1;
      return 796; /* load_toc_v4_pic_si */

    case 73:
      return recog_83 (x1, insn, pnum_clobbers);

    case 83:
      return recog_82 (x1, insn, pnum_clobbers);

    case 84:
      return recog_92 (x1, insn, pnum_clobbers);

    case 36:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1214; /* *hwsync */

    case 37:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1215; /* *lwsync */

    case 72:
      return recog_86 (x1, insn, pnum_clobbers);

    case 122:
      return recog_81 (x1, insn, pnum_clobbers);

    case 19:
      if (GET_MODE (x2) != E_CCmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!cc_reg_operand (operands[0], E_CCmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2214 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1391; /* *xvtlsbb_internal */

    case 124:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 2308 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1404; /* vsx_xsrdpi */

        case 1:
          if (!
#line 2308 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1405; /* vsx_xvrspi */

        case 2:
          if (!
#line 2308 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1406; /* vsx_xvrdpi */

        default:
          return -1;
        }

    case 125:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 2316 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1407; /* vsx_xsrdpic */

        case 1:
          if (!
#line 2316 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1408; /* vsx_xvrspic */

        case 2:
          if (!
#line 2316 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1409; /* vsx_xvrdpic */

        default:
          return -1;
        }

    case 107:
      return recog_66 (x1, insn, pnum_clobbers);

    case 108:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2427 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1425; /* vsx_xvcvhpsp */

    case 143:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2436 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1426; /* vsx_xvcvsphp */

    case 110:
      return recog_91 (x1, insn, pnum_clobbers);

    case 109:
      return recog_80 (x1, insn, pnum_clobbers);

    case 105:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2596 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1440; /* vsx_xvcvdpsxws */

    case 106:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2604 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1441; /* vsx_xvcvdpuxws */

    case 113:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2612 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1442; /* vsx_xvcvsxdsp */

    case 114:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2620 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1443; /* vsx_xvcvuxdsp */

    case 111:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2661 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1448; /* vsx_xvcvsxwdp_df */

    case 112:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2669 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1449; /* vsx_xvcvuxwdp_df */

    case 139:
      return recog_67 (x1, insn, pnum_clobbers);

    case 190:
      if (GET_MODE (x2) != E_TImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_TImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_TImode)
          || !
#line 5187 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1658; /* extendditi2_vector */

    case 146:
      return recog_90 (x1, insn, pnum_clobbers);

    case 147:
      return recog_89 (x1, insn, pnum_clobbers);

    case 155:
      switch (pattern159 (x1))
        {
        case 0:
          if (!
#line 5463 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1687; /* xvxexpsp */

        case 1:
          if (!
#line 5463 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1688; /* xvxexpdp */

        default:
          return -1;
        }

    case 156:
      switch (pattern159 (x1))
        {
        case 0:
          if (!
#line 5473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1689; /* xvxsigsp */

        case 1:
          if (!
#line 5473 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1690; /* xvxsigdp */

        default:
          return -1;
        }

    case 141:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1736; /* vsx_xvcvspbf16 */

    case 140:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1737; /* vsx_xvcvbf16spn */

    case 189:
      return recog_64 (x1, insn, pnum_clobbers);

    case 192:
      return recog_65 (x1, insn, pnum_clobbers);

    case 204:
      return recog_78 (x1, insn, pnum_clobbers);

    case 205:
      if (GET_MODE (x2) != E_V2DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!c32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6628 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1777; /* xxspltidp_v2df_inst */

    case 356:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 907 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1920; /* vstrir_direct_v8hi */

        case 1:
          if (!
#line 907 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1921; /* vstrir_direct_v16qi */

        default:
          return -1;
        }

    case 357:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1924; /* vstril_direct_v8hi */

        case 1:
          if (!
#line 959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1925; /* vstril_direct_v16qi */

        default:
          return -1;
        }

    case 360:
      return recog_85 (x1, insn, pnum_clobbers);

    case 256:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2581 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2106; /* altivec_vrfin */

    case 261:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2635 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2112; /* altivec_vlogefp */

    case 262:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2643 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2113; /* altivec_vexptefp */

    case 264:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2693 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2126; /* altivec_vupkhsw */

        case 1:
          if (!
#line 2693 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2127; /* altivec_vupkhsh */

        case 2:
          if (!
#line 2693 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2128; /* altivec_vupkhsb */

        default:
          return -1;
        }

    case 266:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2706 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2129; /* altivec_vupkhsw_direct */

        case 1:
          if (!
#line 2706 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2130; /* altivec_vupkhsh_direct */

        case 2:
          if (!
#line 2706 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2131; /* altivec_vupkhsb_direct */

        default:
          return -1;
        }

    case 265:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2714 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2132; /* altivec_vupklsw */

        case 1:
          if (!
#line 2714 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2133; /* altivec_vupklsh */

        case 2:
          if (!
#line 2714 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2134; /* altivec_vupklsb */

        default:
          return -1;
        }

    case 267:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2727 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2135; /* *altivec_vupklsw_direct */

        case 1:
          if (!
#line 2727 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2136; /* *altivec_vupklsh_direct */

        case 2:
          if (!
#line 2727 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2137; /* *altivec_vupklsb_direct */

        default:
          return -1;
        }

    case 268:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2735 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2138; /* altivec_vupkhpx */

    case 269:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2748 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2139; /* altivec_vupklpx */

    case 162:
      switch (pattern162 (x1))
        {
        case 0:
          if (!
#line 3020 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2167; /* altivec_lvsl_reg_si */

        case 1:
          if (!(
#line 3020 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2168; /* altivec_lvsl_reg_di */

        default:
          return -1;
        }

    case 276:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3028 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2169; /* altivec_lvsl_direct */

    case 163:
      switch (pattern162 (x1))
        {
        case 0:
          if (!
#line 3058 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2170; /* altivec_lvsr_reg_si */

        case 1:
          if (!(
#line 3058 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2171; /* altivec_lvsr_reg_di */

        default:
          return -1;
        }

    case 277:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3066 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2172; /* altivec_lvsr_direct */

    case 281:
      return recog_70 (x1, insn, pnum_clobbers);

    case 301:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4247 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2293; /* altivec_lvlx */

    case 302:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4255 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2294; /* altivec_lvlxl */

    case 303:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4263 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2295; /* altivec_lvrx */

    case 304:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4271 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2296; /* altivec_lvrxl */

    case 329:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode)
          || !
#line 4419 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2321; /* p8v_vgbbd */

    case 421:
      if (GET_MODE (x2) != E_XOmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 510 "../../gcc-15.1.1-20250425/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2362; /* mma_xxmfacc */

    case 422:
      if (GET_MODE (x2) != E_XOmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 510 "../../gcc-15.1.1-20250425/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2363; /* mma_xxmtacc */

    case 424:
      if (GET_MODE (x2) != E_DDmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_DDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_SDmode)
          || !
#line 41 "../../gcc-15.1.1-20250425/gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], DDmode)
   || gpc_reg_operand (operands[1], SDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2423; /* movsd_store */

    case 423:
      if (GET_MODE (x2) != E_SDmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_SDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_DDmode)
          || !
#line 51 "../../gcc-15.1.1-20250425/gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], SDmode)
   || gpc_reg_operand (operands[1], DDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2424; /* movsd_load */

    case 437:
      return recog_79 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_123 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 0);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          operands[4] = x9;
          if (!const_2_to_3_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern510 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !
#line 3855 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1512; /* vsx_xxpermdi2_v2df_1 */

            case E_V2DImode:
              if (pattern510 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                  || !
#line 3855 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1513; /* vsx_xxpermdi2_v2di_1 */

            default:
              return -1;
            }

        case 16:
          if (pattern224 (x3) != 0
              || pattern537 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0LL:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 16LL)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1LL)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 17LL)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2LL)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 18LL)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3LL)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 19LL)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 4LL)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 20LL)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 5LL)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 21LL)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 6LL)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 22LL)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 7LL)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 23LL)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1958; /* altivec_vmrghb_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1351 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1968; /* altivec_vmrglb_direct_le */

            case 8LL:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 24LL)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 9LL)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 25LL)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 10LL)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 26LL)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 11LL)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 27LL)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 12LL)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 28LL)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 13LL)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 29LL)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 14LL)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 30LL)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 15LL)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 31LL)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1959; /* altivec_vmrghb_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1967; /* altivec_vmrglb_direct_be */

            default:
              return -1;
            }

        case 8:
          if (pattern225 (x3) != 0
              || pattern537 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0LL:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 8LL)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1LL)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 9LL)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2LL)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 10LL)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3LL)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 11LL)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1224 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1960; /* altivec_vmrghh_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1394 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1970; /* altivec_vmrglh_direct_le */

            case 4LL:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 12LL)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 5LL)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 13LL)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 6LL)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 14LL)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 7LL)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 15LL)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1238 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1961; /* altivec_vmrghh_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1380 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1969; /* altivec_vmrglh_direct_be */

            default:
              return -1;
            }

        case 4:
          if (pattern226 (x3) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0LL:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 4LL)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              switch (XWINT (x10, 0))
                {
                case 1LL:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 5LL)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern537 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1962; /* altivec_vmrghw_direct_v4sf_be */
                      if (
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                        return 1966; /* *altivec_vmrghsf */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1973; /* altivec_vmrglw_direct_v4sf_le */

                    case E_V4SImode:
                      if (pattern537 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1963; /* altivec_vmrghw_direct_v4si_be */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1974; /* altivec_vmrglw_direct_v4si_le */

                    default:
                      return -1;
                    }

                case 2LL:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 6LL)
                    return -1;
                  switch (pattern539 (x2))
                    {
                    case 0:
                      if (!
#line 1487 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1976; /* p8_vmrgew_v4sf */

                    case 1:
                      if (!
#line 1487 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1977; /* p8_vmrgew_v4si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 2LL:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 6LL)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3LL)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern537 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1964; /* altivec_vmrghw_direct_v4sf_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (
#line 1423 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return 1971; /* altivec_vmrglw_direct_v4sf_be */
                  if (!
#line 1451 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                    return -1;
                  return 1975; /* *altivec_vmrglsf */

                case E_V4SImode:
                  if (pattern537 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1965; /* altivec_vmrghw_direct_v4si_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (!
#line 1423 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return -1;
                  return 1972; /* altivec_vmrglw_direct_v4si_be */

                default:
                  return -1;
                }

            case 1LL:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 5LL)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3LL)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7LL)
                return -1;
              switch (pattern539 (x2))
                {
                case 0:
                  if (!
#line 1504 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1978; /* p8_vmrgow_v4sf */

                case 1:
                  if (!
#line 1504 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1979; /* p8_vmrgow_v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1641; /* *vsx_reduc_plus_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1644; /* *vsx_reduc_plus_v4sf_scalar */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1642; /* *vsx_reduc_smin_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1645; /* *vsx_reduc_smin_v4sf_scalar */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1643; /* *vsx_reduc_smax_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1646; /* *vsx_reduc_smax_v4sf_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          if (reg_or_mem_operand (operands[1], E_SFmode)
              && 
#line 5241 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !HONOR_SNANS (SFmode)))
            return 328; /* *extendsfdf2_fpr */
          if (!gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 5262 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && HONOR_SNANS (SFmode)))
            return -1;
          return 329; /* *extendsfdf2_snan */

        case E_IFmode:
          switch (pattern205 (x3))
            {
            case 0:
              if (!(
#line 8930 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 630 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 613; /* extenddfif2_vsx */

            case 1:
              if (!
#line 9461 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)))
                return -1;
              return 639; /* *extendtfif2_internal */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_TFmode))
            {
              switch (pattern316 ())
                {
                case 0:
                  if ((
#line 8930 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 614; /* extenddftf2_vsx */
                  break;

                case 1:
                  if (
#line 9448 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)))
                    return 637; /* *extendiftf2_internal */
                  break;

                case 2:
                  if (
#line 9448 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)))
                    return 638; /* *extendkftf2_internal */
                  break;

                default:
                  break;
                }
            }
          if (altivec_register_operand (operands[0], E_TFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (altivec_register_operand (operands[1], E_SFmode)
                      && (
#line 15201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1122; /* extendsftf2_hw */
                  break;

                case E_DFmode:
                  if (altivec_register_operand (operands[1], E_DFmode)
                      && (
#line 15201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1124; /* extenddftf2_hw */
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_TFmode)
              || !vsx_register_operand (operands[1], E_KFmode)
              || !
#line 15211 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD))
            return -1;
          return 1125; /* *extendkftf2 */

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_KFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && 
#line 9461 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)))
            return 640; /* *extendtfkf2_internal */
          if (altivec_register_operand (operands[0], E_KFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (altivec_register_operand (operands[1], E_SFmode)
                      && (
#line 15201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1121; /* extendsfkf2_hw */
                  break;

                case E_DFmode:
                  if (altivec_register_operand (operands[1], E_DFmode)
                      && (
#line 15201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1123; /* extenddfkf2_hw */
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_KFmode)
              || !vsx_register_operand (operands[1], E_TFmode)
              || !
#line 15227 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD))
            return -1;
          return 1126; /* *extendtfkf2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_SDmode)
              || !
#line 62 "../../gcc-15.1.1-20250425/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2425; /* extendsddd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 140 "../../gcc-15.1.1-20250425/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2433; /* extendddtd2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern7 (x3, 
E_V2DFmode))
        {
        case 0:
          if (!
#line 2371 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1420; /* vsx_xvcvspdp_be */

        case 1:
          if (!
#line 2380 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1421; /* vsx_xvcvspdp_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern123 (x3, 
E_SImode) == 0)
            return 275; /* rotlsi3 */
          break;

        case E_DImode:
          if (pattern123 (x3, 
E_DImode) == 0
              && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return 276; /* rotldi3 */
          break;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) == 0
              && 
#line 1989 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return 2016; /* altivec_vrlw */
          break;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) == 0
              && 
#line 1989 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return 2017; /* altivec_vrlh */
          break;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) == 0
              && 
#line 1989 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return 2018; /* altivec_vrlb */
          break;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) == 0
              && 
#line 1989 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return 2019; /* altivec_vrld */
          break;

        case E_V1TImode:
          if (pattern2 (x3, 
E_V1TImode) == 0
              && 
#line 1997 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return 2020; /* altivec_vrlq */
          break;

        default:
          break;
        }
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (!nonimmediate_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !input_operand (operands[1], E_V1TImode)
              || !
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return -1;
          return 1271; /* *vsx_le_permute_v1ti */

        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !input_operand (operands[1], E_TImode)
              || !
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return -1;
          return 1272; /* *vsx_le_permute_ti */

        default:
          return -1;
        }

    case ROTATE:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      switch (pattern215 (x3))
        {
        case 0:
          if (!
#line 1021 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX))
            return -1;
          return 1273; /* *vsx_le_undo_permute_v1ti */

        case 1:
          if (!
#line 1021 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX))
            return -1;
          return 1274; /* *vsx_le_undo_permute_ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!altivec_register_operand (operands[3], E_V2DImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_V2DImode)
    return -1;
  x6 = XEXP (x5, 1);
  operands[1] = x6;
  if (!altivec_register_operand (operands[1], E_V2DImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!altivec_register_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_V2DImode)
      || !
#line 3049 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
    return -1;
  return 3341; /* *fuse_vaddudm_vaddudm */
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98)
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 82; /* *addsi3_imm_carry_0 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 83; /* *adddi3_imm_carry_0 */

        default:
          return -1;
        }

    case MEM:
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x10 = XEXP (x8, 1);
      operands[2] = x10;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x5, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x8))
            {
            case E_SImode:
              if (pattern581 (x5, 
E_SImode) != 0
                  || !(
#line 10257 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 704; /* movdi_si_update */

            case E_DImode:
              if (pattern581 (x5, 
E_DImode) != 0)
                return -1;
              if ((
#line 10257 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 705; /* movdi_di_update */
              if (!
#line 10277 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 706; /* movdi_update_stack */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern572 (x1, 
E_SImode))
            {
            case 0:
              if ((
#line 10321 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 711; /* movsi_si_update */
              if (!
#line 10341 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 713; /* movsi_update_stack */

            case 1:
              if (!(
#line 10321 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 712; /* movsi_di_update */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern572 (x1, 
E_HImode))
            {
            case 0:
              if (!(
#line 10406 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 724; /* *movhi_update4 */

            case 1:
              if (!(
#line 10406 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 725; /* *movhi_update4 */

            default:
              return -1;
            }

        case E_QImode:
          switch (pattern572 (x1, 
E_QImode))
            {
            case 0:
              if (!(
#line 10455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 732; /* *movqi_update3 */

            case 1:
              if (!(
#line 10455 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 733; /* *movqi_update3 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern572 (x1, 
E_SFmode))
            {
            case 0:
              if ((
#line 10488 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 738; /* *movsf_update2 */
              if (!(
#line 10521 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 744; /* *movsf_update4 */

            case 1:
              if ((
#line 10488 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 739; /* *movsf_update2 */
              if (!(
#line 10521 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 745; /* *movsf_update4 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern572 (x1, 
E_DFmode))
            {
            case 0:
              if (!(
#line 10488 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 740; /* *movdf_update2 */

            case 1:
              if (!(
#line 10488 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 741; /* *movdf_update2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          switch (pattern410 (x5))
            {
            case 0:
              if (!
#line 1519 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2659; /* *fuse_and_xor */

            case 1:
              if (!(
#line 1519 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2660; /* *fuse_and_xor */

            case 2:
              if (!
#line 2887 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3259; /* *fuse_vand_vxor */

            case 3:
              if (!
#line 2887 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3260; /* *fuse_vand_vxor */

            case 4:
              if (!
#line 2887 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3261; /* *fuse_vand_vxor */

            case 5:
              if (!
#line 2887 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3262; /* *fuse_vand_vxor */

            case 6:
              if (!
#line 2887 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3263; /* *fuse_vand_vxor */

            case 7:
              if (!
#line 2887 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3264; /* *fuse_vand_vxor */

            case 8:
              if (!
#line 2887 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3265; /* *fuse_vand_vxor */

            case 9:
              if (!
#line 2887 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3266; /* *fuse_vand_vxor */

            case 10:
              if (!(
#line 2887 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3267; /* *fuse_vand_vxor */

            case 11:
              if (!(
#line 2887 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3268; /* *fuse_vand_vxor */

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x11 = XEXP (x8, 1);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[1] = x11;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern238 (x5, 
E_SImode) != 0
                      || !
#line 1537 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2661; /* *fuse_andc_xor */

                case E_DImode:
                  if (pattern238 (x5, 
E_DImode) != 0
                      || !(
#line 1537 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2662; /* *fuse_andc_xor */

                case E_V4SImode:
                  if (pattern239 (x5, 
E_V4SImode) != 0
                      || !
#line 2905 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3269; /* *fuse_vandc_vxor */

                case E_V8HImode:
                  if (pattern239 (x5, 
E_V8HImode) != 0
                      || !
#line 2905 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3270; /* *fuse_vandc_vxor */

                case E_V16QImode:
                  if (pattern239 (x5, 
E_V16QImode) != 0
                      || !
#line 2905 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3271; /* *fuse_vandc_vxor */

                case E_V4SFmode:
                  if (pattern239 (x5, 
E_V4SFmode) != 0
                      || !
#line 2905 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3272; /* *fuse_vandc_vxor */

                case E_V2DFmode:
                  if (pattern239 (x5, 
E_V2DFmode) != 0
                      || !
#line 2905 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3273; /* *fuse_vandc_vxor */

                case E_V2DImode:
                  if (pattern239 (x5, 
E_V2DImode) != 0
                      || !
#line 2905 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3274; /* *fuse_vandc_vxor */

                case E_V1TImode:
                  if (pattern239 (x5, 
E_V1TImode) != 0
                      || !
#line 2905 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3275; /* *fuse_vandc_vxor */

                case E_TImode:
                  if (pattern239 (x5, 
E_TImode) != 0
                      || !
#line 2905 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3276; /* *fuse_vandc_vxor */

                case E_KFmode:
                  if (pattern239 (x5, 
E_KFmode) != 0
                      || !(
#line 2905 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3277; /* *fuse_vandc_vxor */

                case E_TFmode:
                  if (pattern239 (x5, 
E_TFmode) != 0
                      || !(
#line 2905 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3278; /* *fuse_vandc_vxor */

                default:
                  return -1;
                }

            case NOT:
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern193 (x5, 
E_SImode) != 0
                      || !
#line 1591 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2667; /* *fuse_nor_xor */

                case E_DImode:
                  if (pattern193 (x5, 
E_DImode) != 0
                      || !(
#line 1591 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2668; /* *fuse_nor_xor */

                case E_V4SImode:
                  if (pattern243 (x5, 
E_V4SImode) != 0
                      || !
#line 2959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3299; /* *fuse_vnor_vxor */

                case E_V8HImode:
                  if (pattern243 (x5, 
E_V8HImode) != 0
                      || !
#line 2959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3300; /* *fuse_vnor_vxor */

                case E_V16QImode:
                  if (pattern243 (x5, 
E_V16QImode) != 0
                      || !
#line 2959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3301; /* *fuse_vnor_vxor */

                case E_V4SFmode:
                  if (pattern243 (x5, 
E_V4SFmode) != 0
                      || !
#line 2959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3302; /* *fuse_vnor_vxor */

                case E_V2DFmode:
                  if (pattern243 (x5, 
E_V2DFmode) != 0
                      || !
#line 2959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3303; /* *fuse_vnor_vxor */

                case E_V2DImode:
                  if (pattern243 (x5, 
E_V2DImode) != 0
                      || !
#line 2959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3304; /* *fuse_vnor_vxor */

                case E_V1TImode:
                  if (pattern243 (x5, 
E_V1TImode) != 0
                      || !
#line 2959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3305; /* *fuse_vnor_vxor */

                case E_TImode:
                  if (pattern243 (x5, 
E_TImode) != 0
                      || !
#line 2959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3306; /* *fuse_vnor_vxor */

                case E_KFmode:
                  if (pattern243 (x5, 
E_KFmode) != 0
                      || !(
#line 2959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3307; /* *fuse_vnor_vxor */

                case E_TFmode:
                  if (pattern243 (x5, 
E_TFmode) != 0
                      || !(
#line 2959 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3308; /* *fuse_vnor_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != XOR)
        return -1;
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      x13 = XEXP (x9, 1);
      operands[1] = x13;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern527 (x5, 
E_SImode) != 0
              || !
#line 1555 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2663; /* *fuse_eqv_xor */

        case E_DImode:
          if (pattern527 (x5, 
E_DImode) != 0
              || !(
#line 1555 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2664; /* *fuse_eqv_xor */

        case E_V4SImode:
          if (pattern528 (x5, 
E_V4SImode) != 0
              || !
#line 2923 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3279; /* *fuse_veqv_vxor */

        case E_V8HImode:
          if (pattern528 (x5, 
E_V8HImode) != 0
              || !
#line 2923 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3280; /* *fuse_veqv_vxor */

        case E_V16QImode:
          if (pattern528 (x5, 
E_V16QImode) != 0
              || !
#line 2923 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3281; /* *fuse_veqv_vxor */

        case E_V4SFmode:
          if (pattern528 (x5, 
E_V4SFmode) != 0
              || !
#line 2923 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3282; /* *fuse_veqv_vxor */

        case E_V2DFmode:
          if (pattern528 (x5, 
E_V2DFmode) != 0
              || !
#line 2923 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3283; /* *fuse_veqv_vxor */

        case E_V2DImode:
          if (pattern528 (x5, 
E_V2DImode) != 0
              || !
#line 2923 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3284; /* *fuse_veqv_vxor */

        case E_V1TImode:
          if (pattern528 (x5, 
E_V1TImode) != 0
              || !
#line 2923 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3285; /* *fuse_veqv_vxor */

        case E_TImode:
          if (pattern528 (x5, 
E_TImode) != 0
              || !
#line 2923 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3286; /* *fuse_veqv_vxor */

        case E_KFmode:
          if (pattern528 (x5, 
E_KFmode) != 0
              || !(
#line 2923 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3287; /* *fuse_veqv_vxor */

        case E_TFmode:
          if (pattern528 (x5, 
E_TFmode) != 0
              || !(
#line 2923 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3288; /* *fuse_veqv_vxor */

        default:
          return -1;
        }

    case IOR:
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case NOT:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x11 = XEXP (x8, 1);
          switch (GET_CODE (x11))
            {
            case NOT:
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern193 (x5, 
E_SImode) != 0
                      || !
#line 1573 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2665; /* *fuse_nand_xor */

                case E_DImode:
                  if (pattern193 (x5, 
E_DImode) != 0
                      || !(
#line 1573 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2666; /* *fuse_nand_xor */

                case E_V4SImode:
                  if (pattern243 (x5, 
E_V4SImode) != 0
                      || !
#line 2941 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3289; /* *fuse_vnand_vxor */

                case E_V8HImode:
                  if (pattern243 (x5, 
E_V8HImode) != 0
                      || !
#line 2941 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3290; /* *fuse_vnand_vxor */

                case E_V16QImode:
                  if (pattern243 (x5, 
E_V16QImode) != 0
                      || !
#line 2941 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3291; /* *fuse_vnand_vxor */

                case E_V4SFmode:
                  if (pattern243 (x5, 
E_V4SFmode) != 0
                      || !
#line 2941 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3292; /* *fuse_vnand_vxor */

                case E_V2DFmode:
                  if (pattern243 (x5, 
E_V2DFmode) != 0
                      || !
#line 2941 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3293; /* *fuse_vnand_vxor */

                case E_V2DImode:
                  if (pattern243 (x5, 
E_V2DImode) != 0
                      || !
#line 2941 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3294; /* *fuse_vnand_vxor */

                case E_V1TImode:
                  if (pattern243 (x5, 
E_V1TImode) != 0
                      || !
#line 2941 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3295; /* *fuse_vnand_vxor */

                case E_TImode:
                  if (pattern243 (x5, 
E_TImode) != 0
                      || !
#line 2941 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3296; /* *fuse_vnand_vxor */

                case E_KFmode:
                  if (pattern243 (x5, 
E_KFmode) != 0
                      || !(
#line 2941 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3297; /* *fuse_vnand_vxor */

                case E_TFmode:
                  if (pattern243 (x5, 
E_TFmode) != 0
                      || !(
#line 2941 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3298; /* *fuse_vnand_vxor */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x11;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern238 (x5, 
E_SImode) != 0
                      || !
#line 1627 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2671; /* *fuse_orc_xor */

                case E_DImode:
                  if (pattern238 (x5, 
E_DImode) != 0
                      || !(
#line 1627 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2672; /* *fuse_orc_xor */

                case E_V4SImode:
                  if (pattern239 (x5, 
E_V4SImode) != 0
                      || !
#line 2995 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3319; /* *fuse_vorc_vxor */

                case E_V8HImode:
                  if (pattern239 (x5, 
E_V8HImode) != 0
                      || !
#line 2995 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3320; /* *fuse_vorc_vxor */

                case E_V16QImode:
                  if (pattern239 (x5, 
E_V16QImode) != 0
                      || !
#line 2995 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3321; /* *fuse_vorc_vxor */

                case E_V4SFmode:
                  if (pattern239 (x5, 
E_V4SFmode) != 0
                      || !
#line 2995 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3322; /* *fuse_vorc_vxor */

                case E_V2DFmode:
                  if (pattern239 (x5, 
E_V2DFmode) != 0
                      || !
#line 2995 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3323; /* *fuse_vorc_vxor */

                case E_V2DImode:
                  if (pattern239 (x5, 
E_V2DImode) != 0
                      || !
#line 2995 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3324; /* *fuse_vorc_vxor */

                case E_V1TImode:
                  if (pattern239 (x5, 
E_V1TImode) != 0
                      || !
#line 2995 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3325; /* *fuse_vorc_vxor */

                case E_TImode:
                  if (pattern239 (x5, 
E_TImode) != 0
                      || !
#line 2995 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3326; /* *fuse_vorc_vxor */

                case E_KFmode:
                  if (pattern239 (x5, 
E_KFmode) != 0
                      || !(
#line 2995 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3327; /* *fuse_vorc_vxor */

                case E_TFmode:
                  if (pattern239 (x5, 
E_TFmode) != 0
                      || !(
#line 2995 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3328; /* *fuse_vorc_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern410 (x5))
            {
            case 0:
              if (!
#line 1609 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2669; /* *fuse_or_xor */

            case 1:
              if (!(
#line 1609 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2670; /* *fuse_or_xor */

            case 2:
              if (!
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3309; /* *fuse_vor_vxor */

            case 3:
              if (!
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3310; /* *fuse_vor_vxor */

            case 4:
              if (!
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3311; /* *fuse_vor_vxor */

            case 5:
              if (!
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3312; /* *fuse_vor_vxor */

            case 6:
              if (!
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3313; /* *fuse_vor_vxor */

            case 7:
              if (!
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3314; /* *fuse_vor_vxor */

            case 8:
              if (!
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3315; /* *fuse_vor_vxor */

            case 9:
              if (!
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3316; /* *fuse_vor_vxor */

            case 10:
              if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3317; /* *fuse_vor_vxor */

            case 11:
              if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3318; /* *fuse_vor_vxor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      switch (pattern410 (x5))
        {
        case 0:
          if (!
#line 1645 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2673; /* *fuse_xor_xor */

        case 1:
          if (!(
#line 1645 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2674; /* *fuse_xor_xor */

        case 2:
          if (!
#line 3013 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3329; /* *fuse_vxor_vxor */

        case 3:
          if (!
#line 3013 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3330; /* *fuse_vxor_vxor */

        case 4:
          if (!
#line 3013 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3331; /* *fuse_vxor_vxor */

        case 5:
          if (!
#line 3013 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3332; /* *fuse_vxor_vxor */

        case 6:
          if (!
#line 3013 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3333; /* *fuse_vxor_vxor */

        case 7:
          if (!
#line 3013 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3334; /* *fuse_vxor_vxor */

        case 8:
          if (!
#line 3013 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3335; /* *fuse_vxor_vxor */

        case 9:
          if (!
#line 3013 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3336; /* *fuse_vxor_vxor */

        case 10:
          if (!(
#line 3013 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3337; /* *fuse_vxor_vxor */

        case 11:
          if (!(
#line 3013 "../../gcc-15.1.1-20250425/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3338; /* *fuse_vxor_vxor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 1919 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 74; /* *addsi3_imm_dot */

        case 1:
          if (!(
#line 1919 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 75; /* *adddi3_imm_dot */

        case 2:
          if (!
#line 1944 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 76; /* *addsi3_imm_dot2 */

        case 3:
          if (!(
#line 1944 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 77; /* *adddi3_imm_dot2 */

        case 4:
          if (!(
#line 2275 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 110; /* subfsi3_carry_dot2 */

        case 5:
          if (!(
#line 2275 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 111; /* subfdi3_carry_dot2 */

        case 6:
          if (!
#line 3394 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 194; /* *divsi3_sra_dot */

        case 7:
          if (!(
#line 3394 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 195; /* *divdi3_sra_dot */

        case 8:
          if (!
#line 3420 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 196; /* *divsi3_sra_dot2 */

        case 9:
          if (!(
#line 3420 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 197; /* *divdi3_sra_dot2 */

        case 10:
          if (!
#line 3654 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
            return -1;
          return 201; /* *andsi3_imm_dot */

        case 11:
          if (!(
#line 3654 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 202; /* *anddi3_imm_dot */

        case 12:
          if (!
#line 3681 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
            return -1;
          return 203; /* *andsi3_imm_dot2 */

        case 13:
          if (!(
#line 3681 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 204; /* *anddi3_imm_dot2 */

        case 14:
          if (!
#line 4918 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 302; /* *ashrsi3_dot */

        case 15:
          if (!(
#line 4918 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 303; /* *ashrdi3_dot */

        case 16:
          if (!
#line 4945 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 304; /* *ashrsi3_dot2 */

        case 17:
          if (!(
#line 4945 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 305; /* *ashrdi3_dot2 */

        default:
          return -1;
        }

    case BSWAP:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (gpc_reg_operand (operands[1], E_DImode)
          && gpc_reg_operand (operands[0], E_DImode))
        {
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          if (scratch_operand (operands[2], E_DImode))
            {
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (scratch_operand (operands[3], E_DImode)
                  && 
#line 2806 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX && !TARGET_P9_VECTOR))
                return 162; /* bswapdi2_reg */
            }
        }
      if (!reg_or_mem_operand (operands[1], E_DImode)
          || !reg_or_mem_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_DImode)
          || !
#line 2816 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX
   && (REG_P (operands[0]) || REG_P (operands[1]))
   && !(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))
   && !(MEM_P (operands[1]) && MEM_VOLATILE_P (operands[1]))))
        return -1;
      return 163; /* *bswapdi2_64bit */

    case IF_THEN_ELSE:
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64))
            return -1;
          return 223; /* *branch_anddi3_dot */

        case 1:
          if (!
#line 7954 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
            return -1;
          return 572; /* *rotate_on_cmpdi */

        case 2:
          if (!
#line 7954 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
            return -1;
          return 573; /* *rotate_on_cmpdi */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 6269 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 421; /* *floatunsqisf2_internal */

        case 1:
          if (!
#line 6269 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 422; /* *floatunshisf2_internal */

        case 2:
          if (!
#line 6269 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 423; /* *floatunsqidf2_internal */

        case 3:
          if (!
#line 6269 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 424; /* *floatunshidf2_internal */

        case 4:
          if (!
#line 6744 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          return 471; /* *roundu32sf2_fprs */

        case 5:
          if (!
#line 6744 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          return 472; /* *roundu32df2_fprs */

        case 6:
          if (!
#line 4481 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1572; /* *vsx_extract_si_unsfloat_sf */

        case 7:
          if (!(
#line 4481 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          return 1574; /* *vsx_extract_si_unsfloat_if */

        case 8:
          if (!(
#line 4481 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          return 1576; /* *vsx_extract_si_unsfloat_kf */

        case 9:
          if (!(
#line 4481 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            return -1;
          return 1578; /* *vsx_extract_si_unsfloat_tf */

        default:
          return -1;
        }

    case FIX:
      switch (pattern102 (x1))
        {
        case 0:
          if (!
#line 6362 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 427; /* fix_truncsfsi2_internal */

        case 1:
          if (!
#line 6362 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 428; /* fix_truncdfsi2_internal */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern103 (x1))
        {
        case 0:
          if (!
#line 6711 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
            return -1;
          return 469; /* *round32sf2_fprs */

        case 1:
          if (!
#line 6711 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
            return -1;
          return 470; /* *round32df2_fprs */

        case 2:
          if (!
#line 4481 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1571; /* *vsx_extract_si_float_sf */

        case 3:
          if (!(
#line 4481 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          return 1573; /* *vsx_extract_si_float_if */

        case 4:
          if (!(
#line 4481 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          return 1575; /* *vsx_extract_si_float_kf */

        case 5:
          if (!(
#line 4481 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            return -1;
          return 1577; /* *vsx_extract_si_float_tf */

        default:
          return -1;
        }

    case CALL:
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != MEM)
        return -1;
      switch (pattern199 (x1))
        {
        case 0:
          x5 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x5))
            {
            case CLOBBER:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 96)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (GET_MODE (x9) != E_SImode)
                    return -1;
                  if (current_file_function_operand (operands[1], E_SImode)
                      && (
#line 11512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 821; /* *call_value_localsi */
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode))
                    return -1;
                  if ((
#line 11637 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 831; /* *call_value_nonlocal_sysvsi */
                  if (!(
#line 11705 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 837; /* *call_value_nonlocal_aixsi */

                case E_DImode:
                  if (GET_MODE (x9) != E_DImode)
                    return -1;
                  if (current_file_function_operand (operands[1], E_DImode)
                      && (
#line 11512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 822; /* *call_value_localdi */
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  if ((
#line 11637 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 832; /* *call_value_nonlocal_sysvdi */
                  if (!(
#line 11705 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 838; /* *call_value_nonlocal_aixdi */

                default:
                  return -1;
                }

            case USE:
              if (pnum_clobbers == NULL)
                return -1;
              x9 = XEXP (x5, 0);
              operands[4] = x9;
              if (!register_operand (operands[4], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode)
                      || !(
#line 11662 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 833; /* *call_value_nonlocal_sysv_securesi */

                case E_DImode:
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode)
                      || !(
#line 11662 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 834; /* *call_value_nonlocal_sysv_securedi */

                default:
                  return -1;
                }

            case SIMPLE_RETURN:
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (current_file_function_operand (operands[1], E_SImode)
                      && (
#line 11949 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 853; /* *sibcall_value_localsi */
                  if (!symbol_ref_operand (operands[1], E_SImode)
                      || !(
#line 12045 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 861; /* *sibcall_value_nonlocal_sysvsi */

                case E_DImode:
                  if (current_file_function_operand (operands[1], E_DImode)
                      && (
#line 11949 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 854; /* *sibcall_value_localdi */
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !(
#line 12045 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 862; /* *sibcall_value_nonlocal_sysvdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          x5 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x5))
            {
            case CLOBBER:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 96)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!indirect_call_operand (operands[1], E_SImode)
                      || !unspec_tls (operands[2], E_SImode)
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  if ((
#line 11609 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 829; /* *call_value_indirect_nonlocal_sysvsi */
                  if (!(
#line 11823 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 849; /* *call_value_indirect_pcrelsi */

                case E_DImode:
                  if (!indirect_call_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode)
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  if ((
#line 11609 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 830; /* *call_value_indirect_nonlocal_sysvdi */
                  if (!(
#line 11823 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 850; /* *call_value_indirect_pcreldi */

                default:
                  return -1;
                }

            case SET:
              if (pattern501 (x5, pnum_clobbers) != 0)
                return -1;
              x10 = XEXP (x5, 1);
              x11 = XVECEXP (x10, 0, 0);
              operands[4] = x11;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pattern590 (x5, 
E_SImode) != 0
                      || !(
#line 11806 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 847; /* *call_value_indirect_elfv2si */

                case E_DImode:
                  if (pattern590 (x5, 
E_DImode) != 0
                      || !(
#line 11806 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 848; /* *call_value_indirect_elfv2di */

                default:
                  return -1;
                }

            case SIMPLE_RETURN:
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!indirect_call_operand (operands[1], E_SImode)
                      || !(
#line 12016 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 859; /* *sibcall_value_indirect_nonlocal_sysvsi */

                case E_DImode:
                  if (!indirect_call_operand (operands[1], E_DImode)
                      || !(
#line 12016 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 860; /* *sibcall_value_indirect_nonlocal_sysvdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x12 = XVECEXP (x3, 0, 0);
      operands[1] = x12;
      x13 = XVECEXP (x3, 0, 1);
      operands[2] = x13;
      switch (XINT (x3, 1))
        {
        case 35:
          if (GET_MODE (x3) != E_CCEQmode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x14 = XEXP (x4, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !cc_reg_operand (operands[0], E_CCEQmode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[4] = x8;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (pattern573 (
E_SImode) != 0
                  || !
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 874; /* stack_protect_testsi */

            case E_DImode:
              if (pattern573 (
E_DImode) != 0
                  || !
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 875; /* stack_protect_testdi */

            default:
              return -1;
            }

        case 145:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          switch (pattern480 (x1))
            {
            case 0:
              if (!
#line 3658 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1503; /* vsx_extract_v2df_var */

            case 1:
              if (!
#line 3658 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1504; /* vsx_extract_v2di_var */

            case 2:
              if (!
#line 3745 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1510; /* vsx_extract_v4sf_var */

            case 3:
              if (!
#line 4185 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1531; /* vsx_extract_v16qi_var */

            case 4:
              if (!
#line 4185 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1532; /* vsx_extract_v8hi_var */

            case 5:
              if (!
#line 4185 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1533; /* vsx_extract_v4si_var */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      switch (pattern105 (x1))
        {
        case 0:
          if (!
#line 12928 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)))
            return -1;
          return 928; /* *eqsi3 */

        case 1:
          if (!(
#line 12928 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 475 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 929; /* *eqdi3 */

        case 2:
          if (!(
#line 13220 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 496 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 944; /* *eqsi3_extdi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[0] = x3;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x15 = XEXP (x8, 0);
      operands[1] = x15;
      x9 = XEXP (x5, 0);
      operands[2] = x9;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !(
#line 13656 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 985; /* tablejumpsi_insn_nospec */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !(
#line 13656 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 986; /* tablejumpdi_insn_nospec */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 6
          || GET_MODE (x3) != E_DImode)
        return -1;
      x12 = XVECEXP (x3, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!scratch_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[2] = x9;
      if (!scratch_operand (operands[2], E_CCmode)
          || !
#line 14589 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
        return -1;
      return 1061; /* rs6000_get_timebase_ppc32 */

    case VEC_SELECT:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1522; /* *vsx_extract_v16qi_store_p9 */

        case 1:
          if (!
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1523; /* *vsx_extract_v8hi_store_p9 */

        case 2:
          if (!
#line 4049 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
            return -1;
          return 1524; /* *vsx_extract_v4si_store_p9 */

        default:
          return -1;
        }

    case PLUS:
      if (pattern108 (x1) != 0
          || !
#line 4949 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1638; /* vsx_reduc_plus_v4sf */

    case SMIN:
      if (pattern108 (x1) != 0
          || !
#line 4949 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1639; /* vsx_reduc_smin_v4sf */

    case SMAX:
      if (pattern108 (x1) != 0
          || !
#line 4949 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1640; /* vsx_reduc_smax_v4sf */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_SDmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!gpc_reg_operand (operands[0], E_SDmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_TDmode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_TDmode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_DFmode)
          || !
#line 165 "../../gcc-15.1.1-20250425/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
        return -1;
      return 2435; /* trunctdsd2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (XINT (x2, 1))
        {
        case 85:
          if (GET_MODE (x2) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode))
            return NULL;
          switch (GET_MODE (operands[1]))
            {
            case E_KFmode:
              if (gpc_reg_operand (operands[1], E_KFmode)
                  && ((
#line 5356 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 5360 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[1], KFmode))))
                return gen_split_153 (insn, operands);
              if (!memory_operand (operands[1], E_KFmode)
                  || !((
#line 5375 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 5377 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_155 (insn, operands);

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode)
                  && ((
#line 5356 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 5360 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[1], TFmode))))
                return gen_split_154 (insn, operands);
              if (!memory_operand (operands[1], E_TFmode)
                  || !((
#line 5375 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 5377 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_156 (insn, operands);

            default:
              return NULL;
            }

        case 15:
          switch (pattern292 (x2))
            {
            case 0:
              if (!((
#line 10622 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10624 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_394 (insn, operands);

            case 1:
              if (!((
#line 10622 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10624 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_395 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      operands[2] = x4;
      switch (XINT (x2, 1))
        {
        case 4:
          if (GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[0], E_SImode)
              || !got_no_const_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !
#line 7707 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
    && flag_pic == 1
    && reload_completed))
            return NULL;
          return gen_split_290 (insn, operands);

        case 14:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern417 (x2, 
E_SImode) != 0
                  || !((
#line 10575 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10577 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_392 (insn, operands);

            case E_DImode:
              if (pattern417 (x2, 
E_DImode) != 0
                  || !((
#line 10575 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10577 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_393 (insn, operands);

            default:
              return NULL;
            }

        case 23:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern220 (x2, 
E_SImode) != 0
                  || !((
#line 10688 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10690 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_396 (insn, operands);

            case E_DImode:
              if (pattern220 (x2, 
E_DImode) != 0
                  || !((
#line 10688 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10690 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_397 (insn, operands);

            default:
              return NULL;
            }

        case 27:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern220 (x2, 
E_SImode) != 0
                  || !((
#line 10768 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 10770 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_398 (insn, operands);

            case E_DImode:
              if (pattern220 (x2, 
E_DImode) != 0
                  || !((
#line 10768 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 10770 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL)))
                return NULL;
              return gen_split_399 (insn, operands);

            default:
              return NULL;
            }

        case 70:
          if (GET_MODE (x2) != E_DFmode
              || !nonimmediate_operand (operands[0], E_DFmode))
            return NULL;
          switch (pattern433 ())
            {
            case 0:
              if (((
#line 14881 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14883 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_493 (insn, operands);
              if (!((
#line 14904 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14906 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_496 (insn, operands);

            case 1:
              if (((
#line 14881 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14883 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_494 (insn, operands);
              if (!((
#line 14904 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14906 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_497 (insn, operands);

            default:
              return NULL;
            }

        case 71:
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern146 (x2, 
E_DFmode, 
E_TFmode) != 0)
                return NULL;
              if (((
#line 14940 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_HARD_FLOAT) && 
#line 543 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14942 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_499 (insn, operands);
              if (!((
#line 14964 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_SOFT_FLOAT) && 
#line 543 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 14966 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_502 (insn, operands);

            case E_IFmode:
              if (pattern146 (x2, 
E_DFmode, 
E_IFmode) != 0
                  || !((
#line 14940 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode) && TARGET_HARD_FLOAT) && 
#line 544 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 14942 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_500 (insn, operands);

            case E_TDmode:
              if (pattern146 (x2, 
E_DImode, 
E_TDmode) != 0
                  || !((
#line 14940 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TDmode) && TARGET_HARD_FLOAT) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14942 "../../gcc-15.1.1-20250425/gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_501 (insn, operands);

            default:
              return NULL;
            }

        case 138:
          if (pattern360 (x2) != 0
              || !
#line 1730 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_600 (insn, operands);

        case 130:
          if (pattern360 (x2) != 0
              || !
#line 1785 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_601 (insn, operands);

        case 131:
          if (pattern360 (x2) != 0
              || !
#line 1832 "../../gcc-15.1.1-20250425/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !reload_completed))
            return NULL;
          return gen_split_602 (insn, operands);

        case 361:
          if (GET_MODE (x2) != E_OOmode
              || !vsx_register_operand (operands[0], E_OOmode)
              || !mma_assemble_input_operand (operands[1], E_V16QImode)
              || !mma_assemble_input_operand (operands[2], E_V16QImode)
              || !(
#line 383 "../../gcc-15.1.1-20250425/gcc/config/rs6000/mma.md"
(TARGET_MMA) && 
#line 385 "../../gcc-15.1.1-20250425/gcc/config/rs6000/mma.md"
( reload_completed)))
            return NULL;
          return gen_split_740 (insn, operands);

        case 362:
          if (GET_MODE (x2) != E_V16QImode
              || !mma_disassemble_output_operand (operands[0], E_V16QImode))
            return NULL;
          switch (pattern434 ())
            {
            case 0:
              if (!(
#line 415 "../../gcc-15.1.1-20250425/gcc/config/rs6000/mma.md"
(TARGET_MMA
   && vsx_register_operand (operands[1], OOmode)) && 
#line 418 "../../gcc-15.1.1-20250425/gcc/config/rs6000/mma.md"
( reload_completed)))
                return NULL;
              return gen_split_741 (insn, operands);

            case 1:
              if (!(
#line 489 "../../gcc-15.1.1-20250425/gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[1], XOmode)) && 
#line 492 "../../gcc-15.1.1-20250425/gcc/config/rs6000/mma.md"
( reload_completed)))
                return NULL;
              return gen_split_743 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 3:
      if (XINT (x2, 1) != 263)
        return NULL;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (pattern318 (x2))
        {
        case 0:
          if (!(
#line 391 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_722 (insn, operands);

        case 1:
          if (!(
#line 391 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_723 (insn, operands);

        case 2:
          if (!(
#line 391 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_724 (insn, operands);

        case 3:
          if (!(
#line 391 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_725 (insn, operands);

        case 4:
          if (!(
#line 391 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_726 (insn, operands);

        case 5:
          if (!(
#line 391 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_727 (insn, operands);

        case 6:
          if (!(
#line 391 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_728 (insn, operands);

        case 7:
          if (!(
#line 391 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_729 (insn, operands);

        case 8:
          if (!((
#line 391 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_730 (insn, operands);

        case 9:
          if (!((
#line 391 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/rs6000/altivec.md"
( 1)))
            return NULL;
          return gen_split_731 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
