/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_TImode)
      || GET_MODE (x2) != E_TImode
      || !register_operand (operands[1], E_TImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern17 (x1); /* [-1, 1] */
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          return pattern30 (x3); /* [-1, 0] */

        case E_V16SImode:
          if (pattern31 (x3, 
E_V16SImode) != 0)
            return -1;
          return 1;

        case E_V8SImode:
          if (pattern31 (x3, 
E_V8SImode) != 0)
            return -1;
          return 2;

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 3;

        case E_V8DImode:
          if (pattern31 (x3, 
E_V8DImode) != 0)
            return -1;
          return 4;

        case E_V4DImode:
          if (pattern31 (x3, 
E_V4DImode) != 0)
            return -1;
          return 5;

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !nonimmediate_operand (operands[1], E_V2DImode))
            return -1;
          return 6;

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !nonimmediate_operand (operands[1], E_V16QImode)
              || !const_0_to_7_operand (operands[2], E_SImode))
            return -1;
          return 7;

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !nonimmediate_operand (operands[1], E_V8HImode)
              || !const_0_to_15_operand (operands[2], E_SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern14 (x3, 
E_V16SImode) != 0)
            return -1;
          return 9;

        case E_V8SImode:
          if (pattern14 (x3, 
E_V8SImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern14 (x3, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case E_V8DImode:
          if (pattern14 (x3, 
E_V8DImode) != 0)
            return -1;
          return 12;

        case E_V4DImode:
          if (pattern14 (x3, 
E_V4DImode) != 0)
            return -1;
          return 13;

        case E_V2DImode:
          if (pattern14 (x3, 
E_V2DImode) != 0)
            return -1;
          return 14;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_CONCAT
      || GET_MODE (x4) != E_V8HImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 4)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XVECEXP (x5, 0, 3);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x10 = XEXP (x2, 1);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_V4HImode)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != VEC_CONCAT
      || GET_MODE (x11) != E_V8HImode)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_CODE (x12) != PARALLEL
      || XVECLEN (x12, 0) != 4)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XVECEXP (x12, 0, 1);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x15 = XVECEXP (x12, 0, 2);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x16 = XVECEXP (x12, 0, 3);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x17 = XEXP (x1, 0);
  operands[0] = x17;
  if (!register_operand (operands[0], E_V4HImode)
      || pattern53 (x2) != 0)
    return -1;
  return 0;
}

int
pattern72 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XEXP (x1, 1);
      return pattern71 (x4, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XEXP (x1, 1);
      if (pattern71 (x4, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_CONCAT
      || GET_MODE (x3) != E_V8HImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XEXP (x1, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_V4HImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != VEC_CONCAT
      || GET_MODE (x10) != E_V8HImode)
    return -1;
  x11 = XEXP (x9, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 4)
    return -1;
  x12 = XVECEXP (x11, 0, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x11, 0, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x14 = XVECEXP (x11, 0, 2);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x15 = XVECEXP (x11, 0, 3);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || !register_operand (operands[0], E_V4HImode)
      || GET_MODE (x1) != E_V4HImode
      || pattern53 (x1) != 0)
    return -1;
  return 0;
}

int
pattern119 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || pattern41 (x1, 
E_SImode, 
E_DImode) != 0)
    return -1;
  return 0;
}

int
pattern125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern124 (x2, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern124 (x2, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern136 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern128 (x1, 
E_V16SImode, 
E_HImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern128 (x1, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern129 (x1, 
E_QImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8DImode:
      if (pattern128 (x1, 
E_V8DImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern128 (x1, 
E_V4DImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern128 (x1, 
E_V2DImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_V64QImode:
      if (pattern128 (x1, 
E_V64QImode, 
E_DImode) != 0)
        return -1;
      return 6;

    case E_V16QImode:
      if (pattern128 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_V32QImode:
      if (pattern128 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 8;

    case E_V32HImode:
      if (pattern128 (x1, 
E_V32HImode, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_V16HImode:
      if (pattern128 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_V8HImode:
      if (pattern129 (x1, 
E_QImode, 
E_V8HImode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern152 (x3, 
E_V64QImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern152 (x3, 
E_V32QImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern152 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern163 (x3, 
E_V64QImode, 
E_V32HFmode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern163 (x3, 
E_V32QImode, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern163 (x3, 
E_V16QImode, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern173 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8DImode:
      return pattern172 (x3, 
E_V8DImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern172 (x3, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern172 (x3, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V4HFmode:
          if (!const0_operand (operands[2], E_V4HFmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!vector_operand (operands[1], E_V4SImode))
                return -1;
              return 0;

            case E_V4DImode:
              if (!vector_operand (operands[1], E_V4DImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_V2HFmode:
          if (!vector_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V6HFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (pattern179 (x1, 
E_V2SFmode, 
E_V2DImode, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern192 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (XVECLEN (x4, 0))
    {
    case 8:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x14 = XVECEXP (x4, 0, 4);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x4, 0, 5);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x16 = XVECEXP (x4, 0, 6);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x17 = XVECEXP (x4, 0, 7);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x7, 0) != 8)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x22 = XVECEXP (x7, 0, 4);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x23 = XVECEXP (x7, 0, 5);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x24 = XVECEXP (x7, 0, 6);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x25 = XVECEXP (x7, 0, 7);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || pattern191 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 0;

    case 4:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x7, 0) != 4)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || pattern191 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case 2:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x7, 0) != 2)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || pattern191 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern222 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x2, 0);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern221 (x7, 
E_V8HFmode, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern221 (x7, 
E_V4SFmode, 
E_SFmode) != 0)
        return -1;
      return 1;

    case E_DFmode:
      if (pattern221 (x7, 
E_V2DFmode, 
E_DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern236 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern235 (x1, 
E_V4HImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern235 (x1, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern235 (x1, 
E_V2HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return pattern245 (x6); /* [-1, 1] */
}

int
pattern256 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!memory_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_V2DImode))
    return -1;
  return 0;
}

int
pattern262 (rtx x1, int *pnum_clobbers, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern268 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern274 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern279 (rtx x1, int *pnum_clobbers, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (!nonimmediate_operand (x3, i2))
    return -1;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], i1))
        return -1;
      operands[2] = x3;
      return 0;

    case ASHIFT:
      if (GET_MODE (x4) != i1)
        return -1;
      operands[1] = x3;
      res = pattern37 (x4, 
i1, 
i2);
      if (res >= 0)
        return res + 1; /* [1, 3] */
      return -1;

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[2] = x4;
      if (!const_scalar_int_operand (operands[2], i1))
        return -1;
      operands[1] = x3;
      return 4;

    default:
      return -1;
    }
}

int
pattern295 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V4QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 0;

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1, int i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern315 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern319 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !float_vector_all_ones_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern325 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !vector_operand (operands[1], i1))
        return -1;
      return 0;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !vector_operand (operands[1], i2))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !vector_operand (operands[1], i3))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  return 0;
}

int
pattern334 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x1, 1);
  return pattern333 (x7, 
i1, 
i2); /* [-1, 0] */
}

int
pattern338 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const1_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  return 0;
}

int
pattern345 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return pattern344 (x1); /* [-1, 5] */
}

int
pattern347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return 0;
}

int
pattern353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern355 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !x86_64_general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern365 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 110)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCNOmode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != i1)
    return -1;
  return pattern364 (x1, 
E_CCNOmode); /* [-1, 3] */
}

int
pattern371 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern375 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != ZERO_EXTRACT
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x6, 0);
  operands[0] = x10;
  if (!nonimmediate_operand (operands[0], E_DImode))
    return -1;
  x11 = XEXP (x6, 2);
  operands[1] = x11;
  if (!const_0_to_63_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern389 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x8 = XEXP (x2, 0);
  operands[2] = x8;
  if (!memory_operand (operands[2], E_DImode))
    return -1;
  x9 = XEXP (x3, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_V4SImode))
    return -1;
  return pattern388 (x6); /* [-1, 2] */
}

int
pattern403 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !const_scalar_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern410 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 147)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 147)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern416 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 7)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7)
    return -1;
  return 0;
}

int
pattern420 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x1, 0, 2);
  operands[4] = x6;
  if (!const_0_to_7_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern418 (x1); /* [-1, 1] */

    case E_QImode:
      if (pattern419 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern428 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern427 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern427 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern440 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !nonimmediate_operand (operands[4], E_DImode)
          || !const_0_to_63_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode)
          || !const_0_to_63_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !nonimmediate_operand (operands[4], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[3], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern458 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern457 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern457 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern457 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern468 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern471 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_operand (operands[1], i2)
      || !vector_operand (operands[2], i2)
      || !vector_operand (operands[3], i2))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern479 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  x7 = XEXP (x1, 2);
  operands[5] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern478 (x1, 
E_V32HImode, 
E_SImode); /* [-1, 0] */

    case E_V16SImode:
      if (pattern478 (x1, 
E_V16SImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern478 (x1, 
E_V8DImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_V16HImode:
      if (pattern478 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 3;

    case E_V8SImode:
      if (pattern478 (x1, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern478 (x1, 
E_V4DImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern478 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern478 (x1, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      return 7;

    case E_V2DImode:
      if (pattern478 (x1, 
E_V2DImode, 
E_QImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern495 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 0);
  switch (XVECLEN (x4, 0))
    {
    case 16:
      if (GET_MODE (x4) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x8 = XVECEXP (x4, 0, 3);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x9 = XVECEXP (x4, 0, 4);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x12 = XVECEXP (x4, 0, 7);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x13 = XVECEXP (x4, 0, 8);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x14 = XVECEXP (x4, 0, 9);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
        return -1;
      x15 = XVECEXP (x4, 0, 10);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
        return -1;
      x16 = XVECEXP (x4, 0, 11);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
        return -1;
      x17 = XVECEXP (x4, 0, 12);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
        return -1;
      x18 = XVECEXP (x4, 0, 13);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
        return -1;
      x19 = XVECEXP (x4, 0, 14);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
        return -1;
      x20 = XVECEXP (x4, 0, 15);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 23]
          || pattern494 (x1, 
E_V16QImode) != 0)
        return -1;
      return 0;

    case 8:
      if (GET_MODE (x4) != E_V8HImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x8 = XVECEXP (x4, 0, 3);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x9 = XVECEXP (x4, 0, 4);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x12 = XVECEXP (x4, 0, 7);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 11]
          || pattern494 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (XINT (x2, 1) != 151)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  switch (XVECLEN (x5, 0))
    {
    case 16:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x14 = XVECEXP (x5, 0, 8);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x5, 0, 9);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x16 = XVECEXP (x5, 0, 10);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x17 = XVECEXP (x5, 0, 11);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x18 = XVECEXP (x5, 0, 12);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x5, 0, 13);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x20 = XVECEXP (x5, 0, 14);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x21 = XVECEXP (x5, 0, 15);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          return pattern524 (x1, 
E_V32HImode, 
E_V16HImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern524 (x1, 
E_V32QImode, 
E_V16QImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 8:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern524 (x1, 
E_V16HImode, 
E_V8HImode) != 0)
            return -1;
          return 2;

        case E_V8SImode:
          if (pattern524 (x1, 
E_V16SImode, 
E_V8SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 32:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x14 = XVECEXP (x5, 0, 8);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x5, 0, 9);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x16 = XVECEXP (x5, 0, 10);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x17 = XVECEXP (x5, 0, 11);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x18 = XVECEXP (x5, 0, 12);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x5, 0, 13);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x20 = XVECEXP (x5, 0, 14);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x21 = XVECEXP (x5, 0, 15);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      x22 = XVECEXP (x5, 0, 16);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x23 = XVECEXP (x5, 0, 17);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
        return -1;
      x24 = XVECEXP (x5, 0, 18);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
        return -1;
      x25 = XVECEXP (x5, 0, 19);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
        return -1;
      x26 = XVECEXP (x5, 0, 20);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
        return -1;
      x27 = XVECEXP (x5, 0, 21);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
        return -1;
      x28 = XVECEXP (x5, 0, 22);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
        return -1;
      x29 = XVECEXP (x5, 0, 23);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
        return -1;
      x30 = XVECEXP (x5, 0, 24);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
        return -1;
      x31 = XVECEXP (x5, 0, 25);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
        return -1;
      x32 = XVECEXP (x5, 0, 26);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
        return -1;
      x33 = XVECEXP (x5, 0, 27);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
        return -1;
      x34 = XVECEXP (x5, 0, 28);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
        return -1;
      x35 = XVECEXP (x5, 0, 29);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
        return -1;
      x36 = XVECEXP (x5, 0, 30);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 30])
        return -1;
      x37 = XVECEXP (x5, 0, 31);
      if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || pattern524 (x1, 
E_V64QImode, 
E_V32QImode) != 0)
        return -1;
      return 4;

    case 4:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || pattern524 (x1, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern601 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_QImode)
      || !const_scalar_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern607 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern610 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern617 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern616 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern616 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern628 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern627 (x1, 
E_V16QImode, 
E_HImode, 
E_V16HFmode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern627 (x1, 
E_V32QImode, 
E_SImode, 
E_V32HFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern634 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x2;
      x3 = XEXP (x1, 2);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[5] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              return 0;

            case E_V16HFmode:
              return 1;

            case E_V8HFmode:
              return 2;

            case E_V16SFmode:
              return 3;

            case E_V8SFmode:
              return 4;

            case E_V4SFmode:
              return 5;

            case E_V8DFmode:
              return 6;

            case E_V4DFmode:
              return 7;

            case E_V2DFmode:
              return 8;

            case E_V32BFmode:
              return 9;

            case E_V16BFmode:
              return 10;

            case E_V8BFmode:
              return 11;

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x3, 0) != 1LL)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              return 12;

            case E_V2DFmode:
              return 13;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      res = pattern633 (x1);
      if (res >= 0)
        return res + 14; /* [14, 28] */
      return -1;

    default:
      return -1;
    }
}

int
pattern651 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !vector_operand (operands[2], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern657 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !vector_all_ones_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern661 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern663 (rtx x1, int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != i1)
    return -1;
  return 0;
}

int
pattern667 (rtx x1, int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern675 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!memory_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  switch (XVECLEN (x7, 0))
    {
    case 4:
      return pattern672 (x1, 
E_V16QImode, 
E_V4QImode); /* [-1, 1] */

    case 2:
      if (pattern673 (x1, 
E_V2HImode, 
E_V8HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern682 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x10 = XEXP (x4, 0);
  operands[1] = x10;
  x11 = XEXP (x4, 2);
  operands[2] = x11;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern694 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern691 (x5, 
E_TFmode); /* [-1, 0] */

    case E_HFmode:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern221 (x5, 
E_V8HFmode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_SFmode:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern221 (x5, 
E_V4SFmode, 
E_SFmode) != 0)
        return -1;
      return 2;

    case E_DFmode:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern221 (x5, 
E_V2DFmode, 
E_DFmode) != 0)
        return -1;
      return 3;

    case E_V2SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern692 (x5) != 0)
        return -1;
      return 4;

    case E_V2BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern693 (x5, 
E_V2BFmode) != 0)
        return -1;
      return 5;

    case E_V4BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern693 (x5, 
E_V4BFmode) != 0)
        return -1;
      return 6;

    case E_V2HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern693 (x5, 
E_V2HFmode) != 0)
        return -1;
      return 7;

    case E_V4HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern693 (x5, 
E_V4HFmode) != 0)
        return -1;
      return 8;

    case E_V32BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V32BFmode) != 0)
        return -1;
      return 9;

    case E_V16BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V16BFmode) != 0)
        return -1;
      return 10;

    case E_V8BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V8BFmode) != 0)
        return -1;
      return 11;

    case E_V32HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V32HFmode) != 0)
        return -1;
      return 12;

    case E_V16HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V16HFmode) != 0)
        return -1;
      return 13;

    case E_V8HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V8HFmode) != 0)
        return -1;
      return 14;

    case E_V16SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V16SFmode) != 0)
        return -1;
      return 15;

    case E_V8SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V8SFmode) != 0)
        return -1;
      return 16;

    case E_V4SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V4SFmode) != 0)
        return -1;
      return 17;

    case E_V8DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V8DFmode) != 0)
        return -1;
      return 18;

    case E_V4DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V4DFmode) != 0)
        return -1;
      return 19;

    case E_V2DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V2DFmode) != 0)
        return -1;
      return 20;

    default:
      return -1;
    }
}

int
pattern743 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !binary_fp_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern753 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x2, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern751 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern751 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern752 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern752 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern769 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!nonimmediate_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern776 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern783 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const0_or_m1_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern792 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern801 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!pmovzx_parallel (operands[4], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_CONCAT)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 1);
  x9 = XVECEXP (x8, 0, 0);
  operands[5] = x9;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || GET_MODE (x2) != E_V64QImode
          || GET_MODE (x3) != E_V32QImode
          || !const0_operand (operands[3], E_V32QImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !const0_operand (operands[2], E_V8HImode))
            return -1;
          return 0;

        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !const0_operand (operands[2], E_V4SImode))
            return -1;
          return 1;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V2DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || GET_MODE (x2) != E_V128QImode
          || GET_MODE (x3) != E_V64QImode
          || !const0_operand (operands[3], E_V64QImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !const0_operand (operands[2], E_V16HImode))
            return -1;
          return 3;

        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !const0_operand (operands[2], E_V8SImode))
            return -1;
          return 4;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !const0_operand (operands[2], E_V4DImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || GET_MODE (x2) != E_V32QImode
          || GET_MODE (x3) != E_V16QImode
          || !const0_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_V8HImode:
          if (!vector_operand (operands[1], E_V4HImode)
              || !const0_operand (operands[2], E_V4HImode))
            return -1;
          return 6;

        case E_V4SImode:
          if (!vector_operand (operands[1], E_V2SImode)
              || !const0_operand (operands[2], E_V2SImode))
            return -1;
          return 7;

        case E_V2DImode:
          if (!vector_operand (operands[1], E_DImode)
              || !const0_operand (operands[2], E_DImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || GET_MODE (x2) != E_V64HImode
          || GET_MODE (x3) != E_V32HImode
          || !const0_operand (operands[3], E_V32HImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_V64QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !const0_operand (operands[2], E_V32QImode))
            return -1;
          return 9;

        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !const0_operand (operands[2], E_V8SImode))
            return -1;
          return 10;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !const0_operand (operands[2], E_V4DImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || GET_MODE (x2) != E_V32HImode
          || GET_MODE (x3) != E_V16HImode
          || !const0_operand (operands[3], E_V16HImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !const0_operand (operands[2], E_V16QImode))
            return -1;
          return 12;

        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !const0_operand (operands[2], E_V4SImode))
            return -1;
          return 13;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V2DImode))
            return -1;
          return 14;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V16HImode
          || GET_MODE (x3) != E_V8HImode
          || !const0_operand (operands[3], E_V8HImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_V16QImode:
          if (!vector_operand (operands[1], E_V8QImode)
              || !const0_operand (operands[2], E_V8QImode))
            return -1;
          return 15;

        case E_V4SImode:
          if (!vector_operand (operands[1], E_V2SImode)
              || !const0_operand (operands[2], E_V2SImode))
            return -1;
          return 16;

        case E_V2DImode:
          if (!vector_operand (operands[1], E_DImode)
              || !const0_operand (operands[2], E_DImode))
            return -1;
          return 17;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern879 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern893 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (XVECLEN (x4, 0))
    {
    case 8:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x8 = XVECEXP (x4, 0, 3);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x9 = XVECEXP (x4, 0, 4);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x12 = XVECEXP (x4, 0, 7);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern137 (x1, 
E_V8HImode); /* [-1, 0] */

        case E_V8SImode:
          if (pattern137 (x1, 
E_V8SImode) != 0)
            return -1;
          return 1;

        case E_V8DImode:
          if (pattern137 (x1, 
E_V8DImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x8 = XVECEXP (x4, 0, 3);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          res = pattern892 (x1, 
E_V4SImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        case E_V4DImode:
          res = pattern892 (x1, 
E_V4DImode);
          if (res >= 0)
            return res + 5; /* [5, 6] */
          return -1;

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2DImode
          || !nonimm_or_0_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V2QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 7;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 8;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern932 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern930 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern930 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern931 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern931 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern944 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern943 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_TImode:
      if (pattern943 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern952 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!general_reg_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x3, 1);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  x8 = XEXP (x5, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = PATTERN (peep2_next_insn (3));
  return pattern951 (x9, 
i1); /* [-1, 0] */
}

int
pattern959 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern963 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  if (XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern965 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_HFmode)
      || GET_MODE (x1) != E_HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HFmode:
      if (!nonimmediate_operand (operands[1], E_V32HFmode))
        return -1;
      return 0;

    case E_V16HFmode:
      if (!nonimmediate_operand (operands[1], E_V16HFmode))
        return -1;
      return 1;

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern968 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HFmode:
      return pattern273 (x1, 
E_V2HFmode, 
E_V4HFmode); /* [-1, 0] */

    case E_V2BFmode:
      if (pattern273 (x1, 
E_V2BFmode, 
E_V4BFmode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern273 (x1, 
E_V2HImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern976 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_DImode
          || !nonimm_or_0_operand (operands[1], E_V64QImode)
          || !nonimm_or_0_operand (operands[2], E_V64QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!nonimm_or_0_operand (operands[1], E_V32QImode)
              || !nonimm_or_0_operand (operands[2], E_V32QImode))
            return -1;
          return 1;

        case E_V32HImode:
          if (!nonimm_or_0_operand (operands[1], E_V32HImode)
              || !nonimm_or_0_operand (operands[2], E_V32HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern989 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 2);
  if (!register_operand (x3, i1))
    return -1;
  return 0;
}

int
pattern998 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern997 (x1, 
E_V8HImode, 
E_HImode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern997 (x1, 
E_V8HFmode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_V8BFmode:
      if (pattern997 (x1, 
E_V8BFmode, 
E_BFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1010 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V16SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1022 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1026 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || GET_MODE (x2) != E_V2QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != E_V16QImode)
    return -1;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  x10 = XEXP (x7, 1);
  operands[2] = x10;
  switch (GET_MODE (x7))
    {
    case E_V8HImode:
      if (GET_MODE (x8) != E_V8HImode
          || !nonimmediate_operand (operands[1], E_HImode)
          || !const0_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (GET_MODE (x8) != E_V8HFmode
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !const0_operand (operands[2], E_V8HFmode))
        return -1;
      return 1;

    case E_V8BFmode:
      if (GET_MODE (x8) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_BFmode)
          || !const0_operand (operands[2], E_V8BFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1041 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1045 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2SFmode)
      || GET_MODE (x1) != E_V2SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode
      || !register_operand (operands[1], E_V2SFmode)
      || !nonimmediate_operand (operands[2], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern1050 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_CODE (x3))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x3), 0))
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern371 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern371 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern371 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern371 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1075 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (maybe_ne (SUBREG_BYTE (x1), 0))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case VEC_MERGE:
      x3 = XEXP (x2, 2);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 3
          || XINT (x3, 1) != 59
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      switch (GET_MODE (x1))
        {
        case E_V8SFmode:
          return pattern1074 (x2, 
E_V8SImode); /* [-1, 0] */

        case E_V4SFmode:
          if (pattern1074 (x2, 
E_V4SImode) != 0)
            return -1;
          return 1;

        case E_V4DFmode:
          if (pattern1074 (x2, 
E_V4DImode) != 0)
            return -1;
          return 2;

        case E_V2DFmode:
          if (pattern1074 (x2, 
E_V2DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x1))
        {
        case E_V8SFmode:
          if (GET_MODE (x2) != E_V8SImode
              || !register_operand (operands[1], E_V8SImode))
            return -1;
          return 4;

        case E_V4SFmode:
          if (GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode))
            return -1;
          return 5;

        case E_V4DFmode:
          if (GET_MODE (x2) != E_V4DImode
              || !register_operand (operands[1], E_V4DImode))
            return -1;
          return 6;

        case E_V2DFmode:
          if (GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1099 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1107 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !avx2_pblendw_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern1114 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4
      || !nonimmediate_operand (operands[2], i3))
    return -1;
  x4 = XEXP (x2, 1);
  return pattern1113 (x4, 
i1, 
i2, 
i3, 
i4); /* [-1, 0] */
}

int
pattern1120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1126 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 2);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1141 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 19
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern1146 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1153 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  return pattern1152 (x3); /* [-1, 2] */
}

int
pattern1160 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  return pattern1159 (x6, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1167 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x2), 0)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      return pattern1156 (x1); /* [-1, 11] */

    case CONST_INT:
      return 12;

    default:
      return -1;
    }
}

int
pattern1175 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !regmem_or_bitnot_regmem_operand (operands[1], i1)
      || !regmem_or_bitnot_regmem_operand (operands[2], i1)
      || !regmem_or_bitnot_regmem_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[4] = x4;
  if (!regmem_or_bitnot_regmem_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1184 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_gr_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 40
      || GET_MODE (x3) != E_CCCmode)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != NEG
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x3, 0, 0);
  operands[2] = x8;
  if (!general_reg_operand (operands[2], i1))
    return -1;
  x9 = XEXP (x7, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = PATTERN (peep2_next_insn (2));
  return pattern1183 (x11, 
i1); /* [-1, 0] */
}

int
pattern1199 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const48_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern1205 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern1205 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern1205 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern1205 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern1205 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern1205 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern1205 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern1205 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern1205 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern1219 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern1224 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern1226 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1231 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !vector_all_ones_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1239 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCZmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != IF_THEN_ELSE)
    return -1;
  x8 = XEXP (x7, 0);
  if (!bt_comparison_operator (x8, E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1250 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x1, 0);
  switch (GET_CODE (x9))
    {
    case STRICT_LOW_PART:
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return pattern1249 (); /* [-1, 2] */

    case REG:
    case SUBREG:
      operands[0] = x9;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      res = pattern1249 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1267 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1276 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1285 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1292 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || GET_MODE (x2) != i2
      || !register_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1)
      || !const_4_or_8_to_11_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern1298 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1302 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1308 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  switch (GET_MODE (x8))
    {
    case E_QImode:
      return pattern1307 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1307 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1307 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !const_1_to_63_operand (operands[2], E_QImode)
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1328 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!general_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  x5 = XEXP (x4, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern1335 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  if (!general_reg_operand (operands[0], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      switch (GET_CODE (x2))
        {
        case CONST_INT:
          if (XWINT (x2, 0) != 0LL)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != ZERO_EXTRACT)
            return -1;
          x4 = XEXP (x3, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x5 = XEXP (x3, 2);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!int248_register_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_HImode:
              return 0;

            case E_SImode:
              return 1;

            case E_DImode:
              return 2;

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x2;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != STRICT_LOW_PART)
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          res = pattern1327 ();
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        default:
          return -1;
        }

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      switch (GET_CODE (x8))
        {
        case PLUS:
          if (GET_MODE (x8) != i1
              || pattern1330 (x1) != 0)
            return -1;
          return 5;

        case IOR:
          if (GET_MODE (x8) != i1
              || pattern1330 (x1) != 0)
            return -1;
          return 6;

        case XOR:
          if (GET_MODE (x8) != i1
              || pattern1330 (x1) != 0)
            return -1;
          return 7;

        case UNSPEC:
          if (peep2_current_count < 3
              || peep2_current_count < 4
              || XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 40
              || GET_MODE (x8) != E_CCCmode)
            return -1;
          x9 = XVECEXP (x8, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x7, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 17
              || GET_MODE (x10) != E_CCCmode)
            return -1;
          x11 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x11) != SET)
            return -1;
          x12 = XEXP (x11, 1);
          if (GET_CODE (x12) != NEG
              || GET_MODE (x12) != i1)
            return -1;
          x13 = XVECEXP (x8, 0, 0);
          operands[1] = x13;
          if (!general_reg_operand (operands[1], i1))
            return -1;
          x14 = XEXP (x12, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x11, 0);
          if (!rtx_equal_p (x15, operands[1]))
            return -1;
          x16 = PATTERN (peep2_next_insn (2));
          if (pattern1183 (x16, 
i1) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1394 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[4] = x3;
      x4 = XVECEXP (x1, 0, 1);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return 0;

        case E_V16SFmode:
          return 1;

        case E_V8DFmode:
          return 2;

        case E_V16HFmode:
          return 3;

        case E_V8HFmode:
          return 4;

        case E_V8SFmode:
          return 5;

        case E_V4SFmode:
          return 6;

        case E_V4DFmode:
          return 7;

        case E_V2DFmode:
          return 8;

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1LL)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      operands[4] = x4;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 9;

        case E_V4SFmode:
          return 10;

        case E_V2DFmode:
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1415 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1422 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1427 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1433 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1440 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1)
      || !const0_operand (operands[5], i1)
      || !register_operand (operands[6], i2))
    return -1;
  return 0;
}

int
pattern1449 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1458 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1465 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1472 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1479 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1484 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x7, 1);
  operands[3] = x9;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[1] = x10;
  return pattern1483 (x1); /* [-1, 1] */
}

int
pattern1496 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1505 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !vector_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i2
      || !vector_operand (operands[2], i1)
      || !const1_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1518 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1525 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1535 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x1, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x9, 1);
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x13, 1);
  if (GET_MODE (x15) != i1)
    return -1;
  return 0;
}

int
pattern1547 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1555 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x9, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1554 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1554 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1568 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1577 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern1588 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1587 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1587 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1599 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1608 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1615 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern1552 (x6, pnum_clobbers); /* [-1, 2] */
}

int
pattern1625 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i3)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i3
      || !vector_operand (operands[1], i2))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i3
      || !vector_operand (operands[2], i2)
      || !const1_operand (operands[3], i2)
      || !nonimm_or_0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1640 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1648 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !addsub_vs_operator (operands[7], i1)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1659 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MINUS)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LTU:
    case UNLT:
      operands[5] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 0;

    default:
      return -1;
    }
}

int
pattern1669 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1679 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 2);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[3]))
    return -1;
  x8 = XEXP (x1, 1);
  if (!rtx_equal_p (x8, operands[3]))
    return -1;
  return 0;
}

int
pattern1689 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vsib_mem_operator (operands[6], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1694 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1693 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1693 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1707 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1706 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1706 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1718 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1725 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1724 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1724 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1736 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCZmode)
    return -1;
  return 0;
}

int
pattern1747 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1756 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1755 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1755 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1768 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1775 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1774 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1774 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1788 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != 109)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 109)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != UNSPEC_VOLATILE
      || XVECLEN (x8, 0) != 1
      || XINT (x8, 1) != 109
      || GET_MODE (x8) != E_CCZmode)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x7, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 17
      || GET_MODE (x10) != E_CCZmode)
    return -1;
  x11 = XEXP (x2, 0);
  operands[2] = x11;
  x12 = XVECEXP (x3, 0, 0);
  operands[3] = x12;
  x13 = XVECEXP (x3, 0, 2);
  operands[4] = x13;
  x14 = XVECEXP (x3, 0, 3);
  operands[5] = x14;
  if (!const_int_operand (operands[5], E_SImode))
    return -1;
  x15 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x4, 0);
  if (!rtx_equal_p (x16, operands[3]))
    return -1;
  x17 = PATTERN (peep2_next_insn (2));
  x18 = XEXP (x17, 1);
  x19 = XEXP (x18, 0);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  x20 = XEXP (x18, 1);
  if (!rtx_equal_p (x20, operands[1]))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      return pattern1787 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1787 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1787 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1787 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1817 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !register_operand (operands[4], E_V8SFmode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !register_operand (operands[4], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1824 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2
      || !ix86_carry_flag_operator (operands[4], i2)
      || !const_scalar_int_operand (operands[6], i2)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !ix86_carry_flag_operator (operands[5], i1)
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1835 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_15_operand (operands[2], E_VOIDmode)
      || !const_0_to_15_operand (operands[3], E_VOIDmode)
      || !const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode)
      || !const_0_to_15_operand (operands[6], E_VOIDmode)
      || !const_0_to_15_operand (operands[7], E_VOIDmode)
      || !const_0_to_15_operand (operands[8], E_VOIDmode)
      || !const_0_to_15_operand (operands[9], E_VOIDmode)
      || !const_0_to_15_operand (operands[10], E_VOIDmode)
      || !const_0_to_15_operand (operands[11], E_VOIDmode)
      || !const_0_to_15_operand (operands[12], E_VOIDmode)
      || !const_0_to_15_operand (operands[13], E_VOIDmode)
      || !const_0_to_15_operand (operands[14], E_VOIDmode)
      || !const_0_to_15_operand (operands[15], E_VOIDmode)
      || !const_0_to_15_operand (operands[16], E_VOIDmode)
      || !const_0_to_15_operand (operands[17], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1843 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 28);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 29);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 30);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 31);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1848 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  x4 = PATTERN (peep2_next_insn (4));
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  return 0;
}

int
pattern1855 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || pattern1853 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1863 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case COMPARE:
      if (GET_MODE (x6) != E_CCmode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MINUS)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 1
          || XINT (x9, 1) != 109
          || GET_MODE (x9) != E_CCmode)
        return -1;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      if (!flags_reg_operand (operands[0], E_CCmode)
          || GET_MODE (x2) != E_CCmode
          || !comparison_operator (operands[1], E_VOIDmode)
          || GET_MODE (x4) != E_CCmode)
        return -1;
      x11 = XEXP (x7, 0);
      operands[2] = x11;
      x12 = XEXP (x7, 1);
      operands[3] = x12;
      x13 = XVECEXP (x9, 0, 0);
      operands[4] = x13;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (x7))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[2], E_QImode)
              || !general_operand (operands[3], E_QImode)
              || !
#line 1539 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 1; /* ccmpqi */

        case E_HImode:
          if (!nonimmediate_operand (operands[2], E_HImode)
              || !general_operand (operands[3], E_HImode)
              || !
#line 1539 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 2; /* ccmphi */

        case E_SImode:
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !x86_64_general_operand (operands[3], E_SImode)
              || !
#line 1539 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 3; /* ccmpsi */

        case E_DImode:
          if (!nonimmediate_operand (operands[2], E_DImode)
              || !x86_64_general_operand (operands[3], E_DImode)
              || !(
#line 1539 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_CCMP) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 4; /* ccmpdi */

        default:
          return -1;
        }

    case LABEL_REF:
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != PC)
        return -1;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != PC
          || !ix86_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      return 1458; /* *jcc */

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x6;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern1185 (x2, 
E_HImode) != 0
              || !
#line 26339 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1803; /* *movhicc_noc */

        case E_QImode:
          if (pattern1186 (x2) != 0
              || !
#line 26413 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL))
            return -1;
          return 1808; /* *movqicc_noc */

        case E_XFmode:
          if (!register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode
              || !fcmov_comparison_operator (operands[1], E_VOIDmode)
              || !register_operand (operands[2], E_XFmode)
              || !register_operand (operands[3], E_XFmode)
              || !
#line 26607 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE))
            return -1;
          return 1810; /* *movxfcc_1 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || pattern1243 (x2, 
E_DFmode) != 0
              || !
#line 26622 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1811; /* *movdfcc_1 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || pattern1243 (x2, 
E_SFmode) != 0
              || !
#line 26657 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1812; /* *movsfcc_1_387 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 24:
      return recog_7 (x1, insn, pnum_clobbers);

    case 25:
      if (pattern55 (x1, 
E_HImode) != 0
          || !
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SAHF))
        return -1;
      return 47; /* x86_sahf_1 */

    case 26:
      return recog_6 (x1, insn, pnum_clobbers);

    case 44:
      if (GET_MODE (x2) != E_CCFPmode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != COMPARE
          || GET_MODE (x3) != E_CCFPmode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 17
          || GET_MODE (x4) != E_CCFPmode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !nonimmediate_operand (operands[1], E_SFmode)
              || !
#line 2045 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX10_2))
            return -1;
          return 50; /* *cmpxsf */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || !nonimmediate_operand (operands[1], E_DFmode)
              || !
#line 2045 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX10_2))
            return -1;
          return 52; /* *cmpxdf */

        case E_HFmode:
          if (!register_operand (operands[0], E_HFmode)
              || !nonimmediate_operand (operands[1], E_HFmode)
              || !
#line 2058 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX10_2))
            return -1;
          return 54; /* *cmpxhf */

        default:
          return -1;
        }

    case 41:
      if (pattern57 (x1, 
E_CCCmode) != 0)
        return -1;
      return 63; /* x86_stc */

    case 42:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!flags_reg_operand (operands[1], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!push_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_CC) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)))
            return -1;
          return 80; /* pushflsi2 */

        case E_DImode:
          if (!push_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !(
#line 2323 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_CC) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)))
            return -1;
          return 81; /* pushfldi2 */

        default:
          return -1;
        }

    case 43:
      if (GET_MODE (x2) != E_CCmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!flags_reg_operand (operands[0], E_CCmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!pop_operand (operands[1], E_SImode)
              || !
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode))
            return -1;
          return 82; /* popflsi1 */

        case E_DImode:
          if (!pop_operand (operands[1], E_DImode)
              || !
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode))
            return -1;
          return 83; /* popfldi1 */

        default:
          return -1;
        }

    case 60:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_BFmode)
          || !
#line 5471 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SSE2))
        return -1;
      return 203; /* extendbfsf2_1 */

    case 28:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_HImode)
          || !
#line 6045 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387))
        return -1;
      return 238; /* x86_fnstcw_1 */

    case 97:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      if ((
#line 21738 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21648 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI)))
        return 1562; /* tzcnt_hi_nf */
      if (pnum_clobbers == NULL
          || !(
#line 21738 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(true) && 
#line 21648 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI)))
        return -1;
      *pnum_clobbers = 1;
      return 1563; /* tzcnt_hi */

    case 96:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      if ((
#line 21738 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21649 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
        return 1564; /* lzcnt_hi_nf */
      if (pnum_clobbers == NULL
          || !(
#line 21738 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(true) && 
#line 21649 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
        return -1;
      *pnum_clobbers = 1;
      return 1565; /* lzcnt_hi */

    case 27:
      if (pattern55 (x1, 
E_QImode) != 0)
        return -1;
      return 1648; /* parityqi2_cmp */

    case 54:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 23475 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SSE && TARGET_SSE_MATH))
            return -1;
          return 1680; /* *rcpsf2_sse */

        case 1:
          if (!
#line 23501 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1681; /* rcphf2 */

        default:
          return -1;
        }

    case 31:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !
#line 23718 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1706; /* truncxfsf2_i387_noop_unspec */

        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !
#line 23718 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1707; /* truncxfdf2_i387_noop_unspec */

        default:
          return -1;
        }

    case 55:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 23738 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SSE))
            return -1;
          return 1709; /* *rsqrtsf2_sse */

        case 1:
          if (!
#line 23774 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1710; /* rsqrthf2 */

        default:
          return -1;
        }

    case 64:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24041 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1717; /* sinxf2 */

    case 65:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24041 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1718; /* cosxf2 */

    case 71:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24667 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1725; /* *f2xm1xf2_i387 */

    case 69:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 25001 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
        return -1;
      return 1732; /* rintxf2 */

    case 70:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!nonimmediate_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 25142 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
        return -1;
      return 1734; /* lrintxfhi2 */

    case 74:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25232 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1736; /* frndintxf2_roundeven */

    case 75:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25232 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1737; /* frndintxf2_floor */

    case 76:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25232 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1738; /* frndintxf2_ceil */

    case 77:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25232 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1739; /* frndintxf2_trunc */

    case 78:
      if (pattern60 (x1, pnum_clobbers) != 0
          || !
#line 25349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1744; /* *fisthi2_floor_1 */

    case 79:
      if (pattern60 (x1, pnum_clobbers) != 0
          || !
#line 25349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1745; /* *fisthi2_ceil_1 */

    case 73:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 25451 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1756; /* fxamsf2_i387 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 25451 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1757; /* fxamdf2_i387 */

        case E_XFmode:
          if (!register_operand (operands[1], E_XFmode)
              || !
#line 25451 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1758; /* fxamxf2_i387 */

        default:
          return -1;
        }

    case 112:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_V2SFmode)
          || !
#line 900 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2059; /* mmx_rcpv2sf2 */

    case 115:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_V2SFmode)
          || !
#line 948 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2062; /* mmx_rsqrtv2sf2 */

    case 172:
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 8441 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
            return -1;
          return 4717; /* unspec_sse_cvttps2pi */

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !
#line 8905 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 4827; /* unspec_sse2_cvttpd2pi */

        default:
          return -1;
        }

    case 46:
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!vector_operand (operands[1], E_V2DFmode)
          || !
#line 8887 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 4826; /* sse2_cvtpd2pi */

    case 173:
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_V2DFmode)
          || !
#line 8946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_MMX_WITH_SSE && TARGET_AVX512VL))
        return -1;
      return 4829; /* unspec_fixuns_truncv2dfv2si2 */

    case 191:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 10246 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5100; /* avx512vl_cvtb2maskv16qi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 10246 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5103; /* avx512vl_cvtw2maskv16hi */

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !(
#line 10256 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5105; /* avx512f_cvtd2maskv16si */

            default:
              return -1;
            }

        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 10246 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5104; /* avx512vl_cvtw2maskv8hi */

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !(
#line 10256 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5106; /* avx512vl_cvtd2maskv8si */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !(
#line 10256 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5107; /* avx512vl_cvtd2maskv4si */

            case E_V8DImode:
              if (!register_operand (operands[1], E_V8DImode)
                  || !(
#line 10256 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5108; /* avx512f_cvtq2maskv8di */

            case E_V4DImode:
              if (!register_operand (operands[1], E_V4DImode)
                  || !(
#line 10256 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5109; /* avx512vl_cvtq2maskv4di */

            case E_V2DImode:
              if (!register_operand (operands[1], E_V2DImode)
                  || !(
#line 10256 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5110; /* avx512vl_cvtq2maskv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 117:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!memory_operand (operands[0], E_SFmode)
                  || GET_MODE (x2) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !
#line 23402 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4A))
                return -1;
              return 8598; /* sse4a_movntsf */

            case E_DFmode:
              if (!memory_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 23402 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4A))
                return -1;
              return 8599; /* sse4a_movntdf */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XVECEXP (x6, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern1059 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 23414 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4A))
                return -1;
              return 8600; /* sse4a_vmmovntv4sf */

            case E_DFmode:
              if (pattern1059 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 23414 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4A) && 
#line 474 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8601; /* sse4a_vmmovntv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 136:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nonimmediate_operand (operands[1], E_SFmode)
              || !
#line 26982 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8980; /* xop_frczsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !nonimmediate_operand (operands[1], E_DFmode)
              || !
#line 26982 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8981; /* xop_frczdf2 */

        default:
          return -1;
        }

    case 283:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!memory_operand (operands[1], E_DImode)
          || !
#line 346 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_80387))
        return -1;
      return 10912; /* loaddi_via_fpu */

    case 285:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!memory_operand (operands[1], E_DImode)
          || !
#line 369 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_SSE))
        return -1;
      return 10914; /* loaddi_via_sse */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern264 (x3, 
E_SImode))
        {
        case 0:
          if (!
#line 5769 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 213; /* fixuns_trunchfsi2 */

        case 1:
          if (!
#line 5876 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512F && TARGET_SSE_MATH))
            return -1;
          return 218; /* fixuns_truncsfsi2_avx512f */

        case 2:
          if (!
#line 5876 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512F && TARGET_SSE_MATH))
            return -1;
          return 219; /* fixuns_truncdfsi2_avx512f */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern264 (x3, 
E_DImode))
        {
        case 0:
          if (!(
#line 5769 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 215; /* fixuns_trunchfdi2 */

        case 1:
          if (!
#line 5834 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_AVX512F && TARGET_SSE_MATH))
            return -1;
          return 216; /* fixuns_truncsfdi2 */

        case 2:
          if (!
#line 5834 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_AVX512F && TARGET_SSE_MATH))
            return -1;
          return 217; /* fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !nonimmediate_operand (operands[1], E_V2DFmode)
          || !
#line 8956 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_MMX_WITH_SSE && TARGET_AVX512VL))
        return -1;
      return 4830; /* fixuns_truncv2dfv2si2 */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pnum_clobbers == NULL
          || pattern735 (x2, 
E_TImode) != 0)
        return -1;
      if ((
#line 13314 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 810; /* *andnti3_doubleword_bmi */
        }
      if (!(
#line 13332 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 812; /* *andnti3_doubleword */

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern607 (x2, 
E_QImode) != 0
          || !
#line 13364 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
        return -1;
      *pnum_clobbers = 1;
      return 815; /* *andnqi_1 */

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern607 (x2, 
E_HImode) != 0
          || !
#line 13364 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
        return -1;
      *pnum_clobbers = 1;
      return 816; /* *andnhi_1 */

    case E_V2SFmode:
      if (pattern607 (x2, 
E_V2SFmode) != 0
          || !
#line 1343 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
        return -1;
      return 2076; /* *mmx_andnotv2sf3 */

    case E_V2BFmode:
      if (pattern607 (x2, 
E_V2BFmode) != 0
          || !
#line 2568 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE))
        return -1;
      return 2107; /* *mmx_andnotv2bf3 */

    case E_V4BFmode:
      if (pattern607 (x2, 
E_V4BFmode) != 0
          || !(
#line 2568 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2224 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
        return -1;
      return 2108; /* *mmx_andnotv4bf3 */

    case E_V2HFmode:
      if (pattern607 (x2, 
E_V2HFmode) != 0
          || !
#line 2568 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE))
        return -1;
      return 2109; /* *mmx_andnotv2hf3 */

    case E_V4HFmode:
      if (pattern607 (x2, 
E_V4HFmode) != 0
          || !(
#line 2568 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
        return -1;
      return 2110; /* *mmx_andnotv4hf3 */

    case E_V8QImode:
      if (pattern608 (x2, 
E_V8QImode) != 0
          || !
#line 4592 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
        return -1;
      return 2268; /* mmx_andnotv8qi3 */

    case E_V4HImode:
      if (pattern608 (x2, 
E_V4HImode) != 0
          || !
#line 4592 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
        return -1;
      return 2269; /* mmx_andnotv4hi3 */

    case E_V2SImode:
      if (pattern608 (x2, 
E_V2SImode) != 0
          || !
#line 4592 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
        return -1;
      return 2270; /* mmx_andnotv2si3 */

    case E_V4QImode:
      if (pnum_clobbers == NULL
          || pattern607 (x2, 
E_V4QImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2271; /* *andnotv4qi3 */

    case E_V2QImode:
      if (pnum_clobbers == NULL
          || pattern607 (x2, 
E_V2QImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2272; /* *andnotv2qi3 */

    case E_V2HImode:
      if (pnum_clobbers == NULL
          || pattern607 (x2, 
E_V2HImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2273; /* *andnotv2hi3 */

    case E_BFmode:
      if (pattern607 (x2, 
E_BFmode) != 0
          || !
#line 5535 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 3739; /* *andnotbf3 */

    case E_HFmode:
      if (pattern607 (x2, 
E_HFmode) != 0
          || !
#line 5535 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 3740; /* *andnothf3 */

    case E_SFmode:
      if (pattern607 (x2, 
E_SFmode) != 0
          || !
#line 5535 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 3741; /* *andnotsf3 */

    case E_DFmode:
      if (pattern607 (x2, 
E_DFmode) != 0
          || !(
#line 5535 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1352 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SSE2)))
        return -1;
      return 3742; /* *andnotdf3 */

    case E_TFmode:
      if (pattern609 (x2, 
E_TFmode) != 0
          || !
#line 5605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 3743; /* *andnottf3 */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pattern267 (x3, pnum_clobbers, 
E_TImode) != 0
          || !(
#line 14602 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 996; /* *absti2_doubleword */

    case E_QImode:
      if (pattern267 (x3, pnum_clobbers, 
E_QImode) != 0
          || !
#line 14689 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 999; /* *absqi2_1 */

    case E_HImode:
      if (pattern267 (x3, pnum_clobbers, 
E_HImode) != 0
          || !
#line 14689 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1000; /* *abshi2_1 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      if (pnum_clobbers != NULL
          && 
#line 14812 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 1010; /* *abssf2_i387_1 */
        }
      if (!
#line 14934 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
        return -1;
      return 1024; /* *abssf2_i387 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      if (pnum_clobbers != NULL
          && 
#line 14812 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 1012; /* *absdf2_i387_1 */
        }
      if (!
#line 14934 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
        return -1;
      return 1026; /* *absdf2_i387 */

    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || GET_MODE (x3) != E_XFmode
          || !register_operand (operands[1], E_XFmode))
        return -1;
      if (pnum_clobbers != NULL
          && 
#line 14812 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 1014; /* *absxf2_i387_1 */
        }
      if (!
#line 14934 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
        return -1;
      return 1028; /* *absxf2_i387 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_mmxmem_operand (operands[1], E_V8QImode)
          || !
#line 3814 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 2192; /* ssse3_absv8qi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_mmxmem_operand (operands[1], E_V4HImode)
          || !
#line 3814 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 2193; /* ssse3_absv4hi2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_mmxmem_operand (operands[1], E_V2SImode)
          || !
#line 3814 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 2194; /* ssse3_absv2si2 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !
#line 3835 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSSE3))
        return -1;
      return 2195; /* absv4qi2 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !
#line 3835 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSSE3))
        return -1;
      return 2196; /* absv2qi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !
#line 3835 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSSE3))
        return -1;
      return 2197; /* absv2hi2 */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 18192 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1293; /* *rotrqi3_mask_1 */

    case 1:
      if (!
#line 18192 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1295; /* *rotrhi3_mask_1 */

    case 2:
      if (!
#line 18273 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1309; /* *rotrqi3_add_1 */

    case 3:
      if (!
#line 18273 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1311; /* *rotrhi3_add_1 */

    case 4:
      if (!
#line 18342 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1325; /* *rotrqi3_sub_1 */

    case 5:
      if (!
#line 18342 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1327; /* *rotrhi3_sub_1 */

    case 6:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (pattern269 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 18144 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1285; /* *rotrqi3_mask */
            }
          break;

        case 1:
          if (
#line 18144 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1287; /* *rotrhi3_mask */
            }
          break;

        case 2:
          if (
#line 18237 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1301; /* *rotrqi3_add */
            }
          break;

        case 3:
          if (
#line 18237 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1303; /* *rotrhi3_add */
            }
          break;

        case 4:
          if (
#line 18306 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1317; /* *rotrqi3_sub */
            }
          break;

        case 5:
          if (
#line 18306 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1319; /* *rotrhi3_sub */
            }
          break;

        case 6:
          if (pnum_clobbers != NULL
              && pattern612 (x3) == 0
              && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            {
              *pnum_clobbers = 2;
              return 1335; /* ix86_rotrti3_doubleword */
            }
          x4 = XEXP (x3, 1);
          if (XWINT (x4, 0) == 64LL
              && register_operand (operands[0], E_TImode)
              && GET_MODE (x3) == E_TImode
              && register_operand (operands[1], E_TImode)
              && 
#line 18465 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return 1339; /* rotr64ti2_doubleword */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      switch (pattern270 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 18679 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1375; /* *rotrqi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18679 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1376; /* *rotrqi3_1 */

        case 1:
          if (
#line 18679 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1379; /* *rotrhi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18679 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1380; /* *rotrhi3_1 */

        case 2:
          if (!
#line 18710 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 1382; /* *rotrqi3_1_slp */

        case 3:
          if (!
#line 18710 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 1384; /* *rotrhi3_1_slp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      res = recog_53 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!int248_register_operand (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x1, 0);
          switch (GET_CODE (x8))
            {
            case STRICT_LOW_PART:
              x9 = XEXP (x8, 0);
              operands[0] = x9;
              if (!register_operand (operands[0], E_QImode))
                return -1;
              switch (pattern1677 ())
                {
                case 0:
                  if (!
#line 8215 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 405; /* *subqi_exthi_1_slp */

                case 1:
                  if (!
#line 8215 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 406; /* *subqi_extsi_1_slp */

                case 2:
                  if (!(
#line 8215 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 407; /* *subqi_extdi_1_slp */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              operands[0] = x8;
              if (!nonimmediate_operand (operands[0], E_QImode))
                return -1;
              switch (pattern1677 ())
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 416; /* *subqi_exthi_0 */

                case 1:
                  *pnum_clobbers = 1;
                  return 417; /* *subqi_extsi_0 */

                case 2:
                  if (!
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 418; /* *subqi_extdi_0 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_TImode)
        return -1;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      if (pattern754 (x2, 
E_DImode, 
E_TImode) != 0
          || !(
#line 8103 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 383; /* *subti3_doubleword_zext */

    case LTU:
    case UNLT:
      switch (pattern433 (x1, pnum_clobbers))
        {
        case 0:
          if (pattern1192 (x2, 
E_QImode) != 0
              || !
#line 9349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 491; /* *subqi3_carry_0 */

        case 1:
          if (pattern1192 (x2, 
E_HImode) != 0
              || !
#line 9349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 492; /* *subhi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern433 (x1, pnum_clobbers))
        {
        case 0:
          if (pattern1193 (x2, 
E_QImode) != 0
              || !
#line 9363 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 495; /* *subqi3_carry_0r */

        case 1:
          if (pattern1193 (x2, 
E_HImode) != 0
              || !
#line 9363 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 496; /* *subhi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern435 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 10307 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 582; /* *subqi3_eq_0 */

        case 1:
          if (!
#line 10307 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 583; /* *subhi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern435 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 10328 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 586; /* *subqi3_ne_0 */

        case 1:
          if (!
#line 10328 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 587; /* *subhi3_ne_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_61 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      switch (pattern275 (x2))
        {
        case 0:
          x6 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x6) == CONST_INT)
            {
              switch (pattern967 (x2))
                {
                case 0:
                  if (
#line 1691 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                    return 2087; /* *vec_interleave_lowv2sf */
                  break;

                case 1:
                  if (
#line 4991 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                    return 2303; /* mmx_punpckldq */
                  break;

                case 2:
                  if (
#line 1708 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                    return 2088; /* *vec_interleave_highv2sf */
                  break;

                case 3:
                  if (
#line 4970 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                    return 2302; /* mmx_punpckhdq */
                  break;

                default:
                  break;
                }
            }
          x7 = XVECEXP (x3, 0, 0);
          operands[3] = x7;
          switch (pattern968 (x2))
            {
            case 0:
              if (!
#line 6197 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2368; /* *punpckwd */

            case 1:
              if (!
#line 6197 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2369; /* *punpckwd */

            case 2:
              if (!
#line 6197 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2370; /* *punpckwd */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4850 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2296; /* mmx_punpckhbw */

        case 2:
          if (!
#line 4890 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2298; /* mmx_punpcklbw */

        case 3:
          if (!
#line 4871 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2297; /* mmx_punpckhbw_low */

        case 4:
          if (!
#line 4928 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2300; /* mmx_punpckhwd */

        case 5:
          if (!
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2299; /* mmx_punpcklbw_low */

        case 6:
          if (!
#line 4949 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2301; /* mmx_punpcklwd */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern276 (x2) != 0
          || !
#line 8409 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
        return -1;
      return 4716; /* sse_cvtps2pi */

    case FIX:
      if (pattern278 (x2) != 0
          || !
#line 8473 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
        return -1;
      return 4718; /* sse_cvttps2pi */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 5918 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3760; /* *fma_fmadd_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3775; /* *fma_fmadd_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 5918 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3761; /* *fma_fmadd_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3784; /* *fma_fmadd_df */

            case E_HFmode:
              if (pattern858 (x3, 
E_HFmode) != 0
                  || !(
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3774; /* *fma_fmadd_hf */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || GET_MODE (x6) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3823; /* *fma_fmsub_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3838; /* *fma_fmsub_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || GET_MODE (x6) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3824; /* *fma_fmsub_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3847; /* *fma_fmsub_df */

            case E_HFmode:
              if (pattern859 (x3, 
E_HFmode) != 0
                  || !(
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3837; /* *fma_fmsub_hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || GET_MODE (x5) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6123 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3886; /* *fma_fnmadd_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3901; /* *fma_fnmadd_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || GET_MODE (x5) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6123 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3887; /* *fma_fnmadd_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3910; /* *fma_fnmadd_df */

            case E_HFmode:
              if (pattern860 (x3, 
E_HFmode) != 0
                  || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3900; /* *fma_fnmadd_hf */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern861 (x3, 
E_SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6230 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3943; /* *fma_fnmsub_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3972; /* *fma_fnmsub_sf */

            case E_DFmode:
              if (pattern861 (x3, 
E_DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6230 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3945; /* *fma_fnmsub_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3981; /* *fma_fnmsub_df */

            case E_HFmode:
              if (pattern862 (x3, 
E_HFmode) != 0
                  || !(
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3971; /* *fma_fnmsub_hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern974 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 5437 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return 2324; /* *mmx_pextrw_zext */
          break;

        case 1:
          if (
#line 6098 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2362; /* *pextrw_zext */
          break;

        case 2:
          if (
#line 21102 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 8389; /* *vec_extractv8hi_zext */
          break;

        case 3:
          if (
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2328; /* *mmx_pextrb_zext */
          break;

        case 4:
          if (
#line 6130 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2366; /* *pextrb_zext */
          break;

        case 5:
          if ((
#line 21102 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 21045 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
            return 8387; /* *vec_extractv16qi_zext */
          break;

        default:
          break;
        }
      break;

    case E_DImode:
      switch (pattern974 (x2, 
E_DImode))
        {
        case 0:
          if ((
#line 5437 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2325; /* *mmx_pextrw_zext */
          break;

        case 1:
          if ((
#line 6098 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2363; /* *pextrw_zext */
          break;

        case 2:
          if ((
#line 21102 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 8390; /* *vec_extractv8hi_zext */
          break;

        case 3:
          if ((
#line 5474 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2329; /* *mmx_pextrb_zext */
          break;

        case 4:
          if ((
#line 6130 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE4_1) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2367; /* *pextrb_zext */
          break;

        case 5:
          if ((
#line 21102 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && (
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21045 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))))
            return 8388; /* *vec_extractv16qi_zext */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode
      || GET_MODE (x3) != E_SImode)
    return -1;
  operands[1] = x6;
  switch (XWINT (x5, 0))
    {
    case 0LL:
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (register_operand (operands[1], E_V2SImode))
            {
              if (
#line 5749 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE4_1))
                return 2350; /* *vec_extractv2si_0_zext_sse4 */
              if (
#line 5764 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_FROM_VEC))
                return 2351; /* *vec_extractv2si_0_zext */
            }
          break;

        case E_V4SImode:
          if (register_operand (operands[1], E_V4SImode))
            {
              if (
#line 21202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE4_1))
                return 8397; /* *vec_extractv4si_0_zext_sse4 */
              if (
#line 21217 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_FROM_VEC))
                return 8398; /* *vec_extractv4si_0_zext */
            }
          break;

        default:
          break;
        }
      break;

    case 1LL:
      if (register_operand (operands[1], E_V2SImode)
          && 
#line 5826 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && TARGET_64BIT && TARGET_SSE4_1))
        return 2353; /* *vec_extractv2si_1_zext */
      break;

    default:
      break;
    }
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!memory_operand (operands[1], E_V2SImode)
          || !const_0_to_1_operand (operands[2], E_SImode)
          || !
#line 5842 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_64BIT))
        return -1;
      return 2354; /* *vec_extractv2si_zext_mem */

    case E_V4SImode:
      if (!const_0_to_3_operand (operands[2], E_SImode))
        return -1;
      if (register_operand (operands[1], E_V4SImode)
          && 
#line 21278 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE4_1))
        return 8400; /* *vec_extractv4si_zext */
      if (!memory_operand (operands[1], E_V4SImode)
          || !
#line 21301 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE))
        return -1;
      return 8402; /* *vec_extractv4si_zext_mem */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
              operands[3] = x6;
              operands[1] = x4;
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern600 (x2, 
E_SImode) != 0
                      || !
#line 8039 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))))
                    return -1;
                  return 376; /* *leasi_general_4 */

                case E_DImode:
                  if (GET_MODE (x2) != E_DImode
                      || GET_MODE (x3) != E_DImode)
                    return -1;
                  if (register_operand (operands[0], E_DImode)
                      && register_no_SP_operand (operands[1], E_DImode)
                      && const_0_to_3_operand (operands[2], E_VOIDmode)
                      && const_int_operand (operands[3], E_VOIDmode)
                      && (
#line 8039 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 378; /* *leadi_general_4 */
                  if (!nonimmediate_operand (operands[0], E_DImode)
                      || !register_operand (operands[1], E_DImode)
                      || !const_int_operand (operands[2], E_QImode)
                      || !const_scalar_int_operand (operands[3], E_DImode)
                      || !(
#line 14139 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                    return -1;
                  return 929; /* *concatsidi3_5 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_DImode
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode)
                return -1;
              operands[1] = x4;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              operands[2] = x5;
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !(
#line 14062 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 893; /* *concatsidi3_1 */

            case SUBREG:
              switch (pattern439 (x2, 
LSHIFTRT))
                {
                case 0:
                  operands[2] = x5;
                  if (pattern1346 (x2) == 0)
                    {
                      if (
#line 15439 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && TARGET_APX_NF))
                        return 1066; /* x86_64_shld_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 15439 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && true))
                        {
                          *pnum_clobbers = 1;
                          return 1067; /* x86_64_shld_1 */
                        }
                    }
                  operands[3] = x5;
                  if (pattern1347 (x2) != 0)
                    return -1;
                  if (
#line 15461 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && TARGET_APX_NF))
                    return 1068; /* x86_64_shld_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15461 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1069; /* x86_64_shld_ndd_1 */

                case 1:
                  operands[2] = x5;
                  if (pattern1348 (x2) == 0)
                    {
                      if (
#line 15671 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && TARGET_APX_NF))
                        return 1078; /* x86_shld_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 15671 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && true))
                        {
                          *pnum_clobbers = 1;
                          return 1079; /* x86_shld_1 */
                        }
                    }
                  operands[3] = x5;
                  if (pattern1349 (x2) != 0)
                    return -1;
                  if (
#line 15693 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && TARGET_APX_NF))
                    return 1080; /* x86_shld_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15693 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1081; /* x86_shld_ndd_1 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern442 (x2, pnum_clobbers))
                {
                case 0:
                  if (
#line 15477 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_APX_NF
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1070; /* *x86_64_shld_shrd_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15533 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1071; /* *x86_64_shld_shrd_1_nozext */

                case 1:
                  if (
#line 15709 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1082; /* *x86_shld_shrd_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15765 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1083; /* *x86_shld_shrd_1_nozext */

                case 2:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (nonimmediate_operand (operands[0], E_DImode))
                    {
                      operands[2] = x5;
                      if (rtx_equal_p (x4, operands[0]))
                        {
                          x8 = XEXP (x6, 1);
                          x9 = XEXP (x8, 1);
                          if (rtx_equal_p (x9, operands[2])
                              && 
#line 15586 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            {
                              *pnum_clobbers = 1;
                              return 1072; /* *x86_64_shld_2 */
                            }
                        }
                    }
                  operands[2] = x7;
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  operands[1] = x4;
                  if (!nonimmediate_operand (operands[1], E_DImode))
                    return -1;
                  operands[3] = x5;
                  x8 = XEXP (x6, 1);
                  x9 = XEXP (x8, 1);
                  if (!rtx_equal_p (x9, operands[3])
                      || !
#line 15607 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1073; /* *x86_64_shld_ndd_2 */

                case 3:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (nonimmediate_operand (operands[0], E_SImode))
                    {
                      operands[2] = x5;
                      if (rtx_equal_p (x4, operands[0]))
                        {
                          x8 = XEXP (x6, 1);
                          x9 = XEXP (x8, 1);
                          if (rtx_equal_p (x9, operands[2])
                              && 
#line 15817 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            {
                              *pnum_clobbers = 1;
                              return 1084; /* *x86_shld_2 */
                            }
                        }
                    }
                  operands[2] = x7;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  operands[1] = x4;
                  if (!nonimmediate_operand (operands[1], E_SImode))
                    return -1;
                  operands[3] = x5;
                  x8 = XEXP (x6, 1);
                  x9 = XEXP (x8, 1);
                  if (!rtx_equal_p (x9, operands[3])
                      || !
#line 15838 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1085; /* *x86_shld_ndd_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          switch (pattern290 (x2, 
LSHIFTRT))
            {
            case 0:
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              x10 = XEXP (x7, 0);
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (nonimmediate_operand (operands[0], E_DImode))
                {
                  res = recog_77 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[2] = x11;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              operands[1] = x4;
              if (!nonimmediate_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              x13 = XEXP (x7, 1);
              x14 = XEXP (x13, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              if (
#line 15424 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1064; /* x86_64_shld_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 15424 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1065; /* x86_64_shld_ndd */

            case 1:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || pattern289 (x2, 
E_SImode, 
E_DImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              x10 = XEXP (x7, 0);
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              x12 = XEXP (x5, 0);
              operands[2] = x12;
              if (rtx_equal_p (x4, operands[0]))
                {
                  x13 = XEXP (x7, 1);
                  x14 = XEXP (x13, 1);
                  x15 = XEXP (x14, 0);
                  if (rtx_equal_p (x15, operands[2]))
                    {
                      if (
#line 15633 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF))
                        return 1074; /* x86_shld_nf */
                      if (pnum_clobbers != NULL)
                        {
                          *pnum_clobbers = 1;
                          return 1075; /* x86_shld */
                        }
                    }
                }
              operands[2] = x11;
              operands[1] = x4;
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              operands[3] = x12;
              x13 = XEXP (x7, 1);
              x14 = XEXP (x13, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              if (
#line 15655 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1076; /* x86_shld_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 15655 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1077; /* x86_shld_ndd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern260 (x2, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!(
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 905; /* *concatsidi3_3 */

        case 1:
          if (!(
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 935; /* *concatsidi3_6 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern260 (x2, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!(
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 908; /* *concatsidi3_3 */

        case 1:
          if (!(
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 938; /* *concatsidi3_6 */

        default:
          return -1;
        }

    case CONST_INT:
      switch (pattern288 (x2, pnum_clobbers))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (pattern748 (x2))
                {
                case 0:
                  if (
#line 18825 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT))
                    {
                      *pnum_clobbers = 1;
                      return 1391; /* *btssi */
                    }
                  break;

                case 1:
                  if ((
#line 18825 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1393; /* *btsdi */
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG)
            return -1;
          switch (pattern757 (x2))
            {
            case 0:
              if (!
#line 18844 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1395; /* *btssi_mask */

            case 1:
              if (!(
#line 18844 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1397; /* *btsdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18872 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1399; /* *btssi_mask_1 */

        case 2:
          if (!(
#line 18872 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1401; /* *btsdi_mask_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pnum_clobbers != NULL)
        {
          x2 = XEXP (x1, 1);
          if (pattern734 (x2, 
E_DImode, 
E_QImode) == 0
              && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            {
              *pnum_clobbers = 1;
              return 1131; /* ashrdi3_doubleword */
            }
        }
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_DImode)
          && const_int_operand (operands[2], E_QImode))
        {
          if ((
#line 17246 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1168; /* ashrdi3_cvt_nf */
          if (pnum_clobbers != NULL
              && (
#line 17246 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1169; /* ashrdi3_cvt */
            }
        }
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[2], E_DImode)
          && (
#line 17315 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1174; /* *bmi2_ashrdi3_1 */
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonmemory_operand (operands[2], E_QImode))
        return -1;
      if ((
#line 17325 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1177; /* *ashrdi3_1_nf */
      if (pnum_clobbers == NULL
          || !(
#line 17325 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1178; /* *ashrdi3_1 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern620 (x2, 
E_SImode) != 0)
        return -1;
      if (
#line 17325 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 1175; /* *ashrsi3_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 17325 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 1176; /* *ashrsi3_1 */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == SUBREG
      && known_eq (SUBREG_BYTE (x2), 0))
    {
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (register_operand (operands[0], E_QImode))
        {
          x4 = XEXP (x1, 1);
          x5 = XEXP (x4, 2);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (GET_MODE (x2))
                {
                case E_SImode:
                  if (GET_MODE (x4) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 19344 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1434; /* *btsi_setcqi */
                    }
                  break;

                case E_DImode:
                  if (GET_MODE (x4) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 19344 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1435; /* *btdi_setcqi */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 2);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != AND)
    return -1;
  operands[0] = x2;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern1438 (x4, 
E_SImode) != 0
          || !
#line 19425 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1442; /* *btsi_setcsi_mask */

    case E_DImode:
      if (pattern1438 (x4, 
E_DImode) != 0
          || !(
#line 19425 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1443; /* *btdi_setcdi_mask */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (XWINT (x3, 0) == 1LL)
    {
      res = recog_103 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  operands[2] = x3;
  if (!const_0_to_255_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_QImode))
    return -1;
  switch (pattern126 (x2))
    {
    case 0:
      if (!
#line 22172 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM))
        return -1;
      *pnum_clobbers = 1;
      return 1604; /* tbm_bextri_si */

    case 1:
      if (!(
#line 22172 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1605; /* tbm_bextri_di */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (register_operand (operands[1], E_DFmode)
              && 
#line 25501 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
            return 1759; /* movmsk_df */
          break;

        case E_V8QImode:
          if (register_operand (operands[1], E_V8QImode)
              && 
#line 6823 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return 2384; /* mmx_pmovmskb */
          break;

        case E_V8SFmode:
          if (register_operand (operands[1], E_V8SFmode)
              && (
#line 21921 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 8435; /* avx_movmskps256 */
          break;

        case E_V4SFmode:
          if (register_operand (operands[1], E_V4SFmode)
              && 
#line 21921 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 8436; /* sse_movmskps */
          break;

        case E_V4DFmode:
          if (register_operand (operands[1], E_V4DFmode)
              && (
#line 21921 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 8437; /* avx_movmskpd256 */
          break;

        case E_V2DFmode:
          if (register_operand (operands[1], E_V2DFmode)
              && (
#line 21921 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 8438; /* sse2_movmskpd */
          break;

        case E_V32QImode:
          if (register_operand (operands[1], E_V32QImode)
              && (
#line 22071 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 8483; /* avx2_pmovmskb */
          break;

        case E_V16QImode:
          if (register_operand (operands[1], E_V16QImode)
              && 
#line 22071 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 8484; /* sse2_pmovmskb */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case VEC_MERGE:
          switch (pattern1085 (x4))
            {
            case 0:
              if (!(
#line 21972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8451; /* *avx_movmskps256_lt_avx512 */

            case 1:
              if (!
#line 21972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 8452; /* *sse_movmskps_lt_avx512 */

            case 2:
              if (!(
#line 21972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8453; /* *avx_movmskpd256_lt_avx512 */

            case 3:
              if (!(
#line 21972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8454; /* *sse2_movmskpd_lt_avx512 */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern1086 (x4))
            {
            case 0:
              if (!(
#line 22035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8471; /* *avx_movmskps256_shift */

            case 1:
              if (!
#line 22035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 8472; /* *sse_movmskps_shift */

            case 2:
              if (!(
#line 22035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8473; /* *avx_movmskpd256_shift */

            case 3:
              if (!(
#line 22035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8474; /* *sse2_movmskpd_shift */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LT:
      switch (pattern759 (x4))
        {
        case 0:
          if (!(
#line 21948 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8447; /* *avx_movmskps256_lt */

        case 1:
          if (!
#line 21948 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 8448; /* *sse_movmskps_lt */

        case 2:
          if (!(
#line 21948 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8449; /* *avx_movmskpd256_lt */

        case 3:
          if (!(
#line 21948 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 8450; /* *sse2_movmskpd_lt */

        case 4:
          if (!(
#line 22200 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8489; /* *avx2_pmovmskb_lt */

        case 5:
          if (!
#line 22200 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 8490; /* *sse2_pmovmskb_lt */

        default:
          return -1;
        }

    case VEC_MERGE:
      switch (pattern761 (x4))
        {
        case 0:
          if (!(
#line 22228 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8491; /* *avx2_pmovmskb_lt_avx512 */

        case 1:
          if (!
#line 22228 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 8492; /* *sse2_pmovmskb_lt_avx512 */

        case 2:
          if (!
#line 22356 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 8500; /* *pmovsk_kmask_v16qi_avx512 */

        case 3:
          if (!
#line 22370 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 8501; /* *pmovsk_mask_v32qi_avx512 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (pattern981 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2449; /* *avx512f_loadv16si_mask */

    case E_V8SImode:
      if (pattern981 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2450; /* *avx512vl_loadv8si_mask */

    case E_V4SImode:
      if (pattern981 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2451; /* *avx512vl_loadv4si_mask */

    case E_V8DImode:
      if (pattern981 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2452; /* *avx512f_loadv8di_mask */

    case E_V4DImode:
      if (pattern981 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2453; /* *avx512vl_loadv4di_mask */

    case E_V2DImode:
      if (pattern981 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2454; /* *avx512vl_loadv2di_mask */

    case E_V16SFmode:
      if (pattern981 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2455; /* *avx512f_loadv16sf_mask */

    case E_V8SFmode:
      if (pattern981 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2456; /* *avx512vl_loadv8sf_mask */

    case E_V4SFmode:
      if (pattern981 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2457; /* *avx512vl_loadv4sf_mask */

    case E_V8DFmode:
      if (pattern981 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2458; /* *avx512f_loadv8df_mask */

    case E_V4DFmode:
      if (pattern981 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2459; /* *avx512vl_loadv4df_mask */

    case E_V2DFmode:
      if (pattern981 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2460; /* *avx512vl_loadv2df_mask */

    case E_V64QImode:
      if (pattern981 (x2, 
E_V64QImode, 
E_DImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2473; /* *avx512bw_loadv64qi_mask */

    case E_V16QImode:
      if (pattern981 (x2, 
E_V16QImode, 
E_HImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2474; /* *avx512vl_loadv16qi_mask */

    case E_V32QImode:
      if (pattern981 (x2, 
E_V32QImode, 
E_SImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2475; /* *avx512vl_loadv32qi_mask */

    case E_V32HImode:
      if (pattern981 (x2, 
E_V32HImode, 
E_SImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2476; /* *avx512bw_loadv32hi_mask */

    case E_V16HImode:
      if (pattern981 (x2, 
E_V16HImode, 
E_HImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2477; /* *avx512vl_loadv16hi_mask */

    case E_V8HImode:
      if (pattern981 (x2, 
E_V8HImode, 
E_QImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2478; /* *avx512vl_loadv8hi_mask */

    case E_V32HFmode:
      if (pattern981 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2479; /* *avx512bw_loadv32hf_mask */

    case E_V16HFmode:
      if (pattern981 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2480; /* *avx512vl_loadv16hf_mask */

    case E_V8HFmode:
      if (pattern981 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2481; /* *avx512fp16_loadv8hf_mask */

    case E_V32BFmode:
      if (pattern981 (x2, 
E_V32BFmode, 
E_SImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2482; /* *avx512bw_loadv32bf_mask */

    case E_V16BFmode:
      if (pattern981 (x2, 
E_V16BFmode, 
E_HImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2483; /* *avx512vl_loadv16bf_mask */

    case E_V8BFmode:
      if (pattern981 (x2, 
E_V8BFmode, 
E_QImode) != 0
          || !(
#line 1670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2484; /* *avx512vl_loadv8bf_mask */

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (pattern981 (x2, 
E_V64QImode, 
E_DImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 514 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10879; /* avx10_2_vmovrsbv64qi_mask */

    case E_V32QImode:
      if (pattern981 (x2, 
E_V32QImode, 
E_SImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10881; /* avx10_2_vmovrsbv32qi_mask */

    case E_V16QImode:
      if (pattern981 (x2, 
E_V16QImode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10883; /* avx10_2_vmovrsbv16qi_mask */

    case E_V32HImode:
      if (pattern981 (x2, 
E_V32HImode, 
E_SImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 515 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10885; /* avx10_2_vmovrswv32hi_mask */

    case E_V16HImode:
      if (pattern981 (x2, 
E_V16HImode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10887; /* avx10_2_vmovrswv16hi_mask */

    case E_V8HImode:
      if (pattern981 (x2, 
E_V8HImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10889; /* avx10_2_vmovrswv8hi_mask */

    case E_V16SImode:
      if (pattern981 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 516 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10891; /* avx10_2_vmovrsdv16si_mask */

    case E_V8SImode:
      if (pattern981 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10893; /* avx10_2_vmovrsdv8si_mask */

    case E_V4SImode:
      if (pattern981 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10895; /* avx10_2_vmovrsdv4si_mask */

    case E_V8DImode:
      if (pattern981 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 517 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10897; /* avx10_2_vmovrsqv8di_mask */

    case E_V4DImode:
      if (pattern981 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10899; /* avx10_2_vmovrsqv4di_mask */

    case E_V2DImode:
      if (pattern981 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10901; /* avx10_2_vmovrsqv2di_mask */

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 2);
  operands[3] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      x6 = XEXP (x2, 2);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern990 (x2, 
E_V16SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16SImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28135 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 9290; /* *avx512f_vpermi2varv16si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16SImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 9356; /* avx512f_vpermt2varv16si3_mask */
            }
          break;

        case E_V8DImode:
          if (pattern990 (x2, 
E_V8DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28135 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 9291; /* *avx512f_vpermi2varv8di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 9358; /* avx512f_vpermt2varv8di3_mask */
            }
          break;

        case E_V8SImode:
          if (pattern990 (x2, 
E_V8SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28136 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9292; /* *avx512vl_vpermi2varv8si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9360; /* avx512vl_vpermt2varv8si3_mask */
            }
          break;

        case E_V4SImode:
          if (pattern990 (x2, 
E_V4SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V4SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28136 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9293; /* *avx512vl_vpermi2varv4si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V4SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9364; /* avx512vl_vpermt2varv4si3_mask */
            }
          break;

        case E_V4DImode:
          if (pattern990 (x2, 
E_V4DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V4DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28137 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9294; /* *avx512vl_vpermi2varv4di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V4DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9362; /* avx512vl_vpermt2varv4di3_mask */
            }
          break;

        case E_V2DImode:
          if (pattern990 (x2, 
E_V2DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V2DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28137 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9295; /* *avx512vl_vpermi2varv2di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V2DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9366; /* avx512vl_vpermt2varv2di3_mask */
            }
          break;

        case E_V32HImode:
          if (pattern990 (x2, 
E_V32HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V32HImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28138 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9296; /* *avx512bw_vpermi2varv32hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V32HImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28127 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9368; /* avx512bw_vpermt2varv32hi3_mask */
            }
          break;

        case E_V16HImode:
          if (pattern990 (x2, 
E_V16HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16HImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28139 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 9297; /* *avx512vl_vpermi2varv16hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16HImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28128 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 9369; /* avx512vl_vpermt2varv16hi3_mask */
            }
          break;

        case E_V8HImode:
          if (pattern990 (x2, 
E_V8HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8HImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28140 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 9298; /* *avx512vl_vpermi2varv8hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8HImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28129 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 9370; /* avx512vl_vpermt2varv8hi3_mask */
            }
          break;

        case E_V64QImode:
          if (pattern990 (x2, 
E_V64QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V64QImode)
                  && register_operand (operands[4], E_DImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28141 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
                return 9299; /* *avx512bw_vpermi2varv64qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V64QImode)
                  && register_operand (operands[4], E_DImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28130 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
                return 9371; /* avx512bw_vpermt2varv64qi3_mask */
            }
          break;

        case E_V32QImode:
          if (pattern990 (x2, 
E_V32QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V32QImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28142 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 9300; /* *avx512vl_vpermi2varv32qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V32QImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28131 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 9372; /* avx512vl_vpermt2varv32qi3_mask */
            }
          break;

        case E_V16QImode:
          if (pattern990 (x2, 
E_V16QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16QImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 9301; /* *avx512vl_vpermi2varv16qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16QImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28132 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 9373; /* avx512vl_vpermt2varv16qi3_mask */
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x5) == SUBREG
          && known_eq (SUBREG_BYTE (x5), 0))
        {
          x8 = XVECEXP (x3, 0, 0);
          operands[2] = x8;
          x7 = XVECEXP (x3, 0, 1);
          operands[1] = x7;
          x9 = XEXP (x5, 0);
          if (rtx_equal_p (x9, operands[2]))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1439 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) == 0
                      && (
#line 28187 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9302; /* *avx512f_vpermi2varv16sf3_mask */
                  break;

                case E_V8SFmode:
                  if (pattern1439 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) == 0
                      && (
#line 28187 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9303; /* *avx512vl_vpermi2varv8sf3_mask */
                  break;

                case E_V4SFmode:
                  if (pattern1439 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) == 0
                      && (
#line 28187 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9304; /* *avx512vl_vpermi2varv4sf3_mask */
                  break;

                case E_V8DFmode:
                  if (pattern1439 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) == 0
                      && (
#line 28187 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9305; /* *avx512f_vpermi2varv8df3_mask */
                  break;

                case E_V4DFmode:
                  if (pattern1439 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) == 0
                      && (
#line 28187 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9306; /* *avx512vl_vpermi2varv4df3_mask */
                  break;

                case E_V2DFmode:
                  if (pattern1439 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) == 0
                      && (
#line 28187 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9307; /* *avx512vl_vpermi2varv2df3_mask */
                  break;

                default:
                  break;
                }
            }
        }
      x8 = XVECEXP (x3, 0, 0);
      operands[1] = x8;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1261 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9357; /* avx512f_vpermt2varv16sf3_mask */

        case E_V8DFmode:
          if (pattern1261 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9359; /* avx512f_vpermt2varv8df3_mask */

        case E_V8SFmode:
          if (pattern1261 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9361; /* avx512vl_vpermt2varv8sf3_mask */

        case E_V4DFmode:
          if (pattern1261 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9363; /* avx512vl_vpermt2varv4df3_mask */

        case E_V4SFmode:
          if (pattern1261 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9365; /* avx512vl_vpermt2varv4sf3_mask */

        case E_V2DFmode:
          if (pattern1261 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 28247 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9367; /* avx512vl_vpermt2varv2df3_mask */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x5;
      x8 = XVECEXP (x3, 0, 0);
      operands[1] = x8;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      x6 = XEXP (x2, 2);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern482 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9309; /* avx512f_vpermt2varv16si3_maskz_1 */

        case E_V16SFmode:
          if (pattern1262 (x2, 
E_V16SFmode, 
E_HImode, 
E_V16SImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9311; /* avx512f_vpermt2varv16sf3_maskz_1 */

        case E_V8DImode:
          if (pattern482 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9313; /* avx512f_vpermt2varv8di3_maskz_1 */

        case E_V8DFmode:
          if (pattern1262 (x2, 
E_V8DFmode, 
E_QImode, 
E_V8DImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9315; /* avx512f_vpermt2varv8df3_maskz_1 */

        case E_V8SImode:
          if (pattern482 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9317; /* avx512vl_vpermt2varv8si3_maskz_1 */

        case E_V8SFmode:
          if (pattern1262 (x2, 
E_V8SFmode, 
E_QImode, 
E_V8SImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9319; /* avx512vl_vpermt2varv8sf3_maskz_1 */

        case E_V4DImode:
          if (pattern482 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9321; /* avx512vl_vpermt2varv4di3_maskz_1 */

        case E_V4DFmode:
          if (pattern1262 (x2, 
E_V4DFmode, 
E_QImode, 
E_V4DImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9323; /* avx512vl_vpermt2varv4df3_maskz_1 */

        case E_V4SImode:
          if (pattern482 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9325; /* avx512vl_vpermt2varv4si3_maskz_1 */

        case E_V4SFmode:
          if (pattern1262 (x2, 
E_V4SFmode, 
E_QImode, 
E_V4SImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9327; /* avx512vl_vpermt2varv4sf3_maskz_1 */

        case E_V2DImode:
          if (pattern482 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9329; /* avx512vl_vpermt2varv2di3_maskz_1 */

        case E_V2DFmode:
          if (pattern1262 (x2, 
E_V2DFmode, 
E_QImode, 
E_V2DImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9331; /* avx512vl_vpermt2varv2df3_maskz_1 */

        case E_V32HImode:
          if (pattern482 (x2, 
E_V32HImode, 
E_SImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28127 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 9333; /* avx512bw_vpermt2varv32hi3_maskz_1 */

        case E_V16HImode:
          if (pattern482 (x2, 
E_V16HImode, 
E_HImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28128 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 9335; /* avx512vl_vpermt2varv16hi3_maskz_1 */

        case E_V8HImode:
          if (pattern482 (x2, 
E_V8HImode, 
E_QImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28129 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 9337; /* avx512vl_vpermt2varv8hi3_maskz_1 */

        case E_V64QImode:
          if (pattern482 (x2, 
E_V64QImode, 
E_DImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28130 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
            return -1;
          return 9339; /* avx512bw_vpermt2varv64qi3_maskz_1 */

        case E_V32QImode:
          if (pattern482 (x2, 
E_V32QImode, 
E_SImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28131 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 9341; /* avx512vl_vpermt2varv32qi3_maskz_1 */

        case E_V16QImode:
          if (pattern482 (x2, 
E_V16QImode, 
E_HImode) != 0
              || !(
#line 28214 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28132 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 9343; /* avx512vl_vpermt2varv16qi3_maskz_1 */

        case E_V32HFmode:
          if (pattern1262 (x2, 
E_V32HFmode, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 28229 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9345; /* avx512bw_vpermt2varv32hf3_maskz_1 */

        case E_V16HFmode:
          if (pattern1262 (x2, 
E_V16HFmode, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 28229 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9347; /* avx512vl_vpermt2varv16hf3_maskz_1 */

        case E_V8HFmode:
          if (pattern1262 (x2, 
E_V8HFmode, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 28229 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9349; /* avx512fp16_vpermt2varv8hf3_maskz_1 */

        case E_V32BFmode:
          if (pattern1262 (x2, 
E_V32BFmode, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 28229 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9351; /* avx512bw_vpermt2varv32bf3_maskz_1 */

        case E_V16BFmode:
          if (pattern1262 (x2, 
E_V16BFmode, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 28229 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9353; /* avx512vl_vpermt2varv16bf3_maskz_1 */

        case E_V8BFmode:
          if (pattern1262 (x2, 
E_V8BFmode, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 28229 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9355; /* avx512vl_vpermt2varv8bf3_maskz_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (pattern635 (x2))
    {
    case 0:
      if (pattern1371 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5931 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3893; /* fma_fnmadd_v32hf_maskz_1 */

    case 1:
      if (pattern1371 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3897; /* fma_fnmadd_v16hf_maskz_1 */

    case 2:
      if (pattern1371 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5933 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3899; /* fma_fnmadd_v8hf_maskz_1 */

    case 3:
      if (pattern1371 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5935 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3903; /* fma_fnmadd_v16sf_maskz_1 */

    case 4:
      if (pattern1371 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3907; /* fma_fnmadd_v8sf_maskz_1 */

    case 5:
      if (pattern1371 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3909; /* fma_fnmadd_v4sf_maskz_1 */

    case 6:
      if (pattern1371 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5937 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3912; /* fma_fnmadd_v8df_maskz_1 */

    case 7:
      if (pattern1371 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5938 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3916; /* fma_fnmadd_v4df_maskz_1 */

    case 8:
      if (pattern1371 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5938 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3918; /* fma_fnmadd_v2df_maskz_1 */

    case 9:
      if (pattern1372 (x2, 
E_SImode, 
E_V32BFmode) != 0
          || !
#line 32206 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10567; /* avx10_2_fnmaddbf16_v32bf_maskz_1 */

    case 10:
      if (pattern1372 (x2, 
E_HImode, 
E_V16BFmode) != 0
          || !
#line 32206 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10569; /* avx10_2_fnmaddbf16_v16bf_maskz_1 */

    case 11:
      if (pattern1372 (x2, 
E_QImode, 
E_V8BFmode) != 0
          || !
#line 32206 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10571; /* avx10_2_fnmaddbf16_v8bf_maskz_1 */

    case 12:
      if (pattern1373 (x2, 
E_V4SFmode) != 0
          || !
#line 6991 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA4))
        return -1;
      return 4248; /* *fma4i_vmfnmadd_v4sf */

    case 13:
      if (pattern1373 (x2, 
E_V2DFmode) != 0
          || !(
#line 6991 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA4) && 
#line 474 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 4249; /* *fma4i_vmfnmadd_v2df */

    case 14:
      if (pattern1280 (x2, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HFmode)
          && vector_operand (operands[3], E_V32HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return 3919; /* avx512bw_fnmadd_v32hf_mask */
        }
      if (!vector_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[3], E_V32HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3931; /* avx512bw_fnmadd_v32hf_mask3 */

    case 15:
      if (pattern1280 (x2, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HFmode)
          && vector_operand (operands[3], E_V16HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3921; /* avx512vl_fnmadd_v16hf_mask */
        }
      if (!vector_operand (operands[1], E_V16HFmode)
          || !nonimmediate_operand (operands[3], E_V16HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3933; /* avx512vl_fnmadd_v16hf_mask3 */

    case 16:
      if (pattern1280 (x2, 
E_V8HFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8HFmode)
          && vector_operand (operands[3], E_V8HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3922; /* avx512fp16_fnmadd_v8hf_mask */
        }
      if (!vector_operand (operands[1], E_V8HFmode)
          || !nonimmediate_operand (operands[3], E_V8HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3934; /* avx512fp16_fnmadd_v8hf_mask3 */

    case 17:
      if (pattern1280 (x2, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SFmode)
          && vector_operand (operands[3], E_V16SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3923; /* avx512f_fnmadd_v16sf_mask */
        }
      if (!vector_operand (operands[1], E_V16SFmode)
          || !nonimmediate_operand (operands[3], E_V16SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3935; /* avx512f_fnmadd_v16sf_mask3 */

    case 18:
      if (pattern1280 (x2, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SFmode)
          && vector_operand (operands[3], E_V8SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3925; /* avx512vl_fnmadd_v8sf_mask */
        }
      if (!vector_operand (operands[1], E_V8SFmode)
          || !nonimmediate_operand (operands[3], E_V8SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3937; /* avx512vl_fnmadd_v8sf_mask3 */

    case 19:
      if (pattern1280 (x2, 
E_V4SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode)
          && vector_operand (operands[3], E_V4SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3926; /* avx512vl_fnmadd_v4sf_mask */
        }
      if (!vector_operand (operands[1], E_V4SFmode)
          || !nonimmediate_operand (operands[3], E_V4SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3938; /* avx512vl_fnmadd_v4sf_mask3 */

    case 20:
      if (pattern1280 (x2, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DFmode)
          && vector_operand (operands[3], E_V8DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3927; /* avx512f_fnmadd_v8df_mask */
        }
      if (!vector_operand (operands[1], E_V8DFmode)
          || !nonimmediate_operand (operands[3], E_V8DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3939; /* avx512f_fnmadd_v8df_mask3 */

    case 21:
      if (pattern1280 (x2, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DFmode)
          && vector_operand (operands[3], E_V4DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3929; /* avx512vl_fnmadd_v4df_mask */
        }
      if (!vector_operand (operands[1], E_V4DFmode)
          || !nonimmediate_operand (operands[3], E_V4DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3941; /* avx512vl_fnmadd_v4df_mask3 */

    case 22:
      if (pattern1280 (x2, 
E_V2DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && vector_operand (operands[3], E_V2DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6198 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3930; /* avx512vl_fnmadd_v2df_mask */
        }
      if (!vector_operand (operands[1], E_V2DFmode)
          || !nonimmediate_operand (operands[3], E_V2DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6216 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3942; /* avx512vl_fnmadd_v2df_mask3 */

    case 23:
      if (pattern1281 (x2, 
E_SImode, 
E_V32BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && 
#line 32225 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return 10572; /* avx10_2_fnmaddbf16_v32bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !
#line 32243 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10575; /* avx10_2_fnmaddbf16_v32bf_mask3 */

    case 24:
      if (pattern1281 (x2, 
E_HImode, 
E_V16BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && 
#line 32225 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return 10573; /* avx10_2_fnmaddbf16_v16bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !
#line 32243 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10576; /* avx10_2_fnmaddbf16_v16bf_mask3 */

    case 25:
      if (pattern1281 (x2, 
E_QImode, 
E_V8BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && 
#line 32225 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return 10574; /* avx10_2_fnmaddbf16_v8bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !
#line 32243 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10577; /* avx10_2_fnmaddbf16_v8bf_mask3 */

    case 26:
      if (pattern1374 (x2, 
E_V8HFmode) != 0
          || !(
#line 6636 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
        return -1;
      return 4160; /* *fmai_fnmadd_v8hf */

    case 27:
      if (pattern1374 (x2, 
E_V4SFmode) != 0
          || !
#line 6636 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F))
        return -1;
      return 4162; /* *fmai_fnmadd_v4sf */

    case 28:
      if (pattern1374 (x2, 
E_V2DFmode) != 0
          || !(
#line 6636 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 4164; /* *fmai_fnmadd_v2df */

    case 29:
      return recog_158 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x8 = XEXP (x3, 1);
  x9 = XVECEXP (x8, 0, 0);
  switch (XWINT (x9, 0))
    {
    case 1LL:
      x10 = XVECEXP (x8, 0, 1);
      if (XWINT (x10, 0) != 3LL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern1563 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 13370 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5308; /* avx512vl_unpckhpd128_mask */

        case E_V2DImode:
          if (pattern1564 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14481 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 7128; /* vec_interleave_highv2di_mask */

        default:
          return -1;
        }

    case 0LL:
      x10 = XVECEXP (x8, 0, 1);
      if (XWINT (x10, 0) != 2LL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern1563 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 13513 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5318; /* avx512vl_unpcklpd128_mask */

        case E_V2DImode:
          if (pattern1564 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14531 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 7134; /* vec_interleave_lowv2di_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  switch (XVECLEN (x6, 0))
    {
    case 16:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_160 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x12 = XVECEXP (x6, 0, 4);
      operands[7] = x12;
      x13 = XVECEXP (x6, 0, 5);
      operands[8] = x13;
      x14 = XVECEXP (x6, 0, 6);
      operands[9] = x14;
      x15 = XVECEXP (x6, 0, 7);
      operands[10] = x15;
      x16 = XVECEXP (x6, 0, 8);
      operands[11] = x16;
      x17 = XVECEXP (x6, 0, 9);
      operands[12] = x17;
      x18 = XVECEXP (x6, 0, 10);
      operands[13] = x18;
      x19 = XVECEXP (x6, 0, 11);
      operands[14] = x19;
      x20 = XVECEXP (x6, 0, 12);
      operands[15] = x20;
      x21 = XVECEXP (x6, 0, 13);
      operands[16] = x21;
      x22 = XVECEXP (x6, 0, 14);
      operands[17] = x22;
      x23 = XVECEXP (x6, 0, 15);
      operands[18] = x23;
      x24 = XEXP (x2, 1);
      operands[19] = x24;
      x25 = XEXP (x2, 2);
      operands[20] = x25;
      if (!register_operand (operands[20], E_HImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1624 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
              || !nonimm_or_0_operand (operands[19], E_V16SFmode))
            return -1;
          if (const_0_to_3_operand (operands[3], E_VOIDmode)
              && const_0_to_3_operand (operands[4], E_VOIDmode)
              && const_16_to_19_operand (operands[5], E_VOIDmode)
              && const_16_to_19_operand (operands[6], E_VOIDmode)
              && const_4_to_7_operand (operands[7], E_VOIDmode)
              && const_4_to_7_operand (operands[8], E_VOIDmode)
              && const_20_to_23_operand (operands[9], E_VOIDmode)
              && const_20_to_23_operand (operands[10], E_VOIDmode)
              && const_8_to_11_operand (operands[11], E_VOIDmode)
              && const_8_to_11_operand (operands[12], E_VOIDmode)
              && const_24_to_27_operand (operands[13], E_VOIDmode)
              && const_24_to_27_operand (operands[14], E_VOIDmode)
              && const_12_to_15_operand (operands[15], E_VOIDmode)
              && const_12_to_15_operand (operands[16], E_VOIDmode)
              && const_28_to_31_operand (operands[17], E_VOIDmode)
              && const_28_to_31_operand (operands[18], E_VOIDmode)
              && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14270 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4)
       && INTVAL (operands[3]) == (INTVAL (operands[11]) - 8)
       && INTVAL (operands[4]) == (INTVAL (operands[12]) - 8)
       && INTVAL (operands[5]) == (INTVAL (operands[13]) - 8)
       && INTVAL (operands[6]) == (INTVAL (operands[14]) - 8)
       && INTVAL (operands[3]) == (INTVAL (operands[15]) - 12)
       && INTVAL (operands[4]) == (INTVAL (operands[16]) - 12)
       && INTVAL (operands[5]) == (INTVAL (operands[17]) - 12)
       && INTVAL (operands[6]) == (INTVAL (operands[18]) - 12)))))
            return 7117; /* avx512f_shufps512_1_mask */
          if (!const_0_to_15_operand (operands[3], E_VOIDmode)
              || pattern1852 () != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20401 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8357; /* avx512f_shuf_f32x4_1_mask */

        case E_V16SImode:
          if (pattern1624 (x2, 
E_V16SImode, 
E_V32SImode) != 0
              || !const_0_to_15_operand (operands[3], E_VOIDmode)
              || pattern1852 () != 0
              || !nonimm_or_0_operand (operands[19], E_V16SImode)
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20401 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8359; /* avx512f_shuf_i32x4_1_mask */

        default:
          return -1;
        }

    case 8:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_161 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x12 = XVECEXP (x6, 0, 4);
      operands[7] = x12;
      x13 = XVECEXP (x6, 0, 5);
      operands[8] = x13;
      x14 = XVECEXP (x6, 0, 6);
      operands[9] = x14;
      x15 = XVECEXP (x6, 0, 7);
      operands[10] = x15;
      x24 = XEXP (x2, 1);
      operands[11] = x24;
      x25 = XEXP (x2, 2);
      operands[12] = x25;
      if (!register_operand (operands[12], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1737 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0)
            return -1;
          if (const_0_to_3_operand (operands[3], E_VOIDmode)
              && const_0_to_3_operand (operands[4], E_VOIDmode)
              && const_8_to_11_operand (operands[5], E_VOIDmode)
              && const_8_to_11_operand (operands[6], E_VOIDmode)
              && const_4_to_7_operand (operands[7], E_VOIDmode)
              && const_4_to_7_operand (operands[8], E_VOIDmode)
              && const_12_to_15_operand (operands[9], E_VOIDmode)
              && const_12_to_15_operand (operands[10], E_VOIDmode)
              && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11463 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX
   && TARGET_AVX512VL
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4)))))
            return 5175; /* avx_shufps256_1_mask */
          if (!const_0_to_7_operand (operands[3], E_VOIDmode)
              || pattern1827 () != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3)))
            return -1;
          return 8355; /* avx512vl_shuf_f32x4_1_mask */

        case E_V8DFmode:
          if (pattern1737 (x2, 
E_V8DFmode, 
E_V16DFmode) != 0)
            return -1;
          if (const_0_to_1_operand (operands[3], E_VOIDmode)
              && const_8_to_9_operand (operands[4], E_VOIDmode)
              && const_2_to_3_operand (operands[5], E_VOIDmode)
              && const_10_to_11_operand (operands[6], E_VOIDmode)
              && const_4_to_5_operand (operands[7], E_VOIDmode)
              && const_12_to_13_operand (operands[8], E_VOIDmode)
              && const_6_to_7_operand (operands[9], E_VOIDmode)
              && const_14_to_15_operand (operands[10], E_VOIDmode)
              && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return 7119; /* avx512f_shufpd512_1_mask */
          if (!const_0_to_7_operand (operands[3], E_VOIDmode)
              || pattern1827 () != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20223 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 717 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8345; /* avx512f_shuf_f64x2_1_mask */

        case E_V8DImode:
          if (pattern1738 (x2, 
E_V8DImode, 
E_V16DImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20223 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 717 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8347; /* avx512f_shuf_i64x2_1_mask */

        case E_V8SImode:
          if (pattern1738 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3)))
            return -1;
          return 8353; /* avx512vl_shuf_i32x4_1_mask */

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_162 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x24 = XEXP (x2, 1);
      operands[7] = x24;
      x25 = XEXP (x2, 2);
      operands[8] = x25;
      if (!register_operand (operands[8], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern1623 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 11516 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5176; /* sse_shufps_v4sf_mask */

        case E_V4DFmode:
          if (pattern1624 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !nonimm_or_0_operand (operands[7], E_V4DFmode))
            return -1;
          if (const_0_to_1_operand (operands[3], E_VOIDmode)
              && const_4_to_5_operand (operands[4], E_VOIDmode)
              && const_2_to_3_operand (operands[5], E_VOIDmode)
              && const_6_to_7_operand (operands[6], E_VOIDmode)
              && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14384 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return 7121; /* avx_shufpd256_1_mask */
          if (!const_0_to_3_operand (operands[3], E_VOIDmode)
              || !const_0_to_3_operand (operands[4], E_VOIDmode)
              || !const_4_to_7_operand (operands[5], E_VOIDmode)
              || !const_4_to_7_operand (operands[6], E_VOIDmode)
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20165 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1)))
            return -1;
          return 8343; /* avx512dq_shuf_f64x2_1_mask */

        case E_V4DImode:
          if (pattern1623 (x2, 
E_V4DImode, 
E_V8DImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20165 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1)))
            return -1;
          return 8341; /* avx512dq_shuf_i64x2_1_mask */

        default:
          return -1;
        }

    case 2:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_163 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      if (!const_0_to_1_operand (operands[3], E_VOIDmode)
          || pattern1202 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0)
        return -1;
      operands[4] = x8;
      if (!const_2_to_3_operand (operands[4], E_VOIDmode))
        return -1;
      x24 = XEXP (x2, 1);
      operands[5] = x24;
      if (!nonimm_or_0_operand (operands[5], E_V2DFmode))
        return -1;
      x25 = XEXP (x2, 2);
      operands[6] = x25;
      if (!register_operand (operands[6], E_QImode)
          || !
#line 14426 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return -1;
      return 7122; /* sse2_shufpd_v2df_mask */

    case 64:
      return recog_164 (x1, insn, pnum_clobbers);

    case 32:
      if (pattern889 (x6) != 0)
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x24 = XEXP (x2, 1);
      operands[3] = x24;
      x25 = XEXP (x2, 2);
      operands[4] = x25;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      switch (XWINT (x7, 0))
        {
        case 8LL:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 40LL)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 9LL)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 41LL)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 10LL)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 42LL)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 11LL)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 43LL
              || pattern1867 (x6) != 0)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 24LL)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 56LL)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 25LL)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 57LL)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 26LL)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 58LL)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 27LL)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 59LL
              || pattern1872 (x6) != 0
              || pattern1563 (x2, 
E_V32QImode, 
E_V64QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19438 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8249; /* avx2_interleave_highv32qi_mask */

        case 0LL:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 32LL)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 1LL)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 33LL)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 2LL)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 34LL)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 3LL)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 35LL)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 16LL)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 48LL)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 17LL)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 49LL)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 18LL)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 50LL)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 19LL)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 51LL)
            return -1;
          x16 = XVECEXP (x6, 0, 8);
          switch (XWINT (x16, 0))
            {
            case 4LL:
              x17 = XVECEXP (x6, 0, 9);
              if (XWINT (x17, 0) != 36LL)
                return -1;
              x18 = XVECEXP (x6, 0, 10);
              if (XWINT (x18, 0) != 5LL)
                return -1;
              x19 = XVECEXP (x6, 0, 11);
              if (XWINT (x19, 0) != 37LL)
                return -1;
              x20 = XVECEXP (x6, 0, 12);
              if (XWINT (x20, 0) != 6LL)
                return -1;
              x21 = XVECEXP (x6, 0, 13);
              if (XWINT (x21, 0) != 38LL)
                return -1;
              x22 = XVECEXP (x6, 0, 14);
              if (XWINT (x22, 0) != 7LL)
                return -1;
              x23 = XVECEXP (x6, 0, 15);
              if (XWINT (x23, 0) != 39LL)
                return -1;
              x34 = XVECEXP (x6, 0, 24);
              if (XWINT (x34, 0) != 20LL)
                return -1;
              x35 = XVECEXP (x6, 0, 25);
              if (XWINT (x35, 0) != 52LL)
                return -1;
              x36 = XVECEXP (x6, 0, 26);
              if (XWINT (x36, 0) != 21LL)
                return -1;
              x37 = XVECEXP (x6, 0, 27);
              if (XWINT (x37, 0) != 53LL)
                return -1;
              x38 = XVECEXP (x6, 0, 28);
              if (XWINT (x38, 0) != 22LL)
                return -1;
              x39 = XVECEXP (x6, 0, 29);
              if (XWINT (x39, 0) != 54LL)
                return -1;
              x40 = XVECEXP (x6, 0, 30);
              if (XWINT (x40, 0) != 23LL)
                return -1;
              x41 = XVECEXP (x6, 0, 31);
              if (XWINT (x41, 0) != 55LL
                  || pattern1563 (x2, 
E_V32QImode, 
E_V64QImode) != 0
                  || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19534 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                return -1;
              return 8255; /* avx2_interleave_lowv32qi_mask */

            case 8LL:
              x17 = XVECEXP (x6, 0, 9);
              if (XWINT (x17, 0) != 40LL)
                return -1;
              x18 = XVECEXP (x6, 0, 10);
              if (XWINT (x18, 0) != 9LL)
                return -1;
              x19 = XVECEXP (x6, 0, 11);
              if (XWINT (x19, 0) != 41LL)
                return -1;
              x20 = XVECEXP (x6, 0, 12);
              if (XWINT (x20, 0) != 10LL)
                return -1;
              x21 = XVECEXP (x6, 0, 13);
              if (XWINT (x21, 0) != 42LL)
                return -1;
              x22 = XVECEXP (x6, 0, 14);
              if (XWINT (x22, 0) != 11LL)
                return -1;
              x23 = XVECEXP (x6, 0, 15);
              if (XWINT (x23, 0) != 43LL)
                return -1;
              x34 = XVECEXP (x6, 0, 24);
              if (XWINT (x34, 0) != 24LL)
                return -1;
              x35 = XVECEXP (x6, 0, 25);
              if (XWINT (x35, 0) != 56LL)
                return -1;
              x36 = XVECEXP (x6, 0, 26);
              if (XWINT (x36, 0) != 25LL)
                return -1;
              x37 = XVECEXP (x6, 0, 27);
              if (XWINT (x37, 0) != 57LL)
                return -1;
              x38 = XVECEXP (x6, 0, 28);
              if (XWINT (x38, 0) != 26LL)
                return -1;
              x39 = XVECEXP (x6, 0, 29);
              if (XWINT (x39, 0) != 58LL)
                return -1;
              x40 = XVECEXP (x6, 0, 30);
              if (XWINT (x40, 0) != 27LL)
                return -1;
              x41 = XVECEXP (x6, 0, 31);
              if (XWINT (x41, 0) != 59LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HImode:
                  if (pattern1563 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                      || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19654 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 8277; /* avx512bw_interleave_lowv32hi_mask */

                case E_V32HFmode:
                  if (pattern1563 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                      || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19654 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 8279; /* avx512bw_interleave_lowv32hf_mask */

                case E_V32BFmode:
                  if (pattern1563 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                      || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19654 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 8281; /* avx512bw_interleave_lowv32bf_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4LL:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 36LL)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 5LL)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 37LL)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 6LL)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 38LL)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 7LL)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 39LL
              || pattern1867 (x6) != 0)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 20LL)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 52LL)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 21LL)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 53LL)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 22LL)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 54LL)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 23LL)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 55LL
              || pattern1872 (x6) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern1563 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                  || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19586 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8259; /* avx512bw_interleave_highv32hi_mask */

            case E_V32HFmode:
              if (pattern1563 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                  || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19586 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8261; /* avx512bw_interleave_highv32hf_mask */

            case E_V32BFmode:
              if (pattern1563 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                  || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19586 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8263; /* avx512bw_interleave_highv32bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_193 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern151 (x2))
    {
    case 0:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24108 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512BW && TARGET_AVX512VL)))
        return -1;
      return 8681; /* avx2_sign_extendv16qiv16hi2_mask */

    case 1:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24162 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8689; /* avx512bw_sign_extendv32qiv32hi2_mask */

    case 2:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24232 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL)))
        return -1;
      return 8701; /* *sse4_1_sign_extendv8qiv8hi2_mask_1 */

    case 3:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24357 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8713; /* avx512f_sign_extendv16qiv16si2_mask */

    case 4:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8741; /* avx512f_sign_extendv16hiv16si2_mask */

    case 5:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8721; /* *avx2_sign_extendv8qiv8si2_mask_1 */

    case 6:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24553 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8749; /* avx2_sign_extendv8hiv8si2_mask */

    case 7:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24450 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8733; /* *sse4_1_sign_extendv4qiv4si2_mask_1 */

    case 8:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24623 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8761; /* *sse4_1_sign_extendv4hiv4si2_mask_1 */

    case 9:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24754 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8777; /* *avx512f_sign_extendv8qiv8di2_mask_1 */

    case 10:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8808; /* avx512f_sign_extendv8hiv8di2_mask */

    case 11:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25062 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8836; /* avx512f_sign_extendv8siv8di2_mask */

    case 12:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24812 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8789; /* *avx2_sign_extendv4qiv4di2_mask_1 */

    case 13:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24955 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8816; /* *avx2_sign_extendv4hiv4di2_mask_1 */

    case 14:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25113 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8842; /* avx2_sign_extendv4siv4di2_mask */

    case 15:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24874 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8801; /* *sse4_1_sign_extendv2qiv2di2_mask_1 */

    case 16:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25013 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8828; /* *sse4_1_sign_extendv2hiv2di2_mask_1 */

    case 17:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25179 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8852; /* *sse4_1_sign_extendv2siv2di2_mask_1 */

    case 18:
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern893 (x2))
        {
        case 0:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24220 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL)))
            return 8697; /* sse4_1_sign_extendv8qiv8hi2_mask */
          break;

        case 1:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24378 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8717; /* avx2_sign_extendv8qiv8si2_mask */
          break;

        case 2:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24744 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return 8773; /* avx512f_sign_extendv8qiv8di2_mask */
          break;

        case 3:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24438 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8729; /* sse4_1_sign_extendv4qiv4si2_mask */
          break;

        case 4:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8757; /* sse4_1_sign_extendv4hiv4si2_mask */
          break;

        case 5:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24801 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8785; /* avx2_sign_extendv4qiv4di2_mask */
          break;

        case 6:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24944 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8812; /* avx2_sign_extendv4hiv4di2_mask */
          break;

        case 7:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24862 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8797; /* sse4_1_sign_extendv2qiv2di2_mask */
          break;

        case 8:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25001 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8824; /* sse4_1_sign_extendv2hiv2di2_mask */
          break;

        case 9:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25167 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8848; /* sse4_1_sign_extendv2siv2di2_mask */
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return -1;
      switch (pattern896 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24256 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8705; /* *sse4_1_sign_extendv8qiv8hi2_mask_2 */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8725; /* *avx2_sign_extendv8qiv8si2_mask_2 */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24772 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ())))
            return -1;
          return 8781; /* *avx512f_sign_extendv8qiv8di2_mask_2 */

        case 3:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24642 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8765; /* *sse4_1_sign_extendv4hiv4si2_mask_2 */

        case 4:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8820; /* *avx2_sign_extendv4hiv4di2_mask_2 */

        case 5:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25197 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8856; /* *sse4_1_sign_extendv2siv2di2_mask_2 */

        case 6:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24473 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8737; /* *sse4_1_sign_extendv4qiv4si2_mask_2 */

        case 7:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24833 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8793; /* *avx2_sign_extendv4qiv4di2_mask_2 */

        case 8:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8832; /* *sse4_1_sign_extendv2hiv2di2_mask_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_205 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern323 (x2))
    {
    case 0:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4340; /* avx512fp16_vcvtph2w_v32hi */

    case 1:
      switch (pattern638 (x2, 
E_V16SImode))
        {
        case 0:
          if (!(
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4348; /* avx512fp16_vcvtph2dq_v16si */

        case 1:
          if (!
#line 8686 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4768; /* avx512f_fix_notruncv16sfv16si */

        default:
          return -1;
        }

    case 2:
      switch (pattern637 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4356; /* avx512fp16_vcvtph2qq_v8di */

        case 1:
          if (!(
#line 8707 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4784; /* *avx512dq_cvtps2qqv8di */

        case 2:
          if (!(
#line 9697 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5010; /* fix_notruncv8dfv8di2 */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4364; /* avx512fp16_vcvtph2w_v16hi */

    case 4:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x2) != E_V8SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4372; /* avx512fp16_vcvtph2dq_v8si */

        case E_V8SFmode:
          if (!vector_operand (operands[1], E_V8SFmode)
              || !(
#line 8670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1) && 
#line 665 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4764; /* avx_fix_notruncv8sfv8si */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !
#line 9388 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4928; /* avx512f_cvtpd2dq512 */

        default:
          return -1;
        }

    case 5:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x2) != E_V4DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4380; /* avx512fp16_vcvtph2qq_v4di */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 8707 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4788; /* *avx512dq_cvtps2qqv4di */

        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode)
              || !(
#line 9697 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5014; /* fix_notruncv4dfv4di2 */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4388; /* avx512fp16_vcvtph2w_v8hi */

    case 7:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4396; /* avx512fp16_vcvtph2dq_v4si */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !
#line 8670 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 4766; /* sse2_fix_notruncv4sfv4si */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 9398 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 4932; /* avx_cvtpd2dq256 */

        default:
          return -1;
        }

    case 8:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4404; /* avx512fp16_vcvtph2qq_v2di */

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !(
#line 9697 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5016; /* fix_notruncv2dfv2di2 */

        default:
          return -1;
        }

    case 9:
      if (!
#line 8720 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 4790; /* *avx512dq_cvtps2qqv2di */

    default:
      return -1;
    }
}

 int
recog_215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern321 (x2))
    {
    case 0:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2461; /* *avx512f_loadv16si */

    case 1:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2462; /* *avx512vl_loadv8si */

    case 2:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2463; /* *avx512vl_loadv4si */

    case 3:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2464; /* *avx512f_loadv8di */

    case 4:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2465; /* *avx512vl_loadv4di */

    case 5:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2466; /* *avx512vl_loadv2di */

    case 6:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2467; /* *avx512f_loadv16sf */

    case 7:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2468; /* *avx512vl_loadv8sf */

    case 8:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2469; /* *avx512vl_loadv4sf */

    case 9:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2470; /* *avx512f_loadv8df */

    case 10:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2471; /* *avx512vl_loadv4df */

    case 11:
      if (!(
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2472; /* *avx512vl_loadv2df */

    case 12:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2485; /* *avx512bw_loadv64qi */

    case 13:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2486; /* *avx512vl_loadv16qi */

    case 14:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2487; /* *avx512vl_loadv32qi */

    case 15:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2488; /* *avx512bw_loadv32hi */

    case 16:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2489; /* *avx512vl_loadv16hi */

    case 17:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2490; /* *avx512vl_loadv8hi */

    case 18:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2491; /* *avx512bw_loadv32hf */

    case 19:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2492; /* *avx512vl_loadv16hf */

    case 20:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2493; /* *avx512fp16_loadv8hf */

    case 21:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2494; /* *avx512bw_loadv32bf */

    case 22:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2495; /* *avx512vl_loadv16bf */

    case 23:
      if (!(
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2496; /* *avx512vl_loadv8bf */

    default:
      return -1;
    }
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (XINT (x3, 1))
    {
    case 156:
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1008 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4337; /* avx512fp16_vcvtph2uw_v32hi_round */

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x2) != E_V16SImode
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16HFmode:
              if (!register_operand (operands[1], E_V16HFmode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4345; /* avx512fp16_vcvtph2udq_v16si_round */

            case E_V16SFmode:
              if (!nonimmediate_operand (operands[1], E_V16SFmode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8697 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 674 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4773; /* *avx512f_fixuns_notruncv16sfv16si_round */

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1207 (x2, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4353; /* avx512fp16_vcvtph2uqq_v8di_round */

            case 1:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8730 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
							      || V8DImode == V8DFmode
							      || V8DImode == V8DImode
							      || V8DImode == V16SImode
							      || V8DImode == V32HFmode)) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4793; /* *avx512dq_cvtps2uqqv8di_round */

            case 2:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9708 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 5019; /* fixuns_notruncv8dfv8di2_round */

            default:
              return -1;
            }

        case E_V16HImode:
          if (pattern1008 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4361; /* avx512fp16_vcvtph2uw_v16hi_round */

        case E_V8SImode:
          switch (pattern1207 (x2, 
E_V8SImode))
            {
            case 0:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4369; /* avx512fp16_vcvtph2udq_v8si_round */

            case 1:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8697 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 674 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4777; /* *avx512vl_fixuns_notruncv8sfv8si_round */

            case 2:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9489 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4939; /* fixuns_notruncv8dfv8si2_round */

            default:
              return -1;
            }

        case E_V4DImode:
          if (pattern1008 (x2, 
E_V8HFmode, 
E_V4DImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4377; /* avx512fp16_vcvtph2uqq_v4di_round */

        case E_V8HImode:
          if (pattern1008 (x2, 
E_V8HFmode, 
E_V8HImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4385; /* avx512fp16_vcvtph2uw_v8hi_round */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_V4SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4393; /* avx512fp16_vcvtph2udq_v4si_round */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8697 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 674 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4781; /* *avx512vl_fixuns_notruncv4sfv4si_round */

            case E_V4DFmode:
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9489 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4943; /* fixuns_notruncv4dfv4si2_round */

            default:
              return -1;
            }

        case E_V2DImode:
          if (pattern1008 (x2, 
E_V8HFmode, 
E_V2DImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4401; /* avx512fp16_vcvtph2uqq_v2di_round */

        default:
          return -1;
        }

    case 46:
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1008 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4341; /* avx512fp16_vcvtph2w_v32hi_round */

        case E_V16SImode:
          switch (pattern1010 (x2))
            {
            case 0:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4349; /* avx512fp16_vcvtph2dq_v16si_round */

            case 1:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8686 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4769; /* avx512f_fix_notruncv16sfv16si_round */

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x2) != E_V8DImode
              || GET_MODE (x3) != E_V8DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4357; /* avx512fp16_vcvtph2qq_v8di_round */

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8707 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
							      || V8DImode == V8DFmode
							      || V8DImode == V8DImode
							      || V8DImode == V16SImode
							      || V8DImode == V32HFmode)) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4785; /* *avx512dq_cvtps2qqv8di_round */

            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9697 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 5011; /* fix_notruncv8dfv8di2_round */

            default:
              return -1;
            }

        case E_V16HImode:
          if (pattern1008 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4365; /* avx512fp16_vcvtph2w_v16hi_round */

        case E_V8SImode:
          switch (pattern1009 (x2))
            {
            case 0:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4373; /* avx512fp16_vcvtph2dq_v8si_round */

            case 1:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9388 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4929; /* avx512f_cvtpd2dq512_round */

            default:
              return -1;
            }

        case E_V4DImode:
          if (pattern1008 (x2, 
E_V8HFmode, 
E_V4DImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4381; /* avx512fp16_vcvtph2qq_v4di_round */

        case E_V8HImode:
          if (pattern1008 (x2, 
E_V8HFmode, 
E_V8HImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4389; /* avx512fp16_vcvtph2w_v8hi_round */

        case E_V4SImode:
          if (pattern1008 (x2, 
E_V8HFmode, 
E_V4SImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4397; /* avx512fp16_vcvtph2dq_v4si_round */

        case E_V2DImode:
          if (pattern1008 (x2, 
E_V8HFmode, 
E_V2DImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4405; /* avx512fp16_vcvtph2qq_v2di_round */

        default:
          return -1;
        }

    case 172:
      switch (pattern1011 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4495; /* unspec_avx512fp16_fix_truncv8hi2_round */

        case 1:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4503; /* unspec_avx512fp16_fix_truncv16hi2_round */

        case 2:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4511; /* unspec_avx512fp16_fix_truncv32hi2_round */

        case 3:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4519; /* unspec_avx512fp16_fix_truncv8si2_round */

        case 4:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9547 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4950; /* unspec_fix_truncv8dfv8si2_round */

        case 5:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4527; /* unspec_avx512fp16_fix_truncv16si2_round */

        case 6:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8754 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4801; /* unspec_fix_truncv16sfv16si2_round */

        case 7:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4535; /* unspec_avx512fp16_fix_truncv8di2_round */

        case 8:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9676 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4979; /* unspec_fix_truncv8dfv8di2_round */

        case 9:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9719 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5027; /* unspec_fix_truncv8sfv8di2_round */

        default:
          return -1;
        }

    case 173:
      switch (pattern1011 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4499; /* unspec_avx512fp16_fixuns_truncv8hi2_round */

        case 1:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4507; /* unspec_avx512fp16_fixuns_truncv16hi2_round */

        case 2:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4515; /* unspec_avx512fp16_fixuns_truncv32hi2_round */

        case 3:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4523; /* unspec_avx512fp16_fixuns_truncv8si2_round */

        case 4:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9547 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4954; /* unspec_fixuns_truncv8dfv8si2_round */

        case 5:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4531; /* unspec_avx512fp16_fixuns_truncv16si2_round */

        case 6:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8754 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4805; /* unspec_fixuns_truncv16sfv16si2_round */

        case 7:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4539; /* unspec_avx512fp16_fixuns_truncv8di2_round */

        case 8:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9676 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4983; /* unspec_fixuns_truncv8dfv8di2_round */

        case 9:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9719 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5031; /* unspec_fixuns_truncv8sfv8di2_round */

        default:
          return -1;
        }

    case 165:
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1208 (x2, 
E_V32HFmode) != 0
              || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 6947; /* avx512bw_getexpv32hf_round */

        case E_V16HFmode:
          if (pattern1208 (x2, 
E_V16HFmode) != 0
              || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 6951; /* avx512vl_getexpv16hf_round */

        case E_V8HFmode:
          if (pattern1208 (x2, 
E_V8HFmode) != 0
              || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 6955; /* avx512fp16_getexpv8hf_round */

        case E_V16SFmode:
          if (pattern1208 (x2, 
E_V16SFmode) != 0
              || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 6959; /* avx512f_getexpv16sf_round */

        case E_V8SFmode:
          if (pattern1208 (x2, 
E_V8SFmode) != 0
              || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6963; /* avx512vl_getexpv8sf_round */

        case E_V4SFmode:
          if (pattern1208 (x2, 
E_V4SFmode) != 0
              || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6967; /* avx512vl_getexpv4sf_round */

        case E_V8DFmode:
          if (pattern1208 (x2, 
E_V8DFmode) != 0
              || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 6971; /* avx512f_getexpv8df_round */

        case E_V4DFmode:
          if (pattern1208 (x2, 
E_V4DFmode) != 0
              || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6975; /* avx512vl_getexpv4df_round */

        case E_V2DFmode:
          if (pattern1208 (x2, 
E_V2DFmode) != 0
              || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6979; /* avx512vl_getexpv2df_round */

        default:
          return -1;
        }

    case 149:
      if (pattern1012 (x2, 
E_V16HImode, 
E_V16SFmode) != 0
          || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29099 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9580; /* *avx512f_vcvtph2ps512_round */

    case 265:
      if (pattern1013 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32506 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 561 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10681; /* avx10_2_cvtph2ibsv32hf_round */

    case 266:
      if (pattern1013 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32506 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 561 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10685; /* avx10_2_cvtph2iubsv32hf_round */

    case 271:
      if (pattern1012 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
          || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 561 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10697; /* avx10_2_cvttph2ibsv32hf_round */

    case 272:
      if (pattern1012 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
          || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 561 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10701; /* avx10_2_cvttph2iubsv32hf_round */

    case 267:
      if (pattern1013 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10713; /* avx10_2_cvtps2ibsv16sf_round */

    case 268:
      if (pattern1013 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10717; /* avx10_2_cvtps2iubsv16sf_round */

    case 273:
      if (pattern1012 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
          || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32551 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10729; /* avx10_2_cvttps2ibsv16sf_round */

    case 274:
      if (pattern1012 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
          || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32551 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10733; /* avx10_2_cvttps2iubsv16sf_round */

    case 275:
      switch (pattern1014 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 385 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10745; /* avx10_2_vcvttps2dqsv16sf_round */

        case 1:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 386 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10761; /* avx10_2_vcvttpd2dqsv8df_round */

        case 2:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32581 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 450 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10777; /* avx10_2_vcvttpd2qqsv8df_round */

        case 3:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32592 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 617 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10793; /* avx10_2_vcvttps2qqsv8di_round */

        default:
          return -1;
        }

    case 276:
      switch (pattern1014 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 385 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10749; /* avx10_2_vcvttps2udqsv16sf_round */

        case 1:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 386 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10765; /* avx10_2_vcvttpd2udqsv8df_round */

        case 2:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32581 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 450 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10781; /* avx10_2_vcvttpd2uqqsv8df_round */

        case 3:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32592 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 617 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
            return -1;
          return 10797; /* avx10_2_vcvttps2uqqsv8di_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_238 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (pattern780 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
          || !
#line 28612 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9412; /* avx_maskloadps */

    case E_V2DFmode:
      if (pattern780 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 28612 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9413; /* avx_maskloadpd */

    case E_V4DImode:
      if (pattern781 (x3, 
E_V4DImode) != 0
          || !
#line 28612 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9414; /* avx2_maskloadq256 */

    case E_V2DImode:
      if (pattern781 (x3, 
E_V2DImode) != 0
          || !
#line 28612 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9415; /* avx2_maskloadq */

    case E_V8SFmode:
      if (pattern780 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
          || !
#line 28612 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9416; /* avx_maskloadps256 */

    case E_V4DFmode:
      if (pattern780 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
          || !
#line 28612 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9417; /* avx_maskloadpd256 */

    case E_V8SImode:
      if (pattern781 (x3, 
E_V8SImode) != 0
          || !
#line 28612 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9418; /* avx2_maskloadd256 */

    case E_V4SImode:
      if (pattern781 (x3, 
E_V4SImode) != 0
          || !
#line 28612 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9419; /* avx2_maskloadd */

    default:
      return -1;
    }
}

 int
recog_244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && (
#line 6407 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4020; /* *fma_fmaddsub_v8sf */
          if (!vector_operand (operands[1], E_V8SFmode)
              || !vector_operand (operands[2], E_V8SFmode)
              || !vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6425 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4036; /* *fma_fmaddsub_v8sf */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6407 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 4021; /* *fma_fmaddsub_v4sf */
          if (!vector_operand (operands[1], E_V4SFmode)
              || !vector_operand (operands[2], E_V4SFmode)
              || !vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6425 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4038; /* *fma_fmaddsub_v4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && (
#line 6407 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4022; /* *fma_fmaddsub_v4df */
          if (!vector_operand (operands[1], E_V4DFmode)
              || !vector_operand (operands[2], E_V4DFmode)
              || !vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6425 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4044; /* *fma_fmaddsub_v4df */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && (
#line 6407 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 4023; /* *fma_fmaddsub_v2df */
          if (!vector_operand (operands[1], E_V2DFmode)
              || !vector_operand (operands[2], E_V2DFmode)
              || !vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6425 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4046; /* *fma_fmaddsub_v2df */

        case E_V32HFmode:
          if (pattern661 (x3, 
E_V32HFmode) != 0
              || !(
#line 6425 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 4024; /* *fma_fmaddsub_v32hf */

        case E_V16HFmode:
          if (pattern661 (x3, 
E_V16HFmode) != 0
              || !(
#line 6425 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 525 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4028; /* *fma_fmaddsub_v16hf */

        case E_V8HFmode:
          if (pattern661 (x3, 
E_V8HFmode) != 0
              || !(
#line 6425 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 526 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4030; /* *fma_fmaddsub_v8hf */

        case E_V16SFmode:
          if (pattern661 (x3, 
E_V16SFmode) != 0
              || !(
#line 6425 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4032; /* *fma_fmaddsub_v16sf */

        case E_V8DFmode:
          if (pattern661 (x3, 
E_V8DFmode) != 0
              || !(
#line 6425 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4040; /* *fma_fmaddsub_v8df */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || GET_MODE (x6) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && (
#line 6476 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4084; /* *fma_fmsubadd_v8sf */
          if (!vector_operand (operands[1], E_V8SFmode)
              || !vector_operand (operands[2], E_V8SFmode)
              || !vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6495 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4100; /* *fma_fmsubadd_v8sf */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || GET_MODE (x6) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6476 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 4085; /* *fma_fmsubadd_v4sf */
          if (!vector_operand (operands[1], E_V4SFmode)
              || !vector_operand (operands[2], E_V4SFmode)
              || !vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6495 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4102; /* *fma_fmsubadd_v4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || GET_MODE (x6) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && (
#line 6476 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 4086; /* *fma_fmsubadd_v4df */
          if (!vector_operand (operands[1], E_V4DFmode)
              || !vector_operand (operands[2], E_V4DFmode)
              || !vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6495 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4108; /* *fma_fmsubadd_v4df */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || GET_MODE (x6) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && (
#line 6476 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 4087; /* *fma_fmsubadd_v2df */
          if (!vector_operand (operands[1], E_V2DFmode)
              || !vector_operand (operands[2], E_V2DFmode)
              || !vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6495 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4110; /* *fma_fmsubadd_v2df */

        case E_V32HFmode:
          if (pattern1019 (x3, 
E_V32HFmode) != 0
              || !(
#line 6495 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 4088; /* *fma_fmsubadd_v32hf */

        case E_V16HFmode:
          if (pattern1019 (x3, 
E_V16HFmode) != 0
              || !(
#line 6495 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 525 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4092; /* *fma_fmsubadd_v16hf */

        case E_V8HFmode:
          if (pattern1019 (x3, 
E_V8HFmode) != 0
              || !(
#line 6495 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 526 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4094; /* *fma_fmsubadd_v8hf */

        case E_V16SFmode:
          if (pattern1019 (x3, 
E_V16SFmode) != 0
              || !(
#line 6495 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4096; /* *fma_fmsubadd_v16sf */

        case E_V8DFmode:
          if (pattern1019 (x3, 
E_V8DFmode) != 0
              || !(
#line 6495 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4104; /* *fma_fmsubadd_v8df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern152 (x3, 
E_V32HFmode) != 0
          || !
#line 32643 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10830; /* avx10_2_minmaxpv32hf */

    case E_V16HFmode:
      if (pattern152 (x3, 
E_V16HFmode) != 0
          || !
#line 32643 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10834; /* avx10_2_minmaxpv16hf */

    case E_V8HFmode:
      if (pattern152 (x3, 
E_V8HFmode) != 0
          || !
#line 32643 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10838; /* avx10_2_minmaxpv8hf */

    case E_V16SFmode:
      if (pattern152 (x3, 
E_V16SFmode) != 0
          || !
#line 32643 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10842; /* avx10_2_minmaxpv16sf */

    case E_V8SFmode:
      if (pattern152 (x3, 
E_V8SFmode) != 0
          || !
#line 32643 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10846; /* avx10_2_minmaxpv8sf */

    case E_V4SFmode:
      if (pattern152 (x3, 
E_V4SFmode) != 0
          || !
#line 32643 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10850; /* avx10_2_minmaxpv4sf */

    case E_V8DFmode:
      if (pattern152 (x3, 
E_V8DFmode) != 0
          || !
#line 32643 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10854; /* avx10_2_minmaxpv8df */

    case E_V4DFmode:
      if (pattern152 (x3, 
E_V4DFmode) != 0
          || !
#line 32643 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10858; /* avx10_2_minmaxpv4df */

    case E_V2DFmode:
      if (pattern152 (x3, 
E_V2DFmode) != 0
          || !
#line 32643 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10862; /* avx10_2_minmaxpv2df */

    default:
      return -1;
    }
}

 int
recog_254 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern175 (x1))
    {
    case 0:
      if (!(
#line 30397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10127; /* vpshld_v32hi */

    case 1:
      if (!(
#line 30397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10129; /* vpshld_v16si */

    case 2:
      if (!(
#line 30397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10131; /* vpshld_v8di */

    case 3:
      if (!(
#line 30397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10133; /* vpshld_v16hi */

    case 4:
      if (!(
#line 30397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10135; /* vpshld_v8si */

    case 5:
      if (!(
#line 30397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10137; /* vpshld_v4di */

    case 6:
      if (!(
#line 30397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10139; /* vpshld_v8hi */

    case 7:
      if (!(
#line 30397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10141; /* vpshld_v4si */

    case 8:
      if (!(
#line 30397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10143; /* vpshld_v2di */

    default:
      return -1;
    }
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      if (pattern152 (x3, 
E_V32QImode) != 0)
        return -1;
      if ((
#line 23785 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 8647; /* avx2_mpsadbw */
      if (!(
#line 23819 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8651; /* *avx2_mpsadbw */

    case E_V16QImode:
      if (pattern152 (x3, 
E_V16QImode) != 0)
        return -1;
      if (
#line 23785 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
        return 8648; /* sse4_1_mpsadbw */
      if (!
#line 23819 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 8653; /* *sse4_1_mpsadbw */

    case E_V64QImode:
      if (pattern152 (x3, 
E_V64QImode) != 0
          || !
#line 23807 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 8649; /* avx10_2_mpsadbw */

    default:
      return -1;
    }
}

 int
recog_264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (XVECLEN (x4, 0))
    {
    case 2:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !nonimmediate_operand (operands[2], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 11661 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 5182; /* sse_loadlps */

        case E_V4DImode:
          if (pattern1213 (x2, 
E_V4DImode, 
E_V2DImode) != 0
              || !
#line 28423 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 9388; /* vec_set_lo_v4di */

        case E_V4DFmode:
          if (pattern1213 (x2, 
E_V4DFmode, 
E_V2DFmode) != 0
              || !
#line 28423 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 9390; /* vec_set_lo_v4df */

        default:
          return -1;
        }

    case 1:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !nonimmediate_operand (operands[2], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !nonimm_or_0_operand (operands[1], E_V2DFmode)
          || !
#line 14773 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7142; /* sse2_loadlpd */

    case 8:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 10]
          || pattern1214 (x4, 
15, 
14, 
13, 
12, 
11) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1213 (x2, 
E_V16SFmode, 
E_V8SFmode) != 0
              || !(
#line 20081 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8324; /* vec_set_lo_v16sf */

        case E_V16SImode:
          if (pattern1213 (x2, 
E_V16SImode, 
E_V8SImode) != 0
              || !(
#line 20081 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8326; /* vec_set_lo_v16si */

        case E_V16HImode:
          if (pattern1213 (x2, 
E_V16HImode, 
E_V8HImode) != 0
              || !
#line 28520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9404; /* vec_set_lo_v16hi */

        case E_V16HFmode:
          if (pattern1213 (x2, 
E_V16HFmode, 
E_V8HFmode) != 0
              || !
#line 28520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9405; /* vec_set_lo_v16hf */

        case E_V16BFmode:
          if (pattern1213 (x2, 
E_V16BFmode, 
E_V8BFmode) != 0
              || !
#line 28520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9406; /* vec_set_lo_v16bf */

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern1213 (x2, 
E_V8DFmode, 
E_V4DFmode) != 0
              || !(
#line 20113 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8332; /* vec_set_lo_v8df */

        case E_V8DImode:
          if (pattern1213 (x2, 
E_V8DImode, 
E_V4DImode) != 0
              || !(
#line 20113 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8334; /* vec_set_lo_v8di */

        case E_V8SImode:
          if (pattern1213 (x2, 
E_V8SImode, 
E_V4SImode) != 0
              || !
#line 28472 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9396; /* vec_set_lo_v8si */

        case E_V8SFmode:
          if (pattern1213 (x2, 
E_V8SFmode, 
E_V4SFmode) != 0
              || !
#line 28472 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9398; /* vec_set_lo_v8sf */

        default:
          return -1;
        }

    case 16:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 18]
          || pattern1214 (x4, 
23, 
22, 
21, 
20, 
19) != 0)
        return -1;
      x11 = XVECEXP (x4, 0, 8);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
        return -1;
      x12 = XVECEXP (x4, 0, 9);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
        return -1;
      x13 = XVECEXP (x4, 0, 10);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
        return -1;
      x14 = XVECEXP (x4, 0, 11);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
        return -1;
      x15 = XVECEXP (x4, 0, 12);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
        return -1;
      x16 = XVECEXP (x4, 0, 13);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
        return -1;
      x17 = XVECEXP (x4, 0, 14);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 30])
        return -1;
      x18 = XVECEXP (x4, 0, 15);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || pattern1213 (x2, 
E_V32QImode, 
E_V16QImode) != 0
          || !
#line 28568 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9410; /* vec_set_lo_v32qi */

    default:
      return -1;
    }
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 46:
          if (GET_MODE (x3) == E_V4SImode
              && pattern788 (x2, 
E_V4SImode, 
E_V4DFmode, 
E_V8SImode) == 0
              && 
#line 9419 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
            return 4934; /* *avx_cvtpd2dq256_2 */
          if (GET_MODE (x3) != E_V2SImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != CONST_VECTOR
              || pattern510 (x5, 
E_V2SImode, 
2) != 0
              || !register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !vector_operand (operands[1], E_V2DFmode)
              || !
#line 9432 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 4935; /* sse2_cvtpd2dq */

        case 156:
          if (pattern664 (x2) != 0
              || !
#line 9502 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4946; /* fixuns_notruncv2dfv2si2 */

        case 173:
          if (pattern664 (x2) != 0
              || !
#line 9569 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4965; /* *unspec_fixuns_truncv2dfv2si2 */

        case 253:
          if (GET_MODE (x3) != E_V8QImode
              || pattern788 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10419; /* *vcvtph2bf8v8hf */

        case 254:
          if (GET_MODE (x3) != E_V8QImode
              || pattern788 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10420; /* *vcvtph2bf8sv8hf */

        case 255:
          if (GET_MODE (x3) != E_V8QImode
              || pattern788 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10421; /* *vcvtph2hf8v8hf */

        case 256:
          if (GET_MODE (x3) != E_V8QImode
              || pattern788 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10422; /* *vcvtph2hf8sv8hf */

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (XINT (x3, 1))
        {
        case 150:
          if (GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_V4SFmode)
              || !const_0_to_255_operand (operands[2], E_SImode)
              || !const0_operand (operands[3], E_V4HImode)
              || !
#line 29135 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((TARGET_F16C || TARGET_AVX512VL) && 1))
            return -1;
          return 9583; /* *vcvtps2ph */

        case 245:
          if (pattern911 (x2) != 0
              || !
#line 31772 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10395; /* *vcvtbiasph2bf8v8hf */

        case 246:
          if (pattern911 (x2) != 0
              || !
#line 31772 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10396; /* *vcvtbiasph2bf8sv8hf */

        case 247:
          if (pattern911 (x2) != 0
              || !
#line 31772 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10397; /* *vcvtbiasph2hf8v8hf */

        case 248:
          if (pattern911 (x2) != 0
              || !
#line 31772 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10398; /* *vcvtbiasph2hf8sv8hf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_270 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 2);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 5918 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3762; /* *fma_fmadd_v4sf */
          if (!bcst_vector_operand (operands[1], E_V4SFmode)
              || !bcst_vector_operand (operands[2], E_V4SFmode)
              || !bcst_vector_operand (operands[3], E_V4SFmode)
              || !(
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3782; /* *fma_fmadd_v4sf */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && 
#line 5918 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3763; /* *fma_fmadd_v2df */
          if (!bcst_vector_operand (operands[1], E_V2DFmode)
              || !bcst_vector_operand (operands[2], E_V2DFmode)
              || !bcst_vector_operand (operands[3], E_V2DFmode)
              || !(
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3791; /* *fma_fmadd_v2df */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && 
#line 5918 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3764; /* *fma_fmadd_v8sf */
          if (!bcst_vector_operand (operands[1], E_V8SFmode)
              || !bcst_vector_operand (operands[2], E_V8SFmode)
              || !bcst_vector_operand (operands[3], E_V8SFmode)
              || !(
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3780; /* *fma_fmadd_v8sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && 
#line 5918 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3765; /* *fma_fmadd_v4df */
          if (!bcst_vector_operand (operands[1], E_V4DFmode)
              || !bcst_vector_operand (operands[2], E_V4DFmode)
              || !bcst_vector_operand (operands[3], E_V4DFmode)
              || !(
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3789; /* *fma_fmadd_v4df */

        case E_V32HFmode:
          if (pattern858 (x2, 
E_V32HFmode) != 0
              || !(
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5931 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3766; /* *fma_fmadd_v32hf */

        case E_V16HFmode:
          if (pattern858 (x2, 
E_V16HFmode) != 0
              || !(
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3770; /* *fma_fmadd_v16hf */

        case E_V8HFmode:
          if (pattern858 (x2, 
E_V8HFmode) != 0
              || !(
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5933 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3772; /* *fma_fmadd_v8hf */

        case E_V16SFmode:
          if (pattern858 (x2, 
E_V16SFmode) != 0
              || !(
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5935 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3776; /* *fma_fmadd_v16sf */

        case E_V8DFmode:
          if (pattern858 (x2, 
E_V8DFmode) != 0
              || !(
#line 5946 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5937 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3785; /* *fma_fmadd_v8df */

        case E_V32BFmode:
          if (pattern913 (x2, 
E_V32BFmode) != 0
              || !
#line 32143 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10554; /* avx10_2_fmaddbf16_v32bf */

        case E_V16BFmode:
          if (pattern913 (x2, 
E_V16BFmode) != 0
              || !
#line 32143 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10556; /* avx10_2_fmaddbf16_v16bf */

        case E_V8BFmode:
          if (pattern913 (x2, 
E_V8BFmode) != 0
              || !
#line 32143 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10558; /* avx10_2_fmaddbf16_v8bf */

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x4) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3825; /* *fma_fmsub_v4sf */
          if (!bcst_vector_operand (operands[1], E_V4SFmode)
              || !bcst_vector_operand (operands[2], E_V4SFmode)
              || !bcst_vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3845; /* *fma_fmsub_v4sf */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || GET_MODE (x4) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && 
#line 6017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3826; /* *fma_fmsub_v2df */
          if (!bcst_vector_operand (operands[1], E_V2DFmode)
              || !bcst_vector_operand (operands[2], E_V2DFmode)
              || !bcst_vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3854; /* *fma_fmsub_v2df */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || GET_MODE (x4) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && 
#line 6017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3827; /* *fma_fmsub_v8sf */
          if (!bcst_vector_operand (operands[1], E_V8SFmode)
              || !bcst_vector_operand (operands[2], E_V8SFmode)
              || !bcst_vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3843; /* *fma_fmsub_v8sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || GET_MODE (x4) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && 
#line 6017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3828; /* *fma_fmsub_v4df */
          if (!bcst_vector_operand (operands[1], E_V4DFmode)
              || !bcst_vector_operand (operands[2], E_V4DFmode)
              || !bcst_vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3852; /* *fma_fmsub_v4df */

        case E_V32HFmode:
          if (pattern859 (x2, 
E_V32HFmode) != 0
              || !(
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5931 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3829; /* *fma_fmsub_v32hf */

        case E_V16HFmode:
          if (pattern859 (x2, 
E_V16HFmode) != 0
              || !(
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3833; /* *fma_fmsub_v16hf */

        case E_V8HFmode:
          if (pattern859 (x2, 
E_V8HFmode) != 0
              || !(
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5933 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3835; /* *fma_fmsub_v8hf */

        case E_V16SFmode:
          if (pattern859 (x2, 
E_V16SFmode) != 0
              || !(
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5935 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3839; /* *fma_fmsub_v16sf */

        case E_V8DFmode:
          if (pattern859 (x2, 
E_V8DFmode) != 0
              || !(
#line 6049 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5937 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3848; /* *fma_fmsub_v8df */

        case E_V32BFmode:
          if (pattern914 (x2, 
E_V32BFmode) != 0
              || !
#line 32271 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10578; /* avx10_2_fmsubbf16_v32bf */

        case E_V16BFmode:
          if (pattern914 (x2, 
E_V16BFmode) != 0
              || !
#line 32271 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10580; /* avx10_2_fmsubbf16_v16bf */

        case E_V8BFmode:
          if (pattern914 (x2, 
E_V8BFmode) != 0
              || !
#line 32271 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10582; /* avx10_2_fmsubbf16_v8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern668 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 32);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 33);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 34);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 35);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x3, 0, 36);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x3, 0, 37);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x3, 0, 38);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x3, 0, 39);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x3, 0, 40);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x3, 0, 41);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x3, 0, 42);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x3, 0, 43);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x3, 0, 44);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x3, 0, 45);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x3, 0, 46);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x3, 0, 47);
  if (GET_CODE (x19) != CONST_INT)
    return -1;
  x20 = XVECEXP (x3, 0, 48);
  if (GET_CODE (x20) != CONST_INT)
    return -1;
  x21 = XVECEXP (x3, 0, 49);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XVECEXP (x3, 0, 50);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XVECEXP (x3, 0, 51);
  if (GET_CODE (x23) != CONST_INT)
    return -1;
  x24 = XVECEXP (x3, 0, 52);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x3, 0, 53);
  if (GET_CODE (x25) != CONST_INT)
    return -1;
  x26 = XVECEXP (x3, 0, 54);
  if (GET_CODE (x26) != CONST_INT)
    return -1;
  x27 = XVECEXP (x3, 0, 55);
  if (GET_CODE (x27) != CONST_INT)
    return -1;
  x28 = XVECEXP (x3, 0, 56);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XVECEXP (x3, 0, 57);
  if (GET_CODE (x29) != CONST_INT)
    return -1;
  x30 = XVECEXP (x3, 0, 58);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x3, 0, 59);
  if (GET_CODE (x31) != CONST_INT)
    return -1;
  x32 = XVECEXP (x3, 0, 60);
  if (GET_CODE (x32) != CONST_INT)
    return -1;
  x33 = XVECEXP (x3, 0, 61);
  if (GET_CODE (x33) != CONST_INT)
    return -1;
  x34 = XVECEXP (x3, 0, 62);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XVECEXP (x3, 0, 63);
  if (GET_CODE (x35) != CONST_INT
      || pattern1601 (x2, 
E_V64QImode, 
E_V128QImode) != 0)
    return -1;
  x36 = XVECEXP (x3, 0, 0);
  switch (XWINT (x36, 0))
    {
    case 8LL:
      x37 = XVECEXP (x3, 0, 1);
      if (XWINT (x37, 0) != 72LL)
        return -1;
      x38 = XVECEXP (x3, 0, 2);
      if (XWINT (x38, 0) != 9LL)
        return -1;
      x39 = XVECEXP (x3, 0, 3);
      if (XWINT (x39, 0) != 73LL)
        return -1;
      x40 = XVECEXP (x3, 0, 4);
      if (XWINT (x40, 0) != 10LL)
        return -1;
      x41 = XVECEXP (x3, 0, 5);
      if (XWINT (x41, 0) != 74LL)
        return -1;
      x42 = XVECEXP (x3, 0, 6);
      if (XWINT (x42, 0) != 11LL)
        return -1;
      x43 = XVECEXP (x3, 0, 7);
      if (XWINT (x43, 0) != 75LL)
        return -1;
      x44 = XVECEXP (x3, 0, 8);
      if (XWINT (x44, 0) != 12LL)
        return -1;
      x45 = XVECEXP (x3, 0, 9);
      if (XWINT (x45, 0) != 76LL)
        return -1;
      x46 = XVECEXP (x3, 0, 10);
      if (XWINT (x46, 0) != 13LL)
        return -1;
      x47 = XVECEXP (x3, 0, 11);
      if (XWINT (x47, 0) != 77LL)
        return -1;
      x48 = XVECEXP (x3, 0, 12);
      if (XWINT (x48, 0) != 14LL)
        return -1;
      x49 = XVECEXP (x3, 0, 13);
      if (XWINT (x49, 0) != 78LL)
        return -1;
      x50 = XVECEXP (x3, 0, 14);
      if (XWINT (x50, 0) != 15LL)
        return -1;
      x51 = XVECEXP (x3, 0, 15);
      if (XWINT (x51, 0) != 79LL)
        return -1;
      x52 = XVECEXP (x3, 0, 16);
      if (XWINT (x52, 0) != 24LL)
        return -1;
      x53 = XVECEXP (x3, 0, 17);
      if (XWINT (x53, 0) != 88LL)
        return -1;
      x54 = XVECEXP (x3, 0, 18);
      if (XWINT (x54, 0) != 25LL)
        return -1;
      x55 = XVECEXP (x3, 0, 19);
      if (XWINT (x55, 0) != 89LL)
        return -1;
      x56 = XVECEXP (x3, 0, 20);
      if (XWINT (x56, 0) != 26LL)
        return -1;
      x57 = XVECEXP (x3, 0, 21);
      if (XWINT (x57, 0) != 90LL)
        return -1;
      x58 = XVECEXP (x3, 0, 22);
      if (XWINT (x58, 0) != 27LL)
        return -1;
      x59 = XVECEXP (x3, 0, 23);
      if (XWINT (x59, 0) != 91LL)
        return -1;
      x60 = XVECEXP (x3, 0, 24);
      if (XWINT (x60, 0) != 28LL)
        return -1;
      x61 = XVECEXP (x3, 0, 25);
      if (XWINT (x61, 0) != 92LL)
        return -1;
      x62 = XVECEXP (x3, 0, 26);
      if (XWINT (x62, 0) != 29LL)
        return -1;
      x63 = XVECEXP (x3, 0, 27);
      if (XWINT (x63, 0) != 93LL)
        return -1;
      x64 = XVECEXP (x3, 0, 28);
      if (XWINT (x64, 0) != 30LL)
        return -1;
      x65 = XVECEXP (x3, 0, 29);
      if (XWINT (x65, 0) != 94LL)
        return -1;
      x66 = XVECEXP (x3, 0, 30);
      if (XWINT (x66, 0) != 31LL)
        return -1;
      x67 = XVECEXP (x3, 0, 31);
      if (XWINT (x67, 0) != 95LL
          || XWINT (x4, 0) != 40LL
          || XWINT (x5, 0) != 104LL
          || XWINT (x6, 0) != 41LL
          || XWINT (x7, 0) != 105LL
          || XWINT (x8, 0) != 42LL
          || XWINT (x9, 0) != 106LL
          || XWINT (x10, 0) != 43LL
          || XWINT (x11, 0) != 107LL
          || XWINT (x12, 0) != 44LL
          || XWINT (x13, 0) != 108LL
          || XWINT (x14, 0) != 45LL
          || XWINT (x15, 0) != 109LL
          || XWINT (x16, 0) != 46LL
          || XWINT (x17, 0) != 110LL
          || XWINT (x18, 0) != 47LL
          || XWINT (x19, 0) != 111LL
          || XWINT (x20, 0) != 56LL
          || XWINT (x21, 0) != 120LL
          || XWINT (x22, 0) != 57LL
          || XWINT (x23, 0) != 121LL
          || XWINT (x24, 0) != 58LL
          || XWINT (x25, 0) != 122LL
          || XWINT (x26, 0) != 59LL
          || XWINT (x27, 0) != 123LL
          || XWINT (x28, 0) != 60LL
          || XWINT (x29, 0) != 124LL
          || XWINT (x30, 0) != 61LL
          || XWINT (x31, 0) != 125LL
          || XWINT (x32, 0) != 62LL
          || XWINT (x33, 0) != 126LL
          || XWINT (x34, 0) != 63LL
          || XWINT (x35, 0) != 127LL
          || !
#line 19410 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 8246; /* avx512bw_interleave_highv64qi */

    case 0LL:
      x37 = XVECEXP (x3, 0, 1);
      if (XWINT (x37, 0) != 64LL)
        return -1;
      x38 = XVECEXP (x3, 0, 2);
      if (XWINT (x38, 0) != 1LL)
        return -1;
      x39 = XVECEXP (x3, 0, 3);
      if (XWINT (x39, 0) != 65LL)
        return -1;
      x40 = XVECEXP (x3, 0, 4);
      if (XWINT (x40, 0) != 2LL)
        return -1;
      x41 = XVECEXP (x3, 0, 5);
      if (XWINT (x41, 0) != 66LL)
        return -1;
      x42 = XVECEXP (x3, 0, 6);
      if (XWINT (x42, 0) != 3LL)
        return -1;
      x43 = XVECEXP (x3, 0, 7);
      if (XWINT (x43, 0) != 67LL)
        return -1;
      x44 = XVECEXP (x3, 0, 8);
      if (XWINT (x44, 0) != 4LL)
        return -1;
      x45 = XVECEXP (x3, 0, 9);
      if (XWINT (x45, 0) != 68LL)
        return -1;
      x46 = XVECEXP (x3, 0, 10);
      if (XWINT (x46, 0) != 5LL)
        return -1;
      x47 = XVECEXP (x3, 0, 11);
      if (XWINT (x47, 0) != 69LL)
        return -1;
      x48 = XVECEXP (x3, 0, 12);
      if (XWINT (x48, 0) != 6LL)
        return -1;
      x49 = XVECEXP (x3, 0, 13);
      if (XWINT (x49, 0) != 70LL)
        return -1;
      x50 = XVECEXP (x3, 0, 14);
      if (XWINT (x50, 0) != 7LL)
        return -1;
      x51 = XVECEXP (x3, 0, 15);
      if (XWINT (x51, 0) != 71LL)
        return -1;
      x52 = XVECEXP (x3, 0, 16);
      if (XWINT (x52, 0) != 16LL)
        return -1;
      x53 = XVECEXP (x3, 0, 17);
      if (XWINT (x53, 0) != 80LL)
        return -1;
      x54 = XVECEXP (x3, 0, 18);
      if (XWINT (x54, 0) != 17LL)
        return -1;
      x55 = XVECEXP (x3, 0, 19);
      if (XWINT (x55, 0) != 81LL)
        return -1;
      x56 = XVECEXP (x3, 0, 20);
      if (XWINT (x56, 0) != 18LL)
        return -1;
      x57 = XVECEXP (x3, 0, 21);
      if (XWINT (x57, 0) != 82LL)
        return -1;
      x58 = XVECEXP (x3, 0, 22);
      if (XWINT (x58, 0) != 19LL)
        return -1;
      x59 = XVECEXP (x3, 0, 23);
      if (XWINT (x59, 0) != 83LL)
        return -1;
      x60 = XVECEXP (x3, 0, 24);
      if (XWINT (x60, 0) != 20LL)
        return -1;
      x61 = XVECEXP (x3, 0, 25);
      if (XWINT (x61, 0) != 84LL)
        return -1;
      x62 = XVECEXP (x3, 0, 26);
      if (XWINT (x62, 0) != 21LL)
        return -1;
      x63 = XVECEXP (x3, 0, 27);
      if (XWINT (x63, 0) != 85LL)
        return -1;
      x64 = XVECEXP (x3, 0, 28);
      if (XWINT (x64, 0) != 22LL)
        return -1;
      x65 = XVECEXP (x3, 0, 29);
      if (XWINT (x65, 0) != 86LL)
        return -1;
      x66 = XVECEXP (x3, 0, 30);
      if (XWINT (x66, 0) != 23LL)
        return -1;
      x67 = XVECEXP (x3, 0, 31);
      if (XWINT (x67, 0) != 87LL
          || XWINT (x4, 0) != 32LL
          || XWINT (x5, 0) != 96LL
          || XWINT (x6, 0) != 33LL
          || XWINT (x7, 0) != 97LL
          || XWINT (x8, 0) != 34LL
          || XWINT (x9, 0) != 98LL
          || XWINT (x10, 0) != 35LL
          || XWINT (x11, 0) != 99LL
          || XWINT (x12, 0) != 36LL
          || XWINT (x13, 0) != 100LL
          || XWINT (x14, 0) != 37LL
          || XWINT (x15, 0) != 101LL
          || XWINT (x16, 0) != 38LL
          || XWINT (x17, 0) != 102LL
          || XWINT (x18, 0) != 39LL
          || XWINT (x19, 0) != 103LL
          || XWINT (x20, 0) != 48LL
          || XWINT (x21, 0) != 112LL
          || XWINT (x22, 0) != 49LL
          || XWINT (x23, 0) != 113LL
          || XWINT (x24, 0) != 50LL
          || XWINT (x25, 0) != 114LL
          || XWINT (x26, 0) != 51LL
          || XWINT (x27, 0) != 115LL
          || XWINT (x28, 0) != 52LL
          || XWINT (x29, 0) != 116LL
          || XWINT (x30, 0) != 53LL
          || XWINT (x31, 0) != 117LL
          || XWINT (x32, 0) != 54LL
          || XWINT (x33, 0) != 118LL
          || XWINT (x34, 0) != 55LL
          || XWINT (x35, 0) != 119LL
          || !
#line 19506 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 8252; /* avx512bw_interleave_lowv64qi */

    default:
      return -1;
    }
}

 int
recog_296 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x6 = XVECEXP (x4, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (register_operand (operands[1], E_V4SFmode)
                  && (
#line 11699 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 440 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 5185; /* avx2_vec_dupv8sf */
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9126; /* avx512vl_vec_dupv8sf */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !
#line 11711 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 5187; /* avx2_vec_dupv8sf_1 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          if (register_operand (operands[1], E_V4SFmode)
              && 
#line 11699 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 5186; /* avx2_vec_dupv4sf */
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9128; /* avx512vl_vec_dupv4sf */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x2) != E_V16SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16SFmode:
              if (!register_operand (operands[1], E_V16SFmode)
                  || !(
#line 11723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 487 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5188; /* avx512f_vec_dupv16sf_1 */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9124; /* avx512f_vec_dupv16sf */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x2) != E_V8DFmode
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 11723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 487 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5189; /* avx512f_vec_dupv8df_1 */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9130; /* avx512f_vec_dupv8df */

            default:
              return -1;
            }

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x2) != E_V16SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 9017; /* avx2_pbroadcastv16si */
              if (!(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9112; /* avx512f_vec_dupv16si */

            case E_V16SImode:
              if (!nonimmediate_operand (operands[1], E_V16SImode)
                  || !(
#line 27690 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9106; /* avx512f_vec_dupv16si_1 */

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x2) != E_V8DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 578 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 9018; /* avx2_pbroadcastv8di */
              if (!(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9118; /* avx512f_vec_dupv8di */

            case E_V8DImode:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 27690 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9107; /* avx512f_vec_dupv8di_1 */

            default:
              return -1;
            }

        case E_V64QImode:
          if (!register_operand (operands[0], E_V64QImode)
              || GET_MODE (x2) != E_V64QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 579 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9019; /* avx2_pbroadcastv64qi */
              if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9136; /* avx512bw_vec_dupv64qi */

            case E_V64QImode:
              if (!nonimmediate_operand (operands[1], E_V64QImode)
                  || !(
#line 27690 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9109; /* avx512bw_vec_dupv64qi_1 */

            default:
              return -1;
            }

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x2) != E_V32QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 579 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9020; /* avx2_pbroadcastv32qi */
              if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9140; /* avx512vl_vec_dupv32qi */

            case E_V32QImode:
              if (!nonimmediate_operand (operands[1], E_V32QImode)
                  || !
#line 27287 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9035; /* avx2_pbroadcastv32qi_1 */

            default:
              return -1;
            }

        case E_V16QImode:
          if (pattern921 (x2, 
E_V16QImode, 
E_QImode) != 0)
            return -1;
          if (
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9021; /* avx2_pbroadcastv16qi */
          if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9138; /* avx512vl_vec_dupv16qi */

        case E_V32HImode:
          if (!register_operand (operands[0], E_V32HImode)
              || GET_MODE (x2) != E_V32HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9022; /* avx2_pbroadcastv32hi */
              if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9142; /* avx512bw_vec_dupv32hi */

            case E_V32HImode:
              if (!nonimmediate_operand (operands[1], E_V32HImode)
                  || !(
#line 27690 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9108; /* avx512bw_vec_dupv32hi_1 */

            default:
              return -1;
            }

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x2) != E_V16HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9023; /* avx2_pbroadcastv16hi */
              if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9144; /* avx512vl_vec_dupv16hi */

            case E_V16HImode:
              if (!nonimmediate_operand (operands[1], E_V16HImode)
                  || !
#line 27287 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9036; /* avx2_pbroadcastv16hi_1 */

            default:
              return -1;
            }

        case E_V8HImode:
          if (pattern921 (x2, 
E_V8HImode, 
E_HImode) != 0)
            return -1;
          if (
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9024; /* avx2_pbroadcastv8hi */
          if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9146; /* avx512vl_vec_dupv8hi */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x2) != E_V8SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 581 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9025; /* avx2_pbroadcastv8si */
              if (!(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9114; /* avx512vl_vec_dupv8si */

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !
#line 27287 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9037; /* avx2_pbroadcastv8si_1 */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern921 (x2, 
E_V4SImode, 
E_SImode) != 0)
            return -1;
          if (
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9026; /* avx2_pbroadcastv4si */
          if (!(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9116; /* avx512vl_vec_dupv4si */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 582 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9027; /* avx2_pbroadcastv4di */
              if (!(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9120; /* avx512vl_vec_dupv4di */

            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !
#line 27287 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9038; /* avx2_pbroadcastv4di_1 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (pattern921 (x2, 
E_V2DImode, 
E_DImode) != 0)
            return -1;
          if (
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9028; /* avx2_pbroadcastv2di */
          if (!(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9122; /* avx512vl_vec_dupv2di */

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x2) != E_V32HFmode
              || GET_MODE (x3) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9029; /* avx2_pbroadcastv32hf */
              if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9148; /* avx512bw_vec_dupv32hf */

            case E_V32HFmode:
              if (!nonimmediate_operand (operands[1], E_V32HFmode)
                  || !(
#line 27690 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9110; /* avx512bw_vec_dupv32hf_1 */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (!register_operand (operands[0], E_V16HFmode)
              || GET_MODE (x2) != E_V16HFmode
              || GET_MODE (x3) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9030; /* avx2_pbroadcastv16hf */
              if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9150; /* avx512vl_vec_dupv16hf */

            case E_V16HFmode:
              if (!nonimmediate_operand (operands[1], E_V16HFmode)
                  || !
#line 27287 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9039; /* avx2_pbroadcastv16hf_1 */

            default:
              return -1;
            }

        case E_V8HFmode:
          if (pattern921 (x2, 
E_V8HFmode, 
E_HFmode) != 0)
            return -1;
          if (
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9031; /* avx2_pbroadcastv8hf */
          if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9152; /* avx512fp16_vec_dupv8hf */

        case E_V32BFmode:
          if (!register_operand (operands[0], E_V32BFmode)
              || GET_MODE (x2) != E_V32BFmode
              || GET_MODE (x3) != E_BFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8BFmode:
              if (!nonimmediate_operand (operands[1], E_V8BFmode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9032; /* avx2_pbroadcastv32bf */
              if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9154; /* avx512bw_vec_dupv32bf */

            case E_V32BFmode:
              if (!nonimmediate_operand (operands[1], E_V32BFmode)
                  || !(
#line 27690 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9111; /* avx512bw_vec_dupv32bf_1 */

            default:
              return -1;
            }

        case E_V16BFmode:
          if (!register_operand (operands[0], E_V16BFmode)
              || GET_MODE (x2) != E_V16BFmode
              || GET_MODE (x3) != E_BFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8BFmode:
              if (!nonimmediate_operand (operands[1], E_V8BFmode))
                return -1;
              if ((
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9033; /* avx2_pbroadcastv16bf */
              if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9156; /* avx512vl_vec_dupv16bf */

            case E_V16BFmode:
              if (!nonimmediate_operand (operands[1], E_V16BFmode)
                  || !
#line 27287 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9040; /* avx2_pbroadcastv16bf_1 */

            default:
              return -1;
            }

        case E_V8BFmode:
          if (pattern921 (x2, 
E_V8BFmode, 
E_BFmode) != 0)
            return -1;
          if (
#line 27273 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9034; /* avx2_pbroadcastv8bf */
          if (!(
#line 27723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9158; /* avx512vl_vec_dupv8bf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || GET_MODE (x3) != E_DFmode)
            return -1;
          if (register_operand (operands[1], E_V2DFmode)
              && 
#line 27678 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9105; /* avx2_vec_dupv4df */
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9132; /* avx512vl_vec_dupv4df */

        case E_V2DFmode:
          if (pattern921 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 27704 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9134; /* avx512vl_vec_dupv2df */

        default:
          return -1;
        }

    case 2:
      x6 = XVECEXP (x4, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x4, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern917 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V16SImode) != 0
              || !(
#line 28029 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9246; /* *avx512dq_broadcastv16si */

        case E_V8SImode:
          if (pattern917 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V8SImode) != 0
              || !(
#line 28029 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9248; /* *avx512dq_broadcastv8si */

        case E_V4SImode:
          if (pattern921 (x2, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 28029 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9250; /* *avx512dq_broadcastv4si */

        case E_V16SFmode:
          if (pattern917 (x2, 
E_V4SFmode, 
E_V2SFmode, 
E_V16SFmode) != 0
              || !(
#line 28029 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28014 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9252; /* *avx512dq_broadcastv16sf */

        case E_V8SFmode:
          if (pattern917 (x2, 
E_V4SFmode, 
E_V2SFmode, 
E_V8SFmode) != 0
              || !(
#line 28029 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28014 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9254; /* *avx512dq_broadcastv8sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_307 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern533 (x2))
        {
        case 0:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5771; /* *avx512bw_vpternlogv32hf_1 */

        case 1:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5798; /* *avx512vl_vpternlogv16hf_1 */

        case 2:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5825; /* *avx512fp16_vpternlogv8hf_1 */

        case 3:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5852; /* *avx512bw_vpternlogv32bf_1 */

        case 4:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5879; /* *avx512vl_vpternlogv16bf_1 */

        case 5:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5906; /* *avx512vl_vpternlogv8bf_1 */

        case 6:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5933; /* *avx512f_vpternlogv16sf_1 */

        case 7:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5960; /* *avx512vl_vpternlogv8sf_1 */

        case 8:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5987; /* *avx512vl_vpternlogv4sf_1 */

        case 9:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6014; /* *avx512f_vpternlogv8df_1 */

        case 10:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6041; /* *avx512vl_vpternlogv4df_1 */

        case 11:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6068; /* *avx512vl_vpternlogv2df_1 */

        case 12:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5774; /* *avx512bw_vpternlogv32hf_1 */

        case 13:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5801; /* *avx512vl_vpternlogv16hf_1 */

        case 14:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5828; /* *avx512fp16_vpternlogv8hf_1 */

        case 15:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5855; /* *avx512bw_vpternlogv32bf_1 */

        case 16:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5882; /* *avx512vl_vpternlogv16bf_1 */

        case 17:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5909; /* *avx512vl_vpternlogv8bf_1 */

        case 18:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5936; /* *avx512f_vpternlogv16sf_1 */

        case 19:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5963; /* *avx512vl_vpternlogv8sf_1 */

        case 20:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5990; /* *avx512vl_vpternlogv4sf_1 */

        case 21:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6017; /* *avx512f_vpternlogv8df_1 */

        case 22:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6044; /* *avx512vl_vpternlogv4df_1 */

        case 23:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6071; /* *avx512vl_vpternlogv2df_1 */

        case 24:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5777; /* *avx512bw_vpternlogv32hf_1 */

        case 25:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5804; /* *avx512vl_vpternlogv16hf_1 */

        case 26:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5831; /* *avx512fp16_vpternlogv8hf_1 */

        case 27:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5858; /* *avx512bw_vpternlogv32bf_1 */

        case 28:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5885; /* *avx512vl_vpternlogv16bf_1 */

        case 29:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5912; /* *avx512vl_vpternlogv8bf_1 */

        case 30:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5939; /* *avx512f_vpternlogv16sf_1 */

        case 31:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5966; /* *avx512vl_vpternlogv8sf_1 */

        case 32:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5993; /* *avx512vl_vpternlogv4sf_1 */

        case 33:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6020; /* *avx512f_vpternlogv8df_1 */

        case 34:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6047; /* *avx512vl_vpternlogv4df_1 */

        case 35:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6074; /* *avx512vl_vpternlogv2df_1 */

        case 36:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6839; /* *avx512bw_vpternlogv32hf_3 */

        case 37:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6848; /* *avx512vl_vpternlogv16hf_3 */

        case 38:
          if (!
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6857; /* *avx512fp16_vpternlogv8hf_3 */

        case 39:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6866; /* *avx512bw_vpternlogv32bf_3 */

        case 40:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6875; /* *avx512vl_vpternlogv16bf_3 */

        case 41:
          if (!
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6884; /* *avx512vl_vpternlogv8bf_3 */

        case 42:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6893; /* *avx512f_vpternlogv16sf_3 */

        case 43:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6902; /* *avx512vl_vpternlogv8sf_3 */

        case 44:
          if (!
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6911; /* *avx512vl_vpternlogv4sf_3 */

        case 45:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6920; /* *avx512f_vpternlogv8df_3 */

        case 46:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6929; /* *avx512vl_vpternlogv4df_3 */

        case 47:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6938; /* *avx512vl_vpternlogv2df_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6419; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6446; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6473; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6500; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6527; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6554; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6581; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6608; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6635; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6662; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6689; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6716; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern534 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6422; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6449; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6476; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6503; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6530; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6557; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6584; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6611; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6638; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6665; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6692; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6719; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern534 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6425; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6452; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6479; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6506; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6533; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6560; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6587; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6614; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6641; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6668; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6695; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6722; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x6;
          res = recog_281 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (XVECLEN (x3, 0) < 1)
            return -1;
          operands[4] = x3;
          switch (pattern801 (x2))
            {
            case 0:
              if (
#line 24143 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8685; /* *avx2_zero_extendv16qiv16hi2_2 */
              break;

            case 1:
              if (
#line 24143 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8686; /* *avx2_zero_extendv16qiv16hi2_2 */
              break;

            case 2:
              if (
#line 24143 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8687; /* *avx2_zero_extendv16qiv16hi2_2 */
              break;

            case 3:
              if ((
#line 24196 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8693; /* *avx512bw_zero_extendv32qiv32hi2_2 */
              break;

            case 4:
              if ((
#line 24196 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8694; /* *avx512bw_zero_extendv32qiv32hi2_2 */
              break;

            case 5:
              if ((
#line 24196 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8695; /* *avx512bw_zero_extendv32qiv32hi2_2 */
              break;

            case 6:
              if (
#line 24307 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8709; /* *sse4_1_zero_extendv8qiv8hi2_4 */
              break;

            case 7:
              if (
#line 24307 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8710; /* *sse4_1_zero_extendv8qiv8hi2_4 */
              break;

            case 8:
              if (
#line 24307 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8711; /* *sse4_1_zero_extendv8qiv8hi2_4 */
              break;

            case 9:
              if ((
#line 24540 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8745; /* *avx512f_zero_extendv16hiv16si2_2 */
              break;

            case 10:
              if ((
#line 24540 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8746; /* *avx512f_zero_extendv16hiv16si2_2 */
              break;

            case 11:
              if ((
#line 24540 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8747; /* *avx512f_zero_extendv16hiv16si2_2 */
              break;

            case 12:
              if (
#line 24594 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8753; /* *avx2_zero_extendv8hiv8si2_2 */
              break;

            case 13:
              if (
#line 24594 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8754; /* *avx2_zero_extendv8hiv8si2_2 */
              break;

            case 14:
              if (
#line 24594 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8755; /* *avx2_zero_extendv8hiv8si2_2 */
              break;

            case 15:
              if (
#line 24712 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8769; /* *sse4_1_zero_extendv4hiv4si2_4 */
              break;

            case 16:
              if (
#line 24712 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8770; /* *sse4_1_zero_extendv4hiv4si2_4 */
              break;

            case 17:
              if (
#line 24712 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8771; /* *sse4_1_zero_extendv4hiv4si2_4 */
              break;

            default:
              break;
            }
          operands[3] = x3;
          switch (pattern802 (x2))
            {
            case 0:
              if (!(
#line 29050 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 9549; /* *vec_concatv64qi_0_1 */

            case 1:
              if (!(
#line 29050 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 9550; /* *vec_concatv32qi_0_1 */

            case 2:
              if (!
#line 29050 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 9551; /* *vec_concatv16qi_0_1 */

            case 3:
              if (!(
#line 29050 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 9552; /* *vec_concatv32hi_0_1 */

            case 4:
              if (!(
#line 29050 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 9553; /* *vec_concatv16hi_0_1 */

            case 5:
              if (!
#line 29050 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 9554; /* *vec_concatv8hi_0_1 */

            default:
              return -1;
            }

        case SS_TRUNCATE:
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != SS_TRUNCATE)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          switch (XVECLEN (x3, 0))
            {
            case 32:
              if (pattern829 (x3) != 0)
                return -1;
              x10 = XVECEXP (x3, 0, 4);
              if (GET_CODE (x10) != CONST_INT)
                return -1;
              x11 = XVECEXP (x3, 0, 5);
              if (GET_CODE (x11) != CONST_INT)
                return -1;
              x12 = XVECEXP (x3, 0, 6);
              if (GET_CODE (x12) != CONST_INT)
                return -1;
              x13 = XVECEXP (x3, 0, 7);
              if (GET_CODE (x13) != CONST_INT)
                return -1;
              x14 = XVECEXP (x3, 0, 8);
              if (GET_CODE (x14) != CONST_INT)
                return -1;
              x15 = XVECEXP (x3, 0, 9);
              if (GET_CODE (x15) != CONST_INT)
                return -1;
              x16 = XVECEXP (x3, 0, 10);
              if (GET_CODE (x16) != CONST_INT)
                return -1;
              x17 = XVECEXP (x3, 0, 11);
              if (GET_CODE (x17) != CONST_INT
                  || pattern1673 (x3, 
23, 
22, 
21, 
20, 
8) != 0)
                return -1;
              x18 = XVECEXP (x3, 0, 17);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
                return -1;
              x19 = XVECEXP (x3, 0, 18);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
                return -1;
              x20 = XVECEXP (x3, 0, 19);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
                return -1;
              x21 = XVECEXP (x3, 0, 20);
              if (GET_CODE (x21) != CONST_INT)
                return -1;
              x22 = XVECEXP (x3, 0, 21);
              if (GET_CODE (x22) != CONST_INT)
                return -1;
              x23 = XVECEXP (x3, 0, 22);
              if (GET_CODE (x23) != CONST_INT)
                return -1;
              x24 = XVECEXP (x3, 0, 23);
              if (GET_CODE (x24) != CONST_INT)
                return -1;
              x25 = XVECEXP (x3, 0, 24);
              if (GET_CODE (x25) != CONST_INT)
                return -1;
              x26 = XVECEXP (x3, 0, 25);
              if (GET_CODE (x26) != CONST_INT)
                return -1;
              x27 = XVECEXP (x3, 0, 26);
              if (GET_CODE (x27) != CONST_INT)
                return -1;
              x28 = XVECEXP (x3, 0, 27);
              if (GET_CODE (x28) != CONST_INT
                  || pattern1843 (x3, 
31, 
30, 
29, 
28) != 0)
                return -1;
              switch (XWINT (x10, 0))
                {
                case 4LL:
                  if (XWINT (x11, 0) != 5LL
                      || XWINT (x12, 0) != 6LL
                      || XWINT (x13, 0) != 7LL
                      || XWINT (x14, 0) != 16LL
                      || XWINT (x15, 0) != 17LL
                      || XWINT (x16, 0) != 18LL
                      || XWINT (x17, 0) != 19LL
                      || XWINT (x21, 0) != 12LL
                      || XWINT (x22, 0) != 13LL
                      || XWINT (x23, 0) != 14LL
                      || XWINT (x24, 0) != 15LL
                      || pattern1868 (x3) != 0
                      || pattern1800 (x2, 
E_V16HImode, 
E_V16QImode, 
E_V32QImode) != 0
                      || !
#line 19232 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
                    return -1;
                  return 8230; /* avx2_packsswb */

                case 16LL:
                  if (XWINT (x11, 0) != 17LL
                      || XWINT (x12, 0) != 18LL
                      || XWINT (x13, 0) != 19LL
                      || XWINT (x14, 0) != 4LL
                      || XWINT (x15, 0) != 5LL
                      || XWINT (x16, 0) != 6LL
                      || XWINT (x17, 0) != 7LL
                      || XWINT (x21, 0) != 24LL
                      || XWINT (x22, 0) != 25LL
                      || XWINT (x23, 0) != 26LL
                      || XWINT (x24, 0) != 27LL
                      || XWINT (x25, 0) != 12LL
                      || XWINT (x26, 0) != 13LL
                      || XWINT (x27, 0) != 14LL
                      || XWINT (x28, 0) != 15LL
                      || pattern1800 (x2, 
E_V16SImode, 
E_V16HImode, 
E_V32HImode) != 0
                      || !
#line 19348 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
                    return -1;
                  return 8238; /* avx512bw_packssdw */

                default:
                  return -1;
                }

            case 64:
              if (pattern832 (x3, 
35, 
34, 
33, 
32) != 0
                  || pattern1673 (x3, 
39, 
38, 
37, 
36, 
8) != 0
                  || pattern1783 (x3, 
13, 
12, 
11, 
10, 
9) != 0
                  || pattern1825 (x3, 
42, 
41, 
40, 
15, 
14) != 0)
                return -1;
              x28 = XVECEXP (x3, 0, 27);
              if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 43]
                  || pattern1843 (x3, 
47, 
46, 
45, 
44) != 0)
                return -1;
              x29 = XVECEXP (x3, 0, 32);
              if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x30 = XVECEXP (x3, 0, 33);
              if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
                return -1;
              x31 = XVECEXP (x3, 0, 34);
              if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
                return -1;
              x32 = XVECEXP (x3, 0, 35);
              if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
                return -1;
              x33 = XVECEXP (x3, 0, 36);
              if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
                return -1;
              x34 = XVECEXP (x3, 0, 37);
              if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
                return -1;
              x35 = XVECEXP (x3, 0, 38);
              if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
                return -1;
              x36 = XVECEXP (x3, 0, 39);
              if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
                return -1;
              x37 = XVECEXP (x3, 0, 40);
              if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 48])
                return -1;
              x38 = XVECEXP (x3, 0, 41);
              if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 49])
                return -1;
              x39 = XVECEXP (x3, 0, 42);
              if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 50])
                return -1;
              x40 = XVECEXP (x3, 0, 43);
              if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 51])
                return -1;
              x41 = XVECEXP (x3, 0, 44);
              if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 52])
                return -1;
              x42 = XVECEXP (x3, 0, 45);
              if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 53])
                return -1;
              x43 = XVECEXP (x3, 0, 46);
              if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 54])
                return -1;
              x44 = XVECEXP (x3, 0, 47);
              if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 55])
                return -1;
              x45 = XVECEXP (x3, 0, 48);
              if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
                return -1;
              x46 = XVECEXP (x3, 0, 49);
              if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
                return -1;
              x47 = XVECEXP (x3, 0, 50);
              if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
                return -1;
              x48 = XVECEXP (x3, 0, 51);
              if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
                return -1;
              x49 = XVECEXP (x3, 0, 52);
              if (x49 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
                return -1;
              x50 = XVECEXP (x3, 0, 53);
              if (x50 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
                return -1;
              x51 = XVECEXP (x3, 0, 54);
              if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 30])
                return -1;
              x52 = XVECEXP (x3, 0, 55);
              if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
                return -1;
              x53 = XVECEXP (x3, 0, 56);
              if (x53 != const_int_rtx[MAX_SAVED_CONST_INT + 56])
                return -1;
              x54 = XVECEXP (x3, 0, 57);
              if (x54 != const_int_rtx[MAX_SAVED_CONST_INT + 57])
                return -1;
              x55 = XVECEXP (x3, 0, 58);
              if (x55 != const_int_rtx[MAX_SAVED_CONST_INT + 58])
                return -1;
              x56 = XVECEXP (x3, 0, 59);
              if (x56 != const_int_rtx[MAX_SAVED_CONST_INT + 59])
                return -1;
              x57 = XVECEXP (x3, 0, 60);
              if (x57 != const_int_rtx[MAX_SAVED_CONST_INT + 60])
                return -1;
              x58 = XVECEXP (x3, 0, 61);
              if (x58 != const_int_rtx[MAX_SAVED_CONST_INT + 61])
                return -1;
              x59 = XVECEXP (x3, 0, 62);
              if (x59 != const_int_rtx[MAX_SAVED_CONST_INT + 62])
                return -1;
              x60 = XVECEXP (x3, 0, 63);
              if (x60 != const_int_rtx[MAX_SAVED_CONST_INT + 63]
                  || pattern1800 (x2, 
E_V32HImode, 
E_V32QImode, 
E_V64QImode) != 0
                  || !
#line 19279 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
                return -1;
              return 8232; /* avx512bw_packsswb */

            case 16:
              if (pattern830 (x3, 
10, 
9, 
8) != 0
                  || pattern1490 (x3, 
7, 
6, 
5, 
4, 
11) != 0
                  || pattern1800 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V16HImode) != 0
                  || !
#line 19318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
                return -1;
              return 8236; /* avx2_packssdw */

            default:
              return -1;
            }

        case VEC_CONCAT:
          switch (pattern521 (x2))
            {
            case 0:
              if (!
#line 25095 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 8840; /* *avx512f_zero_extendv8siv8di2_2 */

            case 1:
              if (!
#line 25147 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8846; /* *avx2_zero_extendv4siv4di2_2 */

            case 2:
              if (!
#line 25243 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8860; /* *sse4_1_zero_extendv2siv2di2_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      res = recog_295 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != SUBREG)
        return -1;
      switch (pattern523 (x2))
        {
        case 0:
          if (!
#line 15021 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512 && ix86_pre_reload_split ()))
            return -1;
          return 7163; /* *avx512bw_permvar_truncv16siv16hi_1_hf */

        case 1:
          if (!
#line 15074 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW && ix86_pre_reload_split ()))
            return -1;
          return 7165; /* *avx512f_permvar_truncv8siv8hi_1_hf */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x5, 0))
        {
        case 2:
          switch (pattern525 (x2))
            {
            case 0:
              if (!
#line 14996 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512 && ix86_pre_reload_split ()))
                return -1;
              return 7162; /* *avx512bw_permvar_truncv16siv16hi_1 */

            case 1:
              if (!
#line 15258 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512VBMI
   && ix86_pre_reload_split ()))
                return -1;
              return 7195; /* *avx512f_permvar_truncv16hiv16qi_1 */

            case 2:
              if (!
#line 15053 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW && ix86_pre_reload_split ()))
                return -1;
              return 7164; /* *avx512f_permvar_truncv8siv8hi_1 */

            case 3:
              if (!
#line 15105 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
                return -1;
              return 7166; /* *avx512f_vpermvar_truncv8div8si_1 */

            case 4:
              if (!
#line 15177 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512 && ix86_pre_reload_split ()))
                return -1;
              return 7182; /* *avx512f_permvar_truncv32hiv32qi_1 */

            case 5:
              if (!
#line 15277 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
                return -1;
              return 7196; /* *avx512f_permvar_truncv4div4si_1 */

            default:
              return -1;
            }

        case 1:
          if (XINT (x5, 1) != 149
              || GET_MODE (x5) != E_V8SFmode
              || XVECLEN (x3, 0) != 4
              || pattern829 (x3) != 0
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          x61 = XVECEXP (x5, 0, 0);
          operands[1] = x61;
          if (!register_operand (operands[1], E_V8HImode)
              || !
#line 29067 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
            return -1;
          return 9573; /* vcvtph2ps */

        case 4:
          if (pnum_clobbers == NULL
              || XINT (x5, 1) != 153)
            return -1;
          x62 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x62) != MEM)
            return -1;
          x63 = XEXP (x62, 0);
          if (GET_CODE (x63) != UNSPEC
              || XVECLEN (x63, 0) != 3
              || XINT (x63, 1) != 154)
            return -1;
          x64 = XVECEXP (x5, 0, 2);
          if (GET_CODE (x64) != MEM
              || GET_MODE (x64) != E_BLKmode)
            return -1;
          x65 = XEXP (x64, 0);
          if (GET_CODE (x65) != SCRATCH
              || XVECLEN (x3, 0) != 4
              || pattern829 (x3) != 0)
            return -1;
          x66 = XVECEXP (x63, 0, 1);
          if (!register_operand (x66, E_V4DImode))
            return -1;
          x67 = XVECEXP (x63, 0, 2);
          if (!const1248_operand (x67, E_SImode))
            return -1;
          x61 = XVECEXP (x5, 0, 0);
          switch (GET_CODE (x61))
            {
            case REG:
            case SUBREG:
              operands[2] = x61;
              operands[7] = x62;
              x68 = XVECEXP (x63, 0, 0);
              operands[3] = x68;
              operands[4] = x66;
              operands[6] = x67;
              x69 = XVECEXP (x5, 0, 3);
              operands[5] = x69;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  switch (pattern1820 (x2, 
E_V4SImode, 
E_SImode, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29394 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9660; /* *avx2_gatherdiv8si_3 */

                    case 1:
                      if (!(
#line 29394 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9662; /* *avx2_gatherdiv8si_3 */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  switch (pattern1820 (x2, 
E_V4SFmode, 
E_SFmode, 
E_V8SFmode))
                    {
                    case 0:
                      if (!(
#line 29394 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9661; /* *avx2_gatherdiv8sf_3 */

                    case 1:
                      if (!(
#line 29394 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9663; /* *avx2_gatherdiv8sf_3 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case PC:
              operands[6] = x62;
              x68 = XVECEXP (x63, 0, 0);
              operands[2] = x68;
              operands[3] = x66;
              operands[5] = x67;
              x69 = XVECEXP (x5, 0, 3);
              operands[4] = x69;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  switch (pattern1814 (x2, 
E_V4SImode, 
E_SImode, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29418 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9664; /* *avx2_gatherdiv8si_4 */

                    case 1:
                      if (!(
#line 29418 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9666; /* *avx2_gatherdiv8si_4 */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  switch (pattern1814 (x2, 
E_V4SFmode, 
E_SFmode, 
E_V8SFmode))
                    {
                    case 0:
                      if (!(
#line 29418 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9665; /* *avx2_gatherdiv8sf_4 */

                    case 1:
                      if (!(
#line 29418 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9667; /* *avx2_gatherdiv8sf_4 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      return recog_270 (x1, insn, pnum_clobbers);

    case NEG:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x5) != E_V4SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4SFmode)
                  && nonimmediate_operand (operands[2], E_V4SFmode)
                  && nonimmediate_operand (operands[3], E_V4SFmode)
                  && 
#line 6123 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3888; /* *fma_fnmadd_v4sf */
              if (!bcst_vector_operand (operands[1], E_V4SFmode)
                  || !bcst_vector_operand (operands[2], E_V4SFmode)
                  || !bcst_vector_operand (operands[3], E_V4SFmode)
                  || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3908; /* *fma_fnmadd_v4sf */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || GET_MODE (x5) != E_V2DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_V2DFmode)
                  && nonimmediate_operand (operands[2], E_V2DFmode)
                  && nonimmediate_operand (operands[3], E_V2DFmode)
                  && 
#line 6123 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3889; /* *fma_fnmadd_v2df */
              if (!bcst_vector_operand (operands[1], E_V2DFmode)
                  || !bcst_vector_operand (operands[2], E_V2DFmode)
                  || !bcst_vector_operand (operands[3], E_V2DFmode)
                  || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3917; /* *fma_fnmadd_v2df */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x3) != E_V8SFmode
                  || GET_MODE (x5) != E_V8SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8SFmode)
                  && nonimmediate_operand (operands[2], E_V8SFmode)
                  && nonimmediate_operand (operands[3], E_V8SFmode)
                  && 
#line 6123 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3890; /* *fma_fnmadd_v8sf */
              if (!bcst_vector_operand (operands[1], E_V8SFmode)
                  || !bcst_vector_operand (operands[2], E_V8SFmode)
                  || !bcst_vector_operand (operands[3], E_V8SFmode)
                  || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3906; /* *fma_fnmadd_v8sf */

            case E_V4DFmode:
              if (!register_operand (operands[0], E_V4DFmode)
                  || GET_MODE (x3) != E_V4DFmode
                  || GET_MODE (x5) != E_V4DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4DFmode)
                  && nonimmediate_operand (operands[2], E_V4DFmode)
                  && nonimmediate_operand (operands[3], E_V4DFmode)
                  && 
#line 6123 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3891; /* *fma_fnmadd_v4df */
              if (!bcst_vector_operand (operands[1], E_V4DFmode)
                  || !bcst_vector_operand (operands[2], E_V4DFmode)
                  || !bcst_vector_operand (operands[3], E_V4DFmode)
                  || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3915; /* *fma_fnmadd_v4df */

            case E_V32HFmode:
              if (pattern860 (x3, 
E_V32HFmode) != 0
                  || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5931 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 3892; /* *fma_fnmadd_v32hf */

            case E_V16HFmode:
              if (pattern860 (x3, 
E_V16HFmode) != 0
                  || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3896; /* *fma_fnmadd_v16hf */

            case E_V8HFmode:
              if (pattern860 (x3, 
E_V8HFmode) != 0
                  || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5933 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3898; /* *fma_fnmadd_v8hf */

            case E_V16SFmode:
              if (pattern860 (x3, 
E_V16SFmode) != 0
                  || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5935 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3902; /* *fma_fnmadd_v16sf */

            case E_V8DFmode:
              if (pattern860 (x3, 
E_V8DFmode) != 0
                  || !(
#line 6155 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5937 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3911; /* *fma_fnmadd_v8df */

            case E_V32BFmode:
              if (pattern915 (x3, 
E_V32BFmode) != 0
                  || !
#line 32206 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10566; /* avx10_2_fnmaddbf16_v32bf */

            case E_V16BFmode:
              if (pattern915 (x3, 
E_V16BFmode) != 0
                  || !
#line 32206 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10568; /* avx10_2_fnmaddbf16_v16bf */

            case E_V8BFmode:
              if (pattern915 (x3, 
E_V8BFmode) != 0
                  || !
#line 32206 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10570; /* avx10_2_fnmaddbf16_v8bf */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern861 (x3, 
E_V4SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4SFmode)
                  && nonimmediate_operand (operands[2], E_V4SFmode)
                  && nonimmediate_operand (operands[3], E_V4SFmode)
                  && 
#line 6230 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3947; /* *fma_fnmsub_v4sf */
              if (!bcst_vector_operand (operands[1], E_V4SFmode)
                  || !bcst_vector_operand (operands[2], E_V4SFmode)
                  || !bcst_vector_operand (operands[3], E_V4SFmode)
                  || !(
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3979; /* *fma_fnmsub_v4sf */

            case E_V2DFmode:
              if (pattern861 (x3, 
E_V2DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V2DFmode)
                  && nonimmediate_operand (operands[2], E_V2DFmode)
                  && nonimmediate_operand (operands[3], E_V2DFmode)
                  && 
#line 6230 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3951; /* *fma_fnmsub_v2df */
              if (!bcst_vector_operand (operands[1], E_V2DFmode)
                  || !bcst_vector_operand (operands[2], E_V2DFmode)
                  || !bcst_vector_operand (operands[3], E_V2DFmode)
                  || !(
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3988; /* *fma_fnmsub_v2df */

            case E_V8SFmode:
              if (pattern861 (x3, 
E_V8SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8SFmode)
                  && nonimmediate_operand (operands[2], E_V8SFmode)
                  && nonimmediate_operand (operands[3], E_V8SFmode)
                  && 
#line 6230 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3955; /* *fma_fnmsub_v8sf */
              if (!bcst_vector_operand (operands[1], E_V8SFmode)
                  || !bcst_vector_operand (operands[2], E_V8SFmode)
                  || !bcst_vector_operand (operands[3], E_V8SFmode)
                  || !(
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3977; /* *fma_fnmsub_v8sf */

            case E_V4DFmode:
              if (pattern861 (x3, 
E_V4DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4DFmode)
                  && nonimmediate_operand (operands[2], E_V4DFmode)
                  && nonimmediate_operand (operands[3], E_V4DFmode)
                  && 
#line 6230 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3959; /* *fma_fnmsub_v4df */
              if (!bcst_vector_operand (operands[1], E_V4DFmode)
                  || !bcst_vector_operand (operands[2], E_V4DFmode)
                  || !bcst_vector_operand (operands[3], E_V4DFmode)
                  || !(
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3986; /* *fma_fnmsub_v4df */

            case E_V32HFmode:
              if (pattern862 (x3, 
E_V32HFmode) != 0
                  || !(
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5931 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 3963; /* *fma_fnmsub_v32hf */

            case E_V16HFmode:
              if (pattern862 (x3, 
E_V16HFmode) != 0
                  || !(
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3967; /* *fma_fnmsub_v16hf */

            case E_V8HFmode:
              if (pattern862 (x3, 
E_V8HFmode) != 0
                  || !(
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5933 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3969; /* *fma_fnmsub_v8hf */

            case E_V16SFmode:
              if (pattern862 (x3, 
E_V16SFmode) != 0
                  || !(
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5935 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3973; /* *fma_fnmsub_v16sf */

            case E_V8DFmode:
              if (pattern862 (x3, 
E_V8DFmode) != 0
                  || !(
#line 6263 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5937 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3982; /* *fma_fnmsub_v8df */

            case E_V32BFmode:
              if (pattern916 (x3, 
E_V32BFmode) != 0
                  || !
#line 32337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10590; /* avx10_2_fnmsubbf16_v32bf */

            case E_V16BFmode:
              if (pattern916 (x3, 
E_V16BFmode) != 0
                  || !
#line 32337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10592; /* avx10_2_fnmsubbf16_v16bf */

            case E_V8BFmode:
              if (pattern916 (x3, 
E_V8BFmode) != 0
                  || !
#line 32337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10594; /* avx10_2_fnmsubbf16_v8bf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32QImode:
          if (pattern806 (x3, 
E_V32QImode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8924; /* xop_pcmov_v32qi256 */

        case E_V16QImode:
          if (pattern806 (x3, 
E_V16QImode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8925; /* xop_pcmov_v16qi */

        case E_V16HImode:
          if (pattern806 (x3, 
E_V16HImode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8926; /* xop_pcmov_v16hi256 */

        case E_V8HImode:
          if (pattern806 (x3, 
E_V8HImode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8927; /* xop_pcmov_v8hi */

        case E_V8SImode:
          if (pattern806 (x3, 
E_V8SImode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8928; /* xop_pcmov_v8si256 */

        case E_V4SImode:
          if (pattern806 (x3, 
E_V4SImode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8929; /* xop_pcmov_v4si */

        case E_V4DImode:
          if (pattern806 (x3, 
E_V4DImode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8930; /* xop_pcmov_v4di256 */

        case E_V2DImode:
          if (pattern806 (x3, 
E_V2DImode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8931; /* xop_pcmov_v2di */

        case E_V2TImode:
          if (pattern806 (x3, 
E_V2TImode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8932; /* xop_pcmov_v2ti256 */

        case E_V1TImode:
          if (pattern806 (x3, 
E_V1TImode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8933; /* xop_pcmov_v1ti */

        case E_V16HFmode:
          if (pattern806 (x3, 
E_V16HFmode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8934; /* xop_pcmov_v16hf256 */

        case E_V8HFmode:
          if (pattern806 (x3, 
E_V8HFmode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8935; /* xop_pcmov_v8hf */

        case E_V8SFmode:
          if (pattern806 (x3, 
E_V8SFmode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8936; /* xop_pcmov_v8sf256 */

        case E_V4SFmode:
          if (pattern806 (x3, 
E_V4SFmode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8937; /* xop_pcmov_v4sf */

        case E_V4DFmode:
          if (pattern806 (x3, 
E_V4DFmode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8938; /* xop_pcmov_v4df256 */

        case E_V2DFmode:
          if (pattern806 (x3, 
E_V2DFmode) != 0
              || !
#line 26202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8939; /* xop_pcmov_v2df */

        default:
          return -1;
        }

    case GE:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ROTATE:
          x6 = XEXP (x3, 2);
          if (GET_CODE (x6) != ROTATERT)
            return -1;
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != NEG)
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x5, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (pattern1133 (x3))
            {
            case 0:
              if (!
#line 26648 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 8967; /* xop_vrotlv16qi3 */

            case 1:
              if (!
#line 26648 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 8968; /* xop_vrotlv8hi3 */

            case 2:
              if (!
#line 26648 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 8969; /* xop_vrotlv4si3 */

            case 3:
              if (!
#line 26648 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 8970; /* xop_vrotlv2di3 */

            default:
              return -1;
            }

        case ASHIFT:
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x5, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x6 = XEXP (x3, 2);
          switch (GET_CODE (x6))
            {
            case ASHIFTRT:
              x9 = XEXP (x6, 1);
              if (GET_CODE (x9) != NEG)
                return -1;
              switch (pattern1133 (x3))
                {
                case 0:
                  if (!
#line 26885 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8971; /* xop_shav16qi3 */

                case 1:
                  if (!
#line 26885 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8972; /* xop_shav8hi3 */

                case 2:
                  if (!
#line 26885 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8973; /* xop_shav4si3 */

                case 3:
                  if (!
#line 26885 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8974; /* xop_shav2di3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x9 = XEXP (x6, 1);
              if (GET_CODE (x9) != NEG)
                return -1;
              switch (pattern1133 (x3))
                {
                case 0:
                  if (!
#line 26904 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8975; /* xop_shlv16qi3 */

                case 1:
                  if (!
#line 26904 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8976; /* xop_shlv8hi3 */

                case 2:
                  if (!
#line 26904 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8977; /* xop_shlv4si3 */

                case 3:
                  if (!
#line 26904 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8978; /* xop_shlv2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_332 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x3) != E_V64QImode
          || !vector_operand (operands[1], E_V64QImode)
          || !(
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8574; /* *absv64qi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode
          || !vector_operand (operands[1], E_V32QImode)
          || !(
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 8575; /* *absv32qi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !vector_operand (operands[1], E_V16QImode)
          || !
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8576; /* *absv16qi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode
          || !vector_operand (operands[1], E_V32HImode)
          || !(
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8577; /* *absv32hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode
          || !vector_operand (operands[1], E_V16HImode)
          || !(
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 8578; /* *absv16hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !vector_operand (operands[1], E_V8HImode)
          || !
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8579; /* *absv8hi2 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode
          || !vector_operand (operands[1], E_V16SImode)
          || !(
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8580; /* *absv16si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !vector_operand (operands[1], E_V8SImode)
          || !(
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 8581; /* *absv8si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vector_operand (operands[1], E_V4SImode)
          || !
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8582; /* *absv4si2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode
          || !vector_operand (operands[1], E_V8DImode)
          || !(
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8583; /* *absv8di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !vector_operand (operands[1], E_V4DImode)
          || !(
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8584; /* *absv4di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vector_operand (operands[1], E_V2DImode)
          || !(
#line 23341 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8585; /* *absv2di2 */

    default:
      return -1;
    }
}

 int
recog_337 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern26 (x1))
    {
    case 0:
      if (!(
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2986; /* *sminv32hf3 */

    case 1:
      if (!(
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 390 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2992; /* *sminv16hf3 */

    case 2:
      if (!(
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 391 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2996; /* *sminv8hf3 */

    case 3:
      if (!(
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3002; /* *sminv16sf3 */

    case 4:
      if (!(
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3008; /* *sminv8sf3 */

    case 5:
      if (!
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1))
        return -1;
      return 3012; /* *sminv4sf3 */

    case 6:
      if (!(
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3018; /* *sminv8df3 */

    case 7:
      if (!(
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3024; /* *sminv4df3 */

    case 8:
      if (!(
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3028; /* *sminv2df3 */

    case 9:
      if (
#line 17653 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7686; /* *avx2_sminv32qi3 */
      if (!(
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7763; /* *avx512bw_sminv32qi3 */

    case 10:
      if (
#line 17653 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7690; /* *avx2_sminv16hi3 */
      if (!(
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7779; /* *avx512bw_sminv16hi3 */

    case 11:
      if (
#line 17653 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7694; /* *avx2_sminv8si3 */
      if (!(
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7707; /* *avx512f_sminv8si3 */

    case 12:
      if (!(
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7699; /* *avx512f_sminv16si3 */

    case 13:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7715; /* *avx512f_sminv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17797 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7799; /* *sse4_1_sminv4si3 */

    case 14:
      if (!(
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7723; /* *avx512f_sminv8di3 */

    case 15:
      if (!(
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7731; /* *avx512f_sminv4di3 */

    case 16:
      if (!(
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7739; /* *avx512f_sminv2di3 */

    case 17:
      if (!(
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7747; /* *avx512bw_sminv64qi3 */

    case 18:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7755; /* *avx512bw_sminv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17797 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7795; /* *sse4_1_sminv16qi3 */

    case 19:
      if (!(
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7771; /* *avx512bw_sminv32hi3 */

    case 20:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7787; /* *avx512bw_sminv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17816 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7802; /* *sminv8hi3 */

    case 21:
      if (!
#line 32108 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10520; /* avx10_2_sminbf16_v32bf */

    case 22:
      if (!
#line 32108 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10524; /* avx10_2_sminbf16_v16bf */

    case 23:
      if (!
#line 32108 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10528; /* avx10_2_sminbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_344 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (
#line 17653 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7687; /* *avx2_umaxv32qi3 */
      if (!(
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7765; /* *avx512bw_umaxv32qi3 */

    case 1:
      if (
#line 17653 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7691; /* *avx2_umaxv16hi3 */
      if (!(
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7781; /* *avx512bw_umaxv16hi3 */

    case 2:
      if (
#line 17653 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7695; /* *avx2_umaxv8si3 */
      if (!(
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7709; /* *avx512f_umaxv8si3 */

    case 3:
      if (!(
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7701; /* *avx512f_umaxv16si3 */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7717; /* *avx512f_umaxv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17881 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7807; /* *sse4_1_umaxv4si3 */

    case 5:
      if (!(
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7725; /* *avx512f_umaxv8di3 */

    case 6:
      if (!(
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7733; /* *avx512f_umaxv4di3 */

    case 7:
      if (!(
#line 17694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7741; /* *avx512f_umaxv2di3 */

    case 8:
      if (!(
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7749; /* *avx512bw_umaxv64qi3 */

    case 9:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7757; /* *avx512bw_umaxv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17900 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7811; /* *umaxv16qi3 */

    case 10:
      if (!(
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7773; /* *avx512bw_umaxv32hi3 */

    case 11:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17705 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7789; /* *avx512bw_umaxv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17881 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7803; /* *sse4_1_umaxv8hi3 */

    default:
      return -1;
    }
}

 int
recog_353 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x4))
    {
    case CLOBBER:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MEM:
          if (GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != SCRATCH)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (push_operand (operands[0], E_SImode)
                  && general_no_elim_operand (operands[1], E_SImode)
                  && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode))
                return 74; /* *pushsi2_prologue */
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !pop_operand (operands[1], E_SImode)
                  || !
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode))
                return -1;
              return 78; /* *popsi1_epilogue */

            case E_DImode:
              if (push_operand (operands[0], E_DImode)
                  && general_no_elim_operand (operands[1], E_DImode)
                  && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode))
                return 75; /* *pushdi2_prologue */
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !pop_operand (operands[1], E_DImode)
                  || !
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode))
                return -1;
              return 79; /* *popdi1_epilogue */

            default:
              return -1;
            }

        case REG:
          if (REGNO (x6) != 17
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (const0_operand (operands[1], E_SImode))
                {
                  if (register_operand (operands[0], E_SImode)
                      && 
#line 2424 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed))
                    return 84; /* *movsi_xor */
                  if (memory_operand (operands[0], E_SImode)
                      && 
#line 2434 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed))
                    return 87; /* *movsi_and */
                }
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !constm1_operand (operands[1], E_SImode)
                  || !
#line 2444 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed))
                return -1;
              return 90; /* *movsi_or */

            case E_DImode:
              if (const0_operand (operands[1], E_DImode))
                {
                  if (register_operand (operands[0], E_DImode)
                      && (
#line 2424 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 85; /* *movdi_xor */
                  if (memory_operand (operands[0], E_DImode)
                      && (
#line 2434 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 88; /* *movdi_and */
                }
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !constm1_operand (operands[1], E_DImode)
                  || !(
#line 2444 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 91; /* *movdi_or */

            case E_HImode:
              if (memory_operand (operands[0], E_HImode)
                  && const0_operand (operands[1], E_HImode)
                  && 
#line 2434 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed))
                return 86; /* *movhi_and */
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || !constm1_operand (operands[1], E_HImode)
                  || !
#line 2444 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed))
                return -1;
              return 89; /* *movhi_or */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 107; /* swapsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 108; /* swapdi */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || !register_operand (operands[1], E_QImode))
                return -1;
              return 109; /* *swapqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || !register_operand (operands[1], E_HImode))
                return -1;
              return 110; /* *swaphi */

            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || !register_operand (operands[1], E_XFmode)
                  || !
#line 4644 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 173; /* *swapxf */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 72
              || GET_MODE (x8) != E_XFmode
              || !register_operand (operands[0], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!const1_operand (operands[3], E_SFmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_XFmode))
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_XFmode)
              || !
#line 24105 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
            return -1;
          return 1720; /* fptanxf4_i387 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 108
          || GET_MODE (x4) != E_DImode)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (register_operand (operands[1], E_DImode)
          && push_operand (operands[0], E_DImode)
          && 
#line 3910 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
        return 161; /* pushp_di */
      if (!pop_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode)
          || !
#line 3918 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_PPX))
        return -1;
      return 162; /* popp_di */

    default:
      return -1;
    }
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pattern340 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode)
              || !general_operand (operands[2], E_QImode)
              || !
#line 6677 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 287; /* *addqi_1_zexthi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !general_operand (operands[2], E_QImode)
                  || !
#line 6677 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 289; /* *addqi_1_zextsi */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !general_operand (operands[2], E_HImode)
                  || !
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 293; /* *addhi_1_zextsi */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !general_operand (operands[2], E_QImode)
                  || !
#line 6677 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 291; /* *addqi_1_zextdi */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !general_operand (operands[2], E_HImode)
                  || !
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 295; /* *addhi_1_zextdi */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !x86_64_general_operand (operands[2], E_SImode)
                  || !
#line 6760 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 296; /* addsi_1_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case LTU:
        case UNLT:
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 17)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x5, 1);
          operands[1] = x10;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (pattern1139 (x3))
            {
            case 0:
              if (pattern1733 (x5, 
E_QImode) != 0
                  || !
#line 8895 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 465; /* *addqi3_carry_zexthi */

            case 1:
              if (pattern1733 (x5, 
E_QImode) != 0
                  || !
#line 8895 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 466; /* *addqi3_carry_zextsi */

            case 2:
              if (pattern1733 (x5, 
E_HImode) != 0
                  || !
#line 8914 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 468; /* *addhi3_carry_zextsi */

            case 3:
              if (pattern1733 (x5, 
E_QImode) != 0
                  || !
#line 8895 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 467; /* *addqi3_carry_zextdi */

            case 4:
              if (pattern1733 (x5, 
E_HImode) != 0
                  || !
#line 8914 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 469; /* *addhi3_carry_zextdi */

            case 5:
              if (pattern1733 (x5, 
E_SImode) != 0
                  || !
#line 8933 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 470; /* *addsi3_carry_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern1140 (x3))
        {
        case 0:
          if (!ix86_carry_flag_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8952 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 471; /* *addqi3_carry_zexthi_0 */

        case 1:
          if (!ix86_carry_flag_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8952 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 472; /* *addqi3_carry_zextsi_0 */

        case 2:
          if (!ix86_carry_flag_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 8966 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 474; /* *addhi3_carry_zextsi_0 */

        case 3:
          if (!ix86_carry_flag_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8952 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 473; /* *addqi3_carry_zextdi_0 */

        case 4:
          if (!ix86_carry_flag_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 8966 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 475; /* *addhi3_carry_zextdi_0 */

        case 5:
          if (!ix86_carry_flag_operator (operands[2], E_SImode)
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 8980 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 476; /* *addsi3_carry_zext_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern1140 (x3))
        {
        case 0:
          if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8997 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 477; /* *addqi3_carry_zexthi_0r */

        case 1:
          if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8997 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 478; /* *addqi3_carry_zextsi_0r */

        case 2:
          if (!ix86_carry_flag_unset_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 9011 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 480; /* *addhi3_carry_zextsi_0r */

        case 3:
          if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8997 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 479; /* *addqi3_carry_zextdi_0r */

        case 4:
          if (!ix86_carry_flag_unset_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 9011 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 481; /* *addhi3_carry_zextdi_0r */

        case 5:
          if (!ix86_carry_flag_unset_operator (operands[2], E_SImode)
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 9025 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 482; /* *addsi3_carry_zext_0r */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern1141 (x5) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 23251 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_X32))
        return -1;
      return 1663; /* *add_tp_x32_zext */

    default:
      return -1;
    }
}

 int
recog_367 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      if (pattern340 (x1) != 0)
        return -1;
      switch (pattern1138 (x3))
        {
        case 0:
          if (!
#line 4839 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            return -1;
          return 178; /* zero_extendqisi2_and */

        case 1:
          if (!
#line 4839 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            return -1;
          return 179; /* zero_extendhisi2_and */

        case 2:
          if (!
#line 4893 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            return -1;
          return 182; /* zero_extendqihi2_and */

        default:
          return -1;
        }

    case PLUS:
      return recog_365 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_366 (x1, insn, pnum_clobbers);

    case MULT:
      if (pattern341 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode)
              || !immediate_operand (operands[2], E_HImode)
              || !
#line 10643 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_ZU && true))
            return -1;
          return 597; /* *imulhisizu */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !immediate_operand (operands[2], E_HImode)
                  || !
#line 10643 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_ZU && true))
                return -1;
              return 599; /* *imulhidizu */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !x86_64_general_operand (operands[2], E_SImode)
                  || !
#line 10655 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
                return -1;
              return 601; /* *mulsi3_1_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      if (pattern342 (x1, pnum_clobbers, 
MOD) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!nonimmediate_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XEXP (x9, 1);
      if (!rtx_equal_p (x11, operands[3])
          || !
#line 11684 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 655; /* *divmodsi4_zext_1 */

    case UDIV:
      if (pattern342 (x1, pnum_clobbers, 
UMOD) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      switch (pattern1604 (x9))
        {
        case 0:
          if (!
#line 11719 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 656; /* *udivmodsi4_zext_1 */

        case 1:
          if (!
#line 11741 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)))
            return -1;
          *pnum_clobbers = 1;
          return 657; /* *udivmodsi4_pow2_zext_1 */

        default:
          return -1;
        }

    case MOD:
      if (pattern343 (x1, pnum_clobbers, 
DIV) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!nonimmediate_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XEXP (x9, 1);
      if (!rtx_equal_p (x11, operands[3])
          || !
#line 11767 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 658; /* *divmodsi4_zext_2 */

    case UMOD:
      if (pattern343 (x1, pnum_clobbers, 
UDIV) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      switch (pattern1604 (x9))
        {
        case 0:
          if (!
#line 11803 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 659; /* *udivmodsi4_zext_2 */

        case 1:
          if (!
#line 11825 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)))
            return -1;
          *pnum_clobbers = 1;
          return 660; /* *udivmodsi4_pow2_zext_2 */

        default:
          return -1;
        }

    case AND:
      if (pattern340 (x1) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern345 (x3))
            {
            case 0:
              if (!
#line 12628 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 709; /* *andqi_1_zexthi */

            case 1:
              if (!
#line 12628 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 711; /* *andqi_1_zextsi */

            case 2:
              if (!
#line 12642 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 715; /* *andhi_1_zextsi */

            case 3:
              if (!
#line 12628 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 713; /* *andqi_1_zextdi */

            case 4:
              if (!
#line 12642 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 717; /* *andhi_1_zextdi */

            case 5:
              if (!
#line 12658 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 718; /* *andsi_1_zext */

            default:
              return -1;
            }

        case PLUS:
          if (pattern689 (x5) != 0
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x12 = XEXP (x5, 0);
          x13 = XEXP (x12, 1);
          operands[2] = x13;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22120 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_BMI2))
            return -1;
          return 1598; /* *bmi2_bzhi_zero_extendsidi_4 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern346 (x1))
        {
        case 0:
          if (!
#line 13717 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 844; /* *iorqi_1_zexthi */

        case 1:
          if (!
#line 13717 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 848; /* *iorqi_1_zextsi */

        case 2:
          if (!
#line 13731 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 856; /* *iorhi_1_zextsi */

        case 3:
          if (!
#line 13717 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 852; /* *iorqi_1_zextdi */

        case 4:
          if (!
#line 13731 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 860; /* *iorhi_1_zextdi */

        case 5:
          if (!
#line 13747 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 863; /* *iorsi_1_zext */

        default:
          return -1;
        }

    case XOR:
      switch (pattern346 (x1))
        {
        case 0:
          if (!
#line 13717 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 846; /* *xorqi_1_zexthi */

        case 1:
          if (!
#line 13717 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 850; /* *xorqi_1_zextsi */

        case 2:
          if (!
#line 13731 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 858; /* *xorhi_1_zextsi */

        case 3:
          if (!
#line 13717 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 854; /* *xorqi_1_zextdi */

        case 4:
          if (!
#line 13731 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 862; /* *xorhi_1_zextdi */

        case 5:
          if (!
#line 13747 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 864; /* *xorsi_1_zext */

        default:
          return -1;
        }

    case NEG:
      if (pattern347 (x1) != 0)
        return -1;
      switch (pattern349 (x3))
        {
        case 0:
          if (!
#line 14362 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 963; /* *negqi_1_zexthi */

        case 1:
          if (!
#line 14362 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 965; /* *negqi_1_zextsi */

        case 2:
          if (!
#line 14372 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 969; /* *neghi_1_zextsi */

        case 3:
          if (!
#line 14362 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 967; /* *negqi_1_zextdi */

        case 4:
          if (!
#line 14372 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 971; /* *neghi_1_zextdi */

        case 5:
          if (!
#line 14383 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 972; /* *negsi_1_zext */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern351 (x1))
        {
        case 0:
          if (!
#line 16010 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1094; /* *ashlqi3_1_zexthi */

        case 1:
          if (!
#line 16010 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1096; /* *ashlqi3_1_zextsi */

        case 2:
          if (!
#line 16021 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1100; /* *ashlhi3_1_zextsi */

        case 3:
          if (!
#line 16010 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1098; /* *ashlqi3_1_zextdi */

        case 4:
          if (!
#line 16021 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1102; /* *ashlhi3_1_zextdi */

        case 5:
          if (!
#line 16033 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (ASHIFT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 1103; /* *ashlsi3_1_zext */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern341 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              if (const_int_operand (operands[2], E_QImode)
                  && 
#line 17268 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && INTVAL (operands[2]) == 31
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)))
                return 1170; /* *ashrsi3_cvt_zext */
              if (!nonmemory_operand (operands[2], E_QImode)
                  || !
#line 17480 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1207; /* *ashrsi3_1_zext */

            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !nonmemory_operand (operands[2], E_QImode)
                  || !
#line 17457 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1197; /* *ashrqi3_1_zextdi */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !nonmemory_operand (operands[2], E_QImode)
                  || !
#line 17468 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1205; /* *ashrhi3_1_zextdi */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode)
              || !nonmemory_operand (operands[2], E_QImode)
              || !
#line 17457 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1189; /* *ashrqi3_1_zexthi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonmemory_operand (operands[2], E_QImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 17457 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1193; /* *ashrqi3_1_zextsi */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 17468 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1201; /* *ashrhi3_1_zextsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      x14 = XEXP (x2, 0);
      operands[0] = x14;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case CLOBBER:
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 17
              || GET_MODE (x8) != E_CCmode)
            return -1;
          switch (pattern350 (x3))
            {
            case 0:
              if (!
#line 17457 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1187; /* *lshrqi3_1_zexthi */

            case 1:
              if (!
#line 17457 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1191; /* *lshrqi3_1_zextsi */

            case 2:
              if (!
#line 17468 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1199; /* *lshrhi3_1_zextsi */

            case 3:
              if (!
#line 17457 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1195; /* *lshrqi3_1_zextdi */

            case 4:
              if (!
#line 17468 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1203; /* *lshrhi3_1_zextdi */

            case 5:
              if (!
#line 17480 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1206; /* *lshrsi3_1_zext */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 174)
            return -1;
          x15 = XVECEXP (x7, 0, 0);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern1215 (x3, 
E_SImode, 
E_DImode) != 0
              || !const_0_to_31_operand (operands[2], E_VOIDmode)
              || !
#line 2310 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
            return -1;
          return 2609; /* *klshrsi3_1_zext */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern351 (x1))
        {
        case 0:
          if (!
#line 18590 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1352; /* *rotlqi3_1_zexthi */

        case 1:
          if (!
#line 18590 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1356; /* *rotlqi3_1_zextsi */

        case 2:
          if (!
#line 18601 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1364; /* *rotlhi3_1_zextsi */

        case 3:
          if (!
#line 18590 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1360; /* *rotlqi3_1_zextdi */

        case 4:
          if (!
#line 18601 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1368; /* *rotlhi3_1_zextdi */

        case 5:
          if (!
#line 18613 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_binary_operator_ok (ROTATE, SImode, operands)))
            return -1;
          return 1371; /* *rotlsi3_1_zext */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern351 (x1))
        {
        case 0:
          if (!
#line 18590 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1354; /* *rotrqi3_1_zexthi */

        case 1:
          if (!
#line 18590 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1358; /* *rotrqi3_1_zextsi */

        case 2:
          if (!
#line 18601 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1366; /* *rotrhi3_1_zextsi */

        case 3:
          if (!
#line 18590 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1362; /* *rotrqi3_1_zextdi */

        case 4:
          if (!
#line 18601 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1370; /* *rotrhi3_1_zextdi */

        case 5:
          if (!
#line 18613 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_binary_operator_ok (ROTATERT, SImode, operands)))
            return -1;
          return 1372; /* *rotrsi3_1_zext */

        default:
          return -1;
        }

    case CTZ:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x14 = XEXP (x2, 0);
      operands[0] = x14;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (pattern926 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 21181 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1521; /* *ctzsidi2_uext */

        case 1:
          if (!
#line 21221 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1523; /* *ctzsidi2_uext_falsedep */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x14 = XEXP (x2, 0);
      operands[0] = x14;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (pattern550 (x1, pnum_clobbers))
        {
        case 0:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 21616 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT && TARGET_64BIT))
            return -1;
          return 1543; /* *clzsi2_lzcnt_zext_2 */

        case 1:
          x7 = XVECEXP (x1, 0, 1);
          x15 = XVECEXP (x7, 0, 0);
          switch (pattern1408 (x15))
            {
            case 0:
              if (!
#line 21641 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT))
                return -1;
              *pnum_clobbers = 1;
              return 1544; /* *clzsi2_lzcnt_zext_2_falsedep */

            case 1:
              if (!(
#line 21641 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1545; /* *clzsi2_lzcnt_zext_2_falsedep */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case POPCOUNT:
      x14 = XEXP (x2, 0);
      operands[0] = x14;
      switch (pattern550 (x1, pnum_clobbers))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern348 (x3, 
E_SImode, 
E_DImode) != 0
                  || !
#line 22453 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
                return -1;
              return 1634; /* *popcountsi2_zext_2 */

            case E_SImode:
              if (pattern348 (x3, 
E_HImode, 
E_SImode) != 0
                  || !
#line 22519 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_POPCNT
   && ix86_pre_reload_split ()))
                return -1;
              return 1637; /* *popcounthi2_2 */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x15 = XVECEXP (x7, 0, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 22484 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1635; /* *popcountsi2_zext_2_falsedep */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (pattern383 (x7, 
174, 
0) != 0)
        return -1;
      x14 = XEXP (x2, 0);
      operands[0] = x14;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 2233 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
        return -1;
      return 2596; /* *knotsi_1_zext */

    case UNSPEC:
      return recog_364 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_391 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 17
              || GET_MODE (x7) != E_CCmode)
            return -1;
          operands[1] = x5;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x4) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !general_operand (operands[2], E_HImode)
                  || !(
#line 10604 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1191 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH)))
                return -1;
              return 591; /* *mulhi3_1 */

            case E_SImode:
              if (pattern1312 (x4, 
E_SImode) != 0
                  || !
#line 10604 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
                return -1;
              return 593; /* *mulsi3_1 */

            case E_DImode:
              if (pattern1312 (x4, 
E_DImode) != 0
                  || !(
#line 10604 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 595; /* *muldi3_1 */

            case E_QImode:
              if (pattern212 (x4, 
E_QImode) != 0
                  || !
#line 10691 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
                return -1;
              return 603; /* *mulqi3_1 */

            default:
              return -1;
            }

        case SET:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != UMUL_HIGHPART)
            return -1;
          switch (pattern585 (x1))
            {
            case 0:
              if (!(
#line 10955 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 615; /* *bmi2_umulsidi3_1 */

            case 1:
              if (!(
#line 10955 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 616; /* *bmi2_umulditi3_1 */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 110)
            return -1;
          x10 = XVECEXP (x6, 0, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x4) != E_V2SFmode)
            return -1;
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_V2SFmode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!nonimmediate_operand (operands[2], E_V2SFmode)
              || !
#line 795 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_3DNOW && ix86_binary_operator_ok (MULT, V2SFmode, operands)))
            return -1;
          return 2054; /* *mmx_mulv2sf3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern559 (x1, 
ZERO_EXTEND))
        {
        case 0:
          if (!(
#line 10994 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 617; /* *umulsidi3_1 */

        case 1:
          if (!(
#line 10994 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 618; /* *umulditi3_1 */

        case 2:
          if (!
#line 11060 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
            return -1;
          return 626; /* *umulqihi3_1 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern559 (x1, 
SIGN_EXTEND))
        {
        case 0:
          if (!(
#line 11040 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 620; /* *mulsidi3_1 */

        case 1:
          if (!(
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && (
#line 11040 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))))
            return -1;
          return 622; /* *mulditi3_1 */

        case 2:
          if (!
#line 11060 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
            return -1;
          return 624; /* *mulqihi3_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_397 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern566 (x1))
        {
        case 0:
          if (
#line 12743 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 727; /* *xorqi_1_slp */
          break;

        case 1:
          if (
#line 12743 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 730; /* *xorhi_1_slp */
          break;

        case 2:
          if (x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 13529 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 820; /* *xordi3_doubleword */
          if (x86_64_general_operand (operands[2], E_DImode)
              && (
#line 13587 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 834; /* *xordi_1 */
          if (const_int_operand (operands[2], E_DImode)
              && 
#line 13657 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_USE_BT
   && ix86_binary_operator_ok (XOR, DImode, operands)
   && IN_RANGE (exact_log2 (INTVAL (operands[2])), 31, 63)))
            return 839; /* *xordi_1_btc */
          break;

        case 3:
          if ((
#line 13529 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 822; /* *xorti3_doubleword */
          break;

        case 4:
          if (
#line 13587 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)
   && true))
            return 826; /* *xorhi_1 */
          break;

        case 5:
          if (
#line 13587 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)
   && true))
            return 830; /* *xorsi_1 */
          break;

        case 6:
          if (
#line 4713 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V4QImode, operands)))
            return 2285; /* *xorv4qi3 */
          break;

        case 7:
          if (
#line 4713 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V2QImode, operands)))
            return 2288; /* *xorv2qi3 */
          break;

        case 8:
          if (
#line 4713 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V2HImode, operands)))
            return 2291; /* *xorv2hi3 */
          break;

        case 9:
          if (
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 2574; /* kxorqi */
          break;

        case 10:
          if (
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 2577; /* kxorhi */
          break;

        case 11:
          if ((
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2580; /* kxorsi */
          break;

        case 12:
          if ((
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2583; /* kxordi */
          break;

        default:
          break;
        }
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern567 (x1) != 0)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern555 (x4) == 0)
        {
          x6 = XEXP (x4, 0);
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          switch (pattern1606 (x2))
            {
            case 0:
              if (
#line 12770 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 733; /* *xorqi_exthi_1_slp */
              break;

            case 1:
              if (
#line 12770 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 736; /* *xorqi_extsi_1_slp */
              break;

            case 2:
              if ((
#line 12770 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 739; /* *xorqi_extdi_1_slp */
              break;

            case 3:
              return 757; /* *xorqi_exthi_0 */

            case 4:
              return 760; /* *xorqi_extsi_0 */

            case 5:
              if (
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return 763; /* *xorqi_extdi_0 */
              break;

            default:
              break;
            }
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) == SUBREG)
            {
              switch (pattern1607 (x2))
                {
                case 0:
                  if (
#line 12803 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 742; /* *xorqi_exthi_2_slp */
                  break;

                case 1:
                  if (
#line 12803 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 745; /* *xorqi_extsi_2_slp */
                  break;

                case 2:
                  if ((
#line 12803 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 748; /* *xorqi_extdi_2_slp */
                  break;

                case 3:
                  return 766; /* *xorqi_ext2hi_0 */

                case 4:
                  return 769; /* *xorqi_ext2si_0 */

                case 5:
                  if (
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return 772; /* *xorqi_ext2di_0 */
                  break;

                default:
                  break;
                }
            }
        }
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      if (!nonimmediate_operand (operands[0], E_QImode))
        return -1;
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      if (!general_operand (operands[2], E_QImode)
          || !
#line 13777 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      return 870; /* *xorqi_1 */

    case AND:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != XOR)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern353 (x5) != 0)
        return -1;
      switch (pattern1042 (x2))
        {
        case 0:
          if (!
#line 13686 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_pre_reload_split ()))
            return -1;
          return 840; /* *xor2andn */

        case 1:
          if (!
#line 13686 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_pre_reload_split ()))
            return -1;
          return 841; /* *xor2andn */

        case 2:
          if (!(
#line 13686 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_pre_reload_split ()) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 842; /* *xor2andn */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern370 (x1) != 0
          || !
#line 13764 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
        return -1;
      return 866; /* *xorsi_1_zext_imm */

    case ASHIFT:
      switch (pattern373 (x1, 
1))
        {
        case 0:
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          if (register_operand (operands[2], E_QImode))
            {
              switch (pattern935 (x3))
                {
                case 0:
                  if (
#line 18825 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT))
                    return 1392; /* *btcsi */
                  break;

                case 1:
                  if ((
#line 18825 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1394; /* *btcdi */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x10) != SUBREG)
            return -1;
          switch (pattern1315 (x3))
            {
            case 0:
              if (!
#line 18844 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              return 1396; /* *btcsi_mask */

            case 1:
              if (!(
#line 18844 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1398; /* *btcdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18872 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          return 1400; /* *btcsi_mask_1 */

        case 2:
          if (!(
#line 18872 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1402; /* *btcdi_mask_1 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != MINUS
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 63])
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != SUBREG
          || maybe_ne (SUBREG_BYTE (x11), 0)
          || GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != CLZ
          || GET_MODE (x12) != E_DImode)
        return -1;
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 63])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern231 (x5, 
E_CCmode, 
17) != 0)
        return -1;
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x13 = XEXP (x12, 0);
      operands[1] = x13;
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !
#line 21329 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_LZCNT && TARGET_64BIT && ix86_pre_reload_split ()))
        return -1;
      return 1530; /* *bsr_rex64_2 */

    case PLUS:
      x10 = XEXP (x4, 1);
      if (GET_CODE (x10) != CONST_INT
          || pattern347 (x1) != 0)
        return -1;
      x8 = XEXP (x3, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (XWINT (x10, 0))
        {
        case -1LL:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern203 (x3, 
E_SImode) != 0
                  || !
#line 21883 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI))
                return -1;
              return 1578; /* *bmi_blsmsk_si */

            case E_DImode:
              if (pattern203 (x3, 
E_DImode) != 0
                  || !(
#line 21883 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1579; /* *bmi_blsmsk_di */

            default:
              return -1;
            }

        case 1LL:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern203 (x3, 
E_SImode) != 0
                  || !
#line 22229 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM))
                return -1;
              return 1612; /* *tbm_blcmsk_si */

            case E_DImode:
              if (pattern203 (x3, 
E_DImode) != 0
                  || !(
#line 22229 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1613; /* *tbm_blcmsk_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_406 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (pattern815 (x3) != 0)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 1);
  operands[2] = x9;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  if (call_insn_operand (operands[1], E_SImode)
      && 
#line 20453 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT && !SIBLING_CALL_P (insn)))
    return 1483; /* *call_value_pop */
  if (!sibcall_insn_operand (operands[1], E_SImode)
      || !
#line 20464 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT && SIBLING_CALL_P (insn)))
    return -1;
  return 1484; /* *sibcall_value_pop */
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case CTZ:
      switch (pattern926 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 21181 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1520; /* *ctzsidi2_sext */

        case 1:
          if (!
#line 21221 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1522; /* *ctzsidi2_sext_falsedep */

        default:
          return -1;
        }

    case XOR:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MINUS
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CLZ
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (pattern231 (x10, 
E_CCmode, 
17) != 0)
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 21353 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_LZCNT && TARGET_64BIT && ix86_pre_reload_split ()))
        return -1;
      return 1531; /* *bsr_2 */

    default:
      return -1;
    }
}

 int
recog_413 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != TRUNCATE)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != TRUNCATE)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x5, 0);
  operands[2] = x9;
  x10 = XEXP (x6, 0);
  operands[3] = x10;
  if (!nonimmediate_operand (operands[3], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern1320 (x3, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
          || !
#line 26488 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 8956; /* xop_pperm_pack_v2di_v4si */

    case E_V8HImode:
      if (pattern1320 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
          || !
#line 26501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 8957; /* xop_pperm_pack_v4si_v8hi */

    case E_V16QImode:
      if (pattern1320 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
          || !
#line 26514 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 8958; /* xop_pperm_pack_v8hi_v16qi */

    default:
      return -1;
    }
}

 int
recog_417 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 37)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !(
#line 20192 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)))
            return -1;
          return 1470; /* *sibcall_memory */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !(
#line 20192 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)))
            return -1;
          return 1471; /* *sibcall_memory */

        default:
          return -1;
        }

    case SET:
      x6 = XEXP (x4, 1);
      if (pattern815 (x6) != 0)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 7
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      if (call_insn_operand (operands[0], E_SImode)
          && 
#line 20243 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT && !SIBLING_CALL_P (insn)))
        return 1472; /* *call_pop */
      if (!sibcall_insn_operand (operands[0], E_SImode)
          || !
#line 20253 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT && SIBLING_CALL_P (insn)))
        return -1;
      return 1473; /* *sibcall_pop */

    default:
      return -1;
    }
}

 int
recog_421 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  switch (XVECLEN (x5, 0))
    {
    case 1:
      if (XINT (x5, 1) != 10
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 1);
      if (pattern807 (x7, 
E_DImode, 
10, 
1, 
UNSPEC_VOLATILE) != 0
          || pattern1160 (x1, 
E_SImode, 
10) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 29140 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      return 1900; /* rdtscp_rex64 */

    case 5:
      if (XINT (x5, 1) != 109)
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != UNSPEC_VOLATILE
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 109
          || pattern1160 (x1, 
E_CCZmode, 
109) != 0)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17
          || GET_MODE (x10) != E_CCZmode)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[1] = x6;
      x11 = XVECEXP (x5, 0, 1);
      operands[2] = x11;
      x12 = XVECEXP (x5, 0, 2);
      operands[3] = x12;
      x13 = XVECEXP (x5, 0, 3);
      operands[4] = x13;
      x14 = XVECEXP (x5, 0, 4);
      operands[5] = x14;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      x8 = XEXP (x2, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern1818 (x1, 
E_DImode, 
E_SImode) != 0
              || !(
#line 486 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_CMPXCHG8B) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 10916; /* atomic_compare_and_swapdi_doubleword */

        case E_TImode:
          if (pattern1818 (x1, 
E_TImode, 
E_DImode) != 0
              || !(
#line 486 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_CMPXCHG16B) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 10917; /* atomic_compare_and_swapti_doubleword */

        default:
          return -1;
        }

    case 4:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != UNSPEC_VOLATILE
          || XVECLEN (x7, 0) != 1)
        return -1;
      x15 = XVECEXP (x7, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[1] = x6;
      x11 = XVECEXP (x5, 0, 1);
      operands[2] = x11;
      x12 = XVECEXP (x5, 0, 2);
      operands[3] = x12;
      x13 = XVECEXP (x5, 0, 3);
      operands[4] = x13;
      x8 = XEXP (x2, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (XINT (x5, 1))
        {
        case 109:
          if (XINT (x7, 1) != 109)
            return -1;
          x16 = XEXP (x9, 1);
          if (pattern1159 (x16, 
E_CCZmode, 
109) != 0
              || !const_int_operand (operands[4], E_SImode)
              || GET_MODE (x10) != E_CCZmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1808 (x1, 
E_QImode) != 0
                  || !
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_CMPXCHG))
                return -1;
              return 10918; /* atomic_compare_and_swapqi_1 */

            case E_HImode:
              if (pattern1808 (x1, 
E_HImode) != 0
                  || !
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_CMPXCHG))
                return -1;
              return 10919; /* atomic_compare_and_swaphi_1 */

            case E_SImode:
              if (pattern1808 (x1, 
E_SImode) != 0
                  || !
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_CMPXCHG))
                return -1;
              return 10920; /* atomic_compare_and_swapsi_1 */

            case E_DImode:
              if (pattern1808 (x1, 
E_DImode) != 0
                  || !(
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_CMPXCHG) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 10921; /* atomic_compare_and_swapdi_1 */

            default:
              return -1;
            }

        case 112:
          if (XINT (x7, 1) != 112)
            return -1;
          x16 = XEXP (x9, 1);
          if (GET_CODE (x16) != COMPARE
              || GET_MODE (x16) != E_CCmode
              || !const_0_to_15_operand (operands[4], E_SImode)
              || GET_MODE (x10) != E_CCmode)
            return -1;
          x17 = XEXP (x16, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          x18 = XEXP (x16, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1808 (x1, 
E_SImode) != 0
                  || !
#line 1119 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_CMPCCXADD && TARGET_64BIT))
                return -1;
              return 10991; /* cmpccxadd_si */

            case E_DImode:
              if (pattern1808 (x1, 
E_DImode) != 0
                  || !
#line 1119 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_CMPCCXADD && TARGET_64BIT))
                return -1;
              return 10992; /* cmpccxadd_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x5, 1) != 110)
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (pattern942 (x9, 
E_CCmode, 
17) != 0)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[1] = x6;
      x11 = XVECEXP (x5, 0, 1);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x19 = XEXP (x7, 1);
      operands[2] = x19;
      x20 = XEXP (x7, 0);
      if (!rtx_equal_p (x20, operands[1]))
        return -1;
      x8 = XEXP (x2, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern1551 (x1, 
E_QImode) != 0
              || !
#line 703 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_XADD))
            return -1;
          return 10922; /* atomic_fetch_addqi */

        case E_HImode:
          if (pattern1551 (x1, 
E_HImode) != 0
              || !
#line 703 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_XADD))
            return -1;
          return 10923; /* atomic_fetch_addhi */

        case E_SImode:
          if (pattern1551 (x1, 
E_SImode) != 0
              || !
#line 703 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_XADD))
            return -1;
          return 10924; /* atomic_fetch_addsi */

        case E_DImode:
          if (pattern1551 (x1, 
E_DImode) != 0
              || !(
#line 703 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(TARGET_XADD) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 10925; /* atomic_fetch_adddi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_431 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 97)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x1;
      if (!vzeroall_operation (operands[0], E_VOIDmode)
          || !
#line 27222 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9015; /* *avx_vzeroall */

    case USE:
      operands[0] = x1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (save_multiple (operands[0], E_VOIDmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (symbol_operand (operands[1], E_SImode)
                  && (
#line 30283 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return 10071; /* *save_multiplesi */
              break;

            case E_DImode:
              if (symbol_operand (operands[1], E_DImode)
                  && (
#line 30283 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return 10072; /* *save_multipledi */
              break;

            default:
              break;
            }
        }
      if (!restore_multiple (operands[0], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!symbol_operand (operands[1], E_SImode)
              || !(
#line 30290 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)))
            return -1;
          return 10073; /* *restore_multiplesi */

        case E_DImode:
          if (!symbol_operand (operands[1], E_DImode)
              || !(
#line 30290 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)))
            return -1;
          return 10074; /* *restore_multipledi */

        default:
          return -1;
        }

    case SET:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE)
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          if (pattern396 (x5, 
107) != 0)
            return -1;
          operands[2] = x1;
          if (!encodekey128_operation (operands[2], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 31275 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 10287; /* *encodekey128u32 */

        case 3:
          if (pattern396 (x5, 
108) != 0)
            return -1;
          x7 = XVECEXP (x5, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 21
              || GET_MODE (x7) != E_V2DImode)
            return -1;
          operands[2] = x1;
          if (!encodekey256_operation (operands[2], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 31333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 10288; /* *encodekey256u32 */

        case 1:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 17
              || GET_MODE (x4) != E_CCZmode)
            return -1;
          operands[1] = x1;
          if (!aeswidekl_operation (operands[1], E_VOIDmode)
              || GET_MODE (x5) != E_CCZmode)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[0] = x6;
          if (!memory_operand (operands[0], E_BLKmode))
            return -1;
          switch (XINT (x5, 1))
            {
            case 103:
              if (!
#line 31417 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10293; /* *aesdecwide128klu8 */

            case 105:
              if (!
#line 31417 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10294; /* *aesdecwide256klu8 */

            case 104:
              if (!
#line 31417 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10295; /* *aesencwide128klu8 */

            case 106:
              if (!
#line 31417 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10296; /* *aesencwide256klu8 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!push_operand (operands[0], E_DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DFmode
          || !fp_register_operand (operands[1], E_SFmode))
        return NULL;
      if ((
#line 5258 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)))
        return gen_split_64 (insn, operands);
      if (!(
#line 5258 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)))
        return NULL;
      return gen_split_65 (insn, operands);

    case E_XFmode:
      if (!push_operand (operands[0], E_XFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_XFmode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!fp_register_operand (operands[1], E_SFmode))
            return NULL;
          if ((
#line 5265 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_66 (insn, operands);
          if (!(
#line 5265 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)))
            return NULL;
          return gen_split_67 (insn, operands);

        case E_DFmode:
          if (!fp_register_operand (operands[1], E_DFmode))
            return NULL;
          if ((
#line 5265 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_68 (insn, operands);
          if (!(
#line 5265 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)))
            return NULL;
          return gen_split_69 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LTU)
    {
      switch (pattern43 (x1))
        {
        case 0:
          if ((
#line 9893 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9895 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_196 (insn, operands);
          break;

        case 1:
          if ((
#line 9893 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9895 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_197 (insn, operands);
          break;

        default:
          break;
        }
    }
  operands[1] = x2;
  if (!add_comparison_operator (operands[1], E_QImode))
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NOT)
    return NULL;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!nonimmediate_operand (operands[0], E_QImode))
    return NULL;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  switch (GET_MODE (x3))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode)
          || !nonimmediate_operand (operands[3], E_QImode))
        return NULL;
      return gen_split_846 (insn, operands);

    case E_HImode:
      if (!register_operand (operands[2], E_HImode)
          || !nonimmediate_operand (operands[3], E_HImode))
        return NULL;
      return gen_split_847 (insn, operands);

    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !nonimmediate_operand (operands[3], E_SImode))
        return NULL;
      return gen_split_848 (insn, operands);

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !nonimmediate_operand (operands[3], E_DImode)
          || !
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
        return NULL;
      return gen_split_849 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      switch (pattern70 (x3))
        {
        case 0:
          if (!(
#line 3704 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == -1
   && CONST_WIDE_INT_ELT (operands[3], 1) == 0) && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_23 (insn, operands);

        case 1:
          if (!(
#line 3726 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == 0
   && CONST_WIDE_INT_ELT (operands[3], 1) == -1) && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_26 (insn, operands);

        case 2:
          if (!(
#line 3748 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll) && 
#line 3752 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_29 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
              operands[3] = x7;
              operands[1] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern600 (x3, 
E_QImode) != 0
                      || !(
#line 8015 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_160 (insn, operands);

                case E_HImode:
                  if (pattern600 (x3, 
E_HImode) != 0
                      || !(
#line 8015 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_162 (insn, operands);

                case E_SImode:
                  if (pattern600 (x3, 
E_SImode) != 0
                      || !(
#line 8039 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 8042 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_164 (insn, operands);

                case E_DImode:
                  if (GET_MODE (x3) != E_DImode
                      || GET_MODE (x4) != E_DImode)
                    return NULL;
                  if (register_operand (operands[0], E_DImode)
                      && register_no_SP_operand (operands[1], E_DImode)
                      && const_0_to_3_operand (operands[2], E_VOIDmode)
                      && const_int_operand (operands[3], E_VOIDmode)
                      && ((
#line 8039 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 8042 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_166 (insn, operands);
                  if (!nonimmediate_operand (operands[0], E_DImode)
                      || !register_operand (operands[1], E_DImode)
                      || !const_int_operand (operands[2], E_QImode)
                      || !const_scalar_int_operand (operands[3], E_DImode)
                      || !((
#line 14139 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14153 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_467 (insn, operands);

                case E_TImode:
                  if (pattern601 (x3, 
E_TImode) != 0
                      || !((
#line 14139 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14153 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_470 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              operands[1] = x6;
              switch (pattern944 (x3))
                {
                case 0:
                  if (!((
#line 14062 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14064 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_431 (insn, operands);

                case 1:
                  if (!((
#line 14062 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14064 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_434 (insn, operands);

                default:
                  return NULL;
                }

            case LSHIFTRT:
              operands[4] = x6;
              switch (pattern825 (x3))
                {
                case 0:
                  if (!(
#line 15477 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_APX_NF
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()) && 
#line 15481 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_562 (insn, operands);

                case 1:
                  if (!(
#line 15709 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()) && 
#line 15713 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_566 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_443 (insn, operands);

            case 1:
              if (!((
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14100 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_449 (insn, operands);

            case 2:
              if (!((
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_473 (insn, operands);

            case 3:
              if (!((
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_479 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_446 (insn, operands);

            case 1:
              if (!((
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14100 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_452 (insn, operands);

            case 2:
              if (!((
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_476 (insn, operands);

            case 3:
              if (!((
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_482 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern404 (x3))
        {
        case 0:
          if (!((
#line 14079 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14081 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_437 (insn, operands);

        case 1:
          if (!((
#line 14079 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14081 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_440 (insn, operands);

        case 2:
          if (!((
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_455 (insn, operands);

        case 3:
          if (!((
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_461 (insn, operands);

        case 4:
          if (!((
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_458 (insn, operands);

        case 5:
          if (!((
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_464 (insn, operands);

        case 6:
          if (!((
#line 14200 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14211 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_485 (insn, operands);

        case 7:
          if (!((
#line 14200 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14211 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_488 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != ASHIFT)
        return NULL;
      x6 = XEXP (x4, 0);
      operands[4] = x6;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern825 (x3))
        {
        case 0:
          if (!(
#line 16862 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_APX_NF
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()) && 
#line 16866 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_609 (insn, operands);

        case 1:
          if (!(
#line 17093 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()) && 
#line 17097 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_613 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          x4 = XEXP (x2, 1);
          if (GET_MODE (x4) != E_DImode)
            return NULL;
          if (register_operand (operands[0], E_DImode))
            {
              if (nonmemory_operand (operands[1], E_DImode)
                  && nonmemory_operand (operands[2], E_QImode)
                  && (
#line 15325 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(epilogue_completed) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return gen_split_556 (insn, operands);
              if (nonimmediate_operand (operands[1], E_DImode)
                  && register_operand (operands[2], E_QImode)
                  && (
#line 15990 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_573 (insn, operands);
            }
          if (!general_reg_operand (operands[0], E_DImode)
              || !index_reg_operand (operands[1], E_DImode)
              || !const_0_to_3_operand (operands[2], E_VOIDmode)
              || !(
#line 16285 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_580 (insn, operands);

        case E_TImode:
          if (!register_operand (operands[0], E_TImode))
            return NULL;
          x4 = XEXP (x2, 1);
          if (GET_MODE (x4) != E_TImode
              || !nonmemory_operand (operands[1], E_TImode)
              || !nonmemory_operand (operands[2], E_QImode)
              || !(
#line 15325 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(epilogue_completed) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_557 (insn, operands);

        default:
          return NULL;
        }

    case STRICT_LOW_PART:
      switch (pattern1234 (x2))
        {
        case 0:
          if (!(
#line 16235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 16254 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_575 (insn, operands);

        case 1:
          if (!(
#line 16235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 16254 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_576 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0))
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (pattern231 (x4, 
E_CCmode, 
17) != 0)
    return NULL;
  switch (pattern1030 (x2))
    {
    case 0:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      if (general_operand (operands[2], E_QImode))
        {
          switch (pattern1028 (x2))
            {
            case 0:
              if (
#line 7549 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !rtx_equal_p (operands[0], operands[1])))
                return gen_split_137 (insn, operands);
              break;

            case 1:
              if (
#line 7549 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !rtx_equal_p (operands[0], operands[1])))
                return gen_split_138 (insn, operands);
              break;

            case 2:
              if ((
#line 7549 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !rtx_equal_p (operands[0], operands[1])) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_139 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x6) != SUBREG)
        return NULL;
      switch (pattern1805 (x2))
        {
        case 0:
          if (!
#line 7596 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (PLUS == PLUS && rtx_equal_p (operands[0], operands[2])))))
            return NULL;
          return gen_split_140 (insn, operands);

        case 1:
          if (!
#line 7596 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (PLUS == PLUS && rtx_equal_p (operands[0], operands[2])))))
            return NULL;
          return gen_split_142 (insn, operands);

        case 2:
          if (!(
#line 7596 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (PLUS == PLUS && rtx_equal_p (operands[0], operands[2])))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_144 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) == SUBREG)
        {
          switch (pattern1805 (x2))
            {
            case 0:
              if (
#line 7596 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (MINUS == PLUS && rtx_equal_p (operands[0], operands[2])))))
                return gen_split_141 (insn, operands);
              break;

            case 1:
              if (
#line 7596 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (MINUS == PLUS && rtx_equal_p (operands[0], operands[2])))))
                return gen_split_143 (insn, operands);
              break;

            case 2:
              if ((
#line 7596 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (MINUS == PLUS && rtx_equal_p (operands[0], operands[2])))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_145 (insn, operands);
              break;

            default:
              break;
            }
        }
      operands[2] = x6;
      if (!general_operand (operands[2], E_QImode))
        return NULL;
      switch (pattern1028 (x2))
        {
        case 0:
          if (!
#line 8375 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_183 (insn, operands);

        case 1:
          if (!
#line 8375 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_184 (insn, operands);

        case 2:
          if (!(
#line 8375 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_185 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      if (general_operand (operands[2], E_QImode))
        {
          switch (pattern1028 (x2))
            {
            case 0:
              if (
#line 13096 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_331 (insn, operands);
              break;

            case 1:
              if (
#line 13096 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_334 (insn, operands);
              break;

            case 2:
              if ((
#line 13096 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_337 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x6) != SUBREG)
        return NULL;
      switch (pattern1805 (x2))
        {
        case 0:
          if (!
#line 13194 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_349 (insn, operands);

        case 1:
          if (!
#line 13194 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_352 (insn, operands);

        case 2:
          if (!(
#line 13194 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_355 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      if (general_operand (operands[2], E_QImode))
        {
          switch (pattern1028 (x2))
            {
            case 0:
              if (
#line 13096 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_332 (insn, operands);
              break;

            case 1:
              if (
#line 13096 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_335 (insn, operands);
              break;

            case 2:
              if ((
#line 13096 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_338 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x6) != SUBREG)
        return NULL;
      switch (pattern1805 (x2))
        {
        case 0:
          if (!
#line 13194 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_350 (insn, operands);

        case 1:
          if (!
#line 13194 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_353 (insn, operands);

        case 2:
          if (!(
#line 13194 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_356 (insn, operands);

        default:
          return NULL;
        }

    case 4:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      if (general_operand (operands[2], E_QImode))
        {
          switch (pattern1028 (x2))
            {
            case 0:
              if (
#line 13096 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_333 (insn, operands);
              break;

            case 1:
              if (
#line 13096 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_336 (insn, operands);
              break;

            case 2:
              if ((
#line 13096 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_339 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x6) != SUBREG)
        return NULL;
      switch (pattern1805 (x2))
        {
        case 0:
          if (!
#line 13194 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_351 (insn, operands);

        case 1:
          if (!
#line 13194 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_354 (insn, operands);

        case 2:
          if (!(
#line 13194 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_357 (insn, operands);

        default:
          return NULL;
        }

    case 5:
      if (!
#line 14500 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_494 (insn, operands);

    case 6:
      if (!
#line 14500 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_495 (insn, operands);

    case 7:
      if (!(
#line 14500 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_496 (insn, operands);

    case 8:
      if (!
#line 16529 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_586 (insn, operands);

    case 9:
      if (!
#line 16529 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_587 (insn, operands);

    case 10:
      if (!(
#line 16529 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_588 (insn, operands);

    case 11:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      switch (pattern1216 (x3))
        {
        case 0:
          if (((
#line 16759 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16761 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_605 (insn, operands);
          break;

        case 1:
          if (((
#line 16759 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16761 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_607 (insn, operands);
          break;

        default:
          break;
        }
      x5 = XEXP (x3, 0);
      if (GET_MODE (x5) != E_QImode)
        return NULL;
      switch (pattern1029 (x2))
        {
        case 0:
          if (!
#line 17805 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_632 (insn, operands);

        case 1:
          if (!
#line 17805 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_634 (insn, operands);

        case 2:
          if (!(
#line 17805 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_636 (insn, operands);

        default:
          return NULL;
        }

    case 12:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      switch (pattern1216 (x3))
        {
        case 0:
          if (((
#line 16759 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16761 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_606 (insn, operands);
          break;

        case 1:
          if (((
#line 16759 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16761 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_608 (insn, operands);
          break;

        default:
          break;
        }
      x5 = XEXP (x3, 0);
      if (GET_MODE (x5) != E_QImode)
        return NULL;
      switch (pattern1029 (x2))
        {
        case 0:
          if (!
#line 17805 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_633 (insn, operands);

        case 1:
          if (!
#line 17805 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_635 (insn, operands);

        case 2:
          if (!(
#line 17805 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_637 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern406 (x1))
    {
    case 0:
      if (!(
#line 18192 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()) && 
#line 18197 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_695 (insn, operands);

    case 1:
      if (!(
#line 18192 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()) && 
#line 18197 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_697 (insn, operands);

    case 2:
      if (!(
#line 18192 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18197 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_699 (insn, operands);

    case 3:
      if (!((
#line 18192 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18197 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_701 (insn, operands);

    case 4:
      if (!(
#line 18273 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_727 (insn, operands);

    case 5:
      if (!(
#line 18273 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_729 (insn, operands);

    case 6:
      if (!(
#line 18273 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_731 (insn, operands);

    case 7:
      if (!((
#line 18273 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18277 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_733 (insn, operands);

    case 8:
      if (!(
#line 18342 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_759 (insn, operands);

    case 9:
      if (!(
#line 18342 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_761 (insn, operands);

    case 10:
      if (!(
#line 18342 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_763 (insn, operands);

    case 11:
      if (!((
#line 18342 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18346 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_765 (insn, operands);

    case 12:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      switch (pattern1167 (x4))
        {
        case 0:
          if ((
#line 18144 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()) && 
#line 18149 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_679 (insn, operands);
          break;

        case 1:
          if ((
#line 18144 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()) && 
#line 18149 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_681 (insn, operands);
          break;

        case 2:
          if ((
#line 18144 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18149 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_683 (insn, operands);
          break;

        case 3:
          if (((
#line 18144 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18149 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_685 (insn, operands);
          break;

        case 4:
          if ((
#line 18237 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_711 (insn, operands);
          break;

        case 5:
          if ((
#line 18237 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_713 (insn, operands);
          break;

        case 6:
          if ((
#line 18237 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_715 (insn, operands);
          break;

        case 7:
          if (((
#line 18237 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18241 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_717 (insn, operands);
          break;

        case 8:
          if ((
#line 18306 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_743 (insn, operands);
          break;

        case 9:
          if ((
#line 18306 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_745 (insn, operands);
          break;

        case 10:
          if ((
#line 18306 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_747 (insn, operands);
          break;

        case 11:
          if (((
#line 18306 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18310 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return gen_split_749 (insn, operands);
          break;

        case 12:
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          switch (pattern1324 (x4))
            {
            case 0:
              if (
#line 18571 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)))
                return gen_split_786 (insn, operands);
              break;

            case 1:
              if ((
#line 18571 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_787 (insn, operands);
              break;

            default:
              break;
            }
          if (XWINT (x5, 0) == 8LL
              && QIreg_operand (operands[0], E_HImode)
              && GET_MODE (x4) == E_HImode)
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 18743 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
  && (TARGET_USE_XCHGB || optimize_function_for_size_p (cfun))))
                return gen_split_795 (insn, operands);
            }
          break;

        default:
          break;
        }
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern1168 (x2))
        {
        case 0:
          if (!(
#line 18710 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 18721 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_791 (insn, operands);

        case 1:
          if (!(
#line 18710 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 18721 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_793 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_42 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 51:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x6))
            {
            case LT:
              switch (pattern731 (x2))
                {
                case 0:
                  if ((
#line 26806 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()) && 
#line 26811 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_955 (insn, operands);
                  if (!(
#line 26827 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()) && 
#line 26832 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_957 (insn, operands);

                case 1:
                  if ((
#line 26806 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()) && 
#line 26811 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_956 (insn, operands);
                  if (!(
#line 26827 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()) && 
#line 26832 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_958 (insn, operands);

                default:
                  return NULL;
                }

            case EQ:
              switch (pattern733 (x2))
                {
                case 0:
                  if (!(
#line 4338 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()) && 
#line 4340 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1062 (insn, operands);

                case 1:
                  if (!(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4416 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1065 (insn, operands);

                case 2:
                  if (!(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4416 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1066 (insn, operands);

                case 3:
                  if (!(
#line 4414 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4416 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1067 (insn, operands);

                default:
                  return NULL;
                }

            case SUBREG:
              switch (pattern842 (x2))
                {
                case 0:
                  if (!(
#line 4366 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()) && 
#line 4368 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1063 (insn, operands);

                case 1:
                  if (!(
#line 4366 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()) && 
#line 4368 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1064 (insn, operands);

                case 2:
                  if (!(
#line 4442 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4444 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1068 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 59:
          switch (pattern587 (x2))
            {
            case 0:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1476 (insn, operands);

            case 1:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1478 (insn, operands);

            case 2:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1484 (insn, operands);

            case 3:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1480 (insn, operands);

            case 4:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1482 (insn, operands);

            case 5:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1486 (insn, operands);

            default:
              return NULL;
            }

        case 157:
          switch (pattern587 (x2))
            {
            case 0:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1477 (insn, operands);

            case 1:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1479 (insn, operands);

            case 2:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1485 (insn, operands);

            case 3:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1481 (insn, operands);

            case 4:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1483 (insn, operands);

            case 5:
              if (!((
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1487 (insn, operands);

            default:
              return NULL;
            }

        case 121:
          if (pattern303 (x2) != 0
              || !
#line 23274 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((TARGET_SSSE3 && reload_completed
    && SSE_REGNO_P (REGNO (operands[0])))
   || operands[3] == const0_rtx
   || INTVAL (operands[3]) == 64))
            return NULL;
          return gen_split_3472 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 57:
          switch (pattern65 (x1))
            {
            case 0:
              if (!(
#line 4792 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE) && 
#line 4797 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed
   && SSE_REGNO_P (REGNO (operands[0])))))
                return NULL;
              return gen_split_1103 (insn, operands);

            case 1:
              if (!(
#line 4831 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE) && 
#line 4833 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1105 (insn, operands);

            default:
              return NULL;
            }

        case 130:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 17)
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case AND:
              switch (pattern599 (x1))
                {
                case 0:
                  if (!(
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3578 (insn, operands);

                case 1:
                  if (!(
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3579 (insn, operands);

                case 2:
                  if (!(
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3580 (insn, operands);

                case 3:
                  if (!(
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3581 (insn, operands);

                case 4:
                  if (!(
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3582 (insn, operands);

                case 5:
                  if (!(
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3583 (insn, operands);

                case 6:
                  if (!(
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3584 (insn, operands);

                case 7:
                  if (!((
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3585 (insn, operands);

                case 8:
                  if (!((
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3586 (insn, operands);

                case 9:
                  if (!((
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3587 (insn, operands);

                case 10:
                  if (!((
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3588 (insn, operands);

                case 11:
                  if (!((
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3589 (insn, operands);

                case 12:
                  if (!((
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3590 (insn, operands);

                case 13:
                  if (!((
#line 25364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3591 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              operands[0] = x4;
              if (GET_MODE (x3) != E_CCCmode
                  || GET_MODE (x2) != E_CCCmode)
                return NULL;
              x5 = XVECEXP (x2, 0, 1);
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (!register_operand (operands[0], E_V16QImode)
                      || !register_operand (operands[1], E_V16QImode)
                      || !
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3592 (insn, operands);

                case E_V8HImode:
                  if (!register_operand (operands[0], E_V8HImode)
                      || !register_operand (operands[1], E_V8HImode)
                      || !
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3593 (insn, operands);

                case E_V4SImode:
                  if (!register_operand (operands[0], E_V4SImode)
                      || !register_operand (operands[1], E_V4SImode)
                      || !
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3594 (insn, operands);

                case E_V2DImode:
                  if (!register_operand (operands[0], E_V2DImode)
                      || !register_operand (operands[1], E_V2DImode)
                      || !
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3595 (insn, operands);

                case E_V1TImode:
                  if (!register_operand (operands[0], E_V1TImode)
                      || !register_operand (operands[1], E_V1TImode)
                      || !
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3596 (insn, operands);

                case E_V4SFmode:
                  if (!register_operand (operands[0], E_V4SFmode)
                      || !register_operand (operands[1], E_V4SFmode)
                      || !
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3597 (insn, operands);

                case E_V2DFmode:
                  if (!register_operand (operands[0], E_V2DFmode)
                      || !register_operand (operands[1], E_V2DFmode)
                      || !
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3598 (insn, operands);

                case E_V32QImode:
                  if (!register_operand (operands[0], E_V32QImode)
                      || !register_operand (operands[1], E_V32QImode)
                      || !(
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3599 (insn, operands);

                case E_V16HImode:
                  if (!register_operand (operands[0], E_V16HImode)
                      || !register_operand (operands[1], E_V16HImode)
                      || !(
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3600 (insn, operands);

                case E_V8SImode:
                  if (!register_operand (operands[0], E_V8SImode)
                      || !register_operand (operands[1], E_V8SImode)
                      || !(
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3601 (insn, operands);

                case E_V4DImode:
                  if (!register_operand (operands[0], E_V4DImode)
                      || !register_operand (operands[1], E_V4DImode)
                      || !(
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3602 (insn, operands);

                case E_V2TImode:
                  if (!register_operand (operands[0], E_V2TImode)
                      || !register_operand (operands[1], E_V2TImode)
                      || !(
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3603 (insn, operands);

                case E_V8SFmode:
                  if (!register_operand (operands[0], E_V8SFmode)
                      || !register_operand (operands[1], E_V8SFmode)
                      || !(
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3604 (insn, operands);

                case E_V4DFmode:
                  if (!register_operand (operands[0], E_V4DFmode)
                      || !register_operand (operands[1], E_V4DFmode)
                      || !(
#line 25377 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3605 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 49:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (register_operand (operands[1], E_V8QImode)
                  && 
#line 6829 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed
   && SSE_REGNO_P (REGNO (operands[1]))))
                return gen_split_1128 (insn, operands);
              if (GET_CODE (x4) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x4), 0))
                return NULL;
              x7 = XEXP (x4, 0);
              switch (GET_CODE (x7))
                {
                case VEC_MERGE:
                  switch (pattern1085 (x4))
                    {
                    case 0:
                      if (!((
#line 21972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21974 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3408 (insn, operands);

                    case 1:
                      if (!(
#line 21972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 21974 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3409 (insn, operands);

                    case 2:
                      if (!((
#line 21972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21974 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3410 (insn, operands);

                    case 3:
                      if (!((
#line 21972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 21974 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3411 (insn, operands);

                    default:
                      return NULL;
                    }

                case ASHIFTRT:
                  switch (pattern1086 (x4))
                    {
                    case 0:
                      if (!((
#line 22035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22037 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3428 (insn, operands);

                    case 1:
                      if (!(
#line 22035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 22037 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3429 (insn, operands);

                    case 2:
                      if (!((
#line 22035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22037 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3430 (insn, operands);

                    case 3:
                      if (!((
#line 22035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 22037 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3431 (insn, operands);

                    default:
                      return NULL;
                    }

                case NOT:
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  if (!register_operand (operands[1], E_VOIDmode))
                    return NULL;
                  switch (GET_MODE (x4))
                    {
                    case E_V32QImode:
                      if (!(
#line 22174 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2
   && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) == 32) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                        return NULL;
                      return gen_split_3444 (insn, operands);

                    case E_V16QImode:
                      if (!
#line 22174 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2
   && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) == 16))
                        return NULL;
                      return gen_split_3445 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case LT:
              switch (pattern759 (x4))
                {
                case 0:
                  if (!((
#line 21948 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21950 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3404 (insn, operands);

                case 1:
                  if (!(
#line 21948 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 21950 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3405 (insn, operands);

                case 2:
                  if (!((
#line 21948 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21950 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3406 (insn, operands);

                case 3:
                  if (!((
#line 21948 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 21950 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3407 (insn, operands);

                case 4:
                  if (!((
#line 22200 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 22202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3446 (insn, operands);

                case 5:
                  if (!(
#line 22200 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 22202 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3447 (insn, operands);

                default:
                  return NULL;
                }

            case NOT:
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              switch (GET_MODE (x4))
                {
                case E_V32QImode:
                  if (!register_operand (operands[1], E_V32QImode)
                      || !(
#line 22152 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return NULL;
                  return gen_split_3442 (insn, operands);

                case E_V16QImode:
                  if (!register_operand (operands[1], E_V16QImode)
                      || !
#line 22152 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return NULL;
                  return gen_split_3443 (insn, operands);

                default:
                  return NULL;
                }

            case VEC_MERGE:
              switch (pattern761 (x4))
                {
                case 0:
                  if (!((
#line 22228 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 22230 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3448 (insn, operands);

                case 1:
                  if (!(
#line 22228 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 22230 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3449 (insn, operands);

                case 2:
                  if (!(
#line 22356 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 22358 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3457 (insn, operands);

                case 3:
                  if (!(
#line 22370 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 22372 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3458 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 172:
          if (GET_MODE (x2) != E_V2SImode
              || !register_operand (operands[0], E_V2SImode))
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 8445 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed
   && SSE_REG_P (operands[0])))
            return NULL;
          return gen_split_1520 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_69 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern529 (x2))
        {
        case 0:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1670 (insn, operands);

        case 1:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1697 (insn, operands);

        case 2:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1724 (insn, operands);

        case 3:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1751 (insn, operands);

        case 4:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1778 (insn, operands);

        case 5:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1805 (insn, operands);

        case 6:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1832 (insn, operands);

        case 7:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1859 (insn, operands);

        case 8:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1886 (insn, operands);

        case 9:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1913 (insn, operands);

        case 10:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1940 (insn, operands);

        case 11:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1967 (insn, operands);

        case 12:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1673 (insn, operands);

        case 13:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1700 (insn, operands);

        case 14:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1727 (insn, operands);

        case 15:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1754 (insn, operands);

        case 16:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1781 (insn, operands);

        case 17:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1808 (insn, operands);

        case 18:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1835 (insn, operands);

        case 19:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1862 (insn, operands);

        case 20:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1889 (insn, operands);

        case 21:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1916 (insn, operands);

        case 22:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1943 (insn, operands);

        case 23:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1970 (insn, operands);

        case 24:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1676 (insn, operands);

        case 25:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1703 (insn, operands);

        case 26:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1730 (insn, operands);

        case 27:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1757 (insn, operands);

        case 28:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1784 (insn, operands);

        case 29:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1811 (insn, operands);

        case 30:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1838 (insn, operands);

        case 31:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1865 (insn, operands);

        case 32:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1892 (insn, operands);

        case 33:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1919 (insn, operands);

        case 34:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1946 (insn, operands);

        case 35:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1973 (insn, operands);

        case 36:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2960 (insn, operands);

        case 37:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2969 (insn, operands);

        case 38:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2978 (insn, operands);

        case 39:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2987 (insn, operands);

        case 40:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2996 (insn, operands);

        case 41:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3005 (insn, operands);

        case 42:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3014 (insn, operands);

        case 43:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3023 (insn, operands);

        case 44:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3032 (insn, operands);

        case 45:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3041 (insn, operands);

        case 46:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3050 (insn, operands);

        case 47:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3059 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern531 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2318 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2345 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2372 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2399 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2426 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2453 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2480 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2507 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2534 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2561 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2588 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2615 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2321 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2348 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2375 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2402 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2429 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2456 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2483 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2510 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2537 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2564 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2591 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2618 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2324 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2351 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2378 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2405 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2432 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2459 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2486 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2513 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2540 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2567 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2594 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2621 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_77 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case VEC_SELECT:
      if (GET_MODE (x3) != E_DFmode)
        return NULL;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 1)
        return NULL;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !memory_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_DFmode))
        return NULL;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0])
          || !
#line 14822 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
        return NULL;
      return gen_split_3176 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 147)
        return NULL;
      x7 = XVECEXP (x3, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SImode:
          if (pattern1024 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !(
#line 28802 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 28804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3766 (insn, operands);

        case E_V8SFmode:
          if (pattern1024 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !(
#line 28802 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 28804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3767 (insn, operands);

        case E_V4DFmode:
          if (pattern1024 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !(
#line 28802 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 28804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3768 (insn, operands);

        case E_V16SImode:
          if (pattern1024 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !((
#line 30145 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30147 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3814 (insn, operands);

        case E_V16SFmode:
          if (pattern1024 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !((
#line 30145 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30147 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3815 (insn, operands);

        case E_V8DFmode:
          if (pattern1024 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !((
#line 30145 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30147 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3816 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_79 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      if (XINT (x2, 1) != 177)
        return NULL;
      switch (pattern321 (x2))
        {
        case 0:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1156 (insn, operands);

        case 1:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1157 (insn, operands);

        case 2:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1158 (insn, operands);

        case 3:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1159 (insn, operands);

        case 4:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1160 (insn, operands);

        case 5:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1161 (insn, operands);

        case 6:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1162 (insn, operands);

        case 7:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1163 (insn, operands);

        case 8:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1164 (insn, operands);

        case 9:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1165 (insn, operands);

        case 10:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1166 (insn, operands);

        case 11:
          if (!((
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1167 (insn, operands);

        case 12:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1168 (insn, operands);

        case 13:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1169 (insn, operands);

        case 14:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1170 (insn, operands);

        case 15:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1171 (insn, operands);

        case 16:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1172 (insn, operands);

        case 17:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1173 (insn, operands);

        case 18:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1174 (insn, operands);

        case 19:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1175 (insn, operands);

        case 20:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1176 (insn, operands);

        case 21:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1177 (insn, operands);

        case 22:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1178 (insn, operands);

        case 23:
          if (!((
#line 1681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1683 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1179 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      switch (XINT (x2, 1))
        {
        case 51:
          x3 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x3))
            {
            case LT:
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              switch (pattern653 (x2))
                {
                case 0:
                  if (((
#line 3364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 3370 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1296 (insn, operands);
                  break;

                case 1:
                  if ((
#line 3364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 3370 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1297 (insn, operands);
                  break;

                case 2:
                  if (((
#line 3364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 3370 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1298 (insn, operands);
                  break;

                case 3:
                  if (((
#line 3364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 3370 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1299 (insn, operands);
                  break;

                case 4:
                  if (((
#line 23571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23573 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return gen_split_3473 (insn, operands);
                  break;

                case 5:
                  if ((
#line 23571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 23573 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return gen_split_3474 (insn, operands);
                  break;

                case 6:
                  if (((
#line 23571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23573 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return gen_split_3475 (insn, operands);
                  break;

                case 7:
                  if (((
#line 23571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 23573 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return gen_split_3476 (insn, operands);
                  break;

                case 8:
                  if (((
#line 23901 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 23903 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3501 (insn, operands);
                  break;

                case 9:
                  if ((
#line 23901 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 23903 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3502 (insn, operands);
                  break;

                default:
                  break;
                }
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) != SUBREG)
                return NULL;
              switch (pattern655 (x2))
                {
                case 0:
                  if (!((
#line 23951 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[3])) == 32
   && ix86_pre_reload_split ()) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 23956 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3505 (insn, operands);

                case 1:
                  if (!(
#line 23951 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[3])) == 16
   && ix86_pre_reload_split ()) && 
#line 23956 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3506 (insn, operands);

                default:
                  return NULL;
                }

            case GT:
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              switch (pattern658 (x2))
                {
                case 0:
                  if (((
#line 23597 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23599 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return gen_split_3477 (insn, operands);
                  break;

                case 1:
                  if ((
#line 23597 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 23599 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return gen_split_3478 (insn, operands);
                  break;

                case 2:
                  if (((
#line 23597 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23599 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return gen_split_3479 (insn, operands);
                  break;

                case 3:
                  if (((
#line 23597 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 23599 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                    return gen_split_3480 (insn, operands);
                  break;

                case 4:
                  if (((
#line 23925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 23927 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3503 (insn, operands);
                  break;

                case 5:
                  if ((
#line 23925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 23927 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3504 (insn, operands);
                  break;

                default:
                  break;
                }
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) != SUBREG)
                return NULL;
              switch (pattern660 (x2))
                {
                case 0:
                  if (!((
#line 23973 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[3])) == 32
   && ix86_pre_reload_split ()) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 23978 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3507 (insn, operands);

                case 1:
                  if (!(
#line 23973 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[3])) == 16
   && ix86_pre_reload_split ()) && 
#line 23978 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3508 (insn, operands);

                default:
                  return NULL;
                }

            case SUBREG:
              if (maybe_ne (SUBREG_BYTE (x3), 0))
                return NULL;
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              x6 = XVECEXP (x2, 0, 1);
              operands[2] = x6;
              x5 = XEXP (x3, 0);
              switch (GET_CODE (x5))
                {
                case LT:
                  x7 = XEXP (x5, 0);
                  operands[3] = x7;
                  switch (pattern1209 (x2))
                    {
                    case 0:
                      if ((
#line 23631 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 23633 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return gen_split_3481 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 23631 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 23633 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return gen_split_3482 (insn, operands);
                      break;

                    case 2:
                      if (((
#line 23631 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23633 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return gen_split_3483 (insn, operands);
                      break;

                    case 3:
                      if (((
#line 23631 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23633 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return gen_split_3484 (insn, operands);
                      break;

                    default:
                      break;
                    }
                  if (GET_CODE (x7) != SUBREG)
                    return NULL;
                  switch (pattern1210 (x2))
                    {
                    case 0:
                      if (!(
#line 23698 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 23700 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                        return NULL;
                      return gen_split_3489 (insn, operands);

                    case 1:
                      if (!(
#line 23698 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 23700 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                        return NULL;
                      return gen_split_3490 (insn, operands);

                    case 2:
                      if (!((
#line 23698 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23700 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                        return NULL;
                      return gen_split_3491 (insn, operands);

                    case 3:
                      if (!((
#line 23698 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23700 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                        return NULL;
                      return gen_split_3492 (insn, operands);

                    default:
                      return NULL;
                    }

                case GT:
                  x7 = XEXP (x5, 0);
                  operands[3] = x7;
                  switch (pattern1211 (x2))
                    {
                    case 0:
                      if ((
#line 23663 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 23665 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return gen_split_3485 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 23663 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 23665 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return gen_split_3486 (insn, operands);
                      break;

                    case 2:
                      if (((
#line 23663 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23665 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return gen_split_3487 (insn, operands);
                      break;

                    case 3:
                      if (((
#line 23663 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23665 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed)))
                        return gen_split_3488 (insn, operands);
                      break;

                    default:
                      break;
                    }
                  if (GET_CODE (x7) != SUBREG)
                    return NULL;
                  switch (pattern1212 (x2))
                    {
                    case 0:
                      if (!(
#line 23724 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 23726 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                        return NULL;
                      return gen_split_3493 (insn, operands);

                    case 1:
                      if (!(
#line 23724 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 23726 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                        return NULL;
                      return gen_split_3494 (insn, operands);

                    case 2:
                      if (!((
#line 23724 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23726 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                        return NULL;
                      return gen_split_3495 (insn, operands);

                    case 3:
                      if (!((
#line 23724 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 23726 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                        return NULL;
                      return gen_split_3496 (insn, operands);

                    default:
                      return NULL;
                    }

                case NOT:
                  x7 = XEXP (x5, 0);
                  operands[3] = x7;
                  if (!register_operand (operands[3], E_VOIDmode))
                    return NULL;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V32QImode:
                      if (pattern1429 (x2, 
E_V32QImode) != 0
                          || !(
#line 23884 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[3])) == 32) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                        return NULL;
                      return gen_split_3499 (insn, operands);

                    case E_V16QImode:
                      if (pattern1429 (x2, 
E_V16QImode) != 0
                          || !
#line 23884 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[3])) == 16))
                        return NULL;
                      return gen_split_3500 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case NOT:
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              x6 = XVECEXP (x2, 0, 1);
              operands[2] = x6;
              x5 = XEXP (x3, 0);
              operands[3] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V32QImode:
                  if (pattern1172 (x2, 
E_V32QImode) != 0
                      || !(
#line 23871 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return NULL;
                  return gen_split_3497 (insn, operands);

                case E_V16QImode:
                  if (pattern1172 (x2, 
E_V16QImode) != 0
                      || !
#line 23871 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                    return NULL;
                  return gen_split_3498 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 217:
          switch (pattern590 (x2))
            {
            case 0:
              if (!((
#line 7243 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 7245 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1512 (insn, operands);

            case 1:
              if (!((
#line 7243 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7245 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1513 (insn, operands);

            case 2:
              if (!((
#line 7243 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7245 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1514 (insn, operands);

            default:
              return NULL;
            }

        case 219:
          switch (pattern590 (x2))
            {
            case 0:
              if (!((
#line 7270 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 7272 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1515 (insn, operands);

            case 1:
              if (!((
#line 7270 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7272 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1516 (insn, operands);

            case 2:
              if (!((
#line 7270 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7272 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1517 (insn, operands);

            default:
              return NULL;
            }

        case 155:
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != CONST_VECTOR)
            return NULL;
          switch (pattern495 (x2))
            {
            case 0:
              if (!(
#line 21586 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512VBMI
   && ix86_pre_reload_split ()) && 
#line 21589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3402 (insn, operands);

            case 1:
              if (!(
#line 21611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW
   && ix86_pre_reload_split ()) && 
#line 21614 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3403 (insn, operands);

            default:
              return NULL;
            }

        case 47:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x3 = XVECEXP (x2, 0, 2);
          operands[2] = x3;
          switch (pattern784 (x2))
            {
            case 0:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3742 (insn, operands);

            case 1:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3743 (insn, operands);

            case 2:
              if (!(
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3744 (insn, operands);

            case 3:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3745 (insn, operands);

            case 4:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3746 (insn, operands);

            case 5:
              if (!(
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3747 (insn, operands);

            case 6:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3748 (insn, operands);

            case 7:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3749 (insn, operands);

            case 8:
              if (!(
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3750 (insn, operands);

            case 9:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3751 (insn, operands);

            case 10:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3752 (insn, operands);

            case 11:
              if (!(
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3753 (insn, operands);

            case 12:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3754 (insn, operands);

            case 13:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3755 (insn, operands);

            case 14:
              if (!(
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3756 (insn, operands);

            case 15:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3757 (insn, operands);

            case 16:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3758 (insn, operands);

            case 17:
              if (!(
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3759 (insn, operands);

            case 18:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3760 (insn, operands);

            case 19:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3761 (insn, operands);

            case 20:
              if (!(
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3762 (insn, operands);

            case 21:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3763 (insn, operands);

            case 22:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3764 (insn, operands);

            case 23:
              if (!((
#line 28767 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 28769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3765 (insn, operands);

            default:
              return NULL;
            }

        case 171:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x3 = XVECEXP (x2, 0, 2);
          operands[3] = x3;
          switch (pattern907 (x2))
            {
            case 0:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16SImode)) >= 4)) && 
#line 1016 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3793 (insn, operands);

            case 1:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16SFmode)) >= 4)) && 
#line 1017 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3794 (insn, operands);

            case 2:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8DImode)) >= 4)) && 
#line 1018 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3795 (insn, operands);

            case 3:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8DFmode)) >= 4)) && 
#line 1019 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3796 (insn, operands);

            case 4:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8SImode)) >= 4)) && 
#line 1020 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3797 (insn, operands);

            case 5:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8SFmode)) >= 4)) && 
#line 1020 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3798 (insn, operands);

            case 6:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4DImode)) >= 4)) && 
#line 1021 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3799 (insn, operands);

            case 7:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4DFmode)) >= 4)) && 
#line 1021 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3800 (insn, operands);

            case 8:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4SImode)) >= 4)) && 
#line 1022 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3801 (insn, operands);

            case 9:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V4SFmode)) >= 4)) && 
#line 1022 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3802 (insn, operands);

            case 10:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V2DImode)) >= 4)) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3803 (insn, operands);

            case 11:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V2DFmode)) >= 4)) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3804 (insn, operands);

            case 12:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V64QImode)) >= 4)) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3805 (insn, operands);

            case 13:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16QImode)) >= 4)) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3806 (insn, operands);

            case 14:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V32QImode)) >= 4)) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3807 (insn, operands);

            case 15:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V32HImode)) >= 4)) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3808 (insn, operands);

            case 16:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V16HImode)) >= 4)) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3809 (insn, operands);

            case 17:
              if (!((
#line 29736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(ix86_pre_reload_split ()
   && (TARGET_AVX512VBMI2 || GET_MODE_SIZE (GET_MODE_INNER (V8HImode)) >= 4)) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 29739 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3810 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 4:
      return split_56 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_CODE (operands[0]))
    {
    case REG:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern722 (x4, 
E_QImode))
            {
            case 0:
              if (pattern1328 (x4, 
E_QImode) != 0
                  || !
#line 3385 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_reg_dead_p (3, operands[0])
   && optimize_insn_for_size_p ()))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_15 (insn, operands);

            case 1:
              if (XVECLEN (x4, 0) != 2)
                return NULL;
              x5 = XVECEXP (x4, 0, 0);
              if (GET_CODE (x5) != SET)
                return NULL;
              x6 = XEXP (x5, 1);
              if (GET_CODE (x6) != NEG
                  || pattern1332 (x4, 
E_QImode) != 0)
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_155 (insn, operands);

            default:
              return NULL;
            }

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern722 (x4, 
E_HImode))
            {
            case 0:
              if (pattern1328 (x4, 
E_HImode) != 0
                  || !
#line 3385 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_reg_dead_p (3, operands[0])
   && optimize_insn_for_size_p ()))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_16 (insn, operands);

            case 1:
              if (XVECLEN (x4, 0) != 2)
                return NULL;
              x5 = XVECEXP (x4, 0, 0);
              if (GET_CODE (x5) != SET)
                return NULL;
              x6 = XEXP (x5, 1);
              if (GET_CODE (x6) == NEG
                  && pattern1332 (x4, 
E_HImode) == 0)
                {
                  *pmatch_len_ = 2;
                  res = gen_peephole2_156 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (peep2_current_count < 4
                  || pattern1334 (x4, 
E_HImode) != 0
                  || !
#line 26511 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (1, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])))
                return NULL;
              *pmatch_len_ = 3;
              return gen_peephole2_203 (insn, operands);

            default:
              return NULL;
            }

        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode)
              || !general_reg_operand (operands[1], E_SImode))
            return NULL;
          if (peep2_current_count >= 2)
            {
              x4 = PATTERN (peep2_next_insn (1));
              if (pattern1057 (x4, 
E_SImode) == 0
                  && 
#line 3385 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_reg_dead_p (3, operands[0])
   && optimize_insn_for_size_p ()))
                {
                  *pmatch_len_ = 2;
                  res = gen_peephole2_17 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!
#line 3418 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_size > 1
  && ((REGNO (operands[0]) == AX_REG)
      != (REGNO (operands[1]) == AX_REG))
  && optimize_insn_for_size_p ()
  && peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_27 (insn, operands);

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode)
              || !general_reg_operand (operands[1], E_DImode))
            return NULL;
          if (peep2_current_count >= 2)
            {
              x4 = PATTERN (peep2_next_insn (1));
              if (pattern1057 (x4, 
E_DImode) == 0
                  && (
#line 3385 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_reg_dead_p (3, operands[0])
   && optimize_insn_for_size_p ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 2;
                  res = gen_peephole2_18 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if ((
#line 3418 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_size > 1
  && ((REGNO (operands[0]) == AX_REG)
      != (REGNO (operands[1]) == AX_REG))
  && optimize_insn_for_size_p ()
  && peep2_reg_dead_p (1, operands[1])) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_28 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 2
              || peep2_current_count < 3
              || peep2_current_count < 4)
            return NULL;
          x4 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x4) != PARALLEL
              || XVECLEN (x4, 0) != 2)
            return NULL;
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != SET)
            return NULL;
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != ASHIFTRT
              || GET_MODE (x6) != E_DImode)
            return NULL;
          x7 = XEXP (x6, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 63]
              || pattern1330 (x4) != 0)
            return NULL;
          x8 = PATTERN (peep2_next_insn (2));
          if (GET_CODE (x8) != SET)
            return NULL;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!general_reg_operand (operands[2], E_DImode))
            return NULL;
          x10 = XEXP (x8, 1);
          if (!rtx_equal_p (x10, operands[1]))
            return NULL;
          x11 = PATTERN (peep2_next_insn (3));
          if (GET_CODE (x11) != SET)
            return NULL;
          x12 = XEXP (x11, 0);
          operands[3] = x12;
          if (!general_reg_operand (operands[3], E_DImode))
            return NULL;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[0])
              || !
#line 5116 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun) || TARGET_USE_CLTD)
   && REGNO (operands[2]) == AX_REG
   && REGNO (operands[3]) == DX_REG
   && peep2_reg_dead_p (4, operands[0])
   && !reg_mentioned_p (operands[0], operands[1])
   && !reg_mentioned_p (operands[2], operands[0])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_53 (insn, operands);

        default:
          return NULL;
        }

    case SUBREG:
    case MEM:
      if (peep2_current_count < 2
          || peep2_current_count < 3)
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern948 (x4, 
E_SImode))
            {
            case 0:
              if (!(
#line 5039 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(REGNO (operands[1]) != REGNO (operands[2])
   && INTVAL (operands[4]) == (4 * BITS_PER_UNIT - 1)
   && peep2_reg_dead_p (2, operands[1])
   && peep2_reg_dead_p (4, operands[2])
   && !reg_mentioned_p (operands[2], operands[3])) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 3;
              return gen_peephole2_49 (insn, operands);

            case 1:
              if (!(
#line 5057 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(/* cltd is shorter than sarl $31, %eax */
   !optimize_function_for_size_p (cfun)
   && REGNO (operands[1]) == AX_REG
   && REGNO (operands[2]) == DX_REG
   && INTVAL (operands[4]) == (4 * BITS_PER_UNIT - 1)
   && peep2_reg_dead_p (2, operands[1])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_mentioned_p (operands[2], operands[3])) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_51 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern948 (x4, 
E_DImode))
            {
            case 0:
              if (!(
#line 5039 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(REGNO (operands[1]) != REGNO (operands[2])
   && INTVAL (operands[4]) == (8 * BITS_PER_UNIT - 1)
   && peep2_reg_dead_p (2, operands[1])
   && peep2_reg_dead_p (4, operands[2])
   && !reg_mentioned_p (operands[2], operands[3])) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 3;
              return gen_peephole2_50 (insn, operands);

            case 1:
              if (!(
#line 5057 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(/* cltd is shorter than sarl $31, %eax */
   !optimize_function_for_size_p (cfun)
   && REGNO (operands[1]) == AX_REG
   && REGNO (operands[2]) == DX_REG
   && INTVAL (operands[4]) == (8 * BITS_PER_UNIT - 1)
   && peep2_reg_dead_p (2, operands[1])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_mentioned_p (operands[2], operands[3])) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_52 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IOR
      || GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_SImode)
    return NULL;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != -65536LL)
    return NULL;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LSHIFTRT
      || GET_MODE (x6) != E_SImode)
    return NULL;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != BSWAP
      || GET_MODE (x7) != E_SImode)
    return NULL;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return NULL;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return NULL;
  x10 = XEXP (x7, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return NULL;
  x11 = XEXP (x2, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  x12 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x12) != SET)
    return NULL;
  x13 = XEXP (x12, 0);
  operands[2] = x13;
  if (!general_reg_operand (operands[2], E_SImode))
    return NULL;
  x14 = XEXP (x12, 1);
  if (!rtx_equal_p (x14, operands[0])
      || !
#line 22691 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_USE_XCHGB ||
     TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && peep2_regno_dead_p (0, FLAGS_REG)
   && peep2_reg_dead_p(3, operands[0])))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_192 (insn, operands);
}

 rtx_insn *
peephole2_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (register_operand (operands[0], E_SImode))
    {
      res = peephole2_10 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2
      || peep2_current_count < 3
      || !general_reg_operand (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) == PARALLEL
      && XVECLEN (x3, 0) == 2)
    {
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) == SET)
        {
          if (memory_operand (operands[1], E_SImode))
            {
              switch (pattern1182 (x3, 
E_SImode, 
E_DImode))
                {
                case 0:
                  if (
#line 8701 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_70 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if (
#line 9134 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_86 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if (
#line 9621 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_98 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 3:
                  if (
#line 9987 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_110 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 4:
                  if (
#line 8818 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_78 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 5:
                  if (
#line 8844 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[5])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[5], operands[1])))
                    {
                      *pmatch_len_ = 3;
                      res = gen_peephole2_82 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 6:
                  if (
#line 9302 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_92 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 7:
                  if (
#line 9328 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[5])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[5], operands[1])))
                    {
                      *pmatch_len_ = 3;
                      res = gen_peephole2_96 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          if (peep2_current_count >= 4
              && pattern1184 (x3, 
E_SImode) == 0
              && 
#line 14288 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[2])
   && !reg_mentioned_p (operands[0], operands[1])
   && !reg_mentioned_p (operands[2], operands[1])))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_151 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (general_reg_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) == NEG
                  && GET_MODE (x5) == E_SImode
                  && pattern1330 (x3) == 0)
                {
                  x6 = PATTERN (peep2_next_insn (2));
                  if (GET_CODE (x6) == SET
                      && pattern1331 (x6) == 0)
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_157 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
    }
  if (GET_CODE (x3) != SET)
    return NULL;
  if (register_operand (operands[1], E_SImode))
    {
      res = peephole2_11 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (!immediate_operand (operands[1], E_SImode))
    return NULL;
  switch (pattern949 (x3, 
E_DImode, 
E_SImode))
    {
    case 0:
      if (!(
#line 11085 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || REGNO (operands[0]) == DX_REG
       || peep2_reg_dead_p (3, operands[0]))) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_114 (insn, operands);

    case 1:
      if (!(
#line 11107 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(REGNO (operands[3]) != DX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || REGNO (operands[0]) == REGNO (operands[5])
       || peep2_reg_dead_p (3, operands[0]))
   && (REGNO (operands[2]) == REGNO (operands[4])
       || REGNO (operands[2]) == REGNO (operands[5])
       || peep2_reg_dead_p (3, operands[2]))) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_116 (insn, operands);

    case 2:
      x6 = PATTERN (peep2_next_insn (2));
      x7 = XVECEXP (x6, 0, 1);
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return NULL;
      x9 = XVECEXP (x6, 0, 0);
      x10 = XEXP (x9, 1);
      switch (GET_CODE (x10))
        {
        case SMUL_HIGHPART:
          if (pattern1764 (x10) != 0
              || !
#line 11246 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[0]))))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_118 (insn, operands);

        case UMUL_HIGHPART:
          if (pattern1764 (x10) != 0
              || !
#line 11246 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[0]))))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_119 (insn, operands);

        case ZERO_EXTEND:
          if (GET_MODE (x10) != E_DImode
              || !general_reg_operand (operands[4], E_DImode))
            return NULL;
          x11 = XEXP (x10, 0);
          if (GET_MODE (x11) != E_SImode)
            return NULL;
          switch (GET_CODE (x11))
            {
            case SMUL_HIGHPART:
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[2]))
                return NULL;
              x13 = XEXP (x11, 1);
              if (!rtx_equal_p (x13, operands[0])
                  || !
#line 11267 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[2]) != REGNO (operands[3])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[0]))))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_122 (insn, operands);

            case UMUL_HIGHPART:
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[2]))
                return NULL;
              x13 = XEXP (x11, 1);
              if (!rtx_equal_p (x13, operands[0])
                  || !
#line 11267 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[2]) != REGNO (operands[3])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[0]))))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_123 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!flags_reg_operand (x2, E_VOIDmode))
    return NULL;
  x3 = XEXP (x1, 1);
  operands[0] = x3;
  operands[4] = x2;
  res = peephole2_19 (x1, insn, pmatch_len_);
  if (res != NULL_RTX)
    return res;
  if (peep2_current_count < 4)
    return NULL;
  operands[6] = x2;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 2)
    return NULL;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != SET)
    return NULL;
  x6 = XEXP (x5, 0);
  operands[7] = x6;
  if (!flags_reg_operand (operands[7], E_VOIDmode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  x8 = XVECEXP (x4, 0, 1);
  operands[5] = x8;
  x9 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x9) != SET)
    return NULL;
  x10 = XEXP (x9, 1);
  if (!ix86_comparison_operator (x10, E_QImode))
    return NULL;
  operands[3] = x10;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 17)
    return NULL;
  x12 = XEXP (x10, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x13 = XEXP (x9, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_QImode))
    return NULL;
  x14 = PATTERN (peep2_next_insn (3));
  switch (GET_CODE (x14))
    {
    case SET:
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != ZERO_EXTEND)
        return NULL;
      x16 = XEXP (x14, 0);
      operands[4] = x16;
      if (!any_QIreg_operand (operands[4], E_VOIDmode))
        return NULL;
      x17 = XEXP (x15, 0);
      if (!rtx_equal_p (x17, operands[2])
          || !
#line 19990 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((peep2_reg_dead_p (4, operands[2])
    || operands_match_p (operands[2], operands[4]))
   && ! reg_overlap_mentioned_p (operands[4], operands[0])
   && ! reg_overlap_mentioned_p (operands[4], operands[1])
   && ! reg_overlap_mentioned_p (operands[4], operands[5])
   && ! reg_set_p (operands[4], operands[5])
   && refers_to_regno_p (FLAGS_REG, operands[1], (rtx *)NULL)
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_171 (insn, operands);

    case PARALLEL:
      if (XVECLEN (x14, 0) != 2)
        return NULL;
      x18 = XVECEXP (x14, 0, 0);
      if (GET_CODE (x18) != SET)
        return NULL;
      x19 = XEXP (x18, 1);
      if (GET_CODE (x19) != ZERO_EXTEND)
        return NULL;
      x20 = XVECEXP (x14, 0, 1);
      if (GET_CODE (x20) != CLOBBER)
        return NULL;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 17
          || GET_MODE (x21) != E_CCmode)
        return NULL;
      x22 = XEXP (x18, 0);
      operands[4] = x22;
      if (!any_QIreg_operand (operands[4], E_VOIDmode))
        return NULL;
      x23 = XEXP (x19, 0);
      if (!rtx_equal_p (x23, operands[2])
          || !
#line 20063 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((peep2_reg_dead_p (4, operands[2])
    || operands_match_p (operands[2], operands[4]))
   && ! reg_overlap_mentioned_p (operands[4], operands[0])
   && ! reg_overlap_mentioned_p (operands[4], operands[1])
   && ! reg_overlap_mentioned_p (operands[4], operands[5])
   && ! reg_set_p (operands[4], operands[5])
   && refers_to_regno_p (FLAGS_REG, operands[1], (rtx *)NULL)
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_174 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (memory_operand (operands[1], E_SImode)
      && register_operand (operands[0], E_SImode))
    {
      res = peephole2_23 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 3
      || peep2_current_count < 4
      || !general_reg_operand (operands[1], E_SImode)
      || !general_reg_operand (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17)
    return NULL;
  x6 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x4, 1);
  operands[5] = x7;
  x8 = XEXP (x6, 1);
  operands[6] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return NULL;
  x10 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x10) != SET
      || pattern1333 (x10, 
E_SImode) != 0
      || !
#line 26511 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (1, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_204 (insn, operands);
}

 rtx_insn *
peephole2_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND
      || pattern113 (x2) != 0)
    return NULL;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!general_reg_operand (operands[0], E_SImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[0])
      || !
#line 22673 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_USE_XCHGB ||
     TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && peep2_regno_dead_p (0, FLAGS_REG)))
    return NULL;
  *pmatch_len_ = 0;
  return gen_peephole2_191 (insn, operands);
}

 rtx_insn *
peephole2_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!general_reg_operand (operands[1], E_QImode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 2)
    return NULL;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 27
          || GET_MODE (x8) != E_CCmode)
        return NULL;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 17
          || GET_MODE (x9) != E_CCmode)
        return NULL;
      x10 = XVECEXP (x8, 0, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      x11 = XEXP (x7, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_193 (insn, operands);

    case E_SImode:
      if (peep2_current_count < 3
          || peep2_current_count < 4
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != POPCOUNT
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 17
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_SImode))
        return NULL;
      x12 = XEXP (x8, 0);
      if (!rtx_equal_p (x12, operands[0]))
        return NULL;
      x13 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x13) != SET
          || pattern1736 (x13) != 0)
        return NULL;
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      operands[3] = x16;
      if (!register_operand (operands[3], E_QImode))
        return NULL;
      x17 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x17) != SET)
        return NULL;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != IF_THEN_ELSE)
        return NULL;
      x19 = XEXP (x18, 0);
      if (!bt_comparison_operator (x19, E_VOIDmode))
        return NULL;
      operands[4] = x19;
      if (pattern1850 (x17) != 0)
        return NULL;
      x20 = XEXP (x18, 1);
      x21 = XEXP (x20, 0);
      operands[5] = x21;
      if (!
#line 22853 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(REGNO (operands[2]) == REGNO (operands[3])
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && peep2_regno_dead_p (4, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_194 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != 17)
    return NULL;
  x3 = XEXP (x1, 1);
  operands[0] = x3;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!general_reg_operand (operands[1], E_QImode)
          || !
#line 27032 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_regno_dead_p (0, FLAGS_REG)
   && !reg_overlap_mentioned_p (operands[1], operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_213 (insn, operands);

    case E_HImode:
      if (!general_reg_operand (operands[1], E_HImode)
          || !
#line 27032 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_regno_dead_p (0, FLAGS_REG)
   && !reg_overlap_mentioned_p (operands[1], operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_214 (insn, operands);

    case E_SImode:
      if (!general_reg_operand (operands[1], E_SImode)
          || !
#line 27032 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_regno_dead_p (0, FLAGS_REG)
   && !reg_overlap_mentioned_p (operands[1], operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_215 (insn, operands);

    case E_DImode:
      if (!general_reg_operand (operands[1], E_DImode)
          || !(
#line 27032 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_regno_dead_p (0, FLAGS_REG)
   && !reg_overlap_mentioned_p (operands[1], operands[0])) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_216 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XWINT (x2, 0) == -1LL)
    {
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (general_reg_operand (operands[0], E_HImode)
              && 
#line 28518 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_MOVE_M1_VIA_OR || optimize_insn_for_size_p ())
   && peep2_regno_dead_p (0, FLAGS_REG)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_335 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_SImode:
          if (general_reg_operand (operands[0], E_SImode)
              && 
#line 28518 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_MOVE_M1_VIA_OR || optimize_insn_for_size_p ())
   && peep2_regno_dead_p (0, FLAGS_REG)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_336 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_DImode:
          if (general_reg_operand (operands[0], E_DImode)
              && (
#line 28518 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_MOVE_M1_VIA_OR || optimize_insn_for_size_p ())
   && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_337 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  operands[2] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  if (pattern596 (x3, 
2) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  if (XINT (x5, 1) != 110)
    return NULL;
  x6 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PLUS
      || pattern1491 (x3) != 0
      || pattern1674 (x3) != 0)
    return NULL;
  x8 = PATTERN (peep2_next_insn (2));
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 1);
  operands[3] = x10;
  x11 = XEXP (x9, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (pattern1841 (x3, 
E_HImode) != 0
          || !
#line 724 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_416 (insn, operands);

    case E_SImode:
      if (pattern1841 (x3, 
E_SImode) != 0
          || !
#line 724 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_417 (insn, operands);

    case E_DImode:
      if (pattern1841 (x3, 
E_DImode) != 0
          || !(
#line 724 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_418 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UMUL_HIGHPART)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x2, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return NULL;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[3]))
    return NULL;
  x12 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x12) != SET)
    return NULL;
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  x14 = XEXP (x12, 1);
  operands[5] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern1559 (x1, 
E_SImode) != 0
          || !(
#line 10970 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI2
   && ((REGNO (operands[5]) == REGNO (operands[0])
        && REGNO (operands[1]) != REGNO (operands[4]))
       || (REGNO (operands[5]) == REGNO (operands[1])
	   && REGNO (operands[0]) != REGNO (operands[4])))
   && peep2_reg_dead_p (2, operands[5])) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_112 (insn, operands);

    case E_DImode:
      if (pattern1559 (x1, 
E_DImode) != 0
          || !(
#line 10970 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI2
   && ((REGNO (operands[5]) == REGNO (operands[0])
        && REGNO (operands[1]) != REGNO (operands[4]))
       || (REGNO (operands[5]) == REGNO (operands[1])
	   && REGNO (operands[0]) != REGNO (operands[4])))
   && peep2_reg_dead_p (2, operands[5])) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_113 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!arith_or_logical_operator (operands[3], E_QImode))
        return NULL;
      if (register_operand (operands[0], E_QImode))
        {
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          if (memory_operand (operands[1], E_QImode))
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27970 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_271 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (memory_operand (operands[1], E_QImode)
              && rtx_equal_p (x5, operands[0])
              && 
#line 27983 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_275 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return NULL;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[1] = x5;
      if (nonmemory_operand (operands[1], E_QImode))
        {
          x6 = XEXP (x4, 0);
          if (rtx_equal_p (x6, operands[0])
              && 
#line 28058 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_285 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!nonmemory_operand (operands[1], E_QImode)
          || !rtx_equal_p (x5, operands[0])
          || !
#line 28072 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_289 (insn, operands);

    case E_HImode:
      if (!arith_or_logical_operator (operands[3], E_HImode))
        return NULL;
      if (register_operand (operands[0], E_HImode))
        {
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          if (memory_operand (operands[1], E_HImode))
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27970 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_272 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (memory_operand (operands[1], E_HImode)
              && rtx_equal_p (x5, operands[0])
              && 
#line 27983 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_276 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return NULL;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[1] = x5;
      if (nonmemory_operand (operands[1], E_HImode))
        {
          x6 = XEXP (x4, 0);
          if (rtx_equal_p (x6, operands[0])
              && 
#line 28058 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_286 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!nonmemory_operand (operands[1], E_HImode)
          || !rtx_equal_p (x5, operands[0])
          || !
#line 28072 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_290 (insn, operands);

    case E_SImode:
      if (!arith_or_logical_operator (operands[3], E_SImode))
        return NULL;
      if (register_operand (operands[0], E_SImode))
        {
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          if (memory_operand (operands[1], E_SImode))
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27970 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_273 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (memory_operand (operands[1], E_SImode)
              && rtx_equal_p (x5, operands[0])
              && 
#line 27983 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_277 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[1] = x5;
      if (x86_64_nonmemory_operand (operands[1], E_SImode))
        {
          x6 = XEXP (x4, 0);
          if (rtx_equal_p (x6, operands[0])
              && 
#line 28058 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_287 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!x86_64_nonmemory_operand (operands[1], E_SImode)
          || !rtx_equal_p (x5, operands[0])
          || !
#line 28072 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_291 (insn, operands);

    case E_DImode:
      if (!arith_or_logical_operator (operands[3], E_DImode))
        return NULL;
      if (register_operand (operands[0], E_DImode))
        {
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          if (memory_operand (operands[1], E_DImode))
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && (
#line 27970 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_274 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (memory_operand (operands[1], E_DImode)
              && rtx_equal_p (x5, operands[0])
              && (
#line 27983 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY || optimize_insn_for_size_p ())) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_278 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[1] = x5;
      if (x86_64_nonmemory_operand (operands[1], E_DImode))
        {
          x6 = XEXP (x4, 0);
          if (rtx_equal_p (x6, operands[0])
              && (
#line 28058 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_288 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!x86_64_nonmemory_operand (operands[1], E_DImode)
          || !rtx_equal_p (x5, operands[0])
          || !(
#line 28072 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!(TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_292 (insn, operands);

    default:
      return NULL;
    }
}
