/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case AND:
      return pattern0 (x1, pnum_clobbers); /* [-1, 0] */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 1;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 8
      || GET_MODE (x3) != E_XFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 9
      || GET_MODE (x5) != E_XFmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 10
      || GET_MODE (x7) != E_XFmode)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 11
      || GET_MODE (x9) != E_XFmode)
    return -1;
  x10 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 12
      || GET_MODE (x11) != E_XFmode)
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 13
      || GET_MODE (x13) != E_XFmode)
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 14
      || GET_MODE (x15) != E_XFmode)
    return -1;
  x16 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 15
      || GET_MODE (x17) != E_XFmode)
    return -1;
  return 0;
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !general_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !general_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !x86_64_general_operand (operands[2], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !x86_64_general_operand (operands[2], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern59 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      if (GET_MODE (x2) != E_TImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != ZERO_EXTEND
          || GET_MODE (x3) != E_TImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 64]
          || !nonimmediate_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_TImode
          || !nonimmediate_operand (operands[1], E_TImode)
          || !const_scalar_int_operand (operands[3], E_TImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!nonimmediate_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case ZERO_EXTEND:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || GET_MODE (x1) != E_TImode)
            return -1;
          x5 = XEXP (x1, 0);
          if (GET_MODE (x5) != E_TImode
              || !nonimmediate_operand (operands[1], E_TImode)
              || !const_scalar_int_operand (operands[3], E_TImode)
              || GET_MODE (x2) != E_TImode
              || !nonimmediate_operand (operands[2], E_DImode))
            return -1;
          return 1;

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode)
            return -1;
          x5 = XEXP (x1, 0);
          if (GET_MODE (x5) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !const_int_operand (operands[3], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[2], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      return pattern97 (x1, 
E_V2QImode); /* [-1, 0] */

    case E_V4QImode:
      res = pattern98 (x1, 
E_V4QImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_V8QImode:
      if (!memory_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || GET_MODE (x2) != E_V8QImode)
        return -1;
      res = pattern99 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4HImode:
      res = pattern98 (x1, 
E_V4HImode);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case E_V2HImode:
      if (pattern97 (x1, 
E_V2HImode) != 0)
        return -1;
      return 8;

    case E_V2SImode:
      if (pattern97 (x1, 
E_V2SImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern139 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern148 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern146 (x1, 
E_V16SImode, 
E_HImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern146 (x1, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern146 (x1, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_V8DImode:
      if (pattern146 (x1, 
E_V8DImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern146 (x1, 
E_V4DImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern146 (x1, 
E_V2DImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_V64QImode:
      if (pattern146 (x1, 
E_V64QImode, 
E_DImode) != 0)
        return -1;
      return 6;

    case E_V16QImode:
      if (pattern146 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_V32QImode:
      if (pattern146 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 8;

    case E_V32HImode:
      if (pattern146 (x1, 
E_V32HImode, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_V16HImode:
      if (pattern147 (x1, 
E_V16HImode) != 0)
        return -1;
      return 10;

    case E_V8HImode:
      if (pattern146 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern152 (x3, 
E_V16SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern152 (x3, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern152 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!vector_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern178 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      return pattern172 (x3, 
E_V8SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern172 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V16SImode:
      if (pattern172 (x3, 
E_V16SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !vector_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern191 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i3))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern195 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || !ternlog_operand (operands[1], E_V32HFmode))
        return -1;
      return 0;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || !ternlog_operand (operands[1], E_V16HFmode))
        return -1;
      return 1;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || !ternlog_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || !ternlog_operand (operands[1], E_V32BFmode))
        return -1;
      return 3;

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || !ternlog_operand (operands[1], E_V16BFmode))
        return -1;
      return 4;

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || !ternlog_operand (operands[1], E_V8BFmode))
        return -1;
      return 5;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || !ternlog_operand (operands[1], E_V16SFmode))
        return -1;
      return 6;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || !ternlog_operand (operands[1], E_V8SFmode))
        return -1;
      return 7;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !ternlog_operand (operands[1], E_V4SFmode))
        return -1;
      return 8;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || !ternlog_operand (operands[1], E_V8DFmode))
        return -1;
      return 9;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || !ternlog_operand (operands[1], E_V4DFmode))
        return -1;
      return 10;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !ternlog_operand (operands[1], E_V2DFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      return pattern202 (x4); /* [-1, 7] */

    case ASHIFT:
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x10 = XEXP (x5, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern203 (x5, 
E_DImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern203 (x5, 
E_TImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case CLOBBER:
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17
          || GET_MODE (x8) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          return pattern211 (x4, 
E_DImode); /* [-1, 0] */

        case E_TImode:
          if (pattern211 (x4, 
E_TImode) != 0)
            return -1;
          return 1;

        case E_QImode:
          if (pattern211 (x4, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_HImode:
          if (pattern211 (x4, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_SImode:
          if (pattern211 (x4, 
E_SImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern213 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern231 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!mask_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !mask_reg_operand (operands[1], i1)
      || !mask_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x7;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      return 0;

    case ZERO_EXTEND:
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != ZERO_EXTEND
          || GET_MODE (x8) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern258 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      return 0;

    case STRICT_LOW_PART:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      x4 = XEXP (x1, 1);
      res = pattern39 (x4);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return pattern263 (); /* [-1, 2] */
}

int
pattern269 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (pnum_clobbers == NULL
          || maybe_ne (SUBREG_BYTE (x2), 0)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!int248_register_operand (operands[2], E_VOIDmode))
            return -1;
          return pattern268 (x1); /* [-1, 1] */

        case PLUS:
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
            return -1;
          res = pattern268 (x1);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case MINUS:
          x4 = XEXP (x3, 0);
          operands[3] = x4;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
            return -1;
          res = pattern2 (x1);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        default:
          return -1;
        }

    case CONST_INT:
      return 6;

    default:
      return -1;
    }
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case LTU:
    case UNLT:
      operands[4] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!flags_reg_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case EQ:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern303 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_mmxmem_operand (operands[2], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_0_to_255_mul_8_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern310 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !nonimmediate_operand (operands[1], E_HImode)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern318 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !float_vector_all_ones_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x1) != E_V8DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode))
        return -1;
      return 3;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode))
        return -1;
      return 4;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern333 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern335 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != VEC_SELECT)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PARALLEL)
    return -1;
  x9 = XEXP (x1, 1);
  if (GET_CODE (x9) != PLUS)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != VEC_SELECT)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != PARALLEL)
    return -1;
  x13 = XEXP (x9, 1);
  if (GET_CODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != VEC_SELECT)
    return -1;
  x15 = XEXP (x14, 1);
  if (GET_CODE (x15) != PARALLEL)
    return -1;
  x16 = XEXP (x4, 0);
  operands[1] = x16;
  x17 = XEXP (x7, 0);
  if (!rtx_equal_p (x17, operands[1]))
    return -1;
  x18 = XEXP (x11, 0);
  if (!rtx_equal_p (x18, operands[1]))
    return -1;
  x19 = XEXP (x14, 0);
  if (!rtx_equal_p (x19, operands[1]))
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 4:
      x20 = XVECEXP (x5, 0, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x21 = XVECEXP (x5, 0, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x22 = XVECEXP (x5, 0, 2);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x23 = XVECEXP (x5, 0, 3);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 12]
          || XVECLEN (x8, 0) != 4)
        return -1;
      x24 = XVECEXP (x8, 0, 0);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x25 = XVECEXP (x8, 0, 1);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x26 = XVECEXP (x8, 0, 2);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x27 = XVECEXP (x8, 0, 3);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 13]
          || XVECLEN (x12, 0) != 4)
        return -1;
      x28 = XVECEXP (x12, 0, 0);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x29 = XVECEXP (x12, 0, 1);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x30 = XVECEXP (x12, 0, 2);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x31 = XVECEXP (x12, 0, 3);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x15, 0) != 4)
        return -1;
      x32 = XVECEXP (x15, 0, 0);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x33 = XVECEXP (x15, 0, 1);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x34 = XVECEXP (x15, 0, 2);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x35 = XVECEXP (x15, 0, 3);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || pattern334 (x1, 
E_V4QImode, 
E_V4SImode, 
E_V16QImode) != 0)
        return -1;
      return 0;

    case 2:
      x20 = XVECEXP (x5, 0, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x21 = XVECEXP (x5, 0, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
          || XVECLEN (x8, 0) != 2)
        return -1;
      x24 = XVECEXP (x8, 0, 0);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x25 = XVECEXP (x8, 0, 1);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 5]
          || XVECLEN (x12, 0) != 2)
        return -1;
      x28 = XVECEXP (x12, 0, 0);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x29 = XVECEXP (x12, 0, 1);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x15, 0) != 2)
        return -1;
      x32 = XVECEXP (x15, 0, 0);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x33 = XVECEXP (x15, 0, 1);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || pattern334 (x1, 
E_V2HImode, 
E_V2DImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern374 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern378 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern383 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  return 0;
}

int
pattern388 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || GET_MODE (x1) != E_XFmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern396 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != i1
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 20
      || GET_MODE (x2) != E_V2DImode)
    return -1;
  return 0;
}

int
pattern404 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      x5 = XEXP (x4, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              return pattern400 (x1, 
E_DImode, 
E_SImode); /* [-1, 0] */

            case E_TImode:
              if (pattern400 (x1, 
E_TImode, 
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          res = pattern402 (x1);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case ZERO_EXTEND:
          res = pattern402 (x1);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern403 (x1, 
E_DImode, 
E_SImode) != 0)
            return -1;
          return 6;

        case E_TImode:
          if (pattern403 (x1, 
E_TImode, 
E_DImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern423 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  return pattern422 (x2, 
i1); /* [-1, 0] */
}

int
pattern431 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const248_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern430 (x1); /* [-1, 1] */
}

int
pattern438 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern444 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  operands[2] = x1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern452 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 1);
  operands[2] = x7;
  if (!const48_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern451 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern451 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern465 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern464 (x1, 
E_DImode, 
E_V64QImode, 
E_V32HFmode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern464 (x1, 
E_SImode, 
E_V32QImode, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern464 (x1, 
E_HImode, 
E_V16QImode, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern476 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern481 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern485 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[5], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern491 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[3] = x5;
  if (!const48_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern489 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16SFmode:
      if (pattern489 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 1;

    case E_V8DFmode:
      if (pattern489 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern496 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[4], E_V4HFmode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!vector_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!vector_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern500 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SFmode
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[3], E_V2SFmode)
      || !const0_operand (operands[4], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern504 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern507 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != CONST_VECTOR
      || XVECLEN (x2, 0) != 8
      || GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x2, 0, 4);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x2, 0, 5);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XVECEXP (x2, 0, 6);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XVECEXP (x2, 0, 7);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x11 = XEXP (x1, 0);
  if (GET_MODE (x11) != E_V8QImode)
    return -1;
  return 0;
}

int
pattern526 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !regmem_or_bitnot_regmem_operand (operands[1], i1)
      || !regmem_or_bitnot_regmem_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !regmem_or_bitnot_regmem_operand (operands[3], i1)
      || !regmem_or_bitnot_regmem_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern531 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern530 (x1, 
E_V64QImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern530 (x1, 
E_V32QImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern530 (x1, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern530 (x1, 
E_V32HImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern530 (x1, 
E_V16HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern530 (x1, 
E_V8HImode) != 0)
        return -1;
      return 5;

    case E_V16SImode:
      if (pattern530 (x1, 
E_V16SImode) != 0)
        return -1;
      return 6;

    case E_V8SImode:
      if (pattern530 (x1, 
E_V8SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern530 (x1, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V8DImode:
      if (pattern530 (x1, 
E_V8DImode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern530 (x1, 
E_V4DImode) != 0)
        return -1;
      return 10;

    case E_V2DImode:
      if (pattern530 (x1, 
E_V2DImode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern540 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern539 (x5, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern539 (x5, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern545 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  return pattern544 (x6); /* [-1, 2] */
}

int
pattern551 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern553 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern552 (x4); /* [-1, 1] */
}

int
pattern560 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_hilo_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern563 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_or_x86_64_const_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern570 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_BLKmode
      || !memory_operand (operands[0], E_BLKmode)
      || !register_operand (operands[1], E_SImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern575 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern574 (x1); /* [-1, 3] */
}

int
pattern581 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x6;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x11 = XEXP (x10, 1);
      if (GET_CODE (x11) != SUBREG
          || maybe_ne (SUBREG_BYTE (x11), 0))
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != i1
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != SUBREG
          || maybe_ne (SUBREG_BYTE (x13), 0)
          || GET_MODE (x13) != E_QImode)
        return -1;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          if (!rtx_equal_p (x14, operands[3]))
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != ZERO_EXTRACT)
            return -1;
          x16 = XEXP (x15, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x17 = XEXP (x15, 2);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x18 = XEXP (x2, 0);
          operands[4] = x18;
          if (!flags_reg_operand (operands[4], E_VOIDmode))
            return -1;
          operands[5] = x3;
          if (!compare_operator (operands[5], E_VOIDmode))
            return -1;
          return pattern580 (x1); /* [-1, 2] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern604 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern608 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern613 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MULT)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SIGN_EXTEND)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x1, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  return 0;
}

int
pattern622 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern621 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern621 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern631 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern629 (x1, 
E_V16SImode, 
E_HImode, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern629 (x1, 
E_V8SImode, 
E_QImode, 
E_V8SFmode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern629 (x1, 
E_V4SImode, 
E_QImode, 
E_V4SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern636 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  return 0;
}

int
pattern639 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8DImode)
      || GET_MODE (x1) != E_V8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8DFmode:
      if (!vector_operand (operands[1], E_V8DFmode))
        return -1;
      return 1;

    case E_V8SFmode:
      if (!vector_operand (operands[1], E_V8SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern646 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[5] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern642 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

    case E_V16SFmode:
      if (pattern642 (x1, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_V8DFmode:
      if (pattern642 (x1, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern655 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XEXP (x2, 1);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern654 (x1, 
E_V32QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern654 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern662 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern661 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern661 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern661 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern669 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  operands[3] = x2;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[4] = x3;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  operands[5] = x4;
  if (!const_0_to_3_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern676 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_CONCAT:
      return pattern674 (x1); /* [-1, 5] */

    case VEC_MERGE:
      if (GET_MODE (x4) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != VEC_DUPLICATE
          || GET_MODE (x5) != E_V4SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_VECTOR
          || XVECLEN (x6, 0) != 4
          || GET_MODE (x6) != E_V4SImode)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x6, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x6, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XEXP (x4, 2);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern675 (x1);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern690 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 17
      || GET_MODE (x1) != E_CCmode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_TImode:
      return 1;

    case E_QImode:
      return 2;

    case E_HImode:
      return 3;

    case E_SImode:
      return 4;

    case E_SFmode:
      return 5;

    case E_DFmode:
      return 6;

    case E_XFmode:
      return 7;

    default:
      return -1;
    }
}

int
pattern700 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 38)
    return -1;
  return pattern228 (x1); /* [-1, 1] */
}

int
pattern703 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != i1
      || GET_MODE (x6) != E_CCCmode)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x5, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCCmode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern716 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const_scalar_int_operand (operands[3], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !x86_64_hilo_general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern724 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!plusminuslogic_operator (x3, i1))
    return -1;
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!nonmemory_operand (operands[2], i1)
      || pattern723 (x2) != 0)
    return -1;
  return 0;
}

int
pattern734 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern740 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !sse_comparison_operator (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern746 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern745 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern745 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern758 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern763 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern771 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern777 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern785 (rtx x1, int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern802 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!movq_parallel (operands[3], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[4] = x6;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern798 (x1, 
E_V64QImode, 
E_V128QImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern798 (x1, 
E_V32QImode, 
E_V64QImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern798 (x1, 
E_V16QImode, 
E_V32QImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern798 (x1, 
E_V32HImode, 
E_V64HImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern798 (x1, 
E_V16HImode, 
E_V32HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern798 (x1, 
E_V8HImode, 
E_V16HImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern817 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_XFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE
      || !register_operand (operands[0], E_XFmode)
      || !register_operand (operands[1], E_XFmode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!memory_operand (operands[2], E_HImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[3] = x7;
  if (!memory_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern824 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !x86_64_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern828 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern692 (x5); /* [-1, 0] */

    case E_V2BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern693 (x5, 
E_V2BFmode) != 0)
        return -1;
      return 1;

    case E_V4BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern693 (x5, 
E_V4BFmode) != 0)
        return -1;
      return 2;

    case E_V2HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern693 (x5, 
E_V2HFmode) != 0)
        return -1;
      return 3;

    case E_V4HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern693 (x5, 
E_V4HFmode) != 0)
        return -1;
      return 4;

    case E_V32BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V32BFmode) != 0)
        return -1;
      return 5;

    case E_V16BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V16BFmode) != 0)
        return -1;
      return 6;

    case E_V8BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V8BFmode) != 0)
        return -1;
      return 7;

    case E_V32HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V32HFmode) != 0)
        return -1;
      return 8;

    case E_V16HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V16HFmode) != 0)
        return -1;
      return 9;

    case E_V8HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V8HFmode) != 0)
        return -1;
      return 10;

    case E_V16SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V16SFmode) != 0)
        return -1;
      return 11;

    case E_V8SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V8SFmode) != 0)
        return -1;
      return 12;

    case E_V4SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V4SFmode) != 0)
        return -1;
      return 13;

    case E_V8DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V8DFmode) != 0)
        return -1;
      return 14;

    case E_V4DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V4DFmode) != 0)
        return -1;
      return 15;

    case E_V2DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern691 (x5, 
E_V2DFmode) != 0)
        return -1;
      return 16;

    default:
      return -1;
    }
}

int
pattern864 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_V64QImode)
          || !nonimmediate_operand (operands[2], E_V64QImode))
        return -1;
      return 0;

    case E_SImode:
      res = pattern863 ();
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_HImode:
      res = pattern736 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_QImode:
      res = pattern737 ();
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern874 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern883 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern890 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  operands[3] = x2;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[4] = x3;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  operands[5] = x4;
  if (!const_0_to_3_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern897 (rtx x1, int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern902 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  if (!const48_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[4] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern900 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16SFmode:
          if (pattern900 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8DFmode:
          if (pattern900 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x7, 0) != 1LL)
        return -1;
      operands[3] = x6;
      x8 = XEXP (x2, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern901 (x1, 
E_V8HFmode) != 0)
            return -1;
          return 3;

        case E_V4SFmode:
          if (pattern901 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 4;

        case E_V2DFmode:
          if (pattern901 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern917 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern922 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern929 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern928 (x3, 
E_DImode, 
E_SImode); /* [-1, 0] */

    case E_TImode:
      if (pattern928 (x3, 
E_TImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern937 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      if (XINT (x4, 1) != 19)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return pattern935 (x3); /* [-1, 1] */

    case 4:
      if (XINT (x4, 1) != 22
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XVECEXP (x4, 0, 3);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 7
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 6
          || GET_MODE (x8) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[3] = x5;
      if (!tls_modbase_operand (operands[3], E_VOIDmode))
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      operands[4] = x9;
      x10 = XVECEXP (x4, 0, 2);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x11 = XVECEXP (x8, 0, 0);
      operands[1] = x11;
      if (!tls_symbolic_operand (operands[1], E_VOIDmode))
        return -1;
      return 2;

    case 3:
      if (XINT (x4, 1) != 22)
        return -1;
      x10 = XVECEXP (x4, 0, 2);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 7)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 6)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      if (!tls_modbase_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      operands[3] = x9;
      x11 = XVECEXP (x8, 0, 0);
      operands[1] = x11;
      if (!tls_symbolic_operand (operands[1], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern936 (x3, 
E_SImode) != 0)
            return -1;
          return 3;

        case E_DImode:
          if (pattern936 (x3, 
E_DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern966 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_BFmode)
      || GET_MODE (x1) != E_BFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32BFmode:
      if (!nonimmediate_operand (operands[1], E_V32BFmode))
        return -1;
      return 0;

    case E_V16BFmode:
      if (!nonimmediate_operand (operands[1], E_V16BFmode))
        return -1;
      return 1;

    case E_V8BFmode:
      if (!nonimmediate_operand (operands[1], E_V8BFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern969 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern259 (x5, 
E_SImode, 
E_DImode); /* [-1, 1] */
}

int
pattern972 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 59)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[4] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  switch (GET_MODE (x1))
    {
    case E_V32QImode:
      return pattern971 (x2, 
E_V32QImode, 
E_SImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern971 (x2, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern980 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (x1))
    {
    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SImode)
          || !const0_operand (operands[2], E_V8SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SImode)
          || !const0_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DImode)
          || !const0_operand (operands[2], E_V4DImode))
        return -1;
      return 2;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DImode)
          || !const0_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !const0_operand (operands[2], E_V16QImode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern995 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1003 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern1011 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const48_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern1008 (x1, 
E_V8HFmode, 
E_V8HImode); /* [-1, 0] */

    case E_V16HImode:
      if (pattern1008 (x1, 
E_V16HFmode, 
E_V16HImode) != 0)
        return -1;
      return 1;

    case E_V32HImode:
      if (pattern1008 (x1, 
E_V32HFmode, 
E_V32HImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      res = pattern1009 (x1);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    case E_V16SImode:
      res = pattern1010 (x1);
      if (res >= 0)
        return res + 5; /* [5, 6] */
      return -1;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_V8DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          return 7;

        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 8;

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1035 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[3]))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode)
          || !extract_operator (operands[4], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode)
          || !extract_operator (operands[4], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode)
          || !extract_operator (operands[4], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1040 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 1);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0))
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != i1)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != ZERO_EXTEND)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != MINUS
          || GET_MODE (x8) != E_QImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != AND
          || GET_MODE (x10) != E_QImode)
        return -1;
      x11 = XEXP (x10, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XEXP (x3, 0);
      if (!nonmemory_operand (x12, E_QImode))
        return -1;
      switch (XWINT (x4, 0))
        {
        case 63LL:
          if (XWINT (x9, 0) != 64LL
              || XWINT (x11, 0) != 63LL
              || pattern1039 (x1, 
E_DImode, 
E_TImode) != 0)
            return -1;
          return 0;

        case 31LL:
          if (XWINT (x9, 0) != 32LL
              || XWINT (x11, 0) != 31LL)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 2;

    default:
      return -1;
    }
}

int
pattern1061 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern1067 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_no_SP_operand (operands[1], i1)
      || !const123_operand (operands[2], E_VOIDmode)
      || !nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1077 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern1076 (x2); /* [-1, 20] */
}

int
pattern1083 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  return pattern863 (); /* [-1, 1] */
}

int
pattern1087 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!vector_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!vector_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1090 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!nonimmediate_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[4] = x3;
  x4 = XEXP (x2, 2);
  operands[5] = x4;
  if (!register_operand (operands[5], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern1099 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern1099 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern1099 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern1116 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1125 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 0LL:
      x3 = XVECEXP (x1, 0, 1);
      switch (XWINT (x3, 0))
        {
        case 1LL:
          return 0;

        case 2LL:
          return 1;

        default:
          return -1;
        }

    case 1LL:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3LL)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (XWINT (x4, 0) != 5LL)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (XWINT (x5, 0) != 7LL)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1140 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  return pattern1139 (x1); /* [-1, 5] */
}

int
pattern1148 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x1, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1146 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1146 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1147 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1147 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      return 0;

    case STRICT_LOW_PART:
      res = pattern552 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1172 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1178 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_MODE (x7) != E_CCCmode
      || GET_MODE (x3) != E_CCCmode)
    return -1;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  if (!memory_operand (operands[2], i1))
    return -1;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x3, 1);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  x11 = XEXP (x6, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x6, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  return 0;
}

int
pattern1187 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 0);
  switch (GET_MODE (x6))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1201 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1207 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!nonimmediate_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1215 (x1, 
E_DImode, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1215 (x1, 
E_TImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  switch (GET_MODE (x7))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1235 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x3 = XEXP (x1, 1);
          if (GET_MODE (x3) != E_DImode)
            return -1;
          return 0;

        case E_TImode:
          x3 = XEXP (x1, 1);
          if (pattern1233 (x3, 
E_TImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      res = pattern1234 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1254 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  return 0;
}

int
pattern1261 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern1271 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i3))
    return -1;
  return 0;
}

int
pattern1281 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const48_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern1287 (x1, 
E_HImode, 
E_V16SImode, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern1287 (x1, 
E_QImode, 
E_V8SImode, 
E_V8DFmode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_V8DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8DImode
          || !nonimm_or_0_operand (operands[2], E_V8DImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 2;

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1307 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !const_1_to_31_operand (operands[2], E_QImode)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1311 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XEXP (x1, 1);
      return pattern1310 (x4, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XEXP (x1, 1);
      if (pattern1310 (x4, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1320 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || pattern557 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1326 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!mask_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !mask_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1332 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x2, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  return pattern1331 (x8); /* [-1, 0] */
}

int
pattern1343 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1351 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return pattern1350 (); /* [-1, 3] */
}

int
pattern1354 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1363 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1371 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !bcst_vector_operand (operands[1], i1)
      || pattern1358 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1379 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1390 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1396 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1404 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      return pattern1403 (x1); /* [-1, 2] */

    case IOR:
      res = pattern1403 (x1);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case XOR:
      res = pattern1403 (x1);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1418 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1424 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1423 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1423 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1423 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1423 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1436 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode
      || !const_0_to_31_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern1443 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1453 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  x3 = XVECEXP (x2, 0, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!const_0_to_7_operand (operands[5], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern1451 (x1, 
E_V4SImode, 
E_V16QImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern1451 (x1, 
E_V2DImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern1451 (x1, 
E_V8SImode, 
E_V32QImode) != 0)
        return -1;
      return 2;

    case E_V4DImode:
      if (pattern1451 (x1, 
E_V4DImode, 
E_V32QImode) != 0)
        return -1;
      return 3;

    case E_V32QImode:
      if (pattern1452 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 4;

    case E_V16QImode:
      if (pattern1452 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern1469 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !const_0_to_15_operand (operands[2], E_VOIDmode)
      || !const_0_to_15_operand (operands[3], E_VOIDmode)
      || !const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1478 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1488 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (maybe_ne (SUBREG_BYTE (x1), 0)
      || GET_MODE (x1) != E_QImode
      || !nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  return pattern1152 (x2); /* [-1, 2] */
}

int
pattern1491 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  return 0;
}

int
pattern1499 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1512 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x7, 1);
  operands[3] = x9;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  return 0;
}

int
pattern1524 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1533 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1542 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !sext_operand (operands[2], i1)
      || pattern714 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1552 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 32)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 0;

    case CLOBBER:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17
          || GET_MODE (x3) != E_CCmode)
        return -1;
      return 1;

    case USE:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[4] = x3;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1563 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1571 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || pattern1570 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1580 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], E_QImode))
    return -1;
  return 0;
}

int
pattern1592 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vsib_mem_operator (operands[5], i1))
    return -1;
  switch (GET_MODE (operands[6]))
    {
    case E_HImode:
      x2 = XVECEXP (x1, 0, 2);
      x3 = XEXP (x2, 0);
      return pattern1591 (x3, 
E_V16SImode, 
E_HImode); /* [-1, 1] */

    case E_QImode:
      x2 = XVECEXP (x1, 0, 2);
      x3 = XEXP (x2, 0);
      res = pattern1591 (x3, 
E_V8DImode, 
E_QImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1604 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!rtx_equal_p (x2, operands[2]))
    return -1;
  x3 = XEXP (x1, 1);
  if (!rtx_equal_p (x3, operands[3]))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!nonimmediate_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case CONST_INT:
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1614 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1624 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1632 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1642 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (XWINT (x2, 0) != 2LL)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (XWINT (x3, 0) != 2LL)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (XWINT (x4, 0) != 4LL)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (XWINT (x5, 0) != 4LL)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (XWINT (x6, 0) != 6LL)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (XWINT (x7, 0) != 6LL)
    return -1;
  return 0;
}

int
pattern1651 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1661 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_TImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  if (!const_0_to_255_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern1674 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x7, 1);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = PATTERN (peep2_next_insn (2));
  return pattern1517 (x11); /* [-1, 0] */
}

int
pattern1686 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1685 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1685 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1697 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1696 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1696 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1708 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1717 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 2);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1724 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1731 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1739 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8SFmode)
      || GET_MODE (x1) != E_V8SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V8HFmode:
      if (!memory_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V8BFmode:
      if (!memory_operand (operands[1], E_V16BFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1750 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (XWINT (x2, 0) != 1LL)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (XWINT (x3, 0) != 2LL)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (XWINT (x4, 0) != 3LL)
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  if (XWINT (x5, 0) != 4LL)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (XWINT (x6, 0) != 5LL)
    return -1;
  x7 = XVECEXP (x1, 0, 6);
  if (XWINT (x7, 0) != 6LL)
    return -1;
  x8 = XVECEXP (x1, 0, 7);
  if (XWINT (x8, 0) != 7LL)
    return -1;
  x9 = XVECEXP (x1, 0, 8);
  if (XWINT (x9, 0) != 8LL)
    return -1;
  x10 = XVECEXP (x1, 0, 9);
  if (XWINT (x10, 0) != 9LL)
    return -1;
  x11 = XVECEXP (x1, 0, 10);
  if (XWINT (x11, 0) != 10LL)
    return -1;
  x12 = XVECEXP (x1, 0, 11);
  if (XWINT (x12, 0) != 11LL)
    return -1;
  x13 = XVECEXP (x1, 0, 12);
  if (XWINT (x13, 0) != 12LL)
    return -1;
  x14 = XVECEXP (x1, 0, 13);
  if (XWINT (x14, 0) != 13LL)
    return -1;
  x15 = XVECEXP (x1, 0, 14);
  if (XWINT (x15, 0) != 14LL)
    return -1;
  x16 = XVECEXP (x1, 0, 15);
  if (XWINT (x16, 0) != 15LL)
    return -1;
  return 0;
}

int
pattern1769 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !register_operand (operands[4], E_V8SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !register_operand (operands[4], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1776 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[7], i2)
      || !scratch_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1783 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 17);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 18);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 19);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 20);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 21);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1793 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  x7 = XEXP (x1, 1);
  if (!rtx_equal_p (x7, operands[3]))
    return -1;
  return 0;
}

int
pattern1802 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8SImode:
      if (!register_operand (operands[2], E_V8SImode)
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode)
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1810 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_V2DImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  switch (XWINT (x5, 0))
    {
    case 0LL:
      x6 = XVECEXP (x4, 0, 1);
      if (XWINT (x6, 0) != 2LL)
        return -1;
      x7 = XEXP (x1, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (XWINT (x10, 0) != 0LL)
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (XWINT (x11, 0) != 2LL)
        return -1;
      return 0;

    case 1LL:
      x6 = XVECEXP (x4, 0, 1);
      if (XWINT (x6, 0) != 3LL)
        return -1;
      x7 = XEXP (x1, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (XWINT (x10, 0) != 1LL)
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (XWINT (x11, 0) != 3LL)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1821 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[5], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1829 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vsib_mem_operator (operands[6], i3)
      || !register_operand (operands[4], i2)
      || !scratch_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1838 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          return 0;

        case E_SImode:
          return 1;

        case E_DImode:
          return 2;

        case E_TImode:
          return 3;

        default:
          return -1;
        }

    case CONST_INT:
      operands[6] = x5;
      x7 = XEXP (x3, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      operands[2] = x9;
      x10 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          return 4;

        case E_SImode:
          return 5;

        case E_DImode:
          return 6;

        case E_TImode:
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1850 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCZmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x2, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  return 0;
}

int
pattern1858 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !ix86_carry_flag_operator (operands[5], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1865 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (XWINT (x2, 0) != 12LL)
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (XWINT (x3, 0) != 44LL)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (XWINT (x4, 0) != 13LL)
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (XWINT (x5, 0) != 45LL)
    return -1;
  x6 = XVECEXP (x1, 0, 12);
  if (XWINT (x6, 0) != 14LL)
    return -1;
  x7 = XVECEXP (x1, 0, 13);
  if (XWINT (x7, 0) != 46LL)
    return -1;
  x8 = XVECEXP (x1, 0, 14);
  if (XWINT (x8, 0) != 15LL)
    return -1;
  x9 = XVECEXP (x1, 0, 15);
  if (XWINT (x9, 0) != 47LL)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || !bt_comparison_operator (x3, E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (XWINT (x4, 0))
            {
            case 0LL:
              x6 = XEXP (x2, 1);
              if (GET_CODE (x6) != PLUS
                  || GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
                return -1;
              x8 = XEXP (x1, 0);
              operands[0] = x8;
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode)
                return -1;
              operands[1] = x3;
              operands[2] = x5;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              x9 = XEXP (x2, 2);
              operands[3] = x9;
              if (!nonimmediate_operand (operands[3], E_HImode))
                return -1;
              x10 = XEXP (x6, 0);
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 8750 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE))
                return -1;
              *pnum_clobbers = 1;
              return 449; /* *dec_cmovhi */

            case -1LL:
              x6 = XEXP (x2, 1);
              switch (GET_CODE (x6))
                {
                case LABEL_REF:
                  x9 = XEXP (x2, 2);
                  if (GET_CODE (x9) != PC)
                    return -1;
                  x8 = XEXP (x1, 0);
                  if (GET_CODE (x8) != PC)
                    return -1;
                  operands[0] = x3;
                  operands[1] = x5;
                  x10 = XEXP (x6, 0);
                  operands[2] = x10;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_QImode:
                      if (!register_operand (operands[1], E_QImode)
                          || !(
#line 2422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1555 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 2630; /* *kortest_cmpqi_jcc */

                    case E_HImode:
                      if (!register_operand (operands[1], E_HImode)
                          || !
#line 2422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                        return -1;
                      *pnum_clobbers = 1;
                      return 2631; /* *kortest_cmphi_jcc */

                    case E_SImode:
                      if (!register_operand (operands[1], E_SImode)
                          || !
#line 2422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                        return -1;
                      *pnum_clobbers = 1;
                      return 2632; /* *kortest_cmpsi_jcc */

                    case E_DImode:
                      if (!register_operand (operands[1], E_DImode)
                          || !(
#line 2422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1556 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512BW && TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 2633; /* *kortest_cmpdi_jcc */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                case MEM:
                  operands[2] = x6;
                  x8 = XEXP (x1, 0);
                  operands[0] = x8;
                  operands[1] = x3;
                  operands[4] = x5;
                  x9 = XEXP (x2, 2);
                  operands[3] = x9;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_QImode:
                      if (!register_operand (operands[0], E_QImode)
                          || GET_MODE (x2) != E_QImode
                          || !register_operand (operands[2], E_QImode)
                          || !register_operand (operands[3], E_QImode))
                        return -1;
                      switch (pattern1350 ())
                        {
                        case 0:
                          if (!(
#line 2458 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL) && 
#line 1555 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2634; /* *kortest_cmpqi_movqicc */

                        case 1:
                          if (!
#line 2458 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2635; /* *kortest_cmphi_movqicc */

                        case 2:
                          if (!(
#line 2458 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL) && 
#line 1556 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512BW)))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2636; /* *kortest_cmpsi_movqicc */

                        case 3:
                          if (!(
#line 2458 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL) && 
#line 1556 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512BW && TARGET_64BIT)))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2637; /* *kortest_cmpdi_movqicc */

                        default:
                          return -1;
                        }

                    case E_HImode:
                      switch (pattern1351 (x2, 
E_HImode))
                        {
                        case 0:
                          if (!(
#line 2501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1555 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2638; /* *kortest_cmpqi_movhicc */

                        case 1:
                          if (!
#line 2501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2641; /* *kortest_cmphi_movhicc */

                        case 2:
                          if (!(
#line 2501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1556 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512BW)))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2644; /* *kortest_cmpsi_movhicc */

                        case 3:
                          if (!(
#line 2501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1556 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512BW && TARGET_64BIT)))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2647; /* *kortest_cmpdi_movhicc */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          x11 = XEXP (x5, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x4, 0) != 0LL)
            return -1;
          x6 = XEXP (x2, 1);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_CODE (x9) != PC)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          x12 = XEXP (x5, 0);
          operands[1] = x12;
          x13 = XEXP (x5, 2);
          switch (GET_CODE (x13))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x13;
              if (nonmemory_operand (operands[2], E_QImode))
                {
                  x10 = XEXP (x6, 0);
                  operands[3] = x10;
                  switch (GET_MODE (x5))
                    {
                    case E_SImode:
                      if (nonimmediate_operand (operands[1], E_SImode)
                          && 
#line 19209 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (CONST_INT_P (operands[2])
       ? (INTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)
	  && INTVAL (operands[2])
	       >= (optimize_function_for_size_p (cfun) ? 8 : 32))
       : !memory_operand (operands[1], SImode))
   && ix86_pre_reload_split ()))
                        {
                          *pnum_clobbers = 1;
                          return 1424; /* *jcc_btsi */
                        }
                      break;

                    case E_DImode:
                      if (nonimmediate_operand (operands[1], E_DImode)
                          && (
#line 19209 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (CONST_INT_P (operands[2])
       ? (INTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)
	  && INTVAL (operands[2])
	       >= (optimize_function_for_size_p (cfun) ? 8 : 32))
       : !memory_operand (operands[1], DImode))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 1425; /* *jcc_btdi */
                        }
                      break;

                    default:
                      break;
                    }
                }
              if (GET_CODE (x13) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x13), 0)
                  || GET_MODE (x13) != E_QImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != AND)
                return -1;
              x15 = XEXP (x14, 0);
              operands[2] = x15;
              x16 = XEXP (x14, 1);
              operands[3] = x16;
              if (!const_int_operand (operands[3], E_VOIDmode))
                return -1;
              x10 = XEXP (x6, 0);
              operands[4] = x10;
              switch (GET_MODE (x5))
                {
                case E_SImode:
                  switch (pattern1746 (x14, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 19285 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1428; /* *jcc_btsi_mask_1 */

                    case 1:
                      if (!
#line 19285 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1430; /* *jcc_btsi_mask_1 */

                    case 2:
                      if (!(
#line 19285 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1432; /* *jcc_btsi_mask_1 */

                    default:
                      return -1;
                    }

                case E_DImode:
                  switch (pattern1746 (x14, 
E_DImode))
                    {
                    case 0:
                      if (!(
#line 19285 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1429; /* *jcc_btdi_mask_1 */

                    case 1:
                      if (!(
#line 19285 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1431; /* *jcc_btdi_mask_1 */

                    case 2:
                      if (!(
#line 19285 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1433; /* *jcc_btdi_mask_1 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case AND:
              if (GET_MODE (x13) != E_QImode)
                return -1;
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x17 = XEXP (x13, 1);
              operands[3] = x17;
              if (!const_int_operand (operands[3], E_VOIDmode))
                return -1;
              x10 = XEXP (x6, 0);
              operands[4] = x10;
              switch (GET_MODE (x5))
                {
                case E_SImode:
                  if (!register_operand (operands[1], E_SImode)
                      || !
#line 19248 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1426; /* *jcc_btsi_mask */

                case E_DImode:
                  if (!register_operand (operands[1], E_DImode)
                      || !(
#line 19248 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1427; /* *jcc_btdi_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern247 (x2, 
E_SFmode) != 0
              || !
#line 26728 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_XOP))
            return -1;
          return 1813; /* *xop_pcmov_sf */

        case E_DFmode:
          if (pattern247 (x2, 
E_DFmode) != 0
              || !
#line 26728 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_XOP))
            return -1;
          return 1814; /* *xop_pcmov_df */

        case E_V8QImode:
          if (pattern248 (x2, 
E_V8QImode) != 0
              || !
#line 4466 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_XOP && TARGET_MMX_WITH_SSE))
            return -1;
          return 2252; /* *xop_pcmov_v8qi */

        case E_V4HImode:
          if (pattern248 (x2, 
E_V4HImode) != 0
              || !
#line 4466 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_XOP && TARGET_MMX_WITH_SSE))
            return -1;
          return 2253; /* *xop_pcmov_v4hi */

        case E_V2SImode:
          if (pattern248 (x2, 
E_V2SImode) != 0
              || !
#line 4466 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_XOP && TARGET_MMX_WITH_SSE))
            return -1;
          return 2254; /* *xop_pcmov_v2si */

        case E_V2SFmode:
          if (pattern248 (x2, 
E_V2SFmode) != 0
              || !
#line 4466 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_XOP && TARGET_MMX_WITH_SSE))
            return -1;
          return 2255; /* *xop_pcmov_v2sf */

        case E_V4HFmode:
          if (pattern248 (x2, 
E_V4HFmode) != 0
              || !
#line 4477 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_XOP && TARGET_MMX_WITH_SSE))
            return -1;
          return 2256; /* *xop_pcmov_v4hf */

        case E_V4BFmode:
          if (pattern248 (x2, 
E_V4BFmode) != 0
              || !
#line 4477 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_XOP && TARGET_MMX_WITH_SSE))
            return -1;
          return 2257; /* *xop_pcmov_v4bf */

        case E_V4QImode:
          if (pattern248 (x2, 
E_V4QImode) != 0
              || !
#line 4488 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 2258; /* *xop_pcmov_v4qi */

        case E_V2QImode:
          if (pattern248 (x2, 
E_V2QImode) != 0
              || !
#line 4488 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 2259; /* *xop_pcmov_v2qi */

        case E_V2HImode:
          if (pattern248 (x2, 
E_V2HImode) != 0
              || !
#line 4488 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 2260; /* *xop_pcmov_v2hi */

        case E_V2HFmode:
          if (pattern248 (x2, 
E_V2HFmode) != 0
              || !
#line 4499 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 2261; /* *xop_pcmov_v2hf */

        case E_V2BFmode:
          if (pattern248 (x2, 
E_V2BFmode) != 0
              || !
#line 4499 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 2262; /* *xop_pcmov_v2bf */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x2, 1);
      if (pattern249 (x6) != 0)
        return -1;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x10 = XEXP (x6, 0);
      operands[1] = x10;
      x9 = XEXP (x2, 2);
      if (!rtx_equal_p (x9, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (pattern1433 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !(
#line 1740 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1355 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2503; /* avx512f_storehf_mask */

        case E_SFmode:
          if (pattern1433 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 1740 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2504; /* avx512f_storesf_mask */

        case E_DFmode:
          if (pattern1433 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 1740 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2505; /* avx512f_storedf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern70 (x2))
        {
        case 0:
          if (!
#line 3704 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == -1
   && CONST_WIDE_INT_ELT (operands[3], 1) == 0))
            return -1;
          return 144; /* *insvti_highpart_1 */

        case 1:
          if (!
#line 3726 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == 0
   && CONST_WIDE_INT_ELT (operands[3], 1) == -1))
            return -1;
          return 147; /* *insvti_lowpart_1 */

        case 2:
          if (!
#line 3748 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll))
            return -1;
          return 150; /* *insvdi_lowpart_1 */

        default:
          return -1;
        }

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (pattern603 (x2))
            {
            case 0:
              if (!
#line 8015 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))))
                return -1;
              return 372; /* *leaqi_general_4 */

            case 1:
              if (!
#line 8015 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))))
                return -1;
              return 374; /* *leahi_general_4 */

            case 2:
              if (!(
#line 14139 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 932; /* *concatditi3_5 */

            case 3:
              if (!(
#line 14062 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 896; /* *concatditi3_1 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x5, 0);
          switch (GET_CODE (x7))
            {
            case TRUNCATE:
              if (GET_MODE (x7) != E_QImode)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != MOD
                  || GET_MODE (x8) != E_HImode)
                return -1;
              x6 = XEXP (x3, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
                return -1;
              x9 = XEXP (x2, 1);
              if (GET_CODE (x9) != ZERO_EXTEND
                  || GET_MODE (x9) != E_HImode)
                return -1;
              x10 = XEXP (x9, 0);
              if (pattern1188 (x10, 
E_HImode, 
DIV, 
E_QImode, 
TRUNCATE) != 0
                  || pattern991 (x2, 
E_HImode) != 0)
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_HImode))
                return -1;
              x12 = XEXP (x8, 1);
              if (GET_MODE (x12) != E_HImode)
                return -1;
              x13 = XEXP (x10, 0);
              x14 = XEXP (x13, 1);
              if (GET_MODE (x14) != E_HImode)
                return -1;
              x15 = XEXP (x13, 0);
              if (!rtx_equal_p (x15, operands[1]))
                return -1;
              switch (GET_CODE (x12))
                {
                case SIGN_EXTEND:
                  if (GET_CODE (x14) != SIGN_EXTEND)
                    return -1;
                  x16 = XEXP (x12, 0);
                  operands[2] = x16;
                  if (!nonimmediate_operand (operands[2], E_QImode))
                    return -1;
                  x17 = XEXP (x14, 0);
                  if (!rtx_equal_p (x17, operands[2]))
                    return -1;
                  if (
#line 12017 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && TARGET_APX_NF))
                    return 678; /* divmodhiqi3_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 12017 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 679; /* divmodhiqi3 */

                case ZERO_EXTEND:
                  if (GET_CODE (x14) != ZERO_EXTEND)
                    return -1;
                  x16 = XEXP (x12, 0);
                  operands[2] = x16;
                  if (!nonimmediate_operand (operands[2], E_QImode))
                    return -1;
                  x17 = XEXP (x14, 0);
                  if (!rtx_equal_p (x17, operands[2]))
                    return -1;
                  if (
#line 12017 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && TARGET_APX_NF))
                    return 680; /* udivmodhiqi3_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 12017 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 681; /* udivmodhiqi3 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              operands[1] = x7;
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || GET_MODE (x3) != E_TImode
                  || GET_MODE (x5) != E_TImode)
                return -1;
              x6 = XEXP (x3, 1);
              operands[2] = x6;
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x9 = XEXP (x2, 1);
              switch (pattern259 (x9, 
E_DImode, 
E_TImode))
                {
                case 0:
                  if (!(
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 914; /* *concatditi3_3 */

                case 1:
                  if (!(
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 944; /* *concatditi3_6 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern260 (x2, 
E_DImode, 
E_TImode))
            {
            case 0:
              if (!(
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 911; /* *concatditi3_3 */

            case 1:
              if (!(
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 941; /* *concatditi3_6 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      switch (pattern76 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 12743 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            {
              *pnum_clobbers = 1;
              return 726; /* *iorqi_1_slp */
            }
          break;

        case 1:
          if (
#line 12743 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            {
              *pnum_clobbers = 1;
              return 729; /* *iorhi_1_slp */
            }
          break;

        case 2:
          if ((
#line 13529 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 821; /* *iorti3_doubleword */
            }
          break;

        case 3:
          if (
#line 13587 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 823; /* *iorhi_1_nf */
          if (pnum_clobbers != NULL
              && 
#line 13587 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, HImode, operands, TARGET_APX_NDD)
   && true))
            {
              *pnum_clobbers = 1;
              return 824; /* *iorhi_1 */
            }
          break;

        case 4:
          if (
#line 1357 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return 2078; /* iorv2sf3 */
          break;

        case 5:
          if (
#line 2582 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 2112; /* iorv2bf3 */
          break;

        case 6:
          if ((
#line 2582 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2224 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
            return 2115; /* iorv4bf3 */
          break;

        case 7:
          if (
#line 2582 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 2118; /* iorv2hf3 */
          break;

        case 8:
          if ((
#line 2582 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
            return 2121; /* iorv4hf3 */
          break;

        case 9:
          if (
#line 4687 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (IOR, V8QImode, operands)))
            return 2275; /* *mmx_iorv8qi3 */
          break;

        case 10:
          if (
#line 4687 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (IOR, V4HImode, operands)))
            return 2278; /* *mmx_iorv4hi3 */
          break;

        case 11:
          if (
#line 4687 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (IOR, V2SImode, operands)))
            return 2281; /* *mmx_iorv2si3 */
          break;

        case 12:
          if (
#line 4713 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (IOR, V4QImode, operands)))
            {
              *pnum_clobbers = 1;
              return 2284; /* *iorv4qi3 */
            }
          break;

        case 13:
          if (
#line 4713 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (IOR, V2QImode, operands)))
            {
              *pnum_clobbers = 1;
              return 2287; /* *iorv2qi3 */
            }
          break;

        case 14:
          if (
#line 4713 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (IOR, V2HImode, operands)))
            {
              *pnum_clobbers = 1;
              return 2290; /* *iorv2hi3 */
            }
          break;

        case 15:
          if (
#line 5666 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3746; /* iorbf3 */
          break;

        case 16:
          if (
#line 5666 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3749; /* iorhf3 */
          break;

        case 17:
          if (
#line 5666 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3752; /* iorsf3 */
          break;

        case 18:
          if ((
#line 5666 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1352 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SSE2)))
            return 3755; /* iordf3 */
          break;

        case 19:
          if (
#line 5740 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 3758; /* *iortf3 */
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL
          && pattern77 (x2) == 0)
        {
          x5 = XEXP (x3, 0);
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (pattern1248 (x1))
            {
            case 0:
              if (
#line 12770 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 732; /* *iorqi_exthi_1_slp */
                }
              break;

            case 1:
              if (
#line 12770 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 735; /* *iorqi_extsi_1_slp */
                }
              break;

            case 2:
              if ((
#line 12770 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 738; /* *iorqi_extdi_1_slp */
                }
              break;

            case 3:
              *pnum_clobbers = 1;
              return 756; /* *iorqi_exthi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 759; /* *iorqi_extsi_0 */

            case 5:
              if (
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
                {
                  *pnum_clobbers = 1;
                  return 762; /* *iorqi_extdi_0 */
                }
              break;

            default:
              break;
            }
          x9 = XEXP (x2, 1);
          if (GET_CODE (x9) == SUBREG)
            {
              switch (pattern1251 (x1))
                {
                case 0:
                  if (
#line 12803 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    {
                      *pnum_clobbers = 1;
                      return 741; /* *iorqi_exthi_2_slp */
                    }
                  break;

                case 1:
                  if (
#line 12803 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    {
                      *pnum_clobbers = 1;
                      return 744; /* *iorqi_extsi_2_slp */
                    }
                  break;

                case 2:
                  if ((
#line 12803 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 747; /* *iorqi_extdi_2_slp */
                    }
                  break;

                case 3:
                  *pnum_clobbers = 1;
                  return 765; /* *iorqi_ext2hi_0 */

                case 4:
                  *pnum_clobbers = 1;
                  return 768; /* *iorqi_ext2si_0 */

                case 5:
                  if (
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
                    {
                      *pnum_clobbers = 1;
                      return 771; /* *iorqi_ext2di_0 */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      operands[1] = x3;
      if (pattern78 (x1) != 0)
        return -1;
      if (
#line 13777 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 867; /* *iorqi_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 13777 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, QImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 868; /* *iorqi_1 */

    case ZERO_EXTEND:
      switch (pattern38 (x1))
        {
        case 0:
          if (!(
#line 14079 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 902; /* *concatditi3_2 */

        case 1:
          if (!(
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 923; /* *concatditi3_4 */

        case 2:
          if (!(
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 926; /* *concatditi3_4 */

        case 3:
          if (!(
#line 14200 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 950; /* *concatditi3_7 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 19404 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1440; /* *btsi_setncqi_2 */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 19404 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1441; /* *btdi_setncqi_2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern8 (x2, 
E_V8QImode) != 0
              || !
#line 4141 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (EQ, V8QImode, operands)))
            return -1;
          return 2217; /* *mmx_eqv8qi3 */

        case E_V4HImode:
          if (pattern8 (x2, 
E_V4HImode) != 0
              || !
#line 4141 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (EQ, V4HImode, operands)))
            return -1;
          return 2218; /* *mmx_eqv4hi3 */

        case E_V2SImode:
          if (pattern8 (x2, 
E_V2SImode) != 0
              || !
#line 4141 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (EQ, V2SImode, operands)))
            return -1;
          return 2219; /* *mmx_eqv2si3 */

        case E_V4QImode:
          if (pattern7 (x2, 
E_V4QImode) != 0
              || !
#line 4157 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2220; /* *eqv4qi3 */

        case E_V2QImode:
          if (pattern7 (x2, 
E_V2QImode) != 0
              || !
#line 4157 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2221; /* *eqv2qi3 */

        case E_V2HImode:
          if (pattern7 (x2, 
E_V2HImode) != 0
              || !
#line 4157 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2222; /* *eqv2hi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || !ix86_comparison_operator (operands[1], E_HImode))
            return -1;
          if (
#line 19493 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_ZU))
            return 1444; /* *setcc_hi_zu */
          if (pnum_clobbers != NULL
              && 
#line 19517 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL
   && TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            {
              *pnum_clobbers = 1;
              return 1448; /* *setcc_hi_1_and */
            }
          if (!
#line 19534 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))))
            return -1;
          return 1450; /* *setcc_hi_1_movzbl */

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !ix86_comparison_operator (operands[1], E_QImode))
            return -1;
          return 1452; /* *setcc_qi */

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_QImode)
          || !ix86_comparison_operator (operands[1], E_QImode))
        return -1;
      return 1453; /* *setcc_qi_slp */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          x3 = XEXP (x1, 1);
          if (pattern73 (x3, pnum_clobbers) != 0
              || !(
#line 8069 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 381; /* *subti3_doubleword */

        case E_QImode:
          x3 = XEXP (x1, 1);
          if (pattern74 (x3, 
E_QImode) != 0)
            return -1;
          if (
#line 8125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 384; /* *subqi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 8125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 385; /* *subqi_1 */

        case E_HImode:
          x3 = XEXP (x1, 1);
          if (pattern74 (x3, 
E_HImode) != 0)
            return -1;
          if (
#line 8125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 386; /* *subhi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 8125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 387; /* *subhi_1 */

        case E_HFmode:
          x3 = XEXP (x1, 1);
          if (pattern5 (x3, 
E_HFmode) != 0
              || !
#line 23465 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512FP16
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 1677; /* *subhf */

        case E_V8QImode:
          x3 = XEXP (x1, 1);
          if (pattern8 (x3, 
E_V8QImode) != 0
              || !
#line 3211 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (MINUS, V8QImode, operands)))
            return -1;
          return 2125; /* *mmx_subv8qi3 */

        case E_V4HImode:
          x3 = XEXP (x1, 1);
          if (pattern8 (x3, 
E_V4HImode) != 0
              || !
#line 3211 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (MINUS, V4HImode, operands)))
            return -1;
          return 2127; /* *mmx_subv4hi3 */

        case E_V2SImode:
          x3 = XEXP (x1, 1);
          if (pattern8 (x3, 
E_V2SImode) != 0
              || !
#line 3211 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (MINUS, V2SImode, operands)))
            return -1;
          return 2129; /* *mmx_subv2si3 */

        case E_V1DImode:
          x3 = XEXP (x1, 1);
          if (pattern8 (x3, 
E_V1DImode) != 0
              || !(
#line 3211 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (MINUS, V1DImode, operands)) && 
#line 50 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2)))
            return -1;
          return 2131; /* *mmx_subv1di3 */

        case E_V4QImode:
          x3 = XEXP (x1, 1);
          if (pattern7 (x3, 
E_V4QImode) != 0
              || !
#line 3227 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2133; /* subv4qi3 */

        case E_V2HImode:
          x3 = XEXP (x1, 1);
          if (pattern7 (x3, 
E_V2HImode) != 0
              || !
#line 3227 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2135; /* subv2hi3 */

        case E_V2QImode:
          if (pnum_clobbers == NULL)
            return -1;
          x3 = XEXP (x1, 1);
          if (pattern7 (x3, 
E_V2QImode) != 0
              || !
#line 3241 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
            return -1;
          *pnum_clobbers = 1;
          return 2137; /* subv2qi3 */

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          x3 = XEXP (x1, 1);
          if (pattern1068 (x3, 
E_QImode) != 0
              || !
#line 8189 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 403; /* *subqi_1_slp */

        case E_HImode:
          x3 = XEXP (x1, 1);
          if (pattern1068 (x3, 
E_HImode) != 0
              || !
#line 8189 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 404; /* *subhi_1_slp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) == CONST_INT
          && GET_MODE (x2) == E_V2SFmode)
        {
          switch (XWINT (x5, 0))
            {
            case 1LL:
              if (register_operand (operands[0], E_V2SFmode))
                {
                  switch (XWINT (x6, 0))
                    {
                    case 0LL:
                      if (register_mmxmem_operand (operands[1], E_V2SFmode)
                          && 
#line 1641 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_3DNOW_A || TARGET_MMX_WITH_SSE))
                        return 2084; /* mmx_pswapdv2sf2 */
                      break;

                    case 1LL:
                      if (register_operand (operands[1], E_V2SFmode)
                          && 
#line 1657 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                        return 2085; /* *mmx_movshdup */
                      break;

                    default:
                      break;
                    }
                }
              break;

            case 0LL:
              switch (XWINT (x6, 0))
                {
                case 0LL:
                  if (register_operand (operands[0], E_V2SFmode)
                      && register_operand (operands[1], E_V2SFmode)
                      && 
#line 1673 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                    return 2086; /* *mmx_movsldup */
                  break;

                case 1LL:
                  if (nonimmediate_operand (operands[0], E_V2SFmode)
                      && nonimmediate_operand (operands[1], E_V4SFmode)
                      && 
#line 11625 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 5181; /* sse_storelps */
                  break;

                default:
                  break;
                }
              break;

            case 2LL:
              if (XWINT (x6, 0) == 3LL
                  && nonimmediate_operand (operands[0], E_V2SFmode)
                  && nonimmediate_operand (operands[1], E_V4SFmode)
                  && 
#line 11572 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                return 5179; /* sse_storehps */
              break;

            default:
              break;
            }
        }
      operands[2] = x5;
      if (const_0_to_1_operand (operands[2], E_VOIDmode))
        {
          operands[3] = x6;
          if (const_0_to_1_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  if (register_operand (operands[0], E_V2SImode)
                      && GET_MODE (x2) == E_V2SImode
                      && register_operand (operands[1], E_V2SImode)
                      && 
#line 5575 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                    return 2335; /* *mmx_pshufd_1 */
                  break;

                case E_V2HFmode:
                  if (register_operand (operands[0], E_V2HFmode)
                      && GET_MODE (x2) == E_V2HFmode
                      && register_operand (operands[1], E_V2HFmode)
                      && 
#line 6236 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return 2371; /* *pshufwv2hf_1 */
                  break;

                case E_V2BFmode:
                  if (register_operand (operands[0], E_V2BFmode)
                      && GET_MODE (x2) == E_V2BFmode
                      && register_operand (operands[1], E_V2BFmode)
                      && 
#line 6236 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return 2372; /* *pshufwv2bf_1 */
                  break;

                case E_V2HImode:
                  if (register_operand (operands[0], E_V2HImode)
                      && GET_MODE (x2) == E_V2HImode
                      && register_operand (operands[1], E_V2HImode)
                      && 
#line 6236 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return 2373; /* *pshufwv2hi_1 */
                  break;

                default:
                  break;
                }
            }
        }
      if (XWINT (x5, 0) != 1LL
          || x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || !register_mmxmem_operand (operands[1], E_V2SImode)
          || !
#line 5643 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_3DNOW_A))
        return -1;
      return 2342; /* mmx_pswapdv2si2 */

    case 1:
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0LL:
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              switch (pattern964 (x2))
                {
                case 0:
                  if (
#line 1783 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 2093; /* *vec_extractv2sf_0 */
                  break;

                case 1:
                  if (
#line 12309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 5237; /* *vec_extractv4sf_0 */
                  break;

                default:
                  break;
                }
              break;

            case E_HFmode:
              switch (pattern965 (x2))
                {
                case 0:
                  if ((
#line 13218 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 548 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 5296; /* *vec_extractv32hf_0 */
                  break;

                case 1:
                  if (
#line 13218 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 5297; /* *vec_extractv16hf_0 */
                  break;

                case 2:
                  if (
#line 13218 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 5298; /* *vec_extractv8hf_0 */
                  break;

                default:
                  break;
                }
              break;

            case E_BFmode:
              switch (pattern966 (x2))
                {
                case 0:
                  if ((
#line 13218 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 549 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 5299; /* *vec_extractv32bf_0 */
                  break;

                case 1:
                  if (
#line 13218 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 5300; /* *vec_extractv16bf_0 */
                  break;

                case 2:
                  if (
#line 13218 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 5301; /* *vec_extractv8bf_0 */
                  break;

                default:
                  break;
                }
              break;

            case E_DFmode:
              if (nonimmediate_operand (operands[0], E_DFmode)
                  && GET_MODE (x2) == E_DFmode
                  && nonimmediate_operand (operands[1], E_V2DFmode))
                {
                  if (
#line 14636 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 7139; /* sse2_storelpd */
                  if (
#line 14665 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(!TARGET_SSE2 && TARGET_SSE
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 7140; /* *vec_extractv2df_0_sse */
                }
              break;

            case E_QImode:
              if (memory_operand (operands[0], E_QImode)
                  && GET_MODE (x2) == E_QImode
                  && register_operand (operands[1], E_V16QImode)
                  && (
#line 21052 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2
   && !TARGET_SSE4_1
   && (TARGET_INTER_UNIT_MOVES_FROM_VEC
       || optimize_function_for_speed_p (cfun))
   && ix86_pre_reload_split ()) && 
#line 21045 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
                return 8383; /* *vec_extractv16qi_0_mem */
              break;

            case E_HImode:
              if (memory_operand (operands[0], E_HImode)
                  && GET_MODE (x2) == E_HImode
                  && register_operand (operands[1], E_V8HImode)
                  && 
#line 21052 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2
   && !TARGET_SSE4_1
   && (TARGET_INTER_UNIT_MOVES_FROM_VEC
       || optimize_function_for_speed_p (cfun))
   && ix86_pre_reload_split ()))
                return 8384; /* *vec_extractv8hi_0_mem */
              break;

            default:
              break;
            }
          break;

        case 1LL:
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (nonimmediate_operand (operands[0], E_SFmode)
                  && GET_MODE (x2) == E_SFmode
                  && nonimmediate_operand (operands[1], E_V2SFmode)
                  && 
#line 1798 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                return 2094; /* *vec_extractv2sf_1 */
              break;

            case E_DFmode:
              if (nonimmediate_operand (operands[0], E_DFmode)
                  && GET_MODE (x2) == E_DFmode
                  && nonimmediate_operand (operands[1], E_V2DFmode))
                {
                  if (
#line 14579 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 7137; /* sse2_storehpd */
                  if (
#line 14612 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(!TARGET_SSE2 && TARGET_SSE
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 7138; /* *vec_extractv2df_1_sse */
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          if (register_sse4nonimm_operand (operands[0], E_HImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && const_0_to_3_operand (operands[2], E_SImode)
                      && 
#line 5381 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
                    return 2321; /* *mmx_pextrw */
                  break;

                case E_V2HImode:
                  if (register_operand (operands[1], E_V2HImode)
                      && const_0_to_1_operand (operands[2], E_SImode)
                      && 
#line 6047 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return 2359; /* *pextrw */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && const_0_to_7_operand (operands[2], E_SImode)
                      && 
#line 21076 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return 8386; /* *vec_extractv8hi */
                  break;

                default:
                  break;
                }
            }
          if (!register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !const_0_to_7_operand (operands[2], E_VOIDmode)
              || !
#line 21137 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 8393; /* *vec_extractv8hi_mem */

        case E_HFmode:
          if (!register_sse4nonimm_operand (operands[0], E_HFmode)
              || GET_MODE (x2) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HFmode:
              if (!register_operand (operands[1], E_V4HFmode)
                  || !const_0_to_3_operand (operands[2], E_SImode)
                  || !
#line 5401 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
                return -1;
              return 2322; /* *mmx_pextrwv4hf */

            case E_V2HFmode:
              if (!register_operand (operands[1], E_V2HFmode)
                  || !const_0_to_1_operand (operands[2], E_SImode)
                  || !
#line 6064 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2360; /* *pextrwv2hf */

            case E_V8HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !const_0_to_7_operand (operands[2], E_SImode)
                  || !
#line 13230 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 5302; /* *vec_extracthf */

            default:
              return -1;
            }

        case E_BFmode:
          if (!register_sse4nonimm_operand (operands[0], E_BFmode)
              || GET_MODE (x2) != E_BFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4BFmode:
              if (!register_operand (operands[1], E_V4BFmode)
                  || !const_0_to_3_operand (operands[2], E_SImode)
                  || !
#line 5401 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
                return -1;
              return 2323; /* *mmx_pextrwv4bf */

            case E_V2BFmode:
              if (!register_operand (operands[1], E_V2BFmode)
                  || !const_0_to_1_operand (operands[2], E_SImode)
                  || !
#line 6064 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2361; /* *pextrwv2bf */

            case E_V8BFmode:
              if (!register_operand (operands[1], E_V8BFmode)
                  || !const_0_to_7_operand (operands[2], E_SImode)
                  || !
#line 13230 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 5303; /* *vec_extractbf */

            default:
              return -1;
            }

        case E_QImode:
          if (GET_MODE (x2) != E_QImode)
            return -1;
          if (nonimmediate_operand (operands[0], E_QImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && const_0_to_7_operand (operands[2], E_SImode)
                      && 
#line 5454 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                    return 2326; /* *mmx_pextrb */
                  break;

                case E_V4QImode:
                  if (register_operand (operands[1], E_V4QImode)
                      && const_0_to_3_operand (operands[2], E_SImode)
                      && 
#line 6110 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                    return 2364; /* *pextrb */
                  break;

                default:
                  break;
                }
            }
          if (register_sse4nonimm_operand (operands[0], E_QImode)
              && register_operand (operands[1], E_V16QImode)
              && const_0_to_15_operand (operands[2], E_SImode)
              && (
#line 21076 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 21045 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
            return 8385; /* *vec_extractv16qi */
          if (!register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !const_0_to_15_operand (operands[2], E_VOIDmode)
              || !
#line 21137 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 8392; /* *vec_extractv16qi_mem */

        case E_SFmode:
          if (GET_MODE (x2) != E_SFmode)
            return -1;
          if (nonimmediate_operand (operands[0], E_SFmode)
              && register_operand (operands[1], E_V4SFmode)
              && const_0_to_3_operand (operands[2], E_SImode)
              && 
#line 12320 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return 5238; /* *sse4_1_extractps */
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!memory_operand (operands[1], E_V4SFmode)
                  || !const_0_to_3_operand (operands[2], E_VOIDmode)
                  || !
#line 12363 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 5239; /* *vec_extractv4sf_mem */

            case E_V16SFmode:
              if (!register_operand (operands[1], E_V16SFmode)
                  || !const_0_to_15_operand (operands[2], E_VOIDmode)
                  || !(
#line 14058 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (SFmode) >= 16) && 
#line 302 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 7010; /* *vec_extractv16sfsf_valign */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !const_0_to_7_operand (operands[2], E_VOIDmode)
                  || !(
#line 14058 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (SFmode) >= 16) && 
#line 302 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 7011; /* *vec_extractv8sfsf_valign */

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !const_0_to_7_operand (operands[2], E_VOIDmode)
                  || !(
#line 14058 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (DFmode) >= 16) && 
#line 303 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 7012; /* *vec_extractv8dfdf_valign */

            case E_V4DFmode:
              if (!register_operand (operands[1], E_V4DFmode)
                  || !const_0_to_3_operand (operands[2], E_VOIDmode)
                  || !(
#line 14058 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (DFmode) >= 16) && 
#line 303 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 7013; /* *vec_extractv4dfdf_valign */

            default:
              return -1;
            }

        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || GET_MODE (x2) != E_TImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2TImode:
              if (!register_operand (operands[1], E_V2TImode)
                  || !const_0_to_1_operand (operands[2], E_SImode)
                  || !
#line 21393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 8404; /* *vec_extractv2ti */

            case E_V4TImode:
              if (!register_operand (operands[1], E_V4TImode)
                  || !const_0_to_3_operand (operands[2], E_SImode)
                  || !
#line 21411 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 8405; /* *vec_extractv4ti */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      if (pattern669 (x4) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x2) != E_V4HFmode
              || !register_mmxmem_operand (operands[1], E_V4HFmode)
              || !
#line 5543 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return -1;
          return 2332; /* mmx_pshufwv4hf_1 */

        case E_V4BFmode:
          if (!register_operand (operands[0], E_V4BFmode)
              || GET_MODE (x2) != E_V4BFmode
              || !register_mmxmem_operand (operands[1], E_V4BFmode)
              || !
#line 5543 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return -1;
          return 2333; /* mmx_pshufwv4bf_1 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !register_mmxmem_operand (operands[1], E_V4HImode)
              || !
#line 5543 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return -1;
          return 2334; /* mmx_pshufwv4hi_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      return recog_79 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern436 (x3))
        {
        case 0:
          if (pnum_clobbers != NULL
              && x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 13529 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 819; /* *iordi3_doubleword */
            }
          if (x86_64_general_operand (operands[2], E_DImode))
            {
              if ((
#line 13587 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 831; /* *iordi_1_nf */
              if (pnum_clobbers != NULL
                  && (
#line 13587 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 832; /* *iordi_1 */
                }
            }
          if (pnum_clobbers == NULL
              || !const_int_operand (operands[2], E_DImode)
              || !
#line 13635 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_USE_BT
   && ix86_binary_operator_ok (IOR, DImode, operands)
   && IN_RANGE (exact_log2 (INTVAL (operands[2])), 31, 63)))
            return -1;
          *pnum_clobbers = 1;
          return 838; /* *iordi_1_bts */

        case 1:
          if (
#line 13587 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 827; /* *iorsi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 13587 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 828; /* *iorsi_1 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern112 (x3))
        {
        case 0:
          if (pnum_clobbers != NULL)
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (x86_64_zext_immediate_operand (operands[2], E_DImode)
                  && register_operand (operands[0], E_DImode)
                  && 
#line 13764 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)))
                {
                  *pnum_clobbers = 1;
                  return 865; /* *iorsi_1_zext_imm */
                }
            }
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!const_scalar_int_operand (operands[2], E_DImode)
              || !nonimmediate_operand (operands[0], E_DImode)
              || !(
#line 14200 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 947; /* *concatsidi3_7 */

        case 1:
          if (!(
#line 14079 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 899; /* *concatsidi3_2 */

        case 2:
          if (!(
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 917; /* *concatsidi3_4 */

        case 3:
          if (!(
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 920; /* *concatsidi3_4 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case AND:
          switch (pattern290 (x3, 
ASHIFT))
            {
            case 0:
              x5 = XEXP (x3, 1);
              x7 = XEXP (x5, 0);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[1] = x9;
              if (nonimmediate_operand (operands[0], E_DImode))
                {
                  res = recog_78 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[2] = x9;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x10 = XEXP (x4, 0);
              operands[1] = x10;
              if (!nonimmediate_operand (operands[1], E_DImode))
                return -1;
              x11 = XEXP (x6, 0);
              operands[3] = x11;
              x12 = XEXP (x7, 1);
              x13 = XEXP (x12, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[3]))
                return -1;
              if (
#line 16809 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1144; /* x86_64_shrd_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 16809 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1145; /* x86_64_shrd_ndd */

            case 1:
              if (pattern289 (x3, 
E_SImode, 
E_DImode) != 0)
                return -1;
              x5 = XEXP (x3, 1);
              x7 = XEXP (x5, 0);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[1] = x9;
              if (nonimmediate_operand (operands[0], E_SImode))
                {
                  x11 = XEXP (x6, 0);
                  operands[2] = x11;
                  x10 = XEXP (x4, 0);
                  if (rtx_equal_p (x10, operands[0]))
                    {
                      x12 = XEXP (x7, 1);
                      x13 = XEXP (x12, 1);
                      x14 = XEXP (x13, 0);
                      if (rtx_equal_p (x14, operands[2]))
                        {
                          if (
#line 17018 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF))
                            return 1154; /* x86_shrd_nf */
                          if (pnum_clobbers != NULL)
                            {
                              *pnum_clobbers = 1;
                              return 1155; /* x86_shrd */
                            }
                        }
                    }
                }
              operands[2] = x9;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x10 = XEXP (x4, 0);
              operands[1] = x10;
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x6, 0);
              operands[3] = x11;
              x12 = XEXP (x7, 1);
              x13 = XEXP (x12, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[3]))
                return -1;
              if (
#line 17040 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1156; /* x86_shrd_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 17040 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1157; /* x86_shrd_ndd */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case SUBREG:
              switch (pattern439 (x3, 
ASHIFT))
                {
                case 0:
                  operands[2] = x6;
                  if (pattern1346 (x3) == 0)
                    {
                      if (
#line 16824 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && TARGET_APX_NF))
                        return 1146; /* x86_64_shrd_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 16824 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && true))
                        {
                          *pnum_clobbers = 1;
                          return 1147; /* x86_64_shrd_1 */
                        }
                    }
                  operands[3] = x6;
                  if (pattern1347 (x3) != 0)
                    return -1;
                  if (
#line 16846 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && TARGET_APX_NF))
                    return 1148; /* x86_64_shrd_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 16846 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1149; /* x86_64_shrd_ndd_1 */

                case 1:
                  operands[2] = x6;
                  if (pattern1348 (x3) == 0)
                    {
                      if (
#line 17055 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && TARGET_APX_NF))
                        return 1158; /* x86_shrd_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 17055 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && true))
                        {
                          *pnum_clobbers = 1;
                          return 1159; /* x86_shrd_1 */
                        }
                    }
                  operands[3] = x6;
                  if (pattern1349 (x3) != 0)
                    return -1;
                  if (
#line 17077 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && (INTVAL (operands[4]) == 32 - INTVAL (operands[3]))
   && TARGET_APX_NF))
                    return 1160; /* x86_shrd_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 17077 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && (INTVAL (operands[4]) == 32 - INTVAL (operands[3]))
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1161; /* x86_shrd_ndd_1 */

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern442 (x3, pnum_clobbers))
                {
                case 0:
                  if (
#line 16862 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_APX_NF
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1150; /* *x86_64_shrd_shld_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 16918 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1151; /* *x86_64_shrd_shld_1_nozext */

                case 1:
                  if (
#line 17093 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1162; /* *x86_shrd_shld_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 17149 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1163; /* *x86_shrd_shld_1_nozext */

                case 2:
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (nonimmediate_operand (operands[0], E_DImode))
                    {
                      operands[2] = x6;
                      x10 = XEXP (x4, 0);
                      if (rtx_equal_p (x10, operands[0]))
                        {
                          x15 = XEXP (x5, 1);
                          x16 = XEXP (x15, 1);
                          if (rtx_equal_p (x16, operands[2])
                              && 
#line 16971 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            {
                              *pnum_clobbers = 1;
                              return 1152; /* *x86_64_shrd_2 */
                            }
                        }
                    }
                  operands[2] = x7;
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  x10 = XEXP (x4, 0);
                  operands[1] = x10;
                  if (!nonimmediate_operand (operands[1], E_DImode))
                    return -1;
                  operands[3] = x6;
                  x15 = XEXP (x5, 1);
                  x16 = XEXP (x15, 1);
                  if (!rtx_equal_p (x16, operands[2])
                      || !
#line 16992 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
  && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1153; /* *x86_64_shrd_ndd_2 */

                case 3:
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (nonimmediate_operand (operands[0], E_SImode))
                    {
                      operands[2] = x6;
                      x10 = XEXP (x4, 0);
                      if (rtx_equal_p (x10, operands[0]))
                        {
                          x15 = XEXP (x5, 1);
                          x16 = XEXP (x15, 1);
                          if (rtx_equal_p (x16, operands[2])
                              && 
#line 17201 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            {
                              *pnum_clobbers = 1;
                              return 1164; /* *x86_shrd_2 */
                            }
                        }
                    }
                  operands[2] = x7;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x4, 0);
                  operands[1] = x10;
                  if (!nonimmediate_operand (operands[1], E_SImode))
                    return -1;
                  operands[3] = x6;
                  x15 = XEXP (x5, 1);
                  x16 = XEXP (x15, 1);
                  if (!rtx_equal_p (x16, operands[3])
                      || !
#line 17222 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1165; /* *x86_shrd_ndd_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x17 = XEXP (x10, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x18 = XEXP (x10, 0);
      operands[1] = x18;
      x5 = XEXP (x3, 1);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern975 (x3, 
E_SImode) != 0
              || !
#line 22202 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM))
            return -1;
          *pnum_clobbers = 1;
          return 1608; /* *tbm_blci_si */

        case E_DImode:
          if (pattern975 (x3, 
E_DImode) != 0
              || !(
#line 22202 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1609; /* *tbm_blci_di */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      switch (XWINT (x6, 0))
        {
        case 1LL:
          switch (pattern753 (x3))
            {
            case 0:
              if (!
#line 22242 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM))
                return -1;
              *pnum_clobbers = 1;
              return 1614; /* *tbm_blcs_si */

            case 1:
              if (!(
#line 22242 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1615; /* *tbm_blcs_di */

            case 2:
              if (!
#line 22283 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM))
                return -1;
              *pnum_clobbers = 1;
              return 1620; /* *tbm_t1mskc_si */

            case 3:
              if (!(
#line 22283 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1621; /* *tbm_t1mskc_di */

            default:
              return -1;
            }

        case -1LL:
          switch (pattern753 (x3))
            {
            case 0:
              if (!
#line 22255 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM))
                return -1;
              *pnum_clobbers = 1;
              return 1616; /* *tbm_blsfill_si */

            case 1:
              if (!(
#line 22255 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1617; /* *tbm_blsfill_di */

            case 2:
              if (!
#line 22269 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM))
                return -1;
              *pnum_clobbers = 1;
              return 1618; /* *tbm_blsic_si */

            case 3:
              if (!(
#line 22269 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1619; /* *tbm_blsic_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (pattern113 (x3) != 0
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      x7 = XEXP (x5, 0);
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      return 1646; /* bswaphisi2_lowpart */

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern118 (x3, pnum_clobbers))
        {
        case 0:
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              if (pnum_clobbers != NULL
                  && pattern618 (x3) == 0
                  && (
#line 16584 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1123; /* *ashrdi3_doubleword_mask */
                }
              operands[2] = x5;
              if (register_operand (operands[2], E_SImode)
                  && register_operand (operands[0], E_SImode)
                  && GET_MODE (x3) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 17315 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI2))
                return 1172; /* *bmi2_ashrsi3_1 */
              break;

            case CONST_INT:
              operands[2] = x5;
              if (const_int_operand (operands[2], E_QImode)
                  && nonimmediate_operand (operands[0], E_SImode)
                  && GET_MODE (x3) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode))
                {
                  if (
#line 17246 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
                    return 1166; /* ashrsi3_cvt_nf */
                  if (pnum_clobbers != NULL
                      && 
#line 17246 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
                    {
                      *pnum_clobbers = 1;
                      return 1167; /* ashrsi3_cvt */
                    }
                }
              break;

            default:
              break;
            }
          operands[2] = x5;
          res = recog_98 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern619 (x3))
            {
            case 0:
              if (!
#line 17842 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1246; /* *ashrsi3_mask */

            case 1:
              if (!(
#line 17842 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1249; /* *ashrdi3_mask */

            case 2:
              if (!
#line 17890 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1258; /* *ashrsi3_add */

            case 3:
              if (!(
#line 17890 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1261; /* *ashrdi3_add */

            case 4:
              if (!
#line 17936 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1270; /* *ashrsi3_sub */

            case 5:
              if (!(
#line 17936 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1273; /* *ashrdi3_sub */

            default:
              return -1;
            }

        case 1:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && (
#line 16645 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1127; /* *ashrdi3_doubleword_mask_1 */
            }
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 17867 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1255; /* *ashrdi3_mask_1 */

        case 2:
          if (!
#line 17867 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1252; /* *ashrsi3_mask_1 */

        case 3:
          if (!
#line 17914 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1264; /* *ashrsi3_add_1 */

        case 4:
          if (!(
#line 17914 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1267; /* *ashrdi3_add_1 */

        case 5:
          if (!
#line 17966 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1276; /* *ashrsi3_sub_1 */

        case 6:
          if (!(
#line 17966 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1279; /* *ashrdi3_sub_1 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pnum_clobbers == NULL
          || pattern292 (x3, 
E_DImode) != 0
          || !(
#line 17990 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1280; /* *extenddi2_doubleword_highpart */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (pattern126 (x3))
    {
    case 0:
      *pnum_clobbers = 1;
      return 1514; /* ctzsi2 */

    case 1:
      if (!
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1515; /* ctzdi2 */

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case CTZ:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 21181 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1520; /* *ctzsidi2_sext */

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      if (pattern443 (x5, 
CLZ, 
31) != 0)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 21353 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_LZCNT && TARGET_64BIT && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1531; /* *bsr_2 */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 49)
        return -1;
      x9 = XVECEXP (x4, 0, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[1] = x9;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SFmode:
              if (register_operand (operands[1], E_V8SFmode)
                  && (
#line 21934 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 8439; /* *avx_movmskps256_ext */
              break;

            case E_V4SFmode:
              if (register_operand (operands[1], E_V4SFmode)
                  && 
#line 21934 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE))
                return 8441; /* *sse_movmskps_ext */
              break;

            case E_V4DFmode:
              if (register_operand (operands[1], E_V4DFmode)
                  && (
#line 21934 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 8443; /* *avx_movmskpd256_ext */
              break;

            case E_V2DFmode:
              if (register_operand (operands[1], E_V2DFmode)
                  && (
#line 21934 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return 8445; /* *sse2_movmskpd_ext */
              break;

            case E_V16QImode:
              if (register_operand (operands[1], E_V16QImode)
                  && 
#line 22107 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2))
                return 8487; /* *sse2_pmovmskb_ext */
              break;

            default:
              break;
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern1075 (x9))
            {
            case 0:
              if (!(
#line 22016 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8463; /* *avx_movmskps256_ext_lt_avx512 */

            case 1:
              if (!
#line 22016 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE))
                return -1;
              return 8465; /* *sse_movmskps_ext_lt_avx512 */

            case 2:
              if (!(
#line 22016 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8467; /* *avx_movmskpd256_ext_lt_avx512 */

            case 3:
              if (!(
#line 22016 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8469; /* *sse2_movmskpd_ext_lt_avx512 */

            case 4:
              if (!(
#line 22055 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8475; /* *avx_movmskps256_ext_shift */

            case 5:
              if (!
#line 22055 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE))
                return -1;
              return 8477; /* *sse_movmskps_ext_shift */

            case 6:
              if (!(
#line 22055 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8479; /* *avx_movmskpd256_ext_shift */

            case 7:
              if (!(
#line 22055 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8481; /* *sse2_movmskpd_ext_shift */

            default:
              return -1;
            }

        case LT:
          switch (pattern980 (x9))
            {
            case 0:
              if (!(
#line 21991 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8455; /* *avx_movmskps256_ext_lt */

            case 1:
              if (!
#line 21991 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE))
                return -1;
              return 8457; /* *sse_movmskps_ext_lt */

            case 2:
              if (!(
#line 21991 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8459; /* *avx_movmskpd256_ext_lt */

            case 3:
              if (!(
#line 21991 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8461; /* *sse2_movmskpd_ext_lt */

            case 4:
              if (!
#line 22303 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2))
                return -1;
              return 8497; /* *sse2_pmovmskb_ext_lt */

            default:
              return -1;
            }

        case VEC_MERGE:
          switch (pattern972 (x9))
            {
            case 0:
              if (!(
#line 22332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2) && 
#line 629 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 8498; /* *sse2_pmovmskb_ext_lt_avx512 */

            case 1:
              if (!
#line 22332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2))
                return -1;
              return 8499; /* *sse2_pmovmskb_ext_lt_avx512 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (pattern629 (x2, 
E_V8HImode, 
E_QImode, 
E_V8HFmode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4496; /* unspec_avx512fp16_fix_truncv8hi2_mask */

    case E_V16HImode:
      if (pattern629 (x2, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4504; /* unspec_avx512fp16_fix_truncv16hi2_mask */

    case E_V32HImode:
      if (pattern629 (x2, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4512; /* unspec_avx512fp16_fix_truncv32hi2_mask */

    case E_V8SImode:
      switch (pattern982 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4520; /* unspec_avx512fp16_fix_truncv8si2_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8774 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return -1;
          return 4817; /* unspec_fix_truncv8sfv8si2_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9547 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4951; /* unspec_fix_truncv8dfv8si2_mask */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern983 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4528; /* unspec_avx512fp16_fix_truncv16si2_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8754 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4802; /* unspec_fix_truncv16sfv16si2_mask */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern984 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4536; /* unspec_avx512fp16_fix_truncv8di2_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9676 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4980; /* unspec_fix_truncv8dfv8di2_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9719 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5028; /* unspec_fix_truncv8sfv8di2_mask */

        default:
          return -1;
        }

    case E_V4SImode:
      if (pattern136 (x2, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7897 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4591; /* unspec_avx512fp16_fix_truncv4si2_mask */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8793 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 4821; /* unspec_fix_truncv4sfv4si2_mask */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX || (TARGET_AVX512VL && TARGET_AVX512F))))
            return -1;
          return 4971; /* unspec_fix_truncv4dfv4si2_mask */

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 5067; /* unspec_sse2_cvttpd2dq_mask */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern985 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7897 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4595; /* unspec_avx512fp16_fix_truncv4di2_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9676 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4987; /* unspec_fix_truncv4dfv4di2_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9719 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5035; /* unspec_fix_truncv4sfv4di2_mask */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern986 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7947 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4615; /* unspec_avx512fp16_fix_truncv2di2_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9676 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4991; /* unspec_fix_truncv2dfv2di2_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9740 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
            return -1;
          return 5051; /* unspec_avx512dq_fix_truncv2sfv2di2_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_15_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern468 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 9934; /* avx512bw_getmantv32hf_mask */

    case E_V16HFmode:
      if (pattern468 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 9938; /* avx512vl_getmantv16hf_mask */

    case E_V8HFmode:
      if (pattern468 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 9942; /* avx512fp16_getmantv8hf_mask */

    case E_V16SFmode:
      if (pattern468 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9946; /* avx512f_getmantv16sf_mask */

    case E_V8SFmode:
      if (pattern468 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9950; /* avx512vl_getmantv8sf_mask */

    case E_V4SFmode:
      if (pattern468 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9954; /* avx512vl_getmantv4sf_mask */

    case E_V8DFmode:
      if (pattern468 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9958; /* avx512f_getmantv8df_mask */

    case E_V4DFmode:
      if (pattern468 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9962; /* avx512vl_getmantv4df_mask */

    case E_V2DFmode:
      if (pattern468 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9966; /* avx512vl_getmantv2df_mask */

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern483 (x2))
    {
    case 0:
      if (!(
#line 30423 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10154; /* vpshrdv_v32hi_mask */

    case 1:
      if (!(
#line 30423 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10155; /* vpshrdv_v16si_mask */

    case 2:
      if (!(
#line 30423 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10156; /* vpshrdv_v8di_mask */

    case 3:
      if (!(
#line 30423 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10157; /* vpshrdv_v16hi_mask */

    case 4:
      if (!(
#line 30423 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10158; /* vpshrdv_v8si_mask */

    case 5:
      if (!(
#line 30423 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10159; /* vpshrdv_v4di_mask */

    case 6:
      if (!(
#line 30423 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10160; /* vpshrdv_v8hi_mask */

    case 7:
      if (!(
#line 30423 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10161; /* vpshrdv_v4si_mask */

    case 8:
      if (!(
#line 30423 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10162; /* vpshrdv_v2di_mask */

    case 9:
      if (!(
#line 30453 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10163; /* vpshrdv_v32hi_maskz_1 */

    case 10:
      if (!(
#line 30453 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10164; /* vpshrdv_v16si_maskz_1 */

    case 11:
      if (!(
#line 30453 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10165; /* vpshrdv_v8di_maskz_1 */

    case 12:
      if (!(
#line 30453 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10166; /* vpshrdv_v16hi_maskz_1 */

    case 13:
      if (!(
#line 30453 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10167; /* vpshrdv_v8si_maskz_1 */

    case 14:
      if (!(
#line 30453 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10168; /* vpshrdv_v4di_maskz_1 */

    case 15:
      if (!(
#line 30453 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10169; /* vpshrdv_v8hi_maskz_1 */

    case 16:
      if (!(
#line 30453 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10170; /* vpshrdv_v4si_maskz_1 */

    case 17:
      if (!(
#line 30453 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10171; /* vpshrdv_v2di_maskz_1 */

    default:
      return -1;
    }
}

 int
recog_143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XINT (x3, 1))
    {
    case 63:
      switch (pattern459 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 3045; /* ieee_maxv32hf3_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 390 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 3052; /* ieee_maxv16hf3_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 391 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 3056; /* ieee_maxv8hf3_mask */

        case 3:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 3061; /* ieee_maxv16sf3_mask */

        case 4:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3068; /* ieee_maxv8sf3_mask */

        case 5:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1)))
            return -1;
          return 3072; /* ieee_maxv4sf3_mask */

        case 6:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 3077; /* ieee_maxv8df3_mask */

        case 7:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3084; /* ieee_maxv4df3_mask */

        case 8:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3088; /* ieee_maxv2df3_mask */

        case 9:
          if (!(
#line 3489 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 3121; /* avx512fp16_ieee_vmmaxv8hf3 */

        case 10:
          if (!
#line 3489 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 3129; /* sse_ieee_vmmaxv4sf3 */

        case 11:
          if (!(
#line 3489 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3137; /* sse2_ieee_vmmaxv2df3 */

        default:
          return -1;
        }

    case 62:
      switch (pattern459 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 3049; /* ieee_minv32hf3_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 390 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 3054; /* ieee_minv16hf3_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 391 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 3058; /* ieee_minv8hf3_mask */

        case 3:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 3065; /* ieee_minv16sf3_mask */

        case 4:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3070; /* ieee_minv8sf3_mask */

        case 5:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1)))
            return -1;
          return 3074; /* ieee_minv4sf3_mask */

        case 6:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 3081; /* ieee_minv8df3_mask */

        case 7:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3086; /* ieee_minv4df3_mask */

        case 8:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3090; /* ieee_minv2df3_mask */

        case 9:
          if (!(
#line 3489 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 3125; /* avx512fp16_ieee_vmminv8hf3 */

        case 10:
          if (!
#line 3489 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 3133; /* sse_ieee_vmminv4sf3 */

        case 11:
          if (!(
#line 3489 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3141; /* sse2_ieee_vmminv2df3 */

        default:
          return -1;
        }

    case 192:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1197 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V32HFmode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 3161; /* reducepv32hf_mask */

        case E_V16HFmode:
          if (pattern1197 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16HFmode))) && 
#line 525 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 3165; /* reducepv16hf_mask */

        case E_V8HFmode:
          if (pattern1197 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 526 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 3169; /* reducepv8hf_mask */

        case E_V16SFmode:
          if (pattern1197 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16SFmode))) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3173; /* reducepv16sf_mask */

        case E_V8SFmode:
          if (pattern1197 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8SFmode))) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3177; /* reducepv8sf_mask */

        case E_V4SFmode:
          if (pattern1197 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3181; /* reducepv4sf_mask */

        case E_V8DFmode:
          if (pattern1197 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8DFmode))) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3185; /* reducepv8df_mask */

        case E_V4DFmode:
          if (pattern1197 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4DFmode))) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3189; /* reducepv4df_mask */

        case E_V2DFmode:
          if (pattern1197 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3193; /* reducepv2df_mask */

        default:
          return -1;
        }

    case 221:
      switch (pattern461 (x2))
        {
        case 0:
          if (!(
#line 106 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4301; /* avx512bw_fmulc_v32hf_mask */

        case 1:
          if (!(
#line 106 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4309; /* avx512vl_fmulc_v16hf_mask */

        case 2:
          if (!(
#line 106 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4313; /* avx512fp16_fmulc_v8hf_mask */

        case 3:
          if (!
#line 7526 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 4328; /* avx512fp16_fmulcsh_v8hf */

        default:
          return -1;
        }

    case 222:
      switch (pattern461 (x2))
        {
        case 0:
          if (!(
#line 106 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4305; /* avx512bw_fcmulc_v32hf_mask */

        case 1:
          if (!(
#line 106 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4311; /* avx512vl_fcmulc_v16hf_mask */

        case 2:
          if (!(
#line 106 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4315; /* avx512fp16_fcmulc_v8hf_mask */

        case 3:
          if (!
#line 7526 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 4332; /* avx512fp16_fcmulcsh_v8hf */

        default:
          return -1;
        }

    case 58:
      return recog_129 (x1, insn, pnum_clobbers);

    case 165:
      x7 = XEXP (x2, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (pattern458 (x2))
        {
        case 0:
          if (!(
#line 14031 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 6982; /* avx512f_sgetexpv8hf */

        case 1:
          if (!
#line 14031 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 6986; /* avx512f_sgetexpv4sf */

        case 2:
          if (!(
#line 14031 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6990; /* avx512f_sgetexpv2df */

        default:
          return -1;
        }

    case 94:
      return recog_128 (x1, insn, pnum_clobbers);

    case 188:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern464 (x2, 
E_HImode, 
E_V16SImode, 
E_V32HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16657 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (64 == 64 || TARGET_AVX512VL)) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7516; /* avx512bw_pmaddwd512v32hi_mask */

        case E_V8SImode:
          if (pattern464 (x2, 
E_QImode, 
E_V8SImode, 
E_V16HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16657 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (32 == 64 || TARGET_AVX512VL)) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7518; /* avx512bw_pmaddwd512v16hi_mask */

        case E_V4SImode:
          if (pattern464 (x2, 
E_QImode, 
E_V4SImode, 
E_V8HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16657 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (16 == 64 || TARGET_AVX512VL))))
            return -1;
          return 7520; /* avx512bw_pmaddwd512v8hi_mask */

        default:
          return -1;
        }

    case 57:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern1093 (x2, 
E_DImode, 
E_V64QImode, 
E_V32HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19362 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 632 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 8241; /* avx512bw_packuswb_mask */

        case E_V32QImode:
          if (pattern1093 (x2, 
E_SImode, 
E_V32QImode, 
E_V16HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19362 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 632 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 8243; /* avx2_packuswb_mask */

        case E_V16QImode:
          if (pattern1093 (x2, 
E_HImode, 
E_V16QImode, 
E_V8HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19362 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW)))
            return -1;
          return 8245; /* sse2_packuswb_mask */

        case E_V32HImode:
          if (pattern1093 (x2, 
E_SImode, 
E_V32HImode, 
E_V16SImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 23831 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 8656; /* avx512bw_packusdw_mask */

        case E_V16HImode:
          if (pattern1093 (x2, 
E_HImode, 
E_V16HImode, 
E_V8SImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 23831 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 8658; /* avx2_packusdw_mask */

        case E_V8HImode:
          if (pattern1093 (x2, 
E_QImode, 
E_V8HImode, 
E_V4SImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 23831 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW)))
            return -1;
          return 8660; /* sse4_1_packusdw_mask */

        default:
          return -1;
        }

    case 190:
      if (pattern462 (x2) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20701 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8371; /* avx512bw_pshuflwv32hi_mask */

    case 189:
      if (pattern462 (x2) != 0
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20877 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8377; /* avx512bw_pshufhwv32hi_mask */

    case 187:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern464 (x2, 
E_QImode, 
E_V8HImode, 
E_V16QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 22782 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8534; /* avx512bw_pmaddubsw512v8hi_mask */

        case E_V16HImode:
          if (pattern464 (x2, 
E_HImode, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 22782 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8536; /* avx512bw_pmaddubsw512v16hi_mask */

        case E_V32HImode:
          if (pattern464 (x2, 
E_SImode, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 22782 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8538; /* avx512bw_pmaddubsw512v32hi_mask */

        default:
          return -1;
        }

    case 52:
      switch (pattern463 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 23107 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 632 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 8552; /* avx512bw_pshufbv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 23107 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 632 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 8554; /* avx2_pshufbv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 23107 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW)))
            return -1;
          return 8556; /* ssse3_pshufbv16qi3_mask */

        default:
          return -1;
        }

    case 151:
      return recog_127 (x1, insn, pnum_clobbers);

    case 144:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1096 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28112 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL)) && 
#line 374 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 9279; /* avx512f_vpermilvarv16sf3_mask */

        case E_V8SFmode:
          if (pattern1096 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28112 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && (32 == 64 || TARGET_AVX512VL)) && 
#line 374 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 9281; /* avx_vpermilvarv8sf3_mask */

        case E_V4SFmode:
          if (pattern1096 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28112 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && (16 == 64 || TARGET_AVX512VL))))
            return -1;
          return 9283; /* avx_vpermilvarv4sf3_mask */

        case E_V8DFmode:
          if (pattern1096 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28112 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL)) && 
#line 375 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 9285; /* avx512f_vpermilvarv8df3_mask */

        case E_V4DFmode:
          if (pattern1096 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28112 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && (32 == 64 || TARGET_AVX512VL)) && 
#line 375 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 9287; /* avx_vpermilvarv4df3_mask */

        case E_V2DFmode:
          if (pattern1096 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28112 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && (16 == 64 || TARGET_AVX512VL)) && 
#line 376 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 9289; /* avx_vpermilvarv2df3_mask */

        default:
          return -1;
        }

    case 150:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern989 (x2, 
E_QImode, 
E_V8SFmode, 
E_V8HImode) != 0)
            return -1;
          x7 = XEXP (x2, 2);
          operands[4] = x7;
          if (register_operand (operands[0], E_V8HImode))
            {
              x6 = XEXP (x2, 1);
              operands[3] = x6;
              if (nonimm_or_0_operand (operands[3], E_V8HImode)
                  && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29157 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL)))
                return 9587; /* vcvtps2ph256_mask */
            }
          operands[3] = x7;
          if (!memory_operand (operands[0], E_V8HImode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[0])
              || !(
#line 96 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29169 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL)))
            return -1;
          return 9589; /* *vcvtps2ph256_merge_mask */

        case E_V16HImode:
          if (pattern989 (x2, 
E_HImode, 
E_V16SFmode, 
E_V16HImode) != 0)
            return -1;
          x7 = XEXP (x2, 2);
          operands[4] = x7;
          if (register_operand (operands[0], E_V16HImode))
            {
              x6 = XEXP (x2, 1);
              operands[3] = x6;
              if (nonimm_or_0_operand (operands[3], E_V16HImode)
                  && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29208 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 9592; /* avx512f_vcvtps2ph512_mask */
            }
          operands[3] = x7;
          if (!memory_operand (operands[0], E_V16HImode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[0])
              || !(
#line 96 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29220 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9595; /* *avx512f_vcvtps2ph512_merge_mask */

        default:
          return -1;
        }

    case 166:
      return recog_130 (x1, insn, pnum_clobbers);

    case 197:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern1097 (x2, 
E_V64QImode, 
E_DImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30260 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10054; /* vpmultishiftqbv64qi_mask */

        case E_V16QImode:
          if (pattern1097 (x2, 
E_V16QImode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30260 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10056; /* vpmultishiftqbv16qi_mask */

        case E_V32QImode:
          if (pattern1097 (x2, 
E_V32QImode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30260 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10058; /* vpmultishiftqbv32qi_mask */

        default:
          return -1;
        }

    case 200:
      switch (pattern463 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30369 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 10104; /* vgf2p8mulb_v64qi_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30369 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 10106; /* vgf2p8mulb_v32qi_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 30369 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_GFNI)))
            return -1;
          return 10108; /* vgf2p8mulb_v16qi_mask */

        default:
          return -1;
        }

    case 249:
      switch (pattern465 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10372; /* vcvt2ph2bf8v32hf_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10380; /* vcvt2ph2bf8v16hf_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10388; /* vcvt2ph2bf8v8hf_mask */

        default:
          return -1;
        }

    case 250:
      switch (pattern465 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10374; /* vcvt2ph2bf8sv32hf_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10382; /* vcvt2ph2bf8sv16hf_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10390; /* vcvt2ph2bf8sv8hf_mask */

        default:
          return -1;
        }

    case 251:
      switch (pattern465 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10376; /* vcvt2ph2hf8v32hf_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10384; /* vcvt2ph2hf8v16hf_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10392; /* vcvt2ph2hf8v8hf_mask */

        default:
          return -1;
        }

    case 252:
      switch (pattern465 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10378; /* vcvt2ph2hf8sv32hf_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10386; /* vcvt2ph2hf8sv16hf_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10394; /* vcvt2ph2hf8sv8hf_mask */

        default:
          return -1;
        }

    case 245:
      switch (pattern467 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10404; /* vcvtbiasph2bf8v32hf_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10412; /* vcvtbiasph2bf8v16hf_mask */

        default:
          return -1;
        }

    case 246:
      switch (pattern467 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10406; /* vcvtbiasph2bf8sv32hf_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10414; /* vcvtbiasph2bf8sv16hf_mask */

        default:
          return -1;
        }

    case 247:
      switch (pattern467 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10408; /* vcvtbiasph2hf8v32hf_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10416; /* vcvtbiasph2hf8v16hf_mask */

        default:
          return -1;
        }

    case 248:
      switch (pattern467 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10410; /* vcvtbiasph2hf8sv32hf_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10418; /* vcvtbiasph2hf8sv16hf_mask */

        default:
          return -1;
        }

    case 258:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern1097 (x2, 
E_V32BFmode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32092 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10513; /* avx10_2_scalefbf16_v32bf_mask */

        case E_V16BFmode:
          if (pattern1097 (x2, 
E_V16BFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32092 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10515; /* avx10_2_scalefbf16_v16bf_mask */

        case E_V8BFmode:
          if (pattern1097 (x2, 
E_V8BFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32092 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10517; /* avx10_2_scalefbf16_v8bf_mask */

        default:
          return -1;
        }

    case 259:
      switch (pattern469 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10627; /* avx10_2_rndscalebf16_v32bf_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10633; /* avx10_2_rndscalebf16_v16bf_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10639; /* avx10_2_rndscalebf16_v8bf_mask */

        default:
          return -1;
        }

    case 260:
      switch (pattern469 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10629; /* avx10_2_reducebf16_v32bf_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10635; /* avx10_2_reducebf16_v16bf_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10641; /* avx10_2_reducebf16_v8bf_mask */

        default:
          return -1;
        }

    case 261:
      switch (pattern469 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10631; /* avx10_2_getmantbf16_v32bf_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10637; /* avx10_2_getmantbf16_v16bf_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10643; /* avx10_2_getmantbf16_v8bf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[4] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[5] = x7;
  x8 = XVECEXP (x4, 0, 5);
  operands[7] = x8;
  x9 = XVECEXP (x4, 0, 6);
  operands[8] = x9;
  x10 = XVECEXP (x4, 0, 7);
  operands[9] = x10;
  x11 = XVECEXP (x4, 0, 8);
  operands[10] = x11;
  x12 = XVECEXP (x4, 0, 9);
  operands[11] = x12;
  x13 = XVECEXP (x4, 0, 10);
  operands[12] = x13;
  x14 = XVECEXP (x4, 0, 11);
  operands[13] = x14;
  x15 = XVECEXP (x4, 0, 12);
  operands[14] = x15;
  x16 = XVECEXP (x4, 0, 13);
  operands[15] = x16;
  x17 = XVECEXP (x4, 0, 14);
  operands[16] = x17;
  x18 = XVECEXP (x4, 0, 15);
  operands[17] = x18;
  x19 = XEXP (x2, 1);
  operands[18] = x19;
  x20 = XEXP (x2, 2);
  operands[19] = x20;
  if (!register_operand (operands[19], E_HImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode)
          || pattern1835 () != 0
          || !nonimm_or_0_operand (operands[18], E_V16SFmode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20453 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 3) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[2]) == INTVAL (operands[4]) - 2
   && INTVAL (operands[2]) == INTVAL (operands[5]) - 3
   && (INTVAL (operands[6]) & 3) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && INTVAL (operands[6]) == INTVAL (operands[8]) - 2
   && INTVAL (operands[6]) == INTVAL (operands[9]) - 3
   && (INTVAL (operands[10]) & 3) == 0
   && INTVAL (operands[10]) == INTVAL (operands[11]) - 1
   && INTVAL (operands[10]) == INTVAL (operands[12]) - 2
   && INTVAL (operands[10]) == INTVAL (operands[13]) - 3
   && (INTVAL (operands[14]) & 3) == 0
   && INTVAL (operands[14]) == INTVAL (operands[15]) - 1
   && INTVAL (operands[14]) == INTVAL (operands[16]) - 2
   && INTVAL (operands[14]) == INTVAL (operands[17]) - 3) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 8361; /* *avx512f_shuf_f32x4_1_mask_1 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode
          || GET_MODE (x3) != E_V16SImode
          || !nonimm_or_0_operand (operands[18], E_V16SImode))
        return -1;
      if (register_operand (operands[1], E_V16SImode)
          && pattern1835 () == 0
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20453 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 3) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[2]) == INTVAL (operands[4]) - 2
   && INTVAL (operands[2]) == INTVAL (operands[5]) - 3
   && (INTVAL (operands[6]) & 3) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && INTVAL (operands[6]) == INTVAL (operands[8]) - 2
   && INTVAL (operands[6]) == INTVAL (operands[9]) - 3
   && (INTVAL (operands[10]) & 3) == 0
   && INTVAL (operands[10]) == INTVAL (operands[11]) - 1
   && INTVAL (operands[10]) == INTVAL (operands[12]) - 2
   && INTVAL (operands[10]) == INTVAL (operands[13]) - 3
   && (INTVAL (operands[14]) & 3) == 0
   && INTVAL (operands[14]) == INTVAL (operands[15]) - 1
   && INTVAL (operands[14]) == INTVAL (operands[16]) - 2
   && INTVAL (operands[14]) == INTVAL (operands[17]) - 3) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 8363; /* *avx512f_shuf_i32x4_1_mask_1 */
      if (!nonimmediate_operand (operands[1], E_V16SImode)
          || pattern1791 () != 0
          || !const_8_to_11_operand (operands[10], E_VOIDmode)
          || !const_8_to_11_operand (operands[11], E_VOIDmode)
          || !const_8_to_11_operand (operands[12], E_VOIDmode)
          || !const_8_to_11_operand (operands[13], E_VOIDmode)
          || !const_12_to_15_operand (operands[14], E_VOIDmode)
          || !const_12_to_15_operand (operands[15], E_VOIDmode)
          || !const_12_to_15_operand (operands[16], E_VOIDmode)
          || !const_12_to_15_operand (operands[17], E_VOIDmode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20535 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])
   && INTVAL (operands[2]) + 8 == INTVAL (operands[10])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[11])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[12])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[13])
   && INTVAL (operands[2]) + 12 == INTVAL (operands[14])
   && INTVAL (operands[3]) + 12 == INTVAL (operands[15])
   && INTVAL (operands[4]) + 12 == INTVAL (operands[16])
   && INTVAL (operands[5]) + 12 == INTVAL (operands[17]))))
        return -1;
      return 8365; /* avx512f_pshufd_1_mask */

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16HImode:
      if (pattern129 (x2, 
E_HImode, 
E_V16HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17080 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 793 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW))))
        return 7536; /* ashrv16hi3_mask */
      if (!register_operand (operands[1], E_V16HImode)
          || !nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28903 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9494; /* avx512vl_ashrvv16hi_mask */

    case E_V8HImode:
      if (pattern129 (x2, 
E_QImode, 
E_V8HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17080 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 793 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW))))
        return 7538; /* ashrv8hi3_mask */
      if (!register_operand (operands[1], E_V8HImode)
          || !nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28903 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9492; /* avx512vl_ashrvv8hi_mask */

    case E_V8SImode:
      if (pattern129 (x2, 
E_QImode, 
E_V8SImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17080 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7540; /* ashrv8si3_mask */
      if (!register_operand (operands[1], E_V8SImode)
          || !nonimmediate_operand (operands[2], E_V8SImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28892 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9482; /* avx2_ashrvv8si_mask */

    case E_V4SImode:
      if (pattern129 (x2, 
E_QImode, 
E_V4SImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17080 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7542; /* ashrv4si3_mask */
      if (!register_operand (operands[1], E_V4SImode)
          || !nonimmediate_operand (operands[2], E_V4SImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28892 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (16 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9480; /* avx2_ashrvv4si_mask */

    case E_V2DImode:
      if (pattern129 (x2, 
E_QImode, 
E_V2DImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17080 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7544; /* ashrv2di3_mask */
      if (!register_operand (operands[1], E_V2DImode)
          || !nonimmediate_operand (operands[2], E_V2DImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28892 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (16 == 64 || TARGET_AVX512VL)) && 
#line 681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9486; /* avx2_ashrvv2di_mask */

    case E_V32HImode:
      if (pattern129 (x2, 
E_SImode, 
E_V32HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17124 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 788 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
        return 7554; /* ashrv32hi3_mask */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28903 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9496; /* avx512bw_ashrvv32hi_mask */

    case E_V4DImode:
      if (pattern129 (x2, 
E_QImode, 
E_V4DImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17124 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return 7556; /* ashrv4di3_mask */
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28892 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL)) && 
#line 681 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9488; /* avx2_ashrvv4di_mask */

    case E_V16SImode:
      if (pattern129 (x2, 
E_HImode, 
E_V16SImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17124 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7558; /* ashrv16si3_mask */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28892 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 680 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 9484; /* avx512f_ashrvv16si_mask */

    case E_V8DImode:
      if (pattern129 (x2, 
E_QImode, 
E_V8DImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17124 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7560; /* ashrv8di3_mask */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28892 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 682 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 9490; /* avx512f_ashrvv8di_mask */

    default:
      return -1;
    }
}

 int
recog_186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern142 (x2))
    {
    case 0:
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW))))
        return 7573; /* lshrv16hi3_mask */
      if (!register_operand (operands[1], E_V16HImode)
          || !nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9528; /* avx512vl_lshrvv16hi_mask */

    case 1:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW))))
        return 7577; /* lshrv8hi3_mask */
      if (!register_operand (operands[1], E_V8HImode)
          || !nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9524; /* avx512vl_lshrvv8hi_mask */

    case 2:
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7581; /* lshrv8si3_mask */
      if (!register_operand (operands[1], E_V8SImode)
          || !nonimmediate_operand (operands[2], E_V8SImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9504; /* avx2_lshrvv8si_mask */

    case 3:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7585; /* lshrv4si3_mask */
      if (!register_operand (operands[1], E_V4SImode)
          || !nonimmediate_operand (operands[2], E_V4SImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (16 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9508; /* avx2_lshrvv4si_mask */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7589; /* lshrv4di3_mask */
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9516; /* avx2_lshrvv4di_mask */

    case 5:
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7593; /* lshrv2di3_mask */
      if (!register_operand (operands[1], E_V2DImode)
          || !nonimmediate_operand (operands[2], E_V2DImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (16 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9520; /* avx2_lshrvv2di_mask */

    case 6:
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
        return 7613; /* lshrv32hi3_mask */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9532; /* avx512bw_lshrvv32hi_mask */

    case 7:
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7617; /* lshrv16si3_mask */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 803 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 9500; /* avx512f_lshrvv16si_mask */

    case 8:
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7621; /* lshrv8di3_mask */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 9512; /* avx512f_lshrvv8di_mask */

    default:
      return -1;
    }
}

 int
recog_192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern151 (x2))
    {
    case 0:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24108 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512BW && TARGET_AVX512VL)))
        return -1;
      return 8683; /* avx2_zero_extendv16qiv16hi2_mask */

    case 1:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24162 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8691; /* avx512bw_zero_extendv32qiv32hi2_mask */

    case 2:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24232 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL)))
        return -1;
      return 8703; /* *sse4_1_zero_extendv8qiv8hi2_mask_1 */

    case 3:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24357 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8715; /* avx512f_zero_extendv16qiv16si2_mask */

    case 4:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8743; /* avx512f_zero_extendv16hiv16si2_mask */

    case 5:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8723; /* *avx2_zero_extendv8qiv8si2_mask_1 */

    case 6:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24553 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8751; /* avx2_zero_extendv8hiv8si2_mask */

    case 7:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24450 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8735; /* *sse4_1_zero_extendv4qiv4si2_mask_1 */

    case 8:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24623 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8763; /* *sse4_1_zero_extendv4hiv4si2_mask_1 */

    case 9:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24754 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8779; /* *avx512f_zero_extendv8qiv8di2_mask_1 */

    case 10:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8810; /* avx512f_zero_extendv8hiv8di2_mask */

    case 11:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25062 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8838; /* avx512f_zero_extendv8siv8di2_mask */

    case 12:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24812 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8791; /* *avx2_zero_extendv4qiv4di2_mask_1 */

    case 13:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24955 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8818; /* *avx2_zero_extendv4hiv4di2_mask_1 */

    case 14:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25113 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8844; /* avx2_zero_extendv4siv4di2_mask */

    case 15:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24874 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8803; /* *sse4_1_zero_extendv2qiv2di2_mask_1 */

    case 16:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25013 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8830; /* *sse4_1_zero_extendv2hiv2di2_mask_1 */

    case 17:
      if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25179 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8854; /* *sse4_1_zero_extendv2siv2di2_mask_1 */

    case 18:
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern893 (x2))
        {
        case 0:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24220 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL)))
            return 8699; /* sse4_1_zero_extendv8qiv8hi2_mask */
          break;

        case 1:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24378 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8719; /* avx2_zero_extendv8qiv8si2_mask */
          break;

        case 2:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24744 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return 8775; /* avx512f_zero_extendv8qiv8di2_mask */
          break;

        case 3:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24438 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8731; /* sse4_1_zero_extendv4qiv4si2_mask */
          break;

        case 4:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8759; /* sse4_1_zero_extendv4hiv4si2_mask */
          break;

        case 5:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24801 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8787; /* avx2_zero_extendv4qiv4di2_mask */
          break;

        case 6:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24944 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8814; /* avx2_zero_extendv4hiv4di2_mask */
          break;

        case 7:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24862 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8799; /* sse4_1_zero_extendv2qiv2di2_mask */
          break;

        case 8:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25001 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8826; /* sse4_1_zero_extendv2hiv2di2_mask */
          break;

        case 9:
          if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25167 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8850; /* sse4_1_zero_extendv2siv2di2_mask */
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return -1;
      switch (pattern896 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24256 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8707; /* *sse4_1_zero_extendv8qiv8hi2_mask_2 */

        case 1:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8727; /* *avx2_zero_extendv8qiv8si2_mask_2 */

        case 2:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24772 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ())))
            return -1;
          return 8783; /* *avx512f_zero_extendv8qiv8di2_mask_2 */

        case 3:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24642 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8767; /* *sse4_1_zero_extendv4hiv4si2_mask_2 */

        case 4:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8822; /* *avx2_zero_extendv4hiv4di2_mask_2 */

        case 5:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25197 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8858; /* *sse4_1_zero_extendv2siv2di2_mask_2 */

        case 6:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24473 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8739; /* *sse4_1_zero_extendv4qiv4si2_mask_2 */

        case 7:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24833 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8795; /* *avx2_zero_extendv4qiv4di2_mask_2 */

        case 8:
          if (!(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8834; /* *sse4_1_zero_extendv2hiv2di2_mask_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
      switch (pattern132 (x2))
        {
        case 0:
          if (!(
#line 2804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2831; /* avx512fp16_vmdivv8hf3 */

        case 1:
          if (!
#line 2804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2839; /* sse_vmdivv4sf3 */

        case 2:
          if (!(
#line 2804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2847; /* sse2_vmdivv2df3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern999 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2853; /* avx512fp16_divv32hf3_mask */

        case E_V16HFmode:
          if (pattern999 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 390 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2856; /* avx512fp16_divv16hf3_mask */

        case E_V8HFmode:
          if (pattern999 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 391 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2858; /* avx512fp16_divv8hf3_mask */

        case E_V16SFmode:
          if (pattern999 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2861; /* avx512f_divv16sf3_mask */

        case E_V8SFmode:
          if (pattern999 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2864; /* avx_divv8sf3_mask */

        case E_V4SFmode:
          if (pattern999 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1)))
            return -1;
          return 2866; /* sse_divv4sf3_mask */

        case E_V8DFmode:
          if (pattern999 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2869; /* avx512f_divv8df3_mask */

        case E_V4DFmode:
          if (pattern999 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2872; /* avx_divv4df3_mask */

        case E_V2DFmode:
          if (pattern999 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2874; /* sse2_divv2df3_mask */

        case E_V32BFmode:
          if (pattern130 (x2, 
E_V32BFmode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10537; /* avx10_2_divbf16_v32bf_mask */

        case E_V16BFmode:
          if (pattern130 (x2, 
E_V16BFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10545; /* avx10_2_divbf16_v16bf_mask */

        case E_V8BFmode:
          if (pattern130 (x2, 
E_V8BFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10553; /* avx10_2_divbf16_v8bf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_210 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4494; /* unspec_avx512fp16_fix_truncv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4502; /* unspec_avx512fp16_fix_truncv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4510; /* unspec_avx512fp16_fix_truncv32hi2 */

    case E_V8SImode:
      switch (pattern637 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4518; /* unspec_avx512fp16_fix_truncv8si2 */

        case 1:
          if (!
#line 8774 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 4816; /* unspec_fix_truncv8sfv8si2 */

        case 2:
          if (!
#line 9547 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4949; /* unspec_fix_truncv8dfv8si2 */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern638 (x2, 
E_V16SImode))
        {
        case 0:
          if (!(
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4526; /* unspec_avx512fp16_fix_truncv16si2 */

        case 1:
          if (!
#line 8754 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4800; /* unspec_fix_truncv16sfv16si2 */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern639 (x2))
        {
        case 0:
          if (!(
#line 7859 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4534; /* unspec_avx512fp16_fix_truncv8di2 */

        case 1:
          if (!(
#line 9676 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4978; /* unspec_fix_truncv8dfv8di2 */

        case 2:
          if (!(
#line 9719 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5026; /* unspec_fix_truncv8sfv8di2 */

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !
#line 7897 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4590; /* unspec_avx512fp16_fix_truncv4si2 */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !
#line 8793 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 4820; /* unspec_fix_truncv4sfv4si2 */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 9637 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX || (TARGET_AVX512VL && TARGET_AVX512F)))
            return -1;
          return 4970; /* unspec_fix_truncv4dfv4si2 */

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !
#line 9919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 5066; /* unspec_sse2_cvttpd2dq */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern640 (x2))
        {
        case 0:
          if (!
#line 7897 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4594; /* unspec_avx512fp16_fix_truncv4di2 */

        case 1:
          if (!(
#line 9676 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4986; /* unspec_fix_truncv4dfv4di2 */

        case 2:
          if (!(
#line 9719 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5034; /* unspec_fix_truncv4sfv4di2 */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern641 (x2))
        {
        case 0:
          if (!
#line 7947 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4614; /* unspec_avx512fp16_fix_truncv2di2 */

        case 1:
          if (!(
#line 9676 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4990; /* unspec_fix_truncv2dfv2di2 */

        case 2:
          if (!
#line 9740 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 5050; /* unspec_avx512dq_fix_truncv2sfv2di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_224 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SQRT:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x9 = XVECEXP (x2, 0, 1);
      operands[3] = x9;
      if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1389 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3105 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2941; /* *avx512fp16_vmsqrtv8hf2_round */

        case E_V4SFmode:
          if (pattern1389 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3105 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2945; /* *sse_vmsqrtv4sf2_round */

        case E_V2DFmode:
          if (pattern1389 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3105 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2949; /* *sse2_vmsqrtv2df2_round */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern899 (x2))
        {
        case 0:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7842 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4487; /* avx512fp16_vcvtsi2sh_round */

        case 1:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7842 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))))
            return -1;
          return 4491; /* avx512fp16_vcvtsi2shq_round */

        case 2:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 4720; /* sse_cvtsi2ss_round */

        case 3:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))))
            return -1;
          return 4722; /* sse_cvtsi2ssq_round */

        case 4:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8991 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT)))
            return -1;
          return 4833; /* sse2_cvtsi2sdq_round */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern899 (x2))
        {
        case 0:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7842 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4489; /* avx512fp16_vcvtusi2sh_round */

        case 1:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7842 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))))
            return -1;
          return 4493; /* avx512fp16_vcvtusi2shq_round */

        case 2:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8604 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (V4SFmode == V4SFmode))))
            return -1;
          return 4738; /* cvtusi2ss32_round */

        case 3:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8618 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_64BIT)))
            return -1;
          return 4741; /* cvtusi2ss64_round */

        case 4:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8618 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_64BIT) && 
#line 474 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 4743; /* cvtusi2sd64_round */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x7 = XEXP (x6, 0);
      if (pattern897 (x7, 
1, 
E_HFmode) != 0)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x9 = XVECEXP (x2, 0, 1);
      operands[3] = x9;
      if (!const48_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern1653 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 463 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8289 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4693; /* avx512fp16_vcvtsh2sd_round */

        case E_V4SFmode:
          if (pattern1653 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 463 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8289 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4697; /* avx512fp16_vcvtsh2ss_round */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x9 = XVECEXP (x2, 0, 1);
      operands[3] = x9;
      if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
        return -1;
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case VEC_SELECT:
          x11 = XEXP (x7, 1);
          if (GET_CODE (x11) != PARALLEL
              || XVECLEN (x11, 0) != 1)
            return -1;
          x12 = XVECEXP (x11, 0, 0);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern1390 (x2, 
E_HFmode, 
E_V8HFmode) != 0)
            return -1;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8319 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4704; /* avx512fp16_vcvtsd2sh_round */

            case E_SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8319 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4708; /* avx512fp16_vcvtss2sh_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_V2DFmode)
              || pattern1390 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0)
            return -1;
          x8 = XEXP (x3, 1);
          operands[1] = x8;
          if (!register_operand (operands[1], E_V4SFmode)
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9990 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5072; /* sse2_cvtsd2ss_round */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 94)
        return -1;
      x13 = XVECEXP (x6, 0, 0);
      operands[2] = x13;
      x14 = XVECEXP (x6, 0, 1);
      operands[3] = x14;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[1] = x8;
      x9 = XVECEXP (x2, 0, 1);
      operands[4] = x9;
      if (!const48_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1566 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14241 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 7111; /* *avx512f_rndscalev8hf_round */

        case E_V4SFmode:
          if (pattern1566 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F))
            return -1;
          return 7113; /* *avx512f_rndscalev4sf_round */

        case E_V2DFmode:
          if (pattern1566 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14241 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 7115; /* *avx512f_rndscalev2df_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      switch (pattern645 (x2))
        {
        case 0:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2686; /* *addv32hf3_mask_round */

        case 1:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V16HFmode == V16SFmode
							      || V16HFmode == V8DFmode
							      || V16HFmode == V8DImode
							      || V16HFmode == V16SImode
							      || V16HFmode == V32HFmode)) && 
#line 390 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2694; /* *addv16hf3_mask_round */

        case 2:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V8HFmode == V16SFmode
							      || V8HFmode == V8DFmode
							      || V8HFmode == V8DImode
							      || V8HFmode == V16SImode
							      || V8HFmode == V32HFmode)) && 
#line 391 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2702; /* *addv8hf3_mask_round */

        case 3:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2710; /* *addv16sf3_mask_round */

        case 4:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V8SFmode == V16SFmode
							      || V8SFmode == V8DFmode
							      || V8SFmode == V8DImode
							      || V8SFmode == V16SImode
							      || V8SFmode == V32HFmode)) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2718; /* *addv8sf3_mask_round */

        case 5:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V4SFmode == V16SFmode
							      || V4SFmode == V8DFmode
							      || V4SFmode == V8DImode
							      || V4SFmode == V16SImode
							      || V4SFmode == V32HFmode)))))
            return -1;
          return 2726; /* *addv4sf3_mask_round */

        case 6:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2734; /* *addv8df3_mask_round */

        case 7:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V4DFmode == V16SFmode
							      || V4DFmode == V8DFmode
							      || V4DFmode == V8DImode
							      || V4DFmode == V16SImode
							      || V4DFmode == V32HFmode)) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2742; /* *addv4df3_mask_round */

        case 8:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V2DFmode == V16SFmode
							      || V2DFmode == V8DFmode
							      || V2DFmode == V8DImode
							      || V2DFmode == V16SImode
							      || V2DFmode == V32HFmode)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2750; /* *addv2df3_mask_round */

        case 9:
          if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2762; /* avx512fp16_vmaddv8hf3_round */

        case 10:
          if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2713 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2770; /* sse_vmaddv4sf3_round */

        case 11:
          if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2778; /* sse2_vmaddv2df3_round */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern645 (x2))
        {
        case 0:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2690; /* *subv32hf3_mask_round */

        case 1:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V16HFmode == V16SFmode
							      || V16HFmode == V8DFmode
							      || V16HFmode == V8DImode
							      || V16HFmode == V16SImode
							      || V16HFmode == V32HFmode)) && 
#line 390 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2698; /* *subv16hf3_mask_round */

        case 2:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V8HFmode == V16SFmode
							      || V8HFmode == V8DFmode
							      || V8HFmode == V8DImode
							      || V8HFmode == V16SImode
							      || V8HFmode == V32HFmode)) && 
#line 391 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2706; /* *subv8hf3_mask_round */

        case 3:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2714; /* *subv16sf3_mask_round */

        case 4:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V8SFmode == V16SFmode
							      || V8SFmode == V8DFmode
							      || V8SFmode == V8DImode
							      || V8SFmode == V16SImode
							      || V8SFmode == V32HFmode)) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2722; /* *subv8sf3_mask_round */

        case 5:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V4SFmode == V16SFmode
							      || V4SFmode == V8DFmode
							      || V4SFmode == V8DImode
							      || V4SFmode == V16SImode
							      || V4SFmode == V32HFmode)))))
            return -1;
          return 2730; /* *subv4sf3_mask_round */

        case 6:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2738; /* *subv8df3_mask_round */

        case 7:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V4DFmode == V16SFmode
							      || V4DFmode == V8DFmode
							      || V4DFmode == V8DImode
							      || V4DFmode == V16SImode
							      || V4DFmode == V32HFmode)) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2746; /* *subv4df3_mask_round */

        case 8:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V2DFmode == V16SFmode
							      || V2DFmode == V8DFmode
							      || V2DFmode == V8DImode
							      || V2DFmode == V16SImode
							      || V2DFmode == V32HFmode)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2754; /* *subv2df3_mask_round */

        case 9:
          if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2766; /* avx512fp16_vmsubv8hf3_round */

        case 10:
          if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2713 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2774; /* sse_vmsubv4sf3_round */

        case 11:
          if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2782; /* sse2_vmsubv2df3_round */

        default:
          return -1;
        }

    case VEC_MERGE:
      return recog_221 (x1, insn, pnum_clobbers);

    case MULT:
      switch (pattern645 (x2))
        {
        case 0:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2788; /* *mulv32hf3_mask_round */

        case 1:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V16HFmode == V16SFmode
							      || V16HFmode == V8DFmode
							      || V16HFmode == V8DImode
							      || V16HFmode == V16SImode
							      || V16HFmode == V32HFmode)) && 
#line 390 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2792; /* *mulv16hf3_mask_round */

        case 2:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V8HFmode == V16SFmode
							      || V8HFmode == V8DFmode
							      || V8HFmode == V8DImode
							      || V8HFmode == V16SImode
							      || V8HFmode == V32HFmode)) && 
#line 391 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2796; /* *mulv8hf3_mask_round */

        case 3:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2800; /* *mulv16sf3_mask_round */

        case 4:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V8SFmode == V16SFmode
							      || V8SFmode == V8DFmode
							      || V8SFmode == V8DImode
							      || V8SFmode == V16SImode
							      || V8SFmode == V32HFmode)) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2804; /* *mulv8sf3_mask_round */

        case 5:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2753 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V4SFmode == V16SFmode
							      || V4SFmode == V8DFmode
							      || V4SFmode == V8DImode
							      || V4SFmode == V16SImode
							      || V4SFmode == V32HFmode)))))
            return -1;
          return 2808; /* *mulv4sf3_mask_round */

        case 6:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2812; /* *mulv8df3_mask_round */

        case 7:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V4DFmode == V16SFmode
							      || V4DFmode == V8DFmode
							      || V4DFmode == V8DImode
							      || V4DFmode == V16SImode
							      || V4DFmode == V32HFmode)) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2816; /* *mulv4df3_mask_round */

        case 8:
          if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V2DFmode == V16SFmode
							      || V2DFmode == V8DFmode
							      || V2DFmode == V8DImode
							      || V2DFmode == V16SImode
							      || V2DFmode == V32HFmode)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2820; /* *mulv2df3_mask_round */

        case 9:
          if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2828; /* avx512fp16_vmmulv8hf3_round */

        case 10:
          if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2836; /* sse_vmmulv4sf3_round */

        case 11:
          if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2844; /* sse2_vmmulv2df3_round */

        default:
          return -1;
        }

    case DIV:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x2, 0, 1);
      if (!const_4_or_8_to_11_operand (x7, E_SImode))
        return -1;
      x8 = XEXP (x3, 2);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          switch (pattern644 (x2))
            {
            case 0:
              if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 2832; /* avx512fp16_vmdivv8hf3_round */

            case 1:
              if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 2840; /* sse_vmdivv4sf3_round */

            case 2:
              if (!(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 2848; /* sse2_vmdivv2df3_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern646 (x2))
            {
            case 0:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
                return -1;
              return 2854; /* avx512fp16_divv32hf3_mask_round */

            case 1:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2862; /* avx512f_divv16sf3_mask_round */

            case 2:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2870; /* avx512f_divv8df3_mask_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x7 = XVECEXP (x2, 0, 1);
      if (!const_4_or_8_to_11_operand (x7, E_SImode))
        return -1;
      x8 = XEXP (x3, 2);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[3] = x8;
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1387 (x2, 
E_SImode, 
E_V32HFmode) != 0
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3068 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
                return -1;
              return 2907; /* avx512fp16_sqrtv32hf2_mask_round */

            case E_V16SFmode:
              if (pattern1387 (x2, 
E_HImode, 
E_V16SFmode) != 0
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3068 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2915; /* avx512f_sqrtv16sf2_mask_round */

            case E_V8DFmode:
              if (pattern1387 (x2, 
E_QImode, 
E_V8DFmode) != 0
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3068 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2923; /* avx512f_sqrtv8df2_mask_round */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x8, 0) != 1LL)
            return -1;
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1388 (x2, 
E_V8HFmode) != 0
                  || !(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3086 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 2929; /* avx512fp16_vmsqrtv8hf2_round */

            case E_V4SFmode:
              if (pattern1388 (x2, 
E_V4SFmode) != 0
                  || !(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3086 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 2933; /* sse_vmsqrtv4sf2_round */

            case E_V2DFmode:
              if (pattern1388 (x2, 
E_V2DFmode) != 0
                  || !(
#line 421 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3086 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 2937; /* sse2_vmsqrtv2df2_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      return recog_224 (x1, insn, pnum_clobbers);

    case SMAX:
      switch (pattern647 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2985; /* *smaxv32hf3_mask_round */

        case 1:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3001; /* *smaxv16sf3_mask_round */

        case 2:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3017; /* *smaxv8df3_mask_round */

        case 3:
          if (!(
#line 463 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3099; /* *avx512fp16_vmsmaxv8hf3_round */

        case 4:
          if (!(
#line 463 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3470 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 3107; /* *sse_vmsmaxv4sf3_round */

        case 5:
          if (!(
#line 463 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3115; /* *sse2_vmsmaxv2df3_round */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern647 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2989; /* *sminv32hf3_mask_round */

        case 1:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 392 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3005; /* *sminv16sf3_mask_round */

        case 2:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3021; /* *sminv8df3_mask_round */

        case 3:
          if (!(
#line 463 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3103; /* *avx512fp16_vmsminv8hf3_round */

        case 4:
          if (!(
#line 463 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3470 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 3111; /* *sse_vmsminv4sf3_round */

        case 5:
          if (!(
#line 463 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3119; /* *sse2_vmsminv2df3_round */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_223 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_222 (x1, insn, pnum_clobbers);

    case FLOAT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 2);
      operands[3] = x8;
      x7 = XVECEXP (x2, 0, 1);
      operands[4] = x7;
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          switch (pattern1294 (x2))
            {
            case 0:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4411; /* avx512fp16_vcvtw2ph_v8hi_mask_round */

            case 1:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4435; /* avx512fp16_vcvtdq2ph_v8si_mask_round */

            case 2:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4451; /* avx512fp16_vcvtqq2ph_v8di_mask_round */

            default:
              return -1;
            }

        case E_V16HFmode:
          switch (pattern1295 (x2))
            {
            case 0:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4419; /* avx512fp16_vcvtw2ph_v16hi_mask_round */

            case 1:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4443; /* avx512fp16_vcvtdq2ph_v16si_mask_round */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (pattern648 (x2, 
E_SImode, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4427; /* avx512fp16_vcvtw2ph_v32hi_mask_round */

        case E_V16SFmode:
          if (pattern648 (x2, 
E_HImode, 
E_V16SFmode, 
E_V16SImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8628 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 433 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 4747; /* floatv16siv16sf2_mask_round */

        case E_V8DFmode:
          if (pattern1296 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4879; /* floatv8div8df2_mask_round */

        case E_V4DFmode:
          if (pattern1296 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4887; /* floatv4div4df2_mask_round */

        case E_V2DFmode:
          if (pattern1296 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4895; /* floatv2div2df2_mask_round */

        case E_V8SFmode:
          if (pattern1296 (x2, 
E_V8SFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
							      || V8DImode == V8DFmode
							      || V8DImode == V8DImode
							      || V8DImode == V16SImode
							      || V8DImode == V32HFmode)) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4903; /* floatv8div8sf2_mask_round */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 2);
      operands[3] = x8;
      x7 = XVECEXP (x2, 0, 1);
      operands[4] = x7;
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          switch (pattern1294 (x2))
            {
            case 0:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4415; /* avx512fp16_vcvtuw2ph_v8hi_mask_round */

            case 1:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4439; /* avx512fp16_vcvtudq2ph_v8si_mask_round */

            case 2:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4455; /* avx512fp16_vcvtuqq2ph_v8di_mask_round */

            default:
              return -1;
            }

        case E_V16HFmode:
          switch (pattern1295 (x2))
            {
            case 0:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4423; /* avx512fp16_vcvtuw2ph_v16hi_mask_round */

            case 1:
              if (!(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4447; /* avx512fp16_vcvtudq2ph_v16si_mask_round */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (pattern648 (x2, 
E_SImode, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4431; /* avx512fp16_vcvtuw2ph_v32hi_mask_round */

        case E_V16SFmode:
          if (pattern1296 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4755; /* floatunsv16siv16sf2_mask_round */

        case E_V8SFmode:
          if (pattern1297 (x2, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4759; /* floatunsv8siv8sf2_mask_round */

            case E_V8DImode:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
							      || V8DImode == V8DFmode
							      || V8DImode == V8DImode
							      || V8DImode == V16SImode
							      || V8DImode == V32HFmode)) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4907; /* floatunsv8div8sf2_mask_round */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (pattern1296 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4763; /* floatunsv4siv4sf2_mask_round */

        case E_V8DFmode:
          if (pattern1296 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4883; /* floatunsv8div8df2_mask_round */

        case E_V4DFmode:
          if (pattern1296 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4891; /* floatunsv4div4df2_mask_round */

        case E_V2DFmode:
          if (pattern1296 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4899; /* floatunsv2div2df2_mask_round */

        default:
          return -1;
        }

    case FIX:
      switch (pattern649 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4545; /* avx512fp16_fix_truncv8hi2_mask_round */

        case 1:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4553; /* avx512fp16_fix_truncv16hi2_mask_round */

        case 2:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4561; /* avx512fp16_fix_truncv32hi2_mask_round */

        case 3:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4569; /* avx512fp16_fix_truncv8si2_mask_round */

        case 4:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9557 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4960; /* fix_truncv8dfv8si2_mask_round */

        case 5:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4577; /* avx512fp16_fix_truncv16si2_mask_round */

        case 6:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8764 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4811; /* fix_truncv16sfv16si2_mask_round */

        case 7:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4585; /* avx512fp16_fix_truncv8di2_mask_round */

        case 8:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9686 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4997; /* fix_truncv8dfv8di2_mask_round */

        case 9:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9729 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 5041; /* fix_truncv8sfv8di2_mask_round */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern649 (x2))
        {
        case 0:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4549; /* avx512fp16_fixuns_truncv8hi2_mask_round */

        case 1:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4557; /* avx512fp16_fixuns_truncv16hi2_mask_round */

        case 2:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4565; /* avx512fp16_fixuns_truncv32hi2_mask_round */

        case 3:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4573; /* avx512fp16_fixuns_truncv8si2_mask_round */

        case 4:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9557 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4964; /* fixuns_truncv8dfv8si2_mask_round */

        case 5:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4581; /* avx512fp16_fixuns_truncv16si2_mask_round */

        case 6:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8764 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4815; /* fixuns_truncv16sfv16si2_mask_round */

        case 7:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4589; /* avx512fp16_fixuns_truncv8di2_mask_round */

        case 8:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9686 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 5001; /* fixuns_truncv8dfv8di2_mask_round */

        case 9:
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9729 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 5045; /* fixuns_truncv8sfv8di2_mask_round */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x7 = XVECEXP (x2, 0, 1);
      if (!const48_operand (x7, E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          x8 = XEXP (x3, 2);
          operands[3] = x8;
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DFmode:
              if (pattern1297 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8HFmode:
                  if (!register_operand (operands[1], E_V8HFmode)
                      || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 4649; /* avx512fp16_float_extend_phv8df2_mask_round */

                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode)
                      || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 10207 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 467 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                    return -1;
                  return 5094; /* avx512f_cvtps2pd512_mask_round */

                default:
                  return -1;
                }

            case E_V16SFmode:
              if (pattern648 (x2, 
E_HImode, 
E_V16SFmode, 
E_V16HFmode) != 0
                  || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4653; /* avx512fp16_float_extend_phv16sf2_mask_round */

            case E_V8SFmode:
              if (pattern648 (x2, 
E_QImode, 
E_V8SFmode, 
E_V8HFmode) != 0
                  || !(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4657; /* avx512fp16_float_extend_phv8sf2_mask_round */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (GET_MODE (x5) != E_V2SFmode)
            return -1;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 2)
            return -1;
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XVECEXP (x10, 0, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x3, 2);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern1461 (x2) != 0)
            return -1;
          x13 = XEXP (x5, 0);
          operands[2] = x13;
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          x9 = XEXP (x3, 1);
          operands[1] = x9;
          if (!register_operand (operands[1], E_V2DFmode))
            return -1;
          operands[3] = x7;
          if (!(
#line 263 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10034 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5077; /* sse2_cvtss2sd_round */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 2);
      operands[3] = x8;
      x7 = XVECEXP (x2, 0, 1);
      operands[4] = x7;
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1297 (x2, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4673; /* avx512fp16_vcvtpd2ph_v8df_mask_round */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4681; /* avx512fp16_vcvtps2ph_v8sf_mask_round */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (pattern648 (x2, 
E_HImode, 
E_V16HFmode, 
E_V16SFmode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4677; /* avx512fp16_vcvtps2ph_v16sf_mask_round */

        case E_V8SFmode:
          if (pattern648 (x2, 
E_QImode, 
E_V8SFmode, 
E_V8DFmode) != 0
              || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10073 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 5084; /* avx512f_cvtpd2ps512_mask_round */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (GET_MODE (x4) != E_V32HFmode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != FLOAT_TRUNCATE
          || GET_MODE (x5) != E_V16HFmode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != FLOAT_TRUNCATE
          || GET_MODE (x6) != E_V16HFmode
          || !register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || GET_MODE (x3) != E_V32HFmode)
        return -1;
      x13 = XEXP (x5, 0);
      operands[2] = x13;
      if (!register_operand (operands[2], E_V16SFmode))
        return -1;
      x14 = XEXP (x6, 0);
      operands[1] = x14;
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!nonimm_or_0_operand (operands[3], E_V32HFmode))
        return -1;
      x8 = XEXP (x3, 2);
      operands[4] = x8;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 1);
      operands[5] = x7;
      if (!const_4_or_8_to_11_operand (operands[5], E_SImode)
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31714 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 561 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))))
        return -1;
      return 10366; /* avx10_2_cvt2ps2phx_v32hf_mask_round */

    default:
      return -1;
    }
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_276 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  operands[4] = x5;
  x8 = XVECEXP (x3, 0, 2);
  operands[5] = x8;
  x9 = XVECEXP (x3, 0, 3);
  operands[6] = x9;
  x10 = XVECEXP (x3, 0, 4);
  operands[7] = x10;
  x11 = XVECEXP (x3, 0, 5);
  operands[8] = x11;
  x12 = XVECEXP (x3, 0, 6);
  operands[9] = x12;
  x13 = XVECEXP (x3, 0, 7);
  operands[10] = x13;
  x14 = XVECEXP (x3, 0, 8);
  operands[11] = x14;
  x15 = XVECEXP (x3, 0, 9);
  operands[12] = x15;
  x16 = XVECEXP (x3, 0, 10);
  operands[13] = x16;
  x17 = XVECEXP (x3, 0, 11);
  operands[14] = x17;
  x18 = XVECEXP (x3, 0, 12);
  operands[15] = x18;
  x19 = XVECEXP (x3, 0, 13);
  operands[16] = x19;
  x20 = XVECEXP (x3, 0, 14);
  operands[17] = x20;
  x21 = XVECEXP (x3, 0, 15);
  operands[18] = x21;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (pattern1400 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0)
        return -1;
      if (const_0_to_3_operand (operands[3], E_VOIDmode)
          && const_0_to_3_operand (operands[4], E_VOIDmode)
          && const_16_to_19_operand (operands[5], E_VOIDmode)
          && const_16_to_19_operand (operands[6], E_VOIDmode)
          && const_4_to_7_operand (operands[7], E_VOIDmode)
          && const_4_to_7_operand (operands[8], E_VOIDmode)
          && const_20_to_23_operand (operands[9], E_VOIDmode)
          && const_20_to_23_operand (operands[10], E_VOIDmode)
          && const_8_to_11_operand (operands[11], E_VOIDmode)
          && const_8_to_11_operand (operands[12], E_VOIDmode)
          && const_24_to_27_operand (operands[13], E_VOIDmode)
          && const_24_to_27_operand (operands[14], E_VOIDmode)
          && const_12_to_15_operand (operands[15], E_VOIDmode)
          && const_12_to_15_operand (operands[16], E_VOIDmode)
          && const_28_to_31_operand (operands[17], E_VOIDmode)
          && const_28_to_31_operand (operands[18], E_VOIDmode)
          && 
#line 14270 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4)
       && INTVAL (operands[3]) == (INTVAL (operands[11]) - 8)
       && INTVAL (operands[4]) == (INTVAL (operands[12]) - 8)
       && INTVAL (operands[5]) == (INTVAL (operands[13]) - 8)
       && INTVAL (operands[6]) == (INTVAL (operands[14]) - 8)
       && INTVAL (operands[3]) == (INTVAL (operands[15]) - 12)
       && INTVAL (operands[4]) == (INTVAL (operands[16]) - 12)
       && INTVAL (operands[5]) == (INTVAL (operands[17]) - 12)
       && INTVAL (operands[6]) == (INTVAL (operands[18]) - 12))))
        return 7116; /* avx512f_shufps512_1 */
      if (!const_0_to_15_operand (operands[3], E_VOIDmode)
          || pattern1836 () != 0
          || !(
#line 20401 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8356; /* avx512f_shuf_f32x4_1 */

    case E_V16SImode:
      if (pattern1400 (x2, 
E_V16SImode, 
E_V32SImode) != 0
          || !const_0_to_15_operand (operands[3], E_VOIDmode)
          || pattern1836 () != 0
          || !(
#line 20401 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8358; /* avx512f_shuf_i32x4_1 */

    default:
      return -1;
    }
}

 int
recog_280 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern668 (x3) != 0)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 0);
  switch (XWINT (x6, 0))
    {
    case 8LL:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 40LL)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 9LL)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 41LL)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 10LL)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 42LL)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 11LL)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 43LL
          || pattern1865 (x3) != 0)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 24LL)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 56LL)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 25LL)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 57LL)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 26LL)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 58LL)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 27LL)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 59LL
          || pattern1871 (x3) != 0
          || pattern1400 (x2, 
E_V32QImode, 
E_V64QImode) != 0
          || !
#line 19438 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
        return -1;
      return 8248; /* avx2_interleave_highv32qi */

    case 0LL:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 32LL)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 1LL)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 33LL)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 2LL)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 34LL)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 3LL)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 35LL)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 16LL)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 48LL)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 17LL)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 49LL)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 18LL)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 50LL)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 19LL)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 51LL)
        return -1;
      x22 = XVECEXP (x3, 0, 8);
      switch (XWINT (x22, 0))
        {
        case 4LL:
          x23 = XVECEXP (x3, 0, 9);
          if (XWINT (x23, 0) != 36LL)
            return -1;
          x24 = XVECEXP (x3, 0, 10);
          if (XWINT (x24, 0) != 5LL)
            return -1;
          x25 = XVECEXP (x3, 0, 11);
          if (XWINT (x25, 0) != 37LL)
            return -1;
          x26 = XVECEXP (x3, 0, 12);
          if (XWINT (x26, 0) != 6LL)
            return -1;
          x27 = XVECEXP (x3, 0, 13);
          if (XWINT (x27, 0) != 38LL)
            return -1;
          x28 = XVECEXP (x3, 0, 14);
          if (XWINT (x28, 0) != 7LL)
            return -1;
          x29 = XVECEXP (x3, 0, 15);
          if (XWINT (x29, 0) != 39LL)
            return -1;
          x30 = XVECEXP (x3, 0, 24);
          if (XWINT (x30, 0) != 20LL)
            return -1;
          x31 = XVECEXP (x3, 0, 25);
          if (XWINT (x31, 0) != 52LL)
            return -1;
          x32 = XVECEXP (x3, 0, 26);
          if (XWINT (x32, 0) != 21LL)
            return -1;
          x33 = XVECEXP (x3, 0, 27);
          if (XWINT (x33, 0) != 53LL)
            return -1;
          x34 = XVECEXP (x3, 0, 28);
          if (XWINT (x34, 0) != 22LL)
            return -1;
          x35 = XVECEXP (x3, 0, 29);
          if (XWINT (x35, 0) != 54LL)
            return -1;
          x36 = XVECEXP (x3, 0, 30);
          if (XWINT (x36, 0) != 23LL)
            return -1;
          x37 = XVECEXP (x3, 0, 31);
          if (XWINT (x37, 0) != 55LL
              || pattern1400 (x2, 
E_V32QImode, 
E_V64QImode) != 0
              || !
#line 19534 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
            return -1;
          return 8254; /* avx2_interleave_lowv32qi */

        case 8LL:
          x23 = XVECEXP (x3, 0, 9);
          if (XWINT (x23, 0) != 40LL)
            return -1;
          x24 = XVECEXP (x3, 0, 10);
          if (XWINT (x24, 0) != 9LL)
            return -1;
          x25 = XVECEXP (x3, 0, 11);
          if (XWINT (x25, 0) != 41LL)
            return -1;
          x26 = XVECEXP (x3, 0, 12);
          if (XWINT (x26, 0) != 10LL)
            return -1;
          x27 = XVECEXP (x3, 0, 13);
          if (XWINT (x27, 0) != 42LL)
            return -1;
          x28 = XVECEXP (x3, 0, 14);
          if (XWINT (x28, 0) != 11LL)
            return -1;
          x29 = XVECEXP (x3, 0, 15);
          if (XWINT (x29, 0) != 43LL)
            return -1;
          x30 = XVECEXP (x3, 0, 24);
          if (XWINT (x30, 0) != 24LL)
            return -1;
          x31 = XVECEXP (x3, 0, 25);
          if (XWINT (x31, 0) != 56LL)
            return -1;
          x32 = XVECEXP (x3, 0, 26);
          if (XWINT (x32, 0) != 25LL)
            return -1;
          x33 = XVECEXP (x3, 0, 27);
          if (XWINT (x33, 0) != 57LL)
            return -1;
          x34 = XVECEXP (x3, 0, 28);
          if (XWINT (x34, 0) != 26LL)
            return -1;
          x35 = XVECEXP (x3, 0, 29);
          if (XWINT (x35, 0) != 58LL)
            return -1;
          x36 = XVECEXP (x3, 0, 30);
          if (XWINT (x36, 0) != 27LL)
            return -1;
          x37 = XVECEXP (x3, 0, 31);
          if (XWINT (x37, 0) != 59LL)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern1400 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                  || !(
#line 19654 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8276; /* *avx512bw_interleave_lowv32hi */

            case E_V32HFmode:
              if (pattern1400 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                  || !(
#line 19654 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8278; /* *avx512bw_interleave_lowv32hf */

            case E_V32BFmode:
              if (pattern1400 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                  || !(
#line 19654 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8280; /* *avx512bw_interleave_lowv32bf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4LL:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 36LL)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 5LL)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 37LL)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 6LL)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 38LL)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 7LL)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 39LL
          || pattern1865 (x3) != 0)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 20LL)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 52LL)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 21LL)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 53LL)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 22LL)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 54LL)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 23LL)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 55LL
          || pattern1871 (x3) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1400 (x2, 
E_V32HImode, 
E_V64HImode) != 0
              || !(
#line 19586 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8258; /* avx512bw_interleave_highv32hi */

        case E_V32HFmode:
          if (pattern1400 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
              || !(
#line 19586 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8260; /* avx512bw_interleave_highv32hf */

        case E_V32BFmode:
          if (pattern1400 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
              || !(
#line 19586 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8262; /* avx512bw_interleave_highv32bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode))
        {
          if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
              && 
#line 27351 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
            return 9081; /* *avx_vperm_broadcast_v4sf */
          if (
#line 27488 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V4SFmode)))
            return 9088; /* *avx_vpermilpv4sf */
        }
      if (!register_operand (operands[1], E_V4SFmode)
          || !palignr_operand (operands[2], E_VOIDmode)
          || !
#line 28340 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9386; /* *ssse3_palignrv4sf_perm */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
          && 
#line 27379 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX
   && (V8SFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)))
        return 9082; /* *avx_vperm_broadcast_v8sf */
      if (!(
#line 27488 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V8SFmode)) && 
#line 374 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 9086; /* *avx_vpermilpv8sf */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode))
        return -1;
      if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
          && 
#line 27379 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX
   && (V4DFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)))
        return 9083; /* *avx_vperm_broadcast_v4df */
      if (!(
#line 27488 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V4DFmode)) && 
#line 375 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 9092; /* *avx_vpermilpv4df */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode)
          || !(
#line 27488 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V16SFmode)) && 
#line 374 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9084; /* *avx512f_vpermilpv16sf */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode)
          || !(
#line 27488 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V8DFmode)) && 
#line 375 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9090; /* *avx512f_vpermilpv8df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && (
#line 27488 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V2DFmode)) && 
#line 376 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 9094; /* *avx_vpermilpv2df */
      if (!register_operand (operands[1], E_V2DFmode)
          || !palignr_operand (operands[2], E_VOIDmode)
          || !(
#line 28340 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 342 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 9387; /* *ssse3_palignrv2df_perm */

    case E_V16QImode:
      if (pattern1131 (x2, 
E_V16QImode) != 0
          || !
#line 28340 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9380; /* *ssse3_palignrv16qi_perm */

    case E_V8HImode:
      if (pattern1131 (x2, 
E_V8HImode) != 0
          || !
#line 28340 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9381; /* *ssse3_palignrv8hi_perm */

    case E_V8HFmode:
      if (pattern1131 (x2, 
E_V8HFmode) != 0
          || !
#line 28340 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9382; /* *ssse3_palignrv8hf_perm */

    case E_V8BFmode:
      if (pattern1131 (x2, 
E_V8BFmode) != 0
          || !
#line 28340 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9383; /* *ssse3_palignrv8bf_perm */

    case E_V4SImode:
      if (pattern1131 (x2, 
E_V4SImode) != 0
          || !
#line 28340 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9384; /* *ssse3_palignrv4si_perm */

    case E_V2DImode:
      if (pattern1131 (x2, 
E_V2DImode) != 0
          || !
#line 28340 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9385; /* *ssse3_palignrv2di_perm */

    default:
      return -1;
    }
}

 int
recog_304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern529 (x2))
        {
        case 0:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5439; /* *avx512bw_vpternlogv64qi_1 */

        case 1:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5466; /* *avx512vl_vpternlogv32qi_1 */

        case 2:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5493; /* *avx512vl_vpternlogv16qi_1 */

        case 3:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5520; /* *avx512bw_vpternlogv32hi_1 */

        case 4:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5547; /* *avx512vl_vpternlogv16hi_1 */

        case 5:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5574; /* *avx512vl_vpternlogv8hi_1 */

        case 6:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5601; /* *avx512f_vpternlogv16si_1 */

        case 7:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5628; /* *avx512vl_vpternlogv8si_1 */

        case 8:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5655; /* *avx512vl_vpternlogv4si_1 */

        case 9:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5682; /* *avx512f_vpternlogv8di_1 */

        case 10:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5709; /* *avx512vl_vpternlogv4di_1 */

        case 11:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5736; /* *avx512vl_vpternlogv2di_1 */

        case 12:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5442; /* *avx512bw_vpternlogv64qi_1 */

        case 13:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5469; /* *avx512vl_vpternlogv32qi_1 */

        case 14:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5496; /* *avx512vl_vpternlogv16qi_1 */

        case 15:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5523; /* *avx512bw_vpternlogv32hi_1 */

        case 16:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5550; /* *avx512vl_vpternlogv16hi_1 */

        case 17:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5577; /* *avx512vl_vpternlogv8hi_1 */

        case 18:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5604; /* *avx512f_vpternlogv16si_1 */

        case 19:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5631; /* *avx512vl_vpternlogv8si_1 */

        case 20:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5658; /* *avx512vl_vpternlogv4si_1 */

        case 21:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5685; /* *avx512f_vpternlogv8di_1 */

        case 22:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5712; /* *avx512vl_vpternlogv4di_1 */

        case 23:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5739; /* *avx512vl_vpternlogv2di_1 */

        case 24:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5445; /* *avx512bw_vpternlogv64qi_1 */

        case 25:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5472; /* *avx512vl_vpternlogv32qi_1 */

        case 26:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5499; /* *avx512vl_vpternlogv16qi_1 */

        case 27:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5526; /* *avx512bw_vpternlogv32hi_1 */

        case 28:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5553; /* *avx512vl_vpternlogv16hi_1 */

        case 29:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5580; /* *avx512vl_vpternlogv8hi_1 */

        case 30:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5607; /* *avx512f_vpternlogv16si_1 */

        case 31:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5634; /* *avx512vl_vpternlogv8si_1 */

        case 32:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5661; /* *avx512vl_vpternlogv4si_1 */

        case 33:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5688; /* *avx512f_vpternlogv8di_1 */

        case 34:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5715; /* *avx512vl_vpternlogv4di_1 */

        case 35:
          if (!
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5742; /* *avx512vl_vpternlogv2di_1 */

        case 36:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6729; /* *avx512bw_vpternlogv64qi_3 */

        case 37:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6738; /* *avx512vl_vpternlogv32qi_3 */

        case 38:
          if (!
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6747; /* *avx512vl_vpternlogv16qi_3 */

        case 39:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6756; /* *avx512bw_vpternlogv32hi_3 */

        case 40:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6765; /* *avx512vl_vpternlogv16hi_3 */

        case 41:
          if (!
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6774; /* *avx512vl_vpternlogv8hi_3 */

        case 42:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6783; /* *avx512f_vpternlogv16si_3 */

        case 43:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6792; /* *avx512vl_vpternlogv8si_3 */

        case 44:
          if (!
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6801; /* *avx512vl_vpternlogv4si_3 */

        case 45:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6810; /* *avx512f_vpternlogv8di_3 */

        case 46:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6819; /* *avx512vl_vpternlogv4di_3 */

        case 47:
          if (!
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6828; /* *avx512vl_vpternlogv2di_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern531 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6087; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6114; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6141; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6168; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6195; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6222; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6249; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6276; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6303; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6330; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6357; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6384; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6090; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6117; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6144; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6171; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6198; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6225; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6252; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6279; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6306; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6333; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6360; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6387; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6093; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6120; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6147; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6174; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6201; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6228; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6255; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6282; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6309; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6336; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6363; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6390; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_VECTOR
      || XVECLEN (x5, 0) != 32
      || pattern1345 (x5, 
E_V32HImode) != 0)
    return -1;
  x6 = XVECEXP (x5, 0, 8);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x5, 0, 9);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x5, 0, 10);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XVECEXP (x5, 0, 11);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XVECEXP (x5, 0, 12);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x11 = XVECEXP (x5, 0, 13);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XVECEXP (x5, 0, 14);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x5, 0, 15);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XVECEXP (x5, 0, 16);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x15 = XVECEXP (x5, 0, 17);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x16 = XVECEXP (x5, 0, 18);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x17 = XVECEXP (x5, 0, 19);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x18 = XVECEXP (x5, 0, 20);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x19 = XVECEXP (x5, 0, 21);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x20 = XVECEXP (x5, 0, 22);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x21 = XVECEXP (x5, 0, 23);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x22 = XVECEXP (x5, 0, 24);
  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x23 = XVECEXP (x5, 0, 25);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x24 = XVECEXP (x5, 0, 26);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x25 = XVECEXP (x5, 0, 27);
  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x26 = XVECEXP (x5, 0, 28);
  if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x27 = XVECEXP (x5, 0, 29);
  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x28 = XVECEXP (x5, 0, 30);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x29 = XVECEXP (x5, 0, 31);
  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V32HImode)
      || GET_MODE (x2) != E_V32HImode
      || GET_MODE (x3) != E_V32SImode
      || pattern1494 (x4, 
E_V32SImode) != 0)
    return -1;
  x30 = XEXP (x4, 0);
  x31 = XEXP (x30, 0);
  x32 = XEXP (x31, 1);
  if (GET_MODE (x32) != E_V32SImode)
    return -1;
  x33 = XEXP (x32, 0);
  operands[2] = x33;
  if (!nonimmediate_operand (operands[2], E_V32HImode)
      || !
#line 22817 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
    return -1;
  return 8539; /* avx512bw_umulhrswv32hi3 */
}

 int
recog_314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 177:
          return recog_215 (x1, insn, pnum_clobbers);

        case 118:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[0], E_V4SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
            return -1;
          *pnum_clobbers = 1;
          return 2558; /* movdi_to_sse */

        case 119:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V32QImode:
              if (!register_operand (operands[0], E_V32QImode)
                  || GET_MODE (x2) != E_V32QImode
                  || !memory_operand (operands[1], E_V32QImode)
                  || !(
#line 1989 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE3) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2559; /* avx_lddqu256 */

            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !memory_operand (operands[1], E_V16QImode)
                  || !
#line 1989 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 2560; /* sse3_lddqu */

            default:
              return -1;
            }

        case 117:
          return recog_211 (x1, insn, pnum_clobbers);

        case 54:
          return recog_213 (x1, insn, pnum_clobbers);

        case 161:
          switch (pattern322 (x2))
            {
            case 0:
              if (!(
#line 3007 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2888; /* *rcp14v16sf */

            case 1:
              if (!(
#line 3007 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2890; /* *rcp14v8sf */

            case 2:
              if (!(
#line 3007 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2892; /* *rcp14v4sf */

            case 3:
              if (!(
#line 3007 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2894; /* *rcp14v8df */

            case 4:
              if (!(
#line 3007 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2896; /* *rcp14v4df */

            case 5:
              if (!(
#line 3007 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2898; /* *rcp14v2df */

            default:
              return -1;
            }

        case 55:
          return recog_212 (x1, insn, pnum_clobbers);

        case 162:
          switch (pattern322 (x2))
            {
            case 0:
              if (!(
#line 3161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2960; /* *rsqrt14v16sf */

            case 1:
              if (!(
#line 3161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2962; /* *rsqrt14v8sf */

            case 2:
              if (!(
#line 3161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2964; /* *rsqrt14v4sf */

            case 3:
              if (!(
#line 3161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2966; /* *rsqrt14v8df */

            case 4:
              if (!(
#line 3161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2968; /* *rsqrt14v4df */

            case 5:
              if (!(
#line 3161 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2970; /* *rsqrt14v2df */

            default:
              return -1;
            }

        case 156:
          return recog_209 (x1, insn, pnum_clobbers);

        case 46:
          return recog_205 (x1, insn, pnum_clobbers);

        case 172:
          return recog_210 (x1, insn, pnum_clobbers);

        case 173:
          return recog_208 (x1, insn, pnum_clobbers);

        case 165:
          return recog_207 (x1, insn, pnum_clobbers);

        case 127:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DImode:
              if (!register_operand (operands[0], E_V8DImode)
                  || GET_MODE (x2) != E_V8DImode
                  || !memory_operand (operands[1], E_V8DImode)
                  || !(
#line 23769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 707 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 8644; /* avx512f_movntdqa */

            case E_V4DImode:
              if (!register_operand (operands[0], E_V4DImode)
                  || GET_MODE (x2) != E_V4DImode
                  || !memory_operand (operands[1], E_V4DImode)
                  || !(
#line 23769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 707 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 8645; /* avx2_movntdqa */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x2) != E_V2DImode
                  || !memory_operand (operands[1], E_V2DImode)
                  || !
#line 23769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8646; /* sse4_1_movntdqa */

            default:
              return -1;
            }

        case 129:
          if (GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_operand (operands[1], E_V8HImode)
              || !
#line 24095 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8679; /* sse4_1_phminposuw */

        case 136:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 26982 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8982; /* xop_frczv4sf2 */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !nonimmediate_operand (operands[1], E_V2DFmode)
                  || !
#line 26982 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8983; /* xop_frczv2df2 */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x2) != E_V8SFmode
                  || !nonimmediate_operand (operands[1], E_V8SFmode)
                  || !
#line 26982 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8984; /* xop_frczv8sf2 */

            case E_V4DFmode:
              if (!register_operand (operands[0], E_V4DFmode)
                  || GET_MODE (x2) != E_V4DFmode
                  || !nonimmediate_operand (operands[1], E_V4DFmode)
                  || !
#line 26982 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8985; /* xop_frczv4df2 */

            default:
              return -1;
            }

        case 134:
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              operands[1] = x4;
              x5 = XEXP (x4, 0);
              operands[2] = x5;
              x6 = XEXP (x4, 1);
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1006 (x2, 
E_V16QImode) != 0
                      || !
#line 27045 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8996; /* xop_maskcmp_uns2v16qi3 */

                case E_V8HImode:
                  if (pattern1006 (x2, 
E_V8HImode) != 0
                      || !
#line 27045 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8997; /* xop_maskcmp_uns2v8hi3 */

                case E_V4SImode:
                  if (pattern1006 (x2, 
E_V4SImode) != 0
                      || !
#line 27045 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8998; /* xop_maskcmp_uns2v4si3 */

                case E_V2DImode:
                  if (pattern1006 (x2, 
E_V2DImode) != 0
                      || !
#line 27045 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8999; /* xop_maskcmp_uns2v2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 141:
          if (GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[0], E_V2DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_operand (operands[1], E_V2DImode)
              || !
#line 27159 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AES))
            return -1;
          return 9012; /* aesimc */

        case 149:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !memory_operand (operands[1], E_V4HImode)
                  || !
#line 29077 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
                return -1;
              return 9575; /* *vcvtph2ps_load */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x2) != E_V8SFmode
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || !
#line 29087 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
                return -1;
              return 9577; /* vcvtph2ps256 */

            case E_V16SFmode:
              if (!register_operand (operands[0], E_V16SFmode)
                  || GET_MODE (x2) != E_V16SFmode
                  || !vector_operand (operands[1], E_V16HImode)
                  || !
#line 29099 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 9579; /* *avx512f_vcvtph2ps512 */

            default:
              return -1;
            }

        case 168:
          return recog_214 (x1, insn, pnum_clobbers);

        case 253:
          switch (pattern324 (x2))
            {
            case 0:
              if (!
#line 31909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10427; /* vcvtph2bf8v16hf */

            case 1:
              if (!
#line 31909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10435; /* vcvtph2bf8v32hf */

            default:
              return -1;
            }

        case 254:
          switch (pattern324 (x2))
            {
            case 0:
              if (!
#line 31909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10429; /* vcvtph2bf8sv16hf */

            case 1:
              if (!
#line 31909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10437; /* vcvtph2bf8sv32hf */

            default:
              return -1;
            }

        case 255:
          switch (pattern324 (x2))
            {
            case 0:
              if (!
#line 31909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10431; /* vcvtph2hf8v16hf */

            case 1:
              if (!
#line 31909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10439; /* vcvtph2hf8v32hf */

            default:
              return -1;
            }

        case 256:
          switch (pattern324 (x2))
            {
            case 0:
              if (!
#line 31909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10433; /* vcvtph2hf8sv16hf */

            case 1:
              if (!
#line 31909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10441; /* vcvtph2hf8sv32hf */

            default:
              return -1;
            }

        case 257:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (!register_operand (operands[0], E_V32HFmode)
                  || GET_MODE (x2) != E_V32HFmode
                  || !nonimmediate_operand (operands[1], E_V32QImode)
                  || !
#line 31918 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10443; /* vcvthf82phv32hf */

            case E_V16HFmode:
              if (!register_operand (operands[0], E_V16HFmode)
                  || GET_MODE (x2) != E_V16HFmode
                  || !nonimmediate_operand (operands[1], E_V16QImode)
                  || !
#line 31918 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10445; /* vcvthf82phv16hf */

            case E_V8HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x2) != E_V8HFmode
                  || !nonimmediate_operand (operands[1], E_V16QImode)
                  || !
#line 31918 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10447; /* vcvthf82phv8hf */

            default:
              return -1;
            }

        case 263:
          switch (pattern325 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10656; /* avx10_2_cvtbf162ibsv32bf */

            case 1:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10664; /* avx10_2_cvtbf162ibsv16bf */

            case 2:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10672; /* avx10_2_cvtbf162ibsv8bf */

            default:
              return -1;
            }

        case 264:
          switch (pattern325 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10658; /* avx10_2_cvtbf162iubsv32bf */

            case 1:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10666; /* avx10_2_cvtbf162iubsv16bf */

            case 2:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10674; /* avx10_2_cvtbf162iubsv8bf */

            default:
              return -1;
            }

        case 269:
          switch (pattern325 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10660; /* avx10_2_cvttbf162ibsv32bf */

            case 1:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10668; /* avx10_2_cvttbf162ibsv16bf */

            case 2:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10676; /* avx10_2_cvttbf162ibsv8bf */

            default:
              return -1;
            }

        case 270:
          switch (pattern325 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10662; /* avx10_2_cvttbf162iubsv32bf */

            case 1:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10670; /* avx10_2_cvttbf162iubsv16bf */

            case 2:
              if (!
#line 32491 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10678; /* avx10_2_cvttbf162iubsv8bf */

            default:
              return -1;
            }

        case 265:
          switch (pattern325 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32506 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10680; /* avx10_2_cvtph2ibsv32hf */

            case 1:
              if (!
#line 32506 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10688; /* avx10_2_cvtph2ibsv16hf */

            case 2:
              if (!
#line 32506 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10692; /* avx10_2_cvtph2ibsv8hf */

            default:
              return -1;
            }

        case 266:
          switch (pattern325 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32506 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10684; /* avx10_2_cvtph2iubsv32hf */

            case 1:
              if (!
#line 32506 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10690; /* avx10_2_cvtph2iubsv16hf */

            case 2:
              if (!
#line 32506 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10694; /* avx10_2_cvtph2iubsv8hf */

            default:
              return -1;
            }

        case 271:
          switch (pattern325 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10696; /* avx10_2_cvttph2ibsv32hf */

            case 1:
              if (!
#line 32521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10704; /* avx10_2_cvttph2ibsv16hf */

            case 2:
              if (!
#line 32521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10708; /* avx10_2_cvttph2ibsv8hf */

            default:
              return -1;
            }

        case 272:
          switch (pattern325 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10700; /* avx10_2_cvttph2iubsv32hf */

            case 1:
              if (!
#line 32521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10706; /* avx10_2_cvttph2iubsv16hf */

            case 2:
              if (!
#line 32521 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10710; /* avx10_2_cvttph2iubsv8hf */

            default:
              return -1;
            }

        case 267:
          switch (pattern326 (x2))
            {
            case 0:
              if (!(
#line 32536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10712; /* avx10_2_cvtps2ibsv16sf */

            case 1:
              if (!
#line 32536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10720; /* avx10_2_cvtps2ibsv8sf */

            case 2:
              if (!
#line 32536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10724; /* avx10_2_cvtps2ibsv4sf */

            default:
              return -1;
            }

        case 268:
          switch (pattern326 (x2))
            {
            case 0:
              if (!(
#line 32536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10716; /* avx10_2_cvtps2iubsv16sf */

            case 1:
              if (!
#line 32536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10722; /* avx10_2_cvtps2iubsv8sf */

            case 2:
              if (!
#line 32536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10726; /* avx10_2_cvtps2iubsv4sf */

            default:
              return -1;
            }

        case 273:
          switch (pattern326 (x2))
            {
            case 0:
              if (!(
#line 32551 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10728; /* avx10_2_cvttps2ibsv16sf */

            case 1:
              if (!
#line 32551 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10736; /* avx10_2_cvttps2ibsv8sf */

            case 2:
              if (!
#line 32551 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10740; /* avx10_2_cvttps2ibsv4sf */

            default:
              return -1;
            }

        case 274:
          switch (pattern326 (x2))
            {
            case 0:
              if (!(
#line 32551 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10732; /* avx10_2_cvttps2iubsv16sf */

            case 1:
              if (!
#line 32551 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10738; /* avx10_2_cvttps2iubsv8sf */

            case 2:
              if (!
#line 32551 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10742; /* avx10_2_cvttps2iubsv4sf */

            default:
              return -1;
            }

        case 275:
          switch (pattern327 (x2))
            {
            case 0:
              if (!(
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 385 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10744; /* avx10_2_vcvttps2dqsv16sf */

            case 1:
              if (!
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10752; /* avx10_2_vcvttps2dqsv8sf */

            case 2:
              if (!(
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 386 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10760; /* avx10_2_vcvttpd2dqsv8df */

            case 3:
              if (!
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10756; /* avx10_2_vcvttps2dqsv4sf */

            case 4:
              if (!
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10768; /* avx10_2_vcvttpd2dqsv4df */

            case 5:
              if (!
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10772; /* avx10_2_vcvttpd2dqsv2df */

            case 6:
              if (!(
#line 32581 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 450 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10776; /* avx10_2_vcvttpd2qqsv8df */

            case 7:
              if (!(
#line 32592 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 617 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10792; /* avx10_2_vcvttps2qqsv8di */

            case 8:
              if (!
#line 32581 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10784; /* avx10_2_vcvttpd2qqsv4df */

            case 9:
              if (!
#line 32592 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10800; /* avx10_2_vcvttps2qqsv4di */

            case 10:
              if (!
#line 32581 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10788; /* avx10_2_vcvttpd2qqsv2df */

            case 11:
              if (!
#line 32592 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10804; /* avx10_2_vcvttps2qqsv2di */

            default:
              return -1;
            }

        case 276:
          switch (pattern327 (x2))
            {
            case 0:
              if (!(
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 385 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10748; /* avx10_2_vcvttps2udqsv16sf */

            case 1:
              if (!
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10754; /* avx10_2_vcvttps2udqsv8sf */

            case 2:
              if (!(
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 386 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10764; /* avx10_2_vcvttpd2udqsv8df */

            case 3:
              if (!
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10758; /* avx10_2_vcvttps2udqsv4sf */

            case 4:
              if (!
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10770; /* avx10_2_vcvttpd2udqsv4df */

            case 5:
              if (!
#line 32570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10774; /* avx10_2_vcvttpd2udqsv2df */

            case 6:
              if (!(
#line 32581 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 450 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10780; /* avx10_2_vcvttpd2uqqsv8df */

            case 7:
              if (!(
#line 32592 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 617 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10796; /* avx10_2_vcvttps2uqqsv8di */

            case 8:
              if (!
#line 32581 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10786; /* avx10_2_vcvttpd2uqqsv4df */

            case 9:
              if (!
#line 32592 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10802; /* avx10_2_vcvttps2uqqsv4di */

            case 10:
              if (!
#line 32581 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10790; /* avx10_2_vcvttpd2uqqsv2df */

            case 11:
              if (!
#line 32592 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10806; /* avx10_2_vcvttps2uqqsv2di */

            default:
              return -1;
            }

        case 279:
          return recog_206 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case 2:
      return recog_263 (x1, insn, pnum_clobbers);

    case 3:
      return recog_262 (x1, insn, pnum_clobbers);

    case 4:
      return recog_261 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_296 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !nonimmediate_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 14872 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 7145; /* vec_dupv2df */
          if (!(
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9214; /* *avx512vl_vec_dup_gprv2df */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9160; /* *avx512f_broadcastv16sf */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9204; /* *avx512f_vec_dup_gprv16sf */

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !(
#line 28053 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9260; /* *avx512dq_broadcastv16sf_1 */

            default:
              return -1;
            }

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !(
#line 27733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9162; /* *avx512f_broadcastv16si */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !(
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9192; /* *avx512f_vec_dup_gprv16si */

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 28053 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9262; /* *avx512dq_broadcastv16si_1 */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x3) != E_V8DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DFmode:
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !(
#line 27745 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9164; /* *avx512f_broadcastv8df */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9210; /* *avx512f_vec_dup_gprv8df */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 28071 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28064 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9266; /* *avx512dq_broadcastv8df_1 */

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x3) != E_V8DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !(
#line 27745 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9166; /* *avx512f_broadcastv8di */

            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9198; /* *avx512f_vec_dup_gprv8di */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 28071 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28064 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9264; /* *avx512dq_broadcastv8di_1 */

            default:
              return -1;
            }

        case E_V64QImode:
          if (!register_operand (operands[0], E_V64QImode)
              || GET_MODE (x3) != E_V64QImode
              || !nonimmediate_operand (operands[1], E_QImode)
              || !(
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9168; /* *avx512bw_vec_dup_gprv64qi */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9170; /* *avx512vl_vec_dup_gprv16qi */
          if (!
#line 27919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9225; /* *vec_dupv16qi */

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x3) != E_V32QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9172; /* *avx512vl_vec_dup_gprv32qi */
          if (!
#line 27919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9224; /* *vec_dupv32qi */

        case E_V32HImode:
          if (!register_operand (operands[0], E_V32HImode)
              || GET_MODE (x3) != E_V32HImode
              || !nonimmediate_operand (operands[1], E_HImode)
              || !(
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9174; /* *avx512bw_vec_dup_gprv32hi */

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9176; /* *avx512vl_vec_dup_gprv16hi */
          if (!
#line 27919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9226; /* *vec_dupv16hi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9178; /* *avx512vl_vec_dup_gprv8hi */
          if (!
#line 27919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9227; /* *vec_dupv8hi */

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x3) != E_V32HFmode
              || !nonimmediate_operand (operands[1], E_HFmode)
              || !(
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9180; /* *avx512bw_vec_dup_gprv32hf */

        case E_V16HFmode:
          if (!register_operand (operands[0], E_V16HFmode)
              || GET_MODE (x3) != E_V16HFmode
              || !nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          if ((
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9182; /* *avx512vl_vec_dup_gprv16hf */
          if (!
#line 27919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9230; /* *vec_dupv16hf */

        case E_V8HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          if ((
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9184; /* *avx512fp16_vec_dup_gprv8hf */
          if (!
#line 27919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9231; /* *vec_dupv8hf */

        case E_V32BFmode:
          if (!register_operand (operands[0], E_V32BFmode)
              || GET_MODE (x3) != E_V32BFmode
              || !nonimmediate_operand (operands[1], E_BFmode)
              || !(
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9186; /* *avx512bw_vec_dup_gprv32bf */

        case E_V16BFmode:
          if (!register_operand (operands[0], E_V16BFmode)
              || GET_MODE (x3) != E_V16BFmode
              || !nonimmediate_operand (operands[1], E_BFmode))
            return -1;
          if ((
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9188; /* *avx512vl_vec_dup_gprv16bf */
          if (!
#line 27919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9232; /* *vec_dupv16bf */

        case E_V8BFmode:
          if (!register_operand (operands[0], E_V8BFmode)
              || GET_MODE (x3) != E_V8BFmode
              || !nonimmediate_operand (operands[1], E_BFmode))
            return -1;
          if ((
#line 27757 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9190; /* *avx512vl_vec_dup_gprv8bf */
          if (!
#line 27919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9233; /* *vec_dupv8bf */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              if ((
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9194; /* *avx512vl_vec_dup_gprv8si */
              if (
#line 27919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 9228; /* *vec_dupv8si */
              if (!
#line 27939 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9234; /* vec_dupv8si */

            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !
#line 28040 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 9256; /* *avx512vl_broadcastv8si_1 */

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9196; /* *avx512vl_vec_dup_gprv4si */
          if (
#line 27816 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 9217; /* *vec_dupv4si */
          if (!
#line 27919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9229; /* *vec_dupv4si */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9200; /* *avx512vl_vec_dup_gprv4di */
              if (!
#line 27939 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9236; /* vec_dupv4di */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 28071 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28065 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9268; /* *avx512dq_broadcastv4di_1 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9202; /* *avx512vl_vec_dup_gprv2di */
          if (!
#line 27844 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 9218; /* *vec_dupv2di */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode))
                return -1;
              if ((
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9206; /* *avx512vl_vec_dup_gprv8sf */
              if (!
#line 27939 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9235; /* vec_dupv8sf */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 28040 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 9258; /* *avx512vl_broadcastv8sf_1 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_SFmode))
            return -1;
          if ((
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9208; /* *avx512vl_vec_dup_gprv4sf */
          if (!
#line 27784 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 9216; /* vec_dupv4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode))
                return -1;
              if ((
#line 27769 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9212; /* *avx512vl_vec_dup_gprv4df */
              if (!
#line 27939 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9237; /* vec_dupv4df */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 28071 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28065 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9270; /* *avx512dq_broadcastv4df_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x4) != E_SFmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          switch (pattern671 (x3, 
E_V8SFmode))
            {
            case 0:
              if (!(
#line 31630 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT) && 
#line 440 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 10351; /* vbcstnebf162ps_v8sf */

            case 1:
              if (!(
#line 31641 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT) && 
#line 440 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 10353; /* vbcstnesh2ps_v8sf */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern671 (x3, 
E_V4SFmode))
            {
            case 0:
              if (!
#line 31630 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                return -1;
              return 10352; /* vbcstnebf162ps_v4sf */

            case 1:
              if (!
#line 31641 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                return -1;
              return 10354; /* vbcstnesh2ps_v4sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern29 (x1))
    {
    case 0:
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7572; /* *lshrv16hi3 */
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7595; /* lshrv16hi3 */
      if (!nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 28925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9527; /* avx512vl_lshrvv16hi */

    case 1:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7576; /* *lshrv8hi3 */
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7597; /* lshrv8hi3 */
      if (!nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 28925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9523; /* avx512vl_lshrvv8hi */

    case 2:
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7580; /* *lshrv8si3 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7599; /* lshrv8si3 */
      if (!nonimmediate_operand (operands[2], E_V8SImode)
          || !
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9503; /* avx2_lshrvv8si */

    case 3:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7584; /* *lshrv4si3 */
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7601; /* lshrv4si3 */
      if (!nonimmediate_operand (operands[2], E_V4SImode)
          || !
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9507; /* avx2_lshrvv4si */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7588; /* *lshrv4di3 */
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 776 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7603; /* lshrv4di3 */
      if (!nonimmediate_operand (operands[2], E_V4DImode)
          || !
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9515; /* avx2_lshrvv4di */

    case 5:
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7592; /* *lshrv2di3 */
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7605; /* lshrv2di3 */
      if (!nonimmediate_operand (operands[2], E_V2DImode)
          || !
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9519; /* avx2_lshrvv2di */

    case 6:
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return 7612; /* lshrv32hi3 */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 28925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9531; /* avx512bw_lshrvv32hi */

    case 7:
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7616; /* lshrv16si3 */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 803 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9499; /* avx512f_lshrvv16si */

    case 8:
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7620; /* lshrv8di3 */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 28914 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 804 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9511; /* avx512f_lshrvv8di */

    case 9:
      if (register_operand (operands[1], E_V1TImode)
          && const_0_to_255_not_mul_8_operand (operands[2], E_SImode)
          && 
#line 17468 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()))
        return 7623; /* *lshrv1ti3_internal */
      if (!const_0_to_255_mul_8_operand (operands[2], E_SImode))
        return -1;
      if (nonimmediate_operand (operands[1], E_V1TImode)
          && (
#line 17583 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7632; /* avx512bw_lshrv1ti3 */
      if (!register_operand (operands[1], E_V1TImode)
          || !
#line 17598 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7636; /* sse2_lshrv1ti3 */

    case 10:
      if (!(
#line 17583 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7628; /* avx512bw_lshrv4ti3 */

    case 11:
      if (nonimmediate_operand (operands[1], E_V2TImode)
          && (
#line 17583 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7630; /* avx512bw_lshrv2ti3 */
      if (!register_operand (operands[1], E_V2TImode)
          || !(
#line 17598 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 732 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 7634; /* avx2_lshrv2ti3 */

    default:
      return -1;
    }
}

 int
recog_330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  switch (pattern34 (x1))
    {
    case 0:
      if (!
#line 24108 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
        return -1;
      return 8682; /* avx2_zero_extendv16qiv16hi2 */

    case 1:
      if (!
#line 24162 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 8690; /* avx512bw_zero_extendv32qiv32hi2 */

    case 2:
      if (!
#line 24232 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
        return -1;
      return 8702; /* *sse4_1_zero_extendv8qiv8hi2_1 */

    case 3:
      if (!
#line 24357 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8714; /* *avx512f_zero_extendv16qiv16si2 */

    case 4:
      if (!
#line 24500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8742; /* avx512f_zero_extendv16hiv16si2 */

    case 5:
      if (!
#line 24389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8722; /* *avx2_zero_extendv8qiv8si2_1 */

    case 6:
      if (!
#line 24553 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8750; /* avx2_zero_extendv8hiv8si2 */

    case 7:
      if (!
#line 24450 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8734; /* *sse4_1_zero_extendv4qiv4si2_1 */

    case 8:
      if (!
#line 24623 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8762; /* *sse4_1_zero_extendv4hiv4si2_1 */

    case 9:
      if (!
#line 24754 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8778; /* *avx512f_zero_extendv8qiv8di2_1 */

    case 10:
      if (!
#line 24925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8809; /* avx512f_zero_extendv8hiv8di2 */

    case 11:
      if (!
#line 25062 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8837; /* avx512f_zero_extendv8siv8di2 */

    case 12:
      if (!
#line 24812 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8790; /* *avx2_zero_extendv4qiv4di2_1 */

    case 13:
      if (!
#line 24955 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8817; /* *avx2_zero_extendv4hiv4di2_1 */

    case 14:
      if (!
#line 25113 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8843; /* avx2_zero_extendv4siv4di2 */

    case 15:
      if (!
#line 24874 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8802; /* *sse4_1_zero_extendv2qiv2di2_1 */

    case 16:
      if (!
#line 25013 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8829; /* *sse4_1_zero_extendv2hiv2di2_1 */

    case 17:
      if (!
#line 25179 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8853; /* *sse4_1_zero_extendv2siv2di2_1 */

    case 18:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern537 (x2))
        {
        case 0:
          if (
#line 24220 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
            return 8698; /* sse4_1_zero_extendv8qiv8hi2 */
          break;

        case 1:
          if (
#line 24378 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8718; /* avx2_zero_extendv8qiv8si2 */
          break;

        case 2:
          if (
#line 24744 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 8774; /* avx512f_zero_extendv8qiv8di2 */
          break;

        case 3:
          if (
#line 24438 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8730; /* sse4_1_zero_extendv4qiv4si2 */
          break;

        case 4:
          if (
#line 24611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8758; /* sse4_1_zero_extendv4hiv4si2 */
          break;

        case 5:
          if (
#line 24801 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8786; /* avx2_zero_extendv4qiv4di2 */
          break;

        case 6:
          if (
#line 24944 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8813; /* avx2_zero_extendv4hiv4di2 */
          break;

        case 7:
          if (
#line 24862 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8798; /* sse4_1_zero_extendv2qiv2di2 */
          break;

        case 8:
          if (
#line 25001 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8825; /* sse4_1_zero_extendv2hiv2di2 */
          break;

        case 9:
          if (
#line 25167 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8849; /* sse4_1_zero_extendv2siv2di2 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case VEC_CONCAT:
          switch (pattern674 (x2))
            {
            case 0:
              if (!
#line 24256 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8706; /* *sse4_1_zero_extendv8qiv8hi2_2 */

            case 1:
              if (!
#line 24408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8726; /* *avx2_zero_extendv8qiv8si2_2 */

            case 2:
              if (!
#line 24772 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
                return -1;
              return 8782; /* *avx512f_zero_extendv8qiv8di2_2 */

            case 3:
              if (!
#line 24642 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8766; /* *sse4_1_zero_extendv4hiv4si2_2 */

            case 4:
              if (!
#line 24972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8821; /* *avx2_zero_extendv4hiv4di2_2 */

            case 5:
              if (!
#line 25197 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8857; /* *sse4_1_zero_extendv2siv2di2_2 */

            default:
              return -1;
            }

        case VEC_MERGE:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_DUPLICATE)
            return -1;
          if (GET_MODE (x6) == E_V4SImode)
            {
              switch (pattern1025 (x2))
                {
                case 0:
                  if (
#line 24473 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                    return 8738; /* *sse4_1_zero_extendv4qiv4si2_2 */
                  break;

                case 1:
                  if (
#line 24833 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
                    return 8794; /* *avx2_zero_extendv4qiv4di2_2 */
                  break;

                case 2:
                  if (
#line 25035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                    return 8833; /* *sse4_1_zero_extendv2hiv2di2_2 */
                  break;

                default:
                  break;
                }
            }
          x7 = XEXP (x5, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          switch (pattern1026 (x2))
            {
            case 0:
              if (!
#line 24909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                return -1;
              return 8804; /* *sse4_1_zero_extendv2qiv2di2_2 */

            case 1:
              if (!
#line 24909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                return -1;
              return 8805; /* *sse4_1_zero_extendv2qiv2di2_2 */

            case 2:
              if (!
#line 24909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                return -1;
              return 8806; /* *sse4_1_zero_extendv2qiv2di2_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern34 (x1))
    {
    case 0:
      if (!
#line 24108 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
        return -1;
      return 8680; /* avx2_sign_extendv16qiv16hi2 */

    case 1:
      if (!
#line 24162 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 8688; /* avx512bw_sign_extendv32qiv32hi2 */

    case 2:
      if (!
#line 24232 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
        return -1;
      return 8700; /* *sse4_1_sign_extendv8qiv8hi2_1 */

    case 3:
      if (!
#line 24357 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8712; /* *avx512f_sign_extendv16qiv16si2 */

    case 4:
      if (!
#line 24500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8740; /* avx512f_sign_extendv16hiv16si2 */

    case 5:
      if (!
#line 24389 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8720; /* *avx2_sign_extendv8qiv8si2_1 */

    case 6:
      if (!
#line 24553 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8748; /* avx2_sign_extendv8hiv8si2 */

    case 7:
      if (!
#line 24450 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8732; /* *sse4_1_sign_extendv4qiv4si2_1 */

    case 8:
      if (!
#line 24623 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8760; /* *sse4_1_sign_extendv4hiv4si2_1 */

    case 9:
      if (!
#line 24754 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8776; /* *avx512f_sign_extendv8qiv8di2_1 */

    case 10:
      if (!
#line 24925 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8807; /* avx512f_sign_extendv8hiv8di2 */

    case 11:
      if (!
#line 25062 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8835; /* avx512f_sign_extendv8siv8di2 */

    case 12:
      if (!
#line 24812 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8788; /* *avx2_sign_extendv4qiv4di2_1 */

    case 13:
      if (!
#line 24955 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8815; /* *avx2_sign_extendv4hiv4di2_1 */

    case 14:
      if (!
#line 25113 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8841; /* avx2_sign_extendv4siv4di2 */

    case 15:
      if (!
#line 24874 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8800; /* *sse4_1_sign_extendv2qiv2di2_1 */

    case 16:
      if (!
#line 25013 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8827; /* *sse4_1_sign_extendv2hiv2di2_1 */

    case 17:
      if (!
#line 25179 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8851; /* *sse4_1_sign_extendv2siv2di2_1 */

    case 18:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern537 (x2))
        {
        case 0:
          if (
#line 24220 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
            return 8696; /* sse4_1_sign_extendv8qiv8hi2 */
          break;

        case 1:
          if (
#line 24378 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8716; /* avx2_sign_extendv8qiv8si2 */
          break;

        case 2:
          if (
#line 24744 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 8772; /* avx512f_sign_extendv8qiv8di2 */
          break;

        case 3:
          if (
#line 24438 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8728; /* sse4_1_sign_extendv4qiv4si2 */
          break;

        case 4:
          if (
#line 24611 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8756; /* sse4_1_sign_extendv4hiv4si2 */
          break;

        case 5:
          if (
#line 24801 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8784; /* avx2_sign_extendv4qiv4di2 */
          break;

        case 6:
          if (
#line 24944 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8811; /* avx2_sign_extendv4hiv4di2 */
          break;

        case 7:
          if (
#line 24862 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8796; /* sse4_1_sign_extendv2qiv2di2 */
          break;

        case 8:
          if (
#line 25001 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8823; /* sse4_1_sign_extendv2hiv2di2 */
          break;

        case 9:
          if (
#line 25167 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8847; /* sse4_1_sign_extendv2siv2di2 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      switch (pattern676 (x2))
        {
        case 0:
          if (!
#line 24256 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8704; /* *sse4_1_sign_extendv8qiv8hi2_2 */

        case 1:
          if (!
#line 24408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8724; /* *avx2_sign_extendv8qiv8si2_2 */

        case 2:
          if (!
#line 24772 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
            return -1;
          return 8780; /* *avx512f_sign_extendv8qiv8di2_2 */

        case 3:
          if (!
#line 24642 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8764; /* *sse4_1_sign_extendv4hiv4si2_2 */

        case 4:
          if (!
#line 24972 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8819; /* *avx2_sign_extendv4hiv4di2_2 */

        case 5:
          if (!
#line 25197 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8855; /* *sse4_1_sign_extendv2siv2di2_2 */

        case 6:
          if (!
#line 24473 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8736; /* *sse4_1_sign_extendv4qiv4si2_2 */

        case 7:
          if (!
#line 24833 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8792; /* *avx2_sign_extendv4qiv4di2_2 */

        case 8:
          if (!
#line 25035 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8831; /* *sse4_1_sign_extendv2hiv2di2_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!(
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4542; /* avx512fp16_fix_truncv8hi2 */

    case 1:
      if (!(
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4550; /* avx512fp16_fix_truncv16hi2 */

    case 2:
      if (!(
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4558; /* avx512fp16_fix_truncv32hi2 */

    case 3:
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4566; /* avx512fp16_fix_truncv8si2 */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !
#line 8783 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 4818; /* fix_truncv8sfv8si2 */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !
#line 9557 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4957; /* fix_truncv8dfv8si2 */

        default:
          return -1;
        }

    case 4:
      if (!(
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4574; /* avx512fp16_fix_truncv16si2 */

    case 5:
      if (!
#line 8764 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 4808; /* fix_truncv16sfv16si2 */

    case 6:
      if (!(
#line 7869 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4582; /* avx512fp16_fix_truncv8di2 */

    case 7:
      if (!(
#line 9686 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4994; /* fix_truncv8dfv8di2 */

    case 8:
      if (!(
#line 9729 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 5038; /* fix_truncv8sfv8di2 */

    case 9:
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !
#line 7919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4606; /* *avx512fp16_fix_truncv4si2_load */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !
#line 8813 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 4822; /* fix_truncv4sfv4si2 */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 9646 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX || (TARGET_AVX512VL && TARGET_AVX512F)))
            return -1;
          return 4972; /* fix_truncv4dfv4si2 */

        default:
          return -1;
        }

    case 10:
      if (!
#line 7919 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4610; /* *avx512fp16_fix_truncv4di2_load */

    case 11:
      if (!(
#line 9686 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 5002; /* fix_truncv4dfv4di2 */

    case 12:
      if (!(
#line 9729 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 5046; /* fix_truncv4sfv4di2 */

    case 13:
      if (!
#line 7969 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4622; /* *avx512fp16_fix_truncv2di2_load */

    case 14:
      if (!(
#line 9686 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 5006; /* fix_truncv2dfv2di2 */

    case 15:
      if (!
#line 7909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4598; /* avx512fp16_fix_truncv4si2 */

    case 16:
      if (!
#line 7909 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4602; /* avx512fp16_fix_truncv4di2 */

    case 17:
      if (!
#line 7959 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4618; /* avx512fp16_fix_truncv2di2 */

    case 18:
      if (!
#line 9752 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 5054; /* avx512dq_fix_truncv2sfv2di2 */

    default:
      return -1;
    }
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (nonimmediate_operand (operands[0], E_SImode)
          && nonimmediate_operand (operands[1], E_SImode)
          && 
#line 22582 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_MOVBE
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
        return 1640; /* *bswapsi2_movbe */
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode)
          || !
#line 22597 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BSWAP))
        return -1;
      return 1642; /* *bswapsi2 */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      if (nonimmediate_operand (operands[0], E_DImode)
          && nonimmediate_operand (operands[1], E_DImode)
          && (
#line 22582 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_MOVBE
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1641; /* *bswapdi2_movbe */
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_DImode)
          || !(
#line 22597 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BSWAP) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1643; /* *bswapdi2 */

    default:
      return -1;
    }
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (pattern231 (x5, 
E_CCmode, 
17) != 0)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  res = recog_356 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 8LL
      || pattern713 (x2) != 0)
    return -1;
  switch (pattern1404 (x2))
    {
    case 0:
      if (!
#line 13230 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 800; /* *andqi_exthi_3 */

    case 1:
      if (!
#line 13230 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 803; /* *andqi_extsi_3 */

    case 2:
      if (!(
#line 13230 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 806; /* *andqi_extdi_3 */

    case 3:
      if (!
#line 13230 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 801; /* *iorqi_exthi_3 */

    case 4:
      if (!
#line 13230 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 804; /* *iorqi_extsi_3 */

    case 5:
      if (!(
#line 13230 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 807; /* *iorqi_extdi_3 */

    case 6:
      if (!
#line 13230 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 802; /* *xorqi_exthi_3 */

    case 7:
      if (!
#line 13230 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 805; /* *xorqi_extsi_3 */

    case 8:
      if (!(
#line 13230 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 808; /* *xorqi_extdi_3 */

    default:
      return -1;
    }
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 106:
      if (pattern538 (x1) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!pop_operand (operands[1], E_TImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 3901 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_PUSH2POP2))
        return -1;
      return 160; /* pop2_di */

    case 14:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern353 (x6) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) != 0LL
              || !
#line 20773 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1498; /* *set_got */

        case LABEL_REF:
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!
#line 20795 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1499; /* *set_got_labelled */

        default:
          return -1;
        }

    case 97:
      switch (pattern541 (x1))
        {
        case 0:
          if (!
#line 21648 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          return 1550; /* tzcnt_si */

        case 1:
          if (!(((
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21648 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21648 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI)))
            return -1;
          return 1552; /* tzcnt_di */

        case 2:
          if (!(
#line 21738 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(true) && 
#line 21648 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI)))
            return -1;
          return 1563; /* tzcnt_hi */

        case 3:
          if ((
#line 21712 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21648 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI)))
            return 1554; /* *tzcnt_si_falsedep_nf */
          if (pnum_clobbers == NULL
              || !
#line 21648 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          *pnum_clobbers = 1;
          return 1558; /* *tzcnt_si_falsedep */

        case 4:
          if ((
#line 21712 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF) && ((
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21648 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))))
            return 1556; /* *tzcnt_di_falsedep_nf */
          if (pnum_clobbers == NULL
              || !((
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21648 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1560; /* *tzcnt_di_falsedep */

        default:
          return -1;
        }

    case 96:
      switch (pattern541 (x1))
        {
        case 0:
          if (!
#line 21649 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          return 1551; /* lzcnt_si */

        case 1:
          if (!(((
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21649 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21649 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
            return -1;
          return 1553; /* lzcnt_di */

        case 2:
          if (!(
#line 21738 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(true) && 
#line 21649 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
            return -1;
          return 1565; /* lzcnt_hi */

        case 3:
          if ((
#line 21712 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21649 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
            return 1555; /* *lzcnt_si_falsedep_nf */
          if (pnum_clobbers == NULL
              || !
#line 21649 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          *pnum_clobbers = 1;
          return 1559; /* *lzcnt_si_falsedep */

        case 4:
          if ((
#line 21712 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF) && ((
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21649 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))))
            return 1557; /* *lzcnt_di_falsedep_nf */
          if (pnum_clobbers == NULL
              || !((
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21649 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1561; /* *lzcnt_di_falsedep */

        default:
          return -1;
        }

    case 27:
      if (GET_MODE (x3) != E_CCmode
          || pattern677 (x1, 
CLOBBER, 
E_CCmode) != 0)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[0]))
        return -1;
      return 1647; /* parityhi2_cmp */

    case 80:
      if (pattern542 (x1, 
81) != 0
          || !
#line 24072 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1719; /* sincosxf3 */

    case 82:
      if (pattern542 (x1, 
83) != 0
          || !
#line 24587 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1724; /* fxtractxf3_i387 */

    case 70:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_XFmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_XFmode)
          || !
#line 25133 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
        return -1;
      return 1733; /* lrintxfdi2 */

    case 74:
      if (pattern543 (x1) != 0
          || !
#line 25232 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      return 1736; /* frndintxf2_roundeven */

    case 75:
      if (pattern543 (x1) != 0
          || !
#line 25232 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      return 1737; /* frndintxf2_floor */

    case 76:
      if (pattern543 (x1) != 0
          || !
#line 25232 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      return 1738; /* frndintxf2_ceil */

    case 77:
      if (pattern543 (x1) != 0
          || !
#line 25232 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      return 1739; /* frndintxf2_trunc */

    case 78:
      switch (pattern545 (x1))
        {
        case 0:
          if (!
#line 25349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1744; /* *fisthi2_floor_1 */

        case 1:
          if (!
#line 25349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1746; /* *fistsi2_floor_1 */

        case 2:
          if (!
#line 25349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1748; /* *fistdi2_floor_1 */

        default:
          return -1;
        }

    case 79:
      switch (pattern545 (x1))
        {
        case 0:
          if (!
#line 25349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1745; /* *fisthi2_ceil_1 */

        case 1:
          if (!
#line 25349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1747; /* *fistsi2_ceil_1 */

        case 2:
          if (!
#line 25349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1749; /* *fistdi2_ceil_1 */

        default:
          return -1;
        }

    case 18:
      if (pattern546 (x1) != 0)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !const0_operand (operands[1], E_SImode)
              || !
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode))
            return -1;
          return 1861; /* probe_stack_1_si */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !const0_operand (operands[1], E_DImode)
              || !
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode))
            return -1;
          return 1862; /* probe_stack_1_di */

        default:
          return -1;
        }

    case 92:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      if (pnum_clobbers != NULL)
        {
          res = recog_358 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[3] = x5;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern1217 (x3, 
E_SImode))
            {
            case 0:
              if (general_operand (operands[2], E_SImode)
                  && (
#line 27475 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                return 1871; /* *stack_protect_set_2_si_si */
              if (address_no_seg_operand (operands[2], E_SImode)
                  && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == SImode))
                return 1875; /* *stack_protect_set_3_si_si */
              break;

            case 1:
              if (general_operand (operands[2], E_DImode)
                  && (
#line 27494 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                return 1873; /* *stack_protect_set_2_si_di */
              if (address_no_seg_operand (operands[2], E_DImode)
                  && ((
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1876; /* *stack_protect_set_3_si_di */
              break;

            default:
              break;
            }
          break;

        case E_DImode:
          switch (pattern1217 (x3, 
E_DImode))
            {
            case 0:
              if (general_operand (operands[2], E_SImode)
                  && (
#line 27475 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                return 1872; /* *stack_protect_set_2_di_si */
              if (address_no_seg_operand (operands[2], E_SImode)
                  && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == DImode))
                return 1877; /* *stack_protect_set_3_di_si */
              break;

            case 1:
              if (general_operand (operands[2], E_DImode)
                  && (
#line 27494 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                return 1874; /* *stack_protect_set_2_di_di */
              if (address_no_seg_operand (operands[2], E_DImode)
                  && ((
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1878; /* *stack_protect_set_3_di_di */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_DImode)
          || GET_MODE (x9) != E_DImode)
        return -1;
      switch (GET_CODE (x9))
        {
        case ZERO_EXTEND:
          switch (pattern1306 (x1))
            {
            case 0:
              if (!(
#line 27588 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                return -1;
              return 1879; /* *stack_protect_set_4z_si_di */

            case 1:
              if (!(
#line 27588 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                return -1;
              return 1880; /* *stack_protect_set_4z_di_di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern1306 (x1))
            {
            case 0:
              if (!(
#line 27606 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                return -1;
              return 1881; /* *stack_protect_set_4s_si_di */

            case 1:
              if (!(
#line 27606 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                return -1;
              return 1882; /* *stack_protect_set_4s_di_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 118:
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_V4SImode)
          || !
#line 1881 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
        return -1;
      return 2558; /* movdi_to_sse */

    case 282:
      if (GET_MODE (x3) != E_BLKmode
          || pattern340 (x1) != 0)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      return 10905; /* mfence_nosse */

    case 287:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!memory_operand (operands[2], E_DImode)
          || !
#line 196 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(!TARGET_64BIT && (TARGET_80387 || TARGET_SSE)))
        return -1;
      *pnum_clobbers = 1;
      return 10906; /* atomic_loaddi_fpu */

    case 288:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!memory_operand (operands[2], E_DImode)
          || !
#line 295 "../../gcc-15.1.1-20250425/gcc/config/i386/sync.md"
(!TARGET_64BIT && (TARGET_80387 || TARGET_SSE)))
        return -1;
      *pnum_clobbers = 1;
      return 10911; /* atomic_storedi_fpu */

    default:
      return -1;
    }
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      res = recog_372 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != SUBREG
          || pattern555 (x4) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern567 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      switch (pattern1606 (x2))
        {
        case 0:
          if (
#line 6995 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 303; /* *addqi_exthi_1_slp */
          break;

        case 1:
          if (
#line 6995 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 304; /* *addqi_extsi_1_slp */
          break;

        case 2:
          if ((
#line 6995 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 305; /* *addqi_extdi_1_slp */
          break;

        case 3:
          return 327; /* *addqi_exthi_0 */

        case 4:
          return 328; /* *addqi_extsi_0 */

        case 5:
          if (
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return 329; /* *addqi_extdi_0 */
          break;

        default:
          break;
        }
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != SUBREG)
        return -1;
      switch (pattern1607 (x2))
        {
        case 0:
          if (!
#line 7028 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 306; /* *addqi_exthi_2_slp */

        case 1:
          if (!
#line 7028 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 307; /* *addqi_extsi_2_slp */

        case 2:
          if (!(
#line 7028 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 308; /* *addqi_extdi_2_slp */

        case 3:
          return 330; /* *addqi_ext2hi_0 */

        case 4:
          return 331; /* *addqi_ext2si_0 */

        case 5:
          if (!
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 332; /* *addqi_ext2di_0 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern353 (x5) != 0)
        return -1;
      switch (pattern929 (x2))
        {
        case 0:
          if (!(
#line 6511 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 268; /* *adddi3_doubleword_zext */

        case 1:
          if (!(
#line 6511 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 269; /* *addti3_doubleword_zext */

        default:
          return -1;
        }

    case PLUS:
      if (pattern340 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFT:
          switch (pattern1142 (x3))
            {
            case 0:
              if (!(
#line 6542 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 270; /* *adddi3_doubleword_concat */

            case 1:
              if (!(
#line 6542 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 273; /* *addti3_doubleword_concat */

            case 2:
              if (!(
#line 6573 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 276; /* *adddi3_doubleword_concat_zext */

            case 3:
              if (!(
#line 6573 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 279; /* *addti3_doubleword_concat_zext */

            default:
              return -1;
            }

        case LTU:
        case UNLT:
          operands[4] = x6;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1608 (x3, 
E_QImode) != 0
                  || !
#line 8793 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 453; /* addqi3_carry */

            case E_HImode:
              if (pattern1608 (x3, 
E_HImode) != 0
                  || !
#line 8793 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 454; /* addhi3_carry */

            case E_SImode:
              if (pattern1609 (x3, 
E_SImode) != 0
                  || !
#line 8793 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 455; /* addsi3_carry */

            case E_DImode:
              if (pattern1609 (x3, 
E_DImode) != 0
                  || !(
#line 8793 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 456; /* adddi3_carry */

            default:
              return -1;
            }

        case EQ:
          switch (pattern1145 (x3))
            {
            case 0:
              if (!
#line 10136 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 554; /* *addqi3_eq */

            case 1:
              if (!
#line 10136 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 555; /* *addhi3_eq */

            case 2:
              if (!
#line 10136 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 556; /* *addsi3_eq */

            case 3:
              if (!(
#line 10136 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 557; /* *adddi3_eq */

            default:
              return -1;
            }

        case NE:
          switch (pattern1148 (x3))
            {
            case 0:
              if (!
#line 10157 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 558; /* *addqi3_ne */

            case 1:
              if (!
#line 10157 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 559; /* *addhi3_ne */

            case 2:
              if (!
#line 10157 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 560; /* *addsi3_ne */

            case 3:
              if (!(
#line 10157 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 561; /* *adddi3_ne */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern357 (x1))
        {
        case 0:
          if (!(
#line 6542 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 271; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6542 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 274; /* *addti3_doubleword_concat */

        case 2:
          if (!(
#line 6573 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 277; /* *adddi3_doubleword_concat_zext */

        case 3:
          if (!(
#line 6573 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 280; /* *addti3_doubleword_concat_zext */

        default:
          return -1;
        }

    case XOR:
      switch (pattern357 (x1))
        {
        case 0:
          if (!(
#line 6542 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 272; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6542 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 275; /* *addti3_doubleword_concat */

        case 2:
          if (!(
#line 6573 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 278; /* *adddi3_doubleword_concat_zext */

        case 3:
          if (!(
#line 6573 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 281; /* *addti3_doubleword_concat_zext */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern358 (x1))
        {
        case 0:
          if (pattern1506 (x3, 
E_QImode) != 0
              || !
#line 8865 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 457; /* *addqi3_carry_0 */

        case 1:
          if (pattern1506 (x3, 
E_HImode) != 0
              || !
#line 8865 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 458; /* *addhi3_carry_0 */

        case 2:
          if (pattern1506 (x3, 
E_SImode) != 0
              || !
#line 8865 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 459; /* *addsi3_carry_0 */

        case 3:
          if (pattern1506 (x3, 
E_DImode) != 0
              || !(
#line 8865 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 460; /* *adddi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern358 (x1))
        {
        case 0:
          if (pattern1507 (x3, 
E_QImode) != 0
              || !
#line 8879 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 461; /* *addqi3_carry_0r */

        case 1:
          if (pattern1507 (x3, 
E_HImode) != 0
              || !
#line 8879 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 462; /* *addhi3_carry_0r */

        case 2:
          if (pattern1507 (x3, 
E_SImode) != 0
              || !
#line 8879 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 463; /* *addsi3_carry_0r */

        case 3:
          if (pattern1507 (x3, 
E_DImode) != 0
              || !(
#line 8879 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 464; /* *adddi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern362 (x1))
        {
        case 0:
          if (!
#line 10183 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 562; /* *addqi3_eq_0 */

        case 1:
          if (!
#line 10183 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 563; /* *addhi3_eq_0 */

        case 2:
          if (!
#line 10183 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 564; /* *addsi3_eq_0 */

        case 3:
          if (!(
#line 10183 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 565; /* *adddi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern362 (x1))
        {
        case 0:
          if (!
#line 10204 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 566; /* *addqi3_ne_0 */

        case 1:
          if (!
#line 10204 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 567; /* *addhi3_ne_0 */

        case 2:
          if (!
#line 10204 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 568; /* *addsi3_ne_0 */

        case 3:
          if (!(
#line 10204 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 569; /* *adddi3_ne_0 */

        default:
          return -1;
        }

    case MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern353 (x5) != 0)
        return -1;
      switch (pattern933 (x2))
        {
        case 0:
          if (!
#line 10252 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 574; /* *subqi3_ne */

        case 1:
          if (!
#line 10252 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 575; /* *subhi3_ne */

        case 2:
          if (!
#line 10252 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 576; /* *subsi3_ne */

        case 3:
          if (!(
#line 10252 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 577; /* *subdi3_ne */

        case 4:
          if (!
#line 10281 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 578; /* *subqi3_eq_1 */

        case 5:
          if (!
#line 10281 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 579; /* *subhi3_eq_1 */

        case 6:
          if (!
#line 10281 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
            return -1;
          return 580; /* *subsi3_eq_1 */

        case 7:
          if (!(
#line 10281 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 581; /* *subdi3_eq_1 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x10 = XEXP (x4, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != ASHIFT)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != LTU)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 17
          || GET_MODE (x12) != E_CCCmode)
        return -1;
      x13 = XEXP (x11, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x8, 1);
      if (GET_CODE (x14) != CONST_INT
          || pattern347 (x1) != 0)
        return -1;
      switch (XWINT (x14, 0))
        {
        case 31LL:
          if (pattern1658 (x3, 
E_SImode) != 0)
            return -1;
          return 1385; /* rcrsi2 */

        case 63LL:
          if (pattern1658 (x3, 
E_DImode) != 0
              || !
#line 18774 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1386; /* rcrdi2 */

        default:
          return -1;
        }

    case UNSPEC:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern353 (x5) != 0)
        return -1;
      switch (pattern937 (x2))
        {
        case 0:
          if (!
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == SImode))
            return -1;
          return 1661; /* *add_tp_si */

        case 1:
          if (!
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == DImode))
            return -1;
          return 1662; /* *add_tp_di */

        case 2:
          if (!
#line 23326 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
            return -1;
          return 1666; /* *tls_dynamic_gnu2_combine_32 */

        case 3:
          if (!(
#line 23385 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
            return -1;
          return 1671; /* *tls_dynamic_gnu2_combine_64_si */

        case 4:
          if (!(
#line 23385 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
            return -1;
          return 1672; /* *tls_dynamic_gnu2_combine_64_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_394 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern554 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17
          || GET_MODE (x3) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (GET_MODE (x5) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          if (x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 12503 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 703; /* *anddi3_doubleword */
          if (x86_64_szext_general_operand (operands[2], E_DImode)
              && 
#line 12545 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)
   && true))
            return 706; /* *anddi_1 */
          if (!const_int_operand (operands[2], E_DImode)
              || !
#line 12578 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_USE_BT
   && ix86_binary_operator_ok (AND, DImode, operands)
   && IN_RANGE (exact_log2 (~INTVAL (operands[2])), 31, 63)))
            return -1;
          return 707; /* *anddi_1_btr */

        case E_TImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern560 (x5, 
E_TImode) != 0
              || !(
#line 12503 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 704; /* *andti3_doubleword */

        case E_HImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern561 (x5, 
E_HImode) != 0
              || !
#line 12673 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, HImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 720; /* *andhi_1 */

        case E_SImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern562 (x5) != 0
              || !
#line 12673 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 722; /* *andsi_1 */

        case E_QImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern561 (x5, 
E_QImode) != 0
              || !
#line 12711 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, QImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 724; /* *andqi_1 */

        case E_V4QImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern563 (x5, 
E_V4QImode) != 0
              || !
#line 4713 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (AND, V4QImode, operands)))
            return -1;
          return 2283; /* *andv4qi3 */

        case E_V2QImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern563 (x5, 
E_V2QImode) != 0
              || !
#line 4713 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (AND, V2QImode, operands)))
            return -1;
          return 2286; /* *andv2qi3 */

        case E_V2HImode:
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 1);
          if (pattern563 (x5, 
E_V2HImode) != 0
              || !
#line 4713 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (AND, V2HImode, operands)))
            return -1;
          return 2289; /* *andv2hi3 */

        default:
          return -1;
        }

    case 1:
      switch (pattern565 (x1))
        {
        case 0:
          if (!
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2572; /* kandqi */

        case 1:
          if (!
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2575; /* kandhi */

        case 2:
          if (!(
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2578; /* kandsi */

        case 3:
          if (!(
#line 2097 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2581; /* kanddi */

        default:
          return -1;
        }

    case 2:
      if (!
#line 12743 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      return 725; /* *andqi_1_slp */

    case 3:
      if (!
#line 12743 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      return 728; /* *andhi_1_slp */

    default:
      return -1;
    }
}

 int
recog_399 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern377 (x1))
        {
        case 0:
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 17
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 14239 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 952; /* *negdi2_doubleword */
              if (!(
#line 14348 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 961; /* *negdi_1 */

            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x3) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !(
#line 14239 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 953; /* *negti2_doubleword */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 14348 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, QImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              return 955; /* *negqi_1 */

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 14348 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, HImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              return 957; /* *neghi_1 */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 14348 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              return 959; /* *negsi_1 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !
#line 14812 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
                return -1;
              return 1011; /* *negsf2_i387_1 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 14812 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              return 1013; /* *negdf2_i387_1 */

            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || GET_MODE (x3) != E_XFmode
                  || !register_operand (operands[1], E_XFmode)
                  || !
#line 14812 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)))
                return -1;
              return 1015; /* *negxf2_i387_1 */

            case E_V2QImode:
              if (!register_operand (operands[0], E_V2QImode)
                  || GET_MODE (x3) != E_V2QImode
                  || !register_operand (operands[1], E_V2QImode)
                  || !
#line 3134 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
                return -1;
              return 2123; /* negv2qi2 */

            default:
              return -1;
            }

        case 1:
          switch (pattern694 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 14750 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SSE))
                return -1;
              return 1008; /* *negtf2_1 */

            case 1:
              if (!
#line 14836 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return -1;
              *pnum_clobbers = 1;
              return 1017; /* *neghf2_1 */

            case 2:
              if (!
#line 14852 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
                return -1;
              *pnum_clobbers = 1;
              return 1019; /* *negsf2_1 */

            case 3:
              if (!
#line 14852 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              *pnum_clobbers = 1;
              return 1021; /* *negdf2_1 */

            case 4:
              if (!
#line 683 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                return -1;
              return 2050; /* *mmx_negv2sf2 */

            case 5:
              if (!
#line 2239 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 2096; /* *mmx_negv2bf */

            case 6:
              if (!(
#line 2239 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2224 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
                return -1;
              return 2098; /* *mmx_negv4bf */

            case 7:
              if (!
#line 2239 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 2100; /* *mmx_negv2hf */

            case 8:
              if (!(
#line 2239 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
                return -1;
              return 2102; /* *mmx_negv4hf */

            case 9:
              if (!(
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 411 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2654; /* *negv32bf2 */

            case 10:
              if (!(
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2656; /* *negv16bf2 */

            case 11:
              if (!(
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2658; /* *negv8bf2 */

            case 12:
              if (!(
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 413 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2660; /* *negv32hf2 */

            case 13:
              if (!(
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 414 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2662; /* *negv16hf2 */

            case 14:
              if (!(
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 414 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2664; /* *negv8hf2 */

            case 15:
              if (!(
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2666; /* *negv16sf2 */

            case 16:
              if (!(
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2668; /* *negv8sf2 */

            case 17:
              if (!
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 2670; /* *negv4sf2 */

            case 18:
              if (!(
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 416 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2672; /* *negv8df2 */

            case 19:
              if (!(
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 417 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2674; /* *negv4df2 */

            case 20:
              if (!(
#line 2589 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 417 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2676; /* *negv2df2 */

            default:
              return -1;
            }

        case 2:
          if (!
#line 14397 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 973; /* *negqi_1_slp */

        case 3:
          if (!
#line 14397 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 974; /* *neghi_1_slp */

        default:
          return -1;
        }

    case ABS:
      switch (pattern379 (x1))
        {
        case 0:
          if ((
#line 14646 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 997; /* *nabsdi2_doubleword */
          if (!(
#line 14717 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1006; /* *nabsdi2_1 */

        case 1:
          if (!(
#line 14646 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 998; /* *nabsti2_doubleword */

        case 2:
          if (!
#line 14717 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          return 1003; /* *nabsqi2_1 */

        case 3:
          if (!
#line 14717 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          return 1004; /* *nabshi2_1 */

        case 4:
          if (!
#line 14717 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          return 1005; /* *nabssi2_1 */

        case 5:
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern1043 (x3, 
E_TFmode) != 0
                  || !
#line 14775 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SSE))
                return -1;
              return 1009; /* *nabstf2_1 */

            case E_SFmode:
              if (pattern1044 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 14911 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
                return -1;
              return 1022; /* *nabssf2_1 */

            case E_DFmode:
              if (pattern1044 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 14911 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
                return -1;
              return 1023; /* *nabsdf2_1 */

            case E_V2SFmode:
              if (pattern1045 (x3) != 0
                  || !
#line 700 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                return -1;
              return 2051; /* *mmx_nabsv2sf2 */

            case E_V2BFmode:
              if (pattern1046 (x3, 
E_V2BFmode) != 0
                  || !
#line 2256 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 2103; /* *mmx_nabsv2bf2 */

            case E_V4BFmode:
              if (pattern1046 (x3, 
E_V4BFmode) != 0
                  || !(
#line 2256 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2224 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
                return -1;
              return 2104; /* *mmx_nabsv4bf2 */

            case E_V2HFmode:
              if (pattern1046 (x3, 
E_V2HFmode) != 0
                  || !
#line 2256 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 2105; /* *mmx_nabsv2hf2 */

            case E_V4HFmode:
              if (pattern1046 (x3, 
E_V4HFmode) != 0
                  || !(
#line 2256 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2225 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
                return -1;
              return 2106; /* *mmx_nabsv4hf2 */

            case E_V16SFmode:
              if (pattern1043 (x3, 
E_V16SFmode) != 0
                  || !(
#line 2614 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 374 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2677; /* *nabsv16sf2 */

            case E_V8SFmode:
              if (pattern1043 (x3, 
E_V8SFmode) != 0
                  || !(
#line 2614 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 374 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2678; /* *nabsv8sf2 */

            case E_V4SFmode:
              if (pattern1043 (x3, 
E_V4SFmode) != 0
                  || !
#line 2614 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 2679; /* *nabsv4sf2 */

            case E_V8DFmode:
              if (pattern1043 (x3, 
E_V8DFmode) != 0
                  || !(
#line 2614 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 375 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2680; /* *nabsv8df2 */

            case E_V4DFmode:
              if (pattern1043 (x3, 
E_V4DFmode) != 0
                  || !(
#line 2614 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 375 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2681; /* *nabsv4df2 */

            case E_V2DFmode:
              if (pattern1043 (x3, 
E_V2DFmode) != 0
                  || !(
#line 2614 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 376 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2682; /* *nabsv2df2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      operands[1] = x4;
      if (pattern568 (operands[1]) != 0
          || pattern340 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode)
            return -1;
          return 1799; /* *x86_movqicc_0_m1_neg */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode)
            return -1;
          return 1800; /* *x86_movhicc_0_m1_neg */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          return 1801; /* *x86_movsicc_0_m1_neg */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1802; /* *x86_movdicc_0_m1_neg */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_416 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (register_operand (operands[0], E_V64QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V64QImode)
          && register_operand (operands[2], E_V64QImode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 282 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2422; /* *vmovv64qi_constm1_pternlog_false_dep */
      break;

    case E_V32QImode:
      if (register_operand (operands[0], E_V32QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V32QImode)
          && register_operand (operands[2], E_V32QImode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 282 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2423; /* *vmovv32qi_constm1_pternlog_false_dep */
      break;

    case E_V16QImode:
      if (register_operand (operands[0], E_V16QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16QImode)
          && register_operand (operands[2], E_V16QImode)
          && 
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2424; /* *vmovv16qi_constm1_pternlog_false_dep */
      break;

    case E_V32HImode:
      if (register_operand (operands[0], E_V32HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V32HImode)
          && register_operand (operands[2], E_V32HImode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2425; /* *vmovv32hi_constm1_pternlog_false_dep */
      break;

    case E_V16HImode:
      if (register_operand (operands[0], E_V16HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16HImode)
          && register_operand (operands[2], E_V16HImode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2426; /* *vmovv16hi_constm1_pternlog_false_dep */
      break;

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8HImode)
          && register_operand (operands[2], E_V8HImode)
          && 
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2427; /* *vmovv8hi_constm1_pternlog_false_dep */
      break;

    case E_V16SImode:
      if (register_operand (operands[0], E_V16SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16SImode)
          && register_operand (operands[2], E_V16SImode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 284 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2428; /* *vmovv16si_constm1_pternlog_false_dep */
      break;

    case E_V8SImode:
      if (register_operand (operands[0], E_V8SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8SImode)
          && register_operand (operands[2], E_V8SImode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 284 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2429; /* *vmovv8si_constm1_pternlog_false_dep */
      break;

    case E_V4SImode:
      if (register_operand (operands[0], E_V4SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4SImode)
          && register_operand (operands[2], E_V4SImode)
          && 
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2430; /* *vmovv4si_constm1_pternlog_false_dep */
      break;

    case E_V8DImode:
      if (register_operand (operands[0], E_V8DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8DImode)
          && register_operand (operands[2], E_V8DImode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2431; /* *vmovv8di_constm1_pternlog_false_dep */
      break;

    case E_V4DImode:
      if (register_operand (operands[0], E_V4DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4DImode)
          && register_operand (operands[2], E_V4DImode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2432; /* *vmovv4di_constm1_pternlog_false_dep */
      break;

    case E_V2DImode:
      if (register_operand (operands[0], E_V2DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V2DImode)
          && register_operand (operands[2], E_V2DImode)
          && 
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2433; /* *vmovv2di_constm1_pternlog_false_dep */
      break;

    case E_V4TImode:
      if (register_operand (operands[0], E_V4TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4TImode)
          && register_operand (operands[2], E_V4TImode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 286 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2434; /* *vmovv4ti_constm1_pternlog_false_dep */
      break;

    case E_V2TImode:
      if (register_operand (operands[0], E_V2TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V2TImode)
          && register_operand (operands[2], E_V2TImode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 286 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2435; /* *vmovv2ti_constm1_pternlog_false_dep */
      break;

    case E_V1TImode:
      if (register_operand (operands[0], E_V1TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V1TImode)
          && register_operand (operands[2], E_V1TImode)
          && 
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2436; /* *vmovv1ti_constm1_pternlog_false_dep */
      break;

    case E_V32HFmode:
      if (register_operand (operands[0], E_V32HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V32HFmode)
          && register_operand (operands[2], E_V32HFmode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 287 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2437; /* *vmovv32hf_constm1_pternlog_false_dep */
      break;

    case E_V16HFmode:
      if (register_operand (operands[0], E_V16HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16HFmode)
          && register_operand (operands[2], E_V16HFmode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 287 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2438; /* *vmovv16hf_constm1_pternlog_false_dep */
      break;

    case E_V8HFmode:
      if (register_operand (operands[0], E_V8HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8HFmode)
          && register_operand (operands[2], E_V8HFmode)
          && 
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2439; /* *vmovv8hf_constm1_pternlog_false_dep */
      break;

    case E_V32BFmode:
      if (register_operand (operands[0], E_V32BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V32BFmode)
          && register_operand (operands[2], E_V32BFmode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 288 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2440; /* *vmovv32bf_constm1_pternlog_false_dep */
      break;

    case E_V16BFmode:
      if (register_operand (operands[0], E_V16BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16BFmode)
          && register_operand (operands[2], E_V16BFmode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 288 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2441; /* *vmovv16bf_constm1_pternlog_false_dep */
      break;

    case E_V8BFmode:
      if (register_operand (operands[0], E_V8BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8BFmode)
          && register_operand (operands[2], E_V8BFmode)
          && 
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2442; /* *vmovv8bf_constm1_pternlog_false_dep */
      break;

    case E_V16SFmode:
      if (register_operand (operands[0], E_V16SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16SFmode)
          && register_operand (operands[2], E_V16SFmode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 289 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2443; /* *vmovv16sf_constm1_pternlog_false_dep */
      break;

    case E_V8SFmode:
      if (register_operand (operands[0], E_V8SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8SFmode)
          && register_operand (operands[2], E_V8SFmode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 289 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2444; /* *vmovv8sf_constm1_pternlog_false_dep */
      break;

    case E_V4SFmode:
      if (register_operand (operands[0], E_V4SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V4SFmode)
          && register_operand (operands[2], E_V4SFmode)
          && 
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2445; /* *vmovv4sf_constm1_pternlog_false_dep */
      break;

    case E_V8DFmode:
      if (register_operand (operands[0], E_V8DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8DFmode)
          && register_operand (operands[2], E_V8DFmode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 290 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2446; /* *vmovv8df_constm1_pternlog_false_dep */
      break;

    case E_V4DFmode:
      if (register_operand (operands[0], E_V4DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V4DFmode)
          && register_operand (operands[2], E_V4DFmode)
          && (
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 290 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2447; /* *vmovv4df_constm1_pternlog_false_dep */
      break;

    case E_V2DFmode:
      if (register_operand (operands[0], E_V2DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V2DFmode)
          && register_operand (operands[2], E_V2DFmode)
          && 
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 2448; /* *vmovv2df_constm1_pternlog_false_dep */
      break;

    default:
      break;
    }
  switch (GET_CODE (x4))
    {
    case VEC_MERGE:
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      x9 = XEXP (x4, 2);
      operands[1] = x9;
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1321 (x4, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 10347 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5135; /* *avx512f_cvtmask2dv16si_pternlog_false_dep */

        case E_V8SImode:
          if (pattern1321 (x4, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 10347 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5136; /* *avx512vl_cvtmask2dv8si_pternlog_false_dep */

        case E_V4SImode:
          if (pattern1321 (x4, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 10347 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5137; /* *avx512vl_cvtmask2dv4si_pternlog_false_dep */

        case E_V8DImode:
          if (pattern1321 (x4, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 10347 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5138; /* *avx512f_cvtmask2qv8di_pternlog_false_dep */

        case E_V4DImode:
          if (pattern1321 (x4, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 10347 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5139; /* *avx512vl_cvtmask2qv4di_pternlog_false_dep */

        case E_V2DImode:
          if (pattern1321 (x4, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 10347 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5140; /* *avx512vl_cvtmask2qv2di_pternlog_false_dep */

        default:
          return -1;
        }

    case XOR:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1231 (x4, 
E_V16SImode) != 0
              || !(
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 568 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7901; /* *one_cmplv16si2_pternlog_false_dep */

        case E_V8DImode:
          if (pattern1231 (x4, 
E_V8DImode) != 0
              || !(
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7902; /* *one_cmplv8di2_pternlog_false_dep */

        case E_V64QImode:
          if (pattern1231 (x4, 
E_V64QImode) != 0
              || !(
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7903; /* *one_cmplv64qi2_pternlog_false_dep */

        case E_V32QImode:
          if (pattern1231 (x4, 
E_V32QImode) != 0
              || !(
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7904; /* *one_cmplv32qi2_pternlog_false_dep */

        case E_V16QImode:
          if (pattern1231 (x4, 
E_V16QImode) != 0
              || !
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7905; /* *one_cmplv16qi2_pternlog_false_dep */

        case E_V32HImode:
          if (pattern1231 (x4, 
E_V32HImode) != 0
              || !(
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7906; /* *one_cmplv32hi2_pternlog_false_dep */

        case E_V16HImode:
          if (pattern1231 (x4, 
E_V16HImode) != 0
              || !(
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7907; /* *one_cmplv16hi2_pternlog_false_dep */

        case E_V8HImode:
          if (pattern1231 (x4, 
E_V8HImode) != 0
              || !
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7908; /* *one_cmplv8hi2_pternlog_false_dep */

        case E_V8SImode:
          if (pattern1231 (x4, 
E_V8SImode) != 0
              || !(
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7909; /* *one_cmplv8si2_pternlog_false_dep */

        case E_V4SImode:
          if (pattern1231 (x4, 
E_V4SImode) != 0
              || !
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7910; /* *one_cmplv4si2_pternlog_false_dep */

        case E_V4DImode:
          if (pattern1231 (x4, 
E_V4DImode) != 0
              || !(
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7911; /* *one_cmplv4di2_pternlog_false_dep */

        case E_V2DImode:
          if (pattern1231 (x4, 
E_V2DImode) != 0
              || !
#line 18412 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7912; /* *one_cmplv2di2_pternlog_false_dep */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      switch (pattern70 (x3))
        {
        case 0:
          if (!(
#line 3704 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == -1
   && CONST_WIDE_INT_ELT (operands[3], 1) == 0) && 
#line 3710 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_22 (insn, operands);

        case 1:
          if (!(
#line 3726 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == 0
   && CONST_WIDE_INT_ELT (operands[3], 1) == -1) && 
#line 3732 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_25 (insn, operands);

        case 2:
          if (!(
#line 3748 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll) && 
#line 3752 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_28 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern823 (x3, 
E_QImode) != 0
              || !
#line 7095 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_129 (insn, operands);

        case E_HImode:
          if (pattern823 (x3, 
E_HImode) != 0
              || !
#line 7095 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_130 (insn, operands);

        case E_SImode:
          if (pattern824 (x3, 
E_SImode) != 0
              || !
#line 7095 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_131 (insn, operands);

        case E_DImode:
          if (pattern824 (x3, 
E_DImode) != 0
              || !(
#line 7095 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed
   && ix86_lea_for_add_ok (insn, operands)) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_132 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern428 (x3))
            {
            case 0:
              if (!(
#line 7898 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7900 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_150 (insn, operands);

            case 1:
              if (!(
#line 7898 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7900 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_151 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          switch (pattern431 (x3))
            {
            case 0:
              if (!(
#line 7964 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7966 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_156 (insn, operands);

            case 1:
              if (!(
#line 7964 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7966 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_157 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern573 (x3))
            {
            case 0:
              if (!(
#line 7990 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7992 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_158 (insn, operands);

            case 1:
              if (!(
#line 7990 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7992 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_159 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      switch (pattern399 (x3))
        {
        case 0:
          if (!(
#line 7920 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7922 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_152 (insn, operands);

        case 1:
          if (!(
#line 7920 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7922 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_153 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[3] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern1067 (x3, 
E_QImode) != 0
                      || !(
#line 7941 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7943 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_154 (insn, operands);

                case E_HImode:
                  if (pattern1067 (x3, 
E_HImode) != 0
                      || !(
#line 7941 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7943 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_155 (insn, operands);

                case E_DImode:
                  if (pattern601 (x3, 
E_DImode) != 0
                      || !((
#line 14139 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14153 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_466 (insn, operands);

                case E_TImode:
                  if (pattern601 (x3, 
E_TImode) != 0
                      || !((
#line 14139 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14153 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_469 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              switch (pattern944 (x3))
                {
                case 0:
                  if (!((
#line 14062 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14064 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_430 (insn, operands);

                case 1:
                  if (!((
#line 14062 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14064 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_433 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_442 (insn, operands);

            case 1:
              if (!((
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14100 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_448 (insn, operands);

            case 2:
              if (!((
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_472 (insn, operands);

            case 3:
              if (!((
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_478 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_445 (insn, operands);

            case 1:
              if (!((
#line 14098 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14100 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_451 (insn, operands);

            case 2:
              if (!((
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_475 (insn, operands);

            case 3:
              if (!((
#line 14171 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_481 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern404 (x3))
        {
        case 0:
          if (!((
#line 14079 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14081 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_436 (insn, operands);

        case 1:
          if (!((
#line 14079 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14081 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_439 (insn, operands);

        case 2:
          if (!((
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_454 (insn, operands);

        case 3:
          if (!((
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_460 (insn, operands);

        case 4:
          if (!((
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_457 (insn, operands);

        case 5:
          if (!((
#line 14123 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14125 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_463 (insn, operands);

        case 6:
          if (!((
#line 14200 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14211 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_484 (insn, operands);

        case 7:
          if (!((
#line 14200 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14211 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_487 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_21 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern231 (x2, 
E_CCmode, 
17) != 0)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x5;
      switch (pattern1164 (x3))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && GET_MODE (x4) == E_DImode
                  && nonimmediate_operand (operands[1], E_DImode))
                {
                  if (x86_64_hilo_general_operand (operands[2], E_DImode)
                      && ((
#line 12503 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 12505 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_283 (insn, operands);
                  if (const_int_operand (operands[2], E_DImode)
                      && (
#line 12578 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_USE_BT
   && ix86_binary_operator_ok (AND, DImode, operands)
   && IN_RANGE (exact_log2 (~INTVAL (operands[2])), 31, 63)) && 
#line 12582 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_285 (insn, operands);
                }
              break;

            case E_TImode:
              if (pattern560 (x4, 
E_TImode) == 0
                  && ((
#line 12503 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12505 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                return gen_split_284 (insn, operands);
              break;

            case E_HImode:
              if (pattern1337 (x4, 
E_HImode) == 0
                  && 
#line 12827 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && (!REG_P (operands[1])
       || REGNO (operands[0]) != REGNO (operands[1]))
   && (UINTVAL (operands[2]) == GET_MODE_MASK (SImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (HImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (QImode))))
                return gen_split_311 (insn, operands);
              break;

            case E_SImode:
              if (pattern1337 (x4, 
E_SImode) == 0
                  && 
#line 12827 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && (!REG_P (operands[1])
       || REGNO (operands[0]) != REGNO (operands[1]))
   && (UINTVAL (operands[2]) == GET_MODE_MASK (SImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (HImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (QImode))))
                return gen_split_312 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case 1:
          if ((
#line 12743 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12747 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return gen_split_287 (insn, operands);
          break;

        case 2:
          if ((
#line 12743 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12747 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return gen_split_290 (insn, operands);
          break;

        default:
          break;
        }
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) == CONST_INT)
        {
          res = split_17 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      if (GET_CODE (x5) == SUBREG
          && known_eq (SUBREG_BYTE (x5), 0))
        {
          res = split_18 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      if (GET_CODE (x6) != CONST_INT)
        return NULL;
      operands[2] = x6;
      if (const_int_operand (operands[2], E_DImode))
        {
          x7 = XEXP (x3, 0);
          operands[0] = x7;
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x4) == E_DImode)
            {
              operands[1] = x5;
              if (nonimmediate_operand (operands[1], E_DImode)
                  && (
#line 12827 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && (!REG_P (operands[1])
       || REGNO (operands[0]) != REGNO (operands[1]))
   && (UINTVAL (operands[2]) == GET_MODE_MASK (SImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (HImode)
       || UINTVAL (operands[2]) == GET_MODE_MASK (QImode))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_313 (insn, operands);
            }
        }
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (GET_MODE (x4) != E_DImode)
        return NULL;
      if (rtx_equal_p (x5, operands[0]))
        {
          switch (XWINT (x6, 0))
            {
            case -65536LL:
              if (register_operand (operands[0], E_DImode)
                  && (
#line 12862 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_FAST_PREFIX && !TARGET_PARTIAL_REG_STALL)
    || optimize_function_for_size_p (cfun)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_315 (insn, operands);
              break;

            case -256LL:
              if (any_QIreg_operand (operands[0], E_DImode)
                  && (
#line 12872 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_318 (insn, operands);
              break;

            case -65281LL:
              if (QIreg_operand (operands[0], E_DImode)
                  && (
#line 12882 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_321 (insn, operands);
              break;

            default:
              break;
            }
        }
      operands[1] = x5;
      if (register_operand (operands[1], E_DImode)
          && QIreg_operand (operands[0], E_DImode))
        {
          operands[2] = x6;
          if (const_int_operand (operands[2], E_DImode)
              && (
#line 13263 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return gen_split_369 (insn, operands);
        }
      if (general_operand (operands[1], E_DImode)
          && any_QIreg_operand (operands[0], E_DImode))
        {
          operands[2] = x6;
          if (const_int_operand (operands[2], E_DImode)
              && (
#line 13292 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~255)
    && !(INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return gen_split_372 (insn, operands);
        }
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_DImode
          || XWINT (x6, 0) != 63LL
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x8 = XEXP (x5, 0);
      if (GET_MODE (x8) != E_SImode)
        return NULL;
      switch (GET_CODE (x8))
        {
        case CTZ:
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !(
#line 21138 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI && TARGET_64BIT) && 
#line 21140 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( (TARGET_AVOID_FALSE_DEP_FOR_BMI || TARGET_AVOID_FALSE_DEP_FOR_TZCNT)
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_875 (insn, operands);

        case CLZ:
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !(
#line 21577 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_LZCNT && TARGET_64BIT) && 
#line 21579 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_888 (insn, operands);

        case POPCOUNT:
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !(
#line 22402 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT) && 
#line 22410 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_912 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern1418 (x4, 
E_DImode) == 0)
                {
                  if (((
#line 13314 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 13316 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_373 (insn, operands);
                  if (((
#line 13332 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 13335 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_375 (insn, operands);
                }
              break;

            case E_TImode:
              if (pattern1418 (x4, 
E_TImode) == 0)
                {
                  if (((
#line 13314 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13316 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_374 (insn, operands);
                  if (((
#line 13332 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13335 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_376 (insn, operands);
                }
              break;

            case E_SImode:
              if (pattern1418 (x4, 
E_SImode) == 0
                  && 
#line 13400 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(reload_completed
   && optimize_insn_for_size_p () && optimize_size > 1
   && REGNO (operands[0]) == REGNO (operands[1])
   && LEGACY_INT_REG_P (operands[0])
   && !REX_INT_REG_P (operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                return gen_split_377 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x8) != SUBREG
              || maybe_ne (SUBREG_BYTE (x8), 0)
              || GET_MODE (x8) != E_QImode)
            return NULL;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != LSHIFTRT
              || x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          switch (pattern1508 (x4))
            {
            case 0:
              if (!(
#line 19364 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 19366 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_838 (insn, operands);

            case 1:
              if (!((
#line 19364 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19366 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_839 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          switch (pattern1227 (x4))
            {
            case 0:
              if (!(
#line 19382 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 19384 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_840 (insn, operands);

            case 1:
              if (!((
#line 19382 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19384 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_841 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ROTATE:
      switch (pattern1051 (x3, 
-2))
        {
        case 0:
          if (!(
#line 18912 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18917 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_804 (insn, operands);

        case 1:
          if (!((
#line 18912 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18917 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_805 (insn, operands);

        case 2:
          if (!(
#line 18940 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18945 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_806 (insn, operands);

        case 3:
          if (!((
#line 18940 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18945 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_807 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      switch (pattern941 (x3))
        {
        case 0:
          if (!(
#line 21781 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 21783 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_898 (insn, operands);

        case 1:
          if (!((
#line 21781 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21783 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_899 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x10 = XEXP (x5, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return NULL;
      switch (pattern941 (x3))
        {
        case 0:
          if (!(
#line 21926 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 21928 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_904 (insn, operands);

        case 1:
          if (!((
#line 21926 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21928 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_905 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern204 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) == SUBREG)
        {
          switch (pattern1319 (x4))
            {
            case 0:
              if (((
#line 16584 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16589 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                return gen_split_590 (insn, operands);
              break;

            case 1:
              if (((
#line 16584 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16589 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                return gen_split_592 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (GET_MODE (x4) == E_SImode
          && nonimmediate_operand (operands[1], E_SImode))
        {
          if (register_operand (operands[0], E_SImode))
            {
              operands[2] = x5;
              if (register_operand (operands[2], E_QImode)
                  && 
#line 17437 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                return gen_split_623 (insn, operands);
            }
          if (GET_CODE (x5) == SUBREG)
            {
              switch (pattern1488 (x5))
                {
                case 0:
                  if ((
#line 17842 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17847 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_640 (insn, operands);
                  break;

                case 1:
                  if ((
#line 17890 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17894 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_652 (insn, operands);
                  break;

                case 2:
                  if ((
#line 17936 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17940 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_664 (insn, operands);
                  break;

                default:
                  break;
                }
            }
        }
      operands[2] = x5;
      switch (pattern1235 (x2))
        {
        case 0:
          if (register_operand (operands[1], E_DImode)
              && nonmemory_operand (operands[2], E_QImode)
              && (
#line 16696 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(epilogue_completed) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return gen_split_598 (insn, operands);
          if (nonimmediate_operand (operands[1], E_DImode)
              && register_operand (operands[2], E_QImode)
              && (
#line 17437 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return gen_split_625 (insn, operands);
          break;

        case 1:
          if ((
#line 16696 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(epilogue_completed) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return gen_split_600 (insn, operands);
          break;

        case 2:
          if ((
#line 17640 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 17651 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return gen_split_629 (insn, operands);
          break;

        case 3:
          if ((
#line 17640 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 17651 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return gen_split_631 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return NULL;
      switch (pattern1154 (x2, 
E_DImode))
        {
        case 0:
          if (!((
#line 17842 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17847 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_643 (insn, operands);

        case 1:
          if (!((
#line 17890 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17894 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_655 (insn, operands);

        case 2:
          if (!((
#line 17936 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17940 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_667 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && ((
#line 16645 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16650 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return gen_split_594 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !((
#line 17867 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17872 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_649 (insn, operands);

    case 2:
      if (!((
#line 16645 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16650 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_596 (insn, operands);

    case 3:
      if (!(
#line 17867 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17872 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_646 (insn, operands);

    case 4:
      if (!(
#line 17914 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17918 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_658 (insn, operands);

    case 5:
      if (!((
#line 17914 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17918 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_661 (insn, operands);

    case 6:
      if (!(
#line 17966 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17970 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_670 (insn, operands);

    case 7:
      if (!((
#line 17966 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17970 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_673 (insn, operands);

    case 8:
      if (!((
#line 17990 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 17993 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_674 (insn, operands);

    case 9:
      if (!((
#line 17990 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17993 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_675 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_41 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      res = split_40 (x1, insn);
      if (res != NULL_RTX)
        return res;
      if (!bt_comparison_operator (x3, E_VOIDmode))
        return NULL;
      operands[3] = x3;
      x4 = XEXP (x3, 0);
      if (pattern83 (x4, 
E_CCZmode, 
130) != 0)
        return NULL;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != AND)
        return NULL;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != NOT)
        return NULL;
      x7 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x7) != AND)
        return NULL;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != NOT)
        return NULL;
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x10 = XEXP (x2, 2);
      if (GET_CODE (x10) != PC)
        return NULL;
      x11 = XEXP (x1, 0);
      if (GET_CODE (x11) != PC)
        return NULL;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      x13 = XEXP (x5, 1);
      operands[2] = x13;
      x14 = XEXP (x2, 1);
      operands[0] = x14;
      x15 = XEXP (x8, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return NULL;
      x16 = XEXP (x7, 1);
      if (!rtx_equal_p (x16, operands[2]))
        return NULL;
      switch (GET_MODE (x5))
        {
        case E_V16QImode:
          if (pattern1743 (x4, 
E_V16QImode) != 0
              || !
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3676 (insn, operands);

        case E_V8HImode:
          if (pattern1743 (x4, 
E_V8HImode) != 0
              || !
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3677 (insn, operands);

        case E_V4SImode:
          if (pattern1743 (x4, 
E_V4SImode) != 0
              || !
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3678 (insn, operands);

        case E_V2DImode:
          if (pattern1743 (x4, 
E_V2DImode) != 0
              || !
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3679 (insn, operands);

        case E_V1TImode:
          if (pattern1743 (x4, 
E_V1TImode) != 0
              || !
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3680 (insn, operands);

        case E_V4SFmode:
          if (pattern1743 (x4, 
E_V4SFmode) != 0
              || !
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3681 (insn, operands);

        case E_V2DFmode:
          if (pattern1743 (x4, 
E_V2DFmode) != 0
              || !
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3682 (insn, operands);

        case E_V32QImode:
          if (pattern1743 (x4, 
E_V32QImode) != 0
              || !(
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3683 (insn, operands);

        case E_V16HImode:
          if (pattern1743 (x4, 
E_V16HImode) != 0
              || !(
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3684 (insn, operands);

        case E_V8SImode:
          if (pattern1743 (x4, 
E_V8SImode) != 0
              || !(
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3685 (insn, operands);

        case E_V4DImode:
          if (pattern1743 (x4, 
E_V4DImode) != 0
              || !(
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3686 (insn, operands);

        case E_V2TImode:
          if (pattern1743 (x4, 
E_V2TImode) != 0
              || !(
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3687 (insn, operands);

        case E_V8SFmode:
          if (pattern1743 (x4, 
E_V8SFmode) != 0
              || !(
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3688 (insn, operands);

        case E_V4DFmode:
          if (pattern1743 (x4, 
E_V4DFmode) != 0
              || !(
#line 25428 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3689 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_46 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return NULL;
  switch (pattern90 (x1))
    {
    case 0:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_V2SFmode))
        return NULL;
      x5 = XEXP (x3, 1);
      if (XVECLEN (x5, 0) != 1)
        return NULL;
      x6 = XEXP (x2, 1);
      x7 = XEXP (x6, 1);
      if (XVECLEN (x7, 0) != 1
          || !register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || GET_MODE (x3) != E_SFmode)
        return NULL;
      x8 = XVECEXP (x5, 0, 0);
      operands[2] = x8;
      if (!const_0_to_1_operand (operands[2], E_SImode)
          || GET_MODE (x6) != E_SFmode)
        return NULL;
      x9 = XVECEXP (x7, 0, 0);
      operands[3] = x9;
      if (!const_0_to_1_operand (operands[3], E_SImode))
        return NULL;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[1])
          || !(
#line 1012 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE3 && TARGET_MMX_WITH_SSE && ix86_partial_vec_fp_math
   && INTVAL (operands[2]) != INTVAL (operands[3])
   && ix86_pre_reload_split ()) && 
#line 1016 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( 1)))
        return NULL;
      return gen_split_1028 (insn, operands);

    case 1:
      switch (pattern848 (x2))
        {
        case 0:
          if (!
#line 22610 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3 && reload_completed
   && SSE_REGNO_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_3465 (insn, operands);

        case 1:
          if (!
#line 22697 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSSE3 && reload_completed
   && SSE_REGNO_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_3469 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_49 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return NULL;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      switch (pattern275 (x2))
        {
        case 0:
          x6 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x6) == CONST_INT)
            {
              switch (pattern967 (x2))
                {
                case 0:
                  if ((
#line 1691 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE) && 
#line 1693 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed)))
                    return gen_split_1030 (insn, operands);
                  break;

                case 1:
                  if ((
#line 4991 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE) && 
#line 4996 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed
   && SSE_REGNO_P (REGNO (operands[0])))))
                    return gen_split_1113 (insn, operands);
                  break;

                case 2:
                  if ((
#line 1708 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE) && 
#line 1710 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed)))
                    return gen_split_1031 (insn, operands);
                  break;

                case 3:
                  if ((
#line 4970 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE) && 
#line 4975 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed
   && SSE_REGNO_P (REGNO (operands[0])))))
                    return gen_split_1112 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          x7 = XVECEXP (x3, 0, 0);
          operands[3] = x7;
          switch (pattern968 (x2))
            {
            case 0:
              if (!(
#line 6197 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2) && 
#line 6199 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1125 (insn, operands);

            case 1:
              if (!(
#line 6197 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2) && 
#line 6199 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1126 (insn, operands);

            case 2:
              if (!(
#line 6197 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2) && 
#line 6199 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1127 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 4850 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE) && 
#line 4855 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed
   && SSE_REGNO_P (REGNO (operands[0])))))
            return NULL;
          return gen_split_1106 (insn, operands);

        case 2:
          if (!(
#line 4890 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE) && 
#line 4895 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed
   && SSE_REGNO_P (REGNO (operands[0])))))
            return NULL;
          return gen_split_1108 (insn, operands);

        case 3:
          if (!(
#line 4871 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2) && 
#line 4873 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed)))
            return NULL;
          return gen_split_1107 (insn, operands);

        case 4:
          if (!(
#line 4928 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE) && 
#line 4933 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed
   && SSE_REGNO_P (REGNO (operands[0])))))
            return NULL;
          return gen_split_1110 (insn, operands);

        case 5:
          if (!(
#line 4911 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_SSE2) && 
#line 4913 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed)))
            return NULL;
          return gen_split_1109 (insn, operands);

        case 6:
          if (!(
#line 4949 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE) && 
#line 4954 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
( reload_completed
   && SSE_REGNO_P (REGNO (operands[0])))))
            return NULL;
          return gen_split_1111 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (XVECLEN (x3, 0))
        {
        case 1:
          res = split_48 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
            {
              x6 = XVECEXP (x3, 0, 1);
              if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  && memory_operand (operands[0], E_V2SImode)
                  && GET_MODE (x2) == E_V2SImode
                  && rtx_equal_p (x5, operands[0])
                  && 
#line 5633 "../../gcc-15.1.1-20250425/gcc/config/i386/mmx.md"
(TARGET_64BIT && (TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())))
                return gen_split_1117 (insn, operands);
            }
          break;

        default:
          break;
        }
      if (XVECLEN (x3, 0) != 1)
        return NULL;
      x7 = XVECEXP (x3, 0, 0);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && GET_MODE (x2) == E_DImode)
        {
          if (GET_CODE (x5) == SUBREG
              && known_eq (SUBREG_BYTE (x5), 0)
              && GET_MODE (x5) == E_V2DImode
              && register_operand (operands[0], E_DImode))
            {
              x8 = XEXP (x5, 0);
              switch (pattern1196 (x8))
                {
                case 0:
                  if (pshufb_truncv8hiv8qi_operand (operands[2], E_V16QImode)
                      && (
#line 15368 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 15370 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3185 (insn, operands);
                  if (pshufb_truncv4siv4hi_operand (operands[2], E_V16QImode)
                      && (
#line 15723 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15725 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3201 (insn, operands);
                  break;

                case 1:
                  if ((
#line 15964 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15966 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3211 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          operands[1] = x5;
          if (register_operand (operands[1], E_V2DImode))
            {
              if (general_reg_operand (operands[0], E_DImode)
                  && 
#line 21174 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && !TARGET_64BIT
   && reload_completed))
                return gen_split_3389 (insn, operands);
              if (nonimmediate_operand (operands[0], E_DImode)
                  && 
#line 21192 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
                return gen_split_3391 (insn, operands);
            }
        }
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return NULL;
      operands[1] = x5;
      if (!memory_operand (operands[1], E_V2DImode))
        return NULL;
      operands[2] = x7;
      if (!const_0_to_1_operand (operands[2], E_VOIDmode)
          || !
#line 21379 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
        return NULL;
      return gen_split_3397 (insn, operands);

    case UNSPEC:
      if (pattern276 (x2) != 0
          || !
#line 8413 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed
   && SSE_REG_P (operands[0])))
        return NULL;
      return gen_split_1519 (insn, operands);

    case FIX:
      if (pattern278 (x2) != 0
          || !
#line 8477 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed
   && SSE_REG_P (operands[0])))
        return NULL;
      return gen_split_1521 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_55 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 130
      || GET_MODE (x3) != E_CCZmode)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != AND)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT)
    return NULL;
  x6 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x6) != AND)
    return NULL;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != NOT)
    return NULL;
  x8 = XEXP (x2, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  x10 = XEXP (x4, 1);
  operands[2] = x10;
  x11 = XEXP (x7, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return NULL;
  x12 = XEXP (x6, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return NULL;
  x13 = XEXP (x1, 0);
  switch (GET_CODE (x13))
    {
    case REG:
    case SUBREG:
      operands[0] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          switch (pattern1672 (x3, 
E_QImode))
            {
            case 0:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3606 (insn, operands);

            case 1:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3607 (insn, operands);

            case 2:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3608 (insn, operands);

            case 3:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3609 (insn, operands);

            case 4:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3610 (insn, operands);

            case 5:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3611 (insn, operands);

            case 6:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3612 (insn, operands);

            case 7:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3613 (insn, operands);

            case 8:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3614 (insn, operands);

            case 9:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3615 (insn, operands);

            case 10:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3616 (insn, operands);

            case 11:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3617 (insn, operands);

            case 12:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3618 (insn, operands);

            case 13:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3619 (insn, operands);

            default:
              return NULL;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode))
            return NULL;
          switch (pattern1672 (x3, 
E_HImode))
            {
            case 0:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3620 (insn, operands);

            case 1:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3621 (insn, operands);

            case 2:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3622 (insn, operands);

            case 3:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3623 (insn, operands);

            case 4:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3624 (insn, operands);

            case 5:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3625 (insn, operands);

            case 6:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3626 (insn, operands);

            case 7:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3627 (insn, operands);

            case 8:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3628 (insn, operands);

            case 9:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3629 (insn, operands);

            case 10:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3630 (insn, operands);

            case 11:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3631 (insn, operands);

            case 12:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3632 (insn, operands);

            case 13:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3633 (insn, operands);

            default:
              return NULL;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          switch (pattern1672 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3634 (insn, operands);

            case 1:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3635 (insn, operands);

            case 2:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3636 (insn, operands);

            case 3:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3637 (insn, operands);

            case 4:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3638 (insn, operands);

            case 5:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3639 (insn, operands);

            case 6:
              if (!
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return NULL;
              return gen_split_3640 (insn, operands);

            case 7:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3641 (insn, operands);

            case 8:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3642 (insn, operands);

            case 9:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3643 (insn, operands);

            case 10:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3644 (insn, operands);

            case 11:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3645 (insn, operands);

            case 12:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3646 (insn, operands);

            case 13:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_3647 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return NULL;
          switch (pattern1672 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_3648 (insn, operands);

            case 1:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_3649 (insn, operands);

            case 2:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_3650 (insn, operands);

            case 3:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_3651 (insn, operands);

            case 4:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_3652 (insn, operands);

            case 5:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_3653 (insn, operands);

            case 6:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_3654 (insn, operands);

            case 7:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && ((((((
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
                return NULL;
              return gen_split_3655 (insn, operands);

            case 8:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && ((((((
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
                return NULL;
              return gen_split_3656 (insn, operands);

            case 9:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && ((((((
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
                return NULL;
              return gen_split_3657 (insn, operands);

            case 10:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && ((((((
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
                return NULL;
              return gen_split_3658 (insn, operands);

            case 11:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && ((((((
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
                return NULL;
              return gen_split_3659 (insn, operands);

            case 12:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && ((((((
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
                return NULL;
              return gen_split_3660 (insn, operands);

            case 13:
              if (!(
#line 25393 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && ((((((
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX))))
                return NULL;
              return gen_split_3661 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case STRICT_LOW_PART:
      x14 = XEXP (x13, 0);
      operands[0] = x14;
      if (!register_operand (operands[0], E_QImode))
        return NULL;
      switch (pattern1672 (x3, 
E_QImode))
        {
        case 0:
          if (!
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3662 (insn, operands);

        case 1:
          if (!
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3663 (insn, operands);

        case 2:
          if (!
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3664 (insn, operands);

        case 3:
          if (!
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3665 (insn, operands);

        case 4:
          if (!
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3666 (insn, operands);

        case 5:
          if (!
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3667 (insn, operands);

        case 6:
          if (!
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return NULL;
          return gen_split_3668 (insn, operands);

        case 7:
          if (!(
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3669 (insn, operands);

        case 8:
          if (!(
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3670 (insn, operands);

        case 9:
          if (!(
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3671 (insn, operands);

        case 10:
          if (!(
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3672 (insn, operands);

        case 11:
          if (!(
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3673 (insn, operands);

        case 12:
          if (!(
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3674 (insn, operands);

        case 13:
          if (!(
#line 25408 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 607 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3675 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_71 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern533 (x2))
        {
        case 0:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2002 (insn, operands);

        case 1:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2029 (insn, operands);

        case 2:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2056 (insn, operands);

        case 3:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2083 (insn, operands);

        case 4:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2110 (insn, operands);

        case 5:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2137 (insn, operands);

        case 6:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2164 (insn, operands);

        case 7:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2191 (insn, operands);

        case 8:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2218 (insn, operands);

        case 9:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2245 (insn, operands);

        case 10:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2272 (insn, operands);

        case 11:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2299 (insn, operands);

        case 12:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2005 (insn, operands);

        case 13:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2032 (insn, operands);

        case 14:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2059 (insn, operands);

        case 15:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2086 (insn, operands);

        case 16:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2113 (insn, operands);

        case 17:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2140 (insn, operands);

        case 18:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2167 (insn, operands);

        case 19:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2194 (insn, operands);

        case 20:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2221 (insn, operands);

        case 21:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2248 (insn, operands);

        case 22:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2275 (insn, operands);

        case 23:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2302 (insn, operands);

        case 24:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2008 (insn, operands);

        case 25:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2035 (insn, operands);

        case 26:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2062 (insn, operands);

        case 27:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2089 (insn, operands);

        case 28:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2116 (insn, operands);

        case 29:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2143 (insn, operands);

        case 30:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2170 (insn, operands);

        case 31:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2197 (insn, operands);

        case 32:
          if (!(
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2224 (insn, operands);

        case 33:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2251 (insn, operands);

        case 34:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2278 (insn, operands);

        case 35:
          if (!((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2305 (insn, operands);

        case 36:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3070 (insn, operands);

        case 37:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3079 (insn, operands);

        case 38:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3088 (insn, operands);

        case 39:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3097 (insn, operands);

        case 40:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3106 (insn, operands);

        case 41:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3115 (insn, operands);

        case 42:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3124 (insn, operands);

        case 43:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3133 (insn, operands);

        case 44:
          if (!(
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3142 (insn, operands);

        case 45:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3151 (insn, operands);

        case 46:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3160 (insn, operands);

        case 47:
          if (!((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3169 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2650 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2677 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2704 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2731 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2758 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2785 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2812 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2839 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2866 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2893 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2920 (insn, operands);

        case 11:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2947 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern534 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2653 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2680 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2707 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2734 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2761 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2788 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2815 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2842 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2869 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2896 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2923 (insn, operands);

        case 11:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2950 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern534 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2656 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2683 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2710 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2737 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2764 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2791 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2818 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2845 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2872 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2899 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2926 (insn, operands);

        case 11:
          if (!((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2953 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_80 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = split_66 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case IOR:
      res = split_73 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case XOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          res = split_68 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case IOR:
          res = split_69 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case XOR:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
            case MEM:
            case NOT:
              switch (pattern529 (x2))
                {
                case 0:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1679 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1706 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1733 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1760 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1787 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1814 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1841 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1868 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1895 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1922 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1949 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1976 (insn, operands);
                  break;

                case 12:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1682 (insn, operands);
                  break;

                case 13:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1709 (insn, operands);
                  break;

                case 14:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1736 (insn, operands);
                  break;

                case 15:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1763 (insn, operands);
                  break;

                case 16:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1790 (insn, operands);
                  break;

                case 17:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1817 (insn, operands);
                  break;

                case 18:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1844 (insn, operands);
                  break;

                case 19:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1871 (insn, operands);
                  break;

                case 20:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1898 (insn, operands);
                  break;

                case 21:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1925 (insn, operands);
                  break;

                case 22:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1952 (insn, operands);
                  break;

                case 23:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1979 (insn, operands);
                  break;

                case 24:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1685 (insn, operands);
                  break;

                case 25:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1712 (insn, operands);
                  break;

                case 26:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1739 (insn, operands);
                  break;

                case 27:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1766 (insn, operands);
                  break;

                case 28:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1793 (insn, operands);
                  break;

                case 29:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1820 (insn, operands);
                  break;

                case 30:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1847 (insn, operands);
                  break;

                case 31:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1874 (insn, operands);
                  break;

                case 32:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1901 (insn, operands);
                  break;

                case 33:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1928 (insn, operands);
                  break;

                case 34:
                  if (((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1955 (insn, operands);
                  break;

                case 35:
                  if ((
#line 13763 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1982 (insn, operands);
                  break;

                case 36:
                  if (((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2963 (insn, operands);
                  break;

                case 37:
                  if (((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2972 (insn, operands);
                  break;

                case 38:
                  if ((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2981 (insn, operands);
                  break;

                case 39:
                  if (((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2990 (insn, operands);
                  break;

                case 40:
                  if (((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2999 (insn, operands);
                  break;

                case 41:
                  if ((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3008 (insn, operands);
                  break;

                case 42:
                  if (((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3017 (insn, operands);
                  break;

                case 43:
                  if (((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3026 (insn, operands);
                  break;

                case 44:
                  if ((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3035 (insn, operands);
                  break;

                case 45:
                  if (((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3044 (insn, operands);
                  break;

                case 46:
                  if (((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3053 (insn, operands);
                  break;

                case 47:
                  if ((
#line 13932 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3062 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              switch (pattern531 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2327 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2354 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2381 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2408 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2435 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2462 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2489 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2516 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2543 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2570 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2597 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2624 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case IOR:
              switch (pattern531 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2330 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2357 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2384 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2411 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2438 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2465 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2492 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2519 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2546 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2573 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2600 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2627 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case XOR:
              switch (pattern531 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2333 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2360 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2387 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2414 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2441 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2468 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2495 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2522 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2549 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2576 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2603 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2630 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[1] = x3;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern924 (x2, 
E_V16SImode) == 0
                  && ((
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 568 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3328 (insn, operands);
              break;

            case E_V8DImode:
              if (pattern924 (x2, 
E_V8DImode) == 0
                  && ((
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3329 (insn, operands);
              break;

            case E_V64QImode:
              if (pattern924 (x2, 
E_V64QImode) == 0
                  && ((
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3330 (insn, operands);
              break;

            case E_V32QImode:
              if (pattern924 (x2, 
E_V32QImode) == 0
                  && ((
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3331 (insn, operands);
              break;

            case E_V16QImode:
              if (pattern924 (x2, 
E_V16QImode) == 0
                  && (
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3332 (insn, operands);
              break;

            case E_V32HImode:
              if (pattern924 (x2, 
E_V32HImode) == 0
                  && ((
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3333 (insn, operands);
              break;

            case E_V16HImode:
              if (pattern924 (x2, 
E_V16HImode) == 0
                  && ((
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3334 (insn, operands);
              break;

            case E_V8HImode:
              if (pattern924 (x2, 
E_V8HImode) == 0
                  && (
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3335 (insn, operands);
              break;

            case E_V8SImode:
              if (pattern924 (x2, 
E_V8SImode) == 0
                  && ((
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3336 (insn, operands);
              break;

            case E_V4SImode:
              if (pattern924 (x2, 
E_V4SImode) == 0
                  && (
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3337 (insn, operands);
              break;

            case E_V4DImode:
              if (pattern924 (x2, 
E_V4DImode) == 0
                  && ((
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3338 (insn, operands);
              break;

            case E_V2DImode:
              if (pattern924 (x2, 
E_V2DImode) == 0
                  && (
#line 18344 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 18355 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3339 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x3) == VEC_DUPLICATE)
            {
              switch (pattern592 (x2))
                {
                case 0:
                  if ((
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 568 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3372 (insn, operands);
                  break;

                case 1:
                  if ((
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3373 (insn, operands);
                  break;

                case 2:
                  if ((
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return gen_split_3374 (insn, operands);
                  break;

                case 3:
                  if ((
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3375 (insn, operands);
                  break;

                case 4:
                  if (
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3376 (insn, operands);
                  break;

                case 5:
                  if ((
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return gen_split_3377 (insn, operands);
                  break;

                case 6:
                  if ((
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3378 (insn, operands);
                  break;

                case 7:
                  if (
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3379 (insn, operands);
                  break;

                case 8:
                  if ((
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3380 (insn, operands);
                  break;

                case 9:
                  if (
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3381 (insn, operands);
                  break;

                case 10:
                  if ((
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3382 (insn, operands);
                  break;

                case 11:
                  if (
#line 18649 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3383 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  switch (pattern195 ())
    {
    case 0:
      if (((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1647 (insn, operands);
      break;

    case 1:
      if (((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1648 (insn, operands);
      break;

    case 2:
      if ((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1649 (insn, operands);
      break;

    case 3:
      if (((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1650 (insn, operands);
      break;

    case 4:
      if (((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1651 (insn, operands);
      break;

    case 5:
      if ((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1652 (insn, operands);
      break;

    case 6:
      if (((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1653 (insn, operands);
      break;

    case 7:
      if (((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1654 (insn, operands);
      break;

    case 8:
      if ((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1655 (insn, operands);
      break;

    case 9:
      if (((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1656 (insn, operands);
      break;

    case 10:
      if (((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1657 (insn, operands);
      break;

    case 11:
      if (((
#line 13733 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13737 "../../gcc-15.1.1-20250425/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1658 (insn, operands);
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case AND:
      return split_76 (x1, insn);

    case IOR:
      return split_75 (x1, insn);

    case XOR:
      return split_74 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!memory_operand (x2, E_SImode))
        return NULL;
      operands[1] = x2;
      res = peephole2_30 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      operands[0] = x2;
      if (!
#line 27822 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((SImode == HImode
       && TARGET_LCP_STALL)
       || (!TARGET_USE_MOV0
          && TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_258 (insn, operands);

    case E_DImode:
      operands[1] = x2;
      if (!memory_operand (operands[1], E_DImode))
        return NULL;
      if (peep2_current_count >= 2)
        {
          x3 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x3) == SET)
            {
              x4 = XEXP (x3, 1);
              if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x5 = XEXP (x3, 0);
                  operands[2] = x5;
                  if (memory_operand (operands[2], E_DImode))
                    {
                      if (peep2_current_count >= 3)
                        {
                          x6 = PATTERN (peep2_next_insn (2));
                          if (pattern1242 (x6, 
E_DImode) == 0
                              && (
#line 27047 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                            {
                              *pmatch_len_ = 3;
                              res = gen_peephole2_218 (insn, operands);
                              if (res != NULL_RTX)
                                return res;
                            }
                        }
                      if ((
#line 27063 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_220 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
        }
      if (!(
#line 27076 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_222 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return NULL;
  x8 = XEXP (x6, 1);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      if (!register_operand (operands[1], E_VOIDmode)
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      x9 = PATTERN (peep2_next_insn (1));
      if (pattern415 (x9, 
PLUS, 
2) != 0)
        return NULL;
      x10 = XVECEXP (x9, 0, 1);
      if (GET_CODE (x10) != CLOBBER)
        return NULL;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 17
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XVECEXP (x9, 0, 0);
      x13 = XEXP (x12, 1);
      x14 = XEXP (x13, 1);
      operands[2] = x14;
      if (!x86_64_immediate_operand (operands[2], E_VOIDmode))
        return NULL;
      x15 = XEXP (x13, 0);
      if (!rtx_equal_p (x15, operands[0]))
        return NULL;
      x16 = XEXP (x12, 0);
      if (!rtx_equal_p (x16, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || GET_MODE (x13) != E_SImode
              || !
#line 6442 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_AVOID_LEA_FOR_ADDR || optimize_function_for_size_p (cfun)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_62 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || GET_MODE (x13) != E_DImode
              || !(
#line 6442 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_AVOID_LEA_FOR_ADDR || optimize_function_for_size_p (cfun)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_63 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (peep2_current_count < 3
          || XWINT (x8, 0) != -1LL)
        return NULL;
      x9 = PATTERN (peep2_next_insn (1));
      if (pattern1239 (x9, 
-1) != 0)
        return NULL;
      x17 = PATTERN (peep2_next_insn (2));
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      operands[1] = x19;
      if (pattern1763 (x17) != 0)
        return NULL;
      x20 = XEXP (x18, 1);
      operands[2] = x20;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!general_reg_operand (operands[0], E_QImode)
              || GET_MODE (x6) != E_QImode
              || !
#line 8725 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_72 (insn, operands);

        case E_HImode:
          if (!general_reg_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode
              || !
#line 8725 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_73 (insn, operands);

        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !
#line 8725 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_74 (insn, operands);

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !(
#line 8725 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_75 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  if (!flags_reg_operand (operands[5], E_VOIDmode))
    return NULL;
  x4 = XEXP (x2, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[4] = x5;
  x6 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x6, 1);
  if (!ix86_comparison_operator (x7, E_QImode))
    return NULL;
  operands[2] = x7;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17)
    return NULL;
  x9 = XEXP (x7, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x10 = XEXP (x6, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_QImode))
    return NULL;
  x11 = PATTERN (peep2_next_insn (2));
  switch (GET_CODE (x11))
    {
    case SET:
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != ZERO_EXTEND)
        return NULL;
      x13 = XEXP (x11, 0);
      operands[3] = x13;
      if (!any_QIreg_operand (operands[3], E_VOIDmode))
        return NULL;
      x14 = XEXP (x12, 0);
      if (!rtx_equal_p (x14, operands[1])
          || !
#line 19966 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((peep2_reg_dead_p (3, operands[1])
    || operands_match_p (operands[1], operands[3]))
   && ! reg_overlap_mentioned_p (operands[3], operands[0])
   && ! reg_overlap_mentioned_p (operands[3], operands[4])
   && ! reg_set_p (operands[3], operands[4])
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_170 (insn, operands);

    case PARALLEL:
      if (XVECLEN (x11, 0) != 2)
        return NULL;
      x15 = XVECEXP (x11, 0, 0);
      if (GET_CODE (x15) != SET)
        return NULL;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != ZERO_EXTEND
          || pattern1712 (x11, 
E_VOIDmode) != 0)
        return NULL;
      x17 = XEXP (x16, 0);
      if (!rtx_equal_p (x17, operands[1])
          || !
#line 20038 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((peep2_reg_dead_p (3, operands[1])
    || operands_match_p (operands[1], operands[3]))
   && ! reg_overlap_mentioned_p (operands[3], operands[0])
   && ! reg_overlap_mentioned_p (operands[3], operands[4])
   && ! reg_set_p (operands[3], operands[4])
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_173 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
      res = peephole2_38 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case CONST_INT:
      res = peephole2_40 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case PLUS:
      res = peephole2_41 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case COMPARE:
      res = peephole2_43 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case MULT:
      res = peephole2_44 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case ASHIFT:
      if (pattern244 (x1) == 0)
        {
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          if (nonmemory_operand (operands[2], E_QImode))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && GET_MODE (x3) == E_DImode
                      && nonmemory_operand (operands[1], E_DImode)
                      && (
#line 15349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_159 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case E_TImode:
                  if (register_operand (operands[0], E_TImode)
                      && GET_MODE (x3) == E_TImode
                      && nonmemory_operand (operands[1], E_TImode)
                      && (
#line 15349 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_160 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case LSHIFTRT:
      switch (pattern246 (x1))
        {
        case 0:
          if ((
#line 16721 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_161 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if ((
#line 16721 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_163 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      break;

    case ASHIFTRT:
      switch (pattern246 (x1))
        {
        case 0:
          if ((
#line 16721 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1235 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_162 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if ((
#line 16721 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1236 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_164 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      break;

    case NOT:
      if (GET_MODE (x3) == E_DImode)
        {
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) == ZERO_EXTRACT
              && pattern375 (x1) == 0)
            {
              x6 = XEXP (x5, 0);
              if (rtx_equal_p (x6, operands[0]))
                {
                  x7 = XEXP (x5, 2);
                  if (rtx_equal_p (x7, operands[1])
                      && 
#line 19126 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT && !TARGET_USE_BT))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_167 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
      break;

    case POPCOUNT:
      res = peephole2_45 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (peep2_current_count >= 2)
    {
      res = peephole2_46 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return NULL;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_CCmode)
    return NULL;
  switch (GET_CODE (x3))
    {
    case COMPARE:
    case PLUS:
    case MINUS:
    case MULT:
    case DIV:
    case MOD:
    case UDIV:
    case UMOD:
    case AND:
    case IOR:
    case XOR:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      operands[3] = x3;
      res = peephole2_47 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      switch (GET_CODE (x3))
        {
        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          if (peep2_current_count >= 2)
            {
              res = peephole2_48 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          if (GET_CODE (x3) != PLUS
              || pattern416 (x2) != 0)
            return NULL;
          switch (pattern1432 (x2))
            {
            case 0:
              if ((
#line 28654 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_355 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28654 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_356 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28666 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_359 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28666 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_360 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28722 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_375 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28722 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_376 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28734 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_379 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28734 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_380 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28744 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_383 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!(
#line 28744 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == SImode))))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_384 (insn, operands);

            case 1:
              if ((
#line 28654 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_357 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28654 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_358 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28666 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_361 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28666 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_362 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28722 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_377 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28722 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_378 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28734 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_381 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28734 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_382 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28744 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_385 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!(
#line 28744 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(Pmode == DImode))))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_386 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return NULL;
              if (const359_operand (operands[2], E_SImode))
                {
                  if (register_operand (operands[1], E_SImode))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_388 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 28787 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && (!TARGET_PARTIAL_REG_STALL || SImode == SImode)))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_390 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (memory_operand (operands[1], E_SImode)
                  && immediate_operand (operands[2], E_SImode)
                  && 
#line 28803 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SLOW_IMUL_IMM32_MEM && optimize_insn_for_speed_p ()
   && !satisfies_constraint_K (operands[2])))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_392 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode)
                  || !
#line 28835 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SLOW_IMUL_IMM8 && optimize_insn_for_speed_p ()
   && satisfies_constraint_K (operands[2])))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_396 (insn, operands);

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              if (const359_operand (operands[2], E_DImode))
                {
                  if (register_operand (operands[1], E_DImode)
                      && (
#line 28773 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL
   || DImode == SImode
   || optimize_function_for_size_p (cfun)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_389 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (nonimmediate_operand (operands[1], E_DImode)
                      && (
#line 28787 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && (!TARGET_PARTIAL_REG_STALL || DImode == SImode)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_391 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (memory_operand (operands[1], E_DImode)
                  && immediate_operand (operands[2], E_DImode)
                  && (
#line 28803 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SLOW_IMUL_IMM32_MEM && optimize_insn_for_speed_p ()
   && !satisfies_constraint_K (operands[2])) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_393 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !const_int_operand (operands[2], E_DImode)
                  || !(
#line 28835 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SLOW_IMUL_IMM8 && optimize_insn_for_speed_p ()
   && satisfies_constraint_K (operands[2])) && 
#line 1164 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_397 (insn, operands);

            case E_HImode:
              if (pattern1337 (x3, 
E_HImode) != 0
                  || !
#line 28835 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_SLOW_IMUL_IMM8 && optimize_insn_for_speed_p ()
   && satisfies_constraint_K (operands[2])))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_395 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          if (peep2_current_count < 2)
            return NULL;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_VOIDmode))
            return NULL;
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return NULL;
          x11 = PATTERN (peep2_next_insn (1));
          if (pattern415 (x11, 
PLUS, 
2) != 0)
            return NULL;
          x12 = XVECEXP (x11, 0, 1);
          if (GET_CODE (x12) != CLOBBER)
            return NULL;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 17
              || GET_MODE (x13) != E_CCmode)
            return NULL;
          x14 = XVECEXP (x11, 0, 0);
          x15 = XEXP (x14, 0);
          operands[3] = x15;
          if (!register_operand (operands[3], E_VOIDmode))
            return NULL;
          x16 = XEXP (x14, 1);
          x17 = XEXP (x16, 1);
          operands[4] = x17;
          if (!x86_64_general_operand (operands[4], E_VOIDmode))
            return NULL;
          x18 = XEXP (x16, 0);
          if (!rtx_equal_p (x18, operands[0]))
            return NULL;
          if ((
#line 28867 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(IN_RANGE (INTVAL (operands[2]), 1, 3)
   /* Validate MODE for lea.  */
   && ((!TARGET_PARTIAL_REG_STALL
	&& (GET_MODE (operands[0]) == QImode
	    || GET_MODE (operands[0]) == HImode))
       || GET_MODE (operands[0]) == SImode
       || (TARGET_64BIT && GET_MODE (operands[0]) == DImode))
   && (rtx_equal_p (operands[0], operands[3])
       || peep2_reg_dead_p (2, operands[0]))
   /* We reorder load and the shift.  */
   && !reg_overlap_mentioned_p (operands[0], operands[4])) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == SImode)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_398 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 28867 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(IN_RANGE (INTVAL (operands[2]), 1, 3)
   /* Validate MODE for lea.  */
   && ((!TARGET_PARTIAL_REG_STALL
	&& (GET_MODE (operands[0]) == QImode
	    || GET_MODE (operands[0]) == HImode))
       || GET_MODE (operands[0]) == SImode
       || (TARGET_64BIT && GET_MODE (operands[0]) == DImode))
   && (rtx_equal_p (operands[0], operands[3])
       || peep2_reg_dead_p (2, operands[0]))
   /* We reorder load and the shift.  */
   && !reg_overlap_mentioned_p (operands[0], operands[4])) && 
#line 1403 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(word_mode == DImode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_399 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MULT
          || GET_MODE (x5) != E_SImode)
        return NULL;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!memory_operand (operands[1], E_SImode))
        return NULL;
      x19 = XEXP (x5, 1);
      operands[2] = x19;
      if (!immediate_operand (operands[2], E_SImode)
          || !
#line 28816 "../../gcc-15.1.1-20250425/gcc/config/i386/i386.md"
(TARGET_64BIT
   && TARGET_SLOW_IMUL_IMM32_MEM && optimize_insn_for_speed_p ()
   && !satisfies_constraint_K (operands[2])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_394 (insn, operands);

    default:
      return NULL;
    }
}
